/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],se=function(Q){for(var e=[],P=0,D=Q.length;P<D;P++)e[P]=ne[Q[P]];return e};define(ne[134],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function P(w,p,$){const d=D(w,p);if(d!==-1)return w[d]}e.$eb=P;function D(w,p,$=w.length-1){for(let d=$;d>=0;d--){const h=w[d];if(p(h))return d}return-1}e.$fb=D;function s(w,p){const $=M(w,p);return $===-1?void 0:w[$]}e.$gb=s;function M(w,p,$=0,d=w.length){let h=$,E=d;for(;h<E;){const c=Math.floor((h+E)/2);p(w[c])?h=c+1:E=c}return h-1}e.$hb=M;function C(w,p){const $=S(w,p);return $===w.length?void 0:w[$]}e.$ib=C;function S(w,p,$=0,d=w.length){let h=$,E=d;for(;h<E;){const c=Math.floor((h+E)/2);p(w[c])?E=c:h=c+1}return h}e.$jb=S;function u(w,p,$=0,d=w.length){const h=S(w,p,$,d);return h===w.length?-1:h}e.$kb=u;class a{static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if(a.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!p(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const $=M(this.e,p,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$lb=a;function m(w,p){if(w.length===0)return;let $=w[0];for(let d=1;d<w.length;d++){const h=w[d];p(h,$)>0&&($=h)}return $}e.$mb=m;function b(w,p){if(w.length===0)return;let $=w[0];for(let d=1;d<w.length;d++){const h=w[d];p(h,$)>=0&&($=h)}return $}e.$nb=b;function y(w,p){return m(w,($,d)=>-p($,d))}e.$ob=y;function f(w,p){if(w.length===0)return-1;let $=0;for(let d=1;d<w.length;d++){const h=w[d];p(h,w[$])>0&&($=d)}return $}e.$pb=f;function v(w,p){for(const $ of w){const d=p($);if(d!==void 0)return d}}e.$qb=v}),define(ne[135],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function P(C,S){const u=Object.create(null);for(const a of C){const m=S(a);let b=u[m];b||(b=u[m]=[]),b.push(a)}return u}e.$J=P;function D(C,S){const u=[],a=[];for(const m of C)S.has(m)||u.push(m);for(const m of S)C.has(m)||a.push(m);return{removed:u,added:a}}e.$K=D;function s(C,S){const u=[],a=[];for(const[m,b]of C)S.has(m)||u.push(b);for(const[m,b]of S)C.has(m)||a.push(b);return{removed:u,added:a}}e.$L=s;function M(C,S){const u=new Set;for(const a of S)C.has(a)&&u.add(a);return u}e.$M=M}),define(ne[136],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=e.$Zs=e.$Ys=e.$Xs=void 0;function P(S,u){const a=Math.pow(10,u);return Math.round(S*a)/a}class D{constructor(u,a,m,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=P(Math.max(Math.min(1,b),0),3)}static equals(u,a){return u.r===a.r&&u.g===a.g&&u.b===a.b&&u.a===a.a}}e.$Xs=D;class s{constructor(u,a,m,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=P(Math.max(Math.min(1,a),0),3),this.l=P(Math.max(Math.min(1,m),0),3),this.a=P(Math.max(Math.min(1,b),0),3)}static equals(u,a){return u.h===a.h&&u.s===a.s&&u.l===a.l&&u.a===a.a}static fromRGBA(u){const a=u.r/255,m=u.g/255,b=u.b/255,y=u.a,f=Math.max(a,m,b),v=Math.min(a,m,b);let w=0,p=0;const $=(v+f)/2,d=f-v;if(d>0){switch(p=Math.min($<=.5?d/(2*$):d/(2-2*$),1),f){case a:w=(m-b)/d+(m<b?6:0);break;case m:w=(b-a)/d+2;break;case b:w=(a-m)/d+4;break}w*=60,w=Math.round(w)}return new s(w,p,$,y)}static i(u,a,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?u+(a-u)*6*m:m<1/2?a:m<2/3?u+(a-u)*(2/3-m)*6:u}static toRGBA(u){const a=u.h/360,{s:m,l:b,a:y}=u;let f,v,w;if(m===0)f=v=w=b;else{const p=b<.5?b*(1+m):b+m-b*m,$=2*b-p;f=s.i($,p,a+1/3),v=s.i($,p,a),w=s.i($,p,a-1/3)}return new D(Math.round(f*255),Math.round(v*255),Math.round(w*255),y)}}e.$Ys=s;class M{constructor(u,a,m,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=P(Math.max(Math.min(1,a),0),3),this.v=P(Math.max(Math.min(1,m),0),3),this.a=P(Math.max(Math.min(1,b),0),3)}static equals(u,a){return u.h===a.h&&u.s===a.s&&u.v===a.v&&u.a===a.a}static fromRGBA(u){const a=u.r/255,m=u.g/255,b=u.b/255,y=Math.max(a,m,b),f=Math.min(a,m,b),v=y-f,w=y===0?0:v/y;let p;return v===0?p=0:y===a?p=((m-b)/v%6+6)%6:y===m?p=(b-a)/v+2:p=(a-m)/v+4,new M(Math.round(p*60),w,y,u.a)}static toRGBA(u){const{h:a,s:m,v:b,a:y}=u,f=b*m,v=f*(1-Math.abs(a/60%2-1)),w=b-f;let[p,$,d]=[0,0,0];return a<60?(p=f,$=v):a<120?(p=v,$=f):a<180?($=f,d=v):a<240?($=v,d=f):a<300?(p=v,d=f):a<=360&&(p=f,d=v),p=Math.round((p+w)*255),$=Math.round(($+w)*255),d=Math.round((d+w)*255),new D(p,$,d,y)}}e.$Zs=M;class C{static fromHex(u){return C.Format.CSS.parseHex(u)||C.red}static equals(u,a){return!u&&!a?!0:!u||!a?!1:u.equals(a)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof D)this.rgba=u;else if(u instanceof s)this.i=u,this.rgba=s.toRGBA(u);else if(u instanceof M)this.j=u,this.rgba=M.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&D.equals(this.rgba,u.rgba)&&s.equals(this.hsla,u.hsla)&&M.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=C.k(this.rgba.r),a=C.k(this.rgba.g),m=C.k(this.rgba.b),b=.2126*u+.7152*a+.0722*m;return P(b,4)}static k(u){const a=u/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(u){const a=this.getRelativeLuminance(),m=u.getRelativeLuminance();return a>m?(a+.05)/(m+.05):(m+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const a=this.getRelativeLuminance(),m=u.getRelativeLuminance();return a>m}isDarkerThan(u){const a=this.getRelativeLuminance(),m=u.getRelativeLuminance();return a<m}lighten(u){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:a,g:m,b,a:y}=this.rgba;return new C(new D(a,m,b,y*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const a=u.rgba,m=this.rgba.a,b=a.a,y=m+b*(1-m);if(y<1e-6)return C.transparent;const f=this.rgba.r*m/y+a.r*b*(1-m)/y,v=this.rgba.g*m/y+a.g*b*(1-m)/y,w=this.rgba.b*m/y+a.b*b*(1-m)/y;return new C(new D(f,v,w,y))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:a,g:m,b,a:y}=this.rgba;return new C(new D(u.rgba.r-y*(u.rgba.r-a),u.rgba.g-y*(u.rgba.g-m),u.rgba.b-y*(u.rgba.b-b),1))}flatten(...u){const a=u.reduceRight((m,b)=>C.o(b,m));return C.o(this,a)}static o(u,a){const m=1-u.rgba.a;return new C(new D(m*a.rgba.r+u.rgba.a*u.rgba.r,m*a.rgba.g+u.rgba.a*u.rgba.g,m*a.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(u,a,m){if(u.isLighterThan(a))return u;m=m||.5;const b=u.getRelativeLuminance(),y=a.getRelativeLuminance();return m=m*(y-b)/y,u.lighten(m)}static getDarkerColor(u,a,m){if(u.isDarkerThan(a))return u;m=m||.5;const b=u.getRelativeLuminance(),y=a.getRelativeLuminance();return m=m*(b-y)/b,u.darken(m)}static{this.white=new C(new D(255,255,255,1))}static{this.black=new C(new D(0,0,0,1))}static{this.red=new C(new D(255,0,0,1))}static{this.blue=new C(new D(0,0,255,1))}static{this.green=new C(new D(0,255,0,1))}static{this.cyan=new C(new D(0,255,255,1))}static{this.lightgrey=new C(new D(211,211,211,1))}static{this.transparent=new C(new D(0,0,0,0))}}e.$1s=C,function(S){let u;(function(a){let m;(function(b){function y(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:S.Format.CSS.formatRGBA(i)}b.formatRGB=y;function f(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}b.formatRGBA=f;function v(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(i)}b.formatHSL=v;function w(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}b.formatHSLA=w;function p(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function $(i){return`#${p(i.rgba.r)}${p(i.rgba.g)}${p(i.rgba.b)}`}b.formatHex=$;function d(i,o=!1){return o&&i.rgba.a===1?S.Format.CSS.formatHex(i):`#${p(i.rgba.r)}${p(i.rgba.g)}${p(i.rgba.b)}${p(Math.round(i.rgba.a*255))}`}b.formatHexA=d;function h(i){return i.isOpaque()?S.Format.CSS.formatHex(i):S.Format.CSS.formatRGBA(i)}b.format=h;function E(i){const o=i.length;if(o===0||i.charCodeAt(0)!==35)return null;if(o===7){const r=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),t=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),n=16*c(i.charCodeAt(5))+c(i.charCodeAt(6));return new S(new D(r,t,n,1))}if(o===9){const r=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),t=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),n=16*c(i.charCodeAt(5))+c(i.charCodeAt(6)),l=16*c(i.charCodeAt(7))+c(i.charCodeAt(8));return new S(new D(r,t,n,l/255))}if(o===4){const r=c(i.charCodeAt(1)),t=c(i.charCodeAt(2)),n=c(i.charCodeAt(3));return new S(new D(16*r+r,16*t+t,16*n+n))}if(o===5){const r=c(i.charCodeAt(1)),t=c(i.charCodeAt(2)),n=c(i.charCodeAt(3)),l=c(i.charCodeAt(4));return new S(new D(16*r+r,16*t+t,16*n+n,(16*l+l)/255))}return null}b.parseHex=E;function c(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=a.CSS||(a.CSS={}))})(u=S.Format||(S.Format={}))}(C||(e.$1s=C={}))}),define(ne[55],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function P(C){return(S,u,a)=>{let m=null,b=null;if(typeof a.value=="function"?(m="value",b=a.value):typeof a.get=="function"&&(m="get",b=a.get),!b)throw new Error("not supported");a[m]=C(b,u)}}function D(C,S,u){let a=null,m=null;if(typeof u.value=="function"?(a="value",m=u.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",m=u.get),!m)throw new Error("not supported");const b=`$memoize$${S}`;u[a]=function(...y){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,y)}),this[b]}}e.$hh=D;function s(C,S,u){return P((a,m)=>{const b=`$debounce$${m}`,y=`$debounce$result$${m}`;return function(...f){this[y]||(this[y]=u?u():void 0),clearTimeout(this[b]),S&&(this[y]=S(this[y],...f),f=[this[y]]),this[b]=setTimeout(()=>{a.apply(this,f),this[y]=u?u():void 0},C)}})}e.$ih=s;function M(C,S,u){return P((a,m)=>{const b=`$throttle$timer$${m}`,y=`$throttle$result$${m}`,f=`$throttle$lastRun$${m}`,v=`$throttle$pending$${m}`;return function(...w){if(this[y]||(this[y]=u?u():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),S&&(this[y]=S(this[y],...w)),this[v])return;const p=this[f]+C;p<=Date.now()?(this[f]=Date.now(),a.apply(this,[this[y]]),this[y]=u?u():void 0):(this[v]=!0,this[b]=setTimeout(()=>{this[v]=!1,this[f]=Date.now(),a.apply(this,[this[y]]),this[y]=u?u():void 0},p-Date.now()))}})}e.$jh=M}),define(ne[14],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class P{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?h.isErrorNoTelemetry(i)?new h(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$V=P,e.$W=new P;function D(c){e.$W.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=D;function s(c){if(!c||typeof c!="object")return!1;const i=c;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Y=s;function M(c){a(c)||e.$W.onUnexpectedError(c)}e.$Z=M;function C(c){a(c)||e.$W.onUnexpectedExternalError(c)}e.$1=C;function S(c){if(c instanceof Error){const{name:i,message:o}=c,r=c.stacktrace||c.stack;return{$isError:!0,name:i,message:o,stack:r,noTelemetry:h.isErrorNoTelemetry(c)}}return c}e.$2=S;const u="Canceled";function a(c){return c instanceof m?!0:c instanceof Error&&c.name===u&&c.message===u}e.$3=a;class m extends Error{constructor(){super(u),this.name=this.message}}e.$4=m;function b(){const c=new Error(u);return c.name=c.message,c}e.$5=b;function y(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$6=y;function f(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$7=f;class v extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=v;function w(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$9=w;class p extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=p;class $ extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=$;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=d;class h extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof h)return i;const o=new h;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=h;class E extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$bb=E}),define(ne[23],se([0,1,14,134]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function s(U,H=0){return U[U.length-(1+H)]}e.$rb=s;function M(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.$sb=M;function C(U,H,B=(ie,fe)=>ie===fe){if(U===H)return!0;if(!U||!H||U.length!==H.length)return!1;for(let ie=0,fe=U.length;ie<fe;ie++)if(!B(U[ie],H[ie]))return!1;return!0}e.$tb=C;function S(U,H){const B=U.length-1;H<B&&(U[H]=U[B]),U.pop()}e.$ub=S;function u(U,H,B){return a(U.length,ie=>B(U[ie],H))}e.$vb=u;function a(U,H){let B=0,ie=U-1;for(;B<=ie;){const fe=(B+ie)/2|0,de=H(fe);if(de<0)B=fe+1;else if(de>0)ie=fe-1;else return fe}return-(B+1)}e.$wb=a;function m(U,H,B){if(U=U|0,U>=H.length)throw new TypeError("invalid index");const ie=H[Math.floor(H.length*Math.random())],fe=[],de=[],ue=[];for(const be of H){const me=B(be,ie);me<0?fe.push(be):me>0?de.push(be):ue.push(be)}return U<fe.length?m(U,fe,B):U<fe.length+ue.length?ue[0]:m(U-(fe.length+ue.length),de,B)}e.$xb=m;function b(U,H){const B=[];let ie;for(const fe of U.slice(0).sort(H))!ie||H(ie[0],fe)!==0?(ie=[fe],B.push(ie)):ie.push(fe);return B}e.$yb=b;function*y(U,H){let B,ie;for(const fe of U)ie!==void 0&&H(ie,fe)?B.push(fe):(B&&(yield B),B=[fe]),ie=fe;B&&(yield B)}e.$zb=y;function f(U,H){for(let B=0;B<=U.length;B++)H(B===0?void 0:U[B-1],B===U.length?void 0:U[B])}e.$Ab=f;function v(U,H){for(let B=0;B<U.length;B++)H(B===0?void 0:U[B-1],U[B],B+1===U.length?void 0:U[B+1])}e.$Bb=v;function w(U,H,B){const ie=[];function fe(be,me,Ee){if(me===0&&Ee.length===0)return;const Se=ie[ie.length-1];Se&&Se.start+Se.deleteCount===be?(Se.deleteCount+=me,Se.toInsert.push(...Ee)):ie.push({start:be,deleteCount:me,toInsert:Ee})}let de=0,ue=0;for(;;){if(de===U.length){fe(de,0,H.slice(ue));break}if(ue===H.length){fe(de,U.length-de,[]);break}const be=U[de],me=H[ue],Ee=B(be,me);Ee===0?(de+=1,ue+=1):Ee<0?(fe(de,1,[]),de+=1):Ee>0&&(fe(de,0,[me]),ue+=1)}return ie}e.$Cb=w;function p(U,H,B){const ie=w(U,H,B),fe=[],de=[];for(const ue of ie)fe.push(...U.slice(ue.start,ue.start+ue.deleteCount)),de.push(...ue.toInsert);return{removed:fe,added:de}}e.$Db=p;function $(U,H,B){if(B===0)return[];const ie=U.slice(0,B).sort(H);return h(U,H,ie,B,U.length),ie}e.top=$;function d(U,H,B,ie,fe){return B===0?Promise.resolve([]):new Promise((de,ue)=>{(async()=>{const be=U.length,me=U.slice(0,B).sort(H);for(let Ee=B,Se=Math.min(B+ie,be);Ee<be;Ee=Se,Se=Math.min(Se+ie,be)){if(Ee>B&&await new Promise(je=>setTimeout(je)),fe&&fe.isCancellationRequested)throw new P.$4;h(U,H,me,Ee,Se)}return me})().then(de,ue)})}e.$Fb=d;function h(U,H,B,ie,fe){for(const de=B.length;ie<fe;ie++){const ue=U[ie];if(H(ue,B[de-1])<0){B.pop();const be=(0,D.$jb)(B,me=>H(ue,me)<0);B.splice(be,0,ue)}}}function E(U){return U.filter(H=>!!H)}e.$Gb=E;function c(U){let H=0;for(let B=0;B<U.length;B++)U[B]&&(U[H]=U[B],H+=1);U.length=H}e.$Hb=c;function i(U,H,B){U.splice(B,0,U.splice(H,1)[0])}e.$Ib=i;function o(U){return!Array.isArray(U)||U.length===0}e.$Jb=o;function r(U){return Array.isArray(U)&&U.length>0}e.$Kb=r;function t(U,H=B=>B){const B=new Set;return U.filter(ie=>{const fe=H(ie);return B.has(fe)?!1:(B.add(fe),!0)})}e.$Lb=t;function n(U){const H=new Set;return B=>{const ie=U(B);return H.has(ie)?!1:(H.add(ie),!0)}}e.$Mb=n;function l(U,H){return U.length>0?U[0]:H}e.$Nb=l;function g(U,H){return U.length>0?U[U.length-1]:H}e.$Ob=g;function A(U,H,B=(ie,fe)=>ie===fe){let ie=0;for(let fe=0,de=Math.min(U.length,H.length);fe<de&&B(U[fe],H[fe]);fe++)ie++;return ie}e.$Pb=A;function R(U){return[].concat(...U)}e.$Qb=R;function k(U,H){let B=typeof H=="number"?U:0;typeof H=="number"?B=U:(B=0,H=U);const ie=[];if(B<=H)for(let fe=B;fe<H;fe++)ie.push(fe);else for(let fe=B;fe>H;fe--)ie.push(fe);return ie}e.$Rb=k;function I(U,H,B){return U.reduce((ie,fe)=>(ie[H(fe)]=B?B(fe):fe,ie),Object.create(null))}e.$Sb=I;function L(U,H){return U.push(H),()=>N(U,H)}e.$Tb=L;function N(U,H){const B=U.indexOf(H);if(B>-1)return U.splice(B,1),H}e.$Ub=N;function T(U,H,B){const ie=U.slice(0,H),fe=U.slice(H);return ie.concat(B,fe)}e.$Vb=T;function x(U,H){let B;if(typeof H=="number"){let ie=H;B=()=>{const fe=Math.sin(ie++)*179426549;return fe-Math.floor(fe)}}else B=Math.random;for(let ie=U.length-1;ie>0;ie-=1){const fe=Math.floor(B()*(ie+1)),de=U[ie];U[ie]=U[fe],U[fe]=de}}e.$Wb=x;function X(U,H){const B=U.indexOf(H);B>-1&&(U.splice(B,1),U.unshift(H))}e.$Xb=X;function ce(U,H){const B=U.indexOf(H);B>-1&&(U.splice(B,1),U.push(H))}e.$Yb=ce;function re(U,H){for(const B of H)U.push(B)}e.$Zb=re;function ae(U,H){return Array.isArray(U)?U.map(H):H(U)}e.$1b=ae;function Z(U){return Array.isArray(U)?U:[U]}e.$2b=Z;function K(U){return U[Math.floor(Math.random()*U.length)]}e.$3b=K;function G(U,H,B){const ie=W(U,H),fe=U.length,de=B.length;U.length=fe+de;for(let ue=fe-1;ue>=ie;ue--)U[ue+de]=U[ue];for(let ue=0;ue<de;ue++)U[ue+ie]=B[ue]}e.$4b=G;function z(U,H,B,ie){const fe=W(U,H);let de=U.splice(fe,B);return de===void 0&&(de=[]),G(U,fe,ie),de}e.$5b=z;function W(U,H){return H<0?Math.max(H+U.length,0):Math.min(H,U.length)}var V;(function(U){function H(de){return de<0}U.isLessThan=H;function B(de){return de<=0}U.isLessThanOrEqual=B;function ie(de){return de>0}U.isGreaterThan=ie;function fe(de){return de===0}U.isNeitherLessOrGreaterThan=fe,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function q(U,H){return(B,ie)=>H(U(B),U(ie))}e.$6b=q;function Y(...U){return(H,B)=>{for(const ie of U){const fe=ie(H,B);if(!V.isNeitherLessOrGreaterThan(fe))return fe}return V.neitherLessOrGreaterThan}}e.$7b=Y;const oe=(U,H)=>U-H;e.$8b=oe;const J=(U,H)=>(0,e.$8b)(U?1:0,H?1:0);e.$9b=J;function O(U){return(H,B)=>-U(H,B)}e.$0b=O;class j{constructor(H){this.g=H,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(H){let B=this.c;for(;B<this.g.length&&H(this.g[B]);)B++;const ie=B===this.c?null:this.g.slice(this.c,B);return this.c=B,ie}takeFromEndWhile(H){let B=this.d;for(;B>=0&&H(this.g[B]);)B--;const ie=B===this.d?null:this.g.slice(B+1,this.d+1);return this.d=B,ie}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const H=this.g[this.c];return this.c++,H}removeLast(){const H=this.g[this.d];return this.d--,H}takeCount(H){const B=this.g.slice(this.c,this.c+H);return this.c+=H,B}}e.$$b=j;class F{static{this.empty=new F(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(B=>(H(B),!0))}toArray(){const H=[];return this.iterate(B=>(H.push(B),!0)),H}filter(H){return new F(B=>this.iterate(ie=>H(ie)?B(ie):!0))}map(H){return new F(B=>this.iterate(ie=>B(H(ie))))}some(H){let B=!1;return this.iterate(ie=>(B=H(ie),!B)),B}findFirst(H){let B;return this.iterate(ie=>H(ie)?(B=ie,!1):!0),B}findLast(H){let B;return this.iterate(ie=>(H(ie)&&(B=ie),!0)),B}findLastMaxBy(H){let B,ie=!0;return this.iterate(fe=>((ie||V.isGreaterThan(H(fe,B)))&&(ie=!1,B=fe),!0)),B}}e.$_b=F}),define(ne[137],se([0,1,14]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function D(u,a){if(!u)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}e.ok=D;function s(u,a="Unreachable"){throw new Error(a)}e.$3c=s;function M(u){if(!u)throw new P.$bb("Assertion Failed")}e.$4c=M;function C(u){if(!u()){debugger;u(),(0,P.$Z)(new P.$bb("Assertion Failed"))}}e.$5c=C;function S(u,a){let m=0;for(;m<u.length-1;){const b=u[m],y=u[m+1];if(!a(b,y))return!1;m++}return!0}e.$6c=S}),define(ne[84],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function P(D){const s=this;let M=!1,C;return function(){return M||(M=!0,C=D.apply(s,arguments)),C}}e.$cb=P}),define(ne[71],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(D){function s(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}D.is=s;const M=Object.freeze([]);function C(){return M}D.empty=C;function*S(c){yield c}D.single=S;function u(c){return s(c)?c:S(c)}D.wrap=u;function a(c){return c||M}D.from=a;function*m(c){for(let i=c.length-1;i>=0;i--)yield c[i]}D.reverse=m;function b(c){return!c||c[Symbol.iterator]().next().done===!0}D.isEmpty=b;function y(c){return c[Symbol.iterator]().next().value}D.first=y;function f(c,i){for(const o of c)if(i(o))return!0;return!1}D.some=f;function v(c,i){for(const o of c)if(i(o))return o}D.find=v;function*w(c,i){for(const o of c)i(o)&&(yield o)}D.filter=w;function*p(c,i){let o=0;for(const r of c)yield i(r,o++)}D.map=p;function*$(...c){for(const i of c)for(const o of i)yield o}D.concat=$;function d(c,i,o){let r=o;for(const t of c)r=i(r,t);return r}D.reduce=d;function*h(c,i,o=c.length){for(i<0&&(i+=c.length),o<0?o+=c.length:o>c.length&&(o=c.length);i<o;i++)yield c[i]}D.slice=h;function E(c,i=Number.POSITIVE_INFINITY){const o=[];if(i===0)return[o,c];const r=c[Symbol.iterator]();for(let t=0;t<i;t++){const n=r.next();if(n.done)return[o,D.empty()];o.push(n.value)}return[o,{[Symbol.iterator](){return r}}]}D.consume=E})(P||(e.Iterable=P={}))}),define(ne[44],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var D;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var s;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function C(i,o=!1){let r=0;const t=i.length;let n="",l=0,g=16,A=0;function R(X){let ce=0,re=0;for(;ce<X;){const ae=i.charCodeAt(r);if(ae>=48&&ae<=57)re=re*16+ae-48;else if(ae>=65&&ae<=70)re=re*16+ae-65+10;else if(ae>=97&&ae<=102)re=re*16+ae-97+10;else break;r++,ce++}return ce<X&&(re=-1),re}function k(X){r=X,n="",l=0,g=16,A=0}function I(){const X=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&a(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&a(i.charCodeAt(r)))for(r++;r<i.length&&a(i.charCodeAt(r));)r++;else return A=3,i.substring(X,r);let ce=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&a(i.charCodeAt(r))){for(r++;r<i.length&&a(i.charCodeAt(r));)r++;ce=r}else A=3;return i.substring(X,ce)}function L(){let X="",ce=r;for(;;){if(r>=t){X+=i.substring(ce,r),A=2;break}const re=i.charCodeAt(r);if(re===34){X+=i.substring(ce,r),r++;break}if(re===92){if(X+=i.substring(ce,r),r++,r>=t){A=2;break}switch(i.charCodeAt(r++)){case 34:X+='"';break;case 92:X+="\\";break;case 47:X+="/";break;case 98:X+="\b";break;case 102:X+="\f";break;case 110:X+=`
`;break;case 114:X+="\r";break;case 116:X+="	";break;case 117:{const Z=R(4);Z>=0?X+=String.fromCharCode(Z):A=4;break}default:A=5}ce=r;continue}if(re>=0&&re<=31)if(u(re)){X+=i.substring(ce,r),A=2;break}else A=6;r++}return X}function N(){if(n="",A=0,l=r,r>=t)return l=t,g=17;let X=i.charCodeAt(r);if(S(X)){do r++,n+=String.fromCharCode(X),X=i.charCodeAt(r);while(S(X));return g=15}if(u(X))return r++,n+=String.fromCharCode(X),X===13&&i.charCodeAt(r)===10&&(r++,n+=`
`),g=14;switch(X){case 123:return r++,g=1;case 125:return r++,g=2;case 91:return r++,g=3;case 93:return r++,g=4;case 58:return r++,g=6;case 44:return r++,g=5;case 34:return r++,n=L(),g=10;case 47:{const ce=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<t&&!u(i.charCodeAt(r));)r++;return n=i.substring(ce,r),g=12}if(i.charCodeAt(r+1)===42){r+=2;const re=t-1;let ae=!1;for(;r<re;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,ae=!0;break}r++}return ae||(r++,A=1),n=i.substring(ce,r),g=13}return n+=String.fromCharCode(X),r++,g=16}case 45:if(n+=String.fromCharCode(X),r++,r===t||!a(i.charCodeAt(r)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=I(),g=11;default:for(;r<t&&T(X);)r++,X=i.charCodeAt(r);if(l!==r){switch(n=i.substring(l,r),n){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return n+=String.fromCharCode(X),r++,g=16}}function T(X){if(S(X)||u(X))return!1;switch(X){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let X;do X=N();while(X>=12&&X<=15);return X}return{setPosition:k,getPosition:()=>r,scan:o?x:N,getToken:()=>g,getTokenValue:()=>n,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>A}}e.$Um=C;function S(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var m;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(m||(m={}));function b(i,o){const r=[],t=new Object;let n;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function A(R,k,I,L){l.value=R,l.offset=k,l.length=I,l.type=L,l.colonOffset=void 0,n=l}try{h(i,{onObjectBegin:(R,k)=>{if(o<=R)throw t;n=void 0,g=o>R,r.push("")},onObjectProperty:(R,k,I)=>{if(o<k||(A(R,k,I,"property"),r[r.length-1]=R,o<=k+I))throw t},onObjectEnd:(R,k)=>{if(o<=R)throw t;n=void 0,r.pop()},onArrayBegin:(R,k)=>{if(o<=R)throw t;n=void 0,r.push(0)},onArrayEnd:(R,k)=>{if(o<=R)throw t;n=void 0,r.pop()},onLiteralValue:(R,k,I)=>{if(o<k||(A(R,k,I,c(R)),o<=k+I))throw t},onSeparator:(R,k,I)=>{if(o<=k)throw t;if(R===":"&&n&&n.type==="property")n.colonOffset=k,g=!1,n=void 0;else if(R===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(g=!0,r[r.length-1]=""),n=void 0}}})}catch(R){if(R!==t)throw R}return{path:r,previousNode:n,isAtPropertyKey:g,matches:R=>{let k=0;for(let I=0;k<R.length&&I<r.length;I++)if(R[k]===r[I]||R[k]==="*")k++;else if(R[k]!=="**")return!1;return k===R.length}}}e.$Vm=b;function y(i,o=[],r=M.DEFAULT){let t=null,n=[];const l=[];function g(R){Array.isArray(n)?n.push(R):t!==null&&(n[t]=R)}return h(i,{onObjectBegin:()=>{const R={};g(R),l.push(n),n=R,t=null},onObjectProperty:R=>{t=R},onObjectEnd:()=>{n=l.pop()},onArrayBegin:()=>{const R=[];g(R),l.push(n),n=R,t=null},onArrayEnd:()=>{n=l.pop()},onLiteralValue:g,onError:(R,k,I)=>{o.push({error:R,offset:k,length:I})}},r),n[0]}e.$Wm=y;function f(i,o=[],r=M.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(R){t.type==="property"&&(t.length=R-t.offset,t=t.parent)}function l(R){return t.children.push(R),R}h(i,{onObjectBegin:R=>{t=l({type:"object",offset:R,length:-1,parent:t,children:[]})},onObjectProperty:(R,k,I)=>{t=l({type:"property",offset:k,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:R,offset:k,length:I,parent:t})},onObjectEnd:(R,k)=>{t.length=R+k-t.offset,t=t.parent,n(R+k)},onArrayBegin:(R,k)=>{t=l({type:"array",offset:R,length:-1,parent:t,children:[]})},onArrayEnd:(R,k)=>{t.length=R+k-t.offset,t=t.parent,n(R+k)},onLiteralValue:(R,k,I)=>{l({type:c(R),offset:k,length:I,parent:t,value:R}),n(k+I)},onSeparator:(R,k,I)=>{t.type==="property"&&(R===":"?t.colonOffset=k:R===","&&n(k))},onError:(R,k,I)=>{o.push({error:R,offset:k,length:I})}},r);const A=t.children[0];return A&&delete A.parent,A}e.$Xm=f;function v(i,o){if(!i)return;let r=i;for(const t of o)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===t){r=l.children[1],n=!0;break}if(!n)return}else{const n=t;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$Ym=v;function w(i){if(!i.parent||!i.parent.children)return[];const o=w(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;o.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&o.push(r)}return o}e.$Zm=w;function p(i){switch(i.type){case"array":return i.children.map(p);case"object":{const o=Object.create(null);for(const r of i.children){const t=r.children[1];t&&(o[r.children[0].value]=p(t))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$1m=p;function $(i,o,r=!1){return o>=i.offset&&o<i.offset+i.length||r&&o===i.offset+i.length}e.$2m=$;function d(i,o,r=!1){if($(i,o,r)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=o;n++){const l=d(t[n],o,r);if(l)return l}return i}}e.$3m=d;function h(i,o,r=M.DEFAULT){const t=C(i,!1);function n(q){return q?()=>q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function l(q){return q?Y=>q(Y,t.getTokenOffset(),t.getTokenLength()):()=>!0}const g=n(o.onObjectBegin),A=l(o.onObjectProperty),R=n(o.onObjectEnd),k=n(o.onArrayBegin),I=n(o.onArrayEnd),L=l(o.onLiteralValue),N=l(o.onSeparator),T=n(o.onComment),x=l(o.onError),X=r&&r.disallowComments,ce=r&&r.allowTrailingComma;function re(){for(;;){const q=t.scan();switch(t.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:X||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(q){case 12:case 13:X?ae(10):T();break;case 16:ae(1);break;case 15:case 14:break;default:return q}}}function ae(q,Y=[],oe=[]){if(x(q),Y.length+oe.length>0){let J=t.getToken();for(;J!==17;){if(Y.indexOf(J)!==-1){re();break}else if(oe.indexOf(J)!==-1)break;J=re()}}}function Z(q){const Y=t.getTokenValue();return q?L(Y):A(Y),re(),!0}function K(){switch(t.getToken()){case 11:{let q=0;try{q=JSON.parse(t.getTokenValue()),typeof q!="number"&&(ae(2),q=0)}catch{ae(2)}L(q);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return re(),!0}function G(){return t.getToken()!==10?(ae(3,[],[2,5]),!1):(Z(!1),t.getToken()===6?(N(":"),re(),V()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function z(){g(),re();let q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(q||ae(4,[],[]),N(","),re(),t.getToken()===2&&ce)break}else q&&ae(6,[],[]);G()||ae(4,[],[2,5]),q=!0}return R(),t.getToken()!==2?ae(7,[2],[]):re(),!0}function W(){k(),re();let q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(q||ae(4,[],[]),N(","),re(),t.getToken()===4&&ce)break}else q&&ae(6,[],[]);V()||ae(4,[],[4,5]),q=!0}return I(),t.getToken()!==4?ae(8,[4],[]):re(),!0}function V(){switch(t.getToken()){case 3:return W();case 1:return z();case 10:return Z(!0);default:return K()}}return re(),t.getToken()===17?r.allowEmptyContent?!0:(ae(4,[],[]),!1):V()?(t.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.$4m=h;function E(i,o){const r=C(i),t=[];let n,l=0,g;do switch(g=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:l!==g&&t.push(i.substring(l,g)),o!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,o)),l=r.getPosition();break}while(n!==17);return t.join("")}e.$5m=E;function c(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=c}),define(ne[138],se([0,1,44]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eT=e.$dT=e.$cT=e.$bT=void 0;function D(a,m,b){let y,f,v,w,p;if(m){for(w=m.offset,p=w+m.length,v=w;v>0&&!u(a,v-1);)v--;let g=p;for(;g<a.length&&!u(a,g);)g++;f=a.substring(v,g),y=C(f,b)}else f=a,y=0,v=0,w=0,p=a.length;const $=S(b,a);let d=!1,h=0,E;b.insertSpaces?E=M(" ",b.tabSize||4):E="	";const c=(0,P.$Um)(f,!1);let i=!1;function o(){return $+M(E,y+h)}function r(){let g=c.scan();for(d=!1;g===15||g===14;)d=d||g===14,g=c.scan();return i=g===16||c.getTokenError()!==0,g}const t=[];function n(g,A,R){!i&&A<p&&R>w&&a.substring(A,R)!==g&&t.push({offset:A,length:R-A,content:g})}let l=r();if(l!==17){const g=c.getTokenOffset()+v,A=M(E,y);n(A,v,g)}for(;l!==17;){let g=c.getTokenOffset()+c.getTokenLength()+v,A=r(),R="";for(;!d&&(A===12||A===13);){const I=c.getTokenOffset()+v;n(" ",g,I),g=c.getTokenOffset()+c.getTokenLength()+v,R=A===12?o():"",A=r()}if(A===2)l!==1&&(h--,R=o());else if(A===4)l!==3&&(h--,R=o());else{switch(l){case 3:case 1:h++,R=o();break;case 5:case 12:R=o();break;case 13:d?R=o():R=" ";break;case 6:R=" ";break;case 10:if(A===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:A===12||A===13?R=" ":A!==5&&A!==17&&(i=!0);break;case 16:i=!0;break}d&&(A===12||A===13)&&(R=o())}const k=c.getTokenOffset()+v;n(R,g,k),l=A}return t}e.$bT=D;function s(a,m){const b=JSON.stringify(a,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?b.replace(/\r\n|\r|\n/g,m.eol):b}e.$cT=s;function M(a,m){let b="";for(let y=0;y<m;y++)b+=a;return b}function C(a,m){let b=0,y=0;const f=m.tabSize||4;for(;b<a.length;){const v=a.charAt(b);if(v===" ")y++;else if(v==="	")y+=f;else break;b++}return Math.floor(y/f)}function S(a,m){for(let b=0;b<m.length;b++){const y=m.charAt(b);if(y==="\r")return b+1<m.length&&m.charAt(b+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return a&&a.eol||`
`}e.$dT=S;function u(a,m){return`\r
`.indexOf(a.charAt(m))!==-1}e.$eT=u}),define(ne[139],se([0,1,44,138]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jT=e.$iT=e.$hT=e.$gT=e.$fT=void 0;function s(a,m,b){return M(a,m,void 0,b)}e.$fT=s;function M(a,m,b,y,f){const v=m.slice(),w=[],p=(0,P.$Xm)(a,w);let $,d;for(;v.length>0&&(d=v.pop(),$=(0,P.$Ym)(p,v),$===void 0&&b!==void 0);)typeof d=="string"?b={[d]:b}:b=[b];if($)if($.type==="object"&&typeof d=="string"&&Array.isArray($.children)){const h=(0,P.$Ym)($,[d]);if(h!==void 0)if(b===void 0){if(!h.parent)throw new Error("Malformed AST");const E=$.children.indexOf(h.parent);let c,i=h.parent.offset+h.parent.length;if(E>0){const o=$.children[E-1];c=o.offset+o.length}else c=$.offset+1,$.children.length>1&&(i=$.children[1].offset);return C(a,{offset:c,length:i-c,content:""},y)}else return C(a,{offset:h.offset,length:h.length,content:JSON.stringify(b)},y);else{if(b===void 0)return[];const E=`${JSON.stringify(d)}: ${JSON.stringify(b)}`,c=f?f($.children.map(o=>o.children[0].value)):$.children.length;let i;if(c>0){const o=$.children[c-1];i={offset:o.offset+o.length,length:0,content:","+E}}else $.children.length===0?i={offset:$.offset+1,length:0,content:E}:i={offset:$.offset+1,length:0,content:E+","};return C(a,i,y)}}else if($.type==="array"&&typeof d=="number"&&Array.isArray($.children))if(b!==void 0){const h=`${JSON.stringify(b)}`;let E;if($.children.length===0||d===0)E={offset:$.offset+1,length:0,content:$.children.length===0?h:h+","};else{const c=d===-1||d>$.children.length?$.children.length:d,i=$.children[c-1];E={offset:i.offset+i.length,length:0,content:","+h}}return C(a,E,y)}else{const h=d,E=$.children[h];let c;if($.children.length===1)c={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===h){const i=$.children[h-1],o=i.offset+i.length,r=$.offset+$.length;c={offset:o,length:r-2-o,content:""}}else c={offset:E.offset,length:$.children[h+1].offset-E.offset,content:""};return C(a,c,y)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${$.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return C(a,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(b)},y)}}e.$gT=M;function C(a,m,b){let y=S(a,m),f=m.offset,v=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;f>0&&!(0,D.$eT)(y,f-1);)f--;for(;v<y.length&&!(0,D.$eT)(y,v);)v++}const w=(0,D.$bT)(y,{offset:f,length:v-f},b);for(let $=w.length-1;$>=0;$--){const d=w[$];y=S(y,d),f=Math.min(f,d.offset),v=Math.max(v,d.offset+d.length),v+=d.content.length-d.length}const p=a.length-(y.length-v)-f;return[{offset:f,length:p,content:y.substring(f,v)}]}e.$hT=C;function S(a,m){return a.substring(0,m.offset)+m.content+a.substring(m.offset+m.length)}e.$iT=S;function u(a,m){const b=m.slice(0).sort((f,v)=>{const w=f.offset-v.offset;return w===0?f.length-v.length:w});let y=a.length;for(let f=b.length-1;f>=0;f--){const v=b[f];if(v.offset+v.length<=y)a=S(a,v);else throw new Error("Overlapping edit");y=v.offset}return a}e.$jT=u}),define(ne[72],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class P{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=P}),define(ne[101],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(M){this.element=M,this.next=P.Undefined,this.prev=P.Undefined}}class D{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let M=this.a;for(;M!==P.Undefined;){const C=M.next;M.prev=P.Undefined,M.next=P.Undefined,M=C}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,C){const S=new P(M);if(this.a===P.Undefined)this.a=S,this.b=S;else if(C){const a=this.b;this.b=S,S.prev=a,a.next=S}else{const a=this.a;this.a=S,S.next=a,a.prev=S}this.c+=1;let u=!1;return()=>{u||(u=!0,this.e(S))}}shift(){if(this.a!==P.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==P.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==P.Undefined&&M.next!==P.Undefined){const C=M.prev;C.next=M.next,M.next.prev=C}else M.prev===P.Undefined&&M.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):M.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):M.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==P.Undefined;)yield M.element,M=M.next}}e.$1c=D}),define(ne[31],se([0,1]),function(Q,e){"use strict";var P,D,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function M(d,h,E){let c=d.get(h);return c===void 0&&(c=E,d.set(h,c)),c}e.$wc=M;function C(d){const h=[];return d.forEach((E,c)=>{h.push(`${c} => ${E}`)}),`Map(${d.size}) {${h.join(", ")}}`}e.$xc=C;function S(d){const h=[];return d.forEach(E=>{h.push(E)}),`Set(${d.size}) {${h.join(", ")}}`}e.$yc=S;class u{constructor(h,E){this.uri=h,this.value=E}}function a(d){return Array.isArray(d)}class m{static{this.a=h=>h.toString()}constructor(h,E){if(this[P]="ResourceMap",h instanceof m)this.b=new Map(h.b),this.c=E??m.a;else if(a(h)){this.b=new Map,this.c=E??m.a;for(const[c,i]of h)this.set(c,i)}else this.b=new Map,this.c=h??m.a}set(h,E){return this.b.set(this.c(h),new u(h,E)),this}get(h){return this.b.get(this.c(h))?.value}has(h){return this.b.has(this.c(h))}get size(){return this.b.size}clear(){this.b.clear()}delete(h){return this.b.delete(this.c(h))}forEach(h,E){typeof E<"u"&&(h=h.bind(E));for(const[c,i]of this.b)h(i.value,i.uri,this)}*values(){for(const h of this.b.values())yield h.value}*keys(){for(const h of this.b.values())yield h.uri}*entries(){for(const h of this.b.values())yield[h.uri,h.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.b)yield[h.uri,h.value]}}e.$zc=m;class b{constructor(h,E){this[D]="ResourceSet",!h||typeof h=="function"?this.a=new m(h):(this.a=new m(E),h.forEach(this.add,this))}get size(){return this.a.size}add(h){return this.a.set(h,h),this}clear(){this.a.clear()}delete(h){return this.a.delete(h)}forEach(h,E){this.a.forEach((c,i)=>h.call(E,i,i,this))}has(h){return this.a.has(h)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=b;var y;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class f{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(h){return this.a.has(h)}get(h,E=0){const c=this.a.get(h);if(c)return E!==0&&this.j(c,E),c.value}set(h,E,c=0){let i=this.a.get(h);if(i)i.value=E,c!==0&&this.j(i,c);else{switch(i={key:h,value:E,next:void 0,previous:void 0},c){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(h,i),this.d++}return this}delete(h){return!!this.remove(h)}remove(h){const E=this.a.get(h);if(E)return this.a.delete(h),this.i(E),this.d--,E.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const h=this.b;return this.a.delete(h.key),this.i(h),this.d--,h.value}forEach(h,E){const c=this.e;let i=this.b;for(;i;){if(E?h.bind(E)(i.value,i.key,this):h(i.value,i.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const h=this,E=this.e;let c=this.b;const i={[Symbol.iterator](){return i},next(){if(h.e!==E)throw new Error("LinkedMap got modified during iteration.");if(c){const o={value:c.key,done:!1};return c=c.next,o}else return{value:void 0,done:!0}}};return i}values(){const h=this,E=this.e;let c=this.b;const i={[Symbol.iterator](){return i},next(){if(h.e!==E)throw new Error("LinkedMap got modified during iteration.");if(c){const o={value:c.value,done:!1};return c=c.next,o}else return{value:void 0,done:!0}}};return i}entries(){const h=this,E=this.e;let c=this.b;const i={[Symbol.iterator](){return i},next(){if(h.e!==E)throw new Error("LinkedMap got modified during iteration.");if(c){const o={value:[c.key,c.value],done:!1};return c=c.next,o}else return{value:void 0,done:!0}}};return i}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(h){if(h>=this.size)return;if(h===0){this.clear();return}let E=this.b,c=this.size;for(;E&&c>h;)this.a.delete(E.key),E=E.next,c--;this.b=E,this.d=c,E&&(E.previous=void 0),this.e++}g(h){if(!this.b&&!this.c)this.c=h;else if(this.b)h.next=this.b,this.b.previous=h;else throw new Error("Invalid list");this.b=h,this.e++}h(h){if(!this.b&&!this.c)this.b=h;else if(this.c)h.previous=this.c,this.c.next=h;else throw new Error("Invalid list");this.c=h,this.e++}i(h){if(h===this.b&&h===this.c)this.b=void 0,this.c=void 0;else if(h===this.b){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.b=h.next}else if(h===this.c){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.c=h.previous}else{const E=h.next,c=h.previous;if(!E||!c)throw new Error("Invalid list");E.previous=c,c.next=E}h.next=void 0,h.previous=void 0,this.e++}j(h,E){if(!this.b||!this.c)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(h===this.b)return;const c=h.next,i=h.previous;h===this.c?(i.next=void 0,this.c=i):(c.previous=i,i.next=c),h.previous=void 0,h.next=this.b,this.b.previous=h,this.b=h,this.e++}else if(E===2){if(h===this.c)return;const c=h.next,i=h.previous;h===this.b?(c.previous=void 0,this.b=c):(c.previous=i,i.next=c),h.next=void 0,h.previous=this.c,this.c.next=h,this.c=h,this.e++}}}toJSON(){const h=[];return this.forEach((E,c)=>{h.push([c,E])}),h}fromJSON(h){this.clear();for(const[E,c]of h)this.set(E,c)}}e.$Bc=f;class v extends f{constructor(h,E=1){super(),this.k=h,this.l=Math.min(Math.max(0,E),1)}get limit(){return this.k}set limit(h){this.k=h,this.m()}get ratio(){return this.l}set ratio(h){this.l=Math.min(Math.max(0,h),1),this.m()}get(h,E=2){return super.get(h,E)}peek(h){return super.get(h,0)}set(h,E){return super.set(h,E,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=v;class w{constructor(){this.a=new Map}add(h){return this.a.set(h,(this.a.get(h)||0)+1),this}delete(h){let E=this.a.get(h)||0;return E===0?!1:(E--,E===0?this.a.delete(h):this.a.set(h,E),!0)}has(h){return this.a.has(h)}}e.$Dc=w;class p{constructor(h){if(this.a=new Map,this.b=new Map,h)for(const[E,c]of h)this.set(E,c)}clear(){this.a.clear(),this.b.clear()}set(h,E){this.a.set(h,E),this.b.set(E,h)}get(h){return this.a.get(h)}getKey(h){return this.b.get(h)}delete(h){const E=this.a.get(h);return E===void 0?!1:(this.a.delete(h),this.b.delete(E),!0)}forEach(h,E){this.a.forEach((c,i)=>{h.call(E,c,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=p;class ${constructor(){this.a=new Map}add(h,E){let c=this.a.get(h);c||(c=new Set,this.a.set(h,c)),c.add(E)}delete(h,E){const c=this.a.get(h);c&&(c.delete(E),c.size===0&&this.a.delete(h))}forEach(h,E){const c=this.a.get(h);c&&c.forEach(E)}get(h){const E=this.a.get(h);return E||new Set}}e.$Fc=$}),define(ne[2],se([0,1,23,135,31,84,71]),function(Q,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const S=!1;let u=null;class a{constructor(){this.b=new Map}static{this.a=0}c(I){let L=this.b.get(I);return L||(L={parent:null,source:null,isSingleton:!1,value:I,idx:a.a++},this.b.set(I,L)),L}trackDisposable(I){const L=this.c(I);L.source||(L.source=new Error().stack)}setParent(I,L){const N=this.c(I);N.parent=L}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,L){const N=L.get(I);if(N)return N;const T=I.parent?this.f(this.c(I.parent),L):I;return L.set(I,T),T}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,I).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(I=10,L){let N;if(L)N=L;else{const re=new Map,ae=[...this.b.values()].filter(K=>K.source!==null&&!this.f(K,re).isSingleton);if(ae.length===0)return;const Z=new Set(ae.map(K=>K.value));if(N=ae.filter(K=>!(K.parent&&Z.has(K.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function T(re){function ae(K,G){for(;K.length>0&&G.some(z=>typeof z=="string"?z===K[0]:K[0].match(z));)K.shift()}const Z=re.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return ae(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const x=new s.$Fc;for(const re of N){const ae=T(re);for(let Z=0;Z<=ae.length;Z++)x.add(ae.slice(0,Z).join(`
`),re)}N.sort((0,P.$6b)(re=>re.idx,P.$8b));let X="",ce=0;for(const re of N.slice(0,I)){ce++;const ae=T(re),Z=[];for(let K=0;K<ae.length;K++){let G=ae[K];G=`(shared with ${x.get(ae.slice(0,K+1).join(`
`)).size}/${N.length} leaks) at ${G}`;const W=x.get(ae.slice(0,K).join(`
`)),V=(0,D.$J)([...W].map(q=>T(q)[K]),q=>q);delete V[ae[K]];for(const[q,Y]of Object.entries(V))Z.unshift(`    - stacktraces of ${Y.length} other leaks continue with ${q}`);Z.unshift(G)}X+=`


==================== Leaking disposable ${ce}/${N.length}: ${re.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return N.length>I&&(X+=`


... and ${N.length-I} more leaking disposables

`),{leaks:N,details:X}}}e.$Gc=a;function m(k){u=k}if(e.$Hc=m,S){const k="__is_disposable_tracked__";m(new class{trackDisposable(I){const L=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[k]||console.log(L)},3e3)}setParent(I,L){if(I&&I!==i.None)try{I[k]=!0}catch{}}markAsDisposed(I){if(I&&I!==i.None)try{I[k]=!0}catch{}}markAsSingleton(I){}})}function b(k){return u?.trackDisposable(k),k}e.$Ic=b;function y(k){u?.markAsDisposed(k)}e.$Jc=y;function f(k,I){u?.setParent(k,I)}function v(k,I){if(u)for(const L of k)u.setParent(L,I)}function w(k){return u?.markAsSingleton(k),k}e.$Kc=w;function p(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Lc=p;function $(k){if(C.Iterable.is(k)){const I=[];for(const L of k)if(L)try{L.dispose()}catch(N){I.push(N)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Mc=$;function d(k){for(const I of k)p(I)&&I.dispose();return[]}e.$Nc=d;function h(...k){const I=E(()=>$(k));return v(k,I),I}e.$Oc=h;function E(k){const I=b({dispose:(0,M.$cb)(()=>{y(I),k()})});return I}e.$Pc=E;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(y(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return f(I,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),f(I,null))}}e.$Qc=c;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,b(this),f(this.q,this)}dispose(){y(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Rc=i;class o{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&f(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&f(I,null),I}}e.$Sc=o;class r{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=r;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(I){let L=I;return this.unset=()=>L=void 0,this.isset=()=>L!==void 0,this.dispose=()=>{L&&(L(),L=void 0,y(this))},this}}e.$Uc=t;class n{constructor(){this.a=new Map}acquire(I,...L){let N=this.a.get(I);N||(N={counter:0,object:this.b(I,...L)},this.a.set(I,N));const{object:T}=N,x=(0,M.$cb)(()=>{--N.counter===0&&(this.c(I,N.object),this.a.delete(I))});return N.counter++,{object:T,dispose:x}}}e.$Vc=n;class l{constructor(I){this.a=I}async acquire(I,...L){const N=this.a.acquire(I,...L);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(T){throw N.dispose(),T}}}e.$Wc=l;class g{constructor(I){this.object=I}dispose(){}}e.$Xc=g;function A(k){const I=new c;try{k(I)}finally{I.dispose()}}e.$Yc=A;class R{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,L,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(I)?.dispose(),this.a.set(I,L)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=R}),define(ne[85],se([0,1,31]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ol=void 0;const D=new P.$Cc(1e4);function s(a){return u(a,"NFC",D)}e.$ol=s;const M=new P.$Cc(1e4);function C(a){return u(a,"NFD",M)}e.$pl=C;const S=/[^\u0000-\u0080]/;function u(a,m,b){if(!a)return a;const y=b.get(a);if(y)return y;let f;return S.test(a)?f=a.normalize(m):f=a,b.set(a,f),f}e.$ql=function(){const a=/[\u0300-\u036f]/g;return function(m){return C(m).replace(a,"")}}()}),define(ne[140],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function P(S,u,a){return Math.min(Math.max(S,u),a)}e.$Ol=P;function D(S,u){return(u+S%u)%u}e.rot=D;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=s;class M{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=M;class C{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const a=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=C}),function(){function Q(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function C(u){M.push(u,Date.now())}function S(){const u=[];for(let a=0;a<M.length;a+=2)u.push({name:M[a],startTime:M[a+1]});return u}return{mark:C,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const C of performance.getEntriesByType("mark"))M.push({name:C.name,startTime:Math.round(s+C.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=P(D))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var D in P)(typeof exports=="object"?exports:Q)[D]=P[D]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function P(D){if(e[D])return e[D].exports;var s=e[D]={i:D,l:!1,exports:{}};return Q[D].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=Q,P.c=e,P.d=function(D,s,M){P.o(D,s)||Object.defineProperty(D,s,{enumerable:!0,get:M})},P.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},P.t=function(D,s){if(1&s&&(D=P(D)),8&s||4&s&&typeof D=="object"&&D&&D.__esModule)return D;var M=Object.create(null);if(P.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:D}),2&s&&typeof D!="string")for(var C in D)P.d(M,C,function(S){return D[S]}.bind(null,C));return M},P.n=function(D){var s=D&&D.__esModule?function(){return D.default}:function(){return D};return P.d(s,"a",s),s},P.o=function(D,s){return Object.prototype.hasOwnProperty.call(D,s)},P.p="",P(P.s=0)}([function(Q,e,P){(function(D){var s;e=Q.exports=oe,s=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],u=e.src=[],a=0,m=a++;u[m]="0|[1-9]\\d*";var b=a++;u[b]="[0-9]+";var y=a++;u[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=a++;u[f]="("+u[m]+")\\.("+u[m]+")\\.("+u[m]+")";var v=a++;u[v]="("+u[b]+")\\.("+u[b]+")\\.("+u[b]+")";var w=a++;u[w]="(?:"+u[m]+"|"+u[y]+")";var p=a++;u[p]="(?:"+u[b]+"|"+u[y]+")";var $=a++;u[$]="(?:-("+u[w]+"(?:\\."+u[w]+")*))";var d=a++;u[d]="(?:-?("+u[p]+"(?:\\."+u[p]+")*))";var h=a++;u[h]="[0-9A-Za-z-]+";var E=a++;u[E]="(?:\\+("+u[h]+"(?:\\."+u[h]+")*))";var c=a++,i="v?"+u[f]+u[$]+"?"+u[E]+"?";u[c]="^"+i+"$";var o="[v=\\s]*"+u[v]+u[d]+"?"+u[E]+"?",r=a++;u[r]="^"+o+"$";var t=a++;u[t]="((?:<|>)?=?)";var n=a++;u[n]=u[b]+"|x|X|\\*";var l=a++;u[l]=u[m]+"|x|X|\\*";var g=a++;u[g]="[v=\\s]*("+u[l]+")(?:\\.("+u[l]+")(?:\\.("+u[l]+")(?:"+u[$]+")?"+u[E]+"?)?)?";var A=a++;u[A]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[d]+")?"+u[E]+"?)?)?";var R=a++;u[R]="^"+u[t]+"\\s*"+u[g]+"$";var k=a++;u[k]="^"+u[t]+"\\s*"+u[A]+"$";var I=a++;u[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=a++;u[L]="(?:~>?)";var N=a++;u[N]="(\\s*)"+u[L]+"\\s+",S[N]=new RegExp(u[N],"g");var T=a++;u[T]="^"+u[L]+u[g]+"$";var x=a++;u[x]="^"+u[L]+u[A]+"$";var X=a++;u[X]="(?:\\^)";var ce=a++;u[ce]="(\\s*)"+u[X]+"\\s+",S[ce]=new RegExp(u[ce],"g");var re=a++;u[re]="^"+u[X]+u[g]+"$";var ae=a++;u[ae]="^"+u[X]+u[A]+"$";var Z=a++;u[Z]="^"+u[t]+"\\s*("+o+")$|^$";var K=a++;u[K]="^"+u[t]+"\\s*("+i+")$|^$";var G=a++;u[G]="(\\s*)"+u[t]+"\\s*("+o+"|"+u[g]+")",S[G]=new RegExp(u[G],"g");var z=a++;u[z]="^\\s*("+u[g]+")\\s+-\\s+("+u[g]+")\\s*$";var W=a++;u[W]="^\\s*("+u[A]+")\\s+-\\s+("+u[A]+")\\s*$";var V=a++;u[V]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)s(q,u[q]),S[q]||(S[q]=new RegExp(u[q]));function Y(_,le){if(_ instanceof oe)return _;if(typeof _!="string"||_.length>M||!(le?S[r]:S[c]).test(_))return null;try{return new oe(_,le)}catch{return null}}function oe(_,le){if(_ instanceof oe){if(_.loose===le)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof oe))return new oe(_,le);s("SemVer",_,le),this.loose=le;var ge=_.trim().match(le?S[r]:S[c]);if(!ge)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var Ce=+Re;if(Ce>=0&&Ce<C)return Ce}return Re}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=Y,e.valid=function(_,le){var ge=Y(_,le);return ge?ge.version:null},e.clean=function(_,le){var ge=Y(_.trim().replace(/^[=v]+/,""),le);return ge?ge.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(_){return s("SemVer.compare",this.version,this.loose,_),_ instanceof oe||(_=new oe(_,this.loose)),this.compareMain(_)||this.comparePre(_)},oe.prototype.compareMain=function(_){return _ instanceof oe||(_=new oe(_,this.loose)),O(this.major,_.major)||O(this.minor,_.minor)||O(this.patch,_.patch)},oe.prototype.comparePre=function(_){if(_ instanceof oe||(_=new oe(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var le=0;do{var ge=this.prerelease[le],Re=_.prerelease[le];if(s("prerelease compare",le,ge,Re),ge===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(ge===void 0)return-1;if(ge!==Re)return O(ge,Re)}while(++le)},oe.prototype.inc=function(_,le){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,le,ge,Re){typeof ge=="string"&&(Re=ge,ge=void 0);try{return new oe(_,ge).inc(le,Re).version}catch{return null}},e.diff=function(_,le){if(H(_,le))return null;var ge=Y(_),Re=Y(le);if(ge.prerelease.length||Re.prerelease.length){for(var Ce in ge)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ge[Ce]!==Re[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in ge)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ge[Ce]!==Re[Ce])return Ce},e.compareIdentifiers=O;var J=/^[0-9]+$/;function O(_,le){var ge=J.test(_),Re=J.test(le);return ge&&Re&&(_=+_,le=+le),ge&&!Re?-1:Re&&!ge?1:_<le?-1:_>le?1:0}function j(_,le,ge){return new oe(_,ge).compare(new oe(le,ge))}function F(_,le,ge){return j(_,le,ge)>0}function U(_,le,ge){return j(_,le,ge)<0}function H(_,le,ge){return j(_,le,ge)===0}function B(_,le,ge){return j(_,le,ge)!==0}function ie(_,le,ge){return j(_,le,ge)>=0}function fe(_,le,ge){return j(_,le,ge)<=0}function de(_,le,ge,Re){var Ce;switch(le){case"===":typeof _=="object"&&(_=_.version),typeof ge=="object"&&(ge=ge.version),Ce=_===ge;break;case"!==":typeof _=="object"&&(_=_.version),typeof ge=="object"&&(ge=ge.version),Ce=_!==ge;break;case"":case"=":case"==":Ce=H(_,ge,Re);break;case"!=":Ce=B(_,ge,Re);break;case">":Ce=F(_,ge,Re);break;case">=":Ce=ie(_,ge,Re);break;case"<":Ce=U(_,ge,Re);break;case"<=":Ce=fe(_,ge,Re);break;default:throw new TypeError("Invalid operator: "+le)}return Ce}function ue(_,le){if(_ instanceof ue){if(_.loose===le)return _;_=_.value}if(!(this instanceof ue))return new ue(_,le);s("comparator",_,le),this.loose=le,this.parse(_),this.semver===be?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(_,le){return O(le,_)},e.major=function(_,le){return new oe(_,le).major},e.minor=function(_,le){return new oe(_,le).minor},e.patch=function(_,le){return new oe(_,le).patch},e.compare=j,e.compareLoose=function(_,le){return j(_,le,!0)},e.rcompare=function(_,le,ge){return j(le,_,ge)},e.sort=function(_,le){return _.sort(function(ge,Re){return e.compare(ge,Re,le)})},e.rsort=function(_,le){return _.sort(function(ge,Re){return e.rcompare(ge,Re,le)})},e.gt=F,e.lt=U,e.eq=H,e.neq=B,e.gte=ie,e.lte=fe,e.cmp=de,e.Comparator=ue;var be={};function me(_,le){if(_ instanceof me)return _.loose===le?_:new me(_.raw,le);if(_ instanceof ue)return new me(_.value,le);if(!(this instanceof me))return new me(_,le);if(this.loose=le,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Ee(_){return!_||_.toLowerCase()==="x"||_==="*"}function Se(_,le,ge,Re,Ce,Ne,Oe,He,ze,ee,he,$e,ye){return((le=Ee(ge)?"":Ee(Re)?">="+ge+".0.0":Ee(Ce)?">="+ge+"."+Re+".0":">="+le)+" "+(He=Ee(ze)?"":Ee(ee)?"<"+(+ze+1)+".0.0":Ee(he)?"<"+ze+"."+(+ee+1)+".0":$e?"<="+ze+"."+ee+"."+he+"-"+$e:"<="+He)).trim()}function je(_,le){for(var ge=0;ge<_.length;ge++)if(!_[ge].test(le))return!1;if(le.prerelease.length){for(ge=0;ge<_.length;ge++)if(s(_[ge].semver),_[ge].semver!==be&&_[ge].semver.prerelease.length>0){var Re=_[ge].semver;if(Re.major===le.major&&Re.minor===le.minor&&Re.patch===le.patch)return!0}return!1}return!0}function ke(_,le,ge){try{le=new me(le,ge)}catch{return!1}return le.test(_)}function pe(_,le,ge,Re){var Ce,Ne,Oe,He,ze;switch(_=new oe(_,Re),le=new me(le,Re),ge){case">":Ce=F,Ne=fe,Oe=U,He=">",ze=">=";break;case"<":Ce=U,Ne=ie,Oe=F,He="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(_,le,Re))return!1;for(var ee=0;ee<le.set.length;++ee){var he=le.set[ee],$e=null,ye=null;if(he.forEach(function(Ae){Ae.semver===be&&(Ae=new ue(">=0.0.0")),$e=$e||Ae,ye=ye||Ae,Ce(Ae.semver,$e.semver,Re)?$e=Ae:Oe(Ae.semver,ye.semver,Re)&&(ye=Ae)}),$e.operator===He||$e.operator===ze||(!ye.operator||ye.operator===He)&&Ne(_,ye.semver)||ye.operator===ze&&Oe(_,ye.semver))return!1}return!0}ue.prototype.parse=function(_){var le=this.loose?S[Z]:S[K],ge=_.match(le);if(!ge)throw new TypeError("Invalid comparator: "+_);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new oe(ge[2],this.loose):this.semver=be},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(_){return s("Comparator.test",_,this.loose),this.semver===be||(typeof _=="string"&&(_=new oe(_,this.loose)),de(_,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(_,le){if(!(_ instanceof ue))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new me(_.value,le),ke(this.value,ge,le);if(_.operator==="")return ge=new me(this.value,le),ke(_.semver,ge,le);var Re=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),Ne=this.semver.version===_.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),He=de(this.semver,"<",_.semver,le)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),ze=de(this.semver,">",_.semver,le)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return Re||Ce||Ne&&Oe||He||ze},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(_){var le=this.loose;_=_.trim(),s("range",_,le);var ge=le?S[W]:S[z];_=_.replace(ge,Se),s("hyphen replace",_),_=_.replace(S[G],"$1$2$3"),s("comparator trim",_,S[G]),_=(_=(_=_.replace(S[N],"$1~")).replace(S[ce],"$1^")).split(/\s+/).join(" ");var Re=le?S[Z]:S[K],Ce=_.split(" ").map(function(Ne){return function(Oe,He){return s("comp",Oe),Oe=function(ze,ee){return ze.trim().split(/\s+/).map(function(he){return function($e,ye){s("caret",$e,ye);var Ae=ye?S[ae]:S[re];return $e.replace(Ae,function(We,Le,Ue,Ve,Ge){var Je;return s("caret",$e,We,Le,Ue,Ve,Ge),Ee(Le)?Je="":Ee(Ue)?Je=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ee(Ve)?Je=Le==="0"?">="+Le+"."+Ue+".0 <"+Le+"."+(+Ue+1)+".0":">="+Le+"."+Ue+".0 <"+(+Le+1)+".0.0":Ge?(s("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Je=Le==="0"?Ue==="0"?">="+Le+"."+Ue+"."+Ve+Ge+" <"+Le+"."+Ue+"."+(+Ve+1):">="+Le+"."+Ue+"."+Ve+Ge+" <"+Le+"."+(+Ue+1)+".0":">="+Le+"."+Ue+"."+Ve+Ge+" <"+(+Le+1)+".0.0"):(s("no pr"),Je=Le==="0"?Ue==="0"?">="+Le+"."+Ue+"."+Ve+" <"+Le+"."+Ue+"."+(+Ve+1):">="+Le+"."+Ue+"."+Ve+" <"+Le+"."+(+Ue+1)+".0":">="+Le+"."+Ue+"."+Ve+" <"+(+Le+1)+".0.0"),s("caret return",Je),Je})}(he,ee)}).join(" ")}(Oe,He),s("caret",Oe),Oe=function(ze,ee){return ze.trim().split(/\s+/).map(function(he){return function($e,ye){var Ae=ye?S[x]:S[T];return $e.replace(Ae,function(We,Le,Ue,Ve,Ge){var Je;return s("tilde",$e,We,Le,Ue,Ve,Ge),Ee(Le)?Je="":Ee(Ue)?Je=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ee(Ve)?Je=">="+Le+"."+Ue+".0 <"+Le+"."+(+Ue+1)+".0":Ge?(s("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Je=">="+Le+"."+Ue+"."+Ve+Ge+" <"+Le+"."+(+Ue+1)+".0"):Je=">="+Le+"."+Ue+"."+Ve+" <"+Le+"."+(+Ue+1)+".0",s("tilde return",Je),Je})}(he,ee)}).join(" ")}(Oe,He),s("tildes",Oe),Oe=function(ze,ee){return s("replaceXRanges",ze,ee),ze.split(/\s+/).map(function(he){return function($e,ye){$e=$e.trim();var Ae=ye?S[k]:S[R];return $e.replace(Ae,function(We,Le,Ue,Ve,Ge,Je){s("xRange",$e,We,Le,Ue,Ve,Ge,Je);var Ye=Ee(Ue),Xe=Ye||Ee(Ve),it=Xe||Ee(Ge);return Le==="="&&it&&(Le=""),Ye?We=Le===">"||Le==="<"?"<0.0.0":"*":Le&&it?(Xe&&(Ve=0),it&&(Ge=0),Le===">"?(Le=">=",Xe?(Ue=+Ue+1,Ve=0,Ge=0):it&&(Ve=+Ve+1,Ge=0)):Le==="<="&&(Le="<",Xe?Ue=+Ue+1:Ve=+Ve+1),We=Le+Ue+"."+Ve+"."+Ge):Xe?We=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":it&&(We=">="+Ue+"."+Ve+".0 <"+Ue+"."+(+Ve+1)+".0"),s("xRange return",We),We})}(he,ee)}).join(" ")}(Oe,He),s("xrange",Oe),Oe=function(ze,ee){return s("replaceStars",ze,ee),ze.trim().replace(S[V],"")}(Oe,He),s("stars",Oe),Oe}(Ne,le)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Ne){return!!Ne.match(Re)})),Ce=Ce.map(function(Ne){return new ue(Ne,le)})},me.prototype.intersects=function(_,le){if(!(_ instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Re){return _.set.some(function(Ce){return Ce.every(function(Ne){return Re.intersects(Ne,le)})})})})},e.toComparators=function(_,le){return new me(_,le).set.map(function(ge){return ge.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},me.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new oe(_,this.loose));for(var le=0;le<this.set.length;le++)if(je(this.set[le],_))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(_,le,ge){var Re=null,Ce=null;try{var Ne=new me(le,ge)}catch{return null}return _.forEach(function(Oe){Ne.test(Oe)&&(Re&&Ce.compare(Oe)!==-1||(Ce=new oe(Re=Oe,ge)))}),Re},e.minSatisfying=function(_,le,ge){var Re=null,Ce=null;try{var Ne=new me(le,ge)}catch{return null}return _.forEach(function(Oe){Ne.test(Oe)&&(Re&&Ce.compare(Oe)!==1||(Ce=new oe(Re=Oe,ge)))}),Re},e.validRange=function(_,le){try{return new me(_,le).range||"*"}catch{return null}},e.ltr=function(_,le,ge){return pe(_,le,"<",ge)},e.gtr=function(_,le,ge){return pe(_,le,">",ge)},e.outside=pe,e.prerelease=function(_,le){var ge=Y(_,le);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(_,le,ge){return _=new me(_,ge),le=new me(le,ge),_.intersects(le)},e.coerce=function(_){if(_ instanceof oe)return _;if(typeof _!="string")return null;var le=_.match(S[I]);return le==null?null:Y((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,P(1))},function(Q,e){var P,D,s=Q.exports={};function M(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function S(p){if(P===setTimeout)return setTimeout(p,0);if((P===M||!P)&&setTimeout)return P=setTimeout,setTimeout(p,0);try{return P(p,0)}catch{try{return P.call(null,p,0)}catch{return P.call(this,p,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:M}catch{P=M}try{D=typeof clearTimeout=="function"?clearTimeout:C}catch{D=C}})();var u,a=[],m=!1,b=-1;function y(){m&&u&&(m=!1,u.length?a=u.concat(a):b=-1,a.length&&f())}function f(){if(!m){var p=S(y);m=!0;for(var $=a.length;$;){for(u=a,a=[];++b<$;)u&&u[b].run();b=-1,$=a.length}u=null,m=!1,function(d){if(D===clearTimeout)return clearTimeout(d);if((D===C||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(d);try{D(d)}catch{try{return D.call(null,d)}catch{return D.call(this,d)}}}(p)}}function v(p,$){this.fun=p,this.array=$}function w(){}s.nextTick=function(p){var $=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)$[d-1]=arguments[d];a.push(new v(p,$)),a.length!==1||m||S(f)},v.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=w,s.addListener=w,s.once=w,s.off=w,s.removeListener=w,s.removeAllListeners=w,s.emit=w,s.prependListener=w,s.prependOnceListener=w,s.listeners=function(p){return[]},s.binding=function(p){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(p){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(ne[141],se([0,1]),function(Q,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;class D{constructor(S,u,a){this.level=S,this.key=u,this.value=a,this.forward=[]}}const s=void 0;class M{constructor(S,u=2**16){this.comparator=S,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,s,s)}get size(){return this.f}clear(){this.e=new D(this.c,s,s),this.f=0}has(S){return!!M.g(this,S,this.comparator)}get(S){return M.g(this,S,this.comparator)?.value}set(S,u){return M.h(this,S,u,this.comparator)&&(this.f+=1),this}delete(S){const u=M.k(this,S,this.comparator);return u&&(this.f-=1),u}forEach(S,u){let a=this.e.forward[0];for(;a;)S.call(u,a.value,a.key,this),a=a.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",u=this.e.forward[0];for(;u;)S+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return S}static g(S,u,a){let m=S.e;for(let b=S.d-1;b>=0;b--)for(;m.forward[b]&&a(m.forward[b].key,u)<0;)m=m.forward[b];if(m=m.forward[0],m&&a(m.key,u)===0)return m}static h(S,u,a,m){const b=[];let y=S.e;for(let f=S.d-1;f>=0;f--){for(;y.forward[f]&&m(y.forward[f].key,u)<0;)y=y.forward[f];b[f]=y}if(y=y.forward[0],y&&m(y.key,u)===0)return y.value=a,!1;{const f=M.j(S);if(f>S.d){for(let v=S.d;v<f;v++)b[v]=S.e;S.d=f}y=new D(f,u,a);for(let v=0;v<f;v++)y.forward[v]=b[v].forward[v],b[v].forward[v]=y;return!0}}static j(S,u=.5){let a=1;for(;Math.random()<u&&a<S.c;)a+=1;return a}static k(S,u,a){const m=[];let b=S.e;for(let y=S.d-1;y>=0;y--){for(;b.forward[y]&&a(b.forward[y].key,u)<0;)b=b.forward[y];m[y]=b}if(b=b.forward[0],!b||a(b.key,u)!==0)return!1;for(let y=0;y<S.d&&m[y].forward[y]===b;y++)m[y].forward[y]=b.forward[y];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$Br=M}),define(ne[73],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(M){return new D(M)}constructor(M){this.c=P&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Jd=D}),define(ne[3],se([0,1,14,84,2,101,73]),function(Q,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.Event=void 0;const S=!1,u=!1;var a;(function(R){R.None=()=>s.$Rc.None;function k(de){if(u){const{onDidAddListener:ue}=de,be=v.create();let me=0;de.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),be.print()),ue?.()}}}function I(de,ue){return K(de,()=>{},0,void 0,!0,void 0,ue)}R.defer=I;function L(de){return(ue,be=null,me)=>{let Ee=!1,Se;return Se=de(je=>{if(!Ee)return Se?Se.dispose():Ee=!0,ue.call(be,je)},null,me),Ee&&Se.dispose(),Se}}R.once=L;function N(de,ue,be){return ae((me,Ee=null,Se)=>de(je=>me.call(Ee,ue(je)),null,Se),be)}R.map=N;function T(de,ue,be){return ae((me,Ee=null,Se)=>de(je=>{ue(je),me.call(Ee,je)},null,Se),be)}R.forEach=T;function x(de,ue,be){return ae((me,Ee=null,Se)=>de(je=>ue(je)&&me.call(Ee,je),null,Se),be)}R.filter=x;function X(de){return de}R.signal=X;function ce(...de){return(ue,be=null,me)=>{const Ee=(0,s.$Oc)(...de.map(Se=>Se(je=>ue.call(be,je))));return Z(Ee,me)}}R.any=ce;function re(de,ue,be,me){let Ee=be;return N(de,Se=>(Ee=ue(Ee,Se),Ee),me)}R.reduce=re;function ae(de,ue){let be;const me={onWillAddFirstListener(){be=de(Ee.fire,Ee)},onDidRemoveLastListener(){be?.dispose()}};ue||k(me);const Ee=new h(me);return ue?.add(Ee),Ee.event}function Z(de,ue){return ue instanceof Array?ue.push(de):ue&&ue.add(de),de}function K(de,ue,be=100,me=!1,Ee=!1,Se,je){let ke,pe,_,le=0,ge;const Re={leakWarningThreshold:Se,onWillAddFirstListener(){ke=de(Ne=>{le++,pe=ue(pe,Ne),me&&!_&&(Ce.fire(pe),pe=void 0),ge=()=>{const Oe=pe;pe=void 0,_=void 0,(!me||le>1)&&Ce.fire(Oe),le=0},typeof be=="number"?(clearTimeout(_),_=setTimeout(ge,be)):_===void 0&&(_=0,queueMicrotask(ge))})},onWillRemoveListener(){Ee&&le>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,ke.dispose()}};je||k(Re);const Ce=new h(Re);return je?.add(Ce),Ce.event}R.debounce=K;function G(de,ue=0,be){return R.debounce(de,(me,Ee)=>me?(me.push(Ee),me):[Ee],ue,void 0,!0,void 0,be)}R.accumulate=G;function z(de,ue=(me,Ee)=>me===Ee,be){let me=!0,Ee;return x(de,Se=>{const je=me||!ue(Se,Ee);return me=!1,Ee=Se,je},be)}R.latch=z;function W(de,ue,be){return[R.filter(de,ue,be),R.filter(de,me=>!ue(me),be)]}R.split=W;function V(de,ue=!1,be=[],me){let Ee=be.slice(),Se=de(pe=>{Ee?Ee.push(pe):ke.fire(pe)});me&&me.add(Se);const je=()=>{Ee?.forEach(pe=>ke.fire(pe)),Ee=null},ke=new h({onWillAddFirstListener(){Se||(Se=de(pe=>ke.fire(pe)),me&&me.add(Se))},onDidAddFirstListener(){Ee&&(ue?setTimeout(je):je())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return me&&me.add(ke),ke.event}R.buffer=V;function q(de,ue){return(me,Ee,Se)=>{const je=ue(new oe);return de(function(ke){const pe=je.evaluate(ke);pe!==Y&&me.call(Ee,pe)},void 0,Se)}}R.chain=q;const Y=Symbol("HaltChainable");class oe{constructor(){this.f=[]}map(ue){return this.f.push(ue),this}forEach(ue){return this.f.push(be=>(ue(be),be)),this}filter(ue){return this.f.push(be=>ue(be)?be:Y),this}reduce(ue,be){let me=be;return this.f.push(Ee=>(me=ue(me,Ee),me)),this}latch(ue=(be,me)=>be===me){let be=!0,me;return this.f.push(Ee=>{const Se=be||!ue(Ee,me);return be=!1,me=Ee,Se?Ee:Y}),this}evaluate(ue){for(const be of this.f)if(ue=be(ue),ue===Y)break;return ue}}function J(de,ue,be=me=>me){const me=(...ke)=>je.fire(be(...ke)),Ee=()=>de.on(ue,me),Se=()=>de.removeListener(ue,me),je=new h({onWillAddFirstListener:Ee,onDidRemoveLastListener:Se});return je.event}R.fromNodeEventEmitter=J;function O(de,ue,be=me=>me){const me=(...ke)=>je.fire(be(...ke)),Ee=()=>de.addEventListener(ue,me),Se=()=>de.removeEventListener(ue,me),je=new h({onWillAddFirstListener:Ee,onDidRemoveLastListener:Se});return je.event}R.fromDOMEventEmitter=O;function j(de){return new Promise(ue=>L(de)(ue))}R.toPromise=j;function F(de){const ue=new h;return de.then(be=>{ue.fire(be)},()=>{ue.fire(void 0)}).finally(()=>{ue.dispose()}),ue.event}R.fromPromise=F;function U(de,ue,be){return ue(be),de(me=>ue(me))}R.runAndSubscribe=U;function H(de,ue){let be=null;function me(Se){be?.dispose(),be=new s.$Qc,ue(Se,be)}me(void 0);const Ee=de(Se=>me(Se));return(0,s.$Pc)(()=>{Ee.dispose(),be?.dispose()})}R.runAndSubscribeWithStore=H;class B{constructor(ue,be){this._observable=ue,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{ue.addObserver(this)},onDidRemoveLastListener:()=>{ue.removeObserver(this)}};be||k(me),this.emitter=new h(me),be&&be.add(this.emitter)}beginUpdate(ue){this.f++}handlePossibleChange(ue){}handleChange(ue,be){this.g=!0}endUpdate(ue){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ie(de,ue){return new B(de,ue).emitter.event}R.fromObservable=ie;function fe(de){return ue=>{let be=0,me=!1;const Ee={beginUpdate(){be++},endUpdate(){be--,be===0&&(de.reportChanges(),me&&(me=!1,ue()))},handlePossibleChange(){},handleChange(){me=!0}};return de.addObserver(Ee),de.reportChanges(),{dispose(){de.removeObserver(Ee)}}}}R.fromObservableLight=fe})(a||(e.Event=a={}));class m{static{this.all=new Set}static{this.f=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${m.f++}`,m.all.add(this)}start(k){this.g=new C.$Jd,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}e.$Ld=m;let b=-1;function y(R){const k=b;return b=R,{dispose(){b=k}}}e.$Md=y;class f{constructor(k,I=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=I,this.g=0}dispose(){this.f?.clear()}check(k,I){const L=this.threshold;if(L<=0||I<L)return;this.f||(this.f=new Map);const N=this.f.get(k.value)||0;if(this.f.set(k.value,N+1),this.g-=1,this.g<=0){this.g=L*.5;let T,x=0;for(const[X,ce]of this.f)(!T||x<ce)&&(T=X,x=ce);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${x}):`),console.warn(T)}return()=>{const T=this.f.get(k.value)||0;this.f.set(k.value,T-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class p{constructor(k){this.value=k,this.id=w++}}const $=2,d=(R,k)=>{if(R instanceof p)k(R);else for(let I=0;I<R.length;I++){const L=R[I];L&&k(L)}};class h{constructor(k){this.w=0,this.f=k,this.g=b>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new m(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const k=this.t;queueMicrotask(()=>{d(k,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(k,I,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Rc.None;if(this.m)return s.$Rc.None;I&&(k=k.bind(I));const N=new p(k);let T,x;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=v.create(),T=this.g.check(N.stack,this.w+1)),S&&(N.stack=x??v.create()),this.t?this.t instanceof p?(this.u??=new c,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const X=(0,s.$Pc)(()=>{T?.(),this.x(N)});return L instanceof s.$Qc?L.add(X):Array.isArray(L)&&L.push(X),X},this.q}x(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,L=I.indexOf(k);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[L]=void 0;const N=this.u.current===this;if(this.w*$<=I.length){let T=0;for(let x=0;x<I.length;x++)I[x]?I[T++]=I[x]:N&&(this.u.end--,T<this.u.i&&this.u.i--);I.length=T}}y(k,I){if(!k)return;const L=this.f?.onListenerError||P.$Z;if(!L){k.value(I);return}try{k.value(I)}catch(N){L(N)}}z(k){const I=k.current.t;for(;k.i<k.end;)this.y(I[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof p)this.y(this.t,k);else{const I=this.u;I.enqueue(this,k,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Nd=h;const E=()=>new c;e.$Od=E;class c{constructor(){this.i=-1,this.end=0}enqueue(k,I,L){this.i=0,this.end=L,this.current=k,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends h{async fireAsync(k,I,L){if(this.t)for(this.h||(this.h=new M.$1c),d(this.t,N=>this.h.push([N.value,k]));this.h.size>0&&!I.isCancellationRequested;){const[N,T]=this.h.shift(),x=[],X={...T,token:I,waitUntil:ce=>{if(Object.isFrozen(x))throw new Error("waitUntil can NOT be called asynchronous");L&&(ce=L(ce,N)),x.push(ce)}};try{N(X)}catch(ce){(0,P.$Z)(ce);continue}Object.freeze(x),await Promise.allSettled(x).then(ce=>{for(const re of ce)re.status==="rejected"&&(0,P.$Z)(re.reason)})}}}e.$Pd=i;class o extends h{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new M.$1c,this.A=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.A(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.w&&(this.h!==0?this.s.push(k):super.fire(k))}}e.$Qd=o;class r extends o{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}e.$Rd=r;class t extends h{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}e.$Sd=t;class n{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const I={event:k,listener:null};this.h.push(I),this.g&&this.m(I);const L=()=>{this.g&&this.o(I);const N=this.h.indexOf(I);this.h.splice(N,1)};return(0,s.$Pc)((0,D.$cb)(L))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(I=>this.f.fire(I))}o(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.f.dispose()}}e.$Td=n;class l{constructor(k,I,L,N){this.f=new s.$Qc;const T=this.f.add(new n),x=this.f.add(new s.$Zc);function X(ce){x.set(ce,T.add(N(ce)))}for(const ce of k)X(ce);this.f.add(I(ce=>{X(ce)})),this.f.add(L(ce=>{x.deleteAndDispose(ce)})),this.event=T.event}dispose(){this.f.dispose()}}e.$Ud=l;class g{constructor(){this.f=[]}wrapEvent(k){return(I,L,N)=>k(T=>{const x=this.f[this.f.length-1];x?x.push(()=>I.call(L,T)):I.call(L,T)},void 0,N)}bufferEvents(k){const I=[];this.f.push(I);const L=k();return this.f.pop(),I.forEach(N=>N()),L}}e.$Vd=g;class A{constructor(){this.f=!1,this.g=a.None,this.h=s.$Rc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Wd=A}),define(ne[22],se([0,1,3]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.CancellationToken=void 0;const D=Object.freeze(function(S,u){const a=setTimeout(S.bind(u),0);return{dispose(){clearTimeout(a)}}});var s;(function(S){function u(a){return a===S.None||a===S.Cancelled||a instanceof M?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}S.isCancellationToken=u,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?D:(this.b||(this.b=new P.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$Xd=C}),define(ne[142],se([0,1,22]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=void 0;class D{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new P.$Xd,u=this.b(S.token);return this.a={promise:u,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$we=D;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const u=JSON.stringify(S);return this.b!==u&&(this.b=u,this.a=this.c(S)),this.a}}e.$xe=s;class M{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const u=this.b(S);return this.a.set(S,u),u}}e.$ye=M}),define(ne[61],se([0,1,14,2]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function s(E){const c=E;return c?typeof c.read=="function":!1}e.$Yd=s;function M(E){const c=E;return c?[c.on,c.pause,c.resume,c.destroy].every(i=>typeof i=="function"):!1}e.$Zd=M;function C(E){const c=E;return c?M(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$1d=C;function S(E,c){return new u(E,c)}e.$2d=S;class u{constructor(c,i){this.e=c,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(i=>i(c))}h(c){this.c.error.length===0?(0,P.$Z)(c):this.c.error.slice(0).forEach(i=>i(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,i){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(c,i){if(this.a.destroyed)return;let o;switch(c){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(i);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(E,c){const i=[];let o;for(;(o=E.read())!==null;)i.push(o);return c(i)}e.$3d=a;function m(E,c,i){const o=[];let r;for(;(r=E.read())!==null&&o.length<i;)o.push(r);return r===null&&o.length>0?c(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return E.read()}}}e.$4d=m;function b(E,c){return new Promise((i,o)=>{const r=[];y(E,{onData:t=>{c&&r.push(t)},onError:t=>{c?o(t):i(void 0)},onEnd:()=>{i(c?c(r):void 0)}})})}e.$5d=b;function y(E,c,i){E.on("error",o=>{i?.isCancellationRequested||c.onError(o)}),E.on("end",()=>{i?.isCancellationRequested||c.onEnd()}),E.on("data",o=>{i?.isCancellationRequested||c.onData(o)})}e.$6d=y;function f(E,c){return new Promise((i,o)=>{const r=new D.$Qc,t=[],n=A=>{if(t.push(A),t.length>c)return r.dispose(),E.pause(),i({stream:E,buffer:t,ended:!1})},l=A=>(r.dispose(),o(A)),g=()=>(r.dispose(),i({stream:E,buffer:t,ended:!0}));r.add((0,D.$Pc)(()=>E.removeListener("error",l))),E.on("error",l),r.add((0,D.$Pc)(()=>E.removeListener("end",g))),E.on("end",g),r.add((0,D.$Pc)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$7d=f;function v(E,c){const i=S(c);return i.end(E),i}e.$8d=v;function w(){const E=S(()=>{throw new Error("not supported")});return E.end(),E}e.$9d=w;function p(E){let c=!1;return{read:()=>c?null:(c=!0,E)}}e.$0d=p;function $(E,c,i){const o=S(i);return y(E,{onData:r=>o.write(c.data(r)),onError:r=>o.error(c.error?c.error(r):r),onEnd:()=>o.end()}),o}e.$$d=$;function d(E,c,i){let o=!1;return{read:()=>{const r=c.read();return o?r:(o=!0,r!==null?i([E,r]):E)}}}e.$_d=d;function h(E,c,i){let o=!1;const r=S(i);return y(c,{onData:t=>o?r.write(t):(o=!0,r.write(i([E,t]))),onError:t=>r.error(t),onEnd:()=>{o||(o=!0,r.write(E)),r.end()}}),r}e.$ae=h}),define(ne[17],se([0,1,72,61]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const s=typeof Buffer<"u",M=new P.$U(()=>new Uint8Array(256));let C,S;class u{static alloc(I){return s?new u(Buffer.allocUnsafe(I)):new u(new Uint8Array(I))}static wrap(I){return s&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new u(I)}static fromString(I,L){return!(L?.dontUseNodeBuffer||!1)&&s?new u(Buffer.from(I)):(C||(C=new TextEncoder),new u(C.encode(I)))}static fromByteArray(I){const L=u.alloc(I.length);for(let N=0,T=I.length;N<T;N++)L.buffer[N]=I[N];return L}static concat(I,L){if(typeof L>"u"){L=0;for(let x=0,X=I.length;x<X;x++)L+=I[x].byteLength}const N=u.alloc(L);let T=0;for(let x=0,X=I.length;x<X;x++){const ce=I[x];N.set(ce,T),T+=ce.byteLength}return N}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=u.alloc(this.byteLength);return I.set(this),I}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(I,L){return new u(this.buffer.subarray(I,L))}set(I,L){if(I instanceof u)this.buffer.set(I.buffer,L);else if(I instanceof Uint8Array)this.buffer.set(I,L);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),L);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return y(this.buffer,I)}writeUInt32BE(I,L){f(this.buffer,I,L)}readUInt32LE(I){return v(this.buffer,I)}writeUInt32LE(I,L){w(this.buffer,I,L)}readUInt8(I){return p(this.buffer,I)}writeUInt8(I,L){$(this.buffer,I,L)}indexOf(I,L=0){return a(this.buffer,I instanceof u?I.buffer:I,L)}}e.$be=u;function a(k,I,L=0){const N=I.byteLength,T=k.byteLength;if(N===0)return 0;if(N===1)return k.indexOf(I[0]);if(N>T-L)return-1;const x=M.value;x.fill(I.length);for(let ae=0;ae<I.length;ae++)x[I[ae]]=I.length-ae-1;let X=L+I.length-1,ce=X,re=-1;for(;X<T;)if(k[X]===I[ce]){if(ce===0){re=X;break}X--,ce--}else X+=Math.max(I.length-ce,x[k[X]]),ce=I.length-1;return re}e.$ce=a;function m(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0}e.$de=m;function b(k,I,L){k[L+0]=I&255,I=I>>>8,k[L+1]=I&255}e.$ee=b;function y(k,I){return k[I]*2**24+k[I+1]*2**16+k[I+2]*2**8+k[I+3]}e.$fe=y;function f(k,I,L){k[L+3]=I,I=I>>>8,k[L+2]=I,I=I>>>8,k[L+1]=I,I=I>>>8,k[L]=I}e.$ge=f;function v(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0|k[I+2]<<16>>>0|k[I+3]<<24>>>0}e.$he=v;function w(k,I,L){k[L+0]=I&255,I=I>>>8,k[L+1]=I&255,I=I>>>8,k[L+2]=I&255,I=I>>>8,k[L+3]=I&255}e.$ie=w;function p(k,I){return k[I]}e.$je=p;function $(k,I,L){k[L]=I}e.$ke=$;function d(k){return D.$3d(k,I=>u.concat(I))}e.$le=d;function h(k){return D.$0d(k)}e.$me=h;function E(k){return D.$5d(k,I=>u.concat(I))}e.$ne=E;async function c(k){return k.ended?u.concat(k.buffer):u.concat([...k.buffer,await E(k.stream)])}e.$oe=c;function i(k){return D.$8d(k,I=>u.concat(I))}e.$pe=i;function o(k){return D.$$d(k,{data:I=>typeof I=="string"?u.fromString(I):u.wrap(I)},I=>u.concat(I))}e.$qe=o;function r(k){return D.$2d(I=>u.concat(I),k)}e.$re=r;function t(k,I){return D.$_d(k,I,L=>u.concat(L))}e.$se=t;function n(k,I){return D.$ae(k,I,L=>u.concat(L))}e.$te=n;function l(k){let I=0,L=0,N=0;const T=new Uint8Array(Math.floor(k.length/4*3)),x=ce=>{switch(L){case 3:T[N++]=I|ce,L=0;break;case 2:T[N++]=I|ce>>>2,I=ce<<6,L=3;break;case 1:T[N++]=I|ce>>>4,I=ce<<4,L=2;break;default:I=ce<<2,L=1}};for(let ce=0;ce<k.length;ce++){const re=k.charCodeAt(ce);if(re>=65&&re<=90)x(re-65);else if(re>=97&&re<=122)x(re-97+26);else if(re>=48&&re<=57)x(re-48+52);else if(re===43||re===45)x(62);else if(re===47||re===95)x(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${k[ce]}`)}}const X=N;for(;L>0;)x(0);return u.wrap(T).slice(0,X)}e.$ue=l;const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:k},I=!0,L=!1){const N=L?A:g;let T="";const x=k.byteLength%3;let X=0;for(;X<k.byteLength-x;X+=3){const ce=k[X+0],re=k[X+1],ae=k[X+2];T+=N[ce>>>2],T+=N[(ce<<4|re>>>4)&63],T+=N[(re<<2|ae>>>6)&63],T+=N[ae&63]}if(x===1){const ce=k[X+0];T+=N[ce>>>2],T+=N[ce<<4&63],I&&(T+="==")}else if(x===2){const ce=k[X+0],re=k[X+1];T+=N[ce>>>2],T+=N[(ce<<4|re>>>4)&63],T+=N[re<<2&63],I&&(T+="=")}return T}e.$ve=R}),define(ne[27],se([0,1,142,72]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xf=e.$wf=e.$vf=e.$uf=e.GraphemeBreakType=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=void 0;function s(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.$Be=s;const M=/{(\d+)}/g;function C(ee,...he){return he.length===0?ee:ee.replace(M,function($e,ye){const Ae=parseInt(ye,10);return isNaN(Ae)||Ae<0||Ae>=he.length?$e:he[Ae]})}e.$Ce=C;const S=/{([^}]+)}/g;function u(ee,he){return Object.keys(he).length===0?ee:ee.replace(S,($e,ye)=>he[ye]??$e)}e.$De=u;function a(ee){return ee.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.$Ee=a;function m(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Fe=m;function b(ee,he){let $e=0;const ye=he.charCodeAt(0);for(let Ae=ee.length-1;Ae>=0;Ae--)ee.charCodeAt(Ae)===ye&&$e++;return $e}e.$Ge=b;function y(ee,he,$e="\u2026"){return ee.length<=he?ee:`${ee.substr(0,he)}${$e}`}e.$He=y;function f(ee,he=" "){const $e=v(ee,he);return w($e,he)}e.$Ie=f;function v(ee,he){if(!ee||!he)return ee;const $e=he.length;if($e===0||ee.length===0)return ee;let ye=0;for(;ee.indexOf(he,ye)===ye;)ye=ye+$e;return ee.substring(ye)}e.$Je=v;function w(ee,he){if(!ee||!he)return ee;const $e=he.length,ye=ee.length;if($e===0||ye===0)return ee;let Ae=ye,We=-1;for(;We=ee.lastIndexOf(he,Ae-1),!(We===-1||We+$e!==Ae);){if(We===0)return"";Ae=We}return ee.substring(0,Ae)}e.$Ke=w;function p(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Le=p;function $(ee){return ee.replace(/\*/g,"")}e.$Me=$;function d(ee,he,$e={}){if(!ee)throw new Error("Cannot create regex from empty string");he||(ee=m(ee)),$e.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(ee,ye)}e.$Ne=d;function h(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.$Oe=h;function E(ee){return ee.split(/\r\n|\r|\n/)}e.$Pe=E;function c(ee){for(let he=0,$e=ee.length;he<$e;he++){const ye=ee.charCodeAt(he);if(ye!==32&&ye!==9)return he}return-1}e.$Qe=c;function i(ee,he=0,$e=ee.length){for(let ye=he;ye<$e;ye++){const Ae=ee.charCodeAt(ye);if(Ae!==32&&Ae!==9)return ee.substring(he,ye)}return ee.substring(he,$e)}e.$Re=i;function o(ee,he=ee.length-1){for(let $e=he;$e>=0;$e--){const ye=ee.charCodeAt($e);if(ye!==32&&ye!==9)return $e}return-1}e.$Se=o;function r(ee,he,$e){const ye=[];let Ae=0;for(const We of ee.matchAll(he)){if(ye.push(ee.slice(Ae,We.index)),We.index===void 0)throw new Error("match.index should be defined");Ae=We.index+We[0].length,ye.push($e(We[0],...We.slice(1),We.index,ee,We.groups))}return ye.push(ee.slice(Ae)),Promise.all(ye).then(We=>We.join(""))}e.$Te=r;function t(ee,he){return ee<he?-1:ee>he?1:0}e.$Ue=t;function n(ee,he,$e=0,ye=ee.length,Ae=0,We=he.length){for(;$e<ye&&Ae<We;$e++,Ae++){const Ve=ee.charCodeAt($e),Ge=he.charCodeAt(Ae);if(Ve<Ge)return-1;if(Ve>Ge)return 1}const Le=ye-$e,Ue=We-Ae;return Le<Ue?-1:Le>Ue?1:0}e.$Ve=n;function l(ee,he){return g(ee,he,0,ee.length,0,he.length)}e.$We=l;function g(ee,he,$e=0,ye=ee.length,Ae=0,We=he.length){for(;$e<ye&&Ae<We;$e++,Ae++){let Ve=ee.charCodeAt($e),Ge=he.charCodeAt(Ae);if(Ve===Ge)continue;if(Ve>=128||Ge>=128)return n(ee.toLowerCase(),he.toLowerCase(),$e,ye,Ae,We);R(Ve)&&(Ve-=32),R(Ge)&&(Ge-=32);const Je=Ve-Ge;if(Je!==0)return Je}const Le=ye-$e,Ue=We-Ae;return Le<Ue?-1:Le>Ue?1:0}e.$Xe=g;function A(ee){return ee>=48&&ee<=57}e.$Ye=A;function R(ee){return ee>=97&&ee<=122}e.$Ze=R;function k(ee){return ee>=65&&ee<=90}e.$1e=k;function I(ee,he){return ee.length===he.length&&g(ee,he)===0}e.$2e=I;function L(ee,he){const $e=he.length;return he.length>ee.length?!1:g(ee,he,0,$e)===0}e.$3e=L;function N(ee,he){const $e=Math.min(ee.length,he.length);let ye;for(ye=0;ye<$e;ye++)if(ee.charCodeAt(ye)!==he.charCodeAt(ye))return ye;return $e}e.$4e=N;function T(ee,he){const $e=Math.min(ee.length,he.length);let ye;const Ae=ee.length-1,We=he.length-1;for(ye=0;ye<$e;ye++)if(ee.charCodeAt(Ae-ye)!==he.charCodeAt(We-ye))return ye;return $e}e.$5e=T;function x(ee){return 55296<=ee&&ee<=56319}e.$6e=x;function X(ee){return 56320<=ee&&ee<=57343}e.$7e=X;function ce(ee,he){return(ee-55296<<10)+(he-56320)+65536}e.$8e=ce;function re(ee,he,$e){const ye=ee.charCodeAt($e);if(x(ye)&&$e+1<he){const Ae=ee.charCodeAt($e+1);if(X(Ae))return ce(ye,Ae)}return ye}e.$9e=re;function ae(ee,he){const $e=ee.charCodeAt(he-1);if(X($e)&&he>1){const ye=ee.charCodeAt(he-2);if(x(ye))return ce(ye,$e)}return $e}class Z{get offset(){return this.e}constructor(he,$e=0){this.c=he,this.d=he.length,this.e=$e}setOffset(he){this.e=he}prevCodePoint(){const he=ae(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=re(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.$0e=Z;class K{get offset(){return this.c.offset}constructor(he,$e=0){this.c=new Z(he,$e)}nextGraphemeLength(){const he=le.getInstance(),$e=this.c,ye=$e.offset;let Ae=he.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const We=$e.offset,Le=he.getGraphemeBreakType($e.nextCodePoint());if(pe(Ae,Le)){$e.setOffset(We);break}Ae=Le}return $e.offset-ye}prevGraphemeLength(){const he=le.getInstance(),$e=this.c,ye=$e.offset;let Ae=he.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const We=$e.offset,Le=he.getGraphemeBreakType($e.prevCodePoint());if(pe(Le,Ae)){$e.setOffset(We);break}Ae=Le}return ye-$e.offset}eol(){return this.c.eol()}}e.$$e=K;function G(ee,he){return new K(ee,he).nextGraphemeLength()}e.$_e=G;function z(ee,he){return new K(ee,he).prevGraphemeLength()}e.$af=z;function W(ee,he){he>0&&X(ee.charCodeAt(he))&&he--;const $e=he+G(ee,he);return[$e-z(ee,$e),$e]}e.$bf=W;function V(ee){const he=new K(ee);let $e=0;for(;!he.eol();)$e++,he.nextGraphemeLength();return $e}e.$cf=V;let q;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(ee){return q||(q=Y()),q.test(ee)}e.$df=oe;const J=/^[\t\n\r\x20-\x7E]*$/;function O(ee){return J.test(ee)}e.$ef=O,e.$ff=/[\u2028\u2029]/;function j(ee){return e.$ff.test(ee)}e.$gf=j;function F(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.$hf=F;function U(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.$if=U;function H(ee,he){if(ee.length<he)return ee;const $e=/\b/g;let ye=0;for(;$e.test(ee)&&!(ee.length-$e.lastIndex<he);)ye=$e.lastIndex,$e.lastIndex+=1;return ee.substring(ye).replace(/^\s/,"")}e.$jf=H;const B=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function fe(ee){return ee&&(ee=ee.replace(B,"").replace(ie,"")),ee}e.$kf=fe,e.$lf=String.fromCharCode(65279);function de(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.$mf=de;function ue(ee){return de(ee)?ee.substr(1):ee}e.$nf=ue;function be(ee,he){if(!ee||!he||ee.length<he.length)return!1;const $e=he.length,ye=ee.toLowerCase();let Ae=0,We=-1;for(;Ae<$e;){const Le=ye.indexOf(he[Ae],We+1);if(Le<0)return!1;We=Le,Ae++}return!0}e.$of=be;function me(ee,he=!1){return ee?(he&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.$pf=me;function Ee(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.$qf=Ee;function Se(ee,he=1){if(he===0)return"";let $e=-1;do $e=ee.indexOf(`
`,$e+1),he--;while(he>0&&$e>=0);return $e===-1?ee:(ee[$e-1]==="\r"&&$e--,ee.substr(0,$e))}e.$rf=Se;function je(ee){return ee=ee%(2*26),ee<26?String.fromCharCode(97+ee):String.fromCharCode(65+ee-26)}e.$sf=je;function ke(ee){return le.getInstance().getGraphemeBreakType(ee)}e.$tf=ke;function pe(ee,he){return ee===0?he!==5&&he!==7:ee===2&&he===3?!1:ee===4||ee===2||ee===3||he===4||he===2||he===3?!0:!(ee===8&&(he===8||he===9||he===11||he===12)||(ee===11||ee===9)&&(he===9||he===10)||(ee===12||ee===10)&&he===10||he===5||he===13||he===7||ee===1||ee===13&&he===14||ee===6&&he===6)}var _;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(_||(e.GraphemeBreakType=_={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=ge()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const $e=this.d,ye=$e.length/3;let Ae=1;for(;Ae<=ye;)if(he<$e[3*Ae])Ae=2*Ae;else if(he>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Re(ee,he){if(ee===0)return 0;const $e=Ce(ee,he);if($e!==void 0)return $e;const ye=new Z(he,ee);return ye.prevCodePoint(),ye.offset}e.$uf=Re;function Ce(ee,he){const $e=new Z(he,ee);let ye=$e.prevCodePoint();for(;Ne(ye)||ye===65039||ye===8419;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!U(ye))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===8205&&(Ae=$e.offset),Ae}function Ne(ee){return 127995<=ee&&ee<=127999}var Oe;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$vf="\xA0";class He{static{this.c=new D.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$xe(he=>{function $e(Je){const Ye=new Map;for(let Xe=0;Xe<Je.length;Xe+=2)Ye.set(Je[Xe],Je[Xe+1]);return Ye}function ye(Je,Ye){const Xe=new Map(Je);for(const[it,nt]of Ye)Xe.set(it,nt);return Xe}function Ae(Je,Ye){if(!Je)return Ye;const Xe=new Map;for(const[it,nt]of Je)Ye.has(it)&&Xe.set(it,nt);return Xe}const We=this.c.value;let Le=he.filter(Je=>!Je.startsWith("_")&&Je in We);Le.length===0&&(Le=["_default"]);let Ue;for(const Je of Le){const Ye=$e(We[Je]);Ue=Ae(Ue,Ye)}const Ve=$e(We._common),Ge=ye(Ve,Ue);return new He(Ge)})}static getInstance(he){return He.d.get(Array.from(he))}static{this.e=new D.$U(()=>Object.keys(He.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return He.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$wf=He;class ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ze.c())),this.d}static isInvisibleCharacter(he){return ze.e().has(he)}static get codePoints(){return ze.e()}}e.$xf=ze}),define(ne[56],se([0,1,27]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=void 0;function D($){return s($,0)}e.$Di=D;function s($,d){switch(typeof $){case"object":return $===null?M(349,d):Array.isArray($)?u($,d):a($,d);case"string":return S($,d);case"boolean":return C($,d);case"number":return M($,d);case"undefined":return M(937,d);default:return M(617,d)}}e.$Ei=s;function M($,d){return(d<<5)-d+$|0}e.$Fi=M;function C($,d){return M($?433:863,d)}function S($,d){d=M(149417,d);for(let h=0,E=$.length;h<E;h++)d=M($.charCodeAt(h),d);return d}e.$Gi=S;function u($,d){return d=M(104579,d),$.reduce((h,E)=>s(E,h),d)}function a($,d){return d=M(181387,d),Object.keys($).sort().reduce((h,E)=>(h=S(E,h),s($[E],h)),d)}class m{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=s(d,this.g),this.g}}e.$Hi=m;var b;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function y($,d,h=32){const E=h-d,c=~((1<<E)-1);return($<<d|(c&$)>>>E)>>>0}function f($,d=0,h=$.byteLength,E=0){for(let c=0;c<h;c++)$[d+c]=E}function v($,d,h="0"){for(;$.length<d;)$=h+$;return $}function w($,d=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(h=>h.toString(16).padStart(2,"0")).join(""):v(($>>>0).toString(16),d/4)}e.$Ii=w;class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const h=d.length;if(h===0)return;const E=this.p;let c=this.r,i=this.u,o,r;for(i!==0?(o=i,r=-1,i=0):(o=d.charCodeAt(0),r=0);;){let t=o;if(P.$6e(o))if(r+1<h){const n=d.charCodeAt(r+1);P.$7e(n)?(r++,t=P.$8e(o,n)):t=65533}else{i=o;break}else P.$7e(o)&&(t=65533);if(c=this.w(E,c,t),r++,r<h)o=d.charCodeAt(r);else break}this.r=c,this.u=i}w(d,h,E){return E<128?d[h++]=E:E<2048?(d[h++]=192|(E&1984)>>>6,d[h++]=128|(E&63)>>>0):E<65536?(d[h++]=224|(E&61440)>>>12,d[h++]=128|(E&4032)>>>6,d[h++]=128|(E&63)>>>0):(d[h++]=240|(E&1835008)>>>18,d[h++]=128|(E&258048)>>>12,d[h++]=128|(E&4032)>>>6,d[h++]=128|(E&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=p.g,h=this.q;for(let g=0;g<64;g+=4)d.setUint32(g,h.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)d.setUint32(g,y(d.getUint32(g-12,!1)^d.getUint32(g-32,!1)^d.getUint32(g-56,!1)^d.getUint32(g-64,!1),1),!1);let E=this.h,c=this.l,i=this.m,o=this.n,r=this.o,t,n,l;for(let g=0;g<80;g++)g<20?(t=c&i|~c&o,n=1518500249):g<40?(t=c^i^o,n=1859775393):g<60?(t=c&i|c&o|i&o,n=2400959708):(t=c^i^o,n=3395469782),l=y(E,5)+t+r+n+d.getUint32(g*4,!1)&4294967295,r=o,o=i,i=y(c,30),c=E,E=l;this.h=this.h+E&4294967295,this.l=this.l+c&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$Ji=p}),define(ne[74],se([0,1,27]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(D||(D={})),function(s){const M="error",C="warning",S="warn",u="info",a="ignore";function m(y){return y?P.$2e(M,y)?s.Error:P.$2e(C,y)||P.$2e(S,y)?s.Warning:P.$2e(u,y)?s.Info:s.Ignore:s.Ignore}s.fromValue=m;function b(y){switch(y){case s.Error:return M;case s.Warning:return C;case s.Info:return u;default:return a}}s.toString=b}(D||(D={})),e.default=D}),define(ne[143],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(ne[57],se([0,1,23,27]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class s{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const v=f.charCodeAt(0),w=this.b.charCodeAt(this.c);return v-w}value(){return this.b[this.c]}}e.$Rh=s;class M{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,D.$Ve)(f,this.b,0,f.length,this.c,this.d):(0,D.$Xe)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=M;class C{constructor(f=!0,v=!0){this.f=f,this.g=v}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let v=f.length-1;v>=0;v--,this.c--){const w=this.b.charCodeAt(v);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,D.$Ve)(f,this.b,0,f.length,this.d,this.e):(0,D.$Xe)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=C;var S;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(S||(S={}));class u{constructor(f,v){this.f=f,this.g=v,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,D.$We)(f,this.c.scheme);if(this.d[this.e]===2)return(0,D.$We)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,D.$Ue)(f,this.c.query);if(this.d[this.e]===5)return(0,D.$Ue)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=u;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(m||(m={}));class b{static forUris(f=()=>!1,v=()=>!1){return new b(new u(f,v))}static forPaths(f=!1){return new b(new C(void 0,!f))}static forStrings(){return new b(new s)}static forConfigKeys(){return new b(new M)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,v){if(v){const w=v.slice(0);(0,P.$Wb)(w);for(const p of w)this.set(p,f)}else{const w=f.slice(0);(0,P.$Wb)(w);for(const p of w)this.set(p[0],p[1])}}set(f,v){const w=this.b.reset(f);let p;this.c||(this.c=new a,this.c.segment=w.value());const $=[];for(p=this.c;;){const h=w.cmp(p.segment);if(h>0)p.left||(p.left=new a,p.left.segment=w.value()),$.push([-1,p]),p=p.left;else if(h<0)p.right||(p.right=new a,p.right.segment=w.value()),$.push([1,p]),p=p.right;else if(w.hasNext())w.next(),p.mid||(p.mid=new a,p.mid.segment=w.value()),$.push([0,p]),p=p.mid;else break}const d=p.value;p.value=v,p.key=f;for(let h=$.length-1;h>=0;h--){const E=$[h][1];E.updateHeight();const c=E.balanceFactor();if(c<-1||c>1){const i=$[h][0],o=$[h+1][0];if(i===1&&o===1)$[h][1]=E.rotateLeft();else if(i===-1&&o===-1)$[h][1]=E.rotateRight();else if(i===1&&o===-1)E.right=$[h+1][1]=$[h+1][1].rotateRight(),$[h][1]=E.rotateLeft();else if(i===-1&&o===1)E.left=$[h+1][1]=$[h+1][1].rotateLeft(),$[h][1]=E.rotateRight();else throw new Error;if(h>0)switch($[h-1][0]){case-1:$[h-1][1].left=$[h][1];break;case 1:$[h-1][1].right=$[h][1];break;case 0:$[h-1][1].mid=$[h][1];break}else this.c=$[0][1]}}return d}get(f){return this.d(f)?.value}d(f){const v=this.b.reset(f);let w=this.c;for(;w;){const p=v.cmp(w.segment);if(p>0)w=w.left;else if(p<0)w=w.right;else if(v.hasNext())v.next(),w=w.mid;else break}return w}has(f){const v=this.d(f);return!(v?.value===void 0&&v?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,v){const w=this.b.reset(f),p=[];let $=this.c;for(;$;){const d=w.cmp($.segment);if(d>0)p.push([-1,$]),$=$.left;else if(d<0)p.push([1,$]),$=$.right;else if(w.hasNext())w.next(),p.push([0,$]),$=$.mid;else break}if($){if(v?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const d=this.f($.right);if(d.key){const{key:h,value:E,segment:c}=d;this.e(d.key,!1),$.key=h,$.value=E,$.segment=c}}else{const d=$.left??$.right;if(p.length>0){const[h,E]=p[p.length-1];switch(h){case-1:E.left=d;break;case 0:E.mid=d;break;case 1:E.right=d;break}}else this.c=d}for(let d=p.length-1;d>=0;d--){const h=p[d][1];h.updateHeight();const E=h.balanceFactor();if(E>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),p[d][1]=h.rotateLeft()):E<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),p[d][1]=h.rotateRight()),d>0)switch(p[d-1][0]){case-1:p[d-1][1].left=p[d][1];break;case 1:p[d-1][1].right=p[d][1];break;case 0:p[d-1][1].mid=p[d][1];break}else this.c=p[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const v=this.b.reset(f);let w=this.c,p;for(;w;){const $=v.cmp(w.segment);if($>0)w=w.left;else if($<0)w=w.right;else if(v.hasNext())v.next(),p=w.value||p,w=w.mid;else break}return w&&w.value||p}findSuperstr(f){return this.g(f,!1)}g(f,v){const w=this.b.reset(f);let p=this.c;for(;p;){const $=w.cmp(p.segment);if($>0)p=p.left;else if($<0)p=p.right;else if(w.hasNext())w.next(),p=p.mid;else return p.mid?this.h(p.mid):v?p.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[v,w]of this)f(w,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const v=[];return this.j(f,v),v[Symbol.iterator]()}j(f,v){f&&(f.left&&this.j(f.left,v),f.value&&v.push([f.key,f.value]),f.mid&&this.j(f.mid,v),f.right&&this.j(f.right,v))}_isBalanced(){const f=v=>{if(!v)return!0;const w=v.balanceFactor();return w<-1||w>1?!1:f(v.left)&&f(v.right)};return f(this.c)}}e.$Vh=b}),define(ne[12],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=void 0;function P(c){return typeof c=="string"}e.$yf=P;function D(c){return Array.isArray(c)&&c.every(i=>P(i))}e.$zf=D;function s(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Af=s;function M(c){const i=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof i}e.$Bf=M;function C(c){return typeof c=="number"&&!isNaN(c)}e.$Cf=C;function S(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Df=S;function u(c){return c===!0||c===!1}e.$Ef=u;function a(c){return typeof c>"u"}e.$Ff=a;function m(c){return!b(c)}e.$Gf=m;function b(c){return a(c)||c===null}e.$Hf=b;function y(c,i){if(!c)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$If=y;function f(c){if(b(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$Jf=f;function v(...c){const i=[];for(let o=0;o<c.length;o++){const r=c[o];if(b(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(r)}return i}e.$Kf=v;const w=Object.prototype.hasOwnProperty;function p(c){if(!s(c))return!1;for(const i in c)if(w.call(c,i))return!1;return!0}e.$Lf=p;function $(c){return typeof c=="function"}e.$Mf=$;function d(...c){return c.length>0&&c.every($)}e.$Nf=d;function h(c,i){const o=Math.min(c.length,i.length);for(let r=0;r<o;r++)E(c[r],i[r])}e.$Of=h;function E(c,i){if(P(i)){if(typeof c!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if($(i)){try{if(c instanceof i)return}catch{}if(!b(c)&&c.constructor===i||i.length===1&&i.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Pf=E}),define(ne[75],se([0,1,12]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=void 0;const D=Object.create(null);function s(S,u){if((0,P.$yf)(u)){const a=D[u];if(a===void 0)throw new Error(`${S} references an unknown codicon: ${u}`);u=a}return D[S]=u,{id:S}}function M(){return D}e.$Sj=M;function C(){return Object.values(e.$Uj)}e.$Tj=C,e.$Uj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(ne[38],se([0,1,12]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function D(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const c=Array.isArray(E)?[]:{};return Object.entries(E).forEach(([i,o])=>{c[i]=o&&typeof o=="object"?D(o):o}),c}e.$7m=D;function s(E){if(!E||typeof E!="object")return E;const c=[E];for(;c.length>0;){const i=c.shift();Object.freeze(i);for(const o in i)if(M.call(i,o)){const r=i[o];typeof r=="object"&&!Object.isFrozen(r)&&!(0,P.$Bf)(r)&&c.push(r)}}return E}e.$8m=s;const M=Object.prototype.hasOwnProperty;function C(E,c){return S(E,c,new Set)}e.$9m=C;function S(E,c,i){if((0,P.$Hf)(E))return E;const o=c(E);if(typeof o<"u")return o;if(Array.isArray(E)){const r=[];for(const t of E)r.push(S(t,c,i));return r}if((0,P.$Af)(E)){if(i.has(E))throw new Error("Cannot clone recursive data-structure");i.add(E);const r={};for(const t in E)M.call(E,t)&&(r[t]=S(E[t],c,i));return i.delete(E),r}return E}function u(E,c,i=!0){return(0,P.$Af)(E)?((0,P.$Af)(c)&&Object.keys(c).forEach(o=>{o in E?i&&((0,P.$Af)(E[o])&&(0,P.$Af)(c[o])?u(E[o],c[o],i):E[o]=c[o]):E[o]=c[o]}),E):c}e.$0m=u;function a(E,c){if(E===c)return!0;if(E==null||c===null||c===void 0||typeof E!=typeof c||typeof E!="object"||Array.isArray(E)!==Array.isArray(c))return!1;let i,o;if(Array.isArray(E)){if(E.length!==c.length)return!1;for(i=0;i<E.length;i++)if(!a(E[i],c[i]))return!1}else{const r=[];for(o in E)r.push(o);r.sort();const t=[];for(o in c)t.push(o);if(t.sort(),!a(r,t))return!1;for(i=0;i<r.length;i++)if(!a(E[r[i]],c[r[i]]))return!1}return!0}e.$$m=a;function m(E){const c=new Set;return JSON.stringify(E,(i,o)=>{if((0,P.$Af)(o)||Array.isArray(o)){if(c.has(o))return"[Circular]";c.add(o)}return o})}e.$_m=m;function b(E,c){const i=Object.create(null);return!E||!c||Object.keys(c).forEach(r=>{const t=E[r],n=c[r];a(t,n)||(i[r]=n)}),i}e.$an=b;function y(E,c){const i=c.toLowerCase(),o=Object.keys(E).find(r=>r.toLowerCase()===i);return o?E[o]:E[c]}e.$bn=y;function f(E,c){const i=Object.create(null);for(const[o,r]of Object.entries(E))c(o,r)&&(i[o]=r);return i}e.$cn=f;function v(E){let c=[];for(;Object.prototype!==E;)c=c.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return c}e.$dn=v;function w(E){const c=[];for(const i of v(E))typeof E[i]=="function"&&c.push(i);return c}e.$en=w;function p(E,c){const i=r=>function(){const t=Array.prototype.slice.call(arguments,0);return c(r,t)},o={};for(const r of E)o[r]=i(r);return o}e.$fn=p;function $(E,c,i){typeof c=="string"&&E[c]!==void 0&&typeof E[c]!="boolean"&&(E[c]=i)}e.$gn=$;function d(E,c,i){typeof c=="string"&&E[c]!==void 0&&typeof E[c]!="number"&&(E[c]=i)}e.$hn=d;function h(E,c,i,o){if(typeof c!="string")return;const r=E[c];r!==void 0&&(typeof r!="string"||!i.includes(r))&&(E[c]=o)}e.$in=h}),define(ne[102],se([0,1,75]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Vj=e.ThemeColor=void 0;var D;(function(C){function S(u){return u&&typeof u=="object"&&typeof u.id=="string"}C.isThemeColor=S})(D||(e.ThemeColor=D={}));function s(C){return{id:C}}e.$Vj=s;var M;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function u(d){const h=S.exec(d.id);if(!h)return u(P.$Uj.error);const[,E,c]=h,i=["codicon","codicon-"+E];return c&&i.push("codicon-modifier-"+c.substring(1)),i}C.asClassNameArray=u;function a(d){return u(d).join(" ")}C.asClassName=a;function m(d){return"."+u(d).join(".")}C.asCSSSelector=m;function b(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||D.isThemeColor(d.color))}C.isThemeIcon=b;const y=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function f(d){const h=y.exec(d);if(!h)return;const[,E]=h;return{id:E}}C.fromString=f;function v(d){return{id:d}}C.fromId=v;function w(d,h){let E=d.id;const c=E.lastIndexOf("~");return c!==-1&&(E=E.substring(0,c)),h&&(E=`${E}~${h}`),{id:E}}C.modify=w;function p(d){const h=d.id.lastIndexOf("~");if(h!==-1)return d.id.substring(h+1)}C.getModifier=p;function $(d,h){return d.id===h.id&&d.color?.id===h.color?.id}C.isEqual=$})(M||(e.ThemeIcon=M={}))}),define(ne[32],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(s){return P.test(s)}e.$dg=D,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let u=0;u<S.length;u++)S[u]=Math.floor(Math.random()*256);return S};const M=new Uint8Array(16),C=[];for(let S=0;S<256;S++)C.push(S.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let u=0,a="";return a+=C[M[u++]],a+=C[M[u++]],a+=C[M[u++]],a+=C[M[u++]],a+="-",a+=C[M[u++]],a+=C[M[u++]],a+="-",a+=C[M[u++]],a+=C[M[u++]],a+="-",a+=C[M[u++]],a+=C[M[u++]],a+="-",a+=C[M[u++]],a+=C[M[u++]],a+=C[M[u++]],a+=C[M[u++]],a+=C[M[u++]],a+=C[M[u++]],a}}()}),define(ne[144],se([0,1,86,45,84]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tT=void 0;async function M(C,S){if(await new Promise((m,b)=>{const y=D.createReadStream(C),f=P.createHash("sha1");y.pipe(f);const v=(0,s.$cb)((w,p)=>{y.removeAllListeners(),f.removeAllListeners(),w?b(w):m(p)});y.once("error",v),y.once("end",v),f.once("error",v),f.once("data",w=>v(void 0,w.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$tT=M}),define(ne[145],se([0,1,28]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(C){const S=C.replace(/\-/g,":").toLowerCase();return!D.has(S)}function M(){const C=(0,P.networkInterfaces)();for(const S in C){const u=C[S];if(u){for(const{mac:a}of u)if(s(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Qm=M}),define(ne[103],se([0,1,87]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=void 0;function D(S,u,a,m=1){let b=!1;return new Promise(y=>{const f=setTimeout(()=>{if(!b)return b=!0,y(0)},a);s(S,u,m,v=>{if(!b)return b=!0,clearTimeout(f),y(v)})})}e.$gg=D;function s(S,u,a,m){if(u===0)return m(0);const b=new P.Socket;b.once("connect",()=>(C(b),s(S+a,u-1,a,m))),b.once("data",()=>{}),b.once("error",y=>(C(b),y.code!=="ECONNREFUSED"?s(S+a,u-1,a,m):m(S))),b.connect(S,"127.0.0.1")}e.$hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(S,u,a,m="127.0.0.1"){let b=!1,y,f=1;const v=P.createServer({pauseOnConnect:!0});function w(p,$){b||(b=!0,v.removeAllListeners(),v.close(),y&&clearTimeout(y),$(p))}return new Promise(p=>{y=setTimeout(()=>{w(0,p)},a),v.on("listening",()=>{w(S,p)}),v.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&f<u?(S++,f++,v.listen(S,m)):w(0,p)}),v.on("close",()=>{w(0,p)}),v.listen(S,m)})}e.$ig=M;function C(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(u){console.error(u)}}}),function(){function Q(){function e(){return process.uncHostAllowlist}function P(u){const a=new Set;if(Array.isArray(u))for(const m of u)typeof m=="string"&&a.add(m);return Array.from(a)}function D(){const u=e();return u?Array.from(u):[]}function s(u){if(process.platform!=="win32")return;const a=e();if(a)if(typeof u=="string")a.add(u.toLowerCase());else for(const m of P(u))s(m)}function M(u){if(typeof u!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const b of a){if(u.indexOf(b)!==0)continue;const f=u.indexOf("\\",b.length);if(f===-1)continue;const v=u.substring(b.length,f);if(v){m=v;break}}return m}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:D,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Q()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Q():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ne[146],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xT=e.$wT=void 0,e.$wT="vscode:contextmenu",e.$xT="vscode:onCloseContextMenu"}),define(ne[147],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ET=void 0;class P{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$ET=P}),define(ne[148],se([11,10]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ne[149],se([0,1,148]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const D=60,s=D*60,M=s*24,C=M*7,S=M*30,u=M*365;function a(b,y,f,v){typeof b!="number"&&(b=b.getTime());const w=Math.round((new Date().getTime()-b)/1e3);if(w<-30)return(0,P.localize)(0,null,a(new Date().getTime()+w*1e3,!1));if(!v&&w<30)return(0,P.localize)(1,null);let p;return w<D?(p=w,y?p===1?f?(0,P.localize)(2,null,p):(0,P.localize)(3,null,p):f?(0,P.localize)(4,null,p):(0,P.localize)(5,null,p):p===1?f?(0,P.localize)(6,null,p):(0,P.localize)(7,null,p):f?(0,P.localize)(8,null,p):(0,P.localize)(9,null,p)):w<s?(p=Math.floor(w/D),y?p===1?f?(0,P.localize)(10,null,p):(0,P.localize)(11,null,p):f?(0,P.localize)(12,null,p):(0,P.localize)(13,null,p):p===1?f?(0,P.localize)(14,null,p):(0,P.localize)(15,null,p):f?(0,P.localize)(16,null,p):(0,P.localize)(17,null,p)):w<M?(p=Math.floor(w/s),y?p===1?f?(0,P.localize)(18,null,p):(0,P.localize)(19,null,p):f?(0,P.localize)(20,null,p):(0,P.localize)(21,null,p):p===1?f?(0,P.localize)(22,null,p):(0,P.localize)(23,null,p):f?(0,P.localize)(24,null,p):(0,P.localize)(25,null,p)):w<C?(p=Math.floor(w/M),y?p===1?(0,P.localize)(26,null,p):(0,P.localize)(27,null,p):p===1?(0,P.localize)(28,null,p):(0,P.localize)(29,null,p)):w<S?(p=Math.floor(w/C),y?p===1?f?(0,P.localize)(30,null,p):(0,P.localize)(31,null,p):f?(0,P.localize)(32,null,p):(0,P.localize)(33,null,p):p===1?f?(0,P.localize)(34,null,p):(0,P.localize)(35,null,p):f?(0,P.localize)(36,null,p):(0,P.localize)(37,null,p)):w<u?(p=Math.floor(w/S),y?p===1?f?(0,P.localize)(38,null,p):(0,P.localize)(39,null,p):f?(0,P.localize)(40,null,p):(0,P.localize)(41,null,p):p===1?f?(0,P.localize)(42,null,p):(0,P.localize)(43,null,p):f?(0,P.localize)(44,null,p):(0,P.localize)(45,null,p)):(p=Math.floor(w/u),y?p===1?f?(0,P.localize)(46,null,p):(0,P.localize)(47,null,p):f?(0,P.localize)(48,null,p):(0,P.localize)(49,null,p):p===1?f?(0,P.localize)(50,null,p):(0,P.localize)(51,null,p):f?(0,P.localize)(52,null,p):(0,P.localize)(53,null,p))}e.$dm=a;function m(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=m}),define(ne[150],se([11,10]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ne[49],se([0,1,23,12,150]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function M(b,y){return y&&(b.stack||b.stacktrace)?s.localize(0,null,S(b),C(b.stack)||C(b.stacktrace)):S(b)}function C(b){return Array.isArray(b)?b.join(`
`):b}function S(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?s.localize(1,null,b.message):b.message||s.localize(2,null)}function u(b=null,y=!1){if(!b)return s.localize(3,null);if(Array.isArray(b)){const f=P.$Gb(b),v=u(f[0],y);return f.length>1?s.localize(4,null,v,f.length):v}if(D.$yf(b))return b;if(b.detail){const f=b.detail;if(f.error)return M(f.error,y);if(f.exception)return M(f.exception,y)}return b.stack?M(b,y):b.message?b.message:s.localize(5,null)}e.$Ai=u;function a(b){const y=b;return y instanceof Error&&Array.isArray(y.actions)}e.$Bi=a;function m(b,y){let f;return typeof b=="string"?f=new Error(b):f=b,f.actions=y,f}e.$Ci=m}),define(ne[151],se([11,10]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(ne[152],se([0,1,151]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;function D(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.$zp=D}),define(ne[153],se([11,10]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(ne[4],se([0,1,153]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let D=!1,s=!1,M=!1,C=!1,S=!1,u=!1,a=!1,m=!1,b=!1,y=!1,f,v=e.$g,w=e.$g,p,$;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?d=e.$h.vscode.process:typeof process<"u"&&(d=process);const h=typeof d?.versions?.electron=="string",E=h&&d?.type==="renderer";if(typeof navigator=="object"&&!E)$=navigator.userAgent,D=$.indexOf("Windows")>=0,s=$.indexOf("Macintosh")>=0,m=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=$.indexOf("Linux")>=0,y=$?.indexOf("Mobi")>=0,u=!0,f=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$g,v=f,w=navigator.language;else if(typeof d=="object"){D=d.platform==="win32",s=d.platform==="darwin",M=d.platform==="linux",C=M&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,a=h,b=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$g,v=e.$g;const A=d.env.VSCODE_NLS_CONFIG;if(A)try{const R=JSON.parse(A),k=R.availableLanguages["*"];f=R.locale,w=R.osLocale,v=k||e.$g,p=R._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var c;(function(A){A[A.Web=0]="Web",A[A.Mac=1]="Mac",A[A.Linux=2]="Linux",A[A.Windows=3]="Windows"})(c||(e.Platform=c={}));function i(A){switch(A){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=i;let o=0;s?o=1:D?o=3:M&&(o=2),e.$j=D,e.$k=s,e.$l=M,e.$m=C,e.$n=S,e.$o=a,e.$p=u,e.$q=u&&typeof e.$h.importScripts=="function",e.$r=m,e.$s=y,e.$t=b,e.$u=o,e.$v=$,e.$w=v;var r;(function(A){function R(){return e.$w}A.value=R;function k(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}A.isDefaultVariant=k;function I(){return e.$w==="en"}A.isDefault=I})(r||(e.Language=r={})),e.$x=f,e.$y=w,e.$z=p,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const A=[];e.$h.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let I=0,L=A.length;I<L;I++){const N=A[I];if(N.id===k.data.vscodeScheduleAsyncWork){A.splice(I,1),N.callback();return}}});let R=0;return k=>{const I=++R;A.push({id:I,callback:k}),e.$h.postMessage({vscodeScheduleAsyncWork:I},"*")}}return A=>setTimeout(A)})();var t;(function(A){A[A.Windows=1]="Windows",A[A.Macintosh=2]="Macintosh",A[A.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=s||m?2:D?1:3;let n=!0,l=!1;function g(){if(!l){l=!0;const A=new Uint8Array(2);A[0]=1,A[1]=2,n=new Uint16Array(A.buffer)[0]===(2<<8)+1}return n}e.$D=g,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ne[35],se([0,1,4]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let D;if(typeof P.$h.vscode<"u"&&typeof P.$h.vscode.process<"u"){const s=P.$h.vscode.process;D={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return P.$j?"win32":P.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.$cc=D.platform,e.$dc=D.arch}),define(ne[9],se([0,1,35]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const D=65,s=97,M=90,C=122,S=46,u=47,a=92,m=58,b=63;class y extends Error{constructor(o,r,t){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const l=o.indexOf(".")!==-1?"property":"argument";let g=`The "${o}" ${l} ${n} of type ${r}`;g+=`. Received type ${typeof t}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,o){if(i===null||typeof i!="object")throw new y(o,"Object",i)}function v(i,o){if(typeof i!="string")throw new y(o,"string",i)}const w=P.$cc==="win32";function p(i){return i===u||i===a}function $(i){return i===u}function d(i){return i>=D&&i<=M||i>=s&&i<=C}function h(i,o,r,t){let n="",l=0,g=-1,A=0,R=0;for(let k=0;k<=i.length;++k){if(k<i.length)R=i.charCodeAt(k);else{if(t(R))break;R=u}if(t(R)){if(!(g===k-1||A===1))if(A===2){if(n.length<2||l!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const I=n.lastIndexOf(r);I===-1?(n="",l=0):(n=n.slice(0,I),l=n.length-1-n.lastIndexOf(r)),g=k,A=0;continue}else if(n.length!==0){n="",l=0,g=k,A=0;continue}}o&&(n+=n.length>0?`${r}..`:"..",l=2)}else n.length>0?n+=`${r}${i.slice(g+1,k)}`:n=i.slice(g+1,k),l=k-g-1;g=k,A=0}else R===S&&A!==-1?++A:A=-1}return n}function E(i,o){f(o,"pathObject");const r=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${t}`:`${r}${i}${t}`:t}e.$ec={resolve(...i){let o="",r="",t=!1;for(let n=i.length-1;n>=-1;n--){let l;if(n>=0){if(l=i[n],v(l,"path"),l.length===0)continue}else o.length===0?l=P.cwd():(l=P.env[`=${o}`]||P.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==o.toLowerCase()&&l.charCodeAt(2)===a)&&(l=`${o}\\`));const g=l.length;let A=0,R="",k=!1;const I=l.charCodeAt(0);if(g===1)p(I)&&(A=1,k=!0);else if(p(I))if(k=!0,p(l.charCodeAt(1))){let L=2,N=L;for(;L<g&&!p(l.charCodeAt(L));)L++;if(L<g&&L!==N){const T=l.slice(N,L);for(N=L;L<g&&p(l.charCodeAt(L));)L++;if(L<g&&L!==N){for(N=L;L<g&&!p(l.charCodeAt(L));)L++;(L===g||L!==N)&&(R=`\\\\${T}\\${l.slice(N,L)}`,A=L)}}}else A=1;else d(I)&&l.charCodeAt(1)===m&&(R=l.slice(0,2),A=2,g>2&&p(l.charCodeAt(2))&&(k=!0,A=3));if(R.length>0)if(o.length>0){if(R.toLowerCase()!==o.toLowerCase())continue}else o=R;if(t){if(o.length>0)break}else if(r=`${l.slice(A)}\\${r}`,t=k,k&&o.length>0)break}return r=h(r,!t,"\\",p),t?`${o}\\${r}`:`${o}${r}`||"."},normalize(i){v(i,"path");const o=i.length;if(o===0)return".";let r=0,t,n=!1;const l=i.charCodeAt(0);if(o===1)return $(l)?"\\":i;if(p(l))if(n=!0,p(i.charCodeAt(1))){let A=2,R=A;for(;A<o&&!p(i.charCodeAt(A));)A++;if(A<o&&A!==R){const k=i.slice(R,A);for(R=A;A<o&&p(i.charCodeAt(A));)A++;if(A<o&&A!==R){for(R=A;A<o&&!p(i.charCodeAt(A));)A++;if(A===o)return`\\\\${k}\\${i.slice(R)}\\`;A!==R&&(t=`\\\\${k}\\${i.slice(R,A)}`,r=A)}}}else r=1;else d(l)&&i.charCodeAt(1)===m&&(t=i.slice(0,2),r=2,o>2&&p(i.charCodeAt(2))&&(n=!0,r=3));let g=r<o?h(i.slice(r),!n,"\\",p):"";return g.length===0&&!n&&(g="."),g.length>0&&p(i.charCodeAt(o-1))&&(g+="\\"),t===void 0?n?`\\${g}`:g:n?`${t}\\${g}`:`${t}${g}`},isAbsolute(i){v(i,"path");const o=i.length;if(o===0)return!1;const r=i.charCodeAt(0);return p(r)||o>2&&d(r)&&i.charCodeAt(1)===m&&p(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,r;for(let l=0;l<i.length;++l){const g=i[l];v(g,"path"),g.length>0&&(o===void 0?o=r=g:o+=`\\${g}`)}if(o===void 0)return".";let t=!0,n=0;if(typeof r=="string"&&p(r.charCodeAt(0))){++n;const l=r.length;l>1&&p(r.charCodeAt(1))&&(++n,l>2&&(p(r.charCodeAt(2))?++n:t=!1))}if(t){for(;n<o.length&&p(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.$ec.normalize(o)},relative(i,o){if(v(i,"from"),v(o,"to"),i===o)return"";const r=e.$ec.resolve(i),t=e.$ec.resolve(o);if(r===t||(i=r.toLowerCase(),o=t.toLowerCase(),i===o))return"";let n=0;for(;n<i.length&&i.charCodeAt(n)===a;)n++;let l=i.length;for(;l-1>n&&i.charCodeAt(l-1)===a;)l--;const g=l-n;let A=0;for(;A<o.length&&o.charCodeAt(A)===a;)A++;let R=o.length;for(;R-1>A&&o.charCodeAt(R-1)===a;)R--;const k=R-A,I=g<k?g:k;let L=-1,N=0;for(;N<I;N++){const x=i.charCodeAt(n+N);if(x!==o.charCodeAt(A+N))break;x===a&&(L=N)}if(N!==I){if(L===-1)return t}else{if(k>I){if(o.charCodeAt(A+N)===a)return t.slice(A+N+1);if(N===2)return t.slice(A+N)}g>I&&(i.charCodeAt(n+N)===a?L=N:N===2&&(L=3)),L===-1&&(L=0)}let T="";for(N=n+L+1;N<=l;++N)(N===l||i.charCodeAt(N)===a)&&(T+=T.length===0?"..":"\\..");return A+=L,T.length>0?`${T}${t.slice(A,R)}`:(t.charCodeAt(A)===a&&++A,t.slice(A,R))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$ec.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===a){if(o.charCodeAt(1)===a){const r=o.charCodeAt(2);if(r!==b&&r!==S)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===m&&o.charCodeAt(2)===a)return`\\\\?\\${o}`;return i},dirname(i){v(i,"path");const o=i.length;if(o===0)return".";let r=-1,t=0;const n=i.charCodeAt(0);if(o===1)return p(n)?i:".";if(p(n)){if(r=t=1,p(i.charCodeAt(1))){let A=2,R=A;for(;A<o&&!p(i.charCodeAt(A));)A++;if(A<o&&A!==R){for(R=A;A<o&&p(i.charCodeAt(A));)A++;if(A<o&&A!==R){for(R=A;A<o&&!p(i.charCodeAt(A));)A++;if(A===o)return i;A!==R&&(r=t=A+1)}}}}else d(n)&&i.charCodeAt(1)===m&&(r=o>2&&p(i.charCodeAt(2))?3:2,t=r);let l=-1,g=!0;for(let A=o-1;A>=t;--A)if(p(i.charCodeAt(A))){if(!g){l=A;break}}else g=!1;if(l===-1){if(r===-1)return".";l=r}return i.slice(0,l)},basename(i,o){o!==void 0&&v(o,"ext"),v(i,"path");let r=0,t=-1,n=!0,l;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===m&&(r=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let g=o.length-1,A=-1;for(l=i.length-1;l>=r;--l){const R=i.charCodeAt(l);if(p(R)){if(!n){r=l+1;break}}else A===-1&&(n=!1,A=l+1),g>=0&&(R===o.charCodeAt(g)?--g===-1&&(t=l):(g=-1,t=A))}return r===t?t=A:t===-1&&(t=i.length),i.slice(r,t)}for(l=i.length-1;l>=r;--l)if(p(i.charCodeAt(l))){if(!n){r=l+1;break}}else t===-1&&(n=!1,t=l+1);return t===-1?"":i.slice(r,t)},extname(i){v(i,"path");let o=0,r=-1,t=0,n=-1,l=!0,g=0;i.length>=2&&i.charCodeAt(1)===m&&d(i.charCodeAt(0))&&(o=t=2);for(let A=i.length-1;A>=o;--A){const R=i.charCodeAt(A);if(p(R)){if(!l){t=A+1;break}continue}n===-1&&(l=!1,n=A+1),R===S?r===-1?r=A:g!==1&&(g=1):r!==-1&&(g=-1)}return r===-1||n===-1||g===0||g===1&&r===n-1&&r===t+1?"":i.slice(r,n)},format:E.bind(null,"\\"),parse(i){v(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const r=i.length;let t=0,n=i.charCodeAt(0);if(r===1)return p(n)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(p(n)){if(t=1,p(i.charCodeAt(1))){let L=2,N=L;for(;L<r&&!p(i.charCodeAt(L));)L++;if(L<r&&L!==N){for(N=L;L<r&&p(i.charCodeAt(L));)L++;if(L<r&&L!==N){for(N=L;L<r&&!p(i.charCodeAt(L));)L++;L===r?t=L:L!==N&&(t=L+1)}}}}else if(d(n)&&i.charCodeAt(1)===m){if(r<=2)return o.root=o.dir=i,o;if(t=2,p(i.charCodeAt(2))){if(r===3)return o.root=o.dir=i,o;t=3}}t>0&&(o.root=i.slice(0,t));let l=-1,g=t,A=-1,R=!0,k=i.length-1,I=0;for(;k>=t;--k){if(n=i.charCodeAt(k),p(n)){if(!R){g=k+1;break}continue}A===-1&&(R=!1,A=k+1),n===S?l===-1?l=k:I!==1&&(I=1):l!==-1&&(I=-1)}return A!==-1&&(l===-1||I===0||I===1&&l===A-1&&l===g+1?o.base=o.name=i.slice(g,A):(o.name=i.slice(g,l),o.base=i.slice(g,A),o.ext=i.slice(l,A))),g>0&&g!==t?o.dir=i.slice(0,g-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(w){const i=/\\/g;return()=>{const o=P.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>P.cwd()})();e.$fc={resolve(...i){let o="",r=!1;for(let t=i.length-1;t>=-1&&!r;t--){const n=t>=0?i[t]:c();v(n,"path"),n.length!==0&&(o=`${n}/${o}`,r=n.charCodeAt(0)===u)}return o=h(o,!r,"/",$),r?`/${o}`:o.length>0?o:"."},normalize(i){if(v(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===u,r=i.charCodeAt(i.length-1)===u;return i=h(i,!o,"/",$),i.length===0?o?"/":r?"./":".":(r&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return v(i,"path"),i.length>0&&i.charCodeAt(0)===u},join(...i){if(i.length===0)return".";let o;for(let r=0;r<i.length;++r){const t=i[r];v(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.$fc.normalize(o)},relative(i,o){if(v(i,"from"),v(o,"to"),i===o||(i=e.$fc.resolve(i),o=e.$fc.resolve(o),i===o))return"";const r=1,t=i.length,n=t-r,l=1,g=o.length-l,A=n<g?n:g;let R=-1,k=0;for(;k<A;k++){const L=i.charCodeAt(r+k);if(L!==o.charCodeAt(l+k))break;L===u&&(R=k)}if(k===A)if(g>A){if(o.charCodeAt(l+k)===u)return o.slice(l+k+1);if(k===0)return o.slice(l+k)}else n>A&&(i.charCodeAt(r+k)===u?R=k:k===0&&(R=0));let I="";for(k=r+R+1;k<=t;++k)(k===t||i.charCodeAt(k)===u)&&(I+=I.length===0?"..":"/..");return`${I}${o.slice(l+R)}`},toNamespacedPath(i){return i},dirname(i){if(v(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===u;let r=-1,t=!0;for(let n=i.length-1;n>=1;--n)if(i.charCodeAt(n)===u){if(!t){r=n;break}}else t=!1;return r===-1?o?"/":".":o&&r===1?"//":i.slice(0,r)},basename(i,o){o!==void 0&&v(o,"ext"),v(i,"path");let r=0,t=-1,n=!0,l;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let g=o.length-1,A=-1;for(l=i.length-1;l>=0;--l){const R=i.charCodeAt(l);if(R===u){if(!n){r=l+1;break}}else A===-1&&(n=!1,A=l+1),g>=0&&(R===o.charCodeAt(g)?--g===-1&&(t=l):(g=-1,t=A))}return r===t?t=A:t===-1&&(t=i.length),i.slice(r,t)}for(l=i.length-1;l>=0;--l)if(i.charCodeAt(l)===u){if(!n){r=l+1;break}}else t===-1&&(n=!1,t=l+1);return t===-1?"":i.slice(r,t)},extname(i){v(i,"path");let o=-1,r=0,t=-1,n=!0,l=0;for(let g=i.length-1;g>=0;--g){const A=i.charCodeAt(g);if(A===u){if(!n){r=g+1;break}continue}t===-1&&(n=!1,t=g+1),A===S?o===-1?o=g:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||t===-1||l===0||l===1&&o===t-1&&o===r+1?"":i.slice(o,t)},format:E.bind(null,"/"),parse(i){v(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const r=i.charCodeAt(0)===u;let t;r?(o.root="/",t=1):t=0;let n=-1,l=0,g=-1,A=!0,R=i.length-1,k=0;for(;R>=t;--R){const I=i.charCodeAt(R);if(I===u){if(!A){l=R+1;break}continue}g===-1&&(A=!1,g=R+1),I===S?n===-1?n=R:k!==1&&(k=1):n!==-1&&(k=-1)}if(g!==-1){const I=l===0&&r?1:l;n===-1||k===0||k===1&&n===g-1&&n===l+1?o.base=o.name=i.slice(I,g):(o.name=i.slice(I,n),o.base=i.slice(I,g),o.ext=i.slice(n,g))}return l>0?o.dir=i.slice(0,l-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=w?e.$ec.normalize:e.$fc.normalize,e.$hc=w?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=w?e.$ec.join:e.$fc.join,e.$jc=w?e.$ec.resolve:e.$fc.resolve,e.$kc=w?e.$ec.relative:e.$fc.relative,e.$lc=w?e.$ec.dirname:e.$fc.dirname,e.$mc=w?e.$ec.basename:e.$fc.basename,e.$nc=w?e.$ec.extname:e.$fc.extname,e.$oc=w?e.$ec.format:e.$fc.format,e.$pc=w?e.$ec.parse:e.$fc.parse,e.$qc=w?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=w?e.$ec.sep:e.$fc.sep,e.$sc=w?e.$ec.delimiter:e.$fc.delimiter}),define(ne[33],se([0,1,9,4,27,12]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function C(l){return l===47||l===92}e.$Qf=C;function S(l){return l.replace(/[\\/]/g,P.$fc.sep)}e.$Rf=S;function u(l){return l.indexOf("/")===-1&&(l=S(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$Sf=u;function a(l,g=P.$fc.sep){if(!l)return"";const A=l.length,R=l.charCodeAt(0);if(C(R)){if(C(l.charCodeAt(1))&&!C(l.charCodeAt(2))){let I=3;const L=I;for(;I<A&&!C(l.charCodeAt(I));I++);if(L!==I&&!C(l.charCodeAt(I+1))){for(I+=1;I<A;I++)if(C(l.charCodeAt(I)))return l.slice(0,I+1).replace(/[\\/]/g,g)}}return g}else if($(R)&&l.charCodeAt(1)===58)return C(l.charCodeAt(2))?l.slice(0,2)+g:l.slice(0,2);let k=l.indexOf("://");if(k!==-1){for(k+=3;k<A;k++)if(C(l.charCodeAt(k)))return l.slice(0,k+1)}return""}e.$Tf=a;function m(l){if(!D.$j||!l||l.length<5)return!1;let g=l.charCodeAt(0);if(g!==92||(g=l.charCodeAt(1),g!==92))return!1;let A=2;const R=A;for(;A<l.length&&(g=l.charCodeAt(A),g!==92);A++);return!(R===A||(g=l.charCodeAt(A+1),isNaN(g)||g===92))}e.$Uf=m;const b=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(l,g=D.$j){const A=g?b:y;return!(!l||l.length===0||/^\s+$/.test(l)||(A.lastIndex=0,A.test(l))||g&&f.test(l)||l==="."||l===".."||g&&l[l.length-1]==="."||g&&l.length!==l.trim().length||l.length>255)}e.$Vf=v;function w(l,g,A){const R=l===g;return!A||R?R:!l||!g?!1:(0,s.$2e)(l,g)}e.$Wf=w;function p(l,g,A,R=P.sep){if(l===g)return!0;if(!l||!g||g.length>l.length)return!1;if(A){if(!(0,s.$3e)(l,g))return!1;if(g.length===l.length)return!0;let I=g.length;return g.charAt(g.length-1)===R&&I--,l.charAt(I)===R}return g.charAt(g.length-1)!==R&&(g+=R),l.indexOf(g)===0}e.$Xf=p;function $(l){return l>=65&&l<=90||l>=97&&l<=122}e.$Yf=$;function d(l,g){return D.$j&&l.endsWith(":")&&(l+=P.sep),(0,P.$hc)(l)||(l=(0,P.$ic)(g,l)),l=(0,P.$gc)(l),D.$j?(l=(0,s.$Ke)(l,P.sep),l.endsWith(":")&&(l+=P.sep)):(l=(0,s.$Ke)(l,P.sep),l||(l=P.sep)),l}e.$Zf=d;function h(l){const g=(0,P.$gc)(l);return D.$j?l.length>3?!1:E(g)&&(l.length===2||g.charCodeAt(2)===92):g===P.$fc.sep}e.$1f=h;function E(l,g=D.$j){return g?$(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$2f=E;function c(l,g=D.$j){return E(l,g)?l[0]:void 0}e.$3f=c;function i(l,g,A){return g.length>l.length?-1:l===g?0:(A&&(l=l.toLowerCase(),g=g.toLowerCase()),l.indexOf(g))}e.$4f=i;function o(l){const g=l.split(":");let A,R,k;for(const I of g){const L=Number(I);(0,M.$Cf)(L)?R===void 0?R=L:k===void 0&&(k=L):A=A?[A,I].join(":"):I}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:R!==void 0?R:void 0,column:k!==void 0?k:R!==void 0?1:void 0}}e.$5f=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(l,g,A=8){let R="";for(let I=0;I<A;I++){let L;I===0&&D.$j&&!g&&(A===3||A===4)?L=t:L=r,R+=L.charAt(Math.floor(Math.random()*L.length))}let k;return g?k=`${g}-${R}`:k=R,l?(0,P.$ic)(l,k):k}e.$6f=n}),define(ne[76],se([0,1,4]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0;var D;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(D||(e.Source=D={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(S,...u){const a=u.reduce((y,f)=>(y[f]=!0,y),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(y=>!a[y]).forEach(y=>{for(let f=0;f<m.length;f++)if(y.search(m[f])!==-1){delete S[y];break}})}e.$zl=M;function C(S){S&&(delete S.DEBUG,P.$k&&delete S.DYLD_LIBRARY_PATH,P.$l&&delete S.LD_PRELOAD)}e.$Al=C}),define(ne[7],se([0,1,9,4]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,C=/^\/\//;function S(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!s.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!M.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(t,n){return!t&&!n?"file":t}function a(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==b&&(n=b+n):n=b;break}return n}const m="",b="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,l,g,A,R,k=!1){typeof n=="object"?(this.scheme=n.scheme||m,this.authority=n.authority||m,this.path=n.path||m,this.query=n.query||m,this.fragment=n.fragment||m):(this.scheme=u(n,k),this.authority=l||m,this.path=a(this.scheme,g||m),this.query=A||m,this.fragment=R||m,S(this,k))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:l,authority:g,path:A,query:R,fragment:k}=n;return l===void 0?l=this.scheme:l===null&&(l=m),g===void 0?g=this.authority:g===null&&(g=m),A===void 0?A=this.path:A===null&&(A=m),R===void 0?R=this.query:R===null&&(R=m),k===void 0?k=this.fragment:k===null&&(k=m),l===this.scheme&&g===this.authority&&A===this.path&&R===this.query&&k===this.fragment?this:new p(l,g,A,R,k)}static parse(n,l=!1){const g=y.exec(n);return g?new p(g[2]||m,r(g[4]||m),r(g[5]||m),r(g[7]||m),r(g[9]||m),l):new p(m,m,m,m,m)}static file(n){let l=m;if(D.$j&&(n=n.replace(/\\/g,b)),n[0]===b&&n[1]===b){const g=n.indexOf(b,2);g===-1?(l=n.substring(2),n=b):(l=n.substring(2,g),n=n.substring(g)||b)}return new p("file",l,n,m,m)}static from(n,l){return new p(n.scheme,n.authority,n.path,n.query,n.fragment,l)}static joinPath(n,...l){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return D.$j&&n.scheme==="file"?g=f.file(P.$ec.join(E(n,!0),...l)).path:g=P.$fc.join(n.path,...l),n.with({path:g})}toString(n=!1){return c(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const l=new p(n);return l._formatted=n.external??null,l._fsPath=n._sep===w?n.fsPath??null:null,l}}else return n}}e.URI=f;function v(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$uc=v;const w=D.$j?1:void 0;class p extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=w),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const $={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(t,n,l){let g,A=-1;for(let R=0;R<t.length;R++){const k=t.charCodeAt(R);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||n&&k===47||l&&k===91||l&&k===93||l&&k===58)A!==-1&&(g+=encodeURIComponent(t.substring(A,R)),A=-1),g!==void 0&&(g+=t.charAt(R));else{g===void 0&&(g=t.substr(0,R));const I=$[k];I!==void 0?(A!==-1&&(g+=encodeURIComponent(t.substring(A,R)),A=-1),g+=I):A===-1&&(A=R)}}return A!==-1&&(g+=encodeURIComponent(t.substring(A))),g!==void 0?g:t}function h(t){let n;for(let l=0;l<t.length;l++){const g=t.charCodeAt(l);g===35||g===63?(n===void 0&&(n=t.substr(0,l)),n+=$[g]):n!==void 0&&(n+=t[l])}return n!==void 0?n:t}function E(t,n){let l;return t.authority&&t.path.length>1&&t.scheme==="file"?l=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?l=t.path.substr(1):l=t.path[1].toLowerCase()+t.path.substr(2):l=t.path,D.$j&&(l=l.replace(/\//g,"\\")),l}e.$vc=E;function c(t,n){const l=n?h:d;let g="",{scheme:A,authority:R,path:k,query:I,fragment:L}=t;if(A&&(g+=A,g+=":"),(R||A==="file")&&(g+=b,g+=b),R){let N=R.indexOf("@");if(N!==-1){const T=R.substr(0,N);R=R.substr(N+1),N=T.lastIndexOf(":"),N===-1?g+=l(T,!1,!1):(g+=l(T.substr(0,N),!1,!1),g+=":",g+=l(T.substr(N+1),!1,!0)),g+="@"}R=R.toLowerCase(),N=R.lastIndexOf(":"),N===-1?g+=l(R,!1,!0):(g+=l(R.substr(0,N),!1,!0),g+=R.substr(N))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const N=k.charCodeAt(1);N>=65&&N<=90&&(k=`/${String.fromCharCode(N+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const N=k.charCodeAt(0);N>=65&&N<=90&&(k=`${String.fromCharCode(N+32)}:${k.substr(2)}`)}g+=l(k,!0,!1)}return I&&(g+="?",g+=l(I,!1,!1)),L&&(g+="#",g+=n?L:d(L,!1,!1)),g}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(o)?t.replace(o,n=>i(n)):t}}),define(ne[154],se([0,1,7]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$3p=e.$2p=e.$1p=void 0;function D(a){const m=a;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.$1p=D;function s(a){const m=[];let b;try{const y=JSON.parse(a.arguments),f=y[y.length-1];f&&f.__$stack&&(y.pop(),b=f.__$stack),m.push(...y)}catch{m.push("Unable to log remote console arguments",a.arguments)}return{args:m,stack:b}}e.$2p=s;function M(a){if(typeof a!="string")return M(s(a).stack);const m=a;if(m){const b=C(m),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(y&&y.length===4)return{uri:P.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.$3p=M;function C(a){if(!a)return a;const m=a.indexOf(`
`);return m===-1?a:a.substring(0,m)}function S(a,m){const{args:b,stack:y}=s(a),f=typeof b[0]=="string"&&b.length===1;let v=C(y);v&&(v=`(${v.trim()})`);let w=[];if(typeof b[0]=="string"?v&&f?w=[`%c[${m}] %c${b[0]} %c${v}`,u("blue"),u(""),u("grey")]:w=[`%c[${m}] %c${b[0]}`,u("blue"),u(""),...b.slice(1)]:w=[`%c[${m}]%`,u("blue"),...b],v&&!f&&w.push(v),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,w)}e.log=S;function u(a){return`color: ${a}`}}),define(ne[77],se([0,1,17,7]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function s(u){return JSON.stringify(u,C)}e.$kh=s;function M(u){let a=JSON.parse(u);return a=S(a),a}e.$lh=M;function C(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function S(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof P.$be||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let m=0;m<u.length;++m)u[m]=S(u[m],a+1);else for(const m in u)Object.hasOwnProperty.call(u,m)&&(u[m]=S(u[m],a+1))}return u}e.$mh=S}),define(ne[13],se([0,1,14,4,7]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var M;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$7f="vscode-tkn",e.$8f="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${M.vscodeRemoteResource}`}set(m,b,y){this.a[m]=b,this.b[m]=y}setConnectionToken(m,b){this.c[m]=b}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(p){return P.$Z(p),m}const b=m.authority;let y=this.a[b];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const f=this.b[b],v=this.c[b];let w=`path=${encodeURIComponent(m.path)}`;return typeof v=="string"&&(w+=`&${e.$8f}=${encodeURIComponent(v)}`),s.URI.from({scheme:D.$p?this.d:M.vscodeRemoteResource,authority:`${y}:${f}`,path:this.f,query:w})}}e.$9f=new C,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class S{static{this.a=e.$bg}asBrowserUri(m){const b=this.b(m,Q);return this.uriToBrowserUri(b)}uriToBrowserUri(m){return m.scheme===M.vscodeRemote?e.$9f.rewrite(m):m.scheme===M.file&&(D.$n||D.$q&&D.$h.origin===`${M.vscodeFileResource}://${S.a}`)?m.with({scheme:M.vscodeFileResource,authority:m.authority||S.a,query:null,fragment:null}):m}asFileUri(m){const b=this.b(m,Q);return this.uriToFileUri(b)}uriToFileUri(m){return m.scheme===M.vscodeFileResource?m.with({scheme:M.file,authority:m.authority!==S.a?m.authority:null,query:null,fragment:null}):m}b(m,b){return s.URI.isUri(m)?m:s.URI.parse(b.toUrl(m))}}e.$cg=new S;var u;(function(a){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(m.get("3"));const b="vscode-coi";function y(v){let w;typeof v=="string"?w=new URL(v).searchParams:v instanceof URL?w=v.searchParams:s.URI.isUri(v)&&(w=new URL(v.toString(!0)).searchParams);const p=w?.get(b);if(p)return m.get(p)}a.getHeadersFromQuery=y;function f(v,w,p){if(!globalThis.crossOriginIsolated)return;const $=w&&p?"3":p?"2":"1";v instanceof URLSearchParams?v.set(b,$):v[b]=$}a.addSearchParam=f})(u||(e.COI=u={}))}),define(ne[19],se([0,1,33,13,9,4,27,7]),function(Q,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function u(f){return(0,S.$vc)(f,!0)}e.$jg=u;class a{constructor(v){this.a=v}compare(v,w,p=!1){return v===w?0:(0,C.$Ue)(this.getComparisonKey(v,p),this.getComparisonKey(w,p))}isEqual(v,w,p=!1){return v===w?!0:!v||!w?!1:this.getComparisonKey(v,p)===this.getComparisonKey(w,p)}getComparisonKey(v,w=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,w,p=!1){if(v.scheme===w.scheme){if(v.scheme===D.Schemas.file)return P.$Xf(u(v),u(w),this.a(v))&&v.query===w.query&&(p||v.fragment===w.fragment);if((0,e.$Ag)(v.authority,w.authority))return P.$Xf(v.path,w.path,this.a(v),"/")&&v.query===w.query&&(p||v.fragment===w.fragment)}return!1}joinPath(v,...w){return S.URI.joinPath(v,...w)}basenameOrAuthority(v){return(0,e.$sg)(v)||v.authority}basename(v){return s.$fc.basename(v.path)}extname(v){return s.$fc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let w;return v.scheme===D.Schemas.file?w=S.URI.file(s.$lc(u(v))).path:(w=s.$fc.dirname(v.path),v.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),w="/")),v.with({path:w})}normalizePath(v){if(!v.path.length)return v;let w;return v.scheme===D.Schemas.file?w=S.URI.file(s.$gc(u(v))).path:w=s.$fc.normalize(v.path),v.with({path:w})}relativePath(v,w){if(v.scheme!==w.scheme||!(0,e.$Ag)(v.authority,w.authority))return;if(v.scheme===D.Schemas.file){const d=s.$kc(u(v),u(w));return M.$j?P.$Rf(d):d}let p=v.path||"/";const $=w.path||"/";if(this.a(v)){let d=0;for(const h=Math.min(p.length,$.length);d<h&&!(p.charCodeAt(d)!==$.charCodeAt(d)&&p.charAt(d).toLowerCase()!==$.charAt(d).toLowerCase());d++);p=$.substr(0,d)+p.substr(d)}return s.$fc.relative(p,$)}resolvePath(v,w){if(v.scheme===D.Schemas.file){const p=S.URI.file(s.$jc(u(v),w));return v.with({authority:p.authority,path:p.path})}return w=P.$Sf(w),v.with({path:s.$fc.resolve(v.path,w)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,w){return v===w||v!==void 0&&w!==void 0&&(0,C.$2e)(v,w)}hasTrailingPathSeparator(v,w=s.sep){if(v.scheme===D.Schemas.file){const p=u(v);return p.length>P.$Tf(p).length&&p[p.length-1]===w}else{const p=v.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,w=s.sep){return(0,e.$Bg)(v,w)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,w=s.sep){let p=!1;if(v.scheme===D.Schemas.file){const $=u(v);p=$!==void 0&&$.length===P.$Tf($).length&&$[$.length-1]===w}else{w="/";const $=v.path;p=$.length===1&&$.charCodeAt($.length-1)===47}return!p&&!(0,e.$Bg)(v,w)?v.with({path:v.path+"/"}):v}}e.$kg=a,e.$lg=new a(()=>!1),e.$mg=new a(f=>f.scheme===D.Schemas.file?!M.$l:!0),e.$ng=new a(f=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function m(f,v){const w=[];for(let p=0;p<f.length;p++){const $=v(f[p]);f.some((d,h)=>h===p?!1:(0,e.$pg)($,v(d)))||w.push(f[p])}return w}e.$Eg=m;var b;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function v(w){const p=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(h=>{const[E,c]=h.split(":");E&&c&&p.set(E,c)});const d=w.path.substring(0,w.path.indexOf(";"));return d&&p.set(f.META_DATA_MIME,d),p}f.parseMetaData=v})(b||(e.DataUri=b={}));function y(f,v,w){if(v){let p=f.path;return p&&p[0]!==s.$fc.sep&&(p=s.$fc.sep+p),f.with({scheme:w,authority:v,path:p})}return f.with({scheme:w})}e.$Fg=y}),define(ne[8],se([0,1,22,14,3,2,19,4,143]),function(Q,e,P,D,s,M,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function a(j){return!!j&&typeof j.then=="function"}e.$Gg=a;function m(j){const F=new P.$Xd,U=j(F.token),H=new Promise((B,ie)=>{const fe=F.token.onCancellationRequested(()=>{fe.dispose(),F.dispose(),ie(new D.$4)});Promise.resolve(U).then(de=>{fe.dispose(),F.dispose(),B(de)},de=>{fe.dispose(),F.dispose(),ie(de)})});return new class{cancel(){F.cancel()}then(B,ie){return H.then(B,ie)}catch(B){return this.then(void 0,B)}finally(B){return H.finally(B)}}}e.$Hg=m;function b(j,F,U){return new Promise((H,B)=>{const ie=F.onCancellationRequested(()=>{ie.dispose(),H(U)});j.then(H,B).finally(()=>ie.dispose())})}e.$Ig=b;function y(j,F){return new Promise((U,H)=>{const B=F.onCancellationRequested(()=>{B.dispose(),H(new D.$4)});j.then(U,H).finally(()=>B.dispose())})}e.$Jg=y;async function f(j){let F=-1;const U=j.map((H,B)=>H.then(ie=>(F=B,ie)));try{return await Promise.race(U)}finally{j.forEach((H,B)=>{B!==F&&H.cancel()})}}e.$Kg=f;function v(j,F,U){let H;const B=setTimeout(()=>{H?.(void 0),U?.()},F);return Promise.race([j.finally(()=>clearTimeout(B)),new Promise(ie=>H=ie)])}e.$Lg=v;function w(j){return new Promise((F,U)=>{const H=j();a(H)?H.then(F,U):F(H)})}e.$Mg=w;class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(F){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=F,!this.b){const U=()=>{if(this.b=null,this.f)return;const H=this.queue(this.d);return this.d=null,H};this.b=new Promise(H=>{this.a.then(U,U).then(H)})}return new Promise((U,H)=>{this.b.then(U,H)})}return this.a=F(),new Promise((U,H)=>{this.a.then(B=>{this.a=null,U(B)},B=>{this.a=null,H(B)})})}dispose(){this.f=!0}}e.$Ng=p;class ${constructor(){this.a=Promise.resolve(null)}queue(F){return this.a=this.a.then(()=>F(),()=>F())}}e.$Og=$;class d{constructor(){this.a=new Map}queue(F,U){const B=(this.a.get(F)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(F)===B&&this.a.delete(F)});return this.a.set(F,B),B}}e.$Pg=d;const h=(j,F)=>{let U=!0;const H=setTimeout(()=>{U=!1,F()},j);return{isTriggered:()=>U,dispose:()=>{clearTimeout(H),U=!1}}},E=j=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,j())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};class c{constructor(F){this.defaultDelay=F,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(F,U=this.defaultDelay){this.g=F,this.h(),this.b||(this.b=new Promise((B,ie)=>{this.d=B,this.f=ie}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const H=()=>{this.a=null,this.d?.(null)};return this.a=U===u.$Kd?E(H):h(U,H),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new D.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=c;class i{constructor(F){this.a=new c(F),this.b=new p}trigger(F,U){return this.a.trigger(()=>this.b.queue(F),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=i;class o{constructor(){this.a=!1,this.b=new Promise((F,U)=>{this.d=F})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=o;class r extends o{constructor(F){super(),this.f=setTimeout(()=>this.open(),F)}open(){clearTimeout(this.f),super.open()}}e.$Tg=r;function t(j,F){return F?new Promise((U,H)=>{const B=setTimeout(()=>{ie.dispose(),U()},j),ie=F.onCancellationRequested(()=>{clearTimeout(B),ie.dispose(),H(new D.$4)})}):m(U=>t(j,U))}e.$Ug=t;function n(j,F=0,U){const H=setTimeout(()=>{j(),U&&B.dispose()},F),B=(0,M.$Pc)(()=>{clearTimeout(H),U?.deleteAndLeak(B)});return U?.add(B),B}e.$Vg=n;function l(j){const F=[];let U=0;const H=j.length;function B(){return U<H?j[U++]():null}function ie(fe){fe!=null&&F.push(fe);const de=B();return de?de.then(ie):Promise.resolve(F)}return Promise.resolve(null).then(ie)}e.$Wg=l;function g(j,F=H=>!!H,U=null){let H=0;const B=j.length,ie=()=>{if(H>=B)return Promise.resolve(U);const fe=j[H++];return Promise.resolve(fe()).then(ue=>F(ue)?Promise.resolve(ue):ie())};return ie()}e.$Xg=g;function A(j,F=H=>!!H,U=null){if(j.length===0)return Promise.resolve(U);let H=j.length;const B=()=>{H=-1;for(const ie of j)ie.cancel?.()};return new Promise((ie,fe)=>{for(const de of j)de.then(ue=>{--H>=0&&F(ue)?(B(),ie(ue)):H===0&&ie(U)}).catch(ue=>{--H>=0&&(B(),fe(ue))})})}e.$Yg=A;class R{constructor(F){this.a=0,this.d=F,this.f=[],this.b=0,this.g=new s.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(F){return this.a++,new Promise((U,H)=>{this.f.push({factory:F,c:U,e:H}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const F=this.f.shift();this.b++;const U=F.factory();U.then(F.c,F.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=R;class k extends R{constructor(){super(1)}}e.$1g=k;class I{constructor(){this.a=new K,this.b=0}queue(F){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,F())):this.a.run(this.b++,F())}}e.$2g=I;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const F=new W;return this.b.add(F),F.p}g(){for(const[,F]of this.a)if(F.size>0)return!1;return!0}queueFor(F,U=C.$lg){const H=U.getComparisonKey(F);let B=this.a.get(H);if(!B){B=new k;const ie=this.f++,fe=s.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(H),this.h(),this.d?.deleteAndDispose(ie),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$Zc),this.d.set(ie,fe),this.a.set(H,B)}return B}h(){this.g()&&this.j()}j(){for(const F of this.b)F.complete();this.b.clear()}dispose(){for(const[,F]of this.a)F.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=L;class N{constructor(F,U){this.a=-1,typeof F=="function"&&typeof U=="number"&&this.setIfNotSet(F,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(F,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,F()},U)}setIfNotSet(F,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,F()},U))}}e.$4g=N;class T{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(F,U){this.cancel(),this.a=setInterval(()=>{F()},U)}}e.$5g=T;class x{constructor(F,U){this.b=-1,this.a=F,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(F=this.d){this.cancel(),this.b=setTimeout(this.f,F)}get delay(){return this.d}set delay(F){this.d=F}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=x;class X{constructor(F,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=F,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(F=this.b){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(F/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=X;class ce extends x{constructor(F,U){super(F,U),this.j=[]}work(F){this.j.push(F),this.isScheduled()||this.schedule()}h(){const F=this.j;this.j=[],this.a?.(F)}dispose(){this.j=[],super.dispose()}}e.$8g=ce;class re extends M.$Rc{constructor(F,U){super(),this.g=F,this.h=U,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(F){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+F.length>this.g.maxBufferedWork)return!1}else if(this.pending+F.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of F)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new x(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=j=>{(0,S.$B)(()=>{if(F)return;const U=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.$0g=(j,F)=>{const U=requestIdleCallback(j,typeof F=="number"?{timeout:F}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(U))}}}}();class ae{constructor(F){this.d=!1,this.a=()=>{try{this.f=F()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=ae;async function Z(j,F,U){let H;for(let B=0;B<U;B++)try{return await j()}catch(ie){H=ie,await t(F)}throw H}e.$_g=Z;class K{isRunning(F){return typeof F=="number"?this.a?.taskId===F:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(F,U,H){return this.a={taskId:F,cancel:()=>H?.(),promise:U},U.then(()=>this.d(F),()=>this.d(F)),U}d(F){this.a&&F===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const F=this.b;this.b=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}queue(F){if(this.b)this.b.run=F;else{let U,H;const B=new Promise((ie,fe)=>{U=ie,H=fe});this.b={run:F,promise:B,promiseResolve:U,promiseReject:H}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=K;class G{constructor(F,U=()=>Date.now()){this.d=F,this.f=U,this.a=0,this.b=0}increment(){const F=this.f();return F-this.a>this.d&&(this.a=F,this.b=0),this.b++,this.b}}e.$bh=G;var z;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(z||(z={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((F,U)=>{this.a=F,this.b=U})}complete(F){return new Promise(U=>{this.a(F),this.d={outcome:0,value:F},U()})}error(F){return new Promise(U=>{this.b(F),this.d={outcome:1,value:F},U()})}cancel(){return this.error(new D.$4)}}e.$ch=W;var V;(function(j){async function F(H){let B;const ie=await Promise.all(H.map(fe=>fe.then(de=>de,de=>{B||(B=de)})));if(typeof B<"u")throw B;return ie}j.settled=F;function U(H){return new Promise(async(B,ie)=>{try{await H(B,ie)}catch(fe){ie(fe)}})}j.withAsyncBody=U})(V||(e.Promises=V={}));var q;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(q||(q={}));class Y{static fromArray(F){return new Y(U=>{U.emitMany(F)})}static fromPromise(F){return new Y(async U=>{U.emitMany(await F)})}static fromPromises(F){return new Y(async U=>{await Promise.all(F.map(async H=>U.emitOne(await H)))})}static merge(F){return new Y(async U=>{await Promise.all(F.map(async H=>{for await(const B of H)U.emitOne(B)}))})}static{this.EMPTY=Y.fromArray([])}constructor(F){this.a=0,this.b=[],this.d=null,this.f=new s.$Nd,queueMicrotask(async()=>{const U={emitOne:H=>this.g(H),emitMany:H=>this.h(H),reject:H=>this.k(H)};try{await Promise.resolve(F(U)),this.j()}catch(H){this.k(H)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(F<this.b.length)return{done:!1,value:this.b[F++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(F,U){return new Y(async H=>{for await(const B of F)H.emitOne(U(B))})}map(F){return Y.map(this,F)}static filter(F,U){return new Y(async H=>{for await(const B of F)U(B)&&H.emitOne(B)})}filter(F){return Y.filter(this,F)}static coalesce(F){return Y.filter(F,U=>!!U)}coalesce(){return Y.coalesce(this)}static async toPromise(F){const U=[];for await(const H of F)U.push(H);return U}toPromise(){return Y.toPromise(this)}g(F){this.a===0&&(this.b.push(F),this.f.fire())}h(F){this.a===0&&(this.b=this.b.concat(F),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(F){this.a===0&&(this.a=2,this.d=F,this.f.fire())}}e.$dh=Y;class oe extends Y{constructor(F,U){super(U),this.l=F}cancel(){this.l.cancel()}}e.$eh=oe;function J(j){const F=new P.$Xd,U=j(F.token);return new oe(F,async H=>{const B=F.token.onCancellationRequested(()=>{B.dispose(),F.dispose(),H.reject(new D.$4)});try{for await(const ie of U){if(F.token.isCancellationRequested)return;H.emitOne(ie)}B.dispose(),F.dispose()}catch(ie){B.dispose(),F.dispose(),H.reject(ie)}})}e.$fh=J;class O{constructor(){this.a=new W,this.b=new Y(H=>{if(F){H.reject(F);return}return U&&H.emitMany(U),this.d=B=>H.reject(B),this.f=B=>H.emitOne(B),this.a.p});let F,U;this.f=H=>{U||(U=[]),U.push(H)},this.d=H=>{F||(F=H)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(F){this.d(F),this.a.complete()}emitOne(F){this.f(F)}}e.$gh=O}),define(ne[104],se([0,1,23,8,33,31,9,4,27]),function(Q,e,P,D,s,M,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function a(){return Object.create(null)}e.$rj=a,e.$sj="**",e.$tj="/";const m="[/\\\\]",b="[^/\\\\]",y=/\//g;function f(K,G){switch(K){case 0:return"";case 1:return`${b}*?`;default:return`(?:${m}|${b}+${m}${G?`|${m}${b}+`:""})*?`}}function v(K,G){if(!K)return[];const z=[];let W=!1,V=!1,q="";for(const Y of K){switch(Y){case G:if(!W&&!V){z.push(q),q="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":V=!0;break;case"]":V=!1;break}q+=Y}return q&&z.push(q),z}e.$uj=v;function w(K){if(!K)return"";let G="";const z=v(K,e.$tj);if(z.every(W=>W===e.$sj))G=".*";else{let W=!1;z.forEach((V,q)=>{if(V===e.$sj){if(W)return;G+=f(2,q===z.length-1)}else{let Y=!1,oe="",J=!1,O="";for(const j of V){if(j!=="}"&&Y){oe+=j;continue}if(J&&(j!=="]"||!O)){let F;j==="-"?F=j:(j==="^"||j==="!")&&!O?F="^":j===e.$tj?F="":F=(0,u.$Fe)(j),O+=F;continue}switch(j){case"{":Y=!0;continue;case"[":J=!0;continue;case"}":{const U=`(?:${v(oe,",").map(H=>w(H)).join("|")})`;G+=U,Y=!1,oe="";break}case"]":{G+="["+O+"]",J=!1,O="";break}case"?":G+=b;continue;case"*":G+=f(1);continue;default:G+=(0,u.$Fe)(j)}}q<z.length-1&&(z[q+1]!==e.$sj||q+2<z.length)&&(G+=m)}W=V===e.$sj})}return G}const p=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.$Cc(1e4),o=function(){return!1},r=function(){return null};function t(K,G){if(!K)return r;let z;typeof K!="string"?z=K.pattern:z=K,z=z.trim();const W=`${z}_${!!G.trimForExclusions}`;let V=i.get(W);if(V)return n(V,K);let q;return p.test(z)?V=g(z.substr(4),z):(q=$.exec(l(z,G)))?V=A(q[1],z):(G.trimForExclusions?h:d).test(z)?V=R(z,G):(q=E.exec(l(z,G)))?V=k(q[1].substr(1),z,!0):(q=c.exec(l(z,G)))?V=k(q[1],z,!1):V=I(z),i.set(W,V),n(V,K)}function n(K,G){if(typeof G=="string")return K;const z=function(W,V){return(0,s.$Xf)(W,G.base,!S.$l)?K((0,u.$Je)(W.substr(G.base.length),C.sep),V):null};return z.allBasenames=K.allBasenames,z.allPaths=K.allPaths,z.basenames=K.basenames,z.patterns=K.patterns,z}function l(K,G){return G.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function g(K,G){return function(z,W){return typeof z=="string"&&z.endsWith(K)?G:null}}function A(K,G){const z=`/${K}`,W=`\\${K}`,V=function(Y,oe){return typeof Y!="string"?null:oe?oe===K?G:null:Y===K||Y.endsWith(z)||Y.endsWith(W)?G:null},q=[K];return V.basenames=q,V.patterns=[G],V.allBasenames=q,V}function R(K,G){const z=ae(K.slice(1,-1).split(",").map(oe=>t(oe,G)).filter(oe=>oe!==r),K),W=z.length;if(!W)return r;if(W===1)return z[0];const V=function(oe,J){for(let O=0,j=z.length;O<j;O++)if(z[O](oe,J))return K;return null},q=z.find(oe=>!!oe.allBasenames);q&&(V.allBasenames=q.allBasenames);const Y=z.reduce((oe,J)=>J.allPaths?oe.concat(J.allPaths):oe,[]);return Y.length&&(V.allPaths=Y),V}function k(K,G,z){const W=C.sep===C.$fc.sep,V=W?K:K.replace(y,C.sep),q=C.sep+V,Y=C.$fc.sep+K;let oe;return z?oe=function(J,O){return typeof J=="string"&&(J===V||J.endsWith(q)||!W&&(J===K||J.endsWith(Y)))?G:null}:oe=function(J,O){return typeof J=="string"&&(J===V||!W&&J===K)?G:null},oe.allPaths=[(z?"*/":"./")+K],oe}function I(K){try{const G=new RegExp(`^${w(K)}$`);return function(z){return G.lastIndex=0,typeof z=="string"&&G.test(z)?K:null}}catch{return r}}function L(K,G,z){return!K||typeof G!="string"?!1:N(K)(G,void 0,z)}e.$vj=L;function N(K,G={}){if(!K)return o;if(typeof K=="string"||T(K)){const z=t(K,G);if(z===r)return o;const W=function(V,q){return!!z(V,q)};return z.allBasenames&&(W.allBasenames=z.allBasenames),z.allPaths&&(W.allPaths=z.allPaths),W}return ce(K,G)}e.$wj=N;function T(K){const G=K;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$xj=T;function x(K){return K.allBasenames||[]}e.$yj=x;function X(K){return K.allPaths||[]}e.$zj=X;function ce(K,G){const z=ae(Object.getOwnPropertyNames(K).map(oe=>re(oe,K[oe],G)).filter(oe=>oe!==r)),W=z.length;if(!W)return r;if(!z.some(oe=>!!oe.requiresSiblings)){if(W===1)return z[0];const oe=function(j,F){let U;for(let H=0,B=z.length;H<B;H++){const ie=z[H](j,F);if(typeof ie=="string")return ie;(0,D.$Gg)(ie)&&(U||(U=[]),U.push(ie))}return U?(async()=>{for(const H of U){const B=await H;if(typeof B=="string")return B}return null})():null},J=z.find(j=>!!j.allBasenames);J&&(oe.allBasenames=J.allBasenames);const O=z.reduce((j,F)=>F.allPaths?j.concat(F.allPaths):j,[]);return O.length&&(oe.allPaths=O),oe}const V=function(oe,J,O){let j,F;for(let U=0,H=z.length;U<H;U++){const B=z[U];B.requiresSiblings&&O&&(J||(J=(0,C.$mc)(oe)),j||(j=J.substr(0,J.length-(0,C.$nc)(oe).length)));const ie=B(oe,J,j,O);if(typeof ie=="string")return ie;(0,D.$Gg)(ie)&&(F||(F=[]),F.push(ie))}return F?(async()=>{for(const U of F){const H=await U;if(typeof H=="string")return H}return null})():null},q=z.find(oe=>!!oe.allBasenames);q&&(V.allBasenames=q.allBasenames);const Y=z.reduce((oe,J)=>J.allPaths?oe.concat(J.allPaths):oe,[]);return Y.length&&(V.allPaths=Y),V}function re(K,G,z){if(G===!1)return r;const W=t(K,z);if(W===r)return r;if(typeof G=="boolean")return W;if(G){const V=G.when;if(typeof V=="string"){const q=(Y,oe,J,O)=>{if(!O||!W(Y,oe))return null;const j=V.replace("$(basename)",()=>J),F=O(j);return(0,D.$Gg)(F)?F.then(U=>U?K:null):F?K:null};return q.requiresSiblings=!0,q}}return W}function ae(K,G){const z=K.filter(oe=>!!oe.basenames);if(z.length<2)return K;const W=z.reduce((oe,J)=>{const O=J.basenames;return O?oe.concat(O):oe},[]);let V;if(G){V=[];for(let oe=0,J=W.length;oe<J;oe++)V.push(G)}else V=z.reduce((oe,J)=>{const O=J.patterns;return O?oe.concat(O):oe},[]);const q=function(oe,J){if(typeof oe!="string")return null;if(!J){let j;for(j=oe.length;j>0;j--){const F=oe.charCodeAt(j-1);if(F===47||F===92)break}J=oe.substr(j)}const O=W.indexOf(J);return O!==-1?V[O]:null};q.basenames=W,q.patterns=V,q.allBasenames=W;const Y=K.filter(oe=>!oe.basenames);return Y.push(q),Y}function Z(K,G){return(0,P.$tb)(K,G,(z,W)=>typeof z=="string"&&typeof W=="string"?z===W:typeof z!="string"&&typeof W!="string"?z.base===W.base&&z.pattern===W.pattern:!1)}e.$Aj=Z}),define(ne[46],se([0,1,23,33,9,4,19,27]),function(Q,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=void 0;function u(t,n){const{os:l,tildify:g,relative:A}=n;if(A){const I=a(t,A,l);if(typeof I=="string")return I}let R=t.fsPath;if(l===1&&!M.$j?R=R.replace(/\//g,"\\"):l!==1&&M.$j&&(R=R.replace(/\\/g,"/")),l!==1&&g?.userHome){const I=g.userHome.fsPath;let L;t.scheme!==g.userHome.scheme&&t.path.startsWith(s.$fc.sep)?L=g.userHome.with({path:t.path}).fsPath:L=t.fsPath,R=y(L,I,l)}return(l===1?s.$ec:s.$fc).normalize(m(R,l===1))}e.$uv=u;function a(t,n,l){const g=l===1?s.$ec:s.$fc,A=l===3?C.$lg:C.$ng,R=n.getWorkspace(),k=(0,P.$Nb)(R.folders);if(!k)return;t.scheme!==k.uri.scheme&&t.path.startsWith(s.$fc.sep)&&(t=k.uri.with({path:t.path}));const I=n.getWorkspaceFolder(t);if(!I)return;let L;if(A.isEqual(I.uri,t)?L="":L=A.relativePath(I.uri,t)??"",L&&(L=g.normalize(L)),R.folders.length>1&&!n.noPrefix){const N=I.name?I.name:A.basenameOrAuthority(I.uri);L=L?`${N} \u2022 ${L}`:N}return L}function m(t,n=M.$j){return(0,D.$2f)(t,n)?t.charAt(0).toUpperCase()+t.slice(1):t}e.$vv=m;let b=Object.create(null);function y(t,n,l=M.OS){if(l===1||!t||!n)return t;let g=b.original===n?b.normalized:void 0;g||(g=n,M.$j&&(g=(0,D.$Rf)(g)),g=`${(0,S.$Ke)(g,s.$fc.sep)}${s.$fc.sep}`,b={original:n,normalized:g});let A=t;return M.$j&&(A=(0,D.$Rf)(A)),(l===3?A.startsWith(g):(0,S.$3e)(A,g))?`~/${A.substr(g.length)}`:t}e.$wv=y;function f(t,n){return t.replace(/^~($|\/|\\)/,`${n}$1`)}e.$xv=f;const v="\u2026",w="\\\\",p="~";function $(t,n=s.sep){const l=new Array(t.length);let g=!1;for(let A=0;A<t.length;A++){const R=t[A];if(R===""){l[A]=`.${n}`;continue}if(!R){l[A]=R;continue}g=!0;let k="",I=R;I.indexOf(w)===0?(k=I.substr(0,I.indexOf(w)+w.length),I=I.substr(I.indexOf(w)+w.length)):I.indexOf(n)===0?(k=I.substr(0,I.indexOf(n)+n.length),I=I.substr(I.indexOf(n)+n.length)):I.indexOf(p)===0&&(k=I.substr(0,I.indexOf(p)+p.length),I=I.substr(I.indexOf(p)+p.length));const L=I.split(n);for(let N=1;g&&N<=L.length;N++)for(let T=L.length-N;g&&T>=0;T--){g=!1;let x=L.slice(T,T+N).join(n);for(let X=0;!g&&X<t.length;X++)if(X!==A&&t[X]&&t[X].indexOf(x)>-1){const ce=T+N===L.length,re=T>0&&t[X].indexOf(n)>-1?n+x:x,ae=t[X].endsWith(re);g=!ce||ae}if(!g){let X="";(L[0].endsWith(":")||k!=="")&&(T===1&&(T=0,N++,x=L[0]+n+x),T>0&&(X=L[0]+n),X=k+X),T>0&&(X=X+v+n),X=X+x,T+N<L.length&&(X=X+n+v),l[A]=X}}g&&(l[A]=R)}return l}e.$yv=$;var d;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function h(t,n=Object.create(null)){const l=[];let g=!1,A="";for(const R of t)if(R==="$"||g&&R==="{")A&&l.push({value:A,type:d.TEXT}),A="",g=!0;else if(R==="}"&&g){const k=n[A];if(typeof k=="string")k.length&&l.push({value:k,type:d.VARIABLE});else if(k){const I=l[l.length-1];(!I||I.type!==d.SEPARATOR)&&l.push({value:k.label,type:d.SEPARATOR})}A="",g=!1}else A+=R;return A&&!g&&l.push({value:A,type:d.TEXT}),l.filter((R,k)=>{if(R.type===d.SEPARATOR){const I=l[k-1],L=l[k+1];return[I,L].every(N=>N&&(N.type===d.VARIABLE||N.type===d.TEXT)&&N.value.length>0)}return!0}).map(R=>R.value).join("")}e.$zv=h;function E(t,n){return M.$k||n?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$k?"&":"&&"):t.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$Av=E;function c(t,n){return M.$k||n?t.replace(/\(&&\w\)|&&/g,""):M.$j?t.replace(/&&|&/g,l=>l==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.$Bv=c;function i(t){return t.replace(/&/g,"&&")}e.$Cv=i;function o(t){if(t.endsWith("]")){const n=t.lastIndexOf(" [",t.length-2);if(n!==-1){const l=r(t.substring(0,n));return{name:l.name,parentPath:l.parentPath+t.substring(n)}}}return r(t)}e.$Dv=o;function r(t){const n=t.indexOf("/")!==-1?s.$fc:s.$ec,l=n.basename(t),g=n.dirname(t);return l.length?{name:l,parentPath:g}:{name:g,parentPath:""}}}),define(ne[155],se([0,1,17,7]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function s(b){return b.toJSON()}class M{constructor(y){this.a=y}transformIncoming(y){const f=this.a.transformIncoming(y);return f===y?y:s(D.URI.from(f))}transformOutgoing(y){const f=this.a.transformOutgoing(y);return f===y?y:s(D.URI.from(f))}transformOutgoingURI(y){const f=this.a.transformOutgoing(y);return f===y?y:D.URI.from(f)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$Lm=M,e.$Mm=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function C(b,y,f){if(!b||f>200)return null;if(typeof b=="object"){if(b instanceof D.URI)return y.transformOutgoing(b);for(const v in b)if(Object.hasOwnProperty.call(b,v)){const w=C(b[v],y,f+1);w!==null&&(b[v]=w)}}return null}function S(b,y){const f=C(b,y,0);return f===null?b:f}e.$Nm=S;function u(b,y,f,v){if(!b||v>200)return null;if(typeof b=="object"){if(b.$mid===1)return f?D.URI.revive(y.transformIncoming(b)):y.transformIncoming(b);if(b instanceof P.$be)return null;for(const w in b)if(Object.hasOwnProperty.call(b,w)){const p=u(b[w],y,f,v+1);p!==null&&(b[w]=p)}}return null}function a(b,y){const f=u(b,y,!1,0);return f===null?b:f}e.$Om=a;function m(b,y){const f=u(b,y,!0,0);return f===null?b:f}e.$Pm=m}),define(ne[88],se([0,1,28,57,32,145,4]),function(Q,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0,e.$Rm=new class{c(y){return this.a||(this.a=D.$Vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,f=0;const v=(0,P.networkInterfaces)();for(const w in v){const p=v[w];if(p)for(const{mac:$,internal:d}of p)d||(f+=1,this.c($.toUpperCase())&&(y+=1))}this.b=f>0?y/f:0}return this.b}};let S;async function u(y){return S||(S=(async()=>await a(y)||s.$eg())()),S}e.$Sm=u;async function a(y){try{const f=await new Promise((w,p)=>{Q(["crypto"],w,p)}),v=(0,M.$Qm)();return f.createHash("sha256").update(v,"utf8").digest("hex")}catch(f){y(f);return}}const m="Software\\Microsoft\\SQMClient";async function b(y){if(C.$j){const f=await new Promise((v,w)=>{Q(["@vscode/windows-registry"],v,w)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",m,"MachineId")||""}catch(v){return y(v),""}}return""}e.$Tm=b}),define(ne[21],se([0,1,45,28,156,8,33,85,9,4,19,7]),function(Q,e,P,D,s,M,C,S,u,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function f(re,ae=y.UNLINK,Z){if((0,C.$1f)(re))throw new Error("rimraf - will refuse to recursively delete root");return ae===y.UNLINK?w(re):v(re,Z)}async function v(re,ae=(0,C.$6f)((0,D.tmpdir)())){try{try{await P.promises.rename(re,ae)}catch(Z){return Z.code==="ENOENT"?void 0:w(re)}w(ae).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function w(re){return(0,s.promisify)(P.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function p(re){if((0,C.$1f)(re))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function $(re,ae){return E(await(ae?d(re):(0,s.promisify)(P.readdir)(re)))}async function d(re){try{return await(0,s.promisify)(P.readdir)(re,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const ae=[],Z=await $(re);for(const K of Z){let G=!1,z=!1,W=!1;try{const V=await e.Promises.lstat((0,u.$ic)(re,K));G=V.isFile(),z=V.isDirectory(),W=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}ae.push({name:K,isFile:()=>G,isDirectory:()=>z,isSymbolicLink:()=>W})}return ae}function h(re){return E(P.readdirSync(re))}e.readdirSync=h;function E(re){return re.map(ae=>typeof ae=="string"?a.$k?(0,S.$ol)(ae):ae:(ae.name=a.$k?(0,S.$ol)(ae.name):ae.name,ae))}async function c(re){const ae=await $(re),Z=[];for(const K of ae)await o.existsDirectory((0,u.$ic)(re,K))&&Z.push(K);return Z}function i(re,ae=1e3){return new Promise(Z=>{let K=!1;const G=setInterval(()=>{K||(K=!0,P.access(re,z=>{K=!1,z&&(clearInterval(G),Z(void 0))}))},ae)})}e.whenDeleted=i;var o;(function(re){async function ae(G){let z;try{if(z=await e.Promises.lstat(G),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(a.$j&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw V}throw W}}re.stat=ae;async function Z(G){try{const{stat:z,symbolicLink:W}=await re.stat(G);return z.isFile()&&W?.dangling!==!0}catch{}return!1}re.existsFile=Z;async function K(G){try{const{stat:z,symbolicLink:W}=await re.stat(G);return z.isDirectory()&&W?.dangling!==!0}catch{}return!1}re.existsDirectory=K})(o||(e.SymlinkSupport=o={}));const r=new M.$3g;function t(re,ae,Z){return r.queueFor(b.URI.file(re),m.$mg).queue(()=>{const K=R(Z);return new Promise((G,z)=>g(re,ae,K,W=>W?z(W):G()))})}let n=!0;function l(re){n=re}e.configureFlushOnWrite=l;function g(re,ae,Z,K){if(!n)return P.writeFile(re,ae,{mode:Z.mode,flag:Z.flag},K);P.open(re,Z.flag,Z.mode,(G,z)=>{if(G)return K(G);P.writeFile(z,ae,W=>{if(W)return P.close(z,()=>K(W));P.fdatasync(z,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),l(!1)),P.close(z,q=>K(q))))})})}function A(re,ae,Z){const K=R(Z);if(!n)return P.writeFileSync(re,ae,{mode:K.mode,flag:K.flag});const G=P.openSync(re,K.flag,K.mode);try{P.writeFileSync(G,ae);try{P.fdatasyncSync(G)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),l(!1)}}finally{P.closeSync(G)}}e.writeFileSync=A;function R(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function k(re,ae,Z=6e4){if(re!==ae)try{a.$j&&typeof Z=="number"?await I(re,ae,Date.now(),Z):await(0,s.promisify)(P.rename)(re,ae)}catch(K){if(re.toLowerCase()!==ae.toLowerCase()&&K.code==="EXDEV"||re.endsWith("."))await L(re,ae,{preserveSymlinks:!1}),await f(re,y.MOVE);else throw K}}async function I(re,ae,Z,K,G=0){try{return await(0,s.promisify)(P.rename)(re,ae)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-Z>=K)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${z}`),z;if(G===0){let W=!1;try{const{stat:V}=await o.stat(ae);V.isFile()||(W=!0)}catch{}if(W)throw z}return await(0,M.$Ug)(Math.min(100,G*10)),I(re,ae,Z,K,G+1)}}async function L(re,ae,Z){return T(re,ae,{root:{source:re,target:ae},options:Z,handledSourcePaths:new Set})}const N=511;async function T(re,ae,Z){if(Z.handledSourcePaths.has(re))return;Z.handledSourcePaths.add(re);const{stat:K,symbolicLink:G}=await o.stat(re);if(G){if(Z.options.preserveSymlinks)try{return await ce(re,ae,Z)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(G.dangling)return}return K.isDirectory()?x(re,ae,K.mode&N,Z):X(re,ae,K.mode&N)}async function x(re,ae,Z,K){await e.Promises.mkdir(ae,{recursive:!0,mode:Z});const G=await $(re);for(const z of G)await T((0,u.$ic)(re,z),(0,u.$ic)(ae,z),K)}async function X(re,ae,Z){await e.Promises.copyFile(re,ae),await e.Promises.chmod(ae,Z)}async function ce(re,ae,Z){let K=await e.Promises.readlink(re);(0,C.$Xf)(K,Z.root.source,!a.$l)&&(K=(0,u.$ic)(Z.root.target,K.substr(Z.root.source.length+1))),await e.Promises.symlink(K,ae)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(re,ae,Z,K,G)=>new Promise((z,W)=>{P.read(re,ae,Z,K,G,(V,q,Y)=>V?W(V):z({bytesRead:q,buffer:Y}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(re,ae,Z,K,G)=>new Promise((z,W)=>{P.write(re,ae,Z,K,G,(V,q,Y)=>V?W(V):z({bytesWritten:q,buffer:Y}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return c}get writeFile(){return t}get rm(){return f}get rename(){return k}get copy(){return L}}}),define(ne[105],se([0,1,45,9,4,27,21]),function(Q,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.$9p=e.$8p=void 0;function S(y){if(s.$l)return y;const f=(0,D.$lc)(y);if(y===f)return y;const v=((0,D.$mc)(y)||y).toLowerCase();try{const p=(0,C.readdirSync)(f).filter($=>$.toLowerCase()===v);if(p.length===1){const $=S(f);if($)return(0,D.$ic)($,p[0])}else if(p.length>1){const $=p.indexOf(v);if($>=0){const d=S(f);if(d)return(0,D.$ic)(d,p[$])}}}catch{}return null}e.$8p=S;async function u(y){if(s.$l)return y;const f=(0,D.$lc)(y);if(y===f)return y;const v=((0,D.$mc)(y)||y).toLowerCase();try{const p=(await C.Promises.readdir(f)).filter($=>$.toLowerCase()===v);if(p.length===1){const $=await u(f);if($)return(0,D.$ic)($,p[0])}else if(p.length>1){const $=p.indexOf(v);if($>=0){const d=await u(f);if(d)return(0,D.$ic)(d,p[$])}}}catch{}return null}e.$9p=u;async function a(y){try{return await C.Promises.realpath(y)}catch{const v=b(y);return await C.Promises.access(v,P.constants.R_OK),v}}e.$0p=a;function m(y){try{return P.realpathSync(y)}catch{const v=b(y);return P.accessSync(v,P.constants.R_OK),v}}e.$$p=m;function b(y){return(0,M.$Ke)((0,D.$gc)(y),D.sep)}}),define(ne[106],se([0,1,28,9,21]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=void 0;const M=/^\d+$/,C=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var u;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class b{constructor(c,i,o){this.exePath=c,this.displayName=i,this.a=o}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:E=!1}={}){return E?a===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:E=!1,findPreview:c=!1}={}){const i=y({useAlternateBitness:E});if(!i)return null;const o=D.$ic(i,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(o))return null;let r=-1,t=null;for(const g of await s.Promises.readdir(o)){let A=-1;if(c){const k=g.indexOf("-");if(k<0)continue;const I=g.substring(0,k);if(!M.test(I)||g.substring(k+1)!=="preview")continue;A=parseInt(I,10)}else{if(!M.test(g))continue;A=parseInt(g,10)}if(A<=r)continue;const R=D.$ic(o,g,"pwsh.exe");await s.SymlinkSupport.existsFile(R)&&(t=R,r=A)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",l=c?" Preview":"";return new b(t,`PowerShell${l}${n}`,!0)}async function v({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const c=D.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=E?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(c))if(i.test(r)){const t=D.$ic(c,r,"pwsh.exe");return new b(t,o)}return null}function w(){const E=D.$ic(P.homedir(),".dotnet","tools","pwsh.exe");return new b(E,".NET Core PowerShell Global Tool")}function p(){const E=D.$ic(process.env.windir,a===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(E,"Windows PowerShell",!0)}async function*$(){let E=await f();E&&(yield E),E=await f({useAlternateBitness:!0}),E&&(yield E),E=await v(),E&&(yield E),E=w(),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await v({findPreview:!0}),E&&(yield E),E=await f({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=p(),E&&(yield E)}async function*d(){for await(const E of $())await E.exists()&&(yield E)}e.$xl=d;async function h(){for await(const E of d())return E;return null}e.$yl=h}),define(ne[89],se([0,1,9,4,35,76,12,21]),function(Q,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function u(b=s.env){return b.comspec||"cmd.exe"}e.$Bl=u;function a(b){let y=[],f=!1;const v=function(w){if(f){y.push(w);return}(!b.send(w,$=>{if($&&console.error($),f=!1,y.length>0){const d=y.slice(0);y=[],d.forEach(h=>v(h))}})||D.$j)&&(f=!0)};return{send:v}}e.$Cl=a;var m;(function(b){async function y(f,v,w){if(P.$hc(f))return f;if(v===void 0&&(v=s.cwd()),P.$lc(f)!=="."||(w===void 0&&C.$yf(s.env.PATH)&&(w=s.env.PATH.split(P.$sc)),w===void 0||w.length===0))return P.$ic(v,f);async function $(d){if(await S.Promises.exists(d)){let h;try{h=await S.Promises.stat(d)}catch(E){E.message.startsWith("EACCES")&&(h=await S.Promises.lstat(d))}return h?!h.isDirectory():!1}return!1}for(const d of w){let h;if(P.$hc(d)?h=P.$ic(d,f):h=P.$ic(v,d,f),await $(h))return h;let E=h+".com";if(await $(E)||(E=h+".exe",await $(E)))return E}return P.$ic(v,f)}b.findExecutable=y})(m||(e.win32=m={}))}),define(ne[107],se([0,1,47,13]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;function s(C){return new Promise((S,u)=>{let a;const m=new Map;function b(f,v,w,p,$){const d=m.get(v);if(f===C||d){const h={name:y(w),cmd:w,pid:f,ppid:v,load:p,mem:$};m.set(f,h),f===C&&(a=h),d&&(d.children||(d.children=[]),d.children.push(h),d.children.length>1&&(d.children=d.children.sort((E,c)=>E.pid-c.pid)))}}function y(f){const v=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,p=/--crashes-directory/i,$=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,h=/--type=([a-zA-Z-]+)/;if(p.exec(f))return"electron-crash-reporter";if($.exec(f))return"winpty-agent";if(d.exec(f))return"conpty-agent";let E=h.exec(f);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?v.exec(f)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const c=/[a-zA-Z-]+\.js/g;let i="";do E=c.exec(f),E&&(i+=E+" ");while(E);return i&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${i})`:w.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substring(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substring(5):v;new Promise((v,w)=>{Q(["@vscode/windows-process-tree"],v,w)}).then(v=>{v.getProcessList(C,w=>{if(!w){u(new Error(`Root process ${C} not found`));return}v.getProcessCpuUsage(w,p=>{const $=new Map;p.forEach(d=>{const h=f(d.commandLine||"");$.set(d.pid,{name:y(h),cmd:h,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),a=$.get(C),a?($.forEach(d=>{const h=$.get(d.ppid);h&&(h.children||(h.children=[]),h.children.push(d))}),$.forEach(d=>{d.children&&(d.children=d.children.sort((h,E)=>h.pid-E.pid))}),S(a)):u(new Error(`Root process ${C} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{let f=function(){let v=[a];const w=[];for(;v.length;){const $=v.shift();$&&(w.push($.pid),$.children&&(v=v.concat($.children)))}let p=JSON.stringify(D.$cg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+w.join(" "),(0,P.exec)(p,{},($,d,h)=>{if($||h)u($||new Error(h.toString()));else{const E=d.toString().split(`
`);for(let c=0;c<w.length;c++){const i=m.get(w[c]);i.load=parseFloat(E[c])}if(!a){u(new Error(`Root process ${C} not found`));return}S(a)}})};(0,P.exec)("which ps",{},(v,w,p)=>{if(v||p)if(process.platform!=="linux")u(v||new Error(p.toString()));else{const $=JSON.stringify(D.$cg.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)($,{},(d,h,E)=>{d||E?u(d||new Error(E.toString())):(M(h,b),f())})}else{const $=w.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${$} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,E,c)=>{h||c&&!c.includes("screen size is bogus")?u(h||new Error(c.toString())):(M(E,b),process.platform==="linux"?f():a?S(a):u(new Error(`Root process ${C} not found`)))})}})}})}e.$Fr=s;function M(C,S){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=C.toString().split(`
`);for(const m of a){const b=u.exec(m.trim());b&&b.length===6&&S(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(ne[108],se([0,1,28,4,106,89]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=void 0;async function C(b,y){return b===1?D.$j?m():M.$Bl(y):u(b,y)}e.$Dl=C;let S=null;function u(b,y){if(D.$l&&b===2||D.$k&&b===3)return"/bin/bash";if(!S){let f;if(D.$j)f="/bin/bash";else{if(f=y.SHELL,!f)try{f=(0,P.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}S=f}return S}let a=null;async function m(){return a||(a=(await(0,s.$yl)()).exePath),a}});var ve=this&&this.__decorate||function(Q,e,P,D){var s=arguments.length,M=s<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,P):D,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(Q,e,P,D);else for(var S=Q.length-1;S>=0;S--)(C=Q[S])&&(M=(s<3?C(M):s>3?C(e,P,M):C(e,P))||M);return s>3&&M&&Object.defineProperty(e,P,M),M};define(ne[42],se([0,1,23,8,17,22,55,14,3,2,77,27,12]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.ProxyChannel=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.RequestInitiator=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;var f;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(f||(f={}));function v(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(w||(w={}));function p(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})($||($={}));function d(G){let z=0;for(let W=0;;W+=7){const V=G.read(1);if(z|=(V.buffer[0]&127)<<W,!(V.buffer[0]&128))return z}}const h=r(0);function E(G,z){if(z===0){G.write(h);return}let W=0;for(let q=z;q!==0;q=q>>>7)W++;const V=s.$be.alloc(W);for(let q=0;z!==0;q++)V.buffer[q]=z&127,z=z>>>7,z>0&&(V.buffer[q]|=128);G.write(V)}class c{constructor(z){this.b=z,this.a=0}read(z){const W=this.b.slice(this.a,this.a+z);return this.a+=W.byteLength,W}}e.$nh=c;class i{constructor(){this.a=[]}get buffer(){return s.$be.concat(this.a)}write(z){this.a.push(z)}}e.$oh=i;var o;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(o||(o={}));function r(G){const z=s.$be.alloc(1);return z.writeUInt8(G,0),z}const t={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function l(G,z){if(typeof z>"u")G.write(t.Undefined);else if(typeof z=="string"){const W=s.$be.fromString(z);G.write(t.String),E(G,W.byteLength),G.write(W)}else if(n&&Buffer.isBuffer(z)){const W=s.$be.wrap(z);G.write(t.Buffer),E(G,W.byteLength),G.write(W)}else if(z instanceof s.$be)G.write(t.VSBuffer),E(G,z.byteLength),G.write(z);else if(Array.isArray(z)){G.write(t.Array),E(G,z.length);for(const W of z)l(G,W)}else if(typeof z=="number"&&(z|0)===z)G.write(t.Uint),E(G,z);else{const W=s.$be.fromString(JSON.stringify(z));G.write(t.Object),E(G,W.byteLength),G.write(W)}}e.$ph=l;function g(G){switch(G.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return G.read(d(G)).toString();case o.Buffer:return G.read(d(G)).buffer;case o.VSBuffer:return G.read(d(G));case o.Array:{const W=d(G),V=[];for(let q=0;q<W;q++)V.push(g(G));return V}case o.Object:return JSON.parse(G.read(d(G)).toString());case o.Int:return d(G)}}e.$qh=g;class A{constructor(z,W,V=null,q=1e3){this.h=z,this.j=W,this.k=V,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(z,W){this.b.set(z,W),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case 200:{const W=this.o([z.type]);this.k?.logOutgoing(W,0,1,p(z.type));return}case 201:case 202:case 204:case 203:{const W=this.o([z.type,z.id],z.data);this.k?.logOutgoing(W,z.id,1,p(z.type),z.data);return}}}o(z,W=void 0){const V=new i;return l(V,z),l(V,W),this.p(V.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const W=new c(z),V=g(W),q=g(W),Y=V[0];switch(Y){case 100:return this.k?.logIncoming(z.byteLength,V[1],1,`${v(Y)}: ${V[2]}.${V[3]}`,q),this.s({type:Y,id:V[1],channelName:V[2],name:V[3],arg:q});case 102:return this.k?.logIncoming(z.byteLength,V[1],1,`${v(Y)}: ${V[2]}.${V[3]}`,q),this.t({type:Y,id:V[1],channelName:V[2],name:V[3],arg:q});case 101:return this.k?.logIncoming(z.byteLength,V[1],1,`${v(Y)}`),this.u({type:Y,id:V[1]});case 103:return this.k?.logIncoming(z.byteLength,V[1],1,`${v(Y)}`),this.u({type:Y,id:V[1]})}}s(z){const W=this.b.get(z.channelName);if(!W){this.v(z);return}const V=new M.$Xd;let q;try{q=W.call(this.j,z.name,z.arg,V.token)}catch(J){q=Promise.reject(J)}const Y=z.id;q.then(J=>{this.m({id:Y,data:J,type:201})},J=>{J instanceof Error?this.m({id:Y,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.m({id:Y,data:J,type:203})}).finally(()=>{oe.dispose(),this.d.delete(z.id)});const oe=(0,a.$Pc)(()=>V.cancel());this.d.set(z.id,oe)}t(z){const W=this.b.get(z.channelName);if(!W){this.v(z);return}const V=z.id,Y=W.listen(this.j,z.name,z.arg)(oe=>this.m({id:V,data:oe,type:204}));this.d.set(z.id,Y)}u(z){const W=this.d.get(z.id);W&&(W.dispose(),this.d.delete(z.id))}v(z){let W=this.g.get(z.channelName);W||(W=[],this.g.set(z.channelName,W));const V=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:z,timeoutTimer:V})}w(z){const W=this.g.get(z);if(W){for(const V of W)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.s(V.request);break;case 102:this.t(V.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Mc)(this.d.values()),this.d.clear()}}e.$rh=A;var R;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class k{constructor(z,W=null){this.l=z,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=W}getChannel(z){const W=this;return{call(V,q,Y){return W.a?Promise.reject(new S.$4):W.m(z,V,q,Y)},listen(V,q){return W.a?u.Event.None:W.o(z,V,q)}}}m(z,W,V,q=M.CancellationToken.None){const Y=this.g++,J={id:Y,type:100,channelName:z,name:W,arg:V};if(q.isCancellationRequested)return Promise.reject(new S.$4);let O;return new Promise((F,U)=>{if(q.isCancellationRequested)return U(new S.$4);const H=()=>{const de=ue=>{switch(ue.type){case 201:this.f.delete(Y),F(ue.data);break;case 202:{this.f.delete(Y);const be=new Error(ue.data.message);be.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,be.name=ue.data.name,U(be);break}case 203:this.f.delete(Y),U(ue.data);break}};this.f.set(Y,de),this.p(J)};let B=null;this.b===$.Idle?H():(B=(0,D.$Hg)(de=>this.u()),B.then(()=>{B=null,H()}));const ie=()=>{B?(B.cancel(),B=null):this.p({id:Y,type:101}),U(new S.$4)},fe=q.onCancellationRequested(ie);O=(0,a.$Oc)((0,a.$Pc)(ie),fe),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(z,W,V){const q=this.g++,oe={id:q,type:102,channelName:z,name:W,arg:V};let J=null;const O=new u.$Nd({onWillAddFirstListener:()=>{J=(0,D.$Hg)(F=>this.u()),J.then(()=>{J=null,this.d.add(O),this.p(oe)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(O),this.p({id:q,type:103}))}}),j=F=>O.fire(F.data);return this.f.set(q,j),O.event}p(z){switch(z.type){case 100:case 102:{const W=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(W,z.id,0,`${v(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const W=this.q([z.type,z.id]);this.j?.logOutgoing(W,z.id,0,v(z.type));return}}}q(z,W=void 0){const V=new i;return l(V,z),l(V,W),this.r(V.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const W=new c(z),V=g(W),q=g(W),Y=V[0];switch(Y){case 200:return this.j?.logIncoming(z.byteLength,0,0,p(Y)),this.t({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(z.byteLength,V[1],0,p(Y),q),this.t({type:V[0],id:V[1],data:q})}}t(z){if(z.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Mc)(this.d.values()),this.d.clear()}}e.$sh=k,ve([C.$hh],k.prototype,"onDidInitializePromise",null);class I{get connections(){const z=[];return this.f.forEach(W=>z.push(W)),z}constructor(z){this.a=new Map,this.f=new Set,this.g=new u.$Nd,this.onDidAddConnection=this.g.event,this.h=new u.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new a.$Qc,this.j.add(z(({protocol:W,onDidClientDisconnect:V})=>{const q=u.Event.once(W.onMessage);this.j.add(q(Y=>{const oe=new c(Y),J=g(oe),O=new A(W,J),j=new k(W);this.a.forEach((U,H)=>O.registerChannel(H,U));const F={channelServer:O,channelClient:j,ctx:J};this.f.add(F),this.g.fire(F),this.j.add(V(()=>{O.dispose(),j.dispose(),this.f.delete(F),this.h.fire(F)}))}))}))}getChannel(z,W){const V=this;return{call(q,Y,oe){let J;if((0,y.$Mf)(W)){const j=(0,P.$3b)(V.connections.filter(W));J=j?Promise.resolve(j):u.Event.toPromise(u.Event.filter(V.onDidAddConnection,W))}else J=W.routeCall(V,q,Y);const O=J.then(j=>j.channelClient.getChannel(z));return N(O).call(q,Y,oe)},listen(q,Y){if((0,y.$Mf)(W))return V.k(z,W,q,Y);const oe=W.routeEvent(V,q,Y).then(J=>J.channelClient.getChannel(z));return N(oe).listen(q,Y)}}}k(z,W,V,q){const Y=this;let oe;const J=new u.$Nd({onWillAddFirstListener:()=>{oe=new a.$Qc;const O=new u.$Td,j=new Map,F=H=>{const ie=H.channelClient.getChannel(z).listen(V,q),fe=O.add(ie);j.set(H,fe)},U=H=>{const B=j.get(H);B&&(B.dispose(),j.delete(H))};Y.connections.filter(W).forEach(F),u.Event.filter(Y.onDidAddConnection,W)(F,void 0,oe),Y.onDidRemoveConnection(U,void 0,oe),O.event(J.fire,J,oe),oe.add(O)},onDidRemoveLastListener:()=>{oe?.dispose(),oe=void 0}});return J.event}registerChannel(z,W){this.a.set(z,W);for(const V of this.f)V.channelServer.registerChannel(z,W)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$th=I;class L{constructor(z,W,V=null){const q=new i;l(q,W),z.send(q.buffer),this.a=new k(z,V),this.d=new A(z,W,V)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,W){this.d.registerChannel(z,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$uh=L;function N(G){return{call(z,W,V){return G.then(q=>q.call(z,W,V))},listen(z,W){const V=new u.$Wd;return G.then(q=>V.input=q.listen(z,W)),V.event}}}e.$vh=N;function T(G){let z=!1;return{call(W,V,q){return z?G.call(W,V,q):(0,D.$Ug)(0).then(()=>z=!0).then(()=>G.call(W,V,q))},listen(W,V){if(z)return G.listen(W,V);const q=new u.$Wd;return(0,D.$Ug)(0).then(()=>z=!0).then(()=>q.input=G.listen(W,V)),q.event}}}e.$wh=T;class x{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const W of z.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await u.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$xh=x;var X;(function(G){function z(Y,oe,J){const O=Y,j=J&&J.disableMarshalling,F=new Map;for(const U in O)V(U)&&F.set(U,u.Event.buffer(O[U],!0,void 0,oe));return new class{listen(U,H,B){const ie=F.get(H);if(ie)return ie;if(q(H)){const fe=O[H];if(typeof fe=="function")return fe.call(O,B)}throw new S.$ab(`Event not found: ${H}`)}call(U,H,B){const ie=O[H];if(typeof ie=="function"){if(!j&&Array.isArray(B))for(let de=0;de<B.length;de++)B[de]=(0,m.$mh)(B[de]);let fe=ie.apply(O,B);return fe instanceof Promise||(fe=Promise.resolve(fe)),fe}throw new S.$ab(`Method not found: ${H}`)}}}G.fromService=z;function W(Y,oe){const J=oe&&oe.disableMarshalling;return new Proxy({},{get(O,j){if(typeof j=="string")return oe?.properties?.has(j)?oe.properties.get(j):q(j)?function(F){return Y.listen(j,F)}:V(j)?Y.listen(j):async function(...F){let U;oe&&!(0,y.$Hf)(oe.context)?U=[oe.context,...F]:U=F;const H=await Y.call(j,U);return J?H:(0,m.$mh)(H)};throw new S.$ab(`Property not found: ${String(j)}`)}})}G.toService=W;function V(Y){return Y[0]==="o"&&Y[1]==="n"&&b.$1e(Y.charCodeAt(2))}function q(Y){return/^onDynamic/.test(Y)&&b.$1e(Y.charCodeAt(9))}})(X||(e.ProxyChannel=X={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const z=G.toString();if(z!=="[object Object]")return z}return G}function ae(G){return Array.isArray(G)?G.map(re):re(G)}function Z(G,z,W,V,q,Y,oe){oe=ae(oe);const J=ce[q],O=J[V%J.length];let j=[`%c[${G}]%c[${String(z).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(Y)?(j=j.concat(oe),j.push(")")):j.push(oe),console.log.apply(console,j)}class K{constructor(z,W){this.d=z,this.f=W,this.a=0,this.b=0}logOutgoing(z,W,V,q,Y){this.b+=z,Z(this.d,this.b,z,W,V,q,Y)}logIncoming(z,W,V,q,Y){this.a+=z,Z(this.f,this.a,z,W,V,q,Y)}}e.$yh=K}),define(ne[157],se([0,1,17,3,42]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CT=e.$BT=void 0;class M{constructor(u){this.a=u,this.onMessage=D.Event.fromDOMEventEmitter(this.a,"message",a=>P.$be.wrap(a.data)),u.start()}send(u){this.a.postMessage(u.buffer)}disconnect(){this.a.close()}}e.$BT=M;class C extends s.$uh{constructor(u,a){const m=new M(u);super(m,a),this.b=m}dispose(){this.b.disconnect(),super.dispose()}}e.$CT=C}),define(ne[109],se([0,1,17,3,2,42]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.ProtocolConstants=e.$zh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var S;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let l=0;function g(R,k){if(!n.has(R)){const I=String(++l);n.set(R,I)}return n.get(R)}function A(R,k,I,L){if(!t.enableDiagnostics)return;const N=g(R,k);if(L instanceof P.$be||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const T=P.$be.alloc(L.byteLength);T.set(L),t.records.push({timestamp:Date.now(),id:N,label:k,type:I,buff:T})}else t.records.push({timestamp:Date.now(),id:N,label:k,type:I,data:L})}t.traceSocketEvent=A})(S||(e.SocketDiagnostics=S={}));var u;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u||(e.SocketCloseEventType=u={}));let a=null;function m(){return a||(a=P.$be.alloc(0)),a}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,l){if(n===0)return m();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return l&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return l&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const g=P.$be.alloc(n);let A=0,R=0;for(;n>0;){const k=this.a[R];if(k.byteLength>n){const I=k.slice(0,n);g.set(I,A),A+=n,l&&(this.a[R]=k.slice(n),this.b-=n),n-=n}else g.set(k,A),A+=k.byteLength,l?(this.a.shift(),this.b-=k.byteLength):R++,n-=k.byteLength}return g}}e.$zh=b;var y;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(y||(y={}));function f(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class w{constructor(n,l,g,A){this.type=n,this.id=l,this.ack=g,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends s.$Rc{constructor(n){super(),this.f=this.B(new D.$Nd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new b,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const g=this.g.messageType,A=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new w(g,A,R,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=P.$be.alloc(13);l.writeUInt8(n.type,0),l.writeUInt32BE(n.id,1),l.writeUInt32BE(n.ack,5),l.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(l,n.data)}g(n,l){const g=this.f===0;return this.d.push(n,l),this.f+=n.byteLength+l.byteLength,g}h(){const n=P.$be.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,l){this.g(n,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class d extends s.$Rc{constructor(n){super(),this.f=new D.$Nd,this.onMessage=this.f.event,this.g=new D.$Nd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new $(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new w(1,0,0,n))}}e.$Ah=d;class h extends M.$uh{static fromSocket(n,l){return new h(new d(n),l)}get onDidDispose(){return this.b.onDidDispose}constructor(n,l,g=null){super(n,l,g),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Bh=h;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new D.$Nd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Ch=E;class c{constructor(n){this.data=n,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let n=0,l=this.a;for(;l;)l=l.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let l=0,g=this.a;for(;g;)n[l++]=g.data,g=g.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const l=new c(n);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const n=Date.now();for(let l=0;l<o.a;l++)this.c[l]=n-1e3*l;setInterval(()=>{for(let l=o.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),l=(1+o.a)*1e3;let g=0;for(let A=0;A<o.a;A++)n-this.c[A]<=l&&g++;return 1-g/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??o.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Qc,this.o=n.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new w(5,0,0,m());this.p.write(n),this.p.flush()}sendPause(){const n=new w(7,0,0,m());this.p.write(n)}sendResume(){const n=new w(8,0,0,m());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,l){this.a=!0,this.r.dispose(),this.r=new s.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new w(3,0,this.h,m());this.p.write(n);const l=this.b.toArray();for(let g=0,A=l.length;g<A;g++)this.p.write(l[g]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const l=this.b.peek();if(l&&l.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new w(6,0,0,m())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let g=0,A=l.length;g<A;g++)this.p.write(l[g]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const l=++this.c;this.h=this.g;const g=new w(1,l,this.h,n);this.b.push(g),this.a||(this.p.write(g),this.B())}sendControl(n){const l=new w(2,0,0,n);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),l=Date.now()-n.writtenTime,g=Date.now()-this.q.lastReadTime,A=Date.now()-this.n;if(l>=2e4&&g>=2e4&&A>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:g});return}const R=Math.max(2e4-l,2e4-g,2e4-A,500);this.f=setTimeout(()=>{this.f=null,this.B()},R)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new w(3,0,this.h,m());this.p.write(n)}D(){this.h=this.g;const n=new w(9,0,this.h,m());this.p.write(n)}}e.$Dh=r}),define(ne[36],se([0,1,15,14,13]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yT=void 0;class M{constructor(){this.a=new WeakMap}on(S,u){const a=(m,...b)=>{this.b(S,m)&&u(m,...b)};return this.a.set(u,a),P.ipcMain.on(S,a),this}once(S,u){return P.ipcMain.once(S,(a,...m)=>{this.b(S,a)&&u(a,...m)}),this}handle(S,u){return P.ipcMain.handle(S,(a,...m)=>this.b(S,a)?u(a,...m):Promise.reject(`Invalid channel '${S}' or sender for ipcMain.handle() usage.`)),this}removeHandler(S){return P.ipcMain.removeHandler(S),this}removeListener(S,u){const a=this.a.get(u);return a&&(P.ipcMain.removeListener(S,a),this.a.delete(u)),this}b(S,u){if(!S||!S.startsWith("vscode:"))return(0,D.$Z)(`Refused to handle ipcMain event for channel '${S}' because the channel is unknown.`),!1;const a=u.senderFrame,m=a.url;if(!m||m==="about:blank")return!0;let b="unknown";try{b=new URL(m).host}catch{return(0,D.$Z)(`Refused to handle ipcMain event for channel '${S}' because of a malformed URL '${m}'.`),!1}return b!==s.$bg?((0,D.$Z)(`Refused to handle ipcMain event for channel '${S}' because of a bad origin of '${b}'.`),!1):a.parent!==null?((0,D.$Z)(`Refused to handle ipcMain event for channel '${S}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.$yT=new M}),define(ne[158],se([0,1,15,36,146]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zT=void 0;function M(){D.$yT.on(s.$wT,(S,u,a,m,b)=>{const y=C(S,m,a);y.popup({x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{y&&S.sender.send(s.$xT,u)}})})}e.$zT=M;function C(S,u,a){const m=new P.Menu;return a.forEach(b=>{let y;b.type==="separator"?y=new P.MenuItem({type:b.type}):Array.isArray(b.submenu)?y=new P.MenuItem({submenu:C(S,u,b.submenu),label:b.label}):y=new P.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(f,v,w)=>S.sender.send(u,b.id,w)}),m.append(y)}),m}}),define(ne[159],se([0,1,36,17,3,2,42,147]),function(Q,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FT=void 0;function u(m,b){const y=s.Event.fromNodeEventEmitter(P.$yT,b,(v,w)=>({event:v,message:w})),f=s.Event.filter(y,({event:v})=>v.sender.id===m);return s.Event.map(f,({message:v})=>v&&D.$be.wrap(v))}class a extends C.$th{static{this.b=new Map}static d(){const b=s.Event.fromNodeEventEmitter(P.$yT,"vscode:hello",({sender:y})=>y);return s.Event.map(b,y=>{const f=y.id;a.b.get(f)?.dispose();const w=new s.$Nd;a.b.set(f,(0,M.$Pc)(()=>w.fire()));const p=u(f,"vscode:message"),$=s.Event.any(s.Event.signal(u(f,"vscode:disconnect")),w.event);return{protocol:new S.$ET(y,p),onDidClientDisconnect:$}})}constructor(){super(a.d())}}e.$FT=a}),define(ne[110],se([0,1,36,3,32,157]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HT=e.$GT=void 0;class C extends M.$CT{constructor(a,m){super({addEventListener:(b,y)=>a.addListener(b,y),removeEventListener:(b,y)=>a.removeListener(b,y),postMessage:b=>a.postMessage(b),start:()=>a.start(),close:()=>a.close()},m)}}e.$GT=C;async function S(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,s.$eg)();u.webContents.send("vscode:createMessageChannel",a);const m=D.Event.fromNodeEventEmitter(P.$yT,"vscode:createMessageChannelResult",(y,f)=>({nonce:f,port:y.ports[0]})),{port:b}=await D.Event.toPromise(D.Event.once(D.Event.filter(m,y=>y.nonce===a)));return b}e.$HT=S}),define(ne[160],se([0,1,47,8,17,22,154,14,3,2,38,89,76,42]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;class v extends f.$rh{constructor($){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",d=>s.$be.wrap(Buffer.from(d,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$5p=v;class w{constructor($,d){this.i=$,this.j=d,this.c=new Set,this.g=new Map,this.h=new u.$Nd,this.onDidProcessExit=this.h.event;const h=d&&d.timeout?d.timeout:6e4;this.b=new D.$Qg(h),this.d=null,this.f=null}getChannel($){const d=this;return{call(h,E,c){return d.k($,h,E,c)},listen(h,E){return d.l($,h,E)}}}k($,d,h,E=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(S.$5());this.b.cancel();const c=this.n($),i=(0,D.$Hg)(t=>c.call(d,h,t)),o=E.onCancellationRequested(()=>i.cancel()),r=(0,a.$Pc)(()=>i.cancel());return this.c.add(r),i.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l($,d,h){if(!this.b)return u.Event.None;this.b.cancel();let E;const c=new u.$Nd({onWillAddFirstListener:()=>{E=this.n($).listen(d,h)(c.fire,c),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,m.$7m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,y.$Al)(d.env),this.d=(0,P.fork)(this.i,$,d);const h=new u.$Nd;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,C.$1p)(n)){(0,C.log)(n,`IPC Library: ${this.j.serverName}`);return}h.fire(s.$be.wrap(Buffer.from(n,"base64")))});const c=this.j.useQueue?(0,b.$Cl)(this.d):this.d,i=n=>this.d&&this.d.connected&&c.send(n.buffer.toString("base64")),o=h.event,r={send:i,onMessage:o};this.f=new f.$sh(r);const t=()=>this.o();process.once("exit",t),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,l)=>{process.removeListener("exit",t),this.c.forEach(g=>(0,a.$Mc)(g)),this.c.clear(),n!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:l})})}return this.f}n($){let d=this.g.get($);return d||(d=this.m.getChannel($),this.g.set($,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$6p=w}),define(ne[111],se([0,1,8,3,2,77,12]),function(Q,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.StorageState=e.$4o=e.StorageHint=void 0;var S;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function u(y){const f=y;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$4o=u;var a;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(a||(e.StorageState=a={}));class m extends s.$Rc{static{this.a=100}constructor(f,v=Object.create(null)){super(),this.r=f,this.s=v,this.b=this.B(new D.$Qd),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new P.$Rg(m.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((v,w)=>this.w(w,v)),f.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(f,v){if(this.c===a.Closed)return;let w=!1;(0,C.$Hf)(v)?w=this.f.delete(f):this.f.get(f)!==v&&(this.f.set(f,v),w=!0),w&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,v){const w=this.f.get(f);return(0,C.$Hf)(w)?v:w}getBoolean(f,v){const w=this.get(f);return(0,C.$Hf)(w)?v:w==="true"}getNumber(f,v){const w=this.get(f);return(0,C.$Hf)(w)?v:parseInt(w,10)}getObject(f,v){const w=this.get(f);return(0,C.$Hf)(w)?v:(0,M.$lh)(w)}async set(f,v,w=!1){if(this.c===a.Closed)return;if((0,C.$Hf)(v))return this.delete(f,w);const p=(0,C.$Af)(v)||Array.isArray(v)?(0,M.$kh)(v):String(v);if(this.f.get(f)!==p)return this.f.set(f,p),this.j.set(f,p),this.h.delete(f),this.b.fire({key:f,external:w}),this.D()}async delete(f,v=!1){if(!(this.c===a.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:v}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$5o=m;class b{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((v,w)=>this.a.set(w,v)),f.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$6o=b}),define(ne[161],se([0,1,8,3,31,9,21]),function(Q,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4T=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return D.Event.None}static{this.a=2e3}static{this.b=256}constructor(m,b=Object.create(null)){this.g=m,this.h=b,this.c=(0,M.$mc)(this.g),this.d=new u(this.h.logging),this.f=this.n(this.g)}async getItems(){const m=await this.f,b=new Map;return(await this.s(m,"SELECT * FROM ItemTable")).forEach(f=>b.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${b.size} rows`),b}async updateItems(m){const b=await this.f;return this.j(b,m)}j(m,b){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${b.insert?(0,s.$xc)(b.insert):"0"}), delete(${b.delete?(0,s.$yc)(b.delete):"0"})`),this.t(m,()=>{const y=b.insert,f=b.delete;if(y&&y.size>0){const v=[];v.push([]);let w=0;y.forEach((p,$)=>{let d=v[w];d.length>S.b&&(w++,d=[],v.push(d)),d.push($,p)}),v.forEach(p=>{this.u(m,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,$=>$.run(p),()=>{const $=[];let d=0;return y.forEach((h,E)=>{$.push(E),d+=h.length}),`Keys: ${$.join(", ")} Length: ${d}`})})}if(f&&f.size){const v=[];v.push([]);let w=0;f.forEach(p=>{let $=v[w];$.length>S.b&&(w++,$=[],v.push($)),$.push(p)}),v.forEach(p=>{this.u(m,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,$=>$.run(p),()=>{const $=[];return f.forEach(d=>{$.push(d)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const m=await this.f;return this.q(m,"VACUUM")}async close(m){this.d.trace(`[storage ${this.c}] close()`);const b=await this.f;return this.k(b,m)}k(m,b){return new Promise((y,f)=>{m.db.close(v=>(v&&this.o(m,`[storage ${this.c}] close(): ${v}`),this.g===S.IN_MEMORY_PATH?y():!m.isErroneous&&!m.isInMemory?this.l().then(y,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),y())):typeof b=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const p=()=>this.k(w,void 0);return this.j(w,{insert:b()}).then(()=>p(),$=>(p(),Promise.reject($)))})).then(y,f):f(v||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const m=this.m(this.g);return C.Promises.copy(this.g,m,{preserveSymlinks:!1})}m(m){return`${m}.backup`}async checkIntegrity(m){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${m})`);const b=await this.f,y=await this.r(b,m?"PRAGMA integrity_check":"PRAGMA quick_check"),f=m?y.integrity_check:y.quick_check;return b.isErroneous?`${f} (last error: ${b.lastError})`:b.isInMemory?`${f} (in-memory!)`:f}async n(m,b=!0){this.d.trace(`[storage ${this.c}] open(${m}, retryOnBusy: ${b})`);try{return await this.p(m)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&b)return await(0,P.$Ug)(S.a),this.n(m,!1);try{await C.Promises.unlink(m);try{await C.Promises.rename(this.m(m),m,!1)}catch{}return await this.p(m)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(S.IN_MEMORY_PATH)}}}o(m,b){m.isErroneous=!0,m.lastError=b,this.d.error(b)}p(m){return new Promise((b,y)=>{new Promise((f,v)=>{Q(["@vscode/sqlite3"],f,v)}).then(f=>{const v={db:new(this.d.isTracing?f.verbose().Database:f.Database)(m,w=>w?v.db&&w.code!=="SQLITE_CANTOPEN"?v.db.close(()=>y(w)):y(w):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(v),p=>v.db.close(()=>y(p)))),isInMemory:m===S.IN_MEMORY_PATH};v.db.on("error",w=>this.o(v,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&v.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},y)})}q(m,b){return new Promise((y,f)=>{m.db.exec(b,v=>v?(this.o(m,`[storage ${this.c}] exec(): ${v}`),f(v)):y())})}r(m,b){return new Promise((y,f)=>{m.db.get(b,(v,w)=>v?(this.o(m,`[storage ${this.c}] get(): ${v}`),f(v)):y(w))})}s(m,b){return new Promise((y,f)=>{m.db.all(b,(v,w)=>v?(this.o(m,`[storage ${this.c}] all(): ${v}`),f(v)):y(w))})}t(m,b){return new Promise((y,f)=>{m.db.serialize(()=>{m.db.run("BEGIN TRANSACTION"),b(),m.db.run("END TRANSACTION",v=>v?(this.o(m,`[storage ${this.c}] transaction(): ${v}`),f(v)):y())})})}u(m,b,y,f){const v=m.db.prepare(b),w=p=>{this.o(m,`[storage ${this.c}] prepare(): ${p} (${b}). Details: ${f()}`)};v.on("error",w),y(v),v.finalize(p=>{p&&w(p),v.removeListener("error",w)})}}e.$4T=S;class u{static{this.a="VSCODE_TRACE_STORAGE"}constructor(m){m&&typeof m.logTrace=="function"&&process.env[u.a]&&(this.b=m.logTrace),m&&typeof m.logError=="function"&&(this.c=m.logError)}get isTracing(){return!!this.b}trace(m){this.b?.(m)}error(m){this.c?.(m)}}}),define(ne[162],se([11,10]),function(Q,e){return Q.create("vs/code/electron-main/app",e)}),define(ne[163],se([11,10]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[164],se([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[165],se([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/scanner",e)}),define(ne[166],se([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/common/dialogs",e)}),define(ne[167],se([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ne[168],se([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(ne[169],se([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(ne[170],se([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[171],se([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[172],se([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[173],se([11,10]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[174],se([11,10]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ne[175],se([11,10]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(ne[176],se([11,10]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ne[177],se([11,10]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(ne[178],se([11,10]),function(Q,e){return Q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ne[179],se([11,10]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[180],se([11,10]),function(Q,e){return Q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ne[181],se([11,10]),function(Q,e){return Q.create("vs/platform/menubar/electron-main/menubar",e)}),define(ne[182],se([11,10]),function(Q,e){return Q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ne[183],se([11,10]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(ne[184],se([11,10]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(ne[185],se([11,10]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[186],se([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[187],se([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[188],se([11,10]),function(Q,e){return Q.create("vs/platform/update/common/update.config.contribution",e)}),define(ne[189],se([11,10]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[190],se([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ne[191],se([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ne[192],se([11,10]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(ne[193],se([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ne[194],se([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ne[195],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UU=e.$TU=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.$TU=P;function D(s){return s&&s.hasOwnProperty("workspace")}e.$UU=D}),define(ne[196],se([0,1,7]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$26b=e.$16b=e.$Z6b=void 0;function D(C){return typeof C?.backupFolder=="string"}e.$Z6b=D;function s(C){let S=[];try{Array.isArray(C.workspaces)&&(S=C.workspaces.map(u=>({workspace:{id:u.id,configPath:P.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}return S}e.$16b=s;function M(C){let S=[];try{Array.isArray(C.folders)&&(S=C.folders.map(u=>({folderUri:P.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})))}catch{}return S}e.$26b=M}),define(ne[197],se([0,1,14,165]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var s;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...a){switch(a.length){case 1:return(0,D.localize)(0,null,a[0]);case 2:return(0,D.localize)(1,null,a[0],a[1]);case 3:return(0,D.localize)(2,null,a[0],a[1],a[2]);default:return}}const C=(0,D.localize)(3,null),S=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return m.isTripleEq?"===":"==";case 4:return m.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return m.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return m.lexeme;case 18:return m.lexeme;case 19:return m.lexeme;case 20:return"EOF";default:throw(0,P.$7)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(m){return this.c=m,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(m){return this.r()||this.c.charCodeAt(this.e)!==m?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(m){this.f.push({type:m,offset:this.d})}l(m){const b=this.d,y=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:y};this.g.push({offset:b,lexeme:y,additionalInfo:m}),this.f.push(f)}n(){this.m.lastIndex=this.d;const m=this.m.exec(this.c);if(m){this.e=this.d+m[0].length;const b=this.c.substring(this.d,this.e),y=u.b.get(b);y?this.k(y):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let m=this.e,b=!1,y=!1;for(;;){if(m>=this.c.length){this.e=m,this.l(S);return}const v=this.c.charCodeAt(m);if(b)b=!1;else if(v===47&&!y){m++;break}else v===91?y=!0:v===92?b=!0:v===93&&(y=!1);m++}for(;m<this.c.length&&u.a.has(this.c.charCodeAt(m));)m++;this.e=m;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=u}),define(ne[198],se([0,1,3,2]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=void 0;class s{constructor(){this.a=new P.$Nd,this.b=new P.$Nd,this.c=new P.$Nd,this.d=new P.$Nd}static{this.ChannelName="extensionhostdebugservice"}call(S,u,a){switch(u){case"close":return Promise.resolve(this.a.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(S,u,a){switch(u){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Pn=s;class M extends D.$Rc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,u,a){this.b.call("attach",[S,u,a])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,u){this.b.call("terminate",[S,u])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,u){return this.b.call("openExtensionDevelopmentHostWindow",[S,u])}}e.$Qn=M}),define(ne[199],se([0,1,149,55,13,9,35,19,7]),function(Q,e,P,D,s,M,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm=/^([^.]+\..+):(.+)$/;class a{get appRoot(){return(0,M.$lc)(s.$cg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,M.$ic)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,S.$vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,P.$em)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$ic)(this.userDataPath,"logs",f)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$vg)(u.URI.file((0,M.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=C.env.VSCODE_PORTABLE;return f?u.URI.file((0,M.$ic)(f,"argv.json")):(0,S.$vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,M.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,M.$jc)(f):(0,M.$gc)((0,M.$ic)(s.$cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?u.URI.file((0,M.$jc)(f)):u.URI.file((0,M.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,M.$jc)(f);const v=C.env.VSCODE_EXTENSIONS;if(v)return v;const w=C.env.VSCODE_PORTABLE;return w?(0,M.$ic)(w,"extensions"):(0,S.$vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(v=>/^[^:/?#]+?:\/\//.test(v)?u.URI.parse(v):u.URI.file((0,M.$gc)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?u.URI.parse(f):u.URI.file((0,M.$gc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$fm.test(f))}get extensionLogLevel(){const f=[];for(const v of this.args.log||[]){const w=e.$fm.exec(v);w&&w[1]&&w[2]&&f.push([w[1],w[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,S.$vg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=C.env.VSCODE_PORTABLE;return f?u.URI.file((0,M.$ic)(f,"policy.json")):(0,S.$vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,v,w){this.a=f,this.b=v,this.c=w,this.editSessionId=this.args.editSessionId}}e.$gm=a,ve([D.$hh],a.prototype,"appRoot",null),ve([D.$hh],a.prototype,"userHome",null),ve([D.$hh],a.prototype,"userDataPath",null),ve([D.$hh],a.prototype,"appSettingsHome",null),ve([D.$hh],a.prototype,"tmpDir",null),ve([D.$hh],a.prototype,"cacheHome",null),ve([D.$hh],a.prototype,"stateResource",null),ve([D.$hh],a.prototype,"userRoamingDataHome",null),ve([D.$hh],a.prototype,"userDataSyncHome",null),ve([D.$hh],a.prototype,"sync",null),ve([D.$hh],a.prototype,"machineSettingsResource",null),ve([D.$hh],a.prototype,"workspaceStorageHome",null),ve([D.$hh],a.prototype,"localHistoryHome",null),ve([D.$hh],a.prototype,"keyboardLayoutResource",null),ve([D.$hh],a.prototype,"argvResource",null),ve([D.$hh],a.prototype,"isExtensionDevelopment",null),ve([D.$hh],a.prototype,"untitledWorkspacesHome",null),ve([D.$hh],a.prototype,"builtinExtensionsPath",null),ve([D.$hh],a.prototype,"extensionsPath",null),ve([D.$hh],a.prototype,"extensionDevelopmentLocationURI",null),ve([D.$hh],a.prototype,"extensionDevelopmentKind",null),ve([D.$hh],a.prototype,"extensionTestsLocationURI",null),ve([D.$hh],a.prototype,"debugExtensionHost",null),ve([D.$hh],a.prototype,"logLevel",null),ve([D.$hh],a.prototype,"extensionLogLevel",null),ve([D.$hh],a.prototype,"serviceMachineIdResource",null),ve([D.$hh],a.prototype,"disableTelemetry",null),ve([D.$hh],a.prototype,"disableWorkspaceTrust",null),ve([D.$hh],a.prototype,"useInMemorySecretStorage",null),ve([D.$hh],a.prototype,"policyFile",null);function m(y,f){return b(y["inspect-extensions"],y["inspect-brk-extensions"],5870,f,y.debugId,y.extensionEnvironment)}e.$hm=m;function b(y,f,v,w,p,$){const h=Number(f||y)||(w?null:v),E=h?!!f:!1;let c;if($)try{c=JSON.parse($)}catch{}return{port:h,break:E,debugId:p,env:c}}e.$im=b}),define(ne[112],se([0,1,309,4,168]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$El=["tunnel","serve-web"],e.$Fl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(w,p,$=C){const d=w.find(l=>l.length>0&&l[0]!=="-"),h={},E=["_"],c=[],i={};let o;for(const l in p){const g=p[l];g.type==="subcommand"?l===d&&(o=g):(g.alias&&(h[l]=g.alias),g.type==="string"||g.type==="string[]"?(E.push(l),g.deprecates&&E.push(...g.deprecates)):g.type==="boolean"&&(c.push(l),g.deprecates&&c.push(...g.deprecates)),g.global&&(i[l]=g))}if(o&&d){const l=i;for(const k in o.options)l[k]=o.options[k];const g=w.filter(k=>k!==d),A=$.getSubcommandReporter?$.getSubcommandReporter(d):void 0,R=S(g,l,A);return{[d]:R,_:[]}}const r=P(w,{string:E,boolean:c,alias:h}),t={},n=r;t._=r._.map(l=>String(l)).filter(l=>l.length>0),delete n._;for(const l in p){const g=p[l];if(g.type==="subcommand")continue;g.alias&&delete n[g.alias];let A=n[l];if(g.deprecates)for(const R of g.deprecates)n.hasOwnProperty(R)&&(A||(A=n[R],A&&$.onDeprecatedOption(R,g.deprecationMessage||(0,s.localize)(37,null,l))),delete n[R]);if(typeof A<"u"){if(g.type==="string[]"){if(Array.isArray(A)||(A=[A]),!g.allowEmptyValue){const R=A.filter(k=>k.length>0);R.length!==A.length&&($.onEmptyValue(l),A=R.length>0?R:void 0)}}else g.type==="string"&&(Array.isArray(A)?(A=A.pop(),$.onMultipleValues(l,A)):!A&&!g.allowEmptyValue&&($.onEmptyValue(l),A=void 0));t[l]=A,g.deprecationMessage&&$.onDeprecatedOption(l,g.deprecationMessage)}delete n[l]}for(const l in n)$.onUnknownOption(l);return t}e.$Gl=S;function u(w,p){let $="";return p.args&&(Array.isArray(p.args)?$=` <${p.args.join("> <")}>`:$=` <${p.args}>`),p.alias?`-${p.alias} --${w}${$}`:`--${w}${$}`}function a(w,p){const $=[];for(const d in w){const h=w[d],E=u(d,h);$.push([E,h.description])}return m($,p)}e.$Hl=a;function m(w,p){const d=w.reduce((c,i)=>Math.max(c,i[0].length),12)+2+1;if(p-d<25)return w.reduce((c,i)=>c.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const h=p-d-1,E=[];for(const c of w){const i=c[0],o=y(c[1],h),r=b(d-i.length-2);E.push("  "+i+r+o[0]);for(let t=1;t<o.length;t++)E.push(b(d)+o[t])}return E}function b(w){return" ".repeat(w)}function y(w,p){const $=[];for(;w.length;){const d=w.length<p?w.length:w.lastIndexOf(" ",p),h=w.slice(0,d).trim();w=w.slice(d),$.push(h)}return $}function f(w,p,$,d,h){const E=process.stdout.isTTY&&process.stdout.columns||80,c=h?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",i=[`${w} ${$}`];i.push(""),i.push(`${(0,s.localize)(39,null)}: ${p} [${(0,s.localize)(40,null)}]${c}`),i.push(""),h?.noPipe!==!0&&(D.$j?i.push((0,s.localize)(41,null,p)):i.push((0,s.localize)(42,null,p)),i.push(""));const o={},r=[];for(const t in d){const n=d[t];if(n.type==="subcommand")n.description&&r.push({command:t,description:n.description});else if(n.description&&n.cat){let l=o[n.cat];l||(o[n.cat]=l={}),l[t]=n}}for(const t in o){const n=t,l=o[n];l&&(i.push(M[n]),i.push(...a(l,E)),i.push(""))}return r.length&&(i.push((0,s.localize)(43,null)),i.push(...m(r.map(t=>[t.command,t.description]),E)),i.push("")),i.join(`
`)}e.$Il=f;function v(w,p){return`${w||(0,s.localize)(44,null)}
${p||(0,s.localize)(45,null)}
${process.arch}`}e.$Jl=v}),define(ne[200],se([0,1,87,198,112]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=void 0;class M extends D.$Pn{constructor(S){super(),this.f=S}call(S,u,a){return u==="openExtensionDevelopmentHostWindow"?this.g(a[0],a[1]):super.call(S,u,a)}async g(S,u){const a=(0,s.$Gl)(S,s.$Fl);a.debugRenderer=u;const m=a.extensionDevelopmentPath;if(!m)return{success:!1};const[b]=await this.f.openExtensionDevelopmentHostWindow(m,{context:5,cli:a,forceProfile:a.profile,forceTempProfile:a["profile-temp"]});if(!u)return{success:!0};const y=b.win;if(!y)return{success:!0};const f=y.webContents.debugger;let v=f.isAttached()?1/0:0;const w=(0,P.createServer)(p=>{v++===0&&f.attach();let $=!1;const d=c=>{$||p.write(JSON.stringify(c)+"\0")},h=(c,i,o,r)=>d({method:i,params:o,sessionId:r});y.on("close",()=>{f.removeListener("message",h),p.end(),$=!0}),f.addListener("message",h);let E=Buffer.alloc(0);p.on("data",c=>{E=Buffer.concat([E,c]);for(let i=E.indexOf(0);i!==-1;i=E.indexOf(0)){let o;try{const r=E.slice(0,i).toString("utf8");E=E.slice(i+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}f.sendCommand(o.method,o.params,o.sessionId).then(r=>d({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>d({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),p.on("error",c=>{console.error("error on cdp pipe:",c)}),p.on("close",()=>{$=!0,--v===0&&f.detach()})});return await new Promise(p=>w.listen(0,p)),y.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.$p7b=M}),define(ne[62],se([0,1,310,169,112]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Ll=e.$Kl=void 0;function M(b,y){const f=(h,E)=>{console.warn((0,D.localize)(0,null,h,E))},v=h=>{console.warn((0,D.localize)(1,null,h))},w=(h,E)=>{console.warn((0,D.localize)(2,null,h,E))},p=h=>({onUnknownOption:E=>{s.$El.includes(h)||console.warn((0,D.localize)(3,null,E,h))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:w,getSubcommandReporter:s.$El.includes(h)?p:void 0}),$={onUnknownOption:h=>{console.warn((0,D.localize)(4,null,h))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:w,getSubcommandReporter:p},d=(0,s.$Gl)(b,s.$Fl,y?$:void 0);return d.goto&&d._.forEach(h=>P(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(h),(0,D.localize)(5,null))),d}function C(b){const y=b.findIndex(f=>!/^-/.test(f));if(y>-1)return[...b.slice(0,y),...b.slice(y+1)]}function S(b){let[,...y]=b;process.env.VSCODE_DEV&&(y=C(y)||[]);const f=!m(process.env);return M(y,f)}e.$Kl=S;function u(b){let[,,...y]=b;return process.env.VSCODE_DEV&&(y=C(y)||[]),M(y,!0)}e.$Ll=u;function a(b,...y){const f=b.indexOf("--");return f===-1?b.push(...y):b.splice(f,0,...y),b}e.$Ml=a;function m(b){return b.VSCODE_CLI==="1"}e.$Nl=m}),function(){"use strict";function Q(e,P,D){function s(C,S){const u=M(C,S),a=[u];return e.isAbsolute(u)||a.unshift(D),e.resolve(...a)}function M(C,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,S);const m=C["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(b,"AppData","Roaming")}break;case"darwin":a=e.join(P.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,S)}return{getUserDataPath:s}}if(typeof define=="function")define(ne[201],se([113,28,35]),function(e,P,D){return Q(e,P,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=Q(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[90],se([0,1,28,199,201]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=e.$jm=void 0;class M extends D.$gm{constructor(a,m){super(a,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(a,m.nameShort)},m)}}e.$jm=M;function C(u,a){return(0,D.$im)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}e.$km=C;function S(u,a){return(0,D.$im)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}e.$lm=S}),define(ne[202],se([0,1,45,28,33]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H8b=void 0;function M(C){const S=(0,s.$6f)((0,D.tmpdir)());try{return(0,P.writeFileSync)(S,""),C&&console.log(`Marker file for --wait created: ${S}`),S}catch(u){C&&console.error(`Failed to create marker file for --wait: ${u}`);return}}e.$H8b=M}),define(ne[203],se([0,1,12,171]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;function s(C,S,u,a){try{M(C,S,u,a)}catch(m){C.error(m?.message??m)}return S}e.$Ap=s;function M(C,S,u,a){const m=(b,y,f)=>{const v=b[y];if((0,P.$yf)(v)){const w=v,p=w.length;if(p>1&&w[0]==="%"&&w[p-1]==="%"){const $=w.substr(1,p-2);let d=u[$];d===void 0&&a&&(d=a[$]);const h=typeof d=="string"?d:d?.message,E=a?.[$],c=typeof E=="string"?E:E?.message;if(!h){c||C.warn(`[${S.name}]: ${(0,D.localize)(0,null,$)}`);return}if(f&&(y==="title"||y==="category")&&c&&c!==h){const i={value:h,original:c};b[y]=i}else b[y]=h}}else if((0,P.$Af)(v))for(const w in v)v.hasOwnProperty(w)&&(w==="commands"?m(v,w,!0):m(v,w,f));else if(Array.isArray(v))for(let w=0;w<v.length;w++)m(v,w,f)};for(const b in S)S.hasOwnProperty(b)&&m(S,b)}}),define(ne[204],se([0,1,19,74,173,205]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function u($){return $=$.trim(),$==="*"||C.test($)}e.$Oo=u;function a($){if(!u($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=$.match(C);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.$Po=a;function m($){if(!$)return null;const d=$.majorBase,h=$.majorMustEqual,E=$.minorBase;let c=$.minorMustEqual;const i=$.patchBase;let o=$.patchMustEqual;$.hasCaret&&(d===0||(c=!1),o=!1);let r=0;if($.preRelease){const t=S.exec($.preRelease);if(t){const[,n,l,g]=t;r=Date.UTC(Number(n),Number(l)-1,Number(g))}}return{majorBase:d,majorMustEqual:h,minorBase:E,minorMustEqual:c,patchBase:i,patchMustEqual:o,isMinimum:$.hasGreaterEquals,notBefore:r}}e.$Qo=m;function b($,d,h){let E;typeof $=="string"?E=m(a($)):E=$;let c;d instanceof Date?c=d.getTime():typeof d=="string"&&(c=new Date(d).getTime());let i;if(typeof h=="string"?i=m(a(h)):i=h,!E||!i)return!1;const o=E.majorBase,r=E.minorBase,t=E.patchBase;let n=i.majorBase,l=i.minorBase,g=i.patchBase;const A=i.notBefore;let R=i.majorMustEqual,k=i.minorMustEqual,I=i.patchMustEqual;return i.isMinimum?o>n?!0:o<n?!1:r>l?!0:r<l||c&&c<A?!1:t>=g:(o===1&&n===0&&(!R||!k||!I)&&(n=1,l=0,g=0,R=!0,k=!1,I=!1),o<n?!1:o>n?!R:r<l?!1:r>l?!k:t<g?!1:t>g?!I:!(c&&c<A))}e.$Ro=b;function y($,d,h,E,c){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([D.default.Error,s.localize(0,null)]),i;if(typeof E.name!="string")return i.push([D.default.Error,s.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([D.default.Error,s.localize(2,null,"version")]),i;if(!E.engines)return i.push([D.default.Error,s.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([D.default.Error,s.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!p(E.extensionDependencies))return i.push([D.default.Error,s.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!p(E.activationEvents))return i.push([D.default.Error,s.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([D.default.Error,s.localize(7,null,"activationEvents","main","browser")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([D.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([D.default.Error,s.localize(9,null,"main")]),i;{const t=(0,P.$vg)(h,E.main);(0,P.$pg)(t,h)||i.push([D.default.Warning,s.localize(10,null,t.path,h.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([D.default.Error,s.localize(11,null,"browser")]),i;{const t=(0,P.$vg)(h,E.browser);(0,P.$pg)(t,h)||i.push([D.default.Warning,s.localize(12,null,t.path,h.path)])}}if(!M.valid(E.version))return i.push([D.default.Error,s.localize(13,null)]),i;const o=[];if(!f($,d,E,c,o))for(const t of o)i.push([D.default.Error,t]);return i}e.$So=y;function f($,d,h,E,c){return E||typeof h.main>"u"&&typeof h.browser>"u"?!0:w($,d,h.engines.vscode,c)}e.$To=f;function v($,d,h){return $==="*"||w(d,h,$)}e.$Uo=v;function w($,d,h,E=[]){const c=m(a(h));if(!c)return E.push(s.localize(14,null,h)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return E.push(s.localize(15,null,h)),!1}else if(!c.majorMustEqual)return E.push(s.localize(16,null,h)),!1;return b($,d,c)?!0:(E.push(s.localize(17,null,$,h)),!1)}function p($){if(!Array.isArray($))return!1;for(let d=0,h=$.length;d<h;d++)if(typeof $[d]!="string")return!1;return!0}}),define(ne[206],se([0,1,17,32]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=void 0;async function s(M,C,S){let u=S&&S.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const m=(await C.readFile(M.serviceMachineIdResource)).value.toString();u=(0,D.$dg)(m)?m:null}catch{u=null}if(!u){u=(0,D.$eg)();try{await C.writeFile(M.serviceMachineIdResource,P.$be.fromString(u))}catch{}}return S?.store("storage.serviceMachineId",u,-1,1),u}e.$cp=s}),define(ne[78],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class P{constructor(s,M=[],C=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=C}}e.$Mh=P}),define(ne[207],se([0,1,78]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=e.InstantiationType=void 0;const D=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(S,u,a){u instanceof P.$Mh||(u=new P.$Mh(u,[],!!a)),D.push([S,u])}e.$zr=M;function C(){return D}e.$Ar=C}),define(ne[208],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;class P{constructor(M,C){this.key=M,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$eq=P;class D{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const C of this.a.values())C.outgoing.size===0&&M.push(C);return M}insertEdge(M,C){const S=this.lookupOrInsertNode(M),u=this.lookupOrInsertNode(C);S.outgoing.set(u.key,u),u.incoming.set(S.key,S)}removeNode(M){const C=this.b(M);this.a.delete(C);for(const S of this.a.values())S.outgoing.delete(C),S.incoming.delete(C)}lookupOrInsertNode(M){const C=this.b(M);let S=this.a.get(C);return S||(S=new P(C,M),this.a.set(C,S)),S}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[C,S]of this.a)M.push(`${C}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,C]of this.a){const S=new Set([M]),u=this.c(C,S);if(u)return u}}c(M,C){for(const[S,u]of M.outgoing){if(C.has(S))return[...C,S].join(" -> ");C.add(S);const a=this.c(u,C);if(a)return a;C.delete(S)}}}e.$fq=D}),define(ne[5],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var P;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function S(u){return u[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=S})(P||(e._util=P={})),e.$Oh=s("instantiationService");function D(C,S,u){S[P.DI_TARGET]===S?S[P.DI_DEPENDENCIES].push({id:C,index:u}):(S[P.DI_DEPENDENCIES]=[{id:C,index:u}],S[P.DI_TARGET]=S)}function s(C){if(P.serviceIds.has(C))return P.serviceIds.get(C);const S=function(u,a,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(S,u,m)};return S.toString=()=>C,P.serviceIds.set(C,S),S}e.$Ph=s;function M(C){return C}e.$Qh=M}),define(ne[63],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i7b=void 0,e.$i7b=(0,P.$Ph)("auxiliaryWindowsMainService")}),define(ne[64],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=void 0,e.$36b=(0,P.$Ph)("backupMainService")}),define(ne[18],se([0,1,12,7,5]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,s.$Ph)("configurationService");function M($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof D.URI)}e.$ki=M;function C($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof D.URI)}e.$li=C;var S;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function u($){switch($){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=u;function a($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}e.$ni=a;function m($,d){const h=Object.create(null);for(const E in $)b(h,E,$[E],d);return h}e.$oi=m;function b($,d,h,E){const c=d.split("."),i=c.pop();let o=$;for(let r=0;r<c.length;r++){const t=c[r];let n=o[t];switch(typeof n){case"undefined":n=o[t]=Object.create(null);break;case"object":break;default:E(`Ignoring ${d} as ${c.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[i]=h}catch{E(`Ignoring ${d} as ${c.join(".")} is ${JSON.stringify(o)}`)}else E(`Ignoring ${d} as ${c.join(".")} is ${JSON.stringify(o)}`)}e.$pi=b;function y($,d){const h=d.split(".");f($,h)}e.$qi=y;function f($,d){const h=d.shift();if(d.length===0){delete $[h];return}if(Object.keys($).indexOf(h)!==-1){const E=$[h];typeof E=="object"&&!Array.isArray(E)&&(f(E,d),Object.keys(E).length===0&&delete $[h])}}function v($,d,h){function E(o,r){let t=o;for(const n of r){if(typeof t!="object"||t===null)return;t=t[n]}return t}const c=d.split("."),i=E($,c);return typeof i>"u"?h:i}e.$ri=v;function w($,d,h){Object.keys(d).forEach(E=>{E!=="__proto__"&&(E in $?P.$Af($[E])&&P.$Af(d[E])?w($[E],d[E],h):h&&($[E]=d[E]):$[E]=d[E])})}e.$si=w;function p($){return $.replace(/[\[\]]/g,"")}e.$ti=p}),define(ne[114],se([0,1,4,27,197,5,164,14]),function(Q,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",P.$k),u.set("isLinux",P.$l),u.set("isWindows",P.$j),u.set("isWeb",P.$p),u.set("isMacNative",P.$k&&!P.$p),u.set("isEdge",P.$H),u.set("isFirefox",P.$F),u.set("isChrome",P.$E),u.set("isSafari",P.$G);function a(J,O){if(u.get(J)!==void 0)throw(0,S.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(J,O)}e.$Li=a;const m=Object.prototype.hasOwnProperty;var b;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const y={regexParsingWithErrorRecovery:!0},f=(0,C.localize)(0,null),v=(0,C.localize)(1,null),w=(0,C.localize)(2,null),p=(0,C.localize)(3,null),$=(0,C.localize)(4,null),d=(0,C.localize)(5,null),h=(0,C.localize)(6,null),E=(0,C.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=y){this.k=O,this.d=new s.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const F=this.D(),U=F.type===17?d:void 0;throw this.h.push({message:$,offset:F.offset,lexeme:s.$Ki.getLexeme(F),additionalInfo:U}),c.c}return j}catch(j){if(j!==c.c)throw j;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const j=this.o();O.push(j)}return O.length===1?O[0]:i.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const j=this.s();O.push(j)}return O.length===1?O[0]:i.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,p),j?.negate()}case 17:return this.z(),L.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const j=this.l();return this.A(1,p),j}case 17:{const j=O.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const H=U.lexeme,B=H.lastIndexOf("/"),ie=B===H.length-1?void 0:this.w(H.substring(B+1));let fe;try{fe=new RegExp(H.substring(1,B),ie)}catch{throw this.B("REGEX",U)}return re.create(j,fe)}switch(U.type){case 10:case 19:{const H=[U.lexeme];this.z();let B=this.D(),ie=0;for(let me=0;me<U.lexeme.length;me++)U.lexeme.charCodeAt(me)===40?ie++:U.lexeme.charCodeAt(me)===41&&ie--;for(;!this.E()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let me=0;me<B.lexeme.length;me++)B.lexeme.charCodeAt(me)===40?ie++:U.lexeme.charCodeAt(me)===41&&ie--}if(ie<0)break;H.push(s.$Ki.getLexeme(B)),this.z(),B=this.D()}const fe=H.join(""),de=fe.lastIndexOf("/"),ue=de===fe.length-1?void 0:this.w(fe.substring(de+1));let be;try{be=new RegExp(fe.substring(1,de),ue)}catch{throw this.B("REGEX",U)}return i.regex(j,be)}case 18:{const H=U.lexeme;this.z();let B=null;if(!(0,D.$Be)(H)){const ie=H.indexOf("/"),fe=H.lastIndexOf("/");if(ie!==fe&&ie>=0){const de=H.slice(ie+1,fe),ue=H[fe+1]==="i"?"i":"";try{B=new RegExp(de,ue)}catch{throw this.B("REGEX",U)}}}if(B===null)throw this.B("REGEX",U);return re.create(j,B)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const U=this.u();return i.notIn(j,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return i.equals(j,U);switch(U){case"true":return i.has(j);case"false":return i.not(j);default:return i.equals(j,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return i.notEquals(j,U);switch(U){case"true":return i.not(j);case"false":return i.has(j);default:return i.notEquals(j,U)}}case 5:return this.z(),X.create(j,this.u());case 6:return this.z(),ce.create(j,this.u());case 7:return this.z(),T.create(j,this.u());case 8:return this.z(),x.create(j,this.u());case 13:return this.z(),i.in(j,this.u());default:return i.has(j)}}case 20:throw this.h.push({message:h,offset:O.offset,lexeme:"",additionalInfo:E}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,j){if(this.C(O))return this.z();throw this.B(j,this.D())}B(O,j,F){const U=(0,C.localize)(8,null,O,s.$Ki.getLexeme(j)),H=j.offset,B=s.$Ki.getLexeme(j);return this.h.push({message:U,offset:H,lexeme:B,additionalInfo:F}),c.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=c;class i{static false(){return n.INSTANCE}static true(){return l.INSTANCE}static has(O){return g.create(O)}static equals(O,j){return A.create(O,j)}static notEquals(O,j){return I.create(O,j)}static regex(O,j){return re.create(O,j)}static in(O,j){return R.create(O,j)}static notIn(O,j){return k.create(O,j)}static not(O){return L.create(O)}static and(...O){return K.create(O,null,!0)}static or(...O){return G.create(O,null,!0)}static greater(O,j){return T.create(O,j)}static greaterEquals(O,j){return x.create(O,j)}static smaller(O,j){return X.create(O,j)}static smallerEquals(O,j){return ce.create(O,j)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Ni=i;function o(J){const O=new c({regexParsingWithErrorRecovery:!1});return J.map(j=>(O.parse(j),O.lexingErrors.length>0?O.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,C.localize)(9,null,F.additionalInfo):(0,C.localize)(10,null),offset:F.offset,length:F.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}e.$Oi=o;function r(J,O){const j=J?J.substituteConstants():void 0,F=O?O.substituteConstants():void 0;return!j&&!F?!0:!j||!F?!1:j.equals(F)}e.$Pi=r;function t(J,O){return J.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return l.INSTANCE}}e.$Qi=n;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$Ri=l;class g{static create(O,j=null){const F=u.get(O);return typeof F=="boolean"?F?l.INSTANCE:n.INSTANCE:new g(O,j)}constructor(O,j){this.key=O,this.c=j,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:W(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=u.get(this.key);return typeof O=="boolean"?O?l.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Si=g;class A{static create(O,j,F=null){if(typeof j=="boolean")return j?g.create(O,F):L.create(O,F);const U=u.get(O);return typeof U=="boolean"?j===(U?"true":"false")?l.INSTANCE:n.INSTANCE:new A(O,j,F)}constructor(O,j,F){this.c=O,this.d=j,this.f=F,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=u.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?l.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ti=A;class R{static create(O,j){return new R(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:V(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.f),F=O.getValue(this.d);return Array.isArray(j)?j.includes(F):typeof F=="string"&&typeof j=="object"&&j!==null?m.call(j,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Ui=R;class k{static create(O,j){return new k(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=11,this.c=R.create(O,j)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=k;class I{static create(O,j,F=null){if(typeof j=="boolean")return j?L.create(O,F):g.create(O,F);const U=u.get(O);return typeof U=="boolean"?j===(U?"true":"false")?n.INSTANCE:l.INSTANCE:new I(O,j,F)}constructor(O,j,F){this.c=O,this.d=j,this.f=F,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=u.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?n.INSTANCE:l.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Wi=I;class L{static create(O,j=null){const F=u.get(O);return typeof F=="boolean"?F?n.INSTANCE:l.INSTANCE:new L(O,j)}constructor(O,j){this.c=O,this.d=j,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:W(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=u.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:l.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$Xi=L;function N(J,O){if(typeof J=="string"){const j=parseFloat(J);isNaN(j)||(J=j)}return typeof J=="string"||typeof J=="number"?O(J):n.INSTANCE}class T{static create(O,j,F=null){return N(j,U=>new T(O,U,F))}constructor(O,j,F){this.c=O,this.d=j,this.f=F,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$Yi=T;class x{static create(O,j,F=null){return N(j,U=>new x(O,U,F))}constructor(O,j,F){this.c=O,this.d=j,this.f=F,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$Zi=x;class X{static create(O,j,F=null){return N(j,U=>new X(O,U,F))}constructor(O,j,F){this.c=O,this.d=j,this.f=F,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$1i=X;class ce{static create(O,j,F=null){return N(j,U=>new ce(O,U,F))}constructor(O,j,F){this.c=O,this.d=j,this.f=F,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$2i=ce;class re{static create(O,j){return new re(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const j=this.f?this.f.source:"",F=O.f?O.f.source:"";return j<F?-1:j>F?1:0}equals(O){if(O.type===this.type){const j=this.f?this.f.source:"",F=O.f?O.f.source:"";return this.d===O.d&&j===F}return!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$3i=re;class ae{static create(O){return new ae(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ae(this.c.map(O))}negate(){return this.c}}e.$4i=ae;function Z(J){let O=null;for(let j=0,F=J.length;j<F;j++){const U=J[j].substituteConstants();if(J[j]!==U&&O===null){O=[];for(let H=0;H<j;H++)O[H]=J[H]}O!==null&&(O[j]=U)}return O===null?J:O}class K{static create(O,j,F){return K.d(O,j,F)}constructor(O,j){this.expr=O,this.c=j,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,F=this.expr.length;j<F;j++){const U=t(this.expr[j],O.expr[j]);if(U!==0)return U}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,F=this.expr.length;j<F;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=Z(this.expr);return O===this.expr?this:K.create(O,this.c,!1)}evaluate(O){for(let j=0,F=this.expr.length;j<F;j++)if(!this.expr[j].evaluate(O))return!1;return!0}static d(O,j,F){const U=[];let H=!1;for(const B of O)if(B){if(B.type===1){H=!0;continue}if(B.type===0)return n.INSTANCE;if(B.type===6){U.push(...B.expr);continue}U.push(B)}if(U.length===0&&H)return l.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(t);for(let B=1;B<U.length;B++)U[B-1].equals(U[B])&&(U.splice(B,1),B--);if(U.length===1)return U[0];for(;U.length>1;){const B=U[U.length-1];if(B.type!==9)break;U.pop();const ie=U.pop(),fe=U.length===0,de=G.create(B.expr.map(ue=>K.create([ue,ie],null,F)),null,fe);de&&(U.push(de),U.sort(t))}if(U.length===1)return U[0];if(F){for(let B=0;B<U.length;B++)for(let ie=B+1;ie<U.length;ie++)if(U[B].negate().equals(U[ie]))return n.INSTANCE;if(U.length===1)return U[0]}return new K(U,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new K(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());this.c=G.create(O,this,!0)}return this.c}}e.$5i=K;class G{static create(O,j,F){return G.d(O,j,F)}constructor(O,j){this.expr=O,this.c=j,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,F=this.expr.length;j<F;j++){const U=t(this.expr[j],O.expr[j]);if(U!==0)return U}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,F=this.expr.length;j<F;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=Z(this.expr);return O===this.expr?this:G.create(O,this.c,!1)}evaluate(O){for(let j=0,F=this.expr.length;j<F;j++)if(this.expr[j].evaluate(O))return!0;return!1}static d(O,j,F){let U=[],H=!1;if(O){for(let B=0,ie=O.length;B<ie;B++){const fe=O[B];if(fe){if(fe.type===0){H=!0;continue}if(fe.type===1)return l.INSTANCE;if(fe.type===9){U=U.concat(fe.expr);continue}U.push(fe)}}if(U.length===0&&H)return n.INSTANCE;U.sort(t)}if(U.length!==0){if(U.length===1)return U[0];for(let B=1;B<U.length;B++)U[B-1].equals(U[B])&&(U.splice(B,1),B--);if(U.length===1)return U[0];if(F){for(let B=0;B<U.length;B++)for(let ie=B+1;ie<U.length;ie++)if(U[B].negate().equals(U[ie]))return l.INSTANCE;if(U.length===1)return U[0]}return new G(U,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new G(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());for(;O.length>1;){const j=O.shift(),F=O.shift(),U=[];for(const H of oe(j))for(const B of oe(F))U.push(K.create([H,B],null,!1));O.unshift(G.create(U,null,!1))}this.c=G.create(O,this,!0)}return this.c}}e.$6i=G;class z extends g{static{this.d=[]}static all(){return z.d.values()}constructor(O,j,F){super(O,null),this.f=j,typeof F=="object"?z.d.push({...F,key:O}):F!==!0&&z.d.push({key:O,description:F,type:j!=null?typeof j:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return A.create(this.key,O)}notEqualsTo(O){return I.create(this.key,O)}}e.$7i=z,e.$8i=(0,M.$Ph)("contextKeyService");function W(J,O){return J<O?-1:J>O?1:0}function V(J,O,j,F){return J<j?-1:J>j?1:O<F?-1:O>F?1:0}function q(J,O){if(J.type===0||O.type===1)return!0;if(J.type===9)return O.type===9?Y(J.expr,O.expr):!1;if(O.type===9){for(const j of O.expr)if(q(J,j))return!0;return!1}if(J.type===6){if(O.type===6)return Y(O.expr,J.expr);for(const j of J.expr)if(q(j,O))return!0;return!1}return J.equals(O)}e.$9i=q;function Y(J,O){let j=0,F=0;for(;j<J.length&&F<O.length;){const U=J[j].cmp(O[F]);if(U<0)return!1;U===0&&j++,F++}return j===J.length}function oe(J){return J.type===9?J.expr:[J]}}),define(ne[91],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.ID=void 0,e.ID="diagnosticsService",e.$qm=(0,P.$Ph)(e.ID);function D(M){return!!M.hostName&&!!M.errorMessage}e.$rm=D;class s{async getPerformanceInfo(C,S){return{}}async getSystemInfo(C,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,S){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$sm=s}),define(ne[115],se([0,1,19,74,166,5,46,4,38]),function(Q,e,P,D,s,M,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iv=e.$Hv=e.ConfirmResult=e.$Gv=e.$Fv=e.$Ev=void 0,e.$Ev=(0,M.$Ph)("dialogService");var a;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(a||(a={}));class m{a(p){return this.d(p,a.Confirmation)}b(p){return this.d(p,a.Prompt)}c(p){return this.d(p,a.Input)}d(p,$){const d=[];switch($){case a.Confirmation:{const h=p;h.primaryButton?d.push(h.primaryButton):d.push((0,s.localize)(0,null)),h.cancelButton?d.push(h.cancelButton):d.push((0,s.localize)(1,null));break}case a.Prompt:{const h=p;Array.isArray(h.buttons)&&h.buttons.length>0&&d.push(...h.buttons.map(E=>E.label)),h.cancelButton&&(h.cancelButton===!0?d.push((0,s.localize)(2,null)):typeof h.cancelButton=="string"?d.push(h.cancelButton):h.cancelButton.label?d.push(h.cancelButton.label):d.push((0,s.localize)(3,null))),d.length===0&&d.push((0,s.localize)(4,null));break}case a.Input:{const h=p;h.primaryButton?d.push(h.primaryButton):d.push((0,s.localize)(5,null)),h.cancelButton?d.push(h.cancelButton):d.push((0,s.localize)(6,null));break}}return d}e(p){if(typeof p=="string")return p;if(typeof p=="number")return p===D.default.Info?"info":p===D.default.Error?"error":p===D.default.Warning?"warning":"none"}f(p,$,d){const h=[...p.buttons??[]];p.cancelButton&&typeof p.cancelButton!="string"&&typeof p.cancelButton!="boolean"&&h.push(p.cancelButton);let E=h[$]?.run({checkboxChecked:d});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:d}}}e.$Fv=m,e.$Gv=(0,M.$Ph)("fileDialogService");var b;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(b||(e.ConfirmResult=b={}));const y=10;function f(w){const p=[];return p.push(...w.slice(0,y).map($=>typeof $=="string"?$:(0,P.$sg)($))),w.length>y&&(w.length-y===1?p.push((0,s.localize)(7,null)):p.push((0,s.localize)(8,null,w.length-y))),p.push(""),p.join(`
`)}e.$Hv=f;function v(w,p){const $=(0,u.$7m)(w);let d=($.buttons??[]).map(i=>(0,C.$Bv)(i)),h=(w.buttons||[]).map((i,o)=>o),E=0,c=$.cancelId??d.length-1;if(d.length>1){const i=typeof c=="number"?d[c]:void 0;if(S.$l||S.$k){if(typeof i=="string"&&d.length>1&&c!==1){d.splice(c,1),d.splice(1,0,i);const o=h[c];h.splice(c,1),h.splice(1,0,o),c=1}S.$l&&d.length>1&&(d=d.reverse(),h=h.reverse(),E=d.length-1,typeof i=="string"&&(c=E-1))}else if(S.$j&&typeof i=="string"&&d.length>1&&c!==d.length-1){d.splice(c,1),d.push(i);const o=h[c];h.splice(c,1),h.push(o),c=d.length-1}}return $.buttons=d,$.defaultId=E,$.cancelId=c,$.noLink=!0,$.title=$.title||p.nameLong,{options:$,buttonIndeces:h}}e.$Iv=v}),define(ne[116],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iU=e.$hU=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$gU=e.$fU=void 0,e.$fU=(0,P.$Ph)("encryptionService"),e.$gU=(0,P.$Ph)("encryptionMainService");var D;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(D||(e.PasswordStoreCLIOption=D={}));var s;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$hU=M;function C(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$iU=C}),define(ne[37],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,P.$Ph)("environmentService"),e.$Xh=(0,P.$Qh)(e.$Wh)}),define(ne[117],se([0,1,170,5]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ao=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=void 0,e.$1n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$2n=new RegExp(e.$1n),e.$3n="__web_extension",e.$4n="skipWalkthrough",e.$5n="extensionsSync",e.$6n="dependecyOrPackExtensionInstall";function s($){switch($){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$7n=s;function M($){switch($){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$8n=M;function C($,d){switch($){case 3:return d==="x64"?"win32-x64":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$9n=C;function S($,d){return d==="web"&&!$.includes("web")}e.$0n=S;function u($,d,h){return S(d,h)?!1:$==="undefined"||$==="universal"?!0:$==="unknown"?!1:$===h}e.$$n=u;function a($){return $&&typeof $=="object"&&typeof $.id=="string"&&(!$.uuid||typeof $.uuid=="string")}e.$_n=a;var m;(function($){$[$.NoneOrRelevance=0]="NoneOrRelevance",$[$.LastUpdatedDate=1]="LastUpdatedDate",$[$.Title=2]="Title",$[$.PublisherName=3]="PublisherName",$[$.InstallCount=4]="InstallCount",$[$.PublishedDate=10]="PublishedDate",$[$.AverageRating=6]="AverageRating",$[$.WeightedRating=12]="WeightedRating"})(m||(e.SortBy=m={}));var b;(function($){$[$.Default=0]="Default",$[$.Ascending=1]="Ascending",$[$.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var y;(function($){$.Install="install",$.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var f;(function($){$[$.None=1]="None",$[$.Install=2]="Install",$[$.Update=3]="Update",$[$.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$ao=(0,D.$Ph)("extensionGalleryService");var v;(function($){$.Unsupported="Unsupported",$.Deprecated="Deprecated",$.Malicious="Malicious",$.Incompatible="Incompatible",$.IncompatibleTargetPlatform="IncompatibleTargetPlatform",$.ReleaseVersionNotFound="ReleaseVersionNotFound",$.Invalid="Invalid",$.Download="Download",$.Extract="Extract",$.Delete="Delete",$.Rename="Rename",$.CorruptZip="CorruptZip",$.IncompleteZip="IncompleteZip",$.Signature="Signature",$.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var w;(function($){$.UnknownError="UnknownError",$.PackageIsInvalidZip="PackageIsInvalidZip",$.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class p extends Error{constructor(d,h){super(d),this.code=h,this.name=h}}e.$bo=p,e.$co=(0,D.$Ph)("extensionManagementService"),e.$do="extensionsIdentifiers/disabled",e.$eo="extensionsIdentifiers/enabled",e.$fo=(0,D.$Ph)("IGlobalExtensionEnablementService"),e.$go=(0,D.$Ph)("IExtensionTipsService"),e.$ho=(0,P.localize)(0,null),e.$io={value:e.$ho,original:"Extensions"},e.$jo={value:(0,P.localize)(1,null),original:"Preferences"}}),define(ne[209],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x7b=e.$w7b=void 0,e.$w7b=(0,P.$Ph)("extensionHostStarter"),e.$x7b="extensionHostStarter"}),define(ne[210],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GYb=e.$FYb=void 0,e.$FYb=(0,P.$Ph)("externalTerminal"),e.$GYb="Terminal.app"}),define(ne[211],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=void 0,e.$z7b=(0,P.$Ph)("externalTerminal")}),define(ne[212],se([0,1,47,13,9,4,76,21,89,174,210]),function(Q,e,P,D,s,M,C,S,u,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=e.$B7b=e.$A7b=void 0;const b=a.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends y{static{this.b="cmd.exe"}openTerminal(E,c){return this.spawnTerminal(P,E,u.$Bl(),c)}spawnTerminal(E,c,i,o){const r=c.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const t=s.$mc(r,".exe").toLowerCase();if(t==="cmder")return E.spawn(r,o?[o]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),t==="wt"&&n.push("-d ."),new Promise((l,g)=>{const A=p(process),R=E.spawn(i,n,{cwd:o,env:A});R.on("error",g),R.on("exit",()=>l())})}runInTerminal(E,c,i,o,r){const t="windowsExec"in r&&r.windowsExec?r.windowsExec:f.getDefaultTerminalWindows();return new Promise((n,l)=>{const g=`"${c} - ${b}"`,A=`""${i.join('" "')}" & pause"`,R=Object.assign({},p(process),o);Object.keys(R).filter(T=>R[T]===null).forEach(T=>delete R[T]);const k={cwd:c,env:R,windowsVerbatimArguments:!0};let I,L;s.$mc(t,".exe")==="wt"?(I=t,L=["-d",".",f.b,"/c",A]):(I=f.b,L=["/c","start",g,"/wait",t,"/c",A]),P.spawn(I,L,k).on("error",T=>{l($(T))}),n(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.$A7b=f;class v extends y{static{this.b="/usr/bin/osascript"}openTerminal(E,c){return this.spawnTerminal(P,E,c)}runInTerminal(E,c,i,o,r){const t=r.osxExec||m.$GYb;return new Promise((n,l)=>{if(t===m.$GYb||t==="iTerm.app"){const g=t===m.$GYb?"TerminalHelper":"iTermHelper",R=[D.$cg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${g}.scpt`).fsPath,"-t",E||b,"-w",c];for(const L of i)R.push("-a"),R.push(L);if(o){const L=Object.assign({},p(process),o);for(const N in L){const T=L[N];T===null?(R.push("-u"),R.push(N)):(R.push("-e"),R.push(`${N}=${T}`))}}let k="";const I=P.spawn(v.b,R);I.on("error",L=>{l($(L))}),I.stderr.on("data",L=>{k+=L.toString()}),I.on("exit",L=>{if(L===0)n(void 0);else if(k){const N=k.split(`
`,1);l(new Error(N[0]))}else l(new Error(a.localize(1,null,g,L)))})}else l(new Error(a.localize(2,null,t)))})}spawnTerminal(E,c,i){const o=c.osxExec||m.$GYb;return new Promise((r,t)=>{const n=["-a",o];i&&n.push(i);const l=p(process),g=E.spawn("/usr/bin/open",n,{cwd:i,env:l});g.on("error",t),g.on("exit",()=>r())})}}e.$B7b=v;class w extends y{static{this.b=a.localize(3,null)}openTerminal(E,c){return this.spawnTerminal(P,E,c)}runInTerminal(E,c,i,o,r){const t=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((n,l)=>{const g=[];t.then(A=>{A.indexOf("gnome-terminal")>=0?g.push("-x"):g.push("-e"),g.push("bash"),g.push("-c");const R=`${d(i)}; echo; read -p "${w.b}" -n1;`;g.push(`''${R}''`);const k=Object.assign({},p(process),o);Object.keys(k).filter(T=>k[T]===null).forEach(T=>delete k[T]);const I={cwd:c,env:k};let L="";const N=P.spawn(A,g,I);N.on("error",T=>{l($(T))}),N.stderr.on("data",T=>{L+=T.toString()}),N.on("exit",T=>{if(T===0)n(void 0);else if(L){const x=L.split(`
`,1);l(new Error(x[0]))}else l(new Error(a.localize(4,null,A,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!M.$l)w.d=Promise.resolve("xterm");else{const E=await S.Promises.exists("/etc/debian_version");w.d=new Promise(c=>{E?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return w.d}spawnTerminal(E,c,i){const o=c.linuxExec?Promise.resolve(c.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{o.then(n=>{const l=p(process),g=E.spawn(n,[],{cwd:i,env:l});g.on("error",t),g.on("exit",()=>r())})})}}e.$C7b=w;function p(h){const E={...h.env};return(0,C.$zl)(E),E}function $(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(a.localize(5,null,h.path)):h}function d(h){let E="";for(const c of h)c.indexOf(" ")>=0?E+='"'+c+'"':E+=c,E+=" ";return E}}),define(ne[16],se([0,1,57,9,27,12,7,176,5,4,13,72]),function(Q,e,P,D,s,M,C,S,u,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,u.$Ph)("fileService");function y(q){return q.create===!0}e.$_j=y;var f;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var v;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function w(q){const Y=q;return!!Y&&typeof Y.onDidChange=="function"}e.$ak=w;var p;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function $(q){return!!(q.capabilities&2)}e.$bk=$;function d(q){return!!(q.capabilities&8)}e.$ck=d;function h(q){return!!(q.capabilities&131072)}e.$dk=h;function E(q){return!!(q.capabilities&4)}e.$ek=E;function c(q){return!!(q.capabilities&16)}e.$fk=c;function i(q){return $(q)?!!(q.capabilities&16384):!1}e.$gk=i;function o(q){return $(q)?!!(q.capabilities&32768):!1}e.$hk=o;function r(q){return!!(q.capabilities&65536)}e.$ik=r;function t(q){return!!(q.capabilities&2048)}e.$jk=t;var n;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class l extends Error{static create(Y,oe){const J=new l(Y.toString(),oe);return R(J,oe),J}constructor(Y,oe){super(Y),this.code=oe}}e.$kk=l;function g(q,Y){return l.create(q,Y)}e.$lk=g;function A(q){return q||g((0,S.localize)(0,null),n.Unknown)}e.$mk=A;function R(q,Y){return q.name=Y?`${Y} (FileSystemError)`:"FileSystemError",q}e.$nk=R;function k(q){if(!q)return n.Unknown;if(q instanceof l)return q.code;const Y=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!Y)return n.Unknown;switch(Y[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$ok=k;function I(q){if(q instanceof ce)return q.fileOperationResult;switch(k(q)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$pk=I;var L;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class N{constructor(Y,oe,J){this.resource=Y,this.operation=oe,this.target=J}isOperation(Y){return this.operation===Y}}e.$qk=N;var T;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class x{static{this.a=null}constructor(Y,oe){this.c=oe,this.b=void 0,this.d=new b.$U(()=>{const J=P.$Vh.forUris(()=>this.c);return J.fill(this.rawAdded.map(O=>[O,!0])),J}),this.f=new b.$U(()=>{const J=P.$Vh.forUris(()=>this.c);return J.fill(this.rawUpdated.map(O=>[O,!0])),J}),this.g=new b.$U(()=>{const J=P.$Vh.forUris(()=>this.c);return J.fill(this.rawDeleted.map(O=>[O,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of Y){switch(J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}this.b!==x.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=x.a):this.b!==void 0&&(this.b=x.a))}}contains(Y,...oe){return this.h(Y,{includeChildren:!1},...oe)}affects(Y,...oe){return this.h(Y,{includeChildren:!0},...oe)}h(Y,oe,...J){if(!Y)return!1;const O=J.length>0;return!!((!O||J.includes(1))&&(this.d.value.get(Y)||oe.includeChildren&&this.d.value.findSuperstr(Y))||(!O||J.includes(0))&&(this.f.value.get(Y)||oe.includeChildren&&this.f.value.findSuperstr(Y))||(!O||J.includes(2))&&(this.g.value.findSubstr(Y)||oe.includeChildren&&this.g.value.findSuperstr(Y)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Y){return this.b===Y}hasCorrelation(){return typeof this.b=="number"}}e.$rk=x;function X(q,Y,oe){return!q||!Y||q===Y||Y.length>q.length?!1:(Y.charAt(Y.length-1)!==D.sep&&(Y+=D.sep),oe?(0,s.$3e)(q,Y):q.indexOf(Y)===0)}e.$sk=X;class ce extends Error{constructor(Y,oe,J){super(Y),this.fileOperationResult=oe,this.options=J}}e.$tk=ce;class re extends ce{constructor(Y,oe,J,O){super(Y,oe,O),this.fileOperationResult=oe,this.size=J}}e.$uk=re;class ae extends ce{constructor(Y,oe,J){super(Y,2,J),this.stat=oe}}e.$vk=ae;var Z;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var K;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$Dk="";function G(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$Ek=G;async function z(q,Y){if(!Y.hasProvider(C.URI.from({scheme:q.scheme})))return new Promise(oe=>{const J=Y.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===q.scheme&&O.added&&(J.dispose(),oe())})})}e.$Fk=z;class W{static{this.KB=1024}static{this.MB=W.KB*W.KB}static{this.GB=W.MB*W.KB}static{this.TB=W.GB*W.KB}static formatSize(Y){return(0,M.$Cf)(Y)||(Y=0),Y<W.KB?(0,S.localize)(1,null,Y.toFixed(0)):Y<W.MB?(0,S.localize)(2,null,(Y/W.KB).toFixed(2)):Y<W.GB?(0,S.localize)(3,null,(Y/W.MB).toFixed(2)):Y<W.TB?(0,S.localize)(4,null,(Y/W.GB).toFixed(2)):(0,S.localize)(5,null,(Y/W.TB).toFixed(2))}}e.$Gk=W;function V(q){const Y=typeof q=="string"||q?.scheme===m.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===m.Schemas.file?1024*W.MB:Y?10*W.MB:a.$p?50*W.MB:1024*W.MB}e.$Hk=V}),define(ne[118],se([0,1,17,14,177,16]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;async function C(m,b,y,f,v,w){let p;try{await S(m,b,y,f,v,w)}catch($){p=$}finally{p&&v.errorTransformer&&(p=v.errorTransformer(p)),typeof p<"u"&&y.error(p),y.end()}}e.$Pp=C;async function S(m,b,y,f,v,w){u(w);const p=await m.open(b,{create:!1});try{u(w);let $=0,d=0,h=v&&typeof v.length=="number"?v.length:void 0,E=P.$be.alloc(Math.min(v.bufferSize,typeof h=="number"?h:v.bufferSize)),c=v&&typeof v.position=="number"?v.position:0,i=0;do d=await m.read(p,c,E.buffer,i,E.byteLength-i),c+=d,i+=d,$+=d,typeof h=="number"&&(h-=d),i===E.byteLength&&(await y.write(f(E)),E=P.$be.alloc(Math.min(v.bufferSize,typeof h=="number"?h:v.bufferSize)),i=0);while(d>0&&(typeof h!="number"||h>0)&&u(w)&&a($,v));if(i>0){let o=i;typeof h=="number"&&(o=Math.min(i,h)),y.write(f(E.slice(0,o)))}}catch($){throw(0,M.$mk)($)}finally{await m.close(p)}}function u(m){if(m.isCancellationRequested)throw(0,D.$5)();return!0}function a(m,b){if(typeof b?.limits?.size=="number"&&m>b.limits.size)throw(0,M.$lk)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[65],se([0,1,104,2,9,4,7,16]),function(Q,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=e.$Rp=void 0;function u($){return $.recursive===!0}e.$Rp=u;class a extends D.$Rc{static{this.a=5}constructor(d,h,E,c){super(),this.h=d,this.j=h,this.m=E,this.n=c,this.c=this.B(new D.$Sc),this.f=void 0,this.g=0}s(){const d=new D.$Qc;this.c.value=d,this.b=this.r(d),this.b.setVerboseLogging(this.m),d.add(this.b.onDidChangeFile(h=>this.h(h))),d.add(this.b.onDidLogMessage(h=>this.j(h))),d.add(this.b.onDidError(h=>this.t(h)))}t(d){this.n.restartOnError?this.g<a.a&&this.f?(this.w(`restarting watcher after error: ${d}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${d}`):this.w(d)}u(d){this.g++,this.s(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.m=d,await this.b?.setVerboseLogging(d)}w(d){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${d}`})}y(d){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Sp=a;class m extends a{constructor(d,h,E){super(d,h,E,{type:"node.js",restartOnError:!1})}}e.$Tp=m;class b extends a{constructor(d,h,E){super(d,h,E,{type:"universal",restartOnError:!0})}}e.$Up=b;function y($){return $.map(d=>({type:d.type,resource:C.URI.revive(d.resource),cId:d.cId}))}e.$Vp=y;function f($){const d=new p;for(const h of $)d.processEvent(h);return d.coalesce()}e.$Wp=f;function v($,d){return typeof d=="string"&&!d.startsWith(P.$sj)&&!(0,s.$hc)(d)?{base:$,pattern:d}:d}e.$Xp=v;function w($,d){const h=[];for(const E of d)h.push((0,P.$wj)(v($,E)));return h}e.$Yp=w;class p{constructor(){this.a=new Set,this.b=new Map}c(d){return M.$l?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const h=this.b.get(this.c(d));let E=!1;if(h){const c=h.type,i=d.type;h.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?E=!0:c===1&&i===2?(this.b.delete(this.c(d)),this.a.delete(h)):c===2&&i===1?h.type=0:c===1&&i===0||(h.type=i)}else E=!0;E&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],h=[];return Array.from(this.a).filter(E=>E.type!==2?(d.push(E),!1):!0).sort((E,c)=>E.resource.fsPath.length-c.resource.fsPath.length).filter(E=>h.some(c=>(0,S.$sk)(E.resource.fsPath,c,!M.$l))?!1:(h.push(E.resource.fsPath),!0)).concat(d)}}}),define(ne[213],se([0,1,17,49,14,3,2,61,32,16,65]),function(Q,e,P,D,s,M,C,S,u,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=void 0,e.$vN="localFilesystem";class b extends C.$Rc{constructor(f,v){super(),this.a=f,this.b=v,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$Nd),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$Nd),this.onDidWatchError=this.g.event,this.h=(0,u.$eg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,v){const{buffer:w}=await this.a.call("readFile",[f,v]);return w}readFileStream(f,v,w){const p=(0,S.$2d)(d=>P.$be.concat(d.map(h=>P.$be.wrap(h))).buffer),$=new C.$Qc;return $.add(this.a.listen("readFileStream",[f,v])(d=>{if(d instanceof P.$be)p.write(d.buffer);else{if(d==="end")p.end();else{let h;if(d instanceof Error)h=d;else{const E=d;h=(0,a.$lk)(E.message??(0,D.$Ai)(E),E.code??a.FileSystemProviderErrorCode.Unknown)}p.error(h),p.end()}$.dispose()}})),$.add(w.onCancellationRequested(()=>{p.error((0,s.$5)()),p.end(),$.dispose()})),p}writeFile(f,v,w){return this.a.call("writeFile",[f,P.$be.wrap(v),w])}open(f,v){return this.a.call("open",[f,v])}close(f){return this.a.call("close",[f])}async read(f,v,w,p,$){const[d,h]=await this.a.call("read",[f,v,$]);return w.set(d.buffer.slice(0,h),p),h}write(f,v,w,p,$){return this.a.call("write",[f,v,P.$be.wrap(w),p,$])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,v){return this.a.call("delete",[f,v])}rename(f,v,w){return this.a.call("rename",[f,v,w])}copy(f,v,w){return this.a.call("copy",[f,v,w])}cloneFile(f,v){return this.a.call("cloneFile",[f,v])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const v=f;this.f.fire((0,m.$Vp)(v))}else{const v=f;this.g.fire(v)}}))}watch(f,v){const w=(0,u.$eg)();return this.a.call("watch",[this.h,w,f,v]),(0,C.$Pc)(()=>this.a.call("unwatch",[this.h,w]))}}e.$wN=b}),define(ne[214],se([0,1,45,8,22,33,2,85,9,4,19,7,105,21,65]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;class w extends C.$Rc{static{this.a=100}static{this.b=75}constructor(d,h,E,c){super(),this.m=d,this.n=h,this.r=E,this.s=c,this.c=this.B(new D.$9g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new D.$8g(i=>this.z(i),w.b)),this.g=(0,v.$Yp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,v.$Yp)(this.m.path,this.m.includes):void 0,this.j=new s.$Xd,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await f.Promises.stat(d);this.B(await this.w(d,h.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let h=d.path;try{h=await f.Promises.realpath(d.path),d.path===h&&(h=await(0,y.$9p)(d.path)??d.path),d.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${h})`)}catch{}return h}async w(d,h){if(a.$k&&(0,M.$Xf)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.$Rc.None;const E=new s.$Xd(this.j.token),c=new C.$Qc;try{const i=b.URI.file(this.m.path),o=(0,u.$mc)(d),r=(0,P.watch)(d);c.add((0,C.$Pc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${d}'`);const t=new Set;if(h)try{for(const l of await f.Promises.readdir(d))t.add(l)}catch(l){this.D(l)}const n=new Map;c.add((0,C.$Pc)(()=>{for(const[,l]of n)l.dispose();n.clear()})),r.on("error",(l,g)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${l}, ${g})`),this.dispose()}),r.on("change",(l,g)=>{if(E.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${g}`);let A="";if(g&&(A=g.toString(),a.$k&&(A=(0,S.$ol)(A))),!(!A||l!=="change"&&l!=="rename"))if(h)if(l==="rename"){n.get(A)?.dispose();const R=setTimeout(async()=>{if(n.delete(A),A===o&&!await f.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,u.$ic)(d,A));if(E.token.isCancellationRequested)return;let I;k?t.has(A)?I=0:(I=1,t.add(A)):(t.delete(A),I=2),this.y({resource:(0,m.$vg)(i,A),type:I,cId:this.m.correlationId})},w.a);n.set(A,(0,C.$Pc)(()=>clearTimeout(R)))}else{let R;t.has(A)?R=0:(R=1,t.add(A)),this.y({resource:(0,m.$vg)(i,A),type:R,cId:this.m.correlationId})}else if(l==="rename"||A!==o){const R=setTimeout(async()=>{const k=await f.Promises.exists(d);E.token.isCancellationRequested||(k?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),c.add(await this.w(d,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},w.a);c.clear(),c.add((0,C.$Pc)(()=>clearTimeout(R)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await f.Promises.exists(d)&&!E.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${i.toString()})`)}return(0,C.$Pc)(()=>{E.dispose(!0),c.dispose()})}y(d,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!h&&this.g.some(E=>E(d.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${d.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(E=>E(d.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}z(d){const h=(0,v.$Wp)(d);if(h.length>0){if(this.s)for(const c of h)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if(a.$l)return f.Promises.exists(d);try{const h=(0,u.$mc)(d);return(await f.Promises.readdir((0,u.$lc)(d))).some(c=>c===h)}catch(h){return this.G(h),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$_p=w;async function p($,d,h,E,c=512){const i=await f.Promises.open($,"r"),o=Buffer.allocUnsafe(c),r=new s.$Xd(E);let t,n=!1;const l={path:$,excludes:[],recursive:!1},g=new w(l,A=>{(async()=>{for(const{type:R}of A)if(R===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:k}=await f.Promises.read(i,o,0,c,null);if(!k||r.token.isCancellationRequested)break;d(o.slice(0,k))}}catch(k){t=new Error(k),r.dispose(!0)}finally{n=!1}}})()});return await g.ready,h(),new Promise((A,R)=>{r.token.onCancellationRequested(async()=>{g.dispose();try{await f.Promises.close(i)}catch(k){t=new Error(k)}t?R(t):A()})})}e.$aq=p}),define(ne[215],se([0,1,3,104,2,4,214]),function(Q,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;class S extends s.$Rc{constructor(){super(...arguments),this.a=this.B(new P.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(a){const m=this.j(a),b=m.filter(f=>{const v=this.c.get(f.path);return v?!(0,D.$Aj)(v.request.excludes,f.excludes)||!(0,D.$Aj)(v.request.includes,f.includes):!0}),y=Array.from(this.c.values()).filter(({request:f})=>!m.find(v=>v.path===f.path&&(0,D.$Aj)(v.excludes,f.excludes)&&(0,D.$Aj)(v.includes,f.includes))).map(({request:f})=>f.path);b.length&&this.m(`Request to start watching: ${b.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),y.length&&this.m(`Request to stop watching: ${y.join(",")}`);for(const f of y)this.h(f);for(const f of b)this.g(f)}g(a){const m=new C.$_p(a,y=>this.a.fire(y),y=>this.b.fire(y),this.f),b={request:a,instance:m};this.c.set(a.path,b)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const m=this.c.get(a);m&&(this.c.delete(a),m.instance.dispose())}j(a){const m=new Map;for(const b of a){const y=M.$l?b.path:b.path.toLowerCase();let f=m.get(b.correlationId);f||(f=new Map,m.set(b.correlationId,f)),f.set(y,b)}return Array.from(m.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(a){this.f=a;for(const[,m]of this.c)m.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,m){return m?`[File Watcher (node.js)] ${a} (path: ${m.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$bq=S}),define(ne[216],se([0,1,65,215]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class s extends P.$Tp{constructor(C,S,u){super(C,S,u),this.s()}r(C){return C.add(new D.$bq)}}e.$cq=s}),define(ne[217],se([0,1,13,42,160,65]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;class C extends M.$Up{constructor(u,a,m){super(u,a,m),this.s()}r(u){const a=u.add(new s.$6p(P.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:m,signal:b})=>this.t(`terminated by itself with code ${m}, signal: ${b}`))),D.ProxyChannel.toService((0,D.$wh)(a.getChannel("watcher")))}}e.$7p=C}),define(ne[92],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class P{constructor(...s){this.a=new Map;for(const[M,C]of s)this.set(M,C)}set(s,M){const C=this.a.get(s);return this.a.set(s,M),C}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Nh=P}),define(ne[218],se([0,1,8,14,2,78,208,5,92,101]),function(Q,e,P,D,s,M,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;const m=!1;class b extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class y{constructor(p=new u.$Nh,$=!1,d,h=m){this.f=p,this.g=$,this.h=d,this.i=h,this.o=new Set,this.f.set(S.$Oh,this),this._globalGraph=h?d?._globalGraph??new C.$fq(E=>E):void 0}createChild(p){return new y(p,this.g,this,this.i)}invokeFunction(p,...$){const d=v.traceInvocation(this.i,p);let h=!1;try{return p({get:c=>{if(h)throw(0,D.$7)("service accessor is only valid during the invocation of its target method");const i=this.m(c,d);if(!i)throw new Error(`[invokeFunction] unknown service '${c}'`);return i}},...$)}finally{h=!0,d.stop()}}createInstance(p,...$){let d,h;return p instanceof M.$Mh?(d=v.traceCreation(this.i,p.ctor),h=this.j(p.ctor,p.staticArguments.concat($),d)):(d=v.traceCreation(this.i,p),h=this.j(p,$,d)),d.stop(),h}j(p,$=[],d){const h=S._util.getServiceDependencies(p).sort((i,o)=>i.index-o.index),E=[];for(const i of h){const o=this.m(i.id,d);o||this.u(`[createInstance] ${p.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(o)}const c=h.length>0?h[0].index:$.length;if($.length!==c){console.trace(`[createInstance] First service dependency of ${p.name} at position ${c+1} conflicts with ${$.length} static arguments`);const i=c-$.length;i>0?$=$.concat(new Array(i)):$=$.slice(0,c)}return Reflect.construct(p,$.concat(E))}k(p,$){if(this.f.get(p)instanceof M.$Mh)this.f.set(p,$);else if(this.h)this.h.k(p,$);else throw new Error("illegalState - setting UNKNOWN service instance")}l(p){const $=this.f.get(p);return!$&&this.h?this.h.l(p):$}m(p,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const d=this.l(p);return d instanceof M.$Mh?this.q(p,d,$.branch(p,!0)):($.branch(p,!1),d)}q(p,$,d){if(this.o.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.o.add(p);try{return this.r(p,$,d)}finally{this.o.delete(p)}}r(p,$,d){const h=new C.$fq(i=>i.id.toString());let E=0;const c=[{id:p,desc:$,_trace:d}];for(;c.length;){const i=c.pop();if(h.lookupOrInsertNode(i),E++>1e3)throw new b(h);for(const o of S._util.getServiceDependencies(i.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${p} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),r instanceof M.$Mh){const t={id:o.id,desc:r,_trace:i._trace.branch(o.id,!0)};h.insertEdge(i,t),c.push(t)}}}for(;;){const i=h.roots();if(i.length===0){if(!h.isEmpty())throw new b(h);break}for(const{data:o}of i){if(this.l(o.id)instanceof M.$Mh){const t=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,t)}h.removeNode(o)}}return this.l(p)}s(p,$,d=[],h,E){if(this.f.get(p)instanceof M.$Mh)return this.t(p,$,d,h,E);if(this.h)return this.h.s(p,$,d,h,E);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}t(p,$,d=[],h,E){if(h){const c=new y(void 0,this.g,this,this.i);c.c=String(p);const i=new Map,o=new P.$$g(()=>{const r=c.j($,d,E);for(const[t,n]of i){const l=r[t];if(typeof l=="function")for(const g of n)l.apply(r,g)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,t){if(!o.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let g=i.get(t);return g||(g=new a.$1c,i.set(t,g)),(R,k,I)=>{const L=g.push([R,k,I]);return(0,s.$Pc)(L)}}if(t in r)return r[t];const n=o.value;let l=n[t];return typeof l!="function"||(l=l.bind(n),r[t]=l),l},set(r,t,n){return o.value[t]=n,!0},getPrototypeOf(r){return $.prototype}})}else return this.j($,d,E)}u(p,$){if($&&console.warn(p),this.g)throw new Error(p)}}e.$gq=y;var f;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(f||(f={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,$){return p?new v(2,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(p,$){return p?new v(1,$.name):v.c}static{this.f=0}constructor(p,$){this.type=p,this.name=$,this.g=Date.now(),this.h=[]}branch(p,$){const d=new v(3,p.toString());return this.h.push([p,$,d]),d}stop(){const p=Date.now()-this.g;v.f+=p;let $=!1;function d(E,c){const i=[],o=new Array(E+1).join("	");for(const[r,t,n]of c.h)if(t&&n){$=!0,i.push(`${o}CREATES -> ${r}`);const l=d(E+1,n);l&&i.push(l)}else i.push(`${o}uses -> ${r}`);return i.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(p>2||$)&&v.all.add(h.join(`
`))}}e.$hq=v}),define(ne[219],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qxb=e.IssueType=void 0;var D;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(D||(e.IssueType=D={})),e.$qxb=(0,P.$Ph)("issueService")}),define(ne[6],se([0,1,49,3,56,2,31,4,19,12,7,114,5]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,y.$Ph)("logService"),e.$$i=(0,y.$Ph)("loggerService");function f(){return new Date().toISOString()}function v(R){return(0,a.$Cf)(R)}e.$_i=v;var w;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$aj=w.Info;function p(R,k,I){switch(k){case w.Trace:R.trace(I);break;case w.Debug:R.debug(I);break;case w.Info:R.info(I);break;case w.Warning:R.warn(I);break;case w.Error:R.error(I);break;case w.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=p;function $(R,k=!1){let I="";for(let L=0;L<R.length;L++){let N=R[L];if(N instanceof Error&&(N=(0,P.$Ai)(N,k)),typeof N=="object")try{N=JSON.stringify(N)}catch{}I+=(L>0?" ":"")+N}return I}class d extends M.$Rc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new D.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==w.Off&&this.b<=k}}e.$cj=d;class h extends d{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...I){this.f(w.Trace)&&this.g(w.Trace,$([k,...I],!0))}debug(k,...I){this.f(w.Debug)&&this.g(w.Debug,$([k,...I]))}info(k,...I){this.f(w.Info)&&this.g(w.Info,$([k,...I]))}warn(k,...I){this.f(w.Warning)&&this.g(w.Warning,$([k,...I]))}error(k,...I){if(this.f(w.Error))if(k instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=k.stack,this.g(w.Error,$(L))}else this.g(w.Error,$([k,...I]))}flush(){}}e.$dj=h;class E extends d{constructor(k=e.$aj){super(),this.setLevel(k),this.g=!S.$j}trace(k,...I){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...I):console.log(`[main ${f()}]`,k,...I))}debug(k,...I){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...I):console.log(`[main ${f()}]`,k,...I))}info(k,...I){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...I):console.log(`[main ${f()}]`,k,...I))}warn(k,...I){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,k,...I):console.warn(`[main ${f()}]`,k,...I))}error(k,...I){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,k,...I):console.error(`[main ${f()}]`,k,...I))}dispose(){}flush(){}}e.$ej=E;class c extends d{constructor(k=e.$aj,I=!0){super(),this.g=I,this.setLevel(k)}trace(k,...I){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...I):console.log(k,...I))}debug(k,...I){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...I):console.log(k,...I))}info(k,...I){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...I):console.log(k,...I))}warn(k,...I){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...I):console.log(k,...I))}error(k,...I){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...I):console.error(k,...I))}dispose(){}flush(){}}e.$fj=c;class i extends d{constructor(k,I=e.$aj){super(),this.g=k,this.setLevel(I)}trace(k,...I){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(k),...I])}debug(k,...I){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(k),...I])}info(k,...I){this.f(w.Info)&&this.g.log(w.Info,[this.h(k),...I])}warn(k,...I){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(k),...I])}error(k,...I){this.f(w.Error)&&this.g.log(w.Error,[this.h(k),...I])}h(k){return typeof k=="string"?k:(0,P.$Ai)(k,this.f(w.Trace))}dispose(){}flush(){}}e.$gj=i;class o extends d{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const I of this.g)I.setLevel(k);super.setLevel(k)}trace(k,...I){for(const L of this.g)L.trace(k,...I)}debug(k,...I){for(const L of this.g)L.debug(k,...I)}info(k,...I){for(const L of this.g)L.info(k,...I)}warn(k,...I){for(const L of this.g)L.warn(k,...I)}error(k,...I){for(const L of this.g)L.error(k,...I)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.$hj=o;class r extends M.$Rc{constructor(k,I,L){if(super(),this.h=k,this.j=I,this.b=new C.$zc,this.c=this.B(new D.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Nd),this.onDidChangeVisibility=this.g.event,L)for(const N of L)this.b.set(N.resource,{logger:void 0,info:N})}m(k){return(0,a.$yf)(k)?[...this.b.values()].find(I=>I.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,I){const L=this.n(k),N=(0,a.$yf)(k)?k:I?.id??(0,s.$Di)(L.toString()).toString(16);let T=this.b.get(L)?.logger;const x=I?.logLevel==="always"?w.Trace:I?.logLevel;T||(T=this.s(L,x??this.getLogLevel(L)??this.h,{...I,id:N}));const X={logger:T,info:{resource:L,id:N,logLevel:x,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(X.info),this.b.set(L,X),T}n(k){return(0,a.$yf)(k)?(0,u.$vg)(this.j,`${k}.log`):k}setLogLevel(k,I){if(m.URI.isUri(k)){const L=k,N=I,T=this.b.get(L);T&&N!==T.info.logLevel&&(T.info.logLevel=N===this.h?void 0:N,T.logger?.setLevel(N),this.b.set(T.info.resource,T),this.f.fire([L,N]))}else{this.h=k;for(const[L,N]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,I){const L=this.m(k);L&&I!==!L.info.hidden&&(L.info.hidden=!I,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,I]))}getLogLevel(k){let I;return k&&(I=this.b.get(k)?.info.logLevel),I??this.h}registerLogger(k){const I=this.b.get(k.resource);I?I.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const I=this.b.get(k);I&&(I.logger&&I.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=r;class t{constructor(){this.onDidChangeLogLevel=new D.$Nd().event}setLevel(k){}getLevel(){return w.Info}trace(k,...I){}debug(k,...I){}info(k,...I){}warn(k,...I){}error(k,...I){}critical(k,...I){}dispose(){}flush(){}}e.$jj=t;class n extends t{}e.$kj=n;function l(R){if(R.verbose)return w.Trace;if(typeof R.logLevel=="string"){const k=A(R.logLevel.toLowerCase());if(k!==void 0)return k}return e.$aj}e.$lj=l;function g(R){switch(R){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$mj=g;function A(R){switch(R){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$nj=A,e.$oj=new b.$7i("logLevel",g(w.Info))});var te=this&&this.__param||function(Q,e){return function(P,D){e(P,D,Q)}};define(ne[220],se([0,1,15,4,6]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v7b=void 0;const M=P.safeStorage;let C=class{constructor(u){this.a=u,P.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(u){this.a.trace("[EncryptionMainService] Encrypting value.");try{const a=JSON.stringify(M.encryptString(u));return this.a.trace("[EncryptionMainService] Encrypted value."),a}catch(a){throw this.a.error(a),a}}async decrypt(u){let a;try{if(a=JSON.parse(u),!a.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${u}`);const m=Buffer.from(a.data);this.a.trace("[EncryptionMainService] Decrypting value.");const b=M.decryptString(m);return this.a.trace("[EncryptionMainService] Decrypted value."),b}catch(m){throw this.a.error(m),m}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(D.$j)return Promise.resolve("dpapi");if(D.$k)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const u=M.getSelectedStorageBackend();return Promise.resolve(u)}catch(u){this.a.error(u)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(D.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(D.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$v7b=C,e.$v7b=C=ve([te(0,s.$0i)],C)}),define(ne[221],se([0,1,23,8,14,3,2,9,65,6]),function(Q,e,P,D,s,M,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class m extends C.$Rc{constructor(y,f){super(),this.a=y,this.b=f,this.c=this.B(new M.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$Rg(0)),this.w=[],this.y=this.B(new D.$Rg(0))}watch(y,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(y,f):this.z(y,f)}n(y,f){const v={path:this.H(y),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},w=(0,P.$Tb)(this.j,v);return this.r(),(0,C.$Pc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,s.$Z)(y))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,u.$Vp)(f)),f=>this.G(f),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const f of this.j)(0,u.$Rp)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const f of this.j)(0,u.$Rp)(f)&&y.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,f){const v={path:this.H(y),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},w=(0,P.$Tb)(this.w,v);return this.C(),(0,C.$Pc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,s.$Z)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,u.$Vp)(y)),y=>this.G(y),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}H(y){return(0,S.$gc)(y.fsPath)}}e.$Zp=m}),define(ne[222],se([0,1,23,8,17,22,3,56,71,2,57,13,66,19,61,175,16,118,6,14]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$,d,h){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;let c=class extends a.$Rc{static{E=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new C.$Nd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$Nd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$Nd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$Nd),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$Nd),this.Y=this.B(new C.$Nd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$Nd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$3g)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${o}`);const t=new a.$Qc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),t.add(r.onDidChangeFile(n=>{const l=new p.$rk(n,!this.S(r));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,a.$Pc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,a.$Mc)(t)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(t){r.push(t)}}),!this.h.has(o)&&await D.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const t=this.h.get(o.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return u.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,f.$zg)(o))throw new p.$tk((0,w.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const t=new h.$ab;throw t.message=(0,w.localize)(1,null,o.toString()),t}return r}async m(o){const r=await this.j(o);if((0,p.$ek)(r)||(0,p.$bk)(r)||(0,p.$fk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,p.$ek)(r)||(0,p.$bk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(t){throw(0,p.$ok)(t)===p.FileSystemProviderErrorCode.FileNotFound?new p.$tk((0,w.localize)(2,null,this.sb(o)),1):(0,p.$mk)(t)}}async s(o,r){const t=await this.j(o),n=this.S(t),l=r?.resolveTo,g=r?.resolveSingleChildDescendants,A=r?.resolveMetadata,R=await t.stat(o);let k;return this.t(t,o,R,void 0,!!A,(I,L)=>(k||(k=m.$Vh.forUris(()=>!n),k.set(o,!0),l&&k.fill(!0,l)),k.get(I.resource)||k.findSuperstr(I.resource.with({query:null,fragment:null}))?!0:I.isDirectory&&g?L===1:!1))}async t(o,r,t,n,l,g){const{providerExtUri:A}=this.R(o),R={resource:r,name:A.basename(r),isFile:(t.type&p.FileType.File)!==0,isDirectory:(t.type&p.FileType.Directory)!==0,isSymbolicLink:(t.type&p.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&p.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((t.permissions??0)&p.FilePermission.Locked),etag:(0,p.$Ek)({mtime:t.mtime,size:t.size}),children:void 0};if(R.isDirectory&&g(R,n)){try{const k=await o.readdir(r),I=await D.Promises.settled(k.map(async([L,N])=>{try{const T=A.joinPath(r,L),x=l?await o.stat(T):{type:N};return await this.t(o,T,x,k.length,l,g)}catch(T){return this.b.trace(T),null}}));R.children=(0,P.$Gb)(I)}catch(k){this.b.trace(k),R.children=[]}return R}return R}async resolveAll(o){return D.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),t=await r.stat(o);return this.t(r,o,t,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(t){return t}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new p.$tk((0,w.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=s.$be.fromString(""),t){await this.u(o,t);const n=await this.writeFile(o,r);return this.r.fire(new p.$qk(o,0,n)),n}async writeFile(o,r,t){const n=this.qb(await this.n(o),o),{providerExtUri:l}=this.R(n);let g=t;if((0,p.$hk)(n)&&!g?.atomic){const A=n.enforceAtomicWriteFile?.(o);A&&(g={...t,atomic:A})}try{await this.w(n,o,g)||await this.U(n,l.dirname(o));let R;if((0,p.$bk)(n)&&!(r instanceof s.$be))if((0,v.$Zd)(r)){const k=await(0,v.$7d)(r,3);k.ended?R=s.$be.concat(k.buffer):R=k}else R=(0,v.$4d)(r,k=>s.$be.concat(k),3);else R=r;!(0,p.$ek)(n)||(0,p.$bk)(n)&&R instanceof s.$be||(0,p.$bk)(n)&&(0,p.$hk)(n)&&g?.atomic?await this.hb(n,o,g,R):await this.db(n,o,g,R instanceof s.$be?(0,s.$me)(R):R),this.r.fire(new p.$qk(o,4))}catch(A){throw new p.$tk((0,w.localize)(4,null,this.sb(o),(0,p.$mk)(A).toString()),(0,p.$pk)(A),g)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,t){const n=!!t?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,w.localize)(5,null,this.sb(r)));if(!!t?.atomic){if(!(o.capabilities&32768))throw new Error((0,w.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,w.localize)(7,null,this.sb(r)));if(n)throw new Error((0,w.localize)(8,null,this.sb(r)))}let g;try{g=await o.stat(r)}catch{return}if(g.type&p.FileType.Directory)throw new p.$tk((0,w.localize)(9,null,this.sb(r)),0,t);if(this.rb(r,g),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==p.$Dk&&typeof g.mtime=="number"&&typeof g.size=="number"&&t.mtime<g.mtime&&t.etag!==(0,p.$Ek)({mtime:t.mtime,size:g.size}))throw new p.$tk((0,w.localize)(10,null),3,t);return g}async readFile(o,r,t){const n=await this.m(o);return r?.atomic?this.z(n,o,r,t):this.C(n,o,r,t)}async z(o,r,t,n){return new Promise((l,g)=>{this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{try{const A=await this.C(o,r,t,n);l(A)}catch(A){g(A)}})})}async C(o,r,t,n){const l=await this.D(o,r,{...t,preferUnbuffered:!0},n);return{...l,value:await(0,s.$ne)(l.value)}}async readFileStream(o,r,t){const n=await this.m(o);return this.D(n,o,r,t)}async D(o,r,t,n){const l=new M.$Xd(n);let g=t;(0,p.$gk)(o)&&o.enforceAtomicReadFile?.(r)&&(g={...t,atomic:!0});const A=this.J(r,g).then(k=>k,k=>{throw l.dispose(!0),k});let R;try{return typeof g?.etag=="string"&&g.etag!==p.$Dk&&await A,g?.atomic&&(0,p.$gk)(o)||!((0,p.$ek)(o)||(0,p.$fk)(o))||(0,p.$bk)(o)&&g?.preferUnbuffered?R=this.I(o,r,g):(0,p.$fk)(o)?R=this.G(o,r,l.token,g):R=this.H(o,r,l.token,g),R.on("end",()=>l.dispose()),R.on("error",()=>l.dispose()),{...await A,value:R}}catch(k){throw R&&await(0,v.$5d)(R),this.F(k,r,g)}}F(o,r,t){const n=(0,w.localize)(11,null,this.sb(r),(0,p.$mk)(o).toString());return o instanceof p.$vk?new p.$vk(n,o.stat,t):o instanceof p.$uk?new p.$uk(n,o.fileOperationResult,o.size,o.options):new p.$tk(n,(0,p.$pk)(o),t)}G(o,r,t,n=Object.create(null)){const l=o.readFileStream(r,n,t);return(0,v.$$d)(l,{data:g=>g instanceof s.$be?g:s.$be.wrap(g),error:g=>this.F(g,r,n)},g=>s.$be.concat(g))}H(o,r,t,n=Object.create(null)){const l=(0,s.$re)();return(0,$.$Pp)(o,r,l,g=>g,{...n,bufferSize:this.a,errorTransformer:g=>this.F(g,r,n)},t),l}I(o,r,t){const n=(0,v.$2d)(l=>s.$be.concat(l));return(async()=>{try{let l;t?.atomic&&(0,p.$gk)(o)?l=await o.readFile(r,{atomic:!0}):l=await o.readFile(r),typeof t?.position=="number"&&(l=l.slice(t.position)),typeof t?.length=="number"&&(l=l.slice(0,t.length)),this.L(r,l.byteLength,t),n.end(s.$be.wrap(l))}catch(l){n.error(l),n.end()}})(),n}async J(o,r){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new p.$tk((0,w.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==p.$Dk&&r.etag===t.etag)throw new p.$vk((0,w.localize)(13,null),t,r);return this.L(o,t.size,r),t}L(o,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new p.$uk((0,w.localize)(14,null,this.sb(o)),7,r,t)}async canMove(o,r,t){return this.M(o,r,"move",t)}async canCopy(o,r,t){return this.M(o,r,"copy",t)}async M(o,r,t,n){if(o.toString()!==r.toString())try{const l=t==="move"?this.qb(await this.n(o),o):await this.m(o),g=this.qb(await this.n(r),r);await this.Q(l,o,g,r,t,n)}catch(l){return l}return!0}async move(o,r,t){const n=this.qb(await this.n(o),o),l=this.qb(await this.n(r),r),g=await this.N(n,o,l,r,"move",!!t),A=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new p.$qk(o,g==="move"?2:3,A)),A}async copy(o,r,t){const n=await this.m(o),l=this.qb(await this.n(r),r),g=await this.N(n,o,l,r,"copy",!!t),A=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new p.$qk(o,g==="copy"?3:2,A)),A}async N(o,r,t,n,l,g){if(r.toString()===n.toString())return l;const{exists:A,isSameResourceWithDifferentPathCase:R}=await this.Q(o,r,t,n,l,g);if(A&&!R&&g&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),l==="copy"){if(o===t&&(0,p.$ck)(o))await o.copy(r,n,{overwrite:g});else{const k=await this.resolve(r);k.isDirectory?await this.P(o,k,t,n):await this.O(o,r,t,n)}return l}else return o===t?(await o.rename(r,n,{overwrite:g}),l):(await this.N(o,r,t,n,"copy",g),await this.del(r,{recursive:!0}),"copy")}async O(o,r,t,n){if((0,p.$ek)(o)&&(0,p.$ek)(t))return this.jb(o,r,t,n);if((0,p.$ek)(o)&&(0,p.$bk)(t))return this.pb(o,r,t,n);if((0,p.$bk)(o)&&(0,p.$ek)(t))return this.nb(o,r,t,n);if((0,p.$bk)(o)&&(0,p.$bk)(t))return this.lb(o,r,t,n)}async P(o,r,t,n){await t.mkdir(n),Array.isArray(r.children)&&await D.Promises.settled(r.children.map(async l=>{const g=this.R(t).providerExtUri.joinPath(n,l.name);return l.isDirectory?this.P(o,await this.resolve(l.resource),t,g):this.O(o,l.resource,t,g)}))}async Q(o,r,t,n,l,g){let A=!1;if(o===t){const{providerExtUri:k,isPathCaseSensitive:I}=this.R(o);if(I||(A=k.isEqual(r,n)),A&&l==="copy")throw new Error((0,w.localize)(15,null,this.sb(r),this.sb(n)));if(!A&&k.isEqualOrParent(n,r))throw new Error((0,w.localize)(16,null,this.sb(r),this.sb(n)))}const R=await this.exists(n);if(R&&!A){if(!g)throw new p.$tk((0,w.localize)(17,null,this.sb(r),this.sb(n)),4);if(o===t){const{providerExtUri:k}=this.R(o);if(k.isEqualOrParent(r,n))throw new Error((0,w.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:R,isSameResourceWithDifferentPathCase:A}}R(o){const r=this.S(o);return{providerExtUri:r?f.$lg:f.$ng,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const t=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new p.$qk(o,0,t)),t}async U(o,r){const t=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&p.FileType.Directory))throw new Error((0,w.localize)(19,null,this.sb(r)));break}catch(l){if((0,p.$ok)(l)!==p.FileSystemProviderErrorCode.FileNotFound)throw l;t.push(n.basename(r)),r=n.dirname(r)}for(let l=t.length-1;l>=0;l--){r=n.joinPath(r,t[l]);try{await o.mkdir(r)}catch(g){if((0,p.$ok)(g)!==p.FileSystemProviderErrorCode.FileExists)throw g}}}async canDelete(o,r){try{await this.W(o,r)}catch(t){return t}return!0}async W(o,r){const t=this.qb(await this.j(o),o),n=!!r?.useTrash;if(n&&!(t.capabilities&4096))throw new Error((0,w.localize)(20,null,this.sb(o)));const l=r?.atomic;if(l&&!(t.capabilities&65536))throw new Error((0,w.localize)(21,null,this.sb(o)));if(n&&l)throw new Error((0,w.localize)(22,null,this.sb(o)));let g;try{g=await t.stat(o)}catch{}if(g)this.rb(o,g);else throw new p.$tk((0,w.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const R=await this.resolve(o);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,w.localize)(24,null,this.sb(o)))}return t}async del(o,r){const t=await this.W(o,r);let n=r;if((0,p.$ik)(t)&&!n?.atomic){const R=t.enforceAtomicDelete?.(o);R&&(n={...r,atomic:R})}const l=!!n?.useTrash,g=!!n?.recursive,A=n?.atomic??!1;await t.delete(o,{recursive:g,useTrash:l,atomic:A}),this.r.fire(new p.$qk(o,1))}async cloneFile(o,r){const t=await this.j(o),n=this.qb(await this.n(r),r);if(t===n&&this.R(t).providerExtUri.isEqual(o,r))return;if(t===n&&(0,p.$dk)(t))return t.cloneFile(o,r);await this.U(n,this.R(n).providerExtUri.dirname(r));const l=this.cb.queueFor(o,this.R(t).providerExtUri);return t===n&&(0,p.$ck)(t)?l.queue(()=>t.copy(o,r,{overwrite:!0})):l.queue(()=>this.O(t,o,n,r))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:E.ab++})}watch(o,r={recursive:!1,excludes:[]}){const t=new a.$Qc;let n=!1,l=()=>{n=!0};t.add((0,a.$Pc)(()=>l())),(async()=>{try{const A=await this.bb(o,r);n?(0,a.$Mc)(A):l=()=>(0,a.$Mc)(A)}catch(A){this.b.error(A)}})();const g=r.correlationId;if(typeof g=="number"){const A=t.add(new C.$Nd);return t.add(this.X.event(k=>{k.correlates(g)&&A.fire(k)})),{onDidChange:A.event,dispose:()=>t.dispose()}}return t}async bb(o,r){const t=await this.j(o),n=(0,S.$Di)([this.R(t).providerExtUri.getComparisonKey(o),r]);let l=this.$.get(n);return l||(l={count:0,disposable:t.watch(o,r)},this.$.set(n,l)),l.count+=1,(0,a.$Pc)(()=>{l&&(l.count--,l.count===0&&((0,a.$Mc)(l.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,a.$Mc)(o.disposable);this.$.clear()}async db(o,r,t,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{const l=await o.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,v.$Zd)(n)||(0,v.$1d)(n)?await this.eb(o,l,n):await this.fb(o,l,n)}catch(g){throw(0,p.$mk)(g)}finally{await o.close(l)}})}async eb(o,r,t){let n=0,l;if((0,v.$1d)(t)){if(t.buffer.length>0){const g=s.$be.concat(t.buffer);await this.gb(o,r,g,g.byteLength,n,0),n+=g.byteLength}if(t.ended)return;l=t.stream}else l=t;return new Promise((g,A)=>{(0,v.$6d)(l,{onData:async R=>{l.pause();try{await this.gb(o,r,R,R.byteLength,n,0)}catch(k){return A(k)}n+=R.byteLength,setTimeout(()=>l.resume())},onError:R=>A(R),onEnd:()=>g()})})}async fb(o,r,t){let n=0,l;for(;(l=t.read())!==null;)await this.gb(o,r,l,l.byteLength,n,0),n+=l.byteLength}async gb(o,r,t,n,l,g){let A=0;for(;A<n;){const R=await o.write(r,l+A,t.buffer,g+A,n-A);A+=R}}async hb(o,r,t,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(()=>this.ib(o,r,t,n))}async ib(o,r,t,n){let l;n instanceof s.$be?l=n:(0,v.$Zd)(n)?l=await(0,s.$ne)(n):(0,v.$1d)(n)?l=await(0,s.$oe)(n):l=(0,s.$le)(n),await o.writeFile(r,l.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.kb(o,r,t,n))}async kb(o,r,t,n){let l,g;try{l=await o.open(r,{create:!1}),g=await t.open(n,{create:!0,unlock:!1});const A=s.$be.alloc(this.a);let R=0,k=0,I=0;do I=await o.read(l,R,A.buffer,k,A.byteLength-k),await this.gb(t,g,A,I,R,k),R+=I,k+=I,k===A.byteLength&&(k=0);while(I>0)}catch(A){throw(0,p.$mk)(A)}finally{await D.Promises.settled([typeof l=="number"?o.close(l):Promise.resolve(),typeof g=="number"?t.close(g):Promise.resolve()])}}async lb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.mb(o,r,t,n))}async mb(o,r,t,n){return t.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.ob(o,r,t,n))}async ob(o,r,t,n){const l=await t.open(n,{create:!0,unlock:!1});try{const g=await o.readFile(r);await this.gb(t,l,s.$be.wrap(g),g.byteLength,0,0)}catch(g){throw(0,p.$mk)(g)}finally{await t.close(l)}}async pb(o,r,t,n){const l=await(0,s.$ne)(this.H(o,r,M.CancellationToken.None));await this.hb(t,n,void 0,l)}qb(o,r){if(o.capabilities&2048)throw new p.$tk((0,w.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&p.FilePermission.Readonly)throw new p.$tk((0,w.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===b.Schemas.file?o.fsPath:o.toString(!0)}};e.$Qp=c,e.$Qp=c=E=ve([te(0,d.$0i)],c)}),define(ne[93],se([0,1,45,311,8,31,17,3,33,2,9,4,19,61,21,179,16,118,221,49,217,216]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$,d,h,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0,(()=>{try{(0,D.gracefulify)(P)}catch(o){console.error(`Error enabling graceful-fs: ${(0,h.$Ai)(o)}`)}})();class i extends d.$Zp{static{this.I=!1}constructor(r,t){super(r,t),this.onDidChangeCapabilities=S.Event.None,this.N=new M.$zc(n=>y.$mg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,b.$l&&(this.J|=1024)),this.J}async stat(r){try{const{stat:t,symbolicLink:n}=await v.SymlinkSupport.stat(this.H(r));return{type:this.M(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:p.FilePermission.Locked}}catch(t){throw this.fb(t)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const t=await v.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(t.map(async l=>{try{let g;l.isSymbolicLink()?g=(await this.stat((0,y.$vg)(r,l.name))).type:g=this.M(l),n.push([l.name,g])}catch(g){this.a.trace(g)}})),n}catch(t){throw this.fb(t)}}M(r,t){let n;return t?.dangling?n=p.FileType.Unknown:r.isFile()?n=p.FileType.File:r.isDirectory()?n=p.FileType.Directory:n=p.FileType.Unknown,t&&(n|=p.FileType.SymbolicLink),n}async O(r){const t=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await n.wait();const l=new s.$Sg;return this.N.set(r,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,a.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.N.get(r)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),l.open()})}async readFile(r,t){let n;try{t?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const l=this.H(r);return await v.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{n?.dispose()}}P(r){i.I&&this.a.trace(r)}readFileStream(r,t,n){const l=(0,f.$2d)(g=>C.$be.concat(g.map(A=>C.$be.wrap(A))).buffer);return(0,$.$Pp)(this,r,l,g=>g.buffer,{...t,bufferSize:256*1024},n),l}async writeFile(r,t,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,y.$vg)((0,y.$ug)(r),`${(0,y.$sg)(r)}${n.atomic.postfix}`),t,n):this.S(r,t,n)}async Q(r){try{const t=this.H(r),{symbolicLink:n}=await v.SymlinkSupport.stat(t);if(n)return!1}catch{}return!0}async R(r,t,n,l){const g=new a.$Qc;try{g.add(await this.O(r)),g.add(await this.O(t)),await this.S(t,n,l,!0);try{await this.rename(t,r,{overwrite:!0})}catch(A){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw A}}finally{g.dispose()}}async S(r,t,n,l){let g;try{const A=this.H(r);if(!n.create||!n.overwrite){if(await v.Promises.exists(A)){if(!n.overwrite)throw(0,p.$lk)((0,w.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,p.$lk)((0,w.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(r,{create:!0,unlock:n.unlock},l),await this.write(g,0,t,0,t.byteLength)}catch(A){throw await this.gb(r,A)}finally{typeof g=="number"&&await this.close(g)}}static{this.Y=!0}static configureFlushOnWrite(r){i.Y=r}async open(r,t,n){const l=this.H(r);let g;(0,p.$_j)(t)&&!n&&(g=await this.O(r));let A;try{if((0,p.$_j)(t)&&t.unlock)try{const{stat:k}=await v.SymlinkSupport.stat(l);k.mode&128||await v.Promises.chmod(l,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let R;if((0,p.$_j)(t)){if(b.$j)try{await v.Promises.truncate(l,0),R="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}R||(R="w")}else R="r";A=await v.Promises.open(l,R)}catch(R){throw g?.dispose(),(0,p.$_j)(t)?await this.gb(r,R):this.fb(R)}if(this.U.set(A,0),(0,p.$_j)(t)&&this.X.set(A,r),g){const R=this.W.get(A);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${A} (${l})`),this.W.set(A,g),R&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${A} (${l})`),R.dispose())}return A}async close(r){const t=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&i.Y)try{await v.Promises.fdatasync(r)}catch(n){i.configureFlushOnWrite(!1),this.a.error(n)}return await v.Promises.close(r)}catch(n){throw this.fb(n)}finally{t&&(this.W.get(r)===t&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),t.dispose())}}async read(r,t,n,l,g){const A=this.Z(r,t);let R=null;try{R=(await v.Promises.read(r,n,l,g,A)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(r,A,R)}return R}Z(r,t){return t===this.U.get(r)?null:t}$(r,t,n){const l=this.U.get(r);typeof l=="number"&&(typeof t=="number"||(typeof n=="number"?this.U.set(r,l+n):this.U.delete(r)))}async write(r,t,n,l,g){return(0,s.$_g)(()=>this.ab(r,t,n,l,g),100,3)}async ab(r,t,n,l,g){const A=this.Z(r,t);let R=null;try{R=(await v.Promises.write(r,n,l,g,A)).bytesWritten}catch(k){throw await this.gb(this.X.get(r),k)}finally{this.$(r,A,R)}return R}async mkdir(r){try{await v.Promises.mkdir(this.H(r))}catch(t){throw this.fb(t)}}async delete(r,t){try{const n=this.H(r);if(t.recursive){let l;t?.atomic!==!1&&t.atomic.postfix&&(l=(0,m.$ic)((0,m.$lc)(n),`${(0,m.$mc)(n)}${t.atomic.postfix}`)),await v.Promises.rm(n,v.RimRafMode.MOVE,l)}else try{await v.Promises.unlink(n)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let g=!1;try{const{stat:A,symbolicLink:R}=await v.SymlinkSupport.stat(n);g=A.isDirectory()&&!R}catch{}if(g)await v.Promises.rmdir(n);else throw l}else throw l}}catch(n){throw this.fb(n)}}async rename(r,t,n){const l=this.H(r),g=this.H(t);if(l!==g)try{await this.bb(r,t,"move",n.overwrite),await v.Promises.rename(l,g)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,w.localize)(2,null,(0,m.$mc)(l),(0,m.$mc)((0,m.$lc)(g)),A.toString()))),this.fb(A)}}async copy(r,t,n){const l=this.H(r),g=this.H(t);if(l!==g)try{await this.bb(r,t,"copy",n.overwrite),await v.Promises.copy(l,g,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,w.localize)(3,null,(0,m.$mc)(l),(0,m.$mc)((0,m.$lc)(g)),A.toString()))),this.fb(A)}}async bb(r,t,n,l){const g=this.H(r),A=this.H(t);let R=!1;if(!!(this.capabilities&1024)||(R=(0,u.$Wf)(g,A,!0)),R){if(n==="copy")throw(0,p.$lk)((0,w.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const I=await this.L(r);if(!I)throw(0,p.$lk)((0,w.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(t);if(L){if(!l)throw(0,p.$lk)((0,w.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);I.type&p.FileType.File&&L.type&p.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,t){return this.cb(r,t,!1)}async cb(r,t,n){const l=this.H(r),g=this.H(t),A=!!(this.capabilities&1024);if((0,u.$Wf)(l,g,!A))return;const R=new a.$Qc;try{R.add(await this.O(r)),R.add(await this.O(t)),n&&await v.Promises.mkdir((0,m.$lc)(g),{recursive:!0}),await v.Promises.copyFile(l,g)}catch(k){if(k.code==="ENOENT"&&!n)return this.cb(r,t,!0);throw this.fb(k)}finally{R.dispose()}}t(r,t,n){return new E.$7p(l=>r(l),l=>t(l),n)}F(r,t,n){return new c.$cq(l=>r(l),l=>t(l),n)}fb(r){if(r instanceof p.$kk)return r;let t=r,n;switch(r.code){case"ENOENT":n=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=p.FileSystemProviderErrorCode.Unknown;break;default:n=p.FileSystemProviderErrorCode.Unknown}return(0,p.$lk)(t,n)}async gb(r,t){let n=this.fb(t);if(r&&n.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await v.SymlinkSupport.stat(this.H(r));l.mode&128||(n=(0,p.$lk)(t,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return n}}e.$dq=i}),define(ne[223],se([0,1,3,93,2,17,61,22]),function(Q,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=e.$Lr=void 0;class u extends s.$Rc{constructor(b,y){super(),this.a=b,this.b=y,this.F=new Map,this.G=new Map}call(b,y,f){const v=this.c(b);switch(y){case"stat":return this.g(v,f[0]);case"readdir":return this.h(v,f[0]);case"open":return this.r(v,f[0],f[1]);case"close":return this.s(f[0]);case"read":return this.t(f[0],f[1],f[2]);case"readFile":return this.j(v,f[0],f[1]);case"write":return this.u(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.n(v,f[0],f[1],f[2]);case"rename":return this.z(v,f[0],f[1],f[2]);case"copy":return this.C(v,f[0],f[1],f[2]);case"cloneFile":return this.D(v,f[0],f[1]);case"mkdir":return this.w(v,f[0]);case"delete":return this.y(v,f[0],f[1]);case"watch":return this.I(v,f[0],f[1],f[2],f[3]);case"unwatch":return this.J(f[0],f[1])}throw new Error(`IPC Command ${y} not found`)}listen(b,y,f){const v=this.c(b);switch(y){case"fileChange":return this.H(v,f[0]);case"readFileStream":return this.m(v,f[0],f[1])}throw new Error(`Unknown event ${y}`)}g(b,y){const f=this.f(b,y,!0);return this.a.stat(f)}h(b,y){const f=this.f(b,y);return this.a.readdir(f)}async j(b,y,f){const v=this.f(b,y,!0),w=await this.a.readFile(v,f);return M.$be.wrap(w)}m(b,y,f){const v=this.f(b,y,!0),w=new S.$Xd,p=new P.$Nd({onDidRemoveLastListener:()=>{w.cancel()}}),$=this.a.readFileStream(v,f,w.token);return(0,C.$6d)($,{onData:d=>p.fire(M.$be.wrap(d)),onError:d=>p.fire(d),onEnd:()=>{p.fire("end"),p.dispose(),w.dispose()}}),p.event}n(b,y,f,v){const w=this.f(b,y);return this.a.writeFile(w,f.buffer,v)}r(b,y,f){const v=this.f(b,y,!0);return this.a.open(v,f)}s(b){return this.a.close(b)}async t(b,y,f){const v=M.$be.alloc(f),w=0,p=await this.a.read(b,y,v.buffer,w,f);return[v,p]}u(b,y,f,v,w){return this.a.write(b,y,f.buffer,v,w)}w(b,y){const f=this.f(b,y);return this.a.mkdir(f)}y(b,y,f){const v=this.f(b,y);return this.a.delete(v,f)}z(b,y,f,v){const w=this.f(b,y),p=this.f(b,f);return this.a.rename(w,p,v)}C(b,y,f,v){const w=this.f(b,y),p=this.f(b,f);return this.a.copy(w,p,v)}D(b,y,f){const v=this.f(b,y),w=this.f(b,f);return this.a.cloneFile(v,w)}H(b,y){const f=new P.$Nd({onWillAddFirstListener:()=>{this.F.set(y,this.L(b,f))},onDidRemoveLastListener:()=>{(0,s.$Mc)(this.F.get(y)),this.F.delete(y)}});return f.event}async I(b,y,f,v,w){const p=this.F.get(y);if(p){const $=this.f(b,v),d=p.watch(f,$,w);this.G.set(y+f,d)}}async J(b,y){const f=b+y,v=this.G.get(f);v&&((0,s.$Mc)(v),this.G.delete(f))}dispose(){super.dispose();for(const[,b]of this.G)b.dispose();this.G.clear();for(const[,b]of this.F)b.dispose();this.F.clear()}}e.$Lr=u;class a extends s.$Rc{constructor(b,y,f,v){super(),this.c=b,this.f=f,this.g=v,this.a=new Map,this.b=this.B(new D.$dq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(y)}h(b){const y=this.B(new P.$Nd);this.B(y.event(f=>{b.fire(f.map(v=>({resource:this.c.transformOutgoingURI(v.resource),type:v.type,cId:v.cId})))})),this.B(this.b.onDidChangeFile(f=>y.fire(f))),this.B(this.b.onDidWatchError(f=>b.fire(f)))}j(b){}m(b){}watch(b,y,f){const v=this.m(this.g);return Array.isArray(v)&&(f.excludes=[...f.excludes,...v]),this.a.set(b,this.b.watch(y,f)),(0,s.$Pc)(()=>{(0,s.$Mc)(this.a.get(b)),this.a.delete(b)})}dispose(){for(const[,b]of this.a)b.dispose();this.a.clear(),super.dispose()}}e.$Mr=a}),define(ne[224],se([0,1,15,178,4,7,16,9,223,155]),function(Q,e,P,D,s,M,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=void 0;class m extends u.$Lr{constructor(f,v,w){super(f,v),this.M=w}c(f){return a.$Mm}f(f,v){return M.URI.revive(v)}async y(f,v,w){if(!w.useTrash)return super.y(f,v,w);const p=this.f(f,v),$=(0,S.$gc)(p.fsPath);try{await P.shell.trashItem($)}catch{throw(0,C.$lk)(s.$j?(0,D.localize)(0,null,(0,S.$mc)($)):(0,D.localize)(1,null,(0,S.$mc)($)),C.FileSystemProviderErrorCode.Unknown)}}L(f,v){return new b(f,v,this.b,this.M)}}e.$D7b=m;class b extends u.$Mr{watch(f,v,w){if(w.recursive)throw(0,C.$lk)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(f,v,w)}}}),define(ne[225],se([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t4b=void 0;class D extends P.$dj{constructor(M=P.$aj){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(C=>{this.n?.setLevel(C)}))}set logger(M){this.n=M;for(const{level:C,message:S}of this.m)(0,P.log)(M,C,S);this.m=[]}g(M,C){this.n?(0,P.log)(this.n,M,C):this.getLevel()<=M&&this.m.push({level:M,message:C})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$t4b=D}),define(ne[226],se([0,1,7,3,6,2]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=void 0;class C extends s.$ij{constructor(b,y,f,v,w){super(y,f,v),this.r=b,this.t=w,this.B(w.listen("onDidChangeLogLevel",b)(p=>{(0,s.$_i)(p)?super.setLogLevel(p):super.setLogLevel(P.URI.revive(p[0]),p[1])})),this.B(w.listen("onDidChangeVisibility",b)(([p,$])=>super.setVisibility(P.URI.revive(p),$))),this.B(w.listen("onDidChangeLoggers",b)(({added:p,removed:$})=>{for(const d of p)super.registerLogger({...d,resource:P.URI.revive(d.resource)});for(const d of $)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new s.$gj({log:(b,y)=>{this.t.call("consoleLog",[b,y])}})}registerLogger(b){super.registerLogger(b),this.t.call("registerLogger",[b,this.r])}deregisterLogger(b){super.deregisterLogger(b),this.t.call("deregisterLogger",[b,this.r])}setLogLevel(b,y){super.setLogLevel(b,y),this.t.call("setLogLevel",[b,y])}setVisibility(b,y){super.setVisibility(b,y),this.t.call("setVisibility",[this.n(b),y])}s(b,y,f){return new S(this.t,b,y,f,this.r)}static setLogLevel(b,y,f){return b.call("setLogLevel",[y,f])}}e.$br=C;class S extends s.$dj{constructor(b,y,f,v,w){super(v?.logLevel==="always"),this.r=b,this.s=y,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[y,v,w]).then(()=>{this.u(this.n),this.m=!0})}g(b,y){const f=[[b,y]];this.m?this.u(f):this.n.push(...f)}u(b){this.r.call("log",[this.s,b])}}class u{constructor(b,y){this.a=b,this.b=y}listen(b,y){const f=this.b(b);switch(y){case"onDidChangeLoggers":return D.Event.map(this.a.onDidChangeLoggers,v=>({added:[...v.added].map(w=>this.c(w,f)),removed:[...v.removed].map(w=>this.c(w,f))}));case"onDidChangeVisibility":return D.Event.map(this.a.onDidChangeVisibility,v=>[f.transformOutgoingURI(v[0]),v[1]]);case"onDidChangeLogLevel":return D.Event.map(this.a.onDidChangeLogLevel,v=>(0,s.$_i)(v)?v:[f.transformOutgoingURI(v[0]),v[1]])}throw new Error(`Event not found: ${y}`)}async call(b,y,f){const v=this.b(b);switch(y){case"setLogLevel":return(0,s.$_i)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(P.URI.revive(v.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,v)))}throw new Error(`Call not found: ${y}`)}c(b,y){return{...b,resource:y.transformOutgoingURI(b.resource)}}}e.$cr=u;class a extends M.$Rc{constructor(b,y){super(),y.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(f=>y.call("setLogLevel",[f]))),y.call("getRegisteredLoggers").then(f=>{for(const v of f)b.registerLogger({...v,resource:P.URI.revive(v.resource)})}),this.B(y.listen("onDidChangeVisibility")(([f,v])=>b.setVisibility(P.URI.revive(f),v))),this.B(y.listen("onDidChangeLoggers")(({added:f,removed:v})=>{for(const w of f)b.registerLogger({...w,resource:P.URI.revive(w.resource)});for(const w of v)b.deregisterLogger(w.resource)}))}}e.$dr=a}),define(ne[227],se([0,1,2,6]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;class s extends P.$Rc{constructor(C,S=[]){super(),this.a=new D.$hj([C,...S]),this.B(C.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...S){this.a.trace(C,...S)}debug(C,...S){this.a.debug(C,...S)}info(C,...S){this.a.info(C,...S)}warn(C,...S){this.a.warn(C,...S)}error(C,...S){this.a.error(C,...S)}flush(){this.a.flush()}}e.$NN=s}),define(ne[228],se([0,1,31,7,6]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x8b=void 0;class M{constructor(S){this.b=S,this.a=new P.$zc}listen(S,u,a){switch(u){case"onDidChangeLoggers":return a?this.b.getOnDidChangeLoggersEvent(a):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.b.getOnDidChangeLogLevelEvent(a):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.b.getOnDidChangeVisibilityEvent(a):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${u}`)}async call(S,u,a){switch(u){case"createLogger":this.c(D.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.e(D.URI.revive(a[0]),a[1]);case"consoleLog":return this.d(a[0],a[1]);case"setLogLevel":return(0,s.$_i)(a[0])?this.b.setLogLevel(a[0]):this.b.setLogLevel(D.URI.revive(a[0]),a[1]);case"setVisibility":return this.b.setVisibility(D.URI.revive(a[0]),a[1]);case"registerLogger":return this.b.registerLogger({...a[0],resource:D.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.b.deregisterLogger(D.URI.revive(a[0]))}throw new Error(`Call not found: ${u}`)}c(S,u,a){this.a.set(S,this.b.createLogger(S,u,a))}d(S,u){let a=console.log;switch(S){case s.LogLevel.Error:a=console.error;break;case s.LogLevel.Warning:a=console.warn;break;case s.LogLevel.Info:a=console.info;break}a.call(console,...u)}e(S,u){const a=this.a.get(S);if(!a)throw new Error("Create the logger before logging");for(const[m,b]of u)(0,s.log)(a,m,b)}}e.$x8b=M}),define(ne[229],se([0,1,16,6]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=void 0;var s;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(s||(s={}));async function M(a,m,b,y,f){try{const v=await new Promise((p,$)=>{Q(["@vscode/spdlog"],p,$)});v.setFlushOn(s.Trace);const w=await v.createAsyncRotatingLogger(a,m,b,y);return f?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(v){console.error(v)}return null}function C(a,m,b){switch(m){case D.LogLevel.Trace:a.trace(b);break;case D.LogLevel.Debug:a.debug(b);break;case D.LogLevel.Info:a.info(b);break;case D.LogLevel.Warning:a.warn(b);break;case D.LogLevel.Error:a.error(b);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function S(a,m){switch(m){case D.LogLevel.Trace:a.setLevel(s.Trace);break;case D.LogLevel.Debug:a.setLevel(s.Debug);break;case D.LogLevel.Info:a.setLevel(s.Info);break;case D.LogLevel.Warning:a.setLevel(s.Warning);break;case D.LogLevel.Error:a.setLevel(s.Error);break;case D.LogLevel.Off:a.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class u extends D.$dj{constructor(m,b,y,f,v){super(),this.m=[],this.setLevel(v),this.n=this.s(m,b,y,f),this.B(this.onDidChangeLogLevel(w=>{this.r&&S(this.r,w)}))}async s(m,b,y,f){const v=y?6:1,w=30/v*P.$Gk.MB,p=await M(m,b,w,v,f);if(p){this.r=p,S(this.r,this.getLevel());for(const{level:$,message:d}of this.m)C(this.r,$,d);this.m=[]}}g(m,b){this.r?C(this.r,m,b):this.getLevel()<=m&&this.m.push({level:m,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$CN=u}),define(ne[230],se([0,1,32,6,229]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=void 0;class M extends D.$ij{s(S,u,a){return new s.$CN((0,P.$eg)(),S.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.$DN=M}),define(ne[67],se([0,1,31,3,5,6,230]),function(Q,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=e.$d7b=void 0,e.$d7b=(0,s.$Qh)(M.$$i);class S extends C.$DN{constructor(){super(...arguments),this.u=new P.$zc}createLogger(a,m,b){b!==void 0&&this.u.set(this.n(a),b);try{return super.createLogger(a,m)}catch(y){throw this.u.delete(this.n(a)),y}}registerLogger(a,m){m!==void 0&&this.u.set(a.resource,m),super.registerLogger(a)}deregisterLogger(a){this.u.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const m=[];for(const b of super.getRegisteredLoggers())a===this.u.get(b.resource)&&m.push(b);return m}getOnDidChangeLogLevelEvent(a){return D.Event.filter(this.onDidChangeLogLevel,m=>(0,M.$_i)(m)||this.w(m[0],a))}getOnDidChangeVisibilityEvent(a){return D.Event.filter(this.onDidChangeVisibility,([m])=>this.w(m,a))}getOnDidChangeLoggersEvent(a){return D.Event.filter(D.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(y=>this.w(y.resource,a)),removed:[...m.removed].filter(y=>this.w(y.resource,a))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(a){for(const[m,b]of this.u)b===a&&this.deregisterLogger(m)}w(a,m){const b=this.u.get(a);return b===void 0||b===m}dispose(){super.dispose(),this.u.clear()}}e.$e7b=S}),define(ne[231],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S7b=e.$R7b=e.$Q7b=e.$P7b=void 0;function P(C){return C.submenu!==void 0}e.$P7b=P;function D(C){return C.id==="vscode.menubar.separator"}e.$Q7b=D;function s(C){return C.uri!==void 0}e.$R7b=s;function M(C){return!P(C)&&!D(C)&&!s(C)}e.$S7b=M}),define(ne[39],se([0,1,3,71,2,5]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=void 0,e.$ln=(0,M.$Ph)("policy");class C extends s.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$Nd),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const m=Object.keys(this.f).length;return this.f={...a,...this.f},m!==Object.keys(this.f).length&&await this.j(a),D.Iterable.reduce(this.g.entries(),(b,[y,f])=>({...b,[y]:f}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(a,[m,b])=>({...a,[m]:{definition:b,value:this.g.get(m)}}),{})}}e.$mn=C;class S{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$nn=S}),define(ne[232],se([0,1,8,3,71,12,16,6,39]),function(Q,e,P,D,s,M,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q8b=void 0;function a(b,y){const f=[];for(const v of new Set(s.Iterable.concat(b.keys(),y.keys())))b.get(v)!==y.get(v)&&f.push(v);return f}let m=class extends u.$mn{constructor(y,f,v){super(),this.m=y,this.n=f,this.s=v,this.c=this.B(new P.$Rg(500));const w=D.Event.filter(f.onDidFilesChange,p=>p.affects(y));this.B(f.watch(y)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const f=await this.n.readFile(this.m),v=JSON.parse(f.value.toString());if(!(0,M.$Af)(v))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(v))this.f[w]&&y.set(w,v[w])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return y}async w(){const y=await this.u(),f=a(this.g,y);this.g=y,f.length>0&&this.h.fire(f)}};e.$Q8b=m,e.$Q8b=m=ve([te(1,C.$$j),te(2,S.$0i)],m)}),define(ne[233],se([0,1,3,2,39]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=e.$o8b=void 0;class M{constructor(u){this.b=u,this.a=new D.$Qc}listen(u,a){switch(a){case"onDidChange":return P.Event.map(this.b.onDidChange,m=>m.reduce((b,y)=>({...b,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${a}`)}call(u,a,m){switch(a){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${a}`)}dispose(){this.a.dispose()}}e.$o8b=M;class C extends s.$mn{constructor(u,a){super(),this.a=a;for(const m in u){const{definition:b,value:y}=u[m];this.f[m]=b,y!==void 0&&this.g.set(m,y)}this.a.listen("onDidChange")(m=>{for(const b in m){const y=m[b];y===null?this.g.delete(b):this.g.set(b,y)}this.h.fire(Object.keys(m))})}async j(u){const a=await this.a.call("updatePolicyDefinitions",u);for(const m in a)this.g.set(m,a[m])}}e.$p8b=C}),define(ne[234],se([0,1,39,8,312,2,6]),function(Q,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P8b=void 0;let S=class extends P.$mn{constructor(a,m){super(),this.m=a,this.n=m,this.a=new D.$Ng,this.b=this.B(new M.$Sc)}async j(a){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(a).length} policy definitions`),await this.a.queue(()=>new Promise((m,b)=>{try{this.b.value=(0,s.createWatcher)(this.n,a,y=>{this.t(y),m()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),b(y)}}))}t(a){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(a)}`);for(const m in a){const b=a[m];b===void 0?this.g.delete(m):this.g.set(m,b)}this.h.fire(Object.keys(a))}};e.$P8b=S,e.$P8b=S=ve([te(0,C.$0i)],S)}),define(ne[79],se([0,1,4,35]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof P.$h.vscode<"u"&&typeof P.$h.vscode.context<"u"){const M=P.$h.vscode.context.configuration();if(M)s=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:M.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(ne[25],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,P.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"}),define(ne[235],se([0,1,8,6]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=void 0;let s=class{constructor(C,S,u){this.a=C,this.b=S,this.c=u}async inspect(C){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.$Ug)(C);const u=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),u.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};e.$G7b=s,e.$G7b=s=ve([te(2,D.$0i)],s)}),define(ne[80],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$66b=void 0,e.$66b=(0,P.$Ph)("protocolMainService")}),define(ne[43],se([0,1,137,12]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=void 0;class s{constructor(){this.a=new Map}add(C,S){P.ok(D.$yf(C)),P.ok(D.$Af(S)),P.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,S)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$jn=new s}),define(ne[236],se([0,1,3,43]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0,e.$kn={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class M{constructor(){this.b=new P.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,a){this.a[s(u)]=a,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const C=new M;D.$jn.add(e.$kn.JSONContribution,C)}),define(ne[58],se([0,1,23,3,12,163,18,236,43]),function(Q,e,P,D,s,M,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.ConfigurationScope=e.$on=e.EditPresentationTypes=void 0;var a;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$on={Configuration:"base.contributions.configuration"};var m;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn="vscode://schemas/settings/resourceLanguage",e.$wn="vscode://schemas/settings/configurationDefaults";const b=u.$jn.as(S.$kn.JSONContribution);class y{constructor(){this.h=new Set,this.i=new D.$Nd,this.onDidSchemaChange=this.i.event,this.j=new D.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$vn,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const r=new Set;this.n(i,o,r),b.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const o=new Set;this.o(i,o),b.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const r=new Set;this.o(o,r),this.n(i,!1,r),b.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const r=[];for(const{overrides:t,source:n}of i)for(const l in t)if(o.add(l),e.$yn.test(l)){const g=this.a.get(l),A=g?.valuesSources??new Map;if(n)for(const L of Object.keys(t[l]))A.set(L,n);const R={...g?.value||{},...t[l]};this.a.set(l,{source:n,value:R,valuesSources:A});const k=(0,C.$ti)(l),I={type:"object",default:R,description:M.localize(1,null,k),$ref:e.$vn,defaultDefaultValue:R,source:s.$yf(n)?void 0:n,defaultValueSource:n};r.push(...w(l)),this.d[l]=I,this.b.properties[l]=I}else{this.a.set(l,{value:t[l],source:n});const g=this.d[l];g&&(this.w(l,g),this.r(l,g))}this.m(r)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:r,source:t}of i)for(const n in r){const l=this.a.get(n),g=s.$yf(t)?t:t?.id,A=s.$yf(l?.source)?l?.source:l?.source?.id;if(g===A)if(o.add(n),this.a.delete(n),e.$yn.test(n))delete this.d[n],delete this.b.properties[n];else{const R=this.d[n];R&&(this.w(n,R),this.r(n,R))}}this.u()}deltaConfiguration(i){let o=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,r){i.forEach(t=>{this.p(t,o,t.extensionInfo,t.restrictedProperties,void 0,r),this.c.push(t),this.q(t)})}o(i,o){const r=t=>{if(t.properties)for(const n in t.properties){o.add(n);const l=this.d[n];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[n],this.s(n,t.properties[n])}t.allOf?.forEach(n=>r(n))};for(const t of i){r(t);const n=this.c.indexOf(t);n!==-1&&this.c.splice(n,1)}}p(i,o=!0,r,t,n=3,l){n=s.$Hf(i.scope)?n:i.scope;const g=i.properties;if(g)for(const R in g){const k=g[R];if(o&&h(R,k)){delete g[R];continue}if(k.source=r,k.defaultDefaultValue=g[R].default,this.w(R,k),e.$yn.test(R)?k.scope=void 0:(k.scope=s.$Hf(k.scope)?n:k.scope,k.restricted=s.$Hf(k.restricted)?!!t?.includes(R):k.restricted),g[R].hasOwnProperty("included")&&!g[R].included){this.f[R]=g[R],delete g[R];continue}else this.d[R]=g[R],g[R].policy?.name&&this.e.set(g[R].policy.name,R);!g[R].deprecationMessage&&g[R].markdownDeprecationMessage&&(g[R].deprecationMessage=g[R].markdownDeprecationMessage),l.add(R)}const A=i.allOf;if(A)for(const R of A)this.p(R,o,r,t,n,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=r=>{const t=r.properties;if(t)for(const l in t)this.r(l,t[l]);r.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$pn.properties[i]=o,o.scope){case 1:e.$qn.properties[i]=o;break;case 2:e.$rn.properties[i]=o;break;case 6:e.$sn.properties[i]=o;break;case 3:e.$tn.properties[i]=o;break;case 4:e.$un.properties[i]=o;break;case 5:e.$un.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$pn.properties[i],o.scope){case 1:delete e.$qn.properties[i];break;case 2:delete e.$rn.properties[i];break;case 6:delete e.$sn.properties[i];break;case 3:delete e.$tn.properties[i];break;case 4:case 5:delete e.$un.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$vn};this.w(o,r),e.$pn.properties[o]=r,e.$qn.properties[o]=r,e.$rn.properties[o]=r,e.$sn.properties[o]=r,e.$tn.properties[o]=r,e.$un.properties[o]=r}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$vn};e.$pn.patternProperties[e.$xn]=i,e.$qn.patternProperties[e.$xn]=i,e.$rn.patternProperties[e.$xn]=i,e.$sn.patternProperties[e.$xn]=i,e.$tn.patternProperties[e.$xn]=i,e.$un.patternProperties[e.$xn]=i,this.i.fire()}w(i,o){const r=this.a.get(i);let t=r?.value,n=r?.source;s.$Ff(t)&&(t=o.defaultDefaultValue,n=void 0),s.$Ff(t)&&(t=$(o.type)),o.default=t,o.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",v=new RegExp(f,"g");e.$xn=`^(${f})+$`,e.$yn=new RegExp(e.$xn);function w(c){const i=[];if(e.$yn.test(c)){let o=v.exec(c);for(;o?.length;){const r=o[1].trim();r&&i.push(r),o=v.exec(c)}}return(0,P.$Lb)(i)}e.$zn=w;function p(c){return c.reduce((i,o)=>`${i}[${o}]`,"")}e.$An=p;function $(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Bn=$;const d=new y;u.$jn.add(e.$on.Configuration,d);function h(c,i){return c.trim()?e.$yn.test(c)?M.localize(7,null,c):d.getConfigurationProperties()[c]!==void 0?M.localize(8,null,c):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,c,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.$Cn=h;function E(){const c=[],i=d.getConfigurationProperties();for(const o of Object.keys(i))c.push([o,i[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$Dn=E}),define(ne[119],se([0,1,23,3,44,2,31,38,12,7,18,58,43]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=void 0;function f(o){return Object.isFrozen(o)?o:S.$8m(o)}class v{constructor(r={},t=[],n=[],l){this.b=r,this.c=t,this.d=n,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(t=>{if(t instanceof v)return t;const n=new w("");return n.parseRaw(t),n.configurationModel});this.f=r.reduce((t,n)=>n===t?n:t.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,m.$ri)(this.contents,r):this.contents}inspect(r,t){const n=this.rawConfiguration.getValue(r),l=t?this.rawConfiguration.getOverrideValue(r,t):void 0,g=t?this.rawConfiguration.override(t).getValue(r):n;return{value:n,override:l,merged:g}}getOverrideValue(r,t){const n=this.i(t);return n?r?(0,m.$ri)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const n of this.overrides)n.identifiers.includes(r)&&t.push(...n.keys);return P.$Lb(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return P.$Lb(r)}override(r){let t=this.a.get(r);return t||(t=this.g(r),this.a.set(r,t)),t}merge(...r){const t=S.$7m(this.contents),n=S.$7m(this.overrides),l=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const A of r)if(g.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(t,A.contents);for(const R of A.overrides){const[k]=n.filter(I=>P.$tb(I.identifiers,R.identifiers));k?(this.h(k.contents,R.contents),k.keys.push(...R.keys),k.keys=P.$Lb(k.keys)):n.push(S.$7m(R))}for(const R of A.keys)l.indexOf(R)===-1&&l.push(R)}return new v(t,l,n,g.every(A=>A instanceof v)?void 0:g)}g(r){const t=this.i(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const n={};for(const l of P.$Lb([...Object.keys(this.contents),...Object.keys(t)])){let g=this.contents[l];const A=t[l];A&&(typeof g=="object"&&typeof A=="object"?(g=S.$7m(g),this.h(g,A)):g=A),n[l]=g}return new v(n,this.keys,this.overrides)}h(r,t){for(const n of Object.keys(t)){if(n in r&&u.$Af(r[n])&&u.$Af(t[n])){this.h(r[n],t[n]);continue}r[n]=S.$7m(t[n])}}i(r){let t=null,n=null;const l=g=>{g&&(n?this.h(n,g):n=S.$7m(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===r?t=g.contents:g.identifiers.includes(r)&&l(g.contents);return l(t),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,t){this.j(r,t,!0)}setValue(r,t){this.j(r,t,!1)}removeValue(r){const t=this.keys.indexOf(r);t!==-1&&(this.keys.splice(t,1),(0,m.$qi)(this.contents,r),b.$yn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>P.$tb(n.identifiers,(0,b.$zn)(r))),1))}j(r,t,n){(0,m.$pi)(this.contents,r,t,l=>console.error(l)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),b.$yn.test(r)&&this.overrides.push({identifiers:(0,b.$zn)(r),keys:Object.keys(this.contents[r]),contents:(0,m.$oi)(this.contents[r],l=>console.error(l))})}}e.$En=v;class w{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,t){if(!u.$Hf(r)){const n=this.g(r);this.parseRaw(n,t)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,t){this.a=r;const{contents:n,keys:l,overrides:g,restricted:A,hasExcludedProperties:R}=this.h(r,t);this.b=new v(n,l,g,R?[r]:void 0),this.c=A||[]}g(r){let t={},n=null,l=[];const g=[],A=[];function R(I){Array.isArray(l)?l.push(I):n!==null&&(l[n]=I)}const k={onObjectBegin:()=>{const I={};R(I),g.push(l),l=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{l=g.pop()},onArrayBegin:()=>{const I=[];R(I),g.push(l),l=I,n=null},onArrayEnd:()=>{l=g.pop()},onLiteralValue:R,onError:(I,L,N)=>{A.push({error:I,offset:L,length:N})}};if(r)try{s.$4m(r,k),t=l[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return t}h(r,t){const n=y.$jn.as(b.$on.Configuration).getConfigurationProperties(),l=this.i(r,n,!0,t);r=l.raw;const g=(0,m.$oi)(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),A=Object.keys(r),R=this.j(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:g,keys:A,overrides:R,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(r,t,n,l){let g=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:g};const A={},R=[];for(const k in r)if(b.$yn.test(k)&&n){const I=this.i(r[k],t,!1,l);A[k]=I.raw,g=g||I.hasExcludedProperties,R.push(...I.restricted)}else{const I=t[k],L=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&R.push(k),!l.exclude?.includes(k)&&(l.include?.includes(k)||(L===void 0||l.scopes===void 0||l.scopes.includes(L))&&!(l.skipRestricted&&I?.restricted))?A[k]=r[k]:g=!0}return{raw:A,restricted:R,hasExcludedProperties:g}}j(r,t){const n=[];for(const l of Object.keys(r))if(b.$yn.test(l)){const g={};for(const A in r[l])g[A]=r[l][A];n.push({identifiers:(0,b.$zn)(l),keys:Object.keys(g),contents:(0,m.$oi)(g,t)})}return n}}e.$Fn=w;class p extends M.$Rc{constructor(r,t,n,l){super(),this.c=r,this.f=t,this.g=l,this.b=this.B(new D.$Nd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,g=>g.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,g=>(g.isOperation(0)||g.isOperation(3)||g.isOperation(1)||g.isOperation(4))&&n.isEqual(g.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Gn=p;class ${constructor(r,t,n,l,g,A,R,k,I,L,N,T,x){this.a=r,this.b=t,this.c=n,this.overrideIdentifiers=l,this.d=g,this.f=A,this.g=R,this.h=k,this.i=I,this.j=L,this.k=N,this.l=T,this.m=x}get value(){return f(this.c)}n(r,t,n){const l=r.inspect(t,n);return{get value(){return f(l.value)},get override(){return f(l.override)},get merged(){return f(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(r,t,n,l,g=new v,A=new v,R=new C.$zc,k=new v,I=new C.$zc){this.c=r,this.d=t,this.f=n,this.g=l,this.h=g,this.i=A,this.j=R,this.l=k,this.m=I,this.a=null,this.b=new C.$zc,this.n=null}getValue(r,t,n){return this.q(r,t,n).getValue(r)}updateValue(r,t,n={}){let l;n.resource?(l=this.m.get(n.resource),l||(l=new v,this.m.set(n.resource,l))):l=this.l,t===void 0?l.removeValue(r):l.setValue(r,t),n.resource||(this.a=null)}inspect(r,t,n){const l=this.q(r,t,n),g=this.u(t.resource,n),A=t.resource?this.m.get(t.resource)||this.l:this.l,R=new Set;for(const k of l.overrides)for(const I of k.identifiers)l.getOverrideValue(r,I)!==void 0&&R.add(I);return new $(r,t,l.getValue(r),R.size?[...R]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,g||void 0,A)}keys(r){const t=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,t){this.j.set(r,t),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const n=[];if(!t){const{added:l,updated:g,removed:A}=c(this.c,r);t=[...l,...g,...A]}for(const l of t)for(const g of(0,b.$zn)(l)){const A=this.c.getKeysForOverrideIdentifier(g),R=r.getKeysForOverrideIdentifier(g),k=[...R.filter(I=>A.indexOf(I)===-1),...A.filter(I=>R.indexOf(I)===-1),...A.filter(I=>!S.$$m(this.c.override(g).getValue(I),r.override(g).getValue(I)))];n.push([g,k])}return this.updateDefaultConfiguration(r),{keys:t,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:n,removed:l}=c(this.d,r),g=[...t,...n,...l];return g.length&&this.updatePolicyConfiguration(r),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:n,removed:l,overrides:g}=c(this.applicationConfiguration,r),A=[...t,...n,...l];return A.length&&this.updateApplicationConfiguration(r),{keys:A,overrides:g}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:n,removed:l,overrides:g}=c(this.localUserConfiguration,r),A=[...t,...n,...l];return A.length&&this.updateLocalUserConfiguration(r),{keys:A,overrides:g}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:n,removed:l,overrides:g}=c(this.remoteUserConfiguration,r),A=[...t,...n,...l];return A.length&&this.updateRemoteUserConfiguration(r),{keys:A,overrides:g}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:n,removed:l,overrides:g}=c(this.workspaceConfiguration,r),A=[...t,...n,...l];return A.length&&this.updateWorkspaceConfiguration(r),{keys:A,overrides:g}}compareAndUpdateFolderConfiguration(r,t){const n=this.p.get(r),{added:l,updated:g,removed:A,overrides:R}=c(n,t),k=[...l,...g,...A];return(k.length||!n)&&this.updateFolderConfiguration(r,t),{keys:k,overrides:R}}compareAndDeleteFolderConfiguration(r){const t=this.p.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:l,removed:g,overrides:A}=c(t,void 0);return{keys:[...n,...l,...g],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,t,n){let l=this.r(t,n);return t.overrideIdentifier&&(l=l.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(l=l.merge(this.d)),l}r({resource:r},t){let n=this.s();if(t&&r){const l=t.getFolder(r);l&&(n=this.t(l.uri)||n);const g=this.m.get(r);g&&(n=n.merge(g))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let t=this.b.get(r);if(!t){const n=this.s(),l=this.j.get(r);l?(t=n.merge(l),this.b.set(r,t)):t=n}return t}u(r,t){if(t&&r){const n=t.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,t)=>{const{contents:n,overrides:l,keys:g}=this.j.get(t);return r.push([t,{contents:n,overrides:l,keys:g}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(t=>r.add(t)),this.userConfiguration.keys.forEach(t=>r.add(t)),this.i.keys.forEach(t=>r.add(t)),this.j.forEach(t=>t.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const t=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(l=>t.add(l))),[...t.values()]}static parse(r){const t=this.x(r.defaults),n=this.x(r.policy),l=this.x(r.application),g=this.x(r.user),A=this.x(r.workspace),R=r.folders.reduce((k,I)=>(k.set(a.URI.revive(I[0]),this.x(I[1])),k),new C.$zc);return new d(t,n,l,g,new v,A,R,new v,new C.$zc)}static x(r){return new v(r.contents,r.keys,r.overrides)}}e.$Hn=d;function h(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,t=new Map;for(const l of o)l.keys.forEach(g=>r.add(g)),l.overrides.forEach(([g,A])=>{const R=(0,C.$wc)(t,g,new Set);A.forEach(k=>R.add(k))});const n=[];return t.forEach((l,g)=>n.push([g,[...l.values()]])),{keys:[...r.values()],overrides:n}}e.$In=h;class E{constructor(r,t,n,l){this.change=r,this.f=t,this.g=n,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const g of r.keys)this.affectedKeys.add(g);for(const[,g]of r.overrides)for(const A of g)this.affectedKeys.add(A);this.d=this.a;for(const g of this.affectedKeys)this.d+=g+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(r,t){const n=this.a+r,l=this.d.indexOf(n);if(l<0)return!1;const g=l+n.length;if(g>=this.d.length)return!1;const A=this.d.charCodeAt(g);if(A!==this.b&&A!==this.c)return!1;if(t){const R=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.f?.workspace):void 0,k=this.g.getValue(r,t,this.h);return!S.$$m(R,k)}return!0}}e.$Jn=E;function c(o,r){const{added:t,removed:n,updated:l}=i(r?.rawConfiguration,o?.rawConfiguration),g=[],A=o?.getAllOverrideIdentifiers()||[],R=r?.getAllOverrideIdentifiers()||[];if(r){const k=R.filter(I=>!A.includes(I));for(const I of k)g.push([I,r.getKeysForOverrideIdentifier(I)])}if(o){const k=A.filter(I=>!R.includes(I));for(const I of k)g.push([I,o.getKeysForOverrideIdentifier(I)])}if(r&&o){for(const k of A)if(R.includes(k)){const I=i({contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});g.push([k,[...I.added,...I.removed,...I.updated]])}}return{added:t,removed:n,updated:l,overrides:g}}function i(o,r){const t=o?r?o.keys.filter(g=>r.keys.indexOf(g)===-1):[...o.keys]:[],n=r?o?r.keys.filter(g=>o.keys.indexOf(g)===-1):[...r.keys]:[],l=[];if(o&&r){for(const g of r.keys)if(o.keys.indexOf(g)!==-1){const A=(0,m.$ri)(r.contents,g),R=(0,m.$ri)(o.contents,g);S.$$m(A,R)||l.push(g)}}return{added:t,removed:n,updated:l}}}),define(ne[237],se([0,1,23,3,2,38,12,119,58,6,39,43]),function(Q,e,P,D,s,M,C,S,u,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=void 0;class y extends s.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$En}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.$jn.as(u.$on.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:$})=>this.c(Array.from(p),$))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(p,$){this.h(p,b.$jn.as(u.$on.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}f(){return{}}g(){this.b=new S.$En;const p=b.$jn.as(u.$on.Configuration).getConfigurationProperties();this.h(Object.keys(p),p)}h(p,$){const d=this.f();for(const h of p){const E=d[h],c=$[h];E!==void 0?this.b.addValue(h,E):c?this.b.addValue(h,c.default):this.b.removeValue(h)}}}e.$Kn=y;class f{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new S.$En}async initialize(){return this.configurationModel}}e.$Ln=f;let v=class extends s.$Rc{get configurationModel(){return this.b}constructor(p,$,d){super(),this.c=p,this.f=$,this.g=d,this.a=this.B(new D.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$En}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const $={},d=[],h=b.$jn.as(u.$on.Configuration).getConfigurationProperties();for(const E of p){const c=h[E];if(!c){d.push(E);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.g.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}d.push(E),$[c.policy.name]={type:c.type}}}return(0,C.$Lf)($)||await this.f.updatePolicyDefinitions($),d}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const $=b.$jn.as(u.$on.Configuration).getPolicyConfigurations(),d=(0,P.$Gb)(p.map(h=>$.get(h)));this.m(d,!0)}m(p,$){this.g.trace("PolicyConfiguration#update",p);const d=b.$jn.as(u.$on.Configuration).getConfigurationProperties(),h=[],E=this.b.isEmpty();for(const c of p){const i=d[c]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(E?o!==void 0:!(0,M.$$m)(this.b.getValue(c),o))&&h.push([c,o])}else this.b.getValue(c)!==void 0&&h.push([c,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const c=this.b;this.b=new S.$En;for(const i of c.keys)this.b.setValue(i,c.getValue(i));for(const[i,o]of h)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);$&&this.a.fire(this.b)}}};e.$Mn=v,e.$Mn=v=ve([te(1,m.$ln),te(2,a.$0i)],v)}),define(ne[238],se([0,1,8,3,2,19,18,119,237,39]),function(Q,e,P,D,s,M,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=void 0;class m extends s.$Rc{constructor(y,f,v,w){super(),this.j=y,this.h=this.B(new D.$Nd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$Kn),this.c=v instanceof a.$nn?new u.$Ln:this.B(new u.$Mn(this.b,v,w)),this.f=this.B(new S.$Gn(this.j,{},M.$mg,f)),this.a=new S.$Hn(this.b.configurationModel,this.c.configurationModel,new S.$En,new S.$En),this.g=this.B(new P.$6g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:p,properties:$})=>this.n(p,$))),this.B(this.c.onDidChangeConfiguration(p=>this.r(p))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,f,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.$Hn(y,f,new S.$En,v)}getConfigurationData(){return this.a.toData()}getValue(y,f){const v=typeof y=="string"?y:void 0,w=(0,C.$ki)(y)?y:(0,C.$ki)(f)?f:{};return this.a.getValue(v,w,void 0)}updateValue(y,f,v,w){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.m(y)}m(y){const f=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(y);this.s(v,f,2)}n(y,f){const v=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(y,f);this.s(w,v,7)}r(y){const f=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(y);this.s(v,f,7)}s(y,f,v){const w=new S.$Jn(y,{data:f},this.a);w.source=v,w.sourceConfig=this.t(v),this.h.fire(w)}t(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Nn=m}),define(ne[239],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E8b=e.$D8b=e.$C8b=void 0,e.$C8b="request",e.$D8b="remoteResourceHandler";class P{async routeCall(s,M,C){if(M!==e.$C8b)throw new Error(`Call not found: ${M}`);const S=C[0];if(S?.authority){const u=s.connections.find(a=>a.ctx===S.authority);if(u)return u}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$E8b=P}),define(ne[240],se([0,1,14,5]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,D.$Ph)("remoteAuthorityResolverService");var s;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=M;class C{constructor(b,y){this.host=b,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=C;var S;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class u extends P.$ab{static isNotAvailable(b){return b instanceof u&&b._code===S.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof u&&b._code===S.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof u&&b._code===S.NoResolverFound}static isInvalidAuthority(b){return b instanceof u&&b._code===S.InvalidAuthority}static isHandled(b){return b instanceof u&&b.isHandled}constructor(b,y=S.Unknown,f){super(b),this._message=b,this._code=y,this._detail=f,this.isHandled=y===S.NotAvailable&&f===!0,Object.setPrototypeOf(this,u.prototype)}}e.$Sk=u;function a(m){const b=m.indexOf("+");return b===-1?m:m.substring(0,b)}e.$Tk=a}),define(ne[59],se([0,1,13]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function D(a){return a.scheme===P.Schemas.vscodeRemote?a.authority:void 0}e.$Uk=D;function s(a){if(!a)return;const m=a.indexOf("+");return m<0?a:a.substr(0,m)}e.$Vk=s;function M(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.$Wk=M;function C(a){const{host:m,port:b}=u(a);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:b}}e.$Xk=C;function S(a,m){let{host:b,port:y}=u(a);return typeof y>"u"&&(y=m),{host:b,port:y}}e.$Yk=S;function u(a){const m=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const b=a.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const y=a.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:a,port:void 0}}}),define(ne[120],se([0,1,27,5,59]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function M(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$4l=M,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(C||(e.ExtensionType=C={}));var S;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class u{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,$){if(typeof p>"u"||p===null)return typeof $>"u"||$===null;if(typeof $>"u"||$===null)return!1;if(typeof p=="string"||typeof $=="string"){const d=typeof p=="string"?p:p.value,h=typeof $=="string"?$:$.value;return P.$2e(d,h)}return p._lower===$._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$6l=u;class a{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const $ of p)this.add($)}add(p){this.c.add(u.toKey(p))}delete(p){return this.c.delete(u.toKey(p))}has(p){return this.c.has(u.toKey(p))}}e.$7l=a;class m{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(u.toKey(p))}get(p){return this.c.get(u.toKey(p))}has(p){return this.c.has(u.toKey(p))}set(p,$){this.c.set(u.toKey(p),$)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=m;function b(w){return y(w)}e.$9l=b;function y(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$0l=y;function f(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$$l=f;function v(w,p){if(p){const $=`onResolveRemoteAuthority:${(0,s.$Vk)(p)}`;return!!w.activationEvents?.includes($)}return!1}e.$_l=v,e.$am=(0,D.$Ph)("IBuiltinExtensionsScannerService")}),define(ne[241],se([0,1,8,17,22,14,3,2,66,73,32,109,240,59]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.PersistentConnectionEventType=e.$6k=e.$5k=e.$4k=e.ConnectionType=void 0;const v=30*1e3;var w;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function p(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function $(J){const O=new s.$Xd;return setTimeout(()=>O.cancel(),J),O.token}function d(J,O){if(J.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const j=new s.$Xd;return J.onCancellationRequested(()=>j.cancel()),O.onCancellationRequested(()=>j.cancel()),j.token}class h{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new S.$Qc,this.promise=new Promise((j,F)=>{this.f=j,this.g=F}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function E(J,O){const j=new h(O);return j.registerDisposable(J.onControlMessage(F=>{const U=JSON.parse(F.toString()),H=z(U);H?j.reject(H):j.resolve(U)})),j.promise}function c(J,O,j,F,U,H,B,ie){const fe=new h(ie),de=a.$Jd.create(!1);return J.info(`Creating a socket (${B})...`),u.mark(`code/willCreateSocket/${H}`),O.connect(j,F,U,B).then(ue=>{fe.didTimeout?(u.mark(`code/didCreateSocketError/${H}`),J.info(`Creating a socket (${B}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(u.mark(`code/didCreateSocketOK/${H}`),J.info(`Creating a socket (${B}) was successful after ${de.elapsed()} ms.`),fe.resolve(ue))},ue=>{u.mark(`code/didCreateSocketError/${H}`),J.info(`Creating a socket (${B}) returned an error after ${de.elapsed()} ms.`),J.error(ue),fe.reject(ue)}),fe.promise}function i(J,O){const j=new h(O);return J.then(F=>{j.didTimeout||j.resolve(F)},F=>{j.didTimeout||j.reject(F)}),j.promise}async function o(J,O,j,F){const U=Y(J,O);J.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let H;try{H=await c(J.logService,J.remoteSocketFactoryService,J.connectTo,(0,f.$Wk)(J),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,p(O),`renderer-${p(O)}-${J.reconnectionToken}`,F)}catch(ue){throw J.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),J.logService.error(ue),ue}J.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let B,ie;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(H,null),B=J.reconnectionProtocol,ie=!1):(B=new b.$Dh({socket:H}),ie=!0),J.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const fe=await i(J.signService.createNewMessage((0,m.$eg)()),F),de={type:"auth",auth:J.connectionToken||"00000000000000000000",data:fe.data};B.sendControl(D.$be.fromString(JSON.stringify(de)));try{const ue=await E(B,d(F,$(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(J.logService.trace(`${U} 4/6. received SignRequest control message.`),!await i(J.signService.validate(fe,ue.signedData),F)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const me=await i(J.signService.sign(ue.data),F),Ee={type:"connectionType",commit:J.commit,signedData:me,desiredConnectionType:O};return j&&(Ee.args=j),J.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),B.sendControl(D.$be.fromString(JSON.stringify(Ee))),{protocol:B,ownsProtocol:ie}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(J.logService.error(`${U} the handshake timed out. Error:`),J.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${U} received error control message when negotiating connection. Error:`),J.logService.error(ue)),ie&&G(B),ue}}async function r(J,O,j,F){const U=Date.now(),H=Y(J,O),{protocol:B,ownsProtocol:ie}=await o(J,O,j,F),fe=new h(F);return fe.registerDisposable(B.onControlMessage(de=>{const ue=JSON.parse(de.toString()),be=z(ue);be?(J.logService.error(`${H} received error control message when negotiating connection. Error:`),J.logService.error(be),ie&&G(B),fe.reject(be)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${oe(U)}!`),fe.resolve({protocol:B,firstMessage:ue}))})),fe.promise}async function t(J,O){const{protocol:j}=await r(J,1,void 0,O);return{protocol:j}}async function n(J,O,j){const{protocol:F,firstMessage:U}=await r(J,2,O,j),H=U&&U.debugPort;return{protocol:F,debugPort:H}}async function l(J,O,j){const F=Date.now(),U=Y(J,3),{protocol:H}=await o(J,3,O,j);return J.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${oe(F)}!`),H}async function g(J,O,j){const{connectTo:F,connectionToken:U}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:F,connectionToken:U,reconnectionToken:O,reconnectionProtocol:j,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function A(J,O,j){return k(J,async F=>{const{protocol:U}=await t(F,s.CancellationToken.None);return new Z(J,O,j,F.reconnectionToken,U)})}e.$4k=A;async function R(J,O){return k(J,async j=>{const{protocol:F,debugPort:U}=await n(j,O,s.CancellationToken.None);return new K(J,O,j.reconnectionToken,F,U)})}e.$5k=R;async function k(J,O){for(let F=1;;F++)try{const U=(0,m.$eg)(),H=await g(J,U,null);return await O(H)}catch(U){if(F<5)J.logService.error(`[remote-connection][attempt ${F}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(U);else throw J.logService.error(`[remote-connection][attempt ${F}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(U),ae.triggerPermanentFailure(0,0,y.$Sk.isHandled(U)),U}}async function I(J,O,j){const F=await g(J,(0,m.$eg)(),null);return await l(F,{host:O,port:j},s.CancellationToken.None)}e.$6k=I;function L(J){return(0,P.$Hg)(O=>new Promise((j,F)=>{const U=setTimeout(j,J*1e3);O.onCancellationRequested(()=>{clearTimeout(U),j()})}))}var N;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class T{constructor(O,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.type=0}}e.$7k=T;class x{constructor(O,j,F,U){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.durationSeconds=F,this.c=U,this.type=1}skipWait(){this.c.cancel()}}e.$8k=x;class X{constructor(O,j,F){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=F,this.type=2}}e.$9k=X;class ce{constructor(O,j,F){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=F,this.type=4}}e.$0k=ce;class re{constructor(O,j,F,U){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=F,this.handled=U,this.type=3}}e.$$k=re;class ae extends S.$Rc{static triggerPermanentFailure(O,j,F){this._permanentFailure=!0,this.f=O,this.g=j,this.h=F,this.j.forEach(U=>U.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ae._permanentFailure}constructor(O,j,F,U,H){super(),this.t=O,this.u=j,this.reconnectionToken=F,this.protocol=U,this.w=H,this.m=this.B(new C.$Nd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ce(this.reconnectionToken,0,0)),this.B(U.onSocketClose(B=>{const ie=q(this.t,this.reconnectionToken,!0);B?B.type===0?(this.u.logService.info(`${ie} received socket close event (hadError: ${B.hadError}).`),B.error&&this.u.logService.error(B.error)):(this.u.logService.info(`${ie} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this.u.logService.error(B.event)):this.u.logService.info(`${ie} received socket close event.`),this.y()})),this.B(U.onSocketTimeout(B=>{const ie=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${B.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${B.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${B.timeSinceLastReceivedSomeData}).`),this.y()})),ae.j.push(this),this.B((0,S.$Pc)(()=>{const B=ae.j.indexOf(this);B>=0&&ae.j.splice(B,1)})),this.n&&this.D(ae.f,ae.g,ae.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const U=F<j.length?j[F]:j[j.length-1];try{if(U>0){const B=L(U);this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,B)),this.u.logService.info(`${O} waiting for ${U} seconds before reconnecting...`);try{await B}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this.u.logService.info(`${O} resolving connection...`);const H=await g(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${H.connectTo}...`),await this.G(H,$(v)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new ce(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(y.$Sk.isTemporarilyNotAvailable(H)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((0,M.$3)(H)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if(H instanceof y.$Sk){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,y.$Sk.isHandled(H));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!this.n&&!this.s)}C(O,j,F){this.w?ae.triggerPermanentFailure(O,j,F):this.D(O,j,F)}D(O,j,F){this.m.fire(new re(this.reconnectionToken,O,j,F)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$_k=ae;class Z extends ae{constructor(O,j,F,U,H){super(1,O,U,H,!0),this.client=this.B(new b.$Bh(H,{remoteAuthority:j,clientId:F},O.ipcLogger))}async G(O,j){await t(O,j)}}e.$al=Z;class K extends ae{constructor(O,j,F,U,H){super(2,O,F,U,!1),this.H=j,this.debugPort=H}async G(O,j){await n(O,this.H,j)}}e.$bl=K;function G(J){try{J.acceptDisconnect();const O=J.getSocket();J.dispose(),O.dispose()}catch(O){(0,M.$Z)(O)}}function z(J){if(J&&J.type==="error"){const O=new Error(`Connection error: ${J.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function W(J,O){for(;J.length<O;)J+=" ";return J}function V(J,O){return`[remote-connection][${W(p(J),13)}][${O.substr(0,5)}\u2026]`}function q(J,O,j){return`${V(J,O)}[${j?"reconnect":"initial"}]`}function Y(J,O){return`${q(O,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function oe(J){return`${Date.now()-J} ms`}}),define(ne[242],se([0,1,2,5]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=void 0,e.$Zk=(0,D.$Ph)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(C,S){return this.a[C]??=[],this.a[C].push(S),(0,P.$Pc)(()=>{const u=this.a[C]?.indexOf(S);typeof u=="number"&&u>=0&&this.a[C]?.splice(u,1)})}b(C){return(this.a[C.type]||[]).find(u=>u.supports(C))}connect(C,S,u,a){const m=this.b(C);if(!m)throw new Error(`No socket factory found for ${C}`);return m.connect(C,S,u,a)}}e.$1k=s}),define(ne[243],se([0,1,28,47,21,113]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=void 0;let C;async function S(f=!1){return(C===void 0||f)&&(C=u()),C}e.$F7b=S;async function u(){const f=a();if(f===void 0)return!1;if(f>=22e3){const v=b();if(v)return new Promise(w=>{D.execFile(v,["--status"],p=>w(!p))})}else{const v=y();if(v)try{if((await s.Promises.stat(v)).isFile())return!0}catch{}}return!1}function a(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(f)return parseInt(f[3])}function m(f){const v=process.env.SystemRoot;if(v){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(v,w?"Sysnative":"System32",f)}}function b(){return m("wsl.exe")}function y(){return m("lxss\\LxssManager.dll")}}),define(ne[50],se([0,1,17,14,2,183,58,5,6,43]),function(Q,e,P,D,s,M,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=void 0,e.$Vo=(0,S.$Ph)("requestService");class m{constructor(c){this.b=c}toJSON(){if(!this.a){const c=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?c[i]="*****":c[i]=this.b[i];this.a=c}return this.a}}class b extends s.$Rc{constructor(c){super(),this.b=0,this.a=c.createLogger("network",{name:(0,M.localize)(0,null),when:u.$oj.isEqualTo((0,u.$mj)(u.LogLevel.Trace)).serialize()})}async c(c,i,o){const r=`${c} #${++this.b}: ${i.url}`;this.a.trace(`${r} - begin`,i.type,new m(i.headers??{}));try{const t=await o();return this.a.trace(`${r} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,i.type,(0,D.$9)(t)),t}}}e.$Wo=b;function y(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$Xo=y;function f(E){return E.res.statusCode===204}e.$Yo=f;async function v(E){return f(E)?null:(await(0,P.$ne)(E.stream)).toString()}e.$Zo=v;async function w(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);return v(E)}e.$1o=w;async function p(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);if(f(E))return null;const i=(await(0,P.$ne)(E.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.$2o=p;function $(E){h(E)}e.$3o=$;let d;function h(E){const c=a.$jn.as(C.$on.Configuration),i=d;d={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},c.updateConfigurations({add:[d],remove:i?[i]:[]})}h(1)}),define(ne[244],se([0,1,17,22]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;class s{constructor(S){this.a=S}listen(S,u){throw new Error("Invalid listen")}call(S,u,a,m=D.CancellationToken.None){switch(u){case"request":return this.a.request(a[0],m).then(async({res:b,stream:y})=>{const f=await(0,P.$ne)(y);return[{statusCode:b.statusCode,headers:b.headers},f]});case"resolveProxy":return this.a.resolveProxy(a[0])}throw new Error("Invalid call")}}e.$Yq=s;class M{constructor(S){this.a=S}async request(S,u){const[a,m]=await this.a.call("request",[S],u);return{res:a,stream:(0,P.$pe)(m)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}}e.$Zq=M}),define(ne[245],se([0,1,246,12]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;function s(C,S){return C.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:C.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function M(C,S,u={}){const a=(0,P.parse)(C),m=u.proxyUrl||s(a,S);if(!m)return null;const b=(0,P.parse)(m);if(!/^https?:$/.test(b.protocol||""))return null;const y={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,D.$Ef)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((f,v)=>{Q(["http-proxy-agent"],f,v)})).HttpProxyAgent(m,y):new(await new Promise((f,v)=>{Q(["https-proxy-agent"],f,v)})).HttpsProxyAgent(m,y)}e.$1q=M}),define(ne[247],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$17b=e.$Z7b=e.$Y7b=void 0,e.$Y7b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Z7b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$17b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ne[94],se([0,1,47,9,184,22,49,14,4,32,108,62,8,140]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=void 0;let v;async function w($,d,h,E){return h["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$j?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$Nl)(E)&&!h["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$Nl)(E)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=y.Promises.withAsyncBody(async(c,i)=>{const o=new M.$Xd;let r=1e4;const t=$.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,f.$Ol)(t,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),i(new Error((0,s.localize)(0,null)))},r);try{c(await p(d,o.token))}catch(l){!(0,S.$3)(l)&&!o.token.isCancellationRequested?i(new Error((0,s.localize)(1,null,(0,C.$Ai)(l)))):c({})}finally{clearTimeout(n),o.dispose()}})),v)}e.$Tl=w;async function p($,d){const h=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",h);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",E);const c=(0,a.$eg)().replace(/-/g,"").substr(0,12),i=new RegExp(c+"({.*})"+c),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",o);const r=await(0,m.$Dl)(u.OS,o);return $.trace("getUnixShellEnvironment#shell",r),new Promise((t,n)=>{if(d.isCancellationRequested)return n(new S.$4);const l=(0,D.$mc)(r);let g,A;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(g=`& '${process.execPath}' ${R} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,A=["-Login","-Command"]):l==="nu"?(g=`^'${process.execPath}' ${R} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,A=["-i","-l","-c"]):(g=`'${process.execPath}' ${R} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,l==="tcsh"||l==="csh"?A=["-ic"]:A=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(A),g);const k=(0,P.spawn)(r,[...A,g],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});d.onCancellationRequested(()=>(k.kill(),n(new S.$4))),k.on("error",N=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,C.$Ai)(N)),n(N)});const I=[];k.stdout.on("data",N=>I.push(N));const L=[];k.stderr.on("data",N=>L.push(N)),k.on("close",(N,T)=>{const x=Buffer.concat(I).toString("utf8");$.trace("getUnixShellEnvironment#raw",x);const X=Buffer.concat(L).toString("utf8");if(X.trim()&&$.trace("getUnixShellEnvironment#stderr",X),N||T)return n(new Error((0,s.localize)(2,null,N,T)));const ce=i.exec(x),re=ce?ce[1]:"{}";try{const ae=JSON.parse(re);h?ae.ELECTRON_RUN_AS_NODE=h:delete ae.ELECTRON_RUN_AS_NODE,E?ae.ELECTRON_NO_ATTACH_CONSOLE=E:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",ae),t(ae)}catch(ae){$.error("getUnixShellEnvironment#errorCaught",(0,C.$Ai)(ae)),n(ae)}})})}}),define(ne[248],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U3b=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const C=String(P.a++);return this.b.set(C,M),{id:C,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const C=this.b.get(s.id);if(!C)return!1;this.b.delete(s.id);try{return C.validate(M)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$U3b=P}),define(ne[95],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=void 0,e.$2k="signService",e.$3k=(0,P.$Ph)(e.$2k)}),define(ne[249],se([0,1,248]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O8b=void 0;class D extends P.$U3b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(C=>new C.signer().sign(M))}h(){return new Promise((M,C)=>Q(["vsda"],M,C))}}e.$O8b=D}),define(ne[34],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=void 0,e.$EN=(0,P.$Ph)("stateReadService"),e.$FN=(0,P.$Ph)("stateService")}),define(ne[121],se([0,1,8,17,2,12,37,16,6]),function(Q,e,P,D,s,M,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=e.$HN=e.$GN=e.SaveStrategy=void 0;var a;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class m extends s.$Rc{constructor(v,w,p,$){super(),this.h=v,this.j=p,this.m=$,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=w===0?void 0:this.B(new P.$Rg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.j.error(v)}}getItem(v,w){const p=this.a[v];return(0,M.$Hf)(p)?w:p}setItem(v,w){this.setItems([{key:v,data:w}])}setItems(v){let w=!1;for(const{key:p,data:$}of v)this.a[p]!==$&&((0,M.$Hf)($)?(0,M.$Ff)(this.a[p])||(this.a[p]=void 0,w=!0):(this.a[p]=$,w=!0));w&&this.r()}removeItem(v){(0,M.$Ff)(this.a[v])||(this.a[v]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.m.writeFile(this.h,D.$be.fromString(v),{atomic:{postfix:".vsctmp"}}),this.b=v}catch(w){this.j.error(w)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$GN=m;let b=class extends s.$Rc{constructor(v,w,p,$){super(),this.a=this.B(new m(w.stateResource,v,p,$))}async init(){await this.a.init()}getItem(v,w){return this.a.getItem(v,w)}};e.$HN=b,e.$HN=b=ve([te(1,C.$Wh),te(2,u.$0i),te(3,S.$$j)],b);class y extends b{setItem(v,w){this.a.setItem(v,w)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.$IN=y}),define(ne[122],se([0,1,4,35,32]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=void 0;function M(u){if(P.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function C(u,a,m,b,y,f,v,w,p){const $=Object.create(null);$["common.machineId"]=f,$["common.sqmId"]=v,$.sessionID=(0,s.$eg)()+Date.now(),$.commitHash=b,$.version=y,$["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,P.$i)(P.$u),$["common.nodePlatform"]=D.$cc,$["common.nodeArch"]=m,$["common.product"]=p||"desktop",w&&($["common.msftInternal"]=w);let d=0;const h=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),P.$m&&($["common.snap"]="true");const E=M(a);return E&&($["common.platformDetail"]=E),$}e.$ko=C;function S(u){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const m=a.toLowerCase();return u.some(b=>m===b)}e.$lo=S}),define(ne[26],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,P.$Ph)("telemetryService"),e.$dl=(0,P.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var D;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(ne[250],se([0,1,28,8,44,13,9,4,7,88,21,107,91,16,25,26]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=e.$Hr=e.$Gr=void 0;const p=new Map;async function $(i,o){const r=`${i}::${o.join(":")}`,t=p.get(r);if(t)return t;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,g=new Map,A=2e4;function R(I,L,N,T){const x=L.substring(I.length+1);return D.Promises.withAsyncBody(async X=>{let ce;try{ce=await m.Promises.readdir(L,{withFileTypes:!0})}catch{X();return}if(T.count>=A){T.count+=ce.length,T.maxReached=!0,X();return}let re=ce.length;if(re===0){X();return}let ae=ce;T.count+ce.length>A&&(T.maxReached=!0,re=A-T.count,ae=ce.slice(0,re)),T.count+=ce.length;for(const Z of ae)if(Z.isDirectory()){if(N.includes(Z.name)||await R(I,(0,C.$ic)(L,Z.name),N,T),--re===0){X();return}}else{const K=Z.name.lastIndexOf(".");if(K>=0){const G=Z.name.substring(K+1);G&&l.set(G,(l.get(G)??0)+1)}for(const G of n)G.relativePathPattern?.test(x)!==!1&&G.filePattern.test(Z.name)&&g.set(G.tag,(g.get(G.tag)??0)+1);if(--re===0){X();return}}})}const k=D.Promises.withAsyncBody(async I=>{const L={count:0,maxReached:!1};await R(i,i,o,L);const N=await E(i);I({configFiles:d(g),fileTypes:d(l),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:N})});return p.set(r,k),k}e.$Gr=$;function d(i){return Array.from(i.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function h(){const i={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/f.$Gk.GB).toFixed(2)}GB (${(P.freemem()/f.$Gk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(a.$Rm.value()*100)}%`},o=P.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.$Hr=h;async function E(i){try{const o=new Map,r=(0,C.$ic)(i,".vscode","launch.json"),t=await m.Promises.readFile(r),n=[],l=(0,s.$Wm)(t.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$6m)(l)==="object"&&l.configurations)for(const g of l.configurations){const A=g.type;A&&(o.has(A)?o.set(A,o.get(A)+1):o.set(A,1))}return d(o)}catch{return[]}}e.$Ir=E;let c=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const t=P.cpus();return t&&t.length>0&&r.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),r.push(`Memory (System):  ${(P.totalmem()/f.$Gk.GB).toFixed(2)}GB (${(P.freemem()/f.$Gk.GB).toFixed(2)}GB free)`),S.$j||r.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(a.$Rm.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,b.$Fr)(o.mainPID),this.k(o)]).then(async t=>{let[n,l]=t,g=this.m(o,n);return r.forEach(A=>{if((0,y.$rm)(A))g+=`
${A.errorMessage}`,l+=`
${A.errorMessage}`;else if(g+=`

Remote: ${A.hostName}`,A.processes&&(g+=`
${this.m(o,A.processes)}`),A.workspaceMetadata){l+=`
|  Remote: ${A.hostName}`;for(const R of Object.keys(A.workspaceMetadata)){const k=A.workspaceMetadata[R];let I=`${k.fileCount} files`;k.maxFilesReached&&(I=`more than ${I}`),l+=`|    Folder (${R}): ${I}`,l+=this.h(k)}}}),{processInfo:g,workspaceInfo:l}})}async getSystemInfo(o,r){const{memory:t,vmHint:n,os:l,cpus:g}=h(),A={os:l,memory:t,cpus:g,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return S.$j||(A.load=`${P.loadavg().map(R=>Math.round(R)).join(", ")}`),S.$l&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(o,r){const t=[];return(0,b.$Fr)(o.mainPID).then(async n=>(t.push(""),t.push(this.g(o)),t.push(""),t.push(this.m(o,n)),o.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.k(o))),r.forEach(l=>{if((0,y.$rm)(l))t.push(`
${l.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${l.hostName}`),t.push(this.f(l.machineInfo)),l.processes&&t.push(this.m(o,l.processes)),l.workspaceMetadata)for(const g of Object.keys(l.workspaceMetadata)){const A=l.workspaceMetadata[g];let R=`${A.fileCount} files`;A.maxFilesReached&&(R=`more than ${R}`),t.push(`Folder (${g}): ${R}`),t.push(this.h(A))}}),t.push(""),t.push(""),t.join(`
`)))}h(o){const r=[];let n=0;const l=(k,I)=>{const L=` ${k}(${I})`;n+L.length>60?(r.push(g),g="|                 ",n=g.length):n+=L.length,g+=L};let g="|      File types:";const A=10,R=o.fileTypes.length>A?A:o.fileTypes.length;for(let k=0;k<R;k++){const I=o.fileTypes[k];l(I.name,I.count)}if(r.push(g),o.configFiles.length>=0&&(g="|      Conf files:",n=0,o.configFiles.forEach(k=>{l(k.name,k.count)}),r.push(g)),o.launchConfigFiles.length>0){let k="|      Launch Configs:";o.launchConfigFiles.forEach(I=>{const L=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;k+=L}),r.push(k)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(t=>t.length));return Object.keys(o).map(t=>`${t}:  ${" ".repeat(r-t.length)}  ${o[t]}`).join(`
                  `)}k(o){const r=[],t=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(l=>{const g=u.URI.revive(l);if(g.scheme===M.Schemas.file){const A=g.fsPath;t.push($(A,["node_modules",".git"]).then(R=>{let k=`${R.fileCount} files`;R.maxFilesReached&&(k=`more than ${k}`),r.push(`|    Folder (${(0,C.$mc)(A)}): ${k}`),r.push(this.h(R))}).catch(R=>{r.push(`|      Error: Unable to collect workspace stats for folder ${A} (${R.toString()})`)}))}else r.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(o,r){const t=new Map;o.windows.forEach(l=>t.set(l.pid,`window [${l.id}] (${l.title})`)),o.pidToNames.forEach(({pid:l,name:g})=>t.set(l,g));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,t,n,r,0),n.join(`
`)}n(o,r,t,n,l){const g=l===0;let A;g?A=n.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?A=r.get(n.pid):A=`${"  ".repeat(l)} ${n.name}`;const R=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);t.push(`${n.load.toFixed(0).padStart(5," ")}	${(R/f.$Gk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(n.children)&&n.children.forEach(k=>this.n(o,r,t,k,l+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:t}of o.folders){const n=u.URI.revive(t);if(n.scheme!==M.Schemas.file)continue;const l=n.fsPath;try{(await $(l,["node_modules",".git"])).fileTypes.forEach(A=>r.add(A.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const t=u.URI.revive(r);if(t.scheme!==M.Schemas.file)continue;const n=t.fsPath;try{const l=await $(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),l.fileTypes.forEach(g=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:g.name,count:g.count})}),l.launchConfigFiles.forEach(g=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:g.name,count:g.count})}),l.configFiles.forEach(g=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};e.$Jr=c,e.$Jr=c=ve([te(0,w.$cl),te(1,v.$pj)],c)}),define(ne[251],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$57b=e.$47b=void 0;class P{constructor(M){this.b=M}listen(M,C){throw new Error(`Event not found: ${C}`)}call(M,C,{eventName:S,data:u}){return this.b.forEach(a=>a.log(S,u)),Promise.resolve(null)}}e.$47b=P;class D{constructor(M){this.b=M}log(M,C){return this.b.call("log",{eventName:M,data:C}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$57b=D}),define(ne[51],se([0,1,38,12,3,18,59,122,26]),function(Q,e,P,D,s,M,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0;class a{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$mo=a;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$no=m,e.$oo=new m;class b{async publicLog(n,l,g){}async publicLogError(n,l,g){}}e.$po=b,e.$qo="telemetry",e.$ro="extensionTelemetryLog",e.$so={log:()=>null,flush:()=>Promise.resolve(null)};function y(t,n){return s.Event.debounce(n.onDidChangeConfiguration,(g,A)=>{const R=g?new Set([...g.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:R}},1e3,!0)(g=>{g.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,M.$mi)(g.source),configurationKeys:Array.from(g.affectedKeys)})})}e.$to=y;function f(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}e.$uo=f;function v(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$vo=v;function w(t){const n=t.getValue(u.$kl),l=t.getValue(u.$ll);if(t.getValue(u.$ml)===!1||l===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$wo=w;function p(t){const n={},l={},g={};h(t,g);for(let A in g){A=A.length>150?A.substr(A.length-149):A;const R=g[A];typeof R=="number"?l[A]=R:typeof R=="boolean"?l[A]=R?1:0:typeof R=="string"?(R.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${R.length}`),n[A]=R.substring(0,8191)):typeof R<"u"&&R!==null&&(n[A]=R)}return{properties:n,measurements:l}}e.$xo=p;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(t){if(!t)return"none";const n=(0,C.$Vk)(t);return $.has(n)?n:"other"}e.$yo=d;function h(t,n,l=0,g){if(t)for(const A of Object.getOwnPropertyNames(t)){const R=t[A],k=g?g+A:A;Array.isArray(R)?n[k]=(0,P.$_m)(R):R instanceof Date?n[k]=R.toISOString():(0,D.$Af)(R)?l<2?h(R,n,l+1,k+"."):n[k]=(0,P.$_m)(R):n[k]=R}}function E(t,n){const l=t.msftInternalDomains||[],g=n.getValue("telemetry.internalTesting");return(0,S.$lo)(l)||g}e.$zo=E;function c(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Ao=c;function i(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let l=t;const g=[];for(const I of n)for(;;){const L=I.exec(t);if(!L)break;g.push([L.index,I.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,R=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(l="";;){const I=R.exec(t);if(!I)break;const L=g.some(([N,T])=>I.index<T&&N<R.lastIndex);!A.test(I[0])&&!L&&(l+=t.substring(k,I.index)+"<REDACTED: user-file-path>",k=R.lastIndex)}return k<t.length&&(l+=t.substr(k)),l}function o(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of n)if(l.regex.test(t))return`<REDACTED: ${l.label}>`;return t}function r(t,n){return(0,P.$9m)(t,l=>{if(l instanceof a||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let g=l.replaceAll("%20"," ");g=i(g,n);for(const A of n)g=g.replace(A,"");return g=o(g),g}})}e.$Bo=r}),define(ne[123],se([0,1,27,117,120,4,7,14,35,51]),function(Q,e,P,D,s,M,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0;function m(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,P.$We)(r.id,t.id)===0}e.$Co=m;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(t){const n=t.manifest?t.manifest.version:t.version,l=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new y(t.identifier,n,l)}static parse(t){const n=b.exec(t);return n&&n[1]&&n[2]?new y({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,l="undefined"){this.version=n,this.targetPlatform=l,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof y?m(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Do=y;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const t=f.exec(r);return t&&t[1]?[p(t[1]),t[2]]:[p(r),void 0]}e.$Eo=v;function w(r,t){return`${r}.${t}`}e.$Fo=w;function p(r){return r.toLowerCase()}e.$Go=p;function $(r,t){return p(w(r??s.$2l,t))}e.$Ho=$;function d(r,t){const n=[],l=g=>{for(const A of n)if(A.some(R=>m(t(R),t(g))))return A;return null};for(const g of r){const A=l(g);A?A.push(g):n.push([g])}return n}e.$Io=d;function h(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$Jo=h;function E(r){return{id:new a.$mo(r.identifier.id),name:new a.$mo(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Ko=E,e.$Lo=new s.$6l("pprice.better-merge");function c(r,t){const n=[],l=t.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const g=l.shift();if(g&&n.every(A=>!m(A.identifier,{id:g}))){const A=r.filter(R=>m(R.identifier,{id:g}));A.length===1&&(n.push(A[0]),l.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Mo=c;async function i(r,t){if(!M.$l)return!1;let n;try{n=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){t.debug("Error while getting the os-release file.",(0,S.$9)(g))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,t){const n=await i(r,t),l=(0,D.$9n)(n?"alpine":M.$u,u.$dc);return t.debug("ComputeTargetPlatform:",l),l}e.$No=o}),define(ne[252],se([0,1,206,51]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;async function s(M,C,S,u,a,m,b){const y={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${C.nameShort})`};if((0,D.$uo)(C,S)&&(0,D.$wo)(u)===3){const f=await(0,P.$cp)(S,a,m);y["X-Market-User-Id"]=f,y["VSCode-SessionId"]=b.machineId||f}return y}e.$dp=s}),define(ne[253],se([0,1,2,38,4,27,185,18,58,79,25,43,26,51]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,d,h){this.k=d,this.l=h,this.d={},this.i=new P.$Qc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=3,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,M.$Fe)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Fe)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(y.$kl)||E.affectsConfiguration(y.$ml)||E.affectsConfiguration(y.$ll))&&this.m()}))}setExperimentProperty($,d){this.d[$]=d}m(){let $=(0,f.$wo)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const h=d.usage?3:d.error?2:0;$=Math.min($,h)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,d,h){this.g<d||(h=(0,D.$0m)(h,this.d),h=(0,f.$Bo)(h,this.j),h=(0,D.$0m)(h,this.c),this.b.forEach(E=>E.log($,h)))}publicLog($,d){this.n($,3,d)}publicLog2($,d){this.publicLog($,d)}publicLogError($,d){this.h&&this.n($,2,d)}publicLogError2($,d){this.publicLogError($,d)}};e.$4q=v,e.$4q=v=ve([te(1,S.$ji),te(2,m.$pj)],v);function w(){const p=(0,C.localize)(0,null,a.default.nameLong),$=a.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=s.$p?"":(0,C.localize)(3,null),h=(0,C.localize)(4,null),E=(0,C.localize)(5,null),c=(0,C.localize)(6,null),i=(0,C.localize)(7,null),o=`
|       | ${h} | ${E} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${p} ${$} ${d}

&nbsp;

${i}
${o}

&nbsp;

${r}
`}b.$jn.as(u.$on.Configuration).registerConfiguration({id:y.$jl,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[y.$kl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$jn.as(u.$on.Configuration).registerConfiguration({id:y.$jl,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[y.$ml]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,C.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,C.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${y.$kl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[254],se([0,1,4,88,26]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u8b=e.$t8b=void 0;async function M(S,u){let a=S.getItem(s.$hl);return(typeof a!="string"||P.$k&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,D.$Sm)(u.error.bind(u))),a}e.$t8b=M;async function C(S,u){let a=S.getItem(s.$il);return typeof a!="string"&&(a=await(0,D.$Tm)(u.error.bind(u))),a}e.$u8b=C}),define(ne[255],se([0,1,26,254]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w8b=e.$v8b=void 0;async function s(C,S){const u=await(0,D.$t8b)(C,S);return C.setItem(P.$hl,u),u}e.$v8b=s;async function M(C,S){const u=await(0,D.$u8b)(C,S);return C.setItem(P.$il,u),u}e.$w8b=M}),define(ne[124],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(ne[256],se([0,1,4,124]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=void 0;const s=new Map([[D.EnvironmentVariableMutatorType.Append,"APPEND"],[D.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[D.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(m){this.collections=m,this.a=new Map,this.b=new Map,m.forEach((b,y)=>{this.d(b,y);const f=b.map.entries();let v=f.next();for(;!v.done;){const w=v.value[1],p=v.value[0];let $=this.a.get(p);if($||($=[],this.a.set(p,$)),$.length>0&&$[0].type===D.EnvironmentVariableMutatorType.Replace){v=f.next();continue}const d={extensionIdentifier:y,value:w.value,type:w.type,scope:w.scope,variable:w.variable,options:w.options};d.scope||delete d.scope,$.unshift(d),v=f.next()}})}async applyToProcessEnvironment(m,b,y){let f;P.$j&&(f={},Object.keys(m).forEach(v=>f[v.toLowerCase()]=v));for(const[v,w]of this.getVariableMap(b)){const p=P.$j&&f[v.toLowerCase()]||v;for(const $ of w){const d=y?await y($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case D.EnvironmentVariableMutatorType.Append:m[p]=(m[p]||"")+d;break;case D.EnvironmentVariableMutatorType.Prepend:m[p]=d+(m[p]||"");break;case D.EnvironmentVariableMutatorType.Replace:m[p]=d;break}if($.options?.applyAtShellIntegration??!1){const h=`VSCODE_ENV_${s.get($.type)}`;m[h]=(m[h]?m[h]+":":"")+v+"="+this.c(d)}}}}c(m){return m.replaceAll(":","\\x3a")}diff(m,b){const y=new Map,f=new Map,v=new Map;if(m.getVariableMap(b).forEach((w,p)=>{const $=this.getVariableMap(b).get(p),d=S(w,$);d&&y.set(p,d)}),this.getVariableMap(b).forEach((w,p)=>{const $=m.getVariableMap(b).get(p),d=S(w,$);d&&v.set(p,d)}),this.getVariableMap(b).forEach((w,p)=>{const $=m.getVariableMap(b).get(p),d=u(w,$);d&&f.set(p,d)}),!(y.size===0&&f.size===0&&v.size===0))return{added:y,changed:f,removed:v}}getVariableMap(m){const b=new Map;for(const y of this.a.values()){const f=y.filter(v=>C(v,m));f.length>0&&b.set(f[0].variable,f)}return b}getDescriptionMap(m){const b=new Map;for(const y of this.b.values()){const f=y.filter(v=>C(v,m,!0));for(const v of f)b.set(v.extensionIdentifier,v.description)}return b}d(m,b){if(!m.descriptionMap)return;const y=m.descriptionMap.entries();let f=y.next();for(;!f.done;){const v=f.value[1],w=f.value[0];let p=this.b.get(w);p||(p=[],this.b.set(w,p));const $={extensionIdentifier:b,scope:v.scope,description:v.description};$.scope||delete $.scope,p.push($),f=y.next()}}}e.$tr=M;function C(a,m,b=!1){return a.scope?!!(a.scope.workspaceFolder&&m?.workspaceFolder&&a.scope.workspaceFolder.index===m.workspaceFolder.index):b?m===a.scope:!0}function S(a,m){if(!m)return a;const b=new Set;m.forEach(f=>b.add(f.extensionIdentifier));const y=[];return a.forEach(f=>{b.has(f.extensionIdentifier)||y.push(f)}),y.length===0?void 0:y}function u(a,m){if(!m)return;const b=new Map;m.forEach(f=>b.set(f.extensionIdentifier,f));const y=[];return a.forEach(f=>{const v=b.get(f.extensionIdentifier);v&&(f.type!==v.type||f.value!==v.value||f.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index)&&y.push(v)}),y.length===0?void 0:y}}),define(ne[257],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=e.$qr=e.$pr=e.$or=e.$nr=void 0;function P(u){return[...u.entries()]}e.$nr=P;function D(u){return u?[...u.entries()]:[]}e.$or=D;function s(u){return new Map(u)}e.$pr=s;function M(u){return new Map(u??[])}e.$qr=M;function C(u){return Array.from(u.entries()).map(a=>[a[0],P(a[1].map),D(a[1].descriptionMap)])}e.$rr=C;function S(u){return new Map(u.map(a=>[a[0],{map:s(a[1]),descriptionMap:M(a[2])}]))}e.$sr=S}),define(ne[258],se([0,1,8,22,3,2,6]),function(Q,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0;let S=class extends M.$Rc{constructor(a,m){super(),this.h=m,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Nd),this.onCreateRequest=this.g.event,this.b=a===void 0?15e3:a,this.B((0,M.$Pc)(()=>{for(const b of this.f.values())(0,M.$Mc)(b)}))}createRequest(a){return new Promise((m,b)=>{const y=++this.a;this.c.set(y,m),this.g.fire({requestId:y,...a});const f=new D.$Xd;(0,P.$Ug)(this.b,f.token).then(()=>b(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,M.$Pc)(()=>f.cancel())])})}acceptReply(a,m){const b=this.c.get(a);b?(this.c.delete(a),(0,M.$Mc)(this.f.get(a)||[]),this.f.delete(a),b(m)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.$er=S,e.$er=S=ve([te(1,C.$0i)],S)}),define(ne[125],se([0,1,5,114,43]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.$$q=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$0q=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$9q=void 0,e.$9q=new D.$7i("terminalTabFocusMode",!1,!0);var M;(function(c){c.AutomationProfile="terminal.integrated.automationProfile.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var C;(function(c){c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.TabStopWidth="terminal.integrated.tabStopWidth",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorStyleInactive="terminal.integrated.cursorStyleInactive",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.TabFocusMode="terminal.integrated.tabFocusMode",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.HideOnStartup="terminal.integrated.hideOnStartup",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",c.EnableImages="terminal.integrated.enableImages",c.SmoothScrolling="terminal.integrated.smoothScrolling",c.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",c.FocusAfterRun="terminal.integrated.focusAfterRun",c.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",c.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",c.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",c.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var S;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(S||(e.PosixShellType=S={}));var u;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(u||(e.WindowsShellType=u={}));var a;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var m;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.PtyHostWindow="ptyHostWindow",c.Logger="logger",c.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={}));var b;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.$0q=(0,P.$Ph)("ptyService");var y;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var f;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var v;(function(c){c.TerminalView="view",c.Editor="editor"})(v||(e.TerminalLocationString=v={}));var w;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(w||(e.LocalReconnectConstants=w={}));var p;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var $;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var d;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var h;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(h||(e.TerminalExitReason=h={})),e.$$q={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const o=this.b(i.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}s.$jn.add(e.$$q.Backend,new E),e.$_q=(0,P.$Ph)("localPtyService"),e.$ar=(0,P.$Ph)("terminalLogService")}),define(ne[259],se([0,1,75,7,187,102]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=e.$gr=e.$fr=void 0;function C(y,f){const v=[{name:null,description:(0,s.localize)(0,null)}];return v.push(...y.map(w=>({name:w.profileName,description:S(w)}))),f&&v.push(...f.map(w=>({name:w.title,description:u(w)}))),{values:v.map(w=>w.name),markdownDescriptions:v.map(w=>w.description)}}e.$fr=C;function S(y){let f=`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:P.$Uj.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?f+=`
- args: "${y.args}"`:f+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(f+=`
- overrideName: ${y.overrideName}`),y.color&&(f+=`
- color: ${y.color}`),y.env&&(f+=`
- env: ${JSON.stringify(y.env)}`),f}function u(y){return`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:P.$Uj.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function a(y,f){if(!y&&!f)return!0;if(typeof y=="string"&&typeof f=="string")return y===f;if(Array.isArray(y)&&Array.isArray(f)){if(y.length!==f.length)return!1;for(let v=0;v<y.length;v++)if(y[v]!==f[v])return!1;return!0}return!1}e.$gr=a;function m(y,f){if(!y&&!f)return!0;if(!y||!f)return!1;if(M.ThemeIcon.isThemeIcon(y)&&M.ThemeIcon.isThemeIcon(f))return y.id===f.id&&y.color===f.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof f=="object"&&"light"in f&&"dark"in f){const v=y,w=f;if((D.URI.isUri(v.light)||b(v.light))&&(D.URI.isUri(v.dark)||b(v.dark))&&(D.URI.isUri(w.light)||b(w.light))&&(D.URI.isUri(w.dark)||b(w.dark)))return v.light.path===w.light.path&&v.dark.path===w.dark.path}if(D.URI.isUri(y)&&D.URI.isUri(f)||b(y)||b(f)){const v=y,w=f;return v.path===w.path&&v.scheme===w.scheme}return!1}e.$hr=m;function b(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.$ir=b}),define(ne[260],se([0,1,75,4,186,58,43,259]),function(Q,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=e.$kr=e.$jr=void 0,e.$jr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$kr={type:"string",enum:Array.from((0,P.$Tj)(),p=>p.id),markdownEnumDescriptions:Array.from((0,P.$Tj)(),p=>`$(${p.id})`)};const u={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$kr},color:{description:(0,s.localize)(3,null),...e.$jr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},a={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...u}},m={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...u}};function b(p){const $=p===2?"linux":p===1?"osx":"windows";return(0,s.localize)(7,null,(0,D.$i)(p),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:b(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...u}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...u}},{type:"null"},a]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:b(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...u}},{type:"null"},a]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:b(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...u}},{type:"null"},a]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){C.$jn.as(M.$on.Configuration).registerConfiguration(y),w()}e.$lr=f;let v;function w(p,$){const d=C.$jn.as(M.$on.Configuration);let h;p&&(h=(0,S.$fr)(p?.profiles,$));const E=v;v={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:p?.os===3?h?.values:void 0,markdownEnumDescriptions:p?.os===3?h?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:p?.os===2?h?.values:void 0,markdownEnumDescriptions:p?.os===2?h?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:p?.os===1?h?.values:void 0,markdownEnumDescriptions:p?.os===1?h?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[v],remove:E?[E]:[]})}e.$mr=w}),define(ne[261],se([0,1,28,13,38,9,4,35,27,12,21,124,257,256]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=e.$ur=void 0;function v(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let n=0;return t&&t.length===4&&(n=parseInt(t[3])),n}e.$ur=v;async function w(t,n,l,g=S.env,A=m.Promises.exists){if(M.$hc(t))return await A(t)?t:void 0;if(n===void 0&&(n=S.cwd()),M.$lc(t)!=="."){const L=M.$ic(n,t);return await A(L)?L:void 0}const k=(0,s.$bn)(g,"PATH");if(l===void 0&&(0,a.$yf)(k)&&(l=k.split(M.$sc)),l===void 0||l.length===0){const L=M.$ic(n,t);return await A(L)?L:void 0}for(const L of l){let N;if(M.$hc(L)?N=M.$ic(L,t):N=M.$ic(n,L,t),await A(N))return N;if(C.$j){let T=N+".com";if(await A(T)||(T=N+".exe",await A(T)))return T}}const I=M.$ic(n,t);return await A(I)?I:void 0}e.$vr=w;function p(t,n,l,g,A){const R=C.$j&&(!n.windowsEnableConpty||v()<18309);if(!n.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||R)return;const k=t.args,I=S.$cc==="win32"?M.$mc(t.executable).toLowerCase():M.$mc(t.executable),L=M.$lc(D.$cg.asFileUri("").fsPath);let N;const T={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(T.VSCODE_NONCE=n.shellIntegration.nonce),C.$j){if(I==="pwsh.exe"||I==="powershell.exe")return!k||o(k)?N=h.get(d.WindowsPwsh):i(k)&&(N=h.get(d.WindowsPwshLogin)),N?(N=[...N],N[N.length-1]=(0,u.$Ce)(N[N.length-1],L,""),{newArgs:N,envMixin:T}):void 0;g.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(I){case"bash":return!k||k.length===0?N=h.get(d.Bash):r(k)&&(T.VSCODE_SHELL_LOGIN="1",$(n,T),N=h.get(d.Bash)),N?(N=[...N],N[N.length-1]=(0,u.$Ce)(N[N.length-1],L),{newArgs:N,envMixin:T}):void 0;case"fish":{const x=l?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",X=M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return T.XDG_DATA_DIRS=`${x}:${X}`,$(n,T),{newArgs:void 0,envMixin:T}}case"pwsh":return!k||o(k)?N=h.get(d.Pwsh):i(k)&&(N=h.get(d.PwshLogin)),N?(N=[...N],N[N.length-1]=(0,u.$Ce)(N[N.length-1],L,""),{newArgs:N,envMixin:T}):void 0;case"zsh":{if(!k||k.length===0?N=h.get(d.Zsh):r(k)?(N=h.get(d.ZshLogin),$(n,T)):(k===h.get(d.Zsh)||k===h.get(d.ZshLogin))&&(N=k),!N)return;N=[...N],N[N.length-1]=(0,u.$Ce)(N[N.length-1],L);let x;try{x=P.userInfo().username}catch{x="unknown"}const X=M.$ic(P.tmpdir(),`${x}-${A.applicationName}-zsh`);T.ZDOTDIR=X;const ce=l?.ZDOTDIR??P.homedir()??"~";T.USER_ZDOTDIR=ce;const re=[];return re.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$ic(X,".zshrc")}),re.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$ic(X,".zprofile")}),re.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$ic(X,".zshenv")}),re.push({source:M.$ic(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$ic(X,".zlogin")}),{newArgs:N,envMixin:T,filesToCopy:re}}}g.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.$wr=p;function $(t,n){if(C.$k&&t.environmentVariableCollections){const l=(0,y.$sr)(t.environmentVariableCollections),A=new f.$tr(l).getVariableMap({workspaceFolder:t.workspaceFolder}).get("PATH"),R=[];if(A)for(const k of A)k.type===b.EnvironmentVariableMutatorType.Prepend&&R.push(k.value);R.length>0&&(n.VSCODE_PATH_PREFIX=R.join(""))}}var d;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(d||(d={}));const h=new Map;h.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),h.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),h.set(d.Zsh,["-i"]),h.set(d.ZshLogin,["-il"]),h.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],c=["-nol","-nologo"];function i(t){return typeof t=="string"?E.includes(t.toLowerCase()):t.length===1&&E.includes(t[0].toLowerCase())||t.length===2&&(E.includes(t[0].toLowerCase())||E.includes(t[1].toLowerCase()))&&(c.includes(t[0].toLowerCase())||c.includes(t[1].toLowerCase()))}function o(t){return typeof t=="string"?c.includes(t.toLowerCase()):t.length===0||t?.length===1&&c.includes(t[0].toLowerCase())}function r(t){return t==="string"&&E.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&E.includes(t[0].toLowerCase())}}),define(ne[262],se([0,1,47,75,9,4,12,21,106,261,113]),function(Q,e,P,D,s,M,C,S,u,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0;var b;(function(l){l.UnixShellsPath="/etc/shells"})(b||(b={}));let y,f=!0;function v(l,g,A,R,k=process.env,I,L,N,T){return I=I||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},M.$j?w(A,I,k,L,R.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:R.getValue("terminal.integrated.profiles.windows"),typeof g=="string"?g:R.getValue("terminal.integrated.defaultProfile.windows"),T,N):r(I,L,A,l&&typeof l=="object"?{...l}:R.getValue(M.$l?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof g=="string"?g:R.getValue(M.$l?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,N,k)}e.$xr=v;async function w(l,g,A,R,k,I,L,N,T){const x=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),X=`${process.env.windir}\\${x?"Sysnative":"System32"}`;let ce=!1;(0,a.$ur)()>=16299&&(ce=!0),await h(N);const re=new Map;if(l){re.set("PowerShell",{source:"PowerShell",icon:D.$Uj.terminalPowershell,isAutoDetected:!0}),re.set("Windows PowerShell",{path:`${X}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.$Uj.terminalPowershell,isAutoDetected:!0}),re.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),re.set("Command Prompt",{path:`${X}\\cmd.exe`,icon:D.$Uj.terminalCmd,isAutoDetected:!0}),re.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),re.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:D.$Uj.terminalBash,isAutoDetected:!0});const Z=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;re.set("Cmder",{path:`${X}\\cmd.exe`,args:["/K",Z],requiresPath:process.env.CMDER_ROOT?Z:{path:Z,isUnsafe:!0},isAutoDetected:!0})}t(I,re);const ae=await p(re.entries(),L,g,A,R,T);if(l&&k)try{const Z=await i(`${X}\\${ce?"wsl":"bash"}.exe`,L);for(const K of Z)(!I||!(K.profileName in I))&&ae.push(K)}catch{f&&(R?.info("WSL is not installed, so could not detect WSL profiles"),f=!1)}return ae}async function p(l,g,A,R=process.env,k,I){const L=[];for(const[N,T]of l)L.push($(N,T,g,A,R,k,I));return(await Promise.all(L)).filter(N=>!!N)}async function $(l,g,A,R,k=process.env,I,L){if(g===null)return;let N,T,x;if("source"in g&&!("path"in g)){const ae=y?.get(g.source);if(!ae)return;N=ae.paths,T=g.args||ae.args,g.icon?x=d(g.icon):ae.icon&&(x=ae.icon)}else N=Array.isArray(g.path)?g.path:[g.path],T=M.$j||Array.isArray(g.args)?g.args:void 0,x=d(g.icon);let X;if(L){const ae=N.map(K=>typeof K=="string"?K:K.path),Z=await L(ae);X=new Array(N.length);for(let K=0;K<N.length;K++)typeof N[K]=="string"?X[K]=Z[K]:X[K]={path:Z[K],isUnsafe:!0}}else X=N.slice();let ce;if(g.requiresPath){let ae;if((0,C.$yf)(g.requiresPath)?ae=g.requiresPath:(ae=g.requiresPath.path,g.requiresPath.isUnsafe&&(ce=ae)),!await R.existsFile(ae))return}const re=await n(l,A,X,R,k,T,g.env,g.overrideName,g.isAutoDetected,ce);if(!re){I?.debug("Terminal profile not validated",l,N);return}return re.isAutoDetected=g.isAutoDetected,re.icon=x,re.color=g.color,re}function d(l){return typeof l=="string"?{id:l}:l}async function h(l){if(y&&!l)return;const[g,A]=await Promise.all([E(),l||c()]);y=new Map,y.set("Git Bash",{profileName:"Git Bash",paths:g,args:["--login","-i"]}),y.set("PowerShell",{profileName:"PowerShell",paths:A,icon:D.$Uj.terminalPowershell})}async function E(){const l=new Set,g=await(0,a.$vr)("git.exe");if(g){const k=(0,m.dirname)(g);l.add((0,m.resolve)(k,"../.."))}function A(k,I){I&&k.add(I)}A(l,process.env.ProgramW6432),A(l,process.env.ProgramFiles),A(l,process.env["ProgramFiles(X86)"]),A(l,`${process.env.LocalAppData}\\Program`);const R=[];for(const k of l)R.push(`${k}\\Git\\bin\\bash.exe`,`${k}\\Git\\usr\\bin\\bash.exe`,`${k}\\usr\\bin\\bash.exe`);return R.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),R.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),R}async function c(){const l=[];for await(const g of(0,u.$xl)())l.push(g.exePath);return l}async function i(l,g){const A=[],R=await new Promise((L,N)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,x)=>{if(T)return N("Problem occurred when getting wsl distros");L(x)})});if(!R)return[];const k=new RegExp(/[\r?\n]/),I=R.split(k).filter(L=>L.trim().length>0&&L!=="");for(const L of I){if(L===""||L.startsWith("docker-desktop"))continue;const N=`${L} (WSL)`,T={profileName:N,path:l,args:["-d",`${L}`],isDefault:N===g,icon:o(L),isAutoDetected:!1};A.push(T)}return A}function o(l){return l.includes("Ubuntu")?D.$Uj.terminalUbuntu:l.includes("Debian")?D.$Uj.terminalDebian:D.$Uj.terminalLinux}async function r(l,g,A,R,k,I,L,N){const T=new Map;if(A&&await l.existsFile("/etc/shells")){const x=(await l.readFile("/etc/shells")).toString(),X=(I||x.split(`
`)).map(re=>{const ae=re.indexOf("#");return ae===-1?re:re.substring(0,ae)}).filter(re=>re.trim().length>0),ce=new Map;for(const re of X){let ae=(0,s.$mc)(re),Z=ce.get(ae)||0;Z++,Z>1&&(ae=`${ae} (${Z})`),ce.set(ae,Z),T.set(ae,{path:re,isAutoDetected:!0})}}return t(R,T),await p(T.entries(),k,l,N,g,L)}function t(l,g){if(l)for(const[A,R]of Object.entries(l))R===null||typeof R!="object"||!("path"in R)&&!("source"in R)?g.delete(A):(R.icon=R.icon||g.get(A)?.icon,g.set(A,R))}async function n(l,g,A,R,k,I,L,N,T,x){if(A.length===0)return Promise.resolve(void 0);const X=A.shift();if(X==="")return n(l,g,A,R,k,I,L,N,T);const ce=typeof X!="string"&&X.isUnsafe,re=typeof X=="string"?X:X.path,ae={profileName:l,path:re,args:I,env:L,overrideName:N,isAutoDetected:T,isDefault:l===g,isUnsafePath:ce,requiresUnsafePath:x};if((0,s.$mc)(re)===re){const K=k.PATH?k.PATH.split(s.$sc):void 0,G=await(0,a.$vr)(re,void 0,K,void 0,R.existsFile);return G?(ae.path=G,ae.isFromPath=!0,ae):n(l,g,A,R,k,I)}return await R.existsFile((0,s.$gc)(re))?ae:n(l,g,A,R,k,I,L,N,T)}}),define(ne[263],se([0,1,3,2,4,42,18,6,226,94,258,125,260,262,108,73]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;var p;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let $=class extends D.$Rc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(h,E,c,i){super(),this.M=h,this.N=E,this.O=c,this.P=i,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new P.$Nd),this.onPtyHostExit=this.u.event,this.w=this.B(new P.$Nd),this.onPtyHostStart=this.w.event,this.y=this.B(new P.$Nd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new P.$Nd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new P.$Nd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new P.$Nd),this.onProcessData=this.D.event,this.F=this.B(new P.$Nd),this.onProcessReady=this.F.event,this.G=this.B(new P.$Nd),this.onProcessReplay=this.G.event,this.H=this.B(new P.$Nd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new P.$Nd),this.onDidRequestDetach=this.I.event,this.J=this.B(new P.$Nd),this.onDidChangeProperty=this.J.event,this.L=this.B(new P.$Nd),this.onProcessExit=this.L.event,(0,y.$lr)(),this.B(this.M),this.B((0,D.$Pc)(()=>this.W())),this.j=this.B(new m.$er(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&P.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$j)return process.env;try{return await(0,a.$Tl)(this.N,this.O,{_:[]},process.env)}catch(h){return this.O.error("ptyHost was unable to resolve shell environment",h),{}}}U(){const h=this.M.start(),E=h.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(E.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(h.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=p.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const i=M.ProxyChannel.toService(E.getChannel(b.TerminalIpcChannels.PtyHost));return this.B(i.onProcessData(o=>this.D.fire(o))),this.B(i.onProcessReady(o=>this.F.fire(o))),this.B(i.onProcessExit(o=>this.L.fire(o))),this.B(i.onDidChangeProperty(o=>this.J.fire(o))),this.B(i.onProcessReplay(o=>this.G.fire(o))),this.B(i.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(i.onDidRequestDetach(o=>this.I.fire(o))),this.B(new u.$dr(this.P,E.getChannel(b.TerminalIpcChannels.Logger))),this.a=h,this.b=i,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[h,i]}async createProcess(h,E,c,i,o,r,t,n,l,g,A){const R=setTimeout(()=>this.$(),b.HeartbeatConstants.CreateProcessTimeout),k=await this.f.createProcess(h,E,c,i,o,r,t,n,l,g,A);return clearTimeout(R),k}updateTitle(h,E,c){return this.f.updateTitle(h,E,c)}updateIcon(h,E,c,i){return this.f.updateIcon(h,E,c,i)}attachToProcess(h){return this.f.attachToProcess(h)}detachFromProcess(h,E){return this.f.detachFromProcess(h,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(h){return this.f.start(h)}shutdown(h,E){return this.f.shutdown(h,E)}input(h,E){return this.f.input(h,E)}processBinary(h,E){return this.f.processBinary(h,E)}resize(h,E,c){return this.f.resize(h,E,c)}clearBuffer(h){return this.f.clearBuffer(h)}acknowledgeDataEvent(h,E){return this.f.acknowledgeDataEvent(h,E)}setUnicodeVersion(h,E){return this.f.setUnicodeVersion(h,E)}getInitialCwd(h){return this.f.getInitialCwd(h)}getCwd(h){return this.f.getCwd(h)}async getLatency(){const h=new w.$Jd,E=await this.f.getLatency();return h.stop(),[{label:"ptyhostservice<->ptyhost",latency:h.elapsed()},...E]}orphanQuestionReply(h){return this.f.orphanQuestionReply(h)}installAutoReply(h,E){return this.f.installAutoReply(h,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(h){return this.f.uninstallAutoReply(h)}getDefaultSystemShell(h){return this.g?.getDefaultSystemShell(h)??(0,v.$Dl)(h??s.OS,process.env)}async getProfiles(h,E,c,i=!1){const o=await this.S();return(0,f.$xr)(E,c,i,this.N,o,void 0,this.O,this.bb.bind(this,h))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(h,E){return this.f.getWslPath(h,E)}getRevivedPtyNewId(h,E){return this.f.getRevivedPtyNewId(h,E)}setTerminalLayoutInfo(h){return this.f.setTerminalLayoutInfo(h)}async getTerminalLayoutInfo(h){return this.g?.getTerminalLayoutInfo(h)}async requestDetachInstance(h,E){return this.f.requestDetachInstance(h,E)}async acceptDetachInstanceReply(h,E){return this.f.acceptDetachInstanceReply(h,E)}async freePortKillProcess(h){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(h)}async serializeTerminalState(h){return this.f.serializeTerminalState(h)}async reviveTerminalProcesses(h,E,c){return this.f.reviveTerminalProcesses(h,E,c)}async refreshProperty(h,E){return this.f.refreshProperty(h,E)}async updateProperty(h,E,c){return this.f.updateProperty(h,E,c)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(h){this.ab(),this.s=setTimeout(()=>this.Y(),h?b.HeartbeatConstants.ConnectingBeatInterval:b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(h,E){return this.j.createRequest({workspaceId:h,originalText:E})}async acceptPtyHostResolvedVariables(h,E){this.j.acceptReply(h,E)}};e.$yr=$,e.$yr=$=ve([te(1,C.$ji),te(2,S.$0i),te(3,S.$$i)],$)}),define(ne[68],se([0,1,15,3,2,4,18,5,34]),function(Q,e,P,D,s,M,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y6b=e.$X6b=void 0;const a="#FFFFFF",m="#1E1E1E",b="#000000",y="#FFFFFF",f="theme",v="themeBackground",w="windowSplash";e.$X6b=(0,S.$Ph)("themeMainService");let p=class extends s.$Rc{constructor(d,h){super(),this.b=d,this.c=h,this.a=this.B(new D.$Nd),this.onDidChangeColorScheme=this.a.event,P.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$j){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$k){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$l&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const d=this.getColorScheme();if(d.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return d.dark?b:y;let h=this.b.getItem(v,null);if(!h)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":h=a;break;case"hc-black":h=b;break;case"hc-light":h=y;break;default:h=m}return M.$k&&h.toUpperCase()===m&&(h="#171717"),h}saveWindowSplash(d,h){this.b.setItems([{key:f,data:h.baseTheme},{key:v,data:h.colorInfo.background},{key:w,data:h}]),typeof d=="number"&&this.f(d,h)}f(d,h){for(const E of P.BrowserWindow.getAllWindows())if(E.id===d){E.setBackgroundColor(h.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};e.$Y6b=p,e.$Y6b=p=ve([te(0,u.$FN),te(1,C.$ji)],p)}),define(ne[126],se([0,1,3,18,5,6]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.ProvidedOnAutoForward=e.$cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$bv=e.$av=void 0,e.$av=(0,s.$Ph)("tunnelService"),e.$bv=(0,s.$Ph)("sharedTunnelsService");var C;(function(p){p.Http="http",p.Https="https"})(C||(e.TunnelProtocol=C={}));var S;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(S||(e.TunnelPrivacyId=S={}));function u(p){return!!p.forwardPort}e.$cv=u;var a;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function m(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const $=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if($)return{address:$[1],port:+$[2]}}e.$dv=m,e.$ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(p){return e.$ev.indexOf(p)>=0}e.$fv=b,e.$gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(p){return e.$gv.indexOf(p)>=0}e.$hv=y;function f(p,$,d,h){if(d===1)return!1;if(d===2&&y($)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(E?.length===4&&parseInt(E[1])>=18)return!1}return p<1024}e.$iv=f;class v{constructor($,d,h){this.remoteAddress=$,this.localAddress=d,this.b=h,this.a=new P.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$jv=v;let w=class{constructor($,d){this.j=$,this.k=d,this.a=new P.$Nd,this.onTunnelOpened=this.a.event,this.b=new P.$Nd,this.onTunnelClosed=this.b.event,this.c=new P.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const $=this.k.getValue("remote.localPortHost");return!$||$==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider($){return this.f=$,$?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures($){this.g=$.elevation,this.h=$.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const $=[],d=Array.from(this.e.values());for(const h of d){const E=Array.from(h.values());for(const c of E){const i=await c.value;i&&typeof i!="string"&&$.push(i)}}return $}async dispose(){for(const $ of this.e.values()){for(const{value:d}of $.values())await d.then(h=>typeof h!="string"?h?.dispose():void 0);$.clear()}this.e.clear()}setEnvironmentTunnel($,d,h,E,c){this.p($,d,Promise.resolve({tunnelRemoteHost:$,tunnelRemotePort:d,localAddress:h,privacy:E,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel($,d){(y($)||b($))&&($=e.$ev[0]);const h=this.r($,d);if(h)return++h.refcount,h.value}openTunnel($,d,h,E,c,i=!1,o,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${h} on local port ${c}.`);const t=this.f??$;if(!t)return;if(d||(d="localhost"),E||(E=this.l),this.f&&this.i.has(h)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(t,d,h,E,c,i,o,r);return n?n.then(l=>{if(l){if(typeof l=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(d,h),l}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(d,h);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.n(l);return(l.tunnelRemoteHost!==d||l.tunnelRemotePort!==h)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&l.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n($){return{tunnelRemotePort:$.tunnelRemotePort,tunnelRemoteHost:$.tunnelRemoteHost,tunnelLocalPort:$.tunnelLocalPort,localAddress:$.localAddress,privacy:$.privacy,protocol:$.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${$.tunnelRemoteHost}:${$.tunnelRemotePort} `);const d=this.e.get($.tunnelRemoteHost);if(d){const h=d.get($.tunnelRemotePort);h&&(h.refcount--,await this.o($.tunnelRemoteHost,$.tunnelRemotePort,h))}}}}async o($,d,h){if(h.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${$}:${d}.`);const E=h.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has($)&&this.e.get($).delete(d),E}}async closeTunnel($,d){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${$}:${d} `);const h=this.e.get($);if(h&&h.has(d)){const E=h.get(d);E.refcount=0,await this.o($,d,E)}}p($,d,h){this.e.has($)||this.e.set($,new Map),this.e.get($).set(d,{refcount:1,value:h})}async q($,d){const h=this.e.get($);if(h){const E=h.get(d),c=E?await E.value:void 0;(!c||typeof c=="string")&&h.delete(d),h.size===0&&this.e.delete($)}}r($,d){const h=[$];b($)?(h.push(...e.$ev),h.push(...e.$gv)):y($)&&h.push(...e.$gv);const E=h.map(c=>this.e.get(c));for(const c of E){const i=c?.get(d);if(i)return i}}canTunnel($){return!!m($)}t($,d,h,E,c,i,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${h} on local port ${E}.`);const r=h;this.i.add(r);const t=E===void 0?h:E,n={elevationRequired:c?this.isPortPrivileged(t):!1},l={remoteAddress:{host:d,port:h},localAddressPort:E,privacy:i,public:i?i!==S.Private:void 0,protocol:o},g=$.forwardPort(l,n);return g?(this.p(d,h,g),g.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),g}};e.$kv=w,e.$kv=w=ve([te(0,M.$0i),te(1,D.$ji)],w)}),define(ne[48],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yU=e.$xU=e.DisablementReason=e.UpdateType=e.StateType=void 0;var D;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.Disabled="disabled",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(D||(e.StateType=D={}));var s;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(C){C[C.NotBuilt=0]="NotBuilt",C[C.DisabledByEnvironment=1]="DisabledByEnvironment",C[C.ManuallyDisabled=2]="ManuallyDisabled",C[C.MissingConfiguration=3]="MissingConfiguration",C[C.InvalidConfiguration=4]="InvalidConfiguration",C[C.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$xU={Uninitialized:{type:"uninitialized"},Disabled:C=>({type:"disabled",reason:C}),Idle:(C,S)=>({type:"idle",updateType:C,error:S}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.$yU=(0,P.$Ph)("updateService")}),define(ne[264],se([0,1,4,188,58,43]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$jn.as(s.$on.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:P.$j&&!P.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ne[265],se([0,1,3,48]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$77b=e.$67b=void 0;class s{constructor(S){this.a=S}listen(S,u){switch(u){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${u}`)}call(S,u,a){switch(u){case"checkForUpdates":return this.a.checkForUpdates(a);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(a)}throw new Error(`Call not found: ${u}`)}}e.$67b=s;class M{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new P.$Nd,this.onStateChange=this.a.event,this.b=D.$xU.Uninitialized,this.c.listen("onStateChange")(u=>this.state=u),this.c.call("_getInitialState").then(u=>this.state=u)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$77b=M}),define(ne[40],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=void 0,e.$Ik=(0,P.$Ph)("IUriIdentityService")}),define(ne[266],se([0,1,40,207,16,19,141,3,2]),function(Q,e,P,D,s,M,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;class a{static{this._clock=0}constructor(y){this.uri=y,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let m=class{constructor(y){this.g=y,this.c=new u.$Qc,this.f=2**16;const f=new Map,v=w=>{let p=f.get(w.scheme);return p===void 0&&(p=y.hasProvider(w)&&!this.g.hasCapability(w,1024),f.set(w.scheme,p)),p};this.c.add(S.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(w=>{f.delete(w.scheme)})),this.extUri=new M.$kg(v),this.d=new C.$Br((w,p)=>this.extUri.compare(w,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,M.$wg)(y));const f=this.d.get(y);return f?f.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new a(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((v,w)=>v[1].time<w[1].time?1:v[1].time>w[1].time?-1:0);a._clock=0,this.d.clear();const f=this.f*.5;for(let v=0;v<f;v++)this.d.set(y[v][0],y[v][1].touch())}};e.$Cr=m,e.$Cr=m=ve([te(0,s.$$j)],m),(0,D.$zr)(P.$Ik,m,1)}),define(ne[127],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mU=void 0,e.$mU=(0,P.$Ph)("urlService")}),define(ne[267],se([0,1,7]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d8b=e.$c8b=e.$b8b=void 0;class D{constructor(S){this.a=S}listen(S,u){throw new Error(`Event not found: ${u}`)}call(S,u,a){switch(u){case"handleURL":return this.a.handleURL(P.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${u}`)}}e.$b8b=D;class s{constructor(S){this.a=S}handleURL(S,u){return this.a.call("handleURL",[S.toJSON(),u])}}e.$c8b=s;class M{constructor(S,u){this.a=S,this.b=u}async routeCall(S,u,a,m){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(Array.isArray(a)&&a.length>0){const b=P.URI.revive(a[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",b.toString(!0)),b.query){const y=/\bwindowId=(\d+)/.exec(b.query);if(y){const f=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,b.toString(!0));const v=new RegExp(`window:${f}`),w=S.connections.find(p=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",p.ctx),v.test(p.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",b.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",b.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",b.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,u,a,m)}routeEvent(S,u){throw new Error(`Event not found: ${u}`)}}e.$d8b=M}),define(ne[268],se([0,1,8,2,7,25]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oU=e.$nU=void 0;class C extends D.$Rc{constructor(){super(...arguments),this.a=new Set}open(a,m){const b=[...this.a.values()];return(0,P.$Xg)(b.map(y=>()=>y.handleURL(a,m)),void 0,!1).then(y=>y||!1)}registerHandler(a){return this.a.add(a),(0,D.$Pc)(()=>this.a.delete(a))}}e.$nU=C;let S=class extends C{constructor(a){super(),this.b=a}create(a){let{authority:m,path:b,query:y,fragment:f}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&b&&b.indexOf("/")!==0&&(b=`/${b}`),s.URI.from({scheme:this.b.urlProtocol,authority:m,path:b,query:y,fragment:f})}};e.$oU=S,e.$oU=S=ve([te(0,M.$pj)],S)}),define(ne[269],se([0,1,15,8,3,2,4,7]),function(Q,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e8b=void 0;class u extends M.$Rc{constructor(m,b,y,f,v,w){if(super(),this.c=b,this.f=w,this.a=[],this.b=0,m&&(w.trace("ElectronURLListener initialUrisToHandle:",m.map(d=>d.originalUrl)),this.a=m),C.$j){const d=f.isBuilt?[]:[`"${f.appRoot}"`];d.push("--open-url","--"),P.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,d)}const p=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(d,h)=>({event:d,url:h})),({event:d,url:h})=>(d.preventDefault(),h));this.B(p(d=>{const h=this.g(d);h&&this.c.open(h,{originalUrl:d})})),y.getWindows().filter(d=>d.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(y.onDidSignalReadyWindow)(()=>this.h())))}g(m){try{return S.URI.parse(m)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const b of this.a)await this.c.open(b.uri,{originalUrl:b.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",b.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",b.originalUrl),m.push(b));m.length!==0&&(this.a=m,(0,D.$Vg)(()=>this.h(),500,this.q))}}e.$e8b=u}),define(ne[270],se([0,1,3,2,16,57,31]),function(Q,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R8b=void 0;class S extends D.$Rc{constructor(a,m,b,y,f,v){super(),this.f=a,this.g=m,this.h=b,this.j=y,this.m=f,this.n=v,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$Nd),this.onDidChangeFile=this.a.event,this.b=M.$Vh.forUris(()=>!(this.capabilities&1024)),this.c=new C.$Ac(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,m){return this.g.open(this.t(a),m)}close(a){return this.g.close(a)}read(a,m,b,y,f){return this.g.read(a,m,b,y,f)}write(a,m,b,y,f){return this.g.write(a,m,b,y,f)}watch(a,m){this.b.set(a,a);const b=this.g.watch(this.t(a),m);return(0,D.$Pc)(()=>{this.b.delete(a),b.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,m,b){return this.g.rename(this.t(a),this.t(m),b)}readFile(a,m){return this.g.readFile(this.t(a),m)}readFileStream(a,m,b){return this.g.readFileStream(this.t(a),m,b)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,m,b){return this.g.writeFile(this.t(a),m,b)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,m){return this.g.delete(this.t(a),m)}copy(a,m,b){if((0,s.$ck)(this.g))return this.g.copy(this.t(a),this.t(m),b);throw new Error("copy not supported")}cloneFile(a,m){if((0,s.$dk)(this.g))return this.g.cloneFile(this.t(a),this.t(m));throw new Error("clone not supported")}s(a){const m=[];for(const b of a){if(b.resource.scheme!==this.f)continue;const y=this.u(b.resource);this.b.findSubstr(y)&&m.push({resource:y,type:b.type,cId:b.cId})}m.length&&(this.n.debug("User data changed"),this.a.fire(m))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$R8b=S}),define(ne[271],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y8b=void 0,e.$y8b="utilityProcessWorker"}),define(ne[272],se([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f8b=void 0,e.$f8b=(0,P.$Ph)("webviewManagerService")}),define(ne[273],se([0,1,15,2,13,7]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g8b=void 0;class C extends D.$Rc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const u=this.b.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,u)}b(u,a){try{const m=M.URI.parse(u.url),b=C.a.get(m.path);if(typeof b=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${b}`,f=s.$cg.asFileUri(y);return a({path:f.fsPath,headers:{...s.COI.getHeadersFromQuery(u.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.$g8b=C}),define(ne[69],se([0,1,4]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=e.$pC=e.$oC=e.$nC=e.$mC=e.$lC=e.$kC=e.$jC=e.$iC=void 0,e.$iC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function D(b){return typeof b.parentId=="number"}e.$jC=D;function s(b){return!!b.workspaceUri}e.$kC=s;function M(b){return!!b.folderUri}e.$lC=M;function C(b){return!!b.fileUri}e.$mC=C;function S(b){const y=u(b),f=b.getValue("window.menuBarVisibility");return f==="default"||y==="native"&&f==="compact"||P.$k&&P.$n?"classic":f}e.$nC=S;function u(b){if(P.$p)return"custom";const y=b.getValue("window");if(y){if(P.$k&&y.nativeTabs===!0||P.$k&&y.nativeFullScreen===!1)return"native";const w=y.titleBarStyle;if(w==="native"||w==="custom")return w}return P.$l?"native":"custom"}e.$oC=u;function a(b){return!(!P.$j||P.$p||u(b)==="native")}e.$pC=a;function m(b=0){return Math.pow(1.2,b)}e.$qC=m}),define(ne[128],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$I6b=e.UnloadReason=e.LoadReason=void 0;var P;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var D;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(D||(e.UnloadReason=D={}));const s=function(S=1){return{width:1024,height:768,mode:S}};e.$I6b=s;var M;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var C;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(C||(e.WindowError=C={}))}),define(ne[274],se([0,1,8,3,2]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m8b=void 0;class M extends s.$Rc{constructor({onDidOpenWindow:S,onDidFocusWindow:u,getActiveWindowId:a}){super(),this.a=this.B(new s.$Qc),D.Event.latch(D.Event.any(S,u))(this.f,this,this.a),this.b=(0,P.$Hg)(()=>a()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$m8b=M}),define(ne[30],se([0,1,192,9,57,19,7,5,13]),function(Q,e,P,D,s,M,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,S.$Ph)("contextService");function a(t){const n=t;return typeof n?.id=="string"&&C.URI.isUri(n.uri)}e.$Zh=a;function m(t){return typeof t?.id=="string"&&!a(t)&&!y(t)}e.$1h=m,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function b(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,D.$mc)(t)}:n?e.$2h:e.$3h;const l=t;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$4h=b;function y(t){const n=t;return typeof n?.id=="string"&&C.URI.isUri(n.configPath)}e.$5h=y;function f(t){const n=t;if(n?.uri)return{id:n.id,uri:C.URI.revive(n.uri)};const l=t;if(l?.configPath)return{id:l.id,configPath:C.URI.revive(l.configPath)};if(t?.id)return{id:t.id}}e.$6h=f;var v;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function w(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$7h=w;function p(t){const n=t;return!!(n&&typeof n=="object"&&C.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$8h=p;class ${constructor(n,l,g,A,R){this.h=n,this.j=g,this.k=A,this.l=R,this.c=s.$Vh.forUris(this.l,()=>!0),this.folders=l}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Vh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=$;class d{constructor(n,l){this.raw=l,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$vg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=d;function h(t){return new d({uri:t,index:0,name:(0,M.$rg)(t)},{uri:t.toString()})}e.$$h=h,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,P.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function E(t,n){return M.$mg.isEqualOrParent(t,n.untitledWorkspacesHome)}e.$di=E;function c(t){let n;return C.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===u.Schemas.tmp}e.$ei=c,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$fi}e.$gi=i;function o(t,n){return!E(t,n)&&!c(t)}e.$hi=o;function r(t){return(typeof t=="string"?(0,D.$nc)(t):(0,M.$tg)(t))===e.$ai}e.$ii=r}),define(ne[52],se([0,1,15,8,56,46,2,85,4,21,167,115,5,6,25,30]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=e.$46b=void 0,e.$46b=(0,y.$Ph)("dialogMainService");let p=class{constructor(d,h){this.d=d,this.e=h,this.a=new Map,this.b=new Map,this.c=new D.$1g}pickFileFolder(d,h){return this.f({...d,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},h)}pickFolder(d,h){return this.f({...d,pickFolders:!0,title:(0,m.localize)(1,null)},h)}pickFile(d,h){return this.f({...d,pickFiles:!0,title:(0,m.localize)(2,null)},h)}pickWorkspace(d,h){const E=(0,m.localize)(3,null),c=(0,M.$Bv)((0,m.localize)(4,null)),i=w.$bi;return this.f({...d,pickFiles:!0,title:E,filters:i,buttonLabel:c},h)}async f(d,h){const E={title:d.title,buttonLabel:d.buttonLabel,filters:d.filters,defaultPath:d.defaultPath};(typeof d.pickFiles=="boolean"||typeof d.pickFolders=="boolean")&&(E.properties=void 0,d.pickFiles&&d.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",d.pickFolders?"openDirectory":"openFile","createDirectory"]),u.$k&&E.properties.push("treatPackageAsDirectory");const c=await this.showOpenDialog(E,(h||P.BrowserWindow.getFocusedWindow())??void 0);if(c&&c.filePaths&&c.filePaths.length>0)return c.filePaths}g(d){if(d){let h=this.b.get(d.id);return h||(h=new D.$1g,this.b.set(d.id,h)),h}else return this.c}showMessageBox(d,h){return this.g(h).queue(async()=>{const{options:E,buttonIndeces:c}=(0,b.$Iv)(d,this.e);let i;return h?i=await P.dialog.showMessageBox(h,E):i=await P.dialog.showMessageBox(E),{response:c[i.response],checkboxChecked:i.checkboxChecked}})}async showSaveDialog(d,h){const E=this.j(d,h);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(h).queue(async()=>{let c;return h?c=await P.dialog.showSaveDialog(h,d):c=await P.dialog.showSaveDialog(d),c.filePath=this.h(c.filePath),c})}finally{(0,C.$Mc)(E)}}h(d){return d&&u.$k&&(d=(0,S.$ol)(d)),d}i(d){return d.map(h=>this.h(h))}async showOpenDialog(d,h){d.defaultPath&&(await a.Promises.exists(d.defaultPath)||(d.defaultPath=void 0));const E=this.j(d,h);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(h).queue(async()=>{let c;return h?c=await P.dialog.showOpenDialog(h,d):c=await P.dialog.showOpenDialog(d),c.filePaths=this.i(c.filePaths),c})}finally{(0,C.$Mc)(E)}}j(d,h){if(!h)return C.$Rc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",d);let E=this.a.get(h.id);E||(E=new Set,this.a.set(h.id,E));const c=(0,s.$Di)(d);if(!E.has(c))return this.d.trace("[DialogMainService]: new file dialog lock created",d),E.add(c),(0,C.$Pc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",d),E?.delete(c),E?.size===0&&this.a.delete(h.id)})}};e.$56b=p,e.$56b=p=ve([te(0,f.$0i),te(1,v.$pj)],p)}),define(ne[275],se([0,1,3,2,77,30]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$37b=void 0;class C extends D.$Rc{static{this.a=100}constructor(u,a){super(),this.f=u,this.g=a,this.b=this.B(new P.$Nd),this.c=new Map,this.h(a.applicationStorage,this.b)}h(u,a){this.B(P.Event.debounce(u.onDidChangeStorage,(m,b)=>(m?m.push(b):m=[b],m),C.a)(m=>{m.length&&a.fire(this.j(m,u))}))}j(u,a){const m=new Map,b=new Set;return u.forEach(y=>{const f=a.get(y.key);typeof f=="string"?m.set(y.key,f):b.add(y.key)}),{changed:Array.from(m.entries()),deleted:Array.from(b.values())}}listen(u,a,m){switch(a){case"onDidChangeStorage":{const b=m.profile?(0,s.$mh)(m.profile):void 0;if(!b)return this.b.event;let y=this.c.get(b.id);return y||(y=this.B(new P.$Nd),this.h(this.g.profileStorage(b),y),this.c.set(b.id,y)),y.event}}throw new Error(`Event not found: ${a}`)}async call(u,a,m){const b=m.profile?(0,s.$mh)(m.profile):void 0,y=(0,M.$6h)(m.workspace),f=await this.m(b,y);switch(a){case"getItems":return Array.from(f.items.entries());case"updateItems":{const v=m;if(v.insert)for(const[w,p]of v.insert)f.set(w,p);v.delete?.forEach(w=>f.delete(w));break}case"optimize":return f.optimize();case"isUsed":{const v=m.payload;if(typeof v=="string")return this.g.isUsed(v)}default:throw new Error(`Call not found: ${a}`)}}async m(u,a){let m;a?m=this.g.workspaceStorage(a):u?m=this.g.profileStorage(u):m=this.g.applicationStorage;try{await m.init()}catch(b){this.f.error(`StorageIPC#init: Unable to init ${a?"workspace":u?"profile":"application"} storage due to ${b}`)}return m}}e.$37b=C}),define(ne[41],se([0,1,56,3,2,19,7,189,37,16,5,6,30,31,40,8,32,27,12]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.ProfileResourceType=void 0;var h;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function E(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&C.URI.isUri(n.location)&&C.URI.isUri(n.globalStorageHome)&&C.URI.isUri(n.settingsResource)&&C.URI.isUri(n.keybindingsResource)&&C.URI.isUri(n.tasksResource)&&C.URI.isUri(n.snippetsHome)&&C.URI.isUri(n.extensionsResource))}e.$Jk=E,e.$Kk=(0,m.$Ph)("IUserDataProfilesService");function c(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:C.URI.revive(t.location).with({scheme:n}),globalStorageHome:C.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:C.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:C.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:C.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:C.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:C.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:C.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.$Lk=c;function i(t,n,l,g,A,R){return{id:t,name:n,location:l,isDefault:!1,shortName:A?.shortName,icon:A?.icon,globalStorageHome:R&&A?.useDefaultFlags?.globalState?R.globalStorageHome:(0,M.$vg)(l,"globalStorage"),settingsResource:R&&A?.useDefaultFlags?.settings?R.settingsResource:(0,M.$vg)(l,"settings.json"),keybindingsResource:R&&A?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,M.$vg)(l,"keybindings.json"),tasksResource:R&&A?.useDefaultFlags?.tasks?R.tasksResource:(0,M.$vg)(l,"tasks.json"),snippetsHome:R&&A?.useDefaultFlags?.snippets?R.snippetsHome:(0,M.$vg)(l,"snippets"),extensionsResource:R&&A?.useDefaultFlags?.extensions?R.extensionsResource:(0,M.$vg)(l,"extensions.json"),cacheHome:(0,M.$vg)(g,t),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.$Mk=i;let o=class extends s.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,l,g,A){super(),this.t=n,this.u=l,this.w=g,this.y=A,this.f=!0,this.h=this.B(new D.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$zc,emptyWindows:new Map},this.profilesHome=(0,M.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),l=[n];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,d.$yf)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}l.push(i((0,M.$sg)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},n))}}catch(R){this.y.error(R)}const g=new f.$zc,A=new Map;if(l.length)try{const R=this.Q();if(R.workspaces)for(const[k,I]of Object.entries(R.workspaces)){const L=C.URI.parse(k),N=l.find(T=>T.id===I);N&&g.set(L,N)}if(R.emptyWindows)for(const[k,I]of Object.entries(R.emptyWindows)){const L=l.find(N=>N.id===I);L&&A.set(k,L)}}catch(R){this.y.error(R)}this.z={profiles:l,workspaces:g,emptyWindows:A}}return this.z}D(){const n=i("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const l="Temp",g=new RegExp(`${(0,$.$Fe)(l)}\\s(\\d+)`);let A=0;for(const k of this.profiles){const I=g.exec(k.name),L=I?parseInt(I[1]):0;A=L>A?L:A}const R=`${l} ${A+1}`;return this.createProfile((0,P.$Di)((0,p.$eg)()).toString(16),R,{transient:!0},n)}async createNamedProfile(n,l,g){return this.createProfile((0,P.$Di)((0,p.$eg)()).toString(16),n,l,g)}async createProfile(n,l,g,A){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(n,l,g);return A&&await this.setProfileForWorkspace(A,R),R}async F(n,l,g){if(!(0,d.$yf)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.r.get(l);return A||(A=(async()=>{try{const R=this.profiles.find(L=>L.name===l||L.id===n);if(R)return R;const k=i(n,l,(0,M.$vg)(this.profilesHome,n),this.g,g,this.defaultProfile);await this.u.createFolder(k.location);const I=[];return this.j.fire({profile:k,join(L){I.push(L)}}),await w.Promises.settled(I),this.I([k],[],[]),k}finally{this.r.delete(l)}})(),this.r.set(l,A)),A}async updateProfile(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let g=this.profiles.find(A=>A.id===n.id);if(!g)throw new Error(`Profile '${n.name}' does not exist`);return g=i(g.id,l.name??g.name,g.location,this.g,{shortName:l.shortName??g.shortName,icon:l.icon===null?void 0:l.icon??g.icon,transient:l.transient??g.isTransient,useDefaultFlags:l.useDefaultFlags??g.useDefaultFlags},this.defaultProfile),this.I([],[],[g]),g}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(A=>A.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);const g=[];this.m.fire({profile:l,join(A){g.push(A)}});try{await Promise.allSettled(g)}catch(A){this.y.error(A)}for(const A of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(A)?.id&&this.C.emptyWindows.delete(A);for(const A of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(A)?.id&&this.C.workspaces.delete(A);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(A){(0,a.$pk)(A)!==1&&this.y.error(A)}}async setProfileForWorkspace(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=this.profiles.find(A=>A.id===l.id);if(!g)throw new Error(`Profile '${l.name}' does not exist`);this.L(n,g)}unsetWorkspace(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(l=>l.isDirectory&&this.profiles.every(g=>!this.w.extUri.isEqual(g.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(n.map(l=>this.removeProfile(l)))}getProfileForWorkspace(n){const l=this.G(n);return C.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(n){return(0,y.$Zh)(n)?n.uri:(0,y.$5h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,n.location)))}I(n,l,g){const A=[...this.profiles,...n],R=[];this.s.profiles=[];for(let k of A)k.isDefault||l.some(I=>k.id===I.id)||(k=g.find(I=>k.id===I.id)??k,k.isTransient?this.s.profiles.push(k):R.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(R),this.z=void 0,this.J(n,l,g)}J(n,l,g){this.h.fire({added:n,removed:l,updated:g,all:this.profiles})}L(n,l,g){g=l?.isTransient?!0:g,g||this.L(n,void 0,!0);const A=this.G(n),R=g?this.s:this.C;C.URI.isUri(A)?(R.workspaces.delete(A),l&&R.workspaces.set(A,l)):(R.emptyWindows.delete(A),l&&R.emptyWindows.set(A,l)),g||this.M()}M(){const n={};for(const[g,A]of this.C.workspaces.entries())n[g.toString()]=A.id;const l={};for(const[g,A]of this.C.emptyWindows.entries())l[g.toString()]=A.id;this.R({workspaces:n,emptyWindows:l}),this.z=void 0}N(n){const l={},g=this.D();if(n.workspaces)for(const[R,k]of Object.entries(n.workspaces)){const I=C.URI.parse(k);l[R]=this.w.extUri.isEqual(I,g.location)?g.id:this.w.extUri.basename(I)}const A={};if(n.emptyWindows)for(const[R,k]of Object.entries(n.emptyWindows)){const I=C.URI.parse(k);A[R]=this.w.extUri.isEqual(I,g.location)?g.id:this.w.extUri.basename(I)}return{workspaces:l,emptyWindows:A}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Nk=o,e.$Nk=o=ve([te(0,u.$Wh),te(1,a.$$j),te(2,v.$Ik),te(3,b.$0i)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ok=r}),define(ne[81],se([0,1,8,17,2,3,31,7,117,123,16,5,6,41,40,12,14,26]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class h extends Error{constructor(r,t){super(r),this.code=t}}e.$wp=h,e.$xp=(0,b.$Ph)("IExtensionsProfileScannerService");let E=class extends s.$Rc{constructor(r,t,n,l,g,A){super(),this.j=r,this.m=t,this.n=n,this.r=l,this.s=g,this.t=A,this.b=this.B(new M.$Nd),this.onAddExtensions=this.b.event,this.c=this.B(new M.$Nd),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$Nd),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$Nd),this.onDidRemoveExtensions=this.g.event,this.h=new C.$zc}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t){const n=[],l=[];try{return await this.u(t,g=>{const A=[];for(const R of g)r.some(([k])=>(0,a.$Co)(k.identifier,R.identifier)&&k.manifest.version!==R.version)?n.push(R):A.push(R);for(const[R,k]of r){const I=A.findIndex(N=>(0,a.$Co)(N.identifier,R.identifier)&&N.version===R.manifest.version),L={identifier:R.identifier,version:R.manifest.version,location:R.location,metadata:k};I===-1?(l.push(L),A.push(L)):A.splice(I,1,L)}return l.length&&this.b.fire({extensions:l,profileLocation:t}),n.length&&this.f.fire({extensions:n,profileLocation:t}),A}),l.length&&this.c.fire({extensions:l,profileLocation:t}),n.length&&this.g.fire({extensions:n,profileLocation:t}),l}catch(g){throw l.length&&this.c.fire({extensions:l,error:g,profileLocation:t}),n.length&&this.g.fire({extensions:n,error:g,profileLocation:t}),g}}async updateMetadata(r,t){const n=[];return await this.u(t,l=>{const g=[];for(const A of l){const R=r.find(([k])=>(0,a.$Co)(k.identifier,A.identifier)&&k.manifest.version===A.version);R&&(A.metadata={...A.metadata,...R[1]},n.push(A)),g.push(A)}return g}),n}async removeExtensionFromProfile(r,t){const n=[];try{await this.u(t,l=>{const g=[];for(const A of l)(0,a.$Co)(A.identifier,r.identifier)?n.push(A):g.push(A);return n.length&&this.f.fire({extensions:n,profileLocation:t}),g}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(l){throw n.length&&this.g.fire({extensions:n,error:l,profileLocation:t}),l}}async u(r,t,n){return this.F(r).queue(async()=>{let l=[],g;try{const A=await this.m.readFile(r);g=JSON.parse(A.value.toString().trim()||"[]")}catch(A){if((0,m.$pk)(A)!==1)throw A;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(g=await this.D()),!g&&n?.bailOutWhenFileNotFound)throw new h((0,p.$9)(A),"ERROR_PROFILE_NOT_FOUND")}if(g){Array.isArray(g)||this.w(r);let A=!1;for(const R of g){c(R)||this.w(r);let k;if((0,w.$yf)(R.relativeLocation)&&R.relativeLocation)k=this.z(R.relativeLocation);else if((0,w.$yf)(R.location))k=this.z(R.location),A=!0,R.relativeLocation=R.location,R.location=k.toJSON();else{k=S.URI.revive(R.location);const I=this.y(k);I&&(A=!0,R.relativeLocation=I)}l.push({identifier:R.identifier,location:k,version:R.version,metadata:R.metadata})}A&&await this.m.writeFile(r,D.$be.fromString(JSON.stringify(g)))}if(t){l=t(l);const A=l.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(r,D.$be.fromString(JSON.stringify(A)))}return l})}w(r){const t=new h(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(g){if((0,m.$pk)(g)===1)return;throw g}this.t.info("Migrating extensions from old default profile location",r.toString());let l;try{const g=JSON.parse(n);Array.isArray(g)&&g.every(A=>c(A))?l=g:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",g)}catch(g){this.t.error(g)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$be.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(g){if((0,m.$pk)(g)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw g}try{await this.m.del(r)}catch(g){(0,m.$pk)(g)!==1&&this.t.error(g)}try{await this.m.del(t)}catch(g){(0,m.$pk)(g)!==1&&this.t.error(g)}return l})()),this.C}F(r){let t=this.h.get(r);return t||(t=new P.$1g,this.h.set(r,t)),t}};e.$yp=E,e.$yp=E=ve([te(1,m.$$j),te(2,f.$Kk),te(3,v.$Ik),te(4,$.$cl),te(5,y.$0i)],E);function c(o){return(0,w.$Af)(o)&&(0,u.$_n)(o.identifier)&&(i(o.location)||(0,w.$yf)(o.location)&&o.location)&&((0,w.$Ff)(o.relativeLocation)||(0,w.$yf)(o.relativeLocation))&&o.version&&(0,w.$yf)(o.version)}function i(o){return o?(0,w.$yf)(o.path)&&(0,w.$yf)(o.scheme):!1}}),define(ne[129],se([0,1,23,8,38,17,14,44,152,2,13,9,4,19,205,74,12,7,172,37,123,120,204,16,5,6,25,3,77,81,41,40,203]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$,d,h,E,c,i,o,r,t,n,l,g,A,R,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.Translations=void 0;var L;(function(ae){function Z(K,G){if(K===G)return!0;const z=Object.keys(K),W=new Set;for(const V of Object.keys(G))W.add(V);if(z.length!==W.size)return!1;for(const V of z){if(K[V]!==G[V])return!1;W.delete(V)}return W.size===0}ae.equals=Z})(L||(e.Translations=L={})),e.$Bp=(0,r.$Ph)("IExtensionsScannerService");let N=class extends a.$Rc{constructor(Z,K,G,z,W,V,q,Y,oe,J,O,j){super(),this.systemExtensionsLocation=Z,this.userExtensionsLocation=K,this.r=G,this.s=z,this.t=W,this.u=V,this.w=q,this.y=Y,this.z=oe,this.C=J,this.D=O,this.F=j,this.g=this.B(new l.$Nd),this.onDidChangeCache=this.g.event,this.h=(0,f.$vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(X,this.s,this.h)),this.m=this.B(this.F.createInstance(X,this.s,this.h)),this.n=this.B(this.F.createInstance(x,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$No)(this.w,this.y)),this.G}async scanAllExtensions(Z,K,G){const[z,W]=await Promise.all([this.scanSystemExtensions(Z),this.scanUserExtensions(K)]),V=G?await this.scanExtensionsUnderDevelopment(Z,[...z,...W]):[];return this.L(z,W,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Z){const K=[];K.push(this.M(!!Z.useCache,Z.language)),K.push(this.N(Z.language,!!Z.checkControlFile));const[G,z]=await Promise.all(K);return this.J([...G,...z],0,Z,!1)}async scanUserExtensions(Z){const K=Z.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const G=this.D.extUri.isEqual(Z.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(K,!!Z.profileLocation,1,!Z.includeUninstalled,Z.language,!0,G),W=Z.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let V;try{V=await W.scanExtensions(z)}catch(q){if(q instanceof A.$wp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),V=await W.scanExtensions(z);else throw q}return V=await this.J(V,1,Z,!0),this.y.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(Z,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===m.Schemas.file).map(async z=>{const W=await this.P(z,!1,1,!0,Z.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(W)).map(q=>(q.type=K.find(Y=>(0,E.$Co)(Y.identifier,q.identifier))?.type??q.type,this.n.validate(q,W)))}))).flat();return this.J(G,"development",Z,!0)}return[]}async scanExistingExtension(Z,K,G){const z=await this.P(Z,!1,K,!0,G.language,!0,void 0),W=await this.n.scanExtension(z);return!W||!G.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(Z,K,G){const z=await this.P(Z,!1,K,!0,G.language,!0,void 0),W=await this.n.scanOneOrMultipleExtensions(z);return this.J(W,K,G,!0)}async scanMetadata(Z){const K=(0,f.$vg)(Z,"package.json"),G=(await this.w.readFile(K)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(Z,K){const G=(0,f.$vg)(Z,"package.json"),z=(await this.w.readFile(G)).value.toString(),W=JSON.parse(z);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,W.__metadata={...W.__metadata,...K},await this.w.writeFile((0,f.$vg)(Z,"package.json"),M.$be.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Z){if(Z instanceof A.$wp&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Z}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Z=await this.scanUserExtensions({includeInvalid:!0});if(Z.length)await this.u.addExtensionsToProfile(Z.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$be.fromString(JSON.stringify([])))}catch(K){(0,o.$pk)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$9)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Z){this.y.error(Z)}finally{this.H=void 0}})()),this.H}async J(Z,K,G,z){return G.includeAllVersions||(Z=this.L(K===0?Z:void 0,K===1?Z:void 0,K==="development"?Z:void 0,await this.getTargetPlatform(),z)),G.includeInvalid||(Z=Z.filter(W=>W.isValid)),Z.sort((W,V)=>{const q=b.$mc(W.location.fsPath),Y=b.$mc(V.location.fsPath);return q<Y?-1:q>Y?1:0})}L(Z,K,G,z,W){const V=(Y,oe,J)=>{if(Y.isValid&&!oe.isValid)return!1;if(Y.isValid===oe.isValid){if(W&&v.gt(Y.manifest.version,oe.manifest.version))return this.y.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${Y.location.path} with version ${Y.manifest.version}`),!1;if(v.eq(Y.manifest.version,oe.manifest.version)){if(Y.type===0)return this.y.debug(`Skipping extension ${oe.location.path} in favour of system extension ${Y.location.path} with same version`),!1;if(Y.targetPlatform===z)return this.y.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return J?this.y.warn(`Overwriting user extension ${Y.location.path} with ${oe.location.path}.`):this.y.debug(`Overwriting user extension ${Y.location.path} with ${oe.location.path}.`),!0},q=new c.$8l;return Z?.forEach(Y=>{const oe=q.get(Y.identifier.id);(!oe||V(oe,Y,!1))&&q.set(Y.identifier.id,Y)}),K?.forEach(Y=>{const oe=q.get(Y.identifier.id);if(!oe&&Z&&Y.type===0){this.y.debug(`Skipping obsolete system extension ${Y.location.path}.`);return}(!oe||V(oe,Y,!1))&&q.set(Y.identifier.id,Y)}),G?.forEach(Y=>{const oe=q.get(Y.identifier.id);(!oe||V(oe,Y,!0))&&q.set(Y.identifier.id,Y),q.set(Y.identifier.id,Y)}),[...q.values()]}async M(Z,K){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),W=await(Z&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",W.length),W}async N(Z,K){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const z=K?await this.O():{},W=[],V=$.URI.file(b.$gc(b.$ic(m.$cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Y of G){const oe=z[Y.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":W.push((0,f.$vg)(V,Y.name));break;default:W.push($.URI.file(oe));break}}const q=await Promise.all(W.map(async Y=>this.n.scanExtension(await this.P(Y,!1,0,!0,Z,!0,void 0))));return this.y.trace("Scanned dev system extensions:",q.length),(0,P.$Gb)(q)}async O(){try{const Z=await this.w.readFile(this.r);return JSON.parse(Z.value.toString())}catch{return{}}}async P(Z,K,G,z,W,V,q){const Y=await this.f(W??y.$w),oe=await this.Q(Z),J=K&&!this.D.extUri.isEqual(Z,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=J?await this.Q(J):void 0;return new T(Z,oe,J,O,K,q,G,z,V,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,W,Y)}async Q(Z){try{const K=await this.w.stat(Z);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$Cp=N,e.$Cp=N=ve([te(4,R.$Kk),te(5,A.$xp),te(6,o.$$j),te(7,t.$0i),te(8,h.$Wh),te(9,n.$pj),te(10,k.$Ik),te(11,r.$Oh)],N);class T{constructor(Z,K,G,z,W,V,q,Y,oe,J,O,j,F,U,H){this.location=Z,this.mtime=K,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=z,this.profile=W,this.profileScanOptions=V,this.type=q,this.excludeObsolete=Y,this.validate=oe,this.productVersion=J,this.productDate=O,this.productCommit=j,this.devMode=F,this.language=U,this.translations=H}static createNlsConfiguration(Z){return{language:Z.language,pseudo:Z.language==="pseudo",devMode:Z.devMode,translations:Z.translations}}static equals(Z,K){return(0,f.$og)(Z.location,K.location)&&Z.mtime===K.mtime&&(0,f.$og)(Z.applicationExtensionslocation,K.applicationExtensionslocation)&&Z.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&Z.profile===K.profile&&s.$$m(Z.profileScanOptions,K.profileScanOptions)&&Z.type===K.type&&Z.excludeObsolete===K.excludeObsolete&&Z.validate===K.validate&&Z.productVersion===K.productVersion&&Z.productDate===K.productDate&&Z.productCommit===K.productCommit&&Z.devMode===K.devMode&&Z.language===K.language&&L.equals(Z.translations,K.translations)}}e.$Dp=T;let x=class extends a.$Rc{constructor(Z,K,G,z,W){super(),this.f=Z,this.g=K,this.h=G,this.j=z,this.m=W}async scanExtensions(Z){const K=Z.profile?await this.r(Z):await this.n(Z);let G={};if(Z.excludeObsolete&&Z.type===1)try{const z=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(z)}catch{}return(0,p.$Lf)(G)?K:K.filter(z=>!G[E.$Do.create(z).toString()])}async n(Z){const K=await this.j.resolve(Z.location);if(!K.children?.length)return[];const G=await Promise.all(K.children.map(async z=>{if(!z.isDirectory||Z.type===1&&(0,f.$sg)(z.resource).indexOf(".")===0)return null;const W=new T(z.resource,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.profileScanOptions,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(W)}));return(0,P.$Gb)(G).sort((z,W)=>z.location.path<W.location.path?-1:1)}async r(Z){let K=await this.s(Z.location,()=>!0,Z);if(Z.applicationExtensionslocation&&!this.h.extUri.isEqual(Z.location,Z.applicationExtensionslocation)){K=K.filter(z=>!z.metadata?.isApplicationScoped);const G=await this.s(Z.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,Z);K.push(...G)}return K}async s(Z,K,G){const z=await this.g.scanProfileExtensions(Z,G.profileScanOptions);if(!z.length)return[];const W=await Promise.all(z.map(async V=>{if(K(V)){const q=new T(V.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(q,V.metadata)}return null}));return(0,P.$Gb)(W)}async scanOneOrMultipleExtensions(Z){try{if(await this.j.exists((0,f.$vg)(Z.location,"package.json"))){const K=await this.scanExtension(Z);return K?[K]:[]}else return await this.scanExtensions(Z)}catch(K){return this.m.error(`Error scanning extensions at ${Z.location.path}:`,(0,C.$9)(K)),[]}}async scanExtension(Z,K){try{let G=await this.scanExtensionManifest(Z.location);if(G){G.publisher||(G.publisher=c.$2l),K=K??G.__metadata,delete G.__metadata;const z=(0,E.$Ho)(G.publisher,G.name),W=K?.id?{id:z,uuid:K.id}:{id:z},V=K?.isSystem?0:Z.type,q=V===0||!!K?.isBuiltin;G=await this.t(Z.location,G,T.createNlsConfiguration(Z));const Y={type:V,identifier:W,manifest:G,location:Z.location,isBuiltin:q,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return Z.validate?this.validate(Y,Z):Y}}catch(G){Z.type!==0&&this.m.error(G)}return null}validate(Z,K){let G=!0;const z=(0,i.$So)(K.productVersion,K.productDate,K.location,Z.manifest,Z.isBuiltin);for(const[W,V]of z)W===w.default.Error&&(G=!1,this.m.error(this.z(K.location,V)));return Z.isValid=G,Z.validations=z,Z}async scanExtensionManifest(Z){const K=(0,f.$vg)(Z,"package.json");let G;try{G=(await this.j.readFile(K)).value.toString()}catch(W){return(0,o.$pk)(W)!==1&&this.m.error(this.z(Z,(0,d.localize)(0,null,K.path,W.message))),null}let z;try{z=JSON.parse(G)}catch{const V=[];(0,S.$Wm)(G,V);for(const q of V)this.m.error(this.z(Z,(0,d.localize)(1,null,K.path,q.offset,q.length,(0,u.$zp)(q.error))));return null}return(0,S.$6m)(z)!=="object"?(this.m.error(this.z(Z,(0,d.localize)(2,null,K.path))),null):z}async t(Z,K,G){const z=await this.u(Z,K,G);if(z)try{const W=[],V=await this.w(z.default,W);if(W.length>0)return W.forEach(Y=>{this.m.error(this.z(Z,(0,d.localize)(3,null,z.default?.path,(0,u.$zp)(Y.error))))}),K;if((0,S.$6m)(z)!=="object")return this.m.error(this.z(Z,(0,d.localize)(4,null,z.default?.path))),K;const q=z.values||Object.create(null);return(0,I.$Ap)(this.m,K,q,V)}catch{}return K}async u(Z,K,G){const z=(0,f.$vg)(Z,"package.nls.json"),W=(oe,J)=>{J.forEach(O=>{this.m.error(this.z(Z,(0,d.localize)(5,null,oe?.path,(0,u.$zp)(O.error))))})},V=oe=>{this.m.error(this.z(Z,(0,d.localize)(6,null,oe?.path)))},q=`${K.publisher}.${K.name}`,Y=G.translations[q];if(Y)try{const oe=$.URI.file(Y),J=(await this.j.readFile(oe)).value.toString(),O=[],j=(0,S.$Wm)(J,O);return O.length>0?(W(oe,O),{values:void 0,default:z}):(0,S.$6m)(j)!=="object"?(V(oe),{values:void 0,default:z}):{values:j.contents?j.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.j.exists(z))return;let J;try{J=await this.y(Z,G)}catch{return}if(!J.localized)return{values:void 0,default:J.original};try{const O=(await this.j.readFile(J.localized)).value.toString(),j=[],F=(0,S.$Wm)(O,j);return j.length>0?(W(J.localized,j),{values:void 0,default:J.original}):(0,S.$6m)(F)!=="object"?(V(J.localized),{values:void 0,default:J.original}):{values:F,default:J.original}}catch{return{values:void 0,default:J.original}}}}async w(Z,K){if(Z)try{const G=(await this.j.readFile(Z)).value.toString();return(0,S.$Wm)(G,K)}catch{}}y(Z,K){return new Promise((G,z)=>{const W=V=>{const q=(0,f.$vg)(Z,`package.nls.${V}.json`);this.j.exists(q).then(Y=>{Y&&G({localized:q,original:(0,f.$vg)(Z,"package.nls.json")});const oe=V.lastIndexOf("-");oe===-1?G({localized:(0,f.$vg)(Z,"package.nls.json"),original:null}):(V=V.substring(0,oe),W(V))})};if(K.devMode||K.pseudo||!K.language)return G({localized:(0,f.$vg)(Z,"package.nls.json"),original:null});W(K.language)})}z(Z,K){return`[${Z.path}]: ${K}`}};x=ve([te(1,A.$xp),te(2,k.$Ik),te(3,o.$$j),te(4,t.$0i)],x);let X=class extends x{constructor(Z,K,G,z,W,V,q){super(K,z,W,V,q),this.G=Z,this.H=G,this.D=this.B(new D.$Rg(3e3)),this.F=this.B(new l.$Nd),this.onDidChangeCache=this.F.event}async scanExtensions(Z){const K=this.M(Z),G=await this.I(K);if(this.C=Z,G&&G.input&&T.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",Z.location.toString()),this.D.trigger(()=>this.L()),G.result.map(W=>(W.location=$.URI.revive(W.location),W));const z=await super.scanExtensions(Z);return await this.J(K,{input:Z,result:z}),z}async I(Z){try{const K=await this.j.readFile(Z),G=JSON.parse(K.value.toString());return{result:G.result,input:(0,g.$mh)(G.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",Z.path,(0,C.$9)(K))}return null}async J(Z,K){try{await this.j.writeFile(Z,M.$be.fromString(JSON.stringify(K)))}catch(G){this.m.debug("Error while writing the extension cache file:",Z.path,(0,C.$9)(G))}}async L(){if(!this.C)return;const Z=this.M(this.C),K=await this.I(Z);if(!K)return;const G=K.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$$m(z,G))try{this.m.info("Invalidating Cache",G,z),await this.j.del(Z),this.F.fire()}catch(W){this.m.error(W)}}M(Z){const K=this.N(Z);return this.h.extUri.joinPath(K.cacheHome,Z.type===0?c.$1l:c.$Zl)}N(Z){return Z.type===0?this.H.defaultProfile:Z.profile?this.h.extUri.isEqual(Z.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(Z.location,K.extensionsResource))??this.G:this.H.defaultProfile}};X=ve([te(2,R.$Kk),te(3,A.$xp),te(4,k.$Ik),te(5,o.$$j),te(6,t.$0i)],X);function ce(ae,Z){const K=(0,E.$Fo)(ae.manifest.publisher,ae.manifest.name);return{id:K,identifier:new c.$6l(K),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:Z,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.$Ep=ce;class re extends N{constructor(Z,K,G,z,W,V,q,Y,oe,J,O,j){super(Z,K,(0,f.$vg)(G,".vscode-oss-dev","extensions","control.json"),z,W,V,q,Y,oe,J,O,j),this.R=(async()=>{if(y.$z)try{const F=await this.w.readFile($.URI.file(y.$z));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(Z){return this.R}}e.$Fp=re}),define(ne[276],se([0,1,6,41,40,26,81,16,37,7]),function(Q,e,P,D,s,M,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=void 0;let m=class extends C.$yp{constructor(y,f,v,w,p,$){super(a.URI.file(y.extensionsPath),f,v,w,p,$)}};e.$MN=m,e.$MN=m=ve([te(0,u.$Xh),te(1,S.$$j),te(2,D.$Kk),te(3,s.$Ik),te(4,M.$cl),te(5,P.$0i)],m)}),define(ne[277],se([0,1,7,37,81,129,16,5,6,25,40,41]),function(Q,e,P,D,s,M,C,S,u,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q8b=void 0;let y=class extends M.$Fp{constructor(v,w,p,$,d,h,E,c){super(P.URI.file(d.builtinExtensionsPath),P.URI.file(d.extensionsPath),d.userHome,v.defaultProfile,v,w,p,$,d,h,E,c)}};e.$q8b=y,e.$q8b=y=ve([te(0,b.$Kk),te(1,s.$xp),te(2,C.$$j),te(3,u.$0i),te(4,D.$Xh),te(5,a.$pj),te(6,m.$Ik),te(7,S.$Oh)],y)}),define(ne[278],se([0,1,15,2,13,9,4,57,7,32,36,37,6,41]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I8b=void 0;let v=class extends D.$Rc{constructor(p,$,d){super(),this.c=p,this.f=d,this.a=S.$Vh.forPaths(!C.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(p.appRoot),this.addValidFileRoot(p.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(p.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:p}=P.session;p.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,($,d)=>this.j($,d)),p.protocol.interceptFileProtocol(s.Schemas.file,($,d)=>this.h($,d)),this.B((0,D.$Pc)(()=>{p.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),p.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(p){const $=(0,M.$gc)(p);return this.a.get($)?D.$Rc.None:(this.a.set($,!0),(0,D.$Pc)(()=>this.a.delete($)))}h(p,$){const d=u.URI.parse(p.url);return this.f.error(`Refused to load resource ${d.fsPath} from ${s.Schemas.file}: protocol (original URL: ${p.url})`),$({error:-3})}j(p,$){const d=this.m(p);let h;return this.c.crossOriginIsolated&&((0,M.$mc)(d)==="workbench.html"||(0,M.$mc)(d)==="workbench-dev.html"?h=s.COI.CoopAndCoep:h=s.COI.getHeadersFromQuery(p.url)),this.a.findSubstr(d)?$({path:d,headers:h}):this.b.has((0,M.$nc)(d).toLowerCase())?$({path:d}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${d} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${p.url})`),$({error:-3}))}m(p){const $=u.URI.parse(p.url),d=s.$cg.uriToFileUri($);return(0,M.$gc)(d.fsPath)}createIPCObjectUrl(){let p;const $=u.URI.from({scheme:"vscode",path:(0,a.$eg)()}),d=$.toString(),h=async()=>p;return m.$yT.handle(d,h),this.f.trace(`IPC Object URL: Registered new channel ${d}.`),{resource:$,update:E=>p=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${d}.`),m.$yT.removeHandler(d)}}}};e.$I8b=v,e.$I8b=v=ve([te(0,b.$Xh),te(1,f.$Kk),te(2,y.$0i)],v)}),define(ne[96],se([0,1,8,3,2,66,12,111,5,41]),function(Q,e,P,D,s,M,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$9o=e.$8o=e.$7o=void 0,e.$7o="__$__isNewStorageMarker",e.$8o="__$__targetStorageMarker",e.$9o=(0,u.$Ph)("storageService");var m;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var b;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var y;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function f(d){const h=d.get(e.$8o);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.$0o=f;class v extends s.$Rc{static{this.a=60*1e3}constructor(h={flushInterval:v.a}){super(),this.m=h,this.b=this.B(new D.$Qd),this.c=this.B(new D.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new P.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,E,c){return D.Event.filter(this.b.event,i=>i.scope===h&&(E===void 0||i.key===E),c)}n(){this.j.value=(0,P.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,E){const{key:c,external:i}=E;if(c===e.$8o){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:c,target:this.J(h)[c],external:i})}w(h){this.f.fire({reason:h})}get(h,E,c){return this.P(E)?.get(h,c)}getBoolean(h,E,c){return this.P(E)?.getBoolean(h,c)}getNumber(h,E,c){return this.P(E)?.getNumber(h,c)}getObject(h,E,c){return this.P(E)?.getObject(h,c)}storeAll(h,E){this.y(()=>{for(const c of h)this.store(c.key,c.value,c.scope,c.target,E)})}store(h,E,c,i,o=!1){if((0,C.$Hf)(E)){this.remove(h,c,o);return}this.y(()=>{this.z(h,c,i),this.P(c)?.set(h,E,o)})}remove(h,E,c=!1){this.y(()=>{this.z(h,E,void 0),this.P(E)?.delete(h,c)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,E){const c=[],i=this.J(h);for(const o of Object.keys(i))i[o]===E&&c.push(o);return c}z(h,E,c,i=!1){const o=this.J(E);typeof c=="number"?o[h]!==c&&(o[h]=c,this.P(E)?.set(e.$8o,JSON.stringify(o),i)):typeof o[h]=="number"&&(delete o[h],this.P(E)?.set(e.$8o,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const E=this.P(h);return E?f(E):Object.create(null)}isNew(h){return this.getBoolean(e.$7o,h)===!0}async flush(h=m.NONE){this.f.fire({reason:h});const E=this.P(-1),c=this.P(0),i=this.P(1);switch(h){case m.NONE:await P.Promises.settled([E?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await P.Promises.settled([E?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return $(h,E,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,E){return this.w(m.NONE),(0,a.$Jk)(h)?this.R(h,E):this.S(h,E)}M(h,E){return!(h.id===E.id||w(E)&&w(h))}N(h,E,c){this.y(()=>{const i=new Set;for(const[o,r]of h)i.add(o),E.get(o)!==r&&this.u(c,{key:o,external:!0});for(const[o]of E.items)i.has(o)||this.u(c,{key:o,external:!0})})}}e.$$o=v;function w(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.$_o=w;class p extends v{constructor(){super(),this.U=this.B(new S.$5o(new S.$6o,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$5o(new S.$6o,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$5o(new S.$6o,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$ap=p;async function $(d,h,E,c,i,o){const r=L=>{try{return JSON.parse(L)}catch{return L}},t=new Map,n=new Map;d.forEach((L,N)=>{t.set(N,L),n.set(N,r(L))});const l=new Map,g=new Map;h.forEach((L,N)=>{l.set(N,L),g.set(N,r(L))});const A=new Map,R=new Map;E.forEach((L,N)=>{A.set(N,L),R.set(N,r(L))}),console.group(c!==i?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const k=[];if(t.forEach((L,N)=>{k.push({key:N,value:L})}),console.table(k),console.groupEnd(),console.log(n),c!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const L=[];l.forEach((N,T)=>{L.push({key:T,value:N})}),console.table(L),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${o})`);const I=[];A.forEach((L,N)=>{I.push({key:N,value:L})}),console.table(I),console.groupEnd(),console.log(R)}e.$bp=$}),define(ne[279],se([0,1,23,8,3,2,9,73,7,21,111,161,6,96,26,30,13]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=e.$P6b=e.$O6b=e.$N6b=void 0;class $ extends M.$Rc{static{this.a=2e3}get storage(){return this.f}constructor(r,t){super(),this.m=r,this.n=t,this.b=this.B(new s.$Nd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Nd),this.onDidCloseStorage=this.c.event,this.f=this.B(new m.$5o(new m.$6o,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new D.$ch,this.whenInit=this.h.p,this.j=m.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===m.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const t=r.getBoolean(f.$7o);t===void 0?r.set(f.$7o,!0):t&&r.set(f.$7o,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=m.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===y.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,t){return this.f.get(r,t)}set(r,t){return this.f.set(r,t)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new S.$Jd(!1);await this.w(),r.stop(),r.elapsed()>$.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const t=(0,P.top)(Array.from(this.f.items.entries()).map(([l,g])=>({key:l,length:g.length})),(l,g)=>g.length-l.length,5).map(l=>`${l.key}:${l.length}`).join(", "),n=(await this.n.stat(u.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${t}`)}catch(t){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",t)}}async w(){this.g&&await this.g,this.j=m.StorageState.Closed,await this.f.close()}}class d extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,C.$ic)(this.z.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,d.y)}constructor(r,t,n,l){super(n,l),this.z=r,this.C=t}async t(){return new m.$5o(new b.$4T(this.path??b.$4T.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:m.StorageHint.STORAGE_IN_MEMORY})}}class h extends d{constructor(r,t,n,l){super(r,t,n,l)}}e.$N6b=h;class E extends d{constructor(r,t,n,l){super(t.defaultProfile,r,n,l)}async s(r){await super.s(r),this.G(r)}G(r){r.get(v.$fl,void 0)===void 0&&r.set(v.$fl,new Date().toUTCString());const n=r.get(v.$el,void 0),l=new Date().toUTCString();r.set(v.$gl,typeof n>"u"?null:n),r.set(v.$el,l)}}e.$O6b=E;class c extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,C.$ic)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id,c.y)}constructor(r,t,n,l,g){super(n,g),this.C=r,this.D=t,this.F=l}async t(){const{storageFilePath:r,wasCreated:t}=await this.H();return new m.$5o(new b.$4T(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?m.StorageHint.STORAGE_IN_MEMORY:t?m.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:b.$4T.IN_MEMORY_PATH,wasCreated:!0};const r=(0,C.$ic)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id),t=(0,C.$ic)(r,c.y);return await a.Promises.exists(r)?{storageFilePath:t,wasCreated:!1}:(await a.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:t,wasCreated:!0})}async I(r){let t;if((0,w.$Zh)(this.C)?t={folder:this.C.uri.toString()}:(0,w.$5h)(this.C)&&(t={workspace:this.C.configPath.toString()}),t)try{const n=(0,C.$ic)(r,c.z);await a.Promises.exists(n)||await a.Promises.writeFile(n,JSON.stringify(t,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$P6b=c;class i extends ${get path(){}async t(){return new m.$5o(new m.$6o,{hint:m.StorageHint.STORAGE_IN_MEMORY})}}e.$Q6b=i}),define(ne[280],se([0,1,3,2,96]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=void 0;class M extends D.$Rc{constructor(S,u,a){super(),this.b=S,this.c=u,this.f=a;const m=this.B(new D.$Sc);this.a=this.B(new P.$Nd({onWillAddFirstListener:()=>m.value=this.g(),onDidRemoveLastListener:()=>m.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new D.$Qc;return S.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(u,a)=>(u?u.push(a.key):u=[a.key],u),100)(u=>this.h(u))),S.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(u,a)=>{u||(u=new Map);let m=u.get(a.profile.id);return m||u.set(a.profile.id,m={profile:a.profile,keys:[],storage:a.storage}),m.keys.push(a.key),u},100)(u=>this.j(u))),S}h(S){const u=S.includes(s.$8o)?[this.c.defaultProfile]:[],a=[];if(S=S.filter(m=>m!==s.$8o),S.length){const m=(0,s.$0o)(this.b.applicationStorage.storage);a.push({profile:this.c.defaultProfile,changes:S.map(b=>({key:b,scope:0,target:m[b]}))})}this.m(u,a)}j(S){const u=[],a=new Map;for(const[m,b]of S.entries()){b.keys.includes(s.$8o)&&u.push(b.profile);const y=b.keys.filter(f=>f!==s.$8o);if(y.length){const f=(0,s.$0o)(b.storage.storage);a.set(m,{profile:b.profile,changes:y.map(v=>({key:v,scope:0,target:f[v]}))})}}this.m(u,[...a.values()])}m(S,u){(S.length||u.length)&&this.a.fire({valueChanges:u,targetChanges:S})}listen(S,u,a){switch(u){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${u}`)}async call(S,u){throw new Error(`Call not found: ${u}`)}}e.$s8b=M}),define(ne[281],se([0,1,7,37,16,6,34,40,41,12,121]),function(Q,e,P,D,s,M,C,S,u,a,m){"use strict";var b,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=e.$JN=void 0;let f=class extends u.$Nk{static{b=this}static{this.a="profileAssociationsMigration"}constructor($,d,h,E,c){super(h,E,d,c),this.U=$,this.W=h}O(){return this.U.getItem(b.b,[]).map(d=>({...d,location:(0,a.$yf)(d.location)?this.w.extUri.joinPath(this.profilesHome,d.location):P.URI.revive(d.location)}))}Q(){const $=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$JN=f,e.$JN=f=b=ve([te(0,C.$EN),te(1,S.$Ik),te(2,D.$Xh),te(3,s.$$j),te(4,M.$0i)],f);let v=y=class extends f{constructor($,d,h,E,c){super($,d,h,E,c),this.$=$}P($){$.length?this.$.setItem(y.b,$.map(d=>({...d,location:this.w.extUri.basename(d.location)}))):this.$.removeItem(y.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(y.c,$):this.$.removeItem(y.c)}Q(){const $="workspaceAndProfileInfo",d=this.$.getItem($,void 0);if(d){this.$.removeItem($);const E=d.reduce((c,{workspace:i,profile:o})=>(c[P.URI.revive(i).toString()]=P.URI.revive(o).toString(),c),{});this.$.setItem(y.c,{workspaces:E})}const h=super.Q();return this.$.getItem(y.a,!1)||(this.R(h),this.$.setItem(y.a,!0)),h}};e.$KN=v,e.$KN=v=y=ve([te(0,C.$FN),te(1,S.$Ik),te(2,D.$Xh),te(3,s.$$j),te(4,M.$0i)],v);let w=class extends v{constructor($,d,h,E){super(new m.$IN(0,d,E,h),$,d,h,E)}async init(){return await this.$.init(),super.init()}};e.$LN=w,e.$LN=w=ve([te(0,S.$Ik),te(1,D.$Xh),te(2,s.$$j),te(3,M.$0i)],w)}),define(ne[53],se([0,1,37,16,5,6,40,41,281,34]),function(Q,e,P,D,s,M,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S6b=e.$R6b=void 0,e.$R6b=(0,s.$Qh)(S.$Kk);let m=class extends u.$KN{constructor(y,f,v,w,p){super(y,f,v,w,p)}getAssociatedEmptyWindows(){const y=[];for(const f of this.C.emptyWindows.keys())y.push({id:f});return y}};e.$S6b=m,e.$S6b=m=ve([te(0,a.$FN),te(1,C.$Ik),te(2,P.$Xh),te(3,D.$$j),te(4,M.$0i)],m)}),define(ne[130],se([0,1,19,7,30]),function(Q,e,P,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=e.$86b=e.$76b=void 0;async function M(u,a,m){for(const y of u){const f=y.openedWorkspace;if((0,s.$5h)(f)){const v=await m(f);if(v){if(v.folders.some(w=>P.$mg.isEqualOrParent(a,w.uri)))return y}else if(P.$mg.isEqualOrParent(a,f.configPath))return y}}const b=u.filter(y=>(0,s.$Zh)(y.openedWorkspace)&&P.$mg.isEqualOrParent(a,y.openedWorkspace.uri));if(b.length)return b.sort((y,f)=>-(y.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.$76b=M;function C(u,a){for(const m of u)if((0,s.$5h)(m.openedWorkspace)&&P.$mg.isEqual(m.openedWorkspace.configPath,a)||(0,s.$Zh)(m.openedWorkspace)&&P.$mg.isEqual(m.openedWorkspace.uri,a))return m}e.$86b=C;function S(u,a){const m=b=>a.some(y=>P.$mg.isEqual(D.URI.file(y),D.URI.file(b)));for(const b of u)if(b.config?.extensionDevelopmentPath?.some(y=>m(y)))return b}e.$96b=S}),define(ne[97],se([0,1,33,44,139,46,13,9,4,19,7,5,59,30]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5U=e.$4U=e.$3U=e.$2U=e.$1U=e.$ZU=e.$YU=e.$XU=e.$WU=e.$VU=void 0,e.$VU=(0,b.$Ph)("workspacesService");function v(R){return R.hasOwnProperty("workspace")}e.$WU=v;function w(R){return R.hasOwnProperty("folderUri")}e.$XU=w;function p(R){return R.hasOwnProperty("fileUri")}e.$YU=p;function $(R){return d(R)||h(R)}e.$ZU=$;function d(R){const k=R;return typeof k?.path=="string"&&(!k.name||typeof k.name=="string")}function h(R){const k=R;return typeof k?.uri=="string"&&(!k.name||typeof k.name=="string")}function E(R,k,I,L,N){if(R.scheme!==L.scheme)return{name:I,uri:R.toString(!0)};let T=k?void 0:N.relativePath(L,R);if(T!==void 0)T.length===0?T=".":u.$j&&(T=c(T));else if(R.scheme===C.Schemas.file)T=R.fsPath,u.$j&&(T=c(T));else if(N.isEqualAuthority(R.authority,L.authority))T=R.path;else return{name:I,uri:R.toString(!0)};return{name:I,path:T}}e.$1U=E;function c(R){return R=(0,M.$vv)(R),(0,P.$Uf)(R)||(R=(0,P.$Rf)(R)),R}function i(R,k,I){const L=[],N=new Set,T=I.dirname(k);for(const x of R){let X;if(d(x))x.path&&(X=I.resolvePath(T,x.path));else if(h(x))try{X=m.URI.parse(x.uri),X.path[0]!==S.$fc.sep&&(X=X.with({path:S.$fc.sep+X.path}))}catch(ce){console.warn(ce)}if(X){const ce=I.getComparisonKey(X);if(!N.has(ce)){N.add(ce);const re=x.name||I.basenameOrAuthority(X);L.push(new f.$0h({uri:X,name:re,index:L.length},x))}}}return L}e.$2U=i;function o(R,k,I,L,N){const T=r(k,R),x=N.dirname(k),X=N.dirname(L),ce=[];for(const K of T.folders){const G=d(K)?N.resolvePath(x,K.path):m.URI.parse(K.uri);let z;I?z=!1:z=!d(K)||(0,S.$hc)(K.path),ce.push(E(G,z,K.name,X,N))}const re={insertSpaces:!1,tabSize:4,eol:u.$l||u.$k?`
`:`\r
`},ae=s.$gT(R,["folders"],ce,re);let Z=s.$jT(R,ae);return(0,a.$Ag)(T.remoteAuthority,(0,y.$Uk)(L))&&(Z=s.$jT(Z,s.$fT(Z,["remoteAuthority"],re))),Z}e.$3U=o;function r(R,k){const I=D.$Wm(k);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(L=>$(L));else throw new Error(`${R} looks like an invalid workspace file.`);return I}function t(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function n(R){return typeof R.folderUri=="string"}function l(R){return typeof R.fileUri=="string"}function g(R,k){const I={workspaces:[],files:[]};if(R){const L=function(T,x){for(let X=0;X<T.length;X++)try{x(T[X],X)}catch(ce){k.warn(`Error restoring recent entry ${JSON.stringify(T[X])}: ${ce.toString()}. Skip entry.`)}},N=R;Array.isArray(N.entries)&&L(N.entries,T=>{const x=T.label,X=T.remoteAuthority;t(T)?I.workspaces.push({label:x,remoteAuthority:X,workspace:{id:T.workspace.id,configPath:m.URI.parse(T.workspace.configPath)}}):n(T)?I.workspaces.push({label:x,remoteAuthority:X,folderUri:m.URI.parse(T.folderUri)}):l(T)&&I.files.push({label:x,remoteAuthority:X,fileUri:m.URI.parse(T.fileUri)})})}return I}e.$4U=g;function A(R){const k={entries:[]};for(const I of R.workspaces)w(I)?k.entries.push({folderUri:I.folderUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority}):k.entries.push({workspace:{id:I.workspace.id,configPath:I.workspace.configPath.toString()},label:I.label,remoteAuthority:I.remoteAuthority});for(const I of R.files)k.entries.push({fileUri:I.fileUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority});return k}e.$5U=A}),define(ne[98],se([0,1,86,13,4,19]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7b=e.$_6b=e.$$6b=e.$06b=void 0,e.$06b=128/4;function C(a){function m(){let b=a.scheme===D.Schemas.file?(0,M.$jg)(a):a.toString();return s.$l||(b=b.toLowerCase()),(0,P.createHash)("md5").update(b).digest("hex")}return{id:m(),configPath:a}}e.$$6b=C;function S(a,m){function b(){if(a.scheme!==D.Schemas.file)return(0,P.createHash)("md5").update(a.toString()).digest("hex");if(!m)return;let f;return s.$l?f=m.ino:s.$k?f=m.birthtime.getTime():s.$j&&(typeof m.birthtimeMs=="number"?f=Math.floor(m.birthtimeMs):f=m.birthtime.getTime()),(0,P.createHash)("md5").update(a.fsPath).update(f?String(f):"").digest("hex")}const y=b();if(typeof y=="string")return{id:y,uri:a}}e.$_6b=S;function u(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$a7b=u}),define(ne[99],se([0,1,86,87,28,282,17,14,3,2,9,4,32,42,109]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0;class w{traceSocketEvent(k,I){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,I)}constructor(k,I=""){this.f=!0,this.debugLabel=I,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,S.$Z)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const I=L=>{this.traceSocketEvent("read",L),k(C.$be.wrap(L))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(k){const I=L=>{k({type:0,hadError:L,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(k){const I=()=>{k()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,S.$Z)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,S.$Z)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$Eh=w;var p;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize",R[R.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var $;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})($||($={}));class d extends a.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,I){this.socket.traceSocketEvent(k,I)}constructor(k,I,L,N){super(),this.f=this.B(new u.$Nd),this.g=this.B(new u.$Nd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:L?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new h(this,I,L,N,this.f,(T,x)=>this.m(T,x))),this.B(this.a.onError(T=>{console.error(T),(0,S.$Z)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new v.$zh,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let I=0;for(;I<k.byteLength;)this.a.writeMessage(k.slice(I,Math.min(I+262144,k.byteLength)),{compressed:!0,opcode:2}),I+=262144}m(k,{compressed:I,opcode:L}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let N=2;k.byteLength<126?N+=0:k.byteLength<2**16?N+=2:N+=8;const T=C.$be.alloc(N),x=I?64:0,X=L&15;if(T.writeUInt8(128|x|X,0),k.byteLength<126)T.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){T.writeUInt8(126,1);let ce=1;T.writeUInt8(k.byteLength>>>8&255,++ce),T.writeUInt8(k.byteLength>>>0&255,++ce)}else{T.writeUInt8(127,1);let ce=1;T.writeUInt8(0,++ce),T.writeUInt8(0,++ce),T.writeUInt8(0,++ce),T.writeUInt8(0,++ce),T.writeUInt8(k.byteLength>>>24&255,++ce),T.writeUInt8(k.byteLength>>>16&255,++ce),T.writeUInt8(k.byteLength>>>8&255,++ce),T.writeUInt8(k.byteLength>>>0&255,++ce)}this.socket.write(C.$be.concat([T,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const I=this.b.peek(this.j.readLen),L=I.readUInt8(0),N=(L&128)>>>7,T=(L&64)>>>6,x=L&15,X=I.readUInt8(1),ce=(X&128)>>>7,re=X&127;this.j.state=2,this.j.readLen=2+(ce?4:0)+(re===126?2:0)+(re===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const I=this.b.read(this.j.readLen),L=I.readUInt8(1),N=(L&128)>>>7;let T=L&127,x=1;T===126?T=I.readUInt8(++x)*2**8+I.readUInt8(++x):T===127&&(T=I.readUInt8(++x)*0+I.readUInt8(++x)*0+I.readUInt8(++x)*0+I.readUInt8(++x)*0+I.readUInt8(++x)*2**24+I.readUInt8(++x)*2**16+I.readUInt8(++x)*2**8+I.readUInt8(++x));let X=0;N&&(X=I.readUInt8(++x)*2**24+I.readUInt8(++x)*2**16+I.readUInt8(++x)*2**8+I.readUInt8(++x)),this.j.state=3,this.j.readLen=T,this.j.mask=X,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const I=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),i(I,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(I,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(I,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Fh=d;class h extends a.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$be.alloc(0)}constructor(k,I,L,N,T,x){super(),this.n=k,this.r=T,this.s=x,this.a=this.B(new u.$Nd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new u.$Nd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new u.$Nd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,I?(this.b=this.B(new E(this.n,N,L,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(X=>this.a.fire(X))),this.B(this.f.onError(X=>this.a.fire(X)))):(this.b=null,this.f=null)}writeMessage(k,I){this.g.push({data:k,options:I}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:I}=this.g.shift();if(this.f&&I.compressed){const L=await this.w(this.f,k);this.s(L,I)}else this.s(k,{...I,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,I){return new Promise((L,N)=>{k.write(I),k.flush(T=>L(T))})}acceptFrame(k,I,L){this.h.push({data:k,isCompressed:I,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const I=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(I)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,I,L){return new Promise((N,T)=>{k.write(I),L&&k.write(C.$be.fromByteArray([0,0,255,255])),k.flush(x=>N(x))})}}class E extends a.$Rc{get recordedInflateBytes(){return this.j?C.$be.concat(this.f):C.$be.alloc(0)}constructor(k,I,L,N){super(),this.h=k,this.j=I,this.a=this.B(new u.$Nd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(N),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(C.$be.wrap(T))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const I=C.$be.concat(this.g);this.g.length=0,k(I)})}}class c extends a.$Rc{constructor(k,I){super(),this.g=k,this.a=this.B(new u.$Nd),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(C.$be.wrap(L))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let I=C.$be.concat(this.f);this.f.length=0,I=I.slice(0,I.byteLength-4),k(I)})}}function i(R,k){if(k===0)return;const I=R.byteLength>>>2;for(let ce=0;ce<I;ce++){const re=R.readUInt32BE(ce*4);R.writeUInt32BE(re^k,ce*4)}const L=I*4,N=R.byteLength-L,T=k>>>24&255,x=k>>>16&255,X=k>>>8&255;N>=1&&R.writeUInt8(R.readUInt8(L)^T,L),N>=2&&R.writeUInt8(R.readUInt8(L+1)^x,L+1),N>=3&&R.writeUInt8(R.readUInt8(L+2)^X,L+2)}e.$Gh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function r(){const R=(0,y.$eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;const k=process.platform!=="darwin"&&e.$Gh?e.$Gh:(0,s.tmpdir)(),I=(0,m.$ic)(k,`vscode-ipc-${R}.sock`);return n(I),I}e.$Hh=r;function t(R,k,I){const L=(0,P.createHash)("md5").update(R).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${I}-${k}-sock`;const N=I.substr(0,4),T=k.substr(0,6),x=L.substr(0,8);let X;return process.platform!=="darwin"&&e.$Gh&&!process.env.VSCODE_PORTABLE?X=(0,m.$ic)(e.$Gh,`vscode-${x}-${N}-${T}.sock`):X=(0,m.$ic)(R,`${N}-${T}.sock`),n(X),X}e.$Ih=t;function n(R){const k=o[b.$u];typeof k=="number"&&R.length>=k&&console.warn(`WARNING: IPC handle "${R}" is longer than ${k} chars, try a shorter --user-data-dir`)}class l extends f.$th{static b(k){const I=u.Event.fromNodeEventEmitter(k,"connection");return u.Event.map(I,L=>({protocol:new v.$Ah(new w(L,"ipc-server-connection")),onDidClientDisconnect:u.Event.once(u.Event.fromNodeEventEmitter(L,"close"))}))}constructor(k){super(l.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Jh=l;function g(R){return new Promise((k,I)=>{const L=(0,D.createServer)();L.on("error",I),L.listen(R,()=>{L.removeListener("error",I),k(new l(L))})})}e.$Kh=g;function A(R,k){return new Promise((I,L)=>{const N=(0,D.createConnection)(R,()=>{N.removeListener("error",L),I(v.$Bh.fromSocket(new w(N,`ipc-client${k}`),k))});N.once("error",L)})}e.$Lh=A}),define(ne[24],se([0,1,55,9,4,99,37,90,5]),function(Q,e,P,D,s,M,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=e.$J6b=void 0,e.$J6b=(0,u.$Qh)(C.$Wh);class a extends S.$jm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,D.$ic)(this.userDataPath,"clp")}get backupHome(){return(0,D.$ic)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$Ih)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,D.$ic)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$l){for(const b in process.env)if(b.endsWith("_VSCODE_SNAP_ORIG")){const y=b.slice(0,-17);if(this.d[y])continue;process.env[y]&&(this.d[y]=process.env[y]),process.env[b]?process.env[y]=process.env[b]:delete process.env[y]}}}restoreSnapExportedVariables(){if(s.$l)for(const b in this.d)process.env[b]=this.d[b],delete this.d[b]}}e.$K6b=a,ve([P.$hh],a.prototype,"cachedLanguagesPath",null),ve([P.$hh],a.prototype,"backupHome",null),ve([P.$hh],a.prototype,"mainIPCHandle",null),ve([P.$hh],a.prototype,"mainLockfile",null),ve([P.$hh],a.prototype,"disableUpdates",null),ve([P.$hh],a.prototype,"crossOriginIsolated",null),ve([P.$hh],a.prototype,"codeCachePath",null),ve([P.$hh],a.prototype,"useCodeCache",null)}),define(ne[283],se([0,1,86,33,13,9,4,19,21,196,18,24,34,16,6,195,30,98]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$o7b=void 0;let h=class{static{d=this}static{this.a="backupWorkspaces"}constructor(c,i,o,r){this.j=c,this.k=i,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$mg,this.i={isEqual:(t,n)=>(0,D.$Wf)(t,n,!C.$l)}}async initialize(){const c=this.m.getItem(d.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(c.emptyWindows),this.d=await this.u((0,a.$16b)(c)),this.e=await this.v((0,a.$26b)(c)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.$xk.OFF}q(){return this.s()===f.$xk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.$xk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(c,i){this.d.some(r=>c.workspace.id===r.workspace.id)||(this.d.push(c),this.C());const o=(0,M.$ic)(this.c,c.workspace.id);return i?this.t(o,i).then(()=>o):o}async t(c,i){if(await u.Promises.exists(c)&&await this.z(c),await u.Promises.exists(i))try{await u.Promises.rename(i,c,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(c){return this.e.some(i=>this.h.isEqual(c.folderUri,i.folderUri))||(this.e.push(c),this.C()),(0,M.$ic)(this.c,this.D(c))}registerEmptyWindowBackup(c){return this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,c.backupFolder))||(this.g.push(c),this.C()),(0,M.$ic)(this.c,c.backupFolder)}async u(c){if(!Array.isArray(c))return[];const i=new Set,o=[];for(const r of c){const t=r.workspace;if(!(0,p.$5h)(t))return[];if(!i.has(t.id)){i.add(t.id);const n=(0,M.$ic)(this.c,t.id);await this.B(n)?t.configPath.scheme!==s.Schemas.file||await u.Promises.exists(t.configPath.fsPath)?o.push(r):await this.z(n):await this.x(n)}}return o}async v(c){if(!Array.isArray(c))return[];const i=[],o=new Set;for(const r of c){const t=r.folderUri,n=this.h.getComparisonKey(t);if(!o.has(n)){o.add(n);const l=(0,M.$ic)(this.c,this.D(r));await this.B(l)?t.scheme!==s.Schemas.file||await u.Promises.exists(t.fsPath)?i.push(r):await this.z(l):await this.x(l)}}return i}async w(c){if(!Array.isArray(c))return[];const i=[],o=new Set;for(const r of c){const t=r.backupFolder;if(typeof t!="string")return[];if(!o.has(t)){o.add(t);const n=(0,M.$ic)(this.c,t);await this.B(n)?i.push(r):await this.x(n)}}return i}async x(c){try{await u.Promises.rm(c,u.RimRafMode.MOVE)}catch(i){this.l.error(`Backup: Could not delete stale backup: ${i.toString()}`)}}y(){let c=(0,$.$a7b)();for(;this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,c.id));)c=(0,$.$a7b)();return{backupFolder:c.id}}async z(c){const i=this.y(),o=(0,M.$ic)(this.c,i.backupFolder);try{await u.Promises.rename(c,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(i),!0}async getDirtyWorkspaces(){const c=[];for(const i of this.d)await this.A(i)&&c.push(i);for(const i of this.e)await this.A(i)&&c.push(i);return c}A(c){let i;return(0,a.$Z6b)(c)?i=(0,M.$ic)(this.c,c.backupFolder):(0,w.$TU)(c)?i=(0,M.$ic)(this.c,this.D(c)):i=(0,M.$ic)(this.c,c.workspace.id),this.B(i)}async B(c){try{const i=await u.Promises.readdir(c);for(const o of i)try{if((await u.Promises.readdir((0,M.$ic)(c,o))).length>0)return!0}catch{}}catch{}return!1}C(){const c={workspaces:this.d.map(({workspace:i,remoteAuthority:o})=>{const r={id:i.id,configURIPath:i.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:i,remoteAuthority:o})=>{const r={folderUri:i.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:i,remoteAuthority:o})=>{const r={backupFolder:i};return o&&(r.remoteAuthority=o),r})};this.m.setItem(d.a,c)}D(c){const i=c.folderUri;let o;return i.scheme===s.Schemas.file?o=C.$l?i.fsPath:i.fsPath.toLowerCase():o=i.toString().toLowerCase(),(0,P.createHash)("md5").update(o).digest("hex")}};e.$o7b=h,e.$o7b=h=d=ve([te(0,b.$J6b),te(1,m.$ji),te(2,v.$0i),te(3,y.$FN)],h)}),define(ne[20],se([0,1,15,36,8,3,2,4,35,12,5,6,34,24]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$M6b=e.LifecycleMainPhase=e.ShutdownReason=e.$L6b=void 0,e.$L6b=(0,m.$Ph)("lifecycleMainService");var w;(function(d){d[d.QUIT=1]="QUIT",d[d.KILL=2]="KILL"})(w||(e.ShutdownReason=w={}));var p;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen",d[d.Eventually=4]="Eventually"})(p||(e.LifecycleMainPhase=p={}));let $=class extends C.$Rc{static{v=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(h,E,c){super(),this.F=h,this.G=E,this.H=c,this.c=this.B(new M.$Nd),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$Nd),this.onWillShutdown=this.f.event,this.g=this.B(new M.$Nd),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$Nd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(v.b),this.m&&this.G.removeItem(v.b)}J(){const h=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$k&&this.t===0&&this.L(1))};P.app.addListener("before-quit",h);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!S.$k)&&P.app.quit()};P.app.addListener("window-all-closed",E),P.app.once("will-quit",c=>{this.S("Lifecycle#app.on(will-quit) - begin"),c.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),P.app.removeListener("before-quit",h),P.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}L(h){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const c=[];return this.f.fire({reason:h,join(i,o){E.trace(`Lifecycle#onWillShutdown - begin '${i}'`),c.push(o.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(c)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(h){if(h<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===h)return;this.S(`lifecycle (main): phase changed (value: ${h})`),this.n=h;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when(h){if(h<=this.n)return;let E=this.C.get(h);E||(E=new s.$Sg,this.C.set(h,E)),await E.wait()}registerWindow(h){const E=new C.$Qc;this.t++,E.add(h.onWillLoad(i=>this.g.fire({window:h,workspace:i.workspace,reason:i.reason})));const c=(0,a.$Jf)(h.win);c.on("close",i=>{const o=h.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${h.id}`),i.preventDefault(),this.unload(h,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(h),h.close()})}),c.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${h.id}`),this.t--,E.dispose(),this.t===0&&(!S.$k||this.j)&&this.L(1)})}async reload(h,E){await this.unload(h,3)||h.reload(E)}unload(h,E){const c=this.z.get(h.id);if(c)return c;const i=this.M(h,E).finally(()=>{this.z.delete(h.id)});return this.z.set(h.id,i),i}async M(h,E){if(!h.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${h.id}`);const c=this.j?2:E,i=await this.P(h,c);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${h.id})`),this.N(i)):(await this.Q(h,c),!1)}N(h){return h?(this.O(!0),this.j=!1,!0):!1}O(h){this.w&&(this.w(h),this.w=void 0,this.u=void 0)}P(h,E){return new Promise(c=>{const i=this.s++,o=`vscode:ok${i}`,r=`vscode:cancel${i}`;D.$yT.once(o,()=>{c(!1)}),D.$yT.once(r,()=>{c(!0)}),h.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:E})})}Q(h,E){return new Promise(c=>{const o=`vscode:reply${this.s++}`;D.$yT.once(o,()=>c()),h.send("vscode:onWillUnload",{replyChannel:o,reason:E})})}quit(h){return this.R(h).then(E=>{if(!E&&h)try{if(S.$j){const c=(0,u.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.F.error(c)}return E})}R(h){return this.S(`Lifecycle#quit() - begin (willRestart: ${h})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(h&&this.G.setItem(v.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.u)}S(h){this.H.args["enable-smoke-test-driver"]?this.F.info(h):this.F.trace(h)}setRelaunchHandler(h){this.D=h}async relaunch(h){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if(h?.addArgs&&E.push(...h.addArgs),h?.removeArgs)for(const o of h.removeArgs){const r=E.indexOf(o);r>=0&&E.splice(r,1)}const c=()=>{this.D?.handleRelaunch(h)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:E}))};P.app.once("quit",c),await this.quit(!0)&&P.app.removeListener("quit",c)}async kill(h){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Ug)(1e3),(async()=>{for(const E of P.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let c;E.webContents&&!E.webContents.isDestroyed()?c=new Promise(i=>E.once("closed",i)):c=Promise.resolve(),E.destroy(),await c}})()]),P.app.exit(h)}};e.$M6b=$,e.$M6b=$=v=ve([te(0,b.$0i),te(1,y.$FN),te(2,f.$J6b)],$)}),define(ne[284],se([0,1,4,3,2,5,20]),function(Q,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=e.$K7b=void 0,e.$K7b=(0,M.$Ph)("keyboardLayoutMainService");let S=class extends s.$Rc{constructor(m){super(),this.a=this.B(new D.$Nd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,m.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const m=await new Promise((b,y)=>{Q(["native-keymap"],b,y)});this.c=u(m),P.$t||m.onDidChangeKeyboardLayout(()=>{this.c=u(m),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$L7b=S,e.$L7b=S=ve([te(0,C.$L6b)],S);function u(a){const m=a.getKeyMap(),b=a.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:b}}}),define(ne[285],se([0,1,246,8,17,14,12,18,37,94,6,50,245,282]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=void 0;let v=class extends b.$Wo{constructor(d,h,E,c){super(c),this.m=d,this.n=h,this.r=E,this.s(),this.B(d.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const d=this.m.getValue("http");this.f=d?.proxy,this.g=!!d?.proxyStrictSSL,this.h=d?.proxyAuthorization}async request(d,h){const{f:E,g:c}=this;let i;try{i=await(0,a.$Tl)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$9)(t)))}const o={...process.env,...i},r=d.agent?d.agent:await(0,y.$1q)(d.url||"",o,{proxyUrl:E,strictSSL:c});return d.agent=r,d.strictSSL=c,this.h&&(d.headers={...d.headers||{},"Proxy-Authorization":this.h}),this.c(d.isChromiumNetwork?"electron":"node",d,()=>p(d,h))}async resolveProxy(d){}};e.$2q=v,e.$2q=v=ve([te(0,S.$ji),te(1,u.$Xh),te(2,m.$0i),te(3,m.$$i)],v);async function w($){return((0,P.parse)($.url).protocol==="https:"?await new Promise((E,c)=>{Q(["https"],E,c)}):await new Promise((E,c)=>{Q(["http"],E,c)})).request}async function p($,d){return D.Promises.withAsyncBody(async(h,E)=>{const c=(0,P.parse)($.url),i=$.getRawRequest?$.getRawRequest($):await w($),o={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,C.$Ef)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(o.auth=$.user+":"+$.password);const r=i(o,t=>{const n=(0,C.$Cf)($.followRedirects)?$.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)p({...$,url:t.headers.location,followRedirects:n-1},d).then(h,E);else{let l=t;!$.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(l=t.pipe((0,f.createGunzip)())),h({res:t,stream:(0,s.$qe)(l)})}});r.on("error",E),$.timeout&&r.setTimeout($.timeout),$.isChromiumNetwork&&r.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&r.write($.data),r.end(),d.onCancellationRequested(()=>{r.abort(),E(new M.$4)})})}e.$3q=p}),define(ne[286],se([0,1,15,285]),function(Q,e,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N8b=void 0;function s(C){return P.net.request}class M extends D.$2q{request(S,u){return super.request({...S||{},getRawRequest:s,isChromiumNetwork:!0},u)}}e.$N8b=M}),define(ne[82],se([0,1,7,3,2,37,16,5,20,6,96,279,41,53,40,13]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W6b=e.$V6b=e.$U6b=e.$T6b=void 0,e.$T6b=(0,S.$Ph)("storageMainService");let p=class extends s.$Rc{constructor(h,E,c,i,o,r){super(),this.c=h,this.f=E,this.g=c,this.h=i,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new D.$Nd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(h=>{h.window.profile&&this.profileStorage(h.window.profile).init(),h.workspace&&this.workspaceStorage(h.workspace).init()})),this.B(this.h.onWillShutdown(h=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=h.reason,h.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.t)h.join("profileStorage",E.close());for(const[,E]of this.w)h.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(h=>{h.join((async()=>{await this.j.exists(h.profile.globalStorageHome)||await this.j.createFolder(h.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(h=>{const E=this.t.get(h.profile.id);E&&h.join(E.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const h=new b.$O6b(this.n(),this.g,this.c,this.j);return this.B(D.Event.once(h.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),h}profileStorage(h){if((0,m.$_o)(h))return this.applicationStorage;let E=this.t.get(h.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${h.name})`),E=this.B(this.u(h)),this.t.set(h.id,E);const c=this.B(E.onDidChangeStorage(i=>this.b.fire({...i,storage:E,profile:h})));this.B(D.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${h.name})`),this.t.delete(h.id),c.dispose()}))}return E}u(h){return this.a===2?new b.$Q6b(this.c,this.j):new b.$N6b(h,this.n(),this.c,this.j)}workspaceStorage(h){let E=this.w.get(h.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${h.id})`),E=this.B(this.y(h)),this.w.set(h.id,E),this.B(D.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${h.id})`),this.w.delete(h.id)}))),E}y(h){return this.a===2?new b.$Q6b(this.c,this.j):new b.$P6b(h,this.n(),this.c,this.f,this.j)}isUsed(h){const E=P.URI.file(h);for(const c of[this.applicationStorage,...this.t.values(),...this.w.values()])if(c.path&&this.m.extUri.isEqualOrParent(P.URI.file(c.path),E))return!0;return!1}};e.$U6b=p,e.$U6b=p=ve([te(0,a.$0i),te(1,M.$Wh),te(2,f.$R6b),te(3,u.$L6b),te(4,C.$$j),te(5,v.$Ik)],p),e.$V6b=(0,S.$Ph)("applicationStorageMainService");let $=class extends m.$$o{constructor(h,E){super(),this.s=h,this.U=E,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(h){if(h===-1)return this.U.applicationStorage.storage}Q(h){if(h===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:w.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$W6b=$,e.$W6b=$=ve([te(0,y.$Kk),te(1,e.$T6b)],$)}),define(ne[287],se([0,1,87,28,103,99,8,2,4,18,6,25,241,242,95,126,17]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M8b=e.$L8b=e.$K8b=e.$J8b=void 0;async function $(i,o,r,t,n){let l;for(let g=3;g&&(l?.dispose(),l=await new d(i,o,r,t,n).waitForReady(),!(n&&s.$hg[n]||!s.$hg[l.tunnelLocalPort]));g--);return l}class d extends S.$Rc{constructor(o,r,t,n,l){super(),this.m=r,this.n=l,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=P.createServer(),this.c=new C.$Sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=g=>this.r(g),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,w.$hv)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,s.$ig)(o,2,1e3,r),n=null;return this.b.listen(t,this.m),await this.c.wait(),n=this.b.address(),n||(t=0,this.b.listen(t,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(o){o.pause();const r=(0,w.$fv)(this.tunnelRemoteHost)||(0,w.$hv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,y.$6k)(this.a,r,this.tunnelRemotePort),n=t.getSocket(),l=t.readEntireBuffer();t.dispose(),l.byteLength>0&&o.write(l.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),n instanceof M.$Eh?n.socket.destroy():n.end()}),n instanceof M.$Eh?this.t(o,n):this.s(o,n),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),n.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(t=>o.write(t.buffer)),o.on("data",t=>r.write(p.$be.wrap(t))),o.resume()}t(o,r){const t=r.socket;t.on("end",()=>o.end()),t.on("close",()=>o.end()),t.on("error",()=>{o.destroy()}),t.pipe(o),o.pipe(t)}}e.$J8b=d;let h=class extends w.$kv{constructor(o,r,t,n,l){super(r,l),this.u=o,this.v=t,this.w=n}isPortPrivileged(o){return(0,w.$iv)(o,this.l,u.OS,D.release())}s(o,r,t,n,l,g,A,R){const k=this.r(r,t);if(k)return++k.refcount,k.value;if((0,w.$cv)(o))return this.t(o,r,t,l,g,A,R);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${t} on local port ${l}.`);const I={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=$(I,n,r,t,l);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,t,L),L}}};e.$K8b=h,e.$K8b=h=ve([te(0,f.$Zk),te(1,m.$0i),te(2,v.$3k),te(3,b.$pj),te(4,a.$ji)],h);let E=class extends h{constructor(o,r,t,n,l){super(o,r,t,n,l)}};e.$L8b=E,e.$L8b=E=ve([te(0,f.$Zk),te(1,m.$0i),te(2,v.$3k),te(3,b.$pj),te(4,a.$ji)],E);let c=class extends S.$Rc{constructor(o,r,t,n,l){super(),this.b=o,this.c=r,this.f=t,this.g=n,this.h=l,this.a=new Map}async openTunnel(o,r,t,n,l,g,A,R,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${g}.`),!this.a.has(o)){const I=new E(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(o,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,t,n,l,g,A,R,k)}};e.$M8b=c,e.$M8b=c=ve([te(0,f.$Zk),te(1,m.$0i),te(2,b.$pj),te(3,v.$3k),te(4,a.$ji)],c)}),define(ne[100],se([0,1,8,22,3,18,24,20,6,25,50,48]),function(Q,e,P,D,s,M,C,S,u,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$97b=e.$87b=void 0;function y(v,w,p){return`${p.updateUrl}/api/update/${v}/${w}/${p.commit}`}e.$87b=y;let f=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,p,$,d,h,E){this.f=w,this.g=p,this.h=$,this.i=d,this.j=h,this.k=E,this.b=b.$xU.Uninitialized,this.c=new s.$Nd,this.onStateChange=this.c.event,w.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(b.$xU.Disabled(0));return}if(this.h.disableUpdates){this.d(b.$xU.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(b.$xU.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),p=this.m(w);if(!p){this.d(b.$xU.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(p),!this.a){this.d(b.$xU.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(b.$xU.Idle(this.q())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(w){return w==="none"?void 0:this.k.quality}n(w=60*60*1e3){return(0,P.$Ug)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},D.CancellationToken.None)).res.statusCode===204}catch(p){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(p);return}}async _applySpecificUpdate(w){}q(){return 1}r(){}};e.$97b=f,e.$97b=f=ve([te(0,S.$L6b),te(1,M.$ji),te(2,C.$J6b),te(3,m.$Vo),te(4,u.$0i),te(5,a.$pj)],f)}),define(ne[288],se([0,1,15,55,3,2,18,24,20,6,25,50,26,48,100]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$07b=void 0;let w=class extends v.$97b{get v(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",($,d)=>d)}get w(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",($,d,h)=>({url:d,version:h,productVersion:h}))}get y(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",($,d,h,E)=>({releaseNotes:d,version:h,productVersion:h,date:E}))}constructor($,d,h,E,c,i,o){super($,d,E,c,i,o),this.z=h,this.u=new M.$Qc,$.setRelaunchHandler(this)}handleRelaunch($){return $?.addArgs||$?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B($){this.j.error("UpdateService error:",$);const d=this.state.type==="checking for updates"&&this.state.explicit?$:void 0;this.d(f.$xU.Idle(1,d))}s($){let d;this.k.darwinUniversalAssetId?d=this.k.darwinUniversalAssetId:d=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,v.$87b)(d,$,this.k);try{P.autoUpdater.setFeedURL({url:h})}catch(E){this.j.error("Failed to set update feed URL",E);return}return h}t($){this.d(f.$xU.CheckingForUpdates($)),P.autoUpdater.checkForUpdates()}E($){this.state.type==="checking for updates"&&this.d(f.$xU.Downloading($))}F($){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:$.version}),this.d(f.$xU.Ready($)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$xU.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$07b=w,ve([D.$hh],w.prototype,"v",null),ve([D.$hh],w.prototype,"w",null),ve([D.$hh],w.prototype,"x",null),ve([D.$hh],w.prototype,"y",null),e.$07b=w=ve([te(0,u.$L6b),te(1,C.$ji),te(2,y.$cl),te(3,S.$J6b),te(4,b.$Vo),te(5,a.$0i),te(6,m.$pj)],w)}),define(ne[289],se([0,1,47,45,8,3,9,24,20,6,26,48]),function(Q,e,P,D,s,M,C,S,u,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_7b=void 0;let y=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,p,$){if(this.f=w,this.g=$,this.a=b.$xU.Uninitialized,this.b=new M.$Nd,this.onStateChange=this.b.event,p.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(b.$xU.Idle(this.k())),this.h(30*1e3).then(void 0,d=>this.g.error(d))}h(w=60*60*1e3){return(0,s.$Ug)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};y=ve([te(0,u.$L6b),te(1,S.$J6b),te(2,a.$0i)],y);let f=class extends y{constructor(w,p,$,d,h,E){super($,d,h),this.o=w,this.p=p,this.q=E;const c=(0,D.watch)(C.$lc(this.o)),i=M.Event.fromNodeEventEmitter(c,"change",(n,l)=>l),o=M.Event.filter(i,n=>n==="current"),t=M.Event.debounce(o,(n,l)=>l,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{t.dispose(),c.close()})}m(){this.d(b.$xU.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(b.$xU.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$xU.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$xU.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+C.$mc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise(($,d)=>(0,D.realpath)(`${C.$lc(this.o)}/current`,(h,E)=>h?d(h):$(E))),p=C.$mc(w);return this.p!==p}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$_7b=f,e.$_7b=f=ve([te(2,u.$L6b),te(3,S.$J6b),te(4,a.$0i),te(5,m.$cl)],f)}),define(ne[29],se([0,1,4,5,69,68,25,18,24,9,63]),function(Q,e,P,D,s,M,C,S,u,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m7b=e.$l7b=e.$k7b=e.OpenContext=e.$j7b=void 0,e.$j7b=(0,D.$Ph)("windowsMainService");var b;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(b||(e.OpenContext=b={}));function y(w,p,$){const d=w.get(M.$X6b),h=w.get(C.$pj),E=w.get(S.$ji),c=w.get(u.$J6b),i=E.getValue("window"),o={backgroundColor:d.getBackgroundColor(),minWidth:s.$iC.WIDTH,minHeight:s.$iC.HEIGHT,title:h.nameLong,...$,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$qC)(i?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...$?.webPreferences,sandbox:!0},experimentalDarkMode:!0};return p&&(o.x=p.x,o.y=p.y,o.width=p.width,o.height=p.height),P.$l?o.icon=(0,a.$ic)(c.appRoot,"resources/linux/code.png"):P.$j&&!c.isBuilt&&(o.icon=(0,a.$ic)(c.appRoot,"resources/win32/code_150x150.png")),P.$k&&(o.acceptFirstMouse=!0,i?.clickThroughInactive===!1&&(o.acceptFirstMouse=!1)),o}e.$k7b=y;function f(w){const p=w.get(e.$j7b),$=w.get(m.$i7b),d=p.getFocusedWindow()??$.getFocusedWindow();if(d)return d;const h=p.getLastActiveWindow(),E=$.getLastActiveWindow();return h&&E?h.lastFocusTime<E.lastFocusTime?E:h:h??E}e.$l7b=f;function v(w){let p,$=Number.MIN_VALUE;for(const d of w)d.lastFocusTime>$&&($=d.lastFocusTime,p=d);return p}e.$m7b=v}),define(ne[290],se([0,1,15,22,3,56,2,32,116,6,82,29]),function(Q,e,P,D,s,M,C,S,u,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n7b=void 0;var y;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let f=class extends C.$Rc{constructor(w,p,$,d){super(),this.g=w,this.h=p,this.j=$,this.m=d,this.a="proxy-credentials://",this.b=void 0,this.c=y.Initial,this.f=void 0,this.n()}n(){const w=s.Event.fromNodeEventEmitter(P.app,"login",(p,$,d,h,E)=>({event:p,webContents:$,req:d,authInfo:h,callback:E}));this.B(w(this.r,this))}async r({event:w,authInfo:p,req:$,callback:d}){if(!p.isProxy)return;if(!this.b&&this.c===y.LoginDialogShown&&$.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let h;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(p);try{h=await this.b}finally{this.b=void 0}}d(h?.username,h?.password)}async s(w){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.t(w);if(p)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(w){this.g.trace("auth#doResolveProxyCredentials - enter",w);const p=String((0,M.$Di)({scheme:w.scheme,host:w.host,port:w.port}));let $,d;try{const i=this.m.get(this.a+p,-1);if(i){const o=JSON.parse(await this.j.decrypt(i));$=o.username,d=o.password}}catch(i){this.g.error(i)}if(this.c!==y.StoredCredentialsUsed&&typeof $=="string"&&typeof d=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=y.StoredCredentialsUsed,{username:$,password:d};const h=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!h){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const E={authInfo:w,username:this.f?.username??$,password:this.f?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,S.$eg)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",D.CancellationToken.None,E),this.c=y.LoginDialogShown;const c=await new Promise(i=>{const o=async(r,t,n)=>{if(t===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",o),n){const l={username:n.username,password:n.password};try{if(n.remember){const g=await this.j.encrypt(JSON.stringify(l));this.m.store(this.a+p,g,-1,1)}else this.m.remove(this.a+p,-1)}catch(g){this.g.error(g)}i({username:l.username,password:l.password})}else i(void 0)};h.win?.webContents.on("ipc-message",o)});return this.f=c,c}};e.$n7b=f,e.$n7b=f=ve([te(0,a.$0i),te(1,b.$j7b),te(2,u.$gU),te(3,m.$V6b)],f)}),define(ne[291],se([0,1,15,23,4,7,21,18,62,5,6,127,29]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O7b=e.$N7b=e.ID=void 0,e.ID="launchMainService",e.$N7b=(0,a.$Ph)(e.ID);let f=class{constructor(w,p,$,d){this.a=w,this.b=p,this.c=$,this.d=d}async start(w,p){this.a.trace("Received data from other instance: ",w,p),s.$k&&P.app.focus({steal:!0});const $=this.e(w);if($.length){let d=Promise.resolve();if(this.b.getWindowCount()===0){const h=(0,D.$Nb)(await this.b.openEmptyWindow({context:4}));h&&(d=h.ready())}d.then(()=>{for(const{uri:h,originalUrl:E}of $)this.c.open(h,{originalUrl:E})})}else return this.f(w,p)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,D.$Gb)(w._urls.map(p=>{try{return{uri:M.URI.parse(p),originalUrl:p}}catch{return null}})):[]}async f(w,p){const $=(0,u.$Nl)(p)?0:4;let d=[];const h=w.wait&&w.waitMarkerFilePath?M.URI.file(w.waitMarkerFilePath):void 0,E=w.remote||void 0,c={context:$,cli:w,userEnv:p,waitMarkerFileURI:h,remoteAuthority:E,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,c);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let i=!1;if(w["new-window"]||w["unity-launch"]||c.forceProfile||c.forceTempProfile)i=!0;else if(w["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!s.$k}if(i)d=await this.b.open({...c,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,c),d=[o]):d=await this.b.open({...c,forceEmpty:!0})}}else d=await this.b.open({...c,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(h&&d.length===1&&d[0])return Promise.race([d[0].whenClosedOrLoaded,(0,C.whenDeleted)(h.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$O7b=f,e.$O7b=f=ve([te(0,m.$0i),te(1,y.$j7b),te(2,b.$mU),te(3,S.$ji)],f)}),define(ne[292],se([0,1,2,20,53,30,8,29]),function(Q,e,P,D,s,M,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r8b=void 0;let u=class extends P.$Rc{constructor(m,b,y){super(),this.a=b,this.b=y,this.B(m.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B(m.onBeforeCloseWindow(f=>this.c(f))),this.B(new C.$6g(()=>this.g(),30*1e3)).schedule()}async c(m){const b=this.f(m),y=this.a.getProfileForWorkspace(b);y?.isTransient&&(this.a.unsetWorkspace(b,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(m){return m.openedWorkspace??(0,M.$4h)(m.backupPath,m.isExtensionDevelopmentHost)}g(){const m=this.a.getAssociatedEmptyWindows();if(m.length===0)return;const b=this.b.getWindows().map(y=>this.f(y));for(const y of m)b.some(f=>f.id===y.id)||this.a.unsetWorkspace(y,!1)}};e.$r8b=u,e.$r8b=u=ve([te(0,D.$L6b),te(1,s.$R6b),te(2,S.$j7b)],u)}),define(ne[60],se([0,1,15,2,3,6,313,8,13,29,74,26,20,76,38,4,131]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$r7b=e.$q7b=void 0;function d(c){return typeof c.responseWindowId=="number"}let h=class extends D.$Rc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(i,o,r){super(),this.t=i,this.u=o,this.w=r,this.c=String(++$.a),this.f=this.B(new s.$Nd),this.onStdout=this.f.event,this.g=this.B(new s.$Nd),this.onStderr=this.g.event,this.h=this.B(new s.$Nd),this.onMessage=this.h.event,this.j=this.B(new s.$Nd),this.onExit=this.j.event,this.m=this.B(new s.$Nd),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(i,o){let r;switch(this.s?.correlationId?r=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${i}`:r=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${i}`,o){case m.default.Error:this.t.error(r);break;case m.default.Warning:this.t.warn(r);break;case m.default.Info:this.t.trace(r);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(i){const o=this.C(i);return o&&i.payload&&this.postMessage(i.payload),o}C(i){if(!this.z())return!1;this.s=i;const o=`${this.s.type}-${this.c}`,r=u.$cg.asFileUri("bootstrap-fork.js").fsPath,t=this.s.args??[],n=this.s.execArgv??[],l=this.s.allowLoadingUnsignedLibraries,g=this.s.forceAllocationsToV8Sandbox,A="pipe",R=this.D(i);return this.y("creating new...",m.default.Info),this.n=P.utilityProcess.fork(r,t,{serviceName:o,env:R,execArgv:n,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:g,stdio:A}),this.F(this.n,this.s,o),!0}D(i){const o=i.env?{...i.env}:{...(0,v.$7m)(process.env)};o.VSCODE_AMD_ENTRYPOINT=i.entryPoint,typeof i.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(i.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=i.type,w.$j&&((0,p.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,p.getUNCHostAllowlist)().join("\\")),(0,f.$Al)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}F(i,o,r){if(i.stdout){const t=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:t.write(n))))}if(i.stderr){const t=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:t.write(n))))}this.B(s.Event.fromNodeEventEmitter(i,"message")(t=>this.h.fire(t))),this.B(s.Event.fromNodeEventEmitter(i,"spawn")(()=>{this.r=i.pid,typeof i.pid=="number"&&$.b.set(i.pid,{pid:i.pid,name:d(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.y("successfully created",m.default.Info)})),this.B(s.Event.fromNodeEventEmitter(i,"exit")(t=>{this.y(`received exit event with code ${t}`,m.default.Info),this.j.fire({pid:this.r,code:t,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(t,n)=>({event:t,details:n}))(({details:t})=>{t.type==="Utility"&&t.name===r&&(this.y(`crashed with code ${t.exitCode} and reason '${t.reason}'`,m.default.Error),this.u.publicLog2("utilityprocesscrash",{type:o.type,reason:t.reason,code:t.exitCode}),this.m.fire({pid:this.r,code:t.exitCode,reason:t.reason}),this.G())}))}once(i,o){const r=this.B(this.h.event(t=>{t===i&&(r.dispose(),o())}))}postMessage(i,o){this.n&&this.n.postMessage(i,o)}connect(i){const{port1:o,port2:r}=new P.MessageChannelMain;return this.postMessage(i,[r]),o}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",m.default.Info);const i=process;return typeof i._debugProcess=="function"?(i._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",m.default.Info),this.n.kill()?(this.y("successfully killed the process",m.default.Info),this.G()):this.y("unable to kill the process",m.default.Warning)}G(){typeof this.r=="number"&&$.b.delete(this.r),this.n=void 0}async waitForExit(i){this.n&&(this.y("waiting to exit...",m.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,S.$Ug)(i)]),this.n&&(this.y(`did not exit within ${i}ms, will kill it now...`,m.default.Info),this.kill()))}};e.$q7b=h,e.$q7b=h=$=ve([te(0,M.$0i),te(1,b.$cl),te(2,y.$L6b)],h);let E=class extends h{constructor(i,o,r,t){super(i,r,t),this.H=o}start(i){const o=this.H.getWindowById(i.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.C(i))return!1;this.I(o.win,i);const t=this.connect(i.payload);return o.win.webContents.postMessage(i.responseChannel,i.responseNonce,[t]),!0}I(i,o){o.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,r=>r.window.win===i)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(i,"closed")(()=>this.kill())))}};e.$r7b=E,e.$r7b=E=ve([te(0,M.$0i),te(1,a.$j7b),te(2,b.$cl),te(3,y.$L6b)],E)}),define(ne[293],se([0,1,14,6,20,8,60,29,26]),function(Q,e,P,D,s,M,C,S,u){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=void 0;let m=class{static{a=this}static{this.a=0}constructor(y,f,v,w){this.d=y,this.f=f,this.g=v,this.h=w,this.b=new Map,this.c=!1,this.f.onWillShutdown(p=>{this.c=!0,p.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(y){const f=this.b.get(y);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(y){return this.i(y).onStdout}onDynamicStderr(y){return this.i(y).onStderr}onDynamicMessage(y){return this.i(y).onMessage}onDynamicExit(y){return this.i(y).onExit}async createExtensionHost(){if(this.c)throw(0,P.$5)();const y=String(++a.a),f=new C.$r7b(this.d,this.g,this.h,this.f);return this.b.set(y,f),f.onExit(({pid:v,code:w,signal:p})=>{this.d.info(`Extension host with pid ${v} exited with code: ${w}, signal: ${p}.`),setTimeout(()=>{f.dispose(),this.b.delete(y)}),setTimeout(()=>{try{process.kill(v,0),this.d.error(`Extension host with pid ${v} still exists, forcefully killing it...`),process.kill(v)}catch{}},1e3)}),{id:y}}async start(y,f){if(this.c)throw(0,P.$5)();this.i(y).start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:y})}async enableInspectPort(y){if(this.c)throw(0,P.$5)();const f=this.b.get(y);return f?f.enableInspectPort():!1}async kill(y){if(this.c)throw(0,P.$5)();const f=this.b.get(y);f&&f.kill()}async _killAllNow(){for(const[,y]of this.b)y.kill()}async _waitForAllExit(y){const f=[];for(const[,v]of this.b)f.push(v.waitForExit(y));return M.Promises.settled(f).then(()=>{})}};e.$y7b=m,e.$y7b=m=a=ve([te(0,D.$0i),te(1,s.$L6b),te(2,S.$j7b),te(3,u.$cl)],m)}),define(ne[294],se([0,1,36,8,2,24,20,6,41,39,67,60,51,90,12,247]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$27b=void 0;let p=class extends s.$Rc{constructor(d,h,E,c,i,o,r,t){super(),this.c=d,this.f=h,this.g=E,this.h=c,this.j=i,this.m=o,this.n=r,this.r=t,this.a=new D.$Sg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){P.$yT.on(w.$Z7b.request,(d,h)=>this.t(d,h,w.$Z7b.response)),P.$yT.on(w.$17b.request,(d,h)=>this.t(d,h,w.$17b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(d,h,E){this.m.trace(`[SharedProcess] onWindowConnection for: ${E}`),this.a.isOpen()||this.a.open(),await this.whenReady();const c=await this.connect(E);if(d.sender.isDestroyed())return c.close();d.sender.postMessage(E,h,[c])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(w.$Y7b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const d=new D.$ch;this.b?this.b.once(w.$Y7b.initDone,()=>d.complete()):P.$yT.once(w.$Y7b.initDone,()=>d.complete()),await d.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const d=new D.$ch;this.b?this.b.once(w.$Y7b.ipcReady,()=>d.complete()):P.$yT.once(w.$Y7b.ipcReady,()=>d.complete()),await d.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new b.$q7b(this.m,y.$oo,this.j));const d=(0,f.$lm)(this.g.args,this.g.isBuilt);let h;d.port&&(h=["--nolazy"],d.break?h.push(`--inspect-brk=${d.port}`):h.push(`--inspect=${d.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:h})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(d){return await this.z,(0,v.$Jf)(this.b).connect(d)}};e.$27b=p,e.$27b=p=ve([te(2,M.$J6b),te(3,u.$Kk),te(4,C.$L6b),te(5,S.$0i),te(6,m.$d7b),te(7,a.$ln)],p)}),define(ne[295],se([0,1,24,90,20,6,51,60,110,36,2,3,38,18,13]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B8b=void 0;let w=class extends m.$Rc{constructor($,d,h,E,c){super(),this.f=$,this.g=d,this.h=h,this.j=E,this.m=c,this.a=void 0,this.b=new b.$Nd,this.onRequestConnection=this.b.event,this.c=new b.$Nd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),a.$yT.on("vscode:createPtyHostMessageChannel",(i,o)=>this.r(i,o)),this.B((0,m.$Pc)(()=>{a.$yT.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$q7b(this.m,C.$oo,this.j);const $=(0,D.$km)(this.h.args,this.h.isBuilt),d=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:d,args:["--logsPath",this.h.logsHome.with({scheme:v.Schemas.file}).fsPath],env:this.n()});const h=this.a.connect(),E=new u.$GT(h,"ptyHost"),c=new m.$Qc;return c.add(E),c.add((0,m.$Pc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:c,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,y.$7m)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},d=this.g.getValue("terminal.integrated.developer.ptyHost.latency");d&&typeof d=="number"&&($.VSCODE_LATENCY=String(d));const h=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return h&&typeof h=="number"&&($.VSCODE_STARTUP_DELAY=String(h)),this.h.restoreSnapExportedVariables(),$}r($,d){this.b.fire();const h=this.a.connect();if($.sender.isDestroyed()){h.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",d,[h])}};e.$B8b=w,e.$B8b=w=ve([te(1,f.$ji),te(2,P.$J6b),te(3,s.$L6b),te(4,M.$0i)],w)}),define(ne[296],se([0,1,2,5,6,29,60,26,56,3,8,20]),function(Q,e,P,D,s,M,C,S,u,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A8b=e.$z8b=void 0,e.$z8b=(0,D.$Ph)("utilityProcessWorker");let y=class extends P.$Rc{constructor(w,p,$,d){super(),this.b=w,this.c=p,this.f=$,this.g=d,this.a=new Map}async createWorker(w){const p=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${p})`);const $=this.h(w);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${p})`),this.disposeWorker(w));const d=new f(this.b,this.c,this.f,this.g,w);if(!d.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,d);const h=new m.$ch;return a.Event.once(d.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete($),h.complete({reason:E})}),h.p}h(w){return(0,u.$Di)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const p=this.h(w),$=this.a.get(p);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),$.kill(),this.a.delete(p))}};e.$A8b=y,e.$A8b=y=ve([te(0,s.$0i),te(1,M.$j7b),te(2,S.$cl),te(3,b.$L6b)],y);let f=class extends P.$Rc{constructor(w,p,$,d,h){super(),this.c=w,this.f=p,this.g=$,this.h=d,this.j=h,this.a=this.B(new a.$Nd),this.onDidTerminate=this.a.event,this.b=new C.$r7b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(w=>this.a.fire({code:w.code,signal:w.signal}))),this.B(this.b.onCrash(w=>this.a.fire({code:w.code,signal:"ECRASH"})))}spawn(){const p=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:p,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};f=ve([te(0,s.$0i),te(1,M.$j7b),te(2,S.$cl),te(3,b.$L6b)],f)}),define(ne[297],se([0,1,15,3,2,273,29]),function(Q,e,P,D,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h8b=void 0;let S=class extends s.$Rc{constructor(a){super(),this.b=a,this.a=this.B(new D.$Nd),this.onFoundInFrame=this.a.event,this.B(new M.$g8b)}async setIgnoreMenuShortcuts(a,m){let b;if(typeof a.windowId=="number"){const{windowId:y}=a,f=this.b.getWindowById(y);if(!f?.win)throw new Error(`Invalid windowId: ${y}`);b=f.win.webContents}else{const{webContentsId:y}=a;if(b=P.webContents.fromId(y),!b)throw new Error(`Invalid webContentsId: ${y}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(m)}async findInFrame(a,m,b,y){const v=this.c(a,m);if(typeof v.findInFrame=="function"){v.findInFrame(b,{findNext:y.findNext,forward:y.forward});const w=(p,$)=>{$.finalUpdate&&(this.a.fire($),v.removeListener("found-in-frame",w))};v.on("found-in-frame",w)}}async stopFindInFrame(a,m,b){const f=this.c(a,m);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}c(a,m){const b=this.b.getWindowById(a.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${a}`);const y=b.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===m);if(!y)throw new Error(`Unknown frame: ${m}`);return y}};e.$h8b=S,e.$h8b=S=ve([te(0,C.$j7b)],S)}),define(ne[298],se([0,1,15,2,4,19,7,18,20,6,34,29,128,30]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$k8b=e.$j8b=e.$i8b=void 0;let w=class extends D.$Rc{static{v=this}static{this.a="windowsState"}get state(){return this.b}constructor(c,i,o,r,t){super(),this.g=c,this.h=i,this.j=o,this.m=r,this.n=t,this.b=p(this.h.getItem(v.a)),this.c=void 0,this.f=!1,this.r()}r(){P.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(c=>this.u(c)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(c=>this.u(c))}s(){this.f=!0,this.t()}t(){const c=new Set,i={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!i.lastActiveWindow){let t=this.g.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(i.lastActiveWindow=this.w(t),i.lastActiveWindow.uiState.mode===3&&c.add(i.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(i.lastPluginDevelopmentHostWindow=this.w(o),i.lastPluginDevelopmentHostWindow.uiState.mode===3&&(c.has(i.lastPluginDevelopmentHostWindow.uiState.display)?s.$k&&!o.win?.isSimpleFullScreen()&&(i.lastPluginDevelopmentHostWindow.uiState.mode=1):c.add(i.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(i.openedWindows=this.g.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>{const n=this.w(t);return n.uiState.mode===3&&(c.has(n.uiState.display)?s.$k&&n.windowId!==i.lastActiveWindow?.windowId&&!t.win?.isSimpleFullScreen()&&(n.uiState.mode=1):c.add(n.uiState.display)),n}));const r=d(i);this.h.setItem(v.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(c){if(this.j.quitRequested)return;const i=this.w(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=i:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,f.$5h)(c.openedWorkspace)&&o.workspace?.id===c.openedWorkspace.id,t=(0,f.$Zh)(c.openedWorkspace)&&o.folderUri&&M.$mg.isEqual(o.folderUri,c.openedWorkspace.uri);(r||t)&&(o.uiState=i.uiState)}),this.g.getWindowCount()===1&&(this.c=i)}w(c){return{windowId:c.id,workspace:(0,f.$5h)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,f.$Zh)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const i=this.z(c),o=this.n.getValue("window");if(i.mode===3){let r;i.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(i.mode=1)}return i}z(c){const i=this.g.getLastActiveWindow();if(!c.extensionTestsPath){if(c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const g=c.workspace;if((0,f.$5h)(g)){const R=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===g.id).map(k=>k.uiState);if(R.length)return R[0]}if((0,f.$Zh)(g)){const R=this.state.openedWindows.filter(k=>k.folderUri&&M.$mg.isEqual(k.folderUri,g.uri)).map(k=>k.uiState);if(R.length)return R[0]}else if(c.backupPath){const R=this.state.openedWindows.filter(k=>k.backupPath===c.backupPath).map(k=>k.uiState);if(R.length)return R[0]}const A=this.c||this.state.lastActiveWindow;if(!i&&A)return A.uiState}let o;const r=P.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(s.$k){const g=P.screen.getCursorScreenPoint();o=P.screen.getDisplayNearestPoint(g)}!o&&i&&(o=P.screen.getDisplayMatching(i.getBounds())),o||(o=P.screen.getPrimaryDisplay()||r[0])}let t=(0,y.$I6b)();t.x=Math.round(o.bounds.x+o.bounds.width/2-t.width/2),t.y=Math.round(o.bounds.y+o.bounds.height/2-t.height/2);const n=this.n.getValue("window");let l=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")t.mode=0,l=!1;else if(n.newWindowDimensions==="fullscreen")t.mode=3,l=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&i){const g=i.serializeWindowState();g.mode===3?t.mode=3:t=g,l=t.mode!==3&&n.newWindowDimensions==="offset"}}return l&&(t=this.C(t)),t.hasDefaultState=!0,t}C(c){if(this.g.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const i=this.g.getWindows().map(o=>o.getBounds());for(;i.some(o=>o.x===c.x||o.y===c.y);)c.x+=30,c.y+=30;return c}};e.$i8b=w,e.$i8b=w=v=ve([te(0,b.$j7b),te(1,m.$FN),te(2,u.$L6b),te(3,a.$0i),te(4,S.$ji)],w);function p(E){const c={openedWindows:[]},i=E||{openedWindows:[]};return i.lastActiveWindow&&(c.lastActiveWindow=$(i.lastActiveWindow)),i.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=$(i.lastPluginDevelopmentHostWindow)),Array.isArray(i.openedWindows)&&(c.openedWindows=i.openedWindows.map(o=>$(o))),c}e.$j8b=p;function $(E){const c={uiState:E.uiState};return E.backupPath&&(c.backupPath=E.backupPath),E.remoteAuthority&&(c.remoteAuthority=E.remoteAuthority),E.folder&&(c.folderUri=C.URI.parse(E.folder)),E.workspaceIdentifier&&(c.workspace={id:E.workspaceIdentifier.id,configPath:C.URI.parse(E.workspaceIdentifier.configURIPath)}),c}function d(E){return{lastActiveWindow:E.lastActiveWindow&&h(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&h(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(c=>h(c))}}e.$k8b=d;function h(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(ne[54],se([0,1,15,3,44,2,13,9,19,21,194,64,52,24,5,6,53,130,30,97,98]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$,d,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c7b=e.$b7b=void 0,e.$b7b=(0,v.$Ph)("workspacesManagementMainService");let c=class extends M.$Rc{constructor(o,r,t,n,l){super(),this.g=o,this.h=r,this.j=t,this.m=n,this.n=l,this.a=this.B(new D.$Nd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new D.$Nd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await a.Promises.readdir(this.c.with({scheme:C.Schemas.file}).fsPath)).map(r=>(0,u.$vg)(this.c,r,d.$ci));for(const r of o){const t=(0,E.$$6b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:t,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(t)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>a.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===C.Schemas.file)try{const t=r(o.fsPath);return t instanceof Promise?t.then(n=>this.t(o,n),n=>{}):this.t(o,t)}catch{return}}s(o){return(0,d.$di)(o,this.g)||(0,d.$ii)(o)}t(o,r){try{const t=this.u(o,r),n=(0,E.$$6b)(o);return{id:n.id,configPath:n.configPath,folders:(0,h.$2U)(t.folders,n.configPath,u.$mg),remoteAuthority:t.remoteAuthority,transient:t.transient}}catch(t){this.h.warn(t.toString())}}u(o,r){const t=(0,s.$Wm)(r);if(t&&Array.isArray(t.folders))t.folders=t.folders.filter(n=>(0,h.$ZU)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return t}async createUntitledWorkspace(o,r){const{workspace:t,storedWorkspace:n}=this.w(o,r),l=t.configPath.fsPath;return await a.Promises.mkdir((0,S.$lc)(l),{recursive:!0}),await a.Promises.writeFile(l,JSON.stringify(n,null,"	")),this.f.push({workspace:t,remoteAuthority:r}),t}w(o=[],r){const t=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,u.$vg)(this.c,t),l=(0,u.$vg)(n,d.$ci),g=[];for(const A of o)g.push((0,h.$1U)(A.uri,!0,A.name,n,u.$mg));return{workspace:(0,E.$$6b)(l),storedWorkspace:{folders:g,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,E.$$6b)(o)}isUntitledWorkspace(o){return(0,d.$di)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,u.$jg)(o.configPath);try{await a.Promises.rm((0,S.$lc)(r));const t=(0,S.$ic)(this.g.workspaceStorageHome.with({scheme:C.Schemas.file}).fsPath,o.id);await a.Promises.exists(t)&&await a.Promises.writeFile((0,S.$ic)(t,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==o.id)}catch(t){this.h.warn(`Unable to delete untitled workspace ${r} (${t}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,t){if(!o||!o.win||!o.isReady||!await this.z(o,r,t))return;const l=await this.C(o,(0,E.$$6b)(t));if(l)return this.b.fire({window:o,workspace:l.workspace}),l}async z(o,r,t){return t?(0,d.$5h)(o.openedWorkspace)&&u.$mg.isEqual(o.openedWorkspace.configPath,t)?!1:(0,$.$86b)(r,t)?(await this.n.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:(0,m.localize)(1,null,(0,u.$sg)(t)),detail:(0,m.localize)(2,null)},P.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let t;return o.config.extensionDevelopmentPath||(o.config.backupPath?t=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):t=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,d.$5h)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=t,{workspace:r,backupPath:t}}};e.$c7b=c,e.$c7b=c=ve([te(0,f.$J6b),te(1,w.$0i),te(2,p.$R6b),te(3,b.$36b),te(4,y.$46b)],c)}),define(ne[132],se([0,1,15,36,22,5,29,30,54,12,6,60]),function(Q,e,P,D,s,M,C,S,u,a,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=e.$t7b=e.ID=void 0,e.ID="diagnosticsMainService",e.$t7b=(0,M.$Ph)(e.ID);let y=class{constructor(v,w,p){this.a=v,this.b=w,this.c=p}async getRemoteDiagnostics(v){const w=this.a.getWindows();return(await Promise.all(w.map(async $=>{const d=$.remoteAuthority;if(!d)return;const h=`vscode:getDiagnosticInfoResponse${$.id}`,E={includeProcesses:v.includeProcesses,folders:v.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(c=>{$.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:h,args:E}),D.$yT.once(h,(i,o)=>{o||c({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),c(o)}),setTimeout(()=>{c({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const v=[];for(const p of P.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(p.id);$?v.push(await this.d($)):v.push(this.e(p))}const w=[];for(const{pid:p,name:$}of b.$q7b.getAll())w.push({pid:p,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:v,pidToNames:w,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(v){const w=await this.f(v),p=(0,a.$Jf)(v.win);return this.e(p,w,v.remoteAuthority)}e(v,w=[],p){return{id:v.id,pid:v.webContents.getOSProcessId(),title:v.getTitle(),folderURIs:w,remoteAuthority:p}}async f(v){const w=[],p=v.openedWorkspace;if((0,S.$Zh)(p))w.push(p.uri);else if((0,S.$5h)(p)){const $=await this.b.resolveLocalWorkspace(p.configPath);$&&$.folders.forEach(h=>{w.push(h.uri)})}return w}};e.$u7b=y,e.$u7b=y=ve([te(0,C.$j7b),te(1,u.$b7b),te(2,m.$0i)],y)}),define(ne[70],se([0,1,47,15,28,156,55,3,2,13,9,4,7,105,88,21,103,182,52,24,5,20,6,25,68,29,30,54,17,243,235,63]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$,d,h,E,c,i,o,r,t,n,l,g,A,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I7b=e.$H7b=void 0,e.$H7b=(0,E.$Ph)("nativeHostMainService");let I=class extends u.$Rc{constructor(N,T,x,X,ce,re,ae,Z,K,G){super(),this.a=N,this.b=T,this.c=x,this.f=X,this.g=ce,this.h=re,this.j=ae,this.m=Z,this.n=K,this.r=G,this.onDidOpenWindow=S.Event.map(this.a.onDidOpenWindow,z=>z.id),this.onDidTriggerSystemContextMenu=S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:z,x:W,y:V})=>({windowId:z.id,x:W,y:V})),({windowId:z})=>!!this.a.getWindowById(z)),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(D.app,"browser-window-maximize",(z,W)=>W.id),z=>!!this.a.getWindowById(z)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(D.app,"browser-window-unmaximize",(z,W)=>W.id),z=>!!this.a.getWindowById(z)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(z,W)=>W.id),z=>!!this.a.getWindowById(z)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),z=>!!z),z=>z.id),S.Event.filter(S.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(z,W)=>W.id),z=>!!this.a.getWindowById(z))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.s=this.B(new S.$Nd),this.onDidChangePassword=this.s.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(z,W,V)=>V),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),S.Event.fromNodeEventEmitter(D.screen,"display-added"),S.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(N,T){const x=this.a.getWindows().map(ce=>({id:ce.id,workspace:ce.openedWorkspace??(0,n.$4h)(ce.backupPath,ce.isExtensionDevelopmentHost),title:ce.win?.getTitle()??"",filename:ce.getRepresentedFilename(),dirty:ce.isDocumentEdited()})),X=[];return T.includeAuxiliaryWindows&&X.push(...this.b.getWindows().map(ce=>({id:ce.id,parentId:ce.parentId,title:ce.win?.getTitle()??"",filename:ce.getRepresentedFilename()}))),[...x,...X]}async getWindowCount(N){return this.a.getWindowCount()}async getActiveWindowId(N){const T=D.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(T)return T.id}openWindow(N,T,x){return Array.isArray(T)?this.t(N,T,x):this.u(N,T)}async t(N,T,x=Object.create(null)){T.length>0&&await this.a.open({context:5,contextWindowId:N,urisToOpen:T,cli:this.g.args,forceNewWindow:x.forceNewWindow,forceReuseWindow:x.forceReuseWindow,preferNewWindow:x.preferNewWindow,diffMode:x.diffMode,mergeMode:x.mergeMode,addMode:x.addMode,gotoLineMode:x.gotoLineMode,noRecentEntry:x.noRecentEntry,waitMarkerFileURI:x.waitMarkerFileURI,remoteAuthority:x.remoteAuthority||void 0,forceProfile:x.forceProfile,forceTempProfile:x.forceTempProfile})}async u(N,T){await this.a.openEmptyWindow({context:5,contextWindowId:N},T)}async toggleFullScreen(N){this.F(N)?.toggleFullScreen()}async handleTitleDoubleClick(N){this.F(N)?.handleTitleDoubleClick()}async isMaximized(N){const T=this.F(N);return T?.win?T.win.isMaximized():!1}async maximizeWindow(N){const T=this.F(N);T?.win&&T.win.maximize()}async unmaximizeWindow(N){const T=this.F(N);T?.win&&T.win.unmaximize()}async minimizeWindow(N){const T=this.F(N);T?.win&&T.win.minimize()}async moveWindowTop(N,T){const x=this.D(T?.targetWindowId,N);x?.win&&x.win.moveTop()}async positionWindow(N,T,x){const X=this.D(x?.targetWindowId)??this.F(N);if(X?.win){if(X.win.isFullScreen()){const ce=S.Event.toPromise(S.Event.once(S.Event.fromNodeEventEmitter(X.win,"leave-full-screen")));X.win.setFullScreen(!1),await ce}X.win.setBounds(T)}}async updateWindowControls(N,T){const x=this.F(N);x&&x.updateWindowControls(T)}async focusWindow(N,T){this.D(T?.targetWindowId,N)?.focus({force:T?.force??!1})}async setMinimumSize(N,T,x){const X=this.F(N);if(X?.win){const[ce,re]=X.win.getSize(),[ae,Z]=X.win.getMinimumSize(),[K,G]=[T??ae,x??Z],[z,W]=[Math.max(ce,K),Math.max(re,G)];(ae!==K||Z!==G)&&X.win.setMinimumSize(K,G),(ce!==z||re!==W)&&X.win.setSize(z,W)}}async saveWindowSplash(N,T){this.m.saveWindowSplash(N,T)}async installShellCommand(N){const{source:T,target:x}=await this.w();try{const{symbolicLink:X}=await w.SymlinkSupport.stat(T);if(X&&!X.dangling){const ce=await(0,f.$0p)(T);if(x===ce)return}await w.Promises.unlink(T)}catch(X){if(X.code!=="ENOENT")throw X}try{await w.Promises.symlink(x,T)}catch(X){if(X.code!=="EACCES"&&X.code!=="ENOENT")throw X;const{response:ce}=await this.showMessageBox(N,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(ce===0)try{const re=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${x}' '${T}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(re)}catch{throw new Error((0,$.localize)(3,null,T))}}}async uninstallShellCommand(N){const{source:T}=await this.w();try{await w.Promises.unlink(T)}catch(x){switch(x.code){case"EACCES":{const{response:X}=await this.showMessageBox(N,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(X===0)try{const ce=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(ce)}catch{throw new Error((0,$.localize)(7,null,T))}break}case"ENOENT":break;default:throw x}}}async w(){const N=(0,m.$jc)(this.g.appRoot,"bin","code"),T=`/usr/local/bin/${this.j.applicationName}`;if(!await w.Promises.exists(N))throw new Error((0,$.localize)(8,null,N));return{source:T,target:N}}async showMessageBox(N,T){const x=this.H(N);return this.c.showMessageBox(T,x?.win??void 0)}async showSaveDialog(N,T){const x=this.H(N);return this.c.showSaveDialog(T,x?.win??void 0)}async showOpenDialog(N,T){const x=this.H(N);return this.c.showOpenDialog(T,x?.win??void 0)}async pickFileFolderAndOpen(N,T){const x=await this.c.pickFileFolder(T);x&&await this.z(await Promise.all(x.map(async X=>await w.SymlinkSupport.existsDirectory(X)?{folderUri:y.URI.file(X)}:{fileUri:y.URI.file(X)})),T,N)}async pickFolderAndOpen(N,T){const x=await this.c.pickFolder(T);x&&await this.z(x.map(X=>({folderUri:y.URI.file(X)})),T,N)}async pickFileAndOpen(N,T){const x=await this.c.pickFile(T);x&&await this.z(x.map(X=>({fileUri:y.URI.file(X)})),T,N)}async pickWorkspaceAndOpen(N,T){const x=await this.c.pickWorkspace(T);x&&await this.z(x.map(X=>({workspaceUri:y.URI.file(X)})),T,N)}async z(N,T,x){await this.a.open({context:3,contextWindowId:x,cli:this.g.args,urisToOpen:N,forceNewWindow:T.forceNewWindow})}async showItemInFolder(N,T){D.shell.showItemInFolder(T)}async setRepresentedFilename(N,T,x){this.D(x?.targetWindowId,N)?.setRepresentedFilename(T)}async setDocumentEdited(N,T,x){this.D(x?.targetWindowId,N)?.setDocumentEdited(T)}async openExternal(N,T){return this.g.unsetSnapExportedVariables(),D.shell.openExternal(T),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(N,T){return D.shell.trashItem(T)}async isAdmin(){let N;return b.$j?N=(await new Promise((T,x)=>{Q(["native-is-elevated"],T,x)}))():N=process.getuid?.()===0,N}async writeElevated(N,T,x,X){const ce=await new Promise((re,ae)=>{Q(["@vscode/sudo-prompt"],re,ae)});return new Promise((re,ae)=>{const Z=[`"${this.C}"`];X?.unlock&&Z.push("--file-chmod"),Z.push("--file-write",`"${T.fsPath}"`,`"${x.fsPath}"`);const K={name:this.j.nameLong.replace("-",""),icns:b.$k&&this.g.isBuilt?(0,m.$ic)((0,m.$lc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};ce.exec(Z.join(" "),K,(G,z,W)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),W&&this.h.trace(`[sudo-prompt] received stderr: ${W}`),G?ae(G):re(void 0)})})}async isRunningUnderARM64Translation(){return b.$l||b.$j?!1:D.app.runningUnderARM64Translation}get C(){return b.$j?this.g.isBuilt?(0,m.$ic)((0,m.$lc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,m.$ic)(this.g.appRoot,"scripts","code-cli.bat"):b.$l?this.g.isBuilt?(0,m.$ic)((0,m.$lc)(process.execPath),"bin",`${this.j.applicationName}`):(0,m.$ic)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,m.$ic)(this.g.appRoot,"bin","code"):(0,m.$ic)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return v.$Rm.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return b.$j&&(0,A.$F7b)()}async killProcess(N,T,x){process.kill(T,x)}async readClipboardText(N,T){return D.clipboard.readText(T)}async writeClipboardText(N,T,x){return D.clipboard.writeText(T,x)}async readClipboardFindText(N){return D.clipboard.readFindText()}async writeClipboardFindText(N,T){return D.clipboard.writeFindText(T)}async writeClipboardBuffer(N,T,x,X){return D.clipboard.writeBuffer(T,Buffer.from(x.buffer),X)}async readClipboardBuffer(N,T){return g.$be.wrap(D.clipboard.readBuffer(T))}async hasClipboard(N,T,x){return D.clipboard.has(T,x)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(N,T){this.F(N)?.updateTouchBar(T)}async notifyReady(N){this.F(N)?.setReady()}async relaunch(N,T){return this.f.relaunch(T)}async reload(N,T){const x=this.F(N);if(x){if((0,n.$5h)(x.openedWorkspace)){const X=x.openedWorkspace.configPath;if(X.scheme===a.Schemas.file&&(await this.n.resolveLocalWorkspace(X))?.transient)return this.openWindow(x.id,{forceReuseWindow:!0})}return this.f.reload(x,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(N){this.closeWindowById(N,N)}async closeWindowById(N,T){return(this.D(T)??this.F(T))?.win?.close()}async quit(N){const T=this.a.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&T.win?T.win.close():this.f.quit()}async exit(N,T){await this.f.kill(T)}async resolveProxy(N,T){return this.F(N)?.win?.webContents?.session?.resolveProxy(T)}findFreePort(N,T,x,X,ce=1){return(0,p.$gg)(T,x,X,ce)}async openDevTools(N,T){this.H(N)?.win?.webContents.openDevTools(T)}async toggleDevTools(N){this.H(N)?.win?.webContents.toggleDevTools()}async sendInputEvent(N,T){const x=this.F(N);x?.win&&(T.type==="mouseDown"||T.type==="mouseUp")&&x.win.webContents.sendInputEvent(T)}async profileRenderer(N,T,x){const X=this.F(N);if(!X||!X.win)throw new Error;return await new R.$G7b(X.win,T,this.h).inspect(x)}async windowsGetStringRegKey(N,T,x,X){if(!b.$j)return;const ce=await new Promise((re,ae)=>{Q(["@vscode/windows-registry"],re,ae)});try{return ce.GetStringRegKey(T,x,X)}catch{return}}D(N,T){return this.F(N)??this.G(N)??this.F(T)}F(N){if(typeof N=="number")return this.a.getWindowById(N)}G(N){if(typeof N=="number")return this.b.getWindowById(N)}H(N){let T=this.r.invokeFunction(t.$l7b);return T||(T=this.D(N)),T}};e.$I7b=I,ve([C.$hh],I.prototype,"C",null),e.$I7b=I=ve([te(0,t.$j7b),te(1,k.$i7b),te(2,d.$46b),te(3,c.$L6b),te(4,h.$J6b),te(5,i.$0i),te(6,o.$pj),te(7,r.$X6b),te(8,l.$b7b),te(9,E.$Oh)],I)}),define(ne[299],se([0,1,15,28,8,22,33,2,13,4,7,107,36,180,91,132,52,24,6,70,79,25,80,34,60,69,29]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$,d,h,E,c,i,o,r,t,n){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$J7b=void 0;const g="issue.processExplorerWindowState";let A=class{static{l=this}static{this.a="#1E1E1E"}constructor(I,L,N,T,x,X,ce,re,ae,Z,K){this.g=I,this.h=L,this.i=N,this.j=T,this.k=x,this.l=X,this.m=ce,this.n=re,this.o=ae,this.p=Z,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){y.$yT.on("vscode:listProcesses",async I=>{const L=[];try{L.push({name:(0,f.localize)(0,null),rootProcess:await(0,b.$Fr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(T=>{(0,v.$rm)(T)?L.push({name:T.hostName,rootProcess:T}):T.processes&&L.push({name:T.hostName,rootProcess:T.processes})})}catch(N){this.i.error(`Listing processes failed: ${N}`)}this.t(I,"vscode:listProcessesResponse",L)}),y.$yT.on("vscode:workbenchCommand",(I,L)=>{const{id:N,from:T,args:x}=L;let X;switch(T){case"processExplorer":X=this.f;break;default:throw new Error(`Unexpected command source: ${T}`)}X?.webContents.send("vscode:runAction",{id:N,from:T,args:x})}),y.$yT.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),y.$yT.on("vscode:pidToNameRequest",async I=>{const L=await this.k.getMainDiagnostics(),N=[];for(const T of L.windows)N.push([T.pid,`window [${T.id}] (${T.title})`]);for(const{pid:T,name:x}of r.$q7b.getAll())N.push([T,x]);this.t(I,"vscode:pidToNameResponse",N)})}async openReporter(I){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const L=new S.$Qc,N=L.add(this.n.createIPCObjectUrl()),T=this.v(this.c,700,800);this.b=this.u(T,N,{backgroundColor:I.styles.backgroundColor,title:(0,f.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),N.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:E.default}),this.b.loadURL(u.$cg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,L.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,L.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(I){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const L=new S.$Qc,N=L.add(this.n.createIPCObjectUrl()),T=this.p.getItem(g,void 0),x=R(T)?T:this.v(this.f,800,500);this.d=this.u(x,N,{backgroundColor:I.styles.backgroundColor,title:(0,f.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),N.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:E.default}),this.d.loadURL(u.$cg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,L.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,L.dispose())});const X=()=>{if(!this.d)return;const ce=this.d.getSize(),re=this.d.getPosition();if(!ce||!re)return;const ae={width:ce[0],height:ce[1],x:re[0],y:re[1]};this.p.setItem(g,ae)};this.d.on("moved",X),this.d.on("resized",X)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await P.contentTracing.stopRecording(`${(0,C.$6f)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null,I),buttons:[(0,f.localize)(5,null)]},P.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,L)}async $getSystemInfo(){const[I,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,L)}async $getPerformanceInfo(){try{const[I,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,L)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,f.localize)(6,null),buttons:[(0,f.localize)(7,null),(0,f.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,f.localize)(9,null),buttons:[(0,f.localize)(10,null),(0,f.localize)(11,null)]},this.b);return I===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const I=this.q.getWindowById(this.c.id);if(!I)throw new Error("Window not found");return I}async $getIssueReporterUri(I){const L=this.issueReporterWindowCheck(),N=`vscode:triggerIssueUriRequestHandlerResponse${L.id}`;return s.Promises.withAsyncBody(async(T,x)=>{const X=new M.$Xd;L.sendWhenReady("vscode:triggerIssueUriRequestHandler",X.token,{replyChannel:N,extensionId:I}),y.$yT.once(N,(ce,re)=>{T(m.URI.parse(re))});try{await(0,s.$Ug)(5e3),X.cancel(),x(new Error("Timed out waiting for issue reporter URI"))}finally{y.$yT.removeHandler(N)}})}async $getIssueReporterData(I){const L=this.issueReporterWindowCheck(),N=`vscode:triggerIssueDataProviderResponse${L.id}`;return s.Promises.withAsyncBody(async T=>{const x=new M.$Xd;L.sendWhenReady("vscode:triggerIssueDataProvider",x.token,{replyChannel:N,extensionId:I}),y.$yT.once(N,(X,ce)=>{T(ce)});try{await(0,s.$Ug)(5e3),x.cancel(),T("Error: Extension timed out waiting for issue reporter data")}finally{y.$yT.removeHandler(N)}})}async $getIssueReporterTemplate(I){const L=this.issueReporterWindowCheck(),N=`vscode:triggerIssueDataTemplateResponse${L.id}`;return s.Promises.withAsyncBody(async T=>{const x=new M.$Xd;L.sendWhenReady("vscode:triggerIssueDataTemplate",x.token,{replyChannel:N,extensionId:I}),y.$yT.once(N,(X,ce)=>{T(ce)});try{await(0,s.$Ug)(5e3),x.cancel(),T("Error: Extension timed out waiting for issue reporter template")}finally{y.$yT.removeHandler(N)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,L,...N){I.sender.isDestroyed()||I.sender.send(L,...N)}u(I,L,N,T){const x=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:N.title,backgroundColor:N.backgroundColor||l.a,webPreferences:{preload:u.$cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${L.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.$qC)(N.zoomLevel),sandbox:!0},alwaysOnTop:N.alwaysOnTop,experimentalDarkMode:!0});return x.setMenuBarVisibility(!1),x}v(I,L,N){let T;const x=P.screen.getAllDisplays();if(x.length===1)T=x[0];else{if(a.$k){const re=P.screen.getCursorScreenPoint();T=P.screen.getDisplayNearestPoint(re)}!T&&I&&(T=P.screen.getDisplayMatching(I.getBounds())),T||(T=P.screen.getPrimaryDisplay()||x[0])}const X=T.bounds,ce={width:L,height:N,x:X.x+X.width/2-L/2,y:X.y+X.height/2-N/2};return X.width>0&&X.height>0&&(ce.x<X.x&&(ce.x=X.x),ce.y<X.y&&(ce.y=X.y),ce.x>X.x+X.width&&(ce.x=X.x),ce.y>X.y+X.height&&(ce.y=X.y),ce.width>X.width&&(ce.width=X.width),ce.height>X.height&&(ce.height=X.height)),ce}};e.$J7b=A,e.$J7b=A=l=ve([te(1,$.$J6b),te(2,d.$0i),te(3,v.$qm),te(4,w.$t7b),te(5,p.$46b),te(6,h.$H7b),te(7,i.$66b),te(8,c.$pj),te(9,o.$FN),te(10,n.$j7b)],A);function R(k){return typeof k!="object"||k===null?!1:"x"in k&&"y"in k&&"width"in k&&"height"in k}}),define(ne[300],se([0,1,22,18,24,20,6,70,25,50,26,48,100]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$7b=void 0;let f=class extends y.$97b{constructor(w,p,$,d,h,E,c,i){super(w,p,d,h,E,i),this.e=$,this.u=c}s(w){return(0,y.$87b)(`linux-${process.arch}`,w,this.k)}t(w){this.a&&(this.d(b.$xU.CheckingForUpdates(w)),this.i.request({url:this.a},P.CancellationToken.None).then(a.$2o).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(b.$xU.Idle(1))):this.d(b.$xU.AvailableForDownload(p))}).then(void 0,p=>{this.j.error(p),this.e.publicLog2("update:notAvailable",{explicit:!!w});const $=w?p.message||p:void 0;this.d(b.$xU.Idle(1,$))}))}async o(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.u.openExternal(void 0,w.update.url),this.d(b.$xU.Idle(1))}};e.$$7b=f,e.$$7b=f=ve([te(0,M.$L6b),te(1,D.$ji),te(2,m.$cl),te(3,s.$J6b),te(4,a.$Vo),te(5,C.$0i),te(6,S.$H7b),te(7,u.$pj)],f)}),define(ne[301],se([0,1,47,45,28,8,22,55,9,7,144,21,18,24,16,20,6,70,25,50,26,48,100]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$,d,h,E,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a8b=void 0;async function o(l,g=1e3){for(;!l();)await(0,M.$Ug)(g)}let r;function t(){return typeof r>"u"&&(r=D.existsSync(u.$ic(u.$lc(process.execPath),"unins000.exe"))?0:1),r}let n=class extends i.$97b{get cachePath(){const g=u.$ic((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return b.Promises.mkdir(g,{recursive:!0}).then(()=>g)}constructor(g,A,R,k,I,L,N,T,x){super(g,A,k,I,L,x),this.u=R,this.v=N,this.w=T,g.setRelaunchHandler(this)}handleRelaunch(g){return g?.addArgs||g?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(c.$xU.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(g){let A=`win32-${process.arch}`;return t()===1?A+="-archive":this.k.target==="user"&&(A+="-user"),(0,i.$87b)(A,g,this.k)}t(g){this.a&&(this.d(c.$xU.CheckingForUpdates(g)),this.i.request({url:this.a},C.CancellationToken.None).then(h.$2o).then(A=>{const R=t();return!A||!A.url||!A.version||!A.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!g}),this.d(c.$xU.Idle(R)),Promise.resolve(null)):R===1?(this.d(c.$xU.AvailableForDownload(A)),Promise.resolve(null)):(this.d(c.$xU.Downloading(A)),this.C(A.version).then(()=>this.B(A.version).then(k=>b.Promises.exists(k).then(I=>{if(I)return Promise.resolve(k);const L=A.url,N=A.hash,T=`${k}.tmp`;return this.i.request({url:L},C.CancellationToken.None).then(x=>this.v.writeFile(a.URI.file(T),x.stream)).then(N?()=>(0,m.$tT)(T,A.hash):()=>{}).then(()=>b.Promises.rename(T,k,!1)).then(()=>k)})).then(k=>{const I=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:k},I?this.k.target==="user"?this.p():this.d(c.$xU.Downloaded(A)):this.d(c.$xU.Ready(A))})))}).then(void 0,A=>{this.j.error(A),this.u.publicLog2("update:notAvailable",{explicit:!!g});const R=g?A.message||A:void 0;this.d(c.$xU.Idle(t(),R))}))}async o(g){g.update.url&&this.w.openExternal(void 0,g.update.url),this.d(c.$xU.Idle(t()))}async B(g){const A=await this.cachePath;return u.$ic(A,`CodeSetup-${this.k.quality}-${g}.exe`)}async C(g=null){const A=g?L=>!new RegExp(`${this.k.quality}-${g}\\.exe$`).test(L):()=>!0,R=await this.cachePath,I=(await b.Promises.readdir(R)).filter(A).map(async L=>{try{await b.Promises.unlink(u.$ic(R,L))}catch{}});await Promise.all(I)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const g=this.state.update;this.d(c.$xU.Updating(g));const A=await this.cachePath;this.e.updateFilePath=u.$ic(A,`CodeSetup-${this.k.quality}-${g.version}.flag`),await b.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(c.$xU.Idle(t()))});const k=`${this.k.win32MutexName}-ready`,I=await new Promise((L,N)=>{Q(["@vscode/windows-mutex"],L,N)});o(()=>I.isActive(k)).then(()=>this.d(c.$xU.Ready(g)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?D.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return t()}async _applySpecificUpdate(g){if(this.state.type!=="idle")return;const A=this.g.getValue("update.enableWindowsBackgroundUpdates"),R={version:"unknown",productVersion:"unknown"};this.d(c.$xU.Downloading(R)),this.e={packagePath:g},A?this.k.target==="user"?this.p():this.d(c.$xU.Downloaded(R)):this.d(c.$xU.Ready(R))}};e.$a8b=n,ve([S.$hh],n.prototype,"cachePath",null),e.$a8b=n=ve([te(0,w.$L6b),te(1,y.$ji),te(2,E.$cl),te(3,f.$J6b),te(4,h.$Vo),te(5,p.$0i),te(6,v.$$j),te(7,$.$H7b),te(8,d.$pj)],n)}),define(ne[133],se([0,1,15,8,22,49,3,2,13,66,4,7,190,64,18,52,24,62,16,20,6,25,80,252,82,26,102,68,69,29,30,54,128,136,39,34,53,67,23,5]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$,d,h,E,c,i,o,r,t,n,l,g,A,R,k,I,L,N,T,x,X,ce,re){"use strict";var ae;Object.defineProperty(e,"__esModule",{value:!0}),e.$g7b=e.$f7b=void 0;var Z;(function(z){z[z.NONE=0]="NONE",z[z.NAVIGATING=1]="NAVIGATING",z[z.READY=2]="READY"})(Z||(Z={}));class K extends S.$Rc{setRepresentedFilename(W){m.$k?this.a()?.setRepresentedFilename(W):this.b=W}getRepresentedFilename(){return m.$k?this.a()?.getRepresentedFilename():this.b}setDocumentEdited(W){m.$k&&this.a()?.setDocumentEdited(W),this.c=W}isDocumentEdited(){return m.$k?!!this.a()?.isDocumentEdited():!!this.c}focus(W){m.$k&&W?.force&&P.app.focus({steal:!0});const V=this.a();V&&(V.isMinimized()&&V.restore(),V.focus())}}e.$f7b=K;let G=class extends K{static{ae=this}static{this.f="windowControlHeight"}get id(){return this.r}get win(){return this.s}a(){return this.s}get lastFocusTime(){return this.u}get backupPath(){return this.w?.backupPath}get openedWorkspace(){return this.w?.workspace}get profile(){if(!this.config)return;const W=this.U.profiles.find(V=>V.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&W?W:this.U.getProfileForWorkspace(this.config.workspace??(0,R.$4h)(this.backupPath,this.isExtensionDevelopmentHost))??this.U.defaultProfile}get remoteAuthority(){return this.w?.remoteAuthority}get config(){return this.w}get isExtensionDevelopmentHost(){return!!this.w?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.w?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.w?.debugId}constructor(W,V,q,Y,oe,J,O,j,F,U,H,B,ie,fe,de,ue,be,me,Ee,Se,je){super(),this.P=V,this.Q=q,this.R=Y,this.S=oe,this.U=J,this.W=O,this.X=j,this.Y=F,this.Z=U,this.$=H,this.ab=B,this.bb=ie,this.db=fe,this.eb=de,this.fb=ue,this.gb=be,this.hb=me,this.ib=Ee,this.jb=Se,this.g=this.B(new C.$Nd),this.onWillLoad=this.g.event,this.h=this.B(new C.$Nd),this.onDidSignalReady=this.h.event,this.j=this.B(new C.$Nd),this.onDidTriggerSystemContextMenu=this.j.event,this.m=this.B(new C.$Nd),this.onDidClose=this.m.event,this.n=this.B(new C.$Nd),this.onDidDestroy=this.n.event,this.u=-1,this.D=void 0,this.F=void 0,this.G=!1,this.H=[],this.I=[],this.J=void 0,this.L=void 0,this.M=this.B(this.hb.createIPCObjectUrl()),this.O=!1,this.kb=0;{const[ke,pe]=this.ub(W.state);this.z=ke,this.P.trace("window#ctor: using window state",ke);const _=this.z.mode===0||this.z.mode===3,le=this.Z.getValue("window"),ge=je.invokeFunction(A.$k7b,this.z,{show:!_,webPreferences:{preload:u.$cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.M.resource.toString()}`],v8CacheOptions:this.R.useCodeCache?"bypassHeatCheck":"none"}});m.$k&&!this.Bb()&&(ge.fullscreenable=!1);const Re=m.$k&&le?.nativeTabs===!0;Re&&(ge.tabbingIdentifier=this.gb.nameShort);const Ce=(0,g.$oC)(this.Z)==="custom";if(Ce&&(ge.titleBarStyle="hidden",m.$k||(ge.frame=!1),(0,g.$pC)(this.Z))){const Ne=this.$.getWindowSplash()?.colorInfo.titleBarBackground??this.$.getBackgroundColor(),Oe=L.$1s.fromHex(Ne).isDarker()?"#FFFFFF":"#000000";ge.titleBarOverlay={height:29,color:Ne,symbolColor:Oe},this.G=!0}if((0,a.mark)("code/willCreateCodeBrowserWindow"),this.s=new P.BrowserWindow(ge),(0,a.mark)("code/didCreateCodeBrowserWindow"),this.r=this.s.id,m.$k&&Ce&&this.s.setSheetOffset(22),Ce&&(m.$j&&(0,g.$pC)(this.Z)||m.$k)){const Ne=this.jb.getItem(ae.f);Ne&&this.updateWindowControls({height:Ne})}m.$j&&Ce&&this.s.hookWindowMessage(278,()=>{const[Oe,He]=this.s.getPosition(),ze=P.screen.getCursorScreenPoint(),ee=ze.x-Oe,he=ze.y-He;return(()=>!(ee>30&&he>=0&&he<=Math.max(this.s.getBounds().height*.15,35)))()||(this.s.setEnabled(!1),this.s.setEnabled(!0),this.j.fire({x:ee,y:he})),0}),(m.$k||m.$j)&&pe&&(!Re||P.BrowserWindow.getAllWindows().length===1)&&[this.z.width,this.z.height,this.z.x,this.z.y].every(Ne=>typeof Ne=="number")&&this.s.setBounds({width:this.z.width,height:this.z.height,x:this.z.x,y:this.z.y}),_&&((0,a.mark)("code/willMaximizeCodeWindow"),this.s.maximize(),this.z.mode===3&&this.xb(!0),this.s.show(),(0,a.mark)("code/didMaximizeCodeWindow")),this.u=Date.now()}this.R.args["open-devtools"]===!0&&this.s.webContents.openDevTools(),this.rb(),this.Fb(),this.lb()}setReady(){for(this.P.trace(`window#load: window reported ready (id: ${this.r})`),this.kb=2;this.H.length;)this.H.pop()(this);this.h.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.H.push(W)})}get isReady(){return this.kb===2}get whenClosedOrLoaded(){return new Promise(W=>{function V(){q.dispose(),Y.dispose(),W()}const q=this.onDidClose(()=>V()),Y=this.onWillLoad(()=>V())})}lb(){this.s.on("unresponsive",()=>this.ob(1)),this.s.webContents.on("render-process-gone",(V,q)=>this.ob(2,{...q})),this.s.webContents.on("did-fail-load",(V,q,Y)=>this.ob(3,{reason:Y,exitCode:q})),this.s.webContents.on("will-prevent-unload",V=>{V.preventDefault()}),this.s.on("closed",()=>{this.m.fire(),this.dispose()}),this.s.webContents.on("did-finish-load",()=>{this.N&&(this.w=this.N,this.N=void 0)}),this.s.on("focus",()=>{this.u=Date.now()}),this.s.on("maximize",V=>{this.w&&(this.w.maximized=!0),P.app.emit("browser-window-maximize",V,this.s)}),this.s.on("unmaximize",V=>{this.w&&(this.w.maximized=!1),P.app.emit("browser-window-unmaximize",V,this.s)}),this.s.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.F?.complete(),this.F=void 0}),this.s.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.F?.complete(),this.F=void 0}),this.B(this.Z.onDidChangeConfiguration(V=>this.rb(V))),this.B(this.ab.onDidDeleteUntitledWorkspace(V=>this.qb(V)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.s.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(V,q)=>{const Y=await this.nb();q({cancel:!1,requestHeaders:Object.assign(V.requestHeaders,Y)})})}nb(){return this.mb||(this.mb=(0,o.$dp)(this.gb.version,this.gb,this.R,this.Z,this.W,this.X,this.db)),this.mb}async ob(W,V){switch(W){case 2:this.P.error(`CodeWindow: renderer process gone (reason: ${V?.reason||"<unknown>"}, code: ${V?.exitCode||"<unknown>"})`);break;case 1:this.P.error("CodeWindow: detected unresponsive");break;case 3:this.P.error(`CodeWindow: failed to load (reason: ${V?.reason||"<unknown>"}, code: ${V?.exitCode||"<unknown>"})`);break}switch(this.db.publicLog2("windowerror",{type:W,reason:V?.reason,code:V?.exitCode}),W){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.fb.kill(1);return}if(this.R.args["enable-smoke-test-driver"]){await this.pb(!1,!1),this.fb.quit();return}if(W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.s&&this.s.webContents&&this.s.webContents.isDevToolsOpened())return;const{response:q,checkboxChecked:Y}=await this.eb.showMessageBox({type:"warning",buttons:[(0,y.localize)(0,null),(0,y.localize)(1,null),(0,y.localize)(2,null)],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),checkboxLabel:this.w?.workspace?(0,y.localize)(5,null):void 0},this.s);if(q!==2){const oe=q===0;await this.pb(oe,Y)}}else if(W===2){let q;V?q=(0,y.localize)(7,null,V.reason,V.exitCode??"<unknown>"):q=(0,y.localize)(6,null);const{response:Y,checkboxChecked:oe}=await this.eb.showMessageBox({type:"warning",buttons:[this.w?.workspace?(0,y.localize)(8,null):(0,y.localize)(9,null),(0,y.localize)(10,null)],message:q,detail:this.w?.workspace?(0,y.localize)(11,null):(0,y.localize)(12,null),checkboxLabel:this.w?.workspace?(0,y.localize)(13,null):void 0},this.s),J=Y===0;await this.pb(J,oe)}break}}async pb(W,V){const q=this.w?.workspace;if(V&&q)try{const Y=this.Y.workspaceStorage(q);await Y.init(),Y.delete("memento/workbench.parts.editor"),await Y.close()}catch(Y){this.P.error(Y)}if(this.n.fire(),this.s?.destroy(),W&&this.w){let Y,oe;(0,R.$Zh)(q)?Y={folderUri:q.uri}:(0,R.$5h)(q)?Y={workspaceUri:q.configPath}:oe=!0,(0,ce.$Nb)(await this.ib.open({context:5,userEnv:this.w.userEnv,cli:{...this.R.args,_:[]},urisToOpen:Y?[Y]:void 0,forceEmpty:oe,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}qb(W){this.w?.workspace?.id===W.id&&(this.w.workspace=void 0)}rb(W){if(!W||W.affectsConfiguration("window.menuBarVisibility")){const V=this.Cb();V!==this.C&&(this.C=V,this.Db(V))}if(!W||W.affectsConfiguration("http.proxy")){let V=(this.Z.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;V?.endsWith("/")&&(V=V.substr(0,V.length-1));const q=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((V||"").indexOf("@")===-1&&(V!==this.J||q!==this.L)){this.J=V,this.L=q;const Y=V||"",oe=q?`${q},<local>`:"<local>";this.P.trace(`Setting proxy to '${Y}', bypassing '${oe}'`),this.s.webContents.session.setProxy({proxyRules:Y,proxyBypassRules:oe,pacScript:""})}}}addTabbedWindow(W){m.$k&&W.win&&this.s.addTabbedWindow(W.win)}load(W,V=Object.create(null)){this.P.trace(`window#load: attempt to load window (id: ${this.r})`),this.isDocumentEdited()&&(!V.isReload||!this.bb.isHotExitEnabled())&&this.setDocumentEdited(!1),V.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.s.setTitle(this.gb.nameLong)),this.sb(W,V),this.kb===0?this.w=W:this.N=W,this.kb=1,this.s.loadURL(u.$cg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.R.isBuilt?"":"-dev"}.html`).toString(!0));const q=this.O;this.O=!0,!this.R.isBuilt&&!this.R.extensionTestsLocationURI&&this.B(new D.$6g(()=>{this.s&&!this.s.isVisible()&&!this.s.isMinimized()&&(this.s.show(),this.focus({force:!0}),this.s.webContents.openDevTools())},1e4)).schedule(),this.g.fire({workspace:W.workspace,reason:V.isReload?3:q?2:1})}sb(W,V){const q=(this.w??this.N)?.userEnv;if(q){const Y=(0,$.$Nl)(q)&&!(0,$.$Nl)(W.userEnv),oe=this.isExtensionDevelopmentHost;(Y||oe)&&(W.userEnv={...q,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),V.disableExtensions!==void 0&&(W["disable-extensions"]=V.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this.s.isMaximized(),W.partsSplash=this.$.getWindowSplash(),(0,a.mark)("code/willOpenNewWindow"),W.perfMarks=(0,a.getMarks)(),this.M.update(W)}async reload(W){const V=Object.assign({},this.w);V.workspace=await this.tb(V),delete V.filesToOpenOrCreate,delete V.filesToDiff,delete V.filesToMerge,delete V.filesToWait,this.isExtensionDevelopmentHost&&W&&(V.verbose=W.verbose,V.debugId=W.debugId,V.extensionEnvironment=W.extensionEnvironment,V["inspect-extensions"]=W["inspect-extensions"],V["inspect-brk-extensions"]=W["inspect-brk-extensions"],V["extensions-dir"]=W["extensions-dir"]),V.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),V.isInitialStartup=!1,V.policiesData=this.S.serialize(),V.continueOn=this.R.continueOn,V.profiles={all:this.U.profiles,profile:this.profile||this.U.defaultProfile,home:this.U.profilesHome},V.logLevel=this.Q.getLogLevel(),V.loggers={window:this.Q.getRegisteredLoggers(this.id),global:this.Q.getRegisteredLoggers()},this.load(V,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async tb(W){if((0,R.$5h)(W.workspace)){const V=W.workspace.configPath;if(V.scheme===u.Schemas.file&&!await this.W.exists(V))return}else if((0,R.$Zh)(W.workspace)){const V=W.workspace.uri;if(V.scheme===u.Schemas.file&&!await this.W.exists(V))return}return W.workspace}serializeWindowState(){if(!this.s)return(0,I.$I6b)();if(this.isFullScreen){let q;try{q=P.screen.getDisplayMatching(this.getBounds())}catch{}const Y=(0,I.$I6b)();return{mode:3,display:q?q.id:void 0,width:this.z.width||Y.width,height:this.z.height||Y.height,x:this.z.x||0,y:this.z.y||0}}const W=Object.create(null);let V;if(!m.$k&&this.s.isMaximized()?V=0:V=1,V===0?W.mode=0:W.mode=1,V===1||V===0){let q;V===1?q=this.getBounds():q=this.s.getNormalBounds(),W.x=q.x,W.y=q.y,W.width=q.width,W.height=q.height}return W}updateWindowControls(W){if(W.height&&this.jb.setItem(ae.f,W.height),m.$j&&this.G)this.s.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0});else if(m.$k&&W.height!==void 0){const V=(W.height-15)/2;V?this.s.setWindowButtonPosition({x:V,y:V}):this.s.setWindowButtonPosition(null)}}ub(W){(0,a.mark)("code/willRestoreCodeWindowState");let V=!1;if(W)try{const q=P.screen.getAllDisplays();V=q.length>1,W=this.vb(W,q)}catch(q){this.P.warn(`Unexpected error validating window state: ${q}
${q.stack}`)}return(0,a.mark)("code/didRestoreCodeWindowState"),[W||(0,I.$I6b)(),V]}vb(W,V){if(this.P.trace(`window#validateWindowState: validating window state on ${V.length} display(s)`,W),typeof W.x!="number"||typeof W.y!="number"||typeof W.width!="number"||typeof W.height!="number"){this.P.trace("window#validateWindowState: unexpected type of state values");return}if(W.width<=0||W.height<=0){this.P.trace("window#validateWindowState: unexpected negative values");return}if(V.length===1){const oe=this.wb(V[0]);if(oe){let J=function(){!W||typeof W.x!="number"||typeof W.y!="number"||!oe||(W.x<oe.x&&(W.x=oe.x),W.y<oe.y&&(W.y=oe.y))};this.P.trace("window#validateWindowState: 1 monitor working area",oe),J(),W.width>oe.width&&(W.width=oe.width),W.height>oe.height&&(W.height=oe.height),W.x>oe.x+oe.width-128&&(W.x=oe.x+oe.width-W.width),W.y>oe.y+oe.height-128&&(W.y=oe.y+oe.height-W.height),J()}return W}if(W.display&&W.mode===3){const oe=V.find(J=>J.id===W.display);if(oe&&typeof oe.bounds?.x=="number"&&typeof oe.bounds?.y=="number"){this.P.trace("window#validateWindowState: restoring fullscreen to previous display");const J=(0,I.$I6b)(3);return J.x=oe.bounds.x,J.y=oe.bounds.y,J}}let q,Y;try{q=P.screen.getDisplayMatching({x:W.x,y:W.y,width:W.width,height:W.height}),Y=this.wb(q)}catch{}if(q&&Y&&W.x+W.width>Y.x&&W.y+W.height>Y.y&&W.x<Y.x+Y.width&&W.y<Y.y+Y.height)return this.P.trace("window#validateWindowState: multi-monitor working area",Y),W}wb(W){if(W.workArea.width>0&&W.workArea.height>0)return W.workArea;if(W.bounds.width>0&&W.bounds.height>0)return W.bounds}getBounds(){const[W,V]=this.s.getPosition(),[q,Y]=this.s.getSize();return{x:W,y:V,width:q,height:Y}}toggleFullScreen(){this.xb(!this.isFullScreen)}xb(W){this.Bb()?this.yb(W):this.Ab(W),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.C&&this.Db(this.C,!1)}get isFullScreen(){if(m.$k&&typeof this.D=="boolean")return this.D;const W=this.s.isFullScreen(),V=this.s.isSimpleFullScreen();return W||V}yb(W){this.s.isSimpleFullScreen()&&this.s.setSimpleFullScreen(!1),this.zb(W)}zb(W){m.$k&&(this.D=W,this.F=new D.$ch,Promise.race([this.F.p,(0,D.$Ug)(1e4)]).finally(()=>{this.D=void 0})),this.s.setFullScreen(W)}Ab(W){this.s.isFullScreen()&&this.zb(!1),this.s.setSimpleFullScreen(W),this.s.webContents.focus()}Bb(){const W=this.Z.getValue("window");return!W||typeof W.nativeFullScreen!="boolean"||W.nativeTabs?!0:W.nativeFullScreen!==!1}isMinimized(){return this.s.isMinimized()}Cb(){let W=(0,g.$nC)(this.Z);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}Db(W,V=!0){m.$k||(W==="toggle"&&V&&this.send("vscode:showInfoMessage",(0,y.localize)(14,null)),W==="hidden"?setTimeout(()=>{this.Eb(W)}):this.Eb(W))}Eb(W){const V=this.isFullScreen;switch(W){case"classic":this.s.setMenuBarVisibility(!V),this.s.autoHideMenuBar=V;break;case"visible":this.s.setMenuBarVisibility(!0),this.s.autoHideMenuBar=!1;break;case"toggle":this.s.setMenuBarVisibility(!1),this.s.autoHideMenuBar=!0;break;case"hidden":this.s.setMenuBarVisibility(!1),this.s.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.$k)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.s.minimize();break;case"None":break;case"Maximize":default:this.s.isMaximized()?this.s.unmaximize():this.s.maximize()}else this.s.isMaximized()?this.s.unmaximize():this.s.maximize()}close(){this.s?.close()}sendWhenReady(W,V,...q){this.isReady?this.send(W,...q):this.ready().then(()=>{V.isCancellationRequested||this.send(W,...q)})}send(W,...V){if(this.s){if(this.s.isDestroyed()||this.s.webContents.isDestroyed()){this.P.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this.s.webContents.send(W,...V)}catch(q){this.P.warn(`Error sending IPC message to channel '${W}' of window ${this.r}: ${(0,M.$Ai)(q)}`)}}}updateTouchBar(W){m.$k&&this.I.forEach((V,q)=>{const Y=W[q];V.segments=this.Hb(Y)})}Fb(){if(m.$k){for(let W=0;W<10;W++){const V=this.Gb();this.I.push(V)}this.s.setTouchBar(new P.TouchBar({items:this.I}))}}Gb(W=[]){const V=this.Hb(W),q=new P.TouchBar.TouchBarSegmentedControl({segments:V,mode:"buttons",segmentStyle:"automatic",change:Y=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:q.segments[Y].id,from:"touchbar"})}});return q}Hb(W=[]){return W.map(q=>{let Y;q.icon&&!n.ThemeIcon.isThemeIcon(q.icon)&&q.icon?.dark?.scheme===u.Schemas.file&&(Y=P.nativeImage.createFromPath(b.URI.revive(q.icon.dark).fsPath),Y.isEmpty()&&(Y=void 0));let oe;return typeof q.title=="string"?oe=q.title:oe=q.title.value,{id:q.id,label:Y?void 0:oe,icon:Y}})}dispose(){super.dispose(),this.Q.deregisterLoggers(this.id),this.s=null}};e.$g7b=G,e.$g7b=G=ae=ve([te(1,E.$0i),te(2,X.$d7b),te(3,p.$J6b),te(4,N.$ln),te(5,x.$R6b),te(6,d.$$j),te(7,r.$V6b),te(8,r.$T6b),te(9,v.$ji),te(10,l.$X6b),te(11,k.$b7b),te(12,f.$36b),te(13,t.$cl),te(14,w.$46b),te(15,h.$L6b),te(16,c.$pj),te(17,i.$66b),te(18,A.$j7b),te(19,T.$FN),te(20,re.$Oh)],G)}),define(ne[302],se([0,1,15,3,24,133]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=void 0;let C=class extends M.$f7b{get win(){return this.g||this.tryClaimWindow(),this.g}a(){return this.win}get lastFocusTime(){return this.j}constructor(u,a){super(),this.m=u,this.n=a,this.id=this.m.id,this.parentId=-1,this.f=this.B(new D.$Nd),this.onDidClose=this.f.event,this.g=null,this.j=Date.now(),this.r()}r(){this.n.args["open-devtools"]===!0&&this.m.openDevTools({mode:"bottom"}),this.tryClaimWindow()}tryClaimWindow(){if(this.g||this.q.isDisposed||this.m.isDestroyed())return;const u=P.BrowserWindow.fromWebContents(this.m);u&&(this.g=u,u.setMenu(null),this.s(u))}s(u){u.on("closed",()=>{this.f.fire(),this.dispose()}),u.on("focus",()=>{this.j=Date.now()})}dispose(){super.dispose(),this.g=null}};e.$h7b=C,e.$h7b=C=ve([te(1,s.$J6b)],C)}),define(ne[303],se([0,1,15,3,13,36,302,5,29]),function(Q,e,P,D,s,M,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F8b=void 0;let a=class{constructor(b){this.b=b,this.a=new Map,this.c()}c(){P.app.on("browser-window-created",(b,y)=>{const f=this.getWindowById(y.id);f&&f.tryClaimWindow()}),M.$yT.handle("vscode:registerAuxiliaryWindow",async(b,y)=>{const f=this.getWindowById(b.sender.id);return f&&(f.parentId=y),b.sender.id})}createWindow(){return this.b.invokeFunction(u.$k7b,void 0,{webPreferences:{preload:s.$cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}registerWindow(b){const y=this.b.createInstance(C.$h7b,b);this.a.set(y.id,y),D.Event.once(y.onDidClose)(()=>this.a.delete(y.id))}getWindowById(b){return this.a.get(b)}getFocusedWindow(){const b=P.BrowserWindow.getFocusedWindow();if(b)return this.getWindowById(b.id)}getLastActiveWindow(){return(0,u.$m7b)(Array.from(this.a.values()))}getWindows(){return Array.from(this.a.values())}};e.$F8b=a,e.$F8b=a=ve([te(0,S.$Oh)],a)}),define(ne[83],se([0,1,15,23,8,3,46,2,13,4,19,7,21,193,5,20,6,82,97,30,54,31,52]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$,d,h,E,c,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$U7b=e.$T7b=void 0,e.$T7b=(0,v.$Ph)("workspacesHistoryMainService");let r=class extends S.$Rc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(n,l,g,A,R){super(),this.f=n,this.g=l,this.h=g,this.j=A,this.m=R,this.c=this.B(new M.$Nd),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new s.$Rg(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let l=[],g=[];for(const R of n)if((0,d.$WU)(R))!this.g.isUntitledWorkspace(R.workspace)&&!this.w(l,R.workspace)&&l.push(R);else if((0,d.$XU)(R))this.y(l,R.folderUri)||l.push(R);else{const k=this.z(g,R.fileUri),I=R.fileUri.scheme===u.Schemas.file&&o.G.indexOf((0,m.$sg)(R.fileUri))>=0;!k&&!I&&(g.push(R),a.$j&&R.fileUri.scheme===u.Schemas.file&&P.app.addRecentDocument(R.fileUri.fsPath))}const A=await this.r({workspaces:l,files:g});l=A.workspaces,g=A.files,l.length>o.a&&(l.length=o.a),g.length>o.a&&(g.length=o.a),await this.t({workspaces:l,files:g}),this.c.fire(),a.$k&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(n){const l=k=>{const I=this.u(k);for(const L of n)if(m.$mg.isEqual(L,I))return!1;return!0},g=await this.getRecentlyOpened(),A=g.workspaces.filter(l),R=g.files.filter(l);(A.length!==g.workspaces.length||R.length!==g.files.length)&&(await this.t({files:R,workspaces:A}),this.c.fire(),a.$k&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:l}=await this.m.showMessageBox({type:"warning",buttons:[(0,f.localize)(0,null),(0,f.localize)(1,null)],message:(0,f.localize)(2,null),detail:(0,f.localize)(3,null),cancelId:1});if(l!==0)return}await this.t({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(n){const l=new c.$zc(R=>m.$mg.getComparisonKey(R));if(n?.workspaces)for(const R of n.workspaces)l.set(this.u(R),R);const g=new c.$zc(R=>m.$mg.getComparisonKey(R));if(n?.files)for(const R of n.files)g.set(this.u(R),R);const A=await this.s();for(const R of A.workspaces){const k=l.get(this.u(R));k?k.label=k.label??R.label:l.set(this.u(R),R)}for(const R of A.files){const k=g.get(this.u(R));k?k.label=k.label??R.label:g.set(this.u(R),R)}return{workspaces:[...l.values()],files:[...g.values()]}}async s(){await this.j.whenReady;let n;const l=this.j.get(o.b,-1);if(typeof l=="string")try{n=JSON.parse(l)}catch(g){this.f.error("Unexpected error parsing opened paths list",g)}return(0,d.$4U)(n,this.f)}async t(n){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,d.$5U)(n)),-1,1)}u(n){return(0,d.$XU)(n)?n.folderUri:(0,d.$YU)(n)?n.fileUri:n.workspace.configPath}w(n,l){return!!n.find(g=>(0,d.$WU)(g)&&g.workspace.id===l.id)}y(n,l){return!!n.find(g=>(0,d.$XU)(g)&&m.$mg.isEqual(g.folderUri,l))}z(n,l){return!!n.find(g=>m.$mg.isEqual(g.fileUri,l))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){a.$j&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!a.$j)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(4,null),description:(0,f.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const l=[];for(const R of P.app.getJumpListSettings().removedItems){const k=R.args;if(k){const I=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(k);I&&l.push(b.URI.parse(I[2]))}}await this.removeRecentlyOpened(l);let g=!1;const A=(0,D.$Gb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(R=>{const k=(0,d.$WU)(R)?R.workspace:R.folderUri,{title:I,description:L}=this.L(k,R.label);let N;return b.URI.isUri(k)?N=`--folder-uri "${k.toString()}"`:(g=!0,N=`--file-uri "${k.configPath.toString()}"`),{type:"task",title:I.substr(0,255),description:L.substr(0,255),program:process.execPath,args:N,iconPath:"explorer.exe",iconIndex:0}}));A.length>0&&n.push({type:"custom",name:g?(0,f.localize)(6,null):(0,f.localize)(7,null),items:A})}n.push({type:"recent"});try{const l=P.app.setJumpList(n);l&&l!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${l}`)}catch(l){this.f.warn("updateWindowsJumpList#setJumpList",l)}}L(n,l){if(l)return{title:(0,C.$Dv)(l).name,description:l};if(b.URI.isUri(n))return{title:(0,m.$sg)(n),description:this.M(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,f.localize)(8,null),description:""};let g=(0,m.$sg)(n.configPath);return g.endsWith(h.$_h)&&(g=g.substr(0,g.length-h.$_h.length-1)),{title:(0,f.localize)(9,null,g),description:this.M(n.configPath)}}M(n){return n.scheme==="file"?(0,C.$vv)(n.fsPath):n.toString()}async N(){if(!a.$k)return;P.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),l=[];let g=0;for(let R=0;R<n.workspaces.length&&g<o.C;R++){const k=this.u(n.workspaces[R]);if(k.scheme===u.Schemas.file){const I=(0,m.$jg)(k);await y.Promises.exists(I)&&(l.push(I),g++)}}const A=[];for(let R=0;R<n.files.length&&g<o.D;R++){const k=this.u(n.files[R]);if(k.scheme===u.Schemas.file){const I=(0,m.$jg)(k);if(o.G.includes((0,m.$sg)(k))||l.includes(I))continue;await y.Promises.exists(I)&&(A.push(I),g++)}}A.reverse().forEach(R=>P.app.addRecentDocument(R)),l.reverse().forEach(R=>P.app.addRecentDocument(R))}};e.$U7b=r,e.$U7b=r=o=ve([te(0,p.$0i),te(1,E.$b7b),te(2,w.$L6b),te(3,$.$V6b),te(4,i.$46b)],r)}),define(ne[304],se([0,1,15,8,22,46,4,7,181,63,18,24,20,6,231,70,25,34,26,48,69,29,83]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$,d,h,E,c,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$V7b=void 0;const r="menu";let t=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(g,A,R,k,I,L,N,T,x,X,ce,re){this.n=g,this.o=A,this.p=R,this.q=k,this.r=I,this.s=L,this.t=N,this.u=T,this.v=x,this.w=X,this.x=ce,this.y=re,this.m=Object.create(null),this.g=new D.$6g(()=>this.F(),0),this.h=new D.$6g(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.$k||(0,E.$oC)(this.o)==="native")&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const g=this.t.getItem(o.a);g&&(g.menus&&(this.k=g.menus),g.keybindings&&(this.l=g.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(L,N,T)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:N?.id})},this.m["workbench.action.newWindow"]=(L,N,T)=>this.p.openEmptyWindow({context:2,contextWindowId:N?.id}),this.m["workbench.action.files.openFileFolder"]=(L,N,T)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(T),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(L,N,T)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(T),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(L,N,T)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(T),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const g=this.x.youTubeUrl;g&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(g,"openYouTubeUrl"));const A=this.x.requestFeatureUrl;A&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(A,"openUserVoiceUrl"));const R=this.x.reportIssueUrl;R&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(R,"openReportIssues"));const k=this.x.licenseUrl;k&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.$w){const L=k.indexOf("?")>0?"&":"?";this.ab(`${k}${L}lang=${C.$w}`,"openLicenseUrl")}else this.ab(k,"openLicenseUrl")});const I=this.x.privacyStatementUrl;I&&k&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(I,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(g=>this.G(g)),this.w.onDidBlurWindow(()=>this.H()),this.w.onDidFocusWindow(()=>this.H())}get C(){const g=this.o.getValue("window.enableMenuBarMnemonics");return typeof g!="boolean"?!0:g}get D(){if(!C.$k)return!1;const g=this.o.getValue("window.nativeTabs");return typeof g!="boolean"?!1:g}updateMenu(g,A){this.k=g.menus,this.l=g.keybindings,this.t.setItem(o.a,g),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(g){C.$k&&(g.oldCount===0&&g.newCount>0||g.oldCount>0&&g.newCount===0)&&(this.d=g.newCount===0,this.E())}H(){if(!C.$k)return;const g=P.BrowserWindow.getFocusedWindow();this.f=!g||!!this.y.getWindowById(g.id),this.E()}I(){const g=P.Menu.getApplicationMenu();if(g&&this.j.push(g),Object.keys(this.k).length===0){this.J(C.$k?new P.Menu:null);return}const A=new P.Menu;let R;if(C.$k){const I=new P.Menu;R=new P.MenuItem({label:this.x.nameShort,submenu:I}),this.K(I),A.append(R)}if(C.$k&&!this.c){this.c=!0;const I=new P.Menu;I.append(new P.MenuItem({label:this.cb(u.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(I)}if(this.M("File")){const I=new P.Menu,L=new P.MenuItem({label:this.cb(u.localize(1,null)),submenu:I});this.O(I,"File"),A.append(L)}if(this.M("Edit")){const I=new P.Menu,L=new P.MenuItem({label:this.cb(u.localize(2,null)),submenu:I});this.O(I,"Edit"),A.append(L)}if(this.M("Selection")){const I=new P.Menu,L=new P.MenuItem({label:this.cb(u.localize(3,null)),submenu:I});this.O(I,"Selection"),A.append(L)}if(this.M("View")){const I=new P.Menu,L=new P.MenuItem({label:this.cb(u.localize(4,null)),submenu:I});this.O(I,"View"),A.append(L)}if(this.M("Go")){const I=new P.Menu,L=new P.MenuItem({label:this.cb(u.localize(5,null)),submenu:I});this.O(I,"Go"),A.append(L)}if(this.M("Run")){const I=new P.Menu,L=new P.MenuItem({label:this.cb(u.localize(6,null)),submenu:I});this.O(I,"Run"),A.append(L)}if(this.M("Terminal")){const I=new P.Menu,L=new P.MenuItem({label:this.cb(u.localize(7,null)),submenu:I});this.O(I,"Terminal"),A.append(L)}let k;if(this.M("Window")){const I=new P.Menu;k=new P.MenuItem({label:this.cb(u.localize(8,null)),submenu:I,role:"window"}),this.U(I)}if(k&&A.append(k),this.M("Help")){const I=new P.Menu,L=new P.MenuItem({label:this.cb(u.localize(9,null)),submenu:I,role:"help"});this.O(I,"Help"),A.append(L)}A.items&&A.items.length>0?this.J(A):this.J(null),this.h.schedule()}J(g){if(P.Menu.setApplicationMenu(g),g)for(const A of this.y.getWindows())A.win?.setMenu(null)}K(g){const A=this.W(u.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),R=this.V();let k;if(this.M("Preferences")){const re=new P.Menu;this.O(re,"Preferences"),k=new P.MenuItem({label:this.cb(u.localize(11,null)),submenu:re})}const I=new P.Menu,L=new P.MenuItem({label:u.localize(12,null),role:"services",submenu:I}),N=new P.MenuItem({label:u.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),T=new P.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new P.MenuItem({label:u.localize(15,null),role:"unhide"}),X=new P.MenuItem(this.$("workbench.action.quit",{label:u.localize(16,null,this.x.nameLong),click:async(re,ae,Z)=>{const K=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.L(Z)&&this.w.quit(void 0)}})),ce=[A];ce.push(...R),k&&ce.push(n(),k),ce.push(n(),L,n(),N,T,x,n(),X),ce.forEach(re=>g.append(re))}async L(g){if(this.p.getWindowCount()===0)return!0;const A=this.o.getValue("window.confirmBeforeClose");if(A==="always"||A==="keyboardOnly"&&this.S(g)){const{response:R}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[u.localize(17,null),u.localize(18,null)],message:u.localize(19,null)});return R===0}return!0}M(g){if(!C.$k&&(0,E.$oC)(this.o)==="custom")return!1;switch(g){case"File":case"Help":if(C.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[g];case"Window":if(C.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[g]}}N(g,A){A.forEach(R=>{if((0,v.$Q7b)(R))g.append(n());else if((0,v.$P7b)(R)){const k=new P.Menu,I=new P.MenuItem({label:this.cb(R.label),submenu:k});this.N(k,R.submenu.items),g.append(I)}else(0,v.$R7b)(R)?g.append(this.Q(R)):(0,v.$S7b)(R)&&(R.id==="workbench.action.showAboutDialog"&&this.P(g),C.$k?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[R.id]?g.append(new P.MenuItem(this.$(R.id,{label:this.cb(R.label),click:this.m[R.id]}))):g.append(this.W(R.label,R.id,!1,R.checked)):g.append(this.W(R.label,R.id,R.enabled!==!1,!!R.checked)):g.append(this.W(R.label,R.id,R.enabled!==!1,!!R.checked)))})}O(g,A){this.k&&this.k[A]&&this.N(g,this.k[A].items)}P(g){const A=this.V();A.length&&(A.forEach(R=>g.append(R)),g.append(n()))}Q(g){const A=S.URI.revive(g.uri),R=g.id,k=R==="openRecentFile"?{fileUri:A}:R==="openRecentWorkspace"?{workspaceUri:A}:{folderUri:A};return new P.MenuItem(this.$(R,{label:g.label,click:async(I,L,N)=>{const T=this.R(N);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[k],forceNewWindow:T,gotoLineMode:!1,remoteAuthority:g.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([A])}},!1))}R(g){return!!(g&&(!C.$k&&(g.ctrlKey||g.shiftKey)||C.$k&&(g.metaKey||g.altKey)))}S(g){return!!(g.triggeredByAccelerator||g.altKey||g.ctrlKey||g.metaKey||g.shiftKey)}T(g,A,R){const k={label:this.cb(g),role:R,enabled:!0};return new P.MenuItem(this.Z(A,k))}U(g){const A=new P.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),R=new P.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),k=new P.MenuItem({label:u.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),I=this.W(u.localize(23,null),"workbench.action.switchWindow"),L=[];this.D&&(L.push(n()),L.push(this.W(u.localize(24,null),"workbench.action.newWindowTab")),L.push(this.T(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.T(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.T(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.T(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[A,R,n(),I,...L,n(),k].forEach(N=>g.append(N))}V(){switch(this.n.state.type){case"idle":return[new P.MenuItem({label:this.cb(u.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.cb(u.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.cb(u.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.cb(u.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(g,A,R,k){const I=this.cb(g),L=typeof A=="function"?A:(ce,re,ae)=>{const Z=ce?ce.userSettingsLabel:null;let K=A;Array.isArray(A)&&(K=this.R(ae)?A[1]:A[0]),Z&&ae.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Z}):this.Y({type:"commandId",commandId:K})},N=typeof R=="boolean"?R:this.p.getWindowCount()>0,T=typeof k=="boolean"?k:!1,x={label:I,click:L,enabled:N};T&&(x.type="checkbox",x.checked=T);let X;return typeof A=="string"?X=A:Array.isArray(A)&&(X=A[0]),C.$k&&(X==="editor.action.clipboardCutAction"?x.role="cut":X==="editor.action.clipboardCopyAction"?x.role="copy":X==="editor.action.clipboardPasteAction"&&(x.role="paste"),X==="undo"?x.click=this.X(L,{inDevTools:ce=>ce.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):X==="redo"?x.click=this.X(L,{inDevTools:ce=>ce.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):X==="editor.action.selectAll"&&(x.click=this.X(L,{inDevTools:ce=>ce.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.Z(X,x))}X(g,A){return(R,k,I)=>{const L=P.BrowserWindow.getFocusedWindow();if(!L)return A.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return A.inDevTools(L.webContents.devToolsWebContents);g(R,k||L,I)}}Y(g){let A=P.BrowserWindow.getFocusedWindow();if(A){const k=this.y.getWindowById(A.id);k&&(A=this.p.getWindowById(k.parentId)?.win??null)}if(!A){const k=this.p.getLastActiveWindow();k?.isMinimized()&&(A=k.win)}const R=A?this.p.getWindowById(A.id):void 0;if(R){if(this.v.trace("menubar#runActionInRenderer",g),C.$k&&!this.q.isBuilt&&!R.isReady&&(g.type==="commandId"&&g.commandId==="workbench.action.toggleDevTools"||g.type!=="commandId"&&g.userSettingsLabel==="alt+cmd+i"))return!1;if(g.type==="commandId"){const k={id:g.commandId,from:"menu"};R.sendWhenReady("vscode:runAction",s.CancellationToken.None,k)}else{const k={userSettingsLabel:g.userSettingsLabel};R.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,k)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",g),!1}Z(g,A){const R=typeof g=="string"?this.l[g]:void 0;if(R?.label){if(R.isNative!==!1)A.accelerator=R.label,A.userSettingsLabel=R.userSettingsLabel;else if(typeof A.label=="string"){const k=A.label.indexOf("[");k>=0?A.label=`${A.label.substr(0,k)} [${R.label}]`:A.label=`${A.label} [${R.label}]`}}else A.accelerator=void 0;return A}$(g,A,R=!A.accelerator){R&&(A=this.Z(g,A));const k=A.click;return A.click=(I,L,N)=>{this.bb(g),k?.(I,L,N)},A}ab(g,A){this.w.openExternal(void 0,g),this.bb(A)}bb(g){this.r.publicLog2("workbenchActionExecuted",{id:g,from:r})}cb(g){return(0,M.$Av)(g,!this.C)}};e.$V7b=t,e.$V7b=t=o=ve([te(0,h.$yU),te(1,m.$ji),te(2,c.$j7b),te(3,b.$J6b),te(4,d.$cl),te(5,i.$T7b),te(6,$.$FN),te(7,y.$L6b),te(8,f.$0i),te(9,w.$H7b),te(10,p.$pj),te(11,a.$i7b)],t);function n(){return new P.MenuItem({type:"separator"})}}),define(ne[305],se([0,1,5,20,6,304]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X7b=e.$W7b=void 0,e.$W7b=(0,P.$Ph)("menubarMainService");let C=class{constructor(u,a,m){this.b=u,this.c=a,this.d=m,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$V7b)}async updateMenubar(u,a){this.d.trace("menubarService#updateMenubar",u),(await this.a).updateMenu(a,u)}};e.$X7b=C,e.$X7b=C=ve([te(0,P.$Oh),te(1,D.$L6b),te(2,s.$0i)],C)}),define(ne[306],se([0,1,15,21,131,28,23,22,3,33,46,2,13,9,66,4,35,19,12,7,191,64,18,52,24,16,5,20,6,79,80,59,34,69,133,29,130,298,30,98,83,54,68,39,53,67,63]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$,d,h,E,c,i,o,r,t,n,l,g,A,R,k,I,L,N,T,x,X,ce,re,ae,Z,K,G,z,W,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l8b=void 0;function q(J){return(0,ce.$5h)(J?.workspace)}function Y(J){return(0,ce.$Zh)(J?.workspace)}let oe=class extends b.$Rc{constructor(O,j,F,U,H,B,ie,fe,de,ue,be,me,Ee,Se,je,ke,pe,_,le,ge){super(),this.m=O,this.n=j,this.r=F,this.s=U,this.t=H,this.u=B,this.w=ie,this.z=fe,this.C=de,this.D=ue,this.F=be,this.G=me,this.H=Ee,this.I=Se,this.J=je,this.L=ke,this.M=pe,this.N=_,this.O=le,this.P=ge,this.a=this.B(new u.$Nd),this.onDidOpenWindow=this.a.event,this.b=this.B(new u.$Nd),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new u.$Nd),this.onDidDestroyWindow=this.c.event,this.f=this.B(new u.$Nd),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new u.$Nd),this.onDidTriggerSystemContextMenu=this.g.event,this.h=new Map,this.j=this.B(new X.$i8b(this,this.u,this.D,this.s,this.G)),this.Q()}Q(){this.B(this.I.onDidEnterWorkspace(O=>this.b.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const j=new b.$Qc;if(j.add(u.Event.any(O.onDidClose,O.onDidDestroy)(()=>j.dispose())),O.config.extensionDevelopmentPath)for(const F of O.config.extensionDevelopmentPath)j.add(this.N.addValidFileRoot(F));O.config.extensionTestsPath&&j.add(this.N.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,j){const F=this.z.args,U=j?.remoteAuthority||void 0,H=!0,B=j?.forceReuseWindow,ie=!B;return this.open({...O,cli:F,forceEmpty:H,forceNewWindow:ie,forceReuseWindow:B,remoteAuthority:U})}openExistingWindow(O,j){O.focus(),this.R(j,[O])}async open(O){this.s.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const j=[],F=[],U=[],H=[],B=[];let ie,fe=0;const de=await this.$(O);this.s.trace("windowsManager#open pathsToOpen",de);for(const Se of de)Y(Se)?O.addMode?j.push(Se):F.push(Se):q(Se)?U.push(Se):Se.fileUri?(ie||(ie={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Se.remoteAuthority}),ie.filesToOpenOrCreate.push(Se)):Se.backupPath?B.push({backupFolder:(0,f.$mc)(Se.backupPath),remoteAuthority:Se.remoteAuthority}):fe++;O.diffMode&&ie&&ie.filesToOpenOrCreate.length>=2&&(ie.filesToDiff=ie.filesToOpenOrCreate.slice(0,2),ie.filesToOpenOrCreate=[]),O.mergeMode&&ie&&ie.filesToOpenOrCreate.length===4&&(ie.filesToMerge=ie.filesToOpenOrCreate.slice(0,4),ie.filesToOpenOrCreate=[],ie.filesToDiff=[]),ie&&O.waitMarkerFileURI&&(ie.filesToWait={paths:(0,C.$Gb)([...ie.filesToDiff,ie.filesToMerge[3],...ie.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(H.push(...this.I.getUntitledWorkspaces()),U.push(...H),B.push(...this.F.getEmptyWindowBackups())):B.length=0;const{windows:ue,filesOpenedInWindow:be}=await this.S(O,U,F,B,fe,ie,j);if(this.s.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${U.length}, foldersToOpen: ${F.length}, emptyToRestore: ${B.length}, emptyToOpen: ${fe})`),ue.length>1)if(be)be.focus();else{const Se=this.j.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let je=!0,ke=!0;if(Se){const pe=ue.filter(_=>this.j.state.lastActiveWindow&&_.backupPath===this.j.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),je=!1,ke=!1)}if(je)for(let pe=ue.length-1;pe>=0;pe--){const _=ue[pe];if(!(_.openedWorkspace&&H.some(le=>_.openedWorkspace&&le.workspace.id===_.openedWorkspace.id)||_.backupPath&&B.some(le=>_.backupPath&&le.backupFolder===(0,f.$mc)(_.backupPath)))){_.focus(),ke=!1;break}}ke&&ue[ue.length-1].focus()}const me=ie&&ie.filesToDiff.length>0,Ee=ie&&ie.filesToMerge.length>0;if(!ue.some(Se=>Se.isExtensionDevelopmentHost)&&!me&&!Ee&&!O.noRecentEntry){const Se=[];for(const je of de)q(je)&&!je.transient?Se.push({label:je.label,workspace:je.workspace,remoteAuthority:je.remoteAuthority}):Y(je)?Se.push({label:je.label,folderUri:je.workspace.uri,remoteAuthority:je.remoteAuthority}):je.fileUri&&Se.push({label:je.label,fileUri:je.fileUri,remoteAuthority:je.remoteAuthority});this.H.addRecentlyOpened(Se)}return this.R(O,ue),ue}R(O,j){const F=O.waitMarkerFileURI;O.context===0&&F&&j.length===1&&j[0]&&(async()=>{await j[0].whenClosedOrLoaded;try{await this.M.del(F)}catch{}})()}async S(O,j,F,U,H,B,ie){const fe=[];let de;function ue(pe,_){fe.push(pe),_&&(de=pe,B=void 0)}let{openFolderInNewWindow:be,openFilesInNewWindow:me}=this.lb(O);if(!O.initialStartup&&ie.length>0){const pe=ie[0].remoteAuthority,_=this.qb(pe);_&&ue(this.X(_,ie.map(le=>le.workspace.uri)))}const Ee=F.length+j.length+U.length;if(B&&Ee===0){const pe=B.filesToOpenOrCreate[0]||B.filesToDiff[0]||B.filesToMerge[3],_=this.getWindows().filter(ge=>B&&(0,$.$Ag)(ge.remoteAuthority,B.remoteAuthority));let le;pe?.fileUri&&!me&&((O.context===4||O.context===0||O.context===1)&&(le=await(0,x.$76b)(_,pe.fileUri,async ge=>ge.configPath.scheme===y.Schemas.file?this.I.resolveLocalWorkspace(ge.configPath):void 0)),le||(le=this.rb(_))),le?(0,ce.$5h)(le.openedWorkspace)?j.push({workspace:le.openedWorkspace,remoteAuthority:le.remoteAuthority}):(0,ce.$Zh)(le.openedWorkspace)?F.push({workspace:le.openedWorkspace,remoteAuthority:le.remoteAuthority}):ue(this.U(O,le,B),!0):ue(await this.mb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Se=(0,C.$Lb)(j,pe=>pe.workspace.id);if(Se.length>0){const pe=(0,C.$Gb)(Se.map(_=>(0,x.$86b)(this.getWindows(),_.workspace.configPath)));if(pe.length>0){const _=pe[0],le=(0,$.$Ag)(B?.remoteAuthority,_.remoteAuthority)?B:void 0;ue(this.U(O,_,le),!!le),be=!0}for(const _ of Se){if(pe.some(Re=>Re.openedWorkspace&&Re.openedWorkspace.id===_.workspace.id))continue;const le=_.remoteAuthority,ge=(0,$.$Ag)(B?.remoteAuthority,le)?B:void 0;ue(await this.Z(O,_,be,ge),!!ge),be=!0}}const je=(0,C.$Lb)(F,pe=>$.$mg.getComparisonKey(pe.workspace.uri));if(je.length>0){const pe=(0,C.$Gb)(je.map(_=>(0,x.$86b)(this.getWindows(),_.workspace.uri)));if(pe.length>0){const _=pe[0],le=(0,$.$Ag)(B?.remoteAuthority,_.remoteAuthority)?B:void 0;ue(this.U(O,_,le),!!le),be=!0}for(const _ of je){if(pe.some(Re=>(0,ce.$Zh)(Re.openedWorkspace)&&$.$mg.isEqual(Re.openedWorkspace.uri,_.workspace.uri)))continue;const le=_.remoteAuthority,ge=(0,$.$Ag)(B?.remoteAuthority,le)?B:void 0;ue(await this.Z(O,_,be,ge),!!ge),be=!0}}const ke=(0,C.$Lb)(U,pe=>pe.backupFolder);if(ke.length>0)for(const pe of ke){const _=pe.remoteAuthority,le=(0,$.$Ag)(B?.remoteAuthority,_)?B:void 0;ue(await this.Y(O,!0,_,le,pe),!!le),be=!0}if(fe.length===0||B){B&&!H&&H++;const pe=B?B.remoteAuthority:O.remoteAuthority;for(let _=0;_<H;_++)ue(await this.Y(O,be,pe,B),!!B),be=!0}return{windows:(0,C.$Lb)(fe),filesOpenedInWindow:de}}U(O,j,F){this.s.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),this.W(j);const U={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToMerge:F?.filesToMerge,filesToWait:F?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return j.sendWhenReady("vscode:openFiles",S.CancellationToken.None,U),j}W(O){let j=O;const F=P.BrowserWindow.getFocusedWindow();if(F&&F.id!==O.id){const U=this.P.getWindowById(F.id);U&&U.parentId===O.id&&(j=U)}j.focus()}X(O,j){this.s.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:j}),O.focus();const F={foldersToAdd:j};return O.sendWhenReady("vscode:addFolders",S.CancellationToken.None,F),O}Y(O,j,F,U,H){this.s.trace("windowsManager#doOpenEmpty",{restore:!!H,remoteAuthority:F,filesToOpen:U,forceNewWindow:j});let B;return!j&&typeof O.contextWindowId=="number"&&(B=this.getWindowById(O.contextWindowId)),this.mb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:F,forceNewWindow:j,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:U,windowToUse:B,emptyWindowBackupInfo:H,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}Z(O,j,F,U,H){return this.s.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:j,filesToOpen:U}),!F&&!H&&typeof O.contextWindowId=="number"&&(H=this.getWindowById(O.contextWindowId)),this.mb({workspace:j.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:j.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:U,windowToUse:H,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async $(O){let j,F=!1,U=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(j=await this.ab(O),F=!0):O.forceEmpty?j=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(j=await this.bb(O.cli),j.length===0&&j.push(Object.create(null)),F=!0):(j=await this.db(),j.length===0&&j.push(Object.create(null)),U=!0),!O.addMode&&F){const H=j.filter(B=>Y(B));if(H.length>1){const B=H[0].remoteAuthority;if(H.every(ie=>(0,$.$Ag)(ie.remoteAuthority,B))){const ie=await this.I.createUntitledWorkspace(H.map(fe=>({uri:fe.workspace.uri})));j.push({workspace:ie,remoteAuthority:B}),j=j.filter(fe=>!Y(fe))}}}if(O.initialStartup&&!U&&this.G.getValue("window")?.restoreWindows==="preserve"){const H=await this.db();j.unshift(...H.filter(B=>q(B)||Y(B)||B.backupPath))}return j}async ab(O){const j={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},F=await Promise.all((0,C.$Gb)(O.urisToOpen||[]).map(async U=>{const H=await this.fb(U,j);if(H)return H.label=U.label,H;const B=this.hb(U);this.L.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:B.scheme===y.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:B.scheme===y.Schemas.file?(0,E.localize)(3,null,(0,m.$uv)(B,{os:w.OS,tildify:this.z})):(0,E.localize)(4,null,B.toString(!0))},P.BrowserWindow.getFocusedWindow()??void 0)}));return(0,C.$Gb)(F)}async bb(O){const j=[],F={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},U=O["folder-uri"];if(U){const ie=await Promise.all(U.map(fe=>{const de=this.cb(fe);if(de)return this.fb({folderUri:de},F)}));j.push(...(0,C.$Gb)(ie))}const H=O["file-uri"];if(H){const ie=await Promise.all(H.map(fe=>{const de=this.cb(fe);if(de)return this.fb((0,ce.$ii)(fe)?{workspaceUri:de}:{fileUri:de},F)}));j.push(...(0,C.$Gb)(ie))}const B=await Promise.all(O._.map(ie=>F.remoteAuthority?this.kb(ie,F):this.ib(ie,F)));return j.push(...(0,C.$Gb)(B)),j}cb(O){try{const j=h.URI.parse(O);if(!j.scheme){this.s.error(`Invalid URI input string, scheme missing: ${O}`);return}return j.path?j:j.with({path:"/"})}catch(j){this.s.error(`Invalid URI input string: ${O}, ${j.message}`)}}async db(){const O=this.eb();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const j=[];O!=="one"&&j.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&j.push(this.j.state.lastActiveWindow);const F=await Promise.all(j.map(async U=>{if(U.workspace){const H=await this.fb({workspaceUri:U.workspace.configPath},{remoteAuthority:U.remoteAuthority,rejectTransientWorkspaces:!0});if(q(H))return H}else if(U.folderUri){const H=await this.fb({folderUri:U.folderUri},{remoteAuthority:U.remoteAuthority});if(Y(H))return H}else if(O!=="folders"&&U.backupPath)return{backupPath:U.backupPath,remoteAuthority:U.remoteAuthority}}));return(0,C.$Gb)(F)}}}eb(){let O;return this.D.wasRestarted?O="all":(O=this.G.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async fb(O,j=Object.create(null)){const F=this.hb(O);return F.scheme===y.Schemas.file?((0,L.$mC)(O)&&(j={...j,forceOpenWorkspaceAsFile:!0}),this.ib(F.fsPath,j)):this.gb(O,j)}gb(O,j){let F=this.hb(O);const U=(0,k.$Uk)(F)||j.remoteAuthority;if(F=(0,$.$Cg)((0,$.$wg)(F)),(0,L.$mC)(O)){if(j.gotoLineMode){const{path:H,line:B,column:ie}=(0,a.$5f)(F.path);return{fileUri:F.with({path:H}),options:{selection:B?{startLineNumber:B,startColumn:ie||1}:void 0},remoteAuthority:U}}return{fileUri:F,remoteAuthority:U}}else if((0,L.$kC)(O))return{workspace:(0,re.$$6b)(F),remoteAuthority:U};return{workspace:(0,re.$_6b)(F),remoteAuthority:U}}hb(O){return(0,L.$kC)(O)?O.workspaceUri:(0,L.$lC)(O)?O.folderUri:O.fileUri}async ib(O,j,F){let U,H;j.gotoLineMode&&({path:O,line:U,column:H}=(0,a.$5f)(O)),O=(0,a.$Zf)((0,f.$gc)(O),(0,p.cwd)());try{const B=await D.Promises.stat(O);if(B.isFile()){if(!j.forceOpenWorkspaceAsFile){const ie=await this.I.resolveLocalWorkspace(h.URI.file(O));if(ie)return ie.transient&&j.rejectTransientWorkspaces?void 0:{workspace:{id:ie.id,configPath:ie.configPath},type:t.FileType.File,exists:!0,remoteAuthority:ie.remoteAuthority,transient:ie.transient}}return{fileUri:h.URI.file(O),type:t.FileType.File,exists:!0,options:{selection:U?{startLineNumber:U,startColumn:H||1}:void 0}}}else{if(B.isDirectory())return{workspace:(0,re.$_6b)(h.URI.file(O),B),type:t.FileType.Directory,exists:!0};if(!w.$j&&O==="/dev/null")return{fileUri:h.URI.file(O),type:t.FileType.File,exists:!0}}}catch(B){if(B.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!F)return this.jb(O,j);const ie=h.URI.file(O);if(this.H.removeRecentlyOpened([ie]),j.ignoreFileNotFound)return{fileUri:ie,type:t.FileType.File,exists:!1}}}async jb(O,j){const F=h.URI.file(O),{response:U,checkboxChecked:H}=await this.L.showMessageBox({type:"warning",buttons:[(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],message:(0,E.localize)(8,null,F.authority),detail:(0,E.localize)(9,null,(0,m.$uv)(F,{os:w.OS,tildify:this.z})),checkboxLabel:(0,E.localize)(10,null,F.authority),cancelId:1});if(U===0){if((0,s.addUNCHostToAllowlist)(F.authority),H){const B={channel:"vscode:configureAllowedUNCHost",args:F.authority};this.sendToFocused(B.channel,B.args),this.sendToOpeningWindow(B.channel,B.args)}return this.ib(O,j,!0)}if(U===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.jb(O,j)}kb(O,j){const F=O.charCodeAt(0),U=j.remoteAuthority;let H,B;j.gotoLineMode&&({path:O,line:H,column:B}=(0,a.$5f)(O)),F!==47&&((0,a.$Yf)(F)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,a.$Rf)(O)),O=`/${O}`);const ie=h.URI.from({scheme:y.Schemas.vscodeRemote,authority:U,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,ce.$ii)(O))return j.forceOpenWorkspaceAsFile?{fileUri:ie,options:{selection:H?{startLineNumber:H,startColumn:B||1}:void 0},remoteAuthority:j.remoteAuthority}:{workspace:(0,re.$$6b)(ie),remoteAuthority:U};if(j.gotoLineMode||f.$fc.basename(O).indexOf(".")!==-1)return{fileUri:ie,options:{selection:H?{startLineNumber:H,startColumn:B||1}:void 0},remoteAuthority:U}}return{workspace:(0,re.$_6b)(ie),remoteAuthority:U}}lb(O){const j=this.G.getValue("window"),F=j?.openFoldersInNewWindow||"default",U=j?.openFilesInNewWindow||"off";let H=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(F==="on"||F==="off")&&(H=F==="on");let B=!1;return O.forceNewWindow||O.forceReuseWindow?B=!!O.forceNewWindow&&!O.forceReuseWindow:(w.$k?O.context===1&&(B=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!O.cli.extensionDevelopmentPath&&(U==="on"||U==="off")&&(B=U==="on")),{openFolderInNewWindow:!!H,openFilesInNewWindow:B}}async openExtensionDevelopmentHostWindow(O,j){const F=(0,x.$96b)(this.getWindows(),O);if(F)return this.D.reload(F,j.cli),F.focus(),[F];let U=j.cli["folder-uri"]||[],H=j.cli["file-uri"]||[],B=j.cli._;if(!B.length&&!U.length&&!H.length&&!j.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,ue=de?.workspace??de?.folderUri;ue&&(h.URI.isUri(ue)?ue.scheme===y.Schemas.file?B=[ue.fsPath]:U=[ue.toString()]:ue.configPath.scheme===y.Schemas.file?B=[(0,$.$jg)(ue.configPath)]:H=[ue.configPath.toString()])}let ie=j.remoteAuthority;for(const de of O)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=h.URI.parse(de),be=(0,k.$Uk)(ue);be&&(ie?(0,$.$Ag)(be,ie)||this.s.error("more than one extension development path authority"):ie=be)}B=B.filter(de=>{const ue=h.URI.file(de);return(0,x.$86b)(this.getWindows(),ue)?!1:(0,$.$Ag)((0,k.$Uk)(ue),ie)}),U=U.filter(de=>{const ue=this.cb(de);return ue&&(0,x.$86b)(this.getWindows(),ue)?!1:ue?(0,$.$Ag)((0,k.$Uk)(ue),ie):!1}),H=H.filter(de=>{const ue=this.cb(de);return ue&&(0,x.$86b)(this.getWindows(),ue)?!1:ue?(0,$.$Ag)((0,k.$Uk)(ue),ie):!1}),j.cli._=B,j.cli["folder-uri"]=U,j.cli["file-uri"]=H;const fe={context:j.context,cli:j.cli,forceNewWindow:!0,forceEmpty:!B.length&&!U.length&&!H.length,userEnv:j.userEnv,noRecentEntry:!0,waitMarkerFileURI:j.waitMarkerFileURI,remoteAuthority:ie,forceProfile:j.forceProfile,forceTempProfile:j.forceTempProfile};return this.open(fe)}async mb(O){const j=this.G.getValue("window"),F=this.getLastActiveWindow(),U=F?.profile??this.C.defaultProfile;let H;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(H=O.windowToUse||F,H&&H.focus());const B={...this.z.args,...O.cli,machineId:this.m,sqmId:this.n,windowId:-1,mainPid:process.pid,appRoot:this.z.appRoot,execPath:process.execPath,codeCachePath:this.z.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,f.$ic)(this.z.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.C.profilesHome,all:this.C.profiles,profile:U},homeDir:this.z.userHome.with({scheme:y.Schemas.file}).fsPath,tmpDir:this.z.tmpDir.with({scheme:y.Schemas.file}).fsPath,userDataDir:this.z.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.r,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.t.getLogLevel(),loggers:{window:[],global:this.t.getRegisteredLoggers()},logsPath:this.z.logsHome.with({scheme:y.Schemas.file}).fsPath,product:A.default,isInitialStartup:O.initialStartup,perfMarks:(0,v.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof j?.zoomLevel=="number"?j.zoomLevel:void 0,autoDetectHighContrast:j?.autoDetectHighContrast??!0,autoDetectColorScheme:j?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.O.getColorScheme(),policiesData:this.w.serialize(),continueOn:this.z.continueOn};if(H){const ie=H.config;!B.extensionDevelopmentPath&&ie?.extensionDevelopmentPath&&(B.extensionDevelopmentPath=ie.extensionDevelopmentPath,B.extensionDevelopmentKind=ie.extensionDevelopmentKind,B["enable-proposed-api"]=ie["enable-proposed-api"],B.verbose=ie.verbose,B["inspect-extensions"]=ie["inspect-extensions"],B["inspect-brk-extensions"]=ie["inspect-brk-extensions"],B.debugId=ie.debugId,B.extensionEnvironment=ie.extensionEnvironment,B["extensions-dir"]=ie["extensions-dir"],B["disable-extensions"]=ie["disable-extensions"]),B.loggers={global:B.loggers.global,window:ie?.loggers.window??B.loggers.window}}else{const ie=this.j.getNewWindowState(B);(0,v.mark)("code/willCreateCodeWindow");const fe=H=this.J.createInstance(N.$g7b,{state:ie,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,v.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(fe),this.h.set(fe.id,fe),this.a.fire(fe),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const de=new b.$Qc;de.add(fe.onDidSignalReady(()=>this.b.fire(fe))),de.add(u.Event.once(fe.onDidClose)(()=>this.pb(fe,de))),de.add(u.Event.once(fe.onDidDestroy)(()=>this.c.fire(fe))),de.add(fe.onDidTriggerSystemContextMenu(({x:be,y:me})=>this.g.fire({window:fe,x:be,y:me})));const ue=(0,d.$Jf)(fe.win?.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.D.reload(fe)),this.D.registerWindow(fe)}return B.windowId=H.id,H.isReady?this.D.unload(H,4).then(async ie=>{ie||await this.nb(H,B,O,U)}):await this.nb(H,B,O,U),H}async nb(O,j,F,U){if(j.extensionDevelopmentPath||((0,ce.$5h)(j.workspace)?j.backupPath=this.F.registerWorkspaceBackup({workspace:j.workspace,remoteAuthority:j.remoteAuthority}):(0,ce.$Zh)(j.workspace)?j.backupPath=this.F.registerFolderBackup({folderUri:j.workspace.uri,remoteAuthority:j.remoteAuthority}):j.backupPath=this.F.registerEmptyWindowBackup({backupFolder:F.emptyWindowBackupInfo?.backupFolder??(0,re.$a7b)().id,remoteAuthority:j.remoteAuthority})),this.C.isEnabled()){const H=j.workspace??(0,ce.$4h)(j.backupPath,!1),B=this.ob(F,H,U),ie=B instanceof Promise?await B:B;j.profiles.profile=ie,j.extensionDevelopmentPath||await this.C.setProfileForWorkspace(H,ie)}O.load(j)}ob(O,j,F){return O.forceProfile?this.C.profiles.find(U=>U.name===O.forceProfile)??this.C.createNamedProfile(O.forceProfile):O.forceTempProfile?this.C.createTransientProfile():this.C.getProfileForWorkspace(j)??F}pb(O,j){this.h.delete(O.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),j.dispose()}getFocusedWindow(){const O=P.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.rb(this.getWindows())}qb(O){return this.rb(this.getWindows().filter(j=>(0,$.$Ag)(j.remoteAuthority,O)))}rb(O){return(0,T.$m7b)(O)}sendToFocused(O,...j){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,S.CancellationToken.None,...j)}sendToOpeningWindow(O,...j){this.B(u.Event.once(this.onDidSignalReadyWindow)(F=>{F.sendWhenReady(O,S.CancellationToken.None,...j)}))}sendToAll(O,j,F){for(const U of this.getWindows())F&&F.indexOf(U.id)>=0||U.sendWhenReady(O,S.CancellationToken.None,j)}getWindows(){return Array.from(this.h.values())}getWindowCount(){return this.h.size}getWindowById(O){return this.h.get(O)}getWindowByWebContents(O){const j=P.BrowserWindow.fromWebContents(O);if(j)return this.getWindowById(j.id)}};e.$l8b=oe,e.$l8b=oe=ve([te(3,g.$0i),te(4,W.$d7b),te(5,I.$FN),te(6,G.$ln),te(7,r.$J6b),te(8,z.$R6b),te(9,l.$L6b),te(10,c.$36b),te(11,i.$ji),te(12,ae.$T7b),te(13,Z.$b7b),te(14,n.$Oh),te(15,o.$46b),te(16,t.$$j),te(17,R.$66b),te(18,K.$X6b),te(19,V.$i7b)],oe)}),define(ne[307],se([0,1,64,29,83,54]),function(Q,e,P,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n8b=void 0;let C=class{constructor(u,a,m,b){this.a=u,this.b=a,this.c=m,this.d=b,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(u,a){const m=this.b.getWindowById(u);if(m)return this.a.enterWorkspace(m,this.b.getWindows(),a)}createUntitledWorkspace(u,a,m){return this.a.createUntitledWorkspace(a,m)}deleteUntitledWorkspace(u,a){return this.a.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(u,a){return this.a.getWorkspaceIdentifier(a)}getRecentlyOpened(u){return this.c.getRecentlyOpened()}addRecentlyOpened(u,a){return this.c.addRecentlyOpened(a)}removeRecentlyOpened(u,a){return this.c.removeRecentlyOpened(a)}clearRecentlyOpened(u){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$n8b=C,e.$n8b=C=ve([te(0,M.$b7b),te(1,D.$j7b),te(2,s.$T7b),te(3,P.$36b)],C)}),define(ne[308],se([0,1,15,131,36,28,17,49,14,33,3,44,46,2,13,9,4,12,7,32,158,42,159,110,290,162,64,283,18,200,91,132,52,116,220,24,62,94,209,293,211,212,213,16,224,93,78,5,92,219,299,284,291,20,6,305,70,25,59,294,95,34,275,82,122,26,251,253,51,48,265,288,300,289,301,127,267,268,269,272,297,29,306,274,30,97,83,307,54,39,233,53,244,50,81,129,277,292,280,8,255,276,228,67,296,271,23,125,295,263,239,72,63,303]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$,d,h,E,c,i,o,r,t,n,l,g,A,R,k,I,L,N,T,x,X,ce,re,ae,Z,K,G,z,W,V,q,Y,oe,J,O,j,F,U,H,B,ie,fe,de,ue,be,me,Ee,Se,je,ke,pe,_,le,ge,Re,Ce,Ne,Oe,He,ze,ee,he,$e,ye,Ae,We,Le,Ue,Ve,Ge,Je,Ye,Xe,it,nt,wt,bt,pt,yt,vt,kt,Et,rt,ht,Pt,St,It,ot,Rt,ft,at,At,Ct,ct,Dt,dt,Ot){"use strict";var lt;Object.defineProperty(e,"__esModule",{value:!0}),e.$G8b=void 0;let ut=class extends f.$Rc{static{lt=this}static{this.a={[v.Schemas.file]:"security.promptForLocalFileProtocolHandling",[v.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Pe,Ie,De,we,Me,Fe,Be,Ke,qe,Te,Qe,Ze){super(),this.g=Pe,this.h=Ie,this.j=De,this.m=we,this.n=Me,this.s=Fe,this.t=Be,this.u=Ke,this.w=qe,this.y=Te,this.z=Qe,this.C=Ze,this.D(),this.F()}D(){const Pe=qe=>qe?.startsWith(`${v.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((qe,Te,Qe,Ze)=>Pe(Ze.requestingUrl)?Qe(Ie.has(Te)):Qe(!1)),P.session.defaultSession.setPermissionCheckHandler((qe,Te,Qe,Ze)=>Pe(Ze.requestingUrl)?Ie.has(Te):!1);const De=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,v.Schemas.vscodeManagedRemoteResource,"devtools"]),we=qe=>{for(let Te=qe;Te;Te=Te.parent)if(Te.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1},Me=qe=>qe.resourceType==="xhr"||we(qe.frame),Fe=qe=>{const Te=qe.frame;if(!Te||!this.b)return!1;const Qe=P.BrowserWindow.getAllWindows();for(const Ze of Qe)if(Te.processId===Ze.webContents.mainFrame.processId)return!0;return!1},Be=(qe,Te)=>{if(qe.path!=="/index.html")return!0;const Qe=Te.frame;if(!Qe||!this.b)return!1;for(const Ze of this.b.getWindows())if(Ze.win&&Qe.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((qe,Te)=>{const Qe=d.URI.parse(qe.url);return Qe.scheme===v.Schemas.vscodeWebview&&!Be(Qe,qe)?(this.m.error("Blocked vscode-webview request",qe.url),Te({cancel:!0})):Qe.scheme===v.Schemas.vscodeFileResource&&!Fe(qe)?(this.m.error("Blocked vscode-file request",qe.url),Te({cancel:!0})):Qe.path.endsWith(".svg")&&!De.has(Qe.scheme)?Te({cancel:!Me(qe)}):Te({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((qe,Te)=>{const Qe=qe.responseHeaders,Ze=Qe["content-type"]||Qe["Content-Type"];if(Ze&&Array.isArray(Ze)){const xe=d.URI.parse(qe.url);if(xe.path.endsWith(".svg")&&De.has(xe.scheme))return Qe["Content-Type"]=["image/svg+xml"],Te({cancel:!1,responseHeaders:Qe});if(!xe.path.endsWith(v.Schemas.vscodeRemoteResource)&&Ze.some(et=>et.toLowerCase().includes("image/svg")))return Te({cancel:!Me(qe)})}return Te({cancel:!1})});const Ke=P.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,w.$ic)(this.s.codeCachePath,"chrome")),p.$j&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,D.disableUNCAccessRestrictions)():(0,D.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,u.setUnexpectedErrorHandler)(De=>this.H(De)),process.on("uncaughtException",De=>{(0,u.$Y)(De)||(0,u.$Z)(De)}),process.on("unhandledRejection",De=>(0,u.$Z)(De)),this.t.onWillShutdown(()=>this.dispose()),(0,E.$zT)(),P.app.on("accessibility-support-changed",(De,we)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",we)}),P.app.on("activate",async(De,we)=>{this.m.trace("app#activate"),we||await this.b?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(De,we)=>{we?.opener?.url.startsWith(`${v.Schemas.vscodeFileResource}://${v.$bg}/`)&&this.c?.registerWindow(we),we.on("will-navigate",Fe=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),we.setWindowOpenHandler(Fe=>Fe.url==="about:blank"?(this.m.trace("webContents#setWindowOpenHandler: Allowing about:blank window to open"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow()}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Fe.url}}`),this.f?.openExternal(void 0,Fe.url),{action:"deny"}))});let Pe=[],Ie;P.app.on("open-file",(De,we)=>{this.m.trace("app#open-file: ",we),De.preventDefault(),Pe.push((0,Ue.$ii)(we)?{workspaceUri:d.URI.file(we)}:{fileUri:d.URI.file(we)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ie=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$yT.handle("vscode:fetchShellEnv",De=>{const we=this.b?.getWindowByWebContents(De.sender);let Me,Fe;return we?.config?(Me=we.config,Fe={...process.env,...we.config.userEnv}):(Me=this.s.args,Fe=process.env),this.X(Me,Fe,!1)}),s.$yT.handle("vscode:writeNlsFile",(De,we,Me)=>{const Fe=this.G([we]);if(!Fe||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Fe,C.$be.fromString(Me))}),s.$yT.handle("vscode:readNlsFile",async(De,...we)=>{const Me=this.G(we);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Me)).value.toString()}),s.$yT.on("vscode:toggleDevTools",De=>De.sender.toggleDevTools()),s.$yT.on("vscode:openDevTools",De=>De.sender.openDevTools()),s.$yT.on("vscode:reloadWindow",De=>De.sender.reload())}G(Pe){let Ie;for(const De of Pe)typeof De=="string"&&(typeof Ie!="string"?Ie=De:Ie=(0,w.$ic)(Ie,De));if(!(typeof Ie!="string"||!(0,w.$hc)(Ie)||!(0,a.$Xf)(Ie,this.s.cachedLanguagesPath,!p.$l)))return d.URI.file(Ie)}H(Pe){if(Pe){const Ie={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.m.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.m.error(Pe.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Pe=this.z.win32AppUserModelId;p.$j&&Pe&&P.app.setAppUserModelId(Pe);try{p.$k&&this.u.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.m.error(Te)}const Ie=new i.$FT;this.t.onWillShutdown(Te=>{Te.reason===2&&Ie.dispose()}),this.m.trace("Resolving machine identifier...");const[De,we]=await Promise.all([(0,ht.$v8b)(this.w,this.m),(0,ht.$w8b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${De}`);const{sharedProcessReady:Me,sharedProcessClient:Fe}=this.P(De,we),Be=await this.Q(De,we,Me);this.B(Be.createInstance(r.$n7b)),this.B(Be.createInstance(kt.$r8b)),Be.invokeFunction(Te=>this.R(Te,Ie,Fe));const Ke=await Be.invokeFunction(Te=>this.I(Te,Ie));this.J(Ie),this.t.phase=2,await Be.invokeFunction(Te=>this.S(Te,Ke)),this.t.phase=3,this.U(),this.B(new rt.$6g(()=>{this.B((0,rt.$0g)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Pe,Ie){const De=this.b=Pe.get(Ae.$j7b),we=Pe.get(He.$mU),Me=this.f=Pe.get(B.$H7b),Fe=Pe.get(I.$46b),Be=this;we.registerHandler({async handleURL(xe,et){return Be.O(De,Fe,we,xe,et)}});const Ke=this.B(new Le.$m8b({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),qe=new c.$xh(xe=>Ke.getActiveClientId().then(et=>xe===et)),Te=new ze.$d8b(qe,this.m),Qe=Ie.getChannel("urlHandler",Te);we.registerHandler(new ze.$c8b(Qe));const Ze=await this.L(De,Fe);return this.B(new he.$e8b(Ze?.urls,we,De,this.s,this.z,this.m)),Ze}J(Pe){const Ie=()=>({statusCode:404,data:"Not found"}),De=new Dt.$U(()=>Pe.getChannel(ct.$D8b,new ct.$E8b));P.protocol.registerBufferProtocol(v.Schemas.vscodeManagedRemoteResource,(we,Me)=>{const Fe=d.URI.parse(we.url);if(!Fe.authority.startsWith("window:"))return Me(Ie());De.value.call(ct.$C8b,[Fe]).then(Be=>Me({...Be,data:Buffer.from(Be.body,"base64")}),Be=>{this.m.warn("error dispatching remote resource call",Be),Me({statusCode:500,data:String(Be)})})})}async L(Pe,Ie){const De=this.s.args["open-url"]?this.s.args._urls||[]:[];De.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",De);const we=global.getOpenUrls()||[];if(we.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",we),De.length+we.length===0)return;const Me=[...De,...we].map(Ke=>{try{return{uri:d.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),Fe=[],Be=[];for(const Ke of Me){if(!Ke)continue;if(await this.M(Ke.uri,Pe,Ie)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}const qe=this.N(Ke.uri);qe?(this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),qe),Fe.push(qe)):(this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),Be.push(Ke))}return{urls:Be,openables:Fe}}async M(Pe,Ie,De){if(Pe.authority!==v.Schemas.file&&Pe.authority!==v.Schemas.vscodeRemote||this.u.getValue(lt.a[Pe.authority])===!1)return!1;const{response:Me,checkboxChecked:Fe}=await De.showMessageBox({type:"warning",buttons:[(0,t.localize)(0,null),(0,t.localize)(1,null)],message:(0,t.localize)(2,null,Pe.authority===v.Schemas.file?(0,y.$uv)(Pe,{os:p.OS,tildify:this.s}):Pe.toString(!0),this.z.nameShort),detail:(0,t.localize)(3,null),checkboxLabel:Pe.authority===v.Schemas.file?(0,t.localize)(4,null):(0,t.localize)(5,null),cancelId:1});if(Me!==0)return!0;if(Fe){const Be={channel:"vscode:disablePromptForProtocolHandling",args:Pe.authority===v.Schemas.file?"local":"remote"};Ie.sendToFocused(Be.channel,Be.args),Ie.sendToOpeningWindow(Be.channel,Be.args)}return!1}N(Pe){if(Pe.path){if(Pe.authority===v.Schemas.file){const Ie=d.URI.file(Pe.fsPath);return(0,Ue.$ii)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Pe.authority===v.Schemas.vscodeRemote){const Ie=Pe.path.indexOf(w.$fc.sep,1);if(Ie!==-1){const De=Pe.path.substring(1,Ie),we=Pe.path.substring(Ie);let Me=Pe.query;const Fe=new URLSearchParams(Pe.query);Fe.get("windowId")==="_blank"&&(Fe.delete("windowId"),Me=Fe.toString());const Be=d.URI.from({scheme:v.Schemas.vscodeRemote,authority:De,path:we,query:Me,fragment:Pe.fragment});return(0,Ue.$ii)(we)?{workspaceUri:Be}:/:[\d]+$/.test(we)?{fileUri:Be}:{folderUri:Be}}}}}async O(Pe,Ie,De,we,Me){if(this.m.trace("app#handleProtocolUrl():",we.toString(!0),Me),we.scheme===this.z.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:d.URI.parse(we.query).path,query:""})),await this.M(we,Pe,Ie))return this.m.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0;let Fe=!1;const Be=new URLSearchParams(we.query);Be.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),Be.delete("windowId"),we=we.with({query:Be.toString()}),Fe=!0):p.$k&&Pe.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),Fe=!0);const Ke=Be.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),Be.delete("continueOn"),we=we.with({query:Be.toString()}),this.s.continueOn=Ke??void 0);const qe=this.N(we);return qe?(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",qe,we.toString(!0)),(0,ft.$Nb)(await Pe.open({context:5,cli:{...this.s.args},urisToOpen:[qe],forceNewWindow:Fe,gotoLineMode:!0}))?.focus(),!0):Fe?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,ft.$Nb)(await Pe.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,fe.$Uk)(we)}))?.ready(),De.open(we,Me)):(this.m.trace("app#handleProtocolUrl(): not handled",we.toString(!0),Me),!1)}P(Pe,Ie){const De=this.B(this.j.createInstance(de.$27b,Pe,Ie)),we=(async()=>{this.m.trace("Main->SharedProcess#connect");const Fe=await De.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$GT(Fe,"main")})();return{sharedProcessReady:(async()=>(await De.whenReady(),we))(),sharedProcessClient:we}}async Q(Pe,Ie,De){const we=new Y.$Nh;switch(process.platform){case"win32":we.set(le.$yU,new V.$Mh(Oe.$a8b));break;case"linux":p.$m?we.set(le.$yU,new V.$Mh(Ne.$_7b,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(le.$yU,new V.$Mh(Ce.$$7b));break;case"darwin":we.set(le.$yU,new V.$Mh(Re.$07b));break}we.set(Ae.$j7b,new V.$Mh(We.$l8b,[Pe,Ie,this.h],!1)),we.set(dt.$i7b,new V.$Mh(Ot.$F8b,void 0,!1));const Me=new I.$56b(this.m,this.z);we.set(I.$46b,Me),we.set(j.$N7b,new V.$Mh(j.$O7b,void 0,!1)),we.set(k.$t7b,new V.$Mh(k.$u7b,void 0,!1)),we.set(R.$qm,c.ProxyChannel.toService((0,c.$vh)(De.then(Te=>Te.getChannel("diagnostics"))))),we.set(oe.$qxb,new V.$Mh(J.$J7b,[this.h])),we.set(L.$gU,new V.$Mh(N.$v7b)),we.set(O.$K7b,new V.$Mh(O.$L7b)),we.set(B.$H7b,new V.$Mh(B.$I7b,void 0,!1)),we.set($e.$f8b,new V.$Mh(ye.$h8b)),we.set(H.$W7b,new V.$Mh(H.$X7b)),we.set(ce.$w7b,new V.$Mh(re.$y7b)),we.set(Ee.$T6b,new V.$Mh(Ee.$U6b)),we.set(Ee.$V6b,new V.$Mh(Ee.$W6b));const Fe=new At.$B8b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),Be=new Ct.$yr(Fe,this.u,this.m,this.n);we.set(at.$_q,Be),p.$j?we.set(ae.$z7b,new V.$Mh(Z.$A7b)):p.$k?we.set(ae.$z7b,new V.$Mh(Z.$B7b)):p.$l&&we.set(ae.$z7b,new V.$Mh(Z.$C7b));const Ke=new l.$o7b(this.s,this.u,this.m,this.w);we.set(n.$36b,Ke);const qe=new Ye.$c7b(this.s,this.m,this.C,Ke,Me);if(we.set(Ye.$b7b,qe),we.set(Ve.$VU,new V.$Mh(Je.$n8b,void 0,!1)),we.set(Ge.$T7b,new V.$Mh(Ge.$U7b,void 0,!1)),we.set(He.$mU,new V.$Mh(ee.$oU,void 0,!1)),(0,_.$uo)(this.z,this.s)){const Te=(0,_.$zo)(this.z,this.u),Qe=(0,c.$vh)(De.then(st=>st.getChannel("telemetryAppender"))),Ze=new ke.$57b(Qe),xe=(0,Se.$ko)((0,M.release)(),(0,M.hostname)(),process.arch,this.z.commit,this.z.version,Pe,Ie,Te),et=(0,_.$Ao)(this.s),tt={appenders:[Ze],commonProperties:xe,piiPaths:et,sendErrorTelemetry:!0};we.set(je.$cl,new V.$Mh(pe.$4q,[tt],!1))}else we.set(je.$cl,_.$oo);return we.set(pt.$xp,new V.$Mh(Pt.$MN,void 0,!0)),we.set(yt.$Bp,new V.$Mh(vt.$q8b,void 0,!0)),we.set(ot.$z8b,new V.$Mh(ot.$A8b,void 0,!0)),await rt.Promises.settled([Ke.initialize(),qe.initialize()]),this.j.createChild(we)}R(Pe,Ie,De){const we=this.B(new f.$Qc),Me=c.ProxyChannel.fromService(Pe.get(j.$N7b),we,{disableMarshalling:!0});this.g.registerChannel("launch",Me);const Fe=c.ProxyChannel.fromService(Pe.get(k.$t7b),we,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Fe);const Be=new it.$o8b(Pe.get(Xe.$ln));Ie.registerChannel("policy",Be),De.then(_e=>_e.registerChannel("policy",Be));const Ke=this.y.getProvider(v.Schemas.file);(0,$.$If)(Ke instanceof W.$dq);const qe=new z.$D7b(Ke,this.m,this.s);Ie.registerChannel(K.$vN,qe),De.then(_e=>_e.registerChannel(K.$vN,qe));const Te=c.ProxyChannel.fromService(Pe.get(nt.$R6b),we);Ie.registerChannel("userDataProfiles",Te),De.then(_e=>_e.registerChannel("userDataProfiles",Te));const Qe=new wt.$Yq(Pe.get(bt.$Vo));De.then(_e=>_e.registerChannel("request",Qe));const Ze=new ge.$67b(Pe.get(le.$yU));Ie.registerChannel("update",Ze);const xe=c.ProxyChannel.fromService(Pe.get(oe.$qxb),we);Ie.registerChannel("issue",xe);const et=c.ProxyChannel.fromService(Pe.get(L.$gU),we);Ie.registerChannel("encryption",et);const tt=c.ProxyChannel.fromService(Pe.get(ue.$3k),we);Ie.registerChannel("sign",tt);const st=c.ProxyChannel.fromService(Pe.get(O.$K7b),we);Ie.registerChannel("keyboardLayout",st),this.f=Pe.get(B.$H7b);const gt=c.ProxyChannel.fromService(this.f,we);Ie.registerChannel("nativeHost",gt),De.then(_e=>_e.registerChannel("nativeHost",gt));const Mt=c.ProxyChannel.fromService(Pe.get(Ve.$VU),we);Ie.registerChannel("workspaces",Mt);const Lt=c.ProxyChannel.fromService(Pe.get(H.$W7b),we);Ie.registerChannel("menubar",Lt);const jt=c.ProxyChannel.fromService(Pe.get(He.$mU),we);Ie.registerChannel("url",jt);const Nt=c.ProxyChannel.fromService(Pe.get($e.$f8b),we);Ie.registerChannel("webview",Nt);const $t=this.B(new me.$37b(this.m,Pe.get(Ee.$T6b)));Ie.registerChannel("storage",$t),De.then(_e=>_e.registerChannel("storage",$t));const Ut=this.B(new Et.$s8b(Pe.get(Ee.$T6b),Pe.get(nt.$R6b),this.m));De.then(_e=>_e.registerChannel("profileStorageListener",Ut));const Ft=c.ProxyChannel.fromService(Pe.get(at.$_q),we);Ie.registerChannel(at.TerminalIpcChannels.LocalPty,Ft);const Wt=c.ProxyChannel.fromService(Pe.get(ae.$z7b),we);Ie.registerChannel("externalTerminal",Wt);const mt=new St.$x8b(Pe.get(It.$d7b));Ie.registerChannel("logger",mt),De.then(_e=>_e.registerChannel("logger",mt));const Tt=new A.$p7b(Pe.get(Ae.$j7b));Ie.registerChannel("extensionhostdebugservice",Tt);const zt=c.ProxyChannel.fromService(Pe.get(ce.$w7b),we);Ie.registerChannel(ce.$x7b,zt);const Bt=c.ProxyChannel.fromService(Pe.get(ot.$z8b),we);Ie.registerChannel(Rt.$y8b,Bt)}async S(Pe,Ie){const De=this.b=Pe.get(Ae.$j7b);this.c=Pe.get(dt.$i7b);const we=(0,x.$Nl)(process.env)?0:4,Me=this.s.args;if(Ie){if(Ie.openables.length>0)return De.open({context:we,cli:Me,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const tt of Ie.urls){const st=new URLSearchParams(tt.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),tt.originalUrl=tt.uri.toString(!0),tt.uri=tt.uri.with({query:st.toString()}),De.open({context:we,cli:Me,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Fe=global.macOpenFiles,Be=Me._.length,Ke=!!Me["folder-uri"],qe=!!Me["file-uri"],Te=Me["skip-add-to-recently-opened"]===!0,Qe=Me.wait&&Me.waitMarkerFilePath?d.URI.file(Me.waitMarkerFilePath):void 0,Ze=Me.remote||void 0,xe=Me.profile,et=Me["profile-temp"];if(!Be&&!Ke&&!qe){if(Me["new-window"]||xe||et)return De.open({context:we,cli:Me,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Te,waitMarkerFileURI:Qe,initialStartup:!0,remoteAuthority:Ze,forceProfile:xe,forceTempProfile:et});if(Fe.length)return De.open({context:1,cli:Me,urisToOpen:Fe.map(tt=>(0,Ue.$ii)(tt)?{workspaceUri:d.URI.file(tt)}:{fileUri:d.URI.file(tt)}),noRecentEntry:Te,waitMarkerFileURI:Qe,initialStartup:!0})}return De.open({context:we,cli:Me,forceNewWindow:Me["new-window"]||!Be&&Me["unity-launch"],diffMode:Me.diff,mergeMode:Me.merge,noRecentEntry:Te,waitMarkerFileURI:Qe,gotoLineMode:Me.goto,initialStartup:!0,remoteAuthority:Ze,forceProfile:xe,forceTempProfile:et})}U(){this.W(),P.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(Pe,Ie)=>{Ie({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.X(this.s.args,process.env,!0),this.Y(),p.$k&&P.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Pe=this.z.win32MutexName;if(p.$j&&Pe)try{const Ie=await new Promise((we,Me)=>{Q(["@vscode/windows-mutex"],we,Me)}),De=new Ie.Mutex(Pe);m.Event.once(this.t.onWillShutdown)(()=>De.release())}catch(Ie){this.m.error(Ie)}}async X(Pe,Ie,De){try{return await(0,X.$Tl)(this.u,this.m,Pe,Ie)}catch(we){const Me=(0,S.$Ai)(we);De?this.b?.sendToFocused("vscode:showResolveShellEnvError",Me):this.m.error(Me)}return{}}async Y(){try{const Ie=(await this.y.readFile(this.s.argvResource)).value.toString(),De=JSON.parse((0,b.$5m)(Ie)),Me=(0,_.$wo)(this.u)>=1;if(De["enable-crash-reporter"]===void 0){const Fe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Me},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.$eg)()}"`,"}"],Be=Ie.substring(0,Ie.length-2).concat(`,
`,Fe.join(`
`));await this.y.writeFile(this.s.argvResource,C.$be.fromString(Be))}else{const Fe=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Me},`);Fe!==Ie&&await this.y.writeFile(this.s.argvResource,C.$be.fromString(Fe))}}catch(Pe){this.m.error(Pe)}}};e.$G8b=ut,e.$G8b=ut=lt=ve([te(2,q.$Oh),te(3,U.$0i),te(4,U.$$i),te(5,T.$J6b),te(6,F.$L6b),te(7,g.$ji),te(8,be.$FN),te(9,G.$$j),te(10,ie.$pj),te(11,nt.$R6b)],ut)}),define(ne[314],se([0,1,15,45,7,23,8,49,14,33,3,46,13,9,66,4,35,27,21,42,99,308,10,18,238,250,24,62,202,16,222,93,78,218,92,20,225,6,79,25,80,278,126,287,50,286,95,249,34,51,68,53,39,234,232,2,40,266,67,227,115,121,270,264]),function(Q,e,P,D,s,M,C,S,u,a,m,b,y,f,v,w,p,$,d,h,E,c,i,o,r,t,n,l,g,A,R,k,I,L,N,T,x,X,ce,re,ae,Z,K,G,z,W,V,q,Y,oe,J,O,j,F,U,H,B,ie,fe,de,ue,be,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ee{main(){try{this.a()}catch(ke){console.error(ke.message),P.app.exit(1)}}async a(){(0,u.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[ke,pe,_,le,ge,Re,Ce,Ne]=this.b();try{try{await this.d(_,Ne,le,ge,Ce)}catch(Oe){throw this.f(_,Ce,Oe),Oe}await ke.invokeFunction(async Oe=>{const He=Oe.get(X.$0i),ze=Oe.get(T.$L6b),ee=Oe.get(A.$$j),he=Oe.get(X.$$i),$e=await this.e(He,_,ze,ke,Ce,!0);return d.Promises.writeFile(_.mainLockfile,String(process.pid)).catch(ye=>{He.warn(`app#startup(): Error writing main lockfile: ${ye.stack}`)}),Re.logger=he.createLogger("main",{name:(0,i.localize)(0,null)}),m.Event.once(ze.onWillShutdown)(ye=>{ee.dispose(),le.dispose(),ye.join("instanceLockfile",d.Promises.unlink(_.mainLockfile).catch(()=>{}))}),ke.createInstance(c.$G8b,$e,pe).startup()})}catch(Oe){ke.invokeFunction(this.i,Oe)}}b(){const ke=new N.$Nh,pe=new H.$Qc;process.once("exit",()=>pe.dispose());const _={_serviceBrand:void 0,...ce.default};ke.set(re.$pj,_);const le=new n.$K6b(this.j(),_),ge=this.c(le);ke.set(n.$J6b,le);const Re=new fe.$e7b((0,X.$lj)(le),le.logsHome);ke.set(fe.$d7b,Re);const Ce=new x.$t4b(Re.getLogLevel()),Ne=pe.add(new de.$NN(Ce,[new X.$ej(Re.getLogLevel())]));ke.set(X.$0i,Ne);const Oe=new R.$Qp(Ne);ke.set(A.$$j,Oe);const He=new k.$dq(Ne);Oe.registerProvider(y.Schemas.file,He);const ze=new ie.$Cr(Oe);ke.set(B.$Ik,ze);const ee=new be.$IN(1,le,Ne,Oe);ke.set(Y.$EN,ee),ke.set(Y.$FN,ee);const he=new O.$S6b(ee,ze,le,Oe,Ne);ke.set(O.$R6b,he),Oe.registerProvider(y.Schemas.vscodeUserData,new me.$R8b(y.Schemas.file,He,y.Schemas.vscodeUserData,he,ze,Ne));const $e=w.$j&&_.win32RegValueName?pe.add(new F.$P8b(Ne,_.win32RegValueName)):le.policyFile?pe.add(new U.$Q8b(le.policyFile,Oe,Ne)):new j.$nn;ke.set(j.$ln,$e);const ye=new r.$Nn(he.defaultProfile.settingsResource,Oe,$e,Ne);return ke.set(o.$ji,ye),ke.set(T.$L6b,new I.$Mh(T.$M6b,void 0,!1)),ke.set(z.$Vo,new I.$Mh(W.$N8b,void 0,!0)),ke.set(J.$X6b,new I.$Mh(J.$Y6b)),ke.set(V.$3k,new I.$Mh(q.$O8b,void 0,!1)),ke.set(K.$av,new I.$Mh(G.$L8b)),ke.set(ae.$66b,new Z.$I8b(le,he,Ne)),[new L.$gq(ke,!0),ge,le,ye,ee,Ce,_,he]}c(ke){const pe={VSCODE_IPC_HOOK:ke.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(_=>{const le=process.env[_];typeof le=="string"&&(pe[_]=le)}),Object.assign(process.env,pe),pe}async d(ke,pe,_,le,ge){await C.Promises.settled([Promise.all([ke.extensionsPath,ke.codeCachePath,ke.logsHome.with({scheme:y.Schemas.file}).fsPath,pe.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,ke.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,ke.localHistoryHome.with({scheme:y.Schemas.file}).fsPath,ke.backupHome].map(Re=>Re?d.Promises.mkdir(Re,{recursive:!0}):void 0)),le.init(),_.initialize()]),pe.init()}async e(ke,pe,_,le,ge,Re){let Ce;try{(0,v.mark)("code/willStartMainServer"),Ce=await(0,E.$Kh)(pe.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),m.Event.once(_.onWillShutdown)(()=>Ce.dispose())}catch(Ne){if(Ne.code!=="EADDRINUSE")throw this.f(pe,ge,Ne),Ne;let Oe;try{Oe=await(0,E.$Lh)(pe.mainIPCHandle,"main")}catch(he){if(!Re||w.$j||he.code!=="ECONNREFUSED")throw he.code==="EPERM"&&this.g((0,i.localize)(1,null,ge.nameShort),(0,i.localize)(2,null),ge),he;try{(0,D.unlinkSync)(pe.mainIPCHandle)}catch($e){throw ke.warn("Could not delete obsolete instance handle",$e),$e}return this.e(ke,pe,_,le,ge,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const he=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw ke.error(he),Oe.dispose(),new Error(he)}let He;!pe.args.wait&&!pe.args.status&&(He=setTimeout(()=>{this.g((0,i.localize)(3,null,ge.nameShort),(0,i.localize)(4,null),ge)},1e4));const ze=h.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),ee=h.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return le.invokeFunction(async()=>{const he=new t.$Jr(oe.$oo,ge),$e=await ee.getMainDiagnostics(),ye=await ee.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ae=await he.getDiagnostics($e,ye);throw console.log(Ae),new u.$_});throw w.$j&&await this.h(ze,ke),ke.trace("Sending env to running instance..."),await ze.start(pe.args,process.env),Oe.dispose(),He&&clearTimeout(He),new u.$_("Sent env to running instance. Terminating...")}if(pe.args.status)throw console.log((0,i.localize)(5,null,ge.nameShort)),new u.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ce}f(ke,pe,_){if(_.code==="EACCES"||_.code==="EPERM"){const le=(0,M.$Gb)([ke.userDataPath,ke.extensionsPath,E.$Gh]).map(ge=>(0,b.$uv)(s.URI.file(ge),{os:w.OS,tildify:ke}));this.g((0,i.localize)(6,null),(0,i.localize)(7,null,(0,S.$Ai)(_),le.join(`
`)),pe)}}g(ke,pe,_){P.dialog.showMessageBoxSync((0,ue.$Iv)({type:"warning",buttons:[(0,i.localize)(8,null)],message:ke,detail:pe},_).options)}async h(ke,pe){if(w.$j){const _=await ke.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",_);try{(await new Promise((le,ge)=>{Q(["windows-foreground-love"],le,ge)})).allowSetForegroundWindow(_)}catch(le){pe.error(le)}}}i(ke,pe){const _=ke.get(X.$0i),le=ke.get(T.$L6b);let ge=0;pe&&(pe.isExpected?pe.message&&_.trace(pe.message):(ge=1,pe.stack?_.error(pe.stack):_.error(`Startup error: ${pe.toString()}`))),le.kill(ge)}j(){const ke=this.k((0,l.$Kl)(process.argv));if(ke.wait&&!ke.waitMarkerFilePath){const pe=(0,g.$H8b)(ke.verbose);pe&&((0,l.$Ml)(process.argv,"--waitMarkerFilePath",pe),ke.waitMarkerFilePath=pe)}return ke}k(ke){if(ke["open-url"]&&(ke._urls=ke._,ke._=[]),!ke.remote){const pe=this.l(ke._,ke.goto);ke._=pe}return ke}l(ke,pe){const _=(0,p.cwd)(),le=ke.map(Ce=>{let Ne=String(Ce),Oe;pe&&(Oe=(0,a.$5f)(Ne),Ne=Oe.path),Ne&&(Ne=this.m(_,Ne));const He=(0,a.$Zf)(Ne,_),ze=(0,f.$mc)(He);return ze&&!(0,a.$Vf)(ze)?null:pe&&Oe?(Oe.path=He,this.n(Oe)):He}),ge=w.$j||w.$k,Re=(0,M.$Lb)(le,Ce=>Ce&&ge?Ce.toLowerCase():Ce||"");return(0,M.$Gb)(Re)}m(ke,pe){return w.$j&&(pe=(0,$.$Ke)(pe,'"')),pe=(0,$.$Ie)((0,$.$Ie)(pe," "),"	"),w.$j&&(pe=(0,f.$jc)(ke,pe),pe=(0,$.$Ke)(pe,".")),pe}n(ke){const pe=[ke.path];return typeof ke.line=="number"&&pe.push(String(ke.line)),typeof ke.column=="number"&&pe.push(String(ke.column)),pe.join(":")}}new Ee().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/98417b150aeb47dd81dc58893789da4b4cb0e095/core/vs/code/electron-main/main.js.map
