/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var $e=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(le){for(var t=[],w=0,O=le.length;w<O;w++)t[w]=$e[le[w]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:jt,setPrototypeOf:zt,isFrozen:ei,getPrototypeOf:ti,getOwnPropertyDescriptor:ii}=Object;let{freeze:it,seal:at,create:ni}=Object,{apply:Nt,construct:Ft}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,w,O){return t.apply(w,O)}),it||(it=function(t){return t}),at||(at=function(t){return t}),Ft||(Ft=function(t,w){return new t(...w)});const si=ot(Array.prototype.forEach),Ht=ot(Array.prototype.pop),$t=ot(Array.prototype.push),At=ot(String.prototype.toLowerCase),Ot=ot(String.prototype.toString),ri=ot(String.prototype.match),ht=ot(String.prototype.replace),oi=ot(String.prototype.indexOf),li=ot(String.prototype.trim),rt=ot(RegExp.prototype.test),pt=ai(TypeError);function ot(le){return function(t){for(var w=arguments.length,O=new Array(w>1?w-1:0),i=1;i<w;i++)O[i-1]=arguments[i];return Nt(le,t,O)}}function ai(le){return function(){for(var t=arguments.length,w=new Array(t),O=0;O<t;O++)w[O]=arguments[O];return Ft(le,w)}}function ze(le,t,w){var O;w=(O=w)!==null&&O!==void 0?O:At,zt&&zt(le,null);let i=t.length;for(;i--;){let q=t[i];if(typeof q=="string"){const p=w(q);p!==q&&(ei(t)||(t[i]=p),q=p)}le[q]=!0}return le}function gt(le){const t=ni(null);for(const[w,O]of jt(le))t[w]=O;return t}function kt(le,t){for(;le!==null;){const O=ii(le,t);if(O){if(O.get)return ot(O.get);if(typeof O.value=="function")return ot(O.value)}le=ti(le)}function w(O){return console.warn("fallback value for",O),null}return w}const Ut=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Lt=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Tt=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),hi=it(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Mt=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),ui=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=it(["#text"]),qt=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Rt=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),_t=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),St=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ci=at(/\{\{[\w\W]*|[\w\W]*\}\}/gm),fi=at(/<%[\w\W]*|[\w\W]*%>/gm),di=at(/\${[\w\W]*}/gm),gi=at(/^data-[\-\w.\u00B7-\uFFFF]/),mi=at(/^aria-[\-\w]+$/),Vt=at(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),bi=at(/^(?:\w+script|data):/i),$i=at(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Qt=at(/^html$/i);var Kt=Object.freeze({__proto__:null,MUSTACHE_EXPR:ci,ERB_EXPR:fi,TMPLIT_EXPR:di,DATA_ATTR:gi,ARIA_ATTR:mi,IS_ALLOWED_URI:Vt,IS_SCRIPT_OR_DATA:bi,ATTR_WHITESPACE:$i,DOCTYPE_NAME:Qt});const pi=()=>typeof window>"u"?null:window,wi=function(t,w){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let O=null;const i="data-tt-policy-suffix";w&&w.hasAttribute(i)&&(O=w.getAttribute(i));const q="dompurify"+(O?"#"+O:"");try{return t.createPolicy(q,{createHTML(p){return p},createScriptURL(p){return p}})}catch{return console.warn("TrustedTypes policy "+q+" could not be created."),null}};function xt(){let le=arguments.length>0&&arguments[0]!==void 0?arguments[0]:pi();const t=Te=>xt(Te);if(t.version="3.0.5",t.removed=[],!le||!le.document||le.document.nodeType!==9)return t.isSupported=!1,t;const w=le.document,O=w.currentScript;let{document:i}=le;const{DocumentFragment:q,HTMLTemplateElement:p,Node:D,Element:c,NodeFilter:f,NamedNodeMap:m=le.NamedNodeMap||le.MozNamedAttrMap,HTMLFormElement:L,DOMParser:n,trustedTypes:o}=le,e=c.prototype,a=kt(e,"cloneNode"),h=kt(e,"nextSibling"),$=kt(e,"childNodes"),s=kt(e,"parentNode");if(typeof p=="function"){const Te=i.createElement("template");Te.content&&Te.content.ownerDocument&&(i=Te.content.ownerDocument)}let u,d="";const{implementation:l,createNodeIterator:r,createDocumentFragment:y,getElementsByTagName:I}=i,{importNode:T}=w;let g={};t.isSupported=typeof jt=="function"&&typeof s=="function"&&l&&l.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:v,ERB_EXPR:z,TMPLIT_EXPR:H,DATA_ATTR:_,ARIA_ATTR:M,IS_SCRIPT_OR_DATA:F,ATTR_WHITESPACE:Z}=Kt;let{IS_ALLOWED_URI:ee}=Kt,ue=null;const oe=ze({},[...Ut,...Lt,...Tt,...Mt,...Wt]);let se=null;const re=ze({},[...qt,...Rt,..._t,...St]);let be=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Se=null,Le=null,Fe=!0,de=!0,ie=!1,ce=!0,Y=!1,V=!1,G=!1,S=!1,Q=!1,b=!1,R=!1,B=!0,N=!1;const A="user-content-";let k=!0,U=!1,C={},j=null;const E=ze({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let P=null;const W=ze({},["audio","video","img","source","image","track"]);let x=null;const te=ze({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),ne="http://www.w3.org/1998/Math/MathML",ge="http://www.w3.org/2000/svg",ve="http://www.w3.org/1999/xhtml";let Ce=ve,Ae=!1,De=null;const Me=ze({},[ne,ge,ve],Ot);let Oe;const _e=["application/xhtml+xml","text/html"],je="text/html";let Re,Ve=null;const J=i.createElement("form"),he=function(fe){return fe instanceof RegExp||fe instanceof Function},we=function(fe){if(!(Ve&&Ve===fe)){if((!fe||typeof fe!="object")&&(fe={}),fe=gt(fe),Oe=_e.indexOf(fe.PARSER_MEDIA_TYPE)===-1?Oe=je:Oe=fe.PARSER_MEDIA_TYPE,Re=Oe==="application/xhtml+xml"?Ot:At,ue="ALLOWED_TAGS"in fe?ze({},fe.ALLOWED_TAGS,Re):oe,se="ALLOWED_ATTR"in fe?ze({},fe.ALLOWED_ATTR,Re):re,De="ALLOWED_NAMESPACES"in fe?ze({},fe.ALLOWED_NAMESPACES,Ot):Me,x="ADD_URI_SAFE_ATTR"in fe?ze(gt(te),fe.ADD_URI_SAFE_ATTR,Re):te,P="ADD_DATA_URI_TAGS"in fe?ze(gt(W),fe.ADD_DATA_URI_TAGS,Re):W,j="FORBID_CONTENTS"in fe?ze({},fe.FORBID_CONTENTS,Re):E,Se="FORBID_TAGS"in fe?ze({},fe.FORBID_TAGS,Re):{},Le="FORBID_ATTR"in fe?ze({},fe.FORBID_ATTR,Re):{},C="USE_PROFILES"in fe?fe.USE_PROFILES:!1,Fe=fe.ALLOW_ARIA_ATTR!==!1,de=fe.ALLOW_DATA_ATTR!==!1,ie=fe.ALLOW_UNKNOWN_PROTOCOLS||!1,ce=fe.ALLOW_SELF_CLOSE_IN_ATTR!==!1,Y=fe.SAFE_FOR_TEMPLATES||!1,V=fe.WHOLE_DOCUMENT||!1,Q=fe.RETURN_DOM||!1,b=fe.RETURN_DOM_FRAGMENT||!1,R=fe.RETURN_TRUSTED_TYPE||!1,S=fe.FORCE_BODY||!1,B=fe.SANITIZE_DOM!==!1,N=fe.SANITIZE_NAMED_PROPS||!1,k=fe.KEEP_CONTENT!==!1,U=fe.IN_PLACE||!1,ee=fe.ALLOWED_URI_REGEXP||Vt,Ce=fe.NAMESPACE||ve,be=fe.CUSTOM_ELEMENT_HANDLING||{},fe.CUSTOM_ELEMENT_HANDLING&&he(fe.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(be.tagNameCheck=fe.CUSTOM_ELEMENT_HANDLING.tagNameCheck),fe.CUSTOM_ELEMENT_HANDLING&&he(fe.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(be.attributeNameCheck=fe.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),fe.CUSTOM_ELEMENT_HANDLING&&typeof fe.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(be.allowCustomizedBuiltInElements=fe.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),Y&&(de=!1),b&&(Q=!0),C&&(ue=ze({},[...Wt]),se=[],C.html===!0&&(ze(ue,Ut),ze(se,qt)),C.svg===!0&&(ze(ue,Lt),ze(se,Rt),ze(se,St)),C.svgFilters===!0&&(ze(ue,Tt),ze(se,Rt),ze(se,St)),C.mathMl===!0&&(ze(ue,Mt),ze(se,_t),ze(se,St))),fe.ADD_TAGS&&(ue===oe&&(ue=gt(ue)),ze(ue,fe.ADD_TAGS,Re)),fe.ADD_ATTR&&(se===re&&(se=gt(se)),ze(se,fe.ADD_ATTR,Re)),fe.ADD_URI_SAFE_ATTR&&ze(x,fe.ADD_URI_SAFE_ATTR,Re),fe.FORBID_CONTENTS&&(j===E&&(j=gt(j)),ze(j,fe.FORBID_CONTENTS,Re)),k&&(ue["#text"]=!0),V&&ze(ue,["html","head","body"]),ue.table&&(ze(ue,["tbody"]),delete Se.tbody),fe.TRUSTED_TYPES_POLICY){if(typeof fe.TRUSTED_TYPES_POLICY.createHTML!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof fe.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');u=fe.TRUSTED_TYPES_POLICY,d=u.createHTML("")}else u===void 0&&(u=wi(o,O)),u!==null&&typeof d=="string"&&(d=u.createHTML(""));it&&it(fe),Ve=fe}},Ee=ze({},["mi","mo","mn","ms","mtext"]),Pe=ze({},["foreignobject","desc","title","annotation-xml"]),Be=ze({},["title","style","font","a","script"]),Ue=ze({},Lt);ze(Ue,Tt),ze(Ue,hi);const Ye=ze({},Mt);ze(Ye,ui);const Ze=function(fe){let ke=s(fe);(!ke||!ke.tagName)&&(ke={namespaceURI:Ce,tagName:"template"});const Ne=At(fe.tagName),qe=At(ke.tagName);return De[fe.namespaceURI]?fe.namespaceURI===ge?ke.namespaceURI===ve?Ne==="svg":ke.namespaceURI===ne?Ne==="svg"&&(qe==="annotation-xml"||Ee[qe]):!!Ue[Ne]:fe.namespaceURI===ne?ke.namespaceURI===ve?Ne==="math":ke.namespaceURI===ge?Ne==="math"&&Pe[qe]:!!Ye[Ne]:fe.namespaceURI===ve?ke.namespaceURI===ge&&!Pe[qe]||ke.namespaceURI===ne&&!Ee[qe]?!1:!Ye[Ne]&&(Be[Ne]||!Ue[Ne]):!!(Oe==="application/xhtml+xml"&&De[fe.namespaceURI]):!1},Qe=function(fe){$t(t.removed,{element:fe});try{fe.parentNode.removeChild(fe)}catch{fe.remove()}},We=function(fe,ke){try{$t(t.removed,{attribute:ke.getAttributeNode(fe),from:ke})}catch{$t(t.removed,{attribute:null,from:ke})}if(ke.removeAttribute(fe),fe==="is"&&!se[fe])if(Q||b)try{Qe(ke)}catch{}else try{ke.setAttribute(fe,"")}catch{}},tt=function(fe){let ke,Ne;if(S)fe="<remove></remove>"+fe;else{const st=ri(fe,/^[\r\n\t ]+/);Ne=st&&st[0]}Oe==="application/xhtml+xml"&&Ce===ve&&(fe='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+fe+"</body></html>");const qe=u?u.createHTML(fe):fe;if(Ce===ve)try{ke=new n().parseFromString(qe,Oe)}catch{}if(!ke||!ke.documentElement){ke=l.createDocument(Ce,"template",null);try{ke.documentElement.innerHTML=Ae?d:qe}catch{}}const et=ke.body||ke.documentElement;return fe&&Ne&&et.insertBefore(i.createTextNode(Ne),et.childNodes[0]||null),Ce===ve?I.call(ke,V?"html":"body")[0]:V?ke.documentElement:et},nt=function(fe){return r.call(fe.ownerDocument||fe,fe,f.SHOW_ELEMENT|f.SHOW_COMMENT|f.SHOW_TEXT,null,!1)},ft=function(fe){return fe instanceof L&&(typeof fe.nodeName!="string"||typeof fe.textContent!="string"||typeof fe.removeChild!="function"||!(fe.attributes instanceof m)||typeof fe.removeAttribute!="function"||typeof fe.setAttribute!="function"||typeof fe.namespaceURI!="string"||typeof fe.insertBefore!="function"||typeof fe.hasChildNodes!="function")},ct=function(fe){return typeof D=="object"?fe instanceof D:fe&&typeof fe=="object"&&typeof fe.nodeType=="number"&&typeof fe.nodeName=="string"},ut=function(fe,ke,Ne){g[fe]&&si(g[fe],qe=>{qe.call(t,ke,Ne,Ve)})},Ct=function(fe){let ke;if(ut("beforeSanitizeElements",fe,null),ft(fe))return Qe(fe),!0;const Ne=Re(fe.nodeName);if(ut("uponSanitizeElement",fe,{tagName:Ne,allowedTags:ue}),fe.hasChildNodes()&&!ct(fe.firstElementChild)&&(!ct(fe.content)||!ct(fe.content.firstElementChild))&&rt(/<[/\w]/g,fe.innerHTML)&&rt(/<[/\w]/g,fe.textContent))return Qe(fe),!0;if(!ue[Ne]||Se[Ne]){if(!Se[Ne]&&wt(Ne)&&(be.tagNameCheck instanceof RegExp&&rt(be.tagNameCheck,Ne)||be.tagNameCheck instanceof Function&&be.tagNameCheck(Ne)))return!1;if(k&&!j[Ne]){const qe=s(fe)||fe.parentNode,et=$(fe)||fe.childNodes;if(et&&qe){const st=et.length;for(let Ke=st-1;Ke>=0;--Ke)qe.insertBefore(a(et[Ke],!0),h(fe))}}return Qe(fe),!0}return fe instanceof c&&!Ze(fe)||(Ne==="noscript"||Ne==="noembed"||Ne==="noframes")&&rt(/<\/no(script|embed|frames)/i,fe.innerHTML)?(Qe(fe),!0):(Y&&fe.nodeType===3&&(ke=fe.textContent,ke=ht(ke,v," "),ke=ht(ke,z," "),ke=ht(ke,H," "),fe.textContent!==ke&&($t(t.removed,{element:fe.cloneNode()}),fe.textContent=ke)),ut("afterSanitizeElements",fe,null),!1)},dt=function(fe,ke,Ne){if(B&&(ke==="id"||ke==="name")&&(Ne in i||Ne in J))return!1;if(!(de&&!Le[ke]&&rt(_,ke))){if(!(Fe&&rt(M,ke))){if(!se[ke]||Le[ke]){if(!(wt(fe)&&(be.tagNameCheck instanceof RegExp&&rt(be.tagNameCheck,fe)||be.tagNameCheck instanceof Function&&be.tagNameCheck(fe))&&(be.attributeNameCheck instanceof RegExp&&rt(be.attributeNameCheck,ke)||be.attributeNameCheck instanceof Function&&be.attributeNameCheck(ke))||ke==="is"&&be.allowCustomizedBuiltInElements&&(be.tagNameCheck instanceof RegExp&&rt(be.tagNameCheck,Ne)||be.tagNameCheck instanceof Function&&be.tagNameCheck(Ne))))return!1}else if(!x[ke]){if(!rt(ee,ht(Ne,Z,""))){if(!((ke==="src"||ke==="xlink:href"||ke==="href")&&fe!=="script"&&oi(Ne,"data:")===0&&P[fe])){if(!(ie&&!rt(F,ht(Ne,Z,"")))){if(Ne)return!1}}}}}}return!0},wt=function(fe){return fe.indexOf("-")>0},vt=function(fe){let ke,Ne,qe,et;ut("beforeSanitizeAttributes",fe,null);const{attributes:st}=fe;if(!st)return;const Ke={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:se};for(et=st.length;et--;){ke=st[et];const{name:lt,namespaceURI:mt}=ke;if(Ne=lt==="value"?ke.value:li(ke.value),qe=Re(lt),Ke.attrName=qe,Ke.attrValue=Ne,Ke.keepAttr=!0,Ke.forceKeepAttr=void 0,ut("uponSanitizeAttribute",fe,Ke),Ne=Ke.attrValue,Ke.forceKeepAttr||(We(lt,fe),!Ke.keepAttr))continue;if(!ce&&rt(/\/>/i,Ne)){We(lt,fe);continue}Y&&(Ne=ht(Ne,v," "),Ne=ht(Ne,z," "),Ne=ht(Ne,H," "));const Dt=Re(fe.nodeName);if(dt(Dt,qe,Ne)){if(N&&(qe==="id"||qe==="name")&&(We(lt,fe),Ne=A+Ne),u&&typeof o=="object"&&typeof o.getAttributeType=="function"&&!mt)switch(o.getAttributeType(Dt,qe)){case"TrustedHTML":{Ne=u.createHTML(Ne);break}case"TrustedScriptURL":{Ne=u.createScriptURL(Ne);break}}try{mt?fe.setAttributeNS(mt,lt,Ne):fe.setAttribute(lt,Ne),Ht(t.removed)}catch{}}}ut("afterSanitizeAttributes",fe,null)},It=function Te(fe){let ke;const Ne=nt(fe);for(ut("beforeSanitizeShadowDOM",fe,null);ke=Ne.nextNode();)ut("uponSanitizeShadowNode",ke,null),!Ct(ke)&&(ke.content instanceof q&&Te(ke.content),vt(ke));ut("afterSanitizeShadowDOM",fe,null)};return t.sanitize=function(Te){let fe=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ke,Ne,qe,et;if(Ae=!Te,Ae&&(Te="<!-->"),typeof Te!="string"&&!ct(Te))if(typeof Te.toString=="function"){if(Te=Te.toString(),typeof Te!="string")throw pt("dirty is not a string, aborting")}else throw pt("toString is not a function");if(!t.isSupported)return Te;if(G||we(fe),t.removed=[],typeof Te=="string"&&(U=!1),U){if(Te.nodeName){const lt=Re(Te.nodeName);if(!ue[lt]||Se[lt])throw pt("root node is forbidden and cannot be sanitized in-place")}}else if(Te instanceof D)ke=tt("<!---->"),Ne=ke.ownerDocument.importNode(Te,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?ke=Ne:ke.appendChild(Ne);else{if(!Q&&!Y&&!V&&Te.indexOf("<")===-1)return u&&R?u.createHTML(Te):Te;if(ke=tt(Te),!ke)return Q?null:R?d:""}ke&&S&&Qe(ke.firstChild);const st=nt(U?Te:ke);for(;qe=st.nextNode();)Ct(qe)||(qe.content instanceof q&&It(qe.content),vt(qe));if(U)return Te;if(Q){if(b)for(et=y.call(ke.ownerDocument);ke.firstChild;)et.appendChild(ke.firstChild);else et=ke;return(se.shadowroot||se.shadowrootmode)&&(et=T.call(w,et,!0)),et}let Ke=V?ke.outerHTML:ke.innerHTML;return V&&ue["!doctype"]&&ke.ownerDocument&&ke.ownerDocument.doctype&&ke.ownerDocument.doctype.name&&rt(Qt,ke.ownerDocument.doctype.name)&&(Ke="<!DOCTYPE "+ke.ownerDocument.doctype.name+`>
`+Ke),Y&&(Ke=ht(Ke,v," "),Ke=ht(Ke,z," "),Ke=ht(Ke,H," ")),u&&R?u.createHTML(Ke):Ke},t.setConfig=function(Te){we(Te),G=!0},t.clearConfig=function(){Ve=null,G=!1},t.isValidAttribute=function(Te,fe,ke){Ve||we({});const Ne=Re(Te),qe=Re(fe);return dt(Ne,qe,ke)},t.addHook=function(Te,fe){typeof fe=="function"&&(g[Te]=g[Te]||[],$t(g[Te],fe))},t.removeHook=function(Te){if(g[Te])return Ht(g[Te])},t.removeHooks=function(Te){g[Te]&&(g[Te]=[])},t.removeAllHooks=function(){g={}},t}var vi=xt();define("vs/base/browser/dompurify/dompurify",function(){return vi}),define($e[40],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kQ=t.$jQ=void 0;class w{constructor(p){this.domNode=p,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(p){const D=O(p);this.a!==D&&(this.a=D,this.domNode.style.maxWidth=this.a)}setWidth(p){const D=O(p);this.b!==D&&(this.b=D,this.domNode.style.width=this.b)}setHeight(p){const D=O(p);this.c!==D&&(this.c=D,this.domNode.style.height=this.c)}setTop(p){const D=O(p);this.d!==D&&(this.d=D,this.domNode.style.top=this.d)}setLeft(p){const D=O(p);this.e!==D&&(this.e=D,this.domNode.style.left=this.e)}setBottom(p){const D=O(p);this.f!==D&&(this.f=D,this.domNode.style.bottom=this.f)}setRight(p){const D=O(p);this.g!==D&&(this.g=D,this.domNode.style.right=this.g)}setPaddingTop(p){const D=O(p);this.h!==D&&(this.h=D,this.domNode.style.paddingTop=this.h)}setPaddingLeft(p){const D=O(p);this.i!==D&&(this.i=D,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(p){const D=O(p);this.j!==D&&(this.j=D,this.domNode.style.paddingBottom=this.j)}setPaddingRight(p){const D=O(p);this.k!==D&&(this.k=D,this.domNode.style.paddingRight=this.k)}setFontFamily(p){this.l!==p&&(this.l=p,this.domNode.style.fontFamily=this.l)}setFontWeight(p){this.m!==p&&(this.m=p,this.domNode.style.fontWeight=this.m)}setFontSize(p){const D=O(p);this.n!==D&&(this.n=D,this.domNode.style.fontSize=this.n)}setFontStyle(p){this.o!==p&&(this.o=p,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(p){this.p!==p&&(this.p=p,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(p){this.q!==p&&(this.q=p,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(p){this.r!==p&&(this.r=p,this.domNode.style.textDecoration=this.r)}setLineHeight(p){const D=O(p);this.s!==D&&(this.s=D,this.domNode.style.lineHeight=this.s)}setLetterSpacing(p){const D=O(p);this.t!==D&&(this.t=D,this.domNode.style.letterSpacing=this.t)}setClassName(p){this.u!==p&&(this.u=p,this.domNode.className=this.u)}toggleClassName(p,D){this.domNode.classList.toggle(p,D),this.u=this.domNode.className}setDisplay(p){this.v!==p&&(this.v=p,this.domNode.style.display=this.v)}setPosition(p){this.w!==p&&(this.w=p,this.domNode.style.position=this.w)}setVisibility(p){this.x!==p&&(this.x=p,this.domNode.style.visibility=this.x)}setColor(p){this.y!==p&&(this.y=p,this.domNode.style.color=this.y)}setBackgroundColor(p){this.z!==p&&(this.z=p,this.domNode.style.backgroundColor=this.z)}setLayerHinting(p){this.A!==p&&(this.A=p,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(p){this.C!==p&&(this.C=p,this.domNode.style.boxShadow=p)}setContain(p){this.B!==p&&(this.B=p,this.domNode.style.contain=this.B)}setAttribute(p,D){this.domNode.setAttribute(p,D)}removeAttribute(p){this.domNode.removeAttribute(p)}appendChild(p){this.domNode.appendChild(p.domNode)}removeChild(p){this.domNode.removeChild(p.domNode)}}t.$jQ=w;function O(q){return typeof q=="number"?`${q}px`:q}function i(q){return new w(q)}t.$kQ=i}),define($e[68],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GO=t.$FO=void 0;let w=!1,O=null;function i(c){if(!c.parent||c.parent===c)return null;try{const f=c.location,m=c.parent.location;if(f.origin!=="null"&&m.origin!=="null"&&f.origin!==m.origin)return w=!0,null}catch{return w=!0,null}return c.parent}class q{static getSameOriginWindowChain(){if(!O){O=[];let f=window,m;do m=i(f),m?O.push({window:f,iframeElement:f.frameElement||null}):O.push({window:f,iframeElement:null}),f=m;while(f)}return O.slice(0)}static hasDifferentOriginAncestor(){return O||this.getSameOriginWindowChain(),w}static getPositionOfChildWindowRelativeToAncestorWindow(f,m){if(!m||f===m)return{top:0,left:0};let L=0,n=0;const o=this.getSameOriginWindowChain();for(const e of o){if(L+=e.window.scrollY,n+=e.window.scrollX,e.window===m||!e.iframeElement)break;const a=e.iframeElement.getBoundingClientRect();L+=a.top,n+=a.left}return{top:L,left:n}}}t.$FO=q;async function p(c,f){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const m=JSON.stringify({parentOrigin:c,salt:f}),n=new TextEncoder().encode(m),o=await crypto.subtle.digest("sha-256",n);return D(o)}t.$GO=p;function D(c){const m=Array.from(new Uint8Array(c)).map(L=>L.toString(16).padStart(2,"0")).join("");return BigInt(`0x${m}`).toString(32).padStart(52,"0")}}),define($e[69],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TQ=t.$SQ=t.$RQ=t.ListDragOverEffect=void 0;var w;(function(q){q[q.Copy=0]="Copy",q[q.Move=1]="Move"})(w||(t.ListDragOverEffect=w={})),t.$RQ={reject(){return{accept:!1}},accept(){return{accept:!0}}};class O extends Error{constructor(p,D){super(`ListError [${p}] ${D}`)}}t.$SQ=O;class i{constructor(){this.c=new WeakMap}getHeight(p){return this.c.get(p)??this.d(p)}setDynamicHeight(p,D){D>0&&this.c.set(p,D)}}t.$TQ=i}),define($e[70],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QQ=void 0;class w{constructor(i){this.a=i}splice(i,q,p){this.a.forEach(D=>D.splice(i,q,p))}}t.$QQ=w}),define($e[41],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pQ=void 0;const w=20;class O{constructor(q,p,D,c,f,m){this.a=Math.round(p),this.b=Math.round(D),this.c=Math.round(q),this.d=c,this.e=f,this.f=m,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new O(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(q){const p=Math.round(q);return this.d!==p?(this.d=p,this.m(),!0):!1}setScrollSize(q){const p=Math.round(q);return this.e!==p?(this.e=p,this.m(),!0):!1}setScrollPosition(q){const p=Math.round(q);return this.f!==p?(this.f=p,this.m(),!0):!1}setScrollbarSize(q){this.a=Math.round(q)}setOppositeScrollbarSize(q){this.b=Math.round(q)}static l(q,p,D,c,f){const m=Math.max(0,D-q),L=Math.max(0,m-2*p),n=c>0&&c>D;if(!n)return{computedAvailableSize:Math.round(m),computedIsNeeded:n,computedSliderSize:Math.round(L),computedSliderRatio:0,computedSliderPosition:0};const o=Math.round(Math.max(w,Math.floor(D*L/c))),e=(L-o)/(c-D),a=f*e;return{computedAvailableSize:Math.round(m),computedIsNeeded:n,computedSliderSize:Math.round(o),computedSliderRatio:e,computedSliderPosition:Math.round(a)}}m(){const q=O.l(this.b,this.c,this.d,this.e,this.f);this.g=q.computedAvailableSize,this.h=q.computedIsNeeded,this.i=q.computedSliderSize,this.j=q.computedSliderRatio,this.k=q.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(q){if(!this.h)return 0;const p=q-this.c-this.i/2;return Math.round(p/this.j)}getDesiredScrollPositionFromOffsetPaged(q){if(!this.h)return 0;const p=q-this.c;let D=this.f;return p<this.k?D-=this.d:D+=this.d,D}getDesiredScrollPositionFromDelta(q){if(!this.h)return 0;const p=this.k+q;return Math.round(p/this.j)}}t.$pQ=O}),define($e[24],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NS=t.$MS=t.$LS=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var w;(function(c){c[c.Hidden=0]="Hidden",c[c.Visible=1]="Visible",c[c.Recurse=2]="Recurse"})(w||(t.TreeVisibility=w={}));var O;(function(c){c[c.Expanded=0]="Expanded",c[c.Collapsed=1]="Collapsed",c[c.PreserveOrExpanded=2]="PreserveOrExpanded",c[c.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(O||(t.ObjectTreeElementCollapseState=O={}));var i;(function(c){c[c.Unknown=0]="Unknown",c[c.Twistie=1]="Twistie",c[c.Element=2]="Element",c[c.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var q;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(q||(t.TreeDragOverBubble=q={})),t.$LS={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(c=!1){return{accept:!0,bubble:0,autoExpand:c}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(c=!1){return{accept:!0,bubble:0,effect:0,autoExpand:c}}};class p extends Error{constructor(f,m){super(`TreeError [${f}] ${m}`)}}t.$MS=p;class D{constructor(f){this.a=f,this.b=new WeakMap}map(f){let m=this.b.get(f);return m||(m=this.a(f),this.b.set(f,m)),m}}t.$NS=D}),define($e[71],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=void 0;function w(a,h,$){const s=O(a,h);if(s!==-1)return a[s]}t.$eb=w;function O(a,h,$=a.length-1){for(let s=$;s>=0;s--){const u=a[s];if(h(u))return s}return-1}t.$fb=O;function i(a,h){const $=q(a,h);return $===-1?void 0:a[$]}t.$gb=i;function q(a,h,$=0,s=a.length){let u=$,d=s;for(;u<d;){const l=Math.floor((u+d)/2);h(a[l])?u=l+1:d=l}return u-1}t.$hb=q;function p(a,h){const $=D(a,h);return $===a.length?void 0:a[$]}t.$ib=p;function D(a,h,$=0,s=a.length){let u=$,d=s;for(;u<d;){const l=Math.floor((u+d)/2);h(a[l])?d=l:u=l+1}return u}t.$jb=D;function c(a,h,$=0,s=a.length){const u=D(a,h,$,s);return u===a.length?-1:u}t.$kb=c;class f{static{this.assertInvariants=!1}constructor(h){this.e=h,this.c=0}findLastMonotonous(h){if(f.assertInvariants){if(this.d){for(const s of this.e)if(this.d(s)&&!h(s))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=h}const $=q(this.e,h,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}t.$lb=f;function m(a,h){if(a.length===0)return;let $=a[0];for(let s=1;s<a.length;s++){const u=a[s];h(u,$)>0&&($=u)}return $}t.$mb=m;function L(a,h){if(a.length===0)return;let $=a[0];for(let s=1;s<a.length;s++){const u=a[s];h(u,$)>=0&&($=u)}return $}t.$nb=L;function n(a,h){return m(a,($,s)=>-h($,s))}t.$ob=n;function o(a,h){if(a.length===0)return-1;let $=0;for(let s=1;s<a.length;s++){const u=a[s];h(u,a[$])>0&&($=s)}return $}t.$pb=o;function e(a,h){for(const $ of a){const s=h($);if(s!==void 0)return s}}t.$qb=e}),define($e[72],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M=t.$L=t.$K=t.$J=void 0;function w(p,D){const c=Object.create(null);for(const f of p){const m=D(f);let L=c[m];L||(L=c[m]=[]),L.push(f)}return c}t.$J=w;function O(p,D){const c=[],f=[];for(const m of p)D.has(m)||c.push(m);for(const m of D)p.has(m)||f.push(m);return{removed:c,added:f}}t.$K=O;function i(p,D){const c=[],f=[];for(const[m,L]of p)D.has(m)||c.push(L);for(const[m,L]of D)p.has(m)||f.push(L);return{removed:c,added:f}}t.$L=i;function q(p,D){const c=new Set;for(const f of D)p.has(f)&&c.add(f);return c}t.$M=q}),define($e[73],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1s=t.$Zs=t.$Ys=t.$Xs=void 0;function w(D,c){const f=Math.pow(10,c);return Math.round(D*f)/f}class O{constructor(c,f,m,L=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=w(Math.max(Math.min(1,L),0),3)}static equals(c,f){return c.r===f.r&&c.g===f.g&&c.b===f.b&&c.a===f.a}}t.$Xs=O;class i{constructor(c,f,m,L){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=w(Math.max(Math.min(1,f),0),3),this.l=w(Math.max(Math.min(1,m),0),3),this.a=w(Math.max(Math.min(1,L),0),3)}static equals(c,f){return c.h===f.h&&c.s===f.s&&c.l===f.l&&c.a===f.a}static fromRGBA(c){const f=c.r/255,m=c.g/255,L=c.b/255,n=c.a,o=Math.max(f,m,L),e=Math.min(f,m,L);let a=0,h=0;const $=(e+o)/2,s=o-e;if(s>0){switch(h=Math.min($<=.5?s/(2*$):s/(2-2*$),1),o){case f:a=(m-L)/s+(m<L?6:0);break;case m:a=(L-f)/s+2;break;case L:a=(f-m)/s+4;break}a*=60,a=Math.round(a)}return new i(a,h,$,n)}static i(c,f,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?c+(f-c)*6*m:m<1/2?f:m<2/3?c+(f-c)*(2/3-m)*6:c}static toRGBA(c){const f=c.h/360,{s:m,l:L,a:n}=c;let o,e,a;if(m===0)o=e=a=L;else{const h=L<.5?L*(1+m):L+m-L*m,$=2*L-h;o=i.i($,h,f+1/3),e=i.i($,h,f),a=i.i($,h,f-1/3)}return new O(Math.round(o*255),Math.round(e*255),Math.round(a*255),n)}}t.$Ys=i;class q{constructor(c,f,m,L){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=w(Math.max(Math.min(1,f),0),3),this.v=w(Math.max(Math.min(1,m),0),3),this.a=w(Math.max(Math.min(1,L),0),3)}static equals(c,f){return c.h===f.h&&c.s===f.s&&c.v===f.v&&c.a===f.a}static fromRGBA(c){const f=c.r/255,m=c.g/255,L=c.b/255,n=Math.max(f,m,L),o=Math.min(f,m,L),e=n-o,a=n===0?0:e/n;let h;return e===0?h=0:n===f?h=((m-L)/e%6+6)%6:n===m?h=(L-f)/e+2:h=(f-m)/e+4,new q(Math.round(h*60),a,n,c.a)}static toRGBA(c){const{h:f,s:m,v:L,a:n}=c,o=L*m,e=o*(1-Math.abs(f/60%2-1)),a=L-o;let[h,$,s]=[0,0,0];return f<60?(h=o,$=e):f<120?(h=e,$=o):f<180?($=o,s=e):f<240?($=e,s=o):f<300?(h=e,s=o):f<=360&&(h=o,s=e),h=Math.round((h+a)*255),$=Math.round(($+a)*255),s=Math.round((s+a)*255),new O(h,$,s,n)}}t.$Zs=q;class p{static fromHex(c){return p.Format.CSS.parseHex(c)||p.red}static equals(c,f){return!c&&!f?!0:!c||!f?!1:c.equals(f)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:q.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof O)this.rgba=c;else if(c instanceof i)this.i=c,this.rgba=i.toRGBA(c);else if(c instanceof q)this.j=c,this.rgba=q.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&O.equals(this.rgba,c.rgba)&&i.equals(this.hsla,c.hsla)&&q.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=p.k(this.rgba.r),f=p.k(this.rgba.g),m=p.k(this.rgba.b),L=.2126*c+.7152*f+.0722*m;return w(L,4)}static k(c){const f=c/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(c){const f=this.getRelativeLuminance(),m=c.getRelativeLuminance();return f>m?(f+.05)/(m+.05):(m+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const f=this.getRelativeLuminance(),m=c.getRelativeLuminance();return f>m}isDarkerThan(c){const f=this.getRelativeLuminance(),m=c.getRelativeLuminance();return f<m}lighten(c){return new p(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new p(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:f,g:m,b:L,a:n}=this.rgba;return new p(new O(f,m,L,n*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new p(new O(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const f=c.rgba,m=this.rgba.a,L=f.a,n=m+L*(1-m);if(n<1e-6)return p.transparent;const o=this.rgba.r*m/n+f.r*L*(1-m)/n,e=this.rgba.g*m/n+f.g*L*(1-m)/n,a=this.rgba.b*m/n+f.b*L*(1-m)/n;return new p(new O(o,e,a,n))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:f,g:m,b:L,a:n}=this.rgba;return new p(new O(c.rgba.r-n*(c.rgba.r-f),c.rgba.g-n*(c.rgba.g-m),c.rgba.b-n*(c.rgba.b-L),1))}flatten(...c){const f=c.reduceRight((m,L)=>p.o(L,m));return p.o(this,f)}static o(c,f){const m=1-c.rgba.a;return new p(new O(m*f.rgba.r+c.rgba.a*c.rgba.r,m*f.rgba.g+c.rgba.a*c.rgba.g,m*f.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=p.Format.CSS.format(this)),this.u}static getLighterColor(c,f,m){if(c.isLighterThan(f))return c;m=m||.5;const L=c.getRelativeLuminance(),n=f.getRelativeLuminance();return m=m*(n-L)/n,c.lighten(m)}static getDarkerColor(c,f,m){if(c.isDarkerThan(f))return c;m=m||.5;const L=c.getRelativeLuminance(),n=f.getRelativeLuminance();return m=m*(L-n)/L,c.darken(m)}static{this.white=new p(new O(255,255,255,1))}static{this.black=new p(new O(0,0,0,1))}static{this.red=new p(new O(255,0,0,1))}static{this.blue=new p(new O(0,0,255,1))}static{this.green=new p(new O(0,255,0,1))}static{this.cyan=new p(new O(0,255,255,1))}static{this.lightgrey=new p(new O(211,211,211,1))}static{this.transparent=new p(new O(0,0,0,0))}}t.$1s=p,function(D){let c;(function(f){let m;(function(L){function n(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:D.Format.CSS.formatRGBA(r)}L.formatRGB=n;function o(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}L.formatRGBA=o;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:D.Format.CSS.formatHSLA(r)}L.formatHSL=e;function a(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}L.formatHSLA=a;function h(r){const y=r.toString(16);return y.length!==2?"0"+y:y}function $(r){return`#${h(r.rgba.r)}${h(r.rgba.g)}${h(r.rgba.b)}`}L.formatHex=$;function s(r,y=!1){return y&&r.rgba.a===1?D.Format.CSS.formatHex(r):`#${h(r.rgba.r)}${h(r.rgba.g)}${h(r.rgba.b)}${h(Math.round(r.rgba.a*255))}`}L.formatHexA=s;function u(r){return r.isOpaque()?D.Format.CSS.formatHex(r):D.Format.CSS.formatRGBA(r)}L.format=u;function d(r){const y=r.length;if(y===0||r.charCodeAt(0)!==35)return null;if(y===7){const I=16*l(r.charCodeAt(1))+l(r.charCodeAt(2)),T=16*l(r.charCodeAt(3))+l(r.charCodeAt(4)),g=16*l(r.charCodeAt(5))+l(r.charCodeAt(6));return new D(new O(I,T,g,1))}if(y===9){const I=16*l(r.charCodeAt(1))+l(r.charCodeAt(2)),T=16*l(r.charCodeAt(3))+l(r.charCodeAt(4)),g=16*l(r.charCodeAt(5))+l(r.charCodeAt(6)),v=16*l(r.charCodeAt(7))+l(r.charCodeAt(8));return new D(new O(I,T,g,v/255))}if(y===4){const I=l(r.charCodeAt(1)),T=l(r.charCodeAt(2)),g=l(r.charCodeAt(3));return new D(new O(16*I+I,16*T+T,16*g+g))}if(y===5){const I=l(r.charCodeAt(1)),T=l(r.charCodeAt(2)),g=l(r.charCodeAt(3)),v=l(r.charCodeAt(4));return new D(new O(16*I+I,16*T+T,16*g+g,(16*v+v)/255))}return null}L.parseHex=d;function l(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=f.CSS||(f.CSS={}))})(c=D.Format||(D.Format={}))}(p||(t.$1s=p={}))}),define($e[25],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jh=t.$ih=t.$hh=void 0;function w(p){return(D,c,f)=>{let m=null,L=null;if(typeof f.value=="function"?(m="value",L=f.value):typeof f.get=="function"&&(m="get",L=f.get),!L)throw new Error("not supported");f[m]=p(L,c)}}function O(p,D,c){let f=null,m=null;if(typeof c.value=="function"?(f="value",m=c.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(f="get",m=c.get),!m)throw new Error("not supported");const L=`$memoize$${D}`;c[f]=function(...n){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,n)}),this[L]}}t.$hh=O;function i(p,D,c){return w((f,m)=>{const L=`$debounce$${m}`,n=`$debounce$result$${m}`;return function(...o){this[n]||(this[n]=c?c():void 0),clearTimeout(this[L]),D&&(this[n]=D(this[n],...o),o=[this[n]]),this[L]=setTimeout(()=>{f.apply(this,o),this[n]=c?c():void 0},p)}})}t.$ih=i;function q(p,D,c){return w((f,m)=>{const L=`$throttle$timer$${m}`,n=`$throttle$result$${m}`,o=`$throttle$lastRun$${m}`,e=`$throttle$pending$${m}`;return function(...a){if(this[n]||(this[n]=c?c():void 0),(this[o]===null||this[o]===void 0)&&(this[o]=-Number.MAX_VALUE),D&&(this[n]=D(this[n],...a)),this[e])return;const h=this[o]+p;h<=Date.now()?(this[o]=Date.now(),f.apply(this,[this[n]]),this[n]=c?c():void 0):(this[e]=!0,this[L]=setTimeout(()=>{this[e]=!1,this[o]=Date.now(),f.apply(this,[this[n]]),this[n]=c?c():void 0},h-Date.now()))}})}t.$jh=q}),define($e[74],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zs=void 0;class w{constructor(i,q,p,D){this.originalStart=i,this.originalLength=q,this.modifiedStart=p,this.modifiedLength=D}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$zs=w}),define($e[6],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.setUnexpectedErrorHandler=t.$W=t.$V=void 0;class w{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?u.isErrorNoTelemetry(r)?new u(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(y=>{y(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}t.$V=w,t.$W=new w;function O(l){t.$W.setUnexpectedErrorHandler(l)}t.setUnexpectedErrorHandler=O;function i(l){if(!l||typeof l!="object")return!1;const r=l;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}t.$Y=i;function q(l){f(l)||t.$W.onUnexpectedError(l)}t.$Z=q;function p(l){f(l)||t.$W.onUnexpectedExternalError(l)}t.$1=p;function D(l){if(l instanceof Error){const{name:r,message:y}=l,I=l.stacktrace||l.stack;return{$isError:!0,name:r,message:y,stack:I,noTelemetry:u.isErrorNoTelemetry(l)}}return l}t.$2=D;const c="Canceled";function f(l){return l instanceof m?!0:l instanceof Error&&l.name===c&&l.message===c}t.$3=f;class m extends Error{constructor(){super(c),this.name=this.message}}t.$4=m;function L(){const l=new Error(c);return l.name=l.message,l}t.$5=L;function n(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}t.$6=n;function o(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}t.$7=o;class e extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$8=e;function a(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}t.$9=a;class h extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.$0=h;class $ extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.$$=$;class s extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=s;class u extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof u)return r;const y=new u;return y.message=r.message,y.stack=r.stack,y}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.$ab=u;class d extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}t.$bb=d}),define($e[11],pe([1,0,6,71]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.CompareResult=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.top=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=void 0;function i(N,A=0){return N[N.length-(1+A)]}t.$rb=i;function q(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}t.$sb=q;function p(N,A,k=(U,C)=>U===C){if(N===A)return!0;if(!N||!A||N.length!==A.length)return!1;for(let U=0,C=N.length;U<C;U++)if(!k(N[U],A[U]))return!1;return!0}t.$tb=p;function D(N,A){const k=N.length-1;A<k&&(N[A]=N[k]),N.pop()}t.$ub=D;function c(N,A,k){return f(N.length,U=>k(N[U],A))}t.$vb=c;function f(N,A){let k=0,U=N-1;for(;k<=U;){const C=(k+U)/2|0,j=A(C);if(j<0)k=C+1;else if(j>0)U=C-1;else return C}return-(k+1)}t.$wb=f;function m(N,A,k){if(N=N|0,N>=A.length)throw new TypeError("invalid index");const U=A[Math.floor(A.length*Math.random())],C=[],j=[],E=[];for(const P of A){const W=k(P,U);W<0?C.push(P):W>0?j.push(P):E.push(P)}return N<C.length?m(N,C,k):N<C.length+E.length?E[0]:m(N-(C.length+E.length),j,k)}t.$xb=m;function L(N,A){const k=[];let U;for(const C of N.slice(0).sort(A))!U||A(U[0],C)!==0?(U=[C],k.push(U)):U.push(C);return k}t.$yb=L;function*n(N,A){let k,U;for(const C of N)U!==void 0&&A(U,C)?k.push(C):(k&&(yield k),k=[C]),U=C;k&&(yield k)}t.$zb=n;function o(N,A){for(let k=0;k<=N.length;k++)A(k===0?void 0:N[k-1],k===N.length?void 0:N[k])}t.$Ab=o;function e(N,A){for(let k=0;k<N.length;k++)A(k===0?void 0:N[k-1],N[k],k+1===N.length?void 0:N[k+1])}t.$Bb=e;function a(N,A,k){const U=[];function C(P,W,x){if(W===0&&x.length===0)return;const te=U[U.length-1];te&&te.start+te.deleteCount===P?(te.deleteCount+=W,te.toInsert.push(...x)):U.push({start:P,deleteCount:W,toInsert:x})}let j=0,E=0;for(;;){if(j===N.length){C(j,0,A.slice(E));break}if(E===A.length){C(j,N.length-j,[]);break}const P=N[j],W=A[E],x=k(P,W);x===0?(j+=1,E+=1):x<0?(C(j,1,[]),j+=1):x>0&&(C(j,0,[W]),E+=1)}return U}t.$Cb=a;function h(N,A,k){const U=a(N,A,k),C=[],j=[];for(const E of U)C.push(...N.slice(E.start,E.start+E.deleteCount)),j.push(...E.toInsert);return{removed:C,added:j}}t.$Db=h;function $(N,A,k){if(k===0)return[];const U=N.slice(0,k).sort(A);return u(N,A,U,k,N.length),U}t.top=$;function s(N,A,k,U,C){return k===0?Promise.resolve([]):new Promise((j,E)=>{(async()=>{const P=N.length,W=N.slice(0,k).sort(A);for(let x=k,te=Math.min(k+U,P);x<P;x=te,te=Math.min(te+U,P)){if(x>k&&await new Promise(ne=>setTimeout(ne)),C&&C.isCancellationRequested)throw new w.$4;u(N,A,W,x,te)}return W})().then(j,E)})}t.$Fb=s;function u(N,A,k,U,C){for(const j=k.length;U<C;U++){const E=N[U];if(A(E,k[j-1])<0){k.pop();const P=(0,O.$jb)(k,W=>A(E,W)<0);k.splice(P,0,E)}}}function d(N){return N.filter(A=>!!A)}t.$Gb=d;function l(N){let A=0;for(let k=0;k<N.length;k++)N[k]&&(N[A]=N[k],A+=1);N.length=A}t.$Hb=l;function r(N,A,k){N.splice(k,0,N.splice(A,1)[0])}t.$Ib=r;function y(N){return!Array.isArray(N)||N.length===0}t.$Jb=y;function I(N){return Array.isArray(N)&&N.length>0}t.$Kb=I;function T(N,A=k=>k){const k=new Set;return N.filter(U=>{const C=A(U);return k.has(C)?!1:(k.add(C),!0)})}t.$Lb=T;function g(N){const A=new Set;return k=>{const U=N(k);return A.has(U)?!1:(A.add(U),!0)}}t.$Mb=g;function v(N,A){return N.length>0?N[0]:A}t.$Nb=v;function z(N,A){return N.length>0?N[N.length-1]:A}t.$Ob=z;function H(N,A,k=(U,C)=>U===C){let U=0;for(let C=0,j=Math.min(N.length,A.length);C<j&&k(N[C],A[C]);C++)U++;return U}t.$Pb=H;function _(N){return[].concat(...N)}t.$Qb=_;function M(N,A){let k=typeof A=="number"?N:0;typeof A=="number"?k=N:(k=0,A=N);const U=[];if(k<=A)for(let C=k;C<A;C++)U.push(C);else for(let C=k;C>A;C--)U.push(C);return U}t.$Rb=M;function F(N,A,k){return N.reduce((U,C)=>(U[A(C)]=k?k(C):C,U),Object.create(null))}t.$Sb=F;function Z(N,A){return N.push(A),()=>ee(N,A)}t.$Tb=Z;function ee(N,A){const k=N.indexOf(A);if(k>-1)return N.splice(k,1),A}t.$Ub=ee;function ue(N,A,k){const U=N.slice(0,A),C=N.slice(A);return U.concat(k,C)}t.$Vb=ue;function oe(N,A){let k;if(typeof A=="number"){let U=A;k=()=>{const C=Math.sin(U++)*179426549;return C-Math.floor(C)}}else k=Math.random;for(let U=N.length-1;U>0;U-=1){const C=Math.floor(k()*(U+1)),j=N[U];N[U]=N[C],N[C]=j}}t.$Wb=oe;function se(N,A){const k=N.indexOf(A);k>-1&&(N.splice(k,1),N.unshift(A))}t.$Xb=se;function re(N,A){const k=N.indexOf(A);k>-1&&(N.splice(k,1),N.push(A))}t.$Yb=re;function be(N,A){for(const k of A)N.push(k)}t.$Zb=be;function Se(N,A){return Array.isArray(N)?N.map(A):A(N)}t.$1b=Se;function Le(N){return Array.isArray(N)?N:[N]}t.$2b=Le;function Fe(N){return N[Math.floor(Math.random()*N.length)]}t.$3b=Fe;function de(N,A,k){const U=ce(N,A),C=N.length,j=k.length;N.length=C+j;for(let E=C-1;E>=U;E--)N[E+j]=N[E];for(let E=0;E<j;E++)N[E+U]=k[E]}t.$4b=de;function ie(N,A,k,U){const C=ce(N,A);let j=N.splice(C,k);return j===void 0&&(j=[]),de(N,C,U),j}t.$5b=ie;function ce(N,A){return A<0?Math.max(A+N.length,0):Math.min(A,N.length)}var Y;(function(N){function A(j){return j<0}N.isLessThan=A;function k(j){return j<=0}N.isLessThanOrEqual=k;function U(j){return j>0}N.isGreaterThan=U;function C(j){return j===0}N.isNeitherLessOrGreaterThan=C,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(Y||(t.CompareResult=Y={}));function V(N,A){return(k,U)=>A(N(k),N(U))}t.$6b=V;function G(...N){return(A,k)=>{for(const U of N){const C=U(A,k);if(!Y.isNeitherLessOrGreaterThan(C))return C}return Y.neitherLessOrGreaterThan}}t.$7b=G;const S=(N,A)=>N-A;t.$8b=S;const Q=(N,A)=>(0,t.$8b)(N?1:0,A?1:0);t.$9b=Q;function b(N){return(A,k)=>-N(A,k)}t.$0b=b;class R{constructor(A){this.g=A,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(A){let k=this.c;for(;k<this.g.length&&A(this.g[k]);)k++;const U=k===this.c?null:this.g.slice(this.c,k);return this.c=k,U}takeFromEndWhile(A){let k=this.d;for(;k>=0&&A(this.g[k]);)k--;const U=k===this.d?null:this.g.slice(k+1,this.d+1);return this.d=k,U}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const A=this.g[this.c];return this.c++,A}removeLast(){const A=this.g[this.d];return this.d--,A}takeCount(A){const k=this.g.slice(this.c,this.c+A);return this.c+=A,k}}t.$$b=R;class B{static{this.empty=new B(A=>{})}constructor(A){this.iterate=A}forEach(A){this.iterate(k=>(A(k),!0))}toArray(){const A=[];return this.iterate(k=>(A.push(k),!0)),A}filter(A){return new B(k=>this.iterate(U=>A(U)?k(U):!0))}map(A){return new B(k=>this.iterate(U=>k(A(U))))}some(A){let k=!1;return this.iterate(U=>(k=A(U),!k)),k}findFirst(A){let k;return this.iterate(U=>A(U)?(k=U,!1):!0),k}findLast(A){let k;return this.iterate(U=>(A(U)&&(k=U),!0)),k}findLastMaxBy(A){let k,U=!0;return this.iterate(C=>((U||Y.isGreaterThan(A(C,k)))&&(U=!1,k=C),!0)),k}}t.$_b=B}),define($e[75],pe([1,0,6]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=t.$5c=t.$4c=t.$3c=t.ok=void 0;function O(c,f){if(!c)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}t.ok=O;function i(c,f="Unreachable"){throw new Error(f)}t.$3c=i;function q(c){if(!c)throw new w.$bb("Assertion Failed")}t.$4c=q;function p(c){if(!c()){debugger;c(),(0,w.$Z)(new w.$bb("Assertion Failed"))}}t.$5c=p;function D(c,f){let m=0;for(;m<c.length-1;){const L=c[m],n=c[m+1];if(!f(L,n))return!1;m++}return!0}t.$6c=D}),define($e[42],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function w(O){const i=this;let q=!1,p;return function(){return q||(q=!0,p=O.apply(i,arguments)),p}}t.$cb=w}),define($e[76],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wM=t.$vM=void 0;class w{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$vM=w,t.$wM=new w("id#")}),define($e[26],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var w;(function(O){function i(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}O.is=i;const q=Object.freeze([]);function p(){return q}O.empty=p;function*D(l){yield l}O.single=D;function c(l){return i(l)?l:D(l)}O.wrap=c;function f(l){return l||q}O.from=f;function*m(l){for(let r=l.length-1;r>=0;r--)yield l[r]}O.reverse=m;function L(l){return!l||l[Symbol.iterator]().next().done===!0}O.isEmpty=L;function n(l){return l[Symbol.iterator]().next().value}O.first=n;function o(l,r){for(const y of l)if(r(y))return!0;return!1}O.some=o;function e(l,r){for(const y of l)if(r(y))return y}O.find=e;function*a(l,r){for(const y of l)r(y)&&(yield y)}O.filter=a;function*h(l,r){let y=0;for(const I of l)yield r(I,y++)}O.map=h;function*$(...l){for(const r of l)for(const y of r)yield y}O.concat=$;function s(l,r,y){let I=y;for(const T of l)I=r(I,T);return I}O.reduce=s;function*u(l,r,y=l.length){for(r<0&&(r+=l.length),y<0?y+=l.length:y>l.length&&(y=l.length);r<y;r++)yield l[r]}O.slice=u;function d(l,r=Number.POSITIVE_INFINITY){const y=[];if(r===0)return[y,l];const I=l[Symbol.iterator]();for(let T=0;T<r;T++){const g=I.next();if(g.done)return[y,O.empty()];y.push(g.value)}return[y,{[Symbol.iterator](){return I}}]}O.consume=d})(w||(t.Iterable=w={}))}),define($e[43],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Iq=t.KeyMod=t.KeyCodeUtils=t.$Hq=t.$Gq=t.$Fq=t.$Eq=t.$Dq=t.ScanCode=t.KeyCode=void 0;var w;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(w||(t.KeyCode=w={}));var O;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(O||(t.ScanCode=O={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(a,h){this._keyCodeToStr[a]=h,this._strToKeyCode[h.toLowerCase()]=a}keyCodeToStr(a){return this._keyCodeToStr[a]}strToKeyCode(a){return this._strToKeyCode[a.toLowerCase()]||0}}const q=new i,p=new i,D=new i;t.$Dq=new Array(230),t.$Eq={};const c=[],f=Object.create(null),m=Object.create(null);t.$Fq={lowerCaseToEnum:e=>m[e]||0,toEnum:e=>f[e]||0,toString:e=>c[e]||"None"},t.$Gq=[],t.$Hq=[];for(let e=0;e<=193;e++)t.$Gq[e]=-1;for(let e=0;e<=132;e++)t.$Hq[e]=-1;(function(){const e="",a=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],h=[],$=[];for(const s of a){const[u,d,l,r,y,I,T,g,v]=s;if($[d]||($[d]=!0,c[d]=l,f[l]=d,m[l.toLowerCase()]=d,u&&(t.$Gq[d]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.$Hq[r]=d))),!h[r]){if(h[r]=!0,!y)throw new Error(`String representation missing for key code ${r} around scan code ${l}`);q.define(r,y),p.define(r,g||y),D.define(r,v||g||y)}I&&(t.$Dq[I]=r),T&&(t.$Eq[T]=r)}t.$Hq[3]=46})();var L;(function(e){function a(l){return q.keyCodeToStr(l)}e.toString=a;function h(l){return q.strToKeyCode(l)}e.fromString=h;function $(l){return p.keyCodeToStr(l)}e.toUserSettingsUS=$;function s(l){return D.keyCodeToStr(l)}e.toUserSettingsGeneral=s;function u(l){return p.strToKeyCode(l)||D.strToKeyCode(l)}e.fromUserSettings=u;function d(l){if(l>=98&&l<=113)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return q.keyCodeToStr(l)}e.toElectronAccelerator=d})(L||(t.KeyCodeUtils=L={}));var n;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(n||(t.KeyMod=n={}));function o(e,a){const h=(a&65535)<<16>>>0;return(e|h)>>>0}t.$Iq=o}),define($e[77],pe([1,0,6]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pq=t.$Oq=t.$Nq=t.$Mq=t.$Lq=t.$Kq=t.$Jq=void 0;var O;(function(L){L[L.CtrlCmd=2048]="CtrlCmd",L[L.Shift=1024]="Shift",L[L.Alt=512]="Alt",L[L.WinCtrl=256]="WinCtrl",L[L.KeyCode=255]="KeyCode"})(O||(O={}));function i(L,n){if(typeof L=="number"){if(L===0)return null;const o=(L&65535)>>>0,e=(L&4294901760)>>>16;return e!==0?new c([q(o,n),q(e,n)]):new c([q(o,n)])}else{const o=[];for(let e=0;e<L.length;e++)o.push(q(L[e],n));return new c(o)}}t.$Jq=i;function q(L,n){const o=!!(L&2048),e=!!(L&256),a=n===2?e:o,h=!!(L&1024),$=!!(L&512),s=n===2?o:e,u=L&255;return new p(a,h,$,s,u)}t.$Kq=q;class p{constructor(n,o,e,a,h){this.ctrlKey=n,this.shiftKey=o,this.altKey=e,this.metaKey=a,this.keyCode=h}equals(n){return n instanceof p&&this.ctrlKey===n.ctrlKey&&this.shiftKey===n.shiftKey&&this.altKey===n.altKey&&this.metaKey===n.metaKey&&this.keyCode===n.keyCode}getHashCode(){const n=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`K${n}${o}${e}${a}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new c([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Lq=p;class D{constructor(n,o,e,a,h){this.ctrlKey=n,this.shiftKey=o,this.altKey=e,this.metaKey=a,this.scanCode=h}equals(n){return n instanceof D&&this.ctrlKey===n.ctrlKey&&this.shiftKey===n.shiftKey&&this.altKey===n.altKey&&this.metaKey===n.metaKey&&this.scanCode===n.scanCode}getHashCode(){const n=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`S${n}${o}${e}${a}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Mq=D;class c{constructor(n){if(n.length===0)throw(0,w.$6)("chords");this.chords=n}getHashCode(){let n="";for(let o=0,e=this.chords.length;o<e;o++)o!==0&&(n+=";"),n+=this.chords[o].getHashCode();return n}equals(n){if(n===null||this.chords.length!==n.chords.length)return!1;for(let o=0;o<this.chords.length;o++)if(!this.chords[o].equals(n.chords[o]))return!1;return!0}}t.$Nq=c;class f{constructor(n,o,e,a,h,$){this.ctrlKey=n,this.shiftKey=o,this.altKey=e,this.metaKey=a,this.keyLabel=h,this.keyAriaLabel=$}}t.$Oq=f;class m{}t.$Pq=m}),define($e[27],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=void 0;class w{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$U=w}),define($e[44],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=void 0;class w{static{this.Undefined=new w(void 0)}constructor(q){this.element=q,this.next=w.Undefined,this.prev=w.Undefined}}class O{constructor(){this.a=w.Undefined,this.b=w.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===w.Undefined}clear(){let q=this.a;for(;q!==w.Undefined;){const p=q.next;q.prev=w.Undefined,q.next=w.Undefined,q=p}this.a=w.Undefined,this.b=w.Undefined,this.c=0}unshift(q){return this.d(q,!1)}push(q){return this.d(q,!0)}d(q,p){const D=new w(q);if(this.a===w.Undefined)this.a=D,this.b=D;else if(p){const f=this.b;this.b=D,D.prev=f,f.next=D}else{const f=this.a;this.a=D,D.next=f,f.prev=D}this.c+=1;let c=!1;return()=>{c||(c=!0,this.e(D))}}shift(){if(this.a!==w.Undefined){const q=this.a.element;return this.e(this.a),q}}pop(){if(this.b!==w.Undefined){const q=this.b.element;return this.e(this.b),q}}e(q){if(q.prev!==w.Undefined&&q.next!==w.Undefined){const p=q.prev;p.next=q.next,q.next.prev=p}else q.prev===w.Undefined&&q.next===w.Undefined?(this.a=w.Undefined,this.b=w.Undefined):q.next===w.Undefined?(this.b=this.b.prev,this.b.next=w.Undefined):q.prev===w.Undefined&&(this.a=this.a.next,this.a.prev=w.Undefined);this.c-=1}*[Symbol.iterator](){let q=this.a;for(;q!==w.Undefined;)yield q.element,q=q.next}}t.$1c=O}),define($e[31],pe([1,0]),function(le,t){"use strict";var w,O,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.Touch=t.$Ac=t.$zc=t.$yc=t.$xc=t.$wc=void 0;function q(s,u,d){let l=s.get(u);return l===void 0&&(l=d,s.set(u,l)),l}t.$wc=q;function p(s){const u=[];return s.forEach((d,l)=>{u.push(`${l} => ${d}`)}),`Map(${s.size}) {${u.join(", ")}}`}t.$xc=p;function D(s){const u=[];return s.forEach(d=>{u.push(d)}),`Set(${s.size}) {${u.join(", ")}}`}t.$yc=D;class c{constructor(u,d){this.uri=u,this.value=d}}function f(s){return Array.isArray(s)}class m{static{this.a=u=>u.toString()}constructor(u,d){if(this[w]="ResourceMap",u instanceof m)this.b=new Map(u.b),this.c=d??m.a;else if(f(u)){this.b=new Map,this.c=d??m.a;for(const[l,r]of u)this.set(l,r)}else this.b=new Map,this.c=u??m.a}set(u,d){return this.b.set(this.c(u),new c(u,d)),this}get(u){return this.b.get(this.c(u))?.value}has(u){return this.b.has(this.c(u))}get size(){return this.b.size}clear(){this.b.clear()}delete(u){return this.b.delete(this.c(u))}forEach(u,d){typeof d<"u"&&(u=u.bind(d));for(const[l,r]of this.b)u(r.value,r.uri,this)}*values(){for(const u of this.b.values())yield u.value}*keys(){for(const u of this.b.values())yield u.uri}*entries(){for(const u of this.b.values())yield[u.uri,u.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.b)yield[u.uri,u.value]}}t.$zc=m;class L{constructor(u,d){this[O]="ResourceSet",!u||typeof u=="function"?this.a=new m(u):(this.a=new m(d),u.forEach(this.add,this))}get size(){return this.a.size}add(u){return this.a.set(u,u),this}clear(){this.a.clear()}delete(u){return this.a.delete(u)}forEach(u,d){this.a.forEach((l,r)=>u.call(d,r,r,this))}has(u){return this.a.has(u)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ac=L;var n;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(n||(t.Touch=n={}));class o{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(u){return this.a.has(u)}get(u,d=0){const l=this.a.get(u);if(l)return d!==0&&this.j(l,d),l.value}set(u,d,l=0){let r=this.a.get(u);if(r)r.value=d,l!==0&&this.j(r,l);else{switch(r={key:u,value:d,next:void 0,previous:void 0},l){case 0:this.h(r);break;case 1:this.g(r);break;case 2:this.h(r);break;default:this.h(r);break}this.a.set(u,r),this.d++}return this}delete(u){return!!this.remove(u)}remove(u){const d=this.a.get(u);if(d)return this.a.delete(u),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const u=this.b;return this.a.delete(u.key),this.i(u),this.d--,u.value}forEach(u,d){const l=this.e;let r=this.b;for(;r;){if(d?u.bind(d)(r.value,r.key,this):u(r.value,r.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const u=this,d=this.e;let l=this.b;const r={[Symbol.iterator](){return r},next(){if(u.e!==d)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:l.key,done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return r}values(){const u=this,d=this.e;let l=this.b;const r={[Symbol.iterator](){return r},next(){if(u.e!==d)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:l.value,done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return r}entries(){const u=this,d=this.e;let l=this.b;const r={[Symbol.iterator](){return r},next(){if(u.e!==d)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:[l.key,l.value],done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return r}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(u){if(u>=this.size)return;if(u===0){this.clear();return}let d=this.b,l=this.size;for(;d&&l>u;)this.a.delete(d.key),d=d.next,l--;this.b=d,this.d=l,d&&(d.previous=void 0),this.e++}g(u){if(!this.b&&!this.c)this.c=u;else if(this.b)u.next=this.b,this.b.previous=u;else throw new Error("Invalid list");this.b=u,this.e++}h(u){if(!this.b&&!this.c)this.b=u;else if(this.c)u.previous=this.c,this.c.next=u;else throw new Error("Invalid list");this.c=u,this.e++}i(u){if(u===this.b&&u===this.c)this.b=void 0,this.c=void 0;else if(u===this.b){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.b=u.next}else if(u===this.c){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.c=u.previous}else{const d=u.next,l=u.previous;if(!d||!l)throw new Error("Invalid list");d.previous=l,l.next=d}u.next=void 0,u.previous=void 0,this.e++}j(u,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(u===this.b)return;const l=u.next,r=u.previous;u===this.c?(r.next=void 0,this.c=r):(l.previous=r,r.next=l),u.previous=void 0,u.next=this.b,this.b.previous=u,this.b=u,this.e++}else if(d===2){if(u===this.c)return;const l=u.next,r=u.previous;u===this.b?(l.previous=void 0,this.b=l):(l.previous=r,r.next=l),u.next=void 0,u.previous=this.c,this.c.next=u,this.c=u,this.e++}}}toJSON(){const u=[];return this.forEach((d,l)=>{u.push([l,d])}),u}fromJSON(u){this.clear();for(const[d,l]of u)this.set(d,l)}}t.$Bc=o;class e extends o{constructor(u,d=1){super(),this.k=u,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(u){this.k=u,this.m()}get ratio(){return this.l}set ratio(u){this.l=Math.min(Math.max(0,u),1),this.m()}get(u,d=2){return super.get(u,d)}peek(u){return super.get(u,0)}set(u,d){return super.set(u,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Cc=e;class a{constructor(){this.a=new Map}add(u){return this.a.set(u,(this.a.get(u)||0)+1),this}delete(u){let d=this.a.get(u)||0;return d===0?!1:(d--,d===0?this.a.delete(u):this.a.set(u,d),!0)}has(u){return this.a.has(u)}}t.$Dc=a;class h{constructor(u){if(this.a=new Map,this.b=new Map,u)for(const[d,l]of u)this.set(d,l)}clear(){this.a.clear(),this.b.clear()}set(u,d){this.a.set(u,d),this.b.set(d,u)}get(u){return this.a.get(u)}getKey(u){return this.b.get(u)}delete(u){const d=this.a.get(u);return d===void 0?!1:(this.a.delete(u),this.b.delete(d),!0)}forEach(u,d){this.a.forEach((l,r)=>{u.call(d,l,r,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Ec=h;class ${constructor(){this.a=new Map}add(u,d){let l=this.a.get(u);l||(l=new Set,this.a.set(u,l)),l.add(d)}delete(u,d){const l=this.a.get(u);l&&(l.delete(d),l.size===0&&this.a.delete(u))}forEach(u,d){const l=this.a.get(u);l&&l.forEach(d)}get(u){const d=this.a.get(u);return d||new Set}}t.$Fc=$}),define($e[2],pe([1,0,11,72,31,42,26]),function(le,t,w,O,i,q,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=void 0;const D=!1;let c=null;class f{constructor(){this.b=new Map}static{this.a=0}c(F){let Z=this.b.get(F);return Z||(Z={parent:null,source:null,isSingleton:!1,value:F,idx:f.a++},this.b.set(F,Z)),Z}trackDisposable(F){const Z=this.c(F);Z.source||(Z.source=new Error().stack)}setParent(F,Z){const ee=this.c(F);ee.parent=Z}markAsDisposed(F){this.b.delete(F)}markAsSingleton(F){this.c(F).isSingleton=!0}f(F,Z){const ee=Z.get(F);if(ee)return ee;const ue=F.parent?this.f(this.c(F.parent),Z):F;return Z.set(F,ue),ue}getTrackedDisposables(){const F=new Map;return[...this.b.entries()].filter(([,ee])=>ee.source!==null&&!this.f(ee,F).isSingleton).flatMap(([ee])=>ee)}computeLeakingDisposables(F=10,Z){let ee;if(Z)ee=Z;else{const be=new Map,Se=[...this.b.values()].filter(Fe=>Fe.source!==null&&!this.f(Fe,be).isSingleton);if(Se.length===0)return;const Le=new Set(Se.map(Fe=>Fe.value));if(ee=Se.filter(Fe=>!(Fe.parent&&Le.has(Fe.parent))),ee.length===0)throw new Error("There are cyclic diposable chains!")}if(!ee)return;function ue(be){function Se(Fe,de){for(;Fe.length>0&&de.some(ie=>typeof ie=="string"?ie===Fe[0]:Fe[0].match(ie));)Fe.shift()}const Le=be.source.split(`
`).map(Fe=>Fe.trim().replace("at ","")).filter(Fe=>Fe!=="");return Se(Le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Le.reverse()}const oe=new i.$Fc;for(const be of ee){const Se=ue(be);for(let Le=0;Le<=Se.length;Le++)oe.add(Se.slice(0,Le).join(`
`),be)}ee.sort((0,w.$6b)(be=>be.idx,w.$8b));let se="",re=0;for(const be of ee.slice(0,F)){re++;const Se=ue(be),Le=[];for(let Fe=0;Fe<Se.length;Fe++){let de=Se[Fe];de=`(shared with ${oe.get(Se.slice(0,Fe+1).join(`
`)).size}/${ee.length} leaks) at ${de}`;const ce=oe.get(Se.slice(0,Fe).join(`
`)),Y=(0,O.$J)([...ce].map(V=>ue(V)[Fe]),V=>V);delete Y[Se[Fe]];for(const[V,G]of Object.entries(Y))Le.unshift(`    - stacktraces of ${G.length} other leaks continue with ${V}`);Le.unshift(de)}se+=`


==================== Leaking disposable ${re}/${ee.length}: ${be.value.constructor.name} ====================
${Le.join(`
`)}
============================================================

`}return ee.length>F&&(se+=`


... and ${ee.length-F} more leaking disposables

`),{leaks:ee,details:se}}}t.$Gc=f;function m(M){c=M}if(t.$Hc=m,D){const M="__is_disposable_tracked__";m(new class{trackDisposable(F){const Z=new Error("Potentially leaked disposable").stack;setTimeout(()=>{F[M]||console.log(Z)},3e3)}setParent(F,Z){if(F&&F!==r.None)try{F[M]=!0}catch{}}markAsDisposed(F){if(F&&F!==r.None)try{F[M]=!0}catch{}}markAsSingleton(F){}})}function L(M){return c?.trackDisposable(M),M}t.$Ic=L;function n(M){c?.markAsDisposed(M)}t.$Jc=n;function o(M,F){c?.setParent(M,F)}function e(M,F){if(c)for(const Z of M)c.setParent(Z,F)}function a(M){return c?.markAsSingleton(M),M}t.$Kc=a;function h(M){return typeof M.dispose=="function"&&M.dispose.length===0}t.$Lc=h;function $(M){if(p.Iterable.is(M)){const F=[];for(const Z of M)if(Z)try{Z.dispose()}catch(ee){F.push(ee)}if(F.length===1)throw F[0];if(F.length>1)throw new AggregateError(F,"Encountered errors while disposing of store");return Array.isArray(M)?[]:M}else if(M)return M.dispose(),M}t.$Mc=$;function s(M){for(const F of M)h(F)&&F.dispose();return[]}t.$Nc=s;function u(...M){const F=d(()=>$(M));return e(M,F),F}t.$Oc=u;function d(M){const F=L({dispose:(0,q.$cb)(()=>{n(F),M()})});return F}t.$Pc=d;class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,L(this)}dispose(){this.g||(n(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(F){if(!F)return F;if(F===this)throw new Error("Cannot register a disposable on itself!");return o(F,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(F),F}delete(F){if(F){if(F===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(F),F.dispose()}}deleteAndLeak(F){F&&this.f.has(F)&&(this.f.delete(F),o(F,null))}}t.$Qc=l;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,L(this),o(this.q,this)}dispose(){n(this),this.q.dispose()}B(F){if(F===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(F)}}t.$Rc=r;class y{constructor(){this.b=!1,L(this)}get value(){return this.b?void 0:this.a}set value(F){this.b||F===this.a||(this.a?.dispose(),F&&o(F,this),this.a=F)}clear(){this.value=void 0}dispose(){this.b=!0,n(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const F=this.a;return this.a=void 0,F&&o(F,null),F}}t.$Sc=y;class I{constructor(F){this.b=F,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Tc=I;class T{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,L(this)}set(F){let Z=F;return this.unset=()=>Z=void 0,this.isset=()=>Z!==void 0,this.dispose=()=>{Z&&(Z(),Z=void 0,n(this))},this}}t.$Uc=T;class g{constructor(){this.a=new Map}acquire(F,...Z){let ee=this.a.get(F);ee||(ee={counter:0,object:this.b(F,...Z)},this.a.set(F,ee));const{object:ue}=ee,oe=(0,q.$cb)(()=>{--ee.counter===0&&(this.c(F,ee.object),this.a.delete(F))});return ee.counter++,{object:ue,dispose:oe}}}t.$Vc=g;class v{constructor(F){this.a=F}async acquire(F,...Z){const ee=this.a.acquire(F,...Z);try{return{object:await ee.object,dispose:()=>ee.dispose()}}catch(ue){throw ee.dispose(),ue}}}t.$Wc=v;class z{constructor(F){this.object=F}dispose(){}}t.$Xc=z;function H(M){const F=new l;try{M(F)}finally{F.dispose()}}t.$Yc=H;class _{constructor(){this.a=new Map,this.b=!1,L(this)}dispose(){n(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(F){return this.a.has(F)}get size(){return this.a.size}get(F){return this.a.get(F)}set(F,Z,ee=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),ee||this.a.get(F)?.dispose(),this.a.set(F,Z)}deleteAndDispose(F){this.a.get(F)?.dispose(),this.a.delete(F)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$Zc=_}),function(le,t){typeof define=="function"&&define.amd?define($e[78],pe([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(le=typeof globalThis<"u"?globalThis:le||self,t(le.marked={}))}(this,function(le){"use strict";function t(A,k){for(var U=0;U<k.length;U++){var C=k[U];C.enumerable=C.enumerable||!1,C.configurable=!0,"value"in C&&(C.writable=!0),Object.defineProperty(A,C.key,C)}}function w(A,k,U){return k&&t(A.prototype,k),U&&t(A,U),Object.defineProperty(A,"prototype",{writable:!1}),A}function O(A,k){if(A){if(typeof A=="string")return i(A,k);var U=Object.prototype.toString.call(A).slice(8,-1);if(U==="Object"&&A.constructor&&(U=A.constructor.name),U==="Map"||U==="Set")return Array.from(A);if(U==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(U))return i(A,k)}}function i(A,k){(k==null||k>A.length)&&(k=A.length);for(var U=0,C=new Array(k);U<k;U++)C[U]=A[U];return C}function q(A,k){var U=typeof Symbol<"u"&&A[Symbol.iterator]||A["@@iterator"];if(U)return(U=U.call(A)).next.bind(U);if(Array.isArray(A)||(U=O(A))||k&&A&&typeof A.length=="number"){U&&(A=U);var C=0;return function(){return C>=A.length?{done:!0}:{done:!1,value:A[C++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function p(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=p();function D(A){le.defaults=A}var c=/[&<>"']/,f=/[&<>"']/g,m=/[<>"']|&(?!#?\w+;)/,L=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},o=function(k){return n[k]};function e(A,k){if(k){if(c.test(A))return A.replace(f,o)}else if(m.test(A))return A.replace(L,o);return A}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(A){return A.replace(a,function(k,U){return U=U.toLowerCase(),U==="colon"?":":U.charAt(0)==="#"?U.charAt(1)==="x"?String.fromCharCode(parseInt(U.substring(2),16)):String.fromCharCode(+U.substring(1)):""})}var $=/(^|[^\[])\^/g;function s(A,k){A=typeof A=="string"?A:A.source,k=k||"";var U={replace:function(j,E){return E=E.source||E,E=E.replace($,"$1"),A=A.replace(j,E),U},getRegex:function(){return new RegExp(A,k)}};return U}var u=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(A,k,U){if(A){var C;try{C=decodeURIComponent(h(U)).replace(u,"").toLowerCase()}catch{return null}if(C.indexOf("javascript:")===0||C.indexOf("vbscript:")===0||C.indexOf("data:")===0)return null}k&&!d.test(U)&&(U=g(k,U));try{U=encodeURI(U).replace(/%25/g,"%")}catch{return null}return U}var r={},y=/^[^:]+:\/*[^/]*$/,I=/^([^:]+:)[\s\S]*$/,T=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(A,k){r[" "+A]||(y.test(A)?r[" "+A]=A+"/":r[" "+A]=_(A,"/",!0)),A=r[" "+A];var U=A.indexOf(":")===-1;return k.substring(0,2)==="//"?U?k:A.replace(I,"$1")+k:k.charAt(0)==="/"?U?k:A.replace(T,"$1")+k:A+k}var v={exec:function(){}};function z(A){for(var k=1,U,C;k<arguments.length;k++){U=arguments[k];for(C in U)Object.prototype.hasOwnProperty.call(U,C)&&(A[C]=U[C])}return A}function H(A,k){var U=A.replace(/\|/g,function(E,P,W){for(var x=!1,te=P;--te>=0&&W[te]==="\\";)x=!x;return x?"|":" |"}),C=U.split(/ \|/),j=0;if(C[0].trim()||C.shift(),C.length>0&&!C[C.length-1].trim()&&C.pop(),C.length>k)C.splice(k);else for(;C.length<k;)C.push("");for(;j<C.length;j++)C[j]=C[j].trim().replace(/\\\|/g,"|");return C}function _(A,k,U){var C=A.length;if(C===0)return"";for(var j=0;j<C;){var E=A.charAt(C-j-1);if(E===k&&!U)j++;else if(E!==k&&U)j++;else break}return A.slice(0,C-j)}function M(A,k){if(A.indexOf(k[1])===-1)return-1;for(var U=A.length,C=0,j=0;j<U;j++)if(A[j]==="\\")j++;else if(A[j]===k[0])C++;else if(A[j]===k[1]&&(C--,C<0))return j;return-1}function F(A){A&&A.sanitize&&!A.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function Z(A,k){if(k<1)return"";for(var U="";k>1;)k&1&&(U+=A),k>>=1,A+=A;return U+A}function ee(A,k,U,C){var j=k.href,E=k.title?e(k.title):null,P=A[1].replace(/\\([\[\]])/g,"$1");if(A[0].charAt(0)!=="!"){C.state.inLink=!0;var W={type:"link",raw:U,href:j,title:E,text:P,tokens:C.inlineTokens(P)};return C.state.inLink=!1,W}return{type:"image",raw:U,href:j,title:E,text:e(P)}}function ue(A,k){var U=A.match(/^(\s+)(?:```)/);if(U===null)return k;var C=U[1];return k.split(`
`).map(function(j){var E=j.match(/^\s+/);if(E===null)return j;var P=E[0];return P.length>=C.length?j.slice(C.length):j}).join(`
`)}var oe=function(){function A(U){this.options=U||le.defaults}var k=A.prototype;return k.space=function(C){var j=this.rules.block.newline.exec(C);if(j&&j[0].length>0)return{type:"space",raw:j[0]}},k.code=function(C){var j=this.rules.block.code.exec(C);if(j){var E=j[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:j[0],codeBlockStyle:"indented",text:this.options.pedantic?E:_(E,`
`)}}},k.fences=function(C){var j=this.rules.block.fences.exec(C);if(j){var E=j[0],P=ue(E,j[3]||"");return{type:"code",raw:E,lang:j[2]?j[2].trim():j[2],text:P}}},k.heading=function(C){var j=this.rules.block.heading.exec(C);if(j){var E=j[2].trim();if(/#$/.test(E)){var P=_(E,"#");(this.options.pedantic||!P||/ $/.test(P))&&(E=P.trim())}return{type:"heading",raw:j[0],depth:j[1].length,text:E,tokens:this.lexer.inline(E)}}},k.hr=function(C){var j=this.rules.block.hr.exec(C);if(j)return{type:"hr",raw:j[0]}},k.blockquote=function(C){var j=this.rules.block.blockquote.exec(C);if(j){var E=j[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:j[0],tokens:this.lexer.blockTokens(E,[]),text:E}}},k.list=function(C){var j=this.rules.block.list.exec(C);if(j){var E,P,W,x,te,ne,ge,ve,Ce,Ae,De,Me,Oe=j[1].trim(),_e=Oe.length>1,je={type:"list",raw:"",ordered:_e,start:_e?+Oe.slice(0,-1):"",loose:!1,items:[]};Oe=_e?"\\d{1,9}\\"+Oe.slice(-1):"\\"+Oe,this.options.pedantic&&(Oe=_e?Oe:"[*+-]");for(var Re=new RegExp("^( {0,3}"+Oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");C&&(Me=!1,!(!(j=Re.exec(C))||this.rules.block.hr.test(C)));){if(E=j[0],C=C.substring(E.length),ve=j[2].split(`
`,1)[0],Ce=C.split(`
`,1)[0],this.options.pedantic?(x=2,De=ve.trimLeft()):(x=j[2].search(/[^ ]/),x=x>4?1:x,De=ve.slice(x),x+=j[1].length),ne=!1,!ve&&/^ *$/.test(Ce)&&(E+=Ce+`
`,C=C.substring(Ce.length+1),Me=!0),!Me)for(var Ve=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),J=new RegExp("^ {0,"+Math.min(3,x-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),he=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:```|~~~)"),we=new RegExp("^ {0,"+Math.min(3,x-1)+"}#");C&&(Ae=C.split(`
`,1)[0],ve=Ae,this.options.pedantic&&(ve=ve.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(he.test(ve)||we.test(ve)||Ve.test(ve)||J.test(C)));){if(ve.search(/[^ ]/)>=x||!ve.trim())De+=`
`+ve.slice(x);else if(!ne)De+=`
`+ve;else break;!ne&&!ve.trim()&&(ne=!0),E+=Ae+`
`,C=C.substring(Ae.length+1)}je.loose||(ge?je.loose=!0:/\n *\n *$/.test(E)&&(ge=!0)),this.options.gfm&&(P=/^\[[ xX]\] /.exec(De),P&&(W=P[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:E,task:!!P,checked:W,loose:!1,text:De}),je.raw+=E}je.items[je.items.length-1].raw=E.trimRight(),je.items[je.items.length-1].text=De.trimRight(),je.raw=je.raw.trimRight();var Ee=je.items.length;for(te=0;te<Ee;te++){this.lexer.state.top=!1,je.items[te].tokens=this.lexer.blockTokens(je.items[te].text,[]);var Pe=je.items[te].tokens.filter(function(Ue){return Ue.type==="space"}),Be=Pe.every(function(Ue){for(var Ye=Ue.raw.split(""),Ze=0,Qe=q(Ye),We;!(We=Qe()).done;){var tt=We.value;if(tt===`
`&&(Ze+=1),Ze>1)return!0}return!1});!je.loose&&Pe.length&&Be&&(je.loose=!0,je.items[te].loose=!0)}return je}},k.html=function(C){var j=this.rules.block.html.exec(C);if(j){var E={type:"html",raw:j[0],pre:!this.options.sanitizer&&(j[1]==="pre"||j[1]==="script"||j[1]==="style"),text:j[0]};if(this.options.sanitize){var P=this.options.sanitizer?this.options.sanitizer(j[0]):e(j[0]);E.type="paragraph",E.text=P,E.tokens=this.lexer.inline(P)}return E}},k.def=function(C){var j=this.rules.block.def.exec(C);if(j){j[3]&&(j[3]=j[3].substring(1,j[3].length-1));var E=j[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:E,raw:j[0],href:j[2],title:j[3]}}},k.table=function(C){var j=this.rules.block.table.exec(C);if(j){var E={type:"table",header:H(j[1]).map(function(ge){return{text:ge}}),align:j[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:j[3]&&j[3].trim()?j[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(E.header.length===E.align.length){E.raw=j[0];var P=E.align.length,W,x,te,ne;for(W=0;W<P;W++)/^ *-+: *$/.test(E.align[W])?E.align[W]="right":/^ *:-+: *$/.test(E.align[W])?E.align[W]="center":/^ *:-+ *$/.test(E.align[W])?E.align[W]="left":E.align[W]=null;for(P=E.rows.length,W=0;W<P;W++)E.rows[W]=H(E.rows[W],E.header.length).map(function(ge){return{text:ge}});for(P=E.header.length,x=0;x<P;x++)E.header[x].tokens=this.lexer.inline(E.header[x].text);for(P=E.rows.length,x=0;x<P;x++)for(ne=E.rows[x],te=0;te<ne.length;te++)ne[te].tokens=this.lexer.inline(ne[te].text);return E}}},k.lheading=function(C){var j=this.rules.block.lheading.exec(C);if(j)return{type:"heading",raw:j[0],depth:j[2].charAt(0)==="="?1:2,text:j[1],tokens:this.lexer.inline(j[1])}},k.paragraph=function(C){var j=this.rules.block.paragraph.exec(C);if(j){var E=j[1].charAt(j[1].length-1)===`
`?j[1].slice(0,-1):j[1];return{type:"paragraph",raw:j[0],text:E,tokens:this.lexer.inline(E)}}},k.text=function(C){var j=this.rules.block.text.exec(C);if(j)return{type:"text",raw:j[0],text:j[0],tokens:this.lexer.inline(j[0])}},k.escape=function(C){var j=this.rules.inline.escape.exec(C);if(j)return{type:"escape",raw:j[0],text:e(j[1])}},k.tag=function(C){var j=this.rules.inline.tag.exec(C);if(j)return!this.lexer.state.inLink&&/^<a /i.test(j[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(j[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(j[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(j[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:j[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(j[0]):e(j[0]):j[0]}},k.link=function(C){var j=this.rules.inline.link.exec(C);if(j){var E=j[2].trim();if(!this.options.pedantic&&/^</.test(E)){if(!/>$/.test(E))return;var P=_(E.slice(0,-1),"\\");if((E.length-P.length)%2===0)return}else{var W=M(j[2],"()");if(W>-1){var x=j[0].indexOf("!")===0?5:4,te=x+j[1].length+W;j[2]=j[2].substring(0,W),j[0]=j[0].substring(0,te).trim(),j[3]=""}}var ne=j[2],ge="";if(this.options.pedantic){var ve=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ne);ve&&(ne=ve[1],ge=ve[3])}else ge=j[3]?j[3].slice(1,-1):"";return ne=ne.trim(),/^</.test(ne)&&(this.options.pedantic&&!/>$/.test(E)?ne=ne.slice(1):ne=ne.slice(1,-1)),ee(j,{href:ne&&ne.replace(this.rules.inline._escapes,"$1"),title:ge&&ge.replace(this.rules.inline._escapes,"$1")},j[0],this.lexer)}},k.reflink=function(C,j){var E;if((E=this.rules.inline.reflink.exec(C))||(E=this.rules.inline.nolink.exec(C))){var P=(E[2]||E[1]).replace(/\s+/g," ");if(P=j[P.toLowerCase()],!P||!P.href){var W=E[0].charAt(0);return{type:"text",raw:W,text:W}}return ee(E,P,E[0],this.lexer)}},k.emStrong=function(C,j,E){E===void 0&&(E="");var P=this.rules.inline.emStrong.lDelim.exec(C);if(P&&!(P[3]&&E.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var W=P[1]||P[2]||"";if(!W||W&&(E===""||this.rules.inline.punctuation.exec(E))){var x=P[0].length-1,te,ne,ge=x,ve=0,Ce=P[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ce.lastIndex=0,j=j.slice(-1*C.length+x);(P=Ce.exec(j))!=null;)if(te=P[1]||P[2]||P[3]||P[4]||P[5]||P[6],!!te){if(ne=te.length,P[3]||P[4]){ge+=ne;continue}else if((P[5]||P[6])&&x%3&&!((x+ne)%3)){ve+=ne;continue}if(ge-=ne,!(ge>0)){if(ne=Math.min(ne,ne+ge+ve),Math.min(x,ne)%2){var Ae=C.slice(1,x+P.index+ne);return{type:"em",raw:C.slice(0,x+P.index+ne+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}var De=C.slice(2,x+P.index+ne-1);return{type:"strong",raw:C.slice(0,x+P.index+ne+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},k.codespan=function(C){var j=this.rules.inline.code.exec(C);if(j){var E=j[2].replace(/\n/g," "),P=/[^ ]/.test(E),W=/^ /.test(E)&&/ $/.test(E);return P&&W&&(E=E.substring(1,E.length-1)),E=e(E,!0),{type:"codespan",raw:j[0],text:E}}},k.br=function(C){var j=this.rules.inline.br.exec(C);if(j)return{type:"br",raw:j[0]}},k.del=function(C){var j=this.rules.inline.del.exec(C);if(j)return{type:"del",raw:j[0],text:j[2],tokens:this.lexer.inlineTokens(j[2])}},k.autolink=function(C,j){var E=this.rules.inline.autolink.exec(C);if(E){var P,W;return E[2]==="@"?(P=e(this.options.mangle?j(E[1]):E[1]),W="mailto:"+P):(P=e(E[1]),W=P),{type:"link",raw:E[0],text:P,href:W,tokens:[{type:"text",raw:P,text:P}]}}},k.url=function(C,j){var E;if(E=this.rules.inline.url.exec(C)){var P,W;if(E[2]==="@")P=e(this.options.mangle?j(E[0]):E[0]),W="mailto:"+P;else{var x;do x=E[0],E[0]=this.rules.inline._backpedal.exec(E[0])[0];while(x!==E[0]);P=e(E[0]),E[1]==="www."?W="http://"+P:W=P}return{type:"link",raw:E[0],text:P,href:W,tokens:[{type:"text",raw:P,text:P}]}}},k.inlineText=function(C,j){var E=this.rules.inline.text.exec(C);if(E){var P;return this.lexer.state.inRawBlock?P=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(E[0]):e(E[0]):E[0]:P=e(this.options.smartypants?j(E[0]):E[0]),{type:"text",raw:E[0],text:P}}},A}(),se={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};se._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,se._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,se.def=s(se.def).replace("label",se._label).replace("title",se._title).getRegex(),se.bullet=/(?:[*+-]|\d{1,9}[.)])/,se.listItemStart=s(/^( *)(bull) */).replace("bull",se.bullet).getRegex(),se.list=s(se.list).replace(/bull/g,se.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+se.def.source+")").getRegex(),se._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",se._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,se.html=s(se.html,"i").replace("comment",se._comment).replace("tag",se._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),se.paragraph=s(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.blockquote=s(se.blockquote).replace("paragraph",se.paragraph).getRegex(),se.normal=z({},se),se.gfm=z({},se.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),se.gfm.table=s(se.gfm.table).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.gfm.paragraph=s(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",se.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.pedantic=z({},se.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",se._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:s(se.normal._paragraph).replace("hr",se.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",se.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=s(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=s(se._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=s(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=s(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=s(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=s(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=s(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=s(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=s(re.reflink).replace("label",re._label).replace("ref",se._label).getRegex(),re.nolink=s(re.nolink).replace("ref",se._label).getRegex(),re.reflinkSearch=s(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=z({},re),re.pedantic=z({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=z({},re.normal,{escape:s(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),re.gfm.url=s(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=z({},re.gfm,{br:s(re.br).replace("{2,}","*").getRegex(),text:s(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function be(A){return A.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Se(A){var k="",U,C,j=A.length;for(U=0;U<j;U++)C=A.charCodeAt(U),Math.random()>.5&&(C="x"+C.toString(16)),k+="&#"+C+";";return k}var Le=function(){function A(U){this.tokens=[],this.tokens.links=Object.create(null),this.options=U||le.defaults,this.options.tokenizer=this.options.tokenizer||new oe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var C={block:se.normal,inline:re.normal};this.options.pedantic?(C.block=se.pedantic,C.inline=re.pedantic):this.options.gfm&&(C.block=se.gfm,this.options.breaks?C.inline=re.breaks:C.inline=re.gfm),this.tokenizer.rules=C}A.lex=function(C,j){var E=new A(j);return E.lex(C)},A.lexInline=function(C,j){var E=new A(j);return E.inlineTokens(C)};var k=A.prototype;return k.lex=function(C){C=C.replace(/\r\n|\r/g,`
`),this.blockTokens(C,this.tokens);for(var j;j=this.inlineQueue.shift();)this.inlineTokens(j.src,j.tokens);return this.tokens},k.blockTokens=function(C,j){var E=this;j===void 0&&(j=[]),this.options.pedantic?C=C.replace(/\t/g,"    ").replace(/^ +$/gm,""):C=C.replace(/^( *)(\t+)/gm,function(ge,ve,Ce){return ve+"    ".repeat(Ce.length)});for(var P,W,x,te;C;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ge){return(P=ge.call({lexer:E},C,j))?(C=C.substring(P.raw.length),j.push(P),!0):!1}))){if(P=this.tokenizer.space(C)){C=C.substring(P.raw.length),P.raw.length===1&&j.length>0?j[j.length-1].raw+=`
`:j.push(P);continue}if(P=this.tokenizer.code(C)){C=C.substring(P.raw.length),W=j[j.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+P.raw,W.text+=`
`+P.text,this.inlineQueue[this.inlineQueue.length-1].src=W.text):j.push(P);continue}if(P=this.tokenizer.fences(C)){C=C.substring(P.raw.length),j.push(P);continue}if(P=this.tokenizer.heading(C)){C=C.substring(P.raw.length),j.push(P);continue}if(P=this.tokenizer.hr(C)){C=C.substring(P.raw.length),j.push(P);continue}if(P=this.tokenizer.blockquote(C)){C=C.substring(P.raw.length),j.push(P);continue}if(P=this.tokenizer.list(C)){C=C.substring(P.raw.length),j.push(P);continue}if(P=this.tokenizer.html(C)){C=C.substring(P.raw.length),j.push(P);continue}if(P=this.tokenizer.def(C)){C=C.substring(P.raw.length),W=j[j.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+P.raw,W.text+=`
`+P.raw,this.inlineQueue[this.inlineQueue.length-1].src=W.text):this.tokens.links[P.tag]||(this.tokens.links[P.tag]={href:P.href,title:P.title});continue}if(P=this.tokenizer.table(C)){C=C.substring(P.raw.length),j.push(P);continue}if(P=this.tokenizer.lheading(C)){C=C.substring(P.raw.length),j.push(P);continue}if(x=C,this.options.extensions&&this.options.extensions.startBlock&&function(){var ge=1/0,ve=C.slice(1),Ce=void 0;E.options.extensions.startBlock.forEach(function(Ae){Ce=Ae.call({lexer:this},ve),typeof Ce=="number"&&Ce>=0&&(ge=Math.min(ge,Ce))}),ge<1/0&&ge>=0&&(x=C.substring(0,ge+1))}(),this.state.top&&(P=this.tokenizer.paragraph(x))){W=j[j.length-1],te&&W.type==="paragraph"?(W.raw+=`
`+P.raw,W.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):j.push(P),te=x.length!==C.length,C=C.substring(P.raw.length);continue}if(P=this.tokenizer.text(C)){C=C.substring(P.raw.length),W=j[j.length-1],W&&W.type==="text"?(W.raw+=`
`+P.raw,W.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):j.push(P);continue}if(C){var ne="Infinite loop on byte: "+C.charCodeAt(0);if(this.options.silent){console.error(ne);break}else throw new Error(ne)}}return this.state.top=!0,j},k.inline=function(C,j){return j===void 0&&(j=[]),this.inlineQueue.push({src:C,tokens:j}),j},k.inlineTokens=function(C,j){var E=this;j===void 0&&(j=[]);var P,W,x,te=C,ne,ge,ve;if(this.tokens.links){var Ce=Object.keys(this.tokens.links);if(Ce.length>0)for(;(ne=this.tokenizer.rules.inline.reflinkSearch.exec(te))!=null;)Ce.includes(ne[0].slice(ne[0].lastIndexOf("[")+1,-1))&&(te=te.slice(0,ne.index)+"["+Z("a",ne[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ne=this.tokenizer.rules.inline.blockSkip.exec(te))!=null;)te=te.slice(0,ne.index)+"["+Z("a",ne[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ne=this.tokenizer.rules.inline.escapedEmSt.exec(te))!=null;)te=te.slice(0,ne.index)+"++"+te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;C;)if(ge||(ve=""),ge=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(P=De.call({lexer:E},C,j))?(C=C.substring(P.raw.length),j.push(P),!0):!1}))){if(P=this.tokenizer.escape(C)){C=C.substring(P.raw.length),j.push(P);continue}if(P=this.tokenizer.tag(C)){C=C.substring(P.raw.length),W=j[j.length-1],W&&P.type==="text"&&W.type==="text"?(W.raw+=P.raw,W.text+=P.text):j.push(P);continue}if(P=this.tokenizer.link(C)){C=C.substring(P.raw.length),j.push(P);continue}if(P=this.tokenizer.reflink(C,this.tokens.links)){C=C.substring(P.raw.length),W=j[j.length-1],W&&P.type==="text"&&W.type==="text"?(W.raw+=P.raw,W.text+=P.text):j.push(P);continue}if(P=this.tokenizer.emStrong(C,te,ve)){C=C.substring(P.raw.length),j.push(P);continue}if(P=this.tokenizer.codespan(C)){C=C.substring(P.raw.length),j.push(P);continue}if(P=this.tokenizer.br(C)){C=C.substring(P.raw.length),j.push(P);continue}if(P=this.tokenizer.del(C)){C=C.substring(P.raw.length),j.push(P);continue}if(P=this.tokenizer.autolink(C,Se)){C=C.substring(P.raw.length),j.push(P);continue}if(!this.state.inLink&&(P=this.tokenizer.url(C,Se))){C=C.substring(P.raw.length),j.push(P);continue}if(x=C,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Me=C.slice(1),Oe=void 0;E.options.extensions.startInline.forEach(function(_e){Oe=_e.call({lexer:this},Me),typeof Oe=="number"&&Oe>=0&&(De=Math.min(De,Oe))}),De<1/0&&De>=0&&(x=C.substring(0,De+1))}(),P=this.tokenizer.inlineText(x,be)){C=C.substring(P.raw.length),P.raw.slice(-1)!=="_"&&(ve=P.raw.slice(-1)),ge=!0,W=j[j.length-1],W&&W.type==="text"?(W.raw+=P.raw,W.text+=P.text):j.push(P);continue}if(C){var Ae="Infinite loop on byte: "+C.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return j},w(A,null,[{key:"rules",get:function(){return{block:se,inline:re}}}]),A}(),Fe=function(){function A(U){this.options=U||le.defaults}var k=A.prototype;return k.code=function(C,j,E){var P=(j||"").match(/\S*/)[0];if(this.options.highlight){var W=this.options.highlight(C,P);W!=null&&W!==C&&(E=!0,C=W)}return C=C.replace(/\n$/,"")+`
`,P?'<pre><code class="'+this.options.langPrefix+e(P,!0)+'">'+(E?C:e(C,!0))+`</code></pre>
`:"<pre><code>"+(E?C:e(C,!0))+`</code></pre>
`},k.blockquote=function(C){return`<blockquote>
`+C+`</blockquote>
`},k.html=function(C){return C},k.heading=function(C,j,E,P){if(this.options.headerIds){var W=this.options.headerPrefix+P.slug(E);return"<h"+j+' id="'+W+'">'+C+"</h"+j+`>
`}return"<h"+j+">"+C+"</h"+j+`>
`},k.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},k.list=function(C,j,E){var P=j?"ol":"ul",W=j&&E!==1?' start="'+E+'"':"";return"<"+P+W+`>
`+C+"</"+P+`>
`},k.listitem=function(C){return"<li>"+C+`</li>
`},k.checkbox=function(C){return"<input "+(C?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},k.paragraph=function(C){return"<p>"+C+`</p>
`},k.table=function(C,j){return j&&(j="<tbody>"+j+"</tbody>"),`<table>
<thead>
`+C+`</thead>
`+j+`</table>
`},k.tablerow=function(C){return`<tr>
`+C+`</tr>
`},k.tablecell=function(C,j){var E=j.header?"th":"td",P=j.align?"<"+E+' align="'+j.align+'">':"<"+E+">";return P+C+("</"+E+`>
`)},k.strong=function(C){return"<strong>"+C+"</strong>"},k.em=function(C){return"<em>"+C+"</em>"},k.codespan=function(C){return"<code>"+C+"</code>"},k.br=function(){return this.options.xhtml?"<br/>":"<br>"},k.del=function(C){return"<del>"+C+"</del>"},k.link=function(C,j,E){if(C=l(this.options.sanitize,this.options.baseUrl,C),C===null)return E;var P='<a href="'+e(C)+'"';return j&&(P+=' title="'+j+'"'),P+=">"+E+"</a>",P},k.image=function(C,j,E){if(C=l(this.options.sanitize,this.options.baseUrl,C),C===null)return E;var P='<img src="'+C+'" alt="'+E+'"';return j&&(P+=' title="'+j+'"'),P+=this.options.xhtml?"/>":">",P},k.text=function(C){return C},A}(),de=function(){function A(){}var k=A.prototype;return k.strong=function(C){return C},k.em=function(C){return C},k.codespan=function(C){return C},k.del=function(C){return C},k.html=function(C){return C},k.text=function(C){return C},k.link=function(C,j,E){return""+E},k.image=function(C,j,E){return""+E},k.br=function(){return""},A}(),ie=function(){function A(){this.seen={}}var k=A.prototype;return k.serialize=function(C){return C.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},k.getNextSafeSlug=function(C,j){var E=C,P=0;if(this.seen.hasOwnProperty(E)){P=this.seen[C];do P++,E=C+"-"+P;while(this.seen.hasOwnProperty(E))}return j||(this.seen[C]=P,this.seen[E]=0),E},k.slug=function(C,j){j===void 0&&(j={});var E=this.serialize(C);return this.getNextSafeSlug(E,j.dryrun)},A}(),ce=function(){function A(U){this.options=U||le.defaults,this.options.renderer=this.options.renderer||new Fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new ie}A.parse=function(C,j){var E=new A(j);return E.parse(C)},A.parseInline=function(C,j){var E=new A(j);return E.parseInline(C)};var k=A.prototype;return k.parse=function(C,j){j===void 0&&(j=!0);var E="",P,W,x,te,ne,ge,ve,Ce,Ae,De,Me,Oe,_e,je,Re,Ve,J,he,we,Ee=C.length;for(P=0;P<Ee;P++){if(De=C[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(we=this.options.extensions.renderers[De.type].call({parser:this},De),we!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){E+=we||"";continue}switch(De.type){case"space":continue;case"hr":{E+=this.renderer.hr();continue}case"heading":{E+=this.renderer.heading(this.parseInline(De.tokens),De.depth,h(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{E+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(Ce="",ve="",te=De.header.length,W=0;W<te;W++)ve+=this.renderer.tablecell(this.parseInline(De.header[W].tokens),{header:!0,align:De.align[W]});for(Ce+=this.renderer.tablerow(ve),Ae="",te=De.rows.length,W=0;W<te;W++){for(ge=De.rows[W],ve="",ne=ge.length,x=0;x<ne;x++)ve+=this.renderer.tablecell(this.parseInline(ge[x].tokens),{header:!1,align:De.align[x]});Ae+=this.renderer.tablerow(ve)}E+=this.renderer.table(Ce,Ae);continue}case"blockquote":{Ae=this.parse(De.tokens),E+=this.renderer.blockquote(Ae);continue}case"list":{for(Me=De.ordered,Oe=De.start,_e=De.loose,te=De.items.length,Ae="",W=0;W<te;W++)Re=De.items[W],Ve=Re.checked,J=Re.task,je="",Re.task&&(he=this.renderer.checkbox(Ve),_e?Re.tokens.length>0&&Re.tokens[0].type==="paragraph"?(Re.tokens[0].text=he+" "+Re.tokens[0].text,Re.tokens[0].tokens&&Re.tokens[0].tokens.length>0&&Re.tokens[0].tokens[0].type==="text"&&(Re.tokens[0].tokens[0].text=he+" "+Re.tokens[0].tokens[0].text)):Re.tokens.unshift({type:"text",text:he}):je+=he),je+=this.parse(Re.tokens,_e),Ae+=this.renderer.listitem(je,J,Ve);E+=this.renderer.list(Ae,Me,Oe);continue}case"html":{E+=this.renderer.html(De.text);continue}case"paragraph":{E+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Ae=De.tokens?this.parseInline(De.tokens):De.text;P+1<Ee&&C[P+1].type==="text";)De=C[++P],Ae+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);E+=j?this.renderer.paragraph(Ae):Ae;continue}default:{var Pe='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return E},k.parseInline=function(C,j){j=j||this.renderer;var E="",P,W,x,te=C.length;for(P=0;P<te;P++){if(W=C[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(x=this.options.extensions.renderers[W.type].call({parser:this},W),x!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(W.type))){E+=x||"";continue}switch(W.type){case"escape":{E+=j.text(W.text);break}case"html":{E+=j.html(W.text);break}case"link":{E+=j.link(W.href,W.title,this.parseInline(W.tokens,j));break}case"image":{E+=j.image(W.href,W.title,W.text);break}case"strong":{E+=j.strong(this.parseInline(W.tokens,j));break}case"em":{E+=j.em(this.parseInline(W.tokens,j));break}case"codespan":{E+=j.codespan(W.text);break}case"br":{E+=j.br();break}case"del":{E+=j.del(this.parseInline(W.tokens,j));break}case"text":{E+=j.text(W.text);break}default:{var ne='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return E},A}();function Y(A,k,U){if(typeof A>"u"||A===null)throw new Error("marked(): input parameter is undefined or null");if(typeof A!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(A)+", string expected");if(typeof k=="function"&&(U=k,k=null),k=z({},Y.defaults,k||{}),F(k),U){var C=k.highlight,j;try{j=Le.lex(A,k)}catch(te){return U(te)}var E=function(ne){var ge;if(!ne)try{k.walkTokens&&Y.walkTokens(j,k.walkTokens),ge=ce.parse(j,k)}catch(ve){ne=ve}return k.highlight=C,ne?U(ne):U(null,ge)};if(!C||C.length<3||(delete k.highlight,!j.length))return E();var P=0;Y.walkTokens(j,function(te){te.type==="code"&&(P++,setTimeout(function(){C(te.text,te.lang,function(ne,ge){if(ne)return E(ne);ge!=null&&ge!==te.text&&(te.text=ge,te.escaped=!0),P--,P===0&&E()})},0))}),P===0&&E();return}function W(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,k.silent)return"<p>An error occurred:</p><pre>"+e(te.message+"",!0)+"</pre>";throw te}try{var x=Le.lex(A,k);if(k.walkTokens){if(k.async)return Promise.all(Y.walkTokens(x,k.walkTokens)).then(function(){return ce.parse(x,k)}).catch(W);Y.walkTokens(x,k.walkTokens)}return ce.parse(x,k)}catch(te){W(te)}}Y.options=Y.setOptions=function(A){return z(Y.defaults,A),D(Y.defaults),Y},Y.getDefaults=p,Y.defaults=le.defaults,Y.use=function(){for(var A=arguments.length,k=new Array(A),U=0;U<A;U++)k[U]=arguments[U];var C=z.apply(void 0,[{}].concat(k)),j=Y.defaults.extensions||{renderers:{},childTokens:{}},E;k.forEach(function(P){if(P.extensions&&(E=!0,P.extensions.forEach(function(x){if(!x.name)throw new Error("extension name required");if(x.renderer){var te=j.renderers?j.renderers[x.name]:null;te?j.renderers[x.name]=function(){for(var ne=arguments.length,ge=new Array(ne),ve=0;ve<ne;ve++)ge[ve]=arguments[ve];var Ce=x.renderer.apply(this,ge);return Ce===!1&&(Ce=te.apply(this,ge)),Ce}:j.renderers[x.name]=x.renderer}if(x.tokenizer){if(!x.level||x.level!=="block"&&x.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");j[x.level]?j[x.level].unshift(x.tokenizer):j[x.level]=[x.tokenizer],x.start&&(x.level==="block"?j.startBlock?j.startBlock.push(x.start):j.startBlock=[x.start]:x.level==="inline"&&(j.startInline?j.startInline.push(x.start):j.startInline=[x.start]))}x.childTokens&&(j.childTokens[x.name]=x.childTokens)})),P.renderer&&function(){var x=Y.defaults.renderer||new Fe,te=function(ve){var Ce=x[ve];x[ve]=function(){for(var Ae=arguments.length,De=new Array(Ae),Me=0;Me<Ae;Me++)De[Me]=arguments[Me];var Oe=P.renderer[ve].apply(x,De);return Oe===!1&&(Oe=Ce.apply(x,De)),Oe}};for(var ne in P.renderer)te(ne);C.renderer=x}(),P.tokenizer&&function(){var x=Y.defaults.tokenizer||new oe,te=function(ve){var Ce=x[ve];x[ve]=function(){for(var Ae=arguments.length,De=new Array(Ae),Me=0;Me<Ae;Me++)De[Me]=arguments[Me];var Oe=P.tokenizer[ve].apply(x,De);return Oe===!1&&(Oe=Ce.apply(x,De)),Oe}};for(var ne in P.tokenizer)te(ne);C.tokenizer=x}(),P.walkTokens){var W=Y.defaults.walkTokens;C.walkTokens=function(x){var te=[];return te.push(P.walkTokens.call(this,x)),W&&(te=te.concat(W.call(this,x))),te}}E&&(C.extensions=j),Y.setOptions(C)})},Y.walkTokens=function(A,k){for(var U=[],C=function(){var W=E.value;switch(U=U.concat(k.call(Y,W)),W.type){case"table":{for(var x=q(W.header),te;!(te=x()).done;){var ne=te.value;U=U.concat(Y.walkTokens(ne.tokens,k))}for(var ge=q(W.rows),ve;!(ve=ge()).done;)for(var Ce=ve.value,Ae=q(Ce),De;!(De=Ae()).done;){var Me=De.value;U=U.concat(Y.walkTokens(Me.tokens,k))}break}case"list":{U=U.concat(Y.walkTokens(W.items,k));break}default:Y.defaults.extensions&&Y.defaults.extensions.childTokens&&Y.defaults.extensions.childTokens[W.type]?Y.defaults.extensions.childTokens[W.type].forEach(function(Oe){U=U.concat(Y.walkTokens(W[Oe],k))}):W.tokens&&(U=U.concat(Y.walkTokens(W.tokens,k)))}},j=q(A),E;!(E=j()).done;)C();return U},Y.parseInline=function(A,k){if(typeof A>"u"||A===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof A!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(A)+", string expected");k=z({},Y.defaults,k||{}),F(k);try{var U=Le.lexInline(A,k);return k.walkTokens&&Y.walkTokens(U,k.walkTokens),ce.parseInline(U,k)}catch(C){if(C.message+=`
Please report this to https://github.com/markedjs/marked.`,k.silent)return"<p>An error occurred:</p><pre>"+e(C.message+"",!0)+"</pre>";throw C}},Y.Parser=ce,Y.parser=ce.parse,Y.Renderer=Fe,Y.TextRenderer=de,Y.Lexer=Le,Y.lexer=Le.lex,Y.Tokenizer=oe,Y.Slugger=ie,Y.parse=Y;var V=Y.options,G=Y.setOptions,S=Y.use,Q=Y.walkTokens,b=Y.parseInline,R=Y,B=ce.parse,N=Le.lex;le.Lexer=Le,le.Parser=ce,le.Renderer=Fe,le.Slugger=ie,le.TextRenderer=de,le.Tokenizer=oe,le.getDefaults=p,le.lexer=N,le.marked=Y,le.options=V,le.parse=R,le.parseInline=b,le.parser=B,le.setOptions=G,le.use=S,le.walkTokens=Q,Object.defineProperty(le,"__esModule",{value:!0})}),define($e[79],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5R=void 0;class w{constructor(i,q=0,p=i.length,D=q-1){this.a=i,this.b=q,this.c=p,this.d=D}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$5R=w}),define($e[80],pe([1,0,79]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7R=t.$6R=void 0;class O{constructor(p=[],D=10){this.h(p),this.b=D,this.d()}getHistory(){return this.j}add(p){this.a.delete(p),this.a.add(p),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(p){return this.a.has(p)}clear(){this.h([]),this.d()}d(){this.f();const p=this.j;this.c=new w.$5R(p,0,p.length,p.length)}f(){const p=this.j;p.length>this.b&&this.h(p.slice(p.length-this.b))}g(){const p=this.c.current();return p?this.j.indexOf(p):-1}h(p){this.a=new Set;for(const D of p)this.a.add(D)}get j(){const p=[];return this.a.forEach(D=>p.push(D)),p}}t.$6R=O;class i{get size(){return this.f}constructor(p,D=10){if(this.g=D,p.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:p[0],previous:void 0,next:void 0},this.a=new Set([p[0]]);for(let c=1;c<p.length;c++)this.add(p[c])}add(p){const D={value:p,previous:this.c,next:void 0};for(this.c.next=D,this.c=D,this.d=this.c,this.f++,this.a.has(p)?this.h(p):this.a.add(p);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(p){if(this.c.value===p)return p;const D=this.c.value;return this.a.delete(D),this.c.value=p,this.a.has(p)?this.h(p):this.a.add(p),D}prepend(p){if(this.f===this.g||this.a.has(p))return;const D={value:p,previous:void 0,next:this.b};this.b.previous=D,this.b=D,this.f++,this.a.add(p)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(p){return this.a.has(p)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let p=this.b;for(;p;)yield p.value,p=p.next}h(p){let D=this.b;for(;D!==this.c;)D.value===p&&(D===this.b?(this.b=this.b.next,this.b.previous=void 0):(D.previous.next=D.next,D.next.previous=D.previous),this.f--),D=D.next}}t.$7R=i}),define($e[45],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sl=t.$Rl=t.$Ql=t.rot=t.$Ol=void 0;function w(D,c,f){return Math.min(Math.max(D,c),f)}t.$Ol=w;function O(D,c){return(c+D%c)%c}t.rot=O;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$Ql=i;class q{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Rl=q;class p{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const f=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Sl=p}),define($e[46],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var w;(function(O){function i(c,f){if(c.start>=f.end||f.start>=c.end)return{start:0,end:0};const m=Math.max(c.start,f.start),L=Math.min(c.end,f.end);return L-m<=0?{start:0,end:0}:{start:m,end:L}}O.intersect=i;function q(c){return c.end-c.start<=0}O.isEmpty=q;function p(c,f){return!q(i(c,f))}O.intersects=p;function D(c,f){const m=[],L={start:c.start,end:Math.min(f.start,c.end)},n={start:Math.max(f.end,c.start),end:c.end};return q(L)||m.push(L),q(n)||m.push(n),m}O.relativeComplement=D})(w||(t.Range=w={}))}),define($e[81],pe([1,0,46]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XQ=t.$WQ=t.$VQ=t.$UQ=void 0;function O(c,f){const m=[];for(const L of f){if(c.start>=L.range.end)continue;if(c.end<L.range.start)break;const n=w.Range.intersect(c,L.range);w.Range.isEmpty(n)||m.push({range:n,size:L.size})}return m}t.$UQ=O;function i({start:c,end:f},m){return{start:c+m,end:f+m}}t.$VQ=i;function q(c){const f=[];let m=null;for(const L of c){const n=L.range.start,o=L.range.end,e=L.size;if(m&&e===m.size){m.range.end=o;continue}m={range:{start:n,end:o},size:e},f.push(m)}return f}t.$WQ=q;function p(...c){return q(c.reduce((f,m)=>f.concat(m),[]))}class D{get paddingTop(){return this.c}set paddingTop(f){this.b=this.b+f-this.c,this.c=f}constructor(f){this.a=[],this.b=0,this.c=0,this.c=f??0,this.b=this.c}splice(f,m,L=[]){const n=L.length-m,o=O({start:0,end:f},this.a),e=O({start:f+m,end:Number.POSITIVE_INFINITY},this.a).map(h=>({range:i(h.range,n),size:h.size})),a=L.map((h,$)=>({range:{start:f+$,end:f+$+1},size:h.size}));this.a=p(o,a,e),this.b=this.c+this.a.reduce((h,$)=>h+$.size*($.range.end-$.range.start),0)}get count(){const f=this.a.length;return f?this.a[f-1].range.end:0}get size(){return this.b}indexAt(f){if(f<0)return-1;if(f<this.c)return 0;let m=0,L=this.c;for(const n of this.a){const o=n.range.end-n.range.start,e=L+o*n.size;if(f<e)return m+Math.floor((f-L)/n.size);m+=o,L=e}return m}indexAfter(f){return Math.min(this.indexAt(f)+1,this.count)}positionAt(f){if(f<0)return-1;let m=0,L=0;for(const n of this.a){const o=n.range.end-n.range.start,e=L+o;if(f<e)return this.c+m+(f-L)*n.size;m+=o*n.size,L=e}return-1}}t.$XQ=D}),define($e[82],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jd=void 0;const w=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(q){return new O(q)}constructor(q){this.c=w&&q===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Jd=O}),define($e[4],pe([1,0,6,42,2,44,82]),function(le,t,w,O,i,q,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.Event=void 0;const D=!1,c=!1;var f;(function(_){_.None=()=>i.$Rc.None;function M(j){if(c){const{onDidAddListener:E}=j,P=e.create();let W=0;j.onDidAddListener=()=>{++W===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),P.print()),E?.()}}}function F(j,E){return Fe(j,()=>{},0,void 0,!0,void 0,E)}_.defer=F;function Z(j){return(E,P=null,W)=>{let x=!1,te;return te=j(ne=>{if(!x)return te?te.dispose():x=!0,E.call(P,ne)},null,W),x&&te.dispose(),te}}_.once=Z;function ee(j,E,P){return Se((W,x=null,te)=>j(ne=>W.call(x,E(ne)),null,te),P)}_.map=ee;function ue(j,E,P){return Se((W,x=null,te)=>j(ne=>{E(ne),W.call(x,ne)},null,te),P)}_.forEach=ue;function oe(j,E,P){return Se((W,x=null,te)=>j(ne=>E(ne)&&W.call(x,ne),null,te),P)}_.filter=oe;function se(j){return j}_.signal=se;function re(...j){return(E,P=null,W)=>{const x=(0,i.$Oc)(...j.map(te=>te(ne=>E.call(P,ne))));return Le(x,W)}}_.any=re;function be(j,E,P,W){let x=P;return ee(j,te=>(x=E(x,te),x),W)}_.reduce=be;function Se(j,E){let P;const W={onWillAddFirstListener(){P=j(x.fire,x)},onDidRemoveLastListener(){P?.dispose()}};E||M(W);const x=new u(W);return E?.add(x),x.event}function Le(j,E){return E instanceof Array?E.push(j):E&&E.add(j),j}function Fe(j,E,P=100,W=!1,x=!1,te,ne){let ge,ve,Ce,Ae=0,De;const Me={leakWarningThreshold:te,onWillAddFirstListener(){ge=j(_e=>{Ae++,ve=E(ve,_e),W&&!Ce&&(Oe.fire(ve),ve=void 0),De=()=>{const je=ve;ve=void 0,Ce=void 0,(!W||Ae>1)&&Oe.fire(je),Ae=0},typeof P=="number"?(clearTimeout(Ce),Ce=setTimeout(De,P)):Ce===void 0&&(Ce=0,queueMicrotask(De))})},onWillRemoveListener(){x&&Ae>0&&De?.()},onDidRemoveLastListener(){De=void 0,ge.dispose()}};ne||M(Me);const Oe=new u(Me);return ne?.add(Oe),Oe.event}_.debounce=Fe;function de(j,E=0,P){return _.debounce(j,(W,x)=>W?(W.push(x),W):[x],E,void 0,!0,void 0,P)}_.accumulate=de;function ie(j,E=(W,x)=>W===x,P){let W=!0,x;return oe(j,te=>{const ne=W||!E(te,x);return W=!1,x=te,ne},P)}_.latch=ie;function ce(j,E,P){return[_.filter(j,E,P),_.filter(j,W=>!E(W),P)]}_.split=ce;function Y(j,E=!1,P=[],W){let x=P.slice(),te=j(ve=>{x?x.push(ve):ge.fire(ve)});W&&W.add(te);const ne=()=>{x?.forEach(ve=>ge.fire(ve)),x=null},ge=new u({onWillAddFirstListener(){te||(te=j(ve=>ge.fire(ve)),W&&W.add(te))},onDidAddFirstListener(){x&&(E?setTimeout(ne):ne())},onDidRemoveLastListener(){te&&te.dispose(),te=null}});return W&&W.add(ge),ge.event}_.buffer=Y;function V(j,E){return(W,x,te)=>{const ne=E(new S);return j(function(ge){const ve=ne.evaluate(ge);ve!==G&&W.call(x,ve)},void 0,te)}}_.chain=V;const G=Symbol("HaltChainable");class S{constructor(){this.f=[]}map(E){return this.f.push(E),this}forEach(E){return this.f.push(P=>(E(P),P)),this}filter(E){return this.f.push(P=>E(P)?P:G),this}reduce(E,P){let W=P;return this.f.push(x=>(W=E(W,x),W)),this}latch(E=(P,W)=>P===W){let P=!0,W;return this.f.push(x=>{const te=P||!E(x,W);return P=!1,W=x,te?x:G}),this}evaluate(E){for(const P of this.f)if(E=P(E),E===G)break;return E}}function Q(j,E,P=W=>W){const W=(...ge)=>ne.fire(P(...ge)),x=()=>j.on(E,W),te=()=>j.removeListener(E,W),ne=new u({onWillAddFirstListener:x,onDidRemoveLastListener:te});return ne.event}_.fromNodeEventEmitter=Q;function b(j,E,P=W=>W){const W=(...ge)=>ne.fire(P(...ge)),x=()=>j.addEventListener(E,W),te=()=>j.removeEventListener(E,W),ne=new u({onWillAddFirstListener:x,onDidRemoveLastListener:te});return ne.event}_.fromDOMEventEmitter=b;function R(j){return new Promise(E=>Z(j)(E))}_.toPromise=R;function B(j){const E=new u;return j.then(P=>{E.fire(P)},()=>{E.fire(void 0)}).finally(()=>{E.dispose()}),E.event}_.fromPromise=B;function N(j,E,P){return E(P),j(W=>E(W))}_.runAndSubscribe=N;function A(j,E){let P=null;function W(te){P?.dispose(),P=new i.$Qc,E(te,P)}W(void 0);const x=j(te=>W(te));return(0,i.$Pc)(()=>{x.dispose(),P?.dispose()})}_.runAndSubscribeWithStore=A;class k{constructor(E,P){this._observable=E,this.f=0,this.g=!1;const W={onWillAddFirstListener:()=>{E.addObserver(this)},onDidRemoveLastListener:()=>{E.removeObserver(this)}};P||M(W),this.emitter=new u(W),P&&P.add(this.emitter)}beginUpdate(E){this.f++}handlePossibleChange(E){}handleChange(E,P){this.g=!0}endUpdate(E){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function U(j,E){return new k(j,E).emitter.event}_.fromObservable=U;function C(j){return E=>{let P=0,W=!1;const x={beginUpdate(){P++},endUpdate(){P--,P===0&&(j.reportChanges(),W&&(W=!1,E()))},handlePossibleChange(){},handleChange(){W=!0}};return j.addObserver(x),j.reportChanges(),{dispose(){j.removeObserver(x)}}}}_.fromObservableLight=C})(f||(t.Event=f={}));class m{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${m.f++}`,m.all.add(this)}start(M){this.g=new p.$Jd,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}t.$Ld=m;let L=-1;function n(_){const M=L;return L=_,{dispose(){L=M}}}t.$Md=n;class o{constructor(M,F=Math.random().toString(18).slice(2,5)){this.threshold=M,this.name=F,this.g=0}dispose(){this.f?.clear()}check(M,F){const Z=this.threshold;if(Z<=0||F<Z)return;this.f||(this.f=new Map);const ee=this.f.get(M.value)||0;if(this.f.set(M.value,ee+1),this.g-=1,this.g<=0){this.g=Z*.5;let ue,oe=0;for(const[se,re]of this.f)(!ue||oe<re)&&(ue=se,oe=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${oe}):`),console.warn(ue)}return()=>{const ue=this.f.get(M.value)||0;this.f.set(M.value,ue-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let a=0;class h{constructor(M){this.value=M,this.id=a++}}const $=2,s=(_,M)=>{if(_ instanceof h)M(_);else for(let F=0;F<_.length;F++){const Z=_[F];Z&&M(Z)}};class u{constructor(M){this.w=0,this.f=M,this.g=L>0||this.f?.leakWarningThreshold?new o(this.f?.leakWarningThreshold??L):void 0,this.j=this.f?._profName?new m(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(D){const M=this.t;queueMicrotask(()=>{s(M,F=>F.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,F,Z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$Rc.None;if(this.m)return i.$Rc.None;F&&(M=M.bind(F));const ee=new h(M);let ue,oe;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ee.stack=e.create(),ue=this.g.check(ee.stack,this.w+1)),D&&(ee.stack=oe??e.create()),this.t?this.t instanceof h?(this.u??=new l,this.t=[this.t,ee]):this.t.push(ee):(this.f?.onWillAddFirstListener?.(this),this.t=ee,this.f?.onDidAddFirstListener?.(this)),this.w++;const se=(0,i.$Pc)(()=>{ue?.(),this.x(ee)});return Z instanceof i.$Qc?Z.add(se):Array.isArray(Z)&&Z.push(se),se},this.q}x(M){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const F=this.t,Z=F.indexOf(M);if(Z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,F[Z]=void 0;const ee=this.u.current===this;if(this.w*$<=F.length){let ue=0;for(let oe=0;oe<F.length;oe++)F[oe]?F[ue++]=F[oe]:ee&&(this.u.end--,ue<this.u.i&&this.u.i--);F.length=ue}}y(M,F){if(!M)return;const Z=this.f?.onListenerError||w.$Z;if(!Z){M.value(F);return}try{M.value(F)}catch(ee){Z(ee)}}z(M){const F=M.current.t;for(;M.i<M.end;)this.y(F[M.i++],M.value);M.reset()}fire(M){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof h)this.y(this.t,M);else{const F=this.u;F.enqueue(this,M,this.t.length),this.z(F)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Nd=u;const d=()=>new l;t.$Od=d;class l{constructor(){this.i=-1,this.end=0}enqueue(M,F,Z){this.i=0,this.end=Z,this.current=M,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends u{async fireAsync(M,F,Z){if(this.t)for(this.h||(this.h=new q.$1c),s(this.t,ee=>this.h.push([ee.value,M]));this.h.size>0&&!F.isCancellationRequested;){const[ee,ue]=this.h.shift(),oe=[],se={...ue,token:F,waitUntil:re=>{if(Object.isFrozen(oe))throw new Error("waitUntil can NOT be called asynchronous");Z&&(re=Z(re,ee)),oe.push(re)}};try{ee(se)}catch(re){(0,w.$Z)(re);continue}Object.freeze(oe),await Promise.allSettled(oe).then(re=>{for(const be of re)be.status==="rejected"&&(0,w.$Z)(be.reason)})}}}t.$Pd=r;class y extends u{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new q.$1c,this.A=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.A(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.w&&(this.h!==0?this.s.push(M):super.fire(M))}}t.$Qd=y;class I extends y{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}t.$Rd=I;class T extends u{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}t.$Sd=T;class g{constructor(){this.g=!1,this.h=[],this.f=new u({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const F={event:M,listener:null};this.h.push(F),this.g&&this.m(F);const Z=()=>{this.g&&this.o(F);const ee=this.h.indexOf(F);this.h.splice(ee,1)};return(0,i.$Pc)((0,O.$cb)(Z))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(F=>this.f.fire(F))}o(M){M.listener&&M.listener.dispose(),M.listener=null}dispose(){this.f.dispose()}}t.$Td=g;class v{constructor(M,F,Z,ee){this.f=new i.$Qc;const ue=this.f.add(new g),oe=this.f.add(new i.$Zc);function se(re){oe.set(re,ue.add(ee(re)))}for(const re of M)se(re);this.f.add(F(re=>{se(re)})),this.f.add(Z(re=>{oe.deleteAndDispose(re)})),this.event=ue.event}dispose(){this.f.dispose()}}t.$Ud=v;class z{constructor(){this.f=[]}wrapEvent(M){return(F,Z,ee)=>M(ue=>{const oe=this.f[this.f.length-1];oe?oe.push(()=>F.call(Z,ue)):F.call(Z,ue)},void 0,ee)}bufferEvents(M){const F=[];this.f.push(F);const Z=M();return this.f.pop(),F.forEach(ee=>ee()),Z}}t.$Vd=z;class H{constructor(){this.f=!1,this.g=f.None,this.h=i.$Rc.None,this.j=new u({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Wd=H}),define($e[16],pe([1,0,4,2]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DO=t.$CO=t.$BO=t.$AO=t.$zO=t.$yO=t.$xO=t.$wO=t.$vO=t.$uO=t.$tO=t.$sO=t.$rO=t.$qO=t.$pO=t.$oO=t.$nO=t.$mO=void 0;class i{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new w.$Nd,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new i}getZoomLevel(){return this.a}setZoomLevel(d){this.a!==d&&(this.a=d)}getZoomFactor(){return this.b}setZoomFactor(d){this.b=d}setFullscreen(d){this.c!==d&&(this.c=d,this.d.fire())}isFullscreen(){return this.c}}class q extends O.$Rc{constructor(){super(),this.a=this.B(new w.$Nd),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(d){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),d&&this.a.fire()}}class p extends O.$Rc{get value(){return this.b}constructor(){super(),this.a=this.B(new w.$Nd),this.onDidChange=this.a.event,this.b=this.c();const d=this.B(new q);this.B(d.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const d=document.createElement("canvas").getContext("2d"),l=window.devicePixelRatio||1,r=d.webkitBackingStorePixelRatio||d.mozBackingStorePixelRatio||d.msBackingStorePixelRatio||d.oBackingStorePixelRatio||d.backingStorePixelRatio||1;return l/r}}class D{constructor(){this.a=null}b(){return this.a||(this.a=(0,O.$Kc)(new p)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function c(u,d){typeof u=="string"&&(u=window.matchMedia(u)),u.addEventListener("change",d)}t.$mO=c,t.$nO=new D;function f(u){i.INSTANCE.setZoomLevel(u)}t.$oO=f;function m(){return i.INSTANCE.getZoomLevel()}t.$pO=m;function L(){return i.INSTANCE.getZoomFactor()}t.$qO=L;function n(u){i.INSTANCE.setZoomFactor(u)}t.$rO=n;function o(u){i.INSTANCE.setFullscreen(u)}t.$sO=o;function e(){return i.INSTANCE.isFullscreen()}t.$tO=e,t.$uO=i.INSTANCE.onDidChangeFullscreen;const a=navigator.userAgent;t.$vO=a.indexOf("Firefox")>=0,t.$wO=a.indexOf("AppleWebKit")>=0,t.$xO=a.indexOf("Chrome")>=0,t.$yO=!t.$xO&&a.indexOf("Safari")>=0,t.$zO=!t.$xO&&!t.$yO&&t.$wO,t.$AO=a.indexOf("Electron/")>=0,t.$BO=a.indexOf("Android")>=0;let h=!1;if(window.matchMedia){const u=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),d=window.matchMedia("(display-mode: fullscreen)");h=u.matches,c(u,({matches:l})=>{h&&d.matches||(h=l)})}function $(){return h}t.$CO=$;function s(){return navigator?.windowControlsOverlay?.visible}t.$DO=s}),define($e[21],pe([1,0,4]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MQ=void 0;class O{get event(){return this.a.event}constructor(q,p,D){const c=f=>this.a.fire(f);this.a=new w.$Nd({onWillAddFirstListener:()=>q.addEventListener(p,c,D),onDidRemoveLastListener:()=>q.removeEventListener(p,c,D)})}dispose(){this.a.dispose()}}t.$MQ=O}),define($e[28],pe([1,0,4]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xd=t.CancellationToken=void 0;const O=Object.freeze(function(D,c){const f=setTimeout(D.bind(c),0);return{dispose(){clearTimeout(f)}}});var i;(function(D){function c(f){return f===D.None||f===D.Cancelled||f instanceof q?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}D.isCancellationToken=c,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(i||(t.CancellationToken=i={}));class q{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new w.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class p{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new q),this.f}cancel(){this.f?this.f instanceof q&&this.f.cancel():this.f=i.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof q&&this.f.dispose():this.f=i.None}}t.$Xd=p}),define($e[83],pe([1,0,28]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ye=t.$xe=t.$we=void 0;class O{constructor(D){this.b=D,this.a=null}get(){if(this.a)return this.a;const D=new w.$Xd,c=this.b(D.token);return this.a={promise:c,dispose:()=>{this.a=null,D.cancel(),D.dispose()}},this.a}}t.$we=O;class i{constructor(D){this.c=D,this.a=void 0,this.b=void 0}get(D){const c=JSON.stringify(D);return this.b!==c&&(this.b=c,this.a=this.c(D)),this.a}}t.$xe=i;class q{get cachedValues(){return this.a}constructor(D){this.b=D,this.a=new Map}get(D){if(this.a.has(D))return this.a.get(D);const c=this.b(D);return this.a.set(D,c),c}}t.$ye=q}),define($e[47],pe([1,0,4,2]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1r=t.$Zr=t.$Yr=t.$Xr=t.ScrollbarVisibility=void 0;var i;(function(o){o[o.Auto=1]="Auto",o[o.Hidden=2]="Hidden",o[o.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class q{constructor(e,a,h,$,s,u,d){this.c=e,this._scrollStateBrand=void 0,this.c&&(a=a|0,h=h|0,$=$|0,s=s|0,u=u|0,d=d|0),this.rawScrollLeft=$,this.rawScrollTop=d,a<0&&(a=0),$+a>h&&($=h-a),$<0&&($=0),s<0&&(s=0),d+s>u&&(d=u-s),d<0&&(d=0),this.width=a,this.scrollWidth=h,this.scrollLeft=$,this.height=s,this.scrollHeight=u,this.scrollTop=d}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,a){return new q(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new q(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,a){const h=this.width!==e.width,$=this.scrollWidth!==e.scrollWidth,s=this.scrollLeft!==e.scrollLeft,u=this.height!==e.height,d=this.scrollHeight!==e.scrollHeight,l=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:a,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:h,scrollWidthChanged:$,scrollLeftChanged:s,heightChanged:u,scrollHeightChanged:d,scrollTopChanged:l}}}t.$Xr=q;class p extends O.$Rc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new w.$Nd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new q(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,a){const h=this.g.withScrollDimensions(e,a);this.n(h,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const a=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(a,!1)}setScrollPositionSmooth(e,a){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const h=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===h.scrollLeft&&this.h.to.scrollTop===h.scrollTop)return;let $;a?$=new m(this.h.from,h,this.h.startTime,this.h.duration):$=this.h.combine(this.g,h,this.c),this.h.dispose(),this.h=$}else{const h=this.g.withScrollPosition(e);this.h=m.start(this.g,h,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),a=this.g.withScrollPosition(e);if(this.n(a,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,a){const h=this.g;h.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(h,a)))}}t.$Yr=p;class D{constructor(e,a,h){this.scrollLeft=e,this.scrollTop=a,this.isDone=h}}t.$Zr=D;function c(o,e){const a=e-o;return function(h){return o+a*n(h)}}function f(o,e,a){return function(h){return h<a?o(h/a):e((h-a)/(1-a))}}class m{constructor(e,a,h,$){this.from=e,this.to=a,this.duration=$,this.startTime=h,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,a,h){if(Math.abs(e-a)>2.5*h){let s,u;return e<a?(s=e+.75*h,u=a-.75*h):(s=e-.75*h,u=a+.75*h),f(c(e,s),c(u,a),.33)}return c(e,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const a=(e-this.startTime)/this.duration;if(a<1){const h=this.c(a),$=this.d(a);return new D(h,$,!1)}return new D(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,a,h){return m.start(e,a,h)}static start(e,a,h){h=h+10;const $=Date.now()-10;return new m(e,a,$,h)}}t.$1r=m;function L(o){return Math.pow(o,3)}function n(o){return 1-L(1-o)}}),define($e[84],pe([1,0,6,2]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=void 0;function i(d){const l=d;return l?typeof l.read=="function":!1}t.$Yd=i;function q(d){const l=d;return l?[l.on,l.pause,l.resume,l.destroy].every(r=>typeof r=="function"):!1}t.$Zd=q;function p(d){const l=d;return l?q(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}t.$1d=p;function D(d,l){return new c(d,l)}t.$2d=D;class c{constructor(l,r){this.e=l,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(r=>r(l))}h(l){this.c.error.length===0?(0,w.$Z)(l):this.c.error.slice(0).forEach(r=>r(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,r){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(l,r){if(this.a.destroyed)return;let y;switch(l){case"data":y=this.c.data;break;case"end":y=this.c.end;break;case"error":y=this.c.error;break}if(y){const I=y.indexOf(r);I>=0&&y.splice(I,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(y=>y())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(d,l){const r=[];let y;for(;(y=d.read())!==null;)r.push(y);return l(r)}t.$3d=f;function m(d,l,r){const y=[];let I;for(;(I=d.read())!==null&&y.length<r;)y.push(I);return I===null&&y.length>0?l(y):{read:()=>{if(y.length>0)return y.shift();if(typeof I<"u"){const T=I;return I=void 0,T}return d.read()}}}t.$4d=m;function L(d,l){return new Promise((r,y)=>{const I=[];n(d,{onData:T=>{l&&I.push(T)},onError:T=>{l?y(T):r(void 0)},onEnd:()=>{r(l?l(I):void 0)}})})}t.$5d=L;function n(d,l,r){d.on("error",y=>{r?.isCancellationRequested||l.onError(y)}),d.on("end",()=>{r?.isCancellationRequested||l.onEnd()}),d.on("data",y=>{r?.isCancellationRequested||l.onData(y)})}t.$6d=n;function o(d,l){return new Promise((r,y)=>{const I=new O.$Qc,T=[],g=H=>{if(T.push(H),T.length>l)return I.dispose(),d.pause(),r({stream:d,buffer:T,ended:!1})},v=H=>(I.dispose(),y(H)),z=()=>(I.dispose(),r({stream:d,buffer:T,ended:!0}));I.add((0,O.$Pc)(()=>d.removeListener("error",v))),d.on("error",v),I.add((0,O.$Pc)(()=>d.removeListener("end",z))),d.on("end",z),I.add((0,O.$Pc)(()=>d.removeListener("data",g))),d.on("data",g)})}t.$7d=o;function e(d,l){const r=D(l);return r.end(d),r}t.$8d=e;function a(){const d=D(()=>{throw new Error("not supported")});return d.end(),d}t.$9d=a;function h(d){let l=!1;return{read:()=>l?null:(l=!0,d)}}t.$0d=h;function $(d,l,r){const y=D(r);return n(d,{onData:I=>y.write(l.data(I)),onError:I=>y.error(l.error?l.error(I):I),onEnd:()=>y.end()}),y}t.$$d=$;function s(d,l,r){let y=!1;return{read:()=>{const I=l.read();return y?I:(y=!0,I!==null?r([d,I]):d)}}}t.$_d=s;function u(d,l,r){let y=!1;const I=D(r);return n(l,{onData:T=>y?I.write(T):(y=!0,I.write(r([d,T]))),onError:T=>I.error(T),onEnd:()=>{y||(y=!0,I.write(d)),I.end()}}),I}t.$ae=u}),define($e[32],pe([1,0,27,84]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=void 0;const i=typeof Buffer<"u",q=new w.$U(()=>new Uint8Array(256));let p,D;class c{static alloc(F){return i?new c(Buffer.allocUnsafe(F)):new c(new Uint8Array(F))}static wrap(F){return i&&!Buffer.isBuffer(F)&&(F=Buffer.from(F.buffer,F.byteOffset,F.byteLength)),new c(F)}static fromString(F,Z){return!(Z?.dontUseNodeBuffer||!1)&&i?new c(Buffer.from(F)):(p||(p=new TextEncoder),new c(p.encode(F)))}static fromByteArray(F){const Z=c.alloc(F.length);for(let ee=0,ue=F.length;ee<ue;ee++)Z.buffer[ee]=F[ee];return Z}static concat(F,Z){if(typeof Z>"u"){Z=0;for(let oe=0,se=F.length;oe<se;oe++)Z+=F[oe].byteLength}const ee=c.alloc(Z);let ue=0;for(let oe=0,se=F.length;oe<se;oe++){const re=F[oe];ee.set(re,ue),ue+=re.byteLength}return ee}constructor(F){this.buffer=F,this.byteLength=this.buffer.byteLength}clone(){const F=c.alloc(this.byteLength);return F.set(this),F}toString(){return i?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(F,Z){return new c(this.buffer.subarray(F,Z))}set(F,Z){if(F instanceof c)this.buffer.set(F.buffer,Z);else if(F instanceof Uint8Array)this.buffer.set(F,Z);else if(F instanceof ArrayBuffer)this.buffer.set(new Uint8Array(F),Z);else if(ArrayBuffer.isView(F))this.buffer.set(new Uint8Array(F.buffer,F.byteOffset,F.byteLength),Z);else throw new Error("Unknown argument 'array'")}readUInt32BE(F){return n(this.buffer,F)}writeUInt32BE(F,Z){o(this.buffer,F,Z)}readUInt32LE(F){return e(this.buffer,F)}writeUInt32LE(F,Z){a(this.buffer,F,Z)}readUInt8(F){return h(this.buffer,F)}writeUInt8(F,Z){$(this.buffer,F,Z)}indexOf(F,Z=0){return f(this.buffer,F instanceof c?F.buffer:F,Z)}}t.$be=c;function f(M,F,Z=0){const ee=F.byteLength,ue=M.byteLength;if(ee===0)return 0;if(ee===1)return M.indexOf(F[0]);if(ee>ue-Z)return-1;const oe=q.value;oe.fill(F.length);for(let Se=0;Se<F.length;Se++)oe[F[Se]]=F.length-Se-1;let se=Z+F.length-1,re=se,be=-1;for(;se<ue;)if(M[se]===F[re]){if(re===0){be=se;break}se--,re--}else se+=Math.max(F.length-re,oe[M[se]]),re=F.length-1;return be}t.$ce=f;function m(M,F){return M[F+0]<<0>>>0|M[F+1]<<8>>>0}t.$de=m;function L(M,F,Z){M[Z+0]=F&255,F=F>>>8,M[Z+1]=F&255}t.$ee=L;function n(M,F){return M[F]*2**24+M[F+1]*2**16+M[F+2]*2**8+M[F+3]}t.$fe=n;function o(M,F,Z){M[Z+3]=F,F=F>>>8,M[Z+2]=F,F=F>>>8,M[Z+1]=F,F=F>>>8,M[Z]=F}t.$ge=o;function e(M,F){return M[F+0]<<0>>>0|M[F+1]<<8>>>0|M[F+2]<<16>>>0|M[F+3]<<24>>>0}t.$he=e;function a(M,F,Z){M[Z+0]=F&255,F=F>>>8,M[Z+1]=F&255,F=F>>>8,M[Z+2]=F&255,F=F>>>8,M[Z+3]=F&255}t.$ie=a;function h(M,F){return M[F]}t.$je=h;function $(M,F,Z){M[Z]=F}t.$ke=$;function s(M){return O.$3d(M,F=>c.concat(F))}t.$le=s;function u(M){return O.$0d(M)}t.$me=u;function d(M){return O.$5d(M,F=>c.concat(F))}t.$ne=d;async function l(M){return M.ended?c.concat(M.buffer):c.concat([...M.buffer,await d(M.stream)])}t.$oe=l;function r(M){return O.$8d(M,F=>c.concat(F))}t.$pe=r;function y(M){return O.$$d(M,{data:F=>typeof F=="string"?c.fromString(F):c.wrap(F)},F=>c.concat(F))}t.$qe=y;function I(M){return O.$2d(F=>c.concat(F),M)}t.$re=I;function T(M,F){return O.$_d(M,F,Z=>c.concat(Z))}t.$se=T;function g(M,F){return O.$ae(M,F,Z=>c.concat(Z))}t.$te=g;function v(M){let F=0,Z=0,ee=0;const ue=new Uint8Array(Math.floor(M.length/4*3)),oe=re=>{switch(Z){case 3:ue[ee++]=F|re,Z=0;break;case 2:ue[ee++]=F|re>>>2,F=re<<6,Z=3;break;case 1:ue[ee++]=F|re>>>4,F=re<<4,Z=2;break;default:F=re<<2,Z=1}};for(let re=0;re<M.length;re++){const be=M.charCodeAt(re);if(be>=65&&be<=90)oe(be-65);else if(be>=97&&be<=122)oe(be-97+26);else if(be>=48&&be<=57)oe(be-48+52);else if(be===43||be===45)oe(62);else if(be===47||be===95)oe(63);else{if(be===61)break;throw new SyntaxError(`Unexpected base64 character ${M[re]}`)}}const se=ee;for(;Z>0;)oe(0);return c.wrap(ue).slice(0,se)}t.$ue=v;const z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function _({buffer:M},F=!0,Z=!1){const ee=Z?H:z;let ue="";const oe=M.byteLength%3;let se=0;for(;se<M.byteLength-oe;se+=3){const re=M[se+0],be=M[se+1],Se=M[se+2];ue+=ee[re>>>2],ue+=ee[(re<<4|be>>>4)&63],ue+=ee[(be<<2|Se>>>6)&63],ue+=ee[Se&63]}if(oe===1){const re=M[se+0];ue+=ee[re>>>2],ue+=ee[re<<4&63],F&&(ue+="==")}else if(oe===2){const re=M[se+0],be=M[se+1];ue+=ee[re>>>2],ue+=ee[(re<<4|be>>>4)&63],ue+=ee[be<<2&63],F&&(ue+="=")}return ue}t.$ve=_}),define($e[12],pe([1,0,83,27]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xf=t.$wf=t.$vf=t.$uf=t.GraphemeBreakType=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=void 0;function i(J){return!J||typeof J!="string"?!0:J.trim().length===0}t.$Be=i;const q=/{(\d+)}/g;function p(J,...he){return he.length===0?J:J.replace(q,function(we,Ee){const Pe=parseInt(Ee,10);return isNaN(Pe)||Pe<0||Pe>=he.length?we:he[Pe]})}t.$Ce=p;const D=/{([^}]+)}/g;function c(J,he){return Object.keys(he).length===0?J:J.replace(D,(we,Ee)=>he[Ee]??we)}t.$De=c;function f(J){return J.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}t.$Ee=f;function m(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Fe=m;function L(J,he){let we=0;const Ee=he.charCodeAt(0);for(let Pe=J.length-1;Pe>=0;Pe--)J.charCodeAt(Pe)===Ee&&we++;return we}t.$Ge=L;function n(J,he,we="\u2026"){return J.length<=he?J:`${J.substr(0,he)}${we}`}t.$He=n;function o(J,he=" "){const we=e(J,he);return a(we,he)}t.$Ie=o;function e(J,he){if(!J||!he)return J;const we=he.length;if(we===0||J.length===0)return J;let Ee=0;for(;J.indexOf(he,Ee)===Ee;)Ee=Ee+we;return J.substring(Ee)}t.$Je=e;function a(J,he){if(!J||!he)return J;const we=he.length,Ee=J.length;if(we===0||Ee===0)return J;let Pe=Ee,Be=-1;for(;Be=J.lastIndexOf(he,Pe-1),!(Be===-1||Be+we!==Pe);){if(Be===0)return"";Pe=Be}return J.substring(0,Pe)}t.$Ke=a;function h(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Le=h;function $(J){return J.replace(/\*/g,"")}t.$Me=$;function s(J,he,we={}){if(!J)throw new Error("Cannot create regex from empty string");he||(J=m(J)),we.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let Ee="";return we.global&&(Ee+="g"),we.matchCase||(Ee+="i"),we.multiline&&(Ee+="m"),we.unicode&&(Ee+="u"),new RegExp(J,Ee)}t.$Ne=s;function u(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}t.$Oe=u;function d(J){return J.split(/\r\n|\r|\n/)}t.$Pe=d;function l(J){for(let he=0,we=J.length;he<we;he++){const Ee=J.charCodeAt(he);if(Ee!==32&&Ee!==9)return he}return-1}t.$Qe=l;function r(J,he=0,we=J.length){for(let Ee=he;Ee<we;Ee++){const Pe=J.charCodeAt(Ee);if(Pe!==32&&Pe!==9)return J.substring(he,Ee)}return J.substring(he,we)}t.$Re=r;function y(J,he=J.length-1){for(let we=he;we>=0;we--){const Ee=J.charCodeAt(we);if(Ee!==32&&Ee!==9)return we}return-1}t.$Se=y;function I(J,he,we){const Ee=[];let Pe=0;for(const Be of J.matchAll(he)){if(Ee.push(J.slice(Pe,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Pe=Be.index+Be[0].length,Ee.push(we(Be[0],...Be.slice(1),Be.index,J,Be.groups))}return Ee.push(J.slice(Pe)),Promise.all(Ee).then(Be=>Be.join(""))}t.$Te=I;function T(J,he){return J<he?-1:J>he?1:0}t.$Ue=T;function g(J,he,we=0,Ee=J.length,Pe=0,Be=he.length){for(;we<Ee&&Pe<Be;we++,Pe++){const Ze=J.charCodeAt(we),Qe=he.charCodeAt(Pe);if(Ze<Qe)return-1;if(Ze>Qe)return 1}const Ue=Ee-we,Ye=Be-Pe;return Ue<Ye?-1:Ue>Ye?1:0}t.$Ve=g;function v(J,he){return z(J,he,0,J.length,0,he.length)}t.$We=v;function z(J,he,we=0,Ee=J.length,Pe=0,Be=he.length){for(;we<Ee&&Pe<Be;we++,Pe++){let Ze=J.charCodeAt(we),Qe=he.charCodeAt(Pe);if(Ze===Qe)continue;if(Ze>=128||Qe>=128)return g(J.toLowerCase(),he.toLowerCase(),we,Ee,Pe,Be);_(Ze)&&(Ze-=32),_(Qe)&&(Qe-=32);const We=Ze-Qe;if(We!==0)return We}const Ue=Ee-we,Ye=Be-Pe;return Ue<Ye?-1:Ue>Ye?1:0}t.$Xe=z;function H(J){return J>=48&&J<=57}t.$Ye=H;function _(J){return J>=97&&J<=122}t.$Ze=_;function M(J){return J>=65&&J<=90}t.$1e=M;function F(J,he){return J.length===he.length&&z(J,he)===0}t.$2e=F;function Z(J,he){const we=he.length;return he.length>J.length?!1:z(J,he,0,we)===0}t.$3e=Z;function ee(J,he){const we=Math.min(J.length,he.length);let Ee;for(Ee=0;Ee<we;Ee++)if(J.charCodeAt(Ee)!==he.charCodeAt(Ee))return Ee;return we}t.$4e=ee;function ue(J,he){const we=Math.min(J.length,he.length);let Ee;const Pe=J.length-1,Be=he.length-1;for(Ee=0;Ee<we;Ee++)if(J.charCodeAt(Pe-Ee)!==he.charCodeAt(Be-Ee))return Ee;return we}t.$5e=ue;function oe(J){return 55296<=J&&J<=56319}t.$6e=oe;function se(J){return 56320<=J&&J<=57343}t.$7e=se;function re(J,he){return(J-55296<<10)+(he-56320)+65536}t.$8e=re;function be(J,he,we){const Ee=J.charCodeAt(we);if(oe(Ee)&&we+1<he){const Pe=J.charCodeAt(we+1);if(se(Pe))return re(Ee,Pe)}return Ee}t.$9e=be;function Se(J,he){const we=J.charCodeAt(he-1);if(se(we)&&he>1){const Ee=J.charCodeAt(he-2);if(oe(Ee))return re(Ee,we)}return we}class Le{get offset(){return this.e}constructor(he,we=0){this.c=he,this.d=he.length,this.e=we}setOffset(he){this.e=he}prevCodePoint(){const he=Se(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=be(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}t.$0e=Le;class Fe{get offset(){return this.c.offset}constructor(he,we=0){this.c=new Le(he,we)}nextGraphemeLength(){const he=Ae.getInstance(),we=this.c,Ee=we.offset;let Pe=he.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Be=we.offset,Ue=he.getGraphemeBreakType(we.nextCodePoint());if(ve(Pe,Ue)){we.setOffset(Be);break}Pe=Ue}return we.offset-Ee}prevGraphemeLength(){const he=Ae.getInstance(),we=this.c,Ee=we.offset;let Pe=he.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Be=we.offset,Ue=he.getGraphemeBreakType(we.prevCodePoint());if(ve(Ue,Pe)){we.setOffset(Be);break}Pe=Ue}return Ee-we.offset}eol(){return this.c.eol()}}t.$$e=Fe;function de(J,he){return new Fe(J,he).nextGraphemeLength()}t.$_e=de;function ie(J,he){return new Fe(J,he).prevGraphemeLength()}t.$af=ie;function ce(J,he){he>0&&se(J.charCodeAt(he))&&he--;const we=he+de(J,he);return[we-ie(J,we),we]}t.$bf=ce;function Y(J){const he=new Fe(J);let we=0;for(;!he.eol();)we++,he.nextGraphemeLength();return we}t.$cf=Y;let V;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function S(J){return V||(V=G()),V.test(J)}t.$df=S;const Q=/^[\t\n\r\x20-\x7E]*$/;function b(J){return Q.test(J)}t.$ef=b,t.$ff=/[\u2028\u2029]/;function R(J){return t.$ff.test(J)}t.$gf=R;function B(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}t.$hf=B;function N(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}t.$if=N;function A(J,he){if(J.length<he)return J;const we=/\b/g;let Ee=0;for(;we.test(J)&&!(J.length-we.lastIndex<he);)Ee=we.lastIndex,we.lastIndex+=1;return J.substring(Ee).replace(/^\s/,"")}t.$jf=A;const k=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,U=/\x1b\].*?\x07/g;function C(J){return J&&(J=J.replace(k,"").replace(U,"")),J}t.$kf=C,t.$lf=String.fromCharCode(65279);function j(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}t.$mf=j;function E(J){return j(J)?J.substr(1):J}t.$nf=E;function P(J,he){if(!J||!he||J.length<he.length)return!1;const we=he.length,Ee=J.toLowerCase();let Pe=0,Be=-1;for(;Pe<we;){const Ue=Ee.indexOf(he[Pe],Be+1);if(Ue<0)return!1;Be=Ue,Pe++}return!0}t.$of=P;function W(J,he=!1){return J?(he&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}t.$pf=W;function x(J){return J.charAt(0).toUpperCase()+J.slice(1)}t.$qf=x;function te(J,he=1){if(he===0)return"";let we=-1;do we=J.indexOf(`
`,we+1),he--;while(he>0&&we>=0);return we===-1?J:(J[we-1]==="\r"&&we--,J.substr(0,we))}t.$rf=te;function ne(J){return J=J%(2*26),J<26?String.fromCharCode(97+J):String.fromCharCode(65+J-26)}t.$sf=ne;function ge(J){return Ae.getInstance().getGraphemeBreakType(J)}t.$tf=ge;function ve(J,he){return J===0?he!==5&&he!==7:J===2&&he===3?!1:J===4||J===2||J===3||he===4||he===2||he===3?!0:!(J===8&&(he===8||he===9||he===11||he===12)||(J===11||J===9)&&(he===9||he===10)||(J===12||J===10)&&he===10||he===5||he===13||he===7||J===1||J===13&&he===14||J===6&&he===6)}var Ce;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(t.GraphemeBreakType=Ce={}));class Ae{static{this.c=null}static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const we=this.d,Ee=we.length/3;let Pe=1;for(;Pe<=Ee;)if(he<we[3*Pe])Pe=2*Pe;else if(he>we[3*Pe+1])Pe=2*Pe+1;else return we[3*Pe+2];return 0}}function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(J,he){if(J===0)return 0;const we=Oe(J,he);if(we!==void 0)return we;const Ee=new Le(he,J);return Ee.prevCodePoint(),Ee.offset}t.$uf=Me;function Oe(J,he){const we=new Le(he,J);let Ee=we.prevCodePoint();for(;_e(Ee)||Ee===65039||Ee===8419;){if(we.offset===0)return;Ee=we.prevCodePoint()}if(!N(Ee))return;let Pe=we.offset;return Pe>0&&we.prevCodePoint()===8205&&(Pe=we.offset),Pe}function _e(J){return 127995<=J&&J<=127999}var je;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),t.$vf="\xA0";class Re{static{this.c=new O.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new w.$xe(he=>{function we(We){const tt=new Map;for(let nt=0;nt<We.length;nt+=2)tt.set(We[nt],We[nt+1]);return tt}function Ee(We,tt){const nt=new Map(We);for(const[ft,ct]of tt)nt.set(ft,ct);return nt}function Pe(We,tt){if(!We)return tt;const nt=new Map;for(const[ft,ct]of We)tt.has(ft)&&nt.set(ft,ct);return nt}const Be=this.c.value;let Ue=he.filter(We=>!We.startsWith("_")&&We in Be);Ue.length===0&&(Ue=["_default"]);let Ye;for(const We of Ue){const tt=we(Be[We]);Ye=Pe(Ye,tt)}const Ze=we(Be._common),Qe=Ee(Ze,Ye);return new Re(Qe)})}static getInstance(he){return Re.d.get(Array.from(he))}static{this.e=new O.$U(()=>Object.keys(Re.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return Re.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$wf=Re;class Ve{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ve.c())),this.d}static isInvisibleCharacter(he){return Ve.e().has(he)}static get codePoints(){return Ve.e()}}t.$xf=Ve}),define($e[33],pe([1,0,31,12]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rj=t.$Qj=t.$Pj=t.$Oj=t.FuzzyScore=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.$Fj=t.$Ej=t.$Dj=t.$Cj=t.or=void 0;function i(...E){return function(P,W){for(let x=0,te=E.length;x<te;x++){const ne=E[x](P,W);if(ne)return ne}return null}}t.or=i,t.$Cj=q.bind(void 0,!1),t.$Dj=q.bind(void 0,!0);function q(E,P,W){if(!W||W.length<P.length)return null;let x;return E?x=O.$3e(W,P):x=W.indexOf(P)===0,x?P.length>0?[{start:0,end:P.length}]:[]:null}function p(E,P){const W=P.toLowerCase().indexOf(E.toLowerCase());return W===-1?null:[{start:W,end:W+E.length}]}t.$Ej=p;function D(E,P){return c(E.toLowerCase(),P.toLowerCase(),0,0)}t.$Fj=D;function c(E,P,W,x){if(W===E.length)return[];if(x===P.length)return null;if(E[W]===P[x]){let te=null;return(te=c(E,P,W+1,x+1))?$({start:x,end:x+1},te):null}return c(E,P,W,x+1)}function f(E){return 97<=E&&E<=122}function m(E){return 65<=E&&E<=90}t.$Gj=m;function L(E){return 48<=E&&E<=57}function n(E){return E===32||E===9||E===10||E===13}const o=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(E=>o.add(E.charCodeAt(0)));function e(E){return n(E)||o.has(E)}function a(E,P){return E===P||e(E)&&e(P)}function h(E){return f(E)||m(E)||L(E)}function $(E,P){return P.length===0?P=[E]:E.end===P[0].start?P[0].start=E.start:P.unshift(E),P}function s(E,P){for(let W=P;W<E.length;W++){const x=E.charCodeAt(W);if(m(x)||L(x)||W>0&&!h(E.charCodeAt(W-1)))return W}return E.length}function u(E,P,W,x){if(W===E.length)return[];if(x===P.length)return null;if(E[W]!==P[x].toLowerCase())return null;{let te=null,ne=x+1;for(te=u(E,P,W+1,x+1);!te&&(ne=s(P,ne))<P.length;)te=u(E,P,W+1,ne),ne++;return te===null?null:$({start:x,end:x+1},te)}}function d(E){let P=0,W=0,x=0,te=0,ne=0;for(let De=0;De<E.length;De++)ne=E.charCodeAt(De),m(ne)&&P++,f(ne)&&W++,h(ne)&&x++,L(ne)&&te++;const ge=P/E.length,ve=W/E.length,Ce=x/E.length,Ae=te/E.length;return{upperPercent:ge,lowerPercent:ve,alphaPercent:Ce,numericPercent:Ae}}function l(E){const{upperPercent:P,lowerPercent:W}=E;return W===0&&P>.6}function r(E){const{upperPercent:P,lowerPercent:W,alphaPercent:x,numericPercent:te}=E;return W>.2&&P<.8&&x>.6&&te<.2}function y(E){let P=0,W=0,x=0,te=0;for(let ne=0;ne<E.length;ne++)x=E.charCodeAt(ne),m(x)&&P++,f(x)&&W++,n(x)&&te++;return(P===0||W===0)&&te===0?E.length<=30:P<=5}function I(E,P){if(!P||(P=P.trim(),P.length===0)||!y(E)||P.length>60)return null;const W=d(P);if(!r(W)){if(!l(W))return null;P=P.toLowerCase()}let x=null,te=0;for(E=E.toLowerCase();te<P.length&&(x=u(E,P,0,te))===null;)te=s(P,te+1);return x}t.$Hj=I;function T(E,P,W=!1){if(!P||P.length===0)return null;let x=null,te=0;for(E=E.toLowerCase(),P=P.toLowerCase();te<P.length&&(x=g(E,P,0,te,W))===null;)te=v(P,te+1);return x}t.$Ij=T;function g(E,P,W,x,te){if(W===E.length)return[];if(x===P.length)return null;if(a(E.charCodeAt(W),P.charCodeAt(x))){let ne=null,ge=x+1;if(ne=g(E,P,W+1,x+1,te),!te)for(;!ne&&(ge=v(P,ge))<P.length;)ne=g(E,P,W+1,ge,te),ge++;return ne?E.charCodeAt(W)!==P.charCodeAt(x)?ne:$({start:x,end:x+1},ne):null}else return null}function v(E,P){for(let W=P;W<E.length;W++)if(e(E.charCodeAt(W))||W>0&&e(E.charCodeAt(W-1)))return W;return E.length}const z=i(t.$Dj,I,p),H=i(t.$Dj,I,D),_=new w.$Cc(1e4);function M(E,P,W=!1){if(typeof E!="string"||typeof P!="string")return null;let x=_.get(E);x||(x=new RegExp(O.$Le(E),"i"),_.set(E,x));const te=x.exec(P);return te?[{start:te.index,end:te.index+te[0].length}]:W?H(E,P):z(E,P)}t.$Jj=M;function F(E,P){const W=B(E,E.toLowerCase(),0,P,P.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return W?ee(W):null}t.$Kj=F;function Z(E,P,W,x,te,ne){const ge=Math.min(13,E.length);for(;W<ge;W++){const ve=B(E,P,W,x,te,ne,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ve)return ve}return[0,ne]}t.$Lj=Z;function ee(E){if(typeof E>"u")return[];const P=[],W=E[1];for(let x=E.length-1;x>1;x--){const te=E[x]+W,ne=P[P.length-1];ne&&ne.end===te?ne.end=te+1:P.push({start:te,end:te+1})}return P}t.$Mj=ee;const ue=128;function oe(){const E=[],P=[];for(let W=0;W<=ue;W++)P[W]=0;for(let W=0;W<=ue;W++)E.push(P.slice(0));return E}function se(E){const P=[];for(let W=0;W<=E;W++)P[W]=0;return P}const re=se(2*ue),be=se(2*ue),Se=oe(),Le=oe(),Fe=oe(),de=!1;function ie(E,P,W,x,te){function ne(ve,Ce,Ae=" "){for(;ve.length<Ce;)ve=Ae+ve;return ve}let ge=` |   |${x.split("").map(ve=>ne(ve,3)).join("|")}
`;for(let ve=0;ve<=W;ve++)ve===0?ge+=" |":ge+=`${P[ve-1]}|`,ge+=E[ve].slice(0,te+1).map(Ce=>ne(Ce.toString(),3)).join("|")+`
`;return ge}function ce(E,P,W,x){E=E.substr(P),W=W.substr(x),console.log(ie(Le,E,E.length,W,W.length)),console.log(ie(Fe,E,E.length,W,W.length)),console.log(ie(Se,E,E.length,W,W.length))}function Y(E,P){if(P<0||P>=E.length)return!1;const W=E.codePointAt(P);switch(W){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.$if(W)}}function V(E,P){if(P<0||P>=E.length)return!1;switch(E.charCodeAt(P)){case 32:case 9:return!0;default:return!1}}function G(E,P,W){return P[E]!==W[E]}function S(E,P,W,x,te,ne,ge=!1){for(;P<W&&te<ne;)E[P]===x[te]&&(ge&&(re[P]=te),P+=1),te+=1;return P===W}t.$Nj=S;var Q;(function(E){E[E.Diag=1]="Diag",E[E.Left=2]="Left",E[E.LeftLeft=3]="LeftLeft"})(Q||(Q={}));var b;(function(E){E.Default=[-100,0];function P(W){return!W||W.length===2&&W[0]===-100&&W[1]===0}E.isDefault=P})(b||(t.FuzzyScore=b={}));class R{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(P,W){this.firstMatchCanBeWeak=P,this.boostFullMatch=W}}t.$Oj=R;function B(E,P,W,x,te,ne,ge=R.default){const ve=E.length>ue?ue:E.length,Ce=x.length>ue?ue:x.length;if(W>=ve||ne>=Ce||ve-W>Ce-ne||!S(P,W,ve,te,ne,Ce,!0))return;N(ve,Ce,W,ne,P,te);let Ae=1,De=1,Me=W,Oe=ne;const _e=[!1];for(Ae=1,Me=W;Me<ve;Ae++,Me++){const he=re[Me],we=be[Me],Ee=Me+1<ve?be[Me+1]:Ce;for(De=he-ne+1,Oe=he;Oe<Ee;De++,Oe++){let Pe=Number.MIN_SAFE_INTEGER,Be=!1;Oe<=we&&(Pe=A(E,P,Me,W,x,te,Oe,Ce,ne,Se[Ae-1][De-1]===0,_e));let Ue=0;Pe!==Number.MAX_SAFE_INTEGER&&(Be=!0,Ue=Pe+Le[Ae-1][De-1]);const Ye=Oe>he,Ze=Ye?Le[Ae][De-1]+(Se[Ae][De-1]>0?-5:0):0,Qe=Oe>he+1&&Se[Ae][De-1]>0,We=Qe?Le[Ae][De-2]+(Se[Ae][De-2]>0?-5:0):0;if(Qe&&(!Ye||We>=Ze)&&(!Be||We>=Ue))Le[Ae][De]=We,Fe[Ae][De]=3,Se[Ae][De]=0;else if(Ye&&(!Be||Ze>=Ue))Le[Ae][De]=Ze,Fe[Ae][De]=2,Se[Ae][De]=0;else if(Be)Le[Ae][De]=Ue,Fe[Ae][De]=1,Se[Ae][De]=Se[Ae-1][De-1]+1;else throw new Error("not possible")}}if(de&&ce(E,W,x,ne),!_e[0]&&!ge.firstMatchCanBeWeak)return;Ae--,De--;const je=[Le[Ae][De],ne];let Re=0,Ve=0;for(;Ae>=1;){let he=De;do{const we=Fe[Ae][he];if(we===3)he=he-2;else if(we===2)he=he-1;else break}while(he>=1);Re>1&&P[W+Ae-1]===te[ne+De-1]&&!G(he+ne-1,x,te)&&Re+1>Se[Ae][he]&&(he=De),he===De?Re++:Re=1,Ve||(Ve=he),Ae--,De=he-1,je.push(De)}Ce===ve&&ge.boostFullMatch&&(je[0]+=2);const J=Ve-ve;return je[0]-=J,je}t.$Pj=B;function N(E,P,W,x,te,ne){let ge=E-1,ve=P-1;for(;ge>=W&&ve>=x;)te[ge]===ne[ve]&&(be[ge]=ve,ge--),ve--}function A(E,P,W,x,te,ne,ge,ve,Ce,Ae,De){if(P[W]!==ne[ge])return Number.MIN_SAFE_INTEGER;let Me=1,Oe=!1;return ge===W-x?Me=E[W]===te[ge]?7:5:G(ge,te,ne)&&(ge===0||!G(ge-1,te,ne))?(Me=E[W]===te[ge]?7:5,Oe=!0):Y(ne,ge)&&(ge===0||!Y(ne,ge-1))?Me=5:(Y(ne,ge-1)||V(ne,ge-1))&&(Me=5,Oe=!0),Me>1&&W===x&&(De[0]=!0),Oe||(Oe=G(ge,te,ne)||Y(ne,ge-1)||V(ne,ge-1)),W===x?ge>Ce&&(Me-=Oe?3:5):Ae?Me+=Oe?2:0:Me+=Oe?0:1,ge+1===ve&&(Me-=Oe?3:5),Me}function k(E,P,W,x,te,ne,ge){return C(E,P,W,x,te,ne,!0,ge)}t.$Qj=k;function U(E,P,W,x,te,ne,ge){return C(E,P,W,x,te,ne,!1,ge)}t.$Rj=U;function C(E,P,W,x,te,ne,ge,ve){let Ce=B(E,P,W,x,te,ne,ve);if(Ce&&!ge)return Ce;if(E.length>=3){const Ae=Math.min(7,E.length-1);for(let De=W+1;De<Ae;De++){const Me=j(E,De);if(Me){const Oe=B(Me,Me.toLowerCase(),W,x,te,ne,ve);Oe&&(Oe[0]-=3,(!Ce||Oe[0]>Ce[0])&&(Ce=Oe))}}}return Ce}function j(E,P){if(P+1>=E.length)return;const W=E[P],x=E[P+1];if(W!==x)return E.slice(0,P)+x+W+E.slice(P+2)}}),define($e[48],pe([1,0,12]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ji=t.$Ii=t.$Hi=t.$Gi=t.$Fi=t.$Ei=t.$Di=void 0;function O($){return i($,0)}t.$Di=O;function i($,s){switch(typeof $){case"object":return $===null?q(349,s):Array.isArray($)?c($,s):f($,s);case"string":return D($,s);case"boolean":return p($,s);case"number":return q($,s);case"undefined":return q(937,s);default:return q(617,s)}}t.$Ei=i;function q($,s){return(s<<5)-s+$|0}t.$Fi=q;function p($,s){return q($?433:863,s)}function D($,s){s=q(149417,s);for(let u=0,d=$.length;u<d;u++)s=q($.charCodeAt(u),s);return s}t.$Gi=D;function c($,s){return s=q(104579,s),$.reduce((u,d)=>i(d,u),s)}function f($,s){return s=q(181387,s),Object.keys($).sort().reduce((u,d)=>(u=D(d,u),i($[d],u)),s)}class m{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=i(s,this.g),this.g}}t.$Hi=m;var L;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function n($,s,u=32){const d=u-s,l=~((1<<d)-1);return($<<s|(l&$)>>>d)>>>0}function o($,s=0,u=$.byteLength,d=0){for(let l=0;l<u;l++)$[s+l]=d}function e($,s,u="0"){for(;$.length<s;)$=u+$;return $}function a($,s=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(u=>u.toString(16).padStart(2,"0")).join(""):e(($>>>0).toString(16),s/4)}t.$Ii=a;class h{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const u=s.length;if(u===0)return;const d=this.p;let l=this.r,r=this.u,y,I;for(r!==0?(y=r,I=-1,r=0):(y=s.charCodeAt(0),I=0);;){let T=y;if(w.$6e(y))if(I+1<u){const g=s.charCodeAt(I+1);w.$7e(g)?(I++,T=w.$8e(y,g)):T=65533}else{r=y;break}else w.$7e(y)&&(T=65533);if(l=this.w(d,l,T),I++,I<u)y=s.charCodeAt(I);else break}this.r=l,this.u=r}w(s,u,d){return d<128?s[u++]=d:d<2048?(s[u++]=192|(d&1984)>>>6,s[u++]=128|(d&63)>>>0):d<65536?(s[u++]=224|(d&61440)>>>12,s[u++]=128|(d&4032)>>>6,s[u++]=128|(d&63)>>>0):(s[u++]=240|(d&1835008)>>>18,s[u++]=128|(d&258048)>>>12,s[u++]=128|(d&4032)>>>6,s[u++]=128|(d&63)>>>0),u>=64&&(this.y(),u-=64,this.t+=64,s[0]=s[64+0],s[1]=s[64+1],s[2]=s[64+2]),u}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,o(this.p,this.r),this.r>56&&(this.y(),o(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=h.g,u=this.q;for(let z=0;z<64;z+=4)s.setUint32(z,u.getUint32(z,!1),!1);for(let z=64;z<320;z+=4)s.setUint32(z,n(s.getUint32(z-12,!1)^s.getUint32(z-32,!1)^s.getUint32(z-56,!1)^s.getUint32(z-64,!1),1),!1);let d=this.h,l=this.l,r=this.m,y=this.n,I=this.o,T,g,v;for(let z=0;z<80;z++)z<20?(T=l&r|~l&y,g=1518500249):z<40?(T=l^r^y,g=1859775393):z<60?(T=l&r|l&y|r&y,g=2400959708):(T=l^r^y,g=3395469782),v=n(d,5)+T+I+g+s.getUint32(z*4,!1)&4294967295,I=y,y=r,r=n(l,30),l=d,d=v;this.h=this.h+d&4294967295,this.l=this.l+l&4294967295,this.m=this.m+r&4294967295,this.n=this.n+y&4294967295,this.o=this.o+I&4294967295}}t.$Ji=h}),define($e[85],pe([1,0,74,48]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cs=t.$Bs=t.$As=void 0;class i{constructor(n){this.a=n}getElements(){const n=this.a,o=new Int32Array(n.length);for(let e=0,a=n.length;e<a;e++)o[e]=n.charCodeAt(e);return o}}t.$As=i;function q(L,n,o){return new m(new i(L),new i(n)).ComputeDiff(o).changes}t.$Bs=q;class p{static Assert(n,o){if(!n)throw new Error(o)}}class D{static Copy(n,o,e,a,h){for(let $=0;$<h;$++)e[a+$]=n[o+$]}static Copy2(n,o,e,a,h){for(let $=0;$<h;$++)e[a+$]=n[o+$]}}var c;(function(L){L[L.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(c||(c={}));class f{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new w.$zs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(n,o){this.b=Math.min(this.b,n),this.c=Math.min(this.c,o),this.d++}AddModifiedElement(n,o){this.b=Math.min(this.b,n),this.c=Math.min(this.c,o),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class m{constructor(n,o,e=null){this.a=e,this.b=n,this.c=o;const[a,h,$]=m.o(n),[s,u,d]=m.o(o);this.d=$&&d,this.e=a,this.f=h,this.g=s,this.h=u,this.k=[],this.m=[]}static n(n){return n.length>0&&typeof n[0]=="string"}static o(n){const o=n.getElements();if(m.n(o)){const e=new Int32Array(o.length);for(let a=0,h=o.length;a<h;a++)e[a]=(0,O.$Gi)(o[a],0);return[o,e,!0]}return o instanceof Int32Array?[[],o,!1]:[[],new Int32Array(o),!1]}p(n,o){return this.f[n]!==this.h[o]?!1:this.d?this.e[n]===this.g[o]:!0}q(n,o){if(!this.p(n,o))return!1;const e=m.r(this.b,n),a=m.r(this.c,o);return e===a}static r(n,o){return typeof n.getStrictElement=="function"?n.getStrictElement(o):null}s(n,o){return this.f[n]!==this.f[o]?!1:this.d?this.e[n]===this.e[o]:!0}u(n,o){return this.h[n]!==this.h[o]?!1:this.d?this.g[n]===this.g[o]:!0}ComputeDiff(n){return this.v(0,this.f.length-1,0,this.h.length-1,n)}v(n,o,e,a,h){const $=[!1];let s=this.w(n,o,e,a,$);return h&&(s=this.z(s)),{quitEarly:$[0],changes:s}}w(n,o,e,a,h){for(h[0]=!1;n<=o&&e<=a&&this.p(n,e);)n++,e++;for(;o>=n&&a>=e&&this.p(o,a);)o--,a--;if(n>o||e>a){let r;return e<=a?(p.Assert(n===o+1,"originalStart should only be one more than originalEnd"),r=[new w.$zs(n,0,e,a-e+1)]):n<=o?(p.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),r=[new w.$zs(n,o-n+1,e,0)]):(p.Assert(n===o+1,"originalStart should only be one more than originalEnd"),p.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const $=[0],s=[0],u=this.y(n,o,e,a,$,s,h),d=$[0],l=s[0];if(u!==null)return u;if(!h[0]){const r=this.w(n,d,e,l,h);let y=[];return h[0]?y=[new w.$zs(d+1,o-(d+1)+1,l+1,a-(l+1)+1)]:y=this.w(d+1,o,l+1,a,h),this.H(r,y)}return[new w.$zs(n,o-n+1,e,a-e+1)]}x(n,o,e,a,h,$,s,u,d,l,r,y,I,T,g,v,z,H){let _=null,M=null,F=new f,Z=o,ee=e,ue=I[0]-v[0]-a,oe=-1073741824,se=this.k.length-1;do{const re=ue+n;re===Z||re<ee&&d[re-1]<d[re+1]?(r=d[re+1],T=r-ue-a,r<oe&&F.MarkNextChange(),oe=r,F.AddModifiedElement(r+1,T),ue=re+1-n):(r=d[re-1]+1,T=r-ue-a,r<oe&&F.MarkNextChange(),oe=r-1,F.AddOriginalElement(r,T+1),ue=re-1-n),se>=0&&(d=this.k[se],n=d[0],Z=1,ee=d.length-1)}while(--se>=-1);if(_=F.getReverseChanges(),H[0]){let re=I[0]+1,be=v[0]+1;if(_!==null&&_.length>0){const Se=_[_.length-1];re=Math.max(re,Se.getOriginalEnd()),be=Math.max(be,Se.getModifiedEnd())}M=[new w.$zs(re,y-re+1,be,g-be+1)]}else{F=new f,Z=$,ee=s,ue=I[0]-v[0]-u,oe=1073741824,se=z?this.m.length-1:this.m.length-2;do{const re=ue+h;re===Z||re<ee&&l[re-1]>=l[re+1]?(r=l[re+1]-1,T=r-ue-u,r>oe&&F.MarkNextChange(),oe=r+1,F.AddOriginalElement(r+1,T+1),ue=re+1-h):(r=l[re-1],T=r-ue-u,r>oe&&F.MarkNextChange(),oe=r,F.AddModifiedElement(r+1,T+1),ue=re-1-h),se>=0&&(l=this.m[se],h=l[0],Z=1,ee=l.length-1)}while(--se>=-1);M=F.getChanges()}return this.H(_,M)}y(n,o,e,a,h,$,s){let u=0,d=0,l=0,r=0,y=0,I=0;n--,e--,h[0]=0,$[0]=0,this.k=[],this.m=[];const T=o-n+(a-e),g=T+1,v=new Int32Array(g),z=new Int32Array(g),H=a-e,_=o-n,M=n-e,F=o-a,ee=(_-H)%2===0;v[H]=n,z[_]=o,s[0]=!1;for(let ue=1;ue<=T/2+1;ue++){let oe=0,se=0;l=this.J(H-ue,ue,H,g),r=this.J(H+ue,ue,H,g);for(let be=l;be<=r;be+=2){be===l||be<r&&v[be-1]<v[be+1]?u=v[be+1]:u=v[be-1]+1,d=u-(be-H)-M;const Se=u;for(;u<o&&d<a&&this.p(u+1,d+1);)u++,d++;if(v[be]=u,u+d>oe+se&&(oe=u,se=d),!ee&&Math.abs(be-_)<=ue-1&&u>=z[be])return h[0]=u,$[0]=d,Se<=z[be]&&1447>0&&ue<=1447+1?this.x(H,l,r,M,_,y,I,F,v,z,u,o,h,d,a,$,ee,s):null}const re=(oe-n+(se-e)-ue)/2;if(this.a!==null&&!this.a(oe,re))return s[0]=!0,h[0]=oe,$[0]=se,re>0&&1447>0&&ue<=1447+1?this.x(H,l,r,M,_,y,I,F,v,z,u,o,h,d,a,$,ee,s):(n++,e++,[new w.$zs(n,o-n+1,e,a-e+1)]);y=this.J(_-ue,ue,_,g),I=this.J(_+ue,ue,_,g);for(let be=y;be<=I;be+=2){be===y||be<I&&z[be-1]>=z[be+1]?u=z[be+1]-1:u=z[be-1],d=u-(be-_)-F;const Se=u;for(;u>n&&d>e&&this.p(u,d);)u--,d--;if(z[be]=u,ee&&Math.abs(be-H)<=ue&&u<=v[be])return h[0]=u,$[0]=d,Se>=v[be]&&1447>0&&ue<=1447+1?this.x(H,l,r,M,_,y,I,F,v,z,u,o,h,d,a,$,ee,s):null}if(ue<=1447){let be=new Int32Array(r-l+2);be[0]=H-l+1,D.Copy2(v,l,be,1,r-l+1),this.k.push(be),be=new Int32Array(I-y+2),be[0]=_-y+1,D.Copy2(z,y,be,1,I-y+1),this.m.push(be)}}return this.x(H,l,r,M,_,y,I,F,v,z,u,o,h,d,a,$,ee,s)}z(n){for(let o=0;o<n.length;o++){const e=n[o],a=o<n.length-1?n[o+1].originalStart:this.f.length,h=o<n.length-1?n[o+1].modifiedStart:this.h.length,$=e.originalLength>0,s=e.modifiedLength>0;for(;e.originalStart+e.originalLength<a&&e.modifiedStart+e.modifiedLength<h&&(!$||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!s||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const d=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!d)break;e.originalStart++,e.modifiedStart++}const u=[null];if(o<n.length-1&&this.I(n[o],n[o+1],u)){n[o]=u[0],n.splice(o+1,1),o--;continue}}for(let o=n.length-1;o>=0;o--){const e=n[o];let a=0,h=0;if(o>0){const r=n[o-1];a=r.originalStart+r.originalLength,h=r.modifiedStart+r.modifiedLength}const $=e.originalLength>0,s=e.modifiedLength>0;let u=0,d=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const y=e.originalStart-r,I=e.modifiedStart-r;if(y<a||I<h||$&&!this.s(y,y+e.originalLength)||s&&!this.u(I,I+e.modifiedLength))break;const g=(y===a&&I===h?5:0)+this.G(y,e.originalLength,I,e.modifiedLength);g>d&&(d=g,u=r)}e.originalStart-=u,e.modifiedStart-=u;const l=[null];if(o>0&&this.I(n[o-1],n[o],l)){n[o-1]=l[0],n.splice(o,1),o++;continue}}if(this.d)for(let o=1,e=n.length;o<e;o++){const a=n[o-1],h=n[o],$=h.originalStart-a.originalStart-a.originalLength,s=a.originalStart,u=h.originalStart+h.originalLength,d=u-s,l=a.modifiedStart,r=h.modifiedStart+h.modifiedLength,y=r-l;if($<5&&d<20&&y<20){const I=this.A(s,d,l,y,$);if(I){const[T,g]=I;(T!==a.originalStart+a.originalLength||g!==a.modifiedStart+a.modifiedLength)&&(a.originalLength=T-a.originalStart,a.modifiedLength=g-a.modifiedStart,h.originalStart=T+$,h.modifiedStart=g+$,h.originalLength=u-h.originalStart,h.modifiedLength=r-h.modifiedStart)}}}return n}A(n,o,e,a,h){if(o<h||a<h)return null;const $=n+o-h+1,s=e+a-h+1;let u=0,d=0,l=0;for(let r=n;r<$;r++)for(let y=e;y<s;y++){const I=this.B(r,y,h);I>0&&I>u&&(u=I,d=r,l=y)}return u>0?[d,l]:null}B(n,o,e){let a=0;for(let h=0;h<e;h++){if(!this.p(n+h,o+h))return 0;a+=this.e[n+h].length}return a}C(n){return n<=0||n>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[n])}D(n,o){if(this.C(n)||this.C(n-1))return!0;if(o>0){const e=n+o;if(this.C(e-1)||this.C(e))return!0}return!1}E(n){return n<=0||n>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[n])}F(n,o){if(this.E(n)||this.E(n-1))return!0;if(o>0){const e=n+o;if(this.E(e-1)||this.E(e))return!0}return!1}G(n,o,e,a){const h=this.D(n,o)?1:0,$=this.F(e,a)?1:0;return h+$}H(n,o){const e=[];if(n.length===0||o.length===0)return o.length>0?o:n;if(this.I(n[n.length-1],o[0],e)){const a=new Array(n.length+o.length-1);return D.Copy(n,0,a,0,n.length-1),a[n.length-1]=e[0],D.Copy(o,1,a,n.length,o.length-1),a}else{const a=new Array(n.length+o.length);return D.Copy(n,0,a,0,n.length),D.Copy(o,0,a,n.length,o.length),a}}I(n,o,e){if(p.Assert(n.originalStart<=o.originalStart,"Left change is not less than or equal to right change"),p.Assert(n.modifiedStart<=o.modifiedStart,"Left change is not less than or equal to right change"),n.originalStart+n.originalLength>=o.originalStart||n.modifiedStart+n.modifiedLength>=o.modifiedStart){const a=n.originalStart;let h=n.originalLength;const $=n.modifiedStart;let s=n.modifiedLength;return n.originalStart+n.originalLength>=o.originalStart&&(h=o.originalStart+o.originalLength-n.originalStart),n.modifiedStart+n.modifiedLength>=o.modifiedStart&&(s=o.modifiedStart+o.modifiedLength-n.modifiedStart),e[0]=new w.$zs(a,h,$,s),!0}else return e[0]=null,!1}J(n,o,e,a){if(n>=0&&n<a)return n;const h=e,$=a-e-1,s=o%2===0;if(n<0){const u=h%2===0;return s===u?0:1}else{const u=$%2===0;return s===u?a-1:a-2}}}t.$Cs=m}),define($e[49],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kd=void 0,t.$Kd=Symbol("MicrotaskDelay")}),define($e[86],pe([1,0,11,12]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vh=t.$Uh=t.$Th=t.$Sh=t.$Rh=void 0;class i{constructor(){this.b="",this.c=0}reset(o){return this.b=o,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(o){const e=o.charCodeAt(0),a=this.b.charCodeAt(this.c);return e-a}value(){return this.b[this.c]}}t.$Rh=i;class q{constructor(o=!0){this.e=o}reset(o){return this.b=o,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let o=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(o)this.c++;else break;else o=!1;return this}cmp(o){return this.e?(0,O.$Ve)(o,this.b,0,o.length,this.c,this.d):(0,O.$Xe)(o,this.b,0,o.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Sh=q;class p{constructor(o=!0,e=!0){this.f=o,this.g=e}reset(o){this.d=0,this.e=0,this.b=o,this.c=o.length;for(let e=o.length-1;e>=0;e--,this.c--){const a=this.b.charCodeAt(e);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let o=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(o)this.d++;else break;else o=!1}return this}cmp(o){return this.g?(0,O.$Ve)(o,this.b,0,o.length,this.d,this.e):(0,O.$Xe)(o,this.b,0,o.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Th=p;var D;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(D||(D={}));class c{constructor(o,e){this.f=o,this.g=e,this.d=[],this.e=0}reset(o){return this.c=o,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new p(!1,!this.f(o)),this.b.reset(o.path),this.b.value()&&this.d.push(3)),this.g(o)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(o){if(this.d[this.e]===1)return(0,O.$We)(o,this.c.scheme);if(this.d[this.e]===2)return(0,O.$We)(o,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(o);if(this.d[this.e]===4)return(0,O.$Ue)(o,this.c.query);if(this.d[this.e]===5)return(0,O.$Ue)(o,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Uh=c;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const o=this.right;return this.right=o.left,o.left=this,this.updateHeight(),o.updateHeight(),o}rotateRight(){const o=this.left;return this.left=o.right,o.right=this,this.updateHeight(),o.updateHeight(),o}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(m||(m={}));class L{static forUris(o=()=>!1,e=()=>!1){return new L(new c(o,e))}static forPaths(o=!1){return new L(new p(void 0,!o))}static forStrings(){return new L(new i)}static forConfigKeys(){return new L(new q)}constructor(o){this.b=o}clear(){this.c=void 0}fill(o,e){if(e){const a=e.slice(0);(0,w.$Wb)(a);for(const h of a)this.set(h,o)}else{const a=o.slice(0);(0,w.$Wb)(a);for(const h of a)this.set(h[0],h[1])}}set(o,e){const a=this.b.reset(o);let h;this.c||(this.c=new f,this.c.segment=a.value());const $=[];for(h=this.c;;){const u=a.cmp(h.segment);if(u>0)h.left||(h.left=new f,h.left.segment=a.value()),$.push([-1,h]),h=h.left;else if(u<0)h.right||(h.right=new f,h.right.segment=a.value()),$.push([1,h]),h=h.right;else if(a.hasNext())a.next(),h.mid||(h.mid=new f,h.mid.segment=a.value()),$.push([0,h]),h=h.mid;else break}const s=h.value;h.value=e,h.key=o;for(let u=$.length-1;u>=0;u--){const d=$[u][1];d.updateHeight();const l=d.balanceFactor();if(l<-1||l>1){const r=$[u][0],y=$[u+1][0];if(r===1&&y===1)$[u][1]=d.rotateLeft();else if(r===-1&&y===-1)$[u][1]=d.rotateRight();else if(r===1&&y===-1)d.right=$[u+1][1]=$[u+1][1].rotateRight(),$[u][1]=d.rotateLeft();else if(r===-1&&y===1)d.left=$[u+1][1]=$[u+1][1].rotateLeft(),$[u][1]=d.rotateRight();else throw new Error;if(u>0)switch($[u-1][0]){case-1:$[u-1][1].left=$[u][1];break;case 1:$[u-1][1].right=$[u][1];break;case 0:$[u-1][1].mid=$[u][1];break}else this.c=$[0][1]}}return s}get(o){return this.d(o)?.value}d(o){const e=this.b.reset(o);let a=this.c;for(;a;){const h=e.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(e.hasNext())e.next(),a=a.mid;else break}return a}has(o){const e=this.d(o);return!(e?.value===void 0&&e?.mid===void 0)}delete(o){return this.e(o,!1)}deleteSuperstr(o){return this.e(o,!0)}e(o,e){const a=this.b.reset(o),h=[];let $=this.c;for(;$;){const s=a.cmp($.segment);if(s>0)h.push([-1,$]),$=$.left;else if(s<0)h.push([1,$]),$=$.right;else if(a.hasNext())a.next(),h.push([0,$]),$=$.mid;else break}if($){if(e?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const s=this.f($.right);if(s.key){const{key:u,value:d,segment:l}=s;this.e(s.key,!1),$.key=u,$.value=d,$.segment=l}}else{const s=$.left??$.right;if(h.length>0){const[u,d]=h[h.length-1];switch(u){case-1:d.left=s;break;case 0:d.mid=s;break;case 1:d.right=s;break}}else this.c=s}for(let s=h.length-1;s>=0;s--){const u=h[s][1];u.updateHeight();const d=u.balanceFactor();if(d>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),h[s][1]=u.rotateLeft()):d<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),h[s][1]=u.rotateRight()),s>0)switch(h[s-1][0]){case-1:h[s-1][1].left=h[s][1];break;case 1:h[s-1][1].right=h[s][1];break;case 0:h[s-1][1].mid=h[s][1];break}else this.c=h[0][1]}}}f(o){for(;o.left;)o=o.left;return o}findSubstr(o){const e=this.b.reset(o);let a=this.c,h;for(;a;){const $=e.cmp(a.segment);if($>0)a=a.left;else if($<0)a=a.right;else if(e.hasNext())e.next(),h=a.value||h,a=a.mid;else break}return a&&a.value||h}findSuperstr(o){return this.g(o,!1)}g(o,e){const a=this.b.reset(o);let h=this.c;for(;h;){const $=a.cmp(h.segment);if($>0)h=h.left;else if($<0)h=h.right;else if(a.hasNext())a.next(),h=h.mid;else return h.mid?this.h(h.mid):e?h.value:void 0}}hasElementOrSubtree(o){return this.g(o,!0)!==void 0}forEach(o){for(const[e,a]of this)o(a,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(o){const e=[];return this.j(o,e),e[Symbol.iterator]()}j(o,e){o&&(o.left&&this.j(o.left,e),o.value&&e.push([o.key,o.value]),o.mid&&this.j(o.mid,e),o.right&&this.j(o.right,e))}_isBalanced(){const o=e=>{if(!e)return!0;const a=e.balanceFactor();return a<-1||a>1?!1:o(e.left)&&o(e.right)};return o(this.c)}}t.$Vh=L}),define($e[7],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=void 0;function w(l){return typeof l=="string"}t.$yf=w;function O(l){return Array.isArray(l)&&l.every(r=>w(r))}t.$zf=O;function i(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}t.$Af=i;function q(l){const r=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof r}t.$Bf=q;function p(l){return typeof l=="number"&&!isNaN(l)}t.$Cf=p;function D(l){return!!l&&typeof l[Symbol.iterator]=="function"}t.$Df=D;function c(l){return l===!0||l===!1}t.$Ef=c;function f(l){return typeof l>"u"}t.$Ff=f;function m(l){return!L(l)}t.$Gf=m;function L(l){return f(l)||l===null}t.$Hf=L;function n(l,r){if(!l)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}t.$If=n;function o(l){if(L(l))throw new Error("Assertion Failed: argument is undefined or null");return l}t.$Jf=o;function e(...l){const r=[];for(let y=0;y<l.length;y++){const I=l[y];if(L(I))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);r.push(I)}return r}t.$Kf=e;const a=Object.prototype.hasOwnProperty;function h(l){if(!i(l))return!1;for(const r in l)if(a.call(l,r))return!1;return!0}t.$Lf=h;function $(l){return typeof l=="function"}t.$Mf=$;function s(...l){return l.length>0&&l.every($)}t.$Nf=s;function u(l,r){const y=Math.min(l.length,r.length);for(let I=0;I<y;I++)d(l[I],r[I])}t.$Of=u;function d(l,r){if(w(r)){if(typeof l!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if($(r)){try{if(l instanceof r)return}catch{}if(!L(l)&&l.constructor===r||r.length===1&&r.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Pf=d}),define($e[17],pe([1,0,7]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uj=t.$Tj=t.$Sj=void 0;const O=Object.create(null);function i(D,c){if((0,w.$yf)(c)){const f=O[c];if(f===void 0)throw new Error(`${D} references an unknown codicon: ${c}`);c=f}return O[D]=c,{id:D}}function q(){return O}t.$Sj=q;function p(){return Object.values(t.$Uj)}t.$Tj=p,t.$Uj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),thumbsDownFilled:i("thumbsdown-filled",60435),thumbsUpFilled:i("thumbsup-filled",60436),coffee:i("coffee",60437),snake:i("snake",60438),game:i("game",60439),vr:i("vr",60440),chip:i("chip",60441),piano:i("piano",60442),music:i("music",60443),micFilled:i("mic-filled",60444),gitFetch:i("git-fetch",60445),copilot:i("copilot",60446),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define($e[50],pe([1,0,7]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$in=t.$hn=t.$gn=t.$fn=t.$en=t.$dn=t.$cn=t.$bn=t.$an=t.$_m=t.$$m=t.$0m=t.$9m=t.$8m=t.$7m=void 0;function O(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const l=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([r,y])=>{l[r]=y&&typeof y=="object"?O(y):y}),l}t.$7m=O;function i(d){if(!d||typeof d!="object")return d;const l=[d];for(;l.length>0;){const r=l.shift();Object.freeze(r);for(const y in r)if(q.call(r,y)){const I=r[y];typeof I=="object"&&!Object.isFrozen(I)&&!(0,w.$Bf)(I)&&l.push(I)}}return d}t.$8m=i;const q=Object.prototype.hasOwnProperty;function p(d,l){return D(d,l,new Set)}t.$9m=p;function D(d,l,r){if((0,w.$Hf)(d))return d;const y=l(d);if(typeof y<"u")return y;if(Array.isArray(d)){const I=[];for(const T of d)I.push(D(T,l,r));return I}if((0,w.$Af)(d)){if(r.has(d))throw new Error("Cannot clone recursive data-structure");r.add(d);const I={};for(const T in d)q.call(d,T)&&(I[T]=D(d[T],l,r));return r.delete(d),I}return d}function c(d,l,r=!0){return(0,w.$Af)(d)?((0,w.$Af)(l)&&Object.keys(l).forEach(y=>{y in d?r&&((0,w.$Af)(d[y])&&(0,w.$Af)(l[y])?c(d[y],l[y],r):d[y]=l[y]):d[y]=l[y]}),d):l}t.$0m=c;function f(d,l){if(d===l)return!0;if(d==null||l===null||l===void 0||typeof d!=typeof l||typeof d!="object"||Array.isArray(d)!==Array.isArray(l))return!1;let r,y;if(Array.isArray(d)){if(d.length!==l.length)return!1;for(r=0;r<d.length;r++)if(!f(d[r],l[r]))return!1}else{const I=[];for(y in d)I.push(y);I.sort();const T=[];for(y in l)T.push(y);if(T.sort(),!f(I,T))return!1;for(r=0;r<I.length;r++)if(!f(d[I[r]],l[I[r]]))return!1}return!0}t.$$m=f;function m(d){const l=new Set;return JSON.stringify(d,(r,y)=>{if((0,w.$Af)(y)||Array.isArray(y)){if(l.has(y))return"[Circular]";l.add(y)}return y})}t.$_m=m;function L(d,l){const r=Object.create(null);return!d||!l||Object.keys(l).forEach(I=>{const T=d[I],g=l[I];f(T,g)||(r[I]=g)}),r}t.$an=L;function n(d,l){const r=l.toLowerCase(),y=Object.keys(d).find(I=>I.toLowerCase()===r);return y?d[y]:d[l]}t.$bn=n;function o(d,l){const r=Object.create(null);for(const[y,I]of Object.entries(d))l(y,I)&&(r[y]=I);return r}t.$cn=o;function e(d){let l=[];for(;Object.prototype!==d;)l=l.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return l}t.$dn=e;function a(d){const l=[];for(const r of e(d))typeof d[r]=="function"&&l.push(r);return l}t.$en=a;function h(d,l){const r=I=>function(){const T=Array.prototype.slice.call(arguments,0);return l(I,T)},y={};for(const I of d)y[I]=r(I);return y}t.$fn=h;function $(d,l,r){typeof l=="string"&&d[l]!==void 0&&typeof d[l]!="boolean"&&(d[l]=r)}t.$gn=$;function s(d,l,r){typeof l=="string"&&d[l]!==void 0&&typeof d[l]!="number"&&(d[l]=r)}t.$hn=s;function u(d,l,r,y){if(typeof l!="string")return;const I=d[l];I!==void 0&&(typeof I!="string"||!r.includes(I))&&(d[l]=y)}t.$in=u}),define($e[18],pe([1,0,17]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$Vj=t.ThemeColor=void 0;var O;(function(p){function D(c){return c&&typeof c=="object"&&typeof c.id=="string"}p.isThemeColor=D})(O||(t.ThemeColor=O={}));function i(p){return{id:p}}t.$Vj=i;var q;(function(p){p.iconNameSegment="[A-Za-z0-9]+",p.iconNameExpression="[A-Za-z0-9-]+",p.iconModifierExpression="~[A-Za-z]+",p.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${p.iconNameExpression})(${p.iconModifierExpression})?$`);function c(s){const u=D.exec(s.id);if(!u)return c(w.$Uj.error);const[,d,l]=u,r=["codicon","codicon-"+d];return l&&r.push("codicon-modifier-"+l.substring(1)),r}p.asClassNameArray=c;function f(s){return c(s).join(" ")}p.asClassName=f;function m(s){return"."+c(s).join(".")}p.asCSSSelector=m;function L(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||O.isThemeColor(s.color))}p.isThemeIcon=L;const n=new RegExp(`^\\$\\((${p.iconNameExpression}(?:${p.iconModifierExpression})?)\\)$`);function o(s){const u=n.exec(s);if(!u)return;const[,d]=u;return{id:d}}p.fromString=o;function e(s){return{id:s}}p.fromId=e;function a(s,u){let d=s.id;const l=d.lastIndexOf("~");return l!==-1&&(d=d.substring(0,l)),u&&(d=`${d}~${u}`),{id:d}}p.modify=a;function h(s){const u=s.id.lastIndexOf("~");if(u!==-1)return s.id.substring(u+1)}p.getModifier=h;function $(s,u){return s.id===u.id&&s.color?.id===u.color?.id}p.isEqual=$})(q||(t.ThemeIcon=q={}))}),define($e[34],pe([1,0,33,12,18]),function(le,t,w,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=t.$Wj=void 0;const q="$(",p=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${p.source}`,"g");function c($){return $.replace(D,(s,u)=>u?s:`\\${s}`)}t.$Wj=c;const f=new RegExp(`\\\\${p.source}`,"g");function m($){return $.replace(f,s=>`\\${s}`)}t.$Xj=m;const L=new RegExp(`(\\s)?(\\\\)?${p.source}(\\s)?`,"g");function n($){return $.indexOf(q)===-1?$:$.replace(L,(s,u,d,l)=>d?s:u||l||"")}t.$Yj=n;function o($){return $?$.replace(/\$\((.*?)\)/g,(s,u)=>` ${u} `).trim():""}t.$Zj=o;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function a($){e.lastIndex=0;let s="";const u=[];let d=0;for(;;){const l=e.lastIndex,r=e.exec($),y=$.substring(l,r?.index);if(y.length>0){s+=y;for(let I=0;I<y.length;I++)u.push(d)}if(!r)break;d+=r[0].length}return{text:s,iconOffsets:u}}t.$1j=a;function h($,s,u=!1){const{text:d,iconOffsets:l}=s;if(!l||l.length===0)return(0,w.$Jj)($,d,u);const r=(0,O.$Je)(d," "),y=d.length-r.length,I=(0,w.$Jj)($,r,u);if(I)for(const T of I){const g=l[T.start+y]+y;T.start+=g,T.end+=g}return I}t.$2j=h}),define($e[87],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xT=t.$wT=void 0,t.$wT="vscode:contextmenu",t.$xT="vscode:onCloseContextMenu"}),define($e[88],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ET=void 0;class w{constructor(i,q){this.a=i,this.onMessage=q}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$ET=w}),define($e[51],pe([8]),{}),define($e[89],pe([8]),{}),define($e[90],pe([8]),{}),define($e[91],pe([8]),{}),define($e[92],pe([1,0,90,91]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define($e[93],pe([8]),{}),define($e[94],pe([8]),{}),define($e[95],pe([8]),{}),define($e[96],pe([8]),{}),define($e[97],pe([8]),{}),define($e[98],pe([8]),{}),define($e[99],pe([8]),{}),define($e[100],pe([8]),{}),define($e[101],pe([8]),{}),define($e[102],pe([13,10]),function(le,t){return le.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define($e[103],pe([13,10]),function(le,t){return le.create("vs/base/browser/ui/findinput/findInput",t)}),define($e[104],pe([13,10]),function(le,t){return le.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define($e[105],pe([13,10]),function(le,t){return le.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define($e[106],pe([13,10]),function(le,t){return le.create("vs/base/browser/ui/inputbox/inputBox",t)}),define($e[107],pe([13,10]),function(le,t){return le.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define($e[108],pe([13,10]),function(le,t){return le.create("vs/base/browser/ui/tree/abstractTree",t)}),define($e[109],pe([13,10]),function(le,t){return le.create("vs/base/common/actions",t)}),define($e[35],pe([1,0,4,2,109]),function(le,t,w,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zi=t.$yi=t.$xi=t.$wi=t.$vi=t.$ui=void 0;class q extends O.$Rc{constructor(n,o="",e="",a=!0,h){super(),this.h=this.B(new w.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=n,this.m=o,this.u=e,this.w=a,this.C=h}get id(){return this.j}get label(){return this.m}set label(n){this.D(n)}D(n){this.m!==n&&(this.m=n,this.h.fire({label:n}))}get tooltip(){return this.n||""}set tooltip(n){this.F(n)}F(n){this.n!==n&&(this.n=n,this.h.fire({tooltip:n}))}get class(){return this.u}set class(n){this.G(n)}G(n){this.u!==n&&(this.u=n,this.h.fire({class:n}))}get enabled(){return this.w}set enabled(n){this.H(n)}H(n){this.w!==n&&(this.w=n,this.h.fire({enabled:n}))}get checked(){return this.z}set checked(n){this.I(n)}I(n){this.z!==n&&(this.z=n,this.h.fire({checked:n}))}async run(n,o){this.C&&await this.C(n)}}t.$ui=q;class p extends O.$Rc{constructor(){super(...arguments),this.f=this.B(new w.$Nd),this.onWillRun=this.f.event,this.m=this.B(new w.$Nd),this.onDidRun=this.m.event}async run(n,o){if(!n.enabled)return;this.f.fire({action:n});let e;try{await this.u(n,o)}catch(a){e=a}this.m.fire({action:n,error:e})}async u(n,o){await n.run(o)}}t.$vi=p;class D{constructor(){this.id=D.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...n){let o=[];for(const e of n)e.length&&(o.length?o=[...o,new D,...e]:o=e);return o}static{this.ID="vs.actions.separator"}async run(){}}t.$wi=D;class c{get actions(){return this.a}constructor(n,o,e,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=n,this.label=o,this.class=a,this.a=e}async run(){}}t.$xi=c;class f extends q{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,i.localize(0,null),void 0,!1)}}t.$yi=f;function m(L){return{id:L.id,label:L.label,class:void 0,enabled:L.enabled??!0,checked:L.checked??!1,run:async(...n)=>L.run(...n),tooltip:L.label}}t.$zi=m}),define($e[110],pe([13,10]),function(le,t){return le.create("vs/base/common/platform",t)}),define($e[5],pe([1,0,110]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$h=t.$g=void 0,t.$g="en";let O=!1,i=!1,q=!1,p=!1,D=!1,c=!1,f=!1,m=!1,L=!1,n=!1,o,e=t.$g,a=t.$g,h,$;t.$h=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof t.$h.vscode<"u"&&typeof t.$h.vscode.process<"u"?s=t.$h.vscode.process:typeof process<"u"&&(s=process);const u=typeof s?.versions?.electron=="string",d=u&&s?.type==="renderer";if(typeof navigator=="object"&&!d)$=navigator.userAgent,O=$.indexOf("Windows")>=0,i=$.indexOf("Macintosh")>=0,m=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,q=$.indexOf("Linux")>=0,n=$?.indexOf("Mobi")>=0,c=!0,o=w.getConfiguredDefaultLocale(w.localize(0,null))||t.$g,e=o,a=navigator.language;else if(typeof s=="object"){O=s.platform==="win32",i=s.platform==="darwin",q=s.platform==="linux",p=q&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,f=u,L=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,o=t.$g,e=t.$g;const H=s.env.VSCODE_NLS_CONFIG;if(H)try{const _=JSON.parse(H),M=_.availableLanguages["*"];o=_.locale,a=_.osLocale,e=M||t.$g,h=_._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var l;(function(H){H[H.Web=0]="Web",H[H.Mac=1]="Mac",H[H.Linux=2]="Linux",H[H.Windows=3]="Windows"})(l||(t.Platform=l={}));function r(H){switch(H){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$i=r;let y=0;i?y=1:O?y=3:q&&(y=2),t.$j=O,t.$k=i,t.$l=q,t.$m=p,t.$n=D,t.$o=f,t.$p=c,t.$q=c&&typeof t.$h.importScripts=="function",t.$r=m,t.$s=n,t.$t=L,t.$u=y,t.$v=$,t.$w=e;var I;(function(H){function _(){return t.$w}H.value=_;function M(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}H.isDefaultVariant=M;function F(){return t.$w==="en"}H.isDefault=F})(I||(t.Language=I={})),t.$x=o,t.$y=a,t.$z=h,t.$A=typeof t.$h.postMessage=="function"&&!t.$h.importScripts,t.$B=(()=>{if(t.$A){const H=[];t.$h.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let F=0,Z=H.length;F<Z;F++){const ee=H[F];if(ee.id===M.data.vscodeScheduleAsyncWork){H.splice(F,1),ee.callback();return}}});let _=0;return M=>{const F=++_;H.push({id:F,callback:M}),t.$h.postMessage({vscodeScheduleAsyncWork:F},"*")}}return H=>setTimeout(H)})();var T;(function(H){H[H.Windows=1]="Windows",H[H.Macintosh=2]="Macintosh",H[H.Linux=3]="Linux"})(T||(t.OperatingSystem=T={})),t.OS=i||m?2:O?1:3;let g=!0,v=!1;function z(){if(!v){v=!0;const H=new Uint8Array(2);H[0]=1,H[1]=2,g=new Uint16Array(H.buffer)[0]===(2<<8)+1}return g}t.$D=z,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0)}),define($e[111],pe([1,0,16,5]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EO=t.KeyboardSupport=void 0;var i;(function(q){q[q.Always=0]="Always",q[q.FullScreen=1]="FullScreen",q[q.None=2]="None"})(i||(t.KeyboardSupport=i={})),t.$EO={clipboard:{writeText:O.$n||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:O.$n||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>O.$n||w.$CO()?0:navigator.keyboard||w.$yO?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define($e[14],pe([1,0,16,43,77,5]),function(le,t,w,O,i,q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MO=t.$LO=t.$KO=void 0;function p(e){if(e.charCode){const h=String.fromCharCode(e.charCode).toUpperCase();return O.KeyCodeUtils.fromString(h)}const a=e.keyCode;if(a===3)return 7;if(w.$vO)switch(a){case 59:return 85;case 60:if(q.$l)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(q.$k)return 57;break}else if(w.$wO){if(q.$k&&a===93)return 57;if(!q.$k&&a===92)return 57}return O.$Dq[a]||0}const D=q.$k?256:2048,c=512,f=1024,m=q.$k?2048:256;function L(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$KO=L;function n(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${O.KeyCodeUtils.toString(e.keyCode)}')`}t.$LO=n;class o{constructor(a){this._standardKeyboardEventBrand=!0;const h=a;this.browserEvent=h,this.target=h.target,this.ctrlKey=h.ctrlKey,this.shiftKey=h.shiftKey,this.altKey=h.altKey,this.metaKey=h.metaKey,this.altGraphKey=h.getModifierState("AltGraph"),this.keyCode=p(h),this.code=h.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(a){return this.a===a}c(){let a=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode);let h=0;return this.ctrlKey&&(h|=D),this.altKey&&(h|=c),this.shiftKey&&(h|=f),this.metaKey&&(h|=m),h|=a,h}d(){let a=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode),new i.$Lq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,a)}}t.$MO=o}),define($e[19],pe([1,0,16,68,5]),function(le,t,w,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JO=t.$IO=t.$HO=void 0;class q{constructor(f){this.timestamp=Date.now(),this.browserEvent=f,this.leftButton=f.button===0,this.middleButton=f.button===1,this.rightButton=f.button===2,this.buttons=f.buttons,this.target=f.target,this.detail=f.detail||1,f.type==="dblclick"&&(this.detail=2),this.ctrlKey=f.ctrlKey,this.shiftKey=f.shiftKey,this.altKey=f.altKey,this.metaKey=f.metaKey,typeof f.pageX=="number"?(this.posx=f.pageX,this.posy=f.pageY):(this.posx=f.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=f.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const m=O.$FO.getPositionOfChildWindowRelativeToAncestorWindow(window,f.view);this.posx-=m.left,this.posy-=m.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$HO=q;class p extends q{constructor(f){super(f),this.dataTransfer=f.dataTransfer}}t.$IO=p;class D{constructor(f,m=0,L=0){if(this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=L,this.deltaX=m,f){const n=f,o=f;if(typeof n.wheelDeltaY<"u")this.deltaY=n.wheelDeltaY/120;else if(typeof o.VERTICAL_AXIS<"u"&&o.axis===o.VERTICAL_AXIS)this.deltaY=-o.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?w.$vO&&!i.$k?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof n.wheelDeltaX<"u")w.$yO&&i.$j?this.deltaX=-(n.wheelDeltaX/120):this.deltaX=n.wheelDeltaX/120;else if(typeof o.HORIZONTAL_AXIS<"u"&&o.axis===o.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?w.$vO&&!i.$k?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&(this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$JO=D}),define($e[112],pe([1,0,5]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dc=t.$cc=t.env=t.cwd=void 0;let O;if(typeof w.$h.vscode<"u"&&typeof w.$h.vscode.process<"u"){const i=w.$h.vscode.process;O={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return w.$j?"win32":w.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=O.cwd,t.env=O.env,t.$cc=O.platform,t.$dc=O.arch}),define($e[22],pe([1,0,112]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.sep=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=void 0;const O=65,i=97,q=90,p=122,D=46,c=47,f=92,m=58,L=63;class n extends Error{constructor(y,I,T){let g;typeof I=="string"&&I.indexOf("not ")===0?(g="must not be",I=I.replace(/^not /,"")):g="must be";const v=y.indexOf(".")!==-1?"property":"argument";let z=`The "${y}" ${v} ${g} of type ${I}`;z+=`. Received type ${typeof T}`,super(z),this.code="ERR_INVALID_ARG_TYPE"}}function o(r,y){if(r===null||typeof r!="object")throw new n(y,"Object",r)}function e(r,y){if(typeof r!="string")throw new n(y,"string",r)}const a=w.$cc==="win32";function h(r){return r===c||r===f}function $(r){return r===c}function s(r){return r>=O&&r<=q||r>=i&&r<=p}function u(r,y,I,T){let g="",v=0,z=-1,H=0,_=0;for(let M=0;M<=r.length;++M){if(M<r.length)_=r.charCodeAt(M);else{if(T(_))break;_=c}if(T(_)){if(!(z===M-1||H===1))if(H===2){if(g.length<2||v!==2||g.charCodeAt(g.length-1)!==D||g.charCodeAt(g.length-2)!==D){if(g.length>2){const F=g.lastIndexOf(I);F===-1?(g="",v=0):(g=g.slice(0,F),v=g.length-1-g.lastIndexOf(I)),z=M,H=0;continue}else if(g.length!==0){g="",v=0,z=M,H=0;continue}}y&&(g+=g.length>0?`${I}..`:"..",v=2)}else g.length>0?g+=`${I}${r.slice(z+1,M)}`:g=r.slice(z+1,M),v=M-z-1;z=M,H=0}else _===D&&H!==-1?++H:H=-1}return g}function d(r,y){o(y,"pathObject");const I=y.dir||y.root,T=y.base||`${y.name||""}${y.ext||""}`;return I?I===y.root?`${I}${T}`:`${I}${r}${T}`:T}t.$ec={resolve(...r){let y="",I="",T=!1;for(let g=r.length-1;g>=-1;g--){let v;if(g>=0){if(v=r[g],e(v,"path"),v.length===0)continue}else y.length===0?v=w.cwd():(v=w.env[`=${y}`]||w.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==y.toLowerCase()&&v.charCodeAt(2)===f)&&(v=`${y}\\`));const z=v.length;let H=0,_="",M=!1;const F=v.charCodeAt(0);if(z===1)h(F)&&(H=1,M=!0);else if(h(F))if(M=!0,h(v.charCodeAt(1))){let Z=2,ee=Z;for(;Z<z&&!h(v.charCodeAt(Z));)Z++;if(Z<z&&Z!==ee){const ue=v.slice(ee,Z);for(ee=Z;Z<z&&h(v.charCodeAt(Z));)Z++;if(Z<z&&Z!==ee){for(ee=Z;Z<z&&!h(v.charCodeAt(Z));)Z++;(Z===z||Z!==ee)&&(_=`\\\\${ue}\\${v.slice(ee,Z)}`,H=Z)}}}else H=1;else s(F)&&v.charCodeAt(1)===m&&(_=v.slice(0,2),H=2,z>2&&h(v.charCodeAt(2))&&(M=!0,H=3));if(_.length>0)if(y.length>0){if(_.toLowerCase()!==y.toLowerCase())continue}else y=_;if(T){if(y.length>0)break}else if(I=`${v.slice(H)}\\${I}`,T=M,M&&y.length>0)break}return I=u(I,!T,"\\",h),T?`${y}\\${I}`:`${y}${I}`||"."},normalize(r){e(r,"path");const y=r.length;if(y===0)return".";let I=0,T,g=!1;const v=r.charCodeAt(0);if(y===1)return $(v)?"\\":r;if(h(v))if(g=!0,h(r.charCodeAt(1))){let H=2,_=H;for(;H<y&&!h(r.charCodeAt(H));)H++;if(H<y&&H!==_){const M=r.slice(_,H);for(_=H;H<y&&h(r.charCodeAt(H));)H++;if(H<y&&H!==_){for(_=H;H<y&&!h(r.charCodeAt(H));)H++;if(H===y)return`\\\\${M}\\${r.slice(_)}\\`;H!==_&&(T=`\\\\${M}\\${r.slice(_,H)}`,I=H)}}}else I=1;else s(v)&&r.charCodeAt(1)===m&&(T=r.slice(0,2),I=2,y>2&&h(r.charCodeAt(2))&&(g=!0,I=3));let z=I<y?u(r.slice(I),!g,"\\",h):"";return z.length===0&&!g&&(z="."),z.length>0&&h(r.charCodeAt(y-1))&&(z+="\\"),T===void 0?g?`\\${z}`:z:g?`${T}\\${z}`:`${T}${z}`},isAbsolute(r){e(r,"path");const y=r.length;if(y===0)return!1;const I=r.charCodeAt(0);return h(I)||y>2&&s(I)&&r.charCodeAt(1)===m&&h(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let y,I;for(let v=0;v<r.length;++v){const z=r[v];e(z,"path"),z.length>0&&(y===void 0?y=I=z:y+=`\\${z}`)}if(y===void 0)return".";let T=!0,g=0;if(typeof I=="string"&&h(I.charCodeAt(0))){++g;const v=I.length;v>1&&h(I.charCodeAt(1))&&(++g,v>2&&(h(I.charCodeAt(2))?++g:T=!1))}if(T){for(;g<y.length&&h(y.charCodeAt(g));)g++;g>=2&&(y=`\\${y.slice(g)}`)}return t.$ec.normalize(y)},relative(r,y){if(e(r,"from"),e(y,"to"),r===y)return"";const I=t.$ec.resolve(r),T=t.$ec.resolve(y);if(I===T||(r=I.toLowerCase(),y=T.toLowerCase(),r===y))return"";let g=0;for(;g<r.length&&r.charCodeAt(g)===f;)g++;let v=r.length;for(;v-1>g&&r.charCodeAt(v-1)===f;)v--;const z=v-g;let H=0;for(;H<y.length&&y.charCodeAt(H)===f;)H++;let _=y.length;for(;_-1>H&&y.charCodeAt(_-1)===f;)_--;const M=_-H,F=z<M?z:M;let Z=-1,ee=0;for(;ee<F;ee++){const oe=r.charCodeAt(g+ee);if(oe!==y.charCodeAt(H+ee))break;oe===f&&(Z=ee)}if(ee!==F){if(Z===-1)return T}else{if(M>F){if(y.charCodeAt(H+ee)===f)return T.slice(H+ee+1);if(ee===2)return T.slice(H+ee)}z>F&&(r.charCodeAt(g+ee)===f?Z=ee:ee===2&&(Z=3)),Z===-1&&(Z=0)}let ue="";for(ee=g+Z+1;ee<=v;++ee)(ee===v||r.charCodeAt(ee)===f)&&(ue+=ue.length===0?"..":"\\..");return H+=Z,ue.length>0?`${ue}${T.slice(H,_)}`:(T.charCodeAt(H)===f&&++H,T.slice(H,_))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const y=t.$ec.resolve(r);if(y.length<=2)return r;if(y.charCodeAt(0)===f){if(y.charCodeAt(1)===f){const I=y.charCodeAt(2);if(I!==L&&I!==D)return`\\\\?\\UNC\\${y.slice(2)}`}}else if(s(y.charCodeAt(0))&&y.charCodeAt(1)===m&&y.charCodeAt(2)===f)return`\\\\?\\${y}`;return r},dirname(r){e(r,"path");const y=r.length;if(y===0)return".";let I=-1,T=0;const g=r.charCodeAt(0);if(y===1)return h(g)?r:".";if(h(g)){if(I=T=1,h(r.charCodeAt(1))){let H=2,_=H;for(;H<y&&!h(r.charCodeAt(H));)H++;if(H<y&&H!==_){for(_=H;H<y&&h(r.charCodeAt(H));)H++;if(H<y&&H!==_){for(_=H;H<y&&!h(r.charCodeAt(H));)H++;if(H===y)return r;H!==_&&(I=T=H+1)}}}}else s(g)&&r.charCodeAt(1)===m&&(I=y>2&&h(r.charCodeAt(2))?3:2,T=I);let v=-1,z=!0;for(let H=y-1;H>=T;--H)if(h(r.charCodeAt(H))){if(!z){v=H;break}}else z=!1;if(v===-1){if(I===-1)return".";v=I}return r.slice(0,v)},basename(r,y){y!==void 0&&e(y,"ext"),e(r,"path");let I=0,T=-1,g=!0,v;if(r.length>=2&&s(r.charCodeAt(0))&&r.charCodeAt(1)===m&&(I=2),y!==void 0&&y.length>0&&y.length<=r.length){if(y===r)return"";let z=y.length-1,H=-1;for(v=r.length-1;v>=I;--v){const _=r.charCodeAt(v);if(h(_)){if(!g){I=v+1;break}}else H===-1&&(g=!1,H=v+1),z>=0&&(_===y.charCodeAt(z)?--z===-1&&(T=v):(z=-1,T=H))}return I===T?T=H:T===-1&&(T=r.length),r.slice(I,T)}for(v=r.length-1;v>=I;--v)if(h(r.charCodeAt(v))){if(!g){I=v+1;break}}else T===-1&&(g=!1,T=v+1);return T===-1?"":r.slice(I,T)},extname(r){e(r,"path");let y=0,I=-1,T=0,g=-1,v=!0,z=0;r.length>=2&&r.charCodeAt(1)===m&&s(r.charCodeAt(0))&&(y=T=2);for(let H=r.length-1;H>=y;--H){const _=r.charCodeAt(H);if(h(_)){if(!v){T=H+1;break}continue}g===-1&&(v=!1,g=H+1),_===D?I===-1?I=H:z!==1&&(z=1):I!==-1&&(z=-1)}return I===-1||g===-1||z===0||z===1&&I===g-1&&I===T+1?"":r.slice(I,g)},format:d.bind(null,"\\"),parse(r){e(r,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return y;const I=r.length;let T=0,g=r.charCodeAt(0);if(I===1)return h(g)?(y.root=y.dir=r,y):(y.base=y.name=r,y);if(h(g)){if(T=1,h(r.charCodeAt(1))){let Z=2,ee=Z;for(;Z<I&&!h(r.charCodeAt(Z));)Z++;if(Z<I&&Z!==ee){for(ee=Z;Z<I&&h(r.charCodeAt(Z));)Z++;if(Z<I&&Z!==ee){for(ee=Z;Z<I&&!h(r.charCodeAt(Z));)Z++;Z===I?T=Z:Z!==ee&&(T=Z+1)}}}}else if(s(g)&&r.charCodeAt(1)===m){if(I<=2)return y.root=y.dir=r,y;if(T=2,h(r.charCodeAt(2))){if(I===3)return y.root=y.dir=r,y;T=3}}T>0&&(y.root=r.slice(0,T));let v=-1,z=T,H=-1,_=!0,M=r.length-1,F=0;for(;M>=T;--M){if(g=r.charCodeAt(M),h(g)){if(!_){z=M+1;break}continue}H===-1&&(_=!1,H=M+1),g===D?v===-1?v=M:F!==1&&(F=1):v!==-1&&(F=-1)}return H!==-1&&(v===-1||F===0||F===1&&v===H-1&&v===z+1?y.base=y.name=r.slice(z,H):(y.name=r.slice(z,v),y.base=r.slice(z,H),y.ext=r.slice(v,H))),z>0&&z!==T?y.dir=r.slice(0,z-1):y.dir=y.root,y},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(a){const r=/\\/g;return()=>{const y=w.cwd().replace(r,"/");return y.slice(y.indexOf("/"))}}return()=>w.cwd()})();t.$fc={resolve(...r){let y="",I=!1;for(let T=r.length-1;T>=-1&&!I;T--){const g=T>=0?r[T]:l();e(g,"path"),g.length!==0&&(y=`${g}/${y}`,I=g.charCodeAt(0)===c)}return y=u(y,!I,"/",$),I?`/${y}`:y.length>0?y:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const y=r.charCodeAt(0)===c,I=r.charCodeAt(r.length-1)===c;return r=u(r,!y,"/",$),r.length===0?y?"/":I?"./":".":(I&&(r+="/"),y?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===c},join(...r){if(r.length===0)return".";let y;for(let I=0;I<r.length;++I){const T=r[I];e(T,"path"),T.length>0&&(y===void 0?y=T:y+=`/${T}`)}return y===void 0?".":t.$fc.normalize(y)},relative(r,y){if(e(r,"from"),e(y,"to"),r===y||(r=t.$fc.resolve(r),y=t.$fc.resolve(y),r===y))return"";const I=1,T=r.length,g=T-I,v=1,z=y.length-v,H=g<z?g:z;let _=-1,M=0;for(;M<H;M++){const Z=r.charCodeAt(I+M);if(Z!==y.charCodeAt(v+M))break;Z===c&&(_=M)}if(M===H)if(z>H){if(y.charCodeAt(v+M)===c)return y.slice(v+M+1);if(M===0)return y.slice(v+M)}else g>H&&(r.charCodeAt(I+M)===c?_=M:M===0&&(_=0));let F="";for(M=I+_+1;M<=T;++M)(M===T||r.charCodeAt(M)===c)&&(F+=F.length===0?"..":"/..");return`${F}${y.slice(v+_)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const y=r.charCodeAt(0)===c;let I=-1,T=!0;for(let g=r.length-1;g>=1;--g)if(r.charCodeAt(g)===c){if(!T){I=g;break}}else T=!1;return I===-1?y?"/":".":y&&I===1?"//":r.slice(0,I)},basename(r,y){y!==void 0&&e(y,"ext"),e(r,"path");let I=0,T=-1,g=!0,v;if(y!==void 0&&y.length>0&&y.length<=r.length){if(y===r)return"";let z=y.length-1,H=-1;for(v=r.length-1;v>=0;--v){const _=r.charCodeAt(v);if(_===c){if(!g){I=v+1;break}}else H===-1&&(g=!1,H=v+1),z>=0&&(_===y.charCodeAt(z)?--z===-1&&(T=v):(z=-1,T=H))}return I===T?T=H:T===-1&&(T=r.length),r.slice(I,T)}for(v=r.length-1;v>=0;--v)if(r.charCodeAt(v)===c){if(!g){I=v+1;break}}else T===-1&&(g=!1,T=v+1);return T===-1?"":r.slice(I,T)},extname(r){e(r,"path");let y=-1,I=0,T=-1,g=!0,v=0;for(let z=r.length-1;z>=0;--z){const H=r.charCodeAt(z);if(H===c){if(!g){I=z+1;break}continue}T===-1&&(g=!1,T=z+1),H===D?y===-1?y=z:v!==1&&(v=1):y!==-1&&(v=-1)}return y===-1||T===-1||v===0||v===1&&y===T-1&&y===I+1?"":r.slice(y,T)},format:d.bind(null,"/"),parse(r){e(r,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return y;const I=r.charCodeAt(0)===c;let T;I?(y.root="/",T=1):T=0;let g=-1,v=0,z=-1,H=!0,_=r.length-1,M=0;for(;_>=T;--_){const F=r.charCodeAt(_);if(F===c){if(!H){v=_+1;break}continue}z===-1&&(H=!1,z=_+1),F===D?g===-1?g=_:M!==1&&(M=1):g!==-1&&(M=-1)}if(z!==-1){const F=v===0&&I?1:v;g===-1||M===0||M===1&&g===z-1&&g===v+1?y.base=y.name=r.slice(F,z):(y.name=r.slice(F,g),y.base=r.slice(F,z),y.ext=r.slice(g,z))}return v>0?y.dir=r.slice(0,v-1):I&&(y.dir="/"),y},sep:"/",delimiter:":",win32:null,posix:null},t.$fc.win32=t.$ec.win32=t.$ec,t.$fc.posix=t.$ec.posix=t.$fc,t.$gc=a?t.$ec.normalize:t.$fc.normalize,t.$hc=a?t.$ec.isAbsolute:t.$fc.isAbsolute,t.$ic=a?t.$ec.join:t.$fc.join,t.$jc=a?t.$ec.resolve:t.$fc.resolve,t.$kc=a?t.$ec.relative:t.$fc.relative,t.$lc=a?t.$ec.dirname:t.$fc.dirname,t.$mc=a?t.$ec.basename:t.$fc.basename,t.$nc=a?t.$ec.extname:t.$fc.extname,t.$oc=a?t.$ec.format:t.$fc.format,t.$pc=a?t.$ec.parse:t.$fc.parse,t.$qc=a?t.$ec.toNamespacedPath:t.$fc.toNamespacedPath,t.sep=a?t.$ec.sep:t.$fc.sep,t.$sc=a?t.$ec.delimiter:t.$fc.delimiter}),define($e[113],pe([1,0,22,5,12,7]),function(le,t,w,O,i,q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=void 0;function p(v){return v===47||v===92}t.$Qf=p;function D(v){return v.replace(/[\\/]/g,w.$fc.sep)}t.$Rf=D;function c(v){return v.indexOf("/")===-1&&(v=D(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}t.$Sf=c;function f(v,z=w.$fc.sep){if(!v)return"";const H=v.length,_=v.charCodeAt(0);if(p(_)){if(p(v.charCodeAt(1))&&!p(v.charCodeAt(2))){let F=3;const Z=F;for(;F<H&&!p(v.charCodeAt(F));F++);if(Z!==F&&!p(v.charCodeAt(F+1))){for(F+=1;F<H;F++)if(p(v.charCodeAt(F)))return v.slice(0,F+1).replace(/[\\/]/g,z)}}return z}else if($(_)&&v.charCodeAt(1)===58)return p(v.charCodeAt(2))?v.slice(0,2)+z:v.slice(0,2);let M=v.indexOf("://");if(M!==-1){for(M+=3;M<H;M++)if(p(v.charCodeAt(M)))return v.slice(0,M+1)}return""}t.$Tf=f;function m(v){if(!O.$j||!v||v.length<5)return!1;let z=v.charCodeAt(0);if(z!==92||(z=v.charCodeAt(1),z!==92))return!1;let H=2;const _=H;for(;H<v.length&&(z=v.charCodeAt(H),z!==92);H++);return!(_===H||(z=v.charCodeAt(H+1),isNaN(z)||z===92))}t.$Uf=m;const L=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(v,z=O.$j){const H=z?L:n;return!(!v||v.length===0||/^\s+$/.test(v)||(H.lastIndex=0,H.test(v))||z&&o.test(v)||v==="."||v===".."||z&&v[v.length-1]==="."||z&&v.length!==v.trim().length||v.length>255)}t.$Vf=e;function a(v,z,H){const _=v===z;return!H||_?_:!v||!z?!1:(0,i.$2e)(v,z)}t.$Wf=a;function h(v,z,H,_=w.sep){if(v===z)return!0;if(!v||!z||z.length>v.length)return!1;if(H){if(!(0,i.$3e)(v,z))return!1;if(z.length===v.length)return!0;let F=z.length;return z.charAt(z.length-1)===_&&F--,v.charAt(F)===_}return z.charAt(z.length-1)!==_&&(z+=_),v.indexOf(z)===0}t.$Xf=h;function $(v){return v>=65&&v<=90||v>=97&&v<=122}t.$Yf=$;function s(v,z){return O.$j&&v.endsWith(":")&&(v+=w.sep),(0,w.$hc)(v)||(v=(0,w.$ic)(z,v)),v=(0,w.$gc)(v),O.$j?(v=(0,i.$Ke)(v,w.sep),v.endsWith(":")&&(v+=w.sep)):(v=(0,i.$Ke)(v,w.sep),v||(v=w.sep)),v}t.$Zf=s;function u(v){const z=(0,w.$gc)(v);return O.$j?v.length>3?!1:d(z)&&(v.length===2||z.charCodeAt(2)===92):z===w.$fc.sep}t.$1f=u;function d(v,z=O.$j){return z?$(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}t.$2f=d;function l(v,z=O.$j){return d(v,z)?v[0]:void 0}t.$3f=l;function r(v,z,H){return z.length>v.length?-1:v===z?0:(H&&(v=v.toLowerCase(),z=z.toLowerCase()),v.indexOf(z))}t.$4f=r;function y(v){const z=v.split(":");let H,_,M;for(const F of z){const Z=Number(F);(0,q.$Cf)(Z)?_===void 0?_=Z:M===void 0&&(M=Z):H=H?[H,F].join(":"):F}if(!H)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:H,line:_!==void 0?_:void 0,column:M!==void 0?M:_!==void 0?1:void 0}}t.$5f=y;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",T="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function g(v,z,H=8){let _="";for(let F=0;F<H;F++){let Z;F===0&&O.$j&&!z&&(H===3||H===4)?Z=T:Z=I,_+=Z.charAt(Math.floor(Math.random()*Z.length))}let M;return z?M=`${z}-${_}`:M=_,v?(0,w.$ic)(v,M):M}t.$6f=g}),define($e[114],pe([1,0,22]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wr=t.$Vr=t.$Ur=t.$Tr=t.$Sr=void 0,t.$Sr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function q(m){const L=(0,w.$nc)(m),n=O[L.toLowerCase()];return n!==void 0?n:p(m)}t.$Tr=q;function p(m){const L=(0,w.$nc)(m);return i[L.toLowerCase()]}t.$Ur=p;function D(m){for(const L in i)if(i[L]===m)return L}t.$Vr=D;const c=/^(.+)\/(.+?)(;.+)?$/;function f(m,L){const n=c.exec(m);return n?`${n[1].toLowerCase()}/${n[2].toLowerCase()}${n[3]??""}`:L?void 0:m}t.$Wr=f}),define($e[15],pe([1,0,22,5]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vc=t.$uc=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,q=/^\//,p=/^\/\//;function D(T,g){if(!T.scheme&&g)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${T.authority}", path: "${T.path}", query: "${T.query}", fragment: "${T.fragment}"}`);if(T.scheme&&!i.test(T.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(T.path){if(T.authority){if(!q.test(T.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(T.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(T,g){return!T&&!g?"file":T}function f(T,g){switch(T){case"https":case"http":case"file":g?g[0]!==L&&(g=L+g):g=L;break}return g}const m="",L="/",n=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class o{static isUri(g){return g instanceof o?!0:g?typeof g.authority=="string"&&typeof g.fragment=="string"&&typeof g.path=="string"&&typeof g.query=="string"&&typeof g.scheme=="string"&&typeof g.fsPath=="string"&&typeof g.with=="function"&&typeof g.toString=="function":!1}constructor(g,v,z,H,_,M=!1){typeof g=="object"?(this.scheme=g.scheme||m,this.authority=g.authority||m,this.path=g.path||m,this.query=g.query||m,this.fragment=g.fragment||m):(this.scheme=c(g,M),this.authority=v||m,this.path=f(this.scheme,z||m),this.query=H||m,this.fragment=_||m,D(this,M))}get fsPath(){return d(this,!1)}with(g){if(!g)return this;let{scheme:v,authority:z,path:H,query:_,fragment:M}=g;return v===void 0?v=this.scheme:v===null&&(v=m),z===void 0?z=this.authority:z===null&&(z=m),H===void 0?H=this.path:H===null&&(H=m),_===void 0?_=this.query:_===null&&(_=m),M===void 0?M=this.fragment:M===null&&(M=m),v===this.scheme&&z===this.authority&&H===this.path&&_===this.query&&M===this.fragment?this:new h(v,z,H,_,M)}static parse(g,v=!1){const z=n.exec(g);return z?new h(z[2]||m,I(z[4]||m),I(z[5]||m),I(z[7]||m),I(z[9]||m),v):new h(m,m,m,m,m)}static file(g){let v=m;if(O.$j&&(g=g.replace(/\\/g,L)),g[0]===L&&g[1]===L){const z=g.indexOf(L,2);z===-1?(v=g.substring(2),g=L):(v=g.substring(2,z),g=g.substring(z)||L)}return new h("file",v,g,m,m)}static from(g,v){return new h(g.scheme,g.authority,g.path,g.query,g.fragment,v)}static joinPath(g,...v){if(!g.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let z;return O.$j&&g.scheme==="file"?z=o.file(w.$ec.join(d(g,!0),...v)).path:z=w.$fc.join(g.path,...v),g.with({path:z})}toString(g=!1){return l(this,g)}toJSON(){return this}static revive(g){if(g){if(g instanceof o)return g;{const v=new h(g);return v._formatted=g.external??null,v._fsPath=g._sep===a?g.fsPath??null:null,v}}else return g}}t.URI=o;function e(T){return!T||typeof T!="object"?!1:typeof T.scheme=="string"&&(typeof T.authority=="string"||typeof T.authority>"u")&&(typeof T.path=="string"||typeof T.path>"u")&&(typeof T.query=="string"||typeof T.query>"u")&&(typeof T.fragment=="string"||typeof T.fragment>"u")}t.$uc=e;const a=O.$j?1:void 0;class h extends o{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(g=!1){return g?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const g={$mid:1};return this._fsPath&&(g.fsPath=this._fsPath,g._sep=a),this._formatted&&(g.external=this._formatted),this.path&&(g.path=this.path),this.scheme&&(g.scheme=this.scheme),this.authority&&(g.authority=this.authority),this.query&&(g.query=this.query),this.fragment&&(g.fragment=this.fragment),g}}const $={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function s(T,g,v){let z,H=-1;for(let _=0;_<T.length;_++){const M=T.charCodeAt(_);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||g&&M===47||v&&M===91||v&&M===93||v&&M===58)H!==-1&&(z+=encodeURIComponent(T.substring(H,_)),H=-1),z!==void 0&&(z+=T.charAt(_));else{z===void 0&&(z=T.substr(0,_));const F=$[M];F!==void 0?(H!==-1&&(z+=encodeURIComponent(T.substring(H,_)),H=-1),z+=F):H===-1&&(H=_)}}return H!==-1&&(z+=encodeURIComponent(T.substring(H))),z!==void 0?z:T}function u(T){let g;for(let v=0;v<T.length;v++){const z=T.charCodeAt(v);z===35||z===63?(g===void 0&&(g=T.substr(0,v)),g+=$[z]):g!==void 0&&(g+=T[v])}return g!==void 0?g:T}function d(T,g){let v;return T.authority&&T.path.length>1&&T.scheme==="file"?v=`//${T.authority}${T.path}`:T.path.charCodeAt(0)===47&&(T.path.charCodeAt(1)>=65&&T.path.charCodeAt(1)<=90||T.path.charCodeAt(1)>=97&&T.path.charCodeAt(1)<=122)&&T.path.charCodeAt(2)===58?g?v=T.path.substr(1):v=T.path[1].toLowerCase()+T.path.substr(2):v=T.path,O.$j&&(v=v.replace(/\//g,"\\")),v}t.$vc=d;function l(T,g){const v=g?u:s;let z="",{scheme:H,authority:_,path:M,query:F,fragment:Z}=T;if(H&&(z+=H,z+=":"),(_||H==="file")&&(z+=L,z+=L),_){let ee=_.indexOf("@");if(ee!==-1){const ue=_.substr(0,ee);_=_.substr(ee+1),ee=ue.lastIndexOf(":"),ee===-1?z+=v(ue,!1,!1):(z+=v(ue.substr(0,ee),!1,!1),z+=":",z+=v(ue.substr(ee+1),!1,!0)),z+="@"}_=_.toLowerCase(),ee=_.lastIndexOf(":"),ee===-1?z+=v(_,!1,!0):(z+=v(_.substr(0,ee),!1,!0),z+=_.substr(ee))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const ee=M.charCodeAt(1);ee>=65&&ee<=90&&(M=`/${String.fromCharCode(ee+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const ee=M.charCodeAt(0);ee>=65&&ee<=90&&(M=`${String.fromCharCode(ee+32)}:${M.substr(2)}`)}z+=v(M,!0,!1)}return F&&(z+="?",z+=v(F,!1,!1)),Z&&(z+="#",z+=g?Z:s(Z,!1,!1)),z}function r(T){try{return decodeURIComponent(T)}catch{return T.length>3?T.substr(0,3)+r(T.substr(3)):T}}const y=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function I(T){return T.match(y)?T.replace(y,g=>r(g)):T}}),define($e[52],pe([1,0,32,15]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mh=t.$lh=t.$kh=void 0;function i(c){return JSON.stringify(c,p)}t.$kh=i;function q(c){let f=JSON.parse(c);return f=D(f),f}t.$lh=q;function p(c,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function D(c,f=0){if(!c||f>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return O.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 17:return new Date(c.source)}if(c instanceof w.$be||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let m=0;m<c.length;++m)c[m]=D(c[m],f+1);else for(const m in c)Object.hasOwnProperty.call(c,m)&&(c[m]=D(c[m],f+1))}return c}t.$mh=D}),define($e[29],pe([1,0,6,5,15]),function(le,t,w,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.Schemas=void 0;var q;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(q||(t.Schemas=q={})),t.$7f="vscode-tkn",t.$8f="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${q.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${q.vscodeRemoteResource}`}set(m,L,n){this.a[m]=L,this.b[m]=n}setConnectionToken(m,L){this.c[m]=L}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(h){return w.$Z(h),m}const L=m.authority;let n=this.a[L];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const o=this.b[L],e=this.c[L];let a=`path=${encodeURIComponent(m.path)}`;return typeof e=="string"&&(a+=`&${t.$8f}=${encodeURIComponent(e)}`),i.URI.from({scheme:O.$p?this.d:q.vscodeRemoteResource,authority:`${n}:${o}`,path:this.f,query:a})}}t.$9f=new p,t.$0f="vs/../../extensions",t.$$f="vs/../../node_modules",t.$_f="vs/../../node_modules.asar",t.$ag="vs/../../node_modules.asar.unpacked",t.$bg="vscode-app";class D{static{this.a=t.$bg}asBrowserUri(m){const L=this.b(m,le);return this.uriToBrowserUri(L)}uriToBrowserUri(m){return m.scheme===q.vscodeRemote?t.$9f.rewrite(m):m.scheme===q.file&&(O.$n||O.$q&&O.$h.origin===`${q.vscodeFileResource}://${D.a}`)?m.with({scheme:q.vscodeFileResource,authority:m.authority||D.a,query:null,fragment:null}):m}asFileUri(m){const L=this.b(m,le);return this.uriToFileUri(L)}uriToFileUri(m){return m.scheme===q.vscodeFileResource?m.with({scheme:q.file,authority:m.authority!==D.a?m.authority:null,query:null,fragment:null}):m}b(m,L){return i.URI.isUri(m)?m:i.URI.parse(L.toUrl(m))}}t.$cg=new D;var c;(function(f){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(m.get("3"));const L="vscode-coi";function n(e){let a;typeof e=="string"?a=new URL(e).searchParams:e instanceof URL?a=e.searchParams:i.URI.isUri(e)&&(a=new URL(e.toString(!0)).searchParams);const h=a?.get(L);if(h)return m.get(h)}f.getHeadersFromQuery=n;function o(e,a,h){if(!globalThis.crossOriginIsolated)return;const $=a&&h?"3":h?"2":"1";e instanceof URLSearchParams?e.set(L,$):e[L]=$}f.addSearchParam=o})(c||(t.COI=c={}))}),define($e[36],pe([1,0,113,29,22,5,12,15]),function(le,t,w,O,i,q,p,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fg=t.DataUri=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=t.$qg=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=void 0;function c(o){return(0,D.$vc)(o,!0)}t.$jg=c;class f{constructor(e){this.a=e}compare(e,a,h=!1){return e===a?0:(0,p.$Ue)(this.getComparisonKey(e,h),this.getComparisonKey(a,h))}isEqual(e,a,h=!1){return e===a?!0:!e||!a?!1:this.getComparisonKey(e,h)===this.getComparisonKey(a,h)}getComparisonKey(e,a=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,a,h=!1){if(e.scheme===a.scheme){if(e.scheme===O.Schemas.file)return w.$Xf(c(e),c(a),this.a(e))&&e.query===a.query&&(h||e.fragment===a.fragment);if((0,t.$Ag)(e.authority,a.authority))return w.$Xf(e.path,a.path,this.a(e),"/")&&e.query===a.query&&(h||e.fragment===a.fragment)}return!1}joinPath(e,...a){return D.URI.joinPath(e,...a)}basenameOrAuthority(e){return(0,t.$sg)(e)||e.authority}basename(e){return i.$fc.basename(e.path)}extname(e){return i.$fc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let a;return e.scheme===O.Schemas.file?a=D.URI.file(i.$lc(c(e))).path:(a=i.$fc.dirname(e.path),e.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),a="/")),e.with({path:a})}normalizePath(e){if(!e.path.length)return e;let a;return e.scheme===O.Schemas.file?a=D.URI.file(i.$gc(c(e))).path:a=i.$fc.normalize(e.path),e.with({path:a})}relativePath(e,a){if(e.scheme!==a.scheme||!(0,t.$Ag)(e.authority,a.authority))return;if(e.scheme===O.Schemas.file){const s=i.$kc(c(e),c(a));return q.$j?w.$Rf(s):s}let h=e.path||"/";const $=a.path||"/";if(this.a(e)){let s=0;for(const u=Math.min(h.length,$.length);s<u&&!(h.charCodeAt(s)!==$.charCodeAt(s)&&h.charAt(s).toLowerCase()!==$.charAt(s).toLowerCase());s++);h=$.substr(0,s)+h.substr(s)}return i.$fc.relative(h,$)}resolvePath(e,a){if(e.scheme===O.Schemas.file){const h=D.URI.file(i.$jc(c(e),a));return e.with({authority:h.authority,path:h.path})}return a=w.$Sf(a),e.with({path:i.$fc.resolve(e.path,a)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,a){return e===a||e!==void 0&&a!==void 0&&(0,p.$2e)(e,a)}hasTrailingPathSeparator(e,a=i.sep){if(e.scheme===O.Schemas.file){const h=c(e);return h.length>w.$Tf(h).length&&h[h.length-1]===a}else{const h=e.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,a=i.sep){return(0,t.$Bg)(e,a)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,a=i.sep){let h=!1;if(e.scheme===O.Schemas.file){const $=c(e);h=$!==void 0&&$.length===w.$Tf($).length&&$[$.length-1]===a}else{a="/";const $=e.path;h=$.length===1&&$.charCodeAt($.length-1)===47}return!h&&!(0,t.$Bg)(e,a)?e.with({path:e.path+"/"}):e}}t.$kg=f,t.$lg=new f(()=>!1),t.$mg=new f(o=>o.scheme===O.Schemas.file?!q.$l:!0),t.$ng=new f(o=>!0),t.$og=t.$lg.isEqual.bind(t.$lg),t.$pg=t.$lg.isEqualOrParent.bind(t.$lg),t.$qg=t.$lg.getComparisonKey.bind(t.$lg),t.$rg=t.$lg.basenameOrAuthority.bind(t.$lg),t.$sg=t.$lg.basename.bind(t.$lg),t.$tg=t.$lg.extname.bind(t.$lg),t.$ug=t.$lg.dirname.bind(t.$lg),t.$vg=t.$lg.joinPath.bind(t.$lg),t.$wg=t.$lg.normalizePath.bind(t.$lg),t.$xg=t.$lg.relativePath.bind(t.$lg),t.$yg=t.$lg.resolvePath.bind(t.$lg),t.$zg=t.$lg.isAbsolutePath.bind(t.$lg),t.$Ag=t.$lg.isEqualAuthority.bind(t.$lg),t.$Bg=t.$lg.hasTrailingPathSeparator.bind(t.$lg),t.$Cg=t.$lg.removeTrailingPathSeparator.bind(t.$lg),t.$Dg=t.$lg.addTrailingPathSeparator.bind(t.$lg);function m(o,e){const a=[];for(let h=0;h<o.length;h++){const $=e(o[h]);o.some((s,u)=>u===h?!1:(0,t.$pg)($,e(s)))||a.push(o[h])}return a}t.$Eg=m;var L;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function e(a){const h=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(u=>{const[d,l]=u.split(":");d&&l&&h.set(d,l)});const s=a.path.substring(0,a.path.indexOf(";"));return s&&h.set(o.META_DATA_MIME,s),h}o.parseMetaData=e})(L||(t.DataUri=L={}));function n(o,e,a){if(e){let h=o.path;return h&&h[0]!==i.$fc.sep&&(h=i.$fc.sep+h),o.with({scheme:a,authority:e,path:h})}return o.with({scheme:a})}t.$Fg=n}),define($e[9],pe([1,0,28,6,4,2,36,5,49]),function(le,t,w,O,i,q,p,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gh=t.$fh=t.$eh=t.$dh=t.Promises=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=void 0;function f(R){return!!R&&typeof R.then=="function"}t.$Gg=f;function m(R){const B=new w.$Xd,N=R(B.token),A=new Promise((k,U)=>{const C=B.token.onCancellationRequested(()=>{C.dispose(),B.dispose(),U(new O.$4)});Promise.resolve(N).then(j=>{C.dispose(),B.dispose(),k(j)},j=>{C.dispose(),B.dispose(),U(j)})});return new class{cancel(){B.cancel()}then(k,U){return A.then(k,U)}catch(k){return this.then(void 0,k)}finally(k){return A.finally(k)}}}t.$Hg=m;function L(R,B,N){return new Promise((A,k)=>{const U=B.onCancellationRequested(()=>{U.dispose(),A(N)});R.then(A,k).finally(()=>U.dispose())})}t.$Ig=L;function n(R,B){return new Promise((N,A)=>{const k=B.onCancellationRequested(()=>{k.dispose(),A(new O.$4)});R.then(N,A).finally(()=>k.dispose())})}t.$Jg=n;async function o(R){let B=-1;const N=R.map((A,k)=>A.then(U=>(B=k,U)));try{return await Promise.race(N)}finally{R.forEach((A,k)=>{k!==B&&A.cancel()})}}t.$Kg=o;function e(R,B,N){let A;const k=setTimeout(()=>{A?.(void 0),N?.()},B);return Promise.race([R.finally(()=>clearTimeout(k)),new Promise(U=>A=U)])}t.$Lg=e;function a(R){return new Promise((B,N)=>{const A=R();f(A)?A.then(B,N):B(A)})}t.$Mg=a;class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(B){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=B,!this.b){const N=()=>{if(this.b=null,this.f)return;const A=this.queue(this.d);return this.d=null,A};this.b=new Promise(A=>{this.a.then(N,N).then(A)})}return new Promise((N,A)=>{this.b.then(N,A)})}return this.a=B(),new Promise((N,A)=>{this.a.then(k=>{this.a=null,N(k)},k=>{this.a=null,A(k)})})}dispose(){this.f=!0}}t.$Ng=h;class ${constructor(){this.a=Promise.resolve(null)}queue(B){return this.a=this.a.then(()=>B(),()=>B())}}t.$Og=$;class s{constructor(){this.a=new Map}queue(B,N){const k=(this.a.get(B)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.a.get(B)===k&&this.a.delete(B)});return this.a.set(B,k),k}}t.$Pg=s;const u=(R,B)=>{let N=!0;const A=setTimeout(()=>{N=!1,B()},R);return{isTriggered:()=>N,dispose:()=>{clearTimeout(A),N=!1}}},d=R=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,R())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class l{constructor(B){this.defaultDelay=B,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(B,N=this.defaultDelay){this.g=B,this.h(),this.b||(this.b=new Promise((k,U)=>{this.d=k,this.f=U}).then(()=>{if(this.b=null,this.d=null,this.g){const k=this.g;return this.g=null,k()}}));const A=()=>{this.a=null,this.d?.(null)};return this.a=N===c.$Kd?d(A):u(N,A),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Qg=l;class r{constructor(B){this.a=new l(B),this.b=new h}trigger(B,N){return this.a.trigger(()=>this.b.queue(B),N)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Rg=r;class y{constructor(){this.a=!1,this.b=new Promise((B,N)=>{this.d=B})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Sg=y;class I extends y{constructor(B){super(),this.f=setTimeout(()=>this.open(),B)}open(){clearTimeout(this.f),super.open()}}t.$Tg=I;function T(R,B){return B?new Promise((N,A)=>{const k=setTimeout(()=>{U.dispose(),N()},R),U=B.onCancellationRequested(()=>{clearTimeout(k),U.dispose(),A(new O.$4)})}):m(N=>T(R,N))}t.$Ug=T;function g(R,B=0,N){const A=setTimeout(()=>{R(),N&&k.dispose()},B),k=(0,q.$Pc)(()=>{clearTimeout(A),N?.deleteAndLeak(k)});return N?.add(k),k}t.$Vg=g;function v(R){const B=[];let N=0;const A=R.length;function k(){return N<A?R[N++]():null}function U(C){C!=null&&B.push(C);const j=k();return j?j.then(U):Promise.resolve(B)}return Promise.resolve(null).then(U)}t.$Wg=v;function z(R,B=A=>!!A,N=null){let A=0;const k=R.length,U=()=>{if(A>=k)return Promise.resolve(N);const C=R[A++];return Promise.resolve(C()).then(E=>B(E)?Promise.resolve(E):U())};return U()}t.$Xg=z;function H(R,B=A=>!!A,N=null){if(R.length===0)return Promise.resolve(N);let A=R.length;const k=()=>{A=-1;for(const U of R)U.cancel?.()};return new Promise((U,C)=>{for(const j of R)j.then(E=>{--A>=0&&B(E)?(k(),U(E)):A===0&&U(N)}).catch(E=>{--A>=0&&(k(),C(E))})})}t.$Yg=H;class _{constructor(B){this.a=0,this.d=B,this.f=[],this.b=0,this.g=new i.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(B){return this.a++,new Promise((N,A)=>{this.f.push({factory:B,c:N,e:A}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const B=this.f.shift();this.b++;const N=B.factory();N.then(B.c,B.e),N.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$Zg=_;class M extends _{constructor(){super(1)}}t.$1g=M;class F{constructor(){this.a=new Fe,this.b=0}queue(B){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,B())):this.a.run(this.b++,B())}}t.$2g=F;class Z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const B=new ce;return this.b.add(B),B.p}g(){for(const[,B]of this.a)if(B.size>0)return!1;return!0}queueFor(B,N=p.$lg){const A=N.getComparisonKey(B);let k=this.a.get(A);if(!k){k=new M;const U=this.f++,C=i.Event.once(k.onDrained)(()=>{k?.dispose(),this.a.delete(A),this.h(),this.d?.deleteAndDispose(U),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new q.$Zc),this.d.set(U,C),this.a.set(A,k)}return k}h(){this.g()&&this.j()}j(){for(const B of this.b)B.complete();this.b.clear()}dispose(){for(const[,B]of this.a)B.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$3g=Z;class ee{constructor(B,N){this.a=-1,typeof B=="function"&&typeof N=="number"&&this.setIfNotSet(B,N)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(B,N){this.cancel(),this.a=setTimeout(()=>{this.a=-1,B()},N)}setIfNotSet(B,N){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,B()},N))}}t.$4g=ee;class ue{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(B,N){this.cancel(),this.a=setInterval(()=>{B()},N)}}t.$5g=ue;class oe{constructor(B,N){this.b=-1,this.a=B,this.d=N,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(B=this.d){this.cancel(),this.b=setTimeout(this.f,B)}get delay(){return this.d}set delay(B){this.d=B}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$6g=oe;class se{constructor(B,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.a=B,this.b=N,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(B=this.b){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(B/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$7g=se;class re extends oe{constructor(B,N){super(B,N),this.j=[]}work(B){this.j.push(B),this.isScheduled()||this.schedule()}h(){const B=this.j;this.j=[],this.a?.(B)}dispose(){this.j=[],super.dispose()}}t.$8g=re;class be extends q.$Rc{constructor(B,N){super(),this.g=B,this.h=N,this.a=[],this.b=this.B(new q.$Sc),this.f=!1}get pending(){return this.a.length}work(B){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+B.length>this.g.maxBufferedWork)return!1}else if(this.pending+B.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const N of B)this.a.push(N);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new oe(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$9g=be,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.$0g=R=>{(0,D.$B)(()=>{if(B)return;const N=Date.now()+15;R(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let B=!1;return{dispose(){B||(B=!0)}}}:t.$0g=(R,B)=>{const N=requestIdleCallback(R,typeof B=="number"?{timeout:B}:void 0);let A=!1;return{dispose(){A||(A=!0,cancelIdleCallback(N))}}}}();class Se{constructor(B){this.d=!1,this.a=()=>{try{this.f=B()}catch(N){this.g=N}finally{this.d=!0}},this.b=(0,t.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.$$g=Se;async function Le(R,B,N){let A;for(let k=0;k<N;k++)try{return await R()}catch(U){A=U,await T(B)}throw A}t.$_g=Le;class Fe{isRunning(B){return typeof B=="number"?this.a?.taskId===B:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(B,N,A){return this.a={taskId:B,cancel:()=>A?.(),promise:N},N.then(()=>this.d(B),()=>this.d(B)),N}d(B){this.a&&B===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const B=this.b;this.b=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}queue(B){if(this.b)this.b.run=B;else{let N,A;const k=new Promise((U,C)=>{N=U,A=C});this.b={run:B,promise:k,promiseResolve:N,promiseReject:A}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$ah=Fe;class de{constructor(B,N=()=>Date.now()){this.d=B,this.f=N,this.a=0,this.b=0}increment(){const B=this.f();return B-this.a>this.d&&(this.a=B,this.b=0),this.b++,this.b}}t.$bh=de;var ie;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(ie||(ie={}));class ce{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((B,N)=>{this.a=B,this.b=N})}complete(B){return new Promise(N=>{this.a(B),this.d={outcome:0,value:B},N()})}error(B){return new Promise(N=>{this.b(B),this.d={outcome:1,value:B},N()})}cancel(){return this.error(new O.$4)}}t.$ch=ce;var Y;(function(R){async function B(A){let k;const U=await Promise.all(A.map(C=>C.then(j=>j,j=>{k||(k=j)})));if(typeof k<"u")throw k;return U}R.settled=B;function N(A){return new Promise(async(k,U)=>{try{await A(k,U)}catch(C){U(C)}})}R.withAsyncBody=N})(Y||(t.Promises=Y={}));var V;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(V||(V={}));class G{static fromArray(B){return new G(N=>{N.emitMany(B)})}static fromPromise(B){return new G(async N=>{N.emitMany(await B)})}static fromPromises(B){return new G(async N=>{await Promise.all(B.map(async A=>N.emitOne(await A)))})}static merge(B){return new G(async N=>{await Promise.all(B.map(async A=>{for await(const k of A)N.emitOne(k)}))})}static{this.EMPTY=G.fromArray([])}constructor(B){this.a=0,this.b=[],this.d=null,this.f=new i.$Nd,queueMicrotask(async()=>{const N={emitOne:A=>this.g(A),emitMany:A=>this.h(A),reject:A=>this.k(A)};try{await Promise.resolve(B(N)),this.j()}catch(A){this.k(A)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(B<this.b.length)return{done:!1,value:this.b[B++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(B,N){return new G(async A=>{for await(const k of B)A.emitOne(N(k))})}map(B){return G.map(this,B)}static filter(B,N){return new G(async A=>{for await(const k of B)N(k)&&A.emitOne(k)})}filter(B){return G.filter(this,B)}static coalesce(B){return G.filter(B,N=>!!N)}coalesce(){return G.coalesce(this)}static async toPromise(B){const N=[];for await(const A of B)N.push(A);return N}toPromise(){return G.toPromise(this)}g(B){this.a===0&&(this.b.push(B),this.f.fire())}h(B){this.a===0&&(this.b=this.b.concat(B),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(B){this.a===0&&(this.a=2,this.d=B,this.f.fire())}}t.$dh=G;class S extends G{constructor(B,N){super(N),this.l=B}cancel(){this.l.cancel()}}t.$eh=S;function Q(R){const B=new w.$Xd,N=R(B.token);return new S(B,async A=>{const k=B.token.onCancellationRequested(()=>{k.dispose(),B.dispose(),A.reject(new O.$4)});try{for await(const U of N){if(B.token.isCancellationRequested)return;A.emitOne(U)}k.dispose(),B.dispose()}catch(U){k.dispose(),B.dispose(),A.reject(U)}})}t.$fh=Q;class b{constructor(){this.a=new ce,this.b=new G(A=>{if(B){A.reject(B);return}return N&&A.emitMany(N),this.d=k=>A.reject(k),this.f=k=>A.emitOne(k),this.a.p});let B,N;this.f=A=>{N||(N=[]),N.push(A)},this.d=A=>{B||(B=A)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(B){this.d(B),this.a.complete()}emitOne(B){this.f(B)}}t.$gh=b}),define($e[3],pe([1,0,16,111,14,19,9,6,4,115,2,29,5,15,48]),function(le,t,w,O,i,q,p,D,c,f,m,L,n,o,e){"use strict";var a;Object.defineProperty(t,"__esModule",{value:!0}),t.$eQ=t.$dQ=t.h=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.$9P=t.$8P=t.$7P=t.DetectedFullscreenMode=t.$6P=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$=t.Namespace=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=t.$XO=t.$WO=t.$VO=t.$UO=t.$TO=t.$SO=t.$RO=t.$QO=t.$PO=t.$OO=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.getWindowsCount=t.getWindows=t.registerWindow=void 0,a=function(){const K=new Map;K.set(window,{window,disposables:new m.$Qc});const X=new c.$Nd,ae=new c.$Nd,me=new c.$Nd;return{onDidRegisterWindow:X.event,onWillUnregisterWindow:me.event,onDidUnregisterWindow:ae.event,registerWindow(ye){if(K.has(ye))return m.$Rc.None;const Ie=new m.$Qc,He={window:ye,disposables:Ie.add(new m.$Qc)};return K.set(ye,He),Ie.add((0,m.$Pc)(()=>{K.delete(ye),ae.fire(ye)})),Ie.add(s(ye,t.$EP.BEFORE_UNLOAD,()=>{me.fire(ye)})),X.fire(He),Ie},getWindows(){return K.values()},getWindowsCount(){return K.size}}}(),t.registerWindow=a.registerWindow,t.getWindows=a.getWindows,t.getWindowsCount=a.getWindowsCount,t.onDidRegisterWindow=a.onDidRegisterWindow,t.onWillUnregisterWindow=a.onWillUnregisterWindow,t.onDidUnregisterWindow=a.onDidUnregisterWindow;function h(K){for(;K.firstChild;)K.firstChild.remove()}t.$OO=h;class ${constructor(X,ae,me,ye){this.f=X,this.g=ae,this.d=me,this.j=ye||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function s(K,X,ae,me){return new $(K,X,ae,me)}t.$PO=s;function u(K){return function(X){return K(new q.$HO(X))}}function d(K){return function(X){return K(new i.$MO(X))}}const l=function(X,ae,me,ye){let Ie=me;return ae==="click"||ae==="mousedown"?Ie=u(me):(ae==="keydown"||ae==="keypress"||ae==="keyup")&&(Ie=d(me)),s(X,ae,Ie,ye)};t.$QO=l;const r=function(X,ae,me){const ye=u(ae);return I(X,ye,me)};t.$RO=r;const y=function(X,ae,me){const ye=u(ae);return g(X,ye,me)};t.$SO=y;function I(K,X,ae){return s(K,n.$r&&O.$EO.pointerEvents?t.$EP.POINTER_DOWN:t.$EP.MOUSE_DOWN,X,ae)}t.$TO=I;function T(K,X,ae){return s(K,n.$r&&O.$EO.pointerEvents?t.$EP.POINTER_MOVE:t.$EP.MOUSE_MOVE,X,ae)}t.$UO=T;function g(K,X,ae){return s(K,n.$r&&O.$EO.pointerEvents?t.$EP.POINTER_UP:t.$EP.MOUSE_UP,X,ae)}t.$VO=g;class v{constructor(X,ae=0){this.d=X,this.priority=ae,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(X){(0,D.$Z)(X)}}static sort(X,ae){return ae.priority-X.priority}}(function(){let K=[],X=null,ae=!1,me=!1;const ye=()=>{for(ae=!1,X=K,K=[],me=!0;X.length>0;)X.sort(v.sort),X.shift().execute();me=!1};t.$XO=(Ie,He,Xe=0)=>{const Je=new v(Ie,Xe);return K.push(Je),ae||(ae=!0,He.requestAnimationFrame(ye)),Je},t.$WO=(Ie,He,Xe)=>{if(me){const Je=new v(Ie,Xe);return X.push(Je),Je}else return(0,t.$XO)(Ie,He,Xe)}})();function z(K,X){return(0,t.$XO)(K,X,1e4)}t.$YO=z;function H(K,X){return(0,t.$XO)(K,X,-1e4)}t.$ZO=H;const _=8,M=function(K,X){return X};class F extends m.$Rc{constructor(X,ae,me,ye=M,Ie=_){super();let He=null,Xe=0;const Je=this.B(new p.$4g),Ge=()=>{Xe=new Date().getTime(),me(He),He=null};this.B(s(X,ae,Et=>{He=ye(He,Et);const Pt=new Date().getTime()-Xe;Pt>=Ie?(Je.cancel(),Ge()):Je.setIfNotSet(Ge,Ie-Pt)}))}}function Z(K,X,ae,me,ye){return new F(K,X,ae,me,ye)}t.$1O=Z;function ee(K){return K.ownerDocument.defaultView.getComputedStyle(K,null)}t.$2O=ee;function ue(K){const X=K.ownerDocument,ae=X.defaultView?.window;if(K!==X.body)return new se(K.clientWidth,K.clientHeight);if(n.$r&&ae?.visualViewport)return new se(ae.visualViewport.width,ae.visualViewport.height);if(ae?.innerWidth&&ae.innerHeight)return new se(ae.innerWidth,ae.innerHeight);if(X.body&&X.body.clientWidth&&X.body.clientHeight)return new se(X.body.clientWidth,X.body.clientHeight);if(X.documentElement&&X.documentElement.clientWidth&&X.documentElement.clientHeight)return new se(X.documentElement.clientWidth,X.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$3O=ue;class oe{static d(X,ae){return parseFloat(ae)||0}static f(X,ae,me){const ye=ee(X),Ie=ye?ye.getPropertyValue(ae):"0";return oe.d(X,Ie)}static getBorderLeftWidth(X){return oe.f(X,"border-left-width","borderLeftWidth")}static getBorderRightWidth(X){return oe.f(X,"border-right-width","borderRightWidth")}static getBorderTopWidth(X){return oe.f(X,"border-top-width","borderTopWidth")}static getBorderBottomWidth(X){return oe.f(X,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(X){return oe.f(X,"padding-left","paddingLeft")}static getPaddingRight(X){return oe.f(X,"padding-right","paddingRight")}static getPaddingTop(X){return oe.f(X,"padding-top","paddingTop")}static getPaddingBottom(X){return oe.f(X,"padding-bottom","paddingBottom")}static getMarginLeft(X){return oe.f(X,"margin-left","marginLeft")}static getMarginTop(X){return oe.f(X,"margin-top","marginTop")}static getMarginRight(X){return oe.f(X,"margin-right","marginRight")}static getMarginBottom(X){return oe.f(X,"margin-bottom","marginBottom")}}class se{static{this.None=new se(0,0)}constructor(X,ae){this.width=X,this.height=ae}with(X=this.width,ae=this.height){return X!==this.width||ae!==this.height?new se(X,ae):this}static is(X){return typeof X=="object"&&typeof X.height=="number"&&typeof X.width=="number"}static lift(X){return X instanceof se?X:new se(X.width,X.height)}static equals(X,ae){return X===ae?!0:!X||!ae?!1:X.width===ae.width&&X.height===ae.height}}t.$4O=se;function re(K){let X=K.offsetParent,ae=K.offsetTop,me=K.offsetLeft;for(;(K=K.parentNode)!==null&&K!==K.ownerDocument.body&&K!==K.ownerDocument.documentElement;){ae-=K.scrollTop;const ye=U(K)?null:ee(K);ye&&(me-=ye.direction!=="rtl"?K.scrollLeft:-K.scrollLeft),K===X&&(me+=oe.getBorderLeftWidth(K),ae+=oe.getBorderTopWidth(K),ae+=K.offsetTop,me+=K.offsetLeft,X=K.offsetParent)}return{left:me,top:ae}}t.$5O=re;function be(K,X,ae){typeof X=="number"&&(K.style.width=`${X}px`),typeof ae=="number"&&(K.style.height=`${ae}px`)}t.$6O=be;function Se(K,X,ae,me,ye,Ie="absolute"){typeof X=="number"&&(K.style.top=`${X}px`),typeof ae=="number"&&(K.style.right=`${ae}px`),typeof me=="number"&&(K.style.bottom=`${me}px`),typeof ye=="number"&&(K.style.left=`${ye}px`),K.style.position=Ie}t.$7O=Se;function Le(K){const X=K.getBoundingClientRect();return{left:X.left+(K.ownerDocument.defaultView?.scrollX??0),top:X.top+(K.ownerDocument.defaultView?.scrollY??0),width:X.width,height:X.height}}t.$8O=Le;function Fe(K){let X=K,ae=1;do{const me=ee(X).zoom;me!=null&&me!=="1"&&(ae*=me),X=X.parentElement}while(X!==null&&X!==X.ownerDocument.documentElement);return ae}t.$9O=Fe;function de(K){const X=oe.getMarginLeft(K)+oe.getMarginRight(K);return K.offsetWidth+X}t.$0O=de;function ie(K){const X=oe.getBorderLeftWidth(K)+oe.getBorderRightWidth(K),ae=oe.getPaddingLeft(K)+oe.getPaddingRight(K);return K.offsetWidth-X-ae}t.$$O=ie;function ce(K){const X=oe.getMarginLeft(K)+oe.getMarginRight(K);return K.scrollWidth+X}t.$_O=ce;function Y(K){const X=oe.getBorderTopWidth(K)+oe.getBorderBottomWidth(K),ae=oe.getPaddingTop(K)+oe.getPaddingBottom(K);return K.offsetHeight-X-ae}t.$aP=Y;function V(K){const X=oe.getMarginTop(K)+oe.getMarginBottom(K);return K.offsetHeight+X}t.$bP=V;function G(K,X){if(K===null)return 0;const ae=re(K),me=re(X);return ae.left-me.left}function S(K,X){const ae=X.map(ye=>Math.max(ce(ye),de(ye))+G(ye,K)||0);return Math.max(...ae)}t.$cP=S;function Q(K,X){return!!X?.contains(K)}t.$dP=Q;const b="parentFlowToElementId";function R(K,X){K.dataset[b]=X.id}t.$eP=R;function B(K){const X=K.dataset[b];return typeof X=="string"?K.ownerDocument.getElementById(X):null}function N(K,X){let ae=K;for(;ae;){if(ae===X)return!0;if(ae instanceof HTMLElement){const me=B(ae);if(me){ae=me;continue}}ae=ae.parentNode}return!1}t.$fP=N;function A(K,X,ae){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K.classList.contains(X))return K;if(ae){if(typeof ae=="string"){if(K.classList.contains(ae))return null}else if(K===ae)return null}K=K.parentNode}return null}t.$gP=A;function k(K,X,ae){return!!A(K,X,ae)}t.$hP=k;function U(K){return K&&!!K.host&&!!K.mode}t.$iP=U;function C(K){return!!j(K)}t.$jP=C;function j(K){for(;K.parentNode;){if(K===K.ownerDocument?.body)return null;K=K.parentNode}return U(K)?K:null}t.$kP=j;function E(){let K=te().activeElement;for(;K?.shadowRoot;)K=K.shadowRoot.activeElement;return K}t.$lP=E;function P(K){return K.ownerDocument.activeElement===K}t.$mP=P;function W(K){return Q(K.ownerDocument.activeElement,K)}t.$nP=W;function x(K){return K.ownerDocument===te()}t.$oP=x;function te(){return(0,t.getWindowsCount)()<=1?document:Array.from((0,t.getWindows)()).map(({window:X})=>X.document).find(X=>X.hasFocus())??document}t.$pP=te;function ne(){return te().defaultView?.window??window}t.$qP=ne;function ge(K){const X=K;if(X?.ownerDocument?.defaultView)return X.ownerDocument.defaultView.window;const ae=K;return ae?.view?ae.view.window:window}t.$rP=ge;function ve(K){const X=ge(K);X!==ne()&&X.focus()}t.$sP=ve;function Ce(K=document.head,X,ae){const me=document.createElement("style");if(me.type="text/css",me.media="screen",X?.(me),K.appendChild(me),ae&&ae.add((0,m.$Pc)(()=>K.removeChild(me))),K===document.head)for(const{window:ye,disposables:Ie}of(0,t.getWindows)()){if(ye===window)continue;const He=Ie.add(Oe(me,ye));ae?.add(He)}return me}t.$tP=Ce;const Ae=new Map;function De(K){return Ae.has(K)}t.$uP=De;function Me(K){const X=new m.$Qc;for(const[ae]of Ae)X.add(Oe(ae,K));return X}t.$vP=Me;function Oe(K,X){const ae=new m.$Qc,me=K.cloneNode(!0);X.document.head.appendChild(me),ae.add((0,m.$Pc)(()=>X.document.head.removeChild(me)));for(const Ie of Ve(K))me.sheet?.insertRule(Ie.cssText,me.sheet?.cssRules.length);ae.add(t.$wP.observe(K,ae,{childList:!0})(()=>{me.textContent=K.textContent}));let ye=Ae.get(K);return ye||(ye=new Set,Ae.set(K,ye)),ye.add(me),ae.add((0,m.$Pc)(()=>ye?.delete(me))),ae}t.$wP=new class{constructor(){this.mutationObservers=new Map}observe(K,X,ae){let me=this.mutationObservers.get(K);me||(me=new Map,this.mutationObservers.set(K,me));const ye=(0,e.$Di)(ae);let Ie=me.get(ye);if(Ie)Ie.users+=1;else{const He=new c.$Nd,Xe=new MutationObserver(Ge=>He.fire(Ge));Xe.observe(K,ae);const Je=Ie={users:1,observer:Xe,onDidMutate:He.event};X.add((0,m.$Pc)(()=>{Je.users-=1,Je.users===0&&(He.dispose(),Xe.disconnect(),me?.delete(ye),me?.size===0&&this.mutationObservers.delete(K))})),me.set(ye,Ie)}return Ie.onDidMutate}};function _e(K=document.head){const X=document.createElement("meta");return K.appendChild(X),X}t.$xP=_e;let je=null;function Re(){return je||(je=Ce()),je}function Ve(K){return K?.sheet?.rules?K.sheet.rules:K?.sheet?.cssRules?K.sheet.cssRules:[]}function J(K,X,ae=Re()){if(!(!ae||!X)){ae.sheet?.insertRule(`${K} {${X}}`,0);for(const me of Ae.get(ae)??[])J(K,X,me)}}t.$yP=J;function he(K,X=Re()){if(!X)return;const ae=Ve(X),me=[];for(let ye=0;ye<ae.length;ye++){const Ie=ae[ye];we(Ie)&&Ie.selectorText.indexOf(K)!==-1&&me.push(ye)}for(let ye=me.length-1;ye>=0;ye--)X.sheet?.deleteRule(me[ye]);for(const ye of Ae.get(X)??[])he(K,ye)}t.$zP=he;function we(K){return typeof K.selectorText=="string"}function Ee(K){return K instanceof MouseEvent||K instanceof ge(K).MouseEvent}t.$AP=Ee;function Pe(K){return K instanceof KeyboardEvent||K instanceof ge(K).KeyboardEvent}t.$BP=Pe;function Be(K){return K instanceof PointerEvent||K instanceof ge(K).PointerEvent}t.$CP=Be;function Ue(K){return K instanceof DragEvent||K instanceof ge(K).DragEvent}t.$DP=Ue,t.$EP={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:w.$wO?"webkitAnimationStart":"animationstart",ANIMATION_END:w.$wO?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:w.$wO?"webkitAnimationIteration":"animationiteration"};function Ye(K){const X=K;return!!(X&&typeof X.preventDefault=="function"&&typeof X.stopPropagation=="function")}t.$FP=Ye,t.$GP={stop:(K,X)=>(K.preventDefault(),X&&K.stopPropagation(),K)};function Ze(K){const X=[];for(let ae=0;K&&K.nodeType===K.ELEMENT_NODE;ae++)X[ae]=K.scrollTop,K=K.parentNode;return X}t.$HP=Ze;function Qe(K,X){for(let ae=0;K&&K.nodeType===K.ELEMENT_NODE;ae++)K.scrollTop!==X[ae]&&(K.scrollTop=X[ae]),K=K.parentNode}t.$IP=Qe;class We extends m.$Rc{static m(X){if(X instanceof HTMLElement){const ae=j(X),me=ae?ae.activeElement:X.ownerDocument.activeElement;return Q(me,X)}else{const ae=X;return Q(ae.document.activeElement,ae.document)}}constructor(X){super(),this.f=this.B(new c.$Nd),this.onDidFocus=this.f.event,this.g=this.B(new c.$Nd),this.onDidBlur=this.g.event;let ae=We.m(X),me=!1;const ye=()=>{me=!1,ae||(ae=!0,this.f.fire())},Ie=()=>{ae&&(me=!0,window.setTimeout(()=>{me&&(me=!1,ae=!1,this.g.fire())},0))};this.j=()=>{We.m(X)!==ae&&(ae?Ie():ye())},this.B(s(X,t.$EP.FOCUS,ye,!0)),this.B(s(X,t.$EP.BLUR,Ie,!0)),X instanceof HTMLElement&&(this.B(s(X,t.$EP.FOCUS_IN,()=>this.j())),this.B(s(X,t.$EP.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function tt(K){return new We(K)}t.$JP=tt;function nt(K,X){return K.after(X),X}t.$KP=nt;function ft(K,...X){if(K.append(...X),X.length===1&&typeof X[0]!="string")return X[0]}t.$LP=ft;function ct(K,X){return K.insertBefore(X,K.firstChild),X}t.$MP=ct;function ut(K,...X){K.innerText="",ft(K,...X)}t.$NP=ut;const Ct=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var dt;(function(K){K.HTML="http://www.w3.org/1999/xhtml",K.SVG="http://www.w3.org/2000/svg"})(dt||(t.Namespace=dt={}));function wt(K,X,ae,...me){const ye=Ct.exec(X);if(!ye)throw new Error("Bad use of emmet");const Ie=ye[1]||"div";let He;return K!==dt.HTML?He=document.createElementNS(K,Ie):He=document.createElement(Ie),ye[3]&&(He.id=ye[3]),ye[4]&&(He.className=ye[4].replace(/\./g," ").trim()),ae&&Object.entries(ae).forEach(([Xe,Je])=>{typeof Je>"u"||(/^on\w+$/.test(Xe)?He[Xe]=Je:Xe==="selected"?Je&&He.setAttribute(Xe,"true"):He.setAttribute(Xe,Je))}),He.append(...me),He}function vt(K,X,...ae){return wt(dt.HTML,K,X,...ae)}t.$=vt,vt.SVG=function(K,X,...ae){return wt(dt.SVG,K,X,...ae)};function It(K,X){const ae=[];return K.forEach((me,ye)=>{ye>0&&(X instanceof Node?ae.push(X.cloneNode()):ae.push(document.createTextNode(X))),ae.push(me)}),ae}t.$PP=It;function Te(K,...X){K?fe(...X):ke(...X)}t.$QP=Te;function fe(...K){for(const X of K)X.style.display="",X.removeAttribute("aria-hidden")}t.$RP=fe;function ke(...K){for(const X of K)X.style.display="none",X.setAttribute("aria-hidden","true")}t.$SP=ke;function Ne(K,X){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K instanceof HTMLElement&&K.hasAttribute(X))return K;K=K.parentNode}return null}function qe(K){!K||!K.hasAttribute("tabIndex")||(K.ownerDocument.activeElement===K&&Ne(K.parentElement,"tabIndex")?.focus(),K.removeAttribute("tabindex"))}t.$TP=qe;function et(K){return X=>{X.preventDefault(),X.stopPropagation(),K(X)}}t.$UP=et;function st(K){return new Promise(X=>{if(K.document.readyState==="complete"||K.document&&K.document.body!==null)X(void 0);else{const me=()=>{K.window.removeEventListener("DOMContentLoaded",me,!1),X()};K.window.addEventListener("DOMContentLoaded",me,!1)}})}t.$VP=st;function Ke(K,X){const ae=K.devicePixelRatio*X;return Math.max(1,Math.floor(ae))/K.devicePixelRatio}t.$WP=Ke;function lt(K){window.open(K,"_blank","noopener")}t.$XP=lt;const mt=780,Dt=640;function Gt(K){const X=Math.floor(window.screenLeft+window.innerWidth/2-mt/2),ae=Math.floor(window.screenTop+window.innerHeight/2-Dt/2);window.open(K,"_blank",`width=${mt},height=${Dt},top=${ae},left=${X}`)}t.$YP=Gt;function yi(K,X=!0){const ae=window.open();return ae?(X&&(ae.opener=null),ae.location.href=K,!0):!1}t.$ZP=yi;function Ei(K,X){const ae=()=>{K(),me=(0,t.$XO)(ae,X)};let me=(0,t.$XO)(ae,X);return(0,m.$Pc)(()=>me.dispose())}t.$1P=Ei,L.$9f.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Ai(K){return K?`url('${L.$cg.uriToBrowserUri(K).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$2P=Ai;function ki(K){return`'${K.replace(/'/g,"%27")}'`}t.$3P=ki;function Xt(K,X){if(K!==void 0){const ae=K.match(/^\s*var\((.+)\)$/);if(ae){const me=ae[1].split(",",2);return me.length===2&&(X=Xt(me[1].trim(),X)),`var(${me[0]}, ${X})`}return K}return X}t.$4P=Xt;function Si(K,X){let ae;if(o.URI.isUri(K))ae=K.toString(!0);else{const ye=new Blob([K]);ae=URL.createObjectURL(ye),setTimeout(()=>URL.revokeObjectURL(ae))}const me=document.createElement("a");document.body.appendChild(me),me.download=X,me.href=ae,me.click(),setTimeout(()=>document.body.removeChild(me))}t.$5P=Si;function Ci(){return new Promise(K=>{const X=document.createElement("input");document.body.appendChild(X),X.type="file",X.multiple=!0,c.Event.once(c.Event.fromDOMEventEmitter(X,"input"))(()=>{K(X.files??void 0)}),X.click(),setTimeout(()=>document.body.removeChild(X))})}t.$6P=Ci;var yt;(function(K){K[K.DOCUMENT=1]="DOCUMENT",K[K.BROWSER=2]="BROWSER"})(yt||(t.DetectedFullscreenMode=yt={}));function Pi(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:yt.BROWSER,guess:!1}:(n.$k||n.$l)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:yt.BROWSER,guess:!0}:null}t.$7P=Pi;function Yt(K,X=!1){const ae=document.createElement("a");return f.addHook("afterSanitizeAttributes",me=>{for(const ye of["href","src"])if(me.hasAttribute(ye)){const Ie=me.getAttribute(ye);if(ye==="href"&&Ie.startsWith("#"))continue;if(ae.href=Ie,!K.includes(ae.protocol.replace(/:$/,""))){if(X&&ye==="src"&&ae.href.startsWith("data:"))continue;me.removeAttribute(ye)}}}),(0,m.$Pc)(()=>{f.removeHook("afterSanitizeAttributes")})}t.$8P=Yt;const Ni=[L.Schemas.http,L.Schemas.https,L.Schemas.command];t.$9P=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Fi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Oi(K,X){const ae=Yt(Ni);try{const me=f.sanitize(X,Fi);K.innerHTML=me}finally{ae.dispose()}}t.$0P=Oi;function Li(K){const X=new Uint16Array(K.length);for(let ye=0;ye<X.length;ye++)X[ye]=K.charCodeAt(ye);let ae="";const me=new Uint8Array(X.buffer);for(let ye=0;ye<me.length;ye++)ae+=String.fromCharCode(me[ye]);return ae}function Ti(K){return btoa(Li(K))}t.$$P=Ti;class bt extends c.$Nd{constructor(){super(),this.o=new m.$Qc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(c.Event.runAndSubscribe(t.onDidRegisterWindow,({window:X,disposables:ae})=>this.B(X,ae),{window,disposables:this.o}))}B(X,ae){ae.add(s(X,"keydown",me=>{if(me.defaultPrevented)return;const ye=new i.$MO(me);if(!(ye.keyCode===6&&me.repeat)){if(me.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(me.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(me.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(me.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(ye.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=me.altKey,this.s.ctrlKey=me.ctrlKey,this.s.metaKey=me.metaKey,this.s.shiftKey=me.shiftKey,this.s.lastKeyPressed&&(this.s.event=me,this.fire(this.s))}},!0)),ae.add(s(X,"keyup",me=>{me.defaultPrevented||(!me.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!me.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!me.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!me.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=me.altKey,this.s.ctrlKey=me.ctrlKey,this.s.metaKey=me.metaKey,this.s.shiftKey=me.shiftKey,this.s.lastKeyReleased&&(this.s.event=me,this.fire(this.s)))},!0)),ae.add(s(X.document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),ae.add(s(X.document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),ae.add(s(X.document.body,"mousemove",me=>{me.buttons&&(this.s.lastKeyPressed=void 0)},!0)),ae.add(s(X,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return bt.A||(bt.A=new bt),bt.A}dispose(){super.dispose(),this.o.dispose()}}t.$_P=bt;function Mi(K){const X=document.cookie.match("(^|[^;]+)\\s*"+K+"\\s*=\\s*([^;]+)");return X?X.pop():void 0}t.$aQ=Mi;class Ri extends m.$Rc{constructor(X,ae){super(),this.j=X,this.m=ae,this.f=0,this.g=0,this.n()}n(){this.B(s(this.j,t.$EP.DRAG_ENTER,X=>{this.f++,this.g=X.timeStamp,this.m.onDragEnter(X)})),this.B(s(this.j,t.$EP.DRAG_OVER,X=>{X.preventDefault(),this.m.onDragOver?.(X,X.timeStamp-this.g)})),this.B(s(this.j,t.$EP.DRAG_LEAVE,X=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave(X))})),this.B(s(this.j,t.$EP.DRAG_END,X=>{this.f=0,this.g=0,this.m.onDragEnd(X)})),this.B(s(this.j,t.$EP.DROP,X=>{this.f=0,this.g=0,this.m.onDrop(X)}))}}t.$bQ=Ri;const Ii=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Bi(K,...X){let ae,me;Array.isArray(X[0])?(ae={},me=X[0]):(ae=X[0]||{},me=X[1]);const ye=Ii.exec(K);if(!ye||!ye.groups)throw new Error("Bad use of h");const Ie=ye.groups.tag||"div",He=document.createElement(Ie);ye.groups.id&&(He.id=ye.groups.id);const Xe=[];if(ye.groups.class)for(const Ge of ye.groups.class.split("."))Ge!==""&&Xe.push(Ge);if(ae.className!==void 0)for(const Ge of ae.className.split("."))Ge!==""&&Xe.push(Ge);Xe.length>0&&(He.className=Xe.join(" "));const Je={};if(ye.groups.name&&(Je[ye.groups.name]=He),me)for(const Ge of me)Ge instanceof HTMLElement?He.appendChild(Ge):typeof Ge=="string"?He.append(Ge):"root"in Ge&&(Object.assign(Je,Ge),He.appendChild(Ge.root));for(const[Ge,Et]of Object.entries(ae))if(Ge!=="className")if(Ge==="style")for(const[Pt,Bt]of Object.entries(Et))He.style.setProperty(Zt(Pt),typeof Bt=="number"?Bt+"px":""+Bt);else Ge==="tabIndex"?He.tabIndex=Et:He.setAttribute(Zt(Ge),Et.toString());return Je.root=He,Je}t.h=Bi;function Zt(K){return K.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function Jt(K,X){for(const{name:ae,value:me}of K.attributes)X.setAttribute(ae,me)}t.$dQ=Jt;function ji(K,X,ae){const me=K.getAttribute(ae);me?X.setAttribute(ae,me):X.removeAttribute(ae)}function zi(K,X,ae){Jt(K,X);const me=new m.$Qc;return me.add(t.$wP.observe(K,me,{attributes:!0,attributeFilter:ae})(ye=>{for(const Ie of ye)Ie.type==="attributes"&&Ie.attributeName&&ji(K,X,Ie.attributeName)})),me}t.$eQ=zi}),define($e[53],pe([1,0,3,2,114]),function(le,t,w,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hQ=t.$gQ=t.$fQ=void 0;class q extends O.$Rc{constructor(c,f){super(),this.B((0,w.$PO)(c,"dragover",m=>{m.preventDefault(),this.a||(this.a=setTimeout(()=>{f(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(m=>{this.B((0,w.$PO)(c,m,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$fQ=q,t.$gQ={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$Sr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function p(D,c,f,m,L){const n=document.createElement("div");if(n.className=f,n.textContent=c,L&&(n.style.color=L),m&&(n.style.background=m),D.dataTransfer){const o=(0,w.$rP)(D).document;o.body.appendChild(n),D.dataTransfer.setDragImage(n,-10,-10),setTimeout(()=>o.body.removeChild(n),0)}}t.$hQ=p}),define($e[54],pe([1,0,3]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LQ=t.$KQ=t.$JQ=void 0;function O(n,o={}){const e=q(o);return e.textContent=n,e}t.$JQ=O;function i(n,o={}){const e=q(o);return c(e,f(n,!!o.renderCodeSegments),o.actionHandler,o.renderCodeSegments),e}t.$KQ=i;function q(n){const o=n.inline?"span":"div",e=document.createElement(o);return n.className&&(e.className=n.className),e}t.$LQ=q;class p{constructor(o){this.b=o,this.c=0}eos(){return this.c>=this.b.length}next(){const o=this.peek();return this.advance(),o}peek(){return this.b[this.c]}advance(){this.c++}}var D;(function(n){n[n.Invalid=0]="Invalid",n[n.Root=1]="Root",n[n.Text=2]="Text",n[n.Bold=3]="Bold",n[n.Italics=4]="Italics",n[n.Action=5]="Action",n[n.ActionClose=6]="ActionClose",n[n.Code=7]="Code",n[n.NewLine=8]="NewLine"})(D||(D={}));function c(n,o,e,a){let h;if(o.type===2)h=document.createTextNode(o.content||"");else if(o.type===3)h=document.createElement("b");else if(o.type===4)h=document.createElement("i");else if(o.type===7&&a)h=document.createElement("code");else if(o.type===5&&e){const $=document.createElement("a");e.disposables.add(w.$QO($,"click",s=>{e.callback(String(o.index),s)})),h=$}else o.type===8?h=document.createElement("br"):o.type===1&&(h=n);h&&n!==h&&n.appendChild(h),h&&Array.isArray(o.children)&&o.children.forEach($=>{c(h,$,e,a)})}function f(n,o){const e={type:1,children:[]};let a=0,h=e;const $=[],s=new p(n);for(;!s.eos();){let u=s.next();const d=u==="\\"&&L(s.peek(),o)!==0;if(d&&(u=s.next()),!d&&m(u,o)&&u===s.peek()){s.advance(),h.type===2&&(h=$.pop());const l=L(u,o);if(h.type===l||h.type===5&&l===6)h=$.pop();else{const r={type:l,children:[]};l===5&&(r.index=a,a++),h.children.push(r),$.push(h),h=r}}else if(u===`
`)h.type===2&&(h=$.pop()),h.children.push({type:8});else if(h.type!==2){const l={type:2,content:u};h.children.push(l),$.push(h),h=l}else h.content+=u}return h.type===2&&(h=$.pop()),$.length,e}function m(n,o){return L(n,o)!==0}function L(n,o){switch(n){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return o?7:0;default:return 0}}}),define($e[55],pe([1,0,3,2]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lQ=void 0;class i{constructor(){this.a=new O.$Qc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(p,D){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const c=this.c;this.c=null,p&&c&&c(D)}isMonitoring(){return!!this.b}startMonitoring(p,D,c,f,m){this.isMonitoring()&&this.stopMonitoring(!1),this.b=f,this.c=m;let L=p;try{p.setPointerCapture(D),this.a.add((0,O.$Pc)(()=>{try{p.releasePointerCapture(D)}catch{}}))}catch{L=w.$rP(p)}this.a.add(w.$PO(L,w.$EP.POINTER_MOVE,n=>{if(n.buttons!==c){this.stopMonitoring(!0);return}n.preventDefault(),this.b(n)})),this.a.add(w.$PO(L,w.$EP.POINTER_UP,n=>this.stopMonitoring(!0)))}}t.$lQ=i});var xe=this&&this.__decorate||function(le,t,w,O){var i=arguments.length,q=i<3?t:O===null?O=Object.getOwnPropertyDescriptor(t,w):O,p;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")q=Reflect.decorate(le,t,w,O);else for(var D=le.length-1;D>=0;D--)(p=le[D])&&(q=(i<3?p(q):i>3?p(t,w,q):p(t,w))||q);return i>3&&q&&Object.defineProperty(t,w,q),q};define($e[23],pe([1,0,3,11,25,4,2,44]),function(le,t,w,O,i,q,p,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iQ=t.EventType=void 0;var c;(function(m){m.Tap="-monaco-gesturetap",m.Change="-monaco-gesturechange",m.Start="-monaco-gesturestart",m.End="-monaco-gesturesend",m.Contextmenu="-monaco-gesturecontextmenu"})(c||(t.EventType=c={}));class f extends p.$Rc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new D.$1c,this.h=new D.$1c,this.m={},this.j=null,this.n=0,this.B(q.Event.runAndSubscribe(w.onDidRegisterWindow,({window:L,disposables:n})=>{n.add(w.$PO(L.document,"touchstart",o=>this.s(o),{passive:!1})),n.add(w.$PO(L.document,"touchend",o=>this.u(L,o))),n.add(w.$PO(L.document,"touchmove",o=>this.D(o),{passive:!1}))},{window,disposables:this.q}))}static addTarget(L){if(!f.isTouchDevice())return p.$Rc.None;f.b||(f.b=(0,p.$Kc)(new f));const n=f.b.g.push(L);return(0,p.$Pc)(n)}static ignoreTarget(L){if(!f.isTouchDevice())return p.$Rc.None;f.b||(f.b=(0,p.$Kc)(new f));const n=f.b.h.push(L);return(0,p.$Pc)(n)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(L){const n=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let o=0,e=L.targetTouches.length;o<e;o++){const a=L.targetTouches.item(o);this.m[a.identifier]={id:a.identifier,initialTarget:a.target,initialTimeStamp:n,initialPageX:a.pageX,initialPageY:a.pageY,rollingTimestamps:[n],rollingPageX:[a.pageX],rollingPageY:[a.pageY]};const h=this.w(c.Start,a.target);h.pageX=a.pageX,h.pageY=a.pageY,this.z(h)}this.f&&(L.preventDefault(),L.stopPropagation(),this.f=!1)}u(L,n){const o=Date.now(),e=Object.keys(this.m).length;for(let a=0,h=n.changedTouches.length;a<h;a++){const $=n.changedTouches.item(a);if(!this.m.hasOwnProperty(String($.identifier))){console.warn("move of an UNKNOWN touch",$);continue}const s=this.m[$.identifier],u=Date.now()-s.initialTimeStamp;if(u<f.c&&Math.abs(s.initialPageX-O.$rb(s.rollingPageX))<30&&Math.abs(s.initialPageY-O.$rb(s.rollingPageY))<30){const d=this.w(c.Tap,s.initialTarget);d.pageX=O.$rb(s.rollingPageX),d.pageY=O.$rb(s.rollingPageY),this.z(d)}else if(u>=f.c&&Math.abs(s.initialPageX-O.$rb(s.rollingPageX))<30&&Math.abs(s.initialPageY-O.$rb(s.rollingPageY))<30){const d=this.w(c.Contextmenu,s.initialTarget);d.pageX=O.$rb(s.rollingPageX),d.pageY=O.$rb(s.rollingPageY),this.z(d)}else if(e===1){const d=O.$rb(s.rollingPageX),l=O.$rb(s.rollingPageY),r=O.$rb(s.rollingTimestamps)-s.rollingTimestamps[0],y=d-s.rollingPageX[0],I=l-s.rollingPageY[0],T=[...this.g].filter(g=>s.initialTarget instanceof Node&&g.contains(s.initialTarget));this.C(L,T,o,Math.abs(y)/r,y>0?1:-1,d,Math.abs(I)/r,I>0?1:-1,l)}this.z(this.w(c.End,s.initialTarget)),delete this.m[$.identifier]}this.f&&(n.preventDefault(),n.stopPropagation(),this.f=!1)}w(L,n){const o=document.createEvent("CustomEvent");return o.initEvent(L,!1,!0),o.initialTarget=n,o.tapCount=0,o}z(L){if(L.type===c.Tap){const n=new Date().getTime();let o=0;n-this.n>f.r?o=1:o=2,this.n=n,L.tapCount=o}else(L.type===c.Change||L.type===c.Contextmenu)&&(this.n=0);if(L.initialTarget instanceof Node){for(const n of this.h)if(n.contains(L.initialTarget))return;for(const n of this.g)n.contains(L.initialTarget)&&(n.dispatchEvent(L),this.f=!0)}}C(L,n,o,e,a,h,$,s,u){this.j=w.$XO(()=>{const d=Date.now(),l=d-o;let r=0,y=0,I=!0;e+=f.a*l,$+=f.a*l,e>0&&(I=!1,r=a*e*l),$>0&&(I=!1,y=s*$*l);const T=this.w(c.Change);T.translationX=r,T.translationY=y,n.forEach(g=>g.dispatchEvent(T)),I||this.C(L,n,d,e,a,h+r,$,s,u+y)},L)}D(L){const n=Date.now();for(let o=0,e=L.changedTouches.length;o<e;o++){const a=L.changedTouches.item(o);if(!this.m.hasOwnProperty(String(a.identifier))){console.warn("end of an UNKNOWN touch",a);continue}const h=this.m[a.identifier],$=this.w(c.Change,h.initialTarget);$.translationX=a.pageX-O.$rb(h.rollingPageX),$.translationY=a.pageY-O.$rb(h.rollingPageY),$.pageX=a.pageX,$.pageY=a.pageY,this.z($),h.rollingPageX.length>3&&(h.rollingPageX.shift(),h.rollingPageY.shift(),h.rollingTimestamps.shift()),h.rollingPageX.push(a.pageX),h.rollingPageY.push(a.pageY),h.rollingTimestamps.push(n)}this.f&&(L.preventDefault(),L.stopPropagation(),this.f=!1)}}t.$iQ=f,xe([i.$hh],f,"isTouchDevice",null)}),define($e[56],pe([1,0,3,89]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PQ=t.$OQ=t.$NQ=void 0;const O=2e4;let i,q,p,D,c;function f(o){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const h=document.createElement("div");return h.className="monaco-alert",h.setAttribute("role","alert"),h.setAttribute("aria-atomic","true"),i.appendChild(h),h};q=e(),p=e();const a=()=>{const h=document.createElement("div");return h.className="monaco-status",h.setAttribute("aria-live","polite"),h.setAttribute("aria-atomic","true"),i.appendChild(h),h};D=a(),c=a(),o.appendChild(i)}t.$NQ=f;function m(o){i&&(q.textContent!==o?(w.$OO(p),n(q,o)):(w.$OO(q),n(p,o)))}t.$OQ=m;function L(o){i&&(D.textContent!==o?(w.$OO(c),n(D,o)):(w.$OO(D),n(c,o)))}t.$PQ=L;function n(o,e){w.$OO(o),e.length>O&&(e=e.substr(0,O)),o.textContent=e,o.style.visibility="hidden",o.style.visibility="visible"}}),define($e[116],pe([1,0,3,18]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cR=t.$bR=void 0;const i=new RegExp(`(\\\\)?\\$\\((${O.ThemeIcon.iconNameExpression}(?:${O.ThemeIcon.iconModifierExpression})?)\\)`,"g");function q(D){const c=new Array;let f,m=0,L=0;for(;(f=i.exec(D))!==null;){L=f.index||0,m<L&&c.push(D.substring(m,L)),m=(f.index||0)+f[0].length;const[,n,o]=f;c.push(n?`$(${o})`:p({id:o}))}return m<D.length&&c.push(D.substring(m)),c}t.$bR=q;function p(D){const c=w.$("span");return c.classList.add(...O.ThemeIcon.asClassNameArray(D)),c}t.$cR=p}),define($e[117],pe([1,0,3]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YQ=void 0;function O(q){try{q.parentElement?.removeChild(q)}catch{}}class i{constructor(p){this.d=p,this.a=new Map,this.b=new Set,this.c=!1}alloc(p){let D=this.h(p).pop(),c=!1;if(D)c=this.b.has(D.domNode),c&&this.b.delete(D.domNode);else{const f=(0,w.$)(".monaco-list-row"),L=this.i(p).renderTemplate(f);D={domNode:f,templateId:p,templateData:L}}return{row:D,isReusingConnectedDomNode:c}}release(p){p&&this.f(p)}transact(p){if(this.c)throw new Error("Already in transaction");this.c=!0;try{p()}finally{for(const D of this.b)this.g(D);this.b.clear(),this.c=!1}}f(p){const{domNode:D,templateId:c}=p;D&&(this.c?this.b.add(D):this.g(D)),this.h(c).push(p)}g(p){p.classList.remove("scrolling"),O(p)}h(p){let D=this.a.get(p);return D||(D=[],this.a.set(p,D)),D}dispose(){this.a.forEach((p,D)=>{for(const c of p)this.i(D).disposeTemplate(c.templateData),c.templateData=null}),this.a.clear(),this.b.clear()}i(p){const D=this.d.get(p);if(!D)throw new Error(`No renderer found for ${p}`);return D}}t.$YQ=i}),define($e[118],pe([1,0,9,2]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qQ=void 0;class i extends O.$Rc{constructor(p,D,c){super(),this.a=p,this.b=D,this.c=c,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new w.$4g)}setVisibility(p){this.a!==p&&(this.a=p,this.s())}setShouldBeVisible(p){this.g=p,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const p=this.r();this.h!==p&&(this.h=p,this.ensureVisibility())}setIsNeeded(p){this.j!==p&&(this.j=p,this.ensureVisibility())}setDomNode(p){this.f=p,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(p){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(p?" fade":"")))}}t.$qQ=i}),define($e[119],pe([1,0,3,23,11,4,2,5]),function(le,t,w,O,i,q,p,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jR=void 0;class c extends p.$Rc{constructor(m,L,n,o){super(),this.f=0,this.b=o||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new q.$Nd),this.h=n,this.j(),this.setOptions(m,L)}j(){this.B(O.$iQ.addTarget(this.a)),[O.EventType.Tap].forEach(m=>{this.B(w.$PO(this.a,m,L=>{this.a.focus()}))}),this.B(w.$QO(this.a,"click",m=>{w.$GP.stop(m,!0)})),this.B(w.$QO(this.a,"change",m=>{this.a.title=m.target.value,this.g.fire({index:m.target.selectedIndex,selected:m.target.value})})),this.B(w.$QO(this.a,"keydown",m=>{let L=!1;D.$k?(m.keyCode===18||m.keyCode===16||m.keyCode===10)&&(L=!0):(m.keyCode===18&&m.altKey||m.keyCode===10||m.keyCode===3)&&(L=!0),L&&m.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(m,L){(!this.c||!i.$tb(this.c,m))&&(this.c=m,this.a.options.length=0,this.c.forEach((n,o)=>{this.a.add(this.m(n.text,o,n.isDisabled))})),L!==void 0&&this.select(L)}select(m){this.c.length===0?this.f=0:m>=0&&m<this.c.length?this.f=m:m>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(m){this.b.ariaLabel=m,this.a.setAttribute("aria-label",m)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(m){this.a.tabIndex=m?0:-1}render(m){m.classList.add("select-container"),m.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(m){this.h=m,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(m,L,n){const o=document.createElement("option");return o.value=m,o.text=m,o.disabled=!!n,o}}t.$jR=c}),define($e[57],pe([1,0,24,11,9,49,85,4,26]),function(le,t,w,O,i,q,p,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QS=t.$PS=t.$OS=void 0;function f(o){return typeof o=="object"&&"visibility"in o&&"data"in o}t.$OS=f;function m(o){switch(o){case!0:return 1;case!1:return 0;default:return o}}t.$PS=m;function L(o){return typeof o.collapsible=="boolean"}class n{constructor(e,a,h,$={}){this.o=e,this.p=a,this.rootRef=[],this.d=new D.$Vd,this.f=new D.$Nd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new D.$Nd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new D.$Nd,this.onDidSplice=this.l.event,this.m=new i.$Qg(q.$Kd),this.h=typeof $.collapseByDefault>"u"?!1:$.collapseByDefault,this.j=$.filter,this.k=typeof $.autoExpandSingleChildren>"u"?!1:$.autoExpandSingleChildren,this.c={parent:void 0,element:h,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,a,h=c.Iterable.empty(),$={}){if(e.length===0)throw new w.$MS(this.o,"Invalid tree location");$.diffIdentityProvider?this.q($.diffIdentityProvider,e,a,h,$):this.s(e,a,h,$)}q(e,a,h,$=c.Iterable.empty(),s,u=s.diffDepth??0){const{parentNode:d}=this.G(a);if(!d.lastDiffIds)return this.s(a,h,$,s);const l=[...$],r=a[a.length-1],y=new p.$Cs({getElements:()=>d.lastDiffIds},{getElements:()=>[...d.children.slice(0,r),...l,...d.children.slice(r+h)].map(z=>e.getId(z.element).toString())}).ComputeDiff(!1);if(y.quitEarly)return d.lastDiffIds=void 0,this.s(a,h,l,s);const I=a.slice(0,-1),T=(z,H,_)=>{if(u>0)for(let M=0;M<_;M++)z--,H--,this.q(e,[...I,z,0],Number.MAX_SAFE_INTEGER,l[H].children,s,u-1)};let g=Math.min(d.children.length,r+h),v=l.length;for(const z of y.changes.sort((H,_)=>_.originalStart-H.originalStart))T(g,v,g-(z.originalStart+z.originalLength)),g=z.originalStart,v=z.modifiedStart-r,this.s([...I,g],z.originalLength,c.Iterable.slice(l,v,v+z.modifiedLength),s);T(g,v,g)}s(e,a,h=c.Iterable.empty(),{onDidCreateNode:$,onDidDeleteNode:s,diffIdentityProvider:u}){const{parentNode:d,listIndex:l,revealed:r,visible:y}=this.G(e),I=[],T=c.Iterable.map(h,oe=>this.w(oe,d,d.visible?1:0,r,I,$)),g=e[e.length-1],v=d.children.length>0;let z=0;for(let oe=g;oe>=0&&oe<d.children.length;oe--){const se=d.children[oe];if(se.visible){z=se.visibleChildIndex;break}}const H=[];let _=0,M=0;for(const oe of T)H.push(oe),M+=oe.renderNodeCount,oe.visible&&(oe.visibleChildIndex=z+_++);const F=(0,O.$5b)(d.children,g,a,H);u?d.lastDiffIds?(0,O.$5b)(d.lastDiffIds,g,a,H.map(oe=>u.getId(oe.element).toString())):d.lastDiffIds=d.children.map(oe=>u.getId(oe.element).toString()):d.lastDiffIds=void 0;let Z=0;for(const oe of F)oe.visible&&Z++;if(Z!==0)for(let oe=g+H.length;oe<d.children.length;oe++){const se=d.children[oe];se.visible&&(se.visibleChildIndex-=Z)}if(d.visibleChildrenCount+=_-Z,r&&y){const oe=F.reduce((se,re)=>se+(re.visible?re.renderNodeCount:0),0);this.B(d,M-oe),this.p.splice(l,oe,I)}if(F.length>0&&s){const oe=se=>{s(se),se.children.forEach(oe)};F.forEach(oe)}this.l.fire({insertedNodes:H,deletedNodes:F});const ee=d.children.length>0;v!==ee&&this.setCollapsible(e.slice(0,-1),ee);let ue=d;for(;ue;){if(ue.visibility===2){this.m.trigger(()=>this.refilter());break}ue=ue.parent}}rerender(e){if(e.length===0)throw new w.$MS(this.o,"Invalid tree location");const{node:a,listIndex:h,revealed:$}=this.F(e);a.visible&&$&&this.p.splice(h,1,[a])}updateElementHeight(e,a){if(e.length===0)throw new w.$MS(this.o,"Invalid tree location");const{listIndex:h}=this.F(e);this.p.updateElementHeight(h,a)}has(e){return this.D(e)}getListIndex(e){const{listIndex:a,visible:h,revealed:$}=this.F(e);return h&&$?a:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,a){const h=this.E(e);typeof a>"u"&&(a=!h.collapsible);const $={collapsible:a};return this.d.bufferEvents(()=>this.t(e,$))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,a,h){const $=this.E(e);typeof a>"u"&&(a=!$.collapsed);const s={collapsed:a,recursive:h||!1};return this.d.bufferEvents(()=>this.t(e,s))}t(e,a){const{node:h,listIndex:$,revealed:s}=this.F(e),u=this.u(h,$,s,a);if(h!==this.c&&this.k&&u&&!L(a)&&h.collapsible&&!h.collapsed&&!a.recursive){let d=-1;for(let l=0;l<h.children.length;l++)if(h.children[l].visible)if(d>-1){d=-1;break}else d=l;d>-1&&this.t([...e,d],a)}return u}u(e,a,h,$){const s=this.v(e,$,!1);if(!h||!e.visible||!s)return s;const u=e.renderNodeCount,d=this.x(e),l=u-(a===-1?0:1);return this.p.splice(a+1,l,d.slice(1)),s}v(e,a,h){let $;if(e===this.c?$=!1:(L(a)?($=e.collapsible!==a.collapsible,e.collapsible=a.collapsible):e.collapsible?($=e.collapsed!==a.collapsed,e.collapsed=a.collapsed):$=!1,$&&this.f.fire({node:e,deep:h})),!L(a)&&a.recursive)for(const s of e.children)$=this.v(s,a,!0)||$;return $}expandTo(e){this.d.bufferEvents(()=>{let a=this.E(e);for(;a.parent;)a=a.parent,e=e.slice(0,e.length-1),a.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,a=this.z(this.c);this.p.splice(0,e,a),this.m.cancel()}w(e,a,h,$,s,u){const d={parent:a,element:e.element,children:[],depth:a.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},l=this.C(d,h);d.visibility=l,$&&s.push(d);const r=e.children||c.Iterable.empty(),y=$&&l!==0&&!d.collapsed;let I=0,T=1;for(const g of r){const v=this.w(g,d,l,y,s,u);d.children.push(v),T+=v.renderNodeCount,v.visible&&(v.visibleChildIndex=I++)}return d.collapsible=d.collapsible||d.children.length>0,d.visibleChildrenCount=I,d.visible=l===2?I>0:l===1,d.visible?d.collapsed||(d.renderNodeCount=T):(d.renderNodeCount=0,$&&s.pop()),u?.(d),d}x(e){const a=e.renderNodeCount,h=[];return this.y(e,h),this.B(e.parent,h.length-a),h}y(e,a){if(e.visible===!1)return 0;if(a.push(e),e.renderNodeCount=1,!e.collapsed)for(const h of e.children)e.renderNodeCount+=this.y(h,a);return this.g.fire(e),e.renderNodeCount}z(e){const a=e.renderNodeCount,h=[];return this.A(e,e.visible?1:0,h),this.B(e.parent,h.length-a),h}A(e,a,h,$=!0){let s;if(e!==this.c){if(s=this.C(e,a),s===0)return e.visible=!1,e.renderNodeCount=0,!1;$&&h.push(e)}const u=h.length;e.renderNodeCount=e===this.c?0:1;let d=!1;if(!e.collapsed||s!==0){let l=0;for(const r of e.children)d=this.A(r,s,h,$&&!e.collapsed)||d,r.visible&&(r.visibleChildIndex=l++);e.visibleChildrenCount=l}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=s===2?d:s===1,e.visibility=s),e.visible?e.collapsed||(e.renderNodeCount+=h.length-u):(e.renderNodeCount=0,$&&h.pop()),this.g.fire(e),e.visible}B(e,a){if(a!==0)for(;e;)e.renderNodeCount+=a,this.g.fire(e),e=e.parent}C(e,a){const h=this.j?this.j.filter(e.element,a):1;return typeof h=="boolean"?(e.filterData=void 0,h?1:0):f(h)?(e.filterData=h.data,m(h.visibility)):(e.filterData=void 0,m(h))}D(e,a=this.c){if(!e||e.length===0)return!0;const[h,...$]=e;return h<0||h>a.children.length?!1:this.D($,a.children[h])}E(e,a=this.c){if(!e||e.length===0)return a;const[h,...$]=e;if(h<0||h>a.children.length)throw new w.$MS(this.o,"Invalid tree location");return this.E($,a.children[h])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:a,listIndex:h,revealed:$,visible:s}=this.G(e),u=e[e.length-1];if(u<0||u>a.children.length)throw new w.$MS(this.o,"Invalid tree location");const d=a.children[u];return{node:d,listIndex:h,revealed:$,visible:s&&d.visible}}G(e,a=this.c,h=0,$=!0,s=!0){const[u,...d]=e;if(u<0||u>a.children.length)throw new w.$MS(this.o,"Invalid tree location");for(let l=0;l<u;l++)h+=a.children[l].renderNodeCount;return $=$&&!a.collapsed,s=s&&a.visible,d.length===0?{parentNode:a,listIndex:h,revealed:$,visible:s}:this.G(d,a.children[u],h+1,$,s)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const a=[];let h=e;for(;h.parent;)a.push(h.parent.children.indexOf(h)),h=h.parent;return a.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,O.$sb)(e)[0]}getFirstElementChild(e){const a=this.E(e);if(a.children.length!==0)return a.children[0].element}getLastElementAncestor(e=[]){const a=this.E(e);if(a.children.length!==0)return this.H(a)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$QS=n}),define($e[120],pe([1,0,57,24,26]),function(le,t,w,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WS=void 0;class q{get size(){return this.d.size}constructor(D,c,f={}){this.k=D,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new w.$QS(D,c,null,f),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,f.sorter&&(this.j={compare(m,L){return f.sorter.compare(m.element,L.element)}}),this.h=f.identityProvider}setChildren(D,c=i.Iterable.empty(),f={}){const m=this.o(D);this.l(m,this.m(c),f)}l(D,c=i.Iterable.empty(),f){const m=new Set,L=new Set,n=e=>{if(e.element===null)return;const a=e;if(m.add(a.element),this.d.set(a.element,a),this.h){const h=this.h.getId(a.element).toString();L.add(h),this.f.set(h,a)}f.onDidCreateNode?.(a)},o=e=>{if(e.element===null)return;const a=e;if(m.has(a.element)||this.d.delete(a.element),this.h){const h=this.h.getId(a.element).toString();L.has(h)||this.f.delete(h)}f.onDidDeleteNode?.(a)};this.c.splice([...D,0],Number.MAX_VALUE,c,{...f,onDidCreateNode:n,onDidDeleteNode:o})}m(D=i.Iterable.empty()){return this.j&&(D=[...D].sort(this.j.compare.bind(this.j))),i.Iterable.map(D,c=>{let f=this.d.get(c.element);if(!f&&this.h){const n=this.h.getId(c.element).toString();f=this.f.get(n)}if(!f){let n;return typeof c.collapsed>"u"?n=void 0:c.collapsed===O.ObjectTreeElementCollapseState.Collapsed||c.collapsed===O.ObjectTreeElementCollapseState.PreserveOrCollapsed?n=!0:c.collapsed===O.ObjectTreeElementCollapseState.Expanded||c.collapsed===O.ObjectTreeElementCollapseState.PreserveOrExpanded?n=!1:n=!!c.collapsed,{...c,children:this.m(c.children),collapsed:n}}const m=typeof c.collapsible=="boolean"?c.collapsible:f.collapsible;let L;return typeof c.collapsed>"u"||c.collapsed===O.ObjectTreeElementCollapseState.PreserveOrCollapsed||c.collapsed===O.ObjectTreeElementCollapseState.PreserveOrExpanded?L=f.collapsed:c.collapsed===O.ObjectTreeElementCollapseState.Collapsed?L=!0:c.collapsed===O.ObjectTreeElementCollapseState.Expanded?L=!1:L=!!c.collapsed,{...c,collapsible:m,collapsed:L,children:this.m(c.children)}})}rerender(D){const c=this.o(D);this.c.rerender(c)}updateElementHeight(D,c){const f=this.o(D);this.c.updateElementHeight(f,c)}resort(D=null,c=!0){if(!this.j)return;const f=this.o(D),m=this.c.getNode(f);this.l(f,this.n(m,c),{})}n(D,c,f=!0){let m=[...D.children];return(c||f)&&(m=m.sort(this.j.compare.bind(this.j))),i.Iterable.map(m,L=>({element:L.element,collapsible:L.collapsible,collapsed:L.collapsed,children:this.n(L,c,!1)}))}getFirstElementChild(D=null){const c=this.o(D);return this.c.getFirstElementChild(c)}getLastElementAncestor(D=null){const c=this.o(D);return this.c.getLastElementAncestor(c)}has(D){return this.d.has(D)}getListIndex(D){const c=this.o(D);return this.c.getListIndex(c)}getListRenderCount(D){const c=this.o(D);return this.c.getListRenderCount(c)}isCollapsible(D){const c=this.o(D);return this.c.isCollapsible(c)}setCollapsible(D,c){const f=this.o(D);return this.c.setCollapsible(f,c)}isCollapsed(D){const c=this.o(D);return this.c.isCollapsed(c)}setCollapsed(D,c,f){const m=this.o(D);return this.c.setCollapsed(m,c,f)}expandTo(D){const c=this.o(D);this.c.expandTo(c)}refilter(){this.c.refilter()}getNode(D=null){if(D===null)return this.c.getNode(this.c.rootRef);const c=this.d.get(D);if(!c)throw new O.$MS(this.k,`Tree element not found: ${D}`);return c}getNodeLocation(D){return D.element}getParentNodeLocation(D){if(D===null)throw new O.$MS(this.k,"Invalid getParentNodeLocation call");const c=this.d.get(D);if(!c)throw new O.$MS(this.k,`Tree element not found: ${D}`);const f=this.c.getNodeLocation(c),m=this.c.getParentNodeLocation(f);return this.c.getNode(m).element}o(D){if(D===null)return[];const c=this.d.get(D);if(!c)throw new O.$MS(this.k,`Tree element not found: ${D}`);return this.c.getNodeLocation(c)}}t.$WS=q}),define($e[20],pe([1,0,3,14,19,23,2]),function(le,t,w,O,i,q,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mQ=void 0;class D extends p.$Rc{f(f,m){this.B(w.$PO(f,w.$EP.CLICK,L=>m(new i.$HO(L))))}j(f,m){this.B(w.$PO(f,w.$EP.MOUSE_DOWN,L=>m(new i.$HO(L))))}m(f,m){this.B(w.$PO(f,w.$EP.MOUSE_OVER,L=>m(new i.$HO(L))))}u(f,m){this.B(w.$PO(f,w.$EP.MOUSE_LEAVE,L=>m(new i.$HO(L))))}z(f,m){this.B(w.$PO(f,w.$EP.KEY_DOWN,L=>m(new O.$MO(L))))}C(f,m){this.B(w.$PO(f,w.$EP.KEY_UP,L=>m(new O.$MO(L))))}D(f,m){this.B(w.$PO(f,w.$EP.INPUT,m))}F(f,m){this.B(w.$PO(f,w.$EP.BLUR,m))}G(f,m){this.B(w.$PO(f,w.$EP.FOCUS,m))}H(f,m){this.B(w.$PO(f,w.$EP.CHANGE,m))}I(f){return q.$iQ.ignoreTarget(f)}}t.$mQ=D}),define($e[37],pe([1,0,55,20,9,18,3]),function(le,t,w,O,i,q,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oQ=t.$nQ=void 0,t.$nQ=11;class D extends O.$mQ{constructor(f){super(),this.a=f.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=f.bgWidth+"px",this.bgDomNode.style.height=f.bgHeight+"px",typeof f.top<"u"&&(this.bgDomNode.style.top="0px"),typeof f.left<"u"&&(this.bgDomNode.style.left="0px"),typeof f.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof f.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=f.className,this.domNode.classList.add(...q.ThemeIcon.asClassNameArray(f.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$nQ+"px",this.domNode.style.height=t.$nQ+"px",typeof f.top<"u"&&(this.domNode.style.top=f.top+"px"),typeof f.left<"u"&&(this.domNode.style.left=f.left+"px"),typeof f.bottom<"u"&&(this.domNode.style.bottom=f.bottom+"px"),typeof f.right<"u"&&(this.domNode.style.right=f.right+"px"),this.g=this.B(new w.$lQ),this.B(p.$QO(this.bgDomNode,p.$EP.POINTER_DOWN,m=>this.h(m))),this.B(p.$QO(this.domNode,p.$EP.POINTER_DOWN,m=>this.h(m))),this.b=this.B(new i.$5g),this.c=this.B(new i.$4g)}h(f){if(!f.target||!(f.target instanceof Element))return;const m=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(m,200),this.g.startMonitoring(f.target,f.pointerId,f.buttons,L=>{},()=>{this.b.cancel(),this.c.cancel()}),f.preventDefault()}}t.$oQ=D}),define($e[58],pe([1,0,3,40,55,37,118,20,5]),function(le,t,w,O,i,q,p,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rQ=void 0;const f=140;class m extends D.$mQ{constructor(n){super(),this.g=n.lazyRender,this.a=n.host,this.b=n.scrollable,this.c=n.scrollByPage,this.h=n.scrollbarState,this.n=this.B(new p.$qQ(n.visibility,"visible scrollbar "+n.extraScrollbarClassName,"invisible scrollbar "+n.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new i.$lQ),this.s=!0,this.domNode=(0,O.$kQ)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(w.$PO(this.domNode.domNode,w.$EP.POINTER_DOWN,o=>this.M(o)))}t(n){const o=this.B(new q.$oQ(n));this.domNode.domNode.appendChild(o.bgDomNode),this.domNode.domNode.appendChild(o.domNode)}w(n,o,e,a){this.slider=(0,O.$kQ)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(n),this.slider.setLeft(o),typeof e=="number"&&this.slider.setWidth(e),typeof a=="number"&&this.slider.setHeight(a),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(w.$PO(this.slider.domNode,w.$EP.POINTER_DOWN,h=>{h.button===0&&(h.preventDefault(),this.O(h))})),this.f(this.slider.domNode,h=>{h.leftButton&&h.stopPropagation()})}y(n){return this.h.setVisibleSize(n)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(n){return this.h.setScrollSize(n)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(n){return this.h.setScrollPosition(n)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(n){n.target===this.domNode.domNode&&this.N(n)}delegatePointerDown(n){const o=this.domNode.domNode.getClientRects()[0].top,e=o+this.h.getSliderPosition(),a=o+this.h.getSliderPosition()+this.h.getSliderSize(),h=this.U(n);e<=h&&h<=a?n.button===0&&(n.preventDefault(),this.O(n)):this.N(n)}N(n){let o,e;if(n.target===this.domNode.domNode&&typeof n.offsetX=="number"&&typeof n.offsetY=="number")o=n.offsetX,e=n.offsetY;else{const h=w.$8O(this.domNode.domNode);o=n.pageX-h.left,e=n.pageY-h.top}const a=this.S(o,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(a):this.h.getDesiredScrollPositionFromOffset(a)),n.button===0&&(n.preventDefault(),this.O(n))}O(n){if(!n.target||!(n.target instanceof Element))return;const o=this.U(n),e=this.W(n),a=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(n.target,n.pointerId,n.buttons,h=>{const $=this.W(h),s=Math.abs($-e);if(c.$j&&s>f){this.P(a.getScrollPosition());return}const d=this.U(h)-o;this.P(a.getDesiredScrollPositionFromDelta(d))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(n){const o={};this.writeScrollPosition(o,n),this.b.setScrollPositionNow(o)}updateScrollbarSize(n){this.X(n),this.h.setScrollbarSize(n),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$rQ=m}),define($e[121],pe([1,0,19,58,37,41,17]),function(le,t,w,O,i,q,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sQ=void 0;class D extends O.$rQ{constructor(f,m,L){const n=f.getScrollDimensions(),o=f.getCurrentScrollPosition();if(super({lazyRender:m.lazyRender,host:L,scrollbarState:new q.$pQ(m.horizontalHasArrows?m.arrowSize:0,m.horizontal===2?0:m.horizontalScrollbarSize,m.vertical===2?0:m.verticalScrollbarSize,n.width,n.scrollWidth,o.scrollLeft),visibility:m.horizontal,extraScrollbarClassName:"horizontal",scrollable:f,scrollByPage:m.scrollByPage}),m.horizontalHasArrows){const e=(m.arrowSize-i.$nQ)/2,a=(m.horizontalScrollbarSize-i.$nQ)/2;this.t({className:"scra",icon:p.$Uj.scrollbarButtonLeft,top:a,left:e,bottom:void 0,right:void 0,bgWidth:m.arrowSize,bgHeight:m.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new w.$JO(null,1,0))}),this.t({className:"scra",icon:p.$Uj.scrollbarButtonRight,top:a,left:void 0,bottom:void 0,right:e,bgWidth:m.arrowSize,bgHeight:m.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new w.$JO(null,-1,0))})}this.w(Math.floor((m.horizontalScrollbarSize-m.horizontalSliderSize)/2),0,void 0,m.horizontalSliderSize)}R(f,m){this.slider.setWidth(f),this.slider.setLeft(m)}Q(f,m){this.domNode.setWidth(f),this.domNode.setHeight(m),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(f){return this.s=this.J(f.scrollWidth)||this.s,this.s=this.L(f.scrollLeft)||this.s,this.s=this.y(f.width)||this.s,this.s}S(f,m){return f}U(f){return f.pageX}W(f){return f.pageY}X(f){this.slider.setHeight(f)}writeScrollPosition(f,m){f.scrollLeft=m}updateOptions(f){this.updateScrollbarSize(f.horizontal===2?0:f.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this.n.setVisibility(f.horizontal),this.c=f.scrollByPage}}t.$sQ=D}),define($e[122],pe([1,0,19,58,37,41,17]),function(le,t,w,O,i,q,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tQ=void 0;class D extends O.$rQ{constructor(f,m,L){const n=f.getScrollDimensions(),o=f.getCurrentScrollPosition();if(super({lazyRender:m.lazyRender,host:L,scrollbarState:new q.$pQ(m.verticalHasArrows?m.arrowSize:0,m.vertical===2?0:m.verticalScrollbarSize,0,n.height,n.scrollHeight,o.scrollTop),visibility:m.vertical,extraScrollbarClassName:"vertical",scrollable:f,scrollByPage:m.scrollByPage}),m.verticalHasArrows){const e=(m.arrowSize-i.$nQ)/2,a=(m.verticalScrollbarSize-i.$nQ)/2;this.t({className:"scra",icon:p.$Uj.scrollbarButtonUp,top:e,left:a,bottom:void 0,right:void 0,bgWidth:m.verticalScrollbarSize,bgHeight:m.arrowSize,onActivate:()=>this.a.onMouseWheel(new w.$JO(null,0,1))}),this.t({className:"scra",icon:p.$Uj.scrollbarButtonDown,top:void 0,left:a,bottom:e,right:void 0,bgWidth:m.verticalScrollbarSize,bgHeight:m.arrowSize,onActivate:()=>this.a.onMouseWheel(new w.$JO(null,0,-1))})}this.w(0,Math.floor((m.verticalScrollbarSize-m.verticalSliderSize)/2),m.verticalSliderSize,void 0)}R(f,m){this.slider.setHeight(f),this.slider.setTop(m)}Q(f,m){this.domNode.setWidth(m),this.domNode.setHeight(f),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(f){return this.s=this.J(f.scrollHeight)||this.s,this.s=this.L(f.scrollTop)||this.s,this.s=this.y(f.height)||this.s,this.s}S(f,m){return m}U(f){return f.pageY}W(f){return f.pageX}X(f){this.slider.setWidth(f)}writeScrollPosition(f,m){f.scrollTop=m}updateOptions(f){this.updateScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(f.vertical),this.c=f.scrollByPage}}t.$tQ=D}),define($e[59],pe([1,0,16,3,40,19,121,122,20,9,4,2,5,47,96]),function(le,t,w,O,i,q,p,D,c,f,m,L,n,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yQ=t.$xQ=t.$wQ=t.$vQ=t.$uQ=void 0;const e=500,a=50,h=!0;class ${constructor(T,g,v){this.timestamp=T,this.deltaX=g,this.deltaY=v,this.score=0}}class s{static{this.INSTANCE=new s}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let T=1,g=0,v=1,z=this.d;do{const H=z===this.c?T:Math.pow(2,-v);if(T-=H,g+=this.b[z].score*H,z===this.c)break;z=(this.a+z-1)%this.a,v++}while(!0);return g<=.5}acceptStandardWheelEvent(T){const g=O.$rP(T.browserEvent).devicePixelRatio/(0,w.$qO)();n.$j||n.$l?this.accept(Date.now(),T.deltaX/g,T.deltaY/g):this.accept(Date.now(),T.deltaX,T.deltaY)}accept(T,g,v){const z=new $(T,g,v);z.score=this.f(z),this.c===-1&&this.d===-1?(this.b[0]=z,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=z)}f(T){if(Math.abs(T.deltaX)>0&&Math.abs(T.deltaY)>0)return 1;let g=.5;const v=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(T.deltaX)||!this.g(T.deltaY))&&(g+=.25),Math.min(Math.max(g,0),1)}g(T){return Math.abs(Math.round(T)-T)<.01}}t.$uQ=s;class u extends c.$mQ{get options(){return this.a}constructor(T,g,v){super(),this.O=this.B(new m.$Nd),this.onScroll=this.O.event,this.P=this.B(new m.$Nd),this.onWillScroll=this.P.event,T.style.overflow="hidden",this.a=y(g),this.b=v,this.B(this.b.onScroll(H=>{this.P.fire(H),this.S(H),this.O.fire(H)}));const z={onMouseWheel:H=>this.R(H),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new D.$tQ(this.b,this.a,z)),this.g=this.B(new p.$sQ(this.b,this.a,z)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(T),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,i.$kQ)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,i.$kQ)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,i.$kQ)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,H=>this.Z(H)),this.u(this.t,H=>this.Y(H)),this.L=this.B(new f.$4g),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,L.$Mc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(T){this.c.delegatePointerDown(T)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(T){this.b.setScrollDimensions(T,!1)}updateClassName(T){this.a.className=T,n.$k&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(T){typeof T.handleMouseWheel<"u"&&(this.a.handleMouseWheel=T.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof T.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=T.mouseWheelScrollSensitivity),typeof T.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=T.fastScrollSensitivity),typeof T.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=T.scrollPredominantAxis),typeof T.horizontal<"u"&&(this.a.horizontal=T.horizontal),typeof T.vertical<"u"&&(this.a.vertical=T.vertical),typeof T.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=T.horizontalScrollbarSize),typeof T.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=T.verticalScrollbarSize),typeof T.scrollByPage<"u"&&(this.a.scrollByPage=T.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(T){this.N=T}delegateScrollFromMouseWheelEvent(T){this.R(new q.$JO(T))}Q(T){if(this.w.length>0!==T&&(this.w=(0,L.$Mc)(this.w),T)){const v=z=>{this.R(new q.$JO(z))};this.w.push(O.$PO(this.t,O.$EP.MOUSE_WHEEL,v,{passive:!1}))}}R(T){if(T.browserEvent?.defaultPrevented)return;const g=s.INSTANCE;h&&g.acceptStandardWheelEvent(T);let v=!1;if(T.deltaY||T.deltaX){let H=T.deltaY*this.a.mouseWheelScrollSensitivity,_=T.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&_+H===0?_=H=0:Math.abs(H)>=Math.abs(_)?_=0:H=0),this.a.flipAxes&&([H,_]=[_,H]);const M=!n.$k&&T.browserEvent&&T.browserEvent.shiftKey;(this.a.scrollYToX||M)&&!_&&(_=H,H=0),T.browserEvent&&T.browserEvent.altKey&&(_=_*this.a.fastScrollSensitivity,H=H*this.a.fastScrollSensitivity);const F=this.b.getFutureScrollPosition();let Z={};if(H){const ee=a*H,ue=F.scrollTop-(ee<0?Math.floor(ee):Math.ceil(ee));this.c.writeScrollPosition(Z,ue)}if(_){const ee=a*_,ue=F.scrollLeft-(ee<0?Math.floor(ee):Math.ceil(ee));this.g.writeScrollPosition(Z,ue)}Z=this.b.validateScrollPosition(Z),(F.scrollLeft!==Z.scrollLeft||F.scrollTop!==Z.scrollTop)&&(h&&this.a.mouseWheelSmoothScroll&&g.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(Z):this.b.setScrollPositionNow(Z),v=!0)}let z=v;!z&&this.a.alwaysConsumeMouseWheel&&(z=!0),!z&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(z=!0),z&&(T.preventDefault(),T.stopPropagation())}S(T){this.M=this.g.onDidScroll(T)||this.M,this.M=this.c.onDidScroll(T)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const T=this.b.getCurrentScrollPosition(),g=T.scrollTop>0,v=T.scrollLeft>0,z=v?" left":"",H=g?" top":"",_=v||g?" top-left-corner":"";this.n.setClassName(`shadow${z}`),this.r.setClassName(`shadow${H}`),this.s.setClassName(`shadow${_}${H}${z}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(T){this.J=!1,this.ab()}Z(T){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$vQ=u;class d extends u{constructor(T,g){g=g||{},g.mouseWheelSmoothScroll=!1;const v=new o.$Yr({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:z=>O.$XO(z,O.$rP(T))});super(T,g,v),this.B(v)}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$wQ=d;class l extends u{constructor(T,g,v){super(T,g,v)}setScrollPosition(T){T.reuseAnimation?this.b.setScrollPositionSmooth(T,T.reuseAnimation):this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$xQ=l;class r extends u{constructor(T,g){g=g||{},g.mouseWheelSmoothScroll=!1;const v=new o.$Yr({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:z=>O.$XO(z,O.$rP(T))});super(T,g,v),this.B(v),this.cb=T,this.B(this.onScroll(z=>{z.scrollTopChanged&&(this.cb.scrollTop=z.scrollTop),z.scrollLeftChanged&&(this.cb.scrollLeft=z.scrollLeft)})),this.scanDomNode()}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$yQ=r;function y(I){const T={lazyRender:typeof I.lazyRender<"u"?I.lazyRender:!1,className:typeof I.className<"u"?I.className:"",useShadows:typeof I.useShadows<"u"?I.useShadows:!0,handleMouseWheel:typeof I.handleMouseWheel<"u"?I.handleMouseWheel:!0,flipAxes:typeof I.flipAxes<"u"?I.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof I.consumeMouseWheelIfScrollbarIsNeeded<"u"?I.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof I.alwaysConsumeMouseWheel<"u"?I.alwaysConsumeMouseWheel:!1,scrollYToX:typeof I.scrollYToX<"u"?I.scrollYToX:!1,mouseWheelScrollSensitivity:typeof I.mouseWheelScrollSensitivity<"u"?I.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof I.fastScrollSensitivity<"u"?I.fastScrollSensitivity:5,scrollPredominantAxis:typeof I.scrollPredominantAxis<"u"?I.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof I.mouseWheelSmoothScroll<"u"?I.mouseWheelSmoothScroll:!0,arrowSize:typeof I.arrowSize<"u"?I.arrowSize:11,listenOnDomNode:typeof I.listenOnDomNode<"u"?I.listenOnDomNode:null,horizontal:typeof I.horizontal<"u"?I.horizontal:1,horizontalScrollbarSize:typeof I.horizontalScrollbarSize<"u"?I.horizontalScrollbarSize:10,horizontalSliderSize:typeof I.horizontalSliderSize<"u"?I.horizontalSliderSize:0,horizontalHasArrows:typeof I.horizontalHasArrows<"u"?I.horizontalHasArrows:!1,vertical:typeof I.vertical<"u"?I.vertical:1,verticalScrollbarSize:typeof I.verticalScrollbarSize<"u"?I.verticalScrollbarSize:10,verticalHasArrows:typeof I.verticalHasArrows<"u"?I.verticalHasArrows:!1,verticalSliderSize:typeof I.verticalSliderSize<"u"?I.verticalSliderSize:0,scrollByPage:typeof I.scrollByPage<"u"?I.scrollByPage:!1};return T.horizontalSliderSize=typeof I.horizontalSliderSize<"u"?I.horizontalSliderSize:T.horizontalScrollbarSize,T.verticalSliderSize=typeof I.verticalSliderSize<"u"?I.verticalSliderSize:T.verticalScrollbarSize,n.$k&&(T.className+=" mac"),T}}),define($e[60],pe([1,0,53,3,21,23,59,11,9,25,4,2,46,47,81,117,6]),function(le,t,w,O,i,q,p,D,c,f,m,L,n,o,e,a,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Q=t.$2Q=t.$1Q=t.$ZQ=void 0;const $={CurrentDragAndDropData:void 0},s={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(T){return[T]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class u{get context(){return this.d}set context(g){this.d=g}constructor(g){this.elements=g}update(){}getData(){return this.elements}}t.$ZQ=u;class d{constructor(g){this.elements=g}update(){}getData(){return this.elements}}t.$1Q=d;class l{constructor(){this.types=[],this.files=[]}update(g){if(g.types&&this.types.splice(0,this.types.length,...g.types),g.files){this.files.splice(0,this.files.length);for(let v=0;v<g.files.length;v++){const z=g.files.item(v);z&&(z.size||z.type)&&this.files.push(z)}}}getData(){return{types:this.types,files:this.files}}}t.$2Q=l;function r(T,g){return Array.isArray(T)&&Array.isArray(g)?(0,D.$tb)(T,g):T===g}class y{constructor(g){g?.getSetSize?this.getSetSize=g.getSetSize.bind(g):this.getSetSize=(v,z,H)=>H,g?.getPosInSet?this.getPosInSet=g.getPosInSet.bind(g):this.getPosInSet=(v,z)=>z+1,g?.getRole?this.getRole=g.getRole.bind(g):this.getRole=v=>"listitem",g?.isChecked?this.isChecked=g.isChecked.bind(g):this.isChecked=v=>{}}}class I{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(g){if(g!==this.O){if(g&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=g,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const v of this.d)this.Y(v);this.V(),this.q.setScrollDimensions({width:(0,O.$$O)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(g,v,z,H=s){if(this.Q=v,this.domId=`list_id_${++I.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new c.$Qg(50),this.v=!1,this.x=L.$Rc.None,this.y=0,this.G=!1,this.J=L.$Rc.None,this.K=L.$Rc.None,this.L=new L.$Qc,this.M=new m.$Nd,this.N=new m.$Nd,this.onDidChangeContentHeight=m.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=m.Event.latch(this.N.event,void 0,this.L),this.O=!1,H.horizontalScrolling&&H.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$XQ(H.paddingTop??0);for(const M of z)this.j.set(M.templateId,M);this.h=this.L.add(new a.$YQ(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof H.mouseSupport=="boolean"?H.mouseSupport:!0),this.O=H.horizontalScrolling??s.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof H.paddingBottom>"u"?0:H.paddingBottom,this.D=new y(H.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(H.transformOptimization??s.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(q.$iQ.addTarget(this.o)),this.p=this.L.add(new o.$Yr({forceIntegerValues:!0,smoothScrollDuration:H.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:M=>(0,O.$XO)(M,(0,O.$rP)(this.domNode))})),this.q=this.L.add(new p.$xQ(this.o,{alwaysConsumeMouseWheel:H.alwaysConsumeMouseWheel??s.alwaysConsumeMouseWheel,horizontal:1,vertical:H.verticalScrollMode??s.verticalScrollMode,useShadows:H.useShadows??s.useShadows,mouseWheelScrollSensitivity:H.mouseWheelScrollSensitivity,fastScrollSensitivity:H.fastScrollSensitivity,scrollByPage:H.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),g.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,O.$PO)(this.o,q.EventType.Change,M=>this.hb(M))),this.L.add((0,O.$PO)(this.q.getDomNode(),"scroll",M=>M.target.scrollTop=0)),this.L.add((0,O.$PO)(this.domNode,"dragover",M=>this.jb(this.fb(M)))),this.L.add((0,O.$PO)(this.domNode,"drop",M=>this.lb(this.fb(M)))),this.L.add((0,O.$PO)(this.domNode,"dragleave",M=>this.kb(this.fb(M)))),this.L.add((0,O.$PO)(this.domNode,"dragend",M=>this.mb(M))),this.z=H.setRowLineHeight??s.setRowLineHeight,this.A=H.setRowHeight??s.setRowHeight,this.B=H.supportDynamicHeights??s.supportDynamicHeights,this.F=H.dnd??this.L.add(s.dnd),this.layout(H.initialSize?.height,H.initialSize?.width)}updateOptions(g){g.paddingBottom!==void 0&&(this.C=g.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),g.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(g.smoothScrolling?125:0),g.horizontalScrolling!==void 0&&(this.P=g.horizontalScrolling);let v;if(g.scrollByPage!==void 0&&(v={...v??{},scrollByPage:g.scrollByPage}),g.mouseWheelScrollSensitivity!==void 0&&(v={...v??{},mouseWheelScrollSensitivity:g.mouseWheelScrollSensitivity}),g.fastScrollSensitivity!==void 0&&(v={...v??{},fastScrollSensitivity:g.fastScrollSensitivity}),v&&this.q.updateOptions(v),g.paddingTop!==void 0&&g.paddingTop!==this.g.paddingTop){const z=this.sb(this.k,this.m),H=g.paddingTop-this.g.paddingTop;this.g.paddingTop=g.paddingTop,this.W(z,Math.max(0,this.k+H),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(g){this.q.delegateScrollFromMouseWheelEvent(g)}delegateVerticalScrollbarPointerDown(g){this.q.delegateVerticalScrollbarPointerDown(g)}updateElementHeight(g,v,z){if(g<0||g>=this.d.length)return;const H=this.d[g].size;if(typeof v>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[g].lastDynamicHeightWidth=void 0,v=H+this.ub(g)}if(H===v)return;const _=this.sb(this.k,this.m);let M=0;g<_.start||z!==null&&z>g&&z<_.end?M=v-H:M=0,this.g.splice(g,1,[{size:v}]),this.d[g].size=v,this.W(_,Math.max(0,this.k+M),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(g,v,z=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(g,v,z)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(g,v,z=[]){const H=this.sb(this.k,this.m),_={start:g,end:g+v},M=n.Range.intersect(H,_),F=new Map;for(let V=M.end-1;V>=M.start;V--){const G=this.d[V];if(G.dragStartDisposable.dispose(),G.checkedDisposable.dispose(),G.row){let S=F.get(G.templateId);S||(S=[],F.set(G.templateId,S));const Q=this.j.get(G.templateId);Q&&Q.disposeElement&&Q.disposeElement(G.element,V,G.row.templateData,G.size),S.push(G.row)}G.row=null}const Z={start:g+v,end:this.d.length},ee=n.Range.intersect(Z,H),ue=n.Range.relativeComplement(Z,H),oe=z.map(V=>({id:String(this.f++),element:V,templateId:this.Q.getTemplateId(V),size:this.Q.getHeight(V),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(V),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:L.$Rc.None,checkedDisposable:L.$Rc.None}));let se;g===0&&v>=this.d.length?(this.g=new e.$XQ(this.g.paddingTop),this.g.splice(0,0,oe),se=this.d,this.d=oe):(this.g.splice(g,v,oe),se=this.d.splice(g,v,...oe));const re=z.length-v,be=this.sb(this.k,this.m),Se=(0,e.$VQ)(ee,re),Le=n.Range.intersect(be,Se);for(let V=Le.start;V<Le.end;V++)this.Z(this.d[V],V);const Fe=n.Range.relativeComplement(Se,be);for(const V of Fe)for(let G=V.start;G<V.end;G++)this.ab(G);const de=ue.map(V=>(0,e.$VQ)(V,re)),ce=[{start:g,end:g+z.length},...de].map(V=>n.Range.intersect(be,V)),Y=this.vb(ce);for(const V of ce)for(let G=V.start;G<V.end;G++){const S=this.d[G],b=F.get(S.templateId)?.pop();this.X(G,Y,b)}for(const V of F.values())for(const G of V)this.h.release(G);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),se.map(V=>V.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,O.$XO)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null},(0,O.$rP)(this.domNode)))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let g=0;for(const v of this.d)typeof v.width<"u"&&(g=Math.max(g,v.width));this.E=g,this.q.setScrollDimensions({scrollWidth:g===0?0:g+10}),this.N.fire(this.E)}updateWidth(g){if(!this.P||typeof this.E>"u")return;const v=this.d[g];this.Y(v),typeof v.width<"u"&&v.width>this.E&&(this.E=v.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const g of this.d)g.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const g=this.sb(this.k,this.m),v=this.g.positionAt(g.start),z=this.g.positionAt(g.start+1);return z!==-1&&(z-v)/2+v<this.scrollTop?g.start+1:g.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(g){return this.d[g].element}indexOf(g){return this.d.findIndex(v=>v.element===g)}domElement(g){const v=this.d[g].row;return v&&v.domNode}elementHeight(g){return this.d[g].size}elementTop(g){return this.g.positionAt(g)}indexAt(g){return this.g.indexAt(g)}indexAfter(g){return this.g.indexAfter(g)}layout(g,v){const z={height:typeof g=="number"?g:(0,O.$aP)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,z.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(z),typeof v<"u"&&(this.n=v,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof v=="number"?v:(0,O.$$O)(this.domNode)})}W(g,v,z,H,_,M=!1){const F=this.sb(v,z),Z=n.Range.relativeComplement(F,g),ee=n.Range.relativeComplement(g,F),ue=this.vb(Z);if(M){const oe=n.Range.intersect(g,F);for(let se=oe.start;se<oe.end;se++)this.Z(this.d[se],se)}this.h.transact(()=>{for(const oe of ee)for(let se=oe.start;se<oe.end;se++)this.ab(se);for(const oe of Z)for(let se=oe.start;se<oe.end;se++)this.X(se,ue)}),H!==void 0&&(this.o.style.left=`-${H}px`),this.o.style.top=`-${v}px`,this.P&&_!==void 0&&(this.o.style.width=`${Math.max(_,this.n)}px`),this.k=v,this.m=z}X(g,v,z){const H=this.d[g];let _=!1;if(!H.row)if(z)H.row=z;else{const ue=this.h.alloc(H.templateId);H.row=ue.row,_=ue.isReusingConnectedDomNode}const M=this.D.getRole(H.element)||"listitem";H.row.domNode.setAttribute("role",M);const F=this.D.isChecked(H.element);if(typeof F=="boolean")H.row.domNode.setAttribute("aria-checked",String(!!F));else if(F){const ue=oe=>H.row.domNode.setAttribute("aria-checked",String(!!oe));ue(F.value),H.checkedDisposable=F.onDidChange(ue)}(_||!H.row.domNode.parentElement)&&(v?this.o.insertBefore(H.row.domNode,v):this.o.appendChild(H.row.domNode)),this.Z(H,g);const Z=this.j.get(H.templateId);if(!Z)throw new Error(`No renderer found for template id ${H.templateId}`);Z?.renderElement(H.element,g,H.row.templateData,H.size);const ee=this.F.getDragURI(H.element);H.dragStartDisposable.dispose(),H.row.domNode.draggable=!!ee,ee&&(H.dragStartDisposable=(0,O.$PO)(H.row.domNode,"dragstart",ue=>this.ib(H.element,ee,ue))),this.P&&(this.Y(H),this.U())}Y(g){if(!g.row||!g.row.domNode)return;g.row.domNode.style.width="fit-content",g.width=(0,O.$$O)(g.row.domNode);const v=window.getComputedStyle(g.row.domNode);v.paddingLeft&&(g.width+=parseFloat(v.paddingLeft)),v.paddingRight&&(g.width+=parseFloat(v.paddingRight)),g.row.domNode.style.width=""}Z(g,v){g.row.domNode.style.top=`${this.elementTop(v)}px`,this.A&&(g.row.domNode.style.height=`${g.size}px`),this.z&&(g.row.domNode.style.lineHeight=`${g.size}px`),g.row.domNode.setAttribute("data-index",`${v}`),g.row.domNode.setAttribute("data-last-element",v===this.length-1?"true":"false"),g.row.domNode.setAttribute("data-parity",v%2===0?"even":"odd"),g.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(g.element,v,this.length))),g.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(g.element,v))),g.row.domNode.setAttribute("id",this.getElementDomId(v)),g.row.domNode.classList.toggle("drop-target",g.dropTarget)}ab(g){const v=this.d[g];if(v.dragStartDisposable.dispose(),v.checkedDisposable.dispose(),v.row){const z=this.j.get(v.templateId);z&&z.disposeElement&&z.disposeElement(v.element,g,v.row.templateData,v.size),this.h.release(v.row),v.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(g,v){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:g,reuseAnimation:v})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(g){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:g})}get scrollTop(){return this.getScrollTop()}set scrollTop(g){this.setScrollTop(g)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return m.Event.map(this.L.add(new i.$MQ(this.domNode,"click")).event,g=>this.bb(g),this.L)}get onMouseDblClick(){return m.Event.map(this.L.add(new i.$MQ(this.domNode,"dblclick")).event,g=>this.bb(g),this.L)}get onMouseMiddleClick(){return m.Event.filter(m.Event.map(this.L.add(new i.$MQ(this.domNode,"auxclick")).event,g=>this.bb(g),this.L),g=>g.browserEvent.button===1,this.L)}get onMouseUp(){return m.Event.map(this.L.add(new i.$MQ(this.domNode,"mouseup")).event,g=>this.bb(g),this.L)}get onMouseDown(){return m.Event.map(this.L.add(new i.$MQ(this.domNode,"mousedown")).event,g=>this.bb(g),this.L)}get onMouseOver(){return m.Event.map(this.L.add(new i.$MQ(this.domNode,"mouseover")).event,g=>this.bb(g),this.L)}get onMouseMove(){return m.Event.map(this.L.add(new i.$MQ(this.domNode,"mousemove")).event,g=>this.bb(g),this.L)}get onMouseOut(){return m.Event.map(this.L.add(new i.$MQ(this.domNode,"mouseout")).event,g=>this.bb(g),this.L)}get onContextMenu(){return m.Event.any(m.Event.map(this.L.add(new i.$MQ(this.domNode,"contextmenu")).event,g=>this.bb(g),this.L),m.Event.map(this.L.add(new i.$MQ(this.domNode,q.EventType.Contextmenu)).event,g=>this.eb(g),this.L))}get onTouchStart(){return m.Event.map(this.L.add(new i.$MQ(this.domNode,"touchstart")).event,g=>this.db(g),this.L)}get onTap(){return m.Event.map(this.L.add(new i.$MQ(this.o,q.EventType.Tap)).event,g=>this.eb(g),this.L)}bb(g){const v=this.rb(g.target||null),z=typeof v>"u"?void 0:this.d[v],H=z&&z.element;return{browserEvent:g,index:v,element:H}}db(g){const v=this.rb(g.target||null),z=typeof v>"u"?void 0:this.d[v],H=z&&z.element;return{browserEvent:g,index:v,element:H}}eb(g){const v=this.rb(g.initialTarget||null),z=typeof v>"u"?void 0:this.d[v],H=z&&z.element;return{browserEvent:g,index:v,element:H}}fb(g){const v=this.rb(g.target||null),z=typeof v>"u"?void 0:this.d[v],H=z&&z.element;return{browserEvent:g,index:v,element:H}}gb(g){try{const v=this.sb(this.k,this.m);this.W(v,g.scrollTop,g.height,g.scrollLeft,g.scrollWidth),this.B&&this.tb(g.scrollTop,g.height,g.inSmoothScrolling)}catch(v){throw console.error("Got bad scroll event:",g),v}}hb(g){g.preventDefault(),g.stopPropagation(),this.scrollTop-=g.translationY}ib(g,v,z){if(!z.dataTransfer)return;const H=this.F.getDragElements(g);if(z.dataTransfer.effectAllowed="copyMove",z.dataTransfer.setData(w.$gQ.TEXT,v),z.dataTransfer.setDragImage){let _;this.F.getDragLabel&&(_=this.F.getDragLabel(H,z)),typeof _>"u"&&(_=String(H.length));const M=(0,O.$)(".monaco-drag-image");M.textContent=_;const Z=(ee=>{for(;ee&&!ee.classList.contains("monaco-workbench");)ee=ee.parentElement;return ee||this.domNode.ownerDocument})(this.domNode);Z.appendChild(M),z.dataTransfer.setDragImage(M,-10,-10),setTimeout(()=>Z.removeChild(M),0)}this.domNode.classList.add("dragging"),this.H=new u(H),$.CurrentDragAndDropData=new d(H),this.F.onDragStart?.(this.H,z)}jb(g){if(g.browserEvent.preventDefault(),this.K.dispose(),$.CurrentDragAndDropData&&$.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(g.browserEvent),!g.browserEvent.dataTransfer))return!1;if(!this.H)if($.CurrentDragAndDropData)this.H=$.CurrentDragAndDropData;else{if(!g.browserEvent.dataTransfer.types)return!1;this.H=new l}const v=this.F.onDragOver(this.H,g.element,g.index,g.browserEvent);if(this.G=typeof v=="boolean"?v:v.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;g.browserEvent.dataTransfer.dropEffect=typeof v!="boolean"&&v.effect===0?"copy":"move";let z;if(typeof v!="boolean"&&v.feedback?z=v.feedback:typeof g.index>"u"?z=[-1]:z=[g.index],z=(0,D.$Lb)(z).filter(H=>H>=-1&&H<this.length).sort((H,_)=>H-_),z=z[0]===-1?[-1]:z,r(this.I,z))return!0;if(this.I=z,this.J.dispose(),z[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,L.$Pc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const H of z){const _=this.d[H];_.dropTarget=!0,_.row?.domNode.classList.add("drop-target")}this.J=(0,L.$Pc)(()=>{for(const H of z){const _=this.d[H];_.dropTarget=!1,_.row?.domNode.classList.remove("drop-target")}})}return!0}kb(g){this.K.dispose(),this.K=(0,c.$Vg)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,g.element,g.index,g.browserEvent)}lb(g){if(!this.G)return;const v=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,$.CurrentDragAndDropData=void 0,!(!v||!g.browserEvent.dataTransfer)&&(g.browserEvent.preventDefault(),v.update(g.browserEvent.dataTransfer),this.F.drop(v,g.element,g.index,g.browserEvent))}mb(g){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,$.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(g)}nb(){this.I=void 0,this.J.dispose(),this.J=L.$Rc.None}ob(g){if(!this.w){const v=(0,O.$5O)(this.domNode).top;this.w=(0,O.$1P)(this.pb.bind(this,v),(0,O.$rP)(this.domNode))}this.x.dispose(),this.x=(0,c.$Vg)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=g.pageY}pb(g){if(this.y===void 0)return;const v=this.y-g,z=this.renderHeight-35;v<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(v-35))):v>z&&(this.scrollTop+=Math.min(14,Math.floor(.3*(v-z))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(g){const v=this.q.getDomNode();let z=g;for(;z instanceof HTMLElement&&z!==this.o&&v.contains(z);){const H=z.getAttribute("data-index");if(H){const _=Number(H);if(!isNaN(_))return _}z=z.parentElement}}sb(g,v){return{start:this.g.indexAt(g),end:this.g.indexAfter(g+v-1)}}tb(g,v,z){const H=this.sb(g,v);let _,M;g===this.elementTop(H.start)?(_=H.start,M=0):H.end-H.start>1&&(_=H.start+1,M=this.elementTop(_)-g);let F=0;for(;;){const Z=this.sb(g,v);let ee=!1;for(let ue=Z.start;ue<Z.end;ue++){const oe=this.ub(ue);oe!==0&&this.g.splice(ue,1,[this.d[ue]]),F+=oe,ee=ee||oe!==0}if(!ee){F!==0&&this.S();const ue=n.Range.relativeComplement(H,Z);for(const se of ue)for(let re=se.start;re<se.end;re++)this.d[re].row&&this.ab(re);const oe=n.Range.relativeComplement(Z,H);for(const se of oe)for(let re=se.start;re<se.end;re++){const be=re+1,Se=be<this.d.length?this.d[be].row:null,Le=Se?Se.domNode:null;this.X(re,Le)}for(let se=Z.start;se<Z.end;se++)this.d[se].row&&this.Z(this.d[se],se);if(typeof _=="number"){const se=this.p.getFutureScrollPosition().scrollTop-g,re=this.elementTop(_)-M+se;this.setScrollTop(re,z)}this.M.fire(this.contentHeight);return}}}ub(g){const v=this.d[g];if(this.Q.getDynamicHeight){const M=this.Q.getDynamicHeight(v.element);if(M!==null){const F=v.size;return v.size=M,v.lastDynamicHeightWidth=this.n,M-F}}if(!v.hasDynamicHeight||v.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(v.element))return 0;const z=v.size;if(v.row)return v.row.domNode.style.height="",v.size=v.row.domNode.offsetHeight,v.lastDynamicHeightWidth=this.n,v.size-z;const{row:H}=this.h.alloc(v.templateId);H.domNode.style.height="",this.o.appendChild(H.domNode);const _=this.j.get(v.templateId);if(!_)throw new h.$bb("Missing renderer for templateId: "+v.templateId);return _.renderElement(v.element,g,H.templateData,void 0),v.size=H.domNode.offsetHeight,_.disposeElement?.(v.element,g,H.templateData,void 0),this.Q.setDynamicHeight?.(v.element,v.size),v.lastDynamicHeightWidth=this.n,this.o.removeChild(H.domNode),this.h.release(H),v.size-z}vb(g){const v=g[g.length-1];if(!v)return null;const z=this.d[v.end];return!z||!z.row?null:z.row.domNode}getElementDomId(g){return`${this.domId}_${g}`}dispose(){for(const g of this.d)if(g.dragStartDisposable.dispose(),g.checkedDisposable.dispose(),g.row){const v=this.j.get(g.row.templateId);v&&(v.disposeElement?.(g.element,-1,g.row.templateData,void 0),v.disposeTemplate(g.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$3Q=I,xe([f.$hh],I.prototype,"onMouseClick",null),xe([f.$hh],I.prototype,"onMouseDblClick",null),xe([f.$hh],I.prototype,"onMouseMiddleClick",null),xe([f.$hh],I.prototype,"onMouseUp",null),xe([f.$hh],I.prototype,"onMouseDown",null),xe([f.$hh],I.prototype,"onMouseOver",null),xe([f.$hh],I.prototype,"onMouseMove",null),xe([f.$hh],I.prototype,"onMouseOut",null),xe([f.$hh],I.prototype,"onContextMenu",null),xe([f.$hh],I.prototype,"onTouchStart",null),xe([f.$hh],I.prototype,"onTap",null)}),define($e[38],pe([1,0,3,21,14,23,56,70,11,9,73,25,4,33,2,45,5,7,69,60,19,95]),function(le,t,w,O,i,q,p,D,c,f,m,L,n,o,e,a,h,$,s,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aR=t.$_Q=t.$$Q=t.$0Q=t.$9Q=t.$8Q=t.$7Q=t.TypeNavigationMode=t.$6Q=t.$5Q=t.$4Q=void 0;class l{constructor(S){this.d=S,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(S){return S}renderElement(S,Q,b){const R=this.c.findIndex(B=>B.templateData===b);if(R>=0){const B=this.c[R];this.d.unrender(b),B.index=Q}else{const B={index:Q,templateData:b};this.c.push(B)}this.d.renderIndex(Q,b)}splice(S,Q,b){const R=[];for(const B of this.c)B.index<S?R.push(B):B.index>=S+Q&&R.push({index:B.index+b-Q,templateData:B.templateData});this.c=R}renderIndexes(S){for(const{index:Q,templateData:b}of this.c)S.indexOf(Q)>-1&&this.d.renderIndex(Q,b)}disposeTemplate(S){const Q=this.c.findIndex(b=>b.templateData===S);Q<0||this.c.splice(Q,1)}}class r{get name(){return this.h}get renderer(){return new l(this)}constructor(S){this.h=S,this.c=0,this.d=[],this.f=[],this.g=new n.$Nd,this.onChange=this.g.event}splice(S,Q,b){Q=Math.max(0,Math.min(Q,this.c-S));const R=b.length-Q,B=S+Q,N=[];let A=0;for(;A<this.f.length&&this.f[A]<S;)N.push(this.f[A++]);for(let U=0;U<b.length;U++)b[U]&&N.push(U+S);for(;A<this.f.length&&this.f[A]>=B;)N.push(this.f[A++]+R);const k=this.c+R;if(this.f.length>0&&N.length===0&&k>0){const U=this.f.find(C=>C>=S)??k-1;N.push(Math.min(U,k-1))}this.renderer.splice(S,Q,b.length),this.k(N,N),this.c=k}renderIndex(S,Q){Q.classList.toggle(this.h,this.contains(S))}unrender(S){S.classList.remove(this.h)}set(S,Q){return this.k(S,[...S].sort(de),Q)}k(S,Q,b){const R=this.d,B=this.f;this.d=S,this.f=Q;const N=Le(B,S);return this.renderer.renderIndexes(N),this.g.fire({indexes:S,browserEvent:b}),R}get(){return this.d}contains(S){return(0,c.$vb)(this.f,S,de)>=0}dispose(){(0,e.$Mc)(this.g)}}xe([L.$hh],r.prototype,"renderer",null);class y extends r{constructor(S){super("selected"),this.l=S}renderIndex(S,Q){super.renderIndex(S,Q),this.l&&(this.contains(S)?Q.setAttribute("aria-selected","true"):Q.setAttribute("aria-selected","false"))}}class I{constructor(S,Q,b){this.c=S,this.d=Q,this.f=b}splice(S,Q,b){if(!this.f)return this.c.splice(S,Q,new Array(b.length).fill(!1));const R=this.c.get().map(A=>this.f.getId(this.d.element(A)).toString());if(R.length===0)return this.c.splice(S,Q,new Array(b.length).fill(!1));const B=new Set(R),N=b.map(A=>B.has(this.f.getId(A).toString()));this.c.splice(S,Q,N)}}function T(G){return G.tagName==="INPUT"||G.tagName==="TEXTAREA"}t.$4Q=T;function g(G){return G.classList.contains("monaco-editor")?!0:G.classList.contains("monaco-list")||!G.parentElement?!1:g(G.parentElement)}t.$5Q=g;function v(G){return G.tagName==="A"&&G.classList.contains("monaco-button")||G.tagName==="DIV"&&G.classList.contains("monaco-button-dropdown")?!0:G.classList.contains("monaco-list")||!G.parentElement?!1:v(G.parentElement)}t.$6Q=v;class z{get g(){return n.Event.chain(this.c.add(new O.$MQ(this.k.domNode,"keydown")).event,S=>S.filter(Q=>!T(Q.target)).map(Q=>new i.$MO(Q)))}constructor(S,Q,b){this.h=S,this.k=Q,this.c=new e.$Qc,this.d=new e.$Qc,this.f=b.multipleSelectionSupport,this.c.add(this.g(R=>{switch(R.keyCode){case 3:return this.l(R);case 16:return this.o(R);case 18:return this.p(R);case 11:return this.q(R);case 12:return this.s(R);case 9:return this.u(R);case 31:this.f&&(h.$k?R.metaKey:R.ctrlKey)&&this.t(R)}}))}updateOptions(S){S.multipleSelectionSupport!==void 0&&(this.f=S.multipleSelectionSupport)}l(S){S.preventDefault(),S.stopPropagation(),this.h.setSelection(this.h.getFocus(),S.browserEvent)}o(S){S.preventDefault(),S.stopPropagation(),this.h.focusPrevious(1,!1,S.browserEvent);const Q=this.h.getFocus()[0];this.h.setAnchor(Q),this.h.reveal(Q),this.k.domNode.focus()}p(S){S.preventDefault(),S.stopPropagation(),this.h.focusNext(1,!1,S.browserEvent);const Q=this.h.getFocus()[0];this.h.setAnchor(Q),this.h.reveal(Q),this.k.domNode.focus()}q(S){S.preventDefault(),S.stopPropagation(),this.h.focusPreviousPage(S.browserEvent);const Q=this.h.getFocus()[0];this.h.setAnchor(Q),this.h.reveal(Q),this.k.domNode.focus()}s(S){S.preventDefault(),S.stopPropagation(),this.h.focusNextPage(S.browserEvent);const Q=this.h.getFocus()[0];this.h.setAnchor(Q),this.h.reveal(Q),this.k.domNode.focus()}t(S){S.preventDefault(),S.stopPropagation(),this.h.setSelection((0,c.$Rb)(this.h.length),S.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(S){this.h.getSelection().length&&(S.preventDefault(),S.stopPropagation(),this.h.setSelection([],S.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}xe([L.$hh],z.prototype,"g",null);var H;(function(G){G[G.Automatic=0]="Automatic",G[G.Trigger=1]="Trigger"})(H||(t.TypeNavigationMode=H={}));var _;(function(G){G[G.Idle=0]="Idle",G[G.Typing=1]="Typing"})(_||(_={})),t.$7Q=new class{mightProducePrintableCharacter(G){return G.ctrlKey||G.metaKey||G.altKey?!1:G.keyCode>=31&&G.keyCode<=56||G.keyCode>=21&&G.keyCode<=30||G.keyCode>=98&&G.keyCode<=107||G.keyCode>=85&&G.keyCode<=95}};class M{constructor(S,Q,b,R,B){this.o=S,this.p=Q,this.q=b,this.s=R,this.t=B,this.c=!1,this.d=_.Idle,this.f=H.Automatic,this.g=!1,this.h=-1,this.k=new e.$Qc,this.l=new e.$Qc,this.updateOptions(S.options)}updateOptions(S){S.typeNavigationEnabled??!0?this.u():this.v(),this.f=S.typeNavigationMode??H.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let S=!1;const Q=n.Event.chain(this.k.add(new O.$MQ(this.p.domNode,"keydown")).event,B=>B.filter(N=>!T(N.target)).filter(()=>this.f===H.Automatic||this.g).map(N=>new i.$MO(N)).filter(N=>S||this.s(N)).filter(N=>this.t.mightProducePrintableCharacter(N)).forEach(N=>w.$GP.stop(N,!0)).map(N=>N.browserEvent.key)),b=n.Event.debounce(Q,()=>null,800,void 0,void 0,void 0,this.k);n.Event.reduce(n.Event.any(Q,b),(B,N)=>N===null?null:(B||"")+N,void 0,this.k)(this.x,this,this.k),b(this.w,this,this.k),Q(()=>S=!0,void 0,this.k),b(()=>S=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const S=this.o.getFocus();if(S.length>0&&S[0]===this.h){const Q=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(S[0]));Q&&(0,p.$OQ)(Q)}this.h=-1}x(S){if(!S){this.d=_.Idle,this.g=!1;return}const Q=this.o.getFocus(),b=Q.length>0?Q[0]:0,R=this.d===_.Idle?1:0;this.d=_.Typing;for(let B=0;B<this.o.length;B++){const N=(b+B+R)%this.o.length,A=this.q.getKeyboardNavigationLabel(this.p.element(N)),k=A&&A.toString();if(this.o.options.typeNavigationEnabled){if(typeof k<"u"){if((0,o.$Dj)(S,k)){this.h=b,this.o.setFocus([N]),this.o.reveal(N);return}const U=(0,o.$Kj)(S,k);if(U&&U[0].end-U[0].start>1&&U.length===1){this.h=b,this.o.setFocus([N]),this.o.reveal(N);return}}}else if(typeof k>"u"||(0,o.$Dj)(S,k)){this.h=b,this.o.setFocus([N]),this.o.reveal(N);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class F{constructor(S,Q){this.d=S,this.f=Q,this.c=new e.$Qc;const b=n.Event.chain(this.c.add(new O.$MQ(Q.domNode,"keydown")).event,B=>B.filter(N=>!T(N.target)).map(N=>new i.$MO(N)));n.Event.chain(b,B=>B.filter(N=>N.keyCode===2&&!N.ctrlKey&&!N.metaKey&&!N.shiftKey&&!N.altKey))(this.g,this,this.c)}g(S){if(S.target!==this.f.domNode)return;const Q=this.d.getFocus();if(Q.length===0)return;const b=this.f.domElement(Q[0]);if(!b)return;const R=b.querySelector("[tabIndex]");if(!R||!(R instanceof HTMLElement)||R.tabIndex===-1)return;const B=window.getComputedStyle(R);B.visibility==="hidden"||B.display==="none"||(S.preventDefault(),S.stopPropagation(),R.focus())}dispose(){this.c.dispose()}}function Z(G){return h.$k?G.browserEvent.metaKey:G.browserEvent.ctrlKey}t.$8Q=Z;function ee(G){return G.browserEvent.shiftKey}t.$9Q=ee;function ue(G){return(0,w.$AP)(G)&&G.button===2}const oe={isSelectionSingleChangeEvent:Z,isSelectionRangeChangeEvent:ee};class se{constructor(S){this.k=S,this.f=new e.$Qc,this.g=new n.$Nd,this.onPointer=this.g.event,S.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||oe),this.d=typeof S.options.mouseSupport>"u"||!!S.options.mouseSupport,this.d&&(S.onMouseDown(this.s,this,this.f),S.onContextMenu(this.t,this,this.f),S.onMouseDblClick(this.v,this,this.f),S.onTouchStart(this.s,this,this.f),this.f.add(q.$iQ.addTarget(S.getHTMLElement()))),n.Event.any(S.onMouseClick,S.onMouseMiddleClick,S.onTap)(this.u,this,this.f)}updateOptions(S){S.multipleSelectionSupport!==void 0&&(this.c=void 0,S.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||oe))}o(S){return this.c?this.c.isSelectionSingleChangeEvent(S):!1}p(S){return this.c?this.c.isSelectionRangeChangeEvent(S):!1}q(S){return this.o(S)||this.p(S)}s(S){g(S.browserEvent.target)||(0,w.$lP)()!==S.browserEvent.target&&this.k.domFocus()}t(S){if(T(S.browserEvent.target)||g(S.browserEvent.target))return;const Q=typeof S.index>"u"?[]:[S.index];this.k.setFocus(Q,S.browserEvent)}u(S){if(!this.d||T(S.browserEvent.target)||g(S.browserEvent.target)||S.browserEvent.isHandledByList)return;S.browserEvent.isHandledByList=!0;const Q=S.index;if(typeof Q>"u"){this.k.setFocus([],S.browserEvent),this.k.setSelection([],S.browserEvent),this.k.setAnchor(void 0);return}if(this.q(S))return this.w(S);this.k.setFocus([Q],S.browserEvent),this.k.setAnchor(Q),ue(S.browserEvent)||this.k.setSelection([Q],S.browserEvent),this.g.fire(S)}v(S){if(T(S.browserEvent.target)||g(S.browserEvent.target)||this.q(S)||S.browserEvent.isHandledByList)return;S.browserEvent.isHandledByList=!0;const Q=this.k.getFocus();this.k.setSelection(Q,S.browserEvent)}w(S){const Q=S.index;let b=this.k.getAnchor();if(this.p(S)){typeof b>"u"&&(b=this.k.getFocus()[0]??Q,this.k.setAnchor(b));const R=Math.min(b,Q),B=Math.max(b,Q),N=(0,c.$Rb)(R,B+1),A=this.k.getSelection(),k=Se(Le(A,[b]),b);if(k.length===0)return;const U=Le(N,Fe(A,k));this.k.setSelection(U,S.browserEvent),this.k.setFocus([Q],S.browserEvent)}else if(this.o(S)){const R=this.k.getSelection(),B=R.filter(N=>N!==Q);this.k.setFocus([Q]),this.k.setAnchor(Q),R.length===B.length?this.k.setSelection([...B,Q],S.browserEvent):this.k.setSelection(B,S.browserEvent)}}dispose(){this.f.dispose()}}t.$0Q=se;class re{constructor(S,Q){this.c=S,this.d=Q}style(S){const Q=this.d&&`.${this.d}`,b=[];S.listBackground&&b.push(`.monaco-list${Q} .monaco-list-rows { background: ${S.listBackground}; }`),S.listFocusBackground&&(b.push(`.monaco-list${Q}:focus .monaco-list-row.focused { background-color: ${S.listFocusBackground}; }`),b.push(`.monaco-list${Q}:focus .monaco-list-row.focused:hover { background-color: ${S.listFocusBackground}; }`)),S.listFocusForeground&&b.push(`.monaco-list${Q}:focus .monaco-list-row.focused { color: ${S.listFocusForeground}; }`),S.listActiveSelectionBackground&&(b.push(`.monaco-list${Q}:focus .monaco-list-row.selected { background-color: ${S.listActiveSelectionBackground}; }`),b.push(`.monaco-list${Q}:focus .monaco-list-row.selected:hover { background-color: ${S.listActiveSelectionBackground}; }`)),S.listActiveSelectionForeground&&b.push(`.monaco-list${Q}:focus .monaco-list-row.selected { color: ${S.listActiveSelectionForeground}; }`),S.listActiveSelectionIconForeground&&b.push(`.monaco-list${Q}:focus .monaco-list-row.selected .codicon { color: ${S.listActiveSelectionIconForeground}; }`),S.listFocusAndSelectionBackground&&b.push(`
				.monaco-drag-image,
				.monaco-list${Q}:focus .monaco-list-row.selected.focused { background-color: ${S.listFocusAndSelectionBackground}; }
			`),S.listFocusAndSelectionForeground&&b.push(`
				.monaco-drag-image,
				.monaco-list${Q}:focus .monaco-list-row.selected.focused { color: ${S.listFocusAndSelectionForeground}; }
			`),S.listInactiveFocusForeground&&(b.push(`.monaco-list${Q} .monaco-list-row.focused { color:  ${S.listInactiveFocusForeground}; }`),b.push(`.monaco-list${Q} .monaco-list-row.focused:hover { color:  ${S.listInactiveFocusForeground}; }`)),S.listInactiveSelectionIconForeground&&b.push(`.monaco-list${Q} .monaco-list-row.focused .codicon { color:  ${S.listInactiveSelectionIconForeground}; }`),S.listInactiveFocusBackground&&(b.push(`.monaco-list${Q} .monaco-list-row.focused { background-color:  ${S.listInactiveFocusBackground}; }`),b.push(`.monaco-list${Q} .monaco-list-row.focused:hover { background-color:  ${S.listInactiveFocusBackground}; }`)),S.listInactiveSelectionBackground&&(b.push(`.monaco-list${Q} .monaco-list-row.selected { background-color:  ${S.listInactiveSelectionBackground}; }`),b.push(`.monaco-list${Q} .monaco-list-row.selected:hover { background-color:  ${S.listInactiveSelectionBackground}; }`)),S.listInactiveSelectionForeground&&b.push(`.monaco-list${Q} .monaco-list-row.selected { color: ${S.listInactiveSelectionForeground}; }`),S.listHoverBackground&&b.push(`.monaco-list${Q}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${S.listHoverBackground}; }`),S.listHoverForeground&&b.push(`.monaco-list${Q}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${S.listHoverForeground}; }`);const R=(0,w.$4P)(S.listFocusAndSelectionOutline,(0,w.$4P)(S.listSelectionOutline,S.listFocusOutline??""));R&&b.push(`.monaco-list${Q}:focus .monaco-list-row.focused.selected { outline: 1px solid ${R}; outline-offset: -1px;}`),S.listFocusOutline&&b.push(`
				.monaco-drag-image,
				.monaco-list${Q}:focus .monaco-list-row.focused { outline: 1px solid ${S.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${Q}.last-focused .monaco-list-row.focused { outline: 1px solid ${S.listFocusOutline}; outline-offset: -1px; }
			`);const B=(0,w.$4P)(S.listSelectionOutline,S.listInactiveFocusOutline??"");B&&b.push(`.monaco-list${Q} .monaco-list-row.focused.selected { outline: 1px dotted ${B}; outline-offset: -1px; }`),S.listSelectionOutline&&b.push(`.monaco-list${Q} .monaco-list-row.selected { outline: 1px dotted ${S.listSelectionOutline}; outline-offset: -1px; }`),S.listInactiveFocusOutline&&b.push(`.monaco-list${Q} .monaco-list-row.focused { outline: 1px dotted ${S.listInactiveFocusOutline}; outline-offset: -1px; }`),S.listHoverOutline&&b.push(`.monaco-list${Q} .monaco-list-row:hover { outline: 1px dashed ${S.listHoverOutline}; outline-offset: -1px; }`),S.listDropBackground&&b.push(`
				.monaco-list${Q}.drop-target,
				.monaco-list${Q} .monaco-list-rows.drop-target,
				.monaco-list${Q} .monaco-list-row.drop-target { background-color: ${S.listDropBackground} !important; color: inherit !important; }
			`),S.tableColumnsBorder&&b.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${S.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),S.tableOddRowsBackgroundColor&&b.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${S.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=b.join(`
`)}}t.$$Q=re,t.$_Q={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:m.$1s.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:m.$1s.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:m.$1s.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const be={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Se(G,S){const Q=G.indexOf(S);if(Q===-1)return[];const b=[];let R=Q-1;for(;R>=0&&G[R]===S-(Q-R);)b.push(G[R--]);for(b.reverse(),R=Q;R<G.length&&G[R]===S+(R-Q);)b.push(G[R++]);return b}function Le(G,S){const Q=[];let b=0,R=0;for(;b<G.length||R<S.length;)if(b>=G.length)Q.push(S[R++]);else if(R>=S.length)Q.push(G[b++]);else if(G[b]===S[R]){Q.push(G[b]),b++,R++;continue}else G[b]<S[R]?Q.push(G[b++]):Q.push(S[R++]);return Q}function Fe(G,S){const Q=[];let b=0,R=0;for(;b<G.length||R<S.length;)if(b>=G.length)Q.push(S[R++]);else if(R>=S.length)Q.push(G[b++]);else if(G[b]===S[R]){b++,R++;continue}else G[b]<S[R]?Q.push(G[b++]):R++;return Q}const de=(G,S)=>G-S;class ie{constructor(S,Q){this.c=S,this.d=Q}get templateId(){return this.c}renderTemplate(S){return this.d.map(Q=>Q.renderTemplate(S))}renderElement(S,Q,b,R){let B=0;for(const N of this.d)N.renderElement(S,Q,b[B++],R)}disposeElement(S,Q,b,R){let B=0;for(const N of this.d)N.disposeElement?.(S,Q,b[B],R),B+=1}disposeTemplate(S){let Q=0;for(const b of this.d)b.disposeTemplate(S[Q++])}}class ce{constructor(S){this.c=S,this.templateId="a18n"}renderTemplate(S){return S}renderElement(S,Q,b){const R=this.c.getAriaLabel(S);R?b.setAttribute("aria-label",R):b.removeAttribute("aria-label");const B=this.c.getAriaLevel&&this.c.getAriaLevel(S);typeof B=="number"?b.setAttribute("aria-level",`${B}`):b.removeAttribute("aria-level")}disposeTemplate(S){}}class Y{constructor(S,Q){this.c=S,this.d=Q}getDragElements(S){const Q=this.c.getSelectedElements();return Q.indexOf(S)>-1?Q:[S]}getDragURI(S){return this.d.getDragURI(S)}getDragLabel(S,Q){if(this.d.getDragLabel)return this.d.getDragLabel(S,Q)}onDragStart(S,Q){this.d.onDragStart?.(S,Q)}onDragOver(S,Q,b,R){return this.d.onDragOver(S,Q,b,R)}onDragLeave(S,Q,b,R){this.d.onDragLeave?.(S,Q,b,R)}onDragEnd(S){this.d.onDragEnd?.(S)}drop(S,Q,b,R){this.d.drop(S,Q,b,R)}dispose(){this.d.dispose()}}class V{get onDidChangeFocus(){return n.Event.map(this.g.wrapEvent(this.c.onChange),S=>this.G(S),this.y)}get onDidChangeSelection(){return n.Event.map(this.g.wrapEvent(this.d.onChange),S=>this.G(S),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let S=!1;const Q=n.Event.chain(this.y.add(new O.$MQ(this.k.domNode,"keydown")).event,B=>B.map(N=>new i.$MO(N)).filter(N=>S=N.keyCode===58||N.shiftKey&&N.keyCode===68).map(N=>w.$GP.stop(N,!0)).filter(()=>!1)),b=n.Event.chain(this.y.add(new O.$MQ(this.k.domNode,"keyup")).event,B=>B.forEach(()=>S=!1).map(N=>new i.$MO(N)).filter(N=>N.keyCode===58||N.shiftKey&&N.keyCode===68).map(N=>w.$GP.stop(N,!0)).map(({browserEvent:N})=>{const A=this.getFocus(),k=A.length?A[0]:void 0,U=typeof k<"u"?this.k.element(k):void 0,C=typeof k<"u"?this.k.domElement(k):this.k.domNode;return{index:k,element:U,anchor:C,browserEvent:N}})),R=n.Event.chain(this.k.onContextMenu,B=>B.filter(N=>!S).map(({element:N,index:A,browserEvent:k})=>({element:N,index:A,anchor:new d.$HO(k),browserEvent:k})));return n.Event.any(Q,b,R)}get onKeyDown(){return this.y.add(new O.$MQ(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new O.$MQ(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new O.$MQ(this.k.domNode,"keypress")).event}get onDidFocus(){return n.Event.signal(this.y.add(new O.$MQ(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return n.Event.signal(this.y.add(new O.$MQ(this.k.domNode,"blur",!0)).event)}constructor(S,Q,b,R,B=be){this.A=S,this.B=B,this.c=new r("focused"),this.f=new r("anchor"),this.g=new n.$Vd,this.x="",this.y=new e.$Qc,this.z=new n.$Nd,this.onDidDispose=this.z.event;const N=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new y(N!=="listbox");const A=[this.c.renderer,this.d.renderer];this.u=B.accessibilityProvider,this.u&&(A.push(new ce(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),R=R.map(U=>new ie(U.templateId,[...A,U]));const k={...B,dnd:B.dnd&&new Y(this,B.dnd)};if(this.k=this.C(Q,b,R,k),this.k.domNode.setAttribute("role",N),B.styleController)this.q=B.styleController(this.k.domId);else{const U=(0,w.$tP)(this.k.domNode);this.q=new re(U,this.k.domId)}if(this.o=new D.$QQ([new I(this.c,this.k,B.identityProvider),new I(this.d,this.k,B.identityProvider),new I(this.f,this.k,B.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new F(this,this.k)),(typeof B.keyboardSupport!="boolean"||B.keyboardSupport)&&(this.v=new z(this,this.k,B),this.y.add(this.v)),B.keyboardNavigationLabelProvider){const U=B.keyboardNavigationDelegate||t.$7Q;this.t=new M(this,this.k,B.keyboardNavigationLabelProvider,B.keyboardNavigationEventFilter??(()=>!0),U),this.y.add(this.t)}this.w=this.D(B),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(S,Q,b,R){return new u.$3Q(S,Q,b,R)}D(S){return new se(this)}updateOptions(S={}){this.B={...this.B,...S},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(S),this.v?.updateOptions(S),this.k.updateOptions(S)}get options(){return this.B}splice(S,Q,b=[]){if(S<0||S>this.k.length)throw new s.$SQ(this.A,`Invalid start index: ${S}`);if(Q<0)throw new s.$SQ(this.A,`Invalid delete count: ${Q}`);Q===0&&b.length===0||this.g.bufferEvents(()=>this.o.splice(S,Q,b))}updateWidth(S){this.k.updateWidth(S)}updateElementHeight(S,Q){this.k.updateElementHeight(S,Q,null)}rerender(){this.k.rerender()}element(S){return this.k.element(S)}indexOf(S){return this.k.indexOf(S)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(S){this.k.setScrollTop(S)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(S){this.k.setScrollLeft(S)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(S){this.x=S,this.k.domNode.setAttribute("aria-label",S)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(S,Q){this.k.layout(S,Q)}triggerTypeNavigation(){this.t?.trigger()}setSelection(S,Q){for(const b of S)if(b<0||b>=this.length)throw new s.$SQ(this.A,`Invalid index ${b}`);this.d.set(S,Q)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(S=>this.k.element(S))}setAnchor(S){if(typeof S>"u"){this.f.set([]);return}if(S<0||S>=this.length)throw new s.$SQ(this.A,`Invalid index ${S}`);this.f.set([S])}getAnchor(){return(0,c.$Nb)(this.f.get(),void 0)}getAnchorElement(){const S=this.getAnchor();return typeof S>"u"?void 0:this.element(S)}setFocus(S,Q){for(const b of S)if(b<0||b>=this.length)throw new s.$SQ(this.A,`Invalid index ${b}`);this.c.set(S,Q)}focusNext(S=1,Q=!1,b,R){if(this.length===0)return;const B=this.c.get(),N=this.E(B.length>0?B[0]+S:0,Q,R);N>-1&&this.setFocus([N],b)}focusPrevious(S=1,Q=!1,b,R){if(this.length===0)return;const B=this.c.get(),N=this.F(B.length>0?B[0]-S:0,Q,R);N>-1&&this.setFocus([N],b)}async focusNextPage(S,Q){let b=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);b=b===0?0:b-1;const R=this.getFocus()[0];if(R!==b&&(R===void 0||b>R)){const B=this.F(b,!1,Q);B>-1&&R!==B?this.setFocus([B],S):this.setFocus([b],S)}else{const B=this.k.getScrollTop();let N=B+this.k.renderHeight;b>R&&(N-=this.k.elementHeight(b)),this.k.setScrollTop(N),this.k.getScrollTop()!==B&&(this.setFocus([]),await(0,f.$Ug)(0),await this.focusNextPage(S,Q))}}async focusPreviousPage(S,Q){let b;const R=this.k.getScrollTop();R===0?b=this.k.indexAt(R):b=this.k.indexAfter(R-1);const B=this.getFocus()[0];if(B!==b&&(B===void 0||B>=b)){const N=this.E(b,!1,Q);N>-1&&B!==N?this.setFocus([N],S):this.setFocus([b],S)}else{const N=R;this.k.setScrollTop(R-this.k.renderHeight),this.k.getScrollTop()!==N&&(this.setFocus([]),await(0,f.$Ug)(0),await this.focusPreviousPage(S,Q))}}focusLast(S,Q){if(this.length===0)return;const b=this.F(this.length-1,!1,Q);b>-1&&this.setFocus([b],S)}focusFirst(S,Q){this.focusNth(0,S,Q)}focusNth(S,Q,b){if(this.length===0)return;const R=this.E(S,!1,b);R>-1&&this.setFocus([R],Q)}E(S,Q=!1,b){for(let R=0;R<this.length;R++){if(S>=this.length&&!Q)return-1;if(S=S%this.length,!b||b(this.element(S)))return S;S++}return-1}F(S,Q=!1,b){for(let R=0;R<this.length;R++){if(S<0&&!Q)return-1;if(S=(this.length+S%this.length)%this.length,!b||b(this.element(S)))return S;S--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(S=>this.k.element(S))}reveal(S,Q){if(S<0||S>=this.length)throw new s.$SQ(this.A,`Invalid index ${S}`);const b=this.k.getScrollTop(),R=this.k.elementTop(S),B=this.k.elementHeight(S);if((0,$.$Cf)(Q)){const N=B-this.k.renderHeight;this.k.setScrollTop(N*(0,a.$Ol)(Q,0,1)+R)}else{const N=R+B,A=b+this.k.renderHeight;R<b&&N>=A||(R<b||N>=A&&B>=this.k.renderHeight?this.k.setScrollTop(R):N>=A&&this.k.setScrollTop(N-this.k.renderHeight))}}getRelativeTop(S){if(S<0||S>=this.length)throw new s.$SQ(this.A,`Invalid index ${S}`);const Q=this.k.getScrollTop(),b=this.k.elementTop(S),R=this.k.elementHeight(S);if(b<Q||b+R>Q+this.k.renderHeight)return null;const B=R-this.k.renderHeight;return Math.abs((Q-b)/B)}isDOMFocused(){return(0,w.$mP)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getElementID(S){return this.k.getElementDomId(S)}style(S){this.q.style(S)}G({indexes:S,browserEvent:Q}){return{indexes:S,elements:S.map(b=>this.k.element(b)),browserEvent:Q}}H(){const S=this.c.get();this.k.domNode.classList.toggle("element-focused",S.length>0),this.I()}I(){const S=this.c.get();if(S.length>0){let Q;this.u?.getActiveDescendantId&&(Q=this.u.getActiveDescendantId(this.k.element(S[0]))),this.k.domNode.setAttribute("aria-activedescendant",Q||this.k.getElementDomId(S[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const S=this.d.get();this.k.domNode.classList.toggle("selection-none",S.length===0),this.k.domNode.classList.toggle("selection-single",S.length===1),this.k.domNode.classList.toggle("selection-multiple",S.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$aR=V,xe([L.$hh],V.prototype,"onDidChangeFocus",null),xe([L.$hh],V.prototype,"onDidChangeSelection",null),xe([L.$hh],V.prototype,"onContextMenu",null),xe([L.$hh],V.prototype,"onKeyDown",null),xe([L.$hh],V.prototype,"onKeyUp",null),xe([L.$hh],V.prototype,"onKeyPress",null),xe([L.$hh],V.prototype,"onDidFocus",null),xe([L.$hh],V.prototype,"onDidBlur",null)}),define($e[61],pe([1,0,6,34,36,12,15]),function(le,t,w,O,i,q,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0j=t.$9j=t.$8j=t.$7j=t.$6j=t.$5j=t.$4j=t.$3j=t.MarkdownStringTextNewlineStyle=void 0;var D;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(D||(t.MarkdownStringTextNewlineStyle=D={}));class c{constructor($="",s=!1){if(this.value=$,typeof this.value!="string")throw(0,w.$6)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText($,s=0){return this.value+=n(this.supportThemeIcons?(0,O.$Wj)($):$).replace(/([ \t]+)/g,(u,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown($){return this.value+=$,this}appendCodeblock($,s){return this.value+="\n```",this.value+=$,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink($,s,u){return this.value+="[",this.value+=this.c(s,"]"),this.value+="](",this.value+=this.c(String($),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c($,s){const u=new RegExp((0,q.$Fe)(s),"g");return $.replace(u,(d,l)=>$.charAt(l-1)!=="\\"?`\\${d}`:d)}}t.$3j=c;function f(h){return m(h)?!h.value:Array.isArray(h)?h.every(f):!0}t.$4j=f;function m(h){return h instanceof c?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}t.$5j=m;function L(h,$){return h===$?!0:!h||!$?!1:h.value===$.value&&h.isTrusted===$.isTrusted&&h.supportThemeIcons===$.supportThemeIcons&&h.supportHtml===$.supportHtml&&(h.baseUri===$.baseUri||!!h.baseUri&&!!$.baseUri&&(0,i.$og)(p.URI.from(h.baseUri),p.URI.from($.baseUri)))}t.$6j=L;function n(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$7j=n;function o(h){return h.replace(/"/g,"&quot;")}t.$8j=o;function e(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$9j=e;function a(h){const $=[],s=h.split("|").map(d=>d.trim());h=s[0];const u=s[1];if(u){const d=/height=(\d+)/.exec(u),l=/width=(\d+)/.exec(u),r=d?d[1]:"",y=l?l[1]:"",I=isFinite(parseInt(y)),T=isFinite(parseInt(r));I&&$.push(`width="${y}"`),T&&$.push(`height="${r}"`)}return{href:h,dimensions:$}}t.$0j=a}),define($e[123],pe([1,0,3,115,21,54,14,19,116,6,4,61,34,76,27,2,78,52,29,50,36,12,15]),function(le,t,w,O,i,q,p,D,c,f,m,L,n,o,e,a,h,$,s,u,d,l,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hR=t.$gR=t.$fR=t.$eR=t.$dR=void 0;const y=Object.freeze({image:(Y,V,G)=>{let S=[],Q=[];return Y&&({href:Y,dimensions:S}=(0,L.$0j)(Y),Q.push(`src="${(0,L.$8j)(Y)}"`)),G&&Q.push(`alt="${(0,L.$8j)(G)}"`),V&&Q.push(`title="${(0,L.$8j)(V)}"`),S.length&&(Q=Q.concat(S)),"<img "+Q.join(" ")+">"},paragraph:Y=>`<p>${Y}</p>`,link:(Y,V,G)=>typeof Y!="string"?"":(Y===G&&(G=(0,L.$9j)(G)),V=typeof V=="string"?(0,L.$8j)((0,L.$9j)(V)):"",Y=(0,L.$9j)(Y),Y=Y.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Y}" title="${V||Y}">${G}</a>`)});function I(Y,V={},G={}){const S=new a.$Qc;let Q=!1;const b=(0,q.$LQ)(V),R=function(P){let W;try{W=(0,$.$lh)(decodeURIComponent(P))}catch{}return W?(W=(0,u.$9m)(W,x=>{if(Y.uris&&Y.uris[x])return r.URI.revive(Y.uris[x])}),encodeURIComponent(JSON.stringify(W))):P},B=function(P,W){const x=Y.uris&&Y.uris[P];let te=r.URI.revive(x);return W?P.startsWith(s.Schemas.data+":")?P:(te||(te=r.URI.parse(P)),s.$cg.uriToBrowserUri(te).toString(!0)):!te||r.URI.parse(P).toString()===te.toString()?P:(te.query&&(te=te.with({query:R(te.query)})),te.toString())},N=new h.marked.Renderer;N.image=y.image,N.link=y.link,N.paragraph=y.paragraph;const A=[],k=[];if(V.codeBlockRendererSync?N.code=(P,W)=>{const x=o.$wM.nextId(),te=V.codeBlockRendererSync(T(W),P);return k.push([x,te]),`<div class="code" data-code="${x}">${(0,l.$Ee)(P)}</div>`}:V.codeBlockRenderer&&(N.code=(P,W)=>{const x=o.$wM.nextId(),te=V.codeBlockRenderer(T(W),P);return A.push(te.then(ne=>[x,ne])),`<div class="code" data-code="${x}">${(0,l.$Ee)(P)}</div>`}),V.actionHandler){const P=function(te){let ne=te.target;if(!(ne.tagName!=="A"&&(ne=ne.parentElement,!ne||ne.tagName!=="A")))try{let ge=ne.dataset.href;ge&&(Y.baseUri&&(ge=g(r.URI.from(Y.baseUri),ge)),V.actionHandler.callback(ge,te))}catch(ge){(0,f.$Z)(ge)}finally{te.preventDefault()}},W=V.actionHandler.disposables.add(new i.$MQ(b,"click")),x=V.actionHandler.disposables.add(new i.$MQ(b,"auxclick"));V.actionHandler.disposables.add(m.Event.any(W.event,x.event)(te=>{const ne=new D.$HO(te);!ne.leftButton&&!ne.middleButton||P(ne)})),V.actionHandler.disposables.add(w.$PO(b,"keydown",te=>{const ne=new p.$MO(te);!ne.equals(10)&&!ne.equals(3)||P(ne)}))}Y.supportHtml||(G.sanitizer=P=>(Y.isTrusted?P.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?P:"",G.sanitize=!0,G.silent=!0),G.renderer=N;let U=Y.value??"";U.length>1e5&&(U=`${U.substr(0,1e5)}\u2026`),Y.supportThemeIcons&&(U=(0,n.$Xj)(U));let C;if(V.fillInIncompleteTokens){const P={...h.marked.defaults,...G},W=h.marked.lexer(U,P),x=ue(W);C=h.marked.parser(x,P)}else C=h.marked.parse(U,G);Y.supportThemeIcons&&(C=(0,c.$bR)(C).map(W=>typeof W=="string"?W:W.outerHTML).join(""));const E=new DOMParser().parseFromString(v(Y,C),"text/html");if(E.body.querySelectorAll("img").forEach(P=>{const W=P.getAttribute("src");if(W){let x=W;try{Y.baseUri&&(x=g(r.URI.from(Y.baseUri),x))}catch{}P.src=B(x,!0)}}),E.body.querySelectorAll("a").forEach(P=>{const W=P.getAttribute("href");if(P.setAttribute("href",""),!W||/^data:|javascript:/i.test(W)||/^command:/i.test(W)&&!Y.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(W))P.replaceWith(...P.childNodes);else{let x=B(W,!1);Y.baseUri&&(x=g(r.URI.from(Y.baseUri),W)),P.dataset.href=x}}),b.innerHTML=v(Y,E.body.innerHTML),A.length>0)Promise.all(A).then(P=>{if(Q)return;const W=new Map(P),x=b.querySelectorAll("div[data-code]");for(const te of x){const ne=W.get(te.dataset.code??"");ne&&w.$NP(te,ne)}V.asyncRenderCallback?.()});else if(k.length>0){const P=new Map(k),W=b.querySelectorAll("div[data-code]");for(const x of W){const te=P.get(x.dataset.code??"");te&&w.$NP(x,te)}}if(V.asyncRenderCallback)for(const P of b.getElementsByTagName("img")){const W=S.add(w.$PO(P,"load",()=>{W.dispose(),V.asyncRenderCallback()}))}return{element:b,dispose:()=>{Q=!0,S.dispose()}}}t.$dR=I;function T(Y){if(!Y)return"";const V=Y.split(/[\s+|:|,|\{|\?]/,1);return V.length?V[0]:Y}function g(Y,V){return/^\w[\w\d+.-]*:/.test(V)?V:Y.path.endsWith("/")?(0,d.$yg)(Y,V).toString():(0,d.$yg)((0,d.$ug)(Y),V).toString()}function v(Y,V){const{config:G,allowedSchemes:S}=z(Y);O.addHook("uponSanitizeAttribute",(b,R)=>{if(R.attrName==="style"||R.attrName==="class"){if(b.tagName==="SPAN"){if(R.attrName==="style"){R.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(R.attrValue);return}else if(R.attrName==="class"){R.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(R.attrValue);return}}R.keepAttr=!1;return}});const Q=w.$8P(S);try{return O.sanitize(V,{...G,RETURN_TRUSTED_TYPE:!0})}finally{O.removeHook("uponSanitizeAttribute"),Q.dispose()}}t.$eR=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function z(Y){const V=[s.Schemas.http,s.Schemas.https,s.Schemas.mailto,s.Schemas.data,s.Schemas.file,s.Schemas.vscodeFileResource,s.Schemas.vscodeRemote,s.Schemas.vscodeRemoteResource];return Y.isTrusted&&V.push(s.Schemas.command),{config:{ALLOWED_TAGS:[...w.$9P],ALLOWED_ATTR:t.$eR,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:V}}function H(Y){return typeof Y=="string"?Y:_(Y)}t.$fR=H;function _(Y){let V=Y.value??"";V.length>1e5&&(V=`${V.substr(0,1e5)}\u2026`);const G=h.marked.parse(V,{renderer:F.value}).replace(/&(#\d+|[a-zA-Z]+);/g,S=>M.get(S)??S);return v({isTrusted:!1},G).toString()}t.$gR=_;const M=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),F=new e.$U(()=>{const Y=new h.marked.Renderer;return Y.code=V=>V,Y.blockquote=V=>V,Y.html=V=>"",Y.heading=(V,G,S)=>V+`
`,Y.hr=()=>"",Y.list=(V,G)=>V,Y.listitem=V=>V+`
`,Y.paragraph=V=>V+`
`,Y.table=(V,G)=>V+G+`
`,Y.tablerow=V=>V,Y.tablecell=(V,G)=>V+" ",Y.strong=V=>V,Y.em=V=>V,Y.codespan=V=>V,Y.br=()=>`
`,Y.del=V=>V,Y.image=(V,G,S)=>"",Y.text=V=>V,Y.link=(V,G,S)=>S,Y});function Z(Y){let V="";return Y.forEach(G=>{V+=G.raw}),V}function ee(Y){for(const V of Y.tokens)if(V.type==="text"){const G=V.raw.split(`
`),S=G[G.length-1];if(S.includes("`"))return se(Y);if(S.includes("**"))return Fe(Y);if(S.match(/\*\w/))return re(Y);if(S.match(/(^|\s)__\w/))return de(Y);if(S.match(/(^|\s)_\w/))return be(Y);if(S.match(/(^|\s)\[.*\]\(\w*/))return Se(Y);if(S.match(/(^|\s)\[\w/))return Le(Y)}}function ue(Y){let V,G;for(V=0;V<Y.length;V++){const S=Y[V];if(S.type==="paragraph"&&S.raw.match(/(\n|^)```/)){G=oe(Y.slice(V));break}if(S.type==="paragraph"&&S.raw.match(/(\n|^)\|/)){G=ce(Y.slice(V));break}if(V===Y.length-1&&S.type==="paragraph"){const Q=ee(S);if(Q){G=[Q];break}}}if(G){const S=[...Y.slice(0,V),...G];return S.links=Y.links,S}return Y}t.$hR=ue;function oe(Y){const V=Z(Y);return h.marked.lexer(V+"\n```")}function se(Y){return ie(Y,"`")}function re(Y){return ie(Y,"*")}function be(Y){return ie(Y,"_")}function Se(Y){return ie(Y,")")}function Le(Y){return ie(Y,"](about:blank)")}function Fe(Y){return ie(Y,"**")}function de(Y){return ie(Y,"__")}function ie(Y,V){const G=Z(Array.isArray(Y)?Y:[Y]);return h.marked.lexer(G+V)[0]}function ce(Y){const V=Z(Y),G=V.split(`
`);let S,Q=!1;for(let b=0;b<G.length;b++){const R=G[b].trim();if(typeof S>"u"&&R.match(/^\s*\|/)){const B=R.match(/(\|[^\|]+)(?=\||$)/g);B&&(S=B.length)}else if(typeof S=="number")if(R.match(/^\s*\|/)){if(b!==G.length-1)return;Q=!0}else return}if(typeof S=="number"&&S>0){const b=Q?G.slice(0,-1).join(`
`):V,R=!!b.match(/\|\s*$/),B=b+(R?"":"|")+`
|${" --- |".repeat(S)}`;return h.marked.lexer(B)}}}),define($e[124],pe([1,0,3,9,28,61,34,2,7,105]),function(le,t,w,O,i,q,p,D,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DQ=t.$CQ=void 0;function m(o,e){(0,c.$yf)(e)?o.title=(0,p.$Yj)(e):e?.markdownNotSupportedFallback?o.title=e.markdownNotSupportedFallback:o.removeAttribute("title")}t.$CQ=m;class L{constructor(e,a,h){this.c=e,this.d=a,this.f=h}async update(e,a,h){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let $;if(e===void 0||(0,c.$yf)(e)||e instanceof HTMLElement)$=e;else if(!(0,c.$Mf)(e.markdown))$=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,f.localize)(0,null),a),this.b=new i.$Xd;const s=this.b.token;if($=await e.markdown(s),$===void 0&&($=e.markdownNotSupportedFallback),this.isDisposed||s.isCancellationRequested)return}this.g($,a,h)}g(e,a,h){const $=this.a;if(this.h(e)){const s={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!$,...h};this.a=this.c.showHover(s,a)}$?.dispose()}h(e){return e?(0,q.$5j)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function n(o,e,a,h){let $,s;const u=(I,T)=>{const g=s!==void 0;I&&(s?.dispose(),s=void 0),T&&($?.dispose(),$=void 0),g&&o.onDidHideHover?.()},d=(I,T,g)=>new O.$4g(async()=>{(!s||s.isDisposed)&&(s=new L(o,g||e,I>0),await s.update(a,T,h))},I),l=()=>{if($)return;const I=new D.$Qc,T=z=>u(!1,z.fromElement===e);I.add(w.$PO(e,w.$EP.MOUSE_LEAVE,T,!0));const g=()=>u(!0,!0);I.add(w.$PO(e,w.$EP.MOUSE_DOWN,g,!0));const v={targetElements:[e],dispose:()=>{}};if(o.placement===void 0||o.placement==="mouse"){const z=H=>{v.x=H.x+10,H.target instanceof HTMLElement&&H.target.classList.contains("action-label")&&u(!0,!0)};I.add(w.$PO(e,w.$EP.MOUSE_MOVE,z,!0))}I.add(d(o.delay,!1,v)),$=I},r=w.$PO(e,w.$EP.MOUSE_OVER,l,!0);return{show:I=>{u(!1,!0),d(0,I)},hide:()=>{u(!0,!0)},update:async(I,T)=>{a=I,await s?.update(a,void 0,T)},dispose:()=>{r.dispose(),u(!0,!0)}}}t.$DQ=n}),define($e[125],pe([1,0,3,21,14,123,38,11,4,43,2,5,107,98]),function(le,t,w,O,i,q,p,D,c,f,m,L,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iR=void 0;const o=w.$,e="selectOption.entry.template";class a{get templateId(){return e}renderTemplate(s){const u=Object.create(null);return u.root=s,u.text=w.$LP(s,o(".option-text")),u.detail=w.$LP(s,o(".option-detail")),u.decoratorRight=w.$LP(s,o(".option-decorator-right")),u}renderElement(s,u,d){const l=d,r=s.text,y=s.detail,I=s.decoratorRight,T=s.isDisabled;l.text.textContent=r,l.detail.textContent=y||"",l.decoratorRight.innerText=I||"",T?l.root.classList.add("option-disabled"):l.root.classList.remove("option-disabled")}disposeTemplate(s){}}class h extends m.$Rc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(s,u,d,l,r){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=l,this.g=r||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=h.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new c.$Nd,this.B(this.r),this.O(),this.N(d),this.n=u||0,s&&this.setOptions(s,u),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(s){this.u=s,this.w=w.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=w.$LP(this.w,o(".select-box-details-pane"));const u=w.$LP(this.w,o(".select-box-dropdown-container-width-control")),d=w.$LP(u,o(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",w.$LP(d,this.D),this.G=0,this.y=w.$tP(this.w),this.w.setAttribute("draggable","true"),this.B(w.$PO(this.w,w.$EP.DRAG_START,l=>{w.$GP.stop(l,!0)}))}O(){this.B(w.$QO(this.h,"change",u=>{this.n=u.target.selectedIndex,this.r.fire({index:u.target.selectedIndex,selected:u.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(w.$PO(this.h,w.$EP.CLICK,u=>{w.$GP.stop(u),this.f?this.X(!0):this.W()})),this.B(w.$PO(this.h,w.$EP.MOUSE_DOWN,u=>{w.$GP.stop(u)}));let s;this.B(w.$PO(this.h,"touchstart",u=>{s=this.f})),this.B(w.$PO(this.h,"touchend",u=>{w.$GP.stop(u),s?this.X(!0):this.W()})),this.B(w.$PO(this.h,w.$EP.KEY_DOWN,u=>{const d=new i.$MO(u);let l=!1;L.$k?(d.keyCode===18||d.keyCode===16||d.keyCode===10||d.keyCode===3)&&(l=!0):(d.keyCode===18&&d.altKey||d.keyCode===16&&d.altKey||d.keyCode===10||d.keyCode===3)&&(l=!0),l&&(this.W(),w.$GP.stop(u,!0))}))}get onDidSelect(){return this.r.event}setOptions(s,u){D.$tb(this.m,s)||(this.m=s,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((d,l)=>{this.h.add(this.U(d.text,l,d.isDisabled)),typeof d.description=="string"&&(this.H=!0)})),u!==void 0&&(this.select(u),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(s){s>=0&&s<this.m.length?this.n=s:s>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(s){this.g.ariaLabel=s,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(s){this.h.tabIndex=s?0:-1}render(s){this.j=s,s.classList.add("select-container"),s.appendChild(this.h),this.R()}Q(){const s=[];this.s.listFocusBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(s.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=s.join(`
`)}R(){const s=this.s.selectBackground??"",u=this.s.selectForeground??"",d=this.s.selectBorder??"";this.h.style.backgroundColor=s,this.h.style.color=u,this.h.style.borderColor=d}S(){const s=this.s.selectBackground??"",u=w.$4P(this.s.selectListBackground,s);this.C.style.backgroundColor=u,this.I.style.backgroundColor=u;const d=this.s.focusBorder??"";this.w.style.outlineColor=d,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(s,u,d){const l=document.createElement("option");return l.value=s,l.text=s,l.disabled=!!d,l}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:s=>this.Y(s,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:s=>this.Y(s),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(s){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),s&&this.h.focus(),this.u.hideContextView())}Y(s,u){return s.appendChild(this.w),this.ab(u),{dispose:()=>{try{s.removeChild(this.w)}catch{}}}}Z(){let s=0;return this.m.forEach((u,d)=>{this.hb(d),this.I.offsetHeight>s&&(s=this.I.offsetHeight)}),s}ab(s){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const u=w.$rP(this.h),d=w.$8O(this.h),l=getComputedStyle(this.h),r=parseFloat(l.getPropertyValue("--dropdown-padding-top"))+parseFloat(l.getPropertyValue("--dropdown-padding-bottom")),y=u.innerHeight-d.top-d.height-(this.g.minBottomMargin||0),I=d.top-h.b,T=this.h.offsetWidth,g=this.bb(this.D),v=Math.max(g,Math.round(T)).toString()+"px";this.w.style.width=v,this.z.getHTMLElement().style.height="",this.z.layout();let z=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const H=this.H?this.L:0,_=z+r+H,M=Math.floor((y-r-H)/this.getHeight()),F=Math.floor((I-r-H)/this.getHeight());if(s)return d.top+d.height>u.innerHeight-22||d.top<h.b||M<1&&F<1?!1:(M<h.c&&F>M&&this.m.length>M?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(d.top+d.height>u.innerHeight-22||d.top<h.b||this.G===0&&M<1||this.G===1&&F<1)return this.X(!0),!1;if(this.G===0){if(this.f&&M+F<1)return this.X(!0),!1;_>y&&(z=M*this.getHeight())}else _>I&&(z=F*this.getHeight());return this.z.layout(z),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=z+r+"px",this.w.style.height=""):this.w.style.height=z+r+"px",this.hb(this.n),this.w.style.width=v,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(s){let u=0;if(s){let d=0,l=0;this.m.forEach((r,y)=>{const I=r.detail?r.detail.length:0,T=r.decoratorRight?r.decoratorRight.length:0,g=r.text.length+I+T;g>l&&(d=y,l=g)}),s.textContent=this.m[d].text+(this.m[d].decoratorRight?this.m[d].decoratorRight+" ":""),u=w.$0O(s)}return u}cb(s){if(this.z)return;this.C=w.$LP(s,o(".select-box-dropdown-list-container")),this.t=new a,this.z=new p.$aR("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:l=>{let r=l.text;return l.detail&&(r+=`. ${l.detail}`),l.decoratorRight&&(r+=`. ${l.decoratorRight}`),l.description&&(r+=`. ${l.description}`),r},getWidgetAriaLabel:()=>(0,n.localize)(0,null),getRole:()=>L.$k?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const u=this.B(new O.$MQ(this.C,"keydown")),d=c.Event.chain(u.event,l=>l.filter(()=>this.z.length>0).map(r=>new i.$MO(r)));this.B(c.Event.chain(d,l=>l.filter(r=>r.keyCode===3))(this.jb,this)),this.B(c.Event.chain(d,l=>l.filter(r=>r.keyCode===2))(this.jb,this)),this.B(c.Event.chain(d,l=>l.filter(r=>r.keyCode===9))(this.ib,this)),this.B(c.Event.chain(d,l=>l.filter(r=>r.keyCode===16))(this.lb,this)),this.B(c.Event.chain(d,l=>l.filter(r=>r.keyCode===18))(this.kb,this)),this.B(c.Event.chain(d,l=>l.filter(r=>r.keyCode===12))(this.nb,this)),this.B(c.Event.chain(d,l=>l.filter(r=>r.keyCode===11))(this.mb,this)),this.B(c.Event.chain(d,l=>l.filter(r=>r.keyCode===14))(this.ob,this)),this.B(c.Event.chain(d,l=>l.filter(r=>r.keyCode===13))(this.pb,this)),this.B(c.Event.chain(d,l=>l.filter(r=>r.keyCode>=21&&r.keyCode<=56||r.keyCode>=85&&r.keyCode<=113))(this.qb,this)),this.B(w.$PO(this.z.getHTMLElement(),w.$EP.POINTER_UP,l=>this.db(l))),this.B(this.z.onMouseOver(l=>typeof l.index<"u"&&this.z.setFocus([l.index]))),this.B(this.z.onDidChangeFocus(l=>this.gb(l))),this.B(w.$PO(this.w,w.$EP.FOCUS_OUT,l=>{!this.f||w.$dP(l.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(s){if(!this.z.length)return;w.$GP.stop(s);const u=s.target;if(!u||u.classList.contains("slider"))return;const d=u.closest(".monaco-list-row");if(!d)return;const l=Number(d.getAttribute("data-index")),r=d.classList.contains("option-disabled");l>=0&&l<this.m.length&&!r&&(this.n=l,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(s,u){const d=r=>{for(let y=0;y<r.childNodes.length;y++){const I=r.childNodes.item(y);(I.tagName&&I.tagName.toLowerCase())==="img"?r.removeChild(I):d(I)}},l=(0,q.$dR)({value:s,supportThemeIcons:!0},{actionHandler:u});return l.element.classList.add("select-box-description-markdown"),d(l.element),l.element}gb(s){!this.f||!this.H||this.hb(s.indexes[0])}hb(s){this.I.innerText="";const u=this.m[s],d=u?.description??"",l=u?.descriptionIsMarkdown??!1;if(d){if(l){const r=u.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(d,r))}else this.I.innerText=d;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(s){w.$GP.stop(s),this.select(this.F),this.X(!0)}jb(s){w.$GP.stop(s),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(s){if(this.n<this.m.length-1){w.$GP.stop(s,!0);const u=this.m[this.n+1].isDisabled;if(u&&this.m.length>this.n+2)this.n+=2;else{if(u)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(s){this.n>0&&(w.$GP.stop(s,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(s){w.$GP.stop(s),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(s){w.$GP.stop(s),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(s){w.$GP.stop(s),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(s){w.$GP.stop(s),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(s){const u=f.KeyCodeUtils.toString(s.keyCode);let d=-1;for(let l=0;l<this.m.length-1;l++)if(d=(l+this.n+1)%this.m.length,this.m[d].text.charAt(0).toUpperCase()===u&&!this.m[d].isDisabled){this.select(d),this.z.setFocus([d]),this.z.reveal(this.z.getFocus()[0]),w.$GP.stop(s);break}}dispose(){this.X(!1),super.dispose()}}t.$iR=h}),define($e[126],pe([1,0,38,125,119,20,5,97]),function(le,t,w,O,i,q,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lR=t.$kR=void 0,t.$kR={...w.$_Q,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class D extends q.$mQ{constructor(f,m,L,n,o){super(),p.$k&&!o?.useCustomDrawn?this.a=new i.$jR(f,m,n,o):this.a=new O.$iR(f,m,L,n,o),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(f,m){this.a.setOptions(f,m)}select(f){this.a.select(f)}setAriaLabel(f){this.a.setAriaLabel(f)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(f){this.a.setFocusable(f)}render(f){this.a.render(f)}}t.$lR=D}),define($e[62],pe([1,0,16,53,3,23,124,126,35,2,5,7,102,51]),function(le,t,w,O,i,q,p,D,c,f,m,L,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sR=t.$rR=t.$qR=void 0;class o extends f.$Rc{get action(){return this._action}constructor($,s,u={}){super(),this.m=u,this._context=$||this,this._action=s,s instanceof c.$ui&&this.B(s.onDidChange(d=>{this.element&&this.t(d)}))}t($){$.enabled!==void 0&&this.u(),$.checked!==void 0&&this.G(),$.class!==void 0&&this.F(),$.label!==void 0&&(this.w(),this.C()),$.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new c.$vi)),this.j}set actionRunner($){this.j=$}isEnabled(){return this._action.enabled}setActionContext($){this._context=$}render($){const s=this.element=$;this.B(q.$iQ.addTarget($));const u=this.m&&this.m.draggable;u&&($.draggable=!0,w.$vO&&this.B((0,i.$PO)($,i.$EP.DRAG_START,d=>d.dataTransfer?.setData(O.$gQ.TEXT,this._action.label)))),this.B((0,i.$PO)(s,q.EventType.Tap,d=>this.onClick(d,!0))),this.B((0,i.$PO)(s,i.$EP.MOUSE_DOWN,d=>{u||i.$GP.stop(d,!0),this._action.enabled&&d.button===0&&s.classList.add("active")})),m.$k&&this.B((0,i.$PO)(s,i.$EP.CONTEXT_MENU,d=>{d.button===0&&d.ctrlKey===!0&&this.onClick(d)})),this.B((0,i.$PO)(s,i.$EP.CLICK,d=>{i.$GP.stop(d,!0),this.m&&this.m.isMenu||this.onClick(d)})),this.B((0,i.$PO)(s,i.$EP.DBLCLICK,d=>{i.$GP.stop(d,!0)})),[i.$EP.MOUSE_UP,i.$EP.MOUSE_OUT].forEach(d=>{this.B((0,i.$PO)(s,d,l=>{i.$GP.stop(l),s.classList.remove("active")}))})}onClick($,s=!1){i.$GP.stop($,!0);const u=L.$Hf(this._context)?this.m?.useEventAsContext?$:{preserveFocus:s}:this._context;this.actionRunner.run(this._action,u)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable($){this.element&&(this.element.tabIndex=$?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const $=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update($):(this.f=(0,p.$DQ)(this.m.hoverDelegate,this.element,$),this.q.add(this.f))):this.element.title=$}D(){if(this.element){const $=this.z()??"";this.element.setAttribute("aria-label",$)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$qR=o;class e extends o{constructor($,s,u){super($,s,u),this.m=u,this.m.icon=u.icon!==void 0?u.icon:!1,this.m.label=u.label!==void 0?u.label:!0,this.J=""}render($){super.render($),L.$If(this.element);const s=document.createElement("a");if(s.classList.add("action-label"),s.setAttribute("role",this.L()),this.H=s,this.element.appendChild(s),this.m.label&&this.m.keybinding){const u=document.createElement("span");u.classList.add("keybinding"),u.textContent=this.m.keybinding,this.element.appendChild(u)}this.F(),this.w(),this.C(),this.u(),this.G()}L(){return this._action.id===c.$wi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.H&&(this.H.tabIndex=0,this.H.focus())}isFocused(){return!!this.H&&this.H?.tabIndex===0}blur(){this.H&&(this.H.tabIndex=-1)}setFocusable($){this.H&&(this.H.tabIndex=$?0:-1)}w(){this.m.label&&this.H&&(this.H.textContent=this.action.label)}z(){let $=null;return this.action.tooltip?$=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&($=this.action.label,this.m.keybinding&&($=n.localize(0,null,$,this.m.keybinding))),$??void 0}F(){this.J&&this.H&&this.H.classList.remove(...this.J.split(" ")),this.m.icon?(this.J=this.action.class,this.H&&(this.H.classList.add("codicon"),this.J&&this.H.classList.add(...this.J.split(" "))),this.u()):this.H?.classList.remove("codicon")}u(){this.action.enabled?(this.H&&(this.H.removeAttribute("aria-disabled"),this.H.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.H&&(this.H.setAttribute("aria-disabled","true"),this.H.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.H){const $=this.z()??"";this.H.setAttribute("aria-label",$)}}G(){this.H&&(this.action.checked!==void 0?(this.H.classList.toggle("checked",this.action.checked),this.H.setAttribute("aria-checked",this.action.checked?"true":"false"),this.H.setAttribute("role","checkbox")):(this.H.classList.remove("checked"),this.H.setAttribute("aria-checked",""),this.H.setAttribute("role",this.L())))}}t.$rR=e;class a extends o{constructor($,s,u,d,l,r,y){super($,s),this.b=new D.$lR(u,d,l,r,y),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions($,s){this.b.setOptions($,s)}select($){this.b.select($)}g(){this.B(this.b.onDidSelect($=>this.n($.selected,$.index)))}n($,s){this.actionRunner.run(this._action,this.r($,s))}r($,s){return $}setFocusable($){this.b.setFocusable($)}focus(){this.b?.focus()}blur(){this.b?.blur()}render($){this.b.render($)}}t.$sR=a}),define($e[63],pe([1,0,3,14,62,35,4,2,7,51]),function(le,t,w,O,i,q,p,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FQ=t.$EQ=t.ActionsOrientation=void 0;var f;(function(n){n[n.HORIZONTAL=0]="HORIZONTAL",n[n.VERTICAL=1]="VERTICAL"})(f||(t.ActionsOrientation=f={}));class m extends D.$Rc{constructor(o,e={}){super(),this.g=this.B(new D.$Qc),this.r=this.B(new D.$Zc),this.w=!1,this.y=!0,this.C=this.B(new p.$Nd),this.onDidBlur=this.C.event,this.D=this.B(new p.$Nd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new p.$Nd),this.onDidRun=this.G.event,this.H=this.B(new p.$Nd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new q.$vi,this.g.add(this.f)),this.g.add(this.f.onDidRun($=>this.G.fire($))),this.g.add(this.f.onWillRun($=>this.H.fire($))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let a,h;switch(this.m){case 0:a=[15],h=[17];break;case 1:a=[16],h=[18],this.domNode.className+=" vertical";break}this.B(w.$PO(this.domNode,w.$EP.KEY_DOWN,$=>{const s=new O.$MO($);let u=!0;const d=typeof this.t=="number"?this.viewItems[this.t]:void 0;a&&(s.equals(a[0])||s.equals(a[1]))?u=this.P():h&&(s.equals(h[0])||s.equals(h[1]))?u=this.O():s.equals(9)&&this.F?this.D.fire():s.equals(14)?u=this.M():s.equals(13)?u=this.N():s.equals(2)&&d instanceof i.$qR&&d.trapsArrowNavigation?u=this.O():this.J(s)?this.n.keyDown?this.R(s):this.w=!0:u=!1,u&&(s.preventDefault(),s.stopPropagation())})),this.B(w.$PO(this.domNode,w.$EP.KEY_UP,$=>{const s=new O.$MO($);this.J(s)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(s)),s.preventDefault(),s.stopPropagation()):(s.equals(2)||s.equals(1026))&&this.L()})),this.u=this.B(w.$JP(this.domNode)),this.B(this.u.onDidBlur(()=>{(w.$lP()===this.domNode||!w.$dP(w.$lP(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),o.appendChild(this.domNode)}I(){this.length()>=2?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(o){o?this.z.setAttribute("aria-label",o):this.z.removeAttribute("aria-label")}setFocusable(o){if(this.y=o,this.y){const e=this.viewItems.find(a=>a instanceof i.$qR&&a.isEnabled());e instanceof i.$qR&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$qR&&e.setFocusable(!1)})}J(o){let e=!1;return this.n.keys.forEach(a=>{e=e||o.equals(a)}),e}L(){for(let o=0;o<this.z.children.length;o++){const e=this.z.children[o];if(w.$dP(w.$lP(),e)){this.t=o;break}}}get context(){return this.j}set context(o){this.j=o,this.viewItems.forEach(e=>e.setActionContext(o))}get actionRunner(){return this.f}set actionRunner(o){this.f=o,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=o)}getContainer(){return this.domNode}hasAction(o){return this.viewItems.findIndex(e=>e.action.id===o.id)!==-1}getAction(o){if(typeof o=="number")return this.viewItems[o]?.action;if(o instanceof HTMLElement){for(;o.parentElement!==this.z;){if(!o.parentElement)return;o=o.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===o)return this.viewItems[e].action}}push(o,e={}){const a=Array.isArray(o)?o:[o];let h=c.$Cf(e.index)?e.index:null;a.forEach($=>{const s=document.createElement("li");s.className="action-item",s.setAttribute("role","presentation");let u;const d={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(u=this.b.actionViewItemProvider($,d)),u||(u=new i.$rR(this.context,$,d)),this.b.allowContextMenu||this.r.set(u,w.$PO(s,w.$EP.CONTEXT_MENU,l=>{w.$GP.stop(l,!0)})),u.actionRunner=this.f,u.setActionContext(this.context),u.render(s),this.y&&u instanceof i.$qR&&this.viewItems.length===0&&u.setFocusable(!0),h===null||h<0||h>=this.z.children.length?(this.z.appendChild(s),this.viewItems.push(u)):(this.z.insertBefore(s,this.z.children[h]),this.viewItems.splice(h,0,u),h++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(o){if(o>=0&&o<this.z.children.length){const e=this.z.children.item(o);if(e)return e.clientWidth}return 0}getHeight(o){if(o>=0&&o<this.z.children.length){const e=this.z.children.item(o);if(e)return e.clientHeight}return 0}pull(o){o>=0&&o<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[o]),this.r.deleteAndDispose(this.viewItems[o]),(0,D.$Mc)(this.viewItems.splice(o,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,D.$Mc)(this.viewItems),this.r.clearAndDisposeAll(),w.$OO(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(o){let e=!1,a;if(o===void 0?e=!0:typeof o=="number"?a=o:typeof o=="boolean"&&(e=o),e&&typeof this.t>"u"){const h=this.viewItems.findIndex($=>$.isEnabled());this.t=h===-1?void 0:h,this.Q(void 0,void 0,!0)}else a!==void 0&&(this.t=a),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(o){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let a;do{if(!o&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,a=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===q.$wi.ID));return this.Q(),!0}P(o){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let a;do{if(this.t=this.t-1,this.t<0){if(!o&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}a=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===q.$wi.ID));return this.Q(!0),!0}Q(o,e,a=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const h=this.t!==void 0&&this.viewItems[this.t];if(h){let $=!0;c.$Mf(h.focus)||($=!1),this.b.focusOnlyEnabledItems&&c.$Mf(h.isEnabled)&&!h.isEnabled()&&($=!1),h.action.id===q.$wi.ID&&($=!1),$?(a||this.s!==this.t)&&(h.focus(o),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(o){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof i.$qR){const a=e._context===null||e._context===void 0?o:e._context;this.run(e._action,a)}}async run(o,e){await this.f.run(o,e)}dispose(){this.j=void 0,this.viewItems=(0,D.$Mc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$EQ=m;function L(n){if(!n.length)return n;let o=-1;for(let a=0;a<n.length;a++)if(n[a].id!==q.$wi.ID){o=a;break}if(o===-1)return[];n=n.slice(o);for(let a=n.length-1;a>=0&&n[a].id===q.$wi.ID;a--)n.splice(a,1);let e=!1;for(let a=n.length-1;a>=0;a--){const h=n[a].id===q.$wi.ID;h&&!e?n.splice(a,1):h?h&&(e=!1):e=!0}return n}t.$FQ=L}),define($e[64],pe([1,0,3,21,54,63,56,59,20,4,80,50,106,94]),function(le,t,w,O,i,q,p,D,c,f,m,L,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0R=t.$9R=t.$8R=t.MessageType=void 0;const o=w.$;var e;(function($){$[$.INFO=1]="INFO",$[$.WARNING=2]="WARNING",$[$.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$8R={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class a extends c.$mQ{constructor(s,u,d){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new f.$Nd),this.onDidChange=this.O.event,this.P=this.B(new f.$Nd),this.onDidHeightChange=this.P.event,this.a=u,this.g=d,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=w.$LP(s,o(".monaco-inputbox.idle"));const l=this.g.flexibleHeight?"textarea":"input",r=w.$LP(this.element,o(".ibwrapper"));if(this.b=w.$LP(r,o(l+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=w.$LP(r,o("div.mirror")),this.y.innerText="\xA0",this.N=new D.$wQ(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),w.$LP(s,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(T=>this.b.scrollTop=T.scrollTop));const y=this.B(new O.$MQ(s.ownerDocument,"selectionchange")),I=f.Event.filter(y.event,()=>s.ownerDocument.getSelection()?.anchorNode===r);this.B(I(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new q.$EQ(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(s){this.n=s,this.b.setAttribute("placeholder",s)}setTooltip(s){this.r=s,this.b.title=s}setAriaLabel(s){this.s=s,s?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(s){this.b.value!==s&&(this.b.value=s,this.Y())}get step(){return this.b.step}set step(s){this.b.step=s}get height(){return typeof this.J=="number"?this.J:w.$bP(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return w.$mP(this.b)}select(s=null){this.b.select(),s&&(this.b.setSelectionRange(s.start,s.end),s.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(s){s?this.enable():this.disable()}get width(){return w.$0O(this.b)}set width(s){if(this.g.flexibleHeight&&this.g.flexibleWidth){let u=0;if(this.y){const d=parseFloat(this.y.style.paddingLeft||"")||0,l=parseFloat(this.y.style.paddingRight||"")||0;u=d+l}this.b.style.width=s-u+"px"}else this.b.style.width=s+"px";this.y&&(this.y.style.width=s+"px")}set paddingRight(s){this.b.style.width=`calc(100% - ${s}px)`,this.y&&(this.y.style.paddingRight=s+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const s=this.L,u=this.J,d=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:s,height:u}),this.N.setScrollPosition({scrollTop:d})}showMessage(s,u){if(this.w==="open"&&(0,L.$$m)(this.h,s))return;this.h=s,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(s.type));const d=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${w.$4P(d.border,"transparent")}`,this.h.content&&(this.hasFocus()||u)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let s=null;return this.t&&(s=this.t(this.value),s?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(s)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),s?.type}stylesForType(s){const u=this.g.inputBoxStyles;switch(s){case 1:return{border:u.inputValidationInfoBorder,background:u.inputValidationInfoBackground,foreground:u.inputValidationInfoForeground};case 2:return{border:u.inputValidationWarningBorder,background:u.inputValidationWarningBackground,foreground:u.inputValidationWarningForeground};default:return{border:u.inputValidationErrorBorder,background:u.inputValidationErrorBackground,foreground:u.inputValidationErrorForeground}}}U(s){switch(s){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let s;const u=()=>s.style.width=w.$0O(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:l=>{if(!this.h)return null;s=w.$LP(l,o(".monaco-inputbox-container")),u();const r={inline:!0,className:"monaco-inputbox-message"},y=this.h.formatContent?(0,i.$KQ)(this.h.content,r):(0,i.$JQ)(this.h.content,r);y.classList.add(this.U(this.h.type));const I=this.stylesForType(this.h.type);return y.style.backgroundColor=I.background??"",y.style.color=I.foreground??"",y.style.border=I.border?`1px solid ${I.border}`:"",w.$LP(s,y),null},onHide:()=>{this.w="closed"},layout:u});let d;this.h.type===3?d=n.localize(0,null,this.h.content):this.h.type===2?d=n.localize(1,null,this.h.content):d=n.localize(2,null,this.h.content),p.$OQ(d),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const s=this.value,d=s.charCodeAt(s.length-1)===10?" ":"";(s+d).replace(/\u000c/g,"")?this.y.textContent=s+d:this.y.innerText="\xA0",this.layout()}ab(){const s=this.g.inputBoxStyles,u=s.inputBackground??"",d=s.inputForeground??"",l=s.inputBorder??"";this.element.style.backgroundColor=u,this.element.style.color=d,this.b.style.backgroundColor="inherit",this.b.style.color=d,this.element.style.border=`1px solid ${w.$4P(l,"transparent")}`}layout(){if(!this.y)return;const s=this.L;this.L=w.$bP(this.y),s!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(s){const u=this.inputElement,d=u.selectionStart,l=u.selectionEnd,r=u.value;d!==null&&l!==null&&(this.value=r.substr(0,d)+s+r.substr(l),u.setSelectionRange(d+1,d+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$9R=a;class h extends a{constructor(s,u,d){const l=n.localize(3,null,"\u21C5"),r=n.localize(4,null,"\u21C5");super(s,u,d),this.db=this.B(new f.$Nd),this.onDidFocus=this.db.event,this.eb=this.B(new f.$Nd),this.onDidBlur=this.eb.event,this.bb=new m.$6R(d.history,100);const y=()=>{if(d.showHistoryHint&&d.showHistoryHint()&&!this.n.endsWith(l)&&!this.n.endsWith(r)&&this.bb.getHistory().length){const I=this.n.endsWith(")")?l:r,T=this.n+I;d.showPlaceholderOnFocus&&!w.$mP(this.b)?this.n=T:this.setPlaceHolder(T)}};this.cb=new MutationObserver((I,T)=>{I.forEach(g=>{g.target.textContent||y()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>y()),this.F(this.b,()=>{const I=T=>{if(this.n.endsWith(T)){const g=this.n.slice(0,this.n.length-T.length);return d.showPlaceholderOnFocus?this.n=g:this.setPlaceHolder(g),!0}else return!1};I(r)||I(l)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(s){this.value&&(s||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(s){const u=this.getHistory();this.clearHistory(),s.forEach(d=>{this.bb.add(d)}),u.forEach(d=>{this.bb.add(d)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let s=this.jb();s&&(s=s===this.value?this.jb():s),this.value=s??"",p.$PQ(this.value?this.value:n.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let s=this.ib();s&&(s=s===this.value?this.ib():s),s&&(this.value=s,p.$PQ(this.value))}clearHistory(){this.bb.clear()}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let s=this.bb.current();return s||(s=this.bb.last(),this.bb.next()),s}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$0R=h}),define($e[65],pe([1,0,62,20,17,18,4,3,99]),function(le,t,w,O,i,q,p,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pR=t.$oR=t.$nR=t.$mR=void 0,t.$mR={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class c extends w.$qR{constructor(n,o,e){super(n,o,e),this.a=this.B(new f({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:e.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:e.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:e.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(n){this.element=n,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$nR=c;class f extends O.$mQ{constructor(n){super(),this.a=this.B(new p.$Nd),this.onChange=this.a.event,this.b=this.B(new p.$Nd),this.onKeyDown=this.b.event,this.c=n,this.s=this.c.isChecked;const o=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,o.push(...q.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&o.push(...this.c.actionClassName.split(" ")),this.s&&o.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...o),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,e=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),e.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this.s,this.a.fire(!0),e.preventDefault(),e.stopPropagation();return}this.b.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(n){this.s=n,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(n){this.g&&this.domNode.classList.remove(...q.ThemeIcon.asClassNameArray(this.g)),this.g=n,this.g&&this.domNode.classList.add(...q.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(n){this.domNode.title=n,this.domNode.setAttribute("aria-label",n)}}t.$oR=f;class m extends O.$mQ{constructor(n,o,e){super(),this.c=n,this.g=o,this.a=new f({title:this.c,isChecked:this.g,icon:i.$Uj.check,actionClassName:"monaco-checkbox",...t.$mR}),this.domNode=this.a.domNode,this.b=e,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(n){this.a.checked=n,this.h()}focus(){this.domNode.focus()}hasFocus(){return(0,D.$mP)(this.domNode)}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$pR=m}),define($e[127],pe([1,0,65,17,104]),function(le,t,w,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kS=t.$jS=t.$iS=void 0;const q=i.localize(0,null),p=i.localize(1,null),D=i.localize(2,null);class c extends w.$oR{constructor(n){super({icon:O.$Uj.caseSensitive,title:q+n.appendTitle,isChecked:n.isChecked,inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.$iS=c;class f extends w.$oR{constructor(n){super({icon:O.$Uj.wholeWord,title:p+n.appendTitle,isChecked:n.isChecked,inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.$jS=f;class m extends w.$oR{constructor(n){super({icon:O.$Uj.regex,title:D+n.appendTitle,isChecked:n.isChecked,inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.$kS=m}),define($e[128],pe([1,0,3,127,64,20,4,103,2,93]),function(le,t,w,O,i,q,p,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lS=void 0;const f=D.localize(0,null);class m extends q.$mQ{static{this.OPTION_CHANGE="optionChange"}constructor(n,o,e){super(),this.n=!0,this.s=!1,this.w=this.B(new c.$Sc),this.N=[],this.O=this.B(new p.$Nd),this.onDidOptionChange=this.O.event,this.P=this.B(new p.$Nd),this.onKeyDown=this.P.event,this.Q=this.B(new p.$Nd),this.onMouseDown=this.Q.event,this.R=this.B(new p.$Nd),this.onInput=this.R.event,this.S=this.B(new p.$Nd),this.onKeyUp=this.S.event,this.U=this.B(new p.$Nd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new p.$Nd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||f,this.h=!!e.showCommonFindToggles;const a=e.appendCaseSensitiveLabel||"",h=e.appendWholeWordsLabel||"",$=e.appendRegexLabel||"",s=e.history||[],u=!!e.flexibleHeight,d=!!e.flexibleWidth,l=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$0R(this.domNode,o,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:s,showHistoryHint:e.showHistoryHint,flexibleHeight:u,flexibleWidth:d,flexibleMaxHeight:l,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new O.$kS({appendTitle:$,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(y=>{this.O.fire(y),!y&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(y=>{this.W.fire(y)})),this.L=this.B(new O.$jS({appendTitle:h,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(y=>{this.O.fire(y),!y&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new O.$iS({appendTitle:a,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(y=>{this.O.fire(y),!y&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(y=>{this.U.fire(y)}));const r=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,y=>{if(y.equals(15)||y.equals(17)||y.equals(9)){const I=r.indexOf(this.domNode.ownerDocument.activeElement);if(I>=0){let T=-1;y.equals(17)?T=(I+1)%r.length:y.equals(15)&&(I===0?T=r.length-1:T=I-1),y.equals(9)?(r[I].blur(),this.inputBox.focus()):T>=0&&r[T].focus(),w.$GP.stop(y,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),n?.appendChild(this.domNode),this.B(w.$PO(this.inputBox.inputElement,"compositionstart",r=>{this.s=!0})),this.B(w.$PO(this.inputBox.inputElement,"compositionend",r=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,r=>this.P.fire(r)),this.C(this.inputBox.inputElement,r=>this.S.fire(r)),this.D(this.inputBox.inputElement,r=>this.R.fire()),this.j(this.inputBox.inputElement,r=>this.Q.fire(r))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(n){this.inputBox.layout(),this.X(n.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const n of this.N)n.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const n of this.N)n.disable()}setFocusInputOnOptionClick(n){this.n=n}setEnabled(n){n?this.enable():this.disable()}setAdditionalToggles(n){for(const o of this.N)o.domNode.remove();this.N=[],this.w.value=new c.$Qc;for(const o of n??[])this.w.value.add(o),this.y.appendChild(o.domNode),this.w.value.add(o.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(o);this.N.length>0&&(this.y.style.display=""),this.X()}X(n=!1){n?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((o,e)=>o+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(n){this.inputBox.value!==n&&(this.inputBox.value=n)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(n){this.M&&(this.M.checked=n)}getWholeWords(){return this.L?.checked??!1}setWholeWords(n){this.L&&(this.L.checked=n)}getRegex(){return this.J?.checked??!1}setRegex(n){this.J&&(this.J.checked=n,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(n){this.inputBox.showMessage(n)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$lS=m}),define($e[129],pe([1,0,3,21,14,63,128,64,60,38,65,57,24,35,11,9,17,18,31,4,33,2,45,7,108,100]),function(le,t,w,O,i,q,p,D,c,f,m,L,n,o,e,a,h,$,s,u,d,l,r,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VS=t.TreeFindMatchType=t.TreeFindMode=t.$US=t.$TS=t.RenderIndentGuides=t.$SS=t.$RS=void 0;class T extends c.$ZQ{set context(b){this.c.context=b}get context(){return this.c.context}constructor(b){super(b.elements.map(R=>R.element)),this.c=b}}function g(Q){return Q instanceof c.$ZQ?new T(Q):Q}class v{constructor(b,R){this.d=b,this.f=R,this.b=l.$Rc.None,this.c=new l.$Qc}getDragURI(b){return this.f.getDragURI(b.element)}getDragLabel(b,R){if(this.f.getDragLabel)return this.f.getDragLabel(b.map(B=>B.element),R)}onDragStart(b,R){this.f.onDragStart?.(g(b),R)}onDragOver(b,R,B,N,A=!0){const k=this.f.onDragOver(g(b),R&&R.element,B,N),U=this.a!==R;if(U&&(this.b.dispose(),this.a=R),typeof R>"u")return k;if(U&&typeof k!="boolean"&&k.autoExpand&&(this.b=(0,a.$Vg)(()=>{const W=this.d(),x=W.getNodeLocation(R);W.isCollapsed(x)&&W.setCollapsed(x,!1),this.a=void 0},500,this.c)),typeof k=="boolean"||!k.accept||typeof k.bubble>"u"||k.feedback){if(!A){const W=typeof k=="boolean"?k:k.accept,x=typeof k=="boolean"?void 0:k.effect;return{accept:W,effect:x,feedback:[B]}}return k}if(k.bubble===1){const W=this.d(),x=W.getNodeLocation(R),te=W.getParentNodeLocation(x),ne=W.getNode(te),ge=te&&W.getListIndex(te);return this.onDragOver(b,ne,ge,N,!1)}const C=this.d(),j=C.getNodeLocation(R),E=C.getListIndex(j),P=C.getListRenderCount(j);return{...k,feedback:(0,e.$Rb)(E,E+P)}}drop(b,R,B,N){this.b.dispose(),this.a=void 0,this.f.drop(g(b),R&&R.element,B,N)}onDragEnd(b){this.f.onDragEnd?.(b)}dispose(){this.c.dispose(),this.f.dispose()}}function z(Q,b){return b&&{...b,identityProvider:b.identityProvider&&{getId(R){return b.identityProvider.getId(R.element)}},dnd:b.dnd&&new v(Q,b.dnd),multipleSelectionController:b.multipleSelectionController&&{isSelectionSingleChangeEvent(R){return b.multipleSelectionController.isSelectionSingleChangeEvent({...R,element:R.element})},isSelectionRangeChangeEvent(R){return b.multipleSelectionController.isSelectionRangeChangeEvent({...R,element:R.element})}},accessibilityProvider:b.accessibilityProvider&&{...b.accessibilityProvider,getSetSize(R){const B=Q(),N=B.getNodeLocation(R),A=B.getParentNodeLocation(N);return B.getNode(A).visibleChildrenCount},getPosInSet(R){return R.visibleChildIndex+1},isChecked:b.accessibilityProvider&&b.accessibilityProvider.isChecked?R=>b.accessibilityProvider.isChecked(R.element):void 0,getRole:b.accessibilityProvider&&b.accessibilityProvider.getRole?R=>b.accessibilityProvider.getRole(R.element):()=>"treeitem",getAriaLabel(R){return b.accessibilityProvider.getAriaLabel(R.element)},getWidgetAriaLabel(){return b.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:b.accessibilityProvider&&b.accessibilityProvider.getWidgetRole?()=>b.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:b.accessibilityProvider&&b.accessibilityProvider.getAriaLevel?R=>b.accessibilityProvider.getAriaLevel(R.element):R=>R.depth,getActiveDescendantId:b.accessibilityProvider.getActiveDescendantId&&(R=>b.accessibilityProvider.getActiveDescendantId(R.element))},keyboardNavigationLabelProvider:b.keyboardNavigationLabelProvider&&{...b.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(R){return b.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(R.element)}}}}class H{constructor(b){this.a=b}getHeight(b){return this.a.getHeight(b.element)}getTemplateId(b){return this.a.getTemplateId(b.element)}hasDynamicHeight(b){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(b.element)}setDynamicHeight(b,R){this.a.setDynamicHeight?.(b.element,R)}}t.$RS=H;class _{static lift(b){return b instanceof _?b:new _(b)}static empty(b=0){return new _({focus:[],selection:[],expanded:Object.create(null),scrollTop:b})}constructor(b){if(this.focus=new Set(b.focus),this.selection=new Set(b.selection),b.expanded instanceof Array){this.expanded=Object.create(null);for(const R of b.expanded)this.expanded[R]=1}else this.expanded=b.expanded;this.expanded=b.expanded,this.scrollTop=b.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$SS=_;var M;(function(Q){Q.None="none",Q.OnHover="onHover",Q.Always="always"})(M||(t.RenderIndentGuides=M={}));class F{get elements(){return this.b}constructor(b,R=[]){this.b=R,this.a=new l.$Qc,this.onDidChange=u.Event.forEach(b,B=>this.b=B,this.a)}dispose(){this.a.dispose()}}class Z{static{this.a=8}constructor(b,R,B,N,A,k={}){this.o=b,this.p=R,this.q=N,this.s=A,this.b=new Map,this.c=new Map,this.d=Z.a,this.f=!1,this.g=!1,this.j=new Set,this.k=l.$Rc.None,this.m=new l.$Qc,this.templateId=b.templateId,this.updateOptions(k),u.Event.map(B,U=>U.node)(this.u,this,this.m),b.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(b={}){if(typeof b.indent<"u"){const R=(0,r.$Ol)(b.indent,0,40);if(R!==this.d){this.d=R;for(const[B,N]of this.c)this.v(B,N)}}if(typeof b.renderIndentGuides<"u"){const R=b.renderIndentGuides!==M.None;if(R!==this.g){this.g=R;for(const[B,N]of this.c)this.w(B,N);if(this.k.dispose(),R){const B=new l.$Qc;this.q.onDidChange(this.x,this,B),this.k=B,this.x(this.q.elements)}}}typeof b.hideTwistiesOfChildlessElements<"u"&&(this.f=b.hideTwistiesOfChildlessElements)}renderTemplate(b){const R=(0,w.$LP)(b,(0,w.$)(".monaco-tl-row")),B=(0,w.$LP)(R,(0,w.$)(".monaco-tl-indent")),N=(0,w.$LP)(R,(0,w.$)(".monaco-tl-twistie")),A=(0,w.$LP)(R,(0,w.$)(".monaco-tl-contents")),k=this.o.renderTemplate(A);return{container:b,indent:B,twistie:N,indentGuidesDisposable:l.$Rc.None,templateData:k}}renderElement(b,R,B,N){this.c.set(b,B),this.b.set(b.element,b),this.v(b,B),this.o.renderElement(b,R,B.templateData,N)}disposeElement(b,R,B,N){B.indentGuidesDisposable.dispose(),this.o.disposeElement?.(b,R,B.templateData,N),typeof N=="number"&&(this.c.delete(b),this.b.delete(b.element))}disposeTemplate(b){this.o.disposeTemplate(b.templateData)}t(b){const R=this.b.get(b);R&&this.u(R)}u(b){const R=this.c.get(b);R&&(this.x(this.q.elements),this.v(b,R))}v(b,R){const B=Z.a+(b.depth-1)*this.d;R.twistie.style.paddingLeft=`${B}px`,R.indent.style.width=`${B+this.d-16}px`,b.collapsible?R.container.setAttribute("aria-expanded",String(!b.collapsed)):R.container.removeAttribute("aria-expanded"),R.twistie.classList.remove(...$.ThemeIcon.asClassNameArray(h.$Uj.treeItemExpanded));let N=!1;this.o.renderTwistie&&(N=this.o.renderTwistie(b.element,R.twistie)),b.collapsible&&(!this.f||b.visibleChildrenCount>0)?(N||R.twistie.classList.add(...$.ThemeIcon.asClassNameArray(h.$Uj.treeItemExpanded)),R.twistie.classList.add("collapsible"),R.twistie.classList.toggle("collapsed",b.collapsed)):R.twistie.classList.remove("collapsible","collapsed"),this.w(b,R)}w(b,R){if((0,w.$OO)(R.indent),R.indentGuidesDisposable.dispose(),!this.g)return;const B=new l.$Qc,N=this.p();for(;;){const A=N.getNodeLocation(b),k=N.getParentNodeLocation(A);if(!k)break;const U=N.getNode(k),C=(0,w.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(U)&&C.classList.add("active"),R.indent.childElementCount===0?R.indent.appendChild(C):R.indent.insertBefore(C,R.indent.firstElementChild),this.s.add(U,C),B.add((0,l.$Pc)(()=>this.s.delete(U,C))),b=U}R.indentGuidesDisposable=B}x(b){if(!this.g)return;const R=new Set,B=this.p();b.forEach(N=>{const A=B.getNodeLocation(N);try{const k=B.getParentNodeLocation(A);N.collapsible&&N.children.length>0&&!N.collapsed?R.add(N):k&&R.add(B.getNode(k))}catch{}}),this.j.forEach(N=>{R.has(N)||this.s.forEach(N,A=>A.classList.remove("active"))}),R.forEach(N=>{this.j.has(N)||this.s.forEach(N,A=>A.classList.add("active"))}),this.j=R}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,l.$Mc)(this.m)}}class ee{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(b){this.c=b,this.d=b.toLowerCase()}constructor(b,R,B){this.g=b,this.j=R,this.k=B,this.a=0,this.b=0,this.c="",this.d="",this.f=new l.$Qc,b.onWillRefilter(this.m,this,this.f)}filter(b,R){let B=1;if(this.k){const k=this.k.filter(b,R);if(typeof k=="boolean"?B=k?1:0:(0,L.$OS)(k)?B=(0,L.$PS)(k.visibility):B=k,B===0)return!1}if(this.a++,!this.c)return this.b++,{data:d.FuzzyScore.Default,visibility:B};const N=this.j.getKeyboardNavigationLabel(b),A=Array.isArray(N)?N:[N];for(const k of A){const U=k&&k.toString();if(typeof U>"u")return{data:d.FuzzyScore.Default,visibility:B};let C;if(this.g.findMatchType===be.Contiguous){const j=U.toLowerCase().indexOf(this.d);if(j>-1){C=[Number.MAX_SAFE_INTEGER,0];for(let E=this.d.length;E>0;E--)C.push(j+E-1)}}else C=(0,d.$Pj)(this.c,this.d,0,U,U.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(C)return this.b++,A.length===1?{data:C,visibility:B}:{data:{label:U,score:C},visibility:B}}return this.g.findMode===re.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(b):2:{data:d.FuzzyScore.Default,visibility:B}}m(){this.a=0,this.b=0}dispose(){(0,l.$Mc)(this.f)}}class ue extends m.$oR{constructor(b){super({icon:h.$Uj.listFilter,title:(0,I.localize)(0,null),isChecked:b.isChecked??!1,inputActiveOptionBorder:b.inputActiveOptionBorder,inputActiveOptionForeground:b.inputActiveOptionForeground,inputActiveOptionBackground:b.inputActiveOptionBackground})}}t.$TS=ue;class oe extends m.$oR{constructor(b){super({icon:h.$Uj.searchFuzzy,title:(0,I.localize)(1,null),isChecked:b.isChecked??!1,inputActiveOptionBorder:b.inputActiveOptionBorder,inputActiveOptionForeground:b.inputActiveOptionForeground,inputActiveOptionBackground:b.inputActiveOptionBackground})}}t.$US=oe;const se={inputBoxStyles:D.$8R,toggleStyles:m.$mR,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var re;(function(Q){Q[Q.Highlight=0]="Highlight",Q[Q.Filter=1]="Filter"})(re||(t.TreeFindMode=re={}));var be;(function(Q){Q[Q.Fuzzy=0]="Fuzzy",Q[Q.Contiguous=1]="Contiguous"})(be||(t.TreeFindMatchType=be={}));class Se extends l.$Rc{set mode(b){this.b.checked=b===re.Filter,this.f.inputBox.setPlaceHolder(b===re.Filter?(0,I.localize)(2,null):(0,I.localize)(3,null))}set matchType(b){this.c.checked=b===be.Fuzzy}get value(){return this.f.inputBox.value}set value(b){this.f.inputBox.value=b}constructor(b,R,B,N,A,k){super(),this.t=R,this.a=(0,w.h)(".monaco-tree-type-filter",[(0,w.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,w.h)(".monaco-tree-type-filter-input@findInput"),(0,w.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new u.$Nd,this.onDidDisable=this._onDidDisable.event,b.appendChild(this.a.root),this.B((0,l.$Pc)(()=>b.removeChild(this.a.root)));const U=k?.styles??se;U.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=U.listFilterWidgetBackground),U.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${U.listFilterWidgetShadow}`),this.b=this.B(new ue({...U.toggleStyles,isChecked:N===re.Filter})),this.c=this.B(new oe({...U.toggleStyles,isChecked:A===be.Fuzzy})),this.onDidChangeMode=u.Event.map(this.b.onChange,()=>this.b.checked?re.Filter:re.Highlight,this.q),this.onDidChangeMatchType=u.Event.map(this.c.onChange,()=>this.c.checked?be.Fuzzy:be.Contiguous,this.q),this.f=this.B(new p.$lS(this.a.findInput,B,{label:(0,I.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:U.inputBoxStyles,toggleStyles:U.toggleStyles,history:k?.history})),this.g=this.B(new q.$EQ(this.a.actionbar)),this.mode=N;const C=this.B(new O.$MQ(this.f.inputBox.inputElement,"keydown")),j=u.Event.chain(C.event,x=>x.map(te=>new i.$MO(te)));this.B(j(x=>{if(x.equals(3)){x.preventDefault(),x.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(x.equals(18)){x.preventDefault(),x.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(x.equals(16)){x.preventDefault(),x.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const E=this.B(new o.$ui("close",(0,I.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(E,{icon:!0,label:!1});const P=this.B(new O.$MQ(this.a.grab,"mousedown"));this.B(P.event(x=>{const te=new l.$Qc,ne=te.add(new O.$MQ((0,w.$rP)(x),"mousemove")),ge=te.add(new O.$MQ((0,w.$rP)(x),"mouseup")),ve=this.m,Ce=x.pageX,Ae=this.s,De=x.pageY;this.a.grab.classList.add("grabbing");const Me=this.a.root.style.transition;this.a.root.style.transition="unset";const Oe=_e=>{const je=_e.pageX-Ce;this.m=ve-je;const Re=_e.pageY-De;this.s=Ae+Re,this.layout()};te.add(ne.event(Oe)),te.add(ge.event(_e=>{Oe(_e),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Me,te.dispose()}))}));const W=u.Event.chain(this.B(new O.$MQ(this.a.grab,"keydown")).event,x=>x.map(te=>new i.$MO(te)));this.B(W(x=>{let te,ne;if(x.keyCode===15?te=Number.POSITIVE_INFINITY:x.keyCode===17?te=0:x.keyCode===10&&(te=this.m===0?Number.POSITIVE_INFINITY:0),x.keyCode===16?ne=0:x.keyCode===18&&(ne=Number.POSITIVE_INFINITY),te!==void 0&&(x.preventDefault(),x.stopPropagation(),this.m=te,this.layout()),ne!==void 0){x.preventDefault(),x.stopPropagation(),this.s=ne;const ge=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=ge},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(b=this.j){this.j=b,this.m=(0,r.$Ol)(this.m,0,Math.max(0,b-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,r.$Ol)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(b){this.f.showMessage(b)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,a.$Ug)(300),super.dispose()}}class Le{get pattern(){return this.b}get mode(){return this.d}set mode(b){b!==this.d&&(this.d=b,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(b))}get matchType(){return this.f}set matchType(b){b!==this.f&&(this.f=b,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(b))}constructor(b,R,B,N,A,k={}){this.t=b,this.u=B,this.v=N,this.w=A,this.x=k,this.b="",this.c="",this.j=0,this.k=new u.$Nd,this.onDidChangeMode=this.k.event,this.m=new u.$Nd,this.onDidChangeMatchType=this.m.event,this.o=new u.$Nd,this.onDidChangePattern=this.o.event,this.p=new u.$Nd,this.onDidChangeOpenState=this.p.event,this.q=new l.$Qc,this.s=new l.$Qc,this.d=b.options.defaultFindMode??re.Highlight,this.f=b.options.defaultFindMatchType??be.Fuzzy,R.onDidSplice(this.z,this,this.s)}updateOptions(b={}){b.defaultFindMode!==void 0&&(this.mode=b.defaultFindMode),b.defaultFindMatchType!==void 0&&(this.matchType=b.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Se(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(b=>this.mode=b,void 0,this.q),this.g.onDidChangeMatchType(b=>this.matchType=b,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(b){this.b=b,this.o.fire(b),this.v.pattern=b,this.t.refilter(),b&&this.t.focusNext(0,!0,void 0,B=>!d.FuzzyScore.isDefault(B.filterData));const R=this.t.getFocus();if(R.length>0){const B=R[0];this.t.getRelativeTop(B)===null&&this.t.reveal(B,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const b=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&b?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,I.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(b){return!this.g||!this.pattern||this.d===re.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!d.FuzzyScore.isDefault(b.filterData)}layout(b){this.j=b,this.g?.layout(b)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Fe(Q){let b=n.TreeMouseEventTarget.Unknown;return(0,w.$hP)(Q.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?b=n.TreeMouseEventTarget.Twistie:(0,w.$hP)(Q.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?b=n.TreeMouseEventTarget.Element:(0,w.$hP)(Q.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(b=n.TreeMouseEventTarget.Filter),{browserEvent:Q.browserEvent,element:Q.element?Q.element.element:null,target:b}}function de(Q){return{element:Q.element?Q.element.element:null,browserEvent:Q.browserEvent,anchor:Q.anchor}}function ie(Q,b){b(Q),Q.children.forEach(R=>ie(R,b))}class ce{get f(){return this.d||(this.d=this.m()),this.d}constructor(b,R){this.g=b,this.j=R,this.a=[],this.c=new u.$Nd,this.onDidChange=this.c.event}set(b,R){!R?.__forceEvent&&(0,e.$tb)(this.a,b)||this.k(b,!1,R)}k(b,R,B){if(this.a=[...b],this.b=void 0,this.d=void 0,!R){const N=this;this.c.fire({get elements(){return N.get()},browserEvent:B})}}get(){return this.b||(this.b=this.a.map(b=>b.element)),[...this.b]}getNodes(){return this.a}has(b){return this.f.has(b)}onDidModelSplice({insertedNodes:b,deletedNodes:R}){if(!this.j){const C=this.m(),j=E=>C.delete(E);R.forEach(E=>ie(E,j)),this.set([...C.values()]);return}const B=new Set,N=C=>B.add(this.j.getId(C.element).toString());R.forEach(C=>ie(C,N));const A=new Map,k=C=>A.set(this.j.getId(C.element).toString(),C);b.forEach(C=>ie(C,k));const U=[];for(const C of this.a){const j=this.j.getId(C.element).toString();if(!B.has(j))U.push(C);else{const P=A.get(j);P&&P.visible&&U.push(P)}}if(this.a.length>0&&U.length===0){const C=this.g();C&&U.push(C)}this.k(U,!0)}m(){const b=new Set;for(const R of this.a)b.add(R);return b}}class Y extends f.$0Q{constructor(b,R){super(b),this.x=R}u(b){if((0,f.$6Q)(b.browserEvent.target)||(0,f.$4Q)(b.browserEvent.target)||(0,f.$5Q)(b.browserEvent.target)||b.browserEvent.isHandledByList)return;const R=b.element;if(!R)return super.u(b);if(this.p(b)||this.o(b))return super.u(b);const B=b.browserEvent.target,N=B.classList.contains("monaco-tl-twistie")||B.classList.contains("monaco-icon-label")&&B.classList.contains("folder-icon")&&b.browserEvent.offsetX<16;let A=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?A=this.x.expandOnlyOnTwistieClick(R.element):A=!!this.x.expandOnlyOnTwistieClick,A&&!N&&b.browserEvent.detail!==2)return super.u(b);if(!this.x.expandOnDoubleClick&&b.browserEvent.detail===2)return super.u(b);if(R.collapsible){const k=this.x.getNodeLocation(R),U=b.browserEvent.altKey;if(this.x.setFocus([k]),this.x.toggleCollapsed(k,U),A&&N){b.browserEvent.isHandledByList=!0;return}}super.u(b)}v(b){b.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||b.browserEvent.isHandledByList||super.v(b)}}class V extends f.$aR{constructor(b,R,B,N,A,k,U,C){super(b,R,B,N,C),this.p=A,this.s=k,this.K=U}D(b){return new Y(this,b.tree)}splice(b,R,B=[]){if(super.splice(b,R,B),B.length===0)return;const N=[],A=[];let k;B.forEach((U,C)=>{this.p.has(U)&&N.push(b+C),this.s.has(U)&&A.push(b+C),this.K.has(U)&&(k=b+C)}),N.length>0&&super.setFocus((0,e.$Lb)([...super.getFocus(),...N])),A.length>0&&super.setSelection((0,e.$Lb)([...super.getSelection(),...A])),typeof k=="number"&&super.setAnchor(k)}setFocus(b,R,B=!1){super.setFocus(b,R),B||this.p.set(b.map(N=>this.element(N)),R)}setSelection(b,R,B=!1){super.setSelection(b,R),B||this.s.set(b.map(N=>this.element(N)),R)}setAnchor(b,R=!1){super.setAnchor(b),R||(typeof b>"u"?this.K.set([]):this.K.set([this.element(b)]))}}class G{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return u.Event.map(this.j.onMouseClick,Fe)}get onMouseDblClick(){return u.Event.filter(u.Event.map(this.j.onMouseDblClick,Fe),b=>b.target!==n.TreeMouseEventTarget.Filter)}get onContextMenu(){return u.Event.map(this.j.onContextMenu,de)}get onTap(){return u.Event.map(this.j.onTap,Fe)}get onPointer(){return u.Event.map(this.j.onPointer,Fe)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return u.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??re.Highlight}set findMode(b){this.x&&(this.x.mode=b)}get findMatchType(){return this.x?.matchType??be.Fuzzy}set findMatchType(b){this.x&&(this.x.matchType=b)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:u.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(b,R,B,N,A={}){this.D=b,this.E=A,this.w=new u.$Vd,this.onDidChangeFindOpenState=u.Event.None,this.A=new l.$Qc,this.B=new u.$Nd,this.onWillRefilter=this.B.event,this.C=new u.$Nd,this.onDidUpdateOptions=this.C.event;const k=new H(B),U=new u.$Wd,C=new u.$Wd,j=this.A.add(new F(C.event)),E=new s.$Fc;this.k=N.map(ne=>new Z(ne,()=>this.o,U.event,j,E,A));for(const ne of this.k)this.A.add(ne);let P;A.keyboardNavigationLabelProvider&&(P=new ee(this,A.keyboardNavigationLabelProvider,A.filter),A={...A,filter:P},this.A.add(P)),this.p=new ce(()=>this.j.getFocusedElements()[0],A.identityProvider),this.q=new ce(()=>this.j.getSelectedElements()[0],A.identityProvider),this.u=new ce(()=>this.j.getAnchorElement(),A.identityProvider),this.j=new V(b,R,k,this.k,this.p,this.q,this.u,{...z(()=>this.o,A),tree:this}),this.o=this.I(b,this.j,A),U.input=this.o.onDidChangeCollapseState;const W=u.Event.forEach(this.o.onDidSplice,ne=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(ne),this.q.onDidModelSplice(ne)})},this.A);W(()=>null,null,this.A);const x=this.A.add(new u.$Nd),te=this.A.add(new a.$Qg(0));if(this.A.add(u.Event.any(W,this.p.onDidChange,this.q.onDidChange)(()=>{te.trigger(()=>{const ne=new Set;for(const ge of this.p.getNodes())ne.add(ge);for(const ge of this.q.getNodes())ne.add(ge);x.fire([...ne.values()])})})),C.input=x.event,A.keyboardSupport!==!1){const ne=u.Event.chain(this.j.onKeyDown,ge=>ge.filter(ve=>!(0,f.$4Q)(ve.target)).map(ve=>new i.$MO(ve)));u.Event.chain(ne,ge=>ge.filter(ve=>ve.keyCode===15))(this.F,this,this.A),u.Event.chain(ne,ge=>ge.filter(ve=>ve.keyCode===17))(this.G,this,this.A),u.Event.chain(ne,ge=>ge.filter(ve=>ve.keyCode===10))(this.H,this,this.A)}if((A.findWidgetEnabled??!0)&&A.keyboardNavigationLabelProvider&&A.contextViewProvider){const ne=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Le(this,this.o,this.j,P,A.contextViewProvider,ne),this.y=ge=>this.x.shouldAllowFocus(ge),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=u.Event.None,this.onDidChangeFindMatchType=u.Event.None;this.z=(0,w.$tP)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===M.Always)}updateOptions(b={}){this.E={...this.E,...b};for(const R of this.k)R.updateOptions(b);this.j.updateOptions(this.E),this.x?.updateOptions(b),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===M.Always)}get options(){return this.E}updateWidth(b){const R=this.o.getListIndex(b);R!==-1&&this.j.updateWidth(R)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(b){this.j.scrollTop=b}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(b){this.j.scrollLeft=b}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const b=this.j.firstVisibleIndex;return b<0||b>=this.j.length?void 0:this.j.element(b).element}get lastVisibleElement(){const b=this.j.lastVisibleIndex;return this.j.element(b).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(b){this.j.ariaLabel=b}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return(0,w.$mP)(this.getHTMLElement())}layout(b,R){this.j.layout(b,R),(0,y.$Cf)(R)&&this.x?.layout(R)}style(b){const R=`.${this.j.domId}`,B=[];b.treeIndentGuidesStroke&&(B.push(`.monaco-list${R}:hover .monaco-tl-indent > .indent-guide, .monaco-list${R}.always .monaco-tl-indent > .indent-guide  { border-color: ${b.treeInactiveIndentGuidesStroke}; }`),B.push(`.monaco-list${R} .monaco-tl-indent > .indent-guide.active { border-color: ${b.treeIndentGuidesStroke}; }`)),this.z.textContent=B.join(`
`),this.j.style(b)}getParentElement(b){const R=this.o.getParentNodeLocation(b);return this.o.getNode(R).element}getFirstElementChild(b){return this.o.getFirstElementChild(b)}getNode(b){return this.o.getNode(b)}getNodeLocation(b){return this.o.getNodeLocation(b)}collapse(b,R=!1){return this.o.setCollapsed(b,!0,R)}expand(b,R=!1){return this.o.setCollapsed(b,!1,R)}toggleCollapsed(b,R=!1){return this.o.setCollapsed(b,void 0,R)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(b){return this.o.isCollapsible(b)}setCollapsible(b,R){return this.o.setCollapsible(b,R)}isCollapsed(b){return this.o.isCollapsed(b)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(b){if(typeof b>"u")return this.j.setAnchor(void 0);const R=this.o.getNode(b);this.u.set([R]);const B=this.o.getListIndex(b);B>-1&&this.j.setAnchor(B,!0)}getAnchor(){return(0,e.$Nb)(this.u.get(),void 0)}setSelection(b,R){const B=b.map(A=>this.o.getNode(A));this.q.set(B,R);const N=b.map(A=>this.o.getListIndex(A)).filter(A=>A>-1);this.j.setSelection(N,R,!0)}getSelection(){return this.q.get()}setFocus(b,R){const B=b.map(A=>this.o.getNode(A));this.p.set(B,R);const N=b.map(A=>this.o.getListIndex(A)).filter(A=>A>-1);this.j.setFocus(N,R,!0)}focusNext(b=1,R=!1,B,N=this.y){this.j.focusNext(b,R,B,N)}focusPrevious(b=1,R=!1,B,N=this.y){this.j.focusPrevious(b,R,B,N)}focusNextPage(b,R=this.y){return this.j.focusNextPage(b,R)}focusPreviousPage(b,R=this.y){return this.j.focusPreviousPage(b,R)}focusLast(b,R=this.y){this.j.focusLast(b,R)}focusFirst(b,R=this.y){this.j.focusFirst(b,R)}getFocus(){return this.p.get()}reveal(b,R){this.o.expandTo(b);const B=this.o.getListIndex(b);B!==-1&&this.j.reveal(B,R)}getRelativeTop(b){const R=this.o.getListIndex(b);return R===-1?null:this.j.getRelativeTop(R)}getViewState(b=this.options.identityProvider){if(!b)throw new n.$MS(this.D,"Can't get tree view state without an identity provider");const R=k=>b.getId(k).toString(),B=_.empty(this.scrollTop);for(const k of this.getFocus())B.focus.add(R(k));for(const k of this.getSelection())B.selection.add(R(k));const N=this.o.getNode(),A=[N];for(;A.length>0;){const k=A.shift();k!==N&&k.collapsible&&(B.expanded[R(k.element)]=k.collapsed?0:1),A.push(...k.children)}return B}F(b){b.preventDefault(),b.stopPropagation();const R=this.j.getFocusedElements();if(R.length===0)return;const B=R[0],N=this.o.getNodeLocation(B);if(!this.o.setCollapsed(N,!0)){const k=this.o.getParentNodeLocation(N);if(!k)return;const U=this.o.getListIndex(k);this.j.reveal(U),this.j.setFocus([U])}}G(b){b.preventDefault(),b.stopPropagation();const R=this.j.getFocusedElements();if(R.length===0)return;const B=R[0],N=this.o.getNodeLocation(B);if(!this.o.setCollapsed(N,!1)){if(!B.children.some(C=>C.visible))return;const[k]=this.j.getFocus(),U=k+1;this.j.reveal(U),this.j.setFocus([U])}}H(b){b.preventDefault(),b.stopPropagation();const R=this.j.getFocusedElements();if(R.length===0)return;const B=R[0],N=this.o.getNodeLocation(B),A=b.browserEvent.altKey;this.o.setCollapsed(N,void 0,A)}navigate(b){return new S(this.j,this.o,b)}dispose(){(0,l.$Mc)(this.A),this.j.dispose()}}t.$VS=G;class S{constructor(b,R,B){this.b=b,this.c=R,B?this.a=this.c.getListIndex(B):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define($e[130],pe([1,0,129,120,24,26]),function(le,t,w,O,i,q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7S=void 0;class p extends w.$VS{constructor(c,f,m,L,n,o={}){super(c,f,m,L,o),this.f=c,this.g=n,this.d=new Map,this.c=o.identityProvider}getInput(){return this.b}setInput(c,f){if(f&&!this.c)throw new i.$MS(this.f,"Can't restore tree view state without an identity provider");if(this.b=c,!c){this.d.clear(),this.o.setChildren(null,q.Iterable.empty());return}if(!f){this.m(c);return}const m=[],L=[],n=e=>{const a=this.c.getId(e).toString();return!f.expanded[a]},o=e=>{const a=this.c.getId(e.element).toString();f.focus.has(a)&&m.push(e.element),f.selection.has(a)&&L.push(e.element)};this.m(c,n,o),this.setFocus(m),this.setSelection(L),f&&typeof f.scrollTop=="number"&&(this.scrollTop=f.scrollTop)}updateChildren(c=this.b){if(typeof this.b>"u")throw new i.$MS(this.f,"Tree input not set");let f;this.c&&(f=m=>{const L=this.c.getId(m).toString(),n=this.d.get(L);if(n)return n.collapsed}),this.m(c,f)}resort(c=this.b,f=!0){this.o.resort(c===this.b?null:c,f)}refresh(c){if(c===void 0){this.j.rerender();return}this.o.rerender(c)}m(c,f,m){let L;if(this.c){const n=new Set,o=m;m=e=>{const a=this.c.getId(e.element).toString();n.add(a),this.d.set(a,e),o?.(e)},L=e=>{const a=this.c.getId(e.element).toString();n.has(a)||this.d.delete(a)}}this.o.setChildren(c===this.b?null:c,this.s(c,f).elements,{onDidCreateNode:m,onDidDeleteNode:L})}s(c,f){const m=[...this.g.getChildren(c)];return{elements:q.Iterable.map(m,n=>{const{elements:o,size:e}=this.s(n,f),a=this.g.hasChildren?this.g.hasChildren(n):void 0,h=e===0?void 0:f&&f(n);return{element:n,children:o,collapsible:a,collapsed:h}}),size:m.length}}I(c,f,m){return new O.$WS(c,f,m)}}t.$7S=p}),define($e[66],pe([1,0,11,9,32,28,25,6,4,2,52,12,7]),function(le,t,w,O,i,q,p,D,c,f,m,L,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yh=t.ProxyChannel=t.$xh=t.$wh=t.$vh=t.$uh=t.$th=t.$sh=t.RequestInitiator=t.$rh=t.$qh=t.$ph=t.$oh=t.$nh=void 0;var o;(function(de){de[de.Promise=100]="Promise",de[de.PromiseCancel=101]="PromiseCancel",de[de.EventListen=102]="EventListen",de[de.EventDispose=103]="EventDispose"})(o||(o={}));function e(de){switch(de){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(de){de[de.Initialize=200]="Initialize",de[de.PromiseSuccess=201]="PromiseSuccess",de[de.PromiseError=202]="PromiseError",de[de.PromiseErrorObj=203]="PromiseErrorObj",de[de.EventFire=204]="EventFire"})(a||(a={}));function h(de){switch(de){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(de){de[de.Uninitialized=0]="Uninitialized",de[de.Idle=1]="Idle"})($||($={}));function s(de){let ie=0;for(let ce=0;;ce+=7){const Y=de.read(1);if(ie|=(Y.buffer[0]&127)<<ce,!(Y.buffer[0]&128))return ie}}const u=I(0);function d(de,ie){if(ie===0){de.write(u);return}let ce=0;for(let V=ie;V!==0;V=V>>>7)ce++;const Y=i.$be.alloc(ce);for(let V=0;ie!==0;V++)Y.buffer[V]=ie&127,ie=ie>>>7,ie>0&&(Y.buffer[V]|=128);de.write(Y)}class l{constructor(ie){this.b=ie,this.a=0}read(ie){const ce=this.b.slice(this.a,this.a+ie);return this.a+=ce.byteLength,ce}}t.$nh=l;class r{constructor(){this.a=[]}get buffer(){return i.$be.concat(this.a)}write(ie){this.a.push(ie)}}t.$oh=r;var y;(function(de){de[de.Undefined=0]="Undefined",de[de.String=1]="String",de[de.Buffer=2]="Buffer",de[de.VSBuffer=3]="VSBuffer",de[de.Array=4]="Array",de[de.Object=5]="Object",de[de.Int=6]="Int"})(y||(y={}));function I(de){const ie=i.$be.alloc(1);return ie.writeUInt8(de,0),ie}const T={Undefined:I(y.Undefined),String:I(y.String),Buffer:I(y.Buffer),VSBuffer:I(y.VSBuffer),Array:I(y.Array),Object:I(y.Object),Uint:I(y.Int)},g=typeof Buffer<"u";function v(de,ie){if(typeof ie>"u")de.write(T.Undefined);else if(typeof ie=="string"){const ce=i.$be.fromString(ie);de.write(T.String),d(de,ce.byteLength),de.write(ce)}else if(g&&Buffer.isBuffer(ie)){const ce=i.$be.wrap(ie);de.write(T.Buffer),d(de,ce.byteLength),de.write(ce)}else if(ie instanceof i.$be)de.write(T.VSBuffer),d(de,ie.byteLength),de.write(ie);else if(Array.isArray(ie)){de.write(T.Array),d(de,ie.length);for(const ce of ie)v(de,ce)}else if(typeof ie=="number"&&(ie|0)===ie)de.write(T.Uint),d(de,ie);else{const ce=i.$be.fromString(JSON.stringify(ie));de.write(T.Object),d(de,ce.byteLength),de.write(ce)}}t.$ph=v;function z(de){switch(de.read(1).readUInt8(0)){case y.Undefined:return;case y.String:return de.read(s(de)).toString();case y.Buffer:return de.read(s(de)).buffer;case y.VSBuffer:return de.read(s(de));case y.Array:{const ce=s(de),Y=[];for(let V=0;V<ce;V++)Y.push(z(de));return Y}case y.Object:return JSON.parse(de.read(s(de)).toString());case y.Int:return s(de)}}t.$qh=z;class H{constructor(ie,ce,Y=null,V=1e3){this.h=ie,this.j=ce,this.k=Y,this.l=V,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(ie,ce){this.b.set(ie,ce),setTimeout(()=>this.w(ie),0)}m(ie){switch(ie.type){case 200:{const ce=this.o([ie.type]);this.k?.logOutgoing(ce,0,1,h(ie.type));return}case 201:case 202:case 204:case 203:{const ce=this.o([ie.type,ie.id],ie.data);this.k?.logOutgoing(ce,ie.id,1,h(ie.type),ie.data);return}}}o(ie,ce=void 0){const Y=new r;return v(Y,ie),v(Y,ce),this.p(Y.buffer)}p(ie){try{return this.h.send(ie),ie.byteLength}catch{return 0}}q(ie){const ce=new l(ie),Y=z(ce),V=z(ce),G=Y[0];switch(G){case 100:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(G)}: ${Y[2]}.${Y[3]}`,V),this.s({type:G,id:Y[1],channelName:Y[2],name:Y[3],arg:V});case 102:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(G)}: ${Y[2]}.${Y[3]}`,V),this.t({type:G,id:Y[1],channelName:Y[2],name:Y[3],arg:V});case 101:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(G)}`),this.u({type:G,id:Y[1]});case 103:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(G)}`),this.u({type:G,id:Y[1]})}}s(ie){const ce=this.b.get(ie.channelName);if(!ce){this.v(ie);return}const Y=new q.$Xd;let V;try{V=ce.call(this.j,ie.name,ie.arg,Y.token)}catch(Q){V=Promise.reject(Q)}const G=ie.id;V.then(Q=>{this.m({id:G,data:Q,type:201})},Q=>{Q instanceof Error?this.m({id:G,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.m({id:G,data:Q,type:203})}).finally(()=>{S.dispose(),this.d.delete(ie.id)});const S=(0,f.$Pc)(()=>Y.cancel());this.d.set(ie.id,S)}t(ie){const ce=this.b.get(ie.channelName);if(!ce){this.v(ie);return}const Y=ie.id,G=ce.listen(this.j,ie.name,ie.arg)(S=>this.m({id:Y,data:S,type:204}));this.d.set(ie.id,G)}u(ie){const ce=this.d.get(ie.id);ce&&(ce.dispose(),this.d.delete(ie.id))}v(ie){let ce=this.g.get(ie.channelName);ce||(ce=[],this.g.set(ie.channelName,ce));const Y=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.m({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ce.push({request:ie,timeoutTimer:Y})}w(ie){const ce=this.g.get(ie);if(ce){for(const Y of ce)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.s(Y.request);break;case 102:this.t(Y.request);break}this.g.delete(ie)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$Mc)(this.d.values()),this.d.clear()}}t.$rh=H;var _;(function(de){de[de.LocalSide=0]="LocalSide",de[de.OtherSide=1]="OtherSide"})(_||(t.RequestInitiator=_={}));class M{constructor(ie,ce=null){this.l=ie,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new c.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=ce}getChannel(ie){const ce=this;return{call(Y,V,G){return ce.a?Promise.reject(new D.$4):ce.m(ie,Y,V,G)},listen(Y,V){return ce.a?c.Event.None:ce.o(ie,Y,V)}}}m(ie,ce,Y,V=q.CancellationToken.None){const G=this.g++,Q={id:G,type:100,channelName:ie,name:ce,arg:Y};if(V.isCancellationRequested)return Promise.reject(new D.$4);let b;return new Promise((B,N)=>{if(V.isCancellationRequested)return N(new D.$4);const A=()=>{const j=E=>{switch(E.type){case 201:this.f.delete(G),B(E.data);break;case 202:{this.f.delete(G);const P=new Error(E.data.message);P.stack=Array.isArray(E.data.stack)?E.data.stack.join(`
`):E.data.stack,P.name=E.data.name,N(P);break}case 203:this.f.delete(G),N(E.data);break}};this.f.set(G,j),this.p(Q)};let k=null;this.b===$.Idle?A():(k=(0,O.$Hg)(j=>this.u()),k.then(()=>{k=null,A()}));const U=()=>{k?(k.cancel(),k=null):this.p({id:G,type:101}),N(new D.$4)},C=V.onCancellationRequested(U);b=(0,f.$Oc)((0,f.$Pc)(U),C),this.d.add(b)}).finally(()=>{b.dispose(),this.d.delete(b)})}o(ie,ce,Y){const V=this.g++,S={id:V,type:102,channelName:ie,name:ce,arg:Y};let Q=null;const b=new c.$Nd({onWillAddFirstListener:()=>{Q=(0,O.$Hg)(B=>this.u()),Q.then(()=>{Q=null,this.d.add(b),this.p(S)})},onDidRemoveLastListener:()=>{Q?(Q.cancel(),Q=null):(this.d.delete(b),this.p({id:V,type:103}))}}),R=B=>b.fire(B.data);return this.f.set(V,R),b.event}p(ie){switch(ie.type){case 100:case 102:{const ce=this.q([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.j?.logOutgoing(ce,ie.id,0,`${e(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const ce=this.q([ie.type,ie.id]);this.j?.logOutgoing(ce,ie.id,0,e(ie.type));return}}}q(ie,ce=void 0){const Y=new r;return v(Y,ie),v(Y,ce),this.r(Y.buffer)}r(ie){try{return this.l.send(ie),ie.byteLength}catch{return 0}}s(ie){const ce=new l(ie),Y=z(ce),V=z(ce),G=Y[0];switch(G){case 200:return this.j?.logIncoming(ie.byteLength,0,0,h(G)),this.t({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ie.byteLength,Y[1],0,h(G),V),this.t({type:Y[0],id:Y[1],data:V})}}t(ie){if(ie.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(ie.id)?.(ie)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$Mc)(this.d.values()),this.d.clear()}}t.$sh=M,xe([p.$hh],M.prototype,"onDidInitializePromise",null);class F{get connections(){const ie=[];return this.f.forEach(ce=>ie.push(ce)),ie}constructor(ie){this.a=new Map,this.f=new Set,this.g=new c.$Nd,this.onDidAddConnection=this.g.event,this.h=new c.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new f.$Qc,this.j.add(ie(({protocol:ce,onDidClientDisconnect:Y})=>{const V=c.Event.once(ce.onMessage);this.j.add(V(G=>{const S=new l(G),Q=z(S),b=new H(ce,Q),R=new M(ce);this.a.forEach((N,A)=>b.registerChannel(A,N));const B={channelServer:b,channelClient:R,ctx:Q};this.f.add(B),this.g.fire(B),this.j.add(Y(()=>{b.dispose(),R.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(ie,ce){const Y=this;return{call(V,G,S){let Q;if((0,n.$Mf)(ce)){const R=(0,w.$3b)(Y.connections.filter(ce));Q=R?Promise.resolve(R):c.Event.toPromise(c.Event.filter(Y.onDidAddConnection,ce))}else Q=ce.routeCall(Y,V,G);const b=Q.then(R=>R.channelClient.getChannel(ie));return ee(b).call(V,G,S)},listen(V,G){if((0,n.$Mf)(ce))return Y.k(ie,ce,V,G);const S=ce.routeEvent(Y,V,G).then(Q=>Q.channelClient.getChannel(ie));return ee(S).listen(V,G)}}}k(ie,ce,Y,V){const G=this;let S;const Q=new c.$Nd({onWillAddFirstListener:()=>{S=new f.$Qc;const b=new c.$Td,R=new Map,B=A=>{const U=A.channelClient.getChannel(ie).listen(Y,V),C=b.add(U);R.set(A,C)},N=A=>{const k=R.get(A);k&&(k.dispose(),R.delete(A))};G.connections.filter(ce).forEach(B),c.Event.filter(G.onDidAddConnection,ce)(B,void 0,S),G.onDidRemoveConnection(N,void 0,S),b.event(Q.fire,Q,S),S.add(b)},onDidRemoveLastListener:()=>{S?.dispose(),S=void 0}});return Q.event}registerChannel(ie,ce){this.a.set(ie,ce);for(const Y of this.f)Y.channelServer.registerChannel(ie,ce)}dispose(){this.j.dispose();for(const ie of this.f)ie.channelClient.dispose(),ie.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$th=F;class Z{constructor(ie,ce,Y=null){const V=new r;v(V,ce),ie.send(V.buffer),this.a=new M(ie,Y),this.d=new H(ie,ce,Y)}getChannel(ie){return this.a.getChannel(ie)}registerChannel(ie,ce){this.d.registerChannel(ie,ce)}dispose(){this.a.dispose(),this.d.dispose()}}t.$uh=Z;function ee(de){return{call(ie,ce,Y){return de.then(V=>V.call(ie,ce,Y))},listen(ie,ce){const Y=new c.$Wd;return de.then(V=>Y.input=V.listen(ie,ce)),Y.event}}}t.$vh=ee;function ue(de){let ie=!1;return{call(ce,Y,V){return ie?de.call(ce,Y,V):(0,O.$Ug)(0).then(()=>ie=!0).then(()=>de.call(ce,Y,V))},listen(ce,Y){if(ie)return de.listen(ce,Y);const V=new c.$Wd;return(0,O.$Ug)(0).then(()=>ie=!0).then(()=>V.input=de.listen(ce,Y)),V.event}}}t.$wh=ue;class oe{constructor(ie){this.a=ie}routeCall(ie){return this.b(ie)}routeEvent(ie){return this.b(ie)}async b(ie){for(const ce of ie.connections)if(await Promise.resolve(this.a(ce.ctx)))return Promise.resolve(ce);return await c.Event.toPromise(ie.onDidAddConnection),await this.b(ie)}}t.$xh=oe;var se;(function(de){function ie(G,S,Q){const b=G,R=Q&&Q.disableMarshalling,B=new Map;for(const N in b)Y(N)&&B.set(N,c.Event.buffer(b[N],!0,void 0,S));return new class{listen(N,A,k){const U=B.get(A);if(U)return U;if(V(A)){const C=b[A];if(typeof C=="function")return C.call(b,k)}throw new D.$ab(`Event not found: ${A}`)}call(N,A,k){const U=b[A];if(typeof U=="function"){if(!R&&Array.isArray(k))for(let j=0;j<k.length;j++)k[j]=(0,m.$mh)(k[j]);let C=U.apply(b,k);return C instanceof Promise||(C=Promise.resolve(C)),C}throw new D.$ab(`Method not found: ${A}`)}}}de.fromService=ie;function ce(G,S){const Q=S&&S.disableMarshalling;return new Proxy({},{get(b,R){if(typeof R=="string")return S?.properties?.has(R)?S.properties.get(R):V(R)?function(B){return G.listen(R,B)}:Y(R)?G.listen(R):async function(...B){let N;S&&!(0,n.$Hf)(S.context)?N=[S.context,...B]:N=B;const A=await G.call(R,N);return Q?A:(0,m.$mh)(A)};throw new D.$ab(`Property not found: ${String(R)}`)}})}de.toService=ce;function Y(G){return G[0]==="o"&&G[1]==="n"&&L.$1e(G.charCodeAt(2))}function V(G){return/^onDynamic/.test(G)&&L.$1e(G.charCodeAt(9))}})(se||(t.ProxyChannel=se={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function be(de){if(Array.isArray(de))return de;if(de&&typeof de=="object"&&typeof de.toString=="function"){const ie=de.toString();if(ie!=="[object Object]")return ie}return de}function Se(de){return Array.isArray(de)?de.map(be):be(de)}function Le(de,ie,ce,Y,V,G,S){S=Se(S);const Q=re[V],b=Q[Y%Q.length];let R=[`%c[${de}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(ce).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${b}`];/\($/.test(G)?(R=R.concat(S),R.push(")")):R.push(S),console.log.apply(console,R)}class Fe{constructor(ie,ce){this.d=ie,this.f=ce,this.a=0,this.b=0}logOutgoing(ie,ce,Y,V,G){this.b+=ie,Le(this.d,this.b,ie,ce,Y,V,G)}logIncoming(ie,ce,Y,V,G){this.a+=ie,Le(this.f,this.a,ie,ce,Y,V,G)}}t.$yh=Fe}),define($e[30],pe([1,0,5]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$R=t.$Q=t.$P=t.$O=t.$N=void 0,t.$N=w.$h.vscode.ipcRenderer,t.$O=w.$h.vscode.ipcMessagePort,t.$P=w.$h.vscode.webFrame,t.$Q=w.$h.vscode.process,t.$R=w.$h.vscode.context}),define($e[131],pe([1,0,87,30]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AT=void 0;let i=0;function q(D,c,f){const m=[],L=i++,n=`vscode:onContextMenu${L}`,o=(e,a,h)=>{m[a].click?.(h)};O.$N.once(n,o),O.$N.once(w.$xT,(e,a)=>{a===L&&(O.$N.removeListener(n,o),f?.())}),O.$N.send(w.$wT,L,D.map(e=>p(e,m)),n,c)}t.$AT=q;function p(D,c){const f={id:c.length,label:D.label,type:D.type,accelerator:D.accelerator,checked:D.checked,enabled:typeof D.enabled=="boolean"?D.enabled:!0,visible:typeof D.visible=="boolean"?D.visible:!0};return c.push(D),Array.isArray(D.submenu)&&(f.submenu=D.submenu.map(m=>p(m,c))),f}}),define($e[132],pe([1,0,32,4,66,88,30]),function(le,t,w,O,i,q,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IT=void 0;class D extends i.$uh{static f(){const f=O.Event.fromNodeEventEmitter(p.$N,"vscode:message",(m,L)=>w.$be.wrap(L));return p.$N.send("vscode:hello"),new q.$ET(p.$N,f)}constructor(f){const m=D.f();super(m,f),this.b=m}dispose(){this.b.disconnect()}}t.$IT=D}),define($e[133],pe([13,10]),function(le,t){return le.create("vs/platform/files/common/files",t)}),define($e[134],pe([13,10]),function(le,t){return le.create("vs/platform/theme/common/iconRegistry",t)}),define($e[39],pe([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qh=t.$Ph=t.$Oh=t._util=void 0;var w;(function(p){p.serviceIds=new Map,p.DI_TARGET="$di$target",p.DI_DEPENDENCIES="$di$dependencies";function D(c){return c[p.DI_DEPENDENCIES]||[]}p.getServiceDependencies=D})(w||(t._util=w={})),t.$Oh=i("instantiationService");function O(p,D,c){D[w.DI_TARGET]===D?D[w.DI_DEPENDENCIES].push({id:p,index:c}):(D[w.DI_DEPENDENCIES]=[{id:p,index:c}],D[w.DI_TARGET]=D)}function i(p){if(w.serviceIds.has(p))return w.serviceIds.get(p);const D=function(c,f,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(D,c,m)};return D.toString=()=>p,w.serviceIds.set(p,D),D}t.$Ph=i;function q(p){return p}t.$Qh=q}),define($e[135],pe([1,0,39]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sm=t.$rm=t.$qm=t.ID=void 0,t.ID="diagnosticsService",t.$qm=(0,w.$Ph)(t.ID);function O(q){return!!q.hostName&&!!q.errorMessage}t.$rm=O;class i{async getPerformanceInfo(p,D){return{}}async getSystemInfo(p,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(p,D){return""}async getWorkspaceFileExtensions(p){return{extensions:[]}}async reportWorkspaceStats(p){}}t.$sm=i}),define($e[136],pe([1,0,86,22,12,7,15,133,39,5,29,27]),function(le,t,w,O,i,q,p,D,c,f,m,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hk=t.$Gk=t.$Fk=t.$Ek=t.$Dk=t.FileKind=t.$Ck=t.$Bk=t.$Ak=t.$zk=t.$yk=t.$xk=t.$wk=t.FileOperationResult=t.$vk=t.$uk=t.$tk=t.$sk=t.$rk=t.FileChangeType=t.$qk=t.FileOperation=t.$pk=t.$ok=t.$nk=t.$mk=t.$lk=t.$kk=t.FileSystemProviderErrorCode=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.$dk=t.$ck=t.$bk=t.FileSystemProviderCapabilities=t.$ak=t.FilePermission=t.FileType=t.$_j=t.$$j=void 0,t.$$j=(0,c.$Ph)("fileService");function n(V){return V.create===!0}t.$_j=n;var o;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(o||(t.FileType=o={}));var e;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function a(V){const G=V;return!!G&&typeof G.onDidChange=="function"}t.$ak=a;var h;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(h||(t.FileSystemProviderCapabilities=h={}));function $(V){return!!(V.capabilities&2)}t.$bk=$;function s(V){return!!(V.capabilities&8)}t.$ck=s;function u(V){return!!(V.capabilities&131072)}t.$dk=u;function d(V){return!!(V.capabilities&4)}t.$ek=d;function l(V){return!!(V.capabilities&16)}t.$fk=l;function r(V){return $(V)?!!(V.capabilities&16384):!1}t.$gk=r;function y(V){return $(V)?!!(V.capabilities&32768):!1}t.$hk=y;function I(V){return!!(V.capabilities&65536)}t.$ik=I;function T(V){return!!(V.capabilities&2048)}t.$jk=T;var g;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(g||(t.FileSystemProviderErrorCode=g={}));class v extends Error{static create(G,S){const Q=new v(G.toString(),S);return _(Q,S),Q}constructor(G,S){super(G),this.code=S}}t.$kk=v;function z(V,G){return v.create(V,G)}t.$lk=z;function H(V){return V||z((0,D.localize)(0,null),g.Unknown)}t.$mk=H;function _(V,G){return V.name=G?`${G} (FileSystemError)`:"FileSystemError",V}t.$nk=_;function M(V){if(!V)return g.Unknown;if(V instanceof v)return V.code;const G=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!G)return g.Unknown;switch(G[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}t.$ok=M;function F(V){if(V instanceof re)return V.fileOperationResult;switch(M(V)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 9;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileTooLarge:return 7;default:return 10}}t.$pk=F;var Z;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(Z||(t.FileOperation=Z={}));class ee{constructor(G,S,Q){this.resource=G,this.operation=S,this.target=Q}isOperation(G){return this.operation===G}}t.$qk=ee;var ue;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(ue||(t.FileChangeType=ue={}));class oe{static{this.a=null}constructor(G,S){this.c=S,this.b=void 0,this.d=new L.$U(()=>{const Q=w.$Vh.forUris(()=>this.c);return Q.fill(this.rawAdded.map(b=>[b,!0])),Q}),this.f=new L.$U(()=>{const Q=w.$Vh.forUris(()=>this.c);return Q.fill(this.rawUpdated.map(b=>[b,!0])),Q}),this.g=new L.$U(()=>{const Q=w.$Vh.forUris(()=>this.c);return Q.fill(this.rawDeleted.map(b=>[b,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of G){switch(Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}this.b!==oe.a&&(typeof Q.cId=="number"?this.b===void 0?this.b=Q.cId:this.b!==Q.cId&&(this.b=oe.a):this.b!==void 0&&(this.b=oe.a))}}contains(G,...S){return this.h(G,{includeChildren:!1},...S)}affects(G,...S){return this.h(G,{includeChildren:!0},...S)}h(G,S,...Q){if(!G)return!1;const b=Q.length>0;return!!((!b||Q.includes(1))&&(this.d.value.get(G)||S.includeChildren&&this.d.value.findSuperstr(G))||(!b||Q.includes(0))&&(this.f.value.get(G)||S.includeChildren&&this.f.value.findSuperstr(G))||(!b||Q.includes(2))&&(this.g.value.findSubstr(G)||S.includeChildren&&this.g.value.findSuperstr(G)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(G){return this.b===G}hasCorrelation(){return typeof this.b=="number"}}t.$rk=oe;function se(V,G,S){return!V||!G||V===G||G.length>V.length?!1:(G.charAt(G.length-1)!==O.sep&&(G+=O.sep),S?(0,i.$3e)(V,G):V.indexOf(G)===0)}t.$sk=se;class re extends Error{constructor(G,S,Q){super(G),this.fileOperationResult=S,this.options=Q}}t.$tk=re;class be extends re{constructor(G,S,Q,b){super(G,S,b),this.fileOperationResult=S,this.size=Q}}t.$uk=be;class Se extends re{constructor(G,S,Q){super(G,2,Q),this.stat=S}}t.$vk=Se;var Le;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Le||(t.FileOperationResult=Le={})),t.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$yk="files.associations",t.$zk="files.exclude",t.$Ak="files.readonlyInclude",t.$Bk="files.readonlyExclude",t.$Ck="files.readonlyFromPermissions";var Fe;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(Fe||(t.FileKind=Fe={})),t.$Dk="";function de(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}t.$Ek=de;async function ie(V,G){if(!G.hasProvider(p.URI.from({scheme:V.scheme})))return new Promise(S=>{const Q=G.onDidChangeFileSystemProviderRegistrations(b=>{b.scheme===V.scheme&&b.added&&(Q.dispose(),S())})})}t.$Fk=ie;class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(G){return(0,q.$Cf)(G)||(G=0),G<ce.KB?(0,D.localize)(1,null,G.toFixed(0)):G<ce.MB?(0,D.localize)(2,null,(G/ce.KB).toFixed(2)):G<ce.GB?(0,D.localize)(3,null,(G/ce.MB).toFixed(2)):G<ce.TB?(0,D.localize)(4,null,(G/ce.GB).toFixed(2)):(0,D.localize)(5,null,(G/ce.TB).toFixed(2))}}t.$Gk=ce;function Y(V){const G=typeof V=="string"||V?.scheme===m.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===m.Schemas.file?1024*ce.MB:G?10*ce.MB:f.$p?50*ce.MB:1024*ce.MB}t.$Hk=Y}),define($e[137],pe([1,0,39]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T8b=t.$S8b=void 0,t.$S8b=(0,w.$Ph)("mainProcessService");class O{constructor(q,p){this.a=q,this.b=p}getChannel(q){return this.a.getChannel(q,this.b)}registerChannel(q,p){this.a.registerChannel(q,p)}}t.$T8b=O}),define($e[138],pe([1,0,2,132]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U8b=void 0;class i extends w.$Rc{constructor(p){super(),this.a=this.B(new O.$IT(`window:${p}`))}getChannel(p){return this.a.getChannel(p)}registerChannel(p,D){this.a.registerChannel(p,D)}}t.$U8b=i});var Di=this&&this.__param||function(le,t){return function(w,O){t(w,O,le)}};define($e[139],pe([1,0,66,137]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Y8b=void 0;let i=class{constructor(p,D){return this.windowId=p,w.ProxyChannel.toService(D.getChannel("nativeHost"),{context:p,properties:(()=>{const c=new Map;return c.set("windowId",p),c})()})}};t.$Y8b=i,t.$Y8b=i=xe([Di(1,O.$S8b)],i)}),define($e[67],pe([1,0,75,7]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jn=void 0;class i{constructor(){this.a=new Map}add(p,D){w.ok(O.$yf(p)),w.ok(O.$Af(D)),w.ok(!this.a.has(p),"There is already an extension with this id"),this.a.set(p,D)}knows(p){return this.a.has(p)}as(p){return this.a.get(p)||null}}t.$jn=new i}),define($e[140],pe([1,0,4,67]),function(le,t,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kn=void 0,t.$kn={JSONContribution:"base.contributions.json"};function i(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class q{constructor(){this.b=new w.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,f){this.a[i(c)]=f,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}}const p=new q;O.$jn.add(t.$kn.JSONContribution,p)}),define($e[141],pe([1,0,9,17,18,4,7,15,134,140,67]),function(le,t,w,O,i,q,p,D,c,f,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dw=t.$cw=t.$bw=t.$aw=t.$_v=t.$$v=t.$0v=t.$9v=t.IconFontDefinition=t.IconContribution=t.$8v=void 0,t.$8v={IconContribution:"base.contributions.icons"};var L;(function(d){function l(r,y){let I=r.defaults;for(;i.ThemeIcon.isThemeIcon(I);){const T=e.getIcon(I.id);if(!T)return;I=T.defaults}return I}d.getDefinition=l})(L||(t.IconContribution=L={}));var n;(function(d){function l(y){return{weight:y.weight,style:y.style,src:y.src.map(I=>({format:I.format,location:I.location.toString()}))}}d.toJSONObject=l;function r(y){const I=T=>(0,p.$yf)(T)?T:void 0;if(y&&Array.isArray(y.src)&&y.src.every(T=>(0,p.$yf)(T.format)&&(0,p.$yf)(T.location)))return{weight:I(y.weight),style:I(y.style),src:y.src.map(T=>({format:T.format,location:D.URI.parse(T.location)}))}}d.fromJSONObject=r})(n||(t.IconFontDefinition=n={}));class o{constructor(){this.a=new q.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,r,y,I){const T=this.b[l];if(T){if(y&&!T.description){T.description=y,this.d.properties[l].markdownDescription=`${y} $(${l})`;const z=this.e.enum.indexOf(l);z!==-1&&(this.e.enumDescriptions[z]=y),this.a.fire()}return T}const g={id:l,description:y,defaults:r,deprecationMessage:I};this.b[l]=g;const v={$ref:"#/definitions/icons"};return I&&(v.deprecationMessage=I),y&&(v.markdownDescription=`${y}: $(${l})`),this.d.properties[l]=v,this.e.enum.push(l),this.e.enumDescriptions.push(y||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const r=this.e.enum.indexOf(l);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,r){const y=this.f[l];return y||(this.f[l]=r,this.a.fire(),r)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(T,g)=>T.id.localeCompare(g.id),r=T=>{for(;i.ThemeIcon.isThemeIcon(T.defaults);)T=this.b[T.defaults.id];return`codicon codicon-${T?T.id:""}`},y=[];y.push("| preview     | identifier                        | default codicon ID                | description"),y.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const I=Object.keys(this.b).map(T=>this.b[T]);for(const T of I.filter(g=>!!g.description).sort(l))y.push(`|<i class="${r(T)}"></i>|${T.id}|${i.ThemeIcon.isThemeIcon(T.defaults)?T.defaults.id:T.id}|${T.description||""}|`);y.push("| preview     | identifier                        "),y.push("| ----------- | --------------------------------- |");for(const T of I.filter(g=>!i.ThemeIcon.isThemeIcon(g.defaults)).sort(l))y.push(`|<i class="${r(T)}"></i>|${T.id}|`);return y.join(`
`)}}const e=new o;m.$jn.add(t.$8v.IconContribution,e);function a(d,l,r,y){return e.registerIcon(d,l,r,y)}t.$9v=a;function h(){return e}t.$0v=h;function $(){const d=(0,O.$Sj)();for(const l in d){const r="\\"+d[l].toString(16);e.registerIcon(l,{fontCharacter:r})}}$(),t.$$v="vscode://schemas/icons";const s=m.$jn.as(f.$kn.JSONContribution);s.registerSchema(t.$$v,e.getIconSchema());const u=new w.$6g(()=>s.notifySchemaChanged(t.$$v),200);e.onDidChange(()=>{u.isScheduled()||u.schedule()}),t.$_v=a("widget-close",O.$Uj.close,(0,c.localize)(2,null)),t.$aw=a("goto-previous-location",O.$Uj.arrowUp,(0,c.localize)(3,null)),t.$bw=a("goto-next-location",O.$Uj.arrowDown,(0,c.localize)(4,null)),t.$cw=i.ThemeIcon.modify(O.$Uj.sync,"spin"),t.$dw=i.ThemeIcon.modify(O.$Uj.loading,"spin")}),define($e[142],pe([1,0,3,4,2,18,141]),function(le,t,w,O,i,q,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1Cb=t.$ZCb=void 0;function D(f){const m=new i.$Qc,L=m.add(new O.$Nd),n=(0,p.$0v)();return m.add(n.onDidChange(()=>L.fire())),f&&m.add(f.onDidProductIconThemeChange(()=>L.fire())),{dispose:()=>m.dispose(),onDidChange:L.event,getCSS(){const o=f?f.getProductIconTheme():new c,e={},a=$=>{const s=o.getIcon($);if(!s)return;const u=s.font;return u?(e[u.id]=u.definition,`.codicon-${$.id}:before { content: '${s.fontCharacter}'; font-family: ${(0,w.$3P)(u.id)}; }`):`.codicon-${$.id}:before { content: '${s.fontCharacter}'; }`},h=[];for(const $ of n.getIcons()){const s=a($);s&&h.push(s)}for(const $ in e){const s=e[$],u=s.weight?`font-weight: ${s.weight};`:"",d=s.style?`font-style: ${s.style};`:"",l=s.src.map(r=>`${(0,w.$2P)(r.location)} format('${r.format}')`).join(", ");h.push(`@font-face { src: ${l}; font-family: ${(0,w.$3P)($)};${u}${d} font-display: block; }`)}return h.join(`
`)}}}t.$ZCb=D;class c{getIcon(m){const L=(0,p.$0v)();let n=m.defaults;for(;q.ThemeIcon.isThemeIcon(n);){const o=L.getIcon(n.id);if(!o)return;n=o.defaults}return n}}t.$1Cb=c}),define($e[143],pe([1,0,5]),function(le,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qC=t.$pC=t.$oC=t.$nC=t.$mC=t.$lC=t.$kC=t.$jC=t.$iC=void 0,t.$iC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function O(L){return typeof L.parentId=="number"}t.$jC=O;function i(L){return!!L.workspaceUri}t.$kC=i;function q(L){return!!L.folderUri}t.$lC=q;function p(L){return!!L.fileUri}t.$mC=p;function D(L){const n=c(L),o=L.getValue("window.menuBarVisibility");return o==="default"||n==="native"&&o==="compact"||w.$k&&w.$n?"classic":o}t.$nC=D;function c(L){if(w.$p)return"custom";const n=L.getValue("window");if(n){if(w.$k&&n.nativeTabs===!0||w.$k&&n.nativeFullScreen===!1)return"native";const a=n.titleBarStyle;if(a==="native"||a==="custom")return a}return w.$l?"native":"custom"}t.$oC=c;function f(L){return!(!w.$j||w.$p||c(L)==="native")}t.$pC=f;function m(L=0){return Math.pow(1.2,L)}t.$qC=m}),define($e[144],pe([1,0,16,3,30,143]),function(le,t,w,O,i,q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$38b=t.$28b=t.$18b=void 0;function p(m){for(const{window:L}of(0,O.getWindows)())D(L)?.webFrame?.setZoomLevel(m);(0,w.$rO)((0,q.$qC)(m)),(0,w.$oO)(m)}t.$18b=p;function D(m){if(m===window)return{ipcRenderer:i.$N,webFrame:i.$P};{const L=m;if(L?.vscode?.ipcRenderer&&L?.vscode?.webFrame)return L.vscode}}function c(){p((0,w.$pO)()+1)}t.$28b=c;function f(){p((0,w.$pO)()-1)}t.$38b=f}),define($e[145],pe([1,0,10,3,130,9,131,30,135,136,138,139,142,144,14,101,92]),function(le,t,w,O,i,q,p,D,c,f,m,L,n,o,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const a=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,h=/\s--inspect-port=(?<port>\d+)/;class ${getHeight(_){return 22}getTemplateId(_){return T(_)?"process":y(_)?"machine":(0,c.$rm)(_)?"error":I(_)?"header":""}}class s{hasChildren(_){return(0,c.$rm)(_)?!1:T(_)?!!_.children?.length:!0}getChildren(_){return T(_)?_.children?_.children:[]:(0,c.$rm)(_)?[]:I(_)?_.processRoots.length>1?_.processRoots:[_.processRoots[0].rootProcess]:y(_)?[_.rootProcess]:[_.processes]}}class u{constructor(){this.templateId="header"}renderTemplate(_){const M=(0,O.$LP)(_,(0,O.$)(".row")),F=(0,O.$LP)(M,(0,O.$)(".nameLabel")),Z=(0,O.$LP)(M,(0,O.$)(".cpu")),ee=(0,O.$LP)(M,(0,O.$)(".memory")),ue=(0,O.$LP)(M,(0,O.$)(".pid"));return{name:F,CPU:Z,memory:ee,PID:ue}}renderElement(_,M,F,Z){F.name.textContent=(0,w.localize)(0,null),F.CPU.textContent=(0,w.localize)(1,null),F.PID.textContent=(0,w.localize)(2,null),F.memory.textContent=(0,w.localize)(3,null)}disposeTemplate(_){}}class d{constructor(){this.templateId="machine"}renderTemplate(_){const M=Object.create(null),F=(0,O.$LP)(_,(0,O.$)(".row"));return M.name=(0,O.$LP)(F,(0,O.$)(".nameLabel")),M}renderElement(_,M,F,Z){F.name.textContent=_.element.name}disposeTemplate(_){}}class l{constructor(){this.templateId="error"}renderTemplate(_){const M=Object.create(null),F=(0,O.$LP)(_,(0,O.$)(".row"));return M.name=(0,O.$LP)(F,(0,O.$)(".nameLabel")),M}renderElement(_,M,F,Z){F.name.textContent=_.element.errorMessage}disposeTemplate(_){}}class r{constructor(_,M,F){this.a=_,this.b=M,this.c=F,this.templateId="process"}renderTemplate(_){const M=(0,O.$LP)(_,(0,O.$)(".row")),F=(0,O.$LP)(M,(0,O.$)(".nameLabel")),Z=(0,O.$LP)(M,(0,O.$)(".cpu")),ee=(0,O.$LP)(M,(0,O.$)(".memory")),ue=(0,O.$LP)(M,(0,O.$)(".pid"));return{name:F,CPU:Z,PID:ue,memory:ee}}renderElement(_,M,F,Z){const{element:ee}=_,ue=ee.pid.toFixed(0);let oe=ee.name;this.c.has(ee.pid)&&(oe=this.c.get(ee.pid)),F.name.textContent=oe,F.name.title=ee.cmd,F.CPU.textContent=ee.load.toFixed(0),F.PID.textContent=ue,F.PID.parentElement.id=`pid-${ue}`;const se=this.a==="win32"?ee.mem:this.b*(ee.mem/100);F.memory.textContent=(se/f.$Gk.MB).toFixed(0)}disposeTemplate(_){}}function y(H){return!!H.name&&!!H.rootProcess}function I(H){return!!H.processRoots}function T(H){return!!H.pid}class g{constructor(_,M){this.f=M,this.b=new Map;const F=new m.$U8b(_);this.c=new L.$Y8b(_,F),this.k(M.styles),this.g(M),D.$N.on("vscode:pidToNameResponse",(Z,ee)=>{this.b=new Map;for(const[ue,oe]of ee)this.b.set(ue,oe)}),D.$N.on("vscode:listProcessesResponse",async(Z,ee)=>{ee.forEach((ue,oe)=>{T(ue.rootProcess)&&(ue.rootProcess.name=oe===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:ee}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(ee),this.m(0)}),this.a=Date.now(),D.$N.send("vscode:pidToNameRequest"),D.$N.send("vscode:listProcesses")}g(_){document.onkeydown=M=>{const F=_.platform==="darwin"?M.metaKey:M.ctrlKey;F&&M.keyCode===87&&(M.stopPropagation(),M.preventDefault(),D.$N.send("vscode:closeProcessExplorer")),F&&M.keyCode===187&&(0,o.$28b)(),F&&M.keyCode===189&&(0,o.$38b)()}}async h(_){const M=document.getElementById("process-list");if(!M)return;const{totalmem:F}=await this.c.getOSStatistics(),Z=[new r(this.f.platform,F,this.b),new u,new d,new l];this.d=new i.$7S("processExplorer",M,new $,Z,new s,{identityProvider:{getId:ee=>T(ee)?ee.pid.toString():(0,c.$rm)(ee)?ee.hostName:I(ee)?"processes":y(ee)?ee.name:"header"}}),this.d.setInput({processes:{processRoots:_}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(ee=>{const ue=new e.$MO(ee);if(ue.keyCode===35&&ue.altKey){const oe=this.n();Promise.all(oe.map(se=>this.c.killProcess(se,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(ee=>{T(ee.element)&&this.l(ee.element,!0)}),M.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{M.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(_){const M=a.exec(_);return M&&M.groups.port!=="0"||_.indexOf("node ")>=0||_.indexOf("node.exe")>=0}j(_){const M={type:"node",request:"attach",name:`process ${_.pid}`};let F=a.exec(_.cmd);F?M.port=Number(F.groups.port):M.processId=String(_.pid),F=h.exec(_.cmd),F&&(M.port=Number(F.groups.port)),D.$N.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[M]})}k(_){const M=(0,O.$tP)(),F=[];_.listFocusBackground&&(F.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${_.listFocusBackground}; }`),F.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${_.listFocusBackground}; }`)),_.listFocusForeground&&F.push(`.monaco-list:focus .monaco-list-row.focused { color: ${_.listFocusForeground}; }`),_.listActiveSelectionBackground&&(F.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${_.listActiveSelectionBackground}; }`),F.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${_.listActiveSelectionBackground}; }`)),_.listActiveSelectionForeground&&F.push(`.monaco-list:focus .monaco-list-row.selected { color: ${_.listActiveSelectionForeground}; }`),_.listHoverBackground&&F.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${_.listHoverBackground}; }`),_.listHoverForeground&&F.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${_.listHoverForeground}; }`),_.listFocusOutline&&F.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${_.listFocusOutline}; outline-offset: -1px; }`),_.listHoverOutline&&F.push(`.monaco-list-row:hover { outline: 1px dashed ${_.listHoverOutline}; outline-offset: -1px; }`),_.scrollbarShadowColor&&F.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${_.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${_.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${_.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),_.scrollbarSliderBackgroundColor&&F.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${_.scrollbarSliderBackgroundColor};
				}
			`),_.scrollbarSliderHoverBackgroundColor&&F.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${_.scrollbarSliderHoverBackgroundColor};
				}
			`),_.scrollbarSliderActiveBackgroundColor&&F.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${_.scrollbarSliderActiveBackgroundColor};
				}
			`),M.textContent=F.join(`
`),_.color&&(document.body.style.color=_.color)}l(_,M){const F=[],Z=Number(_.pid);M&&(F.push({accelerator:"Alt+E",label:(0,w.localize)(4,null),click:()=>{this.c.killProcess(Z,"SIGTERM")}}),F.push({label:(0,w.localize)(5,null),click:()=>{this.c.killProcess(Z,"SIGKILL")}}),F.push({type:"separator"})),F.push({label:(0,w.localize)(6,null),click:()=>{const ee=this.n();ee?.includes(Z)||(ee.length=0,ee.push(Z));const ue=ee?.map(oe=>document.getElementById(`pid-${oe}`)).filter(oe=>!!oe);if(ue){const oe=ue.map(se=>se.innerText).filter(se=>!!se);this.c.writeClipboardText(oe.join(`
`))}}}),F.push({label:(0,w.localize)(7,null),click:()=>{const ee=document.getElementById("process-list");ee&&this.c.writeClipboardText(ee.innerText)}}),_&&M&&this.i(_.cmd)&&(F.push({type:"separator"}),F.push({label:(0,w.localize)(8,null),click:()=>{this.j(_)}})),(0,p.$AT)(F)}m(_){setTimeout(()=>{const M=Date.now(),F=_+M-this.a;this.a=M,F>1e3?(D.$N.send("vscode:pidToNameRequest"),D.$N.send("vscode:listProcesses")):this.m(F)},200)}n(){return this.d?.getSelection()?.map(_=>{if(!(!_||!("pid"in _)))return _.pid}).filter(_=>!!_)}}function v(){const H=(0,O.$tP)();H.id="codiconStyles";const _=(0,n.$ZCb)(void 0);function M(){H.textContent=_.getCSS()}const F=new q.$6g(M,0);_.onDidChange(()=>F.schedule()),F.schedule()}function z(H){const _=H.data.platform==="win32"?"windows":H.data.platform==="linux"?"linux":"mac";document.body.classList.add(_),v(),(0,o.$18b)(H.data.zoomLevel),new g(H.windowId,H.data)}t.startup=z})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/98417b150aeb47dd81dc58893789da4b4cb0e095/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
