/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],ne=function(J){for(var e=[],L=0,D=J.length;L<D;L++)e[L]=te[J[L]];return e};define(te[70],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class L{static get(){const R=new Map,A=new Map,j=new Map,v=new Map;function u(f,P){f.has(P.detail)||f.set(P.detail,-P.timestamp)}function c(f,P){const y=f.get(P.detail);y&&(y>=0||f.set(P.detail,y+P.timestamp))}let S=[];typeof J=="function"&&typeof J.getStats=="function"&&(S=J.getStats().slice(0).sort((f,P)=>f.timestamp-P.timestamp));for(const f of S)switch(f.type){case 10:u(R,f);break;case 11:case 12:c(R,f);break;case 21:u(A,f);break;case 22:c(A,f);break;case 33:u(j,f);break;case 34:c(j,f);break;case 31:u(v,f);break;case 32:c(v,f);break}let I=0;j.forEach(f=>I+=f);function g(f){const P=[];return f.forEach((y,$)=>P.push([$,y])),P}return{amdLoad:g(R),amdInvoke:g(A),nodeRequire:g(j),nodeEval:g(v),nodeRequireTotal:I}}static toMarkdownTable(R,A){let j="";const v=[];return R.forEach((u,c)=>{v[c]=u.length}),A.forEach(u=>{u.forEach((c,S)=>{typeof c>"u"&&(c=u[S]="-");const I=c.toString().length;v[S]=Math.max(I,v[S])})}),R.forEach((u,c)=>{j+=`| ${u+" ".repeat(v[c]-u.toString().length)} `}),j+=`|
`,R.forEach((u,c)=>{j+=`| ${"-".repeat(v[c])} `}),j+=`|
`,A.forEach(u=>{u.forEach((c,S)=>{typeof c<"u"&&(j+=`| ${c+" ".repeat(v[S]-c.toString().length)} `)}),j+=`|
`}),j}}e.$T=L}),define(te[52],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function L(j){return(v,u,c)=>{let S=null,I=null;if(typeof c.value=="function"?(S="value",I=c.value):typeof c.get=="function"&&(S="get",I=c.get),!I)throw new Error("not supported");c[S]=j(I,u)}}function D(j,v,u){let c=null,S=null;if(typeof u.value=="function"?(c="value",S=u.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",S=u.get),!S)throw new Error("not supported");const I=`$memoize$${v}`;u[c]=function(...g){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,g)}),this[I]}}e.$hh=D;function R(j,v,u){return L((c,S)=>{const I=`$debounce$${S}`,g=`$debounce$result$${S}`;return function(...f){this[g]||(this[g]=u?u():void 0),clearTimeout(this[I]),v&&(this[g]=v(this[g],...f),f=[this[g]]),this[I]=setTimeout(()=>{c.apply(this,f),this[g]=u?u():void 0},j)}})}e.$ih=R;function A(j,v,u){return L((c,S)=>{const I=`$throttle$timer$${S}`,g=`$throttle$result$${S}`,f=`$throttle$lastRun$${S}`,P=`$throttle$pending$${S}`;return function(...y){if(this[g]||(this[g]=u?u():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),v&&(this[g]=v(this[g],...y)),this[P])return;const $=this[f]+j;$<=Date.now()?(this[f]=Date.now(),c.apply(this,[this[g]]),this[g]=u?u():void 0):(this[P]=!0,this[I]=setTimeout(()=>{this[P]=!1,this[f]=Date.now(),c.apply(this,[this[g]]),this[g]=u?u():void 0},$-Date.now()))}})}e.$jh=A}),define(te[71],ne([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function D(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=D;function R(u,c="Unreachable"){throw new Error(c)}e.$3c=R;function A(u){if(!u)throw new L.$bb("Assertion Failed")}e.$4c=A;function j(u){if(!u()){debugger;u(),(0,L.$Z)(new L.$bb("Assertion Failed"))}}e.$5c=j;function v(u,c){let S=0;for(;S<u.length-1;){const I=u[S],g=u[S+1];if(!c(I,g))return!1;S++}return!0}e.$6c=v}),define(te[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var R;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function j(s,r=!1){let t=0;const i=s.length;let n="",o=0,l=16,k=0;function E(se){let ue=0,ce=0;for(;ue<se;){const re=s.charCodeAt(t);if(re>=48&&re<=57)ce=ce*16+re-48;else if(re>=65&&re<=70)ce=ce*16+re-65+10;else if(re>=97&&re<=102)ce=ce*16+re-97+10;else break;t++,ue++}return ue<se&&(ce=-1),ce}function p(se){t=se,n="",o=0,l=16,k=0}function N(){const se=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&c(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&c(s.charCodeAt(t)))for(t++;t<s.length&&c(s.charCodeAt(t));)t++;else return k=3,s.substring(se,t);let ue=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&c(s.charCodeAt(t))){for(t++;t<s.length&&c(s.charCodeAt(t));)t++;ue=t}else k=3;return s.substring(se,ue)}function B(){let se="",ue=t;for(;;){if(t>=i){se+=s.substring(ue,t),k=2;break}const ce=s.charCodeAt(t);if(ce===34){se+=s.substring(ue,t),t++;break}if(ce===92){if(se+=s.substring(ue,t),t++,t>=i){k=2;break}switch(s.charCodeAt(t++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const q=E(4);q>=0?se+=String.fromCharCode(q):k=4;break}default:k=5}ue=t;continue}if(ce>=0&&ce<=31)if(u(ce)){se+=s.substring(ue,t),k=2;break}else k=6;t++}return se}function _(){if(n="",k=0,o=t,t>=i)return o=i,l=17;let se=s.charCodeAt(t);if(v(se)){do t++,n+=String.fromCharCode(se),se=s.charCodeAt(t);while(v(se));return l=15}if(u(se))return t++,n+=String.fromCharCode(se),se===13&&s.charCodeAt(t)===10&&(t++,n+=`
`),l=14;switch(se){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,n=B(),l=10;case 47:{const ue=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!u(s.charCodeAt(t));)t++;return n=s.substring(ue,t),l=12}if(s.charCodeAt(t+1)===42){t+=2;const ce=i-1;let re=!1;for(;t<ce;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,re=!0;break}t++}return re||(t++,k=1),n=s.substring(ue,t),l=13}return n+=String.fromCharCode(se),t++,l=16}case 45:if(n+=String.fromCharCode(se),t++,t===i||!c(s.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=N(),l=11;default:for(;t<i&&ee(se);)t++,se=s.charCodeAt(t);if(o!==t){switch(n=s.substring(o,t),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(se),t++,l=16}}function ee(se){if(v(se)||u(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let se;do se=_();while(se>=12&&se<=15);return se}return{setPosition:p,getPosition:()=>t,scan:r?oe:_,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>k}}e.$Um=j;function v(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function u(s){return s===10||s===13||s===8232||s===8233}function c(s){return s>=48&&s<=57}var S;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(S||(S={}));function I(s,r){const t=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function k(E,p,N,B){o.value=E,o.offset=p,o.length=N,o.type=B,o.colonOffset=void 0,n=o}try{O(s,{onObjectBegin:(E,p)=>{if(r<=E)throw i;n=void 0,l=r>E,t.push("")},onObjectProperty:(E,p,N)=>{if(r<p||(k(E,p,N,"property"),t[t.length-1]=E,r<=p+N))throw i},onObjectEnd:(E,p)=>{if(r<=E)throw i;n=void 0,t.pop()},onArrayBegin:(E,p)=>{if(r<=E)throw i;n=void 0,t.push(0)},onArrayEnd:(E,p)=>{if(r<=E)throw i;n=void 0,t.pop()},onLiteralValue:(E,p,N)=>{if(r<p||(k(E,p,N,w(E)),r<=p+N))throw i},onSeparator:(E,p,N)=>{if(r<=p)throw i;if(E===":"&&n&&n.type==="property")n.colonOffset=p,l=!1,n=void 0;else if(E===","){const B=t[t.length-1];typeof B=="number"?t[t.length-1]=B+1:(l=!0,t[t.length-1]=""),n=void 0}}})}catch(E){if(E!==i)throw E}return{path:t,previousNode:n,isAtPropertyKey:l,matches:E=>{let p=0;for(let N=0;p<E.length&&N<t.length;N++)if(E[p]===t[N]||E[p]==="*")p++;else if(E[p]!=="**")return!1;return p===E.length}}}e.$Vm=I;function g(s,r=[],t=A.DEFAULT){let i=null,n=[];const o=[];function l(E){Array.isArray(n)?n.push(E):i!==null&&(n[i]=E)}return O(s,{onObjectBegin:()=>{const E={};l(E),o.push(n),n=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const E=[];l(E),o.push(n),n=E,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:l,onError:(E,p,N)=>{r.push({error:E,offset:p,length:N})}},t),n[0]}e.$Wm=g;function f(s,r=[],t=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(E){i.type==="property"&&(i.length=E-i.offset,i=i.parent)}function o(E){return i.children.push(E),E}O(s,{onObjectBegin:E=>{i=o({type:"object",offset:E,length:-1,parent:i,children:[]})},onObjectProperty:(E,p,N)=>{i=o({type:"property",offset:p,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:E,offset:p,length:N,parent:i})},onObjectEnd:(E,p)=>{i.length=E+p-i.offset,i=i.parent,n(E+p)},onArrayBegin:(E,p)=>{i=o({type:"array",offset:E,length:-1,parent:i,children:[]})},onArrayEnd:(E,p)=>{i.length=E+p-i.offset,i=i.parent,n(E+p)},onLiteralValue:(E,p,N)=>{o({type:w(E),offset:p,length:N,parent:i,value:E}),n(p+N)},onSeparator:(E,p,N)=>{i.type==="property"&&(E===":"?i.colonOffset=p:E===","&&n(p))},onError:(E,p,N)=>{r.push({error:E,offset:p,length:N})}},t);const k=i.children[0];return k&&delete k.parent,k}e.$Xm=f;function P(s,r){if(!s)return;let t=s;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===i){t=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.$Ym=P;function y(s){if(!s.parent||!s.parent.children)return[];const r=y(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;r.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&r.push(t)}return r}e.$Zm=y;function $(s){switch(s.type){case"array":return s.children.map($);case"object":{const r=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(r[t.children[0].value]=$(i))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$1m=$;function h(s,r,t=!1){return r>=s.offset&&r<s.offset+s.length||t&&r===s.offset+s.length}e.$2m=h;function b(s,r,t=!1){if(h(s,r,t)){const i=s.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=r;n++){const o=b(i[n],r,t);if(o)return o}return s}}e.$3m=b;function O(s,r,t=A.DEFAULT){const i=j(s,!1);function n(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(Q){return Q?Y=>Q(Y,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(r.onObjectBegin),k=o(r.onObjectProperty),E=n(r.onObjectEnd),p=n(r.onArrayBegin),N=n(r.onArrayEnd),B=o(r.onLiteralValue),_=o(r.onSeparator),ee=n(r.onComment),oe=o(r.onError),se=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function ce(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:se||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(Q){case 12:case 13:se?re(10):ee();break;case 16:re(1);break;case 15:case 14:break;default:return Q}}}function re(Q,Y=[],F=[]){if(oe(Q),Y.length+F.length>0){let C=i.getToken();for(;C!==17;){if(Y.indexOf(C)!==-1){ce();break}else if(F.indexOf(C)!==-1)break;C=ce()}}}function q(Q){const Y=i.getTokenValue();return Q?B(Y):k(Y),ce(),!0}function X(){switch(i.getToken()){case 11:{let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(re(2),Q=0)}catch{re(2)}B(Q);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return ce(),!0}function T(){return i.getToken()!==10?(re(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(_(":"),ce(),G()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function M(){l(),ce();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||re(4,[],[]),_(","),ce(),i.getToken()===2&&ue)break}else Q&&re(6,[],[]);T()||re(4,[],[2,5]),Q=!0}return E(),i.getToken()!==2?re(7,[2],[]):ce(),!0}function H(){p(),ce();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||re(4,[],[]),_(","),ce(),i.getToken()===4&&ue)break}else Q&&re(6,[],[]);G()||re(4,[],[4,5]),Q=!0}return N(),i.getToken()!==4?re(8,[4],[]):ce(),!0}function G(){switch(i.getToken()){case 3:return H();case 1:return M();case 10:return q(!0);default:return X()}}return ce(),i.getToken()===17?t.allowEmptyContent?!0:(re(4,[],[]),!1):G()?(i.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.$4m=O;function d(s,r){const t=j(s),i=[];let n,o=0,l;do switch(l=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:o!==l&&i.push(s.substring(o,l)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(n!==17);return i.join("")}e.$5m=d;function w(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=w}),define(te[72],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function L(v,u,c){return Math.min(Math.max(v,u),c)}e.$Ol=L;function D(v,u){return(u+v%u)%u}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=R;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=A;class j{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=j}),function(){function J(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function j(u){A.push(u,Date.now())}function v(){const u=[];for(let c=0;c<A.length;c+=2)u.push({name:A[c],startTime:A[c+1]});return u}return{mark:j,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const j of performance.getEntriesByType("mark"))A.push({name:j.name,startTime:Math.round(R+j.startTime)});return A}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:J)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return J[D].call(R.exports,R,R.exports,L),R.l=!0,R.exports}return L.m=J,L.c=e,L.d=function(D,R,A){L.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:A})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,R){if(1&R&&(D=L(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var j in D)L.d(A,j,function(v){return D[v]}.bind(null,j));return A},L.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(R,"a",R),R},L.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},L.p="",L(L.s=0)}([function(J,e,L){(function(D){var R;e=J.exports=F,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],u=e.src=[],c=0,S=c++;u[S]="0|[1-9]\\d*";var I=c++;u[I]="[0-9]+";var g=c++;u[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=c++;u[f]="("+u[S]+")\\.("+u[S]+")\\.("+u[S]+")";var P=c++;u[P]="("+u[I]+")\\.("+u[I]+")\\.("+u[I]+")";var y=c++;u[y]="(?:"+u[S]+"|"+u[g]+")";var $=c++;u[$]="(?:"+u[I]+"|"+u[g]+")";var h=c++;u[h]="(?:-("+u[y]+"(?:\\."+u[y]+")*))";var b=c++;u[b]="(?:-?("+u[$]+"(?:\\."+u[$]+")*))";var O=c++;u[O]="[0-9A-Za-z-]+";var d=c++;u[d]="(?:\\+("+u[O]+"(?:\\."+u[O]+")*))";var w=c++,s="v?"+u[f]+u[h]+"?"+u[d]+"?";u[w]="^"+s+"$";var r="[v=\\s]*"+u[P]+u[b]+"?"+u[d]+"?",t=c++;u[t]="^"+r+"$";var i=c++;u[i]="((?:<|>)?=?)";var n=c++;u[n]=u[I]+"|x|X|\\*";var o=c++;u[o]=u[S]+"|x|X|\\*";var l=c++;u[l]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[h]+")?"+u[d]+"?)?)?";var k=c++;u[k]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[b]+")?"+u[d]+"?)?)?";var E=c++;u[E]="^"+u[i]+"\\s*"+u[l]+"$";var p=c++;u[p]="^"+u[i]+"\\s*"+u[k]+"$";var N=c++;u[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=c++;u[B]="(?:~>?)";var _=c++;u[_]="(\\s*)"+u[B]+"\\s+",v[_]=new RegExp(u[_],"g");var ee=c++;u[ee]="^"+u[B]+u[l]+"$";var oe=c++;u[oe]="^"+u[B]+u[k]+"$";var se=c++;u[se]="(?:\\^)";var ue=c++;u[ue]="(\\s*)"+u[se]+"\\s+",v[ue]=new RegExp(u[ue],"g");var ce=c++;u[ce]="^"+u[se]+u[l]+"$";var re=c++;u[re]="^"+u[se]+u[k]+"$";var q=c++;u[q]="^"+u[i]+"\\s*("+r+")$|^$";var X=c++;u[X]="^"+u[i]+"\\s*("+s+")$|^$";var T=c++;u[T]="(\\s*)"+u[i]+"\\s*("+r+"|"+u[l]+")",v[T]=new RegExp(u[T],"g");var M=c++;u[M]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var H=c++;u[H]="^\\s*("+u[k]+")\\s+-\\s+("+u[k]+")\\s*$";var G=c++;u[G]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)R(Q,u[Q]),v[Q]||(v[Q]=new RegExp(u[Q]));function Y(V,K){if(V instanceof F)return V;if(typeof V!="string"||V.length>A||!(K?v[t]:v[w]).test(V))return null;try{return new F(V,K)}catch{return null}}function F(V,K){if(V instanceof F){if(V.loose===K)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof F))return new F(V,K);R("SemVer",V,K),this.loose=K;var x=V.trim().match(K?v[t]:v[w]);if(!x)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<j)return ye}return $e}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=Y,e.valid=function(V,K){var x=Y(V,K);return x?x.version:null},e.clean=function(V,K){var x=Y(V.trim().replace(/^[=v]+/,""),K);return x?x.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof F||(V=new F(V,this.loose)),this.compareMain(V)||this.comparePre(V)},F.prototype.compareMain=function(V){return V instanceof F||(V=new F(V,this.loose)),a(this.major,V.major)||a(this.minor,V.minor)||a(this.patch,V.patch)},F.prototype.comparePre=function(V){if(V instanceof F||(V=new F(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var K=0;do{var x=this.prerelease[K],$e=V.prerelease[K];if(R("prerelease compare",K,x,$e),x===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(x===void 0)return-1;if(x!==$e)return a(x,$e)}while(++K)},F.prototype.inc=function(V,K){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,K,x,$e){typeof x=="string"&&($e=x,x=void 0);try{return new F(V,x).inc(K,$e).version}catch{return null}},e.diff=function(V,K){if(Z(V,K))return null;var x=Y(V),$e=Y(K);if(x.prerelease.length||$e.prerelease.length){for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return ye},e.compareIdentifiers=a;var C=/^[0-9]+$/;function a(V,K){var x=C.test(V),$e=C.test(K);return x&&$e&&(V=+V,K=+K),x&&!$e?-1:$e&&!x?1:V<K?-1:V>K?1:0}function m(V,K,x){return new F(V,x).compare(new F(K,x))}function z(V,K,x){return m(V,K,x)>0}function U(V,K,x){return m(V,K,x)<0}function Z(V,K,x){return m(V,K,x)===0}function W(V,K,x){return m(V,K,x)!==0}function le(V,K,x){return m(V,K,x)>=0}function ae(V,K,x){return m(V,K,x)<=0}function me(V,K,x,$e){var ye;switch(K){case"===":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),ye=V===x;break;case"!==":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),ye=V!==x;break;case"":case"=":case"==":ye=Z(V,x,$e);break;case"!=":ye=W(V,x,$e);break;case">":ye=z(V,x,$e);break;case">=":ye=le(V,x,$e);break;case"<":ye=U(V,x,$e);break;case"<=":ye=ae(V,x,$e);break;default:throw new TypeError("Invalid operator: "+K)}return ye}function de(V,K){if(V instanceof de){if(V.loose===K)return V;V=V.value}if(!(this instanceof de))return new de(V,K);R("comparator",V,K),this.loose=K,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,K){return a(K,V)},e.major=function(V,K){return new F(V,K).major},e.minor=function(V,K){return new F(V,K).minor},e.patch=function(V,K){return new F(V,K).patch},e.compare=m,e.compareLoose=function(V,K){return m(V,K,!0)},e.rcompare=function(V,K,x){return m(K,V,x)},e.sort=function(V,K){return V.sort(function(x,$e){return e.compare(x,$e,K)})},e.rsort=function(V,K){return V.sort(function(x,$e){return e.rcompare(x,$e,K)})},e.gt=z,e.lt=U,e.eq=Z,e.neq=W,e.gte=le,e.lte=ae,e.cmp=me,e.Comparator=de;var ge={};function fe(V,K){if(V instanceof fe)return V.loose===K?V:new fe(V.raw,K);if(V instanceof de)return new fe(V.value,K);if(!(this instanceof fe))return new fe(V,K);if(this.loose=K,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,K,x,$e,ye,Oe,Pe,Le,Ie,je,Me,Ne,De){return((K=he(x)?"":he($e)?">="+x+".0.0":he(ye)?">="+x+"."+$e+".0":">="+K)+" "+(Le=he(Ie)?"":he(je)?"<"+(+Ie+1)+".0.0":he(Me)?"<"+Ie+"."+(+je+1)+".0":Ne?"<="+Ie+"."+je+"."+Me+"-"+Ne:"<="+Le)).trim()}function be(V,K){for(var x=0;x<V.length;x++)if(!V[x].test(K))return!1;if(K.prerelease.length){for(x=0;x<V.length;x++)if(R(V[x].semver),V[x].semver!==ge&&V[x].semver.prerelease.length>0){var $e=V[x].semver;if($e.major===K.major&&$e.minor===K.minor&&$e.patch===K.patch)return!0}return!1}return!0}function Se(V,K,x){try{K=new fe(K,x)}catch{return!1}return K.test(V)}function Fe(V,K,x,$e){var ye,Oe,Pe,Le,Ie;switch(V=new F(V,$e),K=new fe(K,$e),x){case">":ye=z,Oe=ae,Pe=U,Le=">",Ie=">=";break;case"<":ye=U,Oe=le,Pe=z,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(V,K,$e))return!1;for(var je=0;je<K.set.length;++je){var Me=K.set[je],Ne=null,De=null;if(Me.forEach(function(ze){ze.semver===ge&&(ze=new de(">=0.0.0")),Ne=Ne||ze,De=De||ze,ye(ze.semver,Ne.semver,$e)?Ne=ze:Pe(ze.semver,De.semver,$e)&&(De=ze)}),Ne.operator===Le||Ne.operator===Ie||(!De.operator||De.operator===Le)&&Oe(V,De.semver)||De.operator===Ie&&Pe(V,De.semver))return!1}return!0}de.prototype.parse=function(V){var K=this.loose?v[q]:v[X],x=V.match(K);if(!x)throw new TypeError("Invalid comparator: "+V);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new F(x[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new F(V,this.loose)),me(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,K){if(!(V instanceof de))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new fe(V.value,K),Se(this.value,x,K);if(V.operator==="")return x=new fe(this.value,K),Se(V.semver,x,K);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Oe=this.semver.version===V.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=me(this.semver,"<",V.semver,K)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=me(this.semver,">",V.semver,K)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||ye||Oe&&Pe||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var K=this.loose;V=V.trim(),R("range",V,K);var x=K?v[H]:v[M];V=V.replace(x,we),R("hyphen replace",V),V=V.replace(v[T],"$1$2$3"),R("comparator trim",V,v[T]),V=(V=(V=V.replace(v[_],"$1~")).replace(v[ue],"$1^")).split(/\s+/).join(" ");var $e=K?v[q]:v[X],ye=V.split(" ").map(function(Oe){return function(Pe,Le){return R("comp",Pe),Pe=function(Ie,je){return Ie.trim().split(/\s+/).map(function(Me){return function(Ne,De){R("caret",Ne,De);var ze=De?v[re]:v[ce];return Ne.replace(ze,function(Ae,ve,Ee,ke,Re){var Ce;return R("caret",Ne,Ae,ve,Ee,ke,Re),he(ve)?Ce="":he(Ee)?Ce=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(ke)?Ce=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ce=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+ke+Re+" <"+ve+"."+Ee+"."+(+ke+1):">="+ve+"."+Ee+"."+ke+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+ke+Re+" <"+(+ve+1)+".0.0"):(R("no pr"),Ce=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+ke+" <"+ve+"."+Ee+"."+(+ke+1):">="+ve+"."+Ee+"."+ke+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+ke+" <"+(+ve+1)+".0.0"),R("caret return",Ce),Ce})}(Me,je)}).join(" ")}(Pe,Le),R("caret",Pe),Pe=function(Ie,je){return Ie.trim().split(/\s+/).map(function(Me){return function(Ne,De){var ze=De?v[oe]:v[ee];return Ne.replace(ze,function(Ae,ve,Ee,ke,Re){var Ce;return R("tilde",Ne,Ae,ve,Ee,ke,Re),he(ve)?Ce="":he(Ee)?Ce=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(ke)?Ce=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ce=">="+ve+"."+Ee+"."+ke+Re+" <"+ve+"."+(+Ee+1)+".0"):Ce=">="+ve+"."+Ee+"."+ke+" <"+ve+"."+(+Ee+1)+".0",R("tilde return",Ce),Ce})}(Me,je)}).join(" ")}(Pe,Le),R("tildes",Pe),Pe=function(Ie,je){return R("replaceXRanges",Ie,je),Ie.split(/\s+/).map(function(Me){return function(Ne,De){Ne=Ne.trim();var ze=De?v[p]:v[E];return Ne.replace(ze,function(Ae,ve,Ee,ke,Re,Ce){R("xRange",Ne,Ae,ve,Ee,ke,Re,Ce);var qe=he(Ee),Ue=qe||he(ke),Te=Ue||he(Re);return ve==="="&&Te&&(ve=""),qe?Ae=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Ue&&(ke=0),Te&&(Re=0),ve===">"?(ve=">=",Ue?(Ee=+Ee+1,ke=0,Re=0):Te&&(ke=+ke+1,Re=0)):ve==="<="&&(ve="<",Ue?Ee=+Ee+1:ke=+ke+1),Ae=ve+Ee+"."+ke+"."+Re):Ue?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Ae=">="+Ee+"."+ke+".0 <"+Ee+"."+(+ke+1)+".0"),R("xRange return",Ae),Ae})}(Me,je)}).join(" ")}(Pe,Le),R("xrange",Pe),Pe=function(Ie,je){return R("replaceStars",Ie,je),Ie.trim().replace(v[G],"")}(Pe,Le),R("stars",Pe),Pe}(Oe,K)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Oe){return!!Oe.match($e)})),ye=ye.map(function(Oe){return new de(Oe,K)})},fe.prototype.intersects=function(V,K){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function($e){return V.set.some(function(ye){return ye.every(function(Oe){return $e.intersects(Oe,K)})})})})},e.toComparators=function(V,K){return new fe(V,K).set.map(function(x){return x.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new F(V,this.loose));for(var K=0;K<this.set.length;K++)if(be(this.set[K],V))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(V,K,x){var $e=null,ye=null;try{var Oe=new fe(K,x)}catch{return null}return V.forEach(function(Pe){Oe.test(Pe)&&($e&&ye.compare(Pe)!==-1||(ye=new F($e=Pe,x)))}),$e},e.minSatisfying=function(V,K,x){var $e=null,ye=null;try{var Oe=new fe(K,x)}catch{return null}return V.forEach(function(Pe){Oe.test(Pe)&&($e&&ye.compare(Pe)!==1||(ye=new F($e=Pe,x)))}),$e},e.validRange=function(V,K){try{return new fe(V,K).range||"*"}catch{return null}},e.ltr=function(V,K,x){return Fe(V,K,"<",x)},e.gtr=function(V,K,x){return Fe(V,K,">",x)},e.outside=Fe,e.prerelease=function(V,K){var x=Y(V,K);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(V,K,x){return V=new fe(V,x),K=new fe(K,x),V.intersects(K)},e.coerce=function(V){if(V instanceof F)return V;if(typeof V!="string")return null;var K=V.match(v[N]);return K==null?null:Y((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,L(1))},function(J,e){var L,D,R=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function v($){if(L===setTimeout)return setTimeout($,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{D=typeof clearTimeout=="function"?clearTimeout:j}catch{D=j}})();var u,c=[],S=!1,I=-1;function g(){S&&u&&(S=!1,u.length?c=u.concat(c):I=-1,c.length&&f())}function f(){if(!S){var $=v(g);S=!0;for(var h=c.length;h;){for(u=c,c=[];++I<h;)u&&u[I].run();I=-1,h=c.length}u=null,S=!1,function(b){if(D===clearTimeout)return clearTimeout(b);if((D===j||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(b);try{D(b)}catch{try{return D.call(null,b)}catch{return D.call(this,b)}}}($)}}function P($,h){this.fun=$,this.array=h}function y(){}R.nextTick=function($){var h=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)h[b-1]=arguments[b];c.push(new P($,h)),c.length!==1||S||v(f)},P.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=y,R.addListener=y,R.once=y,R.off=y,R.removeListener=y,R.removeAllListeners=y,R.emit=y,R.prependListener=y,R.prependOnceListener=y,R.listeners=function($){return[]},R.binding=function($){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function($){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(te[73],ne([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;class D{constructor(v,u,c){this.level=v,this.key=u,this.value=c,this.forward=[]}}const R=void 0;class A{constructor(v,u=2**16){this.comparator=v,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R),this.f=0}has(v){return!!A.g(this,v,this.comparator)}get(v){return A.g(this,v,this.comparator)?.value}set(v,u){return A.h(this,v,u,this.comparator)&&(this.f+=1),this}delete(v){const u=A.k(this,v,this.comparator);return u&&(this.f-=1),u}forEach(v,u){let c=this.e.forward[0];for(;c;)v.call(u,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let v=this.e.forward[0];for(;v;)yield[v.key,v.value],v=v.forward[0]}*keys(){let v=this.e.forward[0];for(;v;)yield v.key,v=v.forward[0]}*values(){let v=this.e.forward[0];for(;v;)yield v.value,v=v.forward[0]}toString(){let v="[SkipList]:",u=this.e.forward[0];for(;u;)v+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return v}static g(v,u,c){let S=v.e;for(let I=v.d-1;I>=0;I--)for(;S.forward[I]&&c(S.forward[I].key,u)<0;)S=S.forward[I];if(S=S.forward[0],S&&c(S.key,u)===0)return S}static h(v,u,c,S){const I=[];let g=v.e;for(let f=v.d-1;f>=0;f--){for(;g.forward[f]&&S(g.forward[f].key,u)<0;)g=g.forward[f];I[f]=g}if(g=g.forward[0],g&&S(g.key,u)===0)return g.value=c,!1;{const f=A.j(v);if(f>v.d){for(let P=v.d;P<f;P++)I[P]=v.e;v.d=f}g=new D(f,u,c);for(let P=0;P<f;P++)g.forward[P]=I[P].forward[P],I[P].forward[P]=g;return!0}}static j(v,u=.5){let c=1;for(;Math.random()<u&&c<v.c;)c+=1;return c}static k(v,u,c){const S=[];let I=v.e;for(let g=v.d-1;g>=0;g--){for(;I.forward[g]&&c(I.forward[g].key,u)<0;)I=I.forward[g];S[g]=I}if(I=I.forward[0],!I||c(I.key,u)!==0)return!1;for(let g=0;g<v.d&&S[g].forward[g]===I;g++)S[g].forward[g]=I.forward[g];for(;v.d>0&&v.e.forward[v.d-1]===R;)v.d-=1;return!0}}e.$Br=A}),define(te[45],ne([0,1,9,2]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function R(d){const w=d;return w?typeof w.read=="function":!1}e.$Yd=R;function A(d){const w=d;return w?[w.on,w.pause,w.resume,w.destroy].every(s=>typeof s=="function"):!1}e.$Zd=A;function j(d){const w=d;return w?A(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.$1d=j;function v(d,w){return new u(d,w)}e.$2d=v;class u{constructor(w,s){this.e=w,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(s=>s(w))}h(w){this.c.error.length===0?(0,L.$Z)(w):this.c.error.slice(0).forEach(s=>s(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,s){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(w,s){if(this.a.destroyed)return;let r;switch(w){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(s);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(d,w){const s=[];let r;for(;(r=d.read())!==null;)s.push(r);return w(s)}e.$3d=c;function S(d,w,s){const r=[];let t;for(;(t=d.read())!==null&&r.length<s;)r.push(t);return t===null&&r.length>0?w(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return d.read()}}}e.$4d=S;function I(d,w){return new Promise((s,r)=>{const t=[];g(d,{onData:i=>{w&&t.push(i)},onError:i=>{w?r(i):s(void 0)},onEnd:()=>{s(w?w(t):void 0)}})})}e.$5d=I;function g(d,w,s){d.on("error",r=>{s?.isCancellationRequested||w.onError(r)}),d.on("end",()=>{s?.isCancellationRequested||w.onEnd()}),d.on("data",r=>{s?.isCancellationRequested||w.onData(r)})}e.$6d=g;function f(d,w){return new Promise((s,r)=>{const t=new D.$Qc,i=[],n=k=>{if(i.push(k),i.length>w)return t.dispose(),d.pause(),s({stream:d,buffer:i,ended:!1})},o=k=>(t.dispose(),r(k)),l=()=>(t.dispose(),s({stream:d,buffer:i,ended:!0}));t.add((0,D.$Pc)(()=>d.removeListener("error",o))),d.on("error",o),t.add((0,D.$Pc)(()=>d.removeListener("end",l))),d.on("end",l),t.add((0,D.$Pc)(()=>d.removeListener("data",n))),d.on("data",n)})}e.$7d=f;function P(d,w){const s=v(w);return s.end(d),s}e.$8d=P;function y(){const d=v(()=>{throw new Error("not supported")});return d.end(),d}e.$9d=y;function $(d){let w=!1;return{read:()=>w?null:(w=!0,d)}}e.$0d=$;function h(d,w,s){const r=v(s);return g(d,{onData:t=>r.write(w.data(t)),onError:t=>r.error(w.error?w.error(t):t),onEnd:()=>r.end()}),r}e.$$d=h;function b(d,w,s){let r=!1;return{read:()=>{const t=w.read();return r?t:(r=!0,t!==null?s([d,t]):d)}}}e.$_d=b;function O(d,w,s){let r=!1;const t=v(s);return g(w,{onData:i=>r?t.write(i):(r=!0,t.write(s([d,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(d)),t.end()}}),t}e.$ae=O}),define(te[14],ne([0,1,164,45]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const R=typeof Buffer<"u",A=new L.$U(()=>new Uint8Array(256));let j,v;class u{static alloc(N){return R?new u(Buffer.allocUnsafe(N)):new u(new Uint8Array(N))}static wrap(N){return R&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new u(N)}static fromString(N,B){return!(B?.dontUseNodeBuffer||!1)&&R?new u(Buffer.from(N)):(j||(j=new TextEncoder),new u(j.encode(N)))}static fromByteArray(N){const B=u.alloc(N.length);for(let _=0,ee=N.length;_<ee;_++)B.buffer[_]=N[_];return B}static concat(N,B){if(typeof B>"u"){B=0;for(let oe=0,se=N.length;oe<se;oe++)B+=N[oe].byteLength}const _=u.alloc(B);let ee=0;for(let oe=0,se=N.length;oe<se;oe++){const ue=N[oe];_.set(ue,ee),ee+=ue.byteLength}return _}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=u.alloc(this.byteLength);return N.set(this),N}toString(){return R?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(N,B){return new u(this.buffer.subarray(N,B))}set(N,B){if(N instanceof u)this.buffer.set(N.buffer,B);else if(N instanceof Uint8Array)this.buffer.set(N,B);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),B);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return g(this.buffer,N)}writeUInt32BE(N,B){f(this.buffer,N,B)}readUInt32LE(N){return P(this.buffer,N)}writeUInt32LE(N,B){y(this.buffer,N,B)}readUInt8(N){return $(this.buffer,N)}writeUInt8(N,B){h(this.buffer,N,B)}indexOf(N,B=0){return c(this.buffer,N instanceof u?N.buffer:N,B)}}e.$be=u;function c(p,N,B=0){const _=N.byteLength,ee=p.byteLength;if(_===0)return 0;if(_===1)return p.indexOf(N[0]);if(_>ee-B)return-1;const oe=A.value;oe.fill(N.length);for(let re=0;re<N.length;re++)oe[N[re]]=N.length-re-1;let se=B+N.length-1,ue=se,ce=-1;for(;se<ee;)if(p[se]===N[ue]){if(ue===0){ce=se;break}se--,ue--}else se+=Math.max(N.length-ue,oe[p[se]]),ue=N.length-1;return ce}e.$ce=c;function S(p,N){return p[N+0]<<0>>>0|p[N+1]<<8>>>0}e.$de=S;function I(p,N,B){p[B+0]=N&255,N=N>>>8,p[B+1]=N&255}e.$ee=I;function g(p,N){return p[N]*2**24+p[N+1]*2**16+p[N+2]*2**8+p[N+3]}e.$fe=g;function f(p,N,B){p[B+3]=N,N=N>>>8,p[B+2]=N,N=N>>>8,p[B+1]=N,N=N>>>8,p[B]=N}e.$ge=f;function P(p,N){return p[N+0]<<0>>>0|p[N+1]<<8>>>0|p[N+2]<<16>>>0|p[N+3]<<24>>>0}e.$he=P;function y(p,N,B){p[B+0]=N&255,N=N>>>8,p[B+1]=N&255,N=N>>>8,p[B+2]=N&255,N=N>>>8,p[B+3]=N&255}e.$ie=y;function $(p,N){return p[N]}e.$je=$;function h(p,N,B){p[B]=N}e.$ke=h;function b(p){return D.$3d(p,N=>u.concat(N))}e.$le=b;function O(p){return D.$0d(p)}e.$me=O;function d(p){return D.$5d(p,N=>u.concat(N))}e.$ne=d;async function w(p){return p.ended?u.concat(p.buffer):u.concat([...p.buffer,await d(p.stream)])}e.$oe=w;function s(p){return D.$8d(p,N=>u.concat(N))}e.$pe=s;function r(p){return D.$$d(p,{data:N=>typeof N=="string"?u.fromString(N):u.wrap(N)},N=>u.concat(N))}e.$qe=r;function t(p){return D.$2d(N=>u.concat(N),p)}e.$re=t;function i(p,N){return D.$_d(p,N,B=>u.concat(B))}e.$se=i;function n(p,N){return D.$ae(p,N,B=>u.concat(B))}e.$te=n;function o(p){let N=0,B=0,_=0;const ee=new Uint8Array(Math.floor(p.length/4*3)),oe=ue=>{switch(B){case 3:ee[_++]=N|ue,B=0;break;case 2:ee[_++]=N|ue>>>2,N=ue<<6,B=3;break;case 1:ee[_++]=N|ue>>>4,N=ue<<4,B=2;break;default:N=ue<<2,B=1}};for(let ue=0;ue<p.length;ue++){const ce=p.charCodeAt(ue);if(ce>=65&&ce<=90)oe(ce-65);else if(ce>=97&&ce<=122)oe(ce-97+26);else if(ce>=48&&ce<=57)oe(ce-48+52);else if(ce===43||ce===45)oe(62);else if(ce===47||ce===95)oe(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${p[ue]}`)}}const se=_;for(;B>0;)oe(0);return u.wrap(ee).slice(0,se)}e.$ue=o;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:p},N=!0,B=!1){const _=B?k:l;let ee="";const oe=p.byteLength%3;let se=0;for(;se<p.byteLength-oe;se+=3){const ue=p[se+0],ce=p[se+1],re=p[se+2];ee+=_[ue>>>2],ee+=_[(ue<<4|ce>>>4)&63],ee+=_[(ce<<2|re>>>6)&63],ee+=_[re&63]}if(oe===1){const ue=p[se+0];ee+=_[ue>>>2],ee+=_[ue<<4&63],N&&(ee+="==")}else if(oe===2){const ue=p[se+0],ce=p[se+1];ee+=_[ue>>>2],ee+=_[(ue<<4|ce>>>4)&63],ee+=_[ce<<2&63],N&&(ee+="=")}return ee}e.$ve=E}),define(te[41],ne([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=void 0;function D(h){return R(h,0)}e.$Di=D;function R(h,b){switch(typeof h){case"object":return h===null?A(349,b):Array.isArray(h)?u(h,b):c(h,b);case"string":return v(h,b);case"boolean":return j(h,b);case"number":return A(h,b);case"undefined":return A(937,b);default:return A(617,b)}}e.$Ei=R;function A(h,b){return(b<<5)-b+h|0}e.$Fi=A;function j(h,b){return A(h?433:863,b)}function v(h,b){b=A(149417,b);for(let O=0,d=h.length;O<d;O++)b=A(h.charCodeAt(O),b);return b}e.$Gi=v;function u(h,b){return b=A(104579,b),h.reduce((O,d)=>R(d,O),b)}function c(h,b){return b=A(181387,b),Object.keys(h).sort().reduce((O,d)=>(O=v(d,O),R(h[d],O)),b)}class S{constructor(){this.g=0}get value(){return this.g}hash(b){return this.g=R(b,this.g),this.g}}e.$Hi=S;var I;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function g(h,b,O=32){const d=O-b,w=~((1<<d)-1);return(h<<b|(w&h)>>>d)>>>0}function f(h,b=0,O=h.byteLength,d=0){for(let w=0;w<O;w++)h[b+w]=d}function P(h,b,O="0"){for(;h.length<b;)h=O+h;return h}function y(h,b=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(O=>O.toString(16).padStart(2,"0")).join(""):P((h>>>0).toString(16),b/4)}e.$Ii=y;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(b){const O=b.length;if(O===0)return;const d=this.p;let w=this.r,s=this.u,r,t;for(s!==0?(r=s,t=-1,s=0):(r=b.charCodeAt(0),t=0);;){let i=r;if(L.$6e(r))if(t+1<O){const n=b.charCodeAt(t+1);L.$7e(n)?(t++,i=L.$8e(r,n)):i=65533}else{s=r;break}else L.$7e(r)&&(i=65533);if(w=this.w(d,w,i),t++,t<O)r=b.charCodeAt(t);else break}this.r=w,this.u=s}w(b,O,d){return d<128?b[O++]=d:d<2048?(b[O++]=192|(d&1984)>>>6,b[O++]=128|(d&63)>>>0):d<65536?(b[O++]=224|(d&61440)>>>12,b[O++]=128|(d&4032)>>>6,b[O++]=128|(d&63)>>>0):(b[O++]=240|(d&1835008)>>>18,b[O++]=128|(d&258048)>>>12,b[O++]=128|(d&4032)>>>6,b[O++]=128|(d&63)>>>0),O>=64&&(this.y(),O-=64,this.t+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),O}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const b=8*this.t;this.q.setUint32(56,Math.floor(b/4294967296),!1),this.q.setUint32(60,b%4294967296,!1),this.y()}y(){const b=$.g,O=this.q;for(let l=0;l<64;l+=4)b.setUint32(l,O.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)b.setUint32(l,g(b.getUint32(l-12,!1)^b.getUint32(l-32,!1)^b.getUint32(l-56,!1)^b.getUint32(l-64,!1),1),!1);let d=this.h,w=this.l,s=this.m,r=this.n,t=this.o,i,n,o;for(let l=0;l<80;l++)l<20?(i=w&s|~w&r,n=1518500249):l<40?(i=w^s^r,n=1859775393):l<60?(i=w&s|w&r|s&r,n=2400959708):(i=w^s^r,n=3395469782),o=g(d,5)+i+t+n+b.getUint32(l*4,!1)&4294967295,t=r,r=s,s=g(w,30),w=d,d=o;this.h=this.h+d&4294967295,this.l=this.l+w&4294967295,this.m=this.m+s&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$Ji=$}),define(te[54],ne([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const A="error",j="warning",v="warn",u="info",c="ignore";function S(g){return g?L.$2e(A,g)?R.Error:L.$2e(j,g)||L.$2e(v,g)?R.Warning:L.$2e(u,g)?R.Info:R.Ignore:R.Ignore}R.fromValue=S;function I(g){switch(g){case R.Error:return A;case R.Warning:return j;case R.Info:return u;default:return c}}R.toString=I}(D||(D={})),e.default=D}),define(te[30],ne([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function D(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const w=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([s,r])=>{w[s]=r&&typeof r=="object"?D(r):r}),w}e.$7m=D;function R(d){if(!d||typeof d!="object")return d;const w=[d];for(;w.length>0;){const s=w.shift();Object.freeze(s);for(const r in s)if(A.call(s,r)){const t=s[r];typeof t=="object"&&!Object.isFrozen(t)&&!(0,L.$Bf)(t)&&w.push(t)}}return d}e.$8m=R;const A=Object.prototype.hasOwnProperty;function j(d,w){return v(d,w,new Set)}e.$9m=j;function v(d,w,s){if((0,L.$Hf)(d))return d;const r=w(d);if(typeof r<"u")return r;if(Array.isArray(d)){const t=[];for(const i of d)t.push(v(i,w,s));return t}if((0,L.$Af)(d)){if(s.has(d))throw new Error("Cannot clone recursive data-structure");s.add(d);const t={};for(const i in d)A.call(d,i)&&(t[i]=v(d[i],w,s));return s.delete(d),t}return d}function u(d,w,s=!0){return(0,L.$Af)(d)?((0,L.$Af)(w)&&Object.keys(w).forEach(r=>{r in d?s&&((0,L.$Af)(d[r])&&(0,L.$Af)(w[r])?u(d[r],w[r],s):d[r]=w[r]):d[r]=w[r]}),d):w}e.$0m=u;function c(d,w){if(d===w)return!0;if(d==null||w===null||w===void 0||typeof d!=typeof w||typeof d!="object"||Array.isArray(d)!==Array.isArray(w))return!1;let s,r;if(Array.isArray(d)){if(d.length!==w.length)return!1;for(s=0;s<d.length;s++)if(!c(d[s],w[s]))return!1}else{const t=[];for(r in d)t.push(r);t.sort();const i=[];for(r in w)i.push(r);if(i.sort(),!c(t,i))return!1;for(s=0;s<t.length;s++)if(!c(d[t[s]],w[t[s]]))return!1}return!0}e.$$m=c;function S(d){const w=new Set;return JSON.stringify(d,(s,r)=>{if((0,L.$Af)(r)||Array.isArray(r)){if(w.has(r))return"[Circular]";w.add(r)}return r})}e.$_m=S;function I(d,w){const s=Object.create(null);return!d||!w||Object.keys(w).forEach(t=>{const i=d[t],n=w[t];c(i,n)||(s[t]=n)}),s}e.$an=I;function g(d,w){const s=w.toLowerCase(),r=Object.keys(d).find(t=>t.toLowerCase()===s);return r?d[r]:d[w]}e.$bn=g;function f(d,w){const s=Object.create(null);for(const[r,t]of Object.entries(d))w(r,t)&&(s[r]=t);return s}e.$cn=f;function P(d){let w=[];for(;Object.prototype!==d;)w=w.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return w}e.$dn=P;function y(d){const w=[];for(const s of P(d))typeof d[s]=="function"&&w.push(s);return w}e.$en=y;function $(d,w){const s=t=>function(){const i=Array.prototype.slice.call(arguments,0);return w(t,i)},r={};for(const t of d)r[t]=s(t);return r}e.$fn=$;function h(d,w,s){typeof w=="string"&&d[w]!==void 0&&typeof d[w]!="boolean"&&(d[w]=s)}e.$gn=h;function b(d,w,s){typeof w=="string"&&d[w]!==void 0&&typeof d[w]!="number"&&(d[w]=s)}e.$hn=b;function O(d,w,s,r){if(typeof w!="string")return;const t=d[w];t!==void 0&&(typeof t!="string"||!s.includes(t))&&(d[w]=r)}e.$in=O}),define(te[28],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return L.test(R)}e.$dg=D,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(v){for(let u=0;u<v.length;u++)v[u]=Math.floor(Math.random()*256);return v};const A=new Uint8Array(16),j=[];for(let v=0;v<256;v++)j.push(v.toString(16).padStart(2,"0"));return function(){R(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,c="";return c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c}}()}),define(te[74],ne([0,1,33]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(j){const v=j.replace(/\-/g,":").toLowerCase();return!D.has(v)}function A(){const j=(0,L.networkInterfaces)();for(const v in j){const u=j[v];if(u){for(const{mac:c}of u)if(R(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Qm=A}),define(te[75],ne([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[76],ne([0,1,75]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const D=60,R=D*60,A=R*24,j=A*7,v=A*30,u=A*365;function c(I,g,f,P){typeof I!="number"&&(I=I.getTime());const y=Math.round((new Date().getTime()-I)/1e3);if(y<-30)return(0,L.localize)(0,null,c(new Date().getTime()+y*1e3,!1));if(!P&&y<30)return(0,L.localize)(1,null);let $;return y<D?($=y,g?$===1?f?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):f?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?f?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):f?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):y<R?($=Math.floor(y/D),g?$===1?f?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):f?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?f?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):f?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):y<A?($=Math.floor(y/R),g?$===1?f?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):f?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?f?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):f?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):y<j?($=Math.floor(y/A),g?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):y<v?($=Math.floor(y/j),g?$===1?f?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):f?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?f?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):f?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):y<u?($=Math.floor(y/v),g?$===1?f?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):f?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?f?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):f?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(y/u),g?$===1?f?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):f?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?f?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):f?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$dm=c;function S(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=S}),define(te[77],ne([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[34],ne([0,1,19,3,77]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function A(I,g){return g&&(I.stack||I.stacktrace)?R.localize(0,null,v(I),j(I.stack)||j(I.stacktrace)):v(I)}function j(I){return Array.isArray(I)?I.join(`
`):I}function v(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?R.localize(1,null,I.message):I.message||R.localize(2,null)}function u(I=null,g=!1){if(!I)return R.localize(3,null);if(Array.isArray(I)){const f=L.$Gb(I),P=u(f[0],g);return f.length>1?R.localize(4,null,P,f.length):P}if(D.$yf(I))return I;if(I.detail){const f=I.detail;if(f.error)return A(f.error,g);if(f.exception)return A(f.exception,g)}return I.stack?A(I,g):I.message?I.message:R.localize(5,null)}e.$Ai=u;function c(I){const g=I;return g instanceof Error&&Array.isArray(g.actions)}e.$Bi=c;function S(I,g){let f;return typeof I=="string"?f=new Error(I):f=I,f.actions=g,f}e.$Ci=S}),define(te[78],ne([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(te[79],ne([0,1,78]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;function D(R){switch(R){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$zp=D}),define(te[55],ne([0,1,13]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0;var D;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(D||(e.Source=D={}));var R;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function A(v,...u){const c=u.reduce((g,f)=>(g[f]=!0,g),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(g=>!c[g]).forEach(g=>{for(let f=0;f<S.length;f++)if(g.search(S[f])!==-1){delete v[g];break}})}e.$zl=A;function j(v){v&&(delete v.DEBUG,L.$k&&delete v.DYLD_LIBRARY_PATH,L.$l&&delete v.LD_PRELOAD)}e.$Al=j}),define(te[80],ne([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$3p=e.$2p=e.$1p=void 0;function D(c){const S=c;return S&&typeof S.type=="string"&&typeof S.severity=="string"}e.$1p=D;function R(c){const S=[];let I;try{const g=JSON.parse(c.arguments),f=g[g.length-1];f&&f.__$stack&&(g.pop(),I=f.__$stack),S.push(...g)}catch{S.push("Unable to log remote console arguments",c.arguments)}return{args:S,stack:I}}e.$2p=R;function A(c){if(typeof c!="string")return A(R(c).stack);const S=c;if(S){const I=j(S),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(g&&g.length===4)return{uri:L.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.$3p=A;function j(c){if(!c)return c;const S=c.indexOf(`
`);return S===-1?c:c.substring(0,S)}function v(c,S){const{args:I,stack:g}=R(c),f=typeof I[0]=="string"&&I.length===1;let P=j(g);P&&(P=`(${P.trim()})`);let y=[];if(typeof I[0]=="string"?P&&f?y=[`%c[${S}] %c${I[0]} %c${P}`,u("blue"),u(""),u("grey")]:y=[`%c[${S}] %c${I[0]}`,u("blue"),u(""),...I.slice(1)]:y=[`%c[${S}]%`,u("blue"),...I],P&&!f&&y.push(P),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,y)}e.log=v;function u(c){return`color: ${c}`}}),define(te[46],ne([0,1,14,11]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function R(u){return JSON.stringify(u,j)}e.$kh=R;function A(u){let c=JSON.parse(u);return c=v(c),c}e.$lh=A;function j(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function v(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof L.$be||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let S=0;S<u.length;++S)u[S]=v(u[S],c+1);else for(const S in u)Object.hasOwnProperty.call(u,S)&&(u[S]=v(u[S],c+1))}return u}e.$mh=v}),define(te[81],ne([0,1,70,15,13,11]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=void 0;class j{constructor(g,f,P){this.id=g,this.dependencies=f,this.callback=P}}class v{static{this.INSTANCE=new v}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,f,P)=>{typeof g!="string"&&(P=f,f=g,g=null),(typeof f!="object"||!Array.isArray(f))&&(P=f,f=null),this.c.push(new j(g,f,P))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const f=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!f)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(g){return new Promise((f,P)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const $=()=>{y.removeEventListener("load",h),y.removeEventListener("error",b)},h=O=>{$(),f(this.c.pop())},b=O=>{$(),P(O)};y.addEventListener("load",h),y.addEventListener("error",b),this.f&&(g=this.f.createScriptURL(g)),y.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(y)})}i(g){return new Promise((f,P)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),f(this.c.pop())}catch(y){P(y)}})}async j(g){try{const f=globalThis._VSCODE_NODE_MODULES.fs,P=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,$=A.URI.parse(g).fsPath,h=f.readFileSync($).toString(),b=y.wrap(h.replace(/^#!.*/,""));return new P.Script(b).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const u=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function S(I,g,f){if(L.$S){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[I]&&(I=c[I]);const P=`${I}/${g}`;if(u.has(P))return u.get(P);let y;if(/^\w[\w\d+.-]*:\/\//.test(P))y=P;else{const O=`${f&&!R.$p?D.$_f:D.$$f}/${P}`;y=D.$cg.asBrowserUri(O).toString(!0)}const $=v.INSTANCE.load(y);return u.set(P,$),$}else return await new Promise((P,y)=>{J([I],P,y)})}e.$zC=S}),define(te[82],ne([0,1,33,47,28,74,13]),function(J,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0,e.$Rm=new class{c(g){return this.a||(this.a=D.$Vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(g)}value(){if(this.b===void 0){let g=0,f=0;const P=(0,L.networkInterfaces)();for(const y in P){const $=P[y];if($)for(const{mac:h,internal:b}of $)b||(f+=1,this.c(h.toUpperCase())&&(g+=1))}this.b=f>0?g/f:0}return this.b}};let v;async function u(g){return v||(v=(async()=>await c(g)||R.$eg())()),v}e.$Sm=u;async function c(g){try{const f=await new Promise((y,$)=>{J(["crypto"],y,$)}),P=(0,A.$Qm)();return f.createHash("sha256").update(P,"utf8").digest("hex")}catch(f){g(f);return}}const S="Software\\Microsoft\\SQMClient";async function I(g){if(j.$j){const f=await new Promise((P,y)=>{J(["@vscode/windows-registry"],P,y)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",S,"MachineId")||""}catch(P){return g(P),""}}return""}e.$Tm=I}),define(te[83],ne([0,1,33,16,24]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=void 0;const A=/^\d+$/,j=/^Microsoft.PowerShell_.*/,v=/^Microsoft.PowerShellPreview_.*/;var u;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class I{constructor(w,s,r){this.exePath=w,this.displayName=s,this.a=r}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:d=!1}={}){return d?c===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:d=!1,findPreview:w=!1}={}){const s=g({useAlternateBitness:d});if(!s)return null;const r=D.$ic(s,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let t=-1,i=null;for(const l of await R.Promises.readdir(r)){let k=-1;if(w){const p=l.indexOf("-");if(p<0)continue;const N=l.substring(0,p);if(!A.test(N)||l.substring(p+1)!=="preview")continue;k=parseInt(N,10)}else{if(!A.test(l))continue;k=parseInt(l,10)}if(k<=t)continue;const E=D.$ic(r,l,"pwsh.exe");await R.SymlinkSupport.existsFile(E)&&(i=E,t=k)}if(!i)return null;const n=s.includes("x86")?" (x86)":"",o=w?" Preview":"";return new I(i,`PowerShell${o}${n}`,!0)}async function P({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const w=D.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(w))return null;const{pwshMsixDirRegex:s,pwshMsixName:r}=d?{pwshMsixDirRegex:v,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(w))if(s.test(t)){const i=D.$ic(w,t,"pwsh.exe");return new I(i,r)}return null}function y(){const d=D.$ic(L.homedir(),".dotnet","tools","pwsh.exe");return new I(d,".NET Core PowerShell Global Tool")}function $(){const d=D.$ic(process.env.windir,c===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(d,"Windows PowerShell",!0)}async function*h(){let d=await f();d&&(yield d),d=await f({useAlternateBitness:!0}),d&&(yield d),d=await P(),d&&(yield d),d=y(),d&&(yield d),d=await f({findPreview:!0}),d&&(yield d),d=await P({findPreview:!0}),d&&(yield d),d=await f({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=$(),d&&(yield d)}async function*b(){for await(const d of h())await d.exists()&&(yield d)}e.$xl=b;async function O(){for await(const d of b())return d;return null}e.$yl=O}),define(te[56],ne([0,1,16,13,35,55,3,24]),function(J,e,L,D,R,A,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(I=R.env){return I.comspec||"cmd.exe"}e.$Bl=u;function c(I){let g=[],f=!1;const P=function(y){if(f){g.push(y);return}(!I.send(y,h=>{if(h&&console.error(h),f=!1,g.length>0){const b=g.slice(0);g=[],b.forEach(O=>P(O))}})||D.$j)&&(f=!0)};return{send:P}}e.$Cl=c;var S;(function(I){async function g(f,P,y){if(L.$hc(f))return f;if(P===void 0&&(P=R.cwd()),L.$lc(f)!=="."||(y===void 0&&j.$yf(R.env.PATH)&&(y=R.env.PATH.split(L.$sc)),y===void 0||y.length===0))return L.$ic(P,f);async function h(b){if(await v.Promises.exists(b)){let O;try{O=await v.Promises.stat(b)}catch(d){d.message.startsWith("EACCES")&&(O=await v.Promises.lstat(b))}return O?!O.isDirectory():!1}return!1}for(const b of y){let O;if(L.$hc(b)?O=L.$ic(b,f):O=L.$ic(P,b,f),await h(O))return O;let d=O+".com";if(await h(d)||(d=O+".exe",await h(d)))return d}return L.$ic(P,f)}I.findExecutable=g})(S||(e.win32=S={}))}),define(te[84],ne([0,1,33,13,83,56]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=void 0;async function j(I,g){return I===1?D.$j?S():A.$Bl(g):u(I,g)}e.$Dl=j;let v=null;function u(I,g){if(D.$l&&I===2||D.$k&&I===3)return"/bin/bash";if(!v){let f;if(D.$j)f="/bin/bash";else{if(f=g.SHELL,!f)try{f=(0,L.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}v=f}return v}let c=null;async function S(){return c||(c=(await(0,R.$yl)()).exePath),c}});var pe=this&&this.__decorate||function(J,e,L,D){var R=arguments.length,A=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,L,D);else for(var v=J.length-1;v>=0;v--)(j=J[v])&&(A=(R<3?j(A):R>3?j(e,L,A):j(e,L))||A);return R>3&&A&&Object.defineProperty(e,L,A),A};define(te[57],ne([0,1,19,8,14,20,52,9,4,2,46,29,3]),function(J,e,L,D,R,A,j,v,u,c,S,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.ProxyChannel=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.RequestInitiator=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;var f;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(f||(f={}));function P(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(y||(y={}));function $(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(h||(h={}));function b(T){let M=0;for(let H=0;;H+=7){const G=T.read(1);if(M|=(G.buffer[0]&127)<<H,!(G.buffer[0]&128))return M}}const O=t(0);function d(T,M){if(M===0){T.write(O);return}let H=0;for(let Q=M;Q!==0;Q=Q>>>7)H++;const G=R.$be.alloc(H);for(let Q=0;M!==0;Q++)G.buffer[Q]=M&127,M=M>>>7,M>0&&(G.buffer[Q]|=128);T.write(G)}class w{constructor(M){this.b=M,this.a=0}read(M){const H=this.b.slice(this.a,this.a+M);return this.a+=H.byteLength,H}}e.$nh=w;class s{constructor(){this.a=[]}get buffer(){return R.$be.concat(this.a)}write(M){this.a.push(M)}}e.$oh=s;var r;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(r||(r={}));function t(T){const M=R.$be.alloc(1);return M.writeUInt8(T,0),M}const i={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},n=typeof Buffer<"u";function o(T,M){if(typeof M>"u")T.write(i.Undefined);else if(typeof M=="string"){const H=R.$be.fromString(M);T.write(i.String),d(T,H.byteLength),T.write(H)}else if(n&&Buffer.isBuffer(M)){const H=R.$be.wrap(M);T.write(i.Buffer),d(T,H.byteLength),T.write(H)}else if(M instanceof R.$be)T.write(i.VSBuffer),d(T,M.byteLength),T.write(M);else if(Array.isArray(M)){T.write(i.Array),d(T,M.length);for(const H of M)o(T,H)}else if(typeof M=="number"&&(M|0)===M)T.write(i.Uint),d(T,M);else{const H=R.$be.fromString(JSON.stringify(M));T.write(i.Object),d(T,H.byteLength),T.write(H)}}e.$ph=o;function l(T){switch(T.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return T.read(b(T)).toString();case r.Buffer:return T.read(b(T)).buffer;case r.VSBuffer:return T.read(b(T));case r.Array:{const H=b(T),G=[];for(let Q=0;Q<H;Q++)G.push(l(T));return G}case r.Object:return JSON.parse(T.read(b(T)).toString());case r.Int:return b(T)}}e.$qh=l;class k{constructor(M,H,G=null,Q=1e3){this.h=M,this.j=H,this.k=G,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(M,H){this.b.set(M,H),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const H=this.o([M.type]);this.k?.logOutgoing(H,0,1,$(M.type));return}case 201:case 202:case 204:case 203:{const H=this.o([M.type,M.id],M.data);this.k?.logOutgoing(H,M.id,1,$(M.type),M.data);return}}}o(M,H=void 0){const G=new s;return o(G,M),o(G,H),this.p(G.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const H=new w(M),G=l(H),Q=l(H),Y=G[0];switch(Y){case 100:return this.k?.logIncoming(M.byteLength,G[1],1,`${P(Y)}: ${G[2]}.${G[3]}`,Q),this.s({type:Y,id:G[1],channelName:G[2],name:G[3],arg:Q});case 102:return this.k?.logIncoming(M.byteLength,G[1],1,`${P(Y)}: ${G[2]}.${G[3]}`,Q),this.t({type:Y,id:G[1],channelName:G[2],name:G[3],arg:Q});case 101:return this.k?.logIncoming(M.byteLength,G[1],1,`${P(Y)}`),this.u({type:Y,id:G[1]});case 103:return this.k?.logIncoming(M.byteLength,G[1],1,`${P(Y)}`),this.u({type:Y,id:G[1]})}}s(M){const H=this.b.get(M.channelName);if(!H){this.v(M);return}const G=new A.$Xd;let Q;try{Q=H.call(this.j,M.name,M.arg,G.token)}catch(C){Q=Promise.reject(C)}const Y=M.id;Q.then(C=>{this.m({id:Y,data:C,type:201})},C=>{C instanceof Error?this.m({id:Y,data:{message:C.message,name:C.name,stack:C.stack?C.stack.split?C.stack.split(`
`):C.stack:void 0},type:202}):this.m({id:Y,data:C,type:203})}).finally(()=>{F.dispose(),this.d.delete(M.id)});const F=(0,c.$Pc)(()=>G.cancel());this.d.set(M.id,F)}t(M){const H=this.b.get(M.channelName);if(!H){this.v(M);return}const G=M.id,Y=H.listen(this.j,M.name,M.arg)(F=>this.m({id:G,data:F,type:204}));this.d.set(M.id,Y)}u(M){const H=this.d.get(M.id);H&&(H.dispose(),this.d.delete(M.id))}v(M){let H=this.g.get(M.channelName);H||(H=[],this.g.set(M.channelName,H));const G=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:M,timeoutTimer:G})}w(M){const H=this.g.get(M);if(H){for(const G of H)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$rh=k;var E;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));class p{constructor(M,H=null){this.l=M,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=H}getChannel(M){const H=this;return{call(G,Q,Y){return H.a?Promise.reject(new v.$4):H.m(M,G,Q,Y)},listen(G,Q){return H.a?u.Event.None:H.o(M,G,Q)}}}m(M,H,G,Q=A.CancellationToken.None){const Y=this.g++,C={id:Y,type:100,channelName:M,name:H,arg:G};if(Q.isCancellationRequested)return Promise.reject(new v.$4);let a;return new Promise((z,U)=>{if(Q.isCancellationRequested)return U(new v.$4);const Z=()=>{const me=de=>{switch(de.type){case 201:this.f.delete(Y),z(de.data);break;case 202:{this.f.delete(Y);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,U(ge);break}case 203:this.f.delete(Y),U(de.data);break}};this.f.set(Y,me),this.p(C)};let W=null;this.b===h.Idle?Z():(W=(0,D.$Hg)(me=>this.u()),W.then(()=>{W=null,Z()}));const le=()=>{W?(W.cancel(),W=null):this.p({id:Y,type:101}),U(new v.$4)},ae=Q.onCancellationRequested(le);a=(0,c.$Oc)((0,c.$Pc)(le),ae),this.d.add(a)}).finally(()=>{a.dispose(),this.d.delete(a)})}o(M,H,G){const Q=this.g++,F={id:Q,type:102,channelName:M,name:H,arg:G};let C=null;const a=new u.$Nd({onWillAddFirstListener:()=>{C=(0,D.$Hg)(z=>this.u()),C.then(()=>{C=null,this.d.add(a),this.p(F)})},onDidRemoveLastListener:()=>{C?(C.cancel(),C=null):(this.d.delete(a),this.p({id:Q,type:103}))}}),m=z=>a.fire(z.data);return this.f.set(Q,m),a.event}p(M){switch(M.type){case 100:case 102:{const H=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(H,M.id,0,`${P(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const H=this.q([M.type,M.id]);this.j?.logOutgoing(H,M.id,0,P(M.type));return}}}q(M,H=void 0){const G=new s;return o(G,M),o(G,H),this.r(G.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const H=new w(M),G=l(H),Q=l(H),Y=G[0];switch(Y){case 200:return this.j?.logIncoming(M.byteLength,0,0,$(Y)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,G[1],0,$(Y),Q),this.t({type:G[0],id:G[1],data:Q})}}t(M){if(M.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$sh=p,pe([j.$hh],p.prototype,"onDidInitializePromise",null);class N{get connections(){const M=[];return this.f.forEach(H=>M.push(H)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new u.$Nd,this.onDidAddConnection=this.g.event,this.h=new u.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new c.$Qc,this.j.add(M(({protocol:H,onDidClientDisconnect:G})=>{const Q=u.Event.once(H.onMessage);this.j.add(Q(Y=>{const F=new w(Y),C=l(F),a=new k(H,C),m=new p(H);this.a.forEach((U,Z)=>a.registerChannel(Z,U));const z={channelServer:a,channelClient:m,ctx:C};this.f.add(z),this.g.fire(z),this.j.add(G(()=>{a.dispose(),m.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(M,H){const G=this;return{call(Q,Y,F){let C;if((0,g.$Mf)(H)){const m=(0,L.$3b)(G.connections.filter(H));C=m?Promise.resolve(m):u.Event.toPromise(u.Event.filter(G.onDidAddConnection,H))}else C=H.routeCall(G,Q,Y);const a=C.then(m=>m.channelClient.getChannel(M));return _(a).call(Q,Y,F)},listen(Q,Y){if((0,g.$Mf)(H))return G.k(M,H,Q,Y);const F=H.routeEvent(G,Q,Y).then(C=>C.channelClient.getChannel(M));return _(F).listen(Q,Y)}}}k(M,H,G,Q){const Y=this;let F;const C=new u.$Nd({onWillAddFirstListener:()=>{F=new c.$Qc;const a=new u.$Td,m=new Map,z=Z=>{const le=Z.channelClient.getChannel(M).listen(G,Q),ae=a.add(le);m.set(Z,ae)},U=Z=>{const W=m.get(Z);W&&(W.dispose(),m.delete(Z))};Y.connections.filter(H).forEach(z),u.Event.filter(Y.onDidAddConnection,H)(z,void 0,F),Y.onDidRemoveConnection(U,void 0,F),a.event(C.fire,C,F),F.add(a)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return C.event}registerChannel(M,H){this.a.set(M,H);for(const G of this.f)G.channelServer.registerChannel(M,H)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$th=N;class B{constructor(M,H,G=null){const Q=new s;o(Q,H),M.send(Q.buffer),this.a=new p(M,G),this.d=new k(M,H,G)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,H){this.d.registerChannel(M,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$uh=B;function _(T){return{call(M,H,G){return T.then(Q=>Q.call(M,H,G))},listen(M,H){const G=new u.$Wd;return T.then(Q=>G.input=Q.listen(M,H)),G.event}}}e.$vh=_;function ee(T){let M=!1;return{call(H,G,Q){return M?T.call(H,G,Q):(0,D.$Ug)(0).then(()=>M=!0).then(()=>T.call(H,G,Q))},listen(H,G){if(M)return T.listen(H,G);const Q=new u.$Wd;return(0,D.$Ug)(0).then(()=>M=!0).then(()=>Q.input=T.listen(H,G)),Q.event}}}e.$wh=ee;class oe{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const H of M.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await u.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.$xh=oe;var se;(function(T){function M(Y,F,C){const a=Y,m=C&&C.disableMarshalling,z=new Map;for(const U in a)G(U)&&z.set(U,u.Event.buffer(a[U],!0,void 0,F));return new class{listen(U,Z,W){const le=z.get(Z);if(le)return le;if(Q(Z)){const ae=a[Z];if(typeof ae=="function")return ae.call(a,W)}throw new v.$ab(`Event not found: ${Z}`)}call(U,Z,W){const le=a[Z];if(typeof le=="function"){if(!m&&Array.isArray(W))for(let me=0;me<W.length;me++)W[me]=(0,S.$mh)(W[me]);let ae=le.apply(a,W);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new v.$ab(`Method not found: ${Z}`)}}}T.fromService=M;function H(Y,F){const C=F&&F.disableMarshalling;return new Proxy({},{get(a,m){if(typeof m=="string")return F?.properties?.has(m)?F.properties.get(m):Q(m)?function(z){return Y.listen(m,z)}:G(m)?Y.listen(m):async function(...z){let U;F&&!(0,g.$Hf)(F.context)?U=[F.context,...z]:U=z;const Z=await Y.call(m,U);return C?Z:(0,S.$mh)(Z)};throw new v.$ab(`Property not found: ${String(m)}`)}})}T.toService=H;function G(Y){return Y[0]==="o"&&Y[1]==="n"&&I.$1e(Y.charCodeAt(2))}function Q(Y){return/^onDynamic/.test(Y)&&I.$1e(Y.charCodeAt(9))}})(se||(e.ProxyChannel=se={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const M=T.toString();if(M!=="[object Object]")return M}return T}function re(T){return Array.isArray(T)?T.map(ce):ce(T)}function q(T,M,H,G,Q,Y,F){F=re(F);const C=ue[Q],a=C[G%C.length];let m=[`%c[${T}]%c[${String(M).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(Y)?(m=m.concat(F),m.push(")")):m.push(F),console.log.apply(console,m)}class X{constructor(M,H){this.d=M,this.f=H,this.a=0,this.b=0}logOutgoing(M,H,G,Q,Y){this.b+=M,q(this.d,this.b,M,H,G,Q,Y)}logIncoming(M,H,G,Q,Y){this.a+=M,q(this.f,this.a,M,H,G,Q,Y)}}e.$yh=X}),define(te[85],ne([0,1,58,8,14,20,80,9,4,2,30,56,55,57]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;class P extends f.$rh{constructor(h){super({send:b=>{try{process.send?.(b.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",b=>R.$be.wrap(Buffer.from(b,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$5p=P;class y{constructor(h,b){this.i=h,this.j=b,this.c=new Set,this.g=new Map,this.h=new u.$Nd,this.onDidProcessExit=this.h.event;const O=b&&b.timeout?b.timeout:6e4;this.b=new D.$Qg(O),this.d=null,this.f=null}getChannel(h){const b=this;return{call(O,d,w){return b.k(h,O,d,w)},listen(O,d){return b.l(h,O,d)}}}k(h,b,O,d=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(v.$5());this.b.cancel();const w=this.n(h),s=(0,D.$Hg)(i=>w.call(b,O,i)),r=d.onCancellationRequested(()=>s.cancel()),t=(0,c.$Pc)(()=>s.cancel());return this.c.add(t),s.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(h,b,O){if(!this.b)return u.Event.None;this.b.cancel();let d;const w=new u.$Nd({onWillAddFirstListener:()=>{d=this.n(h).listen(b,O)(w.fire,w),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return w.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],b=Object.create(null);b.env={...(0,S.$7m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(b.env={...b.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(b.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,g.$Al)(b.env),this.d=(0,L.fork)(this.i,h,b);const O=new u.$Nd;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,j.$1p)(n)){(0,j.log)(n,`IPC Library: ${this.j.serverName}`);return}O.fire(R.$be.wrap(Buffer.from(n,"base64")))});const w=this.j.useQueue?(0,I.$Cl)(this.d):this.d,s=n=>this.d&&this.d.connected&&w.send(n.buffer.toString("base64")),r=O.event,t={send:s,onMessage:r};this.f=new f.$sh(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,o)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,c.$Mc)(l)),this.c.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:o})})}return this.f}n(h){let b=this.g.get(h);return b||(b=this.m.getChannel(h),this.g.set(h,b)),b}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$6p=y}),define(te[86],ne([0,1,8,4,2,46,3]),function(J,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.StorageState=e.$4o=e.StorageHint=void 0;var v;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(v||(e.StorageHint=v={}));function u(g){const f=g;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$4o=u;var c;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(c||(e.StorageState=c={}));class S extends R.$Rc{static{this.a=100}constructor(f,P=Object.create(null)){super(),this.r=f,this.s=P,this.b=this.B(new D.$Qd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$Rg(S.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((P,y)=>this.w(y,P)),f.deleted?.forEach(P=>this.w(P,void 0))}finally{this.b.resume()}}w(f,P){if(this.c===c.Closed)return;let y=!1;(0,j.$Hf)(P)?y=this.f.delete(f):this.f.get(f)!==P&&(this.f.set(f,P),y=!0),y&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==v.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,P){const y=this.f.get(f);return(0,j.$Hf)(y)?P:y}getBoolean(f,P){const y=this.get(f);return(0,j.$Hf)(y)?P:y==="true"}getNumber(f,P){const y=this.get(f);return(0,j.$Hf)(y)?P:parseInt(y,10)}getObject(f,P){const y=this.get(f);return(0,j.$Hf)(y)?P:(0,A.$lh)(y)}async set(f,P,y=!1){if(this.c===c.Closed)return;if((0,j.$Hf)(P))return this.delete(f,y);const $=(0,j.$Af)(P)||Array.isArray(P)?(0,A.$kh)(P):String(P);if(this.f.get(f)!==$)return this.f.set(f,$),this.j.set(f,$),this.h.delete(f),this.b.fire({key:f,external:y}),this.D()}async delete(f,P=!1){if(!(this.c===c.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:P}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===v.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===v.STORAGE_IN_MEMORY}}e.$5o=S;class I{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((P,y)=>this.a.set(y,P)),f.delete?.forEach(P=>this.a.delete(P))}async optimize(){}async close(){}}e.$6o=I}),define(te[87],ne([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[88],ne([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[89],ne([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(te[90],ne([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(te[91],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[92],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[93],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(te[94],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[95],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[96],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[97],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[98],ne([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[99],ne([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[100],ne([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[101],ne([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[102],ne([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(te[103],ne([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[104],ne([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(te[105],ne([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[106],ne([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[107],ne([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(te[108],ne([0,1,9,90]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var R;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(R||(e.TokenType=R={}));function A(...c){switch(c.length){case 1:return(0,D.localize)(0,null,c[0]);case 2:return(0,D.localize)(1,null,c[0],c[1]);case 3:return(0,D.localize)(2,null,c[0],c[1],c[2]);default:return}}const j=(0,D.localize)(3,null),v=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return S.isTripleEq?"===":"==";case 4:return S.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return S.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return S.lexeme;case 18:return S.lexeme;case 19:return S.lexeme;case 20:return"EOF";default:throw(0,L.$7)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(S){return this.c=S,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(S){return this.r()||this.c.charCodeAt(this.e)!==S?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(S){this.f.push({type:S,offset:this.d})}l(S){const I=this.d,g=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:g};this.g.push({offset:I,lexeme:g,additionalInfo:S}),this.f.push(f)}n(){this.m.lastIndex=this.d;const S=this.m.exec(this.c);if(S){this.e=this.d+S[0].length;const I=this.c.substring(this.d,this.e),g=u.b.get(I);g?this.k(g):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let S=this.e,I=!1,g=!1;for(;;){if(S>=this.c.length){this.e=S,this.l(v);return}const P=this.c.charCodeAt(S);if(I)I=!1;else if(P===47&&!g){S++;break}else P===91?g=!0:P===92?I=!0:P===93&&(g=!1);S++}for(;S<this.c.length&&u.a.has(this.c.charCodeAt(S));)S++;this.e=S;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=u}),define(te[109],ne([0,1,76,52,15,16,35,17,11]),function(J,e,L,D,R,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.$lc)(R.$cg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$ic)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,v.$vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,v.$vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,L.$em)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$ic)(this.userDataPath,"logs",f)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,v.$vg)(u.URI.file((0,A.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,v.$vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,v.$vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,v.$vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=j.env.VSCODE_PORTABLE;return f?u.URI.file((0,A.$ic)(f,"argv.json")):(0,v.$vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.$jc)(f):(0,A.$gc)((0,A.$ic)(R.$cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?u.URI.file((0,A.$jc)(f)):u.URI.file((0,A.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.$jc)(f);const P=j.env.VSCODE_EXTENSIONS;if(P)return P;const y=j.env.VSCODE_PORTABLE;return y?(0,A.$ic)(y,"extensions"):(0,v.$vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(P=>/^[^:/?#]+?:\/\//.test(P)?u.URI.parse(P):u.URI.file((0,A.$gc)(P)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?u.URI.parse(f):u.URI.file((0,A.$gc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$fm.test(f))}get extensionLogLevel(){const f=[];for(const P of this.args.log||[]){const y=e.$fm.exec(P);y&&y[1]&&y[2]&&f.push([y[1],y[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,v.$vg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=j.env.VSCODE_PORTABLE;return f?u.URI.file((0,A.$ic)(f,"policy.json")):(0,v.$vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,P,y){this.a=f,this.b=P,this.c=y,this.editSessionId=this.args.editSessionId}}e.$gm=c,pe([D.$hh],c.prototype,"appRoot",null),pe([D.$hh],c.prototype,"userHome",null),pe([D.$hh],c.prototype,"userDataPath",null),pe([D.$hh],c.prototype,"appSettingsHome",null),pe([D.$hh],c.prototype,"tmpDir",null),pe([D.$hh],c.prototype,"cacheHome",null),pe([D.$hh],c.prototype,"stateResource",null),pe([D.$hh],c.prototype,"userRoamingDataHome",null),pe([D.$hh],c.prototype,"userDataSyncHome",null),pe([D.$hh],c.prototype,"sync",null),pe([D.$hh],c.prototype,"machineSettingsResource",null),pe([D.$hh],c.prototype,"workspaceStorageHome",null),pe([D.$hh],c.prototype,"localHistoryHome",null),pe([D.$hh],c.prototype,"keyboardLayoutResource",null),pe([D.$hh],c.prototype,"argvResource",null),pe([D.$hh],c.prototype,"isExtensionDevelopment",null),pe([D.$hh],c.prototype,"untitledWorkspacesHome",null),pe([D.$hh],c.prototype,"builtinExtensionsPath",null),pe([D.$hh],c.prototype,"extensionsPath",null),pe([D.$hh],c.prototype,"extensionDevelopmentLocationURI",null),pe([D.$hh],c.prototype,"extensionDevelopmentKind",null),pe([D.$hh],c.prototype,"extensionTestsLocationURI",null),pe([D.$hh],c.prototype,"debugExtensionHost",null),pe([D.$hh],c.prototype,"logLevel",null),pe([D.$hh],c.prototype,"extensionLogLevel",null),pe([D.$hh],c.prototype,"serviceMachineIdResource",null),pe([D.$hh],c.prototype,"disableTelemetry",null),pe([D.$hh],c.prototype,"disableWorkspaceTrust",null),pe([D.$hh],c.prototype,"useInMemorySecretStorage",null),pe([D.$hh],c.prototype,"policyFile",null);function S(g,f){return I(g["inspect-extensions"],g["inspect-brk-extensions"],5870,f,g.debugId,g.extensionEnvironment)}e.$hm=S;function I(g,f,P,y,$,h){const O=Number(f||g)||(y?null:P),d=O?!!f:!1;let w;if(h)try{w=JSON.parse(h)}catch{}return{port:O,break:d,debugId:$,env:w}}e.$im=I}),function(){"use strict";function J(e,L,D){function R(j,v){const u=A(j,v),c=[u];return e.isAbsolute(u)||c.unshift(D),e.resolve(...c)}function A(j,v){process.env.VSCODE_DEV&&(v="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,v);const S=j["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(I,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,v)}return{getUserDataPath:R}}if(typeof define=="function")define(te[110],ne([165,33,35]),function(e,L,D){return J(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[111],ne([0,1,33,109,110]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=e.$jm=void 0;class A extends D.$gm{constructor(c,S){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,R.getUserDataPath)(c,S.nameShort)},S)}}e.$jm=A;function j(u,c){return(0,D.$im)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}e.$km=j;function v(u,c){return(0,D.$im)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}e.$lm=v}),define(te[112],ne([0,1,3,94]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;function R(j,v,u,c){try{A(j,v,u,c)}catch(S){j.error(S?.message??S)}return v}e.$Ap=R;function A(j,v,u,c){const S=(I,g,f)=>{const P=I[g];if((0,L.$yf)(P)){const y=P,$=y.length;if($>1&&y[0]==="%"&&y[$-1]==="%"){const h=y.substr(1,$-2);let b=u[h];b===void 0&&c&&(b=c[h]);const O=typeof b=="string"?b:b?.message,d=c?.[h],w=typeof d=="string"?d:d?.message;if(!O){w||j.warn(`[${v.name}]: ${(0,D.localize)(0,null,h)}`);return}if(f&&(g==="title"||g==="category")&&w&&w!==O){const s={value:O,original:w};I[g]=s}else I[g]=O}}else if((0,L.$Af)(P))for(const y in P)P.hasOwnProperty(y)&&(y==="commands"?S(P,y,!0):S(P,y,f));else if(Array.isArray(P))for(let y=0;y<P.length;y++)S(P,y,f)};for(const I in v)v.hasOwnProperty(I)&&S(v,I)}}),define(te[48],ne([0,1,17,54,98,42]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function u(h){return h=h.trim(),h==="*"||j.test(h)}e.$Oo=u;function c(h){if(!u(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=h.match(j);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.$Po=c;function S(h){if(!h)return null;const b=h.majorBase,O=h.majorMustEqual,d=h.minorBase;let w=h.minorMustEqual;const s=h.patchBase;let r=h.patchMustEqual;h.hasCaret&&(b===0||(w=!1),r=!1);let t=0;if(h.preRelease){const i=v.exec(h.preRelease);if(i){const[,n,o,l]=i;t=Date.UTC(Number(n),Number(o)-1,Number(l))}}return{majorBase:b,majorMustEqual:O,minorBase:d,minorMustEqual:w,patchBase:s,patchMustEqual:r,isMinimum:h.hasGreaterEquals,notBefore:t}}e.$Qo=S;function I(h,b,O){let d;typeof h=="string"?d=S(c(h)):d=h;let w;b instanceof Date?w=b.getTime():typeof b=="string"&&(w=new Date(b).getTime());let s;if(typeof O=="string"?s=S(c(O)):s=O,!d||!s)return!1;const r=d.majorBase,t=d.minorBase,i=d.patchBase;let n=s.majorBase,o=s.minorBase,l=s.patchBase;const k=s.notBefore;let E=s.majorMustEqual,p=s.minorMustEqual,N=s.patchMustEqual;return s.isMinimum?r>n?!0:r<n?!1:t>o?!0:t<o||w&&w<k?!1:i>=l:(r===1&&n===0&&(!E||!p||!N)&&(n=1,o=0,l=0,E=!0,p=!1,N=!1),r<n?!1:r>n?!E:t<o?!1:t>o?!p:i<l?!1:i>l?!N:!(w&&w<k))}e.$Ro=I;function g(h,b,O,d,w){const s=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return s.push([D.default.Error,R.localize(0,null)]),s;if(typeof d.name!="string")return s.push([D.default.Error,R.localize(1,null,"name")]),s;if(typeof d.version!="string")return s.push([D.default.Error,R.localize(2,null,"version")]),s;if(!d.engines)return s.push([D.default.Error,R.localize(3,null,"engines")]),s;if(typeof d.engines.vscode!="string")return s.push([D.default.Error,R.localize(4,null,"engines.vscode")]),s;if(typeof d.extensionDependencies<"u"&&!$(d.extensionDependencies))return s.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),s;if(typeof d.activationEvents<"u"){if(!$(d.activationEvents))return s.push([D.default.Error,R.localize(6,null,"activationEvents")]),s;if(typeof d.main>"u"&&typeof d.browser>"u")return s.push([D.default.Error,R.localize(7,null,"activationEvents","main","browser")]),s}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&s.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return s.push([D.default.Error,R.localize(9,null,"main")]),s;{const i=(0,L.$vg)(O,d.main);(0,L.$pg)(i,O)||s.push([D.default.Warning,R.localize(10,null,i.path,O.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return s.push([D.default.Error,R.localize(11,null,"browser")]),s;{const i=(0,L.$vg)(O,d.browser);(0,L.$pg)(i,O)||s.push([D.default.Warning,R.localize(12,null,i.path,O.path)])}}if(!A.valid(d.version))return s.push([D.default.Error,R.localize(13,null)]),s;const r=[];if(!f(h,b,d,w,r))for(const i of r)s.push([D.default.Error,i]);return s}e.$So=g;function f(h,b,O,d,w){return d||typeof O.main>"u"&&typeof O.browser>"u"?!0:y(h,b,O.engines.vscode,w)}e.$To=f;function P(h,b,O){return h==="*"||y(b,O,h)}e.$Uo=P;function y(h,b,O,d=[]){const w=S(c(O));if(!w)return d.push(R.localize(14,null,O)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return d.push(R.localize(15,null,O)),!1}else if(!w.majorMustEqual)return d.push(R.localize(16,null,O)),!1;return I(h,b,w)?!0:(d.push(R.localize(17,null,h,O)),!1)}function $(h){if(!Array.isArray(h))return!1;for(let b=0,O=h.length;b<O;b++)if(typeof h[b]!="string")return!1;return!0}}),define(te[113],ne([0,1,14,28]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=void 0;async function R(A,j,v){let u=v&&v.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const S=(await j.readFile(A.serviceMachineIdResource)).value.toString();u=(0,D.$dg)(S)?S:null}catch{u=null}if(!u){u=(0,D.$eg)();try{await j.writeFile(A.serviceMachineIdResource,L.$be.fromString(u))}catch{}}return v?.store("storage.serviceMachineId",u,-1,1),u}e.$cp=R}),define(te[49],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class L{constructor(R,A=[],j=!1){this.ctor=R,this.staticArguments=A,this.supportsDelayedInstantiation=j}}e.$Mh=L}),define(te[114],ne([0,1,49]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=e.InstantiationType=void 0;const D=[];var R;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function A(v,u,c){u instanceof L.$Mh||(u=new L.$Mh(u,[],!!c)),D.push([v,u])}e.$zr=A;function j(){return D}e.$Ar=j}),define(te[115],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;class L{constructor(A,j){this.key=A,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$eq=L;class D{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const j of this.a.values())j.outgoing.size===0&&A.push(j);return A}insertEdge(A,j){const v=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(j);v.outgoing.set(u.key,u),u.incoming.set(v.key,v)}removeNode(A){const j=this.b(A);this.a.delete(j);for(const v of this.a.values())v.outgoing.delete(j),v.incoming.delete(j)}lookupOrInsertNode(A){const j=this.b(A);let v=this.a.get(j);return v||(v=new L(j,A),this.a.set(j,v)),v}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[j,v]of this.a)A.push(`${j}
	(-> incoming)[${[...v.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...v.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,j]of this.a){const v=new Set([A]),u=this.c(j,v);if(u)return u}}c(A,j){for(const[v,u]of A.outgoing){if(j.has(v))return[...j,v].join(" -> ");j.add(v);const c=this.c(u,j);if(c)return c;j.delete(v)}}}e.$fq=D}),define(te[25],ne([0,1,3,11,10]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,R.$Ph)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof D.URI)}e.$ki=A;function j(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof D.URI)}e.$li=j;var v;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(v||(e.ConfigurationTarget=v={}));function u(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=u;function c(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$ni=c;function S(h,b){const O=Object.create(null);for(const d in h)I(O,d,h[d],b);return O}e.$oi=S;function I(h,b,O,d){const w=b.split("."),s=w.pop();let r=h;for(let t=0;t<w.length;t++){const i=w[t];let n=r[i];switch(typeof n){case"undefined":n=r[i]=Object.create(null);break;case"object":break;default:d(`Ignoring ${b} as ${w.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}r=n}if(typeof r=="object"&&r!==null)try{r[s]=O}catch{d(`Ignoring ${b} as ${w.join(".")} is ${JSON.stringify(r)}`)}else d(`Ignoring ${b} as ${w.join(".")} is ${JSON.stringify(r)}`)}e.$pi=I;function g(h,b){const O=b.split(".");f(h,O)}e.$qi=g;function f(h,b){const O=b.shift();if(b.length===0){delete h[O];return}if(Object.keys(h).indexOf(O)!==-1){const d=h[O];typeof d=="object"&&!Array.isArray(d)&&(f(d,b),Object.keys(d).length===0&&delete h[O])}}function P(h,b,O){function d(r,t){let i=r;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const w=b.split("."),s=d(h,w);return typeof s>"u"?O:s}e.$ri=P;function y(h,b,O){Object.keys(b).forEach(d=>{d!=="__proto__"&&(d in h?L.$Af(h[d])&&L.$Af(b[d])?y(h[d],b[d],O):O&&(h[d]=b[d]):h[d]=b[d])})}e.$si=y;function $(h){return h.replace(/[\[\]]/g,"")}e.$ti=$}),define(te[116],ne([0,1,13,29,108,10,89,9]),function(J,e,L,D,R,A,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",L.$k),u.set("isLinux",L.$l),u.set("isWindows",L.$j),u.set("isWeb",L.$p),u.set("isMacNative",L.$k&&!L.$p),u.set("isEdge",L.$H),u.set("isFirefox",L.$F),u.set("isChrome",L.$E),u.set("isSafari",L.$G);function c(C,a){if(u.get(C)!==void 0)throw(0,v.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(C,a)}e.$Li=c;const S=Object.prototype.hasOwnProperty;var I;(function(C){C[C.False=0]="False",C[C.True=1]="True",C[C.Defined=2]="Defined",C[C.Not=3]="Not",C[C.Equals=4]="Equals",C[C.NotEquals=5]="NotEquals",C[C.And=6]="And",C[C.Regex=7]="Regex",C[C.NotRegex=8]="NotRegex",C[C.Or=9]="Or",C[C.In=10]="In",C[C.NotIn=11]="NotIn",C[C.Greater=12]="Greater",C[C.GreaterEquals=13]="GreaterEquals",C[C.Smaller=14]="Smaller",C[C.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const g={regexParsingWithErrorRecovery:!0},f=(0,j.localize)(0,null),P=(0,j.localize)(1,null),y=(0,j.localize)(2,null),$=(0,j.localize)(3,null),h=(0,j.localize)(4,null),b=(0,j.localize)(5,null),O=(0,j.localize)(6,null),d=(0,j.localize)(7,null);class w{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(a=g){this.k=a,this.d=new R.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(a){if(a===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:P});return}this.f=this.d.reset(a).scan(),this.g=0,this.h=[];try{const m=this.l();if(!this.E()){const z=this.D(),U=z.type===17?b:void 0;throw this.h.push({message:h,offset:z.offset,lexeme:R.$Ki.getLexeme(z),additionalInfo:U}),w.c}return m}catch(m){if(m!==w.c)throw m;return}}l(){return this.m()}m(){const a=[this.o()];for(;this.y(16);){const m=this.o();a.push(m)}return a.length===1?a[0]:s.or(...a)}o(){const a=[this.s()];for(;this.y(15);){const m=this.s();a.push(m)}return a.length===1?a[0]:s.and(...a)}s(){if(this.y(2)){const a=this.D();switch(a.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const m=this.l();return this.A(1,$),m?.negate()}case 17:return this.z(),B.create(a.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",a)}}return this.t()}t(){const a=this.D();switch(a.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const m=this.l();return this.A(1,$),m}case 17:{const m=a.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const Z=U.lexeme,W=Z.lastIndexOf("/"),le=W===Z.length-1?void 0:this.w(Z.substring(W+1));let ae;try{ae=new RegExp(Z.substring(1,W),le)}catch{throw this.B("REGEX",U)}return ce.create(m,ae)}switch(U.type){case 10:case 19:{const Z=[U.lexeme];this.z();let W=this.D(),le=0;for(let fe=0;fe<U.lexeme.length;fe++)U.lexeme.charCodeAt(fe)===40?le++:U.lexeme.charCodeAt(fe)===41&&le--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?le++:U.lexeme.charCodeAt(fe)===41&&le--}if(le<0)break;Z.push(R.$Ki.getLexeme(W)),this.z(),W=this.D()}const ae=Z.join(""),me=ae.lastIndexOf("/"),de=me===ae.length-1?void 0:this.w(ae.substring(me+1));let ge;try{ge=new RegExp(ae.substring(1,me),de)}catch{throw this.B("REGEX",U)}return s.regex(m,ge)}case 18:{const Z=U.lexeme;this.z();let W=null;if(!(0,D.$Be)(Z)){const le=Z.indexOf("/"),ae=Z.lastIndexOf("/");if(le!==ae&&le>=0){const me=Z.slice(le+1,ae),de=Z[ae+1]==="i"?"i":"";try{W=new RegExp(me,de)}catch{throw this.B("REGEX",U)}}}if(W===null)throw this.B("REGEX",U);return ce.create(m,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const U=this.u();return s.notIn(m,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return s.equals(m,U);switch(U){case"true":return s.has(m);case"false":return s.not(m);default:return s.equals(m,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return s.notEquals(m,U);switch(U){case"true":return s.not(m);case"false":return s.has(m);default:return s.notEquals(m,U)}}case 5:return this.z(),se.create(m,this.u());case 6:return this.z(),ue.create(m,this.u());case 7:return this.z(),ee.create(m,this.u());case 8:return this.z(),oe.create(m,this.u());case 13:return this.z(),s.in(m,this.u());default:return s.has(m)}}case 20:throw this.h.push({message:O,offset:a.offset,lexeme:"",additionalInfo:d}),w.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const a=this.D();switch(a.type){case 17:case 18:return this.z(),a.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(a){return a.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(a){return this.C(a)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(a,m){if(this.C(a))return this.z();throw this.B(m,this.D())}B(a,m,z){const U=(0,j.localize)(8,null,a,R.$Ki.getLexeme(m)),Z=m.offset,W=R.$Ki.getLexeme(m);return this.h.push({message:U,offset:Z,lexeme:W,additionalInfo:z}),w.c}C(a){return this.D().type===a}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=w;class s{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(a){return l.create(a)}static equals(a,m){return k.create(a,m)}static notEquals(a,m){return N.create(a,m)}static regex(a,m){return ce.create(a,m)}static in(a,m){return E.create(a,m)}static notIn(a,m){return p.create(a,m)}static not(a){return B.create(a)}static and(...a){return X.create(a,null,!0)}static or(...a){return T.create(a,null,!0)}static greater(a,m){return ee.create(a,m)}static greaterEquals(a,m){return oe.create(a,m)}static smaller(a,m){return se.create(a,m)}static smallerEquals(a,m){return ue.create(a,m)}static{this.c=new w({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this.c.parse(a)}}e.$Ni=s;function r(C){const a=new w({regexParsingWithErrorRecovery:!1});return C.map(m=>(a.parse(m),a.lexingErrors.length>0?a.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,j.localize)(9,null,z.additionalInfo):(0,j.localize)(10,null),offset:z.offset,length:z.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$Oi=r;function t(C,a){const m=C?C.substituteConstants():void 0,z=a?a.substituteConstants():void 0;return!m&&!z?!0:!m||!z?!1:m.equals(z)}e.$Pi=t;function i(C,a){return C.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return o.INSTANCE}}e.$Qi=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.$Ri=o;class l{static create(a,m=null){const z=u.get(a);return typeof z=="boolean"?z?o.INSTANCE:n.INSTANCE:new l(a,m)}constructor(a,m){this.key=a,this.c=m,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:H(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=u.get(this.key);return typeof a=="boolean"?a?o.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.c||(this.c=B.create(this.key,this)),this.c}}e.$Si=l;class k{static create(a,m,z=null){if(typeof m=="boolean")return m?l.create(a,z):B.create(a,z);const U=u.get(a);return typeof U=="boolean"?m===(U?"true":"false")?o.INSTANCE:n.INSTANCE:new k(a,m,z)}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=u.get(this.c);if(typeof a=="boolean"){const m=a?"true":"false";return this.d===m?o.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(a){return a.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Ti=k;class E{static create(a,m){return new E(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=10,this.c=null}cmp(a){return a.type!==this.type?this.type-a.type:G(this.d,this.f,a.d,a.f)}equals(a){return a.type===this.type?this.d===a.d&&this.f===a.f:!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.f),z=a.getValue(this.d);return Array.isArray(m)?m.includes(z):typeof z=="string"&&typeof m=="object"&&m!==null?S.call(m,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(a){return a.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$Ui=E;class p{static create(a,m){return new p(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=11,this.c=E.create(a,m)}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(a){return a.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=p;class N{static create(a,m,z=null){if(typeof m=="boolean")return m?B.create(a,z):l.create(a,z);const U=u.get(a);return typeof U=="boolean"?m===(U?"true":"false")?n.INSTANCE:o.INSTANCE:new N(a,m,z)}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=u.get(this.c);if(typeof a=="boolean"){const m=a?"true":"false";return this.d===m?n.INSTANCE:o.INSTANCE}return this}evaluate(a){return a.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(a){return a.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Wi=N;class B{static create(a,m=null){const z=u.get(a);return typeof z=="boolean"?z?n.INSTANCE:o.INSTANCE:new B(a,m)}constructor(a,m){this.c=a,this.d=m,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:H(this.c,a.c)}equals(a){return a.type===this.type?this.c===a.c:!1}substituteConstants(){const a=u.get(this.c);return typeof a=="boolean"?a?n.INSTANCE:o.INSTANCE:this}evaluate(a){return!a.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(a){return a.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Xi=B;function _(C,a){if(typeof C=="string"){const m=parseFloat(C);isNaN(m)||(C=m)}return typeof C=="string"||typeof C=="number"?a(C):n.INSTANCE}class ee{static create(a,m,z=null){return _(m,U=>new ee(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Yi=ee;class oe{static create(a,m,z=null){return _(m,U=>new oe(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$Zi=oe;class se{static create(a,m,z=null){return _(m,U=>new se(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$1i=se;class ue{static create(a,m,z=null){return _(m,U=>new ue(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$2i=ue;class ce{static create(a,m){return new ce(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=7,this.c=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.d<a.d)return-1;if(this.d>a.d)return 1;const m=this.f?this.f.source:"",z=a.f?a.f.source:"";return m<z?-1:m>z?1:0}equals(a){if(a.type===this.type){const m=this.f?this.f.source:"",z=a.f?a.f.source:"";return this.d===a.d&&m===z}return!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.d);return this.f?this.f.test(m):!1}serialize(){const a=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${a}`}keys(){return[this.d]}map(a){return a.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=re.create(this)),this.c}}e.$3i=ce;class re{static create(a){return new re(a)}constructor(a){this.c=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(a){return new re(this.c.map(a))}negate(){return this.c}}e.$4i=re;function q(C){let a=null;for(let m=0,z=C.length;m<z;m++){const U=C[m].substituteConstants();if(C[m]!==U&&a===null){a=[];for(let Z=0;Z<m;Z++)a[Z]=C[Z]}a!==null&&(a[m]=U)}return a===null?C:a}class X{static create(a,m,z){return X.d(a,m,z)}constructor(a,m){this.expr=a,this.c=m,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,z=this.expr.length;m<z;m++){const U=i(this.expr[m],a.expr[m]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,z=this.expr.length;m<z;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:X.create(a,this.c,!1)}evaluate(a){for(let m=0,z=this.expr.length;m<z;m++)if(!this.expr[m].evaluate(a))return!1;return!0}static d(a,m,z){const U=[];let Z=!1;for(const W of a)if(W){if(W.type===1){Z=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){U.push(...W.expr);continue}U.push(W)}if(U.length===0&&Z)return o.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(i);for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];for(;U.length>1;){const W=U[U.length-1];if(W.type!==9)break;U.pop();const le=U.pop(),ae=U.length===0,me=T.create(W.expr.map(de=>X.create([de,le],null,z)),null,ae);me&&(U.push(me),U.sort(i))}if(U.length===1)return U[0];if(z){for(let W=0;W<U.length;W++)for(let le=W+1;le<U.length;le++)if(U[W].negate().equals(U[le]))return n.INSTANCE;if(U.length===1)return U[0]}return new X(U,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new X(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.c){const a=[];for(const m of this.expr)a.push(m.negate());this.c=T.create(a,this,!0)}return this.c}}e.$5i=X;class T{static create(a,m,z){return T.d(a,m,z)}constructor(a,m){this.expr=a,this.c=m,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,z=this.expr.length;m<z;m++){const U=i(this.expr[m],a.expr[m]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,z=this.expr.length;m<z;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:T.create(a,this.c,!1)}evaluate(a){for(let m=0,z=this.expr.length;m<z;m++)if(this.expr[m].evaluate(a))return!0;return!1}static d(a,m,z){let U=[],Z=!1;if(a){for(let W=0,le=a.length;W<le;W++){const ae=a[W];if(ae){if(ae.type===0){Z=!0;continue}if(ae.type===1)return o.INSTANCE;if(ae.type===9){U=U.concat(ae.expr);continue}U.push(ae)}}if(U.length===0&&Z)return n.INSTANCE;U.sort(i)}if(U.length!==0){if(U.length===1)return U[0];for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];if(z){for(let W=0;W<U.length;W++)for(let le=W+1;le<U.length;le++)if(U[W].negate().equals(U[le]))return o.INSTANCE;if(U.length===1)return U[0]}return new T(U,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new T(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.c){const a=[];for(const m of this.expr)a.push(m.negate());for(;a.length>1;){const m=a.shift(),z=a.shift(),U=[];for(const Z of F(m))for(const W of F(z))U.push(X.create([Z,W],null,!1));a.unshift(T.create(U,null,!1))}this.c=T.create(a,this,!0)}return this.c}}e.$6i=T;class M extends l{static{this.d=[]}static all(){return M.d.values()}constructor(a,m,z){super(a,null),this.f=m,typeof z=="object"?M.d.push({...z,key:a}):z!==!0&&M.d.push({key:a,description:z,type:m!=null?typeof m:void 0})}bindTo(a){return a.createKey(this.key,this.f)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return k.create(this.key,a)}notEqualsTo(a){return N.create(this.key,a)}}e.$7i=M,e.$8i=(0,A.$Ph)("contextKeyService");function H(C,a){return C<a?-1:C>a?1:0}function G(C,a,m,z){return C<m?-1:C>m?1:a<z?-1:a>z?1:0}function Q(C,a){if(C.type===0||a.type===1)return!0;if(C.type===9)return a.type===9?Y(C.expr,a.expr):!1;if(a.type===9){for(const m of a.expr)if(Q(C,m))return!0;return!1}if(C.type===6){if(a.type===6)return Y(a.expr,C.expr);for(const m of C.expr)if(Q(m,a))return!0;return!1}return C.equals(a)}e.$9i=Q;function Y(C,a){let m=0,z=0;for(;m<C.length&&z<a.length;){const U=C[m].cmp(a[z]);if(U<0)return!1;U===0&&m++,z++}return m===C.length}function F(C){return C.type===9?C.expr:[C]}}),define(te[59],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=void 0,e.$Rn=(0,L.$Ph)("downloadService")}),define(te[18],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,L.$Ph)("environmentService"),e.$Xh=(0,L.$Qh)(e.$Wh)}),define(te[21],ne([0,1,92,10]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ao=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=void 0,e.$1n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$2n=new RegExp(e.$1n),e.$3n="__web_extension",e.$4n="skipWalkthrough",e.$5n="extensionsSync",e.$6n="dependecyOrPackExtensionInstall";function R(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$7n=R;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$8n=A;function j(h,b){switch(h){case 3:return b==="x64"?"win32-x64":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$9n=j;function v(h,b){return b==="web"&&!h.includes("web")}e.$0n=v;function u(h,b,O){return v(b,O)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===O}e.$$n=u;function c(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$_n=c;var S;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var I;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var g;(function(h){h.Install="install",h.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var f;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$ao=(0,D.$Ph)("extensionGalleryService");var P;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));var y;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class $ extends Error{constructor(b,O){super(b),this.code=O,this.name=O}}e.$bo=$,e.$co=(0,D.$Ph)("extensionManagementService"),e.$do="extensionsIdentifiers/disabled",e.$eo="extensionsIdentifiers/enabled",e.$fo=(0,D.$Ph)("IGlobalExtensionEnablementService"),e.$go=(0,D.$Ph)("IExtensionTipsService"),e.$ho=(0,L.localize)(0,null),e.$io={value:e.$ho,original:"Extensions"},e.$jo={value:(0,L.localize)(1,null),original:"Preferences"}}),define(te[60],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=void 0,e.$hp=(0,L.$Ph)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((A,j)=>J(["node-vsce-sign"],async v=>A(v),j))),this.a}async verify(A,j,v){let u;try{u=await this.b()}catch{return!1}return u.verify(A,j,v)}}e.$ip=D}),define(te[61],ne([0,1,14,9,100,12]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;async function j(S,I,g,f,P,y){let $;try{await v(S,I,g,f,P,y)}catch(h){$=h}finally{$&&P.errorTransformer&&($=P.errorTransformer($)),typeof $<"u"&&g.error($),g.end()}}e.$Pp=j;async function v(S,I,g,f,P,y){u(y);const $=await S.open(I,{create:!1});try{u(y);let h=0,b=0,O=P&&typeof P.length=="number"?P.length:void 0,d=L.$be.alloc(Math.min(P.bufferSize,typeof O=="number"?O:P.bufferSize)),w=P&&typeof P.position=="number"?P.position:0,s=0;do b=await S.read($,w,d.buffer,s,d.byteLength-s),w+=b,s+=b,h+=b,typeof O=="number"&&(O-=b),s===d.byteLength&&(await g.write(f(d)),d=L.$be.alloc(Math.min(P.bufferSize,typeof O=="number"?O:P.bufferSize)),s=0);while(b>0&&(typeof O!="number"||O>0)&&u(y)&&c(h,P));if(s>0){let r=s;typeof O=="number"&&(r=Math.min(s,O)),g.write(f(d.slice(0,r)))}}catch(h){throw(0,A.$mk)(h)}finally{await S.close($)}}function u(S){if(S.isCancellationRequested)throw(0,D.$5)();return!0}function c(S,I){if(typeof I?.limits?.size=="number"&&S>I.limits.size)throw(0,A.$lk)((0,R.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[117],ne([0,1,4,166,2,13,167]),function(J,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;class v extends R.$Rc{constructor(){super(...arguments),this.a=this.B(new L.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const S=this.j(c),I=S.filter(f=>{const P=this.c.get(f.path);return P?!(0,D.$Aj)(P.request.excludes,f.excludes)||!(0,D.$Aj)(P.request.includes,f.includes):!0}),g=Array.from(this.c.values()).filter(({request:f})=>!S.find(P=>P.path===f.path&&(0,D.$Aj)(P.excludes,f.excludes)&&(0,D.$Aj)(P.includes,f.includes))).map(({request:f})=>f.path);I.length&&this.m(`Request to start watching: ${I.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),g.length&&this.m(`Request to stop watching: ${g.join(",")}`);for(const f of g)this.h(f);for(const f of I)this.g(f)}g(c){const S=new j.$_p(c,g=>this.a.fire(g),g=>this.b.fire(g),this.f),I={request:c,instance:S};this.c.set(c.path,I)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const S=this.c.get(c);S&&(this.c.delete(c),S.instance.dispose())}j(c){const S=new Map;for(const I of c){const g=A.$l?I.path:I.path.toLowerCase();let f=S.get(I.correlationId);f||(f=new Map,S.set(I.correlationId,f)),f.set(g,I)}return Array.from(S.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,S]of this.c)S.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,S){return S?`[File Watcher (node.js)] ${c} (path: ${S.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$bq=v}),define(te[118],ne([0,1,62,117]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class R extends L.$Tp{constructor(j,v,u){super(j,v,u),this.s()}r(j){return j.add(new D.$bq)}}e.$cq=R}),define(te[119],ne([0,1,15,57,85,62]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;class j extends A.$Up{constructor(u,c,S){super(u,c,S),this.s()}r(u){const c=u.add(new R.$6p(L.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:S,signal:I})=>this.t(`terminated by itself with code ${S}, signal: ${I}`))),D.ProxyChannel.toService((0,D.$wh)(c.getChannel("watcher")))}}e.$7p=j}),define(te[63],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class L{constructor(...R){this.a=new Map;for(const[A,j]of R)this.set(A,j)}set(R,A){const j=this.a.get(R);return this.a.set(R,A),j}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$Nh=L}),define(te[120],ne([0,1,8,9,2,49,115,10,63,168]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;const S=!1;class I extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class g{constructor($=new u.$Nh,h=!1,b,O=S){this.f=$,this.g=h,this.h=b,this.i=O,this.o=new Set,this.f.set(v.$Oh,this),this._globalGraph=O?b?._globalGraph??new j.$fq(d=>d):void 0}createChild($){return new g($,this.g,this,this.i)}invokeFunction($,...h){const b=P.traceInvocation(this.i,$);let O=!1;try{return $({get:w=>{if(O)throw(0,D.$7)("service accessor is only valid during the invocation of its target method");const s=this.m(w,b);if(!s)throw new Error(`[invokeFunction] unknown service '${w}'`);return s}},...h)}finally{O=!0,b.stop()}}createInstance($,...h){let b,O;return $ instanceof A.$Mh?(b=P.traceCreation(this.i,$.ctor),O=this.j($.ctor,$.staticArguments.concat(h),b)):(b=P.traceCreation(this.i,$),O=this.j($,h,b)),b.stop(),O}j($,h=[],b){const O=v._util.getServiceDependencies($).sort((s,r)=>s.index-r.index),d=[];for(const s of O){const r=this.m(s.id,b);r||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${s.id}.`,!1),d.push(r)}const w=O.length>0?O[0].index:h.length;if(h.length!==w){console.trace(`[createInstance] First service dependency of ${$.name} at position ${w+1} conflicts with ${h.length} static arguments`);const s=w-h.length;s>0?h=h.concat(new Array(s)):h=h.slice(0,w)}return Reflect.construct($,h.concat(d))}k($,h){if(this.f.get($)instanceof A.$Mh)this.f.set($,h);else if(this.h)this.h.k($,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const h=this.f.get($);return!h&&this.h?this.h.l($):h}m($,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const b=this.l($);return b instanceof A.$Mh?this.q($,b,h.branch($,!0)):(h.branch($,!1),b)}q($,h,b){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,h,b)}finally{this.o.delete($)}}r($,h,b){const O=new j.$fq(s=>s.id.toString());let d=0;const w=[{id:$,desc:h,_trace:b}];for(;w.length;){const s=w.pop();if(O.lookupOrInsertNode(s),d++>1e3)throw new I(O);for(const r of v._util.getServiceDependencies(s.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${$} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(r.id)),t instanceof A.$Mh){const i={id:r.id,desc:t,_trace:s._trace.branch(r.id,!0)};O.insertEdge(s,i),w.push(i)}}}for(;;){const s=O.roots();if(s.length===0){if(!O.isEmpty())throw new I(O);break}for(const{data:r}of s){if(this.l(r.id)instanceof A.$Mh){const i=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,i)}O.removeNode(r)}}return this.l($)}s($,h,b=[],O,d){if(this.f.get($)instanceof A.$Mh)return this.t($,h,b,O,d);if(this.h)return this.h.s($,h,b,O,d);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t($,h,b=[],O,d){if(O){const w=new g(void 0,this.g,this,this.i);w.c=String($);const s=new Map,r=new L.$$g(()=>{const t=w.j(h,b,d);for(const[i,n]of s){const o=t[i];if(typeof o=="function")for(const l of n)o.apply(t,l)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!r.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=s.get(i);return l||(l=new c.$1c,s.set(i,l)),(E,p,N)=>{const B=l.push([E,p,N]);return(0,R.$Pc)(B)}}if(i in t)return t[i];const n=r.value;let o=n[i];return typeof o!="function"||(o=o.bind(n),t[i]=o),o},set(t,i,n){return r.value[i]=n,!0},getPrototypeOf(t){return h.prototype}})}else return this.j(h,b,d)}u($,h){if(h&&console.warn($),this.g)throw new Error($)}}e.$gq=g;var f;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(f||(f={}));class P{static{this.all=new Set}static{this.c=new class extends P{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,h){return $?new P(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):P.c}static traceCreation($,h){return $?new P(1,h.name):P.c}static{this.f=0}constructor($,h){this.type=$,this.name=h,this.g=Date.now(),this.h=[]}branch($,h){const b=new P(3,$.toString());return this.h.push([$,h,b]),b}stop(){const $=Date.now()-this.g;P.f+=$;let h=!1;function b(d,w){const s=[],r=new Array(d+1).join("	");for(const[t,i,n]of w.h)if(i&&n){h=!0,s.push(`${r}CREATES -> ${t}`);const o=b(d+1,n);o&&s.push(o)}else s.push(`${r}uses -> ${t}`);return s.join(`
`)}const O=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${P.f.toFixed(2)}ms)`];($>2||h)&&P.all.add(O.join(`
`))}}e.$hq=P});var ie=this&&this.__param||function(J,e){return function(L,D){e(L,D,J)}};define(te[64],ne([0,1,20,2,13,102,21,10]),function(J,e,L,D,R,A,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=void 0;function u(S){return S.tags.find(I=>I.startsWith("lp-"))?.split("lp-")[1]}e.$Uq=u,e.$Vq=(0,v.$Ph)("languagePackService");let c=class extends D.$Rc{constructor(I){super(),this.c=I}async getAvailableLanguages(){const I=new L.$Xd;setTimeout(()=>I.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const P=g.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some($=>$.startsWith("lp-"))).map(y=>{const $=y.properties.localizedLanguages?.[0],h=u(y);return{...this.f(h,$,y),extensionId:y.identifier.id,galleryExtension:y}});return P.push(this.f("en","English")),P}f(I,g,f){const P=g??I;let y;if(P!==I&&(y=`(${I})`),I.toLowerCase()===R.$w.toLowerCase()&&(y??="",y+=(0,A.localize)(0,null)),f?.installCount){y??="";const $=f.installCount;let h;$>1e6?h=`${Math.floor($/1e5)/10}M`:$>1e3?h=`${Math.floor($/1e3)}K`:h=String($),y+=` $(cloud-download) ${h}`}return{id:I,label:P,description:y}}};e.$Wq=c,e.$Wq=c=pe([ie(0,j.$ao)],c)}),define(te[6],ne([0,1,34,4,41,2,31,13,17,3,11,116,10]),function(J,e,L,D,R,A,j,v,u,c,S,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,g.$Ph)("logService"),e.$$i=(0,g.$Ph)("loggerService");function f(){return new Date().toISOString()}function P(E){return(0,c.$Cf)(E)}e.$_i=P;var y;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$aj=y.Info;function $(E,p,N){switch(p){case y.Trace:E.trace(N);break;case y.Debug:E.debug(N);break;case y.Info:E.info(N);break;case y.Warning:E.warn(N);break;case y.Error:E.error(N);break;case y.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=$;function h(E,p=!1){let N="";for(let B=0;B<E.length;B++){let _=E[B];if(_ instanceof Error&&(_=(0,L.$Ai)(_,p)),typeof _=="object")try{_=JSON.stringify(_)}catch{}N+=(B>0?" ":"")+_}return N}class b extends A.$Rc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new D.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==y.Off&&this.b<=p}}e.$cj=b;class O extends b{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...N){this.f(y.Trace)&&this.g(y.Trace,h([p,...N],!0))}debug(p,...N){this.f(y.Debug)&&this.g(y.Debug,h([p,...N]))}info(p,...N){this.f(y.Info)&&this.g(y.Info,h([p,...N]))}warn(p,...N){this.f(y.Warning)&&this.g(y.Warning,h([p,...N]))}error(p,...N){if(this.f(y.Error))if(p instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=p.stack,this.g(y.Error,h(B))}else this.g(y.Error,h([p,...N]))}flush(){}}e.$dj=O;class d extends b{constructor(p=e.$aj){super(),this.setLevel(p),this.g=!v.$j}trace(p,...N){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...N):console.log(`[main ${f()}]`,p,...N))}debug(p,...N){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...N):console.log(`[main ${f()}]`,p,...N))}info(p,...N){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...N):console.log(`[main ${f()}]`,p,...N))}warn(p,...N){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,p,...N):console.warn(`[main ${f()}]`,p,...N))}error(p,...N){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,p,...N):console.error(`[main ${f()}]`,p,...N))}dispose(){}flush(){}}e.$ej=d;class w extends b{constructor(p=e.$aj,N=!0){super(),this.g=N,this.setLevel(p)}trace(p,...N){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...N):console.log(p,...N))}debug(p,...N){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...N):console.log(p,...N))}info(p,...N){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...N):console.log(p,...N))}warn(p,...N){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...N):console.log(p,...N))}error(p,...N){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...N):console.error(p,...N))}dispose(){}flush(){}}e.$fj=w;class s extends b{constructor(p,N=e.$aj){super(),this.g=p,this.setLevel(N)}trace(p,...N){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(p),...N])}debug(p,...N){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(p),...N])}info(p,...N){this.f(y.Info)&&this.g.log(y.Info,[this.h(p),...N])}warn(p,...N){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(p),...N])}error(p,...N){this.f(y.Error)&&this.g.log(y.Error,[this.h(p),...N])}h(p){return typeof p=="string"?p:(0,L.$Ai)(p,this.f(y.Trace))}dispose(){}flush(){}}e.$gj=s;class r extends b{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const N of this.g)N.setLevel(p);super.setLevel(p)}trace(p,...N){for(const B of this.g)B.trace(p,...N)}debug(p,...N){for(const B of this.g)B.debug(p,...N)}info(p,...N){for(const B of this.g)B.info(p,...N)}warn(p,...N){for(const B of this.g)B.warn(p,...N)}error(p,...N){for(const B of this.g)B.error(p,...N)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose()}}e.$hj=r;class t extends A.$Rc{constructor(p,N,B){if(super(),this.h=p,this.j=N,this.b=new j.$zc,this.c=this.B(new D.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Nd),this.onDidChangeVisibility=this.g.event,B)for(const _ of B)this.b.set(_.resource,{logger:void 0,info:_})}m(p){return(0,c.$yf)(p)?[...this.b.values()].find(N=>N.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,N){const B=this.n(p),_=(0,c.$yf)(p)?p:N?.id??(0,R.$Di)(B.toString()).toString(16);let ee=this.b.get(B)?.logger;const oe=N?.logLevel==="always"?y.Trace:N?.logLevel;ee||(ee=this.s(B,oe??this.getLogLevel(B)??this.h,{...N,id:_}));const se={logger:ee,info:{resource:B,id:_,logLevel:oe,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(se.info),this.b.set(B,se),ee}n(p){return(0,c.$yf)(p)?(0,u.$vg)(this.j,`${p}.log`):p}setLogLevel(p,N){if(S.URI.isUri(p)){const B=p,_=N,ee=this.b.get(B);ee&&_!==ee.info.logLevel&&(ee.info.logLevel=_===this.h?void 0:_,ee.logger?.setLevel(_),this.b.set(ee.info.resource,ee),this.f.fire([B,_]))}else{this.h=p;for(const[B,_]of this.b.entries())this.b.get(B)?.info.logLevel===void 0&&_.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,N){const B=this.m(p);B&&N!==!B.info.hidden&&(B.info.hidden=!N,this.b.set(B.info.resource,B),this.g.fire([B.info.resource,N]))}getLogLevel(p){let N;return p&&(N=this.b.get(p)?.info.logLevel),N??this.h}registerLogger(p){const N=this.b.get(p.resource);N?N.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const N=this.b.get(p);N&&(N.logger&&N.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=t;class i{constructor(){this.onDidChangeLogLevel=new D.$Nd().event}setLevel(p){}getLevel(){return y.Info}trace(p,...N){}debug(p,...N){}info(p,...N){}warn(p,...N){}error(p,...N){}critical(p,...N){}dispose(){}flush(){}}e.$jj=i;class n extends i{}e.$kj=n;function o(E){if(E.verbose)return y.Trace;if(typeof E.logLevel=="string"){const p=k(E.logLevel.toLowerCase());if(p!==void 0)return p}return e.$aj}e.$lj=o;function l(E){switch(E){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$mj=l;function k(E){switch(E){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$nj=k,e.$oj=new I.$7i("logLevel",l(y.Info))}),define(te[121],ne([0,1,19,8,9,4,2,16,62,6]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class S extends j.$Rc{constructor(g,f){super(),this.a=g,this.b=f,this.c=this.B(new A.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$Rg(0)),this.w=[],this.y=this.B(new D.$Rg(0))}watch(g,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(g,f):this.z(g,f)}n(g,f){const P={path:this.H(g),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},y=(0,L.$Tb)(this.j,P);return this.r(),(0,j.$Pc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,R.$Z)(g))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,u.$Vp)(f)),f=>this.G(f),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const f of this.j)(0,u.$Rp)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const f of this.j)(0,u.$Rp)(f)&&g.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,f){const P={path:this.H(g),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},y=(0,L.$Tb)(this.w,P);return this.C(),(0,j.$Pc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,R.$Z)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,u.$Vp)(g)),g=>this.G(g),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}H(g){return(0,v.$gc)(g.fsPath)}}e.$Zp=S}),define(te[122],ne([0,1,19,8,14,20,4,41,65,2,47,15,123,17,45,99,12,61,6,9]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f,P,y,$,h,b,O){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;let w=class extends c.$Rc{static{d=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new j.$Nd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$Nd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$Nd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$Nd),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$Nd),this.Y=this.B(new j.$Nd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new j.$Nd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$3g)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${r}`);const i=new c.$Qc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),i.add(t.onDidChangeFile(n=>{const o=new $.$rk(n,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,c.$Pc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,c.$Mc)(i)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(i){t.push(i)}}),!this.h.has(r)&&await D.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const i=this.h.get(r.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,f.$zg)(r))throw new $.$tk((0,y.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const i=new O.$ab;throw i.message=(0,y.localize)(1,null,r.toString()),i}return t}async m(r){const t=await this.j(r);if((0,$.$ek)(t)||(0,$.$bk)(t)||(0,$.$fk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,$.$ek)(t)||(0,$.$bk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(i){throw(0,$.$ok)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$tk((0,y.localize)(2,null,this.sb(r)),1):(0,$.$mk)(i)}}async s(r,t){const i=await this.j(r),n=this.S(i),o=t?.resolveTo,l=t?.resolveSingleChildDescendants,k=t?.resolveMetadata,E=await i.stat(r);let p;return this.t(i,r,E,void 0,!!k,(N,B)=>(p||(p=S.$Vh.forUris(()=>!n),p.set(r,!0),o&&p.fill(!0,o)),p.get(N.resource)||p.findSuperstr(N.resource.with({query:null,fragment:null}))?!0:N.isDirectory&&l?B===1:!1))}async t(r,t,i,n,o,l){const{providerExtUri:k}=this.R(r),E={resource:t,name:k.basename(t),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Ek)({mtime:i.mtime,size:i.size}),children:void 0};if(E.isDirectory&&l(E,n)){try{const p=await r.readdir(t),N=await D.Promises.settled(p.map(async([B,_])=>{try{const ee=k.joinPath(t,B),oe=o?await r.stat(ee):{type:_};return await this.t(r,ee,oe,p.length,o,l)}catch(ee){return this.b.trace(ee),null}}));E.children=(0,L.$Gb)(N)}catch(p){this.b.trace(p),E.children=[]}return E}return E}async resolveAll(r){return D.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),i=await t.stat(r);return this.t(t,r,i,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(i){return i}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new $.$tk((0,y.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=R.$be.fromString(""),i){await this.u(r,i);const n=await this.writeFile(r,t);return this.r.fire(new $.$qk(r,0,n)),n}async writeFile(r,t,i){const n=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(n);let l=i;if((0,$.$hk)(n)&&!l?.atomic){const k=n.enforceAtomicWriteFile?.(r);k&&(l={...i,atomic:k})}try{await this.w(n,r,l)||await this.U(n,o.dirname(r));let E;if((0,$.$bk)(n)&&!(t instanceof R.$be))if((0,P.$Zd)(t)){const p=await(0,P.$7d)(t,3);p.ended?E=R.$be.concat(p.buffer):E=p}else E=(0,P.$4d)(t,p=>R.$be.concat(p),3);else E=t;!(0,$.$ek)(n)||(0,$.$bk)(n)&&E instanceof R.$be||(0,$.$bk)(n)&&(0,$.$hk)(n)&&l?.atomic?await this.hb(n,r,l,E):await this.db(n,r,l,E instanceof R.$be?(0,R.$me)(E):E),this.r.fire(new $.$qk(r,4))}catch(k){throw new $.$tk((0,y.localize)(4,null,this.sb(r),(0,$.$mk)(k).toString()),(0,$.$pk)(k),l)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,i){const n=!!i?.unlock;if(n&&!(r.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(r.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(t)));if(n)throw new Error((0,y.localize)(8,null,this.sb(t)))}let l;try{l=await r.stat(t)}catch{return}if(l.type&$.FileType.Directory)throw new $.$tk((0,y.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$Dk&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,$.$Ek)({mtime:i.mtime,size:l.size}))throw new $.$tk((0,y.localize)(10,null),3,i);return l}async readFile(r,t,i){const n=await this.m(r);return t?.atomic?this.z(n,r,t,i):this.C(n,r,t,i)}async z(r,t,i,n){return new Promise((o,l)=>{this.cb.queueFor(t,this.R(r).providerExtUri).queue(async()=>{try{const k=await this.C(r,t,i,n);o(k)}catch(k){l(k)}})})}async C(r,t,i,n){const o=await this.D(r,t,{...i,preferUnbuffered:!0},n);return{...o,value:await(0,R.$ne)(o.value)}}async readFileStream(r,t,i){const n=await this.m(r);return this.D(n,r,t,i)}async D(r,t,i,n){const o=new A.$Xd(n);let l=i;(0,$.$gk)(r)&&r.enforceAtomicReadFile?.(t)&&(l={...i,atomic:!0});const k=this.J(t,l).then(p=>p,p=>{throw o.dispose(!0),p});let E;try{return typeof l?.etag=="string"&&l.etag!==$.$Dk&&await k,l?.atomic&&(0,$.$gk)(r)||!((0,$.$ek)(r)||(0,$.$fk)(r))||(0,$.$bk)(r)&&l?.preferUnbuffered?E=this.I(r,t,l):(0,$.$fk)(r)?E=this.G(r,t,o.token,l):E=this.H(r,t,o.token,l),E.on("end",()=>o.dispose()),E.on("error",()=>o.dispose()),{...await k,value:E}}catch(p){throw E&&await(0,P.$5d)(E),this.F(p,t,l)}}F(r,t,i){const n=(0,y.localize)(11,null,this.sb(t),(0,$.$mk)(r).toString());return r instanceof $.$vk?new $.$vk(n,r.stat,i):r instanceof $.$uk?new $.$uk(n,r.fileOperationResult,r.size,r.options):new $.$tk(n,(0,$.$pk)(r),i)}G(r,t,i,n=Object.create(null)){const o=r.readFileStream(t,n,i);return(0,P.$$d)(o,{data:l=>l instanceof R.$be?l:R.$be.wrap(l),error:l=>this.F(l,t,n)},l=>R.$be.concat(l))}H(r,t,i,n=Object.create(null)){const o=(0,R.$re)();return(0,h.$Pp)(r,t,o,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.F(l,t,n)},i),o}I(r,t,i){const n=(0,P.$2d)(o=>R.$be.concat(o));return(async()=>{try{let o;i?.atomic&&(0,$.$gk)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(t,o.byteLength,i),n.end(R.$be.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async J(r,t){const i=await this.resolve(r,{resolveMetadata:!0});if(i.isDirectory)throw new $.$tk((0,y.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==$.$Dk&&t.etag===i.etag)throw new $.$vk((0,y.localize)(13,null),i,t);return this.L(r,i.size,t),i}L(r,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new $.$uk((0,y.localize)(14,null,this.sb(r)),7,t,i)}async canMove(r,t,i){return this.M(r,t,"move",i)}async canCopy(r,t,i){return this.M(r,t,"copy",i)}async M(r,t,i,n){if(r.toString()!==t.toString())try{const o=i==="move"?this.qb(await this.n(r),r):await this.m(r),l=this.qb(await this.n(t),t);await this.Q(o,r,l,t,i,n)}catch(o){return o}return!0}async move(r,t,i){const n=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),l=await this.N(n,r,o,t,"move",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$qk(r,l==="move"?2:3,k)),k}async copy(r,t,i){const n=await this.m(r),o=this.qb(await this.n(t),t),l=await this.N(n,r,o,t,"copy",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$qk(r,l==="copy"?3:2,k)),k}async N(r,t,i,n,o,l){if(t.toString()===n.toString())return o;const{exists:k,isSameResourceWithDifferentPathCase:E}=await this.Q(r,t,i,n,o,l);if(k&&!E&&l&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),o==="copy"){if(r===i&&(0,$.$ck)(r))await r.copy(t,n,{overwrite:l});else{const p=await this.resolve(t);p.isDirectory?await this.P(r,p,i,n):await this.O(r,t,i,n)}return o}else return r===i?(await r.rename(t,n,{overwrite:l}),o):(await this.N(r,t,i,n,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(r,t,i,n){if((0,$.$ek)(r)&&(0,$.$ek)(i))return this.jb(r,t,i,n);if((0,$.$ek)(r)&&(0,$.$bk)(i))return this.pb(r,t,i,n);if((0,$.$bk)(r)&&(0,$.$ek)(i))return this.nb(r,t,i,n);if((0,$.$bk)(r)&&(0,$.$bk)(i))return this.lb(r,t,i,n)}async P(r,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async o=>{const l=this.R(i).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),i,l):this.O(r,o.resource,i,l)}))}async Q(r,t,i,n,o,l){let k=!1;if(r===i){const{providerExtUri:p,isPathCaseSensitive:N}=this.R(r);if(N||(k=p.isEqual(t,n)),k&&o==="copy")throw new Error((0,y.localize)(15,null,this.sb(t),this.sb(n)));if(!k&&p.isEqualOrParent(n,t))throw new Error((0,y.localize)(16,null,this.sb(t),this.sb(n)))}const E=await this.exists(n);if(E&&!k){if(!l)throw new $.$tk((0,y.localize)(17,null,this.sb(t),this.sb(n)),4);if(r===i){const{providerExtUri:p}=this.R(r);if(p.isEqualOrParent(t,n))throw new Error((0,y.localize)(18,null,this.sb(t),this.sb(n)))}}return{exists:E,isSameResourceWithDifferentPathCase:k}}R(r){const t=this.S(r);return{providerExtUri:t?f.$lg:f.$ng,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const i=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new $.$qk(r,0,i)),i}async U(r,t){const i=[],{providerExtUri:n}=this.R(r);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await r.stat(t)).type&$.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(t)));break}catch(o){if((0,$.$ok)(o)!==$.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(n.basename(t)),t=n.dirname(t)}for(let o=i.length-1;o>=0;o--){t=n.joinPath(t,i[o]);try{await r.mkdir(t)}catch(l){if((0,$.$ok)(l)!==$.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(r,t){try{await this.W(r,t)}catch(i){return i}return!0}async W(r,t){const i=this.qb(await this.j(r),r),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(r)));if(n&&o)throw new Error((0,y.localize)(22,null,this.sb(r)));let l;try{l=await i.stat(r)}catch{}if(l)this.rb(r,l);else throw new $.$tk((0,y.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const E=await this.resolve(r);if(E.isDirectory&&Array.isArray(E.children)&&E.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(r)))}return i}async del(r,t){const i=await this.W(r,t);let n=t;if((0,$.$ik)(i)&&!n?.atomic){const E=i.enforceAtomicDelete?.(r);E&&(n={...t,atomic:E})}const o=!!n?.useTrash,l=!!n?.recursive,k=n?.atomic??!1;await i.delete(r,{recursive:l,useTrash:o,atomic:k}),this.r.fire(new $.$qk(r,1))}async cloneFile(r,t){const i=await this.j(r),n=this.qb(await this.n(t),t);if(i===n&&this.R(i).providerExtUri.isEqual(r,t))return;if(i===n&&(0,$.$dk)(i))return i.cloneFile(r,t);await this.U(n,this.R(n).providerExtUri.dirname(t));const o=this.cb.queueFor(r,this.R(i).providerExtUri);return i===n&&(0,$.$ck)(i)?o.queue(()=>i.copy(r,t,{overwrite:!0})):o.queue(()=>this.O(i,r,n,t))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:d.ab++})}watch(r,t={recursive:!1,excludes:[]}){const i=new c.$Qc;let n=!1,o=()=>{n=!0};i.add((0,c.$Pc)(()=>o())),(async()=>{try{const k=await this.bb(r,t);n?(0,c.$Mc)(k):o=()=>(0,c.$Mc)(k)}catch(k){this.b.error(k)}})();const l=t.correlationId;if(typeof l=="number"){const k=i.add(new j.$Nd);return i.add(this.X.event(p=>{p.correlates(l)&&k.fire(p)})),{onDidChange:k.event,dispose:()=>i.dispose()}}return i}async bb(r,t){const i=await this.j(r),n=(0,v.$Di)([this.R(i).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(n);return o||(o={count:0,disposable:i.watch(r,t)},this.$.set(n,o)),o.count+=1,(0,c.$Pc)(()=>{o&&(o.count--,o.count===0&&((0,c.$Mc)(o.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,c.$Mc)(r.disposable);this.$.clear()}async db(r,t,i,n){return this.cb.queueFor(t,this.R(r).providerExtUri).queue(async()=>{const o=await r.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,P.$Zd)(n)||(0,P.$1d)(n)?await this.eb(r,o,n):await this.fb(r,o,n)}catch(l){throw(0,$.$mk)(l)}finally{await r.close(o)}})}async eb(r,t,i){let n=0,o;if((0,P.$1d)(i)){if(i.buffer.length>0){const l=R.$be.concat(i.buffer);await this.gb(r,t,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((l,k)=>{(0,P.$6d)(o,{onData:async E=>{o.pause();try{await this.gb(r,t,E,E.byteLength,n,0)}catch(p){return k(p)}n+=E.byteLength,setTimeout(()=>o.resume())},onError:E=>k(E),onEnd:()=>l()})})}async fb(r,t,i){let n=0,o;for(;(o=i.read())!==null;)await this.gb(r,t,o,o.byteLength,n,0),n+=o.byteLength}async gb(r,t,i,n,o,l){let k=0;for(;k<n;){const E=await r.write(t,o+k,i.buffer,l+k,n-k);k+=E}}async hb(r,t,i,n){return this.cb.queueFor(t,this.R(r).providerExtUri).queue(()=>this.ib(r,t,i,n))}async ib(r,t,i,n){let o;n instanceof R.$be?o=n:(0,P.$Zd)(n)?o=await(0,R.$ne)(n):(0,P.$1d)(n)?o=await(0,R.$oe)(n):o=(0,R.$le)(n),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(r,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(r,t,i,n))}async kb(r,t,i,n){let o,l;try{o=await r.open(t,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const k=R.$be.alloc(this.a);let E=0,p=0,N=0;do N=await r.read(o,E,k.buffer,p,k.byteLength-p),await this.gb(i,l,k,N,E,p),E+=N,p+=N,p===k.byteLength&&(p=0);while(N>0)}catch(k){throw(0,$.$mk)(k)}finally{await D.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async lb(r,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(r,t,i,n))}async mb(r,t,i,n){return i.writeFile(n,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ob(r,t,i,n))}async ob(r,t,i,n){const o=await i.open(n,{create:!0,unlock:!1});try{const l=await r.readFile(t);await this.gb(i,o,R.$be.wrap(l),l.byteLength,0,0)}catch(l){throw(0,$.$mk)(l)}finally{await i.close(o)}}async pb(r,t,i,n){const o=await(0,R.$ne)(this.H(r,t,A.CancellationToken.None));await this.hb(i,n,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new $.$tk((0,y.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&$.FilePermission.Readonly)throw new $.$tk((0,y.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===I.Schemas.file?r.fsPath:r.toString(!0)}};e.$Qp=w,e.$Qp=w=d=pe([ie(0,b.$0i)],w)}),define(te[124],ne([0,1,125,169,8,31,14,4,170,2,16,13,17,45,24,101,12,61,121,34,119,118]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f,P,y,$,h,b,O,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(r){console.error(`Error enabling graceful-fs: ${(0,O.$Ai)(r)}`)}})();class s extends b.$Zp{static{this.I=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=v.Event.None,this.N=new A.$zc(n=>g.$mg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$l&&(this.J|=1024)),this.J}async stat(t){try{const{stat:i,symbolicLink:n}=await P.SymlinkSupport.stat(this.H(t));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:$.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await P.Promises.readdir(this.H(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,g.$vg)(t,o.name))).type:l=this.M(o),n.push([o.name,l])}catch(l){this.a.trace(l)}})),n}catch(i){throw this.fb(i)}}M(t,i){let n;return i?.dangling?n=$.FileType.Unknown:t.isFile()?n=$.FileType.File:t.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,i&&(n|=$.FileType.SymbolicLink),n}async O(t){const i=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const o=new R.$Sg;return this.N.set(t,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(t)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),n=await this.O(t));const o=this.H(t);return await P.Promises.readFile(o)}catch(o){throw this.fb(o)}finally{n?.dispose()}}P(t){s.I&&this.a.trace(t)}readFileStream(t,i,n){const o=(0,f.$2d)(l=>j.$be.concat(l.map(k=>j.$be.wrap(k))).buffer);return(0,h.$Pp)(this,t,o,l=>l.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,g.$vg)((0,g.$ug)(t),`${(0,g.$sg)(t)}${n.atomic.postfix}`),i,n):this.S(t,i,n)}async Q(t){try{const i=this.H(t),{symbolicLink:n}=await P.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(t,i,n,o){const l=new c.$Qc;try{l.add(await this.O(t)),l.add(await this.O(i)),await this.S(i,n,o,!0);try{await this.rename(i,t,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{l.dispose()}}async S(t,i,n,o){let l;try{const k=this.H(t);if(!n.create||!n.overwrite){if(await P.Promises.exists(k)){if(!n.overwrite)throw(0,$.$lk)((0,y.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$lk)((0,y.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:n.unlock},o),await this.write(l,0,i,0,i.byteLength)}catch(k){throw await this.gb(t,k)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){s.Y=t}async open(t,i,n){const o=this.H(t);let l;(0,$.$_j)(i)&&!n&&(l=await this.O(t));let k;try{if((0,$.$_j)(i)&&i.unlock)try{const{stat:p}=await P.SymlinkSupport.stat(o);p.mode&128||await P.Promises.chmod(o,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let E;if((0,$.$_j)(i)){if(I.$j)try{await P.Promises.truncate(o,0),E="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}E||(E="w")}else E="r";k=await P.Promises.open(o,E)}catch(E){throw l?.dispose(),(0,$.$_j)(i)?await this.gb(t,E):this.fb(E)}if(this.U.set(k,0),(0,$.$_j)(i)&&this.X.set(k,t),l){const E=this.W.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${o})`),this.W.set(k,l),E&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${o})`),E.dispose())}return k}async close(t){const i=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&s.Y)try{await P.Promises.fdatasync(t)}catch(n){s.configureFlushOnWrite(!1),this.a.error(n)}return await P.Promises.close(t)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(t)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,o,l){const k=this.Z(t,i);let E=null;try{E=(await P.Promises.read(t,n,o,l,k)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(t,k,E)}return E}Z(t,i){return i===this.U.get(t)?null:i}$(t,i,n){const o=this.U.get(t);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(t,o+n):this.U.delete(t)))}async write(t,i,n,o,l){return(0,R.$_g)(()=>this.ab(t,i,n,o,l),100,3)}async ab(t,i,n,o,l){const k=this.Z(t,i);let E=null;try{E=(await P.Promises.write(t,n,o,l,k)).bytesWritten}catch(p){throw await this.gb(this.X.get(t),p)}finally{this.$(t,k,E)}return E}async mkdir(t){try{await P.Promises.mkdir(this.H(t))}catch(i){throw this.fb(i)}}async delete(t,i){try{const n=this.H(t);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,S.$ic)((0,S.$lc)(n),`${(0,S.$mc)(n)}${i.atomic.postfix}`)),await P.Promises.rm(n,P.RimRafMode.MOVE,o)}else try{await P.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:k,symbolicLink:E}=await P.SymlinkSupport.stat(n);l=k.isDirectory()&&!E}catch{}if(l)await P.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.fb(n)}}async rename(t,i,n){const o=this.H(t),l=this.H(i);if(o!==l)try{await this.bb(t,i,"move",n.overwrite),await P.Promises.rename(o,l)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,y.localize)(2,null,(0,S.$mc)(o),(0,S.$mc)((0,S.$lc)(l)),k.toString()))),this.fb(k)}}async copy(t,i,n){const o=this.H(t),l=this.H(i);if(o!==l)try{await this.bb(t,i,"copy",n.overwrite),await P.Promises.copy(o,l,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,y.localize)(3,null,(0,S.$mc)(o),(0,S.$mc)((0,S.$lc)(l)),k.toString()))),this.fb(k)}}async bb(t,i,n,o){const l=this.H(t),k=this.H(i);let E=!1;if(!!(this.capabilities&1024)||(E=(0,u.$Wf)(l,k,!0)),E){if(n==="copy")throw(0,$.$lk)((0,y.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const N=await this.L(t);if(!N)throw(0,$.$lk)((0,y.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const B=await this.L(i);if(B){if(!o)throw(0,$.$lk)((0,y.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);N.type&$.FileType.File&&B.type&$.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.cb(t,i,!1)}async cb(t,i,n){const o=this.H(t),l=this.H(i),k=!!(this.capabilities&1024);if((0,u.$Wf)(o,l,!k))return;const E=new c.$Qc;try{E.add(await this.O(t)),E.add(await this.O(i)),n&&await P.Promises.mkdir((0,S.$lc)(l),{recursive:!0}),await P.Promises.copyFile(o,l)}catch(p){if(p.code==="ENOENT"&&!n)return this.cb(t,i,!0);throw this.fb(p)}finally{E.dispose()}}t(t,i,n){return new d.$7p(o=>t(o),o=>i(o),n)}F(t,i,n){return new w.$cq(o=>t(o),o=>i(o),n)}fb(t){if(t instanceof $.$kk)return t;let i=t,n;switch(t.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$lk)(i,n)}async gb(t,i){let n=this.fb(i);if(t&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await P.SymlinkSupport.stat(this.H(t));o.mode&128||(n=(0,$.$lk)(i,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return n}}e.$dq=s}),define(te[126],ne([0,1,2,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;class R extends L.$Rc{constructor(j,v=[]){super(),this.a=new D.$hj([j,...v]),this.B(j.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...v){this.a.trace(j,...v)}debug(j,...v){this.a.debug(j,...v)}info(j,...v){this.a.info(j,...v)}warn(j,...v){this.a.warn(j,...v)}error(j,...v){this.a.error(j,...v)}flush(){this.a.flush()}}e.$NN=R}),define(te[127],ne([0,1,12,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=void 0;var R;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(R||(R={}));async function A(c,S,I,g,f){try{const P=await new Promise(($,h)=>{J(["@vscode/spdlog"],$,h)});P.setFlushOn(R.Trace);const y=await P.createAsyncRotatingLogger(c,S,I,g);return f?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(P){console.error(P)}return null}function j(c,S,I){switch(S){case D.LogLevel.Trace:c.trace(I);break;case D.LogLevel.Debug:c.debug(I);break;case D.LogLevel.Info:c.info(I);break;case D.LogLevel.Warning:c.warn(I);break;case D.LogLevel.Error:c.error(I);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function v(c,S){switch(S){case D.LogLevel.Trace:c.setLevel(R.Trace);break;case D.LogLevel.Debug:c.setLevel(R.Debug);break;case D.LogLevel.Info:c.setLevel(R.Info);break;case D.LogLevel.Warning:c.setLevel(R.Warning);break;case D.LogLevel.Error:c.setLevel(R.Error);break;case D.LogLevel.Off:c.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${S}`)}}class u extends D.$dj{constructor(S,I,g,f,P){super(),this.m=[],this.setLevel(P),this.n=this.s(S,I,g,f),this.B(this.onDidChangeLogLevel(y=>{this.r&&v(this.r,y)}))}async s(S,I,g,f){const P=g?6:1,y=30/P*L.$Gk.MB,$=await A(S,I,y,P,f);if($){this.r=$,v(this.r,this.getLevel());for(const{level:h,message:b}of this.m)j(this.r,h,b);this.m=[]}}g(S,I){this.r?j(this.r,S,I):this.getLevel()<=S&&this.m.push({level:S,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$CN=u}),define(te[128],ne([0,1,28,6,127]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=void 0;class A extends D.$ij{s(v,u,c){return new R.$CN((0,L.$eg)(),v.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.$DN=A}),define(te[38],ne([0,1,4,65,2,10]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=void 0,e.$ln=(0,A.$Ph)("policy");class j extends R.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Nd),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const S=Object.keys(this.f).length;return this.f={...c,...this.f},S!==Object.keys(this.f).length&&await this.j(c),D.Iterable.reduce(this.g.entries(),(I,[g,f])=>({...I,[g]:f}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(c,[S,I])=>({...c,[S]:{definition:I,value:this.g.get(S)}}),{})}}e.$mn=j;class v{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$nn=v}),define(te[129],ne([0,1,8,4,65,3,12,6,38]),function(J,e,L,D,R,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q8b=void 0;function c(I,g){const f=[];for(const P of new Set(R.Iterable.concat(I.keys(),g.keys())))I.get(P)!==g.get(P)&&f.push(P);return f}let S=class extends u.$mn{constructor(g,f,P){super(),this.m=g,this.n=f,this.s=P,this.c=this.B(new L.$Rg(500));const y=D.Event.filter(f.onDidFilesChange,$=>$.affects(g));this.B(f.watch(g)),this.B(y(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const g=new Map;try{const f=await this.n.readFile(this.m),P=JSON.parse(f.value.toString());if(!(0,A.$Af)(P))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(P))this.f[y]&&g.set(y,P[y])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return g}async w(){const g=await this.u(),f=c(this.g,g);this.g=g,f.length>0&&this.h.fire(f)}};e.$Q8b=S,e.$Q8b=S=pe([ie(1,j.$$j),ie(2,v.$0i)],S)}),define(te[130],ne([0,1,38,8,171,2,6]),function(J,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P8b=void 0;let v=class extends L.$mn{constructor(c,S){super(),this.m=c,this.n=S,this.a=new D.$Ng,this.b=this.B(new A.$Sc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((S,I)=>{try{this.b.value=(0,R.createWatcher)(this.n,c,g=>{this.t(g),S()})}catch(g){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),I(g)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const S in c){const I=c[S];I===void 0?this.g.delete(S):this.g.set(S,I)}this.h.fire(Object.keys(c))}};e.$P8b=v,e.$P8b=v=pe([ie(0,j.$0i)],v)}),define(te[32],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,L.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"}),define(te[36],ne([0,1,71,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=void 0;class R{constructor(){this.a=new Map}add(j,v){L.ok(D.$yf(j)),L.ok(D.$Af(v)),L.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,v)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$jn=new R}),define(te[131],ne([0,1,4,36]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0,e.$kn={JSONContribution:"base.contributions.json"};function R(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class A{constructor(){this.b=new L.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[R(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const j=new A;D.$jn.add(e.$kn.JSONContribution,j)}),define(te[43],ne([0,1,19,4,3,88,25,131,36]),function(J,e,L,D,R,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.ConfigurationScope=e.$on=e.EditPresentationTypes=void 0;var c;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$on={Configuration:"base.contributions.configuration"};var S;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn="vscode://schemas/settings/resourceLanguage",e.$wn="vscode://schemas/settings/configurationDefaults";const I=u.$jn.as(v.$kn.JSONContribution);class g{constructor(){this.h=new Set,this.i=new D.$Nd,this.onDidSchemaChange=this.i.event,this.j=new D.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$vn,this.g),this.v()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const t=new Set;this.n(s,r,t),I.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const r=new Set;this.o(s,r),I.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:s,remove:r}){const t=new Set;this.o(r,t),this.n(s,!1,t),I.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const r=new Set;this.k(s,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(s,r){const t=[];for(const{overrides:i,source:n}of s)for(const o in i)if(r.add(o),e.$yn.test(o)){const l=this.a.get(o),k=l?.valuesSources??new Map;if(n)for(const B of Object.keys(i[o]))k.set(B,n);const E={...l?.value||{},...i[o]};this.a.set(o,{source:n,value:E,valuesSources:k});const p=(0,j.$ti)(o),N={type:"object",default:E,description:A.localize(1,null,p),$ref:e.$vn,defaultDefaultValue:E,source:R.$yf(n)?void 0:n,defaultValueSource:n};t.push(...y(o)),this.d[o]=N,this.b.properties[o]=N}else{this.a.set(o,{value:i[o],source:n});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(t)}deregisterDefaultConfigurations(s){const r=new Set;this.l(s,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(s,r){for(const{overrides:t,source:i}of s)for(const n in t){const o=this.a.get(n),l=R.$yf(i)?i:i?.id,k=R.$yf(o?.source)?o?.source:o?.source?.id;if(l===k)if(r.add(n),this.a.delete(n),e.$yn.test(n))delete this.d[n],delete this.b.properties[n];else{const E=this.d[n];E&&(this.w(n,E),this.r(n,E))}}this.u()}deltaConfiguration(s){let r=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),r=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),r=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const r of s)this.h.add(r);this.u()}n(s,r,t){s.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(s,r){const t=i=>{if(i.properties)for(const n in i.properties){r.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of s){t(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(s,r=!0,t,i,n=3,o){n=R.$Hf(s.scope)?n:s.scope;const l=s.properties;if(l)for(const E in l){const p=l[E];if(r&&O(E,p)){delete l[E];continue}if(p.source=t,p.defaultDefaultValue=l[E].default,this.w(E,p),e.$yn.test(E)?p.scope=void 0:(p.scope=R.$Hf(p.scope)?n:p.scope,p.restricted=R.$Hf(p.restricted)?!!i?.includes(E):p.restricted),l[E].hasOwnProperty("included")&&!l[E].included){this.f[E]=l[E],delete l[E];continue}else this.d[E]=l[E],l[E].policy?.name&&this.e.set(l[E].policy.name,E);!l[E].deprecationMessage&&l[E].markdownDeprecationMessage&&(l[E].deprecationMessage=l[E].markdownDeprecationMessage),o.add(E)}const k=s.allOf;if(k)for(const E of k)this.p(E,r,t,i,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const r=t=>{const i=t.properties;if(i)for(const o in i)this.r(o,i[o]);t.allOf?.forEach(r)};r(s)}r(s,r){switch(e.$pn.properties[s]=r,r.scope){case 1:e.$qn.properties[s]=r;break;case 2:e.$rn.properties[s]=r;break;case 6:e.$sn.properties[s]=r;break;case 3:e.$tn.properties[s]=r;break;case 4:e.$un.properties[s]=r;break;case 5:e.$un.properties[s]=r,this.g.properties[s]=r;break}}s(s,r){switch(delete e.$pn.properties[s],r.scope){case 1:delete e.$qn.properties[s];break;case 2:delete e.$rn.properties[s];break;case 6:delete e.$sn.properties[s];break;case 3:delete e.$tn.properties[s];break;case 4:case 5:delete e.$un.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const r=`[${s}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$vn};this.w(r,t),e.$pn.properties[r]=t,e.$qn.properties[r]=t,e.$rn.properties[r]=t,e.$sn.properties[r]=t,e.$tn.properties[r]=t,e.$un.properties[r]=t}}v(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$vn};e.$pn.patternProperties[e.$xn]=s,e.$qn.patternProperties[e.$xn]=s,e.$rn.patternProperties[e.$xn]=s,e.$sn.patternProperties[e.$xn]=s,e.$tn.patternProperties[e.$xn]=s,e.$un.patternProperties[e.$xn]=s,this.i.fire()}w(s,r){const t=this.a.get(s);let i=t?.value,n=t?.source;R.$Ff(i)&&(i=r.defaultDefaultValue,n=void 0),R.$Ff(i)&&(i=h(r.type)),r.default=i,r.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",P=new RegExp(f,"g");e.$xn=`^(${f})+$`,e.$yn=new RegExp(e.$xn);function y(w){const s=[];if(e.$yn.test(w)){let r=P.exec(w);for(;r?.length;){const t=r[1].trim();t&&s.push(t),r=P.exec(w)}}return(0,L.$Lb)(s)}e.$zn=y;function $(w){return w.reduce((s,r)=>`${s}[${r}]`,"")}e.$An=$;function h(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Bn=h;const b=new g;u.$jn.add(e.$on.Configuration,b);function O(w,s){return w.trim()?e.$yn.test(w)?A.localize(7,null,w):b.getConfigurationProperties()[w]!==void 0?A.localize(8,null,w):s.policy?.name&&b.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,w,s.policy?.name,b.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.$Cn=O;function d(){const w=[],s=b.getConfigurationProperties();for(const r of Object.keys(s))w.push([r,s[r].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.$Dn=d}),define(te[66],ne([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(J,e,L,D,R,A,j,v,u,c,S,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=void 0;function f(r){return Object.isFrozen(r)?r:v.$8m(r)}class P{constructor(t={},i=[],n=[],o){this.b=t,this.c=i,this.d=n,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof P)return i;const n=new y("");return n.parseRaw(i),n.configurationModel});this.f=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,S.$ri)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),o=i?this.rawConfiguration.getOverrideValue(t,i):void 0,l=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:o,merged:l}}getOverrideValue(t,i){const n=this.i(i);return n?t?(0,S.$ri)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return L.$Lb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.$Lb(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=v.$7m(this.contents),n=v.$7m(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const k of t)if(l.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(i,k.contents);for(const E of k.overrides){const[p]=n.filter(N=>L.$tb(N.identifiers,E.identifiers));p?(this.h(p.contents,E.contents),p.keys.push(...E.keys),p.keys=L.$Lb(p.keys)):n.push(v.$7m(E))}for(const E of k.keys)o.indexOf(E)===-1&&o.push(E)}return new P(i,o,n,l.every(k=>k instanceof P)?void 0:l)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of L.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[o];const k=i[o];k&&(typeof l=="object"&&typeof k=="object"?(l=v.$7m(l),this.h(l,k)):l=k),n[o]=l}return new P(n,this.keys,this.overrides)}h(t,i){for(const n of Object.keys(i)){if(n in t&&u.$Af(t[n])&&u.$Af(i[n])){this.h(t[n],i[n]);continue}t[n]=v.$7m(i[n])}}i(t){let i=null,n=null;const o=l=>{l&&(n?this.h(n,l):n=v.$7m(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?i=l.contents:l.identifiers.includes(t)&&o(l.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,S.$qi)(this.contents,t),I.$yn.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>L.$tb(n.identifiers,(0,I.$zn)(t))),1))}j(t,i,n){(0,S.$pi)(this.contents,t,i,o=>console.error(o)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),I.$yn.test(t)&&this.overrides.push({identifiers:(0,I.$zn)(t),keys:Object.keys(this.contents[t]),contents:(0,S.$oi)(this.contents[t],o=>console.error(o))})}}e.$En=P;class y{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new P}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!u.$Hf(t)){const n=this.g(t);this.parseRaw(n,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:n,keys:o,overrides:l,restricted:k,hasExcludedProperties:E}=this.h(t,i);this.b=new P(n,o,l,E?[t]:void 0),this.c=k||[]}g(t){let i={},n=null,o=[];const l=[],k=[];function E(N){Array.isArray(o)?o.push(N):n!==null&&(o[n]=N)}const p={onObjectBegin:()=>{const N={};E(N),l.push(o),o=N,n=null},onObjectProperty:N=>{n=N},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const N=[];E(N),l.push(o),o=N,n=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:E,onError:(N,B,_)=>{k.push({error:N,offset:B,length:_})}};if(t)try{R.$4m(t,p),i=o[0]||{}}catch(N){console.error(`Error while parsing settings file ${this.f}: ${N}`),this.d=[N]}return i}h(t,i){const n=g.$jn.as(I.$on.Configuration).getConfigurationProperties(),o=this.i(t,n,!0,i);t=o.raw;const l=(0,S.$oi)(t,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),k=Object.keys(t),E=this.j(t,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:l,keys:k,overrides:E,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,i,n,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const k={},E=[];for(const p in t)if(I.$yn.test(p)&&n){const N=this.i(t[p],i,!1,o);k[p]=N.raw,l=l||N.hasExcludedProperties,E.push(...N.restricted)}else{const N=i[p],B=N?typeof N.scope<"u"?N.scope:3:void 0;N?.restricted&&E.push(p),!o.exclude?.includes(p)&&(o.include?.includes(p)||(B===void 0||o.scopes===void 0||o.scopes.includes(B))&&!(o.skipRestricted&&N?.restricted))?k[p]=t[p]:l=!0}return{raw:k,restricted:E,hasExcludedProperties:l}}j(t,i){const n=[];for(const o of Object.keys(t))if(I.$yn.test(o)){const l={};for(const k in t[o])l[k]=t[o][k];n.push({identifiers:(0,I.$zn)(o),keys:Object.keys(l),contents:(0,S.$oi)(l,i)})}return n}}e.$Fn=y;class $ extends A.$Rc{constructor(t,i,n,o){super(),this.c=t,this.f=i,this.g=o,this.b=this.B(new D.$Nd),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new P}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Gn=$;class h{constructor(t,i,n,o,l,k,E,p,N,B,_,ee,oe){this.a=t,this.b=i,this.c=n,this.overrideIdentifiers=o,this.d=l,this.f=k,this.g=E,this.h=p,this.i=N,this.j=B,this.k=_,this.l=ee,this.m=oe}get value(){return f(this.c)}n(t,i,n){const o=t.inspect(i,n);return{get value(){return f(o.value)},get override(){return f(o.override)},get merged(){return f(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class b{constructor(t,i,n,o,l=new P,k=new P,E=new j.$zc,p=new P,N=new j.$zc){this.c=t,this.d=i,this.f=n,this.g=o,this.h=l,this.i=k,this.j=E,this.l=p,this.m=N,this.a=null,this.b=new j.$zc,this.n=null}getValue(t,i,n){return this.q(t,i,n).getValue(t)}updateValue(t,i,n={}){let o;n.resource?(o=this.m.get(n.resource),o||(o=new P,this.m.set(n.resource,o))):o=this.l,i===void 0?o.removeValue(t):o.setValue(t,i),n.resource||(this.a=null)}inspect(t,i,n){const o=this.q(t,i,n),l=this.u(i.resource,n),k=i.resource?this.m.get(i.resource)||this.l:this.l,E=new Set;for(const p of o.overrides)for(const N of p.identifiers)o.getOverrideValue(t,N)!==void 0&&E.add(N);return new h(t,i,o.getValue(t),E.size?[...E]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,l||void 0,k)}keys(t){const i=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:o,updated:l,removed:k}=w(this.c,t);i=[...o,...l,...k]}for(const o of i)for(const l of(0,I.$zn)(o)){const k=this.c.getKeysForOverrideIdentifier(l),E=t.getKeysForOverrideIdentifier(l),p=[...E.filter(N=>k.indexOf(N)===-1),...k.filter(N=>E.indexOf(N)===-1),...k.filter(N=>!v.$$m(this.c.override(l).getValue(N),t.override(l).getValue(N)))];n.push([l,p])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:o}=w(this.d,t),l=[...i,...n,...o];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:o,overrides:l}=w(this.applicationConfiguration,t),k=[...i,...n,...o];return k.length&&this.updateApplicationConfiguration(t),{keys:k,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:o,overrides:l}=w(this.localUserConfiguration,t),k=[...i,...n,...o];return k.length&&this.updateLocalUserConfiguration(t),{keys:k,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:o,overrides:l}=w(this.remoteUserConfiguration,t),k=[...i,...n,...o];return k.length&&this.updateRemoteUserConfiguration(t),{keys:k,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:o,overrides:l}=w(this.workspaceConfiguration,t),k=[...i,...n,...o];return k.length&&this.updateWorkspaceConfiguration(t),{keys:k,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const n=this.p.get(t),{added:o,updated:l,removed:k,overrides:E}=w(n,i),p=[...o,...l,...k];return(p.length||!n)&&this.updateFolderConfiguration(t,i),{keys:p,overrides:E}}compareAndDeleteFolderConfiguration(t){const i=this.p.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:o,removed:l,overrides:k}=w(i,void 0);return{keys:[...n,...o,...l],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,i,n){let o=this.r(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}r({resource:t},i){let n=this.s();if(i&&t){const o=i.getFolder(t);o&&(n=this.t(o.uri)||n);const l=this.m.get(t);l&&(n=n.merge(l))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let i=this.b.get(t);if(!i){const n=this.s(),o=this.j.get(t);o?(i=n.merge(o),this.b.set(t,i)):i=n}return i}u(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:n,overrides:o,keys:l}=this.j.get(i);return t.push([i,{contents:n,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}w(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.x(t.defaults),n=this.x(t.policy),o=this.x(t.application),l=this.x(t.user),k=this.x(t.workspace),E=t.folders.reduce((p,N)=>(p.set(c.URI.revive(N[0]),this.x(N[1])),p),new j.$zc);return new b(i,n,o,l,new P,k,E,new P,new j.$zc)}static x(t){return new P(t.contents,t.keys,t.overrides)}}e.$Hn=b;function O(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const o of r)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,k])=>{const E=(0,j.$wc)(i,l,new Set);k.forEach(p=>E.add(p))});const n=[];return i.forEach((o,l)=>n.push([l,[...o.values()]])),{keys:[...t.values()],overrides:n}}e.$In=O;class d{constructor(t,i,n,o){this.change=t,this.f=i,this.g=n,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const k of l)this.affectedKeys.add(k);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=b.parse(this.f.data)),this.i}affectsConfiguration(t,i){const n=this.a+t,o=this.d.indexOf(n);if(o<0)return!1;const l=o+n.length;if(l>=this.d.length)return!1;const k=this.d.charCodeAt(l);if(k!==this.b&&k!==this.c)return!1;if(i){const E=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,p=this.g.getValue(t,i,this.h);return!v.$$m(E,p)}return!0}}e.$Jn=d;function w(r,t){const{added:i,removed:n,updated:o}=s(t?.rawConfiguration,r?.rawConfiguration),l=[],k=r?.getAllOverrideIdentifiers()||[],E=t?.getAllOverrideIdentifiers()||[];if(t){const p=E.filter(N=>!k.includes(N));for(const N of p)l.push([N,t.getKeysForOverrideIdentifier(N)])}if(r){const p=k.filter(N=>!E.includes(N));for(const N of p)l.push([N,r.getKeysForOverrideIdentifier(N)])}if(t&&r){for(const p of k)if(E.includes(p)){const N=s({contents:r.getOverrideValue(void 0,p)||{},keys:r.getKeysForOverrideIdentifier(p)},{contents:t.getOverrideValue(void 0,p)||{},keys:t.getKeysForOverrideIdentifier(p)});l.push([p,[...N.added,...N.removed,...N.updated]])}}return{added:i,removed:n,updated:o,overrides:l}}function s(r,t){const i=r?t?r.keys.filter(l=>t.keys.indexOf(l)===-1):[...r.keys]:[],n=t?r?t.keys.filter(l=>r.keys.indexOf(l)===-1):[...t.keys]:[],o=[];if(r&&t){for(const l of t.keys)if(r.keys.indexOf(l)!==-1){const k=(0,S.$ri)(t.contents,l),E=(0,S.$ri)(r.contents,l);v.$$m(k,E)||o.push(l)}}return{added:i,removed:n,updated:o}}}),define(te[132],ne([0,1,19,4,2,30,3,66,43,6,38,36]),function(J,e,L,D,R,A,j,v,u,c,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=void 0;class g extends R.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new v.$En}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(I.$jn.as(u.$on.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:h})=>this.c(Array.from($),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,h){this.h($,I.$jn.as(u.$on.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new v.$En;const $=I.$jn.as(u.$on.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,h){const b=this.f();for(const O of $){const d=b[O],w=h[O];d!==void 0?this.b.addValue(O,d):w?this.b.addValue(O,w.default):this.b.removeValue(O)}}}e.$Kn=g;class f{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new v.$En}async initialize(){return this.configurationModel}}e.$Ln=f;let P=class extends R.$Rc{get configurationModel(){return this.b}constructor($,h,b){super(),this.c=$,this.f=h,this.g=b,this.a=this.B(new D.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new v.$En}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const h={},b=[],O=I.$jn.as(u.$on.Configuration).getConfigurationProperties();for(const d of $){const w=O[d];if(!w){b.push(d);continue}if(w.policy){if(w.type!=="string"&&w.type!=="number"){this.g.warn(`Policy ${w.policy.name} has unsupported type ${w.type}`);continue}b.push(d),h[w.policy.name]={type:w.type}}}return(0,j.$Lf)(h)||await this.f.updatePolicyDefinitions(h),b}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const h=I.$jn.as(u.$on.Configuration).getPolicyConfigurations(),b=(0,L.$Gb)($.map(O=>h.get(O)));this.m(b,!0)}m($,h){this.g.trace("PolicyConfiguration#update",$);const b=I.$jn.as(u.$on.Configuration).getConfigurationProperties(),O=[],d=this.b.isEmpty();for(const w of $){const s=b[w]?.policy?.name;if(s){const r=this.f.getPolicyValue(s);(d?r!==void 0:!(0,A.$$m)(this.b.getValue(w),r))&&O.push([w,r])}else this.b.getValue(w)!==void 0&&O.push([w,void 0])}if(O.length){this.g.trace("PolicyConfiguration#changed",O);const w=this.b;this.b=new v.$En;for(const s of w.keys)this.b.setValue(s,w.getValue(s));for(const[s,r]of O)r===void 0?this.b.removeValue(s):this.b.setValue(s,r);h&&this.a.fire(this.b)}}};e.$Mn=P,e.$Mn=P=pe([ie(1,S.$ln),ie(2,c.$0i)],P)}),define(te[133],ne([0,1,8,4,2,17,25,66,132,38]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=void 0;class S extends R.$Rc{constructor(g,f,P,y){super(),this.j=g,this.h=this.B(new D.$Nd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$Kn),this.c=P instanceof c.$nn?new u.$Ln:this.B(new u.$Mn(this.b,P,y)),this.f=this.B(new v.$Gn(this.j,{},A.$mg,f)),this.a=new v.$Hn(this.b.configurationModel,this.c.configurationModel,new v.$En,new v.$En),this.g=this.B(new L.$6g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:h})=>this.n($,h))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,f,P]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new v.$Hn(g,f,new v.$En,P)}getConfigurationData(){return this.a.toData()}getValue(g,f){const P=typeof g=="string"?g:void 0,y=(0,j.$ki)(g)?g:(0,j.$ki)(f)?f:{};return this.a.getValue(P,y,void 0)}updateValue(g,f,P,y){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.m(g)}m(g){const f=this.a.toData(),P=this.a.compareAndUpdateLocalUserConfiguration(g);this.s(P,f,2)}n(g,f){const P=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(g,f);this.s(y,P,7)}r(g){const f=this.a.toData(),P=this.a.compareAndUpdatePolicyConfiguration(g);this.s(P,f,7)}s(g,f,P){const y=new v.$Jn(g,{data:f},this.a);y.source=P,y.sourceConfig=this.t(P),this.h.fire(y)}t(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Nn=S}),define(te[67],ne([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function D(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$Uk=D;function R(c){if(!c)return;const S=c.indexOf("+");return S<0?c:c.substr(0,S)}e.$Vk=R;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Wk=A;function j(c){const{host:S,port:I}=u(c);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:S,port:I}}e.$Xk=j;function v(c,S){let{host:I,port:g}=u(c);return typeof g>"u"&&(g=S),{host:I,port:g}}e.$Yk=v;function u(c){const S=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const I=c.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const g=c.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:c,port:void 0}}}),define(te[37],ne([0,1,29,10,67]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function A(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$4l=A,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var j;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(j||(e.ExtensionType=j={}));var v;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(v||(e.TargetPlatform=v={}));class u{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,h){if(typeof $>"u"||$===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof $=="string"||typeof h=="string"){const b=typeof $=="string"?$:$.value,O=typeof h=="string"?h:h.value;return L.$2e(b,O)}return $._lower===h._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$6l=u;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const h of $)this.add(h)}add($){this.c.add(u.toKey($))}delete($){return this.c.delete(u.toKey($))}has($){return this.c.has(u.toKey($))}}e.$7l=c;class S{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(u.toKey($))}get($){return this.c.get(u.toKey($))}has($){return this.c.has(u.toKey($))}set($,h){this.c.set(u.toKey($),h)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=S;function I(y){return g(y)}e.$9l=I;function g(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$0l=g;function f(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$$l=f;function P(y,$){if($){const h=`onResolveRemoteAuthority:${(0,R.$Vk)($)}`;return!!y.activationEvents?.includes(h)}return!1}e.$_l=P,e.$am=(0,D.$Ph)("IBuiltinExtensionsScannerService")}),define(te[134],ne([0,1,2,37,12]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;class A extends L.$Rc{constructor(v,u,c,S,I){super(),this.a=v,this.b=u,this.c=c,this.f=I,this.B(S.onDidInstallExtensions(g=>this.g(g))),this.B(S.onDidUninstallExtension(g=>this.h(g)))}g(v){for(const u of v)u.local&&this.invalidate(u.profileLocation)}h(v){v.error||this.invalidate(v.profileLocation)}async invalidate(v){if(v)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,v)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(v){try{await this.b.del(this.c.extUri.joinPath(v.cacheHome,D.$Zl))}catch(u){(0,R.$pk)(u)!==1&&this.f.error(u)}}}e.$Jp=A}),define(te[44],ne([0,1,14,9,2,103,43,10,6,36]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=void 0,e.$Vo=(0,v.$Ph)("requestService");class S{constructor(w){this.b=w}toJSON(){if(!this.a){const w=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?w[s]="*****":w[s]=this.b[s];this.a=w}return this.a}}class I extends R.$Rc{constructor(w){super(),this.b=0,this.a=w.createLogger("network",{name:(0,A.localize)(0,null),when:u.$oj.isEqualTo((0,u.$mj)(u.LogLevel.Trace)).serialize()})}async c(w,s,r){const t=`${w} #${++this.b}: ${s.url}`;this.a.trace(`${t} - begin`,s.type,new S(s.headers??{}));try{const i=await r();return this.a.trace(`${t} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,s.type,(0,D.$9)(i)),i}}}e.$Wo=I;function g(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.$Xo=g;function f(d){return d.res.statusCode===204}e.$Yo=f;async function P(d){return f(d)?null:(await(0,L.$ne)(d.stream)).toString()}e.$Zo=P;async function y(d){if(!g(d))throw new Error("Server returned "+d.res.statusCode);return P(d)}e.$1o=y;async function $(d){if(!g(d))throw new Error("Server returned "+d.res.statusCode);if(f(d))return null;const s=(await(0,L.$ne)(d.stream)).toString();try{return JSON.parse(s)}catch(r){throw r.message+=`:
`+s,r}}e.$2o=$;function h(d){O(d)}e.$3o=h;let b;function O(d){const w=c.$jn.as(j.$on.Configuration),s=b;b={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},w.updateConfigurations({add:[b],remove:s?[s]:[]})}O(1)}),define(te[135],ne([0,1,20,15,12,44]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3N=void 0;let j=class{constructor(u,c){this.a=u,this.b=c}async download(u,c,S=L.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,c);return}const I={type:"GET",url:u.toString(!0)},g=await this.a.request(I,S);if(g.res.statusCode===200)await this.b.writeFile(c,g.stream);else{const f=await(0,A.$1o)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${f}`)}}};e.$3N=j,e.$3N=j=pe([ie(0,A.$Vo),ie(1,R.$$j)],j)}),define(te[136],ne([0,1,137,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;function R(j,v){return j.protocol==="http:"?v.HTTP_PROXY||v.http_proxy||null:j.protocol==="https:"&&(v.HTTPS_PROXY||v.https_proxy||v.HTTP_PROXY||v.http_proxy)||null}async function A(j,v,u={}){const c=(0,L.parse)(j),S=u.proxyUrl||R(c,v);if(!S)return null;const I=(0,L.parse)(S);if(!/^https?:$/.test(I.protocol||""))return null;const g={host:I.hostname||"",port:(I.port?+I.port:0)||(I.protocol==="https"?443:80),auth:I.auth,rejectUnauthorized:(0,D.$Ef)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((f,P)=>{J(["http-proxy-agent"],f,P)})).HttpProxyAgent(S,g):new(await new Promise((f,P)=>{J(["https-proxy-agent"],f,P)})).HttpsProxyAgent(S,g)}e.$1q=A}),define(te[138],ne([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=void 0;let P;async function y(h,b,O,d){return O["force-disable-user-env"]?(b.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$j?(b.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.$Nl)(d)&&!O["force-user-env"]?(b.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.$Nl)(d)?b.trace("resolveShellEnv(): running (--force-user-env)"):b.trace("resolveShellEnv(): running (macOS/Linux)"),P||(P=g.Promises.withAsyncBody(async(w,s)=>{const r=new A.$Xd;let t=1e4;const i=h.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,f.$Ol)(i,1,120)*1e3);const n=setTimeout(()=>{r.dispose(!0),s(new Error((0,R.localize)(0,null)))},t);try{w(await $(b,r.token))}catch(o){!(0,v.$3)(o)&&!r.token.isCancellationRequested?s(new Error((0,R.localize)(1,null,(0,j.$Ai)(o)))):w({})}finally{clearTimeout(n),r.dispose()}})),P)}e.$Tl=y;async function $(h,b){const O=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",O);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",d);const w=(0,c.$eg)().replace(/-/g,"").substr(0,12),s=new RegExp(w+"({.*})"+w),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",r);const t=await(0,S.$Dl)(u.OS,r);return h.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if(b.isCancellationRequested)return n(new v.$4);const o=(0,D.$mc)(t);let l,k;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${E} -p '''${w}'' + JSON.stringify(process.env) + ''${w}'''`,k=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${E} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,k=["-i","-l","-c"]):(l=`'${process.execPath}' ${E} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,o==="tcsh"||o==="csh"?k=["-ic"]:k=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),l);const p=(0,L.spawn)(t,[...k,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});b.onCancellationRequested(()=>(p.kill(),n(new v.$4))),p.on("error",_=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,j.$Ai)(_)),n(_)});const N=[];p.stdout.on("data",_=>N.push(_));const B=[];p.stderr.on("data",_=>B.push(_)),p.on("close",(_,ee)=>{const oe=Buffer.concat(N).toString("utf8");h.trace("getUnixShellEnvironment#raw",oe);const se=Buffer.concat(B).toString("utf8");if(se.trim()&&h.trace("getUnixShellEnvironment#stderr",se),_||ee)return n(new Error((0,R.localize)(2,null,_,ee)));const ue=s.exec(oe),ce=ue?ue[1]:"{}";try{const re=JSON.parse(ce);O?re.ELECTRON_RUN_AS_NODE=O:delete re.ELECTRON_RUN_AS_NODE,d?re.ELECTRON_NO_ATTACH_CONSOLE=d:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.VSCODE_RESOLVING_ENVIRONMENT,delete re.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",re),i(re)}catch(re){h.error("getUnixShellEnvironment#errorCaught",(0,j.$Ai)(re)),n(re)}})})}}),define(te[139],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=void 0,e.$EN=(0,L.$Ph)("stateReadService"),e.$FN=(0,L.$Ph)("stateService")}),define(te[68],ne([0,1,8,14,2,3,18,12,6]),function(J,e,L,D,R,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=e.$HN=e.$GN=e.SaveStrategy=void 0;var c;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class S extends R.$Rc{constructor(P,y,$,h){super(),this.h=P,this.j=$,this.m=h,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=y===0?void 0:this.B(new L.$Rg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(P){P.fileOperationResult!==1&&this.j.error(P)}}getItem(P,y){const $=this.a[P];return(0,A.$Hf)($)?y:$}setItem(P,y){this.setItems([{key:P,data:y}])}setItems(P){let y=!1;for(const{key:$,data:h}of P)this.a[$]!==h&&((0,A.$Hf)(h)?(0,A.$Ff)(this.a[$])||(this.a[$]=void 0,y=!0):(this.a[$]=h,y=!0));y&&this.r()}removeItem(P){(0,A.$Ff)(this.a[P])||(this.a[P]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const P=JSON.stringify(this.a,null,4);if(P!==this.b)try{await this.m.writeFile(this.h,D.$be.fromString(P),{atomic:{postfix:".vsctmp"}}),this.b=P}catch(y){this.j.error(y)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$GN=S;let I=class extends R.$Rc{constructor(P,y,$,h){super(),this.a=this.B(new S(y.stateResource,P,$,h))}async init(){await this.a.init()}getItem(P,y){return this.a.getItem(P,y)}};e.$HN=I,e.$HN=I=pe([ie(1,j.$Wh),ie(2,u.$0i),ie(3,v.$$j)],I);class g extends I{setItem(P,y){this.a.setItem(P,y)}setItems(P){this.a.setItems(P)}removeItem(P){this.a.removeItem(P)}close(){return this.a.close()}}e.$IN=g}),define(te[69],ne([0,1,13,35,28]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=void 0;function A(u){if(L.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function j(u,c,S,I,g,f,P,y,$){const h=Object.create(null);h["common.machineId"]=f,h["common.sqmId"]=P,h.sessionID=(0,R.$eg)()+Date.now(),h.commitHash=I,h.version=g,h["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,L.$i)(L.$u),h["common.nodePlatform"]=D.$cc,h["common.nodeArch"]=S,h["common.product"]=$||"desktop",y&&(h["common.msftInternal"]=y);let b=0;const O=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-O,enumerable:!0},"common.sequence":{get:()=>b++,enumerable:!0}}),L.$m&&(h["common.snap"]="true");const d=A(c);return d&&(h["common.platformDetail"]=d),h}e.$ko=j;function v(u){const c=D.env.USERDNSDOMAIN;if(!c)return!1;const S=c.toLowerCase();return u.some(I=>S===I)}e.$lo=v}),define(te[26],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,L.$Ph)("telemetryService"),e.$dl=(0,L.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var D;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var R;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(te[39],ne([0,1,30,3,4,25,67,69,26]),function(J,e,L,D,R,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$mo=c;class S{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$no=S,e.$oo=new S;class I{async publicLog(n,o,l){}async publicLogError(n,o,l){}}e.$po=I,e.$qo="telemetry",e.$ro="extensionTelemetryLog",e.$so={log:()=>null,flush:()=>Promise.resolve(null)};function g(i,n){return R.Event.debounce(n.onDidChangeConfiguration,(l,k)=>{const E=l?new Set([...l.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:E}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.$mi)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$to=g;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$uo=f;function P(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$vo=P;function y(i){const n=i.getValue(u.$kl),o=i.getValue(u.$ll);if(i.getValue(u.$ml)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$wo=y;function $(i){const n={},o={},l={};O(i,l);for(let k in l){k=k.length>150?k.substr(k.length-149):k;const E=l[k];typeof E=="number"?o[k]=E:typeof E=="boolean"?o[k]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${E.length}`),n[k]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(n[k]=E)}return{properties:n,measurements:o}}e.$xo=$;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function b(i){if(!i)return"none";const n=(0,j.$Vk)(i);return h.has(n)?n:"other"}e.$yo=b;function O(i,n,o=0,l){if(i)for(const k of Object.getOwnPropertyNames(i)){const E=i[k],p=l?l+k:k;Array.isArray(E)?n[p]=(0,L.$_m)(E):E instanceof Date?n[p]=E.toISOString():(0,D.$Af)(E)?o<2?O(E,n,o+1,p+"."):n[p]=(0,L.$_m)(E):n[p]=E}}function d(i,n){const o=i.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,v.$lo)(o)||l}e.$zo=d;function w(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Ao=w;function s(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const l=[];for(const N of n)for(;;){const B=N.exec(i);if(!B)break;l.push([B.index,N.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(o="";;){const N=E.exec(i);if(!N)break;const B=l.some(([_,ee])=>N.index<ee&&_<E.lastIndex);!k.test(N[0])&&!B&&(o+=i.substring(p,N.index)+"<REDACTED: user-file-path>",p=E.lastIndex)}return p<i.length&&(o+=i.substr(p)),o}function r(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function t(i,n){return(0,L.$9m)(i,o=>{if(o instanceof c||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let l=o.replaceAll("%20"," ");l=s(l,n);for(const k of n)l=l.replace(k,"");return l=r(l),l}})}e.$Bo=t}),define(te[27],ne([0,1,29,21,37,13,11,9,35,39]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0;function S(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.$We)(t.id,i.id)===0}e.$Co=S;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new g(i.identifier,n,o)}static parse(i){const n=I.exec(i);return n&&n[1]&&n[2]?new g({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof g?S(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Do=g;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function P(t){const i=f.exec(t);return i&&i[1]?[$(i[1]),i[2]]:[$(t),void 0]}e.$Eo=P;function y(t,i){return`${t}.${i}`}e.$Fo=y;function $(t){return t.toLowerCase()}e.$Go=$;function h(t,i){return $(y(t??R.$2l,i))}e.$Ho=h;function b(t,i){const n=[],o=l=>{for(const k of n)if(k.some(E=>S(i(E),i(l))))return k;return null};for(const l of t){const k=o(l);k?k.push(l):n.push([l])}return n}e.$Io=b;function O(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$Jo=O;function d(t){return{id:new c.$mo(t.identifier.id),name:new c.$mo(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Ko=d,e.$Lo=new R.$6l("pprice.better-merge");function w(t,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&n.every(k=>!S(k.identifier,{id:l}))){const k=t.filter(E=>S(E.identifier,{id:l}));k.length===1&&(n.push(k[0]),o.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Mo=w;async function s(t,i){if(!A.$l)return!1;let n;try{n=(await t.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,v.$9)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,i){const n=await s(t,i),o=(0,D.$9n)(n?"alpine":A.$u,u.$dc);return i.debug("ComputeTargetPlatform:",o),o}e.$No=r}),define(te[140],ne([0,1,20,9,15,17,42,11,93,21,27,37]),function(J,e,L,D,R,A,j,v,u,c,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=void 0;const g=$=>(0,u.localize)(0,null,$),f=(0,u.localize)(1,null,"ms-dotnettools.csharp");function P($,h){return h?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let y=class{constructor(h,b,O){this.a=h,this.b=b,this.d=O}get f(){}async listExtensions(h,b,O){let d=await this.b.getInstalled(1,O);const w=I.$5l.map(r=>r.toLowerCase());if(b&&b!==""){if(w.indexOf(b.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}d=d.filter(r=>r.manifest.categories?r.manifest.categories.map(i=>i.toLowerCase()).indexOf(b.toLowerCase())>-1:!1)}else if(b===""){this.a.info("Possible Categories: "),w.forEach(r=>{this.a.info(r)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),d=d.sort((r,t)=>r.identifier.id.localeCompare(t.identifier.id));let s;for(const r of d)s!==r.identifier.id&&(s=r.identifier.id,this.a.info(P(r.manifest,h)))}async installExtensions(h,b,O,d){const w=[];try{const s=[];h.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const r=[];let t=[];const i=(o,l,k)=>{t.push({id:o,version:l!=="prerelease"?l:void 0,installOptions:{...O,isBuiltin:k,installPreReleaseVersion:l==="prerelease"||O.installPreReleaseVersion}})};for(const o of h)if(o instanceof v.URI)r.push({vsix:o,installOptions:O});else{const[l,k]=(0,S.$Eo)(o);i(l,k,!1)}for(const o of b)if(o instanceof v.URI)r.push({vsix:o,installOptions:{...O,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,k]=(0,S.$Eo)(o);i(l,k,!0)}const n=await this.b.getInstalled(1,O.profileLocation);if(r.length&&await Promise.all(r.map(async({vsix:o,installOptions:l})=>{try{const k=await this.g(o,l,d,n);k&&s.push(k)}catch(k){this.a.error(k),w.push(o.toString())}})),t.length&&(t=t.filter(({id:o,version:l})=>{const k=n.find(E=>(0,S.$Co)(E.identifier,{id:o}));if(k){if(!d&&(!l||l==="prerelease"&&k.preRelease))return this.a.info((0,u.localize)(5,null,o,k.manifest.version,o)),!1;if(l&&k.manifest.version===l)return this.a.info((0,u.localize)(6,null,`${o}@${l}`)),!1}return!0}),t.length)){const o=await this.h(t);await Promise.all(t.map(async l=>{const k=o.get(l.id.toLowerCase());if(k)try{const E=await this.j(l,k,n);E&&s.push(E)}catch(E){this.a.error(E.message||E.stack||E),w.push(l.id)}else this.a.error(`${g(l.version?`${l.id}@${l.version}`:l.id)}
${f}`),w.push(l.id)}))}}catch(s){throw this.a.error((0,u.localize)(7,null,(0,D.$9)(s))),s}if(w.length)throw new Error((0,u.localize)(8,null,w.join(", ")))}async g(h,b,O,d){const w=await this.b.getManifest(h);if(!w)throw new Error("Invalid vsix");if(await this.l(w,O,b.profileLocation,d))try{return await this.b.install(h,b),this.a.info((0,u.localize)(9,null,(0,A.$sg)(h))),w}catch(r){if((0,D.$3)(r))return this.a.info((0,u.localize)(10,null,(0,A.$sg)(h))),null;throw r}return null}async h(h){const b=new Map,O=h.some(s=>s.installOptions.installPreReleaseVersion),d=await this.b.getTargetPlatform(),w=[];for(const s of h)c.$2n.test(s.id)&&w.push({...s,preRelease:O});if(w.length){const s=await this.d.getExtensions(w,{targetPlatform:d},L.CancellationToken.None);for(const r of s)b.set(r.identifier.id.toLowerCase(),r)}return b}async j({id:h,version:b,installOptions:O},d,w){const s=await this.d.getManifest(d,L.CancellationToken.None);if(s&&!this.k(s))return null;const r=w.find(t=>(0,S.$Co)(t.identifier,d.identifier));if(r){if(d.version===r.manifest.version)return this.a.info((0,u.localize)(11,null,b?`${h}@${b}`:h)),null;this.a.info((0,u.localize)(12,null,h,d.version))}try{O.isBuiltin?this.a.info(b?(0,u.localize)(13,null,h,b):(0,u.localize)(14,null,h)):this.a.info(b?(0,u.localize)(15,null,h,b):(0,u.localize)(16,null,h));const t=await this.b.installFromGallery(d,{...O,installGivenVersion:!!b});return this.a.info((0,u.localize)(17,null,h,t.manifest.version)),s}catch(t){if((0,D.$3)(t))return this.a.info((0,u.localize)(18,null,h)),null;throw t}}k(h){return!0}async l(h,b,O,d){if(!b){const w={id:(0,S.$Ho)(h.publisher,h.name)},s=d.find(r=>(0,S.$Co)(w,r.identifier)&&(0,j.gt)(r.manifest.version,h.version));if(s)return this.a.info((0,u.localize)(19,null,s.identifier.id,s.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,b,O){const d=async s=>{if(s instanceof v.URI){const r=await this.b.getManifest(s);return P(r)}return s},w=[];for(const s of h){const r=await d(s),i=(await this.b.getInstalled(void 0,O)).filter(n=>(0,S.$Co)(n.identifier,{id:r}));if(!i.length)throw new Error(`${this.m(r)}
${f}`);if(i.some(n=>n.type===0)){this.a.info((0,u.localize)(20,null,r));return}if(!b&&i.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(21,null,r));return}this.a.info((0,u.localize)(22,null,r));for(const n of i)await this.b.uninstall(n,{profileLocation:O}),w.push(n);this.f?this.a.info((0,u.localize)(23,null,r,this.f)):this.a.info((0,u.localize)(24,null,r))}}async locateExtension(h){const b=await this.b.getInstalled();h.forEach(O=>{b.forEach(d=>{if(d.identifier.id===O&&d.location.scheme===R.Schemas.file){this.a.info(d.location.fsPath);return}})})}m(h){return this.f?(0,u.localize)(25,null,h,this.f):(0,u.localize)(26,null,h)}};e.$jp=y,e.$jp=y=pe([ie(1,c.$co),ie(2,c.$ao)],y)}),define(te[141],ne([0,1,4,2,31,27,37]),function(J,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class v extends D.$Rc{constructor(c,S,I,g,f,P,y){super(),this.f=c,this.g=S,this.h=I,this.j=g,this.m=f,this.n=P,this.r=y,this.a=this.B(new L.$Nd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$Zc),this.s().then(null,$=>y.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(S=>(this.c.set(S.id,(0,D.$Oc)(this.n.watch(this.m.extUri.dirname(S.extensionsResource)),this.n.watch(S.extensionsResource))),this.G(S.extensionsResource))))}catch(S){throw this.r.error(S),S}}async w(c){for(const S of c.extensions)this.I(this.L(S.identifier,S.version),c.profileLocation)}async y(c){for(const S of c.extensions){const I=this.L(S.identifier,S.version);c.error?this.J(I,c.profileLocation):this.I(I,c.profileLocation)}}async z(c){for(const S of c.extensions)this.J(this.L(S.identifier,S.version),c.profileLocation)}async C(c){const S=[],I=[];for(const g of c.extensions){const f=this.L(g.identifier,g.version);c.error?this.I(f,c.profileLocation):(this.J(f,c.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",g.identifier.id,g.version),I.push(this.f.scanInstalledExtensionAtLocation(g.location).then(P=>{P?S.push(P):this.r.info("Extension not found at the location",g.location.toString())},P=>this.r.error(P)))))}try{await Promise.all(I),S.length&&await this.H(S)}catch(g){this.r.error(g)}}D(c){for(const S of this.h.profiles)c.contains(S.extensionsResource,0,1)&&this.F(S.extensionsResource)}async F(c){const S=[],I=[],g=await this.j.scanProfileExtensions(c),f=new Set,P=new Set;for(const[y,$]of this.b)$.has(c)&&P.add(y);for(const y of g){const $=this.L(y.identifier,y.version);f.add($),P.has($)||(S.push(y.identifier),this.I($,c))}for(const y of P)if(!f.has(y)){const $=this.M(y);$&&(I.push($.identifier),this.J(y,c))}(S.length||I.length)&&this.a.fire({added:S.length?{extensions:S,profileLocation:c}:void 0,removed:I.length?{extensions:I,profileLocation:c}:void 0})}async G(c){const S=await this.j.scanProfileExtensions(c);for(const I of S)this.I(this.L(I.identifier,I.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(I=>!this.b.has(this.L(I.identifier,I.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,S){let I=this.b.get(c);I||this.b.set(c,I=new R.$Ac(g=>this.m.extUri.getComparisonKey(g))),I.add(S)}J(c,S){const I=this.b.get(c);I&&I.delete(S),I?.size||this.b.delete(c)}L(c,S){return`${j.$6l.toKey(c.id)}@${S}`}M(c){const[S,I]=(0,A.$Eo)(c);return I?{identifier:{id:S},version:I}:void 0}}e.$Kp=v}),define(te[142],ne([0,1,113,39]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;async function R(A,j,v,u,c,S,I){const g={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${j.nameShort})`};if((0,D.$uo)(j,v)&&(0,D.$wo)(u)===3){const f=await(0,L.$cp)(v,c,S);g["X-Market-User-Id"]=f,g["VSCode-SessionId"]=I.machineId||f}return g}e.$dp=R}),define(te[143],ne([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;let y=class extends f.$Wq{constructor(O,d,w,s){super(w),this.h=O,this.j=s,this.g=this.B(new $(d,s)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(O,d){const s=(await this.g.getLanguagePacks())[d];if(!s){this.j.warn(`No language pack found for ${d}`);return}const r=s.translations[O];return r?P.URI.file(r):void 0}async getInstalledLanguages(){const O=await this.g.getLanguagePacks(),d=Object.keys(O).map(w=>{const s=O[w];return{...this.f(w,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return d.push(this.f("en","English")),d.sort((w,s)=>w.label.localeCompare(s.label)),d}async m(O){O&&O.manifest&&O.manifest.contributes&&O.manifest.contributes.localizations&&O.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",O.identifier.id),await this.update())}async n(O){const d=await this.g.getLanguagePacks();Object.keys(d).some(w=>d[w]&&d[w].extensions.some(s=>(0,I.$Co)(s.extensionIdentifier,O.identifier)))&&(this.j.info("Removing language packs from the extension",O.identifier.id),await this.update())}async update(){const[O,d]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),w=await this.g.update(d);return!(0,D.$tb)(Object.keys(O),Object.keys(w))}};e.$Xq=y,e.$Xq=y=pe([ie(0,S.$co),ie(1,c.$Xh),ie(2,S.$ao),ie(3,g.$0i)],y);let $=class extends A.$Rc{constructor(O,d){super(),this.j=d,this.c={},this.f=(0,v.$ic)(O.userDataPath,"languagepacks.json"),this.g=new R.$1g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(O){return this.s(d=>{Object.keys(d).forEach(w=>delete d[w]),this.m(d,...O)}).then(()=>this.c)}m(O,...d){for(const w of d)w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&this.n(O,w);Object.keys(O).forEach(w=>this.r(O[w]))}n(O,d){const w=d.identifier,s=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const r of s)if(d.location.scheme===j.Schemas.file&&h(r)){let t=O[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},O[r.languageId]=t);const i=t.extensions.filter(n=>(0,I.$Co)(n.extensionIdentifier,w))[0];i?i.version=d.manifest.version:t.extensions.push({extensionIdentifier:w,version:d.manifest.version});for(const n of r.translations)t.translations[n.id]=(0,v.$ic)(d.location.fsPath,n.path)}}r(O){if(O){const d=(0,L.createHash)("md5");for(const w of O.extensions)d.update(w.extensionIdentifier.uuid||w.extensionIdentifier.id).update(w.version);O.hash=d.digest("hex")}}s(O=()=>null){return this.g.queue(()=>{let d=null;return u.Promises.readFile(this.f,"utf8").then(void 0,w=>w.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(w)).then(w=>{try{return JSON.parse(w)}catch{return{}}}).then(w=>(d=O(w),w)).then(w=>{for(const r of Object.keys(w))w[r]||delete w[r];this.c=w,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),u.Promises.writeFile(this.f,s)}).then(()=>d,w=>this.j.error(w))})}};$=pe([ie(0,c.$Xh),ie(1,g.$0i)],$);function h(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const O of b.translations)if(typeof O.id!="string"||typeof O.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}}),define(te[144],ne([0,1,81,9,30,39]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=void 0;const j="https://mobile.events.data.microsoft.com/OneCollector/1.0",v="https://mobile.events.data.microsoft.com/ping";async function u(S,I,g){const f=await(0,L.$zC)("@microsoft/1ds-core-js","dist/ms.core.js"),P=await(0,L.$zC)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new f.AppInsightsCore,$=new P.PostChannel,h={instrumentationKey:S,endpointUrl:j,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(g){h.extensionConfig={};const b={alwaysUseXhrOverride:!0,httpXHROverride:g};h.extensionConfig[$.identifier]=b}return y.initialize(h,[]),y.addTelemetryInitializer(b=>{I&&(b.ext=b.ext??{},b.ext.utc=b.ext.utc??{},b.ext.utc.flags=8462029)}),y}class c{constructor(I,g,f,P,y){this.e=I,this.f=g,this.g=f,this.h=y,this.c=j,this.d=v,this.g||(this.g={}),typeof P=="function"?this.a=P():this.a=P,this.b=null}i(I){if(this.a){if(typeof this.a!="string"){I(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(g=>{I(g)},g=>{(0,D.$Z)(g),console.error(g)})}}log(I,g){if(!this.a)return;g=(0,R.$0m)(g,this.g),g=(0,A.$xo)(g);const f=this.f+"/"+I;try{this.i(P=>{P.pluginVersionString=g?.properties.version??"Unknown",P.track({name:f,baseData:{name:f,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise(I=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.$AN=c}),define(te[145],ne([0,1,2,30,13,29,105,25,43,146,32,36,26,39]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;let P=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,b,O){this.k=b,this.l=O,this.d={},this.i=new L.$Qc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,A.$Fe)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Fe)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(g.$kl)||d.affectsConfiguration(g.$ml)||d.affectsConfiguration(g.$ll))&&this.m()}))}setExperimentProperty(h,b){this.d[h]=b}m(){let h=(0,f.$wo)(this.k);const b=this.l.enabledTelemetryLevels;if(b){this.h=this.sendErrorTelemetry?b.error:!1;const O=b.usage?3:b.error?2:0;h=Math.min(h,O)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,b,O){this.g<b||(O=(0,D.$0m)(O,this.d),O=(0,f.$Bo)(O,this.j),O=(0,D.$0m)(O,this.c),this.b.forEach(d=>d.log(h,O)))}publicLog(h,b){this.n(h,3,b)}publicLog2(h,b){this.publicLog(h,b)}publicLogError(h,b){this.h&&this.n(h,2,b)}publicLogError2(h,b){this.publicLogError(h,b)}};e.$4q=P,e.$4q=P=pe([ie(1,v.$ji),ie(2,S.$pj)],P);function y(){const $=(0,j.localize)(0,null,c.default.nameLong),h=c.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),b=R.$p?"":(0,j.localize)(3,null),O=(0,j.localize)(4,null),d=(0,j.localize)(5,null),w=(0,j.localize)(6,null),s=(0,j.localize)(7,null),r=`
|       | ${O} | ${d} | ${w} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,j.localize)(8,null);return`
${$} ${h} ${b}

&nbsp;

${s}
${r}

&nbsp;

${t}
`}I.$jn.as(u.$on.Configuration).registerConfiguration({id:g.$jl,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[g.$kl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.$jn.as(u.$on.Configuration).registerConfiguration({id:g.$jl,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[g.$ml]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,j.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,j.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${g.$kl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[147],ne([0,1,14,20,174,144]),function(J,e,L,D,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0;async function j(S,I){const g=await I.request(S,D.CancellationToken.None),f=(await(0,L.$ne)(g.stream)).toString(),P=g.res.statusCode??200;return{headers:g.res.headers,statusCode:P,responseData:f}}async function v(S){const I={method:S.type,headers:S.headers};return new Promise((f,P)=>{const y=R.request(S.url??"",I,$=>{$.on("data",function(h){f({headers:$.headers,statusCode:$.statusCode??200,responseData:h.toString()})}),$.on("error",function(h){P(h)})});y.write(S.data,$=>{$&&P($)}),y.end()})}async function u(S,I,g){const f=typeof I.data=="string"?I.data:new TextDecoder().decode(I.data),P={type:"POST",headers:{...I.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(I.data).toString()},url:I.urlString,data:f};try{const y=S?await j(P,S):await v(P);g(y.statusCode,y.headers,y.responseData)}catch{g(0,{})}}class c extends A.$AN{constructor(I,g,f,P,y){const $={sendPOST:(h,b)=>{u(I,h,b)}};super(g,f,P,y,$)}}e.$BN=c}),define(te[148],ne([0,1,16,24]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b9b=void 0;async function R(A,j){const v=Object.create(null),u=(S,I)=>{const g=JSON.parse(S);v[I]=g};if(j){const S=[],I=await D.Promises.readdir(j);for(const f of I)try{(await D.Promises.stat((0,L.$ic)(j,f))).isDirectory()&&S.push(f)}catch{}const g=[];for(const f of S)(await D.Promises.readdir((0,L.$ic)(j,f))).filter(y=>y==="telemetry.json").length===1&&g.push(f);for(const f of g){const P=(await D.Promises.readFile((0,L.$ic)(j,f,"telemetry.json"))).toString();u(P,f)}}let c=(await D.Promises.readFile((0,L.$ic)(A,"telemetry-core.json"))).toString();return u(c,"vscode-core"),c=(await D.Promises.readFile((0,L.$ic)(A,"telemetry-extensions.json"))).toString(),u(c,"vscode-extensions"),JSON.stringify(v,null,4)}e.$b9b=R}),define(te[149],ne([0,1,13,82,26]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u8b=e.$t8b=void 0;async function A(v,u){let c=v.getItem(R.$hl);return(typeof c!="string"||L.$k&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,D.$Sm)(u.error.bind(u))),c}e.$t8b=A;async function j(v,u){let c=v.getItem(R.$il);return typeof c!="string"&&(c=await(0,D.$Tm)(u.error.bind(u))),c}e.$u8b=j}),define(te[22],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=void 0,e.$Ik=(0,L.$Ph)("IUriIdentityService")}),define(te[150],ne([0,1,22,114,12,17,73,4,2]),function(J,e,L,D,R,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;class c{static{this._clock=0}constructor(g){this.uri=g,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let S=class{constructor(g){this.g=g,this.c=new u.$Qc,this.f=2**16;const f=new Map,P=y=>{let $=f.get(y.scheme);return $===void 0&&($=g.hasProvider(y)&&!this.g.hasCapability(y,1024),f.set(y.scheme,$)),$};this.c.add(v.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(y=>{f.delete(y.scheme)})),this.extUri=new A.$kg(P),this.d=new j.$Br((y,$)=>this.extUri.compare(y,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,A.$wg)(g));const f=this.d.get(g);return f?f.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new c(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((P,y)=>P[1].time<y[1].time?1:P[1].time>y[1].time?-1:0);c._clock=0,this.d.clear();const f=this.f*.5;for(let P=0;P<f;P++)this.d.set(g[P][0],g[P][1].touch())}};e.$Cr=S,e.$Cr=S=pe([ie(0,R.$$j)],S),(0,D.$zr)(L.$Ik,S,1)}),define(te[151],ne([0,1,4,2,12,47,31]),function(J,e,L,D,R,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R8b=void 0;class v extends D.$Rc{constructor(c,S,I,g,f,P){super(),this.f=c,this.g=S,this.h=I,this.j=g,this.m=f,this.n=P,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Nd),this.onDidChangeFile=this.a.event,this.b=A.$Vh.forUris(()=>!(this.capabilities&1024)),this.c=new j.$Ac(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(g.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,S){return this.g.open(this.t(c),S)}close(c){return this.g.close(c)}read(c,S,I,g,f){return this.g.read(c,S,I,g,f)}write(c,S,I,g,f){return this.g.write(c,S,I,g,f)}watch(c,S){this.b.set(c,c);const I=this.g.watch(this.t(c),S);return(0,D.$Pc)(()=>{this.b.delete(c),I.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,S,I){return this.g.rename(this.t(c),this.t(S),I)}readFile(c,S){return this.g.readFile(this.t(c),S)}readFileStream(c,S,I){return this.g.readFileStream(this.t(c),S,I)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,S,I){return this.g.writeFile(this.t(c),S,I)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,S){return this.g.delete(this.t(c),S)}copy(c,S,I){if((0,R.$ck)(this.g))return this.g.copy(this.t(c),this.t(S),I);throw new Error("copy not supported")}cloneFile(c,S){if((0,R.$dk)(this.g))return this.g.cloneFile(this.t(c),this.t(S));throw new Error("clone not supported")}s(c){const S=[];for(const I of c){if(I.resource.scheme!==this.f)continue;const g=this.u(I.resource);this.b.findSubstr(g)&&S.push({resource:g,type:I.type,cId:I.cId})}S.length&&(this.n.debug("User data changed"),this.a.fire(S))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$R8b=v}),define(te[152],ne([0,1,107,16,47,17,11,10,15]),function(J,e,L,D,R,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,v.$Ph)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&j.URI.isUri(n.uri)}e.$Zh=c;function S(i){return typeof i?.id=="string"&&!c(i)&&!g(i)}e.$1h=S,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function I(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$mc)(i)}:n?e.$2h:e.$3h;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$4h=I;function g(i){const n=i;return typeof n?.id=="string"&&j.URI.isUri(n.configPath)}e.$5h=g;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:j.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:j.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.$6h=f;var P;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(P||(e.WorkbenchState=P={}));function y(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$7h=y;function $(i){const n=i;return!!(n&&typeof n=="object"&&j.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$8h=$;class h{constructor(n,o,l,k,E){this.h=n,this.j=l,this.k=k,this.l=E,this.c=R.$Vh.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.$Vh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=h;class b{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.$vg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=b;function O(i){return new b({uri:i,index:0,name:(0,A.$rg)(i)},{uri:i.toString()})}e.$$h=O,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,L.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function d(i,n){return A.$mg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$di=d;function w(i){let n;return j.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===u.Schemas.tmp}e.$ei=w,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$fi}e.$gi=s;function r(i,n){return!d(i,n)&&!w(i)}e.$hi=r;function t(i){return(typeof i=="string"?(0,D.$nc)(i):(0,A.$tg)(i))===e.$ai}e.$ii=t}),define(te[23],ne([0,1,41,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f,P,y,$,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.ProfileResourceType=void 0;var O;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(O||(e.ProfileResourceType=O={}));function d(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&j.URI.isUri(n.location)&&j.URI.isUri(n.globalStorageHome)&&j.URI.isUri(n.settingsResource)&&j.URI.isUri(n.keybindingsResource)&&j.URI.isUri(n.tasksResource)&&j.URI.isUri(n.snippetsHome)&&j.URI.isUri(n.extensionsResource))}e.$Jk=d,e.$Kk=(0,S.$Ph)("IUserDataProfilesService");function w(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:j.URI.revive(i.location).with({scheme:n}),globalStorageHome:j.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:j.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:j.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:j.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:j.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:j.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:j.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Lk=w;function s(i,n,o,l,k,E){return{id:i,name:n,location:o,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:E&&k?.useDefaultFlags?.globalState?E.globalStorageHome:(0,A.$vg)(o,"globalStorage"),settingsResource:E&&k?.useDefaultFlags?.settings?E.settingsResource:(0,A.$vg)(o,"settings.json"),keybindingsResource:E&&k?.useDefaultFlags?.keybindings?E.keybindingsResource:(0,A.$vg)(o,"keybindings.json"),tasksResource:E&&k?.useDefaultFlags?.tasks?E.tasksResource:(0,A.$vg)(o,"tasks.json"),snippetsHome:E&&k?.useDefaultFlags?.snippets?E.snippetsHome:(0,A.$vg)(o,"snippets"),extensionsResource:E&&k?.useDefaultFlags?.extensions?E.extensionsResource:(0,A.$vg)(o,"extensions.json"),cacheHome:(0,A.$vg)(l,i),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.$Mk=s;let r=class extends R.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,l,k){super(),this.t=n,this.u=o,this.w=l,this.y=k,this.f=!0,this.h=this.B(new D.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$zc,emptyWindows:new Map},this.profilesHome=(0,A.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const E of this.O()){if(!E.name||!(0,b.$yf)(E.name)||!E.location){this.y.warn("Skipping the invalid stored profile",E.location||E.name);continue}o.push(s((0,A.$sg)(E.location),E.name,E.location,this.g,{shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags},n))}}catch(E){this.y.error(E)}const l=new f.$zc,k=new Map;if(o.length)try{const E=this.Q();if(E.workspaces)for(const[p,N]of Object.entries(E.workspaces)){const B=j.URI.parse(p),_=o.find(ee=>ee.id===N);_&&l.set(B,_)}if(E.emptyWindows)for(const[p,N]of Object.entries(E.emptyWindows)){const B=o.find(_=>_.id===N);B&&k.set(p,B)}}catch(E){this.y.error(E)}this.z={profiles:o,workspaces:l,emptyWindows:k}}return this.z}D(){const n=s("__default__profile__",(0,v.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",l=new RegExp(`${(0,h.$Fe)(o)}\\s(\\d+)`);let k=0;for(const p of this.profiles){const N=l.exec(p.name),B=N?parseInt(N[1]):0;k=B>k?B:k}const E=`${o} ${k+1}`;return this.createProfile((0,L.$Di)((0,$.$eg)()).toString(16),E,{transient:!0},n)}async createNamedProfile(n,o,l){return this.createProfile((0,L.$Di)((0,$.$eg)()).toString(16),n,o,l)}async createProfile(n,o,l,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=await this.F(n,o,l);return k&&await this.setProfileForWorkspace(k,E),E}async F(n,o,l){if(!(0,b.$yf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(o);return k||(k=(async()=>{try{const E=this.profiles.find(B=>B.name===o||B.id===n);if(E)return E;const p=s(n,o,(0,A.$vg)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(p.location);const N=[];return this.j.fire({profile:p,join(B){N.push(B)}}),await y.Promises.settled(N),this.I([p],[],[]),p}finally{this.r.delete(o)}})(),this.r.set(o,k)),k}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(k=>k.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=s(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(k=>k.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:o,join(k){l.push(k)}});try{await Promise.allSettled(l)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(k){(0,c.$pk)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(k=>k.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n);return j.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(n){return(0,g.$Zh)(n)?n.uri:(0,g.$5h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,l){const k=[...this.profiles,...n],E=[];this.s.profiles=[];for(let p of k)p.isDefault||o.some(N=>p.id===N.id)||(p=l.find(N=>p.id===N.id)??p,p.isTransient?this.s.profiles.push(p):E.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(E),this.z=void 0,this.J(n,o,l)}J(n,o,l){this.h.fire({added:n,removed:o,updated:l,all:this.profiles})}L(n,o,l){l=o?.isTransient?!0:l,l||this.L(n,void 0,!0);const k=this.G(n),E=l?this.s:this.C;j.URI.isUri(k)?(E.workspaces.delete(k),o&&E.workspaces.set(k,o)):(E.emptyWindows.delete(k),o&&E.emptyWindows.set(k,o)),l||this.M()}M(){const n={};for(const[l,k]of this.C.workspaces.entries())n[l.toString()]=k.id;const o={};for(const[l,k]of this.C.emptyWindows.entries())o[l.toString()]=k.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},l=this.D();if(n.workspaces)for(const[E,p]of Object.entries(n.workspaces)){const N=j.URI.parse(p);o[E]=this.w.extUri.isEqual(N,l.location)?l.id:this.w.extUri.basename(N)}const k={};if(n.emptyWindows)for(const[E,p]of Object.entries(n.emptyWindows)){const N=j.URI.parse(p);k[E]=this.w.extUri.isEqual(N,l.location)?l.id:this.w.extUri.basename(N)}return{workspaces:o,emptyWindows:k}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Nk=r,e.$Nk=r=pe([ie(0,u.$Wh),ie(1,c.$$j),ie(2,P.$Ik),ie(3,I.$0i)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ok=t}),define(te[153],ne([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f,P,y,$,h,b,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=void 0;let d=class extends v.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,o,l,k,E,p){super(),this.z=n,this.C=o,this.D=l,this.F=k,this.G=E,this.H=p,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new j.$Nd),this.s=this.B(new j.$Nd),this.t=this.B(new j.$Nd),this.u=this.B(new j.$Nd),this.w=this.B(new j.$Nd),this.y=[],this.B((0,v.$Pc)(()=>{this.j.forEach(({task:N})=>N.cancel()),this.m.forEach(N=>N.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const o=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,g.$$n)(l,n.allTargetPlatforms,o))}async installFromGallery(n,o={}){try{const k=(await this.installGalleryExtensions([{extension:n,options:o}])).find(({identifier:E})=>(0,f.$Co)(E,n.identifier));if(k?.local)return k?.local;throw k?.error?k.error:s(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(l){throw s(l)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new g.$bo(I.localize(0,null),g.ExtensionManagementErrorCode.Internal);const o=[],l=[];await Promise.allSettled(n.map(async({extension:k,options:E})=>{try{const p=await this.O(k,!!E?.installGivenVersion,!!E?.installPreReleaseVersion);l.push({...p,options:E})}catch(p){o.push({identifier:k.identifier,operation:2,source:k,error:p})}})),l.length&&o.push(...await this.I(l));for(const k of o)k.error&&(this.F.error("Failed to install extension.",k.identifier.id),this.F.error(k.error),k.source&&!S.URI.isUri(k.source)&&r(this.C,"extensionGallery:install",{extensionData:(0,f.$Ko)(k.source),error:k.error}));return o}async uninstall(n,o={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,o)}async toggleAppliationScope(n,o){if((0,P.$9l)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let l=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(l=await this.ab(n,this.H.defaultProfile.extensionsResource,o));for(const k of this.H.profiles){const E=(await this.getInstalled(1,k.extensionsResource)).find(p=>(0,f.$Co)(p.identifier,n.identifier));E?this.w.fire(E):this.u.fire({identifier:n.identifier,profileLocation:k.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const o=[];return await Promise.allSettled(n.map(async l=>{try{const k=await this.J(l,(E,p)=>n.some(N=>(0,f.$Go)(p.identifier.id)===(0,f.$Ho)(N.manifest.publisher,N.manifest.name))?!1:this.L(E,p));o.push(...k)}catch(k){o.push({identifier:{id:(0,f.$Ho)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:k})}})),this.s.fire(o),o}async J({manifest:n,extension:o,options:l},k){const E=l.isApplicationScoped||l.isBuiltin||(0,P.$9l)(n),p={...l,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(o)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:E,profileLocation:E?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},N=ue=>`${f.$Do.create(ue).toString()}${p.profileLocation?`-${p.profileLocation.toString()}`:""}`;if(!S.URI.isUri(o)){const ue=this.j.get(N(o));if(ue)return this.F.info("Extensions is already requested to install",o.identifier.id),await ue.task.waitUntilTaskIsFinished(),[]}const B=[],_=[],ee=[],oe=this.Z(n,o,p);S.URI.isUri(o)||this.j.set(N(o),{task:oe,waitingTasks:[]}),this.n.fire({identifier:oe.identifier,source:o,profileLocation:p.profileLocation}),this.F.info("Installing extension:",oe.identifier.id),B.push({task:oe,manifest:n});let se=!1;try{if(p.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",oe.identifier.id);else try{const ce=await this.N(oe.identifier,n,!!p.installOnlyNewlyAddedFromExtensionPack,!!p.installPreReleaseVersion,p.profileLocation),re=await this.getInstalled(void 0,p.profileLocation),q={...p,donotIncludePackAndDependencies:!0,context:{...p.context,[g.$6n]:!0}};for(const{gallery:X,manifest:T}of(0,L.$Lb)(ce,({gallery:M})=>M.identifier.id)){se=se||!!T.extensionDependencies?.some(G=>(0,f.$Co)({id:G},oe.identifier));const M=N(X),H=this.j.get(M);if(H){if(k(oe,H.task)){const G=H.task.identifier;this.F.info("Waiting for already requested installing extension",G.id,oe.identifier.id),H.waitingTasks.push(oe),_.push(j.Event.toPromise(j.Event.filter(this.onDidInstallExtensions,Q=>Q.some(Y=>(0,f.$Co)(Y.identifier,G)))).then(Q=>{if(this.F.info("Finished waiting for already requested installing extension",G.id,oe.identifier.id),!Q.find(F=>(0,f.$Co)(F.identifier,G))?.local)throw new Error(`Extension ${G.id} is not installed`)}))}}else if(!re.some(({identifier:G})=>(0,f.$Co)(G,X.identifier))){const G=this.Z(T,X,q);this.j.set(M,{task:G,waitingTasks:[oe]}),this.n.fire({identifier:G.identifier,source:X,profileLocation:p.profileLocation}),this.F.info("Installing extension:",G.identifier.id,oe.identifier.id),B.push({task:G,manifest:T})}}}catch(ce){if(S.URI.isUri(oe.source))(0,L.$Kb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",oe.identifier.id,ce.message),(0,L.$Kb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",oe.identifier.id,ce.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",oe.identifier.id),ce}const ue=B.reduce((ce,{task:re,manifest:q})=>(ce.set(re.identifier.id.toLowerCase(),{task:re,manifest:q}),ce),new Map);for(;ue.size;){let ce;const re=[...ue.values()].filter(({manifest:q})=>!q.extensionDependencies?.some(X=>ue.has(X.toLowerCase())));re.length?ce=ue.size===1?re:re.filter(({task:q})=>!(q===oe&&!se)):(this.F.info("Found extensions with circular dependencies",re.map(({task:q})=>q.identifier.id)),ce=[...ue.values()]),await this.M(ce.map(async({task:q})=>{const X=new Date().getTime();try{const T=await q.run();if(await this.M(this.y.map(M=>M.postInstall(T,q.source,p,R.CancellationToken.None))),!S.URI.isUri(q.source)){const M=q.operation===3,H=M?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(r(this.C,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Ko)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-X,durationSinceUpdate:H}),u.$p&&q.operation!==3)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}}ee.push({local:T,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.profileLocation,applicationScoped:T.isApplicationScoped})}catch(T){throw S.URI.isUri(q.source)||r(this.C,q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Ko)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-X,error:T}),this.F.error("Error while installing the extension:",q.identifier.id),T}finally{ue.delete(q.identifier.id.toLowerCase())}}))}return _.length&&await this.M(_),ee.forEach(({identifier:ce})=>this.F.info("Extension installed successfully:",ce.id)),ee}catch(ue){if(B.forEach(({task:ce})=>ce.cancel()),ee.length)try{const ce=await Promise.allSettled(ee.map(({local:re})=>this.$(re,{versionOnly:!0,profileLocation:p.profileLocation}).run()));for(let re=0;re<ce.length;re++){const q=ce[re],{identifier:X}=ee[re];q.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",X.id):this.F.warn("Rollback: Error while uninstalling extension",X.id,(0,A.$9)(q.reason))}}catch(ce){this.F.warn("Error while rolling back extensions",(0,A.$9)(ce),ee.map(({identifier:re})=>re.id))}return B.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:p.context,profileLocation:p.profileLocation,error:ue}))}finally{for(const{task:ue}of B)ue.source&&!S.URI.isUri(ue.source)&&this.j.delete(N(ue.source))}}L(n,o){for(const[,{task:l,waitingTasks:k}]of this.j.entries())if(l===n&&(k.includes(o)||k.some(E=>this.L(E,o)))||l===o&&k[0]&&!this.L(n,k[0]))return!1;return!0}async M(n){const o=[],l=[],k=await Promise.allSettled(n);for(const E of k)E.status==="fulfilled"?o.push(E.value):l.push(E.reason);if(l.length)throw w(l);return o}async N(n,o,l,k,E){if(!this.z.isEnabled())return[];const p=await this.getInstalled(void 0,E),N=[],B=[],_=async(ee,oe)=>{N.push(ee);const se=oe.extensionDependencies||[],ue=[...se];if(oe.extensionPack){const ce=l?p.find(re=>(0,f.$Co)(re.identifier,ee)):void 0;for(const re of oe.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(q=>(0,f.$Co)({id:q},{id:re}))||ue.every(q=>!(0,f.$Co)({id:q},{id:re}))&&ue.push(re)}if(ue.length){const ce=ue.filter(re=>N.every(q=>!(0,f.$Co)(q,{id:re})));if(ce.length){const re=await this.z.getExtensions(ce.map(q=>({id:q,preRelease:k})),R.CancellationToken.None);for(const q of re){if(N.find(M=>(0,f.$Co)(M,q.identifier)))continue;const X=se.some(M=>(0,f.$Co)({id:M},q.identifier));let T;try{T=await this.O(q,!1,k)}catch(M){if(X)throw M;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,A.$9)(M));continue}B.push({gallery:T.extension,manifest:T.manifest}),await _(T.extension.identifier,T.manifest)}}}};return await _(n,o),B}async O(n,o,l){let k;const E=await this.getExtensionsControlManifest();if(E.malicious.some(B=>(0,f.$Co)(n.identifier,B)))throw new g.$bo(I.localize(1,null,n.identifier.id),g.ExtensionManagementErrorCode.Malicious);const p=E.deprecated[n.identifier.id.toLowerCase()];if(p?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${p.extension.id}' extension instead.`),k=(await this.z.getExtensions([{id:p.extension.id,preRelease:p.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!k)throw new g.$bo(I.localize(2,null,n.identifier.id,p.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const B=await this.getTargetPlatform();throw new g.$bo(I.localize(3,null,n.identifier.id,this.G.nameLong,(0,g.$7n)(B)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(k=await this.P(n,o,l),!k)throw!l&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],R.CancellationToken.None))[0]?new g.$bo(I.localize(4,null,n.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$bo(I.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",k.identifier.id);const N=await this.z.getManifest(k,R.CancellationToken.None);if(N===null)throw new g.$bo(`Missing manifest for extension ${k.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(N.version!==k.version)throw new g.$bo(`Cannot install '${k.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:k,manifest:N}}async P(n,o,l){const k=await this.getTargetPlatform();let E=null;return!o&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(E=(await this.z.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null),!E&&await this.z.isExtensionCompatible(n,l,k)&&(E=n),E||(o?E=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null:E=await this.z.getCompatibleExtension(n,l,k)),E}async Q(n,o){const l={...o,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.Y()},k=ee=>`${ee.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,E=this.m.get(k(n.identifier));if(E)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),E.waitUntilTaskIsFinished();const p=ee=>{const oe=this.$(ee,l);return this.m.set(k(oe.extension.identifier),oe),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${ee.identifier.id}@${ee.manifest.version}`),this.t.fire({identifier:ee.identifier,profileLocation:l.profileLocation,applicationScoped:ee.isApplicationScoped}),oe},N=(ee,oe)=>{oe?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString(),oe.message):this.F.error("Failed to uninstall extension:",`${ee.identifier.id}@${ee.manifest.version}`,oe.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${ee.identifier.id}@${ee.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$Jo)(ee),error:oe}),this.u.fire({identifier:ee.identifier,error:oe?.code,profileLocation:l.profileLocation,applicationScoped:ee.isApplicationScoped})},B=[],_=[];try{B.push(p(n));const ee=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const oe=this.U(n,ee);for(const se of oe)this.m.has(k(se.identifier))?this.F.info("Extensions is already requested to uninstall",se.identifier.id):B.push(p(se))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(B.map(oe=>oe.extension),ee,n),await this.M(B.map(async oe=>{try{if(await oe.run(),await this.M(this.y.map(se=>se.postUninstall(oe.extension,l,R.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.z.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}N(oe.extension)}catch(se){const ue=se instanceof g.$bo?se:new g.$bo((0,A.$9)(se),g.ExtensionManagementErrorCode.Internal);throw N(oe.extension,ue),ue}finally{_.push(oe)}}))}catch(ee){const oe=ee instanceof g.$bo?ee:new g.$bo((0,A.$9)(ee),g.ExtensionManagementErrorCode.Internal);for(const se of B){try{se.cancel()}catch{}_.includes(se)||N(se.extension,oe)}throw oe}finally{for(const ee of B)this.m.delete(k(ee.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",ee.extension.identifier.id)}}R(n,o,l){for(const k of n){const E=this.W(k,o);if(E.length){const p=E.filter(N=>!n.some(B=>(0,f.$Co)(B.identifier,N.identifier)));if(p.length)throw new Error(this.S(k,p,l))}}}S(n,o,l){return l===n?o.length===1?I.localize(6,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?I.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):I.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?I.localize(9,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?I.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):I.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}U(n,o,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const k=n.manifest.extensionPack?n.manifest.extensionPack:[];if(k.length){const E=o.filter(N=>!N.isBuiltin&&k.some(B=>(0,f.$Co)({id:B},N.identifier))),p=[];for(const N of E)p.push(...this.U(N,o,l));return[...E,...p]}return[]}W(n,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(k=>(0,f.$Co)({id:k},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$sp=d,e.$sp=d=pe([ie(0,g.$ao),ie(1,h.$cl),ie(2,b.$Ik),ie(3,y.$0i),ie(4,$.$pj),ie(5,O.$Kk)],d);function w(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$tp=w;function s(i){if(i instanceof g.$bo)return i;const n=new g.$bo(i.message,g.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$up=s;function r(i,n,{extensionData:o,verificationStatus:l,duration:k,error:E,durationSinceUpdate:p}){let N,B;(0,c.$Gf)(l)&&(l===!0?l="Verified":(l===!1||(N=g.ExtensionManagementErrorCode.Signature,B=l),l="Unverified")),E&&(E instanceof g.$bo?(N=E.code,E.code===g.ExtensionManagementErrorCode.Signature&&(B=E.message)):N=g.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...o,verificationStatus:l,success:!E,duration:k,errorcode:N,errorcodeDetail:B,durationSinceUpdate:p})}class t{constructor(){this.d=new D.$Sg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$Hg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$Hg)(n=>new Promise((o,l)=>{const k=n.onCancellationRequested(()=>{k.dispose(),l(new A.$4)})})),this.d.open()),this.g.cancel()}}e.$vp=t}),define(te[40],ne([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f,P,y,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.ExtensionsProfileScanningErrorCode=void 0;var b;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(b||(e.ExtensionsProfileScanningErrorCode=b={}));class O extends Error{constructor(t,i){super(t),this.code=i}}e.$wp=O,e.$xp=(0,I.$Ph)("IExtensionsProfileScannerService");let d=class extends R.$Rc{constructor(t,i,n,o,l,k){super(),this.j=t,this.m=i,this.n=n,this.r=o,this.s=l,this.t=k,this.b=this.B(new A.$Nd),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Nd),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Nd),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Nd),this.onDidRemoveExtensions=this.g.event,this.h=new j.$zc}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],o=[];try{return await this.u(i,l=>{const k=[];for(const E of l)t.some(([p])=>(0,c.$Co)(p.identifier,E.identifier)&&p.manifest.version!==E.version)?n.push(E):k.push(E);for(const[E,p]of t){const N=k.findIndex(_=>(0,c.$Co)(_.identifier,E.identifier)&&_.version===E.manifest.version),B={identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:p};N===-1?(o.push(B),k.push(B)):k.splice(N,1,B)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),k}),o.length&&this.c.fire({extensions:o,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),o}catch(l){throw o.length&&this.c.fire({extensions:o,error:l,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:l,profileLocation:i}),l}}async updateMetadata(t,i){const n=[];return await this.u(i,o=>{const l=[];for(const k of o){const E=t.find(([p])=>(0,c.$Co)(p.identifier,k.identifier)&&p.manifest.version===k.version);E&&(k.metadata={...k.metadata,...E[1]},n.push(k)),l.push(k)}return l}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.u(i,o=>{const l=[];for(const k of o)(0,c.$Co)(k.identifier,t.identifier)?n.push(k):l.push(k);return n.length&&this.f.fire({extensions:n,profileLocation:i}),l}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:i}),o}}async u(t,i,n){return this.F(t).queue(async()=>{let o=[],l;try{const k=await this.m.readFile(t);l=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,S.$pk)(k)!==1)throw k;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new O((0,$.$9)(k),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let k=!1;for(const E of l){w(E)||this.w(t);let p;if((0,y.$yf)(E.relativeLocation)&&E.relativeLocation)p=this.z(E.relativeLocation);else if((0,y.$yf)(E.location))p=this.z(E.location),k=!0,E.relativeLocation=E.location,E.location=p.toJSON();else{p=v.URI.revive(E.location);const N=this.y(p);N&&(k=!0,E.relativeLocation=N)}o.push({identifier:E.identifier,location:p,version:E.version,metadata:E.metadata})}k&&await this.m.writeFile(t,D.$be.fromString(JSON.stringify(l)))}if(i){o=i(o);const k=o.map(E=>({identifier:E.identifier,version:E.version,location:E.location.toJSON(),relativeLocation:this.y(E.location),metadata:E.metadata}));await this.m.writeFile(t,D.$be.fromString(JSON.stringify(k)))}return o})}w(t){const i=new O(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(t)).value.toString()}catch(l){if((0,S.$pk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(k=>w(k))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$be.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,S.$pk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,S.$pk)(l)!==1&&this.t.error(l)}try{await this.m.del(i)}catch(l){(0,S.$pk)(l)!==1&&this.t.error(l)}return o})()),this.C}F(t){let i=this.h.get(t);return i||(i=new L.$1g,this.h.set(t,i)),i}};e.$yp=d,e.$yp=d=pe([ie(1,S.$$j),ie(2,f.$Kk),ie(3,P.$Ik),ie(4,h.$cl),ie(5,g.$0i)],d);function w(r){return(0,y.$Af)(r)&&(0,u.$_n)(r.identifier)&&(s(r.location)||(0,y.$yf)(r.location)&&r.location)&&((0,y.$Ff)(r.relativeLocation)||(0,y.$yf)(r.relativeLocation))&&r.version&&(0,y.$yf)(r.version)}function s(r){return r?(0,y.$yf)(r.path)&&(0,y.$yf)(r.scheme):!1}}),define(te[50],ne([0,1,19,8,30,14,9,53,79,2,15,16,13,17,42,54,3,11,95,18,27,37,48,12,10,6,32,4,46,40,23,22,112]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f,P,y,$,h,b,O,d,w,s,r,t,i,n,o,l,k,E,p,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.Translations=void 0;var B;(function(re){function q(X,T){if(X===T)return!0;const M=Object.keys(X),H=new Set;for(const G of Object.keys(T))H.add(G);if(M.length!==H.size)return!1;for(const G of M){if(X[G]!==T[G])return!1;H.delete(G)}return H.size===0}re.equals=q})(B||(e.Translations=B={})),e.$Bp=(0,t.$Ph)("IExtensionsScannerService");let _=class extends c.$Rc{constructor(q,X,T,M,H,G,Q,Y,F,C,a,m){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=X,this.r=T,this.s=M,this.t=H,this.u=G,this.w=Q,this.y=Y,this.z=F,this.C=C,this.D=a,this.F=m,this.g=this.B(new o.$Nd),this.onDidChangeCache=this.g.event,this.h=(0,f.$vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(se,this.s,this.h)),this.m=this.B(this.F.createInstance(se,this.s,this.h)),this.n=this.B(this.F.createInstance(oe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,d.$No)(this.w,this.y)),this.G}async scanAllExtensions(q,X,T){const[M,H]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(X)]),G=T?await this.scanExtensionsUnderDevelopment(q,[...M,...H]):[];return this.L(M,H,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const X=[];X.push(this.M(!!q.useCache,q.language)),X.push(this.N(q.language,!!q.checkControlFile));const[T,M]=await Promise.all(X);return this.J([...T,...M],0,q,!1)}async scanUserExtensions(q){const X=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(X,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),H=q.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let G;try{G=await H.scanExtensions(M)}catch(Q){if(Q instanceof k.$wp&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await H.scanExtensions(M);else throw Q}return G=await this.J(G,1,q,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(q,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===S.Schemas.file).map(async M=>{const H=await this.P(M,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(H)).map(Q=>(Q.type=X.find(Y=>(0,d.$Co)(Y.identifier,Q.identifier))?.type??Q.type,this.n.validate(Q,H)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,X,T){const M=await this.P(q,!1,X,!0,T.language,!0,void 0),H=await this.n.scanExtension(M);return!H||!T.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(q,X,T){const M=await this.P(q,!1,X,!0,T.language,!0,void 0),H=await this.n.scanOneOrMultipleExtensions(M);return this.J(H,X,T,!0)}async scanMetadata(q){const X=(0,f.$vg)(q,"package.json"),T=(await this.w.readFile(X)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,X){const T=(0,f.$vg)(q,"package.json"),M=(await this.w.readFile(T)).value.toString(),H=JSON.parse(M);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,H.__metadata={...H.__metadata,...X},await this.w.writeFile((0,f.$vg)(q,"package.json"),A.$be.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof k.$wp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$be.fromString(JSON.stringify([])))}catch(X){(0,r.$pk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$9)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,X,T,M){return T.includeAllVersions||(q=this.L(X===0?q:void 0,X===1?q:void 0,X==="development"?q:void 0,await this.getTargetPlatform(),M)),T.includeInvalid||(q=q.filter(H=>H.isValid)),q.sort((H,G)=>{const Q=I.$mc(H.location.fsPath),Y=I.$mc(G.location.fsPath);return Q<Y?-1:Q>Y?1:0})}L(q,X,T,M,H){const G=(Y,F,C)=>{if(Y.isValid&&!F.isValid)return!1;if(Y.isValid===F.isValid){if(H&&P.gt(Y.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${Y.location.path} with version ${Y.manifest.version}`),!1;if(P.eq(Y.manifest.version,F.manifest.version)){if(Y.type===0)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${Y.location.path} with same version`),!1;if(Y.targetPlatform===M)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return C?this.y.warn(`Overwriting user extension ${Y.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${Y.location.path} with ${F.location.path}.`),!0},Q=new w.$8l;return q?.forEach(Y=>{const F=Q.get(Y.identifier.id);(!F||G(F,Y,!1))&&Q.set(Y.identifier.id,Y)}),X?.forEach(Y=>{const F=Q.get(Y.identifier.id);if(!F&&q&&Y.type===0){this.y.debug(`Skipping obsolete system extension ${Y.location.path}.`);return}(!F||G(F,Y,!1))&&Q.set(Y.identifier.id,Y)}),T?.forEach(Y=>{const F=Q.get(Y.identifier.id);(!F||G(F,Y,!0))&&Q.set(Y.identifier.id,Y),Q.set(Y.identifier.id,Y)}),[...Q.values()]}async M(q,X){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),H=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",H.length),H}async N(q,X){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const M=X?await this.O():{},H=[],G=h.URI.file(I.$gc(I.$ic(S.$cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Y of T){const F=M[Y.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":H.push((0,f.$vg)(G,Y.name));break;default:H.push(h.URI.file(F));break}}const Q=await Promise.all(H.map(async Y=>this.n.scanExtension(await this.P(Y,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Q.length),(0,L.$Gb)(Q)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,X,T,M,H,G,Q){const Y=await this.f(H??g.$w),F=await this.Q(q),C=X&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,a=C?await this.Q(C):void 0;return new ee(q,F,C,a,X,Q,T,M,G,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,H,Y)}async Q(q){try{const X=await this.w.stat(q);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$Cp=_,e.$Cp=_=pe([ie(4,E.$Kk),ie(5,k.$xp),ie(6,r.$$j),ie(7,i.$0i),ie(8,O.$Wh),ie(9,n.$pj),ie(10,p.$Ik),ie(11,t.$Oh)],_);class ee{constructor(q,X,T,M,H,G,Q,Y,F,C,a,m,z,U,Z){this.location=q,this.mtime=X,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=M,this.profile=H,this.profileScanOptions=G,this.type=Q,this.excludeObsolete=Y,this.validate=F,this.productVersion=C,this.productDate=a,this.productCommit=m,this.devMode=z,this.language=U,this.translations=Z}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,X){return(0,f.$og)(q.location,X.location)&&q.mtime===X.mtime&&(0,f.$og)(q.applicationExtensionslocation,X.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&q.profile===X.profile&&R.$$m(q.profileScanOptions,X.profileScanOptions)&&q.type===X.type&&q.excludeObsolete===X.excludeObsolete&&q.validate===X.validate&&q.productVersion===X.productVersion&&q.productDate===X.productDate&&q.productCommit===X.productCommit&&q.devMode===X.devMode&&q.language===X.language&&B.equals(q.translations,X.translations)}}e.$Dp=ee;let oe=class extends c.$Rc{constructor(q,X,T,M,H){super(),this.f=q,this.g=X,this.h=T,this.j=M,this.m=H}async scanExtensions(q){const X=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const M=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(M)}catch{}return(0,$.$Lf)(T)?X:X.filter(M=>!T[d.$Do.create(M).toString()])}async n(q){const X=await this.j.resolve(q.location);if(!X.children?.length)return[];const T=await Promise.all(X.children.map(async M=>{if(!M.isDirectory||q.type===1&&(0,f.$sg)(M.resource).indexOf(".")===0)return null;const H=new ee(M.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(H)}));return(0,L.$Gb)(T).sort((M,H)=>M.location.path<H.location.path?-1:1)}async r(q){let X=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){X=X.filter(M=>!M.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,q);X.push(...T)}return X}async s(q,X,T){const M=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!M.length)return[];const H=await Promise.all(M.map(async G=>{if(X(G)){const Q=new ee(G.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Q,G.metadata)}return null}));return(0,L.$Gb)(H)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,f.$vg)(q.location,"package.json"))){const X=await this.scanExtension(q);return X?[X]:[]}else return await this.scanExtensions(q)}catch(X){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,j.$9)(X)),[]}}async scanExtension(q,X){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=w.$2l),X=X??T.__metadata,delete T.__metadata;const M=(0,d.$Ho)(T.publisher,T.name),H=X?.id?{id:M,uuid:X.id}:{id:M},G=X?.isSystem?0:q.type,Q=G===0||!!X?.isBuiltin;T=await this.t(q.location,T,ee.createNlsConfiguration(q));const Y={type:G,identifier:H,manifest:T,location:q.location,isBuiltin:Q,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return q.validate?this.validate(Y,q):Y}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,X){let T=!0;const M=(0,s.$So)(X.productVersion,X.productDate,X.location,q.manifest,q.isBuiltin);for(const[H,G]of M)H===y.default.Error&&(T=!1,this.m.error(this.z(X.location,G)));return q.isValid=T,q.validations=M,q}async scanExtensionManifest(q){const X=(0,f.$vg)(q,"package.json");let T;try{T=(await this.j.readFile(X)).value.toString()}catch(H){return(0,r.$pk)(H)!==1&&this.m.error(this.z(q,(0,b.localize)(0,null,X.path,H.message))),null}let M;try{M=JSON.parse(T)}catch{const G=[];(0,v.$Wm)(T,G);for(const Q of G)this.m.error(this.z(q,(0,b.localize)(1,null,X.path,Q.offset,Q.length,(0,u.$zp)(Q.error))));return null}return(0,v.$6m)(M)!=="object"?(this.m.error(this.z(q,(0,b.localize)(2,null,X.path))),null):M}async t(q,X,T){const M=await this.u(q,X,T);if(M)try{const H=[],G=await this.w(M.default,H);if(H.length>0)return H.forEach(Y=>{this.m.error(this.z(q,(0,b.localize)(3,null,M.default?.path,(0,u.$zp)(Y.error))))}),X;if((0,v.$6m)(M)!=="object")return this.m.error(this.z(q,(0,b.localize)(4,null,M.default?.path))),X;const Q=M.values||Object.create(null);return(0,N.$Ap)(this.m,X,Q,G)}catch{}return X}async u(q,X,T){const M=(0,f.$vg)(q,"package.nls.json"),H=(F,C)=>{C.forEach(a=>{this.m.error(this.z(q,(0,b.localize)(5,null,F?.path,(0,u.$zp)(a.error))))})},G=F=>{this.m.error(this.z(q,(0,b.localize)(6,null,F?.path)))},Q=`${X.publisher}.${X.name}`,Y=T.translations[Q];if(Y)try{const F=h.URI.file(Y),C=(await this.j.readFile(F)).value.toString(),a=[],m=(0,v.$Wm)(C,a);return a.length>0?(H(F,a),{values:void 0,default:M}):(0,v.$6m)(m)!=="object"?(G(F),{values:void 0,default:M}):{values:m.contents?m.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.j.exists(M))return;let C;try{C=await this.y(q,T)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const a=(await this.j.readFile(C.localized)).value.toString(),m=[],z=(0,v.$Wm)(a,m);return m.length>0?(H(C.localized,m),{values:void 0,default:C.original}):(0,v.$6m)(z)!=="object"?(G(C.localized),{values:void 0,default:C.original}):{values:z,default:C.original}}catch{return{values:void 0,default:C.original}}}}async w(q,X){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,v.$Wm)(T,X)}catch{}}y(q,X){return new Promise((T,M)=>{const H=G=>{const Q=(0,f.$vg)(q,`package.nls.${G}.json`);this.j.exists(Q).then(Y=>{Y&&T({localized:Q,original:(0,f.$vg)(q,"package.nls.json")});const F=G.lastIndexOf("-");F===-1?T({localized:(0,f.$vg)(q,"package.nls.json"),original:null}):(G=G.substring(0,F),H(G))})};if(X.devMode||X.pseudo||!X.language)return T({localized:(0,f.$vg)(q,"package.nls.json"),original:null});H(X.language)})}z(q,X){return`[${q.path}]: ${X}`}};oe=pe([ie(1,k.$xp),ie(2,p.$Ik),ie(3,r.$$j),ie(4,i.$0i)],oe);let se=class extends oe{constructor(q,X,T,M,H,G,Q){super(X,M,H,G,Q),this.G=q,this.H=T,this.D=this.B(new D.$Rg(3e3)),this.F=this.B(new o.$Nd),this.onDidChangeCache=this.F.event}async scanExtensions(q){const X=this.M(q),T=await this.I(X);if(this.C=q,T&&T.input&&ee.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(H=>(H.location=h.URI.revive(H.location),H));const M=await super.scanExtensions(q);return await this.J(X,{input:q,result:M}),M}async I(q){try{const X=await this.j.readFile(q),T=JSON.parse(X.value.toString());return{result:T.result,input:(0,l.$mh)(T.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",q.path,(0,j.$9)(X))}return null}async J(q,X){try{await this.j.writeFile(q,A.$be.fromString(JSON.stringify(X)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,j.$9)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),X=await this.I(q);if(!X)return;const T=X.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$$m(M,T))try{this.m.info("Invalidating Cache",T,M),await this.j.del(q),this.F.fire()}catch(H){this.m.error(H)}}M(q){const X=this.N(q);return this.h.extUri.joinPath(X.cacheHome,q.type===0?w.$1l:w.$Zl)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(q.location,X.extensionsResource))??this.G:this.H.defaultProfile}};se=pe([ie(2,E.$Kk),ie(3,k.$xp),ie(4,p.$Ik),ie(5,r.$$j),ie(6,i.$0i)],se);function ue(re,q){const X=(0,d.$Fo)(re.manifest.publisher,re.manifest.name);return{id:X,identifier:new w.$6l(X),isBuiltin:re.type===0,isUserBuiltin:re.type===1&&re.isBuiltin,isUnderDevelopment:q,extensionLocation:re.location,uuid:re.identifier.uuid,targetPlatform:re.targetPlatform,...re.manifest}}e.$Ep=ue;class ce extends _{constructor(q,X,T,M,H,G,Q,Y,F,C,a,m){super(q,X,(0,f.$vg)(T,".vscode-oss-dev","extensions","control.json"),M,H,G,Q,Y,F,C,a,m),this.R=(async()=>{if(g.$z)try{const z=await this.w.readFile(h.URI.file(g.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$Fp=ce}),define(te[154],ne([0,1,58,8,34,4,2,15,16,24,6,23]),function(J,e,L,D,R,A,j,v,u,c,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;let g=class extends j.$Rc{constructor(P,y){super(),this.b=P,this.f=y,this.a=new D.$Zg(5)}async postUninstall(P){const y=this.g(P,"uninstall");y&&(this.f.info(P.identifier.id,P.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,P),this.f.info("Finished running post uninstall script",P.identifier.id,P.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",P.identifier.id,P.manifest.version),this.f.error($)}}));try{await c.Promises.rm(this.m(P))}catch($){this.f.error("Error while removing extension storage path",P.identifier.id),this.f.error($)}}g(P,y){const $=`vscode:${y}`;if(P.location.scheme===v.Schemas.file&&P.manifest&&P.manifest.scripts&&typeof P.manifest.scripts[$]=="string"){const h=P.manifest.scripts[$].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(P.identifier.id,P.manifest.version,`${$} should be a node script`),null):{script:(0,u.$ic)(P.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(P,y,$,h,b){return new Promise((O,d)=>{const w=this.j(P,y,$,b);let s;const r=t=>{s&&(clearTimeout(s),s=null),t?d(t):O(void 0)};w.on("error",t=>{r((0,R.$Ai)(t)||"Unknown")}),w.on("exit",(t,i)=>{r(t?`post-${y} process exited with code ${t}`:void 0)}),h&&(s=setTimeout(()=>{s=null,w.kill(),d("timed out")},5e3))})}j(P,y,$,h){const b={silent:!0,execArgv:void 0},O=(0,L.fork)(P,[`--type=extension-post-${y}`,...$],b);O.stdout.setEncoding("utf8"),O.stderr.setEncoding("utf8");const d=A.Event.fromNodeEventEmitter(O.stdout,"data"),w=A.Event.fromNodeEventEmitter(O.stderr,"data");d(t=>this.f.info(h.identifier.id,h.manifest.version,`post-${y}`,t)),w(t=>this.f.error(h.identifier.id,h.manifest.version,`post-${y}`,t));const s=A.Event.any(A.Event.map(d,t=>({data:`%c${t}`,format:[""]})),A.Event.map(w,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(h.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),O}m(P){return(0,u.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,P.identifier.id.toLowerCase())}};e.$Hp=g,e.$Hp=g=pe([ie(0,I.$Kk),ie(1,S.$0i)],g)}),define(te[155],ne([0,1,6,23,22,26,40,12,18,11]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=void 0;let S=class extends j.$yp{constructor(g,f,P,y,$,h){super(c.URI.file(g.extensionsPath),f,P,y,$,h)}};e.$MN=S,e.$MN=S=pe([ie(0,u.$Xh),ie(1,v.$$j),ie(2,D.$Kk),ie(3,R.$Ik),ie(4,A.$cl),ie(5,L.$0i)],S)}),define(te[156],ne([0,1,11,18,40,50,12,10,6,32,22,23]),function(J,e,L,D,R,A,j,v,u,c,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q8b=void 0;let g=class extends A.$Fp{constructor(P,y,$,h,b,O,d,w){super(L.URI.file(b.builtinExtensionsPath),L.URI.file(b.extensionsPath),b.userHome,P.defaultProfile,P,y,$,h,b,O,d,w)}};e.$q8b=g,e.$q8b=g=pe([ie(0,I.$Kk),ie(1,R.$xp),ie(2,j.$$j),ie(3,u.$0i),ie(4,D.$Xh),ie(5,c.$pj),ie(6,S.$Ik),ie(7,v.$Oh)],g)}),define(te[157],ne([0,1,8,4,2,123,3,86,10,23]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$9o=e.$8o=e.$7o=void 0,e.$7o="__$__isNewStorageMarker",e.$8o="__$__targetStorageMarker",e.$9o=(0,u.$Ph)("storageService");var S;(function(b){b[b.NONE=0]="NONE",b[b.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var I;(function(b){b[b.APPLICATION=-1]="APPLICATION",b[b.PROFILE=0]="PROFILE",b[b.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var g;(function(b){b[b.USER=0]="USER",b[b.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function f(b){const O=b.get(e.$8o);if(O)try{return JSON.parse(O)}catch{}return Object.create(null)}e.$0o=f;class P extends R.$Rc{static{this.a=60*1e3}constructor(O={flushInterval:P.a}){super(),this.m=O,this.b=this.B(new D.$Qd),this.c=this.B(new D.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new L.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(O,d,w){return D.Event.filter(this.b.event,s=>s.scope===O&&(d===void 0||s.key===d),w)}n(){this.j.value=(0,L.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(O,d){const{key:w,external:s}=d;if(w===e.$8o){switch(O){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:O})}else this.b.fire({scope:O,key:w,target:this.J(O)[w],external:s})}w(O){this.f.fire({reason:O})}get(O,d,w){return this.P(d)?.get(O,w)}getBoolean(O,d,w){return this.P(d)?.getBoolean(O,w)}getNumber(O,d,w){return this.P(d)?.getNumber(O,w)}getObject(O,d,w){return this.P(d)?.getObject(O,w)}storeAll(O,d){this.y(()=>{for(const w of O)this.store(w.key,w.value,w.scope,w.target,d)})}store(O,d,w,s,r=!1){if((0,j.$Hf)(d)){this.remove(O,w,r);return}this.y(()=>{this.z(O,w,s),this.P(w)?.set(O,d,r)})}remove(O,d,w=!1){this.y(()=>{this.z(O,d,void 0),this.P(d)?.delete(O,w)})}y(O){this.b.pause(),this.c.pause();try{O()}finally{this.b.resume(),this.c.resume()}}keys(O,d){const w=[],s=this.J(O);for(const r of Object.keys(s))s[r]===d&&w.push(r);return w}z(O,d,w,s=!1){const r=this.J(d);typeof w=="number"?r[O]!==w&&(r[O]=w,this.P(d)?.set(e.$8o,JSON.stringify(r),s)):typeof r[O]=="number"&&(delete r[O],this.P(d)?.set(e.$8o,JSON.stringify(r),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(O){switch(O){case-1:return this.I;case 0:return this.G;default:return this.D}}L(O){const d=this.P(O);return d?f(d):Object.create(null)}isNew(O){return this.getBoolean(e.$7o,O)===!0}async flush(O=S.NONE){this.f.fire({reason:O});const d=this.P(-1),w=this.P(0),s=this.P(1);switch(O){case S.NONE:await L.Promises.settled([d?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await L.Promises.settled([d?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const O=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,w=this.P(1)?.items??new Map;return h(O,d,w,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(O){return await this.flush(),this.P(O)?.optimize()}async switch(O,d){return this.w(S.NONE),(0,c.$Jk)(O)?this.R(O,d):this.S(O,d)}M(O,d){return!(O.id===d.id||y(d)&&y(O))}N(O,d,w){this.y(()=>{const s=new Set;for(const[r,t]of O)s.add(r),d.get(r)!==t&&this.u(w,{key:r,external:!0});for(const[r]of d.items)s.has(r)||this.u(w,{key:r,external:!0})})}}e.$$o=P;function y(b){return b.isDefault||!!b.useDefaultFlags?.globalState}e.$_o=y;class $ extends P{constructor(){super(),this.U=this.B(new v.$5o(new v.$6o,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new v.$5o(new v.$6o,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new v.$5o(new v.$6o,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(O=>this.u(1,O))),this.B(this.W.onDidChangeStorage(O=>this.u(0,O))),this.B(this.U.onDidChangeStorage(O=>this.u(-1,O)))}P(O){switch(O){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(O){switch(O){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(O){return!1}}e.$ap=$;async function h(b,O,d,w,s,r){const t=B=>{try{return JSON.parse(B)}catch{return B}},i=new Map,n=new Map;b.forEach((B,_)=>{i.set(_,B),n.set(_,t(B))});const o=new Map,l=new Map;O.forEach((B,_)=>{o.set(_,B),l.set(_,t(B))});const k=new Map,E=new Map;d.forEach((B,_)=>{k.set(_,B),E.set(_,t(B))}),console.group(w!==s?`Storage: Application (path: ${w})`:`Storage: Application & Profile (path: ${w}, default profile)`);const p=[];if(i.forEach((B,_)=>{p.push({key:_,value:B})}),console.table(p),console.groupEnd(),console.log(n),w!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const B=[];o.forEach((_,ee)=>{B.push({key:ee,value:_})}),console.table(B),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const N=[];k.forEach((B,_)=>{N.push({key:_,value:B})}),console.table(N),console.groupEnd(),console.log(E)}e.$bp=h}),define(te[158],ne([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,44,142,157,26,175]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f,P,y,$,h,b,O,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=void 0;const s=A.$p?"web":(0,I.$9n)(A.$u,j.$dc),r="X-Market-Search-Activity-Id";var t;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...a){return String(a.reduce((m,z)=>m|z,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},E={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class p{constructor(m=E){this.d=m}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(m,z=this.d.pageSize){return new p({...this.d,pageNumber:m,pageSize:z})}withFilter(m,...z){const U=[...this.d.criteria,...z.length?z.map(Z=>({filterType:m,value:Z})):[{filterType:m}]];return new p({...this.d,criteria:U})}withSortBy(m){return new p({...this.d,sortBy:m})}withSortOrder(m){return new p({...this.d,sortOrder:m})}withFlags(...m){return new p({...this.d,flags:m.reduce((z,U)=>z|U,0)})}withAssetTypes(...m){return new p({...this.d,assetTypes:m})}withSource(m){return new p({...this.d,source:m})}get raw(){const{criteria:m,pageNumber:z,pageSize:U,sortBy:Z,sortOrder:W,flags:le,assetTypes:ae}=this.d;return{filters:[{criteria:m,pageNumber:z,pageSize:U,sortBy:Z,sortOrder:W}],assetTypes:ae,flags:le}}get searchText(){const m=this.d.criteria.filter(z=>z.filterType===n.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(m=>String(m.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function N(a,m){const z=(a||[]).filter(U=>U.statisticName===m)[0];return z?z.value:0}function B(a){const m="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(U=>U.assetType.indexOf(m)===0).reduce((U,Z)=>{const W=oe(a,Z.assetType);return W&&U.push([Z.assetType.substring(m.length),W]),U},[])}function _(a){if(a.properties){const m=a.properties.filter(Z=>Z.key===o.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=m.filter(Z=>z.test(Z.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return oe(a,o.Repository)}function ee(a){return{uri:`${a.fallbackAssetUri}/${o.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${o.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function oe(a,m){return a.files.filter(U=>U.assetType===m)[0]?{uri:`${a.assetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function se(a,m){const z=a.properties?a.properties.filter(Z=>Z.key===m):[],U=z.length>0&&z[0].value;return U?U.split(",").map(Z=>(0,g.$Go)(Z)):[]}function ue(a){const m=a.properties?a.properties.filter(z=>z.key===l.Engine):[];return m.length>0&&m[0].value||""}function ce(a){const m=a.properties?a.properties.filter(z=>z.key===l.PreRelease):[];return m.length>0&&m[0].value==="true"}function re(a){const m=a.properties?a.properties.filter(U=>U.key===l.LocalizedLanguages):[],z=m.length>0&&m[0].value||"";return z?z.split(","):[]}function q(a){return a.properties?.find(m=>m.key===l.SponsorLink)?.value}function X(a){return a.indexOf("preview")!==-1}function T(a){return a.targetPlatform?(0,I.$8n)(a.targetPlatform):"undefined"}function M(a){const m=(0,L.$Lb)(a.versions.map(T)),z=!!a.tags?.includes(I.$3n),U=m.indexOf("web");return z?U===-1&&m.push("web"):U!==-1&&m.splice(U,1),m}function H(a,m){for(let z=0;z<a.length;z++){const U=a[z];if(U.version===a[z-1]?.version){let Z=z;if(T(U)===m)for(;Z>0&&a[Z-1].version===U.version;)Z--;Z!==z&&(a.splice(z,1),a.splice(Z,0,U))}}return a}e.$ep=H;function G(a,m,z){a.telemetryData={index:m,querySource:z,queryActivityId:a.queryContext?.[r]}}function Q(a,m,z,U){const Z=a.versions[0],W={manifest:oe(m,o.Manifest),readme:oe(m,o.Details),changelog:oe(m,o.Changelog),license:oe(m,o.License),repository:_(m),download:ee(m),icon:oe(m,o.Icon),signature:oe(m,o.Signature),coreTranslations:B(m)};return{identifier:{id:(0,g.$Ho)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:m.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(Z),description:a.shortDescription||"",installCount:N(a.statistics,"install"),rating:N(a.statistics,"averagerating"),ratingCount:N(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:z,assets:W,properties:{dependencies:se(m,l.Dependency),extensionPack:se(m,l.ExtensionPack),engine:ue(m),localizedLanguages:re(m),targetPlatform:T(m),isPreReleaseVersion:ce(m)},hasPreReleaseVersion:ce(Z),hasReleaseVersion:!0,preview:X(a.flags),isSigned:!!W.signature,queryContext:U}}let Y=class{constructor(m,z,U,Z,W,le,ae,me){this.k=z,this.l=U,this.n=Z,this.o=W,this.q=le,this.u=ae,this.w=me;const de=ae.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,b.$dp)(ae.version,ae,this.n,this.w,this.q,m,this.o)}x(m=""){return`${this.d}${m}`}isEnabled(){return!!this.d}async getExtensions(m,z,U){const Z=D.CancellationToken.isCancellationToken(z)?{}:z,W=D.CancellationToken.isCancellationToken(z)?z:U,le=[],ae=[],me=[],de=[];let ge=!0;for(const we of m){we.uuid?ae.push(we.uuid):le.push(we.id);const be=!!(we.version||we.preRelease);me.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!ae.length&&!le.length)return[];let fe=new p().withPage(1,m.length);ae.length&&(fe=fe.withFilter(n.ExtensionId,...ae)),le.length&&(fe=fe.withFilter(n.ExtensionName,...le)),(Z.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,t.IncludeVersions)),Z.source&&(fe=fe.withSource(Z.source));const{extensions:he}=await this.z(fe,{targetPlatform:Z.targetPlatform??s,includePreRelease:me,versions:de,compatible:!!Z.compatible},W);return Z.source&&he.forEach((we,be)=>G(we,be,Z.source)),he}async getCompatibleExtension(m,z,U){if((0,I.$0n)(m.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible(m,z,U))return m;const Z=new p().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,m.identifier.uuid),{extensions:W}=await this.z(Z,{targetPlatform:U,compatible:!0,includePreRelease:z},D.CancellationToken.None);return W[0]||null}async isExtensionCompatible(m,z,U){if(!(0,I.$$n)(m.properties.targetPlatform,m.allTargetPlatforms,U)||!z&&m.properties.isPreReleaseVersion)return!1;let Z=m.properties.engine;if(!Z){const W=await this.getManifest(m,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");Z=W.engines.vscode}return(0,f.$Uo)(Z,this.u.version,this.u.date)}async y(m,z,U,Z,W){if(!(0,I.$$n)(T(m),Z,W)||z!=="any"&&ce(m)!==(z==="prerelease"))return!1;if(U)try{const le=await this.E(m);if(!(0,f.$Uo)(le,this.u.version,this.u.date))return!1}catch(le){return this.l.error(`Error while getting the engine for the version ${m.version}.`,(0,R.$9)(le)),!1}return!0}async query(m,z){let U=m.text||"";const Z=m.pageSize??50;let W=new p().withPage(1,Z);U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Category,he||fe),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Tag,he||fe),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(n.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),W=W.withFilter(n.SearchText,U)),W=W.withSortBy(0)):m.ids?W=W.withFilter(n.ExtensionId,...m.ids):m.names?W=W.withFilter(n.ExtensionName,...m.names):W=W.withSortBy(4),typeof m.sortBy=="number"&&(W=W.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&(W=W.withSortOrder(m.sortOrder)),m.source&&(W=W.withSource(m.source));const le=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!m.includePreRelease},fe);return he.forEach((be,Se)=>G(be,(ge.pageNumber-1)*ge.pageSize+Se,m.source)),{extensions:he,total:we}},{extensions:ae,total:me}=await le(W,z),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new R.$4;const{extensions:he}=await le(W.withPage(ge+1),fe);return he};return{firstPage:ae,total:me,pageSize:W.pageSize,getPage:de}}async z(m,z,U){const Z=m.flags;m.flags&t.IncludeLatestVersionOnly&&m.flags&t.IncludeVersions&&(m=m.withFlags(m.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(m.flags&t.IncludeLatestVersionOnly)&&!(m.flags&t.IncludeVersions)&&(m=m.withFlags(m.flags,t.IncludeLatestVersionOnly)),z.versions?.length&&(m=m.withFlags(m.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),m=m.withFlags(m.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:W,total:le,context:ae}=await this.B(m,U);if(!(m.flags&t.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,z,ae);we&&fe.push(we)}return{extensions:fe,total:le}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,g.$Ho)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,v.$Ef)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Fe=>(0,g.$Co)(Fe,we))?.includePreRelease;if(z.compatible&&(0,I.$0n)(M(he),z.targetPlatform))continue;const Se=await this.A(he,z,ae);!Se||Se.properties.isPreReleaseVersion&&(!be||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==z.targetPlatform&&Se.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,Se])}if(ge.size){const fe=new w.$Jd,he=new p().withFlags(Z&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,z,U);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const Se=ge.get(be.identifier.uuid);de.push([Se,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:le}}async A(m,z,U){const Z={id:(0,g.$Ho)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},W=z.versions?.find(de=>(0,g.$Co)(de,Z))?.version,le=(0,v.$Ef)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(de=>(0,g.$Co)(de,Z))?.includePreRelease,ae=M(m),me=H(m.versions,z.targetPlatform);if(z.compatible&&(0,I.$0n)(ae,z.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(W&&ge.version!==W)){if(await this.y(ge,le?"any":"release",z.compatible,ae,z.targetPlatform))return Q(m,ge,ae,U);if(W&&ge.version===W)return null}}return W||z.compatible?null:Q(m,m.versions[0],ae)}async B(m,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const U=await this.j,Z=JSON.stringify(m.raw),W={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},le=new w.$Jd;let ae,me,de=0;try{if(ae=await this.k.request({type:"POST",url:this.g&&m.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:Z,headers:W},z),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,h.$2o)(ae);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[r]:ae.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.o.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(Z.length),duration:le.elapsed(),success:!!ae&&(0,h.$Xo)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:me?(0,R.$3)(me)?"canceled":(0,R.$9)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(m,z,U,Z){if(!this.isEnabled())return;const W=A.$p?this.x(`/itemName/${m}.${z}/version/${U}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${m}/extensions/${z}/${U}/stats?statType=${Z}`),le=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:le};try{await this.k.request({type:"POST",url:W,headers:me},D.CancellationToken.None)}catch{}}async download(m,z,U){this.l.trace("ExtensionGalleryService#download",m.identifier.id);const Z=(0,g.$Ko)(m),W=new Date().getTime(),le=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Z,duration:fe}),ae=U===2?"install":U===3?"update":"",me=ae?{uri:`${m.assets.download.uri}${u.URI.parse(m.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${m.assets.download.fallbackUri}${u.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:m.assets.download,de=m.queryContext?.[r]?{[r]:m.queryContext[r]}:void 0,ge=await this.D(me,de?{headers:de}:void 0);await this.q.writeFile(z,ge.stream),le(new Date().getTime()-W)}async downloadSignatureArchive(m,z){if(!m.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const U=await this.D(m.assets.signature);await this.q.writeFile(z,U.stream)}async getReadme(m,z){if(m.assets.readme){const U=await this.D(m.assets.readme,{},z);return await(0,h.$1o)(U)||""}return""}async getManifest(m,z){if(m.assets.manifest){const U=await this.D(m.assets.manifest,{},z),Z=await(0,h.$1o)(U);return Z?JSON.parse(Z):null}return null}async C(m,z){const U=oe(m,o.Manifest);if(!U)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},W=await this.D(U,{headers:Z});return await(0,h.$2o)(W)}async getCoreTranslation(m,z){const U=m.assets.coreTranslations.filter(Z=>Z[0]===z.toUpperCase())[0];if(U){const Z=await this.D(U[1]),W=await(0,h.$1o)(Z);return W?JSON.parse(W):null}return null}async getChangelog(m,z){if(m.assets.changelog){const U=await this.D(m.assets.changelog,{},z);return await(0,h.$1o)(U)||""}return""}async getAllCompatibleVersions(m,z,U){let Z=new p().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?Z=Z.withFilter(n.ExtensionId,m.identifier.uuid):Z=Z.withFilter(n.ExtensionName,m.identifier.id);const{galleryExtensions:W}=await this.B(Z,D.CancellationToken.None);if(!W.length)return[];const le=M(W[0]);if((0,I.$0n)(le,U))return[];const ae=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,z?"any":"release",!0,le,U)&&ae.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of H(ae,U))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:ce(ge)}));return me}async D(m,z={},U=D.CancellationToken.None){const Z=await this.j,W={type:"GET"},le={...Z,...z.headers||{}};z={...z,...W,headers:le};const ae=m.uri,me=m.fallbackUri,de={...z,url:ae};try{const ge=await this.k.request(de,U);if(ge.res.statusCode===200)return ge;const fe=await(0,h.$1o)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,R.$3)(ge))throw ge;const fe=(0,R.$9)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:ae,message:fe});const he={...z,url:me};return this.k.request(he,U)}}async E(m){let z=ue(m);if(!z){const U=await this.C(m,D.CancellationToken.None);if(!U)throw new Error("Manifest was not found");z=U.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const m=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,h.$2o)(m),U=[],Z={},W=[];if(z){for(const le of z.malicious)U.push({id:le});if(z.migrateToPreRelease)for(const[le,ae]of Object.entries(z.migrateToPreRelease))(!ae.engine||(0,f.$Uo)(ae.engine,this.u.version,this.u.date))&&(Z[le.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[le,ae]of Object.entries(z.deprecated))ae&&(Z[le.toLowerCase()]=(0,v.$Ef)(ae)?{}:ae);if(z.search)for(const le of z.search)W.push(le)}return{malicious:U,deprecated:Z,search:W}}};Y=pe([ie(1,h.$Vo),ie(2,y.$0i),ie(3,S.$Wh),ie(4,d.$cl),ie(5,P.$$j),ie(6,$.$pj),ie(7,c.$ji)],Y);let F=class extends Y{constructor(m,z,U,Z,W,le,ae,me){super(m,z,U,Z,W,le,ae,me)}};e.$fp=F,e.$fp=F=pe([ie(0,O.$9o),ie(1,h.$Vo),ie(2,y.$0i),ie(3,S.$Wh),ie(4,d.$cl),ie(5,P.$$j),ie(6,$.$pj),ie(7,c.$ji)],F);let C=class extends Y{constructor(m,z,U,Z,W,le,ae){super(void 0,m,z,U,Z,W,le,ae)}};e.$gp=C,e.$gp=C=pe([ie(0,h.$Vo),ie(1,y.$0i),ie(2,S.$Wh),ie(3,d.$cl),ie(4,P.$$j),ie(5,$.$pj),ie(6,c.$ji)],C)}),define(te[159],ne([0,1,11,18,12,6,139,22,23,3,68]),function(J,e,L,D,R,A,j,v,u,c,S){"use strict";var I,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=e.$JN=void 0;let f=class extends u.$Nk{static{I=this}static{this.a="profileAssociationsMigration"}constructor(h,b,O,d,w){super(O,d,b,w),this.U=h,this.W=O}O(){return this.U.getItem(I.b,[]).map(b=>({...b,location:(0,c.$yf)(b.location)?this.w.extUri.joinPath(this.profilesHome,b.location):L.URI.revive(b.location)}))}Q(){const h=this.U.getItem(I.c,{});return this.U.getItem(I.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$JN=f,e.$JN=f=I=pe([ie(0,j.$EN),ie(1,v.$Ik),ie(2,D.$Xh),ie(3,R.$$j),ie(4,A.$0i)],f);let P=g=class extends f{constructor(h,b,O,d,w){super(h,b,O,d,w),this.$=h}P(h){h.length?this.$.setItem(g.b,h.map(b=>({...b,location:this.w.extUri.basename(b.location)}))):this.$.removeItem(g.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(g.c,h):this.$.removeItem(g.c)}Q(){const h="workspaceAndProfileInfo",b=this.$.getItem(h,void 0);if(b){this.$.removeItem(h);const d=b.reduce((w,{workspace:s,profile:r})=>(w[L.URI.revive(s).toString()]=L.URI.revive(r).toString(),w),{});this.$.setItem(g.c,{workspaces:d})}const O=super.Q();return this.$.getItem(g.a,!1)||(this.R(O),this.$.setItem(g.a,!0)),O}};e.$KN=P,e.$KN=P=g=pe([ie(0,j.$FN),ie(1,v.$Ik),ie(2,D.$Xh),ie(3,R.$$j),ie(4,A.$0i)],P);let y=class extends P{constructor(h,b,O,d){super(new S.$IN(0,b,d,O),h,b,O,d)}async init(){return await this.$.init(),super.init()}};e.$LN=y,e.$LN=y=pe([ie(0,v.$Ik),ie(1,D.$Xh),ie(2,R.$$j),ie(3,A.$0i)],y)}),define(te[51],ne([0,1,125,8,16,3,24,87,176,177]),function(J,e,L,D,R,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.zip=e.$op=e.$np=void 0,e.$np="end of central directory record signature not found";const S=new RegExp(e.$np);class I extends Error{constructor(r,t){let i=t.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=r,this.cause=t}}e.$op=I;function g(s){const r=s.externalFileAttributes>>16||33188;return[448,56,7].map(t=>r&t).reduce((t,i)=>t+i,r&61440)}function f(s){if(s instanceof I)return s;let r;return S.test(s.message)&&(r="CorruptZip"),new I(r,s)}function P(s,r,t,i,n,o){const l=R.$lc(r),k=R.$ic(i,l);if(!k.startsWith(i))return Promise.reject(new Error(v.localize(0,null,r)));const E=R.$ic(i,r);let p;return o.onCancellationRequested(()=>{p?.destroy()}),Promise.resolve(j.Promises.mkdir(k,{recursive:!0})).then(()=>new Promise((N,B)=>{if(!o.isCancellationRequested)try{p=(0,L.createWriteStream)(E,{mode:t}),p.once("close",()=>N()),p.once("error",B),s.once("error",B),s.pipe(p)}catch(_){B(_)}}))}function y(s,r,t,i){let n=(0,D.$Hg)(()=>Promise.resolve()),o=0;const l=i.onCancellationRequested(()=>{n.cancel(),s.close()});return new Promise((k,E)=>{const p=new D.$Og,N=B=>{B.isCancellationRequested||(o++,s.readEntry())};s.once("error",E),s.once("close",()=>n.then(()=>{i.isCancellationRequested||s.entryCount===o?k():E(new I("Incomplete",new Error(v.localize(1,null,o,s.entryCount))))},E)),s.readEntry(),s.on("entry",B=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(B.fileName)){N(i);return}const _=B.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(_)){const se=R.$ic(r,_);n=(0,D.$Hg)(ue=>j.Promises.mkdir(se,{recursive:!0}).then(()=>N(ue)).then(void 0,E));return}const ee=h(s,B),oe=g(B);n=(0,D.$Hg)(se=>p.queue(()=>ee.then(ue=>P(ue,_,oe,r,t,se).then(()=>N(se)))).then(null,E))})}).finally(()=>l.dispose())}function $(s,r=!1){return new Promise((t,i)=>{(0,u.open)(s,r?{lazyEntries:!0}:void 0,(n,o)=>{n?i(f(n)):t((0,A.$Jf)(o))})})}function h(s,r){return new Promise((t,i)=>{s.openReadStream(r,(n,o)=>{n?i(f(n)):t((0,A.$Jf)(o))})})}function b(s,r){return new Promise((t,i)=>{const n=new c.ZipFile;r.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const o=(0,L.createWriteStream)(s);n.outputStream.pipe(o),n.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>t(s))})}e.zip=b;function O(s,r,t={},i){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let o=$(s,!0);return t.overwrite&&(o=o.then(l=>j.Promises.rm(r).then(()=>l))),o.then(l=>y(l,r,{sourcePathRegex:n},i))}e.$qp=O;function d(s,r){return $(s).then(t=>new Promise((i,n)=>{t.on("entry",o=>{o.fileName===r&&h(t,o).then(l=>i(l),l=>n(l))}),t.once("close",()=>n(new Error(v.localize(2,null,r))))}))}function w(s,r){return d(s,r).then(t=>new Promise((i,n)=>{const o=[];t.once("error",n),t.on("data",l=>o.push(l)),t.on("end",()=>i(Buffer.concat(o)))}))}e.$rp=w}),define(te[160],ne([0,1,8,9,2,15,17,42,3,28,24,51,25,18,21,27,60,12,6]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f,P,y,$,h,b){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;let d=class extends R.$Rc{static{O=this}static{this.c=".sigzip"}constructor(s,r,t,i,n,o){super(),this.h=r,this.j=t,this.m=i,this.n=n,this.r=o,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,r,t){await this.g;const i=(0,j.$vg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,o=>this.j.download(s,o,r))}catch(o){throw new P.$bo(o.message,P.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.t(s)){const o=await this.u(s);try{n=await this.n.verify(i.fsPath,o.fsPath,this.r.getLevel()===b.LogLevel.Trace)}catch(l){const k=l;if(n=k.code,k.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${k.output}`),n===P.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===P.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new P.$bo(I.$np,P.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(o)}catch(l){this.r.error(l)}}}return n===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${s.identifier.id}`),{location:i,verificationStatus:n}}t(s){if(!s.isSigned)return!1;const r=this.m.getValue("extensions.verifySignature");return(0,u.$Ef)(r)?r:!0}async u(s){await this.g;const r=(0,j.$vg)(this.extensionsDownloadDir,`${this.z(s)}${O.c}`);return await this.w(s,r,t=>this.j.downloadSignatureArchive(s,t)),r}async w(s,r,t){if(await this.h.exists(r))return;if(r.scheme!==A.Schemas.file){await t(r);return}const i=(0,j.$vg)(this.extensionsDownloadDir,`.${(0,c.$eg)()}`);await this.h.exists(i)||await t(i);try{await S.Promises.rename(i.fsPath,r.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,D.$9)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const r=[],t=[],i=[];for(const l of s.children)if(l.name.endsWith(O.c))i.push(l.resource);else{const k=y.$Do.parse(l.name);k&&t.push([k,l])}const n=(0,y.$Io)(t,([l])=>l),o=[];for(const l of n)l.sort((k,E)=>v.rcompare(k[0].version,E[0].version)),r.push(...l.slice(1).map(k=>k[1].resource)),o.push(l[0][1]);o.sort((l,k)=>l.mtime-k.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),r.push(...i),await L.Promises.settled(r.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(s){this.r.error(s)}}z(s){return this.f?y.$Do.create(s).toString().toLowerCase():(0,c.$eg)()}};e.$Gp=d,e.$Gp=d=O=pe([ie(0,f.$Xh),ie(1,h.$$j),ie(2,P.$ao),ie(3,g.$ji),ie(4,$.$hp),ie(5,b.$0i)],d)}),define(te[161],ne([0,1,51,97]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;function R(A){return(0,L.$rp)(A,"extension/package.json").then(j=>{try{return JSON.parse(j.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$Ip=R}),define(te[162],ne([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f,P,y,$,h,b,O,d,w,s,r,t,i,n,o,l,k,E,p,N,B,_,ee,oe,se,ue,ce,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.$Mp=e.$Lp=void 0,e.$Lp=(0,ee.$Qh)(t.$co);const q=".vsctmp";let X=class extends r.$sp{constructor(F,C,a,m,z,U,Z,W,le,ae,me,de){super(F,C,me,a,ae,de),this.fb=z,this.gb=U,this.hb=Z,this.ib=le,this.eb=new Map,this.rb=new S.$Ac;const ge=this.B(W.createInstance(k.$Hp));this.bb=this.B(W.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new p.$Jp(de,le,me,this,this.F)),this.db=this.B(W.createInstance(l.$Gp));const fe=this.B(new N.$Kp(this,this.fb,de,U,me,le,a));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$No)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const C=await this.pb(F),a=await(0,O.zip)((0,f.$vg)(this.db.extensionsDownloadDir,(0,h.$eg)()).fsPath,C);return $.URI.file(a)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:C,cleanup:a}=await this.lb(F),m=g.$jc(C.fsPath);try{return await(0,E.$Ip)(m)}finally{await a()}}getInstalled(F,C=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(F??null,C)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.bb.scanUserExtensionAtLocation(F)}async install(F,C={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:a,cleanup:m}=await this.lb(F);try{const z=await(0,E.$Ip)(g.$jc(a.fsPath)),U=(0,i.$Ho)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,B.$Uo)(z.engines.vscode,this.G.version,this.G.date))throw new Error(d.localize(0,null,U,this.G.version));const W=(await this.I([{manifest:z,extension:a,options:C}])).find(({identifier:le})=>(0,i.$Co)(le,{id:U}));if(W?.local)return W.local;throw W?.error?W.error:(0,r.$up)(new Error(`Unknown error while installing extension ${U}`))}finally{await m()}}async installFromLocation(F,C){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const a=await this.bb.scanUserExtensionAtLocation(F);if(!a)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.ub([[a,void 0]],C),this.F.info("Successfully installed extension",a.identifier.id,C.toString()),a}async installExtensionsFromProfile(F,C,a){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,C.toString(),a.toString());const m=(await this.bb.scanExtensions(1,C)).filter(z=>F.some(U=>(0,i.$Co)(U,z.identifier)));if(m.length){const z=await Promise.all(m.map(U=>this.bb.scanMetadata(U,C)));await this.ub(m.map((U,Z)=>[U,z[Z]]),a),this.F.info("Successfully installed extensions",m.map(U=>U.identifier.id),a.toString())}return m}async updateMetadata(F,C,a=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),C.isPreReleaseVersion&&(C.preRelease=!0),C.isMachineScoped===!1&&(C.isMachineScoped=void 0),C.isBuiltin===!1&&(C.isBuiltin=void 0),C.pinned===!1&&(C.pinned=void 0),F=await this.bb.updateMetadata(F,C,a),this.cb.invalidate(a),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(d.localize(1,null));const C=await this.getTargetPlatform(),[a]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:C,compatible:!0},R.CancellationToken.None);if(!a)throw new Error(d.localize(2,null));await this.bb.setUninstalled(F);try{await this.bb.removeUninstalledExtension(F)}catch(m){throw new Error(d.localize(3,null,(0,A.$Ai)(m)))}return this.installFromGallery(a)}ab(F,C,a,m){return this.bb.copyExtension(F,C,a,m)}copyExtensions(F,C){return this.bb.copyExtensions(F,C)}markAsUninstalled(...F){return this.bb.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(F){this.F.error(F)}}async download(F,C,a){const{location:m}=await this.db.download(F,C,!a);return m}async lb(F){if(F.scheme===I.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const C=(0,f.$vg)(this.db.extensionsDownloadDir,(0,h.$eg)());return await this.hb.download(F,C),this.F.info("Downloaded extension to",C.toString()),{location:C,cleanup:async()=>{try{await this.ib.del(C)}catch(m){this.F.error(m)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(F,C,a){if($.URI.isUri(C))return new G(F,C,a,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const m=i.$Do.create(C).toString();let z=this.eb.get(m);return z||(this.eb.set(m,z=new H(F,C,a,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.eb.delete(m))),z}$(F,C){return new Q(F,C.profileLocation,this.gb)}async pb(F){const C=async m=>{let z=await b.Promises.readdir(m);z=z.map(W=>g.$ic(m,W));const U=await Promise.all(z.map(W=>b.Promises.stat(W)));let Z=Promise.resolve([]);return U.forEach((W,le)=>{const ae=z[le];W.isFile()&&(Z=Z.then(me=>[...me,ae])),W.isDirectory()&&(Z=Z.then(me=>C(ae).then(de=>[...me,...de])))}),Z};return(await C(F.location.fsPath)).map(m=>({path:`extension/${g.$kc(F.location.fsPath,m)}`,localPath:m}))}async qb({added:F,removed:C}){if(C){const a=F&&this.D.extUri.isEqual(C.profileLocation,F.profileLocation)?C.extensions.filter(m=>F.extensions.every(z=>!(0,i.$Co)(z,m))):C.extensions;for(const m of a)this.F.info("Extensions removed from another source",m.id,C.profileLocation.toString()),this.u.fire({identifier:m,profileLocation:C.profileLocation})}if(F){const m=(await this.bb.scanExtensions(1,F.profileLocation)).filter(z=>F.extensions.some(U=>(0,i.$Co)(U,z.identifier)));this.s.fire(m.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,F.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:F.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(C=>this.rb.add(C)));const F=await this.ib.resolve(this.fb.userExtensionsLocation);for(const C of F.children??[])C.isDirectory&&this.rb.add(C.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(C=>this.tb(C)))}async tb(F){if(!F.affects(this.fb.userExtensionsLocation,1))return;const C=[];for(const a of F.rawAdded){if(this.rb.has(a)||!this.D.extUri.isEqual(this.D.extUri.dirname(a),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(a,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(a).startsWith(".")||!(await this.ib.stat(a)).isDirectory)continue;const m=await this.bb.scanUserExtensionAtLocation(a);m&&m.installedTimestamp===void 0&&(this.rb.add(a),C.push(m))}C.length&&(await this.ub(C.map(a=>[a,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",C.map(a=>a.identifier.id)))}async ub(F,C){const a=F.map(m=>m[0]);await this.vb(a),await this.gb.addExtensionsToProfile(F,C),this.s.fire(a.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:C})))}async vb(F){const C=await this.bb.getUninstalledExtensions();for(const a of F){const m=i.$Do.create(a);C[m.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",m.id),await this.bb.setInstalled(m),this.F.info("Removed the extension from uninstalled list:",m.id))}}};e.$Mp=X,e.$Mp=X=pe([ie(0,t.$ao),ie(1,ue.$cl),ie(2,oe.$0i),ie(3,s.$Xh),ie(4,o.$Bp),ie(5,n.$xp),ie(6,w.$Rn),ie(7,ee.$Oh),ie(8,_.$$j),ie(9,se.$pj),ie(10,ce.$Ik),ie(11,re.$Kk)],X);let T=class extends c.$Rc{constructor(F,C,a,m,z,U){super(),this.j=F,this.m=C,this.n=a,this.s=m,this.t=z,this.u=U,this.h=this.B(new v.$Nd),this.onExtract=this.h.event,this.c=(0,f.$vg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$1g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,C){const a={includeInvalid:!0,profileLocation:C};let m=[];return F===null||F===0?m.push(...await this.n.scanAllExtensions({includeInvalid:!0},a,!1)):F===1&&m.push(...await this.n.scanUserExtensions(a)),m=F!==null?m.filter(z=>z.type===F):m,Promise.all(m.map(z=>this.F(z)))}async scanAllUserExtensions(F){const C=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(C.map(a=>this.F(a)))}async scanUserExtensionAtLocation(F){try{const C=await this.n.scanExistingExtension(F,1,{includeInvalid:!0});if(C)return await this.F(C)}catch(C){this.u.error(C)}return null}async extractUserExtension(F,C,a,m,z){const U=F.toString(),Z=$.URI.file(g.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,h.$eg)()}`)),W=$.URI.file(g.$ic(this.n.userExtensionsLocation.fsPath,U));let le=await this.m.exists(W);if(le&&m){try{await this.y(F.id,W,"removeExisting")}catch{throw new t.$bo(d.localize(4,null,W.fsPath,F.id),t.ExtensionManagementErrorCode.Delete)}le=!1}if(!le)try{try{this.u.trace(`Started extracting the extension from ${C} to ${W.fsPath}`),await(0,O.$qp)(C,Z.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${W}:`,F.id)}catch(ae){let me=t.ExtensionManagementErrorCode.Extract;throw ae instanceof O.$op&&(ae.type==="CorruptZip"?me=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(me=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$bo(ae.message,me)}await this.n.updateMetadata(Z,a);try{this.u.trace(`Started renaming the extension from ${Z.fsPath} to ${W.fsPath}`),await this.C(Z.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,j.$9)(ae)}. Deleted from extracted location`,Z),ae}this.h.fire(W)}catch(ae){try{await this.m.del(Z,{recursive:!0})}catch{}throw ae}return this.D(W,1)}async scanMetadata(F,C){return C?(await this.w(F,C))?.metadata:this.n.scanMetadata(F.location)}async w(F,C){return(await this.s.scanProfileExtensions(C)).find(m=>(0,i.$Co)(m.identifier,F.identifier))}async updateMetadata(F,C,a){return a?await this.s.updateMetadata([[F,C]],a):await this.n.updateMetadata(F.location,C),this.D(F.location,F.type,a)}getUninstalledExtensions(){return this.z()}async setUninstalled(...F){const C=F.map(a=>i.$Do.create(a));await this.z(a=>C.forEach(m=>{a[m.toString()]=!0,this.u.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(F){await this.z(C=>delete C[F.toString()])}async removeExtension(F,C){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,C)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(C=>delete C[i.$Do.create(F).toString()])}async copyExtension(F,C,a,m){const z=await this.w(F,C),U=await this.w(F,a);return m={...z?.metadata,...m},U?await this.s.updateMetadata([[F,{...U.metadata,...m}]],a):await this.s.addExtensionsToProfile([[F,m]],a),this.D(F.location,F.type,a)}async copyExtensions(F,C){const a=await this.scanExtensions(1,F),m=await Promise.all(a.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,F)]));await this.s.addExtensionsToProfile(m,C)}async y(F,C,a){this.u.trace(`Deleting ${a} extension from disk`,F,C.fsPath);const m=this.t.extUri.joinPath(this.t.extUri.dirname(C),`${this.t.extUri.basename(C)}.${(0,u.$Di)((0,h.$eg)()).toString(16)}${q}`);await this.C(C.fsPath,m.fsPath),await this.m.del(m,{recursive:!0}),this.u.info(`Deleted ${a} extension from disk`,F,C.fsPath)}async z(F){return this.g.queue(async()=>{let C;try{C=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(m){if((0,_.$pk)(m)!==1)throw m}let a={};if(C)try{a=JSON.parse(C)}catch{}return F&&(F(a),Object.keys(a).length?await this.m.writeFile(this.c,D.$be.fromString(JSON.stringify(a))):await this.m.del(this.c)),a})}async C(F,C){try{await b.Promises.rename(F,C,2*60*1e3)}catch(a){throw new t.$bo(a.message||d.localize(5,null,F,C),a.code||t.ExtensionManagementErrorCode.Rename)}}async D(F,C,a){if(a){const z=(await this.n.scanUserExtensions({profileLocation:a})).find(U=>this.t.extUri.isEqual(U.location,F));if(z)return this.F(z)}else{const m=await this.n.scanExistingExtension(F,C,{includeInvalid:!0});if(m)return this.F(m)}throw new Error(d.localize(6,null,F.path))}async F(F){const C=await this.m.resolve(F.location);let a,m;return C.children&&(a=C.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,m=C.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:a,changelogUrl:m,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const C=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const z of C)F[i.$Do.create(z).toString()]||a.add(z.identifier.id.toLowerCase());try{const z=(0,i.$Io)(C,U=>U.identifier);await L.Promises.settled(z.map(async U=>{const Z=U.sort((W,le)=>P.rcompare(W.manifest.version,le.manifest.version))[0];a.has(Z.identifier.id.toLowerCase())||await this.j(await this.F(Z))}))}catch(z){this.u.error(z)}const m=C.filter(z=>z.metadata&&F[i.$Do.create(z).toString()]);await Promise.allSettled(m.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(C){(0,_.$pk)(C)!==1&&this.u.error(C);return}if(F?.children)try{await Promise.allSettled(F.children.map(async C=>{if(!(!C.isDirectory||!C.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",C.resource.toString());try{await this.m.del(C.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",C.resource.toString())}catch(a){(0,_.$pk)(a)!==1&&this.u.error(a)}}}))}catch{}}};e.$Np=T,e.$Np=T=pe([ie(1,_.$$j),ie(2,o.$Bp),ie(3,n.$xp),ie(4,ce.$Ik),ie(5,oe.$0i)],T);class M extends r.$vp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$Ff)(this.options.operation)?this.l:this.options.operation}constructor(F,C,a,m,z,U,Z,W,le){super(),this.identifier=F,this.source=C,this.options=a,this.m=m,this.n=z,this.o=U,this.p=Z,this.q=W,this.s=le,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(F){const[C,a]=await this.x(F);return this.j=C.isBuiltin||C.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[C,a]],this.j),C}async u({zipPath:F,key:C,metadata:a},m,z){let U=await this.v(C);return U||(this.s.trace("Extracting extension...",C.id),U=await this.m.extractUserExtension(C,F,a,m,z),this.s.info("Extracting extension completed.",C.id)),U}async v(F){return await this.w(F)?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(m=>i.$Do.create(m).equals(F))):void 0}async w(F){return!!(await this.m.getUninstalledExtensions())[F.toString()]}}class H extends M{constructor(F,C,a,m,z,U,Z,W,le,ae){super(C.identifier,C,a,z,U,Z,W,le,ae),this.y=C,this.z=m}async x(F){const a=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Z=>(0,i.$Co)(Z.identifier,this.y.identifier));a&&(this.l=3);const m={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,y.$Ef)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.y.version)return[await this.m.updateMetadata(a,m),m];const{location:z,verificationStatus:U}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=U,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:i.$Do.create(this.y),metadata:m},!1,F),m]}catch(Z){try{await this.z.delete(z)}catch(W){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,j.$9)(W))}throw Z}}async B(F){try{await(0,E.$Ip)(F)}catch(C){throw new t.$bo((0,r.$tp)(C).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$Op=H;class G extends M{constructor(F,C,a,m,z,U,Z,W,le,ae){super({id:(0,i.$Ho)(F.publisher,F.name)},C,a,z,U,Z,W,le,ae),this.y=F,this.z=C,this.A=m}async h(F){const C=await super.h(F);return this.D(C,F),C}async x(F){const C=new i.$Do(this.identifier,this.y.version),m=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Z=>(0,i.$Co)(this.identifier,Z.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(m)if(this.l=3,C.equals(new i.$Do(m.identifier,m.manifest.version)))try{await this.m.removeExtension(m,"existing")}catch{throw new Error(d.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&P.gt(m.manifest.version,this.y.version)&&await this.m.setUninstalled(m);else{const Z=await this.v(C);if(Z)try{await this.m.removeExtension(Z,"existing")}catch{throw new Error(d.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:g.$jc(this.z.fsPath),key:C,metadata:z},!0,F),z]}async D(F,C){try{let[a]=await this.A.getExtensions([{id:F.identifier.id,version:F.manifest.version}],C);if(a||([a]=await this.A.getExtensions([{id:F.identifier.id}],C)),a){const m={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(F,m,this.options.profileLocation)}}catch{}}}class Q extends r.$vp{constructor(F,C,a){super(),this.extension=F,this.j=C,this.k=a}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(te[163],ne([0,1,137,8,14,9,3,25,18,138,6,44,136,178]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=void 0;let P=class extends I.$Wo{constructor(b,O,d,w){super(w),this.m=b,this.n=O,this.r=d,this.s(),this.B(b.onDidChangeConfiguration(s=>{s.affectsConfiguration("http")&&this.s()}))}s(){const b=this.m.getValue("http");this.f=b?.proxy,this.g=!!b?.proxyStrictSSL,this.h=b?.proxyAuthorization}async request(b,O){const{f:d,g:w}=this;let s;try{s=await(0,c.$Tl)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$9)(i)))}const r={...process.env,...s},t=b.agent?b.agent:await(0,g.$1q)(b.url||"",r,{proxyUrl:d,strictSSL:w});return b.agent=t,b.strictSSL=w,this.h&&(b.headers={...b.headers||{},"Proxy-Authorization":this.h}),this.c(b.isChromiumNetwork?"electron":"node",b,()=>$(b,O))}async resolveProxy(b){}};e.$2q=P,e.$2q=P=pe([ie(0,v.$ji),ie(1,u.$Xh),ie(2,S.$0i),ie(3,S.$$i)],P);async function y(h){return((0,L.parse)(h.url).protocol==="https:"?await new Promise((d,w)=>{J(["https"],d,w)}):await new Promise((d,w)=>{J(["http"],d,w)})).request}async function $(h,b){return D.Promises.withAsyncBody(async(O,d)=>{const w=(0,L.parse)(h.url),s=h.getRawRequest?h.getRawRequest(h):await y(h),r={hostname:w.hostname,port:w.port?parseInt(w.port):w.protocol==="https:"?443:80,protocol:w.protocol,path:w.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,j.$Ef)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(r.auth=h.user+":"+h.password);const t=s(r,i=>{const n=(0,j.$Cf)(h.followRedirects)?h.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)$({...h,url:i.headers.location,followRedirects:n-1},b).then(O,d);else{let o=i;!h.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,f.createGunzip)())),O({res:i,stream:(0,R.$qe)(o)})}});t.on("error",d),h.timeout&&t.setTimeout(h.timeout),h.isChromiumNetwork&&t.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&t.write(h.data),t.end(),b.onCancellationRequested(()=>{t.abort(),d(new A.$4)})})}e.$3q=$}),define(te[179],ne([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,44,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,L,D,R,A,j,v,u,c,S,I,g,f,P,y,$,h,b,O,d,w,s,r,t,i,n,o,l,k,E,p,N,B,_,ee,oe,se,ue,ce,re,q,X,T,M,H,G,Q,Y,F,C,a,m,z,U,Z,W,le,ae,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends j.$Rc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const Se=be.get(ee.$0i),Fe=be.get(o.$$j),V=be.get(h.$Xh),K=be.get(m.$Kk);Se.info("CLI main",this.b),this.g(Se),await this.h(V,Fe,K,he),await Promise.all(we.map(x=>{(0,D.$Lg)(x.flush(),1e3)}))})}async f(){const he=new N.$Nh,we={_serviceBrand:void 0,...ce.default};he.set(re.$pj,we);const be=new b.$jm(this.b,we);he.set(h.$Xh,be),await Promise.all([be.appSettingsHome.with({scheme:v.Schemas.file}).fsPath,be.extensionsPath].map(Ae=>Ae?g.Promises.mkdir(Ae,{recursive:!0}):void 0));const Se=new le.$DN((0,ee.$lj)(be),be.logsHome);he.set(ee.$$i,Se);const Fe=this.B(Se.createLogger("cli",{name:(0,ae.localize)(0,null)})),V=[];Se.getLogLevel()===ee.LogLevel.Trace&&V.push(new ee.$fj(Se.getLogLevel()));const K=this.B(new W.$NN(Fe,V));he.set(ee.$0i,K);const x=this.B(new l.$Qp(K));he.set(o.$$j,x);const $e=this.B(new k.$dq(K));x.registerProvider(v.Schemas.file,$e);const ye=new a.$Cr(x);he.set(C.$Ik,ye);const Oe=new T.$HN(1,be,K,x),Pe=new z.$JN(Oe,ye,be,x,K);he.set(m.$Kk,Pe),x.registerProvider(v.Schemas.vscodeUserData,new me.$R8b(v.Schemas.file,$e,v.Schemas.vscodeUserData,Pe,ye,K));const Le=c.$j&&we.win32RegValueName?this.B(new ue.$P8b(K,we.win32RegValueName)):be.policyFile?this.B(new oe.$Q8b(be.policyFile,x,K)):new se.$nn;he.set(se.$ln,Le);const Ie=this.B(new P.$Nn(Pe.defaultProfile.settingsResource,x,Le,K));he.set(f.$ji,Ie),await Promise.all([Oe.init(),Ie.initialize()]);let je;try{je=await(0,U.$t8b)(Oe,K)}catch(Ae){Ae.code!=="ENOENT"&&K.error(Ae)}const Me=await(0,U.$u8b)(Oe,K);Pe.init(),he.set(C.$Ik,new a.$Cr(x));const Ne=new X.$2q(Ie,be,K,Se);he.set(q.$Vo,Ne),he.set(y.$Rn,new E.$Mh($.$3N,void 0,!0)),he.set(r.$xp,new E.$Mh(Z.$MN,void 0,!0)),he.set(t.$Bp,new E.$Mh(n.$q8b,void 0,!0)),he.set(w.$hp,new E.$Mh(w.$ip,void 0,!0)),he.set(i.$Lp,new E.$Mh(i.$Mp,void 0,!0)),he.set(d.$ao,new E.$Mh(O.$gp,void 0,!0)),he.set(B.$Vq,new E.$Mh(_.$Xq,void 0,!1));const De=[],ze=(0,Q.$zo)(we,Ie);if((0,Q.$uo)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&De.push(new Y.$BN(Ne,ze,"monacoworkbench",null,we.aiConfig.ariaKey));const Ae={appenders:De,sendErrorTelemetry:!1,commonProperties:(0,M.$ko)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,je,Me,ze),piiPaths:(0,Q.$Ao)(be)};he.set(H.$cl,new E.$Mh(G.$4q,[Ae],!1))}else he.set(H.$cl,Q.$oo);return[new p.$gq(he),De]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const be=(0,R.$Ai)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,A.$Y)(we)||(0,A.$Z)(we)}),process.on("unhandledRejection",we=>(0,A.$Z)(we))}async h(he,we,be,Se){let Fe;if(he.args.profile&&(Fe=be.profiles.find(K=>K.name===he.args.profile),!Fe))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Fe??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Se.createInstance(s.$jp,new ee.$fj(ee.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const K={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return Se.createInstance(s.$jp,new ee.$fj(ee.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),K,!!this.b.force)}else{if(this.b["uninstall-extension"])return Se.createInstance(s.$jp,new ee.$fj(ee.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return Se.createInstance(s.$jp,new ee.$fj(ee.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$b9b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?I.URI.file((0,u.$hc)(we)?we:(0,u.$ic)((0,S.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/98417b150aeb47dd81dc58893789da4b4cb0e095/core/vs/code/node/cliProcessMain.js.map
