/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(te){for(var e=[],D=0,L=te.length;D<L;D++)e[D]=oe[te[D]];return e};define(oe[123],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class D{static get(){const N=new Map,A=new Map,I=new Map,R=new Map;function S(c,$){c.has($.detail)||c.set($.detail,-$.timestamp)}function g(c,$){const y=c.get($.detail);y&&(y>=0||c.set($.detail,y+$.timestamp))}let C=[];typeof te=="function"&&typeof te.getStats=="function"&&(C=te.getStats().slice(0).sort((c,$)=>c.timestamp-$.timestamp));for(const c of C)switch(c.type){case 10:S(N,c);break;case 11:case 12:g(N,c);break;case 21:S(A,c);break;case 22:g(A,c);break;case 33:S(I,c);break;case 34:g(I,c);break;case 31:S(R,c);break;case 32:g(R,c);break}let k=0;I.forEach(c=>k+=c);function b(c){const $=[];return c.forEach((y,p)=>$.push([p,y])),$}return{amdLoad:b(N),amdInvoke:b(A),nodeRequire:b(I),nodeEval:b(R),nodeRequireTotal:k}}static toMarkdownTable(N,A){let I="";const R=[];return N.forEach((S,g)=>{R[g]=S.length}),A.forEach(S=>{S.forEach((g,C)=>{typeof g>"u"&&(g=S[C]="-");const k=g.toString().length;R[C]=Math.max(k,R[C])})}),N.forEach((S,g)=>{I+=`| ${S+" ".repeat(R[g]-S.toString().length)} `}),I+=`|
`,N.forEach((S,g)=>{I+=`| ${"-".repeat(R[g])} `}),I+=`|
`,A.forEach(S=>{S.forEach((g,C)=>{typeof g<"u"&&(I+=`| ${g+" ".repeat(R[C]-g.toString().length)} `)}),I+=`|
`}),I}}e.$T=D}),define(oe[124],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function D(y,p,h){const f=L(y,p);if(f!==-1)return y[f]}e.$eb=D;function L(y,p,h=y.length-1){for(let f=h;f>=0;f--){const u=y[f];if(p(u))return f}return-1}e.$fb=L;function N(y,p){const h=A(y,p);return h===-1?void 0:y[h]}e.$gb=N;function A(y,p,h=0,f=y.length){let u=h,d=f;for(;u<d;){const E=Math.floor((u+d)/2);p(y[E])?u=E+1:d=E}return u-1}e.$hb=A;function I(y,p){const h=R(y,p);return h===y.length?void 0:y[h]}e.$ib=I;function R(y,p,h=0,f=y.length){let u=h,d=f;for(;u<d;){const E=Math.floor((u+d)/2);p(y[E])?d=E:u=E+1}return u}e.$jb=R;function S(y,p,h=0,f=y.length){const u=R(y,p,h,f);return u===y.length?-1:u}e.$kb=S;class g{static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if(g.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!p(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const h=A(this.e,p,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}e.$lb=g;function C(y,p){if(y.length===0)return;let h=y[0];for(let f=1;f<y.length;f++){const u=y[f];p(u,h)>0&&(h=u)}return h}e.$mb=C;function k(y,p){if(y.length===0)return;let h=y[0];for(let f=1;f<y.length;f++){const u=y[f];p(u,h)>=0&&(h=u)}return h}e.$nb=k;function b(y,p){return C(y,(h,f)=>-p(h,f))}e.$ob=b;function c(y,p){if(y.length===0)return-1;let h=0;for(let f=1;f<y.length;f++){const u=y[f];p(u,y[h])>0&&(h=f)}return h}e.$pb=c;function $(y,p){for(const h of y){const f=p(h);if(f!==void 0)return f}}e.$qb=$}),define(oe[125],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function D(I,R){const S=Object.create(null);for(const g of I){const C=R(g);let k=S[C];k||(k=S[C]=[]),k.push(g)}return S}e.$J=D;function L(I,R){const S=[],g=[];for(const C of I)R.has(C)||S.push(C);for(const C of R)I.has(C)||g.push(C);return{removed:S,added:g}}e.$K=L;function N(I,R){const S=[],g=[];for(const[C,k]of I)R.has(C)||S.push(k);for(const[C,k]of R)I.has(C)||g.push(k);return{removed:S,added:g}}e.$L=N;function A(I,R){const S=new Set;for(const g of R)I.has(g)&&S.add(g);return S}e.$M=A}),define(oe[84],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function D(I){return(R,S,g)=>{let C=null,k=null;if(typeof g.value=="function"?(C="value",k=g.value):typeof g.get=="function"&&(C="get",k=g.get),!k)throw new Error("not supported");g[C]=I(k,S)}}function L(I,R,S){let g=null,C=null;if(typeof S.value=="function"?(g="value",C=S.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(g="get",C=S.get),!C)throw new Error("not supported");const k=`$memoize$${R}`;S[g]=function(...b){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,b)}),this[k]}}e.$hh=L;function N(I,R,S){return D((g,C)=>{const k=`$debounce$${C}`,b=`$debounce$result$${C}`;return function(...c){this[b]||(this[b]=S?S():void 0),clearTimeout(this[k]),R&&(this[b]=R(this[b],...c),c=[this[b]]),this[k]=setTimeout(()=>{g.apply(this,c),this[b]=S?S():void 0},I)}})}e.$ih=N;function A(I,R,S){return D((g,C)=>{const k=`$throttle$timer$${C}`,b=`$throttle$result$${C}`,c=`$throttle$lastRun$${C}`,$=`$throttle$pending$${C}`;return function(...y){if(this[b]||(this[b]=S?S():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),R&&(this[b]=R(this[b],...y)),this[$])return;const p=this[c]+I;p<=Date.now()?(this[c]=Date.now(),g.apply(this,[this[b]]),this[b]=S?S():void 0):(this[$]=!0,this[k]=setTimeout(()=>{this[$]=!1,this[c]=Date.now(),g.apply(this,[this[b]]),this[b]=S?S():void 0},p-Date.now()))}})}e.$jh=A}),define(oe[7],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class D{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?u.isErrorNoTelemetry(s)?new u(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(o=>{o(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$V=D,e.$W=new D;function L(E){e.$W.setUnexpectedErrorHandler(E)}e.setUnexpectedErrorHandler=L;function N(E){if(!E||typeof E!="object")return!1;const s=E;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.$Y=N;function A(E){g(E)||e.$W.onUnexpectedError(E)}e.$Z=A;function I(E){g(E)||e.$W.onUnexpectedExternalError(E)}e.$1=I;function R(E){if(E instanceof Error){const{name:s,message:o}=E,n=E.stacktrace||E.stack;return{$isError:!0,name:s,message:o,stack:n,noTelemetry:u.isErrorNoTelemetry(E)}}return E}e.$2=R;const S="Canceled";function g(E){return E instanceof C?!0:E instanceof Error&&E.name===S&&E.message===S}e.$3=g;class C extends Error{constructor(){super(S),this.name=this.message}}e.$4=C;function k(){const E=new Error(S);return E.name=E.message,E}e.$5=k;function b(E){return E?new Error(`Illegal argument: ${E}`):new Error("Illegal argument")}e.$6=b;function c(E){return E?new Error(`Illegal state: ${E}`):new Error("Illegal state")}e.$7=c;class $ extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=$;function y(E){return E?E.message?E.message:E.stack?E.stack.split(`
`)[0]:String(E):"Error"}e.$9=y;class p extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$0=p;class h extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$$=h;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=f;class u extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof u)return s;const o=new u;return o.message=s.message,o.stack=s.stack,o}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$ab=u;class d extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$bb=d}),define(oe[18],ae([0,1,7,124]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function N(M,H=0){return M[M.length-(1+H)]}e.$rb=N;function A(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.$sb=A;function I(M,H,J=(re,ce)=>re===ce){if(M===H)return!0;if(!M||!H||M.length!==H.length)return!1;for(let re=0,ce=M.length;re<ce;re++)if(!J(M[re],H[re]))return!1;return!0}e.$tb=I;function R(M,H){const J=M.length-1;H<J&&(M[H]=M[J]),M.pop()}e.$ub=R;function S(M,H,J){return g(M.length,re=>J(M[re],H))}e.$vb=S;function g(M,H){let J=0,re=M-1;for(;J<=re;){const ce=(J+re)/2|0,ue=H(ce);if(ue<0)J=ce+1;else if(ue>0)re=ce-1;else return ce}return-(J+1)}e.$wb=g;function C(M,H,J){if(M=M|0,M>=H.length)throw new TypeError("invalid index");const re=H[Math.floor(H.length*Math.random())],ce=[],ue=[],he=[];for(const $e of H){const de=J($e,re);de<0?ce.push($e):de>0?ue.push($e):he.push($e)}return M<ce.length?C(M,ce,J):M<ce.length+he.length?he[0]:C(M-(ce.length+he.length),ue,J)}e.$xb=C;function k(M,H){const J=[];let re;for(const ce of M.slice(0).sort(H))!re||H(re[0],ce)!==0?(re=[ce],J.push(re)):re.push(ce);return J}e.$yb=k;function*b(M,H){let J,re;for(const ce of M)re!==void 0&&H(re,ce)?J.push(ce):(J&&(yield J),J=[ce]),re=ce;J&&(yield J)}e.$zb=b;function c(M,H){for(let J=0;J<=M.length;J++)H(J===0?void 0:M[J-1],J===M.length?void 0:M[J])}e.$Ab=c;function $(M,H){for(let J=0;J<M.length;J++)H(J===0?void 0:M[J-1],M[J],J+1===M.length?void 0:M[J+1])}e.$Bb=$;function y(M,H,J){const re=[];function ce($e,de,we){if(de===0&&we.length===0)return;const ve=re[re.length-1];ve&&ve.start+ve.deleteCount===$e?(ve.deleteCount+=de,ve.toInsert.push(...we)):re.push({start:$e,deleteCount:de,toInsert:we})}let ue=0,he=0;for(;;){if(ue===M.length){ce(ue,0,H.slice(he));break}if(he===H.length){ce(ue,M.length-ue,[]);break}const $e=M[ue],de=H[he],we=J($e,de);we===0?(ue+=1,he+=1):we<0?(ce(ue,1,[]),ue+=1):we>0&&(ce(ue,0,[de]),he+=1)}return re}e.$Cb=y;function p(M,H,J){const re=y(M,H,J),ce=[],ue=[];for(const he of re)ce.push(...M.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:ce,added:ue}}e.$Db=p;function h(M,H,J){if(J===0)return[];const re=M.slice(0,J).sort(H);return u(M,H,re,J,M.length),re}e.top=h;function f(M,H,J,re,ce){return J===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const $e=M.length,de=M.slice(0,J).sort(H);for(let we=J,ve=Math.min(J+re,$e);we<$e;we=ve,ve=Math.min(ve+re,$e)){if(we>J&&await new Promise(Ie=>setTimeout(Ie)),ce&&ce.isCancellationRequested)throw new D.$4;u(M,H,de,we,ve)}return de})().then(ue,he)})}e.$Fb=f;function u(M,H,J,re,ce){for(const ue=J.length;re<ce;re++){const he=M[re];if(H(he,J[ue-1])<0){J.pop();const $e=(0,L.$jb)(J,de=>H(he,de)<0);J.splice($e,0,he)}}}function d(M){return M.filter(H=>!!H)}e.$Gb=d;function E(M){let H=0;for(let J=0;J<M.length;J++)M[J]&&(M[H]=M[J],H+=1);M.length=H}e.$Hb=E;function s(M,H,J){M.splice(J,0,M.splice(H,1)[0])}e.$Ib=s;function o(M){return!Array.isArray(M)||M.length===0}e.$Jb=o;function n(M){return Array.isArray(M)&&M.length>0}e.$Kb=n;function i(M,H=J=>J){const J=new Set;return M.filter(re=>{const ce=H(re);return J.has(ce)?!1:(J.add(ce),!0)})}e.$Lb=i;function t(M){const H=new Set;return J=>{const re=M(J);return H.has(re)?!1:(H.add(re),!0)}}e.$Mb=t;function r(M,H){return M.length>0?M[0]:H}e.$Nb=r;function a(M,H){return M.length>0?M[M.length-1]:H}e.$Ob=a;function v(M,H,J=(re,ce)=>re===ce){let re=0;for(let ce=0,ue=Math.min(M.length,H.length);ce<ue&&J(M[ce],H[ce]);ce++)re++;return re}e.$Pb=v;function w(M){return[].concat(...M)}e.$Qb=w;function l(M,H){let J=typeof H=="number"?M:0;typeof H=="number"?J=M:(J=0,H=M);const re=[];if(J<=H)for(let ce=J;ce<H;ce++)re.push(ce);else for(let ce=J;ce>H;ce--)re.push(ce);return re}e.$Rb=l;function m(M,H,J){return M.reduce((re,ce)=>(re[H(ce)]=J?J(ce):ce,re),Object.create(null))}e.$Sb=m;function O(M,H){return M.push(H),()=>F(M,H)}e.$Tb=O;function F(M,H){const J=M.indexOf(H);if(J>-1)return M.splice(J,1),H}e.$Ub=F;function z(M,H,J){const re=M.slice(0,H),ce=M.slice(H);return re.concat(J,ce)}e.$Vb=z;function U(M,H){let J;if(typeof H=="number"){let re=H;J=()=>{const ce=Math.sin(re++)*179426549;return ce-Math.floor(ce)}}else J=Math.random;for(let re=M.length-1;re>0;re-=1){const ce=Math.floor(J()*(re+1)),ue=M[re];M[re]=M[ce],M[ce]=ue}}e.$Wb=U;function B(M,H){const J=M.indexOf(H);J>-1&&(M.splice(J,1),M.unshift(H))}e.$Xb=B;function Y(M,H){const J=M.indexOf(H);J>-1&&(M.splice(J,1),M.push(H))}e.$Yb=Y;function K(M,H){for(const J of H)M.push(J)}e.$Zb=K;function x(M,H){return Array.isArray(M)?M.map(H):H(M)}e.$1b=x;function V(M){return Array.isArray(M)?M:[M]}e.$2b=V;function Q(M){return M[Math.floor(Math.random()*M.length)]}e.$3b=Q;function G(M,H,J){const re=ee(M,H),ce=M.length,ue=J.length;M.length=ce+ue;for(let he=ce-1;he>=re;he--)M[he+ue]=M[he];for(let he=0;he<ue;he++)M[he+re]=J[he]}e.$4b=G;function W(M,H,J,re){const ce=ee(M,H);let ue=M.splice(ce,J);return ue===void 0&&(ue=[]),G(M,ce,re),ue}e.$5b=W;function ee(M,H){return H<0?Math.max(H+M.length,0):Math.min(H,M.length)}var ie;(function(M){function H(ue){return ue<0}M.isLessThan=H;function J(ue){return ue<=0}M.isLessThanOrEqual=J;function re(ue){return ue>0}M.isGreaterThan=re;function ce(ue){return ue===0}M.isNeitherLessOrGreaterThan=ce,M.greaterThan=1,M.lessThan=-1,M.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function _(M,H){return(J,re)=>H(M(J),M(re))}e.$6b=_;function ne(...M){return(H,J)=>{for(const re of M){const ce=re(H,J);if(!ie.isNeitherLessOrGreaterThan(ce))return ce}return ie.neitherLessOrGreaterThan}}e.$7b=ne;const Z=(M,H)=>M-H;e.$8b=Z;const q=(M,H)=>(0,e.$8b)(M?1:0,H?1:0);e.$9b=q;function P(M){return(H,J)=>-M(H,J)}e.$0b=P;class j{constructor(H){this.g=H,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(H){let J=this.c;for(;J<this.g.length&&H(this.g[J]);)J++;const re=J===this.c?null:this.g.slice(this.c,J);return this.c=J,re}takeFromEndWhile(H){let J=this.d;for(;J>=0&&H(this.g[J]);)J--;const re=J===this.d?null:this.g.slice(J+1,this.d+1);return this.d=J,re}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const H=this.g[this.c];return this.c++,H}removeLast(){const H=this.g[this.d];return this.d--,H}takeCount(H){const J=this.g.slice(this.c,this.c+H);return this.c+=H,J}}e.$$b=j;class T{static{this.empty=new T(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(J=>(H(J),!0))}toArray(){const H=[];return this.iterate(J=>(H.push(J),!0)),H}filter(H){return new T(J=>this.iterate(re=>H(re)?J(re):!0))}map(H){return new T(J=>this.iterate(re=>J(H(re))))}some(H){let J=!1;return this.iterate(re=>(J=H(re),!J)),J}findFirst(H){let J;return this.iterate(re=>H(re)?(J=re,!1):!0),J}findLast(H){let J;return this.iterate(re=>(H(re)&&(J=re),!0)),J}findLastMaxBy(H){let J,re=!0;return this.iterate(ce=>((re||ie.isGreaterThan(H(ce,J)))&&(re=!1,J=ce),!0)),J}}e.$_b=T}),define(oe[126],ae([0,1,7]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function L(S,g){if(!S)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=L;function N(S,g="Unreachable"){throw new Error(g)}e.$3c=N;function A(S){if(!S)throw new D.$bb("Assertion Failed")}e.$4c=A;function I(S){if(!S()){debugger;S(),(0,D.$Z)(new D.$bb("Assertion Failed"))}}e.$5c=I;function R(S,g){let C=0;for(;C<S.length-1;){const k=S[C],b=S[C+1];if(!g(k,b))return!1;C++}return!0}e.$6c=R}),define(oe[85],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function D(L){const N=this;let A=!1,I;return function(){return A||(A=!0,I=L.apply(N,arguments)),I}}e.$cb=D}),define(oe[59],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(L){function N(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}L.is=N;const A=Object.freeze([]);function I(){return A}L.empty=I;function*R(E){yield E}L.single=R;function S(E){return N(E)?E:R(E)}L.wrap=S;function g(E){return E||A}L.from=g;function*C(E){for(let s=E.length-1;s>=0;s--)yield E[s]}L.reverse=C;function k(E){return!E||E[Symbol.iterator]().next().done===!0}L.isEmpty=k;function b(E){return E[Symbol.iterator]().next().value}L.first=b;function c(E,s){for(const o of E)if(s(o))return!0;return!1}L.some=c;function $(E,s){for(const o of E)if(s(o))return o}L.find=$;function*y(E,s){for(const o of E)s(o)&&(yield o)}L.filter=y;function*p(E,s){let o=0;for(const n of E)yield s(n,o++)}L.map=p;function*h(...E){for(const s of E)for(const o of s)yield o}L.concat=h;function f(E,s,o){let n=o;for(const i of E)n=s(n,i);return n}L.reduce=f;function*u(E,s,o=E.length){for(s<0&&(s+=E.length),o<0?o+=E.length:o>E.length&&(o=E.length);s<o;s++)yield E[s]}L.slice=u;function d(E,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,E];const n=E[Symbol.iterator]();for(let i=0;i<s;i++){const t=n.next();if(t.done)return[o,L.empty()];o.push(t.value)}return[o,{[Symbol.iterator](){return n}}]}L.consume=d})(D||(e.Iterable=D={}))}),define(oe[35],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var L;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var N;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(N||(e.ParseErrorCode=N={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function I(s,o=!1){let n=0;const i=s.length;let t="",r=0,a=16,v=0;function w(B){let Y=0,K=0;for(;Y<B;){const x=s.charCodeAt(n);if(x>=48&&x<=57)K=K*16+x-48;else if(x>=65&&x<=70)K=K*16+x-65+10;else if(x>=97&&x<=102)K=K*16+x-97+10;else break;n++,Y++}return Y<B&&(K=-1),K}function l(B){n=B,t="",r=0,a=16,v=0}function m(){const B=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&g(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&g(s.charCodeAt(n)))for(n++;n<s.length&&g(s.charCodeAt(n));)n++;else return v=3,s.substring(B,n);let Y=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&g(s.charCodeAt(n))){for(n++;n<s.length&&g(s.charCodeAt(n));)n++;Y=n}else v=3;return s.substring(B,Y)}function O(){let B="",Y=n;for(;;){if(n>=i){B+=s.substring(Y,n),v=2;break}const K=s.charCodeAt(n);if(K===34){B+=s.substring(Y,n),n++;break}if(K===92){if(B+=s.substring(Y,n),n++,n>=i){v=2;break}switch(s.charCodeAt(n++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const V=w(4);V>=0?B+=String.fromCharCode(V):v=4;break}default:v=5}Y=n;continue}if(K>=0&&K<=31)if(S(K)){B+=s.substring(Y,n),v=2;break}else v=6;n++}return B}function F(){if(t="",v=0,r=n,n>=i)return r=i,a=17;let B=s.charCodeAt(n);if(R(B)){do n++,t+=String.fromCharCode(B),B=s.charCodeAt(n);while(R(B));return a=15}if(S(B))return n++,t+=String.fromCharCode(B),B===13&&s.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(B){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=O(),a=10;case 47:{const Y=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!S(s.charCodeAt(n));)n++;return t=s.substring(Y,n),a=12}if(s.charCodeAt(n+1)===42){n+=2;const K=i-1;let x=!1;for(;n<K;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=s.substring(Y,n),a=13}return t+=String.fromCharCode(B),n++,a=16}case 45:if(t+=String.fromCharCode(B),n++,n===i||!g(s.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=m(),a=11;default:for(;n<i&&z(B);)n++,B=s.charCodeAt(n);if(r!==n){switch(t=s.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(B),n++,a=16}}function z(B){if(R(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let B;do B=F();while(B>=12&&B<=15);return B}return{setPosition:l,getPosition:()=>n,scan:o?U:F,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$Um=I;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function g(s){return s>=48&&s<=57}var C;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(C||(C={}));function k(s,o){const n=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function v(w,l,m,O){r.value=w,r.offset=l,r.length=m,r.type=O,r.colonOffset=void 0,t=r}try{u(s,{onObjectBegin:(w,l)=>{if(o<=w)throw i;t=void 0,a=o>w,n.push("")},onObjectProperty:(w,l,m)=>{if(o<l||(v(w,l,m,"property"),n[n.length-1]=w,o<=l+m))throw i},onObjectEnd:(w,l)=>{if(o<=w)throw i;t=void 0,n.pop()},onArrayBegin:(w,l)=>{if(o<=w)throw i;t=void 0,n.push(0)},onArrayEnd:(w,l)=>{if(o<=w)throw i;t=void 0,n.pop()},onLiteralValue:(w,l,m)=>{if(o<l||(v(w,l,m,E(w)),o<=l+m))throw i},onSeparator:(w,l,m)=>{if(o<=l)throw i;if(w===":"&&t&&t.type==="property")t.colonOffset=l,a=!1,t=void 0;else if(w===","){const O=n[n.length-1];typeof O=="number"?n[n.length-1]=O+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(w){if(w!==i)throw w}return{path:n,previousNode:t,isAtPropertyKey:a,matches:w=>{let l=0;for(let m=0;l<w.length&&m<n.length;m++)if(w[l]===n[m]||w[l]==="*")l++;else if(w[l]!=="**")return!1;return l===w.length}}}e.$Vm=k;function b(s,o=[],n=A.DEFAULT){let i=null,t=[];const r=[];function a(w){Array.isArray(t)?t.push(w):i!==null&&(t[i]=w)}return u(s,{onObjectBegin:()=>{const w={};a(w),r.push(t),t=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const w=[];a(w),r.push(t),t=w,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(w,l,m)=>{o.push({error:w,offset:l,length:m})}},n),t[0]}e.$Wm=b;function c(s,o=[],n=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(w){i.type==="property"&&(i.length=w-i.offset,i=i.parent)}function r(w){return i.children.push(w),w}u(s,{onObjectBegin:w=>{i=r({type:"object",offset:w,length:-1,parent:i,children:[]})},onObjectProperty:(w,l,m)=>{i=r({type:"property",offset:l,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:w,offset:l,length:m,parent:i})},onObjectEnd:(w,l)=>{i.length=w+l-i.offset,i=i.parent,t(w+l)},onArrayBegin:(w,l)=>{i=r({type:"array",offset:w,length:-1,parent:i,children:[]})},onArrayEnd:(w,l)=>{i.length=w+l-i.offset,i=i.parent,t(w+l)},onLiteralValue:(w,l,m)=>{r({type:E(w),offset:l,length:m,parent:i,value:w}),t(l+m)},onSeparator:(w,l,m)=>{i.type==="property"&&(w===":"?i.colonOffset=l:w===","&&t(l))},onError:(w,l,m)=>{o.push({error:w,offset:l,length:m})}},n);const v=i.children[0];return v&&delete v.parent,v}e.$Xm=c;function $(s,o){if(!s)return;let n=s;for(const i of o)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===i){n=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$Ym=$;function y(s){if(!s.parent||!s.parent.children)return[];const o=y(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;o.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&o.push(n)}return o}e.$Zm=y;function p(s){switch(s.type){case"array":return s.children.map(p);case"object":{const o=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(o[n.children[0].value]=p(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$1m=p;function h(s,o,n=!1){return o>=s.offset&&o<s.offset+s.length||n&&o===s.offset+s.length}e.$2m=h;function f(s,o,n=!1){if(h(s,o,n)){const i=s.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=o;t++){const r=f(i[t],o,n);if(r)return r}return s}}e.$3m=f;function u(s,o,n=A.DEFAULT){const i=I(s,!1);function t(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(_){return _?ne=>_(ne,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),v=r(o.onObjectProperty),w=t(o.onObjectEnd),l=t(o.onArrayBegin),m=t(o.onArrayEnd),O=r(o.onLiteralValue),F=r(o.onSeparator),z=t(o.onComment),U=r(o.onError),B=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function K(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:B||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(_){case 12:case 13:B?x(10):z();break;case 16:x(1);break;case 15:case 14:break;default:return _}}}function x(_,ne=[],Z=[]){if(U(_),ne.length+Z.length>0){let q=i.getToken();for(;q!==17;){if(ne.indexOf(q)!==-1){K();break}else if(Z.indexOf(q)!==-1)break;q=K()}}}function V(_){const ne=i.getTokenValue();return _?O(ne):v(ne),K(),!0}function Q(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(x(2),_=0)}catch{x(2)}O(_);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return K(),!0}function G(){return i.getToken()!==10?(x(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(F(":"),K(),ie()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function W(){a(),K();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),F(","),K(),i.getToken()===2&&Y)break}else _&&x(6,[],[]);G()||x(4,[],[2,5]),_=!0}return w(),i.getToken()!==2?x(7,[2],[]):K(),!0}function ee(){l(),K();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),F(","),K(),i.getToken()===4&&Y)break}else _&&x(6,[],[]);ie()||x(4,[],[4,5]),_=!0}return m(),i.getToken()!==4?x(8,[4],[]):K(),!0}function ie(){switch(i.getToken()){case 3:return ee();case 1:return W();case 10:return V(!0);default:return Q()}}return K(),i.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):ie()?(i.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$4m=u;function d(s,o){const n=I(s),i=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&i.push(s.substring(r,a)),o!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return i.join("")}e.$5m=d;function E(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=E}),define(oe[41],ae([0,1,35]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eT=e.$dT=e.$cT=e.$bT=void 0;function L(g,C,k){let b,c,$,y,p;if(C){for(y=C.offset,p=y+C.length,$=y;$>0&&!S(g,$-1);)$--;let a=p;for(;a<g.length&&!S(g,a);)a++;c=g.substring($,a),b=I(c,k)}else c=g,b=0,$=0,y=0,p=g.length;const h=R(k,g);let f=!1,u=0,d;k.insertSpaces?d=A(" ",k.tabSize||4):d="	";const E=(0,D.$Um)(c,!1);let s=!1;function o(){return h+A(d,b+u)}function n(){let a=E.scan();for(f=!1;a===15||a===14;)f=f||a===14,a=E.scan();return s=a===16||E.getTokenError()!==0,a}const i=[];function t(a,v,w){!s&&v<p&&w>y&&g.substring(v,w)!==a&&i.push({offset:v,length:w-v,content:a})}let r=n();if(r!==17){const a=E.getTokenOffset()+$,v=A(d,b);t(v,$,a)}for(;r!==17;){let a=E.getTokenOffset()+E.getTokenLength()+$,v=n(),w="";for(;!f&&(v===12||v===13);){const m=E.getTokenOffset()+$;t(" ",a,m),a=E.getTokenOffset()+E.getTokenLength()+$,w=v===12?o():"",v=n()}if(v===2)r!==1&&(u--,w=o());else if(v===4)r!==3&&(u--,w=o());else{switch(r){case 3:case 1:u++,w=o();break;case 5:case 12:w=o();break;case 13:f?w=o():w=" ";break;case 6:w=" ";break;case 10:if(v===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?w=" ":v!==5&&v!==17&&(s=!0);break;case 16:s=!0;break}f&&(v===12||v===13)&&(w=o())}const l=E.getTokenOffset()+$;t(w,a,l),r=v}return i}e.$bT=L;function N(g,C){const k=JSON.stringify(g,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?k.replace(/\r\n|\r|\n/g,C.eol):k}e.$cT=N;function A(g,C){let k="";for(let b=0;b<C;b++)k+=g;return k}function I(g,C){let k=0,b=0;const c=C.tabSize||4;for(;k<g.length;){const $=g.charAt(k);if($===" ")b++;else if($==="	")b+=c;else break;k++}return Math.floor(b/c)}function R(g,C){for(let k=0;k<C.length;k++){const b=C.charAt(k);if(b==="\r")return k+1<C.length&&C.charAt(k+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return g&&g.eol||`
`}e.$dT=R;function S(g,C){return`\r
`.indexOf(g.charAt(C))!==-1}e.$eT=S}),define(oe[86],ae([0,1,35,41]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jT=e.$iT=e.$hT=e.$gT=e.$fT=void 0;function N(g,C,k){return A(g,C,void 0,k)}e.$fT=N;function A(g,C,k,b,c){const $=C.slice(),y=[],p=(0,D.$Xm)(g,y);let h,f;for(;$.length>0&&(f=$.pop(),h=(0,D.$Ym)(p,$),h===void 0&&k!==void 0);)typeof f=="string"?k={[f]:k}:k=[k];if(h)if(h.type==="object"&&typeof f=="string"&&Array.isArray(h.children)){const u=(0,D.$Ym)(h,[f]);if(u!==void 0)if(k===void 0){if(!u.parent)throw new Error("Malformed AST");const d=h.children.indexOf(u.parent);let E,s=u.parent.offset+u.parent.length;if(d>0){const o=h.children[d-1];E=o.offset+o.length}else E=h.offset+1,h.children.length>1&&(s=h.children[1].offset);return I(g,{offset:E,length:s-E,content:""},b)}else return I(g,{offset:u.offset,length:u.length,content:JSON.stringify(k)},b);else{if(k===void 0)return[];const d=`${JSON.stringify(f)}: ${JSON.stringify(k)}`,E=c?c(h.children.map(o=>o.children[0].value)):h.children.length;let s;if(E>0){const o=h.children[E-1];s={offset:o.offset+o.length,length:0,content:","+d}}else h.children.length===0?s={offset:h.offset+1,length:0,content:d}:s={offset:h.offset+1,length:0,content:d+","};return I(g,s,b)}}else if(h.type==="array"&&typeof f=="number"&&Array.isArray(h.children))if(k!==void 0){const u=`${JSON.stringify(k)}`;let d;if(h.children.length===0||f===0)d={offset:h.offset+1,length:0,content:h.children.length===0?u:u+","};else{const E=f===-1||f>h.children.length?h.children.length:f,s=h.children[E-1];d={offset:s.offset+s.length,length:0,content:","+u}}return I(g,d,b)}else{const u=f,d=h.children[u];let E;if(h.children.length===1)E={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===u){const s=h.children[u-1],o=s.offset+s.length,n=h.offset+h.length;E={offset:o,length:n-2-o,content:""}}else E={offset:d.offset,length:h.children[u+1].offset-d.offset,content:""};return I(g,E,b)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${h.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return I(g,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(k)},b)}}e.$gT=A;function I(g,C,k){let b=R(g,C),c=C.offset,$=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;c>0&&!(0,L.$eT)(b,c-1);)c--;for(;$<b.length&&!(0,L.$eT)(b,$);)$++}const y=(0,L.$bT)(b,{offset:c,length:$-c},k);for(let h=y.length-1;h>=0;h--){const f=y[h];b=R(b,f),c=Math.min(c,f.offset),$=Math.max($,f.offset+f.length),$+=f.content.length-f.length}const p=g.length-(b.length-$)-c;return[{offset:c,length:p,content:b.substring(c,$)}]}e.$hT=I;function R(g,C){return g.substring(0,C.offset)+C.content+g.substring(C.offset+C.length)}e.$iT=R;function S(g,C){const k=C.slice(0).sort((c,$)=>{const y=c.offset-$.offset;return y===0?c.length-$.length:y});let b=g.length;for(let c=k.length-1;c>=0;c--){const $=k[c];if($.offset+$.length<=b)g=R(g,$);else throw new Error("Overlapping edit");b=$.offset}return g}e.$jT=S}),define(oe[60],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class D{constructor(N){this.d=N,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(N){this.c=N}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=D}),define(oe[87],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}class L{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let A=this.a;for(;A!==D.Undefined;){const I=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=I}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,I){const R=new D(A);if(this.a===D.Undefined)this.a=R,this.b=R;else if(I){const g=this.b;this.b=R,R.prev=g,g.next=R}else{const g=this.a;this.a=R,R.next=g,g.prev=R}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(R))}}shift(){if(this.a!==D.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==D.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const I=A.prev;I.next=A.next,A.next.prev=I}else A.prev===D.Undefined&&A.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):A.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):A.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.$1c=L}),define(oe[34],ae([0,1]),function(te,e){"use strict";var D,L,N;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function A(f,u,d){let E=f.get(u);return E===void 0&&(E=d,f.set(u,E)),E}e.$wc=A;function I(f){const u=[];return f.forEach((d,E)=>{u.push(`${E} => ${d}`)}),`Map(${f.size}) {${u.join(", ")}}`}e.$xc=I;function R(f){const u=[];return f.forEach(d=>{u.push(d)}),`Set(${f.size}) {${u.join(", ")}}`}e.$yc=R;class S{constructor(u,d){this.uri=u,this.value=d}}function g(f){return Array.isArray(f)}class C{static{this.a=u=>u.toString()}constructor(u,d){if(this[D]="ResourceMap",u instanceof C)this.b=new Map(u.b),this.c=d??C.a;else if(g(u)){this.b=new Map,this.c=d??C.a;for(const[E,s]of u)this.set(E,s)}else this.b=new Map,this.c=u??C.a}set(u,d){return this.b.set(this.c(u),new S(u,d)),this}get(u){return this.b.get(this.c(u))?.value}has(u){return this.b.has(this.c(u))}get size(){return this.b.size}clear(){this.b.clear()}delete(u){return this.b.delete(this.c(u))}forEach(u,d){typeof d<"u"&&(u=u.bind(d));for(const[E,s]of this.b)u(s.value,s.uri,this)}*values(){for(const u of this.b.values())yield u.value}*keys(){for(const u of this.b.values())yield u.uri}*entries(){for(const u of this.b.values())yield[u.uri,u.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.b)yield[u.uri,u.value]}}e.$zc=C;class k{constructor(u,d){this[L]="ResourceSet",!u||typeof u=="function"?this.a=new C(u):(this.a=new C(d),u.forEach(this.add,this))}get size(){return this.a.size}add(u){return this.a.set(u,u),this}clear(){this.a.clear()}delete(u){return this.a.delete(u)}forEach(u,d){this.a.forEach((E,s)=>u.call(d,s,s,this))}has(u){return this.a.has(u)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=k;var b;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class c{constructor(){this[N]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(u){return this.a.has(u)}get(u,d=0){const E=this.a.get(u);if(E)return d!==0&&this.j(E,d),E.value}set(u,d,E=0){let s=this.a.get(u);if(s)s.value=d,E!==0&&this.j(s,E);else{switch(s={key:u,value:d,next:void 0,previous:void 0},E){case 0:this.h(s);break;case 1:this.g(s);break;case 2:this.h(s);break;default:this.h(s);break}this.a.set(u,s),this.d++}return this}delete(u){return!!this.remove(u)}remove(u){const d=this.a.get(u);if(d)return this.a.delete(u),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const u=this.b;return this.a.delete(u.key),this.i(u),this.d--,u.value}forEach(u,d){const E=this.e;let s=this.b;for(;s;){if(d?u.bind(d)(s.value,s.key,this):u(s.value,s.key,this),this.e!==E)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const u=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(u.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:E.key,done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}values(){const u=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(u.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:E.value,done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}entries(){const u=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(u.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:[E.key,E.value],done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(u){if(u>=this.size)return;if(u===0){this.clear();return}let d=this.b,E=this.size;for(;d&&E>u;)this.a.delete(d.key),d=d.next,E--;this.b=d,this.d=E,d&&(d.previous=void 0),this.e++}g(u){if(!this.b&&!this.c)this.c=u;else if(this.b)u.next=this.b,this.b.previous=u;else throw new Error("Invalid list");this.b=u,this.e++}h(u){if(!this.b&&!this.c)this.b=u;else if(this.c)u.previous=this.c,this.c.next=u;else throw new Error("Invalid list");this.c=u,this.e++}i(u){if(u===this.b&&u===this.c)this.b=void 0,this.c=void 0;else if(u===this.b){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.b=u.next}else if(u===this.c){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.c=u.previous}else{const d=u.next,E=u.previous;if(!d||!E)throw new Error("Invalid list");d.previous=E,E.next=d}u.next=void 0,u.previous=void 0,this.e++}j(u,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(u===this.b)return;const E=u.next,s=u.previous;u===this.c?(s.next=void 0,this.c=s):(E.previous=s,s.next=E),u.previous=void 0,u.next=this.b,this.b.previous=u,this.b=u,this.e++}else if(d===2){if(u===this.c)return;const E=u.next,s=u.previous;u===this.b?(E.previous=void 0,this.b=E):(E.previous=s,s.next=E),u.next=void 0,u.previous=this.c,this.c.next=u,this.c=u,this.e++}}}toJSON(){const u=[];return this.forEach((d,E)=>{u.push([E,d])}),u}fromJSON(u){this.clear();for(const[d,E]of u)this.set(d,E)}}e.$Bc=c;class $ extends c{constructor(u,d=1){super(),this.k=u,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(u){this.k=u,this.m()}get ratio(){return this.l}set ratio(u){this.l=Math.min(Math.max(0,u),1),this.m()}get(u,d=2){return super.get(u,d)}peek(u){return super.get(u,0)}set(u,d){return super.set(u,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=$;class y{constructor(){this.a=new Map}add(u){return this.a.set(u,(this.a.get(u)||0)+1),this}delete(u){let d=this.a.get(u)||0;return d===0?!1:(d--,d===0?this.a.delete(u):this.a.set(u,d),!0)}has(u){return this.a.has(u)}}e.$Dc=y;class p{constructor(u){if(this.a=new Map,this.b=new Map,u)for(const[d,E]of u)this.set(d,E)}clear(){this.a.clear(),this.b.clear()}set(u,d){this.a.set(u,d),this.b.set(d,u)}get(u){return this.a.get(u)}getKey(u){return this.b.get(u)}delete(u){const d=this.a.get(u);return d===void 0?!1:(this.a.delete(u),this.b.delete(d),!0)}forEach(u,d){this.a.forEach((E,s)=>{u.call(d,E,s,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=p;class h{constructor(){this.a=new Map}add(u,d){let E=this.a.get(u);E||(E=new Set,this.a.set(u,E)),E.add(d)}delete(u,d){const E=this.a.get(u);E&&(E.delete(d),E.size===0&&this.a.delete(u))}forEach(u,d){const E=this.a.get(u);E&&E.forEach(d)}get(u){const d=this.a.get(u);return d||new Set}}e.$Fc=h}),define(oe[2],ae([0,1,18,125,34,85,59]),function(te,e,D,L,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const R=!1;let S=null;class g{constructor(){this.b=new Map}static{this.a=0}c(m){let O=this.b.get(m);return O||(O={parent:null,source:null,isSingleton:!1,value:m,idx:g.a++},this.b.set(m,O)),O}trackDisposable(m){const O=this.c(m);O.source||(O.source=new Error().stack)}setParent(m,O){const F=this.c(m);F.parent=O}markAsDisposed(m){this.b.delete(m)}markAsSingleton(m){this.c(m).isSingleton=!0}f(m,O){const F=O.get(m);if(F)return F;const z=m.parent?this.f(this.c(m.parent),O):m;return O.set(m,z),z}getTrackedDisposables(){const m=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,m).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(m=10,O){let F;if(O)F=O;else{const K=new Map,x=[...this.b.values()].filter(Q=>Q.source!==null&&!this.f(Q,K).isSingleton);if(x.length===0)return;const V=new Set(x.map(Q=>Q.value));if(F=x.filter(Q=>!(Q.parent&&V.has(Q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function z(K){function x(Q,G){for(;Q.length>0&&G.some(W=>typeof W=="string"?W===Q[0]:Q[0].match(W));)Q.shift()}const V=K.source.split(`
`).map(Q=>Q.trim().replace("at ","")).filter(Q=>Q!=="");return x(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const U=new N.$Fc;for(const K of F){const x=z(K);for(let V=0;V<=x.length;V++)U.add(x.slice(0,V).join(`
`),K)}F.sort((0,D.$6b)(K=>K.idx,D.$8b));let B="",Y=0;for(const K of F.slice(0,m)){Y++;const x=z(K),V=[];for(let Q=0;Q<x.length;Q++){let G=x[Q];G=`(shared with ${U.get(x.slice(0,Q+1).join(`
`)).size}/${F.length} leaks) at ${G}`;const ee=U.get(x.slice(0,Q).join(`
`)),ie=(0,L.$J)([...ee].map(_=>z(_)[Q]),_=>_);delete ie[x[Q]];for(const[_,ne]of Object.entries(ie))V.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${_}`);V.unshift(G)}B+=`


==================== Leaking disposable ${Y}/${F.length}: ${K.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return F.length>m&&(B+=`


... and ${F.length-m} more leaking disposables

`),{leaks:F,details:B}}}e.$Gc=g;function C(l){S=l}if(e.$Hc=C,R){const l="__is_disposable_tracked__";C(new class{trackDisposable(m){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[l]||console.log(O)},3e3)}setParent(m,O){if(m&&m!==s.None)try{m[l]=!0}catch{}}markAsDisposed(m){if(m&&m!==s.None)try{m[l]=!0}catch{}}markAsSingleton(m){}})}function k(l){return S?.trackDisposable(l),l}e.$Ic=k;function b(l){S?.markAsDisposed(l)}e.$Jc=b;function c(l,m){S?.setParent(l,m)}function $(l,m){if(S)for(const O of l)S.setParent(O,m)}function y(l){return S?.markAsSingleton(l),l}e.$Kc=y;function p(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.$Lc=p;function h(l){if(I.Iterable.is(l)){const m=[];for(const O of l)if(O)try{O.dispose()}catch(F){m.push(F)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.$Mc=h;function f(l){for(const m of l)p(m)&&m.dispose();return[]}e.$Nc=f;function u(...l){const m=d(()=>h(l));return $(l,m),m}e.$Oc=u;function d(l){const m=k({dispose:(0,A.$cb)(()=>{b(m),l()})});return m}e.$Pc=d;class E{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,k(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return c(m,this),this.g?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(m),m}delete(m){if(m){if(m===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(m),m.dispose()}}deleteAndLeak(m){m&&this.f.has(m)&&(this.f.delete(m),c(m,null))}}e.$Qc=E;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new E,k(this),c(this.q,this)}dispose(){b(this),this.q.dispose()}B(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(m)}}e.$Rc=s;class o{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(m){this.b||m===this.a||(this.a?.dispose(),m&&c(m,this),this.a=m)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const m=this.a;return this.a=void 0,m&&c(m,null),m}}e.$Sc=o;class n{constructor(m){this.b=m,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=n;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(m){let O=m;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,b(this))},this}}e.$Uc=i;class t{constructor(){this.a=new Map}acquire(m,...O){let F=this.a.get(m);F||(F={counter:0,object:this.b(m,...O)},this.a.set(m,F));const{object:z}=F,U=(0,A.$cb)(()=>{--F.counter===0&&(this.c(m,F.object),this.a.delete(m))});return F.counter++,{object:z,dispose:U}}}e.$Vc=t;class r{constructor(m){this.a=m}async acquire(m,...O){const F=this.a.acquire(m,...O);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(z){throw F.dispose(),z}}}e.$Wc=r;class a{constructor(m){this.object=m}dispose(){}}e.$Xc=a;function v(l){const m=new E;try{l(m)}finally{m.dispose()}}e.$Yc=v;class w{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(m){return this.a.has(m)}get size(){return this.a.size}get(m){return this.a.get(m)}set(m,O,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(m)?.dispose(),this.a.set(m,O)}deleteAndDispose(m){this.a.get(m)?.dispose(),this.a.delete(m)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=w}),define(oe[88],ae([0,1,34]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ol=void 0;const L=new D.$Cc(1e4);function N(g){return S(g,"NFC",L)}e.$ol=N;const A=new D.$Cc(1e4);function I(g){return S(g,"NFD",A)}e.$pl=I;const R=/[^\u0000-\u0080]/;function S(g,C,k){if(!g)return g;const b=k.get(g);if(b)return b;let c;return R.test(g)?c=g.normalize(C):c=g,k.set(g,c),c}e.$ql=function(){const g=/[\u0300-\u036f]/g;return function(C){return I(C).replace(g,"")}}()}),function(){function te(N){const A=[];typeof N=="number"&&A.push("code/timeOrigin",N);function I(S){A.push(S,Date.now())}function R(){const S=[];for(let g=0;g<A.length;g+=2)S.push({name:A[g],startTime:A[g+1]});return S}return{mark:I,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(N){performance.mark(N)},getMarks(){let N=performance.timeOrigin;typeof N!="number"&&(N=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(N)}];for(const I of performance.getEntriesByType("mark"))A.push({name:I.name,startTime:Math.round(N+I.startTime)});return A}};if(typeof process=="object"){const N=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(N)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function D(N){return N.MonacoPerformanceMarks||(N.MonacoPerformanceMarks=e()),N.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=D(L))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var L in D)(typeof exports=="object"?exports:te)[L]=D[L]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function D(L){if(e[L])return e[L].exports;var N=e[L]={i:L,l:!1,exports:{}};return te[L].call(N.exports,N,N.exports,D),N.l=!0,N.exports}return D.m=te,D.c=e,D.d=function(L,N,A){D.o(L,N)||Object.defineProperty(L,N,{enumerable:!0,get:A})},D.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},D.t=function(L,N){if(1&N&&(L=D(L)),8&N||4&N&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&N&&typeof L!="string")for(var I in L)D.d(A,I,function(R){return L[R]}.bind(null,I));return A},D.n=function(L){var N=L&&L.__esModule?function(){return L.default}:function(){return L};return D.d(N,"a",N),N},D.o=function(L,N){return Object.prototype.hasOwnProperty.call(L,N)},D.p="",D(D.s=0)}([function(te,e,D){(function(L){var N;e=te.exports=Z,N=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],g=0,C=g++;S[C]="0|[1-9]\\d*";var k=g++;S[k]="[0-9]+";var b=g++;S[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var c=g++;S[c]="("+S[C]+")\\.("+S[C]+")\\.("+S[C]+")";var $=g++;S[$]="("+S[k]+")\\.("+S[k]+")\\.("+S[k]+")";var y=g++;S[y]="(?:"+S[C]+"|"+S[b]+")";var p=g++;S[p]="(?:"+S[k]+"|"+S[b]+")";var h=g++;S[h]="(?:-("+S[y]+"(?:\\."+S[y]+")*))";var f=g++;S[f]="(?:-?("+S[p]+"(?:\\."+S[p]+")*))";var u=g++;S[u]="[0-9A-Za-z-]+";var d=g++;S[d]="(?:\\+("+S[u]+"(?:\\."+S[u]+")*))";var E=g++,s="v?"+S[c]+S[h]+"?"+S[d]+"?";S[E]="^"+s+"$";var o="[v=\\s]*"+S[$]+S[f]+"?"+S[d]+"?",n=g++;S[n]="^"+o+"$";var i=g++;S[i]="((?:<|>)?=?)";var t=g++;S[t]=S[k]+"|x|X|\\*";var r=g++;S[r]=S[C]+"|x|X|\\*";var a=g++;S[a]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[h]+")?"+S[d]+"?)?)?";var v=g++;S[v]="[v=\\s]*("+S[t]+")(?:\\.("+S[t]+")(?:\\.("+S[t]+")(?:"+S[f]+")?"+S[d]+"?)?)?";var w=g++;S[w]="^"+S[i]+"\\s*"+S[a]+"$";var l=g++;S[l]="^"+S[i]+"\\s*"+S[v]+"$";var m=g++;S[m]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=g++;S[O]="(?:~>?)";var F=g++;S[F]="(\\s*)"+S[O]+"\\s+",R[F]=new RegExp(S[F],"g");var z=g++;S[z]="^"+S[O]+S[a]+"$";var U=g++;S[U]="^"+S[O]+S[v]+"$";var B=g++;S[B]="(?:\\^)";var Y=g++;S[Y]="(\\s*)"+S[B]+"\\s+",R[Y]=new RegExp(S[Y],"g");var K=g++;S[K]="^"+S[B]+S[a]+"$";var x=g++;S[x]="^"+S[B]+S[v]+"$";var V=g++;S[V]="^"+S[i]+"\\s*("+o+")$|^$";var Q=g++;S[Q]="^"+S[i]+"\\s*("+s+")$|^$";var G=g++;S[G]="(\\s*)"+S[i]+"\\s*("+o+"|"+S[a]+")",R[G]=new RegExp(S[G],"g");var W=g++;S[W]="^\\s*("+S[a]+")\\s+-\\s+("+S[a]+")\\s*$";var ee=g++;S[ee]="^\\s*("+S[v]+")\\s+-\\s+("+S[v]+")\\s*$";var ie=g++;S[ie]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)N(_,S[_]),R[_]||(R[_]=new RegExp(S[_]));function ne(le,ge){if(le instanceof Z)return le;if(typeof le!="string"||le.length>A||!(ge?R[n]:R[E]).test(le))return null;try{return new Z(le,ge)}catch{return null}}function Z(le,ge){if(le instanceof Z){if(le.loose===ge)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Z))return new Z(le,ge);N("SemVer",le,ge),this.loose=ge;var be=le.trim().match(ge?R[n]:R[E]);if(!be)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Pe=+Se;if(Pe>=0&&Pe<I)return Pe}return Se}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=ne,e.valid=function(le,ge){var be=ne(le,ge);return be?be.version:null},e.clean=function(le,ge){var be=ne(le.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(le){return N("SemVer.compare",this.version,this.loose,le),le instanceof Z||(le=new Z(le,this.loose)),this.compareMain(le)||this.comparePre(le)},Z.prototype.compareMain=function(le){return le instanceof Z||(le=new Z(le,this.loose)),P(this.major,le.major)||P(this.minor,le.minor)||P(this.patch,le.patch)},Z.prototype.comparePre=function(le){if(le instanceof Z||(le=new Z(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],Se=le.prerelease[ge];if(N("prerelease compare",ge,be,Se),be===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(be===void 0)return-1;if(be!==Se)return P(be,Se)}while(++ge)},Z.prototype.inc=function(le,ge){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,ge,be,Se){typeof be=="string"&&(Se=be,be=void 0);try{return new Z(le,be).inc(ge,Se).version}catch{return null}},e.diff=function(le,ge){if(H(le,ge))return null;var be=ne(le),Se=ne(ge);if(be.prerelease.length||Se.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return Pe},e.compareIdentifiers=P;var q=/^[0-9]+$/;function P(le,ge){var be=q.test(le),Se=q.test(ge);return be&&Se&&(le=+le,ge=+ge),be&&!Se?-1:Se&&!be?1:le<ge?-1:le>ge?1:0}function j(le,ge,be){return new Z(le,be).compare(new Z(ge,be))}function T(le,ge,be){return j(le,ge,be)>0}function M(le,ge,be){return j(le,ge,be)<0}function H(le,ge,be){return j(le,ge,be)===0}function J(le,ge,be){return j(le,ge,be)!==0}function re(le,ge,be){return j(le,ge,be)>=0}function ce(le,ge,be){return j(le,ge,be)<=0}function ue(le,ge,be,Se){var Pe;switch(ge){case"===":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Pe=le===be;break;case"!==":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Pe=le!==be;break;case"":case"=":case"==":Pe=H(le,be,Se);break;case"!=":Pe=J(le,be,Se);break;case">":Pe=T(le,be,Se);break;case">=":Pe=re(le,be,Se);break;case"<":Pe=M(le,be,Se);break;case"<=":Pe=ce(le,be,Se);break;default:throw new TypeError("Invalid operator: "+ge)}return Pe}function he(le,ge){if(le instanceof he){if(le.loose===ge)return le;le=le.value}if(!(this instanceof he))return new he(le,ge);N("comparator",le,ge),this.loose=ge,this.parse(le),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,N("comp",this)}e.rcompareIdentifiers=function(le,ge){return P(ge,le)},e.major=function(le,ge){return new Z(le,ge).major},e.minor=function(le,ge){return new Z(le,ge).minor},e.patch=function(le,ge){return new Z(le,ge).patch},e.compare=j,e.compareLoose=function(le,ge){return j(le,ge,!0)},e.rcompare=function(le,ge,be){return j(ge,le,be)},e.sort=function(le,ge){return le.sort(function(be,Se){return e.compare(be,Se,ge)})},e.rsort=function(le,ge){return le.sort(function(be,Se){return e.rcompare(be,Se,ge)})},e.gt=T,e.lt=M,e.eq=H,e.neq=J,e.gte=re,e.lte=ce,e.cmp=ue,e.Comparator=he;var $e={};function de(le,ge){if(le instanceof de)return le.loose===ge?le:new de(le.raw,ge);if(le instanceof he)return new de(le.value,ge);if(!(this instanceof de))return new de(le,ge);if(this.loose=ge,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function we(le){return!le||le.toLowerCase()==="x"||le==="*"}function ve(le,ge,be,Se,Pe,ze,je,Ue,Me,se,fe,me,ye){return((ge=we(be)?"":we(Se)?">="+be+".0.0":we(Pe)?">="+be+"."+Se+".0":">="+ge)+" "+(Ue=we(Me)?"":we(se)?"<"+(+Me+1)+".0.0":we(fe)?"<"+Me+"."+(+se+1)+".0":me?"<="+Me+"."+se+"."+fe+"-"+me:"<="+Ue)).trim()}function Ie(le,ge){for(var be=0;be<le.length;be++)if(!le[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<le.length;be++)if(N(le[be].semver),le[be].semver!==$e&&le[be].semver.prerelease.length>0){var Se=le[be].semver;if(Se.major===ge.major&&Se.minor===ge.minor&&Se.patch===ge.patch)return!0}return!1}return!0}function Le(le,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(le)}function Te(le,ge,be,Se){var Pe,ze,je,Ue,Me;switch(le=new Z(le,Se),ge=new de(ge,Se),be){case">":Pe=T,ze=ce,je=M,Ue=">",Me=">=";break;case"<":Pe=M,ze=re,je=T,Ue="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(le,ge,Se))return!1;for(var se=0;se<ge.set.length;++se){var fe=ge.set[se],me=null,ye=null;if(fe.forEach(function(ke){ke.semver===$e&&(ke=new he(">=0.0.0")),me=me||ke,ye=ye||ke,Pe(ke.semver,me.semver,Se)?me=ke:je(ke.semver,ye.semver,Se)&&(ye=ke)}),me.operator===Ue||me.operator===Me||(!ye.operator||ye.operator===Ue)&&ze(le,ye.semver)||ye.operator===Me&&je(le,ye.semver))return!1}return!0}he.prototype.parse=function(le){var ge=this.loose?R[V]:R[Q],be=le.match(ge);if(!be)throw new TypeError("Invalid comparator: "+le);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new Z(be[2],this.loose):this.semver=$e},he.prototype.toString=function(){return this.value},he.prototype.test=function(le){return N("Comparator.test",le,this.loose),this.semver===$e||(typeof le=="string"&&(le=new Z(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},he.prototype.intersects=function(le,ge){if(!(le instanceof he))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(le.value,ge),Le(this.value,be,ge);if(le.operator==="")return be=new de(this.value,ge),Le(le.semver,be,ge);var Se=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),ze=this.semver.version===le.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),Ue=ue(this.semver,"<",le.semver,ge)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Me=ue(this.semver,">",le.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Se||Pe||ze&&je||Ue||Me},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(le){var ge=this.loose;le=le.trim(),N("range",le,ge);var be=ge?R[ee]:R[W];le=le.replace(be,ve),N("hyphen replace",le),le=le.replace(R[G],"$1$2$3"),N("comparator trim",le,R[G]),le=(le=(le=le.replace(R[F],"$1~")).replace(R[Y],"$1^")).split(/\s+/).join(" ");var Se=ge?R[V]:R[Q],Pe=le.split(" ").map(function(ze){return function(je,Ue){return N("comp",je),je=function(Me,se){return Me.trim().split(/\s+/).map(function(fe){return function(me,ye){N("caret",me,ye);var ke=ye?R[x]:R[K];return me.replace(ke,function(Re,Ce,De,Oe,Ae){var Fe;return N("caret",me,Re,Ce,De,Oe,Ae),we(Ce)?Fe="":we(De)?Fe=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Oe)?Fe=Ce==="0"?">="+Ce+"."+De+".0 <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+".0 <"+(+Ce+1)+".0.0":Ae?(N("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=Ce==="0"?De==="0"?">="+Ce+"."+De+"."+Oe+Ae+" <"+Ce+"."+De+"."+(+Oe+1):">="+Ce+"."+De+"."+Oe+Ae+" <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+"."+Oe+Ae+" <"+(+Ce+1)+".0.0"):(N("no pr"),Fe=Ce==="0"?De==="0"?">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+De+"."+(+Oe+1):">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+(+De+1)+".0":">="+Ce+"."+De+"."+Oe+" <"+(+Ce+1)+".0.0"),N("caret return",Fe),Fe})}(fe,se)}).join(" ")}(je,Ue),N("caret",je),je=function(Me,se){return Me.trim().split(/\s+/).map(function(fe){return function(me,ye){var ke=ye?R[U]:R[z];return me.replace(ke,function(Re,Ce,De,Oe,Ae){var Fe;return N("tilde",me,Re,Ce,De,Oe,Ae),we(Ce)?Fe="":we(De)?Fe=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Oe)?Fe=">="+Ce+"."+De+".0 <"+Ce+"."+(+De+1)+".0":Ae?(N("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=">="+Ce+"."+De+"."+Oe+Ae+" <"+Ce+"."+(+De+1)+".0"):Fe=">="+Ce+"."+De+"."+Oe+" <"+Ce+"."+(+De+1)+".0",N("tilde return",Fe),Fe})}(fe,se)}).join(" ")}(je,Ue),N("tildes",je),je=function(Me,se){return N("replaceXRanges",Me,se),Me.split(/\s+/).map(function(fe){return function(me,ye){me=me.trim();var ke=ye?R[l]:R[w];return me.replace(ke,function(Re,Ce,De,Oe,Ae,Fe){N("xRange",me,Re,Ce,De,Oe,Ae,Fe);var Be=we(De),qe=Be||we(Oe),Ve=qe||we(Ae);return Ce==="="&&Ve&&(Ce=""),Be?Re=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Ve?(qe&&(Oe=0),Ve&&(Ae=0),Ce===">"?(Ce=">=",qe?(De=+De+1,Oe=0,Ae=0):Ve&&(Oe=+Oe+1,Ae=0)):Ce==="<="&&(Ce="<",qe?De=+De+1:Oe=+Oe+1),Re=Ce+De+"."+Oe+"."+Ae):qe?Re=">="+De+".0.0 <"+(+De+1)+".0.0":Ve&&(Re=">="+De+"."+Oe+".0 <"+De+"."+(+Oe+1)+".0"),N("xRange return",Re),Re})}(fe,se)}).join(" ")}(je,Ue),N("xrange",je),je=function(Me,se){return N("replaceStars",Me,se),Me.trim().replace(R[ie],"")}(je,Ue),N("stars",je),je}(ze,ge)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(ze){return!!ze.match(Se)})),Pe=Pe.map(function(ze){return new he(ze,ge)})},de.prototype.intersects=function(le,ge){if(!(le instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Se){return le.set.some(function(Pe){return Pe.every(function(ze){return Se.intersects(ze,ge)})})})})},e.toComparators=function(le,ge){return new de(le,ge).set.map(function(be){return be.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},de.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new Z(le,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Ie(this.set[ge],le))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(le,ge,be){var Se=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return le.forEach(function(je){ze.test(je)&&(Se&&Pe.compare(je)!==-1||(Pe=new Z(Se=je,be)))}),Se},e.minSatisfying=function(le,ge,be){var Se=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return le.forEach(function(je){ze.test(je)&&(Se&&Pe.compare(je)!==1||(Pe=new Z(Se=je,be)))}),Se},e.validRange=function(le,ge){try{return new de(le,ge).range||"*"}catch{return null}},e.ltr=function(le,ge,be){return Te(le,ge,"<",be)},e.gtr=function(le,ge,be){return Te(le,ge,">",be)},e.outside=Te,e.prerelease=function(le,ge){var be=ne(le,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(le,ge,be){return le=new de(le,be),ge=new de(ge,be),le.intersects(ge)},e.coerce=function(le){if(le instanceof Z)return le;if(typeof le!="string")return null;var ge=le.match(R[m]);return ge==null?null:ne((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,D(1))},function(te,e){var D,L,N=te.exports={};function A(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function R(p){if(D===setTimeout)return setTimeout(p,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(p,0);try{return D(p,0)}catch{try{return D.call(null,p,0)}catch{return D.call(this,p,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{L=typeof clearTimeout=="function"?clearTimeout:I}catch{L=I}})();var S,g=[],C=!1,k=-1;function b(){C&&S&&(C=!1,S.length?g=S.concat(g):k=-1,g.length&&c())}function c(){if(!C){var p=R(b);C=!0;for(var h=g.length;h;){for(S=g,g=[];++k<h;)S&&S[k].run();k=-1,h=g.length}S=null,C=!1,function(f){if(L===clearTimeout)return clearTimeout(f);if((L===I||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(f);try{L(f)}catch{try{return L.call(null,f)}catch{return L.call(this,f)}}}(p)}}function $(p,h){this.fun=p,this.array=h}function y(){}N.nextTick=function(p){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];g.push(new $(p,h)),g.length!==1||C||R(c)},$.prototype.run=function(){this.fun.apply(null,this.array)},N.title="browser",N.browser=!0,N.env={},N.argv=[],N.version="",N.versions={},N.on=y,N.addListener=y,N.once=y,N.off=y,N.removeListener=y,N.removeAllListeners=y,N.emit=y,N.prependListener=y,N.prependOnceListener=y,N.listeners=function(p){return[]},N.binding=function(p){throw new Error("process.binding is not supported")},N.cwd=function(){return"/"},N.chdir=function(p){throw new Error("process.chdir is not supported")},N.umask=function(){return 0}}])}),define(oe[127],ae([0,1]),function(te,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;class L{constructor(R,S,g){this.level=R,this.key=S,this.value=g,this.forward=[]}}const N=void 0;class A{constructor(R,S=2**16){this.comparator=R,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new L(this.c,N,N)}get size(){return this.f}clear(){this.e=new L(this.c,N,N),this.f=0}has(R){return!!A.g(this,R,this.comparator)}get(R){return A.g(this,R,this.comparator)?.value}set(R,S){return A.h(this,R,S,this.comparator)&&(this.f+=1),this}delete(R){const S=A.k(this,R,this.comparator);return S&&(this.f-=1),S}forEach(R,S){let g=this.e.forward[0];for(;g;)R.call(S,g.value,g.key,this),g=g.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",S=this.e.forward[0];for(;S;)R+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return R}static g(R,S,g){let C=R.e;for(let k=R.d-1;k>=0;k--)for(;C.forward[k]&&g(C.forward[k].key,S)<0;)C=C.forward[k];if(C=C.forward[0],C&&g(C.key,S)===0)return C}static h(R,S,g,C){const k=[];let b=R.e;for(let c=R.d-1;c>=0;c--){for(;b.forward[c]&&C(b.forward[c].key,S)<0;)b=b.forward[c];k[c]=b}if(b=b.forward[0],b&&C(b.key,S)===0)return b.value=g,!1;{const c=A.j(R);if(c>R.d){for(let $=R.d;$<c;$++)k[$]=R.e;R.d=c}b=new L(c,S,g);for(let $=0;$<c;$++)b.forward[$]=k[$].forward[$],k[$].forward[$]=b;return!0}}static j(R,S=.5){let g=1;for(;Math.random()<S&&g<R.c;)g+=1;return g}static k(R,S,g){const C=[];let k=R.e;for(let b=R.d-1;b>=0;b--){for(;k.forward[b]&&g(k.forward[b].key,S)<0;)k=k.forward[b];C[b]=k}if(k=k.forward[0],!k||g(k.key,S)!==0)return!1;for(let b=0;b<R.d&&C[b].forward[b]===k;b++)C[b].forward[b]=k.forward[b];for(;R.d>0&&R.e.forward[R.d-1]===N;)R.d-=1;return!0}}e.$Br=A}),define(oe[61],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(A){return new L(A)}constructor(A){this.c=D&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Jd=L}),define(oe[3],ae([0,1,7,85,2,87,61]),function(te,e,D,L,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.Event=void 0;const R=!1,S=!1;var g;(function(w){w.None=()=>N.$Rc.None;function l(ue){if(S){const{onDidAddListener:he}=ue,$e=$.create();let de=0;ue.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),he?.()}}}function m(ue,he){return Q(ue,()=>{},0,void 0,!0,void 0,he)}w.defer=m;function O(ue){return(he,$e=null,de)=>{let we=!1,ve;return ve=ue(Ie=>{if(!we)return ve?ve.dispose():we=!0,he.call($e,Ie)},null,de),we&&ve.dispose(),ve}}w.once=O;function F(ue,he,$e){return x((de,we=null,ve)=>ue(Ie=>de.call(we,he(Ie)),null,ve),$e)}w.map=F;function z(ue,he,$e){return x((de,we=null,ve)=>ue(Ie=>{he(Ie),de.call(we,Ie)},null,ve),$e)}w.forEach=z;function U(ue,he,$e){return x((de,we=null,ve)=>ue(Ie=>he(Ie)&&de.call(we,Ie),null,ve),$e)}w.filter=U;function B(ue){return ue}w.signal=B;function Y(...ue){return(he,$e=null,de)=>{const we=(0,N.$Oc)(...ue.map(ve=>ve(Ie=>he.call($e,Ie))));return V(we,de)}}w.any=Y;function K(ue,he,$e,de){let we=$e;return F(ue,ve=>(we=he(we,ve),we),de)}w.reduce=K;function x(ue,he){let $e;const de={onWillAddFirstListener(){$e=ue(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};he||l(de);const we=new u(de);return he?.add(we),we.event}function V(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function Q(ue,he,$e=100,de=!1,we=!1,ve,Ie){let Le,Te,le,ge=0,be;const Se={leakWarningThreshold:ve,onWillAddFirstListener(){Le=ue(ze=>{ge++,Te=he(Te,ze),de&&!le&&(Pe.fire(Te),Te=void 0),be=()=>{const je=Te;Te=void 0,le=void 0,(!de||ge>1)&&Pe.fire(je),ge=0},typeof $e=="number"?(clearTimeout(le),le=setTimeout(be,$e)):le===void 0&&(le=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,Le.dispose()}};Ie||l(Se);const Pe=new u(Se);return Ie?.add(Pe),Pe.event}w.debounce=Q;function G(ue,he=0,$e){return w.debounce(ue,(de,we)=>de?(de.push(we),de):[we],he,void 0,!0,void 0,$e)}w.accumulate=G;function W(ue,he=(de,we)=>de===we,$e){let de=!0,we;return U(ue,ve=>{const Ie=de||!he(ve,we);return de=!1,we=ve,Ie},$e)}w.latch=W;function ee(ue,he,$e){return[w.filter(ue,he,$e),w.filter(ue,de=>!he(de),$e)]}w.split=ee;function ie(ue,he=!1,$e=[],de){let we=$e.slice(),ve=ue(Te=>{we?we.push(Te):Le.fire(Te)});de&&de.add(ve);const Ie=()=>{we?.forEach(Te=>Le.fire(Te)),we=null},Le=new u({onWillAddFirstListener(){ve||(ve=ue(Te=>Le.fire(Te)),de&&de.add(ve))},onDidAddFirstListener(){we&&(he?setTimeout(Ie):Ie())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return de&&de.add(Le),Le.event}w.buffer=ie;function _(ue,he){return(de,we,ve)=>{const Ie=he(new Z);return ue(function(Le){const Te=Ie.evaluate(Le);Te!==ne&&de.call(we,Te)},void 0,ve)}}w.chain=_;const ne=Symbol("HaltChainable");class Z{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push($e=>(he($e),$e)),this}filter(he){return this.f.push($e=>he($e)?$e:ne),this}reduce(he,$e){let de=$e;return this.f.push(we=>(de=he(de,we),de)),this}latch(he=($e,de)=>$e===de){let $e=!0,de;return this.f.push(we=>{const ve=$e||!he(we,de);return $e=!1,de=we,ve?we:ne}),this}evaluate(he){for(const $e of this.f)if(he=$e(he),he===ne)break;return he}}function q(ue,he,$e=de=>de){const de=(...Le)=>Ie.fire($e(...Le)),we=()=>ue.on(he,de),ve=()=>ue.removeListener(he,de),Ie=new u({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}w.fromNodeEventEmitter=q;function P(ue,he,$e=de=>de){const de=(...Le)=>Ie.fire($e(...Le)),we=()=>ue.addEventListener(he,de),ve=()=>ue.removeEventListener(he,de),Ie=new u({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}w.fromDOMEventEmitter=P;function j(ue){return new Promise(he=>O(ue)(he))}w.toPromise=j;function T(ue){const he=new u;return ue.then($e=>{he.fire($e)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}w.fromPromise=T;function M(ue,he,$e){return he($e),ue(de=>he(de))}w.runAndSubscribe=M;function H(ue,he){let $e=null;function de(ve){$e?.dispose(),$e=new N.$Qc,he(ve,$e)}de(void 0);const we=ue(ve=>de(ve));return(0,N.$Pc)(()=>{we.dispose(),$e?.dispose()})}w.runAndSubscribeWithStore=H;class J{constructor(he,$e){this._observable=he,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};$e||l(de),this.emitter=new u(de),$e&&$e.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,$e){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function re(ue,he){return new J(ue,he).emitter.event}w.fromObservable=re;function ce(ue){return he=>{let $e=0,de=!1;const we={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(ue.reportChanges(),de&&(de=!1,he()))},handlePossibleChange(){},handleChange(){de=!0}};return ue.addObserver(we),ue.reportChanges(),{dispose(){ue.removeObserver(we)}}}}w.fromObservableLight=ce})(g||(e.Event=g={}));class C{static{this.all=new Set}static{this.f=0}constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${C.f++}`,C.all.add(this)}start(l){this.g=new I.$Jd,this.listenerCount=l}stop(){if(this.g){const l=this.g.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this.g=void 0}}}e.$Ld=C;let k=-1;function b(w){const l=k;return k=w,{dispose(){k=l}}}e.$Md=b;class c{constructor(l,m=Math.random().toString(18).slice(2,5)){this.threshold=l,this.name=m,this.g=0}dispose(){this.f?.clear()}check(l,m){const O=this.threshold;if(O<=0||m<O)return;this.f||(this.f=new Map);const F=this.f.get(l.value)||0;if(this.f.set(l.value,F+1),this.g-=1,this.g<=0){this.g=O*.5;let z,U=0;for(const[B,Y]of this.f)(!z||U<Y)&&(z=B,U=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${U}):`),console.warn(z)}return()=>{const z=this.f.get(l.value)||0;this.f.set(l.value,z-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class p{constructor(l){this.value=l,this.id=y++}}const h=2,f=(w,l)=>{if(w instanceof p)l(w);else for(let m=0;m<w.length;m++){const O=w[m];O&&l(O)}};class u{constructor(l){this.w=0,this.f=l,this.g=k>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const l=this.t;queueMicrotask(()=>{f(l,m=>m.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(l,m,O)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),N.$Rc.None;if(this.m)return N.$Rc.None;m&&(l=l.bind(m));const F=new p(l);let z,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=$.create(),z=this.g.check(F.stack,this.w+1)),R&&(F.stack=U??$.create()),this.t?this.t instanceof p?(this.u??=new E,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const B=(0,N.$Pc)(()=>{z?.(),this.x(F)});return O instanceof N.$Qc?O.add(B):Array.isArray(O)&&O.push(B),B},this.q}x(l){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const m=this.t,O=m.indexOf(l);if(O===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,m[O]=void 0;const F=this.u.current===this;if(this.w*h<=m.length){let z=0;for(let U=0;U<m.length;U++)m[U]?m[z++]=m[U]:F&&(this.u.end--,z<this.u.i&&this.u.i--);m.length=z}}y(l,m){if(!l)return;const O=this.f?.onListenerError||D.$Z;if(!O){l.value(m);return}try{l.value(m)}catch(F){O(F)}}z(l){const m=l.current.t;for(;l.i<l.end;)this.y(m[l.i++],l.value);l.reset()}fire(l){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof p)this.y(this.t,l);else{const m=this.u;m.enqueue(this,l,this.t.length),this.z(m)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Nd=u;const d=()=>new E;e.$Od=d;class E{constructor(){this.i=-1,this.end=0}enqueue(l,m,O){this.i=0,this.end=O,this.current=l,this.value=m}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends u{async fireAsync(l,m,O){if(this.t)for(this.h||(this.h=new A.$1c),f(this.t,F=>this.h.push([F.value,l]));this.h.size>0&&!m.isCancellationRequested;){const[F,z]=this.h.shift(),U=[],B={...z,token:m,waitUntil:Y=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");O&&(Y=O(Y,F)),U.push(Y)}};try{F(B)}catch(Y){(0,D.$Z)(Y);continue}Object.freeze(U),await Promise.allSettled(U).then(Y=>{for(const K of Y)K.status==="rejected"&&(0,D.$Z)(K.reason)})}}}e.$Pd=s;class o extends u{get isPaused(){return this.h!==0}constructor(l){super(l),this.h=0,this.s=new A.$1c,this.A=l?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const l=Array.from(this.s);this.s.clear(),super.fire(this.A(l))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(l){this.w&&(this.h!==0?this.s.push(l):super.fire(l))}}e.$Qd=o;class n extends o{constructor(l){super(l),this.k=l.delay??100}fire(l){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(l)}}e.$Rd=n;class i extends u{constructor(l){super(l),this.h=[],this.k=l?.merge}fire(l){this.hasListeners()&&(this.h.push(l),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(m=>super.fire(m)),this.h=[]}))}}e.$Sd=i;class t{constructor(){this.g=!1,this.h=[],this.f=new u({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(l){const m={event:l,listener:null};this.h.push(m),this.g&&this.m(m);const O=()=>{this.g&&this.o(m);const F=this.h.indexOf(m);this.h.splice(F,1)};return(0,N.$Pc)((0,L.$cb)(O))}j(){this.g=!0,this.h.forEach(l=>this.m(l))}k(){this.g=!1,this.h.forEach(l=>this.o(l))}m(l){l.listener=l.event(m=>this.f.fire(m))}o(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.f.dispose()}}e.$Td=t;class r{constructor(l,m,O,F){this.f=new N.$Qc;const z=this.f.add(new t),U=this.f.add(new N.$Zc);function B(Y){U.set(Y,z.add(F(Y)))}for(const Y of l)B(Y);this.f.add(m(Y=>{B(Y)})),this.f.add(O(Y=>{U.deleteAndDispose(Y)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Ud=r;class a{constructor(){this.f=[]}wrapEvent(l){return(m,O,F)=>l(z=>{const U=this.f[this.f.length-1];U?U.push(()=>m.call(O,z)):m.call(O,z)},void 0,F)}bufferEvents(l){const m=[];this.f.push(m);const O=l();return this.f.pop(),m.forEach(F=>F()),O}}e.$Vd=a;class v{constructor(){this.f=!1,this.g=g.None,this.h=N.$Rc.None,this.j=new u({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(l){this.g=l,this.f&&(this.h.dispose(),this.h=l(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Wd=v}),define(oe[26],ae([0,1,3]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.CancellationToken=void 0;const L=Object.freeze(function(R,S){const g=setTimeout(R.bind(S),0);return{dispose(){clearTimeout(g)}}});var N;(function(R){function S(g){return g===R.None||g===R.Cancelled||g instanceof A?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}R.isCancellationToken=S,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(N||(e.CancellationToken=N={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new D.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=N.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=N.None}}e.$Xd=I}),define(oe[128],ae([0,1,26]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=void 0;class L{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new D.$Xd,S=this.b(R.token);return this.a={promise:S,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$we=L;class N{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const S=JSON.stringify(R);return this.b!==S&&(this.b=S,this.a=this.c(R)),this.a}}e.$xe=N;class A{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const S=this.b(R);return this.a.set(R,S),S}}e.$ye=A}),define(oe[46],ae([0,1,7,2]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function N(d){const E=d;return E?typeof E.read=="function":!1}e.$Yd=N;function A(d){const E=d;return E?[E.on,E.pause,E.resume,E.destroy].every(s=>typeof s=="function"):!1}e.$Zd=A;function I(d){const E=d;return E?A(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$1d=I;function R(d,E){return new S(d,E)}e.$2d=R;class S{constructor(E,s){this.e=E,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(s=>s(E))}h(E){this.c.error.length===0?(0,D.$Z)(E):this.c.error.slice(0).forEach(s=>s(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,s){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(E,s){if(this.a.destroyed)return;let o;switch(E){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(s);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(d,E){const s=[];let o;for(;(o=d.read())!==null;)s.push(o);return E(s)}e.$3d=g;function C(d,E,s){const o=[];let n;for(;(n=d.read())!==null&&o.length<s;)o.push(n);return n===null&&o.length>0?E(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return d.read()}}}e.$4d=C;function k(d,E){return new Promise((s,o)=>{const n=[];b(d,{onData:i=>{E&&n.push(i)},onError:i=>{E?o(i):s(void 0)},onEnd:()=>{s(E?E(n):void 0)}})})}e.$5d=k;function b(d,E,s){d.on("error",o=>{s?.isCancellationRequested||E.onError(o)}),d.on("end",()=>{s?.isCancellationRequested||E.onEnd()}),d.on("data",o=>{s?.isCancellationRequested||E.onData(o)})}e.$6d=b;function c(d,E){return new Promise((s,o)=>{const n=new L.$Qc,i=[],t=v=>{if(i.push(v),i.length>E)return n.dispose(),d.pause(),s({stream:d,buffer:i,ended:!1})},r=v=>(n.dispose(),o(v)),a=()=>(n.dispose(),s({stream:d,buffer:i,ended:!0}));n.add((0,L.$Pc)(()=>d.removeListener("error",r))),d.on("error",r),n.add((0,L.$Pc)(()=>d.removeListener("end",a))),d.on("end",a),n.add((0,L.$Pc)(()=>d.removeListener("data",t))),d.on("data",t)})}e.$7d=c;function $(d,E){const s=R(E);return s.end(d),s}e.$8d=$;function y(){const d=R(()=>{throw new Error("not supported")});return d.end(),d}e.$9d=y;function p(d){let E=!1;return{read:()=>E?null:(E=!0,d)}}e.$0d=p;function h(d,E,s){const o=R(s);return b(d,{onData:n=>o.write(E.data(n)),onError:n=>o.error(E.error?E.error(n):n),onEnd:()=>o.end()}),o}e.$$d=h;function f(d,E,s){let o=!1;return{read:()=>{const n=E.read();return o?n:(o=!0,n!==null?s([d,n]):d)}}}e.$_d=f;function u(d,E,s){let o=!1;const n=R(s);return b(E,{onData:i=>o?n.write(i):(o=!0,n.write(s([d,i]))),onError:i=>n.error(i),onEnd:()=>{o||(o=!0,n.write(d)),n.end()}}),n}e.$ae=u}),define(oe[15],ae([0,1,60,46]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const N=typeof Buffer<"u",A=new D.$U(()=>new Uint8Array(256));let I,R;class S{static alloc(m){return N?new S(Buffer.allocUnsafe(m)):new S(new Uint8Array(m))}static wrap(m){return N&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new S(m)}static fromString(m,O){return!(O?.dontUseNodeBuffer||!1)&&N?new S(Buffer.from(m)):(I||(I=new TextEncoder),new S(I.encode(m)))}static fromByteArray(m){const O=S.alloc(m.length);for(let F=0,z=m.length;F<z;F++)O.buffer[F]=m[F];return O}static concat(m,O){if(typeof O>"u"){O=0;for(let U=0,B=m.length;U<B;U++)O+=m[U].byteLength}const F=S.alloc(O);let z=0;for(let U=0,B=m.length;U<B;U++){const Y=m[U];F.set(Y,z),z+=Y.byteLength}return F}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=S.alloc(this.byteLength);return m.set(this),m}toString(){return N?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(m,O){return new S(this.buffer.subarray(m,O))}set(m,O){if(m instanceof S)this.buffer.set(m.buffer,O);else if(m instanceof Uint8Array)this.buffer.set(m,O);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),O);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return b(this.buffer,m)}writeUInt32BE(m,O){c(this.buffer,m,O)}readUInt32LE(m){return $(this.buffer,m)}writeUInt32LE(m,O){y(this.buffer,m,O)}readUInt8(m){return p(this.buffer,m)}writeUInt8(m,O){h(this.buffer,m,O)}indexOf(m,O=0){return g(this.buffer,m instanceof S?m.buffer:m,O)}}e.$be=S;function g(l,m,O=0){const F=m.byteLength,z=l.byteLength;if(F===0)return 0;if(F===1)return l.indexOf(m[0]);if(F>z-O)return-1;const U=A.value;U.fill(m.length);for(let x=0;x<m.length;x++)U[m[x]]=m.length-x-1;let B=O+m.length-1,Y=B,K=-1;for(;B<z;)if(l[B]===m[Y]){if(Y===0){K=B;break}B--,Y--}else B+=Math.max(m.length-Y,U[l[B]]),Y=m.length-1;return K}e.$ce=g;function C(l,m){return l[m+0]<<0>>>0|l[m+1]<<8>>>0}e.$de=C;function k(l,m,O){l[O+0]=m&255,m=m>>>8,l[O+1]=m&255}e.$ee=k;function b(l,m){return l[m]*2**24+l[m+1]*2**16+l[m+2]*2**8+l[m+3]}e.$fe=b;function c(l,m,O){l[O+3]=m,m=m>>>8,l[O+2]=m,m=m>>>8,l[O+1]=m,m=m>>>8,l[O]=m}e.$ge=c;function $(l,m){return l[m+0]<<0>>>0|l[m+1]<<8>>>0|l[m+2]<<16>>>0|l[m+3]<<24>>>0}e.$he=$;function y(l,m,O){l[O+0]=m&255,m=m>>>8,l[O+1]=m&255,m=m>>>8,l[O+2]=m&255,m=m>>>8,l[O+3]=m&255}e.$ie=y;function p(l,m){return l[m]}e.$je=p;function h(l,m,O){l[O]=m}e.$ke=h;function f(l){return L.$3d(l,m=>S.concat(m))}e.$le=f;function u(l){return L.$0d(l)}e.$me=u;function d(l){return L.$5d(l,m=>S.concat(m))}e.$ne=d;async function E(l){return l.ended?S.concat(l.buffer):S.concat([...l.buffer,await d(l.stream)])}e.$oe=E;function s(l){return L.$8d(l,m=>S.concat(m))}e.$pe=s;function o(l){return L.$$d(l,{data:m=>typeof m=="string"?S.fromString(m):S.wrap(m)},m=>S.concat(m))}e.$qe=o;function n(l){return L.$2d(m=>S.concat(m),l)}e.$re=n;function i(l,m){return L.$_d(l,m,O=>S.concat(O))}e.$se=i;function t(l,m){return L.$ae(l,m,O=>S.concat(O))}e.$te=t;function r(l){let m=0,O=0,F=0;const z=new Uint8Array(Math.floor(l.length/4*3)),U=Y=>{switch(O){case 3:z[F++]=m|Y,O=0;break;case 2:z[F++]=m|Y>>>2,m=Y<<6,O=3;break;case 1:z[F++]=m|Y>>>4,m=Y<<4,O=2;break;default:m=Y<<2,O=1}};for(let Y=0;Y<l.length;Y++){const K=l.charCodeAt(Y);if(K>=65&&K<=90)U(K-65);else if(K>=97&&K<=122)U(K-97+26);else if(K>=48&&K<=57)U(K-48+52);else if(K===43||K===45)U(62);else if(K===47||K===95)U(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${l[Y]}`)}}const B=F;for(;O>0;)U(0);return S.wrap(z).slice(0,B)}e.$ue=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:l},m=!0,O=!1){const F=O?v:a;let z="";const U=l.byteLength%3;let B=0;for(;B<l.byteLength-U;B+=3){const Y=l[B+0],K=l[B+1],x=l[B+2];z+=F[Y>>>2],z+=F[(Y<<4|K>>>4)&63],z+=F[(K<<2|x>>>6)&63],z+=F[x&63]}if(U===1){const Y=l[B+0];z+=F[Y>>>2],z+=F[Y<<4&63],m&&(z+="==")}else if(U===2){const Y=l[B+0],K=l[B+1];z+=F[Y>>>2],z+=F[(Y<<4|K>>>4)&63],z+=F[K<<2&63],m&&(z+="=")}return z}e.$ve=w}),define(oe[27],ae([0,1,128,60]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xf=e.$wf=e.$vf=e.$uf=e.GraphemeBreakType=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=void 0;function N(se){return!se||typeof se!="string"?!0:se.trim().length===0}e.$Be=N;const A=/{(\d+)}/g;function I(se,...fe){return fe.length===0?se:se.replace(A,function(me,ye){const ke=parseInt(ye,10);return isNaN(ke)||ke<0||ke>=fe.length?me:fe[ke]})}e.$Ce=I;const R=/{([^}]+)}/g;function S(se,fe){return Object.keys(fe).length===0?se:se.replace(R,(me,ye)=>fe[ye]??me)}e.$De=S;function g(se){return se.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Ee=g;function C(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Fe=C;function k(se,fe){let me=0;const ye=fe.charCodeAt(0);for(let ke=se.length-1;ke>=0;ke--)se.charCodeAt(ke)===ye&&me++;return me}e.$Ge=k;function b(se,fe,me="\u2026"){return se.length<=fe?se:`${se.substr(0,fe)}${me}`}e.$He=b;function c(se,fe=" "){const me=$(se,fe);return y(me,fe)}e.$Ie=c;function $(se,fe){if(!se||!fe)return se;const me=fe.length;if(me===0||se.length===0)return se;let ye=0;for(;se.indexOf(fe,ye)===ye;)ye=ye+me;return se.substring(ye)}e.$Je=$;function y(se,fe){if(!se||!fe)return se;const me=fe.length,ye=se.length;if(me===0||ye===0)return se;let ke=ye,Re=-1;for(;Re=se.lastIndexOf(fe,ke-1),!(Re===-1||Re+me!==ke);){if(Re===0)return"";ke=Re}return se.substring(0,ke)}e.$Ke=y;function p(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Le=p;function h(se){return se.replace(/\*/g,"")}e.$Me=h;function f(se,fe,me={}){if(!se)throw new Error("Cannot create regex from empty string");fe||(se=C(se)),me.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ye="";return me.global&&(ye+="g"),me.matchCase||(ye+="i"),me.multiline&&(ye+="m"),me.unicode&&(ye+="u"),new RegExp(se,ye)}e.$Ne=f;function u(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}e.$Oe=u;function d(se){return se.split(/\r\n|\r|\n/)}e.$Pe=d;function E(se){for(let fe=0,me=se.length;fe<me;fe++){const ye=se.charCodeAt(fe);if(ye!==32&&ye!==9)return fe}return-1}e.$Qe=E;function s(se,fe=0,me=se.length){for(let ye=fe;ye<me;ye++){const ke=se.charCodeAt(ye);if(ke!==32&&ke!==9)return se.substring(fe,ye)}return se.substring(fe,me)}e.$Re=s;function o(se,fe=se.length-1){for(let me=fe;me>=0;me--){const ye=se.charCodeAt(me);if(ye!==32&&ye!==9)return me}return-1}e.$Se=o;function n(se,fe,me){const ye=[];let ke=0;for(const Re of se.matchAll(fe)){if(ye.push(se.slice(ke,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ke=Re.index+Re[0].length,ye.push(me(Re[0],...Re.slice(1),Re.index,se,Re.groups))}return ye.push(se.slice(ke)),Promise.all(ye).then(Re=>Re.join(""))}e.$Te=n;function i(se,fe){return se<fe?-1:se>fe?1:0}e.$Ue=i;function t(se,fe,me=0,ye=se.length,ke=0,Re=fe.length){for(;me<ye&&ke<Re;me++,ke++){const Oe=se.charCodeAt(me),Ae=fe.charCodeAt(ke);if(Oe<Ae)return-1;if(Oe>Ae)return 1}const Ce=ye-me,De=Re-ke;return Ce<De?-1:Ce>De?1:0}e.$Ve=t;function r(se,fe){return a(se,fe,0,se.length,0,fe.length)}e.$We=r;function a(se,fe,me=0,ye=se.length,ke=0,Re=fe.length){for(;me<ye&&ke<Re;me++,ke++){let Oe=se.charCodeAt(me),Ae=fe.charCodeAt(ke);if(Oe===Ae)continue;if(Oe>=128||Ae>=128)return t(se.toLowerCase(),fe.toLowerCase(),me,ye,ke,Re);w(Oe)&&(Oe-=32),w(Ae)&&(Ae-=32);const Fe=Oe-Ae;if(Fe!==0)return Fe}const Ce=ye-me,De=Re-ke;return Ce<De?-1:Ce>De?1:0}e.$Xe=a;function v(se){return se>=48&&se<=57}e.$Ye=v;function w(se){return se>=97&&se<=122}e.$Ze=w;function l(se){return se>=65&&se<=90}e.$1e=l;function m(se,fe){return se.length===fe.length&&a(se,fe)===0}e.$2e=m;function O(se,fe){const me=fe.length;return fe.length>se.length?!1:a(se,fe,0,me)===0}e.$3e=O;function F(se,fe){const me=Math.min(se.length,fe.length);let ye;for(ye=0;ye<me;ye++)if(se.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return me}e.$4e=F;function z(se,fe){const me=Math.min(se.length,fe.length);let ye;const ke=se.length-1,Re=fe.length-1;for(ye=0;ye<me;ye++)if(se.charCodeAt(ke-ye)!==fe.charCodeAt(Re-ye))return ye;return me}e.$5e=z;function U(se){return 55296<=se&&se<=56319}e.$6e=U;function B(se){return 56320<=se&&se<=57343}e.$7e=B;function Y(se,fe){return(se-55296<<10)+(fe-56320)+65536}e.$8e=Y;function K(se,fe,me){const ye=se.charCodeAt(me);if(U(ye)&&me+1<fe){const ke=se.charCodeAt(me+1);if(B(ke))return Y(ye,ke)}return ye}e.$9e=K;function x(se,fe){const me=se.charCodeAt(fe-1);if(B(me)&&fe>1){const ye=se.charCodeAt(fe-2);if(U(ye))return Y(ye,me)}return me}class V{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=x(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=K(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$0e=V;class Q{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new V(fe,me)}nextGraphemeLength(){const fe=ge.getInstance(),me=this.c,ye=me.offset;let ke=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.nextCodePoint());if(Te(ke,Ce)){me.setOffset(Re);break}ke=Ce}return me.offset-ye}prevGraphemeLength(){const fe=ge.getInstance(),me=this.c,ye=me.offset;let ke=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.prevCodePoint());if(Te(Ce,ke)){me.setOffset(Re);break}ke=Ce}return ye-me.offset}eol(){return this.c.eol()}}e.$$e=Q;function G(se,fe){return new Q(se,fe).nextGraphemeLength()}e.$_e=G;function W(se,fe){return new Q(se,fe).prevGraphemeLength()}e.$af=W;function ee(se,fe){fe>0&&B(se.charCodeAt(fe))&&fe--;const me=fe+G(se,fe);return[me-W(se,me),me]}e.$bf=ee;function ie(se){const fe=new Q(se);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}e.$cf=ie;let _;function ne(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Z(se){return _||(_=ne()),_.test(se)}e.$df=Z;const q=/^[\t\n\r\x20-\x7E]*$/;function P(se){return q.test(se)}e.$ef=P,e.$ff=/[\u2028\u2029]/;function j(se){return e.$ff.test(se)}e.$gf=j;function T(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}e.$hf=T;function M(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}e.$if=M;function H(se,fe){if(se.length<fe)return se;const me=/\b/g;let ye=0;for(;me.test(se)&&!(se.length-me.lastIndex<fe);)ye=me.lastIndex,me.lastIndex+=1;return se.substring(ye).replace(/^\s/,"")}e.$jf=H;const J=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,re=/\x1b\].*?\x07/g;function ce(se){return se&&(se=se.replace(J,"").replace(re,"")),se}e.$kf=ce,e.$lf=String.fromCharCode(65279);function ue(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}e.$mf=ue;function he(se){return ue(se)?se.substr(1):se}e.$nf=he;function $e(se,fe){if(!se||!fe||se.length<fe.length)return!1;const me=fe.length,ye=se.toLowerCase();let ke=0,Re=-1;for(;ke<me;){const Ce=ye.indexOf(fe[ke],Re+1);if(Ce<0)return!1;Re=Ce,ke++}return!0}e.$of=$e;function de(se,fe=!1){return se?(fe&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}e.$pf=de;function we(se){return se.charAt(0).toUpperCase()+se.slice(1)}e.$qf=we;function ve(se,fe=1){if(fe===0)return"";let me=-1;do me=se.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?se:(se[me-1]==="\r"&&me--,se.substr(0,me))}e.$rf=ve;function Ie(se){return se=se%(2*26),se<26?String.fromCharCode(97+se):String.fromCharCode(65+se-26)}e.$sf=Ie;function Le(se){return ge.getInstance().getGraphemeBreakType(se)}e.$tf=Le;function Te(se,fe){return se===0?fe!==5&&fe!==7:se===2&&fe===3?!1:se===4||se===2||se===3||fe===4||fe===2||fe===3?!0:!(se===8&&(fe===8||fe===9||fe===11||fe===12)||(se===11||se===9)&&(fe===9||fe===10)||(se===12||se===10)&&fe===10||fe===5||fe===13||fe===7||se===1||se===13&&fe===14||se===6&&fe===6)}var le;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,ye=me.length/3;let ke=1;for(;ke<=ye;)if(fe<me[3*ke])ke=2*ke;else if(fe>me[3*ke+1])ke=2*ke+1;else return me[3*ke+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(se,fe){if(se===0)return 0;const me=Pe(se,fe);if(me!==void 0)return me;const ye=new V(fe,se);return ye.prevCodePoint(),ye.offset}e.$uf=Se;function Pe(se,fe){const me=new V(fe,se);let ye=me.prevCodePoint();for(;ze(ye)||ye===65039||ye===8419;){if(me.offset===0)return;ye=me.prevCodePoint()}if(!M(ye))return;let ke=me.offset;return ke>0&&me.prevCodePoint()===8205&&(ke=me.offset),ke}function ze(se){return 127995<=se&&se<=127999}var je;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$vf="\xA0";class Ue{static{this.c=new L.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$xe(fe=>{function me(Fe){const Be=new Map;for(let qe=0;qe<Fe.length;qe+=2)Be.set(Fe[qe],Fe[qe+1]);return Be}function ye(Fe,Be){const qe=new Map(Fe);for(const[Ve,_e]of Be)qe.set(Ve,_e);return qe}function ke(Fe,Be){if(!Fe)return Be;const qe=new Map;for(const[Ve,_e]of Fe)Be.has(Ve)&&qe.set(Ve,_e);return qe}const Re=this.c.value;let Ce=fe.filter(Fe=>!Fe.startsWith("_")&&Fe in Re);Ce.length===0&&(Ce=["_default"]);let De;for(const Fe of Ce){const Be=me(Re[Fe]);De=ke(De,Be)}const Oe=me(Re._common),Ae=ye(Oe,De);return new Ue(Ae)})}static getInstance(fe){return Ue.d.get(Array.from(fe))}static{this.e=new L.$U(()=>Object.keys(Ue.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Ue.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$wf=Ue;class Me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Me.c())),this.d}static isInvisibleCharacter(fe){return Me.e().has(fe)}static get codePoints(){return Me.e()}}e.$xf=Me}),define(oe[52],ae([0,1,27]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=void 0;function L(h){return N(h,0)}e.$Di=L;function N(h,f){switch(typeof h){case"object":return h===null?A(349,f):Array.isArray(h)?S(h,f):g(h,f);case"string":return R(h,f);case"boolean":return I(h,f);case"number":return A(h,f);case"undefined":return A(937,f);default:return A(617,f)}}e.$Ei=N;function A(h,f){return(f<<5)-f+h|0}e.$Fi=A;function I(h,f){return A(h?433:863,f)}function R(h,f){f=A(149417,f);for(let u=0,d=h.length;u<d;u++)f=A(h.charCodeAt(u),f);return f}e.$Gi=R;function S(h,f){return f=A(104579,f),h.reduce((u,d)=>N(d,u),f)}function g(h,f){return f=A(181387,f),Object.keys(h).sort().reduce((u,d)=>(u=R(d,u),N(h[d],u)),f)}class C{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=N(f,this.g),this.g}}e.$Hi=C;var k;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function b(h,f,u=32){const d=u-f,E=~((1<<d)-1);return(h<<f|(E&h)>>>d)>>>0}function c(h,f=0,u=h.byteLength,d=0){for(let E=0;E<u;E++)h[f+E]=d}function $(h,f,u="0"){for(;h.length<f;)h=u+h;return h}function y(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(u=>u.toString(16).padStart(2,"0")).join(""):$((h>>>0).toString(16),f/4)}e.$Ii=y;class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const u=f.length;if(u===0)return;const d=this.p;let E=this.r,s=this.u,o,n;for(s!==0?(o=s,n=-1,s=0):(o=f.charCodeAt(0),n=0);;){let i=o;if(D.$6e(o))if(n+1<u){const t=f.charCodeAt(n+1);D.$7e(t)?(n++,i=D.$8e(o,t)):i=65533}else{s=o;break}else D.$7e(o)&&(i=65533);if(E=this.w(d,E,i),n++,n<u)o=f.charCodeAt(n);else break}this.r=E,this.u=s}w(f,u,d){return d<128?f[u++]=d:d<2048?(f[u++]=192|(d&1984)>>>6,f[u++]=128|(d&63)>>>0):d<65536?(f[u++]=224|(d&61440)>>>12,f[u++]=128|(d&4032)>>>6,f[u++]=128|(d&63)>>>0):(f[u++]=240|(d&1835008)>>>18,f[u++]=128|(d&258048)>>>12,f[u++]=128|(d&4032)>>>6,f[u++]=128|(d&63)>>>0),u>=64&&(this.y(),u-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),u}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=p.g,u=this.q;for(let a=0;a<64;a+=4)f.setUint32(a,u.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)f.setUint32(a,b(f.getUint32(a-12,!1)^f.getUint32(a-32,!1)^f.getUint32(a-56,!1)^f.getUint32(a-64,!1),1),!1);let d=this.h,E=this.l,s=this.m,o=this.n,n=this.o,i,t,r;for(let a=0;a<80;a++)a<20?(i=E&s|~E&o,t=1518500249):a<40?(i=E^s^o,t=1859775393):a<60?(i=E&s|E&o|s&o,t=2400959708):(i=E^s^o,t=3395469782),r=b(d,5)+i+n+t+f.getUint32(a*4,!1)&4294967295,n=o,o=s,s=b(E,30),E=d,d=r;this.h=this.h+d&4294967295,this.l=this.l+E&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$Ji=p}),define(oe[89],ae([0,1,27]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(N){N[N.Ignore=0]="Ignore",N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(L||(L={})),function(N){const A="error",I="warning",R="warn",S="info",g="ignore";function C(b){return b?D.$2e(A,b)?N.Error:D.$2e(I,b)||D.$2e(R,b)?N.Warning:D.$2e(S,b)?N.Info:N.Ignore:N.Ignore}N.fromValue=C;function k(b){switch(b){case N.Error:return A;case N.Warning:return I;case N.Info:return S;default:return g}}N.toString=k}(L||(L={})),e.default=L}),define(oe[129],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(oe[47],ae([0,1,18,27]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class N{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const $=c.charCodeAt(0),y=this.b.charCodeAt(this.c);return $-y}value(){return this.b[this.c]}}e.$Rh=N;class A{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,L.$Ve)(c,this.b,0,c.length,this.c,this.d):(0,L.$Xe)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=A;class I{constructor(c=!0,$=!0){this.f=c,this.g=$}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let $=c.length-1;$>=0;$--,this.c--){const y=this.b.charCodeAt($);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,L.$Ve)(c,this.b,0,c.length,this.d,this.e):(0,L.$Xe)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=I;var R;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(R||(R={}));class S{constructor(c,$){this.f=c,this.g=$,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(3)),this.g(c)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===1)return(0,L.$We)(c,this.c.scheme);if(this.d[this.e]===2)return(0,L.$We)(c,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(c);if(this.d[this.e]===4)return(0,L.$Ue)(c,this.c.query);if(this.d[this.e]===5)return(0,L.$Ue)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=S;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(C||(C={}));class k{static forUris(c=()=>!1,$=()=>!1){return new k(new S(c,$))}static forPaths(c=!1){return new k(new I(void 0,!c))}static forStrings(){return new k(new N)}static forConfigKeys(){return new k(new A)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,$){if($){const y=$.slice(0);(0,D.$Wb)(y);for(const p of y)this.set(p,c)}else{const y=c.slice(0);(0,D.$Wb)(y);for(const p of y)this.set(p[0],p[1])}}set(c,$){const y=this.b.reset(c);let p;this.c||(this.c=new g,this.c.segment=y.value());const h=[];for(p=this.c;;){const u=y.cmp(p.segment);if(u>0)p.left||(p.left=new g,p.left.segment=y.value()),h.push([-1,p]),p=p.left;else if(u<0)p.right||(p.right=new g,p.right.segment=y.value()),h.push([1,p]),p=p.right;else if(y.hasNext())y.next(),p.mid||(p.mid=new g,p.mid.segment=y.value()),h.push([0,p]),p=p.mid;else break}const f=p.value;p.value=$,p.key=c;for(let u=h.length-1;u>=0;u--){const d=h[u][1];d.updateHeight();const E=d.balanceFactor();if(E<-1||E>1){const s=h[u][0],o=h[u+1][0];if(s===1&&o===1)h[u][1]=d.rotateLeft();else if(s===-1&&o===-1)h[u][1]=d.rotateRight();else if(s===1&&o===-1)d.right=h[u+1][1]=h[u+1][1].rotateRight(),h[u][1]=d.rotateLeft();else if(s===-1&&o===1)d.left=h[u+1][1]=h[u+1][1].rotateLeft(),h[u][1]=d.rotateRight();else throw new Error;if(u>0)switch(h[u-1][0]){case-1:h[u-1][1].left=h[u][1];break;case 1:h[u-1][1].right=h[u][1];break;case 0:h[u-1][1].mid=h[u][1];break}else this.c=h[0][1]}}return f}get(c){return this.d(c)?.value}d(c){const $=this.b.reset(c);let y=this.c;for(;y;){const p=$.cmp(y.segment);if(p>0)y=y.left;else if(p<0)y=y.right;else if($.hasNext())$.next(),y=y.mid;else break}return y}has(c){const $=this.d(c);return!($?.value===void 0&&$?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,$){const y=this.b.reset(c),p=[];let h=this.c;for(;h;){const f=y.cmp(h.segment);if(f>0)p.push([-1,h]),h=h.left;else if(f<0)p.push([1,h]),h=h.right;else if(y.hasNext())y.next(),p.push([0,h]),h=h.mid;else break}if(h){if($?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const f=this.f(h.right);if(f.key){const{key:u,value:d,segment:E}=f;this.e(f.key,!1),h.key=u,h.value=d,h.segment=E}}else{const f=h.left??h.right;if(p.length>0){const[u,d]=p[p.length-1];switch(u){case-1:d.left=f;break;case 0:d.mid=f;break;case 1:d.right=f;break}}else this.c=f}for(let f=p.length-1;f>=0;f--){const u=p[f][1];u.updateHeight();const d=u.balanceFactor();if(d>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),p[f][1]=u.rotateLeft()):d<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),p[f][1]=u.rotateRight()),f>0)switch(p[f-1][0]){case-1:p[f-1][1].left=p[f][1];break;case 1:p[f-1][1].right=p[f][1];break;case 0:p[f-1][1].mid=p[f][1];break}else this.c=p[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const $=this.b.reset(c);let y=this.c,p;for(;y;){const h=$.cmp(y.segment);if(h>0)y=y.left;else if(h<0)y=y.right;else if($.hasNext())$.next(),p=y.value||p,y=y.mid;else break}return y&&y.value||p}findSuperstr(c){return this.g(c,!1)}g(c,$){const y=this.b.reset(c);let p=this.c;for(;p;){const h=y.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(y.hasNext())y.next(),p=p.mid;else return p.mid?this.h(p.mid):$?p.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[$,y]of this)c(y,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const $=[];return this.j(c,$),$[Symbol.iterator]()}j(c,$){c&&(c.left&&this.j(c.left,$),c.value&&$.push([c.key,c.value]),c.mid&&this.j(c.mid,$),c.right&&this.j(c.right,$))}_isBalanced(){const c=$=>{if(!$)return!0;const y=$.balanceFactor();return y<-1||y>1?!1:c($.left)&&c($.right)};return c(this.c)}}e.$Vh=k}),define(oe[12],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=void 0;function D(E){return typeof E=="string"}e.$yf=D;function L(E){return Array.isArray(E)&&E.every(s=>D(s))}e.$zf=L;function N(E){return typeof E=="object"&&E!==null&&!Array.isArray(E)&&!(E instanceof RegExp)&&!(E instanceof Date)}e.$Af=N;function A(E){const s=Object.getPrototypeOf(Uint8Array);return typeof E=="object"&&E instanceof s}e.$Bf=A;function I(E){return typeof E=="number"&&!isNaN(E)}e.$Cf=I;function R(E){return!!E&&typeof E[Symbol.iterator]=="function"}e.$Df=R;function S(E){return E===!0||E===!1}e.$Ef=S;function g(E){return typeof E>"u"}e.$Ff=g;function C(E){return!k(E)}e.$Gf=C;function k(E){return g(E)||E===null}e.$Hf=k;function b(E,s){if(!E)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$If=b;function c(E){if(k(E))throw new Error("Assertion Failed: argument is undefined or null");return E}e.$Jf=c;function $(...E){const s=[];for(let o=0;o<E.length;o++){const n=E[o];if(k(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);s.push(n)}return s}e.$Kf=$;const y=Object.prototype.hasOwnProperty;function p(E){if(!N(E))return!1;for(const s in E)if(y.call(E,s))return!1;return!0}e.$Lf=p;function h(E){return typeof E=="function"}e.$Mf=h;function f(...E){return E.length>0&&E.every(h)}e.$Nf=f;function u(E,s){const o=Math.min(E.length,s.length);for(let n=0;n<o;n++)d(E[n],s[n])}e.$Of=u;function d(E,s){if(D(s)){if(typeof E!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(h(s)){try{if(E instanceof s)return}catch{}if(!k(E)&&E.constructor===s||s.length===1&&s.call(void 0,E)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Pf=d}),define(oe[30],ae([0,1,12]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function L(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const E=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([s,o])=>{E[s]=o&&typeof o=="object"?L(o):o}),E}e.$7m=L;function N(d){if(!d||typeof d!="object")return d;const E=[d];for(;E.length>0;){const s=E.shift();Object.freeze(s);for(const o in s)if(A.call(s,o)){const n=s[o];typeof n=="object"&&!Object.isFrozen(n)&&!(0,D.$Bf)(n)&&E.push(n)}}return d}e.$8m=N;const A=Object.prototype.hasOwnProperty;function I(d,E){return R(d,E,new Set)}e.$9m=I;function R(d,E,s){if((0,D.$Hf)(d))return d;const o=E(d);if(typeof o<"u")return o;if(Array.isArray(d)){const n=[];for(const i of d)n.push(R(i,E,s));return n}if((0,D.$Af)(d)){if(s.has(d))throw new Error("Cannot clone recursive data-structure");s.add(d);const n={};for(const i in d)A.call(d,i)&&(n[i]=R(d[i],E,s));return s.delete(d),n}return d}function S(d,E,s=!0){return(0,D.$Af)(d)?((0,D.$Af)(E)&&Object.keys(E).forEach(o=>{o in d?s&&((0,D.$Af)(d[o])&&(0,D.$Af)(E[o])?S(d[o],E[o],s):d[o]=E[o]):d[o]=E[o]}),d):E}e.$0m=S;function g(d,E){if(d===E)return!0;if(d==null||E===null||E===void 0||typeof d!=typeof E||typeof d!="object"||Array.isArray(d)!==Array.isArray(E))return!1;let s,o;if(Array.isArray(d)){if(d.length!==E.length)return!1;for(s=0;s<d.length;s++)if(!g(d[s],E[s]))return!1}else{const n=[];for(o in d)n.push(o);n.sort();const i=[];for(o in E)i.push(o);if(i.sort(),!g(n,i))return!1;for(s=0;s<n.length;s++)if(!g(d[n[s]],E[n[s]]))return!1}return!0}e.$$m=g;function C(d){const E=new Set;return JSON.stringify(d,(s,o)=>{if((0,D.$Af)(o)||Array.isArray(o)){if(E.has(o))return"[Circular]";E.add(o)}return o})}e.$_m=C;function k(d,E){const s=Object.create(null);return!d||!E||Object.keys(E).forEach(n=>{const i=d[n],t=E[n];g(i,t)||(s[n]=t)}),s}e.$an=k;function b(d,E){const s=E.toLowerCase(),o=Object.keys(d).find(n=>n.toLowerCase()===s);return o?d[o]:d[E]}e.$bn=b;function c(d,E){const s=Object.create(null);for(const[o,n]of Object.entries(d))E(o,n)&&(s[o]=n);return s}e.$cn=c;function $(d){let E=[];for(;Object.prototype!==d;)E=E.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return E}e.$dn=$;function y(d){const E=[];for(const s of $(d))typeof d[s]=="function"&&E.push(s);return E}e.$en=y;function p(d,E){const s=n=>function(){const i=Array.prototype.slice.call(arguments,0);return E(n,i)},o={};for(const n of d)o[n]=s(n);return o}e.$fn=p;function h(d,E,s){typeof E=="string"&&d[E]!==void 0&&typeof d[E]!="boolean"&&(d[E]=s)}e.$gn=h;function f(d,E,s){typeof E=="string"&&d[E]!==void 0&&typeof d[E]!="number"&&(d[E]=s)}e.$hn=f;function u(d,E,s,o){if(typeof E!="string")return;const n=d[E];n!==void 0&&(typeof n!="string"||!s.includes(n))&&(d[E]=o)}e.$in=u}),define(oe[32],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(N){return D.test(N)}e.$dg=L,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let N;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?N=crypto.getRandomValues.bind(crypto):N=function(R){for(let S=0;S<R.length;S++)R[S]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),I=[];for(let R=0;R<256;R++)I.push(R.toString(16).padStart(2,"0"));return function(){N(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,g="";return g+=I[A[S++]],g+=I[A[S++]],g+=I[A[S++]],g+=I[A[S++]],g+="-",g+=I[A[S++]],g+=I[A[S++]],g+="-",g+=I[A[S++]],g+=I[A[S++]],g+="-",g+=I[A[S++]],g+=I[A[S++]],g+="-",g+=I[A[S++]],g+=I[A[S++]],g+=I[A[S++]],g+=I[A[S++]],g+=I[A[S++]],g+=I[A[S++]],g}}()}),define(oe[130],ae([0,1,36]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function N(I){const R=I.replace(/\-/g,":").toLowerCase();return!L.has(R)}function A(){const I=(0,D.networkInterfaces)();for(const R in I){const S=I[R];if(S){for(const{mac:g}of S)if(N(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Qm=A}),define(oe[131],ae([0,1,266,15]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uT=void 0;class N extends D.Transform{constructor(I){if(super(),typeof I=="number")this.b=I,this.c=1;else{const R=Buffer.isBuffer(I)?I:Buffer.from(I);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(I,R,S){this.a?this.a=Buffer.concat([this.a,I]):this.a=I;let g=0;for(;g<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,g):(0,L.$ce)(this.a,this.b,g);if(C===-1)break;this.push(this.a.slice(g,C+this.c)),g=C+this.c}this.a=g===this.a.length?void 0:this.a.slice(g),S()}_flush(I){this.a&&this.push(this.a),I()}}e.$uT=N}),define(oe[132],ae([0,1,62]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=void 0;function L(R,S,g,C=1){let k=!1;return new Promise(b=>{const c=setTimeout(()=>{if(!k)return k=!0,b(0)},g);N(R,S,C,$=>{if(!k)return k=!0,clearTimeout(c),b($)})})}e.$gg=L;function N(R,S,g,C){if(S===0)return C(0);const k=new D.Socket;k.once("connect",()=>(I(k),N(R+g,S-1,g,C))),k.once("data",()=>{}),k.once("error",b=>(I(k),b.code!=="ECONNREFUSED"?N(R+g,S-1,g,C):C(R))),k.connect(R,"127.0.0.1")}e.$hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,S,g,C="127.0.0.1"){let k=!1,b,c=1;const $=D.createServer({pauseOnConnect:!0});function y(p,h){k||(k=!0,$.removeAllListeners(),$.close(),b&&clearTimeout(b),h(p))}return new Promise(p=>{b=setTimeout(()=>{y(0,p)},g),$.on("listening",()=>{y(R,p)}),$.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&c<S?(R++,c++,$.listen(R,C)):y(0,p)}),$.on("close",()=>{y(0,p)}),$.listen(R,C)})}e.$ig=A;function I(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(S){console.error(S)}}}),define(oe[133],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KT=void 0;function D(L){return!!L.parentPort}e.$KT=D}),define(oe[134],ae([13,9]),function(te,e){return te.create("vs/base/common/date",e)}),define(oe[63],ae([0,1,134]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const L=60,N=L*60,A=N*24,I=A*7,R=A*30,S=A*365;function g(k,b,c,$){typeof k!="number"&&(k=k.getTime());const y=Math.round((new Date().getTime()-k)/1e3);if(y<-30)return(0,D.localize)(0,null,g(new Date().getTime()+y*1e3,!1));if(!$&&y<30)return(0,D.localize)(1,null);let p;return y<L?(p=y,b?p===1?c?(0,D.localize)(2,null,p):(0,D.localize)(3,null,p):c?(0,D.localize)(4,null,p):(0,D.localize)(5,null,p):p===1?c?(0,D.localize)(6,null,p):(0,D.localize)(7,null,p):c?(0,D.localize)(8,null,p):(0,D.localize)(9,null,p)):y<N?(p=Math.floor(y/L),b?p===1?c?(0,D.localize)(10,null,p):(0,D.localize)(11,null,p):c?(0,D.localize)(12,null,p):(0,D.localize)(13,null,p):p===1?c?(0,D.localize)(14,null,p):(0,D.localize)(15,null,p):c?(0,D.localize)(16,null,p):(0,D.localize)(17,null,p)):y<A?(p=Math.floor(y/N),b?p===1?c?(0,D.localize)(18,null,p):(0,D.localize)(19,null,p):c?(0,D.localize)(20,null,p):(0,D.localize)(21,null,p):p===1?c?(0,D.localize)(22,null,p):(0,D.localize)(23,null,p):c?(0,D.localize)(24,null,p):(0,D.localize)(25,null,p)):y<I?(p=Math.floor(y/A),b?p===1?(0,D.localize)(26,null,p):(0,D.localize)(27,null,p):p===1?(0,D.localize)(28,null,p):(0,D.localize)(29,null,p)):y<R?(p=Math.floor(y/I),b?p===1?c?(0,D.localize)(30,null,p):(0,D.localize)(31,null,p):c?(0,D.localize)(32,null,p):(0,D.localize)(33,null,p):p===1?c?(0,D.localize)(34,null,p):(0,D.localize)(35,null,p):c?(0,D.localize)(36,null,p):(0,D.localize)(37,null,p)):y<S?(p=Math.floor(y/R),b?p===1?c?(0,D.localize)(38,null,p):(0,D.localize)(39,null,p):c?(0,D.localize)(40,null,p):(0,D.localize)(41,null,p):p===1?c?(0,D.localize)(42,null,p):(0,D.localize)(43,null,p):c?(0,D.localize)(44,null,p):(0,D.localize)(45,null,p)):(p=Math.floor(y/S),b?p===1?c?(0,D.localize)(46,null,p):(0,D.localize)(47,null,p):c?(0,D.localize)(48,null,p):(0,D.localize)(49,null,p):p===1?c?(0,D.localize)(50,null,p):(0,D.localize)(51,null,p):c?(0,D.localize)(52,null,p):(0,D.localize)(53,null,p))}e.$dm=g;function C(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=C}),define(oe[135],ae([13,9]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,18,12,135]),function(te,e,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function A(k,b){return b&&(k.stack||k.stacktrace)?N.localize(0,null,R(k),I(k.stack)||I(k.stacktrace)):R(k)}function I(k){return Array.isArray(k)?k.join(`
`):k}function R(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?N.localize(1,null,k.message):k.message||N.localize(2,null)}function S(k=null,b=!1){if(!k)return N.localize(3,null);if(Array.isArray(k)){const c=D.$Gb(k),$=S(c[0],b);return c.length>1?N.localize(4,null,$,c.length):$}if(L.$yf(k))return k;if(k.detail){const c=k.detail;if(c.error)return A(c.error,b);if(c.exception)return A(c.exception,b)}return k.stack?A(k,b):k.message?k.message:N.localize(5,null)}e.$Ai=S;function g(k){const b=k;return b instanceof Error&&Array.isArray(b.actions)}e.$Bi=g;function C(k,b){let c;return typeof k=="string"?c=new Error(k):c=k,c.actions=b,c}e.$Ci=C}),define(oe[136],ae([13,9]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(oe[137],ae([0,1,136]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;function L(N){switch(N){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.$zp=L}),define(oe[138],ae([13,9]),function(te,e){return te.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,138]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let L=!1,N=!1,A=!1,I=!1,R=!1,S=!1,g=!1,C=!1,k=!1,b=!1,c,$=e.$g,y=e.$g,p,h;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?f=e.$h.vscode.process:typeof process<"u"&&(f=process);const u=typeof f?.versions?.electron=="string",d=u&&f?.type==="renderer";if(typeof navigator=="object"&&!d)h=navigator.userAgent,L=h.indexOf("Windows")>=0,N=h.indexOf("Macintosh")>=0,C=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=h.indexOf("Linux")>=0,b=h?.indexOf("Mobi")>=0,S=!0,c=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,$=c,y=navigator.language;else if(typeof f=="object"){L=f.platform==="win32",N=f.platform==="darwin",A=f.platform==="linux",I=A&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,g=u,k=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=e.$g,$=e.$g;const v=f.env.VSCODE_NLS_CONFIG;if(v)try{const w=JSON.parse(v),l=w.availableLanguages["*"];c=w.locale,y=w.osLocale,$=l||e.$g,p=w._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var E;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(E||(e.Platform=E={}));function s(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=s;let o=0;N?o=1:L?o=3:A&&(o=2),e.$j=L,e.$k=N,e.$l=A,e.$m=I,e.$n=R,e.$o=g,e.$p=S,e.$q=S&&typeof e.$h.importScripts=="function",e.$r=C,e.$s=b,e.$t=k,e.$u=o,e.$v=h,e.$w=$;var n;(function(v){function w(){return e.$w}v.value=w;function l(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=l;function m(){return e.$w==="en"}v.isDefault=m})(n||(e.Language=n={})),e.$x=c,e.$y=y,e.$z=p,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const v=[];e.$h.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let m=0,O=v.length;m<O;m++){const F=v[m];if(F.id===l.data.vscodeScheduleAsyncWork){v.splice(m,1),F.callback();return}}});let w=0;return l=>{const m=++w;v.push({id:m,callback:l}),e.$h.postMessage({vscodeScheduleAsyncWork:m},"*")}}return v=>setTimeout(v)})();var i;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=N||C?2:L?1:3;let t=!0,r=!1;function a(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,t=new Uint16Array(v.buffer)[0]===(2<<8)+1}return t}e.$D=a,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(oe[37],ae([0,1,5]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let L;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.process<"u"){const N=D.$h.vscode.process;L={get platform(){return N.platform},get arch(){return N.arch},get env(){return N.env},cwd(){return N.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return D.$j?"win32":D.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$cc=L.platform,e.$dc=L.arch}),define(oe[16],ae([0,1,37]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const L=65,N=97,A=90,I=122,R=46,S=47,g=92,C=58,k=63;class b extends Error{constructor(o,n,i){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof i}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function c(s,o){if(s===null||typeof s!="object")throw new b(o,"Object",s)}function $(s,o){if(typeof s!="string")throw new b(o,"string",s)}const y=D.$cc==="win32";function p(s){return s===S||s===g}function h(s){return s===S}function f(s){return s>=L&&s<=A||s>=N&&s<=I}function u(s,o,n,i){let t="",r=0,a=-1,v=0,w=0;for(let l=0;l<=s.length;++l){if(l<s.length)w=s.charCodeAt(l);else{if(i(w))break;w=S}if(i(w)){if(!(a===l-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const m=t.lastIndexOf(n);m===-1?(t="",r=0):(t=t.slice(0,m),r=t.length-1-t.lastIndexOf(n)),a=l,v=0;continue}else if(t.length!==0){t="",r=0,a=l,v=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${s.slice(a+1,l)}`:t=s.slice(a+1,l),r=l-a-1;a=l,v=0}else w===R&&v!==-1?++v:v=-1}return t}function d(s,o){c(o,"pathObject");const n=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${i}`:`${n}${s}${i}`:i}e.$ec={resolve(...s){let o="",n="",i=!1;for(let t=s.length-1;t>=-1;t--){let r;if(t>=0){if(r=s[t],$(r,"path"),r.length===0)continue}else o.length===0?r=D.cwd():(r=D.env[`=${o}`]||D.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${o}\\`));const a=r.length;let v=0,w="",l=!1;const m=r.charCodeAt(0);if(a===1)p(m)&&(v=1,l=!0);else if(p(m))if(l=!0,p(r.charCodeAt(1))){let O=2,F=O;for(;O<a&&!p(r.charCodeAt(O));)O++;if(O<a&&O!==F){const z=r.slice(F,O);for(F=O;O<a&&p(r.charCodeAt(O));)O++;if(O<a&&O!==F){for(F=O;O<a&&!p(r.charCodeAt(O));)O++;(O===a||O!==F)&&(w=`\\\\${z}\\${r.slice(F,O)}`,v=O)}}}else v=1;else f(m)&&r.charCodeAt(1)===C&&(w=r.slice(0,2),v=2,a>2&&p(r.charCodeAt(2))&&(l=!0,v=3));if(w.length>0)if(o.length>0){if(w.toLowerCase()!==o.toLowerCase())continue}else o=w;if(i){if(o.length>0)break}else if(n=`${r.slice(v)}\\${n}`,i=l,l&&o.length>0)break}return n=u(n,!i,"\\",p),i?`${o}\\${n}`:`${o}${n}`||"."},normalize(s){$(s,"path");const o=s.length;if(o===0)return".";let n=0,i,t=!1;const r=s.charCodeAt(0);if(o===1)return h(r)?"\\":s;if(p(r))if(t=!0,p(s.charCodeAt(1))){let v=2,w=v;for(;v<o&&!p(s.charCodeAt(v));)v++;if(v<o&&v!==w){const l=s.slice(w,v);for(w=v;v<o&&p(s.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&!p(s.charCodeAt(v));)v++;if(v===o)return`\\\\${l}\\${s.slice(w)}\\`;v!==w&&(i=`\\\\${l}\\${s.slice(w,v)}`,n=v)}}}else n=1;else f(r)&&s.charCodeAt(1)===C&&(i=s.slice(0,2),n=2,o>2&&p(s.charCodeAt(2))&&(t=!0,n=3));let a=n<o?u(s.slice(n),!t,"\\",p):"";return a.length===0&&!t&&(a="."),a.length>0&&p(s.charCodeAt(o-1))&&(a+="\\"),i===void 0?t?`\\${a}`:a:t?`${i}\\${a}`:`${i}${a}`},isAbsolute(s){$(s,"path");const o=s.length;if(o===0)return!1;const n=s.charCodeAt(0);return p(n)||o>2&&f(n)&&s.charCodeAt(1)===C&&p(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,n;for(let r=0;r<s.length;++r){const a=s[r];$(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let i=!0,t=0;if(typeof n=="string"&&p(n.charCodeAt(0))){++t;const r=n.length;r>1&&p(n.charCodeAt(1))&&(++t,r>2&&(p(n.charCodeAt(2))?++t:i=!1))}if(i){for(;t<o.length&&p(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$ec.normalize(o)},relative(s,o){if($(s,"from"),$(o,"to"),s===o)return"";const n=e.$ec.resolve(s),i=e.$ec.resolve(o);if(n===i||(s=n.toLowerCase(),o=i.toLowerCase(),s===o))return"";let t=0;for(;t<s.length&&s.charCodeAt(t)===g;)t++;let r=s.length;for(;r-1>t&&s.charCodeAt(r-1)===g;)r--;const a=r-t;let v=0;for(;v<o.length&&o.charCodeAt(v)===g;)v++;let w=o.length;for(;w-1>v&&o.charCodeAt(w-1)===g;)w--;const l=w-v,m=a<l?a:l;let O=-1,F=0;for(;F<m;F++){const U=s.charCodeAt(t+F);if(U!==o.charCodeAt(v+F))break;U===g&&(O=F)}if(F!==m){if(O===-1)return i}else{if(l>m){if(o.charCodeAt(v+F)===g)return i.slice(v+F+1);if(F===2)return i.slice(v+F)}a>m&&(s.charCodeAt(t+F)===g?O=F:F===2&&(O=3)),O===-1&&(O=0)}let z="";for(F=t+O+1;F<=r;++F)(F===r||s.charCodeAt(F)===g)&&(z+=z.length===0?"..":"\\..");return v+=O,z.length>0?`${z}${i.slice(v,w)}`:(i.charCodeAt(v)===g&&++v,i.slice(v,w))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const o=e.$ec.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const n=o.charCodeAt(2);if(n!==k&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return s},dirname(s){$(s,"path");const o=s.length;if(o===0)return".";let n=-1,i=0;const t=s.charCodeAt(0);if(o===1)return p(t)?s:".";if(p(t)){if(n=i=1,p(s.charCodeAt(1))){let v=2,w=v;for(;v<o&&!p(s.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&p(s.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&!p(s.charCodeAt(v));)v++;if(v===o)return s;v!==w&&(n=i=v+1)}}}}else f(t)&&s.charCodeAt(1)===C&&(n=o>2&&p(s.charCodeAt(2))?3:2,i=n);let r=-1,a=!0;for(let v=o-1;v>=i;--v)if(p(s.charCodeAt(v))){if(!a){r=v;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return s.slice(0,r)},basename(s,o){o!==void 0&&$(o,"ext"),$(s,"path");let n=0,i=-1,t=!0,r;if(s.length>=2&&f(s.charCodeAt(0))&&s.charCodeAt(1)===C&&(n=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let a=o.length-1,v=-1;for(r=s.length-1;r>=n;--r){const w=s.charCodeAt(r);if(p(w)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=n;--r)if(p(s.charCodeAt(r))){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){$(s,"path");let o=0,n=-1,i=0,t=-1,r=!0,a=0;s.length>=2&&s.charCodeAt(1)===C&&f(s.charCodeAt(0))&&(o=i=2);for(let v=s.length-1;v>=o;--v){const w=s.charCodeAt(v);if(p(w)){if(!r){i=v+1;break}continue}t===-1&&(r=!1,t=v+1),w===R?n===-1?n=v:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===i+1?"":s.slice(n,t)},format:d.bind(null,"\\"),parse(s){$(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const n=s.length;let i=0,t=s.charCodeAt(0);if(n===1)return p(t)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(p(t)){if(i=1,p(s.charCodeAt(1))){let O=2,F=O;for(;O<n&&!p(s.charCodeAt(O));)O++;if(O<n&&O!==F){for(F=O;O<n&&p(s.charCodeAt(O));)O++;if(O<n&&O!==F){for(F=O;O<n&&!p(s.charCodeAt(O));)O++;O===n?i=O:O!==F&&(i=O+1)}}}}else if(f(t)&&s.charCodeAt(1)===C){if(n<=2)return o.root=o.dir=s,o;if(i=2,p(s.charCodeAt(2))){if(n===3)return o.root=o.dir=s,o;i=3}}i>0&&(o.root=s.slice(0,i));let r=-1,a=i,v=-1,w=!0,l=s.length-1,m=0;for(;l>=i;--l){if(t=s.charCodeAt(l),p(t)){if(!w){a=l+1;break}continue}v===-1&&(w=!1,v=l+1),t===R?r===-1?r=l:m!==1&&(m=1):r!==-1&&(m=-1)}return v!==-1&&(r===-1||m===0||m===1&&r===v-1&&r===a+1?o.base=o.name=s.slice(a,v):(o.name=s.slice(a,r),o.base=s.slice(a,v),o.ext=s.slice(r,v))),a>0&&a!==i?o.dir=s.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const E=(()=>{if(y){const s=/\\/g;return()=>{const o=D.cwd().replace(s,"/");return o.slice(o.indexOf("/"))}}return()=>D.cwd()})();e.$fc={resolve(...s){let o="",n=!1;for(let i=s.length-1;i>=-1&&!n;i--){const t=i>=0?s[i]:E();$(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===S)}return o=u(o,!n,"/",h),n?`/${o}`:o.length>0?o:"."},normalize(s){if($(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===S,n=s.charCodeAt(s.length-1)===S;return s=u(s,!o,"/",h),s.length===0?o?"/":n?"./":".":(n&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return $(s,"path"),s.length>0&&s.charCodeAt(0)===S},join(...s){if(s.length===0)return".";let o;for(let n=0;n<s.length;++n){const i=s[n];$(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$fc.normalize(o)},relative(s,o){if($(s,"from"),$(o,"to"),s===o||(s=e.$fc.resolve(s),o=e.$fc.resolve(o),s===o))return"";const n=1,i=s.length,t=i-n,r=1,a=o.length-r,v=t<a?t:a;let w=-1,l=0;for(;l<v;l++){const O=s.charCodeAt(n+l);if(O!==o.charCodeAt(r+l))break;O===S&&(w=l)}if(l===v)if(a>v){if(o.charCodeAt(r+l)===S)return o.slice(r+l+1);if(l===0)return o.slice(r+l)}else t>v&&(s.charCodeAt(n+l)===S?w=l:l===0&&(w=0));let m="";for(l=n+w+1;l<=i;++l)(l===i||s.charCodeAt(l)===S)&&(m+=m.length===0?"..":"/..");return`${m}${o.slice(r+w)}`},toNamespacedPath(s){return s},dirname(s){if($(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===S;let n=-1,i=!0;for(let t=s.length-1;t>=1;--t)if(s.charCodeAt(t)===S){if(!i){n=t;break}}else i=!1;return n===-1?o?"/":".":o&&n===1?"//":s.slice(0,n)},basename(s,o){o!==void 0&&$(o,"ext"),$(s,"path");let n=0,i=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let a=o.length-1,v=-1;for(r=s.length-1;r>=0;--r){const w=s.charCodeAt(r);if(w===S){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===S){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){$(s,"path");let o=-1,n=0,i=-1,t=!0,r=0;for(let a=s.length-1;a>=0;--a){const v=s.charCodeAt(a);if(v===S){if(!t){n=a+1;break}continue}i===-1&&(t=!1,i=a+1),v===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||i===-1||r===0||r===1&&o===i-1&&o===n+1?"":s.slice(o,i)},format:d.bind(null,"/"),parse(s){$(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const n=s.charCodeAt(0)===S;let i;n?(o.root="/",i=1):i=0;let t=-1,r=0,a=-1,v=!0,w=s.length-1,l=0;for(;w>=i;--w){const m=s.charCodeAt(w);if(m===S){if(!v){r=w+1;break}continue}a===-1&&(v=!1,a=w+1),m===R?t===-1?t=w:l!==1&&(l=1):t!==-1&&(l=-1)}if(a!==-1){const m=r===0&&n?1:r;t===-1||l===0||l===1&&t===a-1&&t===r+1?o.base=o.name=s.slice(m,a):(o.name=s.slice(m,t),o.base=s.slice(m,a),o.ext=s.slice(t,a))}return r>0?o.dir=s.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=y?e.$ec.normalize:e.$fc.normalize,e.$hc=y?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=y?e.$ec.join:e.$fc.join,e.$jc=y?e.$ec.resolve:e.$fc.resolve,e.$kc=y?e.$ec.relative:e.$fc.relative,e.$lc=y?e.$ec.dirname:e.$fc.dirname,e.$mc=y?e.$ec.basename:e.$fc.basename,e.$nc=y?e.$ec.extname:e.$fc.extname,e.$oc=y?e.$ec.format:e.$fc.format,e.$pc=y?e.$ec.parse:e.$fc.parse,e.$qc=y?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=y?e.$ec.sep:e.$fc.sep,e.$sc=y?e.$ec.delimiter:e.$fc.delimiter}),define(oe[48],ae([0,1,16,5,27,12]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function I(r){return r===47||r===92}e.$Qf=I;function R(r){return r.replace(/[\\/]/g,D.$fc.sep)}e.$Rf=R;function S(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Sf=S;function g(r,a=D.$fc.sep){if(!r)return"";const v=r.length,w=r.charCodeAt(0);if(I(w)){if(I(r.charCodeAt(1))&&!I(r.charCodeAt(2))){let m=3;const O=m;for(;m<v&&!I(r.charCodeAt(m));m++);if(O!==m&&!I(r.charCodeAt(m+1))){for(m+=1;m<v;m++)if(I(r.charCodeAt(m)))return r.slice(0,m+1).replace(/[\\/]/g,a)}}return a}else if(h(w)&&r.charCodeAt(1)===58)return I(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let l=r.indexOf("://");if(l!==-1){for(l+=3;l<v;l++)if(I(r.charCodeAt(l)))return r.slice(0,l+1)}return""}e.$Tf=g;function C(r){if(!L.$j||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let v=2;const w=v;for(;v<r.length&&(a=r.charCodeAt(v),a!==92);v++);return!(w===v||(a=r.charCodeAt(v+1),isNaN(a)||a===92))}e.$Uf=C;const k=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(r,a=L.$j){const v=a?k:b;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||a&&c.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$Vf=$;function y(r,a,v){const w=r===a;return!v||w?w:!r||!a?!1:(0,N.$2e)(r,a)}e.$Wf=y;function p(r,a,v,w=D.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(v){if(!(0,N.$3e)(r,a))return!1;if(a.length===r.length)return!0;let m=a.length;return a.charAt(a.length-1)===w&&m--,r.charAt(m)===w}return a.charAt(a.length-1)!==w&&(a+=w),r.indexOf(a)===0}e.$Xf=p;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Yf=h;function f(r,a){return L.$j&&r.endsWith(":")&&(r+=D.sep),(0,D.$hc)(r)||(r=(0,D.$ic)(a,r)),r=(0,D.$gc)(r),L.$j?(r=(0,N.$Ke)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,N.$Ke)(r,D.sep),r||(r=D.sep)),r}e.$Zf=f;function u(r){const a=(0,D.$gc)(r);return L.$j?r.length>3?!1:d(a)&&(r.length===2||a.charCodeAt(2)===92):a===D.$fc.sep}e.$1f=u;function d(r,a=L.$j){return a?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$2f=d;function E(r,a=L.$j){return d(r,a)?r[0]:void 0}e.$3f=E;function s(r,a,v){return a.length>r.length?-1:r===a?0:(v&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$4f=s;function o(r){const a=r.split(":");let v,w,l;for(const m of a){const O=Number(m);(0,A.$Cf)(O)?w===void 0?w=O:l===void 0&&(l=O):v=v?[v,m].join(":"):m}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:w!==void 0?w:void 0,column:l!==void 0?l:w!==void 0?1:void 0}}e.$5f=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,v=8){let w="";for(let m=0;m<v;m++){let O;m===0&&L.$j&&!a&&(v===3||v===4)?O=i:O=n,w+=O.charAt(Math.floor(Math.random()*O.length))}let l;return a?l=`${a}-${w}`:l=w,r?(0,D.$ic)(r,l):l}e.$6f=t}),define(oe[139],ae([0,1,16]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=e.$Tr=e.$Sr=void 0,e.$Sr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},N={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const k=(0,D.$nc)(C),b=L[k.toLowerCase()];return b!==void 0?b:I(C)}e.$Tr=A;function I(C){const k=(0,D.$nc)(C);return N[k.toLowerCase()]}e.$Ur=I;function R(C){for(const k in N)if(N[k]===C)return k}e.$Vr=R;const S=/^(.+)\/(.+?)(;.+)?$/;function g(C,k){const b=S.exec(C);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:k?void 0:C}e.$Wr=g}),define(oe[90],ae([0,1,5]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0;var L;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(L||(e.Source=L={}));var N;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(N||(e.TerminateResponseCode=N={}));function A(R,...S){const g=S.reduce((b,c)=>(b[c]=!0,b),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(b=>!g[b]).forEach(b=>{for(let c=0;c<C.length;c++)if(b.search(C[c])!==-1){delete R[b];break}})}e.$zl=A;function I(R){R&&(delete R.DEBUG,D.$k&&delete R.DYLD_LIBRARY_PATH,D.$l&&delete R.LD_PRELOAD)}e.$Al=I}),define(oe[10],ae([0,1,16,5]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const N=/^\w[\w\d+.-]*$/,A=/^\//,I=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!N.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(i,t){return!i&&!t?"file":i}function g(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==k&&(t=k+t):t=k;break}return t}const C="",k="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(t){return t instanceof c?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,v,w,l=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=S(t,l),this.authority=r||C,this.path=g(this.scheme,a||C),this.query=v||C,this.fragment=w||C,R(this,l))}get fsPath(){return d(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:v,query:w,fragment:l}=t;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),v===void 0?v=this.path:v===null&&(v=C),w===void 0?w=this.query:w===null&&(w=C),l===void 0?l=this.fragment:l===null&&(l=C),r===this.scheme&&a===this.authority&&v===this.path&&w===this.query&&l===this.fragment?this:new p(r,a,v,w,l)}static parse(t,r=!1){const a=b.exec(t);return a?new p(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),r):new p(C,C,C,C,C)}static file(t){let r=C;if(L.$j&&(t=t.replace(/\\/g,k)),t[0]===k&&t[1]===k){const a=t.indexOf(k,2);a===-1?(r=t.substring(2),t=k):(r=t.substring(2,a),t=t.substring(a)||k)}return new p("file",r,t,C,C)}static from(t,r){return new p(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return L.$j&&t.scheme==="file"?a=c.file(D.$ec.join(d(t,!0),...r)).path:a=D.$fc.join(t.path,...r),t.with({path:a})}toString(t=!1){return E(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof c)return t;{const r=new p(t);return r._formatted=t.external??null,r._fsPath=t._sep===y?t.fsPath??null:null,r}}else return t}}e.URI=c;function $(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$uc=$;const y=L.$j?1:void 0;class p extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(t=!1){return t?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=y),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(i,t,r){let a,v=-1;for(let w=0;w<i.length;w++){const l=i.charCodeAt(w);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||t&&l===47||r&&l===91||r&&l===93||r&&l===58)v!==-1&&(a+=encodeURIComponent(i.substring(v,w)),v=-1),a!==void 0&&(a+=i.charAt(w));else{a===void 0&&(a=i.substr(0,w));const m=h[l];m!==void 0?(v!==-1&&(a+=encodeURIComponent(i.substring(v,w)),v=-1),a+=m):v===-1&&(v=w)}}return v!==-1&&(a+=encodeURIComponent(i.substring(v))),a!==void 0?a:i}function u(i){let t;for(let r=0;r<i.length;r++){const a=i.charCodeAt(r);a===35||a===63?(t===void 0&&(t=i.substr(0,r)),t+=h[a]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function d(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,L.$j&&(r=r.replace(/\//g,"\\")),r}e.$vc=d;function E(i,t){const r=t?u:f;let a="",{scheme:v,authority:w,path:l,query:m,fragment:O}=i;if(v&&(a+=v,a+=":"),(w||v==="file")&&(a+=k,a+=k),w){let F=w.indexOf("@");if(F!==-1){const z=w.substr(0,F);w=w.substr(F+1),F=z.lastIndexOf(":"),F===-1?a+=r(z,!1,!1):(a+=r(z.substr(0,F),!1,!1),a+=":",a+=r(z.substr(F+1),!1,!0)),a+="@"}w=w.toLowerCase(),F=w.lastIndexOf(":"),F===-1?a+=r(w,!1,!0):(a+=r(w.substr(0,F),!1,!0),a+=w.substr(F))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const F=l.charCodeAt(1);F>=65&&F<=90&&(l=`/${String.fromCharCode(F+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const F=l.charCodeAt(0);F>=65&&F<=90&&(l=`${String.fromCharCode(F+32)}:${l.substr(2)}`)}a+=r(l,!0,!1)}return m&&(a+="?",a+=r(m,!1,!1)),O&&(a+="#",a+=t?O:f(O,!1,!1)),a}function s(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(o)?i.replace(o,t=>s(t)):i}}),define(oe[140],ae([0,1,10]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$3p=e.$2p=e.$1p=void 0;function L(g){const C=g;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$1p=L;function N(g){const C=[];let k;try{const b=JSON.parse(g.arguments),c=b[b.length-1];c&&c.__$stack&&(b.pop(),k=c.__$stack),C.push(...b)}catch{C.push("Unable to log remote console arguments",g.arguments)}return{args:C,stack:k}}e.$2p=N;function A(g){if(typeof g!="string")return A(N(g).stack);const C=g;if(C){const k=I(C),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(b&&b.length===4)return{uri:D.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$3p=A;function I(g){if(!g)return g;const C=g.indexOf(`
`);return C===-1?g:g.substring(0,C)}function R(g,C){const{args:k,stack:b}=N(g),c=typeof k[0]=="string"&&k.length===1;let $=I(b);$&&($=`(${$.trim()})`);let y=[];if(typeof k[0]=="string"?$&&c?y=[`%c[${C}] %c${k[0]} %c${$}`,S("blue"),S(""),S("grey")]:y=[`%c[${C}] %c${k[0]}`,S("blue"),S(""),...k.slice(1)]:y=[`%c[${C}]%`,S("blue"),...k],$&&!c&&y.push($),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,y)}e.log=R;function S(g){return`color: ${g}`}}),define(oe[64],ae([0,1,15,10]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function N(S){return JSON.stringify(S,I)}e.$kh=N;function A(S){let g=JSON.parse(S);return g=R(g),g}e.$lh=A;function I(S,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function R(S,g=0){if(!S||g>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return L.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 17:return new Date(S.source)}if(S instanceof D.$be||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let C=0;C<S.length;++C)S[C]=R(S[C],g+1);else for(const C in S)Object.hasOwnProperty.call(S,C)&&(S[C]=R(S[C],g+1))}return S}e.$mh=R}),define(oe[23],ae([0,1,7,5,10]),function(te,e,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var A;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.$7f="vscode-tkn",e.$8f="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${A.vscodeRemoteResource}`}set(C,k,b){this.a[C]=k,this.b[C]=b}setConnectionToken(C,k){this.c[C]=k}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(p){return D.$Z(p),C}const k=C.authority;let b=this.a[k];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const c=this.b[k],$=this.c[k];let y=`path=${encodeURIComponent(C.path)}`;return typeof $=="string"&&(y+=`&${e.$8f}=${encodeURIComponent($)}`),N.URI.from({scheme:L.$p?this.d:A.vscodeRemoteResource,authority:`${b}:${c}`,path:this.f,query:y})}}e.$9f=new I,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class R{static{this.a=e.$bg}asBrowserUri(C){const k=this.b(C,te);return this.uriToBrowserUri(k)}uriToBrowserUri(C){return C.scheme===A.vscodeRemote?e.$9f.rewrite(C):C.scheme===A.file&&(L.$n||L.$q&&L.$h.origin===`${A.vscodeFileResource}://${R.a}`)?C.with({scheme:A.vscodeFileResource,authority:C.authority||R.a,query:null,fragment:null}):C}asFileUri(C){const k=this.b(C,te);return this.uriToFileUri(k)}uriToFileUri(C){return C.scheme===A.vscodeFileResource?C.with({scheme:A.file,authority:C.authority!==R.a?C.authority:null,query:null,fragment:null}):C}b(C,k){return N.URI.isUri(C)?C:N.URI.parse(k.toUrl(C))}}e.$cg=new R;var S;(function(g){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(C.get("3"));const k="vscode-coi";function b($){let y;typeof $=="string"?y=new URL($).searchParams:$ instanceof URL?y=$.searchParams:N.URI.isUri($)&&(y=new URL($.toString(!0)).searchParams);const p=y?.get(k);if(p)return C.get(p)}g.getHeadersFromQuery=b;function c($,y,p){if(!globalThis.crossOriginIsolated)return;const h=y&&p?"3":p?"2":"1";$ instanceof URLSearchParams?$.set(k,h):$[k]=h}g.addSearchParam=c})(S||(e.COI=S={}))}),define(oe[141],ae([0,1,123,23,5,10]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=void 0;class I{constructor(b,c,$){this.id=b,this.dependencies=c,this.callback=$}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,c,$)=>{typeof b!="string"&&($=c,c=b,b=null),(typeof c!="object"||!Array.isArray(c))&&($=c,c=null),this.c.push(new I(b,c,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const c=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!c)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}h(b){return new Promise((c,$)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const p=()=>{y.removeEventListener("load",h),y.removeEventListener("error",f)},h=u=>{p(),c(this.c.pop())},f=u=>{p(),$(u)};y.addEventListener("load",h),y.addEventListener("error",f),this.f&&(b=this.f.createScriptURL(b)),y.setAttribute("src",b),document.getElementsByTagName("head")[0].appendChild(y)})}i(b){return new Promise((c,$)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),c(this.c.pop())}catch(y){$(y)}})}async j(b){try{const c=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,p=A.URI.parse(b).fsPath,h=c.readFileSync(p).toString(),f=y.wrap(h.replace(/^#!.*/,""));return new $.Script(f).runInThisContext().apply(),this.c.pop()}catch(c){throw c}}}const S=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function C(k,b,c){if(D.$S){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[k]&&(k=g[k]);const $=`${k}/${b}`;if(S.has($))return S.get($);let y;if(/^\w[\w\d+.-]*:\/\//.test($))y=$;else{const u=`${c&&!N.$p?L.$_f:L.$$f}/${$}`;y=L.$cg.asBrowserUri(u).toString(!0)}const p=R.INSTANCE.load(y);return S.set($,p),p}else return await new Promise(($,y)=>{te([k],$,y)})}e.$zC=C}),define(oe[19],ae([0,1,48,23,16,5,27,10]),function(te,e,D,L,N,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function S(c){return(0,R.$vc)(c,!0)}e.$jg=S;class g{constructor($){this.a=$}compare($,y,p=!1){return $===y?0:(0,I.$Ue)(this.getComparisonKey($,p),this.getComparisonKey(y,p))}isEqual($,y,p=!1){return $===y?!0:!$||!y?!1:this.getComparisonKey($,p)===this.getComparisonKey(y,p)}getComparisonKey($,y=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,y,p=!1){if($.scheme===y.scheme){if($.scheme===L.Schemas.file)return D.$Xf(S($),S(y),this.a($))&&$.query===y.query&&(p||$.fragment===y.fragment);if((0,e.$Ag)($.authority,y.authority))return D.$Xf($.path,y.path,this.a($),"/")&&$.query===y.query&&(p||$.fragment===y.fragment)}return!1}joinPath($,...y){return R.URI.joinPath($,...y)}basenameOrAuthority($){return(0,e.$sg)($)||$.authority}basename($){return N.$fc.basename($.path)}extname($){return N.$fc.extname($.path)}dirname($){if($.path.length===0)return $;let y;return $.scheme===L.Schemas.file?y=R.URI.file(N.$lc(S($))).path:(y=N.$fc.dirname($.path),$.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),y="/")),$.with({path:y})}normalizePath($){if(!$.path.length)return $;let y;return $.scheme===L.Schemas.file?y=R.URI.file(N.$gc(S($))).path:y=N.$fc.normalize($.path),$.with({path:y})}relativePath($,y){if($.scheme!==y.scheme||!(0,e.$Ag)($.authority,y.authority))return;if($.scheme===L.Schemas.file){const f=N.$kc(S($),S(y));return A.$j?D.$Rf(f):f}let p=$.path||"/";const h=y.path||"/";if(this.a($)){let f=0;for(const u=Math.min(p.length,h.length);f<u&&!(p.charCodeAt(f)!==h.charCodeAt(f)&&p.charAt(f).toLowerCase()!==h.charAt(f).toLowerCase());f++);p=h.substr(0,f)+p.substr(f)}return N.$fc.relative(p,h)}resolvePath($,y){if($.scheme===L.Schemas.file){const p=R.URI.file(N.$jc(S($),y));return $.with({authority:p.authority,path:p.path})}return y=D.$Sf(y),$.with({path:N.$fc.resolve($.path,y)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,y){return $===y||$!==void 0&&y!==void 0&&(0,I.$2e)($,y)}hasTrailingPathSeparator($,y=N.sep){if($.scheme===L.Schemas.file){const p=S($);return p.length>D.$Tf(p).length&&p[p.length-1]===y}else{const p=$.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,y=N.sep){return(0,e.$Bg)($,y)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,y=N.sep){let p=!1;if($.scheme===L.Schemas.file){const h=S($);p=h!==void 0&&h.length===D.$Tf(h).length&&h[h.length-1]===y}else{y="/";const h=$.path;p=h.length===1&&h.charCodeAt(h.length-1)===47}return!p&&!(0,e.$Bg)($,y)?$.with({path:$.path+"/"}):$}}e.$kg=g,e.$lg=new g(()=>!1),e.$mg=new g(c=>c.scheme===L.Schemas.file?!A.$l:!0),e.$ng=new g(c=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function C(c,$){const y=[];for(let p=0;p<c.length;p++){const h=$(c[p]);c.some((f,u)=>u===p?!1:(0,e.$pg)(h,$(f)))||y.push(c[p])}return y}e.$Eg=C;var k;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function $(y){const p=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(u=>{const[d,E]=u.split(":");d&&E&&p.set(d,E)});const f=y.path.substring(0,y.path.indexOf(";"));return f&&p.set(c.META_DATA_MIME,f),p}c.parseMetaData=$})(k||(e.DataUri=k={}));function b(c,$,y){if($){let p=c.path;return p&&p[0]!==N.$fc.sep&&(p=N.$fc.sep+p),c.with({scheme:y,authority:$,path:p})}return c.with({scheme:y})}e.$Fg=b}),define(oe[6],ae([0,1,26,7,3,2,19,5,129]),function(te,e,D,L,N,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function g(j){return!!j&&typeof j.then=="function"}e.$Gg=g;function C(j){const T=new D.$Xd,M=j(T.token),H=new Promise((J,re)=>{const ce=T.token.onCancellationRequested(()=>{ce.dispose(),T.dispose(),re(new L.$4)});Promise.resolve(M).then(ue=>{ce.dispose(),T.dispose(),J(ue)},ue=>{ce.dispose(),T.dispose(),re(ue)})});return new class{cancel(){T.cancel()}then(J,re){return H.then(J,re)}catch(J){return this.then(void 0,J)}finally(J){return H.finally(J)}}}e.$Hg=C;function k(j,T,M){return new Promise((H,J)=>{const re=T.onCancellationRequested(()=>{re.dispose(),H(M)});j.then(H,J).finally(()=>re.dispose())})}e.$Ig=k;function b(j,T){return new Promise((M,H)=>{const J=T.onCancellationRequested(()=>{J.dispose(),H(new L.$4)});j.then(M,H).finally(()=>J.dispose())})}e.$Jg=b;async function c(j){let T=-1;const M=j.map((H,J)=>H.then(re=>(T=J,re)));try{return await Promise.race(M)}finally{j.forEach((H,J)=>{J!==T&&H.cancel()})}}e.$Kg=c;function $(j,T,M){let H;const J=setTimeout(()=>{H?.(void 0),M?.()},T);return Promise.race([j.finally(()=>clearTimeout(J)),new Promise(re=>H=re)])}e.$Lg=$;function y(j){return new Promise((T,M)=>{const H=j();g(H)?H.then(T,M):T(H)})}e.$Mg=y;class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(T){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=T,!this.b){const M=()=>{if(this.b=null,this.f)return;const H=this.queue(this.d);return this.d=null,H};this.b=new Promise(H=>{this.a.then(M,M).then(H)})}return new Promise((M,H)=>{this.b.then(M,H)})}return this.a=T(),new Promise((M,H)=>{this.a.then(J=>{this.a=null,M(J)},J=>{this.a=null,H(J)})})}dispose(){this.f=!0}}e.$Ng=p;class h{constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.$Og=h;class f{constructor(){this.a=new Map}queue(T,M){const J=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(T)===J&&this.a.delete(T)});return this.a.set(T,J),J}}e.$Pg=f;const u=(j,T)=>{let M=!0;const H=setTimeout(()=>{M=!1,T()},j);return{isTriggered:()=>M,dispose:()=>{clearTimeout(H),M=!1}}},d=j=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,j())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class E{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,M=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((J,re)=>{this.d=J,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const J=this.g;return this.g=null,J()}}));const H=()=>{this.a=null,this.d?.(null)};return this.a=M===S.$Kd?d(H):u(M,H),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=E;class s{constructor(T){this.a=new E(T),this.b=new p}trigger(T,M){return this.a.trigger(()=>this.b.queue(T),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=s;class o{constructor(){this.a=!1,this.b=new Promise((T,M)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=o;class n extends o{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.$Tg=n;function i(j,T){return T?new Promise((M,H)=>{const J=setTimeout(()=>{re.dispose(),M()},j),re=T.onCancellationRequested(()=>{clearTimeout(J),re.dispose(),H(new L.$4)})}):C(M=>i(j,M))}e.$Ug=i;function t(j,T=0,M){const H=setTimeout(()=>{j(),M&&J.dispose()},T),J=(0,A.$Pc)(()=>{clearTimeout(H),M?.deleteAndLeak(J)});return M?.add(J),J}e.$Vg=t;function r(j){const T=[];let M=0;const H=j.length;function J(){return M<H?j[M++]():null}function re(ce){ce!=null&&T.push(ce);const ue=J();return ue?ue.then(re):Promise.resolve(T)}return Promise.resolve(null).then(re)}e.$Wg=r;function a(j,T=H=>!!H,M=null){let H=0;const J=j.length,re=()=>{if(H>=J)return Promise.resolve(M);const ce=j[H++];return Promise.resolve(ce()).then(he=>T(he)?Promise.resolve(he):re())};return re()}e.$Xg=a;function v(j,T=H=>!!H,M=null){if(j.length===0)return Promise.resolve(M);let H=j.length;const J=()=>{H=-1;for(const re of j)re.cancel?.()};return new Promise((re,ce)=>{for(const ue of j)ue.then(he=>{--H>=0&&T(he)?(J(),re(he)):H===0&&re(M)}).catch(he=>{--H>=0&&(J(),ce(he))})})}e.$Yg=v;class w{constructor(T){this.a=0,this.d=T,this.f=[],this.b=0,this.g=new N.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(T){return this.a++,new Promise((M,H)=>{this.f.push({factory:T,c:M,e:H}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const T=this.f.shift();this.b++;const M=T.factory();M.then(T.c,T.e),M.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=w;class l extends w{constructor(){super(1)}}e.$1g=l;class m{constructor(){this.a=new Q,this.b=0}queue(T){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,T())):this.a.run(this.b++,T())}}e.$2g=m;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const T=new ee;return this.b.add(T),T.p}g(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueFor(T,M=I.$lg){const H=M.getComparisonKey(T);let J=this.a.get(H);if(!J){J=new l;const re=this.f++,ce=N.Event.once(J.onDrained)(()=>{J?.dispose(),this.a.delete(H),this.h(),this.d?.deleteAndDispose(re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$Zc),this.d.set(re,ce),this.a.set(H,J)}return J}h(){this.g()&&this.j()}j(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=O;class F{constructor(T,M){this.a=-1,typeof T=="function"&&typeof M=="number"&&this.setIfNotSet(T,M)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,M){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},M)}setIfNotSet(T,M){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},M))}}e.$4g=F;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(T,M){this.cancel(),this.a=setInterval(()=>{T()},M)}}e.$5g=z;class U{constructor(T,M){this.b=-1,this.a=T,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=U;class B{constructor(T,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=T,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=B;class Y extends U{constructor(T,M){super(T,M),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.$8g=Y;class K extends A.$Rc{constructor(T,M){super(),this.g=T,this.h=M,this.a=[],this.b=this.B(new A.$Sc),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const M of T)this.a.push(M);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=K,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=j=>{(0,R.$B)(()=>{if(T)return;const M=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.$0g=(j,T)=>{const M=requestIdleCallback(j,typeof T=="number"?{timeout:T}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(M))}}}}();class x{constructor(T){this.d=!1,this.a=()=>{try{this.f=T()}catch(M){this.g=M}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=x;async function V(j,T,M){let H;for(let J=0;J<M;J++)try{return await j()}catch(re){H=re,await i(T)}throw H}e.$_g=V;class Q{isRunning(T){return typeof T=="number"?this.a?.taskId===T:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(T,M,H){return this.a={taskId:T,cancel:()=>H?.(),promise:M},M.then(()=>this.d(T),()=>this.d(T)),M}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}queue(T){if(this.b)this.b.run=T;else{let M,H;const J=new Promise((re,ce)=>{M=re,H=ce});this.b={run:T,promise:J,promiseResolve:M,promiseReject:H}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=Q;class G{constructor(T,M=()=>Date.now()){this.d=T,this.f=M,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.$bh=G;var W;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(W||(W={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((T,M)=>{this.a=T,this.b=M})}complete(T){return new Promise(M=>{this.a(T),this.d={outcome:0,value:T},M()})}error(T){return new Promise(M=>{this.b(T),this.d={outcome:1,value:T},M()})}cancel(){return this.error(new L.$4)}}e.$ch=ee;var ie;(function(j){async function T(H){let J;const re=await Promise.all(H.map(ce=>ce.then(ue=>ue,ue=>{J||(J=ue)})));if(typeof J<"u")throw J;return re}j.settled=T;function M(H){return new Promise(async(J,re)=>{try{await H(J,re)}catch(ce){re(ce)}})}j.withAsyncBody=M})(ie||(e.Promises=ie={}));var _;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(_||(_={}));class ne{static fromArray(T){return new ne(M=>{M.emitMany(T)})}static fromPromise(T){return new ne(async M=>{M.emitMany(await T)})}static fromPromises(T){return new ne(async M=>{await Promise.all(T.map(async H=>M.emitOne(await H)))})}static merge(T){return new ne(async M=>{await Promise.all(T.map(async H=>{for await(const J of H)M.emitOne(J)}))})}static{this.EMPTY=ne.fromArray([])}constructor(T){this.a=0,this.b=[],this.d=null,this.f=new N.$Nd,queueMicrotask(async()=>{const M={emitOne:H=>this.g(H),emitMany:H=>this.h(H),reject:H=>this.k(H)};try{await Promise.resolve(T(M)),this.j()}catch(H){this.k(H)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await N.Event.toPromise(this.f.event)}while(!0)}}}static map(T,M){return new ne(async H=>{for await(const J of T)H.emitOne(M(J))})}map(T){return ne.map(this,T)}static filter(T,M){return new ne(async H=>{for await(const J of T)M(J)&&H.emitOne(J)})}filter(T){return ne.filter(this,T)}static coalesce(T){return ne.filter(T,M=>!!M)}coalesce(){return ne.coalesce(this)}static async toPromise(T){const M=[];for await(const H of T)M.push(H);return M}toPromise(){return ne.toPromise(this)}g(T){this.a===0&&(this.b.push(T),this.f.fire())}h(T){this.a===0&&(this.b=this.b.concat(T),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(T){this.a===0&&(this.a=2,this.d=T,this.f.fire())}}e.$dh=ne;class Z extends ne{constructor(T,M){super(M),this.l=T}cancel(){this.l.cancel()}}e.$eh=Z;function q(j){const T=new D.$Xd,M=j(T.token);return new Z(T,async H=>{const J=T.token.onCancellationRequested(()=>{J.dispose(),T.dispose(),H.reject(new L.$4)});try{for await(const re of M){if(T.token.isCancellationRequested)return;H.emitOne(re)}J.dispose(),T.dispose()}catch(re){J.dispose(),T.dispose(),H.reject(re)}})}e.$fh=q;class P{constructor(){this.a=new ee,this.b=new ne(H=>{if(T){H.reject(T);return}return M&&H.emitMany(M),this.d=J=>H.reject(J),this.f=J=>H.emitOne(J),this.a.p});let T,M;this.f=H=>{M||(M=[]),M.push(H)},this.d=H=>{T||(T=H)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(T){this.d(T),this.a.complete()}emitOne(T){this.f(T)}}e.$gh=P}),define(oe[91],ae([0,1,18,6,48,34,16,5,27]),function(te,e,D,L,N,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function g(){return Object.create(null)}e.$rj=g,e.$sj="**",e.$tj="/";const C="[/\\\\]",k="[^/\\\\]",b=/\//g;function c(Q,G){switch(Q){case 0:return"";case 1:return`${k}*?`;default:return`(?:${C}|${k}+${C}${G?`|${C}${k}+`:""})*?`}}function $(Q,G){if(!Q)return[];const W=[];let ee=!1,ie=!1,_="";for(const ne of Q){switch(ne){case G:if(!ee&&!ie){W.push(_),_="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}_+=ne}return _&&W.push(_),W}e.$uj=$;function y(Q){if(!Q)return"";let G="";const W=$(Q,e.$tj);if(W.every(ee=>ee===e.$sj))G=".*";else{let ee=!1;W.forEach((ie,_)=>{if(ie===e.$sj){if(ee)return;G+=c(2,_===W.length-1)}else{let ne=!1,Z="",q=!1,P="";for(const j of ie){if(j!=="}"&&ne){Z+=j;continue}if(q&&(j!=="]"||!P)){let T;j==="-"?T=j:(j==="^"||j==="!")&&!P?T="^":j===e.$tj?T="":T=(0,S.$Fe)(j),P+=T;continue}switch(j){case"{":ne=!0;continue;case"[":q=!0;continue;case"}":{const M=`(?:${$(Z,",").map(H=>y(H)).join("|")})`;G+=M,ne=!1,Z="";break}case"]":{G+="["+P+"]",q=!1,P="";break}case"?":G+=k;continue;case"*":G+=c(1);continue;default:G+=(0,S.$Fe)(j)}}_<W.length-1&&(W[_+1]!==e.$sj||_+2<W.length)&&(G+=C)}ee=ie===e.$sj})}return G}const p=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,E=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new A.$Cc(1e4),o=function(){return!1},n=function(){return null};function i(Q,G){if(!Q)return n;let W;typeof Q!="string"?W=Q.pattern:W=Q,W=W.trim();const ee=`${W}_${!!G.trimForExclusions}`;let ie=s.get(ee);if(ie)return t(ie,Q);let _;return p.test(W)?ie=a(W.substr(4),W):(_=h.exec(r(W,G)))?ie=v(_[1],W):(G.trimForExclusions?u:f).test(W)?ie=w(W,G):(_=d.exec(r(W,G)))?ie=l(_[1].substr(1),W,!0):(_=E.exec(r(W,G)))?ie=l(_[1],W,!1):ie=m(W),s.set(ee,ie),t(ie,Q)}function t(Q,G){if(typeof G=="string")return Q;const W=function(ee,ie){return(0,N.$Xf)(ee,G.base,!R.$l)?Q((0,S.$Je)(ee.substr(G.base.length),I.sep),ie):null};return W.allBasenames=Q.allBasenames,W.allPaths=Q.allPaths,W.basenames=Q.basenames,W.patterns=Q.patterns,W}function r(Q,G){return G.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function a(Q,G){return function(W,ee){return typeof W=="string"&&W.endsWith(Q)?G:null}}function v(Q,G){const W=`/${Q}`,ee=`\\${Q}`,ie=function(ne,Z){return typeof ne!="string"?null:Z?Z===Q?G:null:ne===Q||ne.endsWith(W)||ne.endsWith(ee)?G:null},_=[Q];return ie.basenames=_,ie.patterns=[G],ie.allBasenames=_,ie}function w(Q,G){const W=x(Q.slice(1,-1).split(",").map(Z=>i(Z,G)).filter(Z=>Z!==n),Q),ee=W.length;if(!ee)return n;if(ee===1)return W[0];const ie=function(Z,q){for(let P=0,j=W.length;P<j;P++)if(W[P](Z,q))return Q;return null},_=W.find(Z=>!!Z.allBasenames);_&&(ie.allBasenames=_.allBasenames);const ne=W.reduce((Z,q)=>q.allPaths?Z.concat(q.allPaths):Z,[]);return ne.length&&(ie.allPaths=ne),ie}function l(Q,G,W){const ee=I.sep===I.$fc.sep,ie=ee?Q:Q.replace(b,I.sep),_=I.sep+ie,ne=I.$fc.sep+Q;let Z;return W?Z=function(q,P){return typeof q=="string"&&(q===ie||q.endsWith(_)||!ee&&(q===Q||q.endsWith(ne)))?G:null}:Z=function(q,P){return typeof q=="string"&&(q===ie||!ee&&q===Q)?G:null},Z.allPaths=[(W?"*/":"./")+Q],Z}function m(Q){try{const G=new RegExp(`^${y(Q)}$`);return function(W){return G.lastIndex=0,typeof W=="string"&&G.test(W)?Q:null}}catch{return n}}function O(Q,G,W){return!Q||typeof G!="string"?!1:F(Q)(G,void 0,W)}e.$vj=O;function F(Q,G={}){if(!Q)return o;if(typeof Q=="string"||z(Q)){const W=i(Q,G);if(W===n)return o;const ee=function(ie,_){return!!W(ie,_)};return W.allBasenames&&(ee.allBasenames=W.allBasenames),W.allPaths&&(ee.allPaths=W.allPaths),ee}return Y(Q,G)}e.$wj=F;function z(Q){const G=Q;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$xj=z;function U(Q){return Q.allBasenames||[]}e.$yj=U;function B(Q){return Q.allPaths||[]}e.$zj=B;function Y(Q,G){const W=x(Object.getOwnPropertyNames(Q).map(Z=>K(Z,Q[Z],G)).filter(Z=>Z!==n)),ee=W.length;if(!ee)return n;if(!W.some(Z=>!!Z.requiresSiblings)){if(ee===1)return W[0];const Z=function(j,T){let M;for(let H=0,J=W.length;H<J;H++){const re=W[H](j,T);if(typeof re=="string")return re;(0,L.$Gg)(re)&&(M||(M=[]),M.push(re))}return M?(async()=>{for(const H of M){const J=await H;if(typeof J=="string")return J}return null})():null},q=W.find(j=>!!j.allBasenames);q&&(Z.allBasenames=q.allBasenames);const P=W.reduce((j,T)=>T.allPaths?j.concat(T.allPaths):j,[]);return P.length&&(Z.allPaths=P),Z}const ie=function(Z,q,P){let j,T;for(let M=0,H=W.length;M<H;M++){const J=W[M];J.requiresSiblings&&P&&(q||(q=(0,I.$mc)(Z)),j||(j=q.substr(0,q.length-(0,I.$nc)(Z).length)));const re=J(Z,q,j,P);if(typeof re=="string")return re;(0,L.$Gg)(re)&&(T||(T=[]),T.push(re))}return T?(async()=>{for(const M of T){const H=await M;if(typeof H=="string")return H}return null})():null},_=W.find(Z=>!!Z.allBasenames);_&&(ie.allBasenames=_.allBasenames);const ne=W.reduce((Z,q)=>q.allPaths?Z.concat(q.allPaths):Z,[]);return ne.length&&(ie.allPaths=ne),ie}function K(Q,G,W){if(G===!1)return n;const ee=i(Q,W);if(ee===n)return n;if(typeof G=="boolean")return ee;if(G){const ie=G.when;if(typeof ie=="string"){const _=(ne,Z,q,P)=>{if(!P||!ee(ne,Z))return null;const j=ie.replace("$(basename)",()=>q),T=P(j);return(0,L.$Gg)(T)?T.then(M=>M?Q:null):T?Q:null};return _.requiresSiblings=!0,_}}return ee}function x(Q,G){const W=Q.filter(Z=>!!Z.basenames);if(W.length<2)return Q;const ee=W.reduce((Z,q)=>{const P=q.basenames;return P?Z.concat(P):Z},[]);let ie;if(G){ie=[];for(let Z=0,q=ee.length;Z<q;Z++)ie.push(G)}else ie=W.reduce((Z,q)=>{const P=q.patterns;return P?Z.concat(P):Z},[]);const _=function(Z,q){if(typeof Z!="string")return null;if(!q){let j;for(j=Z.length;j>0;j--){const T=Z.charCodeAt(j-1);if(T===47||T===92)break}q=Z.substr(j)}const P=ee.indexOf(q);return P!==-1?ie[P]:null};_.basenames=ee,_.patterns=ie,_.allBasenames=ee;const ne=Q.filter(Z=>!Z.basenames);return ne.push(_),ne}function V(Q,G){return(0,D.$tb)(Q,G,(W,ee)=>typeof W=="string"&&typeof ee=="string"?W===ee:typeof W!="string"&&typeof ee!="string"?W.base===ee.base&&W.pattern===ee.pattern:!1)}e.$Aj=V}),define(oe[92],ae([0,1,15,10]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function N(k){return k.toJSON()}class A{constructor(b){this.a=b}transformIncoming(b){const c=this.a.transformIncoming(b);return c===b?b:N(L.URI.from(c))}transformOutgoing(b){const c=this.a.transformOutgoing(b);return c===b?b:N(L.URI.from(c))}transformOutgoingURI(b){const c=this.a.transformOutgoing(b);return c===b?b:L.URI.from(c)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$Lm=A,e.$Mm=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function I(k,b,c){if(!k||c>200)return null;if(typeof k=="object"){if(k instanceof L.URI)return b.transformOutgoing(k);for(const $ in k)if(Object.hasOwnProperty.call(k,$)){const y=I(k[$],b,c+1);y!==null&&(k[$]=y)}}return null}function R(k,b){const c=I(k,b,0);return c===null?k:c}e.$Nm=R;function S(k,b,c,$){if(!k||$>200)return null;if(typeof k=="object"){if(k.$mid===1)return c?L.URI.revive(b.transformIncoming(k)):b.transformIncoming(k);if(k instanceof D.$be)return null;for(const y in k)if(Object.hasOwnProperty.call(k,y)){const p=S(k[y],b,c,$+1);p!==null&&(k[y]=p)}}return null}function g(k,b){const c=S(k,b,!1,0);return c===null?k:c}e.$Om=g;function C(k,b){const c=S(k,b,!0,0);return c===null?k:c}e.$Pm=C}),define(oe[142],ae([0,1,36,47,32,130,5]),function(te,e,D,L,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0,e.$Rm=new class{c(b){return this.a||(this.a=L.$Vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,c=0;const $=(0,D.networkInterfaces)();for(const y in $){const p=$[y];if(p)for(const{mac:h,internal:f}of p)f||(c+=1,this.c(h.toUpperCase())&&(b+=1))}this.b=c>0?b/c:0}return this.b}};let R;async function S(b){return R||(R=(async()=>await g(b)||N.$eg())()),R}e.$Sm=S;async function g(b){try{const c=await new Promise((y,p)=>{te(["crypto"],y,p)}),$=(0,A.$Qm)();return c.createHash("sha256").update($,"utf8").digest("hex")}catch(c){b(c);return}}const C="Software\\Microsoft\\SQMClient";async function k(b){if(I.$j){const c=await new Promise(($,y)=>{te(["@vscode/windows-registry"],$,y)});try{return c.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch($){return b($),""}}return""}e.$Tm=k}),define(oe[31],ae([0,1,53,36,267,6,48,88,16,5,19,10]),function(te,e,D,L,N,A,I,R,S,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function c(K,x=b.UNLINK,V){if((0,I.$1f)(K))throw new Error("rimraf - will refuse to recursively delete root");return x===b.UNLINK?y(K):$(K,V)}async function $(K,x=(0,I.$6f)((0,L.tmpdir)())){try{try{await D.promises.rename(K,x)}catch(V){return V.code==="ENOENT"?void 0:y(K)}y(x).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function y(K){return(0,N.promisify)(D.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function p(K){if((0,I.$1f)(K))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function h(K,x){return d(await(x?f(K):(0,N.promisify)(D.readdir)(K)))}async function f(K){try{return await(0,N.promisify)(D.readdir)(K,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const x=[],V=await h(K);for(const Q of V){let G=!1,W=!1,ee=!1;try{const ie=await e.Promises.lstat((0,S.$ic)(K,Q));G=ie.isFile(),W=ie.isDirectory(),ee=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}x.push({name:Q,isFile:()=>G,isDirectory:()=>W,isSymbolicLink:()=>ee})}return x}function u(K){return d(D.readdirSync(K))}e.readdirSync=u;function d(K){return K.map(x=>typeof x=="string"?g.$k?(0,R.$ol)(x):x:(x.name=g.$k?(0,R.$ol)(x.name):x.name,x))}async function E(K){const x=await h(K),V=[];for(const Q of x)await o.existsDirectory((0,S.$ic)(K,Q))&&V.push(Q);return V}function s(K,x=1e3){return new Promise(V=>{let Q=!1;const G=setInterval(()=>{Q||(Q=!0,D.access(K,W=>{Q=!1,W&&(clearInterval(G),V(void 0))}))},x)})}e.whenDeleted=s;var o;(function(K){async function x(G){let W;try{if(W=await e.Promises.lstat(G),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(g.$j&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw ie}throw ee}}K.stat=x;async function V(G){try{const{stat:W,symbolicLink:ee}=await K.stat(G);return W.isFile()&&ee?.dangling!==!0}catch{}return!1}K.existsFile=V;async function Q(G){try{const{stat:W,symbolicLink:ee}=await K.stat(G);return W.isDirectory()&&ee?.dangling!==!0}catch{}return!1}K.existsDirectory=Q})(o||(e.SymlinkSupport=o={}));const n=new A.$3g;function i(K,x,V){return n.queueFor(k.URI.file(K),C.$mg).queue(()=>{const Q=w(V);return new Promise((G,W)=>a(K,x,Q,ee=>ee?W(ee):G()))})}let t=!0;function r(K){t=K}e.configureFlushOnWrite=r;function a(K,x,V,Q){if(!t)return D.writeFile(K,x,{mode:V.mode,flag:V.flag},Q);D.open(K,V.flag,V.mode,(G,W)=>{if(G)return Q(G);D.writeFile(W,x,ee=>{if(ee)return D.close(W,()=>Q(ee));D.fdatasync(W,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),r(!1)),D.close(W,_=>Q(_))))})})}function v(K,x,V){const Q=w(V);if(!t)return D.writeFileSync(K,x,{mode:Q.mode,flag:Q.flag});const G=D.openSync(K,Q.flag,Q.mode);try{D.writeFileSync(G,x);try{D.fdatasyncSync(G)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),r(!1)}}finally{D.closeSync(G)}}e.writeFileSync=v;function w(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function l(K,x,V=6e4){if(K!==x)try{g.$j&&typeof V=="number"?await m(K,x,Date.now(),V):await(0,N.promisify)(D.rename)(K,x)}catch(Q){if(K.toLowerCase()!==x.toLowerCase()&&Q.code==="EXDEV"||K.endsWith("."))await O(K,x,{preserveSymlinks:!1}),await c(K,b.MOVE);else throw Q}}async function m(K,x,V,Q,G=0){try{return await(0,N.promisify)(D.rename)(K,x)}catch(W){if(W.code!=="EACCES"&&W.code!=="EPERM"&&W.code!=="EBUSY")throw W;if(Date.now()-V>=Q)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${W}`),W;if(G===0){let ee=!1;try{const{stat:ie}=await o.stat(x);ie.isFile()||(ee=!0)}catch{}if(ee)throw W}return await(0,A.$Ug)(Math.min(100,G*10)),m(K,x,V,Q,G+1)}}async function O(K,x,V){return z(K,x,{root:{source:K,target:x},options:V,handledSourcePaths:new Set})}const F=511;async function z(K,x,V){if(V.handledSourcePaths.has(K))return;V.handledSourcePaths.add(K);const{stat:Q,symbolicLink:G}=await o.stat(K);if(G){if(V.options.preserveSymlinks)try{return await Y(K,x,V)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(G.dangling)return}return Q.isDirectory()?U(K,x,Q.mode&F,V):B(K,x,Q.mode&F)}async function U(K,x,V,Q){await e.Promises.mkdir(x,{recursive:!0,mode:V});const G=await h(K);for(const W of G)await z((0,S.$ic)(K,W),(0,S.$ic)(x,W),Q)}async function B(K,x,V){await e.Promises.copyFile(K,x),await e.Promises.chmod(x,V)}async function Y(K,x,V){let Q=await e.Promises.readlink(K);(0,I.$Xf)(Q,V.root.source,!g.$l)&&(Q=(0,S.$ic)(V.root.target,Q.substr(V.root.source.length+1))),await e.Promises.symlink(Q,x)}e.Promises=new class{get access(){return(0,N.promisify)(D.access)}get stat(){return(0,N.promisify)(D.stat)}get lstat(){return(0,N.promisify)(D.lstat)}get utimes(){return(0,N.promisify)(D.utimes)}get read(){return(K,x,V,Q,G)=>new Promise((W,ee)=>{D.read(K,x,V,Q,G,(ie,_,ne)=>ie?ee(ie):W({bytesRead:_,buffer:ne}))})}get readFile(){return(0,N.promisify)(D.readFile)}get write(){return(K,x,V,Q,G)=>new Promise((W,ee)=>{D.write(K,x,V,Q,G,(ie,_,ne)=>ie?ee(ie):W({bytesWritten:_,buffer:ne}))})}get appendFile(){return(0,N.promisify)(D.appendFile)}get fdatasync(){return(0,N.promisify)(D.fdatasync)}get truncate(){return(0,N.promisify)(D.truncate)}get copyFile(){return(0,N.promisify)(D.copyFile)}get open(){return(0,N.promisify)(D.open)}get close(){return(0,N.promisify)(D.close)}get symlink(){return(0,N.promisify)(D.symlink)}get readlink(){return(0,N.promisify)(D.readlink)}get chmod(){return(0,N.promisify)(D.chmod)}get mkdir(){return(0,N.promisify)(D.mkdir)}get unlink(){return(0,N.promisify)(D.unlink)}get rmdir(){return(0,N.promisify)(D.rmdir)}get realpath(){return(0,N.promisify)(D.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return E}get writeFile(){return i}get rm(){return c}get rename(){return l}get copy(){return O}}}),define(oe[143],ae([0,1,53,16,5,27,31]),function(te,e,D,L,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.$9p=e.$8p=void 0;function R(b){if(N.$l)return b;const c=(0,L.$lc)(b);if(b===c)return b;const $=((0,L.$mc)(b)||b).toLowerCase();try{const p=(0,I.readdirSync)(c).filter(h=>h.toLowerCase()===$);if(p.length===1){const h=R(c);if(h)return(0,L.$ic)(h,p[0])}else if(p.length>1){const h=p.indexOf($);if(h>=0){const f=R(c);if(f)return(0,L.$ic)(f,p[h])}}}catch{}return null}e.$8p=R;async function S(b){if(N.$l)return b;const c=(0,L.$lc)(b);if(b===c)return b;const $=((0,L.$mc)(b)||b).toLowerCase();try{const p=(await I.Promises.readdir(c)).filter(h=>h.toLowerCase()===$);if(p.length===1){const h=await S(c);if(h)return(0,L.$ic)(h,p[0])}else if(p.length>1){const h=p.indexOf($);if(h>=0){const f=await S(c);if(f)return(0,L.$ic)(f,p[h])}}}catch{}return null}e.$9p=S;async function g(b){try{return await I.Promises.realpath(b)}catch{const $=k(b);return await I.Promises.access($,D.constants.R_OK),$}}e.$0p=g;function C(b){try{return D.realpathSync(b)}catch{const $=k(b);return D.accessSync($,D.constants.R_OK),$}}e.$$p=C;function k(b){return(0,A.$Ke)((0,L.$gc)(b),L.sep)}}),define(oe[144],ae([0,1,16,5,37,90,12,31]),function(te,e,D,L,N,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function S(k=N.env){return k.comspec||"cmd.exe"}e.$Bl=S;function g(k){let b=[],c=!1;const $=function(y){if(c){b.push(y);return}(!k.send(y,h=>{if(h&&console.error(h),c=!1,b.length>0){const f=b.slice(0);b=[],f.forEach(u=>$(u))}})||L.$j)&&(c=!0)};return{send:$}}e.$Cl=g;var C;(function(k){async function b(c,$,y){if(D.$hc(c))return c;if($===void 0&&($=N.cwd()),D.$lc(c)!=="."||(y===void 0&&I.$yf(N.env.PATH)&&(y=N.env.PATH.split(D.$sc)),y===void 0||y.length===0))return D.$ic($,c);async function h(f){if(await R.Promises.exists(f)){let u;try{u=await R.Promises.stat(f)}catch(d){d.message.startsWith("EACCES")&&(u=await R.Promises.lstat(f))}return u?!u.isDirectory():!1}return!1}for(const f of y){let u;if(D.$hc(f)?u=D.$ic(f,c):u=D.$ic($,f,c),await h(u))return u;let d=u+".com";if(await h(d)||(d=u+".exe",await h(d)))return d}return D.$ic($,c)}k.findExecutable=b})(C||(e.win32=C={}))}),define(oe[145],ae([0,1,65,23]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;function N(I){return new Promise((R,S)=>{let g;const C=new Map;function k(c,$,y,p,h){const f=C.get($);if(c===I||f){const u={name:b(y),cmd:y,pid:c,ppid:$,load:p,mem:h};C.set(c,u),c===I&&(g=u),f&&(f.children||(f.children=[]),f.children.push(u),f.children.length>1&&(f.children=f.children.sort((d,E)=>d.pid-E.pid)))}}function b(c){const $=/--utility-sub-type=network/i,y=/--ms-enable-electron-run-as-node/i,p=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(p.exec(c))return"electron-crash-reporter";if(h.exec(c))return"winpty-agent";if(f.exec(c))return"conpty-agent";let d=u.exec(c);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?$.exec(c)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const E=/[a-zA-Z-]+\.js/g;let s="";do d=E.exec(c),d&&(s+=d+" ");while(d);return s&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${s})`:y.exec(c)?`electron-nodejs (${c})`:c}if(process.platform==="win32"){const c=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,y)=>{te(["@vscode/windows-process-tree"],$,y)}).then($=>{$.getProcessList(I,y=>{if(!y){S(new Error(`Root process ${I} not found`));return}$.getProcessCpuUsage(y,p=>{const h=new Map;p.forEach(f=>{const u=c(f.commandLine||"");h.set(f.pid,{name:b(u),cmd:u,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),g=h.get(I),g?(h.forEach(f=>{const u=h.get(f.ppid);u&&(u.children||(u.children=[]),u.children.push(f))}),h.forEach(f=>{f.children&&(f.children=f.children.sort((u,d)=>u.pid-d.pid))}),R(g)):S(new Error(`Root process ${I} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let c=function(){let $=[g];const y=[];for(;$.length;){const h=$.shift();h&&(y.push(h.pid),h.children&&($=$.concat(h.children)))}let p=JSON.stringify(L.$cg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+y.join(" "),(0,D.exec)(p,{},(h,f,u)=>{if(h||u)S(h||new Error(u.toString()));else{const d=f.toString().split(`
`);for(let E=0;E<y.length;E++){const s=C.get(y[E]);s.load=parseFloat(d[E])}if(!g){S(new Error(`Root process ${I} not found`));return}R(g)}})};(0,D.exec)("which ps",{},($,y,p)=>{if($||p)if(process.platform!=="linux")S($||new Error(p.toString()));else{const h=JSON.stringify(L.$cg.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(h,{},(f,u,d)=>{f||d?S(f||new Error(d.toString())):(A(u,k),c())})}else{const h=y.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${h} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,d,E)=>{u||E&&!E.includes("screen size is bogus")?S(u||new Error(E.toString())):(A(d,k),process.platform==="linux"?c():g?R(g):S(new Error(`Root process ${I} not found`)))})}})}})}e.$Fr=N;function A(I,R){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=I.toString().split(`
`);for(const C of g){const k=S.exec(C.trim());k&&k.length===6&&R(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}});var pe=this&&this.__decorate||function(te,e,D,L){var N=arguments.length,A=N<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,D):L,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,D,L);else for(var R=te.length-1;R>=0;R--)(I=te[R])&&(A=(N<3?I(A):N>3?I(e,D,A):I(e,D))||A);return N>3&&A&&Object.defineProperty(e,D,A),A};define(oe[42],ae([0,1,18,6,15,26,84,7,3,2,64,27,12]),function(te,e,D,L,N,A,I,R,S,g,C,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.ProxyChannel=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.RequestInitiator=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;var c;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(c||(c={}));function $(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(y||(y={}));function p(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(h||(h={}));function f(G){let W=0;for(let ee=0;;ee+=7){const ie=G.read(1);if(W|=(ie.buffer[0]&127)<<ee,!(ie.buffer[0]&128))return W}}const u=n(0);function d(G,W){if(W===0){G.write(u);return}let ee=0;for(let _=W;_!==0;_=_>>>7)ee++;const ie=N.$be.alloc(ee);for(let _=0;W!==0;_++)ie.buffer[_]=W&127,W=W>>>7,W>0&&(ie.buffer[_]|=128);G.write(ie)}class E{constructor(W){this.b=W,this.a=0}read(W){const ee=this.b.slice(this.a,this.a+W);return this.a+=ee.byteLength,ee}}e.$nh=E;class s{constructor(){this.a=[]}get buffer(){return N.$be.concat(this.a)}write(W){this.a.push(W)}}e.$oh=s;var o;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(o||(o={}));function n(G){const W=N.$be.alloc(1);return W.writeUInt8(G,0),W}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(G,W){if(typeof W>"u")G.write(i.Undefined);else if(typeof W=="string"){const ee=N.$be.fromString(W);G.write(i.String),d(G,ee.byteLength),G.write(ee)}else if(t&&Buffer.isBuffer(W)){const ee=N.$be.wrap(W);G.write(i.Buffer),d(G,ee.byteLength),G.write(ee)}else if(W instanceof N.$be)G.write(i.VSBuffer),d(G,W.byteLength),G.write(W);else if(Array.isArray(W)){G.write(i.Array),d(G,W.length);for(const ee of W)r(G,ee)}else if(typeof W=="number"&&(W|0)===W)G.write(i.Uint),d(G,W);else{const ee=N.$be.fromString(JSON.stringify(W));G.write(i.Object),d(G,ee.byteLength),G.write(ee)}}e.$ph=r;function a(G){switch(G.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return G.read(f(G)).toString();case o.Buffer:return G.read(f(G)).buffer;case o.VSBuffer:return G.read(f(G));case o.Array:{const ee=f(G),ie=[];for(let _=0;_<ee;_++)ie.push(a(G));return ie}case o.Object:return JSON.parse(G.read(f(G)).toString());case o.Int:return f(G)}}e.$qh=a;class v{constructor(W,ee,ie=null,_=1e3){this.h=W,this.j=ee,this.k=ie,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:200})}registerChannel(W,ee){this.b.set(W,ee),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const ee=this.o([W.type]);this.k?.logOutgoing(ee,0,1,p(W.type));return}case 201:case 202:case 204:case 203:{const ee=this.o([W.type,W.id],W.data);this.k?.logOutgoing(ee,W.id,1,p(W.type),W.data);return}}}o(W,ee=void 0){const ie=new s;return r(ie,W),r(ie,ee),this.p(ie.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const ee=new E(W),ie=a(ee),_=a(ee),ne=ie[0];switch(ne){case 100:return this.k?.logIncoming(W.byteLength,ie[1],1,`${$(ne)}: ${ie[2]}.${ie[3]}`,_),this.s({type:ne,id:ie[1],channelName:ie[2],name:ie[3],arg:_});case 102:return this.k?.logIncoming(W.byteLength,ie[1],1,`${$(ne)}: ${ie[2]}.${ie[3]}`,_),this.t({type:ne,id:ie[1],channelName:ie[2],name:ie[3],arg:_});case 101:return this.k?.logIncoming(W.byteLength,ie[1],1,`${$(ne)}`),this.u({type:ne,id:ie[1]});case 103:return this.k?.logIncoming(W.byteLength,ie[1],1,`${$(ne)}`),this.u({type:ne,id:ie[1]})}}s(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const ie=new A.$Xd;let _;try{_=ee.call(this.j,W.name,W.arg,ie.token)}catch(q){_=Promise.reject(q)}const ne=W.id;_.then(q=>{this.m({id:ne,data:q,type:201})},q=>{q instanceof Error?this.m({id:ne,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:ne,data:q,type:203})}).finally(()=>{Z.dispose(),this.d.delete(W.id)});const Z=(0,g.$Pc)(()=>ie.cancel());this.d.set(W.id,Z)}t(W){const ee=this.b.get(W.channelName);if(!ee){this.v(W);return}const ie=W.id,ne=ee.listen(this.j,W.name,W.arg)(Z=>this.m({id:ie,data:Z,type:204}));this.d.set(W.id,ne)}u(W){const ee=this.d.get(W.id);ee&&(ee.dispose(),this.d.delete(W.id))}v(W){let ee=this.g.get(W.channelName);ee||(ee=[],this.g.set(W.channelName,ee));const ie=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ee.push({request:W,timeoutTimer:ie})}w(W){const ee=this.g.get(W);if(ee){for(const ie of ee)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}e.$rh=v;var w;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class l{constructor(W,ee=null){this.l=W,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=ee}getChannel(W){const ee=this;return{call(ie,_,ne){return ee.a?Promise.reject(new R.$4):ee.m(W,ie,_,ne)},listen(ie,_){return ee.a?S.Event.None:ee.o(W,ie,_)}}}m(W,ee,ie,_=A.CancellationToken.None){const ne=this.g++,q={id:ne,type:100,channelName:W,name:ee,arg:ie};if(_.isCancellationRequested)return Promise.reject(new R.$4);let P;return new Promise((T,M)=>{if(_.isCancellationRequested)return M(new R.$4);const H=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(ne),T(he.data);break;case 202:{this.f.delete(ne);const $e=new Error(he.data.message);$e.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,$e.name=he.data.name,M($e);break}case 203:this.f.delete(ne),M(he.data);break}};this.f.set(ne,ue),this.p(q)};let J=null;this.b===h.Idle?H():(J=(0,L.$Hg)(ue=>this.u()),J.then(()=>{J=null,H()}));const re=()=>{J?(J.cancel(),J=null):this.p({id:ne,type:101}),M(new R.$4)},ce=_.onCancellationRequested(re);P=(0,g.$Oc)((0,g.$Pc)(re),ce),this.d.add(P)}).finally(()=>{P.dispose(),this.d.delete(P)})}o(W,ee,ie){const _=this.g++,Z={id:_,type:102,channelName:W,name:ee,arg:ie};let q=null;const P=new S.$Nd({onWillAddFirstListener:()=>{q=(0,L.$Hg)(T=>this.u()),q.then(()=>{q=null,this.d.add(P),this.p(Z)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(P),this.p({id:_,type:103}))}}),j=T=>P.fire(T.data);return this.f.set(_,j),P.event}p(W){switch(W.type){case 100:case 102:{const ee=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(ee,W.id,0,`${$(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const ee=this.q([W.type,W.id]);this.j?.logOutgoing(ee,W.id,0,$(W.type));return}}}q(W,ee=void 0){const ie=new s;return r(ie,W),r(ie,ee),this.r(ie.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const ee=new E(W),ie=a(ee),_=a(ee),ne=ie[0];switch(ne){case 200:return this.j?.logIncoming(W.byteLength,0,0,p(ne)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,ie[1],0,p(ne),_),this.t({type:ie[0],id:ie[1],data:_})}}t(W){if(W.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}e.$sh=l,pe([I.$hh],l.prototype,"onDidInitializePromise",null);class m{get connections(){const W=[];return this.f.forEach(ee=>W.push(ee)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new S.$Nd,this.onDidAddConnection=this.g.event,this.h=new S.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new g.$Qc,this.j.add(W(({protocol:ee,onDidClientDisconnect:ie})=>{const _=S.Event.once(ee.onMessage);this.j.add(_(ne=>{const Z=new E(ne),q=a(Z),P=new v(ee,q),j=new l(ee);this.a.forEach((M,H)=>P.registerChannel(H,M));const T={channelServer:P,channelClient:j,ctx:q};this.f.add(T),this.g.fire(T),this.j.add(ie(()=>{P.dispose(),j.dispose(),this.f.delete(T),this.h.fire(T)}))}))}))}getChannel(W,ee){const ie=this;return{call(_,ne,Z){let q;if((0,b.$Mf)(ee)){const j=(0,D.$3b)(ie.connections.filter(ee));q=j?Promise.resolve(j):S.Event.toPromise(S.Event.filter(ie.onDidAddConnection,ee))}else q=ee.routeCall(ie,_,ne);const P=q.then(j=>j.channelClient.getChannel(W));return F(P).call(_,ne,Z)},listen(_,ne){if((0,b.$Mf)(ee))return ie.k(W,ee,_,ne);const Z=ee.routeEvent(ie,_,ne).then(q=>q.channelClient.getChannel(W));return F(Z).listen(_,ne)}}}k(W,ee,ie,_){const ne=this;let Z;const q=new S.$Nd({onWillAddFirstListener:()=>{Z=new g.$Qc;const P=new S.$Td,j=new Map,T=H=>{const re=H.channelClient.getChannel(W).listen(ie,_),ce=P.add(re);j.set(H,ce)},M=H=>{const J=j.get(H);J&&(J.dispose(),j.delete(H))};ne.connections.filter(ee).forEach(T),S.Event.filter(ne.onDidAddConnection,ee)(T,void 0,Z),ne.onDidRemoveConnection(M,void 0,Z),P.event(q.fire,q,Z),Z.add(P)},onDidRemoveLastListener:()=>{Z?.dispose(),Z=void 0}});return q.event}registerChannel(W,ee){this.a.set(W,ee);for(const ie of this.f)ie.channelServer.registerChannel(W,ee)}dispose(){this.j.dispose();for(const W of this.f)W.channelClient.dispose(),W.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$th=m;class O{constructor(W,ee,ie=null){const _=new s;r(_,ee),W.send(_.buffer),this.a=new l(W,ie),this.d=new v(W,ee,ie)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,ee){this.d.registerChannel(W,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$uh=O;function F(G){return{call(W,ee,ie){return G.then(_=>_.call(W,ee,ie))},listen(W,ee){const ie=new S.$Wd;return G.then(_=>ie.input=_.listen(W,ee)),ie.event}}}e.$vh=F;function z(G){let W=!1;return{call(ee,ie,_){return W?G.call(ee,ie,_):(0,L.$Ug)(0).then(()=>W=!0).then(()=>G.call(ee,ie,_))},listen(ee,ie){if(W)return G.listen(ee,ie);const _=new S.$Wd;return(0,L.$Ug)(0).then(()=>W=!0).then(()=>_.input=G.listen(ee,ie)),_.event}}}e.$wh=z;class U{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const ee of W.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await S.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$xh=U;var B;(function(G){function W(ne,Z,q){const P=ne,j=q&&q.disableMarshalling,T=new Map;for(const M in P)ie(M)&&T.set(M,S.Event.buffer(P[M],!0,void 0,Z));return new class{listen(M,H,J){const re=T.get(H);if(re)return re;if(_(H)){const ce=P[H];if(typeof ce=="function")return ce.call(P,J)}throw new R.$ab(`Event not found: ${H}`)}call(M,H,J){const re=P[H];if(typeof re=="function"){if(!j&&Array.isArray(J))for(let ue=0;ue<J.length;ue++)J[ue]=(0,C.$mh)(J[ue]);let ce=re.apply(P,J);return ce instanceof Promise||(ce=Promise.resolve(ce)),ce}throw new R.$ab(`Method not found: ${H}`)}}}G.fromService=W;function ee(ne,Z){const q=Z&&Z.disableMarshalling;return new Proxy({},{get(P,j){if(typeof j=="string")return Z?.properties?.has(j)?Z.properties.get(j):_(j)?function(T){return ne.listen(j,T)}:ie(j)?ne.listen(j):async function(...T){let M;Z&&!(0,b.$Hf)(Z.context)?M=[Z.context,...T]:M=T;const H=await ne.call(j,M);return q?H:(0,C.$mh)(H)};throw new R.$ab(`Property not found: ${String(j)}`)}})}G.toService=ee;function ie(ne){return ne[0]==="o"&&ne[1]==="n"&&k.$1e(ne.charCodeAt(2))}function _(ne){return/^onDynamic/.test(ne)&&k.$1e(ne.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const W=G.toString();if(W!=="[object Object]")return W}return G}function x(G){return Array.isArray(G)?G.map(K):K(G)}function V(G,W,ee,ie,_,ne,Z){Z=x(Z);const q=Y[_],P=q[ie%q.length];let j=[`%c[${G}]%c[${String(W).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(ne)?(j=j.concat(Z),j.push(")")):j.push(Z),console.log.apply(console,j)}class Q{constructor(W,ee){this.d=W,this.f=ee,this.a=0,this.b=0}logOutgoing(W,ee,ie,_,ne){this.b+=W,V(this.d,this.b,W,ee,ie,_,ne)}logIncoming(W,ee,ie,_,ne){this.a+=W,V(this.f,this.a,W,ee,ie,_,ne)}}e.$yh=Q}),define(oe[66],ae([0,1,15,3,2,42]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.ProtocolConstants=e.$zh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var R;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function a(w,l){if(!t.has(w)){const m=String(++r);t.set(w,m)}return t.get(w)}function v(w,l,m,O){if(!i.enableDiagnostics)return;const F=a(w,l);if(O instanceof D.$be||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const z=D.$be.alloc(O.byteLength);z.set(O),i.records.push({timestamp:Date.now(),id:F,label:l,type:m,buff:z})}else i.records.push({timestamp:Date.now(),id:F,label:l,type:m,data:O})}i.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var S;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let g=null;function C(){return g||(g=D.$be.alloc(0)),g}class k{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const l=this.a[0];return r&&(this.a.shift(),this.b-=t),l}if(this.a[0].byteLength>t){const l=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),l}const a=D.$be.alloc(t);let v=0,w=0;for(;t>0;){const l=this.a[w];if(l.byteLength>t){const m=l.slice(0,t);a.set(m,v),v+=t,r&&(this.a[w]=l.slice(t),this.b-=t),t-=t}else a.set(l,v),v+=l.byteLength,r?(this.a.shift(),this.b-=l.byteLength):w++,t-=l.byteLength}return a}}e.$zh=k;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(b||(b={}));function c(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class y{constructor(t,r,a,v){this.type=t,this.id=r,this.ack=a,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends N.$Rc{constructor(t){super(),this.f=this.B(new L.$Nd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new k,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:c(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,v=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new y(a,v,w,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=D.$be.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:c(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=D.$be.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class f extends N.$Rc{constructor(t){super(),this.f=new L.$Nd,this.onMessage=this.f.event,this.g=new L.$Nd,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new h(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new y(1,0,0,t))}}e.$Ah=f;class u extends A.$uh{static fromSocket(t,r){return new u(new f(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Bh=u;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new L.$Nd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Ch=d;class E{constructor(t){this.data=t,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new E(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let v=0;v<o.a;v++)t-this.c[v]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new N.$Qc,this.o=t.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new y(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new y(7,0,0,C());this.p.write(t)}sendResume(){const t=new y(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new N.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new y(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new y(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new y(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new y(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&a>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const w=Math.max(2e4-r,2e4-a,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new y(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new y(9,0,this.h,C());this.p.write(t)}}e.$Dh=n}),define(oe[93],ae([0,1,65,6,15,26,140,7,3,2,30,144,90,42]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;class $ extends c.$rh{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",f=>N.$be.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$5p=$;class y{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new S.$Nd,this.onDidProcessExit=this.h.event;const u=f&&f.timeout?f.timeout:6e4;this.b=new L.$Qg(u),this.d=null,this.f=null}getChannel(h){const f=this;return{call(u,d,E){return f.k(h,u,d,E)},listen(u,d){return f.l(h,u,d)}}}k(h,f,u,d=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(R.$5());this.b.cancel();const E=this.n(h),s=(0,L.$Hg)(i=>E.call(f,u,i)),o=d.onCancellationRequested(()=>s.cancel()),n=(0,g.$Pc)(()=>s.cancel());return this.c.add(n),s.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(h,f,u){if(!this.b)return S.Event.None;this.b.cancel();let d;const E=new S.$Nd({onWillAddFirstListener:()=>{d=this.n(h).listen(f,u)(E.fire,E),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return E.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,C.$7m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,b.$Al)(f.env),this.d=(0,D.fork)(this.i,h,f);const u=new S.$Nd;S.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,I.$1p)(t)){(0,I.log)(t,`IPC Library: ${this.j.serverName}`);return}u.fire(N.$be.wrap(Buffer.from(t,"base64")))});const E=this.j.useQueue?(0,k.$Cl)(this.d):this.d,s=t=>this.d&&this.d.connected&&E.send(t.buffer.toString("base64")),o=u.event,n={send:s,onMessage:o};this.f=new c.$sh(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",i),this.c.forEach(a=>(0,g.$Mc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$6p=y}),define(oe[146],ae([0,1,133,15,42,3,12,18]),function(te,e,D,L,N,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MT=e.$LT=void 0;class S{constructor(b){this.a=b,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",c=>L.$be.wrap(c.data)),b.start()}send(b){this.a.postMessage(b.buffer)}disconnect(){this.a.close()}}class g extends N.$th{static b(b){(0,I.$If)((0,D.$KT)(process),"Electron Utility Process");const c=new A.$Nd;return process.parentPort.on("message",$=>{if(b?.handledClientConnection($))return;const y=(0,R.$Nb)($.ports);y&&c.fire(y)}),A.Event.map(c.event,$=>({protocol:new S($),onDidClientDisconnect:A.Event.fromNodeEventEmitter($,"close")}))}constructor(b){super(g.b(b))}}e.$LT=g;function C(k,b,c){const $=y=>{y.data===b&&(k.removeListener("message",$),c())};k.on("message",$)}e.$MT=C}),define(oe[67],ae([0,1,6,3,2,64,12]),function(te,e,D,L,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.StorageState=e.$4o=e.StorageHint=void 0;var R;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function S(b){const c=b;return c?.changed instanceof Map||c?.deleted instanceof Set}e.$4o=S;var g;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(g||(e.StorageState=g={}));class C extends N.$Rc{static{this.a=100}constructor(c,$=Object.create(null)){super(),this.r=c,this.s=$,this.b=this.B(new L.$Qd),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new D.$Rg(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(c=>this.u(c)))}u(c){this.b.pause();try{c.changed?.forEach(($,y)=>this.w(y,$)),c.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(c,$){if(this.c===g.Closed)return;let y=!1;(0,I.$Hf)($)?y=this.f.delete(c):this.f.get(c)!==$&&(this.f.set(c,$),y=!0),y&&this.b.fire({key:c,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(c,$){const y=this.f.get(c);return(0,I.$Hf)(y)?$:y}getBoolean(c,$){const y=this.get(c);return(0,I.$Hf)(y)?$:y==="true"}getNumber(c,$){const y=this.get(c);return(0,I.$Hf)(y)?$:parseInt(y,10)}getObject(c,$){const y=this.get(c);return(0,I.$Hf)(y)?$:(0,A.$lh)(y)}async set(c,$,y=!1){if(this.c===g.Closed)return;if((0,I.$Hf)($))return this.delete(c,y);const p=(0,I.$Af)($)||Array.isArray($)?(0,A.$kh)($):String($);if(this.f.get(c)!==p)return this.f.set(c,p),this.j.set(c,p),this.h.delete(c),this.b.fire({key:c,external:y}),this.D()}async delete(c,$=!1){if(!(this.c===g.Closed||!this.f.delete(c)))return this.h.has(c)||this.h.add(c),this.j.delete(c),this.b.fire({key:c,external:$}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const c={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(c).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(c){if(this.z)return this.D(c)}async D(c){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),c)}async whenFlushed(){if(this.z)return new Promise(c=>this.n.push(c))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$5o=C;class k{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(c){c.insert?.forEach(($,y)=>this.a.set(y,$)),c.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$6o=k}),define(oe[147],ae([13,9]),function(te,e){return te.create("vs/base/node/zip",e)}),define(oe[148],ae([13,9]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[149],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[150],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(oe[151],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[152],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[153],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[154],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[155],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[156],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[157],ae([13,9]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[158],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(oe[159],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(oe[160],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(oe[161],ae([13,9]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[162],ae([13,9]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[163],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[164],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[165],ae([13,9]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(oe[166],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[167],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[168],ae([13,9]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[169],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[170],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[171],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[172],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[173],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[174],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[175],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[176],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[177],ae([13,9]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(oe[178],ae([0,1,7,150]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var N;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(N||(e.TokenType=N={}));function A(...g){switch(g.length){case 1:return(0,L.localize)(0,null,g[0]);case 2:return(0,L.localize)(1,null,g[0],g[1]);case 3:return(0,L.localize)(2,null,g[0],g[1],g[2]);default:return}}const I=(0,L.localize)(3,null),R=(0,L.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,D.$7)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const k=this.d,b=this.c.substring(this.d,this.e),c={type:19,offset:this.d,lexeme:b};this.g.push({offset:k,lexeme:b,additionalInfo:C}),this.f.push(c)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const k=this.c.substring(this.d,this.e),b=S.b.get(k);b?this.k(b):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,k=!1,b=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const $=this.c.charCodeAt(C);if(k)k=!1;else if($===47&&!b){C++;break}else $===91?b=!0:$===92?k=!0:$===93&&(b=!1);C++}for(;C<this.c.length&&S.a.has(this.c.charCodeAt(C));)C++;this.e=C;const c=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=S}),define(oe[179],ae([0,1,63,84,23,16,37,19,10]),function(te,e,D,L,N,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm=/^([^.]+\..+):(.+)$/;class g{get appRoot(){return(0,A.$lc)(N.$cg.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,A.$ic)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,R.$vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:N.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,D.$em)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$ic)(this.userDataPath,"logs",c)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$vg)(S.URI.file((0,A.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=I.env.VSCODE_PORTABLE;return c?S.URI.file((0,A.$ic)(c,"argv.json")):(0,R.$vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,A.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,A.$jc)(c):(0,A.$gc)((0,A.$ic)(N.$cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?S.URI.file((0,A.$jc)(c)):S.URI.file((0,A.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,A.$jc)(c);const $=I.env.VSCODE_EXTENSIONS;if($)return $;const y=I.env.VSCODE_PORTABLE;return y?(0,A.$ic)(y,"extensions"):(0,R.$vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map($=>/^[^:/?#]+?:\/\//.test($)?S.URI.parse($):S.URI.file((0,A.$gc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?S.URI.parse(c):S.URI.file((0,A.$gc)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.$fm.test(c))}get extensionLogLevel(){const c=[];for(const $ of this.args.log||[]){const y=e.$fm.exec($);y&&y[1]&&y[2]&&c.push([y[1],y[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,R.$vg)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=I.env.VSCODE_PORTABLE;return c?S.URI.file((0,A.$ic)(c,"policy.json")):(0,R.$vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this.a}constructor(c,$,y){this.a=c,this.b=$,this.c=y,this.editSessionId=this.args.editSessionId}}e.$gm=g,pe([L.$hh],g.prototype,"appRoot",null),pe([L.$hh],g.prototype,"userHome",null),pe([L.$hh],g.prototype,"userDataPath",null),pe([L.$hh],g.prototype,"appSettingsHome",null),pe([L.$hh],g.prototype,"tmpDir",null),pe([L.$hh],g.prototype,"cacheHome",null),pe([L.$hh],g.prototype,"stateResource",null),pe([L.$hh],g.prototype,"userRoamingDataHome",null),pe([L.$hh],g.prototype,"userDataSyncHome",null),pe([L.$hh],g.prototype,"sync",null),pe([L.$hh],g.prototype,"machineSettingsResource",null),pe([L.$hh],g.prototype,"workspaceStorageHome",null),pe([L.$hh],g.prototype,"localHistoryHome",null),pe([L.$hh],g.prototype,"keyboardLayoutResource",null),pe([L.$hh],g.prototype,"argvResource",null),pe([L.$hh],g.prototype,"isExtensionDevelopment",null),pe([L.$hh],g.prototype,"untitledWorkspacesHome",null),pe([L.$hh],g.prototype,"builtinExtensionsPath",null),pe([L.$hh],g.prototype,"extensionsPath",null),pe([L.$hh],g.prototype,"extensionDevelopmentLocationURI",null),pe([L.$hh],g.prototype,"extensionDevelopmentKind",null),pe([L.$hh],g.prototype,"extensionTestsLocationURI",null),pe([L.$hh],g.prototype,"debugExtensionHost",null),pe([L.$hh],g.prototype,"logLevel",null),pe([L.$hh],g.prototype,"extensionLogLevel",null),pe([L.$hh],g.prototype,"serviceMachineIdResource",null),pe([L.$hh],g.prototype,"disableTelemetry",null),pe([L.$hh],g.prototype,"disableWorkspaceTrust",null),pe([L.$hh],g.prototype,"useInMemorySecretStorage",null),pe([L.$hh],g.prototype,"policyFile",null);function C(b,c){return k(b["inspect-extensions"],b["inspect-brk-extensions"],5870,c,b.debugId,b.extensionEnvironment)}e.$hm=C;function k(b,c,$,y,p,h){const u=Number(c||b)||(y?null:$),d=u?!!c:!1;let E;if(h)try{E=JSON.parse(h)}catch{}return{port:u,break:d,debugId:p,env:E}}e.$im=k}),function(){"use strict";function te(e,D,L){function N(I,R){const S=A(I,R),g=[S];return e.isAbsolute(S)||g.unshift(L),e.resolve(...g)}function A(I,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,R);const C=I["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(k,"AppData","Roaming")}break;case"darwin":g=e.join(D.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,R)}return{getUserDataPath:N}}if(typeof define=="function")define(oe[180],ae([268,36,37]),function(e,D,L){return te(e,D,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=te(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[181],ae([0,1,36,179,180]),function(te,e,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=e.$jm=void 0;class A extends L.$gm{constructor(g,C){super(g,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,N.getUserDataPath)(g,C.nameShort)},C)}}e.$jm=A;function I(S,g){return(0,L.$im)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,g,S.extensionEnvironment)}e.$km=I;function R(S,g){return(0,L.$im)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,g,S.extensionEnvironment)}e.$lm=R}),define(oe[182],ae([0,1,12,153]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;function N(I,R,S,g){try{A(I,R,S,g)}catch(C){I.error(C?.message??C)}return R}e.$Ap=N;function A(I,R,S,g){const C=(k,b,c)=>{const $=k[b];if((0,D.$yf)($)){const y=$,p=y.length;if(p>1&&y[0]==="%"&&y[p-1]==="%"){const h=y.substr(1,p-2);let f=S[h];f===void 0&&g&&(f=g[h]);const u=typeof f=="string"?f:f?.message,d=g?.[h],E=typeof d=="string"?d:d?.message;if(!u){E||I.warn(`[${R.name}]: ${(0,L.localize)(0,null,h)}`);return}if(c&&(b==="title"||b==="category")&&E&&E!==u){const s={value:u,original:E};k[b]=s}else k[b]=u}}else if((0,D.$Af)($))for(const y in $)$.hasOwnProperty(y)&&(y==="commands"?C($,y,!0):C($,y,c));else if(Array.isArray($))for(let y=0;y<$.length;y++)C($,y,c)};for(const k in R)R.hasOwnProperty(k)&&C(R,k)}}),define(oe[183],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M9b=e.$L9b=void 0;class D{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$L9b=D;class L{constructor(A){this.a=A}listen(A,I){throw new Error(`Event not found: ${I}`)}call(A,I,R){switch(I){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${I}`)}}e.$M9b=L}),define(oe[68],ae([0,1,19,89,157,54]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(h){return h=h.trim(),h==="*"||I.test(h)}e.$Oo=S;function g(h){if(!S(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(I);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$Po=g;function C(h){if(!h)return null;const f=h.majorBase,u=h.majorMustEqual,d=h.minorBase;let E=h.minorMustEqual;const s=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(f===0||(E=!1),o=!1);let n=0;if(h.preRelease){const i=R.exec(h.preRelease);if(i){const[,t,r,a]=i;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:f,majorMustEqual:u,minorBase:d,minorMustEqual:E,patchBase:s,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:n}}e.$Qo=C;function k(h,f,u){let d;typeof h=="string"?d=C(g(h)):d=h;let E;f instanceof Date?E=f.getTime():typeof f=="string"&&(E=new Date(f).getTime());let s;if(typeof u=="string"?s=C(g(u)):s=u,!d||!s)return!1;const o=d.majorBase,n=d.minorBase,i=d.patchBase;let t=s.majorBase,r=s.minorBase,a=s.patchBase;const v=s.notBefore;let w=s.majorMustEqual,l=s.minorMustEqual,m=s.patchMustEqual;return s.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||E&&E<v?!1:i>=a:(o===1&&t===0&&(!w||!l||!m)&&(t=1,r=0,a=0,w=!0,l=!1,m=!1),o<t?!1:o>t?!w:n<r?!1:n>r?!l:i<a?!1:i>a?!m:!(E&&E<v))}e.$Ro=k;function b(h,f,u,d,E){const s=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return s.push([L.default.Error,N.localize(0,null)]),s;if(typeof d.name!="string")return s.push([L.default.Error,N.localize(1,null,"name")]),s;if(typeof d.version!="string")return s.push([L.default.Error,N.localize(2,null,"version")]),s;if(!d.engines)return s.push([L.default.Error,N.localize(3,null,"engines")]),s;if(typeof d.engines.vscode!="string")return s.push([L.default.Error,N.localize(4,null,"engines.vscode")]),s;if(typeof d.extensionDependencies<"u"&&!p(d.extensionDependencies))return s.push([L.default.Error,N.localize(5,null,"extensionDependencies")]),s;if(typeof d.activationEvents<"u"){if(!p(d.activationEvents))return s.push([L.default.Error,N.localize(6,null,"activationEvents")]),s;if(typeof d.main>"u"&&typeof d.browser>"u")return s.push([L.default.Error,N.localize(7,null,"activationEvents","main","browser")]),s}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&s.push([L.default.Warning,N.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return s.push([L.default.Error,N.localize(9,null,"main")]),s;{const i=(0,D.$vg)(u,d.main);(0,D.$pg)(i,u)||s.push([L.default.Warning,N.localize(10,null,i.path,u.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return s.push([L.default.Error,N.localize(11,null,"browser")]),s;{const i=(0,D.$vg)(u,d.browser);(0,D.$pg)(i,u)||s.push([L.default.Warning,N.localize(12,null,i.path,u.path)])}}if(!A.valid(d.version))return s.push([L.default.Error,N.localize(13,null)]),s;const o=[];if(!c(h,f,d,E,o))for(const i of o)s.push([L.default.Error,i]);return s}e.$So=b;function c(h,f,u,d,E){return d||typeof u.main>"u"&&typeof u.browser>"u"?!0:y(h,f,u.engines.vscode,E)}e.$To=c;function $(h,f,u){return h==="*"||y(f,u,h)}e.$Uo=$;function y(h,f,u,d=[]){const E=C(g(u));if(!E)return d.push(N.localize(14,null,u)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return d.push(N.localize(15,null,u)),!1}else if(!E.majorMustEqual)return d.push(N.localize(16,null,u)),!1;return k(h,f,E)?!0:(d.push(N.localize(17,null,h,u)),!1)}function p(h){if(!Array.isArray(h))return!1;for(let f=0,u=h.length;f<u;f++)if(typeof h[f]!="string")return!1;return!0}}),define(oe[43],ae([0,1,15,32]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=void 0;async function N(A,I,R){let S=R&&R.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const C=(await I.readFile(A.serviceMachineIdResource)).value.toString();S=(0,L.$dg)(C)?C:null}catch{S=null}if(!S){S=(0,L.$eg)();try{await I.writeFile(A.serviceMachineIdResource,D.$be.fromString(S))}catch{}}return R?.store("storage.serviceMachineId",S,-1,1),S}e.$cp=N}),define(oe[69],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class D{constructor(N,A=[],I=!1){this.ctor=N,this.staticArguments=A,this.supportsDelayedInstantiation=I}}e.$Mh=D}),define(oe[184],ae([0,1,69]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=e.InstantiationType=void 0;const L=[];var N;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(N||(e.InstantiationType=N={}));function A(R,S,g){S instanceof D.$Mh||(S=new D.$Mh(S,[],!!g)),L.push([R,S])}e.$zr=A;function I(){return L}e.$Ar=I}),define(oe[185],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;class D{constructor(A,I){this.key=A,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.$eq=D;class L{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const I of this.a.values())I.outgoing.size===0&&A.push(I);return A}insertEdge(A,I){const R=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(I);R.outgoing.set(S.key,S),S.incoming.set(R.key,R)}removeNode(A){const I=this.b(A);this.a.delete(I);for(const R of this.a.values())R.outgoing.delete(I),R.incoming.delete(I)}lookupOrInsertNode(A){const I=this.b(A);let R=this.a.get(I);return R||(R=new D(I,A),this.a.set(I,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[I,R]of this.a)A.push(`${I}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,I]of this.a){const R=new Set([A]),S=this.c(I,R);if(S)return S}}c(A,I){for(const[R,S]of A.outgoing){if(I.has(R))return[...I,R].join(" -> ");I.add(R);const g=this.c(S,I);if(g)return g;I.delete(R)}}}e.$fq=L}),define(oe[4],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var D;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=R})(D||(e._util=D={})),e.$Oh=N("instantiationService");function L(I,R,S){R[D.DI_TARGET]===R?R[D.DI_DEPENDENCIES].push({id:I,index:S}):(R[D.DI_DEPENDENCIES]=[{id:I,index:S}],R[D.DI_TARGET]=R)}function N(I){if(D.serviceIds.has(I))return D.serviceIds.get(I);const R=function(S,g,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(R,S,C)};return R.toString=()=>I,D.serviceIds.set(I,R),R}e.$Ph=N;function A(I){return I}e.$Qh=A}),define(oe[186],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i9b=void 0,e.$i9b=(0,D.$Ph)("checksumService")}),define(oe[20],ae([0,1,12,10,4]),function(te,e,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,N.$Ph)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof L.URI)}e.$ki=A;function I(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof L.URI)}e.$li=I;var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function S(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=S;function g(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$ni=g;function C(h,f){const u=Object.create(null);for(const d in h)k(u,d,h[d],f);return u}e.$oi=C;function k(h,f,u,d){const E=f.split("."),s=E.pop();let o=h;for(let n=0;n<E.length;n++){const i=E[n];let t=o[i];switch(typeof t){case"undefined":t=o[i]=Object.create(null);break;case"object":break;default:d(`Ignoring ${f} as ${E.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[s]=u}catch{d(`Ignoring ${f} as ${E.join(".")} is ${JSON.stringify(o)}`)}else d(`Ignoring ${f} as ${E.join(".")} is ${JSON.stringify(o)}`)}e.$pi=k;function b(h,f){const u=f.split(".");c(h,u)}e.$qi=b;function c(h,f){const u=f.shift();if(f.length===0){delete h[u];return}if(Object.keys(h).indexOf(u)!==-1){const d=h[u];typeof d=="object"&&!Array.isArray(d)&&(c(d,f),Object.keys(d).length===0&&delete h[u])}}function $(h,f,u){function d(o,n){let i=o;for(const t of n){if(typeof i!="object"||i===null)return;i=i[t]}return i}const E=f.split("."),s=d(h,E);return typeof s>"u"?u:s}e.$ri=$;function y(h,f,u){Object.keys(f).forEach(d=>{d!=="__proto__"&&(d in h?D.$Af(h[d])&&D.$Af(f[d])?y(h[d],f[d],u):u&&(h[d]=f[d]):h[d]=f[d])})}e.$si=y;function p(h){return h.replace(/[\[\]]/g,"")}e.$ti=p}),define(oe[94],ae([0,1,5,27,178,4,149,7]),function(te,e,D,L,N,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",D.$k),S.set("isLinux",D.$l),S.set("isWindows",D.$j),S.set("isWeb",D.$p),S.set("isMacNative",D.$k&&!D.$p),S.set("isEdge",D.$H),S.set("isFirefox",D.$F),S.set("isChrome",D.$E),S.set("isSafari",D.$G);function g(q,P){if(S.get(q)!==void 0)throw(0,R.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(q,P)}e.$Li=g;const C=Object.prototype.hasOwnProperty;var k;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const b={regexParsingWithErrorRecovery:!0},c=(0,I.localize)(0,null),$=(0,I.localize)(1,null),y=(0,I.localize)(2,null),p=(0,I.localize)(3,null),h=(0,I.localize)(4,null),f=(0,I.localize)(5,null),u=(0,I.localize)(6,null),d=(0,I.localize)(7,null);class E{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=b){this.k=P,this.d=new N.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const T=this.D(),M=T.type===17?f:void 0;throw this.h.push({message:h,offset:T.offset,lexeme:N.$Ki.getLexeme(T),additionalInfo:M}),E.c}return j}catch(j){if(j!==E.c)throw j;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const j=this.o();P.push(j)}return P.length===1?P[0]:s.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const j=this.s();P.push(j)}return P.length===1?P[0]:s.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,p),j?.negate()}case 17:return this.z(),O.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const j=this.l();return this.A(1,p),j}case 17:{const j=P.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const H=M.lexeme,J=H.lastIndexOf("/"),re=J===H.length-1?void 0:this.w(H.substring(J+1));let ce;try{ce=new RegExp(H.substring(1,J),re)}catch{throw this.B("REGEX",M)}return K.create(j,ce)}switch(M.type){case 10:case 19:{const H=[M.lexeme];this.z();let J=this.D(),re=0;for(let de=0;de<M.lexeme.length;de++)M.lexeme.charCodeAt(de)===40?re++:M.lexeme.charCodeAt(de)===41&&re--;for(;!this.E()&&J.type!==15&&J.type!==16;){switch(J.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let de=0;de<J.lexeme.length;de++)J.lexeme.charCodeAt(de)===40?re++:M.lexeme.charCodeAt(de)===41&&re--}if(re<0)break;H.push(N.$Ki.getLexeme(J)),this.z(),J=this.D()}const ce=H.join(""),ue=ce.lastIndexOf("/"),he=ue===ce.length-1?void 0:this.w(ce.substring(ue+1));let $e;try{$e=new RegExp(ce.substring(1,ue),he)}catch{throw this.B("REGEX",M)}return s.regex(j,$e)}case 18:{const H=M.lexeme;this.z();let J=null;if(!(0,L.$Be)(H)){const re=H.indexOf("/"),ce=H.lastIndexOf("/");if(re!==ce&&re>=0){const ue=H.slice(re+1,ce),he=H[ce+1]==="i"?"i":"";try{J=new RegExp(ue,he)}catch{throw this.B("REGEX",M)}}}if(J===null)throw this.B("REGEX",M);return K.create(j,J)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const M=this.u();return s.notIn(j,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return s.equals(j,M);switch(M){case"true":return s.has(j);case"false":return s.not(j);default:return s.equals(j,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return s.notEquals(j,M);switch(M){case"true":return s.not(j);case"false":return s.has(j);default:return s.notEquals(j,M)}}case 5:return this.z(),B.create(j,this.u());case 6:return this.z(),Y.create(j,this.u());case 7:return this.z(),z.create(j,this.u());case 8:return this.z(),U.create(j,this.u());case 13:return this.z(),s.in(j,this.u());default:return s.has(j)}}case 20:throw this.h.push({message:u,offset:P.offset,lexeme:"",additionalInfo:d}),E.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,j){if(this.C(P))return this.z();throw this.B(j,this.D())}B(P,j,T){const M=(0,I.localize)(8,null,P,N.$Ki.getLexeme(j)),H=j.offset,J=N.$Ki.getLexeme(j);return this.h.push({message:M,offset:H,lexeme:J,additionalInfo:T}),E.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=E;class s{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(P){return a.create(P)}static equals(P,j){return v.create(P,j)}static notEquals(P,j){return m.create(P,j)}static regex(P,j){return K.create(P,j)}static in(P,j){return w.create(P,j)}static notIn(P,j){return l.create(P,j)}static not(P){return O.create(P)}static and(...P){return Q.create(P,null,!0)}static or(...P){return G.create(P,null,!0)}static greater(P,j){return z.create(P,j)}static greaterEquals(P,j){return U.create(P,j)}static smaller(P,j){return B.create(P,j)}static smallerEquals(P,j){return Y.create(P,j)}static{this.c=new E({regexParsingWithErrorRecovery:!1})}static deserialize(P){return P==null?void 0:this.c.parse(P)}}e.$Ni=s;function o(q){const P=new E({regexParsingWithErrorRecovery:!1});return q.map(j=>(P.parse(j),P.lexingErrors.length>0?P.lexingErrors.map(T=>({errorMessage:T.additionalInfo?(0,I.localize)(9,null,T.additionalInfo):(0,I.localize)(10,null),offset:T.offset,length:T.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(T=>({errorMessage:T.additionalInfo?`${T.message}. ${T.additionalInfo}`:T.message,offset:T.offset,length:T.lexeme.length})):[]))}e.$Oi=o;function n(q,P){const j=q?q.substituteConstants():void 0,T=P?P.substituteConstants():void 0;return!j&&!T?!0:!j||!T?!1:j.equals(T)}e.$Pi=n;function i(q,P){return q.cmp(P)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return r.INSTANCE}}e.$Qi=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return t.INSTANCE}}e.$Ri=r;class a{static create(P,j=null){const T=S.get(P);return typeof T=="boolean"?T?r.INSTANCE:t.INSTANCE:new a(P,j)}constructor(P,j){this.key=P,this.c=j,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=S.get(this.key);return typeof P=="boolean"?P?r.INSTANCE:t.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=O.create(this.key,this)),this.c}}e.$Si=a;class v{static create(P,j,T=null){if(typeof j=="boolean")return j?a.create(P,T):O.create(P,T);const M=S.get(P);return typeof M=="boolean"?j===(M?"true":"false")?r.INSTANCE:t.INSTANCE:new v(P,j,T)}constructor(P,j,T){this.c=P,this.d=j,this.f=T,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=S.get(this.c);if(typeof P=="boolean"){const j=P?"true":"false";return this.d===j?r.INSTANCE:t.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.$Ti=v;class w{static create(P,j){return new w(P,j)}constructor(P,j){this.d=P,this.f=j,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const j=P.getValue(this.f),T=P.getValue(this.d);return Array.isArray(j)?j.includes(T):typeof T=="string"&&typeof j=="object"&&j!==null?C.call(j,T):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=l.create(this.d,this.f)),this.c}}e.$Ui=w;class l{static create(P,j){return new l(P,j)}constructor(P,j){this.d=P,this.f=j,this.type=11,this.c=w.create(P,j)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=l;class m{static create(P,j,T=null){if(typeof j=="boolean")return j?O.create(P,T):a.create(P,T);const M=S.get(P);return typeof M=="boolean"?j===(M?"true":"false")?t.INSTANCE:r.INSTANCE:new m(P,j,T)}constructor(P,j,T){this.c=P,this.d=j,this.f=T,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=S.get(this.c);if(typeof P=="boolean"){const j=P?"true":"false";return this.d===j?t.INSTANCE:r.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Wi=m;class O{static create(P,j=null){const T=S.get(P);return typeof T=="boolean"?T?t.INSTANCE:r.INSTANCE:new O(P,j)}constructor(P,j){this.c=P,this.d=j,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=S.get(this.c);return typeof P=="boolean"?P?t.INSTANCE:r.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Xi=O;function F(q,P){if(typeof q=="string"){const j=parseFloat(q);isNaN(j)||(q=j)}return typeof q=="string"||typeof q=="number"?P(q):t.INSTANCE}class z{static create(P,j,T=null){return F(j,M=>new z(P,M,T))}constructor(P,j,T){this.c=P,this.d=j,this.f=T,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Yi=z;class U{static create(P,j,T=null){return F(j,M=>new U(P,M,T))}constructor(P,j,T){this.c=P,this.d=j,this.f=T,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Zi=U;class B{static create(P,j,T=null){return F(j,M=>new B(P,M,T))}constructor(P,j,T){this.c=P,this.d=j,this.f=T,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$1i=B;class Y{static create(P,j,T=null){return F(j,M=>new Y(P,M,T))}constructor(P,j,T){this.c=P,this.d=j,this.f=T,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$2i=Y;class K{static create(P,j){return new K(P,j)}constructor(P,j){this.d=P,this.f=j,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const j=this.f?this.f.source:"",T=P.f?P.f.source:"";return j<T?-1:j>T?1:0}equals(P){if(P.type===this.type){const j=this.f?this.f.source:"",T=P.f?P.f.source:"";return this.d===P.d&&j===T}return!1}substituteConstants(){return this}evaluate(P){const j=P.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$3i=K;class x{static create(P){return new x(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(P){return new x(this.c.map(P))}negate(){return this.c}}e.$4i=x;function V(q){let P=null;for(let j=0,T=q.length;j<T;j++){const M=q[j].substituteConstants();if(q[j]!==M&&P===null){P=[];for(let H=0;H<j;H++)P[H]=q[H]}P!==null&&(P[j]=M)}return P===null?q:P}class Q{static create(P,j,T){return Q.d(P,j,T)}constructor(P,j){this.expr=P,this.c=j,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let j=0,T=this.expr.length;j<T;j++){const M=i(this.expr[j],P.expr[j]);if(M!==0)return M}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let j=0,T=this.expr.length;j<T;j++)if(!this.expr[j].equals(P.expr[j]))return!1;return!0}return!1}substituteConstants(){const P=V(this.expr);return P===this.expr?this:Q.create(P,this.c,!1)}evaluate(P){for(let j=0,T=this.expr.length;j<T;j++)if(!this.expr[j].evaluate(P))return!1;return!0}static d(P,j,T){const M=[];let H=!1;for(const J of P)if(J){if(J.type===1){H=!0;continue}if(J.type===0)return t.INSTANCE;if(J.type===6){M.push(...J.expr);continue}M.push(J)}if(M.length===0&&H)return r.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(i);for(let J=1;J<M.length;J++)M[J-1].equals(M[J])&&(M.splice(J,1),J--);if(M.length===1)return M[0];for(;M.length>1;){const J=M[M.length-1];if(J.type!==9)break;M.pop();const re=M.pop(),ce=M.length===0,ue=G.create(J.expr.map(he=>Q.create([he,re],null,T)),null,ce);ue&&(M.push(ue),M.sort(i))}if(M.length===1)return M[0];if(T){for(let J=0;J<M.length;J++)for(let re=J+1;re<M.length;re++)if(M[J].negate().equals(M[re]))return t.INSTANCE;if(M.length===1)return M[0]}return new Q(M,j)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const j of this.expr)P.push(...j.keys());return P}map(P){return new Q(this.expr.map(j=>j.map(P)),null)}negate(){if(!this.c){const P=[];for(const j of this.expr)P.push(j.negate());this.c=G.create(P,this,!0)}return this.c}}e.$5i=Q;class G{static create(P,j,T){return G.d(P,j,T)}constructor(P,j){this.expr=P,this.c=j,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let j=0,T=this.expr.length;j<T;j++){const M=i(this.expr[j],P.expr[j]);if(M!==0)return M}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let j=0,T=this.expr.length;j<T;j++)if(!this.expr[j].equals(P.expr[j]))return!1;return!0}return!1}substituteConstants(){const P=V(this.expr);return P===this.expr?this:G.create(P,this.c,!1)}evaluate(P){for(let j=0,T=this.expr.length;j<T;j++)if(this.expr[j].evaluate(P))return!0;return!1}static d(P,j,T){let M=[],H=!1;if(P){for(let J=0,re=P.length;J<re;J++){const ce=P[J];if(ce){if(ce.type===0){H=!0;continue}if(ce.type===1)return r.INSTANCE;if(ce.type===9){M=M.concat(ce.expr);continue}M.push(ce)}}if(M.length===0&&H)return t.INSTANCE;M.sort(i)}if(M.length!==0){if(M.length===1)return M[0];for(let J=1;J<M.length;J++)M[J-1].equals(M[J])&&(M.splice(J,1),J--);if(M.length===1)return M[0];if(T){for(let J=0;J<M.length;J++)for(let re=J+1;re<M.length;re++)if(M[J].negate().equals(M[re]))return r.INSTANCE;if(M.length===1)return M[0]}return new G(M,j)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const j of this.expr)P.push(...j.keys());return P}map(P){return new G(this.expr.map(j=>j.map(P)),null)}negate(){if(!this.c){const P=[];for(const j of this.expr)P.push(j.negate());for(;P.length>1;){const j=P.shift(),T=P.shift(),M=[];for(const H of Z(j))for(const J of Z(T))M.push(Q.create([H,J],null,!1));P.unshift(G.create(M,null,!1))}this.c=G.create(P,this,!0)}return this.c}}e.$6i=G;class W extends a{static{this.d=[]}static all(){return W.d.values()}constructor(P,j,T){super(P,null),this.f=j,typeof T=="object"?W.d.push({...T,key:P}):T!==!0&&W.d.push({key:P,description:T,type:j!=null?typeof j:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return v.create(this.key,P)}notEqualsTo(P){return m.create(this.key,P)}}e.$7i=W,e.$8i=(0,A.$Ph)("contextKeyService");function ee(q,P){return q<P?-1:q>P?1:0}function ie(q,P,j,T){return q<j?-1:q>j?1:P<T?-1:P>T?1:0}function _(q,P){if(q.type===0||P.type===1)return!0;if(q.type===9)return P.type===9?ne(q.expr,P.expr):!1;if(P.type===9){for(const j of P.expr)if(_(q,j))return!0;return!1}if(q.type===6){if(P.type===6)return ne(P.expr,q.expr);for(const j of q.expr)if(_(j,P))return!0;return!1}return q.equals(P)}e.$9i=_;function ne(q,P){let j=0,T=0;for(;j<q.length&&T<P.length;){const M=q[j].cmp(P[T]);if(M<0)return!1;M===0&&j++,T++}return j===q.length}function Z(q){return q.type===9?q.expr:[q]}}),define(oe[95],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.ID=void 0,e.ID="diagnosticsService",e.$qm=(0,D.$Ph)(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.$rm=L;class N{async getPerformanceInfo(I,R){return{}}async getSystemInfo(I,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,R){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.$sm=N}),define(oe[96],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=void 0,e.$Rn=(0,D.$Ph)("downloadService")}),define(oe[14],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,D.$Ph)("environmentService"),e.$Xh=(0,D.$Qh)(e.$Wh)}),define(oe[29],ae([0,1,152,4]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ao=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=void 0,e.$1n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$2n=new RegExp(e.$1n),e.$3n="__web_extension",e.$4n="skipWalkthrough",e.$5n="extensionsSync",e.$6n="dependecyOrPackExtensionInstall";function N(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$7n=N;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$8n=A;function I(h,f){switch(h){case 3:return f==="x64"?"win32-x64":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$9n=I;function R(h,f){return f==="web"&&!h.includes("web")}e.$0n=R;function S(h,f,u){return R(f,u)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===u}e.$$n=S;function g(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$_n=g;var C;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var k;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var b;(function(h){h.Install="install",h.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var c;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(c||(e.InstallOperation=c={})),e.$ao=(0,L.$Ph)("extensionGalleryService");var $;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var y;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class p extends Error{constructor(f,u){super(f),this.code=u,this.name=u}}e.$bo=p,e.$co=(0,L.$Ph)("extensionManagementService"),e.$do="extensionsIdentifiers/disabled",e.$eo="extensionsIdentifiers/enabled",e.$fo=(0,L.$Ph)("IGlobalExtensionEnablementService"),e.$go=(0,L.$Ph)("IExtensionTipsService"),e.$ho=(0,D.localize)(0,null),e.$io={value:e.$ho,original:"Extensions"},e.$jo={value:(0,D.localize)(1,null),original:"Preferences"}}),define(oe[187],ae([0,1,3,2,30,10,92,29]),function(te,e,D,L,N,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=e.$lp=e.$kp=void 0;function S(p,h){return p?A.URI.revive(h?h.transformIncoming(p):p):void 0}function g(p,h){return h?h.transformOutgoingURI(p):p}function C(p,h){h=h||I.$Mm;const f=p.manifest;return{...(0,I.$Pm)({...p,manifest:void 0},h),manifest:f}}function k(p,h){return p?.profileLocation?(0,I.$Pm)(p,h??I.$Mm):p}function b(p,h){return h?(0,N.$9m)(p,f=>f instanceof A.URI?h.transformOutgoingURI(f):void 0):p}class c{constructor(h,f){this.a=h,this.b=f,this.onInstallExtension=D.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,f){const u=this.b(h);switch(f){case"onInstallExtension":return D.Event.map(this.onInstallExtension,d=>({...d,profileLocation:d.profileLocation?g(d.profileLocation,u):d.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,d=>d.map(E=>({...E,local:E.local?b(E.local,u):E.local,profileLocation:E.profileLocation?g(E.profileLocation,u):E.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,d=>({...d,profileLocation:d.profileLocation?g(d.profileLocation,u):d.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,d=>({...d,profileLocation:d.profileLocation?g(d.profileLocation,u):d.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,d=>b(d,u))}throw new Error("Invalid listen")}async call(h,f,u){const d=this.b(h);switch(f){case"zip":{const E=C(u[0],d),s=await this.a.zip(E);return g(s,d)}case"unzip":return this.a.unzip(S(u[0],d));case"install":return this.a.install(S(u[0],d),k(u[1],d));case"installFromLocation":return this.a.installFromLocation(S(u[0],d),S(u[1],d));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(u[0],S(u[1],d),S(u[2],d));case"getManifest":return this.a.getManifest(S(u[0],d));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(u[0]);case"installFromGallery":return this.a.installFromGallery(u[0],k(u[1],d));case"installGalleryExtensions":{const E=u[0];return this.a.installGalleryExtensions(E.map(({extension:s,options:o})=>({extension:s,options:k(o,d)??{}})))}case"uninstall":return this.a.uninstall(C(u[0],d),k(u[1],d));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(u[0],d));case"getInstalled":return(await this.a.getInstalled(u[0],S(u[1],d))).map(s=>b(s,d));case"toggleAppliationScope":{const E=await this.a.toggleAppliationScope(C(u[0],d),S(u[1],d));return b(E,d)}case"copyExtensions":return this.a.copyExtensions(S(u[0],d),S(u[1],d));case"updateMetadata":{const E=await this.a.updateMetadata(C(u[0],d),u[1],S(u[2],d));return b(E,d)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(u[0],u[1],u[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$kp=c;class $ extends L.$Rc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.m=h,this.c=this.B(new D.$Nd),this.f=this.B(new D.$Nd),this.g=this.B(new D.$Nd),this.h=this.B(new D.$Nd),this.j=this.B(new D.$Nd),this.B(this.m.listen("onInstallExtension")(f=>this.n(this.c,{...f,source:this.r(f.source)?A.URI.revive(f.source):f.source,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(f=>this.n(this.f,f.map(u=>({...u,local:u.local?C(u.local,null):u.local,source:this.r(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(f=>this.n(this.g,{...f,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(f=>this.n(this.h,{...f,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(f=>this.j.fire(C(f,null))))}n(h,f){h.fire(f)}r(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(h){const f=await this.getTargetPlatform();return h.allTargetPlatforms.some(u=>(0,R.$$n)(u,h.allTargetPlatforms,f))}zip(h){return Promise.resolve(this.m.call("zip",[h]).then(f=>A.URI.revive(f)))}unzip(h){return Promise.resolve(this.m.call("unzip",[h]))}install(h,f){return Promise.resolve(this.m.call("install",[h,f])).then(u=>C(u,null))}installFromLocation(h,f){return Promise.resolve(this.m.call("installFromLocation",[h,f])).then(u=>C(u,null))}async installExtensionsFromProfile(h,f,u){return(await this.m.call("installExtensionsFromProfile",[h,f,u])).map(E=>C(E,null))}getManifest(h){return Promise.resolve(this.m.call("getManifest",[h]))}installFromGallery(h,f){return Promise.resolve(this.m.call("installFromGallery",[h,f])).then(u=>C(u,null))}async installGalleryExtensions(h){return(await this.m.call("installGalleryExtensions",[h])).map(u=>({...u,local:u.local?C(u.local,null):u.local,source:this.r(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))}uninstall(h,f){return Promise.resolve(this.m.call("uninstall",[h,f]))}reinstallFromGallery(h){return Promise.resolve(this.m.call("reinstallFromGallery",[h])).then(f=>C(f,null))}getInstalled(h=null,f){return Promise.resolve(this.m.call("getInstalled",[h,f])).then(u=>u.map(d=>C(d,null)))}updateMetadata(h,f,u){return Promise.resolve(this.m.call("updateMetadata",[h,f,u])).then(d=>C(d,null))}toggleAppliationScope(h,f){return this.m.call("toggleAppliationScope",[h,f]).then(u=>C(u,null))}copyExtensions(h,f){return this.m.call("copyExtensions",[h,f])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(h,f,u){const d=await this.m.call("download",[h,f,u]);return A.URI.revive(d)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$lp=$;class y{constructor(h){this.a=h}listen(h,f){throw new Error("Invalid listen")}call(h,f,u){switch(f){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$mp=y}),define(oe[97],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=void 0,e.$hp=(0,D.$Ph)("IExtensionSignatureVerificationService");class L{b(){return this.a||(this.a=new Promise((A,I)=>te(["node-vsce-sign"],async R=>A(R),I))),this.a}async verify(A,I,R){let S;try{S=await this.b()}catch{return!1}return S.verify(A,I,R)}}e.$ip=L}),define(oe[98],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dWb=e.RecommendationsNotificationResult=e.$cWb=e.RecommendationSource=void 0;var L;(function(I){I[I.FILE=1]="FILE",I[I.WORKSPACE=2]="WORKSPACE",I[I.EXE=3]="EXE"})(L||(e.RecommendationSource=L={}));function N(I){switch(I){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$cWb=N;var A;(function(I){I.Ignored="ignored",I.Cancelled="cancelled",I.TooMany="toomany",I.IncompatibleWindow="incompatibleWindow",I.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$dWb=(0,D.$Ph)("IExtensionRecommendationNotificationService")}),define(oe[11],ae([0,1,47,16,27,12,10,159,4,5,23,60]),function(te,e,D,L,N,A,I,R,S,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,S.$Ph)("fileService");function b(_){return _.create===!0}e.$_j=b;var c;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var $;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})($||(e.FilePermission=$={}));function y(_){const ne=_;return!!ne&&typeof ne.onDidChange=="function"}e.$ak=y;var p;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function h(_){return!!(_.capabilities&2)}e.$bk=h;function f(_){return!!(_.capabilities&8)}e.$ck=f;function u(_){return!!(_.capabilities&131072)}e.$dk=u;function d(_){return!!(_.capabilities&4)}e.$ek=d;function E(_){return!!(_.capabilities&16)}e.$fk=E;function s(_){return h(_)?!!(_.capabilities&16384):!1}e.$gk=s;function o(_){return h(_)?!!(_.capabilities&32768):!1}e.$hk=o;function n(_){return!!(_.capabilities&65536)}e.$ik=n;function i(_){return!!(_.capabilities&2048)}e.$jk=i;var t;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ne,Z){const q=new r(ne.toString(),Z);return w(q,Z),q}constructor(ne,Z){super(ne),this.code=Z}}e.$kk=r;function a(_,ne){return r.create(_,ne)}e.$lk=a;function v(_){return _||a((0,R.localize)(0,null),t.Unknown)}e.$mk=v;function w(_,ne){return _.name=ne?`${ne} (FileSystemError)`:"FileSystemError",_}e.$nk=w;function l(_){if(!_)return t.Unknown;if(_ instanceof r)return _.code;const ne=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!ne)return t.Unknown;switch(ne[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$ok=l;function m(_){if(_ instanceof Y)return _.fileOperationResult;switch(l(_)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$pk=m;var O;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class F{constructor(ne,Z,q){this.resource=ne,this.operation=Z,this.target=q}isOperation(ne){return this.operation===ne}}e.$qk=F;var z;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class U{static{this.a=null}constructor(ne,Z){this.c=Z,this.b=void 0,this.d=new k.$U(()=>{const q=D.$Vh.forUris(()=>this.c);return q.fill(this.rawAdded.map(P=>[P,!0])),q}),this.f=new k.$U(()=>{const q=D.$Vh.forUris(()=>this.c);return q.fill(this.rawUpdated.map(P=>[P,!0])),q}),this.g=new k.$U(()=>{const q=D.$Vh.forUris(()=>this.c);return q.fill(this.rawDeleted.map(P=>[P,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of ne){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==U.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(ne,...Z){return this.h(ne,{includeChildren:!1},...Z)}affects(ne,...Z){return this.h(ne,{includeChildren:!0},...Z)}h(ne,Z,...q){if(!ne)return!1;const P=q.length>0;return!!((!P||q.includes(1))&&(this.d.value.get(ne)||Z.includeChildren&&this.d.value.findSuperstr(ne))||(!P||q.includes(0))&&(this.f.value.get(ne)||Z.includeChildren&&this.f.value.findSuperstr(ne))||(!P||q.includes(2))&&(this.g.value.findSubstr(ne)||Z.includeChildren&&this.g.value.findSuperstr(ne)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ne){return this.b===ne}hasCorrelation(){return typeof this.b=="number"}}e.$rk=U;function B(_,ne,Z){return!_||!ne||_===ne||ne.length>_.length?!1:(ne.charAt(ne.length-1)!==L.sep&&(ne+=L.sep),Z?(0,N.$3e)(_,ne):_.indexOf(ne)===0)}e.$sk=B;class Y extends Error{constructor(ne,Z,q){super(ne),this.fileOperationResult=Z,this.options=q}}e.$tk=Y;class K extends Y{constructor(ne,Z,q,P){super(ne,Z,P),this.fileOperationResult=Z,this.size=q}}e.$uk=K;class x extends Y{constructor(ne,Z,q){super(ne,2,q),this.stat=Z}}e.$vk=x;var V;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var Q;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$Dk="";function G(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Ek=G;async function W(_,ne){if(!ne.hasProvider(I.URI.from({scheme:_.scheme})))return new Promise(Z=>{const q=ne.onDidChangeFileSystemProviderRegistrations(P=>{P.scheme===_.scheme&&P.added&&(q.dispose(),Z())})})}e.$Fk=W;class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ne){return(0,A.$Cf)(ne)||(ne=0),ne<ee.KB?(0,R.localize)(1,null,ne.toFixed(0)):ne<ee.MB?(0,R.localize)(2,null,(ne/ee.KB).toFixed(2)):ne<ee.GB?(0,R.localize)(3,null,(ne/ee.MB).toFixed(2)):ne<ee.TB?(0,R.localize)(4,null,(ne/ee.GB).toFixed(2)):(0,R.localize)(5,null,(ne/ee.TB).toFixed(2))}}e.$Gk=ee;function ie(_){const ne=typeof _=="string"||_?.scheme===C.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===C.Schemas.file?1024*ee.MB:ne?10*ee.MB:g.$p?50*ee.MB:1024*ee.MB}e.$Hk=ie});var X=this&&this.__param||function(te,e){return function(D,L){e(D,L,te)}};define(oe[188],ae([0,1,70,46,11]),function(te,e,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j9b=void 0;let A=class{constructor(R){this.a=R}async checksum(R){const S=(await this.a.readFileStream(R)).value;return new Promise((g,C)=>{const k=(0,D.createHash)("md5");(0,L.$6d)(S,{onData:b=>k.update(b.buffer),onError:b=>C(b),onEnd:()=>g(k.digest("base64").replace(/=+$/,""))})})}};e.$j9b=A,e.$j9b=A=pe([X(0,N.$$j)],A)}),define(oe[99],ae([0,1,15,7,160,11]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;async function I(C,k,b,c,$,y){let p;try{await R(C,k,b,c,$,y)}catch(h){p=h}finally{p&&$.errorTransformer&&(p=$.errorTransformer(p)),typeof p<"u"&&b.error(p),b.end()}}e.$Pp=I;async function R(C,k,b,c,$,y){S(y);const p=await C.open(k,{create:!1});try{S(y);let h=0,f=0,u=$&&typeof $.length=="number"?$.length:void 0,d=D.$be.alloc(Math.min($.bufferSize,typeof u=="number"?u:$.bufferSize)),E=$&&typeof $.position=="number"?$.position:0,s=0;do f=await C.read(p,E,d.buffer,s,d.byteLength-s),E+=f,s+=f,h+=f,typeof u=="number"&&(u-=f),s===d.byteLength&&(await b.write(c(d)),d=D.$be.alloc(Math.min($.bufferSize,typeof u=="number"?u:$.bufferSize)),s=0);while(f>0&&(typeof u!="number"||u>0)&&S(y)&&g(h,$));if(s>0){let o=s;typeof u=="number"&&(o=Math.min(s,u)),b.write(c(d.slice(0,o)))}}catch(h){throw(0,A.$mk)(h)}finally{await C.close(p)}}function S(C){if(C.isCancellationRequested)throw(0,L.$5)();return!0}function g(C,k){if(typeof k?.limits?.size=="number"&&C>k.limits.size)throw(0,A.$lk)((0,N.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[49],ae([0,1,91,2,16,5,10,11]),function(te,e,D,L,N,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=e.$Rp=void 0;function S(h){return h.recursive===!0}e.$Rp=S;class g extends L.$Rc{static{this.a=5}constructor(f,u,d,E){super(),this.h=f,this.j=u,this.m=d,this.n=E,this.c=this.B(new L.$Sc),this.f=void 0,this.g=0}s(){const f=new L.$Qc;this.c.value=f,this.b=this.r(f),this.b.setVerboseLogging(this.m),f.add(this.b.onDidChangeFile(u=>this.h(u))),f.add(this.b.onDidLogMessage(u=>this.j(u))),f.add(this.b.onDidError(u=>this.t(u)))}t(f){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${f}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${f}`):this.w(f)}u(f){this.g++,this.s(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.m=f,await this.b?.setVerboseLogging(f)}w(f){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${f}`})}y(f){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Sp=g;class C extends g{constructor(f,u,d){super(f,u,d,{type:"node.js",restartOnError:!1})}}e.$Tp=C;class k extends g{constructor(f,u,d){super(f,u,d,{type:"universal",restartOnError:!0})}}e.$Up=k;function b(h){return h.map(f=>({type:f.type,resource:I.URI.revive(f.resource),cId:f.cId}))}e.$Vp=b;function c(h){const f=new p;for(const u of h)f.processEvent(u);return f.coalesce()}e.$Wp=c;function $(h,f){return typeof f=="string"&&!f.startsWith(D.$sj)&&!(0,N.$hc)(f)?{base:h,pattern:f}:f}e.$Xp=$;function y(h,f){const u=[];for(const d of f)u.push((0,D.$wj)($(h,d)));return u}e.$Yp=y;class p{constructor(){this.a=new Set,this.b=new Map}c(f){return A.$l?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const u=this.b.get(this.c(f));let d=!1;if(u){const E=u.type,s=f.type;u.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?d=!0:E===1&&s===2?(this.b.delete(this.c(f)),this.a.delete(u)):E===2&&s===1?u.type=0:E===1&&s===0||(u.type=s)}else d=!0;d&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],u=[];return Array.from(this.a).filter(d=>d.type!==2?(f.push(d),!1):!0).sort((d,E)=>d.resource.fsPath.length-E.resource.fsPath.length).filter(d=>u.some(E=>(0,R.$sk)(d.resource.fsPath,E,!A.$l))?!1:(u.push(d.resource.fsPath),!0)).concat(f)}}}),define(oe[189],ae([0,1,15,38,7,3,2,46,32,11,49]),function(te,e,D,L,N,A,I,R,S,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=void 0,e.$vN="localFilesystem";class k extends I.$Rc{constructor(c,$){super(),this.a=c,this.b=$,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$Nd),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$Nd),this.onDidWatchError=this.g.event,this.h=(0,S.$eg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(c){return this.a.call("stat",[c])}readdir(c){return this.a.call("readdir",[c])}async readFile(c,$){const{buffer:y}=await this.a.call("readFile",[c,$]);return y}readFileStream(c,$,y){const p=(0,R.$2d)(f=>D.$be.concat(f.map(u=>D.$be.wrap(u))).buffer),h=new I.$Qc;return h.add(this.a.listen("readFileStream",[c,$])(f=>{if(f instanceof D.$be)p.write(f.buffer);else{if(f==="end")p.end();else{let u;if(f instanceof Error)u=f;else{const d=f;u=(0,g.$lk)(d.message??(0,L.$Ai)(d),d.code??g.FileSystemProviderErrorCode.Unknown)}p.error(u),p.end()}h.dispose()}})),h.add(y.onCancellationRequested(()=>{p.error((0,N.$5)()),p.end(),h.dispose()})),p}writeFile(c,$,y){return this.a.call("writeFile",[c,D.$be.wrap($),y])}open(c,$){return this.a.call("open",[c,$])}close(c){return this.a.call("close",[c])}async read(c,$,y,p,h){const[f,u]=await this.a.call("read",[c,$,h]);return y.set(f.buffer.slice(0,u),p),u}write(c,$,y,p,h){return this.a.call("write",[c,$,D.$be.wrap(y),p,h])}mkdir(c){return this.a.call("mkdir",[c])}delete(c,$){return this.a.call("delete",[c,$])}rename(c,$,y){return this.a.call("rename",[c,$,y])}copy(c,$,y){return this.a.call("copy",[c,$,y])}cloneFile(c,$){return this.a.call("cloneFile",[c,$])}j(){this.B(this.a.listen("fileChange",[this.h])(c=>{if(Array.isArray(c)){const $=c;this.f.fire((0,C.$Vp)($))}else{const $=c;this.g.fire($)}}))}watch(c,$){const y=(0,S.$eg)();return this.a.call("watch",[this.h,y,c,$]),(0,I.$Pc)(()=>this.a.call("unwatch",[this.h,y]))}}e.$wN=k}),define(oe[190],ae([0,1,53,6,26,48,2,88,16,5,19,10,143,31,49]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;class y extends I.$Rc{static{this.a=100}static{this.b=75}constructor(f,u,d,E){super(),this.m=f,this.n=u,this.r=d,this.s=E,this.c=this.B(new L.$9g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.n(s))),this.f=this.B(new L.$8g(s=>this.z(s),y.b)),this.g=(0,$.$Yp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,$.$Yp)(this.m.path,this.m.includes):void 0,this.j=new N.$Xd,this.ready=this.t()}async t(){try{const f=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const u=await c.Promises.stat(f);this.B(await this.w(f,u.isDirectory()))}catch(f){f.code!=="ENOENT"?this.D(f):this.G(f)}}async u(f){let u=f.path;try{u=await c.Promises.realpath(f.path),f.path===u&&(u=await(0,b.$9p)(f.path)??f.path),f.path!==u&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${u})`)}catch{}return u}async w(f,u){if(g.$k&&(0,A.$Xf)(f,"/Volumes/",!0))return this.D(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.$Rc.None;const d=new N.$Xd(this.j.token),E=new I.$Qc;try{const s=k.URI.file(this.m.path),o=(0,S.$mc)(f),n=(0,D.watch)(f);E.add((0,I.$Pc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${f}'`);const i=new Set;if(u)try{for(const r of await c.Promises.readdir(f))i.add(r)}catch(r){this.D(r)}const t=new Map;E.add((0,I.$Pc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.D(`Failed to watch ${f} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(d.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${a}`);let v="";if(a&&(v=a.toString(),g.$k&&(v=(0,R.$ol)(v))),!(!v||r!=="change"&&r!=="rename"))if(u)if(r==="rename"){t.get(v)?.dispose();const w=setTimeout(async()=>{if(t.delete(v),v===o&&!await c.Promises.exists(f)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.C((0,S.$ic)(f,v));if(d.token.isCancellationRequested)return;let m;l?i.has(v)?m=0:(m=1,i.add(v)):(i.delete(v),m=2),this.y({resource:(0,C.$vg)(s,v),type:m,cId:this.m.correlationId})},y.a);t.set(v,(0,I.$Pc)(()=>clearTimeout(w)))}else{let w;i.has(v)?w=0:(w=1,i.add(v)),this.y({resource:(0,C.$vg)(s,v),type:w,cId:this.m.correlationId})}else if(r==="rename"||v!==o){const w=setTimeout(async()=>{const l=await c.Promises.exists(f);d.token.isCancellationRequested||(l?(this.y({resource:s,type:0,cId:this.m.correlationId},!0),E.add(await this.w(f,!1))):(this.y({resource:s,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},y.a);E.clear(),E.add((0,I.$Pc)(()=>clearTimeout(w)))}else this.y({resource:s,type:0,cId:this.m.correlationId},!0)})}catch(s){await c.Promises.exists(f)&&!d.token.isCancellationRequested&&this.D(`Failed to watch ${f} for changes using fs.watch() (${s.toString()})`)}return(0,I.$Pc)(()=>{d.dispose(!0),E.dispose()})}y(f,u=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!u&&this.g.some(d=>d(f.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${f.resource.fsPath}`):!u&&this.h&&this.h.length>0&&!this.h.some(d=>d(f.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}z(f){const u=(0,$.$Wp)(f);if(u.length>0){if(this.s)for(const E of u)this.G(` >> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(f){if(g.$l)return c.Promises.exists(f);try{const u=(0,S.$mc)(f);return(await c.Promises.readdir((0,S.$lc)(f))).some(E=>E===u)}catch(u){return this.G(u),!1}}setVerboseLogging(f){this.s=f}D(f){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}F(f){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}G(f){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$_p=y;async function p(h,f,u,d,E=512){const s=await c.Promises.open(h,"r"),o=Buffer.allocUnsafe(E),n=new N.$Xd(d);let i,t=!1;const r={path:h,excludes:[],recursive:!1},a=new y(r,v=>{(async()=>{for(const{type:w}of v)if(w===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:l}=await c.Promises.read(s,o,0,E,null);if(!l||n.token.isCancellationRequested)break;f(o.slice(0,l))}}catch(l){i=new Error(l),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,u(),new Promise((v,w)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await c.Promises.close(s)}catch(l){i=new Error(l)}i?w(i):v()})})}e.$aq=p}),define(oe[191],ae([0,1,3,91,2,5,190]),function(te,e,D,L,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;class R extends N.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(g){const C=this.j(g),k=C.filter(c=>{const $=this.c.get(c.path);return $?!(0,L.$Aj)($.request.excludes,c.excludes)||!(0,L.$Aj)($.request.includes,c.includes):!0}),b=Array.from(this.c.values()).filter(({request:c})=>!C.find($=>$.path===c.path&&(0,L.$Aj)($.excludes,c.excludes)&&(0,L.$Aj)($.includes,c.includes))).map(({request:c})=>c.path);k.length&&this.m(`Request to start watching: ${k.map(c=>`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`).join(",")}`),b.length&&this.m(`Request to stop watching: ${b.join(",")}`);for(const c of b)this.h(c);for(const c of k)this.g(c)}g(g){const C=new I.$_p(g,b=>this.a.fire(b),b=>this.b.fire(b),this.f),k={request:g,instance:C};this.c.set(g.path,k)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const C=this.c.get(g);C&&(this.c.delete(g),C.instance.dispose())}j(g){const C=new Map;for(const k of g){const b=A.$l?k.path:k.path.toLowerCase();let c=C.get(k.correlationId);c||(c=new Map,C.set(k.correlationId,c)),c.set(b,k)}return Array.from(C.values()).map(k=>Array.from(k.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,C]of this.c)C.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,C){return C?`[File Watcher (node.js)] ${g} (path: ${C.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$bq=R}),define(oe[192],ae([0,1,49,191]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class N extends D.$Tp{constructor(I,R,S){super(I,R,S),this.s()}r(I){return I.add(new L.$bq)}}e.$cq=N}),define(oe[193],ae([0,1,23,42,93,49]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;class I extends A.$Up{constructor(S,g,C){super(S,g,C),this.s()}r(S){const g=S.add(new N.$6p(D.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(g.onDidProcessExit(({code:C,signal:k})=>this.t(`terminated by itself with code ${C}, signal: ${k}`))),L.ProxyChannel.toService((0,L.$wh)(g.getChannel("watcher")))}}e.$7p=I}),define(oe[71],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class D{constructor(...N){this.a=new Map;for(const[A,I]of N)this.set(A,I)}set(N,A){const I=this.a.get(N);return this.a.set(N,A),I}has(N){return this.a.has(N)}get(N){return this.a.get(N)}}e.$Nh=D}),define(oe[194],ae([0,1,6,7,2,69,185,4,71,87]),function(te,e,D,L,N,A,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;const C=!1;class k extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class b{constructor(p=new S.$Nh,h=!1,f,u=C){this.f=p,this.g=h,this.h=f,this.i=u,this.o=new Set,this.f.set(R.$Oh,this),this._globalGraph=u?f?._globalGraph??new I.$fq(d=>d):void 0}createChild(p){return new b(p,this.g,this,this.i)}invokeFunction(p,...h){const f=$.traceInvocation(this.i,p);let u=!1;try{return p({get:E=>{if(u)throw(0,L.$7)("service accessor is only valid during the invocation of its target method");const s=this.m(E,f);if(!s)throw new Error(`[invokeFunction] unknown service '${E}'`);return s}},...h)}finally{u=!0,f.stop()}}createInstance(p,...h){let f,u;return p instanceof A.$Mh?(f=$.traceCreation(this.i,p.ctor),u=this.j(p.ctor,p.staticArguments.concat(h),f)):(f=$.traceCreation(this.i,p),u=this.j(p,h,f)),f.stop(),u}j(p,h=[],f){const u=R._util.getServiceDependencies(p).sort((s,o)=>s.index-o.index),d=[];for(const s of u){const o=this.m(s.id,f);o||this.u(`[createInstance] ${p.name} depends on UNKNOWN service ${s.id}.`,!1),d.push(o)}const E=u.length>0?u[0].index:h.length;if(h.length!==E){console.trace(`[createInstance] First service dependency of ${p.name} at position ${E+1} conflicts with ${h.length} static arguments`);const s=E-h.length;s>0?h=h.concat(new Array(s)):h=h.slice(0,E)}return Reflect.construct(p,h.concat(d))}k(p,h){if(this.f.get(p)instanceof A.$Mh)this.f.set(p,h);else if(this.h)this.h.k(p,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(p){const h=this.f.get(p);return!h&&this.h?this.h.l(p):h}m(p,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const f=this.l(p);return f instanceof A.$Mh?this.q(p,f,h.branch(p,!0)):(h.branch(p,!1),f)}q(p,h,f){if(this.o.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.o.add(p);try{return this.r(p,h,f)}finally{this.o.delete(p)}}r(p,h,f){const u=new I.$fq(s=>s.id.toString());let d=0;const E=[{id:p,desc:h,_trace:f}];for(;E.length;){const s=E.pop();if(u.lookupOrInsertNode(s),d++>1e3)throw new k(u);for(const o of R._util.getServiceDependencies(s.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${p} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),n instanceof A.$Mh){const i={id:o.id,desc:n,_trace:s._trace.branch(o.id,!0)};u.insertEdge(s,i),E.push(i)}}}for(;;){const s=u.roots();if(s.length===0){if(!u.isEmpty())throw new k(u);break}for(const{data:o}of s){if(this.l(o.id)instanceof A.$Mh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}u.removeNode(o)}}return this.l(p)}s(p,h,f=[],u,d){if(this.f.get(p)instanceof A.$Mh)return this.t(p,h,f,u,d);if(this.h)return this.h.s(p,h,f,u,d);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(p,h,f=[],u,d){if(u){const E=new b(void 0,this.g,this,this.i);E.c=String(p);const s=new Map,o=new D.$$g(()=>{const n=E.j(h,f,d);for(const[i,t]of s){const r=n[i];if(typeof r=="function")for(const a of t)r.apply(n,a)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let a=s.get(i);return a||(a=new g.$1c,s.set(i,a)),(w,l,m)=>{const O=a.push([w,l,m]);return(0,N.$Pc)(O)}}if(i in n)return n[i];const t=o.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),n[i]=r),r},set(n,i,t){return o.value[i]=t,!0},getPrototypeOf(n){return h.prototype}})}else return this.j(h,f,d)}u(p,h){if(h&&console.warn(p),this.g)throw new Error(p)}}e.$gq=b;var c;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(c||(c={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,h){return p?new $(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(p,h){return p?new $(1,h.name):$.c}static{this.f=0}constructor(p,h){this.type=p,this.name=h,this.g=Date.now(),this.h=[]}branch(p,h){const f=new $(3,p.toString());return this.h.push([p,h,f]),f}stop(){const p=Date.now()-this.g;$.f+=p;let h=!1;function f(d,E){const s=[],o=new Array(d+1).join("	");for(const[n,i,t]of E.h)if(i&&t){h=!0,s.push(`${o}CREATES -> ${n}`);const r=f(d+1,t);r&&s.push(r)}else s.push(`${o}uses -> ${n}`);return s.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(p>2||h)&&$.all.add(u.join(`
`))}}e.$hq=$}),define(oe[72],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T8b=e.$S8b=void 0,e.$S8b=(0,D.$Ph)("mainProcessService");class L{constructor(A,I){this.a=A,this.b=I}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,I){this.a.registerChannel(A,I)}}e.$T8b=L}),define(oe[73],ae([0,1,26,2,5,162,29,4]),function(te,e,D,L,N,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=void 0;function S(C){return C.tags.find(k=>k.startsWith("lp-"))?.split("lp-")[1]}e.$Uq=S,e.$Vq=(0,R.$Ph)("languagePackService");let g=class extends L.$Rc{constructor(k){super(),this.c=k}async getAvailableLanguages(){const k=new D.$Xd;setTimeout(()=>k.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},k.token)}catch{return[]}const $=b.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(p=>p.startsWith("lp-"))).map(y=>{const p=y.properties.localizedLanguages?.[0],h=S(y);return{...this.f(h,p,y),extensionId:y.identifier.id,galleryExtension:y}});return $.push(this.f("en","English")),$}f(k,b,c){const $=b??k;let y;if($!==k&&(y=`(${k})`),k.toLowerCase()===N.$w.toLowerCase()&&(y??="",y+=(0,A.localize)(0,null)),c?.installCount){y??="";const p=c.installCount;let h;p>1e6?h=`${Math.floor(p/1e5)/10}M`:p>1e3?h=`${Math.floor(p/1e3)}K`:h=String(p),y+=` $(cloud-download) ${h}`}return{id:k,label:$,description:y}}};e.$Wq=g,e.$Wq=g=pe([X(0,I.$ao)],g)}),define(oe[195],ae([0,1,2,73]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f9b=void 0;let N=class extends D.$Rc{constructor(I){super(),this.a=I,this.b()}b(){this.a.update()}};e.$f9b=N,e.$f9b=N=pe([X(0,L.$Vq)],N)}),define(oe[8],ae([0,1,38,3,52,2,34,5,19,12,10,94,4]),function(te,e,D,L,N,A,I,R,S,g,C,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,b.$Ph)("logService"),e.$$i=(0,b.$Ph)("loggerService");function c(){return new Date().toISOString()}function $(w){return(0,g.$Cf)(w)}e.$_i=$;var y;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$aj=y.Info;function p(w,l,m){switch(l){case y.Trace:w.trace(m);break;case y.Debug:w.debug(m);break;case y.Info:w.info(m);break;case y.Warning:w.warn(m);break;case y.Error:w.error(m);break;case y.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=p;function h(w,l=!1){let m="";for(let O=0;O<w.length;O++){let F=w[O];if(F instanceof Error&&(F=(0,D.$Ai)(F,l)),typeof F=="object")try{F=JSON.stringify(F)}catch{}m+=(O>0?" ":"")+F}return m}class f extends A.$Rc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new L.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==y.Off&&this.b<=l}}e.$cj=f;class u extends f{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...m){this.f(y.Trace)&&this.g(y.Trace,h([l,...m],!0))}debug(l,...m){this.f(y.Debug)&&this.g(y.Debug,h([l,...m]))}info(l,...m){this.f(y.Info)&&this.g(y.Info,h([l,...m]))}warn(l,...m){this.f(y.Warning)&&this.g(y.Warning,h([l,...m]))}error(l,...m){if(this.f(y.Error))if(l instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=l.stack,this.g(y.Error,h(O))}else this.g(y.Error,h([l,...m]))}flush(){}}e.$dj=u;class d extends f{constructor(l=e.$aj){super(),this.setLevel(l),this.g=!R.$j}trace(l,...m){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,l,...m):console.log(`[main ${c()}]`,l,...m))}debug(l,...m){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,l,...m):console.log(`[main ${c()}]`,l,...m))}info(l,...m){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,l,...m):console.log(`[main ${c()}]`,l,...m))}warn(l,...m){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,l,...m):console.warn(`[main ${c()}]`,l,...m))}error(l,...m){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,l,...m):console.error(`[main ${c()}]`,l,...m))}dispose(){}flush(){}}e.$ej=d;class E extends f{constructor(l=e.$aj,m=!0){super(),this.g=m,this.setLevel(l)}trace(l,...m){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",l,...m):console.log(l,...m))}debug(l,...m){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",l,...m):console.log(l,...m))}info(l,...m){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",l,...m):console.log(l,...m))}warn(l,...m){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",l,...m):console.log(l,...m))}error(l,...m){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",l,...m):console.error(l,...m))}dispose(){}flush(){}}e.$fj=E;class s extends f{constructor(l,m=e.$aj){super(),this.g=l,this.setLevel(m)}trace(l,...m){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(l),...m])}debug(l,...m){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(l),...m])}info(l,...m){this.f(y.Info)&&this.g.log(y.Info,[this.h(l),...m])}warn(l,...m){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(l),...m])}error(l,...m){this.f(y.Error)&&this.g.log(y.Error,[this.h(l),...m])}h(l){return typeof l=="string"?l:(0,D.$Ai)(l,this.f(y.Trace))}dispose(){}flush(){}}e.$gj=s;class o extends f{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const m of this.g)m.setLevel(l);super.setLevel(l)}trace(l,...m){for(const O of this.g)O.trace(l,...m)}debug(l,...m){for(const O of this.g)O.debug(l,...m)}info(l,...m){for(const O of this.g)O.info(l,...m)}warn(l,...m){for(const O of this.g)O.warn(l,...m)}error(l,...m){for(const O of this.g)O.error(l,...m)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.$hj=o;class n extends A.$Rc{constructor(l,m,O){if(super(),this.h=l,this.j=m,this.b=new I.$zc,this.c=this.B(new L.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$Nd),this.onDidChangeVisibility=this.g.event,O)for(const F of O)this.b.set(F.resource,{logger:void 0,info:F})}m(l){return(0,g.$yf)(l)?[...this.b.values()].find(m=>m.info.id===l):this.b.get(l)}getLogger(l){return this.m(l)?.logger}createLogger(l,m){const O=this.n(l),F=(0,g.$yf)(l)?l:m?.id??(0,N.$Di)(O.toString()).toString(16);let z=this.b.get(O)?.logger;const U=m?.logLevel==="always"?y.Trace:m?.logLevel;z||(z=this.s(O,U??this.getLogLevel(O)??this.h,{...m,id:F}));const B={logger:z,info:{resource:O,id:F,logLevel:U,name:m?.name,hidden:m?.hidden,extensionId:m?.extensionId,when:m?.when}};return this.registerLogger(B.info),this.b.set(O,B),z}n(l){return(0,g.$yf)(l)?(0,S.$vg)(this.j,`${l}.log`):l}setLogLevel(l,m){if(C.URI.isUri(l)){const O=l,F=m,z=this.b.get(O);z&&F!==z.info.logLevel&&(z.info.logLevel=F===this.h?void 0:F,z.logger?.setLevel(F),this.b.set(z.info.resource,z),this.f.fire([O,F]))}else{this.h=l;for(const[O,F]of this.b.entries())this.b.get(O)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(l,m){const O=this.m(l);O&&m!==!O.info.hidden&&(O.info.hidden=!m,this.b.set(O.info.resource,O),this.g.fire([O.info.resource,m]))}getLogLevel(l){let m;return l&&(m=this.b.get(l)?.info.logLevel),m??this.h}registerLogger(l){const m=this.b.get(l.resource);m?m.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.b.set(l.resource,{info:l,logger:void 0}),this.c.fire({added:[l],removed:[]}))}deregisterLogger(l){const m=this.b.get(l);m&&(m.logger&&m.logger.dispose(),this.b.delete(l),this.c.fire({added:[],removed:[m.info]}))}*getRegisteredLoggers(){for(const l of this.b.values())yield l.info}getRegisteredLogger(l){return this.b.get(l)?.info}dispose(){this.b.forEach(l=>l.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=n;class i{constructor(){this.onDidChangeLogLevel=new L.$Nd().event}setLevel(l){}getLevel(){return y.Info}trace(l,...m){}debug(l,...m){}info(l,...m){}warn(l,...m){}error(l,...m){}critical(l,...m){}dispose(){}flush(){}}e.$jj=i;class t extends i{}e.$kj=t;function r(w){if(w.verbose)return y.Trace;if(typeof w.logLevel=="string"){const l=v(w.logLevel.toLowerCase());if(l!==void 0)return l}return e.$aj}e.$lj=r;function a(w){switch(w){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$mj=a;function v(w){switch(w){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$nj=v,e.$oj=new k.$7i("logLevel",a(y.Info))}),define(oe[196],ae([0,1,6,7,2,23,16,19,31,14,8]),function(te,e,D,L,N,A,I,R,S,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g9b=void 0;let k=class extends N.$Rc{constructor(c,$){super(),this.a=c,this.b=$,this.B(new D.$6g(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const c=(0,R.$sg)(this.a.logsHome),$=(0,R.$ug)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,h=(await S.Promises.readdir($)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==c),f=h.slice(0,Math.max(0,h.length-9));f.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(u=>S.Promises.rm((0,I.$ic)($,u)))))}catch(c){(0,L.$Z)(c)}}};e.$g9b=k,e.$g9b=k=pe([X(0,g.$Wh),X(1,C.$0i)],k)}),define(oe[197],ae([0,1,18,6,7,3,2,16,49,8]),function(te,e,D,L,N,A,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class C extends I.$Rc{constructor(b,c){super(),this.a=b,this.b=c,this.c=this.B(new A.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new L.$Rg(0)),this.w=[],this.y=this.B(new L.$Rg(0))}watch(b,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n(b,c):this.z(b,c)}n(b,c){const $={path:this.H(b),excludes:c.excludes,includes:c.includes,recursive:c.recursive,correlationId:c.correlationId},y=(0,D.$Tb)(this.j,$);return this.r(),(0,I.$Pc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,N.$Z)(b))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,S.$Vp)(c)),c=>this.G(c),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const c of this.j)(0,S.$Rp)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const c of this.j)(0,S.$Rp)(c)&&b.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,c){const $={path:this.H(b),excludes:c.excludes,includes:c.includes,recursive:!1,correlationId:c.correlationId},y=(0,D.$Tb)(this.w,$);return this.C(),(0,I.$Pc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,N.$Z)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,S.$Vp)(b)),b=>this.G(b),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,R.$gc)(b.fsPath)}}e.$Zp=C}),define(oe[198],ae([0,1,18,6,15,26,3,52,59,2,47,23,100,19,46,158,11,99,8,7]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f,u){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;let E=class extends g.$Rc{static{d=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new I.$Nd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.$Nd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.$Nd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new I.$Nd),this.onDidRunOperation=this.r.event,this.X=this.B(new I.$Nd),this.Y=this.B(new I.$Nd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new I.$Nd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new L.$3g)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${o}`);const i=new g.$Qc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),i.add(n.onDidChangeFile(t=>{const r=new p.$rk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&i.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),i.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,g.$Pc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,g.$Mc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(i){n.push(i)}}),!this.h.has(o)&&await L.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&n)}listCapabilities(){return S.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,c.$zg)(o))throw new p.$tk((0,y.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const i=new u.$ab;throw i.message=(0,y.localize)(1,null,o.toString()),i}return n}async m(o){const n=await this.j(o);if((0,p.$ek)(n)||(0,p.$bk)(n)||(0,p.$fk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,p.$ek)(n)||(0,p.$bk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(i){throw(0,p.$ok)(i)===p.FileSystemProviderErrorCode.FileNotFound?new p.$tk((0,y.localize)(2,null,this.sb(o)),1):(0,p.$mk)(i)}}async s(o,n){const i=await this.j(o),t=this.S(i),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,w=await i.stat(o);let l;return this.t(i,o,w,void 0,!!v,(m,O)=>(l||(l=C.$Vh.forUris(()=>!t),l.set(o,!0),r&&l.fill(!0,r)),l.get(m.resource)||l.findSuperstr(m.resource.with({query:null,fragment:null}))?!0:m.isDirectory&&a?O===1:!1))}async t(o,n,i,t,r,a){const{providerExtUri:v}=this.R(o),w={resource:n,name:v.basename(n),isFile:(i.type&p.FileType.File)!==0,isDirectory:(i.type&p.FileType.Directory)!==0,isSymbolicLink:(i.type&p.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&p.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&p.FilePermission.Locked),etag:(0,p.$Ek)({mtime:i.mtime,size:i.size}),children:void 0};if(w.isDirectory&&a(w,t)){try{const l=await o.readdir(n),m=await L.Promises.settled(l.map(async([O,F])=>{try{const z=v.joinPath(n,O),U=r?await o.stat(z):{type:F};return await this.t(o,z,U,l.length,r,a)}catch(z){return this.b.trace(z),null}}));w.children=(0,D.$Gb)(m)}catch(l){this.b.trace(l),w.children=[]}return w}return w}async resolveAll(o){return L.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),i=await n.stat(o);return this.t(n,o,i,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(i){return i}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new p.$tk((0,y.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=N.$be.fromString(""),i){await this.u(o,i);const t=await this.writeFile(o,n);return this.r.fire(new p.$qk(o,0,t)),t}async writeFile(o,n,i){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=i;if((0,p.$hk)(t)&&!a?.atomic){const v=t.enforceAtomicWriteFile?.(o);v&&(a={...i,atomic:v})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let w;if((0,p.$bk)(t)&&!(n instanceof N.$be))if((0,$.$Zd)(n)){const l=await(0,$.$7d)(n,3);l.ended?w=N.$be.concat(l.buffer):w=l}else w=(0,$.$4d)(n,l=>N.$be.concat(l),3);else w=n;!(0,p.$ek)(t)||(0,p.$bk)(t)&&w instanceof N.$be||(0,p.$bk)(t)&&(0,p.$hk)(t)&&a?.atomic?await this.hb(t,o,a,w):await this.db(t,o,a,w instanceof N.$be?(0,N.$me)(w):w),this.r.fire(new p.$qk(o,4))}catch(v){throw new p.$tk((0,y.localize)(4,null,this.sb(o),(0,p.$mk)(v).toString()),(0,p.$pk)(v),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,i){const t=!!i?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(n)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(n)));if(t)throw new Error((0,y.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&p.FileType.Directory)throw new p.$tk((0,y.localize)(9,null,this.sb(n)),0,i);if(this.rb(n,a),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==p.$Dk&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==(0,p.$Ek)({mtime:i.mtime,size:a.size}))throw new p.$tk((0,y.localize)(10,null),3,i);return a}async readFile(o,n,i){const t=await this.m(o);return n?.atomic?this.z(t,o,n,i):this.C(t,o,n,i)}async z(o,n,i,t){return new Promise((r,a)=>{this.cb.queueFor(n,this.R(o).providerExtUri).queue(async()=>{try{const v=await this.C(o,n,i,t);r(v)}catch(v){a(v)}})})}async C(o,n,i,t){const r=await this.D(o,n,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,N.$ne)(r.value)}}async readFileStream(o,n,i){const t=await this.m(o);return this.D(t,o,n,i)}async D(o,n,i,t){const r=new A.$Xd(t);let a=i;(0,p.$gk)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...i,atomic:!0});const v=this.J(n,a).then(l=>l,l=>{throw r.dispose(!0),l});let w;try{return typeof a?.etag=="string"&&a.etag!==p.$Dk&&await v,a?.atomic&&(0,p.$gk)(o)||!((0,p.$ek)(o)||(0,p.$fk)(o))||(0,p.$bk)(o)&&a?.preferUnbuffered?w=this.I(o,n,a):(0,p.$fk)(o)?w=this.G(o,n,r.token,a):w=this.H(o,n,r.token,a),w.on("end",()=>r.dispose()),w.on("error",()=>r.dispose()),{...await v,value:w}}catch(l){throw w&&await(0,$.$5d)(w),this.F(l,n,a)}}F(o,n,i){const t=(0,y.localize)(11,null,this.sb(n),(0,p.$mk)(o).toString());return o instanceof p.$vk?new p.$vk(t,o.stat,i):o instanceof p.$uk?new p.$uk(t,o.fileOperationResult,o.size,o.options):new p.$tk(t,(0,p.$pk)(o),i)}G(o,n,i,t=Object.create(null)){const r=o.readFileStream(n,t,i);return(0,$.$$d)(r,{data:a=>a instanceof N.$be?a:N.$be.wrap(a),error:a=>this.F(a,n,t)},a=>N.$be.concat(a))}H(o,n,i,t=Object.create(null)){const r=(0,N.$re)();return(0,h.$Pp)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},i),r}I(o,n,i){const t=(0,$.$2d)(r=>N.$be.concat(r));return(async()=>{try{let r;i?.atomic&&(0,p.$gk)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(n,r.byteLength,i),t.end(N.$be.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new p.$tk((0,y.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==p.$Dk&&n.etag===i.etag)throw new p.$vk((0,y.localize)(13,null),i,n);return this.L(o,i.size,n),i}L(o,n,i){if(typeof i?.limits?.size=="number"&&n>i.limits.size)throw new p.$uk((0,y.localize)(14,null,this.sb(o)),7,n,i)}async canMove(o,n,i){return this.M(o,n,"move",i)}async canCopy(o,n,i){return this.M(o,n,"copy",i)}async M(o,n,i,t){if(o.toString()!==n.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,i,t)}catch(r){return r}return!0}async move(o,n,i){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new p.$qk(o,a==="move"?2:3,v)),v}async copy(o,n,i){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new p.$qk(o,a==="copy"?3:2,v)),v}async N(o,n,i,t,r,a){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:w}=await this.Q(o,n,i,t,r,a);if(v&&!w&&a&&await this.del(t,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(t)),r==="copy"){if(o===i&&(0,p.$ck)(o))await o.copy(n,t,{overwrite:a});else{const l=await this.resolve(n);l.isDirectory?await this.P(o,l,i,t):await this.O(o,n,i,t)}return r}else return o===i?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,i,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,i,t){if((0,p.$ek)(o)&&(0,p.$ek)(i))return this.jb(o,n,i,t);if((0,p.$ek)(o)&&(0,p.$bk)(i))return this.pb(o,n,i,t);if((0,p.$bk)(o)&&(0,p.$ek)(i))return this.nb(o,n,i,t);if((0,p.$bk)(o)&&(0,p.$bk)(i))return this.lb(o,n,i,t)}async P(o,n,i,t){await i.mkdir(t),Array.isArray(n.children)&&await L.Promises.settled(n.children.map(async r=>{const a=this.R(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,a):this.O(o,r.resource,i,a)}))}async Q(o,n,i,t,r,a){let v=!1;if(o===i){const{providerExtUri:l,isPathCaseSensitive:m}=this.R(o);if(m||(v=l.isEqual(n,t)),v&&r==="copy")throw new Error((0,y.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&l.isEqualOrParent(t,n))throw new Error((0,y.localize)(16,null,this.sb(n),this.sb(t)))}const w=await this.exists(t);if(w&&!v){if(!a)throw new p.$tk((0,y.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===i){const{providerExtUri:l}=this.R(o);if(l.isEqualOrParent(n,t))throw new Error((0,y.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:w,isSameResourceWithDifferentPathCase:v}}R(o){const n=this.S(o);return{providerExtUri:n?c.$lg:c.$ng,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new p.$qk(o,0,i)),i}async U(o,n){const i=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&p.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(n)));break}catch(r){if((0,p.$ok)(r)!==p.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(n)),n=t.dirname(n)}for(let r=i.length-1;r>=0;r--){n=t.joinPath(n,i[r]);try{await o.mkdir(n)}catch(a){if((0,p.$ok)(a)!==p.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(i){return i}return!0}async W(o,n){const i=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,y.localize)(22,null,this.sb(o)));let a;try{a=await i.stat(o)}catch{}if(a)this.rb(o,a);else throw new p.$tk((0,y.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const w=await this.resolve(o);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(o)))}return i}async del(o,n){const i=await this.W(o,n);let t=n;if((0,p.$ik)(i)&&!t?.atomic){const w=i.enforceAtomicDelete?.(o);w&&(t={...n,atomic:w})}const r=!!t?.useTrash,a=!!t?.recursive,v=t?.atomic??!1;await i.delete(o,{recursive:a,useTrash:r,atomic:v}),this.r.fire(new p.$qk(o,1))}async cloneFile(o,n){const i=await this.j(o),t=this.qb(await this.n(n),n);if(i===t&&this.R(i).providerExtUri.isEqual(o,n))return;if(i===t&&(0,p.$dk)(i))return i.cloneFile(o,n);await this.U(t,this.R(t).providerExtUri.dirname(n));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===t&&(0,p.$ck)(i)?r.queue(()=>i.copy(o,n,{overwrite:!0})):r.queue(()=>this.O(i,o,t,n))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:d.ab++})}watch(o,n={recursive:!1,excludes:[]}){const i=new g.$Qc;let t=!1,r=()=>{t=!0};i.add((0,g.$Pc)(()=>r())),(async()=>{try{const v=await this.bb(o,n);t?(0,g.$Mc)(v):r=()=>(0,g.$Mc)(v)}catch(v){this.b.error(v)}})();const a=n.correlationId;if(typeof a=="number"){const v=i.add(new I.$Nd);return i.add(this.X.event(l=>{l.correlates(a)&&v.fire(l)})),{onDidChange:v.event,dispose:()=>i.dispose()}}return i}async bb(o,n){const i=await this.j(o),t=(0,R.$Di)([this.R(i).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:i.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,g.$Pc)(()=>{r&&(r.count--,r.count===0&&((0,g.$Mc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,g.$Mc)(o.disposable);this.$.clear()}async db(o,n,i,t){return this.cb.queueFor(n,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(n,{create:!0,unlock:i?.unlock??!1});try{(0,$.$Zd)(t)||(0,$.$1d)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,p.$mk)(a)}finally{await o.close(r)}})}async eb(o,n,i){let t=0,r;if((0,$.$1d)(i)){if(i.buffer.length>0){const a=N.$be.concat(i.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((a,v)=>{(0,$.$6d)(r,{onData:async w=>{r.pause();try{await this.gb(o,n,w,w.byteLength,t,0)}catch(l){return v(l)}t+=w.byteLength,setTimeout(()=>r.resume())},onError:w=>v(w),onEnd:()=>a()})})}async fb(o,n,i){let t=0,r;for(;(r=i.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,i,t,r,a){let v=0;for(;v<t;){const w=await o.write(n,r+v,i.buffer,a+v,t-v);v+=w}}async hb(o,n,i,t){return this.cb.queueFor(n,this.R(o).providerExtUri).queue(()=>this.ib(o,n,i,t))}async ib(o,n,i,t){let r;t instanceof N.$be?r=t:(0,$.$Zd)(t)?r=await(0,N.$ne)(t):(0,$.$1d)(t)?r=await(0,N.$oe)(t):r=(0,N.$le)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.kb(o,n,i,t))}async kb(o,n,i,t){let r,a;try{r=await o.open(n,{create:!1}),a=await i.open(t,{create:!0,unlock:!1});const v=N.$be.alloc(this.a);let w=0,l=0,m=0;do m=await o.read(r,w,v.buffer,l,v.byteLength-l),await this.gb(i,a,v,m,w,l),w+=m,l+=m,l===v.byteLength&&(l=0);while(m>0)}catch(v){throw(0,p.$mk)(v)}finally{await L.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async lb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.mb(o,n,i,t))}async mb(o,n,i,t){return i.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.ob(o,n,i,t))}async ob(o,n,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(i,r,N.$be.wrap(a),a.byteLength,0,0)}catch(a){throw(0,p.$mk)(a)}finally{await i.close(r)}}async pb(o,n,i,t){const r=await(0,N.$ne)(this.H(o,n,A.CancellationToken.None));await this.hb(i,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new p.$tk((0,y.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&p.FilePermission.Readonly)throw new p.$tk((0,y.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===k.Schemas.file?o.fsPath:o.toString(!0)}};e.$Qp=E,e.$Qp=E=d=pe([X(0,f.$0i)],E)}),define(oe[199],ae([0,1,53,269,6,34,15,3,48,2,16,5,19,46,31,161,11,99,197,38,193,192]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f,u,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0,(()=>{try{(0,L.gracefulify)(D)}catch(o){console.error(`Error enabling graceful-fs: ${(0,u.$Ai)(o)}`)}})();class s extends f.$Zp{static{this.I=!1}constructor(n,i){super(n,i),this.onDidChangeCapabilities=R.Event.None,this.N=new A.$zc(t=>b.$mg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,k.$l&&(this.J|=1024)),this.J}async stat(n){try{const{stat:i,symbolicLink:t}=await $.SymlinkSupport.stat(this.H(n));return{type:this.M(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await $.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,b.$vg)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(i){throw this.fb(i)}}M(n,i){let t;return i?.dangling?t=p.FileType.Unknown:n.isFile()?t=p.FileType.File:n.isDirectory()?t=p.FileType.Directory:t=p.FileType.Unknown,i&&(t|=p.FileType.SymbolicLink),t}async O(n){const i=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new N.$Sg;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,g.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(n,i){let t;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await $.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){s.I&&this.a.trace(n)}readFileStream(n,i,t){const r=(0,c.$2d)(a=>I.$be.concat(a.map(v=>I.$be.wrap(v))).buffer);return(0,h.$Pp)(this,n,r,a=>a.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(n,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,b.$vg)((0,b.$ug)(n),`${(0,b.$sg)(n)}${t.atomic.postfix}`),i,t):this.S(n,i,t)}async Q(n){try{const i=this.H(n),{symbolicLink:t}=await $.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async R(n,i,t,r){const a=new g.$Qc;try{a.add(await this.O(n)),a.add(await this.O(i)),await this.S(i,t,r,!0);try{await this.rename(i,n,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{a.dispose()}}async S(n,i,t,r){let a;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await $.Promises.exists(v)){if(!t.overwrite)throw(0,p.$lk)((0,y.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,p.$lk)((0,y.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,i,0,i.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(n){s.Y=n}async open(n,i,t){const r=this.H(n);let a;(0,p.$_j)(i)&&!t&&(a=await this.O(n));let v;try{if((0,p.$_j)(i)&&i.unlock)try{const{stat:l}=await $.SymlinkSupport.stat(r);l.mode&128||await $.Promises.chmod(r,l.mode|128)}catch(l){l.code!=="ENOENT"&&this.a.trace(l)}let w;if((0,p.$_j)(i)){if(k.$j)try{await $.Promises.truncate(r,0),w="r+"}catch(l){l.code!=="ENOENT"&&this.a.trace(l)}w||(w="w")}else w="r";v=await $.Promises.open(r,w)}catch(w){throw a?.dispose(),(0,p.$_j)(i)?await this.gb(n,w):this.fb(w)}if(this.U.set(v,0),(0,p.$_j)(i)&&this.X.set(v,n),a){const w=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,a),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),w.dispose())}return v}async close(n){const i=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&s.Y)try{await $.Promises.fdatasync(n)}catch(t){s.configureFlushOnWrite(!1),this.a.error(t)}return await $.Promises.close(n)}catch(t){throw this.fb(t)}finally{i&&(this.W.get(n)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,t,r,a){const v=this.Z(n,i);let w=null;try{w=(await $.Promises.read(n,t,r,a,v)).bytesRead}catch(l){throw this.fb(l)}finally{this.$(n,v,w)}return w}Z(n,i){return i===this.U.get(n)?null:i}$(n,i,t){const r=this.U.get(n);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,i,t,r,a){return(0,N.$_g)(()=>this.ab(n,i,t,r,a),100,3)}async ab(n,i,t,r,a){const v=this.Z(n,i);let w=null;try{w=(await $.Promises.write(n,t,r,a,v)).bytesWritten}catch(l){throw await this.gb(this.X.get(n),l)}finally{this.$(n,v,w)}return w}async mkdir(n){try{await $.Promises.mkdir(this.H(n))}catch(i){throw this.fb(i)}}async delete(n,i){try{const t=this.H(n);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,C.$ic)((0,C.$lc)(t),`${(0,C.$mc)(t)}${i.atomic.postfix}`)),await $.Promises.rm(t,$.RimRafMode.MOVE,r)}else try{await $.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:v,symbolicLink:w}=await $.SymlinkSupport.stat(t);a=v.isDirectory()&&!w}catch{}if(a)await $.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,i,t){const r=this.H(n),a=this.H(i);if(r!==a)try{await this.bb(n,i,"move",t.overwrite),await $.Promises.rename(r,a)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,y.localize)(2,null,(0,C.$mc)(r),(0,C.$mc)((0,C.$lc)(a)),v.toString()))),this.fb(v)}}async copy(n,i,t){const r=this.H(n),a=this.H(i);if(r!==a)try{await this.bb(n,i,"copy",t.overwrite),await $.Promises.copy(r,a,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,y.localize)(3,null,(0,C.$mc)(r),(0,C.$mc)((0,C.$lc)(a)),v.toString()))),this.fb(v)}}async bb(n,i,t,r){const a=this.H(n),v=this.H(i);let w=!1;if(!!(this.capabilities&1024)||(w=(0,S.$Wf)(a,v,!0)),w){if(t==="copy")throw(0,p.$lk)((0,y.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const m=await this.L(n);if(!m)throw(0,p.$lk)((0,y.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const O=await this.L(i);if(O){if(!r)throw(0,p.$lk)((0,y.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);m.type&p.FileType.File&&O.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.cb(n,i,!1)}async cb(n,i,t){const r=this.H(n),a=this.H(i),v=!!(this.capabilities&1024);if((0,S.$Wf)(r,a,!v))return;const w=new g.$Qc;try{w.add(await this.O(n)),w.add(await this.O(i)),t&&await $.Promises.mkdir((0,C.$lc)(a),{recursive:!0}),await $.Promises.copyFile(r,a)}catch(l){if(l.code==="ENOENT"&&!t)return this.cb(n,i,!0);throw this.fb(l)}finally{w.dispose()}}t(n,i,t){return new d.$7p(r=>n(r),r=>i(r),t)}F(n,i,t){return new E.$cq(r=>n(r),r=>i(r),t)}fb(n){if(n instanceof p.$kk)return n;let i=n,t;switch(n.code){case"ENOENT":t=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=p.FileSystemProviderErrorCode.Unknown;break;default:t=p.FileSystemProviderErrorCode.Unknown}return(0,p.$lk)(i,t)}async gb(n,i){let t=this.fb(i);if(n&&t.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await $.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,p.$lk)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$dq=s}),define(oe[101],ae([0,1,3,2,4,8]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J9b=e.$I9b=void 0,e.$I9b=(0,N.$Ph)("sharedProcessLifecycleService");let I=class extends L.$Rc{constructor(S){super(),this.b=S,this.a=this.B(new D.$Nd),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$J9b=I,e.$J9b=I=pe([X(0,A.$0i)],I)}),define(oe[200],ae([0,1,10,3,8,2]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=void 0;class I extends N.$ij{constructor(k,b,c,$,y){super(b,c,$),this.r=k,this.t=y,this.B(y.listen("onDidChangeLogLevel",k)(p=>{(0,N.$_i)(p)?super.setLogLevel(p):super.setLogLevel(D.URI.revive(p[0]),p[1])})),this.B(y.listen("onDidChangeVisibility",k)(([p,h])=>super.setVisibility(D.URI.revive(p),h))),this.B(y.listen("onDidChangeLoggers",k)(({added:p,removed:h})=>{for(const f of p)super.registerLogger({...f,resource:D.URI.revive(f.resource)});for(const f of h)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new N.$gj({log:(k,b)=>{this.t.call("consoleLog",[k,b])}})}registerLogger(k){super.registerLogger(k),this.t.call("registerLogger",[k,this.r])}deregisterLogger(k){super.deregisterLogger(k),this.t.call("deregisterLogger",[k,this.r])}setLogLevel(k,b){super.setLogLevel(k,b),this.t.call("setLogLevel",[k,b])}setVisibility(k,b){super.setVisibility(k,b),this.t.call("setVisibility",[this.n(k),b])}s(k,b,c){return new R(this.t,k,b,c,this.r)}static setLogLevel(k,b,c){return k.call("setLogLevel",[b,c])}}e.$br=I;class R extends N.$dj{constructor(k,b,c,$,y){super($?.logLevel==="always"),this.r=k,this.s=b,this.m=!1,this.n=[],this.setLevel(c),this.r.call("createLogger",[b,$,y]).then(()=>{this.u(this.n),this.m=!0})}g(k,b){const c=[[k,b]];this.m?this.u(c):this.n.push(...c)}u(k){this.r.call("log",[this.s,k])}}class S{constructor(k,b){this.a=k,this.b=b}listen(k,b){const c=this.b(k);switch(b){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(y=>this.c(y,c)),removed:[...$.removed].map(y=>this.c(y,c))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,$=>[c.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,$=>(0,N.$_i)($)?$:[c.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${b}`)}async call(k,b,c){const $=this.b(k);switch(b){case"setLogLevel":return(0,N.$_i)(c[0])?this.a.setLogLevel(c[0]):this.a.setLogLevel(D.URI.revive($.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,$)))}throw new Error(`Call not found: ${b}`)}c(k,b){return{...k,resource:b.transformOutgoingURI(k.resource)}}}e.$cr=S;class g extends A.$Rc{constructor(k,b){super(),b.call("setLogLevel",[k.getLogLevel()]),this.B(k.onDidChangeLogLevel(c=>b.call("setLogLevel",[c]))),b.call("getRegisteredLoggers").then(c=>{for(const $ of c)k.registerLogger({...$,resource:D.URI.revive($.resource)})}),this.B(b.listen("onDidChangeVisibility")(([c,$])=>k.setVisibility(D.URI.revive(c),$))),this.B(b.listen("onDidChangeLoggers")(({added:c,removed:$})=>{for(const y of c)k.registerLogger({...y,resource:D.URI.revive(y.resource)});for(const y of $)k.deregisterLogger(y.resource)}))}}e.$dr=g}),define(oe[201],ae([0,1,2,8]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;class N extends D.$Rc{constructor(I,R=[]){super(),this.a=new L.$hj([I,...R]),this.B(I.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...R){this.a.trace(I,...R)}debug(I,...R){this.a.debug(I,...R)}info(I,...R){this.a.info(I,...R)}warn(I,...R){this.a.warn(I,...R)}error(I,...R){this.a.error(I,...R)}flush(){this.a.flush()}}e.$NN=N}),define(oe[55],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E7b=void 0,e.$E7b=(0,D.$Ph)("nativeHostService")}),define(oe[56],ae([0,1,3,59,2,4]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=void 0,e.$ln=(0,A.$Ph)("policy");class I extends N.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$Nd),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const C=Object.keys(this.f).length;return this.f={...g,...this.f},C!==Object.keys(this.f).length&&await this.j(g),L.Iterable.reduce(this.g.entries(),(k,[b,c])=>({...k,[b]:c}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(g,[C,k])=>({...g,[C]:{definition:k,value:this.g.get(C)}}),{})}}e.$mn=I;class R{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$nn=R}),define(oe[202],ae([0,1,3,2,56]),function(te,e,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=e.$o8b=void 0;class A{constructor(S){this.b=S,this.a=new L.$Qc}listen(S,g){switch(g){case"onDidChange":return D.Event.map(this.b.onDidChange,C=>C.reduce((k,b)=>({...k,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(S,g,C){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.$o8b=A;class I extends N.$mn{constructor(S,g){super(),this.a=g;for(const C in S){const{definition:k,value:b}=S[C];this.f[C]=k,b!==void 0&&this.g.set(C,b)}this.a.listen("onDidChange")(C=>{for(const k in C){const b=C[k];b===null?this.g.delete(k):this.g.set(k,b)}this.h.fire(Object.keys(C))})}async j(S){const g=await this.a.call("updatePolicyDefinitions",S);for(const C in g)this.g.set(C,g[C])}}e.$p8b=I}),define(oe[102],ae([0,1,5,37]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.context<"u"){const A=D.$h.vscode.context.configuration();if(A)N=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:A.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(oe[25],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,D.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"}),define(oe[203],ae([0,1,6,7,2,16,31,8,25]),function(te,e,D,L,N,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d9b=void 0;let g=class extends N.$Rc{constructor(k,b,c){super(),this.b=b,this.c=c,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,k&&this.B(new D.$6g(()=>{this.f(k)},3e4)).schedule()}async f(k){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const b=Date.now(),c=(0,A.$lc)(k),$=(0,A.$mc)(k),y=await I.Promises.readdir(c);await Promise.all(y.map(async p=>{if(p===$)return;const h=(0,A.$ic)(c,p),f=await I.Promises.stat(h);if(f.isDirectory()&&b-f.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${p}.`),I.Promises.rm(h)}))}catch(b){(0,L.$Z)(b)}}};e.$d9b=g,e.$d9b=g=pe([X(1,S.$pj),X(2,R.$0i)],g)}),define(oe[204],ae([0,1,6,7,2,16,31,14,8,25]),function(te,e,D,L,N,A,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e9b=void 0;let C=class extends N.$Rc{constructor(b,c,$){super(),this.b=b,this.c=c,this.f=$,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.$6g(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const b=Object.create(null),c=JSON.parse(await I.Promises.readFile((0,A.$ic)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const f of Object.keys(c)){const u=c[f];b[`${u.hash}.${f}`]=!0}const $=(0,A.$ic)(this.b.userDataPath,"clp");if(!await I.Promises.exists($))return;const p=await I.Promises.readdir($);for(const f of p){if(b[f]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${f}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${f}`),await I.Promises.rm((0,A.$ic)($,f))}const h=Date.now();for(const f of Object.keys(b)){const u=(0,A.$ic)($,f),d=await I.Promises.readdir(u);for(const E of d){if(E==="tcf.json")continue;const s=(0,A.$ic)(u,E),o=await I.Promises.stat(s);o.isDirectory()&&h-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.$ic)(f,E)}`),await I.Promises.rm(s))}}}catch(b){(0,L.$Z)(b)}}};e.$e9b=C,e.$e9b=C=pe([X(0,R.$Xh),X(1,S.$0i),X(2,g.$pj)],C)}),define(oe[205],ae([0,1,16,4]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$4E=void 0,e.$4E=(0,L.$Ph)("IV8InspectProfilingService");var N;(function(A){function I(S){return!!(S.samples&&S.timeDeltas)}A.isValidProfile=I;function R(S,g="noAbsolutePaths"){for(const C of S.nodes)C.callFrame&&C.callFrame.url&&((0,D.$hc)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,D.$ic)(g,(0,D.$mc)(C.callFrame.url)));return S}A.rewriteAbsolutePaths=R})(N||(e.Utils=N={}))}),define(oe[206],ae([0,1,32]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y9b=void 0;class L{constructor(){this.a=new Map}async startProfiling(A){const R=await(await new Promise((g,C)=>{te(["v8-inspect-profiler"],g,C)})).startProfiling({port:A.port,checkForPaused:!0}),S=(0,D.$eg)();return this.a.set(S,R),S}async stopProfiling(A){const I=this.a.get(A);if(!I)throw new Error(`UNKNOWN session '${A}'`);const R=await I.stop();return this.a.delete(A),R.profile}}e.$y9b=L}),define(oe[40],ae([0,1,126,12]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=void 0;class N{constructor(){this.a=new Map}add(I,R){D.ok(L.$yf(I)),D.ok(L.$Af(R)),D.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,R)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$jn=new N}),define(oe[103],ae([0,1,3,40]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0,e.$kn={JSONContribution:"base.contributions.json"};function N(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new D.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,g){this.a[N(S)]=g,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const I=new A;L.$jn.add(e.$kn.JSONContribution,I)}),define(oe[50],ae([0,1,18,3,12,148,20,103,40]),function(te,e,D,L,N,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.ConfigurationScope=e.$on=e.EditPresentationTypes=void 0;var g;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$on={Configuration:"base.contributions.configuration"};var C;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn="vscode://schemas/settings/resourceLanguage",e.$wn="vscode://schemas/settings/configurationDefaults";const k=S.$jn.as(R.$kn.JSONContribution);class b{constructor(){this.h=new Set,this.i=new L.$Nd,this.onDidSchemaChange=this.i.event,this.j=new L.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$vn,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const n=new Set;this.n(s,o,n),k.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const o=new Set;this.o(s,o),k.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const n=new Set;this.o(o,n),this.n(s,!1,n),k.registerSchema(e.$vn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const n=[];for(const{overrides:i,source:t}of s)for(const r in i)if(o.add(r),e.$yn.test(r)){const a=this.a.get(r),v=a?.valuesSources??new Map;if(t)for(const O of Object.keys(i[r]))v.set(O,t);const w={...a?.value||{},...i[r]};this.a.set(r,{source:t,value:w,valuesSources:v});const l=(0,I.$ti)(r),m={type:"object",default:w,description:A.localize(1,null,l),$ref:e.$vn,defaultDefaultValue:w,source:N.$yf(t)?void 0:t,defaultValueSource:t};n.push(...y(r)),this.d[r]=m,this.b.properties[r]=m}else{this.a.set(r,{value:i[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:n,source:i}of s)for(const t in n){const r=this.a.get(t),a=N.$yf(i)?i:i?.id,v=N.$yf(r?.source)?r?.source:r?.source?.id;if(a===v)if(o.add(t),this.a.delete(t),e.$yn.test(t))delete this.d[t],delete this.b.properties[t];else{const w=this.d[t];w&&(this.w(t,w),this.r(t,w))}}this.u()}deltaConfiguration(s){let o=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,n){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(s,o){const n=i=>{if(i.properties)for(const t in i.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,i.properties[t])}i.allOf?.forEach(t=>n(t))};for(const i of s){n(i);const t=this.c.indexOf(i);t!==-1&&this.c.splice(t,1)}}p(s,o=!0,n,i,t=3,r){t=N.$Hf(s.scope)?t:s.scope;const a=s.properties;if(a)for(const w in a){const l=a[w];if(o&&u(w,l)){delete a[w];continue}if(l.source=n,l.defaultDefaultValue=a[w].default,this.w(w,l),e.$yn.test(w)?l.scope=void 0:(l.scope=N.$Hf(l.scope)?t:l.scope,l.restricted=N.$Hf(l.restricted)?!!i?.includes(w):l.restricted),a[w].hasOwnProperty("included")&&!a[w].included){this.f[w]=a[w],delete a[w];continue}else this.d[w]=a[w],a[w].policy?.name&&this.e.set(a[w].policy.name,w);!a[w].deprecationMessage&&a[w].markdownDeprecationMessage&&(a[w].deprecationMessage=a[w].markdownDeprecationMessage),r.add(w)}const v=s.allOf;if(v)for(const w of v)this.p(w,o,n,i,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=n=>{const i=n.properties;if(i)for(const r in i)this.r(r,i[r]);n.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$pn.properties[s]=o,o.scope){case 1:e.$qn.properties[s]=o;break;case 2:e.$rn.properties[s]=o;break;case 6:e.$sn.properties[s]=o;break;case 3:e.$tn.properties[s]=o;break;case 4:e.$un.properties[s]=o;break;case 5:e.$un.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$pn.properties[s],o.scope){case 1:delete e.$qn.properties[s];break;case 2:delete e.$rn.properties[s];break;case 6:delete e.$sn.properties[s];break;case 3:delete e.$tn.properties[s];break;case 4:case 5:delete e.$un.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$vn};this.w(o,n),e.$pn.properties[o]=n,e.$qn.properties[o]=n,e.$rn.properties[o]=n,e.$sn.properties[o]=n,e.$tn.properties[o]=n,e.$un.properties[o]=n}}v(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$vn};e.$pn.patternProperties[e.$xn]=s,e.$qn.patternProperties[e.$xn]=s,e.$rn.patternProperties[e.$xn]=s,e.$sn.patternProperties[e.$xn]=s,e.$tn.patternProperties[e.$xn]=s,e.$un.patternProperties[e.$xn]=s,this.i.fire()}w(s,o){const n=this.a.get(s);let i=n?.value,t=n?.source;N.$Ff(i)&&(i=o.defaultDefaultValue,t=void 0),N.$Ff(i)&&(i=h(o.type)),o.default=i,o.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",$=new RegExp(c,"g");e.$xn=`^(${c})+$`,e.$yn=new RegExp(e.$xn);function y(E){const s=[];if(e.$yn.test(E)){let o=$.exec(E);for(;o?.length;){const n=o[1].trim();n&&s.push(n),o=$.exec(E)}}return(0,D.$Lb)(s)}e.$zn=y;function p(E){return E.reduce((s,o)=>`${s}[${o}]`,"")}e.$An=p;function h(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Bn=h;const f=new b;S.$jn.add(e.$on.Configuration,f);function u(E,s){return E.trim()?e.$yn.test(E)?A.localize(7,null,E):f.getConfigurationProperties()[E]!==void 0?A.localize(8,null,E):s.policy?.name&&f.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,E,s.policy?.name,f.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.$Cn=u;function d(){const E=[],s=f.getConfigurationProperties();for(const o of Object.keys(s))E.push([o,s[o].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.$Dn=d}),define(oe[74],ae([0,1,18,3,35,2,34,30,12,10,20,50,40]),function(te,e,D,L,N,A,I,R,S,g,C,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=void 0;function c(o){return Object.isFrozen(o)?o:R.$8m(o)}class ${constructor(n={},i=[],t=[],r){this.b=n,this.c=i,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof $)return i;const t=new y("");return t.parseRaw(i),t.configurationModel});this.f=n.reduce((i,t)=>t===i?t:i.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$ri)(this.contents,n):this.contents}inspect(n,i){const t=this.rawConfiguration.getValue(n),r=i?this.rawConfiguration.getOverrideValue(n,i):void 0,a=i?this.rawConfiguration.override(i).getValue(n):t;return{value:t,override:r,merged:a}}getOverrideValue(n,i){const t=this.i(i);return t?n?(0,C.$ri)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const t of this.overrides)t.identifiers.includes(n)&&i.push(...t.keys);return D.$Lb(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return D.$Lb(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=R.$7m(this.contents),t=R.$7m(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const v of n)if(a.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(i,v.contents);for(const w of v.overrides){const[l]=t.filter(m=>D.$tb(m.identifiers,w.identifiers));l?(this.h(l.contents,w.contents),l.keys.push(...w.keys),l.keys=D.$Lb(l.keys)):t.push(R.$7m(w))}for(const w of v.keys)r.indexOf(w)===-1&&r.push(w)}return new $(i,r,t,a.every(v=>v instanceof $)?void 0:a)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of D.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r];const v=i[r];v&&(typeof a=="object"&&typeof v=="object"?(a=R.$7m(a),this.h(a,v)):a=v),t[r]=a}return new $(t,this.keys,this.overrides)}h(n,i){for(const t of Object.keys(i)){if(t in n&&S.$Af(n[t])&&S.$Af(i[t])){this.h(n[t],i[t]);continue}n[t]=R.$7m(i[t])}}i(n){let i=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=R.$7m(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?i=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,C.$qi)(this.contents,n),k.$yn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>D.$tb(t.identifiers,(0,k.$zn)(n))),1))}j(n,i,t){(0,C.$pi)(this.contents,n,i,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),k.$yn.test(n)&&this.overrides.push({identifiers:(0,k.$zn)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$oi)(this.contents[n],r=>console.error(r))})}}e.$En=$;class y{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!S.$Hf(n)){const t=this.g(n);this.parseRaw(t,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:t,keys:r,overrides:a,restricted:v,hasExcludedProperties:w}=this.h(n,i);this.b=new $(t,r,a,w?[n]:void 0),this.c=v||[]}g(n){let i={},t=null,r=[];const a=[],v=[];function w(m){Array.isArray(r)?r.push(m):t!==null&&(r[t]=m)}const l={onObjectBegin:()=>{const m={};w(m),a.push(r),r=m,t=null},onObjectProperty:m=>{t=m},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const m=[];w(m),a.push(r),r=m,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:w,onError:(m,O,F)=>{v.push({error:m,offset:O,length:F})}};if(n)try{N.$4m(n,l),i=r[0]||{}}catch(m){console.error(`Error while parsing settings file ${this.f}: ${m}`),this.d=[m]}return i}h(n,i){const t=b.$jn.as(k.$on.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,i);n=r.raw;const a=(0,C.$oi)(n,l=>console.error(`Conflict in settings file ${this.f}: ${l}`)),v=Object.keys(n),w=this.j(n,l=>console.error(`Conflict in settings file ${this.f}: ${l}`));return{contents:a,keys:v,overrides:w,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,i,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const v={},w=[];for(const l in n)if(k.$yn.test(l)&&t){const m=this.i(n[l],i,!1,r);v[l]=m.raw,a=a||m.hasExcludedProperties,w.push(...m.restricted)}else{const m=i[l],O=m?typeof m.scope<"u"?m.scope:3:void 0;m?.restricted&&w.push(l),!r.exclude?.includes(l)&&(r.include?.includes(l)||(O===void 0||r.scopes===void 0||r.scopes.includes(O))&&!(r.skipRestricted&&m?.restricted))?v[l]=n[l]:a=!0}return{raw:v,restricted:w,hasExcludedProperties:a}}j(n,i){const t=[];for(const r of Object.keys(n))if(k.$yn.test(r)){const a={};for(const v in n[r])a[v]=n[r][v];t.push({identifiers:(0,k.$zn)(r),keys:Object.keys(a),contents:(0,C.$oi)(a,i)})}return t}}e.$Fn=y;class p extends A.$Rc{constructor(n,i,t,r){super(),this.c=n,this.f=i,this.g=r,this.b=this.B(new L.$Nd),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Gn=p;class h{constructor(n,i,t,r,a,v,w,l,m,O,F,z,U){this.a=n,this.b=i,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=v,this.g=w,this.h=l,this.i=m,this.j=O,this.k=F,this.l=z,this.m=U}get value(){return c(this.c)}n(n,i,t){const r=n.inspect(i,t);return{get value(){return c(r.value)},get override(){return c(r.override)},get merged(){return c(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(n,i,t,r,a=new $,v=new $,w=new I.$zc,l=new $,m=new I.$zc){this.c=n,this.d=i,this.f=t,this.g=r,this.h=a,this.i=v,this.j=w,this.l=l,this.m=m,this.a=null,this.b=new I.$zc,this.n=null}getValue(n,i,t){return this.q(n,i,t).getValue(n)}updateValue(n,i,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new $,this.m.set(t.resource,r))):r=this.l,i===void 0?r.removeValue(n):r.setValue(n,i),t.resource||(this.a=null)}inspect(n,i,t){const r=this.q(n,i,t),a=this.u(i.resource,t),v=i.resource?this.m.get(i.resource)||this.l:this.l,w=new Set;for(const l of r.overrides)for(const m of l.identifiers)r.getOverrideValue(n,m)!==void 0&&w.add(m);return new h(n,i,r.getValue(n),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,v)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const t=[];if(!i){const{added:r,updated:a,removed:v}=E(this.c,n);i=[...r,...a,...v]}for(const r of i)for(const a of(0,k.$zn)(r)){const v=this.c.getKeysForOverrideIdentifier(a),w=n.getKeysForOverrideIdentifier(a),l=[...w.filter(m=>v.indexOf(m)===-1),...v.filter(m=>w.indexOf(m)===-1),...v.filter(m=>!R.$$m(this.c.override(a).getValue(m),n.override(a).getValue(m)))];t.push([a,l])}return this.updateDefaultConfiguration(n),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:t,removed:r}=E(this.d,n),a=[...i,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.applicationConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.localUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.remoteUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.workspaceConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(n,i){const t=this.p.get(n),{added:r,updated:a,removed:v,overrides:w}=E(t,i),l=[...r,...a,...v];return(l.length||!t)&&this.updateFolderConfiguration(n,i),{keys:l,overrides:w}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:v}=E(i,void 0);return{keys:[...t,...r,...a],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,t){let r=this.r(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}r({resource:n},i){let t=this.s();if(i&&n){const r=i.getFolder(n);r&&(t=this.t(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const t=this.s(),r=this.j.get(n);r?(i=t.merge(r),this.b.set(n,i)):i=t}return i}u(n,i){if(i&&n){const t=i.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:t,overrides:r,keys:a}=this.j.get(i);return n.push([i,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(t=>n.add(t))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r))),[...i.values()]}static parse(n){const i=this.x(n.defaults),t=this.x(n.policy),r=this.x(n.application),a=this.x(n.user),v=this.x(n.workspace),w=n.folders.reduce((l,m)=>(l.set(g.URI.revive(m[0]),this.x(m[1])),l),new I.$zc);return new f(i,t,r,a,new $,v,w,new $,new I.$zc)}static x(n){return new $(n.contents,n.keys,n.overrides)}}e.$Hn=f;function u(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,i=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,v])=>{const w=(0,I.$wc)(i,a,new Set);v.forEach(l=>w.add(l))});const t=[];return i.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$In=u;class d{constructor(n,i,t,r){this.change=n,this.f=i,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const v of a)this.affectedKeys.add(v);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(n,i){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const v=this.d.charCodeAt(a);if(v!==this.b&&v!==this.c)return!1;if(i){const w=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,l=this.g.getValue(n,i,this.h);return!R.$$m(w,l)}return!0}}e.$Jn=d;function E(o,n){const{added:i,removed:t,updated:r}=s(n?.rawConfiguration,o?.rawConfiguration),a=[],v=o?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const l=w.filter(m=>!v.includes(m));for(const m of l)a.push([m,n.getKeysForOverrideIdentifier(m)])}if(o){const l=v.filter(m=>!w.includes(m));for(const m of l)a.push([m,o.getKeysForOverrideIdentifier(m)])}if(n&&o){for(const l of v)if(w.includes(l)){const m=s({contents:o.getOverrideValue(void 0,l)||{},keys:o.getKeysForOverrideIdentifier(l)},{contents:n.getOverrideValue(void 0,l)||{},keys:n.getKeysForOverrideIdentifier(l)});a.push([l,[...m.added,...m.removed,...m.updated]])}}return{added:i,removed:t,updated:r,overrides:a}}function s(o,n){const i=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const v=(0,C.$ri)(n.contents,a),w=(0,C.$ri)(o.contents,a);R.$$m(v,w)||r.push(a)}}return{added:i,removed:t,updated:r}}}),define(oe[207],ae([0,1,18,3,2,30,12,74,50,8,56,40]),function(te,e,D,L,N,A,I,R,S,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=void 0;class b extends N.$Rc{constructor(){super(...arguments),this.a=this.B(new L.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new R.$En}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(k.$jn.as(S.$on.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:h})=>this.c(Array.from(p),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(p,h){this.h(p,k.$jn.as(S.$on.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}f(){return{}}g(){this.b=new R.$En;const p=k.$jn.as(S.$on.Configuration).getConfigurationProperties();this.h(Object.keys(p),p)}h(p,h){const f=this.f();for(const u of p){const d=f[u],E=h[u];d!==void 0?this.b.addValue(u,d):E?this.b.addValue(u,E.default):this.b.removeValue(u)}}}e.$Kn=b;class c{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new R.$En}async initialize(){return this.configurationModel}}e.$Ln=c;let $=class extends N.$Rc{get configurationModel(){return this.b}constructor(p,h,f){super(),this.c=p,this.f=h,this.g=f,this.a=this.B(new L.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new R.$En}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const h={},f=[],u=k.$jn.as(S.$on.Configuration).getConfigurationProperties();for(const d of p){const E=u[d];if(!E){f.push(d);continue}if(E.policy){if(E.type!=="string"&&E.type!=="number"){this.g.warn(`Policy ${E.policy.name} has unsupported type ${E.type}`);continue}f.push(d),h[E.policy.name]={type:E.type}}}return(0,I.$Lf)(h)||await this.f.updatePolicyDefinitions(h),f}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const h=k.$jn.as(S.$on.Configuration).getPolicyConfigurations(),f=(0,D.$Gb)(p.map(u=>h.get(u)));this.m(f,!0)}m(p,h){this.g.trace("PolicyConfiguration#update",p);const f=k.$jn.as(S.$on.Configuration).getConfigurationProperties(),u=[],d=this.b.isEmpty();for(const E of p){const s=f[E]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(d?o!==void 0:!(0,A.$$m)(this.b.getValue(E),o))&&u.push([E,o])}else this.b.getValue(E)!==void 0&&u.push([E,void 0])}if(u.length){this.g.trace("PolicyConfiguration#changed",u);const E=this.b;this.b=new R.$En;for(const s of E.keys)this.b.setValue(s,E.getValue(s));for(const[s,o]of u)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);h&&this.a.fire(this.b)}}};e.$Mn=$,e.$Mn=$=pe([X(1,C.$ln),X(2,g.$0i)],$)}),define(oe[208],ae([0,1,6,3,2,19,20,74,207,56]),function(te,e,D,L,N,A,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=void 0;class C extends N.$Rc{constructor(b,c,$,y){super(),this.j=b,this.h=this.B(new L.$Nd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$Kn),this.c=$ instanceof g.$nn?new S.$Ln:this.B(new S.$Mn(this.b,$,y)),this.f=this.B(new R.$Gn(this.j,{},A.$mg,c)),this.a=new R.$Hn(this.b.configurationModel,this.c.configurationModel,new R.$En,new R.$En),this.g=this.B(new D.$6g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:p,properties:h})=>this.n(p,h))),this.B(this.c.onDidChangeConfiguration(p=>this.r(p))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,c,$]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$Hn(b,c,new R.$En,$)}getConfigurationData(){return this.a.toData()}getValue(b,c){const $=typeof b=="string"?b:void 0,y=(0,I.$ki)(b)?b:(0,I.$ki)(c)?c:{};return this.a.getValue($,y,void 0)}updateValue(b,c,$,y){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.m(b)}m(b){const c=this.a.toData(),$=this.a.compareAndUpdateLocalUserConfiguration(b);this.s($,c,2)}n(b,c){const $=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(b,c);this.s(y,$,7)}r(b){const c=this.a.toData(),$=this.a.compareAndUpdatePolicyConfiguration(b);this.s($,c,7)}s(b,c,$){const y=new R.$Jn(b,{data:c},this.a);y.source=$,y.sourceConfig=this.t($),this.h.fire(y)}t(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Nn=C}),define(oe[209],ae([0,1,15,3,2,66]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkb=e.$Ukb=e.$Tkb=e.$Skb=void 0;const I=(g,C,k)=>{const b=new Uint8Array(16);for(let y=0;y<16;y++)b[y]=Math.round(Math.random()*256);const c=(0,D.$ve)(D.$be.wrap(b));return[`GET ws://localhost${g}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${c}`].join(`\r
`)+`\r
\r
`};e.$Skb=I,e.$Tkb=D.$be.fromString(`\r
\r
`);async function R(g,C,k,b,c){g.write(D.$be.fromString((0,e.$Skb)(C,k,b)));const $=new N.$Qc;try{return await new Promise((y,p)=>{let h;$.add(g.onData(f=>{h?h=D.$be.concat([h,f],h.byteLength+f.byteLength):h=f;const u=h.indexOf(e.$Tkb);if(u===-1)return;y(g),g.pauseData();const d=h.slice(u+e.$Tkb.byteLength);d.byteLength&&c.onData.fire(d)})),$.add(g.onClose(f=>p(f??new Error("socket closed")))),$.add(g.onEnd(()=>p(new Error("socket ended"))))})}catch(y){throw g.dispose(),y}finally{$.dispose()}}e.$Ukb=R;class S extends N.$Rc{constructor(C,k){super(),this.g=C,this.a=this.B(new L.$Qd),this.onData=(...b)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...b)),this.b=this.B(new L.$Nd),this.onDidDispose=this.b.event,this.f=!1,this.B(k.onData),this.B(k.onData.event(b=>this.a.fire(b))),this.onClose=this.B(k.onClose).event,this.onEnd=this.B(k.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,k){A.SocketDiagnostics.traceSocketEvent(this,this.g,C,k)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Vkb=S}),define(oe[210],ae([0,1,7,4]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,L.$Ph)("remoteAuthorityResolverService");var N;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(N||(e.RemoteConnectionType=N={}));class A{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=A;class I{constructor(k,b){this.host=k,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=I;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class S extends D.$ab{static isNotAvailable(k){return k instanceof S&&k._code===R.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof S&&k._code===R.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof S&&k._code===R.NoResolverFound}static isInvalidAuthority(k){return k instanceof S&&k._code===R.InvalidAuthority}static isHandled(k){return k instanceof S&&k.isHandled}constructor(k,b=R.Unknown,c){super(k),this._message=k,this._code=b,this._detail=c,this.isHandled=b===R.NotAvailable&&c===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Sk=S;function g(C){const k=C.indexOf("+");return k===-1?C:C.substring(0,k)}e.$Tk=g}),define(oe[75],ae([0,1,23]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function L(g){return g.scheme===D.Schemas.vscodeRemote?g.authority:void 0}e.$Uk=L;function N(g){if(!g)return;const C=g.indexOf("+");return C<0?g:g.substr(0,C)}e.$Vk=N;function A(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Wk=A;function I(g){const{host:C,port:k}=S(g);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:k}}e.$Xk=I;function R(g,C){let{host:k,port:b}=S(g);return typeof b>"u"&&(b=C),{host:k,port:b}}e.$Yk=R;function S(g){const C=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const k=g.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const b=g.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:g,port:void 0}}}),define(oe[44],ae([0,1,27,4,75]),function(te,e,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function A(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$4l=A,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(I||(e.ExtensionType=I={}));var R;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class S{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p>"u"||p===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){const f=typeof p=="string"?p:p.value,u=typeof h=="string"?h:h.value;return D.$2e(f,u)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$6l=S;class g{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const h of p)this.add(h)}add(p){this.c.add(S.toKey(p))}delete(p){return this.c.delete(S.toKey(p))}has(p){return this.c.has(S.toKey(p))}}e.$7l=g;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(S.toKey(p))}get(p){return this.c.get(S.toKey(p))}has(p){return this.c.has(S.toKey(p))}set(p,h){this.c.set(S.toKey(p),h)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=C;function k(y){return b(y)}e.$9l=k;function b(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$0l=b;function c(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$$l=c;function $(y,p){if(p){const h=`onResolveRemoteAuthority:${(0,N.$Vk)(p)}`;return!!y.activationEvents?.includes(h)}return!1}e.$_l=$,e.$am=(0,L.$Ph)("IBuiltinExtensionsScannerService")}),define(oe[211],ae([0,1,2,44,11]),function(te,e,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;class A extends D.$Rc{constructor(R,S,g,C,k){super(),this.a=R,this.b=S,this.c=g,this.f=k,this.B(C.onDidInstallExtensions(b=>this.g(b))),this.B(C.onDidUninstallExtension(b=>this.h(b)))}g(R){for(const S of R)S.local&&this.invalidate(S.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,R)&&await this.j(S);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,L.$Zl))}catch(S){(0,N.$pk)(S)!==1&&this.f.error(S)}}}e.$Jp=A}),define(oe[212],ae([0,1,6,15,26,7,3,2,100,61,32,66,210,75]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.PersistentConnectionEventType=e.$6k=e.$5k=e.$4k=e.ConnectionType=void 0;const $=30*1e3;var y;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function p(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(q){const P=new N.$Xd;return setTimeout(()=>P.cancel(),q),P.token}function f(q,P){if(q.isCancellationRequested||P.isCancellationRequested)return N.CancellationToken.Cancelled;const j=new N.$Xd;return q.onCancellationRequested(()=>j.cancel()),P.onCancellationRequested(()=>j.cancel()),j.token}class u{get didTimeout(){return this.c==="timedout"}constructor(P){this.c="pending",this.d=new R.$Qc,this.promise=new Promise((j,T)=>{this.f=j,this.g=T}),P.isCancellationRequested?this.h():this.d.add(P.onCancellationRequested(()=>this.h()))}registerDisposable(P){this.c==="pending"?this.d.add(P):P.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const P=new Error("Time limit reached");return P.code="ETIMEDOUT",P.syscall="connect",P}resolve(P){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(P))}reject(P){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(P))}}function d(q,P){const j=new u(P);return j.registerDisposable(q.onControlMessage(T=>{const M=JSON.parse(T.toString()),H=W(M);H?j.reject(H):j.resolve(M)})),j.promise}function E(q,P,j,T,M,H,J,re){const ce=new u(re),ue=g.$Jd.create(!1);return q.info(`Creating a socket (${J})...`),S.mark(`code/willCreateSocket/${H}`),P.connect(j,T,M,J).then(he=>{ce.didTimeout?(S.mark(`code/didCreateSocketError/${H}`),q.info(`Creating a socket (${J}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(S.mark(`code/didCreateSocketOK/${H}`),q.info(`Creating a socket (${J}) was successful after ${ue.elapsed()} ms.`),ce.resolve(he))},he=>{S.mark(`code/didCreateSocketError/${H}`),q.info(`Creating a socket (${J}) returned an error after ${ue.elapsed()} ms.`),q.error(he),ce.reject(he)}),ce.promise}function s(q,P){const j=new u(P);return q.then(T=>{j.didTimeout||j.resolve(T)},T=>{j.didTimeout||j.reject(T)}),j.promise}async function o(q,P,j,T){const M=ne(q,P);q.logService.trace(`${M} 1/6. invoking socketFactory.connect().`);let H;try{H=await E(q.logService,q.remoteSocketFactoryService,q.connectTo,(0,c.$Wk)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,p(P),`renderer-${p(P)}-${q.reconnectionToken}`,T)}catch(he){throw q.logService.error(`${M} socketFactory.connect() failed or timed out. Error:`),q.logService.error(he),he}q.logService.trace(`${M} 2/6. socketFactory.connect() was successful.`);let J,re;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(H,null),J=q.reconnectionProtocol,re=!1):(J=new k.$Dh({socket:H}),re=!0),q.logService.trace(`${M} 3/6. sending AuthRequest control message.`);const ce=await s(q.signService.createNewMessage((0,C.$eg)()),T),ue={type:"auth",auth:q.connectionToken||"00000000000000000000",data:ce.data};J.sendControl(L.$be.fromString(JSON.stringify(ue)));try{const he=await d(J,f(T,h(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(q.logService.trace(`${M} 4/6. received SignRequest control message.`),!await s(q.signService.validate(ce,he.signedData),T)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const de=await s(q.signService.sign(he.data),T),we={type:"connectionType",commit:q.commit,signedData:de,desiredConnectionType:P};return j&&(we.args=j),q.logService.trace(`${M} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(L.$be.fromString(JSON.stringify(we))),{protocol:J,ownsProtocol:re}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(q.logService.error(`${M} the handshake timed out. Error:`),q.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${M} received error control message when negotiating connection. Error:`),q.logService.error(he)),re&&G(J),he}}async function n(q,P,j,T){const M=Date.now(),H=ne(q,P),{protocol:J,ownsProtocol:re}=await o(q,P,j,T),ce=new u(T);return ce.registerDisposable(J.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),$e=W(he);$e?(q.logService.error(`${H} received error control message when negotiating connection. Error:`),q.logService.error($e),re&&G(J),ce.reject($e)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${Z(M)}!`),ce.resolve({protocol:J,firstMessage:he}))})),ce.promise}async function i(q,P){const{protocol:j}=await n(q,1,void 0,P);return{protocol:j}}async function t(q,P,j){const{protocol:T,firstMessage:M}=await n(q,2,P,j),H=M&&M.debugPort;return{protocol:T,debugPort:H}}async function r(q,P,j){const T=Date.now(),M=ne(q,3),{protocol:H}=await o(q,3,P,j);return q.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${Z(T)}!`),H}async function a(q,P,j){const{connectTo:T,connectionToken:M}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:T,connectionToken:M,reconnectionToken:P,reconnectionProtocol:j,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function v(q,P,j){return l(q,async T=>{const{protocol:M}=await i(T,N.CancellationToken.None);return new V(q,P,j,T.reconnectionToken,M)})}e.$4k=v;async function w(q,P){return l(q,async j=>{const{protocol:T,debugPort:M}=await t(j,P,N.CancellationToken.None);return new Q(q,P,j.reconnectionToken,T,M)})}e.$5k=w;async function l(q,P){for(let T=1;;T++)try{const M=(0,C.$eg)(),H=await a(q,M,null);return await P(H)}catch(M){if(T<5)q.logService.error(`[remote-connection][attempt ${T}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(M);else throw q.logService.error(`[remote-connection][attempt ${T}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(M),x.triggerPermanentFailure(0,0,b.$Sk.isHandled(M)),M}}async function m(q,P,j){const T=await a(q,(0,C.$eg)(),null);return await r(T,{host:P,port:j},N.CancellationToken.None)}e.$6k=m;function O(q){return(0,D.$Hg)(P=>new Promise((j,T)=>{const M=setTimeout(j,q*1e3);P.onCancellationRequested(()=>{clearTimeout(M),j()})}))}var F;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class z{constructor(P,j){this.reconnectionToken=P,this.millisSinceLastIncomingData=j,this.type=0}}e.$7k=z;class U{constructor(P,j,T,M){this.reconnectionToken=P,this.millisSinceLastIncomingData=j,this.durationSeconds=T,this.c=M,this.type=1}skipWait(){this.c.cancel()}}e.$8k=U;class B{constructor(P,j,T){this.reconnectionToken=P,this.millisSinceLastIncomingData=j,this.attempt=T,this.type=2}}e.$9k=B;class Y{constructor(P,j,T){this.reconnectionToken=P,this.millisSinceLastIncomingData=j,this.attempt=T,this.type=4}}e.$0k=Y;class K{constructor(P,j,T,M){this.reconnectionToken=P,this.millisSinceLastIncomingData=j,this.attempt=T,this.handled=M,this.type=3}}e.$$k=K;class x extends R.$Rc{static triggerPermanentFailure(P,j,T){this._permanentFailure=!0,this.f=P,this.g=j,this.h=T,this.j.forEach(M=>M.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(P=>P.y())}static debugPauseSocketWriting(){this.j.forEach(P=>P.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(P,j,T,M,H){super(),this.t=P,this.u=j,this.reconnectionToken=T,this.protocol=M,this.w=H,this.m=this.B(new I.$Nd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(M.onSocketClose(J=>{const re=_(this.t,this.reconnectionToken,!0);J?J.type===0?(this.u.logService.info(`${re} received socket close event (hadError: ${J.hadError}).`),J.error&&this.u.logService.error(J.error)):(this.u.logService.info(`${re} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.u.logService.error(J.event)):this.u.logService.info(`${re} received socket close event.`),this.y()})),this.B(M.onSocketTimeout(J=>{const re=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$Pc)(()=>{const J=x.j.indexOf(this);J>=0&&x.j.splice(J,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const P=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${P} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let T=-1;do{T++;const M=T<j.length?j[T]:j[j.length-1];try{if(M>0){const J=O(M);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M,J)),this.u.logService.info(`${P} waiting for ${M} seconds before reconnecting...`);try{await J}catch{}}if(this.n){this.u.logService.error(`${P} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1)),this.u.logService.info(`${P} resolving connection...`);const H=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${P} connecting to ${H.connectTo}...`),await this.G(H,h($)),this.u.logService.info(`${P} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${P} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(T>360){this.u.logService.error(`${P} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(b.$Sk.isTemporarilyNotAvailable(H)){this.u.logService.info(`${P} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this.u.logService.info(`${P} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((0,A.$3)(H)){this.u.logService.info(`${P} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if(H instanceof b.$Sk){this.u.logService.error(`${P} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,b.$Sk.isHandled(H));break}this.u.logService.error(`${P} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}}while(!this.n&&!this.s)}C(P,j,T){this.w?x.triggerPermanentFailure(P,j,T):this.D(P,j,T)}D(P,j,T){this.m.fire(new K(this.reconnectionToken,P,j,T)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$_k=x;class V extends x{constructor(P,j,T,M,H){super(1,P,M,H,!0),this.client=this.B(new k.$Bh(H,{remoteAuthority:j,clientId:T},P.ipcLogger))}async G(P,j){await i(P,j)}}e.$al=V;class Q extends x{constructor(P,j,T,M,H){super(2,P,T,M,!1),this.H=j,this.debugPort=H}async G(P,j){await t(P,this.H,j)}}e.$bl=Q;function G(q){try{q.acceptDisconnect();const P=q.getSocket();q.dispose(),P.dispose()}catch(P){(0,A.$Z)(P)}}function W(q){if(q&&q.type==="error"){const P=new Error(`Connection error: ${q.reason}`);return P.code="VSCODE_CONNECTION_ERROR",P}return null}function ee(q,P){for(;q.length<P;)q+=" ";return q}function ie(q,P){return`[remote-connection][${ee(p(q),13)}][${P.substr(0,5)}\u2026]`}function _(q,P,j){return`${ie(q,P)}[${j?"reconnect":"initial"}]`}function ne(q,P){return`${_(P,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function Z(q){return`${Date.now()-q} ms`}}),define(oe[104],ae([0,1,2,4]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=void 0,e.$Zk=(0,L.$Ph)("remoteSocketFactoryService");class N{constructor(){this.a={}}register(I,R){return this.a[I]??=[],this.a[I].push(R),(0,D.$Pc)(()=>{const S=this.a[I]?.indexOf(R);typeof S=="number"&&S>=0&&this.a[I]?.splice(S,1)})}b(I){return(this.a[I.type]||[]).find(S=>S.supports(I))}connect(I,R,S,g){const C=this.b(I);if(!C)throw new Error(`No socket factory found for ${I}`);return C.connect(I,R,S,g)}}e.$1k=N}),define(oe[213],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w9b=e.$v9b=void 0,e.$v9b=(0,D.$Ph)("sharedProcessTunnelService"),e.$w9b="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,163]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G9b=e.$F9b=e.$E9b=e.$D9b=e.$C9b=e.TunnelStates=e.$B9b=e.$A9b=void 0,e.$A9b=(0,D.$Ph)("IRemoteTunnelService"),e.$B9b={active:!1};var N;(function(A){A.disconnected=I=>({type:"disconnected",onTokenFailed:I}),A.connected=(I,R)=>({type:"connected",info:I,serviceInstallFailed:R}),A.connecting=I=>({type:"connecting",progress:I}),A.uninitialized={type:"uninitialized"}})(N||(e.TunnelStates=N={})),e.$C9b="remote.tunnels.access",e.$D9b=e.$C9b+".hostNameOverride",e.$E9b=e.$C9b+".preventSleep",e.$F9b="remoteTunnelService",e.$G9b=(0,L.localize)(0,null)}),define(oe[57],ae([0,1,15,7,2,165,50,4,8,40]),function(te,e,D,L,N,A,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=void 0,e.$Vo=(0,R.$Ph)("requestService");class C{constructor(E){this.b=E}toJSON(){if(!this.a){const E=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?E[s]="*****":E[s]=this.b[s];this.a=E}return this.a}}class k extends N.$Rc{constructor(E){super(),this.b=0,this.a=E.createLogger("network",{name:(0,A.localize)(0,null),when:S.$oj.isEqualTo((0,S.$mj)(S.LogLevel.Trace)).serialize()})}async c(E,s,o){const n=`${E} #${++this.b}: ${s.url}`;this.a.trace(`${n} - begin`,s.type,new C(s.headers??{}));try{const i=await o();return this.a.trace(`${n} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,s.type,(0,L.$9)(i)),i}}}e.$Wo=k;function b(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.$Xo=b;function c(d){return d.res.statusCode===204}e.$Yo=c;async function $(d){return c(d)?null:(await(0,D.$ne)(d.stream)).toString()}e.$Zo=$;async function y(d){if(!b(d))throw new Error("Server returned "+d.res.statusCode);return $(d)}e.$1o=y;async function p(d){if(!b(d))throw new Error("Server returned "+d.res.statusCode);if(c(d))return null;const s=(await(0,D.$ne)(d.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$2o=p;function h(d){u(d)}e.$3o=h;let f;function u(d){const E=g.$jn.as(I.$on.Configuration),s=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},E.updateConfigurations({add:[f],remove:s?[s]:[]})}u(1)}),define(oe[214],ae([0,1,26,23,11,57]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3N=void 0;let I=class{constructor(S,g){this.a=S,this.b=g}async download(S,g,C=D.CancellationToken.None){if(S.scheme===L.Schemas.file||S.scheme===L.Schemas.vscodeRemote){await this.b.copy(S,g);return}const k={type:"GET",url:S.toString(!0)},b=await this.a.request(k,C);if(b.res.statusCode===200)await this.b.writeFile(g,b.stream);else{const c=await(0,A.$1o)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${c}`)}}};e.$3N=I,e.$3N=I=pe([X(0,A.$Vo),X(1,N.$$j)],I)}),define(oe[215],ae([0,1,15,26]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;class N{constructor(R){this.a=R}listen(R,S){throw new Error("Invalid listen")}call(R,S,g,C=L.CancellationToken.None){switch(S){case"request":return this.a.request(g[0],C).then(async({res:k,stream:b})=>{const c=await(0,D.$ne)(b);return[{statusCode:k.statusCode,headers:k.headers},c]});case"resolveProxy":return this.a.resolveProxy(g[0])}throw new Error("Invalid call")}}e.$Yq=N;class A{constructor(R){this.a=R}async request(R,S){const[g,C]=await this.a.call("request",[R],S);return{res:g,stream:(0,D.$pe)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.$Zq=A}),define(oe[216],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$17b=e.$Z7b=e.$Y7b=void 0,e.$Y7b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Z7b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$17b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[217],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U3b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(N){try{const A=await this.c();if(A){const I=String(D.a++);return this.b.set(I,A),{id:I,data:A.createNewMessage(N)}}}catch{}return{id:"",data:N}}async validate(N,A){if(!N.id)return!0;const I=this.b.get(N.id);if(!I)return!1;this.b.delete(N.id);try{return I.validate(A)==="ok"}catch{return!1}finally{I.dispose?.()}}async sign(N){try{return await this.d(N)}catch{}return N}}e.$U3b=D}),define(oe[106],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=void 0,e.$2k="signService",e.$3k=(0,D.$Ph)(e.$2k)}),define(oe[218],ae([0,1,217]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O8b=void 0;class L extends D.$U3b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(I=>new I.signer().sign(A))}h(){return new Promise((A,I)=>te(["vsda"],A,I))}}e.$O8b=L}),define(oe[76],ae([0,1,3,2]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EDb=e.$DDb=e.$CDb=e.$BDb=void 0;class N extends L.$Rc{constructor(k,b,c){super(),this.a=k,this.b=b,this.c=c}async getItems(){const k={profile:this.b,workspace:this.c},b=await this.a.call("getItems",k);return new Map(b)}updateItems(k){const b={profile:this.b,workspace:this.c};return k.insert&&(b.insert=Array.from(k.insert.entries())),k.delete&&(b.delete=Array.from(k.delete.values())),this.a.call("updateItems",b)}optimize(){const k={profile:this.b,workspace:this.c};return this.a.call("optimize",k)}}class A extends N{constructor(k,b){super(k,b,void 0),this.f=this.B(new D.$Nd),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(k=>this.h(k)))}h(k){(Array.isArray(k.changed)||Array.isArray(k.deleted))&&this.f.fire({changed:k.changed?new Map(k.changed):void 0,deleted:k.deleted?new Set(k.deleted):void 0})}}class I extends A{constructor(k){super(k,void 0)}async close(){this.dispose()}}e.$BDb=I;class R extends A{constructor(k,b){super(k,b)}async close(){this.dispose()}}e.$CDb=R;class S extends N{constructor(k,b){super(k,void 0,b),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.$DDb=S;class g{constructor(k){this.a=k}isUsed(k){const b={payload:k,profile:void 0,workspace:void 0};return this.a.call("isUsed",b)}}e.$EDb=g}),define(oe[107],ae([0,1,5,37,32]),function(te,e,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=void 0;function A(S){if(D.$u===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function I(S,g,C,k,b,c,$,y,p){const h=Object.create(null);h["common.machineId"]=c,h["common.sqmId"]=$,h.sessionID=(0,N.$eg)()+Date.now(),h.commitHash=k,h.version=b,h["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,D.$i)(D.$u),h["common.nodePlatform"]=L.$cc,h["common.nodeArch"]=C,h["common.product"]=p||"desktop",y&&(h["common.msftInternal"]=y);let f=0;const u=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),D.$m&&(h["common.snap"]="true");const d=A(g);return d&&(h["common.platformDetail"]=d),h}e.$ko=I;function R(S){const g=L.env.USERDNSDOMAIN;if(!g)return!1;const C=g.toLowerCase();return S.some(k=>C===k)}e.$lo=R}),define(oe[22],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,D.$Ph)("telemetryService"),e.$dl=(0,D.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var N;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(N||(e.TelemetryConfiguration=N={}))}),define(oe[219],ae([0,1,36,6,35,23,16,5,10,142,31,145,95,11,25,22]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=e.$Hr=e.$Gr=void 0;const p=new Map;async function h(s,o){const n=`${s}::${o.join(":")}`,i=p.get(n);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,v=2e4;function w(m,O,F,z){const U=O.substring(m.length+1);return L.Promises.withAsyncBody(async B=>{let Y;try{Y=await C.Promises.readdir(O,{withFileTypes:!0})}catch{B();return}if(z.count>=v){z.count+=Y.length,z.maxReached=!0,B();return}let K=Y.length;if(K===0){B();return}let x=Y;z.count+Y.length>v&&(z.maxReached=!0,K=v-z.count,x=Y.slice(0,K)),z.count+=Y.length;for(const V of x)if(V.isDirectory()){if(F.includes(V.name)||await w(m,(0,I.$ic)(O,V.name),F,z),--K===0){B();return}}else{const Q=V.name.lastIndexOf(".");if(Q>=0){const G=V.name.substring(Q+1);G&&r.set(G,(r.get(G)??0)+1)}for(const G of t)G.relativePathPattern?.test(U)!==!1&&G.filePattern.test(V.name)&&a.set(G.tag,(a.get(G.tag)??0)+1);if(--K===0){B();return}}})}const l=L.Promises.withAsyncBody(async m=>{const O={count:0,maxReached:!1};await w(s,s,o,O);const F=await d(s);m({configFiles:f(a),fileTypes:f(r),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:F})});return p.set(n,l),l}e.$Gr=h;function f(s){return Array.from(s.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function u(){const s={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/c.$Gk.GB).toFixed(2)}GB (${(D.freemem()/c.$Gk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$Rm.value()*100)}%`},o=D.cpus();return o&&o.length>0&&(s.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),s}e.$Hr=u;async function d(s){try{const o=new Map,n=(0,I.$ic)(s,".vscode","launch.json"),i=await C.Promises.readFile(n),t=[],r=(0,N.$Wm)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,N.$6m)(r)==="object"&&r.configurations)for(const a of r.configurations){const v=a.type;v&&(o.has(v)?o.set(v,o.get(v)+1):o.set(v,1))}return f(o)}catch{return[]}}e.$Ir=d;let E=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const i=D.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/c.$Gk.GB).toFixed(2)}GB (${(D.freemem()/c.$Gk.GB).toFixed(2)}GB free)`),R.$j||n.push(`Load (avg):       ${D.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(g.$Rm.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,k.$Fr)(o.mainPID),this.k(o)]).then(async i=>{let[t,r]=i,a=this.m(o,t);return n.forEach(v=>{if((0,b.$rm)(v))a+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(a+=`

Remote: ${v.hostName}`,v.processes&&(a+=`
${this.m(o,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const w of Object.keys(v.workspaceMetadata)){const l=v.workspaceMetadata[w];let m=`${l.fileCount} files`;l.maxFilesReached&&(m=`more than ${m}`),r+=`|    Folder (${w}): ${m}`,r+=this.h(l)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:i,vmHint:t,os:r,cpus:a}=u(),v={os:r,memory:i,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.$j||(v.load=`${D.loadavg().map(w=>Math.round(w)).join(", ")}`),R.$l&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(o,n){const i=[];return(0,k.$Fr)(o.mainPID).then(async t=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),n.forEach(r=>{if((0,b.$rm)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.f(r.machineInfo)),r.processes&&i.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[a];let w=`${v.fileCount} files`;v.maxFilesReached&&(w=`more than ${w}`),i.push(`Folder (${a}): ${w}`),i.push(this.h(v))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const n=[];let t=0;const r=(l,m)=>{const O=` ${l}(${m})`;t+O.length>60?(n.push(a),a="|                 ",t=a.length):t+=O.length,a+=O};let a="|      File types:";const v=10,w=o.fileTypes.length>v?v:o.fileTypes.length;for(let l=0;l<w;l++){const m=o.fileTypes[l];r(m.name,m.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(l=>{r(l.name,l.count)}),n.push(a)),o.launchConfigFiles.length>0){let l="|      Launch Configs:";o.launchConfigFiles.forEach(m=>{const O=m.count>1?` ${m.name}(${m.count})`:` ${m.name}`;l+=O}),n.push(l)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const n=[],i=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=S.URI.revive(r);if(a.scheme===A.Schemas.file){const v=a.fsPath;i.push(h(v,["node_modules",".git"]).then(w=>{let l=`${w.fileCount} files`;w.maxFilesReached&&(l=`more than ${l}`),n.push(`|    Folder (${(0,I.$mc)(v)}): ${l}`),n.push(this.h(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${w.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const i=new Map;o.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>i.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,i,t,n,0),t.join(`
`)}n(o,n,i,t,r){const a=r===0;let v;a?v=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const w=process.platform==="win32"?t.mem:D.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${(w/c.$Gk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(l=>this.n(o,n,i,l,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:i}of o.folders){const t=S.URI.revive(i);if(t.scheme!==A.Schemas.file)continue;const r=t.fsPath;try{(await h(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const i=S.URI.revive(n);if(i.scheme!==A.Schemas.file)continue;const t=i.fsPath;try{const r=await h(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$Jr=E,e.$Jr=E=pe([X(0,y.$cl),X(1,$.$pj)],E)}),define(oe[108],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$57b=e.$47b=void 0;class D{constructor(A){this.b=A}listen(A,I){throw new Error(`Event not found: ${I}`)}call(A,I,{eventName:R,data:S}){return this.b.forEach(g=>g.log(R,S)),Promise.resolve(null)}}e.$47b=D;class L{constructor(A){this.b=A}log(A,I){return this.b.call("log",{eventName:A,data:I}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$57b=L}),define(oe[45],ae([0,1,30,12,3,20,75,107,22]),function(te,e,D,L,N,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0;class g{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$mo=g;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$no=C,e.$oo=new C;class k{async publicLog(t,r,a){}async publicLogError(t,r,a){}}e.$po=k,e.$qo="telemetry",e.$ro="extensionTelemetryLog",e.$so={log:()=>null,flush:()=>Promise.resolve(null)};function b(i,t){return N.Event.debounce(t.onDidChangeConfiguration,(a,v)=>{const w=a?new Set([...a.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:w}},1e3,!0)(a=>{a.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.$mi)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.$to=b;function c(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.$uo=c;function $(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$vo=$;function y(i){const t=i.getValue(S.$kl),r=i.getValue(S.$ll);if(i.getValue(S.$ml)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$wo=y;function p(i){const t={},r={},a={};u(i,a);for(let v in a){v=v.length>150?v.substr(v.length-149):v;const w=a[v];typeof w=="number"?r[v]=w:typeof w=="boolean"?r[v]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${w.length}`),t[v]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(t[v]=w)}return{properties:t,measurements:r}}e.$xo=p;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(i){if(!i)return"none";const t=(0,I.$Vk)(i);return h.has(t)?t:"other"}e.$yo=f;function u(i,t,r=0,a){if(i)for(const v of Object.getOwnPropertyNames(i)){const w=i[v],l=a?a+v:v;Array.isArray(w)?t[l]=(0,D.$_m)(w):w instanceof Date?t[l]=w.toISOString():(0,L.$Af)(w)?r<2?u(w,t,r+1,l+"."):t[l]=(0,D.$_m)(w):t[l]=w}}function d(i,t){const r=i.msftInternalDomains||[],a=t.getValue("telemetry.internalTesting");return(0,R.$lo)(r)||a}e.$zo=d;function E(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Ao=E;function s(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const a=[];for(const m of t)for(;;){const O=m.exec(i);if(!O)break;a.push([O.index,m.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(r="";;){const m=w.exec(i);if(!m)break;const O=a.some(([F,z])=>m.index<z&&F<w.lastIndex);!v.test(m[0])&&!O&&(r+=i.substring(l,m.index)+"<REDACTED: user-file-path>",l=w.lastIndex)}return l<i.length&&(r+=i.substr(l)),r}function o(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function n(i,t){return(0,D.$9m)(i,r=>{if(r instanceof g||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=s(a,t);for(const v of t)a=a.replace(v,"");return a=o(a),a}})}e.$Bo=n}),define(oe[33],ae([0,1,27,29,44,5,10,7,37,45]),function(te,e,D,L,N,A,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0;function C(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,D.$We)(n.id,i.id)===0}e.$Co=C;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,t,r)}static parse(i){const t=k.exec(i);return t&&t[1]&&t[2]?new b({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?C(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Do=b;const c=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const i=c.exec(n);return i&&i[1]?[p(i[1]),i[2]]:[p(n),void 0]}e.$Eo=$;function y(n,i){return`${n}.${i}`}e.$Fo=y;function p(n){return n.toLowerCase()}e.$Go=p;function h(n,i){return p(y(n??N.$2l,i))}e.$Ho=h;function f(n,i){const t=[],r=a=>{for(const v of t)if(v.some(w=>C(i(w),i(a))))return v;return null};for(const a of n){const v=r(a);v?v.push(a):t.push([a])}return t}e.$Io=f;function u(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$Jo=u;function d(n){return{id:new g.$mo(n.identifier.id),name:new g.$mo(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Ko=d,e.$Lo=new N.$6l("pprice.better-merge");function E(n,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(v=>!C(v.identifier,{id:a}))){const v=n.filter(w=>C(w.identifier,{id:a}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$Mo=E;async function s(n,i){if(!A.$l)return!1;let t;try{t=(await n.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,R.$9)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,i){const t=await s(n,i),r=(0,L.$9n)(t?"alpine":A.$u,S.$dc);return i.debug("ComputeTargetPlatform:",r),r}e.$No=o}),define(oe[220],ae([0,1,18,2,19,10,11,25,6,3,16,5,37,33]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$15b=e.$Z5b=void 0;let $=class extends L.$Rc{constructor(u,d){super(),this.b=u,this.c=d,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,E])=>this.a.set(E.configPath,E))}getConfigBasedTips(u){return this.f(u)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(u){const d=[];for(const[E,s]of this.a)if(!(s.configScheme&&s.configScheme!==u.scheme))try{const o=(await this.b.readFile((0,N.$vg)(u,E))).value.toString();for(const[n,i]of Object.entries(s.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(o))&&d.push({extensionId:n,extensionName:i.name,configName:s.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return d}};e.$Z5b=$,e.$Z5b=$=pe([X(0,I.$$j),X(1,R.$pj)],$);const y="extensionTips/promptedExecutableTips",p="extensionTips/lastPromptedMediumImpExeTime";class h extends ${constructor(u,d,E,s,o,n,i,t){super(i,t),this.r=u,this.s=d,this.t=E,this.u=s,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const v=[],w=[],l=[];Object.entries(a.recommendations).forEach(([m,O])=>{O.important?a.important?v.push({extensionId:m,extensionName:O.name,isExtensionPack:!!O.isExtensionPack}):w.push({extensionId:m,extensionName:O.name,isExtensionPack:!!O.isExtensionPack}):l.push({extensionId:m,extensionName:O.name,isExtensionPack:!!O.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),w.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w}),l.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:l})}),(0,S.$Vg)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const u=await this.O(this.g),d=await this.O(this.h);return[...u,...d]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const u=await this.O(this.g),d=await this.O(this.h),E=await this.u.getInstalled();this.m=this.D(u,E),this.n=this.D(d,E)}D(u,d){const E=new Map;u.forEach(t=>E.set(t.extensionId.toLowerCase(),t));const{installed:s,uninstalled:o}=this.N([...E.keys()],d);for(const t of s){const r=E.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=E.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),i=new Map;for(const t of o){const r=E.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=i.get(r.exeName);a||(a=[],i.set(r.exeName,a)),a.push(r)}}return i}F(){if(this.m.size===0)return;const[u,d]=[...this.m.entries()][0];this.H(d).then(E=>{switch(E){case"reacted":this.M(d[0].exeName,d);break;case"ignored":this.m.delete(u);break;case"incompatibleWindow":{const s=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(s(()=>this.F()));break}case"toomany":{const s=this.B(new L.$Sc);s.value=(0,S.$Vg)(()=>{s.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const u=this.I(),d=Date.now()-u,E=7*24*60*60*1e3;if(d<E){const n=this.B(new L.$Sc);n.value=(0,S.$Vg)(()=>{n.dispose(),this.G()},E-d);return}const[s,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(s),this.M(o[0].exeName,o);const i=this.B(new L.$Sc);i.value=(0,S.$Vg)(()=>{i.dispose(),this.G()},E);break}case"ignored":this.n.delete(s),this.G();break;case"incompatibleWindow":{const i=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(i(()=>this.G()));break}case"toomany":{const i=this.B(new L.$Sc);i.value=(0,S.$Vg)(()=>{i.dispose(),this.G()},60*60*1e3);break}}})}async H(u){const d=await this.u.getInstalled(1),E=u.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(o=>d.every(n=>!(0,c.$Co)(n.identifier,{id:o})))).map(({extensionId:s})=>s.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:E,source:3,name:u[0].exeFriendlyName,searchValue:`@exe:"${u[0].exeName}"`})}I(){let u=this.w.getNumber(p,-1);return u||(u=Date.now(),this.J(u)),u}J(u){this.w.store(p,u,-1,1)}L(){return JSON.parse(this.w.get(y,-1,"{}"))}M(u,d){const E=this.L();E[u]=d.map(({extensionId:s})=>s.toLowerCase()),this.w.store(y,JSON.stringify(E),-1,0)}N(u,d){const E=[],s=[],o=d.reduce((n,i)=>(n.add(i.identifier.id.toLowerCase()),n),new Set);return u.forEach(n=>{o.has(n.toLowerCase())?E.push(n):s.push(n)}),{installed:E,uninstalled:s}}async O(u){const d=[],E=new Map;for(const s of u.keys()){const o=u.get(s);if(!o||!(0,D.$Kb)(o.recommendations))continue;const n=[];k.$j?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>b.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>b.env.ProgramFiles).replace("%APPDATA%",()=>b.env.APPDATA).replace("%WINDIR%",()=>b.env.WINDIR)):(n.push((0,C.$ic)("/usr/local/bin",s)),n.push((0,C.$ic)("/usr/bin",s)),n.push((0,C.$ic)(this.r.fsPath,s)));for(const i of n){let t=E.get(i);if(t===void 0&&(t=await this.b.exists(A.URI.file(i)),E.set(i,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:v,whenNotInstalled:w}of o.recommendations)d.push({extensionId:r,extensionName:a,isExtensionPack:v,exeName:s,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:w})}}return d}}e.$15b=h}),define(oe[221],ae([0,1,26,33]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tWb=void 0;async function N(A,I,R,S,g){try{const C=await A.getExtensionsControlManifest();if(!C.deprecated)return;const k=await A.getInstalled(1);for(const[b,c]of Object.entries(C.deprecated)){if(!c?.extension)continue;const{id:$,autoMigrate:y,preRelease:p}=c.extension;if(!y)continue;const h=k.find(u=>(0,L.$Co)(u.identifier,{id:b}));if(!h)continue;const f=(await I.getExtensions([{id:$,preRelease:p}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!f){g.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${$}' extension is not found`);continue}try{g.info(`Migrating '${h.identifier.id}' extension to '${$}' extension...`);const u=!S.getDisabledExtensions().some(E=>(0,L.$Co)(E,h.identifier));await A.uninstall(h),g.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let d=k.find(E=>(0,L.$Co)(E.identifier,{id:$}));(!d||!d.isPreReleaseVersion&&u)&&(d=await A.installFromGallery(f,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${d.identifier.id}'`),u||(await S.disableExtension(d.identifier),g.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),y.storage&&(R.addToMigrationList((0,L.$Fo)(h.manifest.publisher,h.manifest.name),(0,L.$Fo)(d.manifest.publisher,d.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${h.identifier.id}' extension to '${$}' extension.`)}catch(u){g.error(u)}}}catch(C){g.error(C)}}e.$tWb=N}),define(oe[222],ae([0,1,3,2,34,33,44]),function(te,e,D,L,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class R extends L.$Rc{constructor(g,C,k,b,c,$,y){super(),this.f=g,this.g=C,this.h=k,this.j=b,this.m=c,this.n=$,this.r=y,this.a=this.B(new D.$Nd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.$Zc),this.s().then(null,p=>y.error(p))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(C=>(this.c.set(C.id,(0,L.$Oc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(g){for(const C of g.extensions)this.I(this.L(C.identifier,C.version),g.profileLocation)}async y(g){for(const C of g.extensions){const k=this.L(C.identifier,C.version);g.error?this.J(k,g.profileLocation):this.I(k,g.profileLocation)}}async z(g){for(const C of g.extensions)this.J(this.L(C.identifier,C.version),g.profileLocation)}async C(g){const C=[],k=[];for(const b of g.extensions){const c=this.L(b.identifier,b.version);g.error?this.I(c,g.profileLocation):(this.J(c,g.profileLocation),this.b.has(c)||(this.r.debug("Extension is removed from all profiles",b.identifier.id,b.version),k.push(this.f.scanInstalledExtensionAtLocation(b.location).then($=>{$?C.push($):this.r.info("Extension not found at the location",b.location.toString())},$=>this.r.error($)))))}try{await Promise.all(k),C.length&&await this.H(C)}catch(b){this.r.error(b)}}D(g){for(const C of this.h.profiles)g.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(g){const C=[],k=[],b=await this.j.scanProfileExtensions(g),c=new Set,$=new Set;for(const[y,p]of this.b)p.has(g)&&$.add(y);for(const y of b){const p=this.L(y.identifier,y.version);c.add(p),$.has(p)||(C.push(y.identifier),this.I(p,g))}for(const y of $)if(!c.has(y)){const p=this.M(y);p&&(k.push(p.identifier),this.J(y,g))}(C.length||k.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:g}:void 0,removed:k.length?{extensions:k,profileLocation:g}:void 0})}async G(g){const C=await this.j.scanProfileExtensions(g);for(const k of C)this.I(this.L(k.identifier,k.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(k=>!this.b.has(this.L(k.identifier,k.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,C){let k=this.b.get(g);k||this.b.set(g,k=new N.$Ac(b=>this.m.extUri.getComparisonKey(b))),k.add(C)}J(g,C){const k=this.b.get(g);k&&k.delete(C),k?.size||this.b.delete(g)}L(g,C){return`${I.$6l.toKey(g.id)}@${C}`}M(g){const[C,k]=(0,A.$Eo)(g);return k?{identifier:{id:C},version:k}:void 0}}e.$Kp=R}),define(oe[223],ae([0,1,43,45]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;async function N(A,I,R,S,g,C,k){const b={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${I.nameShort})`};if((0,L.$uo)(I,R)&&(0,L.$wo)(S)===3){const c=await(0,D.$cp)(R,g,C);b["X-Market-User-Id"]=c,b["VSCode-SessionId"]=k.machineId||c}return b}e.$dp=N}),define(oe[224],ae([0,1,70,18,6,2,23,16,31,14,29,33,8,73,10]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;let y=class extends c.$Wq{constructor(u,d,E,s){super(E),this.h=u,this.j=s,this.g=this.B(new p(d,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(u,d){const s=(await this.g.getLanguagePacks())[d];if(!s){this.j.warn(`No language pack found for ${d}`);return}const o=s.translations[u];return o?$.URI.file(o):void 0}async getInstalledLanguages(){const u=await this.g.getLanguagePacks(),d=Object.keys(u).map(E=>{const s=u[E];return{...this.f(E,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return d.push(this.f("en","English")),d.sort((E,s)=>E.label.localeCompare(s.label)),d}async m(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",u.identifier.id),await this.update())}async n(u){const d=await this.g.getLanguagePacks();Object.keys(d).some(E=>d[E]&&d[E].extensions.some(s=>(0,k.$Co)(s.extensionIdentifier,u.identifier)))&&(this.j.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,d]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),E=await this.g.update(d);return!(0,L.$tb)(Object.keys(u),Object.keys(E))}};e.$Xq=y,e.$Xq=y=pe([X(0,C.$co),X(1,g.$Xh),X(2,C.$ao),X(3,b.$0i)],y);let p=class extends A.$Rc{constructor(u,d){super(),this.j=d,this.c={},this.f=(0,R.$ic)(u.userDataPath,"languagepacks.json"),this.g=new N.$1g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(u){return this.s(d=>{Object.keys(d).forEach(E=>delete d[E]),this.m(d,...u)}).then(()=>this.c)}m(u,...d){for(const E of d)E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&this.n(u,E);Object.keys(u).forEach(E=>this.r(u[E]))}n(u,d){const E=d.identifier,s=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const o of s)if(d.location.scheme===I.Schemas.file&&h(o)){let n=u[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},u[o.languageId]=n);const i=n.extensions.filter(t=>(0,k.$Co)(t.extensionIdentifier,E))[0];i?i.version=d.manifest.version:n.extensions.push({extensionIdentifier:E,version:d.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.$ic)(d.location.fsPath,t.path)}}r(u){if(u){const d=(0,D.createHash)("md5");for(const E of u.extensions)d.update(E.extensionIdentifier.uuid||E.extensionIdentifier.id).update(E.version);u.hash=d.digest("hex")}}s(u=()=>null){return this.g.queue(()=>{let d=null;return S.Promises.readFile(this.f,"utf8").then(void 0,E=>E.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(E)).then(E=>{try{return JSON.parse(E)}catch{return{}}}).then(E=>(d=u(E),E)).then(E=>{for(const o of Object.keys(E))E[o]||delete E[o];this.c=E,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),S.Promises.writeFile(this.f,s)}).then(()=>d,E=>this.j.error(E))})}};p=pe([X(0,g.$Xh),X(1,b.$0i)],p);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const u of f.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(oe[225],ae([0,1,141,7,30,45]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function S(C,k,b){const c=await(0,D.$zC)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,D.$zC)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new c.AppInsightsCore,p=new $.PostChannel,h={instrumentationKey:C,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(b){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:b};h.extensionConfig[p.identifier]=f}return y.initialize(h,[]),y.addTelemetryInitializer(f=>{k&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),y}class g{constructor(k,b,c,$,y){this.e=k,this.f=b,this.g=c,this.h=y,this.c=I,this.d=R,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(k){if(this.a){if(typeof this.a!="string"){k(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(b=>{k(b)},b=>{(0,L.$Z)(b),console.error(b)})}}log(k,b){if(!this.a)return;b=(0,N.$0m)(b,this.g),b=(0,A.$xo)(b);const c=this.f+"/"+k;try{this.i($=>{$.pluginVersionString=b?.properties.version??"Unknown",$.track({name:c,baseData:{name:c,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(k=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,k(void 0)})})}):Promise.resolve(void 0)}}e.$AN=g}),define(oe[109],ae([0,1,2,166,14,8,25,45]),function(te,e,D,L,N,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o5b=void 0;let S=class extends D.$Rc{constructor(C,k,b,c,$=""){super(),this.b=$;const y=k.getLogger(R.$qo);if(y)this.a=this.B(y);else{const h=(0,R.$vo)(c,b)?" (Not Sent)":"",f=()=>(0,R.$uo)(c,b)&&C.getLevel()===A.LogLevel.Trace;this.a=this.B(k.createLogger(R.$qo,{name:(0,L.localize)(0,null,h),hidden:!f()})),this.B(C.onDidChangeLogLevel(()=>k.setVisibility(R.$qo,f()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,k){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$xo)(k))}};e.$o5b=S,e.$o5b=S=pe([X(0,A.$0i),X(1,A.$$i),X(2,N.$Wh),X(3,I.$pj)],S)}),define(oe[110],ae([0,1,2,30,5,27,167,20,50,102,25,40,22,45]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,u){this.k=f,this.l=u,this.d={},this.i=new D.$Qc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,A.$Fe)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Fe)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(b.$kl)||d.affectsConfiguration(b.$ml)||d.affectsConfiguration(b.$ll))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,c.$wo)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const u=f.usage?3:f.error?2:0;h=Math.min(h,u)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,u){this.g<f||(u=(0,L.$0m)(u,this.d),u=(0,c.$Bo)(u,this.j),u=(0,L.$0m)(u,this.c),this.b.forEach(d=>d.log(h,u)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$4q=$,e.$4q=$=pe([X(1,R.$ji),X(2,C.$pj)],$);function y(){const p=(0,I.localize)(0,null,g.default.nameLong),h=g.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=N.$p?"":(0,I.localize)(3,null),u=(0,I.localize)(4,null),d=(0,I.localize)(5,null),E=(0,I.localize)(6,null),s=(0,I.localize)(7,null),o=`
|       | ${u} | ${d} | ${E} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,I.localize)(8,null);return`
${p} ${h} ${f}

&nbsp;

${s}
${o}

&nbsp;

${n}
`}k.$jn.as(S.$on.Configuration).registerConfiguration({id:b.$jl,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[b.$kl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.$jn.as(S.$on.Configuration).registerConfiguration({id:b.$jl,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[b.$ml]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,I.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,I.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${b.$kl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[226],ae([0,1,15,26,270,225]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0;async function I(C,k){const b=await k.request(C,L.CancellationToken.None),c=(await(0,D.$ne)(b.stream)).toString(),$=b.res.statusCode??200;return{headers:b.res.headers,statusCode:$,responseData:c}}async function R(C){const k={method:C.type,headers:C.headers};return new Promise((c,$)=>{const y=N.request(C.url??"",k,p=>{p.on("data",function(h){c({headers:p.headers,statusCode:p.statusCode??200,responseData:h.toString()})}),p.on("error",function(h){$(h)})});y.write(C.data,p=>{p&&$(p)}),y.end()})}async function S(C,k,b){const c=typeof k.data=="string"?k.data:new TextDecoder().decode(k.data),$={type:"POST",headers:{...k.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(k.data).toString()},url:k.urlString,data:c};try{const y=C?await I($,C):await R($);b(y.statusCode,y.headers,y.responseData)}catch{b(0,{})}}class g extends A.$AN{constructor(k,b,c,$,y){const p={sendPOST:(h,f)=>{S(k,h,f)}};super(b,c,$,y,p)}}e.$BN=g}),define(oe[227],ae([0,1,23,93,20,14,8,25,22,108,109,110]),function(te,e,D,L,N,A,I,R,S,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k9b=void 0;let b=class{constructor($,y,p,h,f,u){this.b=$,this.c=y,this.d=p,this.e=h,this.f=f,this.g=u,this.a=new Map}h($){if(!this.a.has($.id)){const y=Object.create(null);y["common.vscodemachineid"]=this.c.machineId,y["common.vscodesessionid"]=this.c.sessionId;const p=[$.id,JSON.stringify(y),$.aiKey],f=new L.$6p(D.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:p,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new g.$57b(f),new C.$o5b(this.d,this.e,this.f,this.g,`[${$.id}] `)];this.a.set($.id,new k.$4q({appenders:u,sendErrorTelemetry:$.sendErrorTelemetry},this.b,this.g))}return this.a.get($.id)}publicLog($,y,p){this.h($).publicLog(y,p)}publicLogError($,y,p){this.h($).publicLogError(y,p)}};e.$k9b=b,e.$k9b=b=pe([X(0,N.$ji),X(1,S.$cl),X(2,I.$0i),X(3,I.$$i),X(4,A.$Wh),X(5,R.$pj)],b)}),define(oe[77],ae([0,1,3,20,4,8]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.ProvidedOnAutoForward=e.$cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$bv=e.$av=void 0,e.$av=(0,N.$Ph)("tunnelService"),e.$bv=(0,N.$Ph)("sharedTunnelsService");var I;(function(p){p.Http="http",p.Https="https"})(I||(e.TunnelProtocol=I={}));var R;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(R||(e.TunnelPrivacyId=R={}));function S(p){return!!p.forwardPort}e.$cv=S;var g;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function C(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(h)return{address:h[1],port:+h[2]}}e.$dv=C,e.$ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(p){return e.$ev.indexOf(p)>=0}e.$fv=k,e.$gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(p){return e.$gv.indexOf(p)>=0}e.$hv=b;function c(p,h,f,u){if(f===1)return!1;if(f===2&&b(h)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(d?.length===4&&parseInt(d[1])>=18)return!1}return p<1024}e.$iv=c;class ${constructor(h,f,u){this.remoteAddress=h,this.localAddress=f,this.b=u,this.a=new D.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$jv=$;let y=class{constructor(h,f){this.j=h,this.k=f,this.a=new D.$Nd,this.onTunnelOpened=this.a.event,this.b=new D.$Nd,this.onTunnelClosed=this.b.event,this.c=new D.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const h=this.k.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.h=h.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const h=[],f=Array.from(this.e.values());for(const u of f){const d=Array.from(u.values());for(const E of d){const s=await E.value;s&&typeof s!="string"&&h.push(s)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:f}of h.values())await f.then(u=>typeof u!="string"?u?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,f,u,d,E){this.p(h,f,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:f,localAddress:u,privacy:d,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,f){(b(h)||k(h))&&(h=e.$ev[0]);const u=this.r(h,f);if(u)return++u.refcount,u.value}openTunnel(h,f,u,d,E,s=!1,o,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${u} on local port ${E}.`);const i=this.f??h;if(!i)return;if(f||(f="localhost"),d||(d=this.l),this.f&&this.i.has(u)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(i,f,u,d,E,s,o,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(f,u),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(f,u);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.n(r);return(r.tunnelRemoteHost!==f||r.tunnelRemotePort!==u)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const f=this.e.get(h.tunnelRemoteHost);if(f){const u=f.get(h.tunnelRemotePort);u&&(u.refcount--,await this.o(h.tunnelRemoteHost,h.tunnelRemotePort,u))}}}}async o(h,f,u){if(u.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${f}.`);const d=u.value.then(async E=>{E&&typeof E!="string"&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(f),d}}async closeTunnel(h,f){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${f} `);const u=this.e.get(h);if(u&&u.has(f)){const d=u.get(f);d.refcount=0,await this.o(h,f,d)}}p(h,f,u){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(f,{refcount:1,value:u})}async q(h,f){const u=this.e.get(h);if(u){const d=u.get(f),E=d?await d.value:void 0;(!E||typeof E=="string")&&u.delete(f),u.size===0&&this.e.delete(h)}}r(h,f){const u=[h];k(h)?(u.push(...e.$ev),u.push(...e.$gv)):b(h)&&u.push(...e.$gv);const d=u.map(E=>this.e.get(E));for(const E of d){const s=E?.get(f);if(s)return s}}canTunnel(h){return!!C(h)}t(h,f,u,d,E,s,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${u} on local port ${d}.`);const n=u;this.i.add(n);const i=d===void 0?u:d,t={elevationRequired:E?this.isPortPrivileged(i):!1},r={remoteAddress:{host:f,port:u},localAddressPort:d,privacy:s,public:s?s!==R.Private:void 0,protocol:o},a=h.forwardPort(r,t);return a?(this.p(f,u,a),a.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),a}};e.$kv=y,e.$kv=y=pe([X(0,A.$0i),X(1,L.$ji)],y)}),define(oe[228],ae([0,1,8,77,2,7,6]),function(te,e,D,L,N,A,I){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$x9b=void 0;class S extends N.$Rc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new I.$ch),this.b.p)}setAddress(k){this.a=k,this.b&&(this.b.complete(k),this.b=null)}setTunnel(k){this.B(k)}}let g=class extends N.$Rc{static{R=this}static{this.a=0}constructor(k,b){super(),this.f=k,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(k=>k.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(k,b,c,$,y,p,h){const f=new S,u=await Promise.resolve(this.f.openTunnel(k,f,c,$,y,p,h));if(!u||typeof u=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${c}:${$} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),f.dispose(),await u.dispose(),(0,A.$5)();return f.setTunnel(u),this.b.set(b,f),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${u.localAddress} (local) to ${c}:${$} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(k,b){const c=this.b.get(k);c&&c.setAddress(b)}async destroyTunnel(k){const b=this.b.get(k);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${k}.`),this.b.delete(k),await b.dispose();return}this.c.add(k)}};e.$x9b=g,e.$x9b=g=R=pe([X(0,L.$bv),X(1,D.$0i)],g)}),define(oe[28],ae([0,1,4]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=void 0,e.$Ik=(0,D.$Ph)("IUriIdentityService")}),define(oe[229],ae([0,1,28,184,11,19,127,3,2]),function(te,e,D,L,N,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;class g{static{this._clock=0}constructor(b){this.uri=b,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let C=class{constructor(b){this.g=b,this.c=new S.$Qc,this.f=2**16;const c=new Map,$=y=>{let p=c.get(y.scheme);return p===void 0&&(p=b.hasProvider(y)&&!this.g.hasCapability(y,1024),c.set(y.scheme,p)),p};this.c.add(R.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(y=>{c.delete(y.scheme)})),this.extUri=new A.$kg($),this.d=new I.$Br((y,p)=>this.extUri.compare(y,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,A.$wg)(b));const c=this.d.get(b);return c?c.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new g(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort(($,y)=>$[1].time<y[1].time?1:$[1].time>y[1].time?-1:0);g._clock=0,this.d.clear();const c=this.f*.5;for(let $=0;$<c;$++)this.d.set(b[$][0],b[$][1].touch())}};e.$Cr=C,e.$Cr=C=pe([X(0,N.$$j)],C),(0,L.$zr)(D.$Ik,C,1)}),define(oe[230],ae([0,1,3,2,11,47,34]),function(te,e,D,L,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R8b=void 0;class R extends L.$Rc{constructor(g,C,k,b,c,$){super(),this.f=g,this.g=C,this.h=k,this.j=b,this.m=c,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$Nd),this.onDidChangeFile=this.a.event,this.b=A.$Vh.forUris(()=>!(this.capabilities&1024)),this.c=new I.$Ac(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(b.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const g of this.j.profiles)this.c.add(g.settingsResource),this.c.add(g.keybindingsResource),this.c.add(g.tasksResource),this.c.add(g.extensionsResource)}open(g,C){return this.g.open(this.t(g),C)}close(g){return this.g.close(g)}read(g,C,k,b,c){return this.g.read(g,C,k,b,c)}write(g,C,k,b,c){return this.g.write(g,C,k,b,c)}watch(g,C){this.b.set(g,g);const k=this.g.watch(this.t(g),C);return(0,L.$Pc)(()=>{this.b.delete(g),k.dispose()})}stat(g){return this.g.stat(this.t(g))}mkdir(g){return this.g.mkdir(this.t(g))}rename(g,C,k){return this.g.rename(this.t(g),this.t(C),k)}readFile(g,C){return this.g.readFile(this.t(g),C)}readFileStream(g,C,k){return this.g.readFileStream(this.t(g),C,k)}readdir(g){return this.g.readdir(this.t(g))}enforceAtomicReadFile(g){return this.c.has(g)}writeFile(g,C,k){return this.g.writeFile(this.t(g),C,k)}enforceAtomicWriteFile(g){return this.c.has(g)?{postfix:".vsctmp"}:!1}delete(g,C){return this.g.delete(this.t(g),C)}copy(g,C,k){if((0,N.$ck)(this.g))return this.g.copy(this.t(g),this.t(C),k);throw new Error("copy not supported")}cloneFile(g,C){if((0,N.$dk)(this.g))return this.g.cloneFile(this.t(g),this.t(C));throw new Error("clone not supported")}s(g){const C=[];for(const k of g){if(k.resource.scheme!==this.f)continue;const b=this.u(k.resource);this.b.findSubstr(b)&&C.push({resource:b,type:k.type,cId:k.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(g){return g.with({scheme:this.f})}u(g){return g.with({scheme:this.h})}}e.$R8b=R}),define(oe[78],ae([0,1,86]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iDb=e.$hDb=e.edit=void 0;function L(I,R,S,g){const C=(0,D.$gT)(I,R,S,g)[0];return C&&(I=I.substring(0,C.offset)+C.content+I.substring(C.offset+C.length)),I}e.edit=L;function N(I,R,S){let g=S;for(;g>=0;){if(I.charAt(g)===R.charAt(R.length-1)&&R.length===1)return g+1;if(g--,R.length===2&&g>=0&&I.charAt(g)===R.charAt(0))return g+2}return 0}e.$hDb=N;function A(I,R,S){let g=S;for(;g>=0;)if(I.charAt(g)===R.charAt(R.length-1)&&R.length===1||(g++,R.length===2&&g>=0&&I.charAt(g)===R.charAt(1)))return g;return I.length-1}e.$iDb=A}),define(oe[231],ae([0,1,30,54,12]),function(te,e,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$93b=void 0;function A(c,$,y,p,h,f){const u=[],d=[],E=[];if(!$){const B=c.filter(({identifier:Y})=>h.every(K=>K.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:u,removed:d,updated:E},remote:B.length>0?{added:B,updated:[],removed:[],all:B}:null}}c=c.map(k),$=$.map(k),y=y?y.map(k):null;const s=new Map,o=B=>{B.uuid&&s.set(B.id.toLowerCase(),B.uuid)};c.forEach(({identifier:B})=>o(B)),$.forEach(({identifier:B})=>o(B)),y?.forEach(({identifier:B})=>o(B)),p?.forEach(({identifier:B})=>o(B)),f?.forEach(B=>o(B));const n=B=>{const Y=B.identifier.uuid||s.get(B.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${B.identifier.id.toLowerCase()}`},i=(B,Y)=>(B.set(n(Y),Y),B),t=c.reduce(i,new Map),r=$.reduce(i,new Map),a=$.reduce((B,Y)=>i(B,(0,D.$7m)(Y)),new Map),v=y?y.reduce(i,new Map):null,w=p.reduce(i,new Map),l=h.reduce((B,Y)=>{const K=s.get(Y.toLowerCase());return B.add(K?`uuid:${K}`:`id:${Y.toLowerCase()}`)},new Set),m=f?f.reduce((B,{id:Y,uuid:K})=>(K=K??s.get(Y.toLowerCase()),B.add(K?`uuid:${K}`:`id:${Y.toLowerCase()}`)),new Set):null,O=I(t,r,l,!1);if(O.added.size>0||O.removed.size>0||O.updated.size>0){const B=I(v,t,l,!1),Y=I(v,r,l,!0),K=(x,V,Q,G)=>{let W,ee,ie;return V.installed?(W=G.pinned,ie=G.preRelease,W&&(ee=G.version)):(W=Q.pinned,ie=Q.preRelease,W&&(ee=Q.version)),W===void 0&&(W=V.pinned,W&&(ee=V.version)),ie===void 0&&(ie=V.preRelease),{...G,installed:V.installed||Q.installed,pinned:W,preRelease:ie,version:ee??(Q.version&&(!V.installed||L.gt(Q.version,V.version))?Q.version:V.version),state:S(V,Q,v?.get(x))}};for(const x of Y.removed.values()){const V=t.get(x);if(!V)continue;const Q=(0,N.$Jf)(v?.get(x)),G=m&&!m.has(x)&&Q.installed;V.installed&&G?d.push(V.identifier):a.set(x,V)}for(const x of Y.added.values()){const V=(0,N.$Jf)(r.get(x)),Q=t.get(x);if(Q){if(O.updated.has(x)){const G=K(x,Q,V,V);R(Q,V,!1,!1)||E.push(b(G,x)),a.set(x,G)}}else V.installed&&u.push(b(V,x))}for(const x of Y.updated.values()){const V=(0,N.$Jf)(r.get(x)),Q=(0,N.$Jf)(v?.get(x)),G=t.get(x);if(G)if(m&&!m.has(x)&&Q.installed&&G.installed&&!V.installed)d.push(G.identifier);else{const ee=K(x,G,V,V);E.push(b(ee,x)),a.set(x,ee)}else V.installed&&u.push(b(V,x))}for(const x of B.added.values())Y.added.has(x)||a.set(x,(0,N.$Jf)(t.get(x)));for(const x of B.updated.values()){if(Y.removed.has(x)||Y.updated.has(x))continue;const V=(0,N.$Jf)(t.get(x)),Q=(0,N.$Jf)(r.get(x));a.set(x,K(x,V,Q,V))}for(const x of B.removed.values())Y.updated.has(x)||Y.removed.has(x)||w.has(x)||(0,N.$Jf)(r.get(x)).installed&&m&&(m.has(x)||!(0,N.$Jf)(v?.get(x)).installed||a.delete(x))}const F=[],z=I(r,a,new Set,!0),U=z.added.size>0||z.updated.size>0||z.removed.size>0;return U&&a.forEach((B,Y)=>F.push(b(B,Y))),{local:{added:u,removed:d,updated:E},remote:U?{added:[...z.added].map(B=>a.get(B)),updated:[...z.updated].map(B=>a.get(B)),removed:[...z.removed].map(B=>r.get(B)),all:F}:null}}e.$93b=A;function I(c,$,y,p){const h=c?[...c.keys()].filter(s=>!y.has(s)):[],f=[...$.keys()].filter(s=>!y.has(s)),u=f.filter(s=>!h.includes(s)).reduce((s,o)=>(s.add(o),s),new Set),d=h.filter(s=>!f.includes(s)).reduce((s,o)=>(s.add(o),s),new Set),E=new Set;for(const s of h){if(d.has(s))continue;const o=c.get(s),n=$.get(s);(!n||!R(o,n,p,!0))&&E.add(s)}return{added:u,removed:d,updated:E}}function R(c,$,y,p){return!(c.disabled!==$.disabled||!!c.isApplicationScoped!=!!$.isApplicationScoped||p&&c.installed!==$.installed||c.installed&&$.installed&&(c.preRelease!==$.preRelease||c.pinned!==$.pinned||$.pinned&&c.version!==$.version)||!C(c.state,$.state)||y&&c.version!==$.version)}function S(c,$,y){const p=c.state,h=$.state,f=y?.state;if(!$.version||p&&L.gt(c.version,$.version))return p;if(h&&L.gt($.version,c.version)||!p)return h;if(!h)return p;const u=(0,D.$7m)(p),d=f?g(f,h):{added:Object.keys(h).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set},E=f?g(f,p):{added:Object.keys(p).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set};for(const s of[...d.added.values(),...d.updated.values()])u[s]=h[s];for(const s of d.removed.values())E.updated.has(s)||delete u[s];return u}function g(c,$){const y=Object.keys(c),p=Object.keys($),h=p.filter(d=>!y.includes(d)).reduce((d,E)=>(d.add(E),d),new Set),f=y.filter(d=>!p.includes(d)).reduce((d,E)=>(d.add(E),d),new Set),u=new Set;for(const d of y){if(f.has(d))continue;const E=c[d],s=$[d];(0,D.$$m)(E,s)||u.add(d)}return{added:h,removed:f,updated:u}}function C(c={},$={}){const{added:y,removed:p,updated:h}=g(c,$);return y.size===0&&p.size===0&&h.size===0}function k(c){return{...c,disabled:!!c.disabled,installed:!!c.installed}}function b(c,$){const y={...c,identifier:{id:c.identifier.id,uuid:$.startsWith("uuid:")?$.substring(5):void 0},preRelease:!!c.preRelease,pinned:!!c.pinned};return c.disabled||delete y.disabled,c.installed||delete y.installed,c.state||delete y.state,c.isApplicationScoped||delete y.isApplicationScoped,y}}),define(oe[111],ae([0,1,18,20,4]),function(te,e,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fFb=e.$eFb=void 0,e.$eFb=(0,N.$Ph)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,S){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),S&&g.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(R,S){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),S&&g.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(R){const S=R.filter(b=>b.isMachineScoped).map(b=>b.identifier.id.toLowerCase()),g=this.b().map(b=>b.toLowerCase()),C=[],k=[];if(Array.isArray(g))for(const b of g)b.startsWith("-")?k.push(b.substring(1)):C.push(b);return(0,D.$Lb)([...S,...C].filter(b=>!k.includes(b)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$fFb=A,e.$fFb=A=pe([X(0,L.$ji)],A)}),define(oe[232],ae([0,1,18,35,30,94,78]),function(te,e,D,L,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c4b=void 0;function R(d){return(0,L.$Wm)(d)||[]}async function S(d,E,s,o,n){const i=R(d),t=R(E),r=s?R(s):null,a=[...i,...t,...r||[]].map(K=>K.key),v=await n.resolveUserBindings(a),w=C(i,t,r,v);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:E,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const l=b(i),m=b(t),O=r?b(r):null,F=$(l,m,v),z=O?$(O,l,v):{added:[...l.keys()].reduce((K,x)=>(K.add(x),K),new Set),removed:new Set,updated:new Set},U=O?$(O,m,v):{added:[...m.keys()].reduce((K,x)=>(K.add(x),K),new Set),removed:new Set,updated:new Set},B=g(F,z,U);let Y=d;for(const K of B.removed.values())B.conflicts.has(K)||(Y=f(Y,K,o));for(const K of B.added.values()){if(B.conflicts.has(K))continue;const x=m.get(K);if(x.some(V=>V.command!==`-${K}`&&w.conflicts.has(v[V.key]))){B.conflicts.add(K);continue}Y=h(Y,x,o)}for(const K of B.updated.values()){if(B.conflicts.has(K))continue;const x=m.get(K);if(x.some(V=>V.command!==`-${K}`&&w.conflicts.has(v[V.key]))){B.conflicts.add(K);continue}Y=u(Y,K,x,o)}return{mergeContent:Y,hasChanges:!0,hasConflicts:B.conflicts.size>0}}e.$c4b=S;function g(d,E,s){const o=new Set,n=new Set,i=new Set,t=new Set;for(const r of E.removed.values())s.updated.has(r)&&t.add(r);for(const r of s.removed.values())t.has(r)||(E.updated.has(r)?t.add(r):n.add(r));for(const r of E.added.values())t.has(r)||s.added.has(r)&&d.updated.has(r)&&t.add(r);for(const r of s.added.values())t.has(r)||(E.added.has(r)?d.updated.has(r)&&t.add(r):o.add(r));for(const r of E.updated.values())t.has(r)||s.updated.has(r)&&d.updated.has(r)&&t.add(r);for(const r of s.updated.values())t.has(r)||(E.updated.has(r)?d.updated.has(r)&&t.add(r):i.add(r));return{added:o,removed:n,updated:i,conflicts:t}}function C(d,E,s,o){const n=new Set,i=k(d,o),t=k(E,o),r=s?k(s,o):null,a=c(i,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?c(r,i):{added:[...i.keys()].reduce((z,U)=>(z.add(U),z),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=r?c(r,t):{added:[...t.keys()].reduce((z,U)=>(z.add(U),z),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:l,removed:m,updated:O,conflicts:F}=g(a,v,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:l,removed:m,updated:O,conflicts:F}}function k(d,E){const s=new Map;for(const o of d){const n=E[o.key];let i=s.get(n);i||(i=[],s.set(n,i)),i.push(o)}return s}function b(d){const E=new Map;for(const s of d){const o=s.command[0]==="-"?s.command.substring(1):s.command;let n=E.get(o);n||(n=[],E.set(o,n)),n.push(s)}return E}function c(d,E){const s=[...d.keys()],o=[...E.keys()],n=o.filter(r=>!s.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=s.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of s){if(i.has(r))continue;const a=d.get(r).map(w=>({...w,key:r})),v=E.get(r).map(w=>({...w,key:r}));(0,D.$tb)(a,v,(w,l)=>p(w,l))||t.add(r)}return{added:n,removed:i,updated:t}}function $(d,E,s){const o=[...d.keys()],n=[...E.keys()],i=n.filter(a=>!o.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const v=d.get(a).map(l=>({...l,key:s[l.key]})),w=E.get(a).map(l=>({...l,key:s[l.key]}));y(v,w)||r.add(a)}return{added:i,removed:t,updated:r}}function y(d,E){return!(!(0,D.$tb)(d.filter(({command:s})=>s[0]!=="-"),E.filter(({command:s})=>s[0]!=="-"),(s,o)=>p(s,o))||!(0,D.$tb)(d.filter(({command:s})=>s[0]==="-"),E.filter(({command:s})=>s[0]==="-"),(s,o)=>p(s,o)))}function p(d,E){if(d.command!==E.command||d.key!==E.key)return!1;const s=A.$Ni.deserialize(d.when),o=A.$Ni.deserialize(E.when);return!(s&&!o||!s&&o||s&&o&&!s.equals(o)||!N.$$m(d.args,E.args))}function h(d,E,s){for(const o of E)d=I.edit(d,[-1],o,s);return d}function f(d,E,s){const o=R(d);for(let n=o.length-1;n>=0;n--)(o[n].command===E||o[n].command===`-${E}`)&&(d=I.edit(d,[n],void 0,s));return d}function u(d,E,s,o){const n=R(d),i=n.findIndex(t=>t.command===E||t.command===`-${E}`);for(let t=n.length-1;t>=0;t--)(n[t].command===E||n[t].command===`-${E}`)&&(d=I.edit(d,[t],void 0,o));for(let t=s.length-1;t>=0;t--)d=I.edit(d,[i],s[t],o);return d}}),define(oe[233],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k4b=e.$j4b=void 0;function D(A,I,R){const S={},g={},C=new Set;if(!I)return{local:{added:S,updated:g,removed:[...C.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const k=L(A,I);if(k.added.size===0&&k.removed.size===0&&k.updated.size===0)return{local:{added:S,updated:g,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const b=L(R,A),c=L(R,I),$={},y={},p=new Set,h=new Set;for(const f of b.removed.values())c.updated.has(f)?S[f]=I[f]:p.add(f);for(const f of c.removed.values())h.has(f)||(b.updated.has(f)?h.add(f):C.add(f));for(const f of b.updated.values())h.has(f)||(c.updated.has(f)?k.updated.has(f)&&h.add(f):y[f]=A[f]);for(const f of c.updated.values())h.has(f)||(b.updated.has(f)?k.updated.has(f)&&h.add(f):A[f]!==void 0&&(g[f]=I[f]));for(const f of b.added.values())h.has(f)||(c.added.has(f)?k.updated.has(f)&&h.add(f):$[f]=A[f]);for(const f of c.added.values())h.has(f)||(b.added.has(f)?k.updated.has(f)&&h.add(f):S[f]=I[f]);return{local:{added:S,removed:[...C.values()],updated:g},remote:{added:$,removed:[...p.values()],updated:y},conflicts:[...h.values()]}}e.$j4b=D;function L(A,I){const R=A?Object.keys(A):[],S=I?Object.keys(I):[],g=S.filter(b=>!R.includes(b)).reduce((b,c)=>(b.add(c),b),new Set),C=R.filter(b=>!S.includes(b)).reduce((b,c)=>(b.add(c),b),new Set),k=new Set;for(const b of R){if(C.has(b))continue;const c=A[b],$=I[b];c!==$&&k.add(b)}return{added:g,removed:C,updated:k}}function N(A,I){const{added:R,removed:S,updated:g}=L(A,I);return R.size===0&&S.size===0&&g.size===0}e.$k4b=N}),define(oe[234],ae([0,1,30]),function(te,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$45b=void 0;function L(A,I,R,S){const g={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!I){const b=A.filter(({id:c})=>!S.includes(c));return b.length?C.added=b:C=null,{local:g,remote:C}}const k=N(A,I,S);if(k.added.length>0||k.removed.length>0||k.updated.length>0){const b=N(R,A,S),c=N(R,I,S);for(const $ of c.removed){const y=A.find(p=>p.id===$);y&&g.removed.push(y)}for(const $ of c.added){const y=I.find(p=>p.id===$);b.added.includes($)?k.updated.includes($)&&g.updated.push(y):g.added.push(y)}for(const $ of c.updated)g.updated.push(I.find(y=>y.id===$));for(const $ of b.added)c.added.includes($)||C.added.push(A.find(y=>y.id===$));for(const $ of b.updated)c.removed.includes($)||c.updated.includes($)||C.updated.push(A.find(y=>y.id===$));for(const $ of b.removed){const y=I.find(p=>p.id===$);y&&C.removed.push(y)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:g,remote:C}}e.$45b=L;function N(A,I,R){A=A?A.filter(({id:c})=>!R.includes(c)):[],I=I.filter(({id:c})=>!R.includes(c));const S=A.map(({id:c})=>c),g=I.map(({id:c})=>c),C=g.filter(c=>!S.includes(c)),k=S.filter(c=>!g.includes(c)),b=[];for(const{id:c,name:$,shortName:y,icon:p,useDefaultFlags:h}of A){if(k.includes(c))continue;const f=I.find(u=>u.id===c);(!f||f.name!==$||f.shortName!==y||f.icon!==p||!(0,D.$$m)(f.useDefaultFlags,h))&&b.push(c)}return{added:C,removed:k,updated:b}}}),define(oe[24],ae([0,1,18,12,173,50,29,4,103,40]),function(te,e,D,L,N,A,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhb=e.$ehb=e.$dhb=e.$chb=e.$bhb=e.$ahb=e.$_gb=e.$$gb=e.$0gb=e.$9gb=e.$8gb=e.MergeState=e.Change=e.SyncStatus=e.$7gb=e.$6gb=e.$5gb=e.UserDataSyncErrorCode=e.$4gb=e.$3gb=e.$2gb=e.$1gb=e.$Zgb=e.$Ygb=e.$Xgb=e.$Wgb=e.$Vgb=e.SyncResource=e.$Ugb=e.$Tgb=e.$Sgb=e.$Rgb=e.$Qgb=e.$Pgb=void 0;function C(){const t=g.$jn.as(A.$on.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$Pgb=C;function k(){const t=g.$jn.as(A.$on.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(w=>!!t[w].ignoreSync),a=Object.keys(t).filter(w=>t[w].scope===2||t[w].scope===6),v=C();return(0,D.$Lb)([...r,...a,...v])}e.$Qgb=k,e.$Rgb="settingsSync",e.$Sgb="settingsSync.keybindingsPerPlatform";function b(){const t="vscode://schemas/ignoredSettings",r=g.$jn.as(A.$on.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,N.localize)(0,null),type:"object",properties:{[e.$Sgb]:{type:"boolean",description:(0,N.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,N.localize)(2,null),items:[{type:"string",pattern:I.$1n,errorMessage:(0,N.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,N.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=g.$jn.as(S.$kn.JSONContribution),v=()=>{const w=C(),l=k(),m=Object.keys(A.$pn.properties).filter(z=>!l.includes(z)),O=l.filter(z=>!w.includes(z)),F={items:{type:"string",enum:[...m,...O.map(z=>`-${z}`)]}};a.registerSchema(t,F)};return r.onDidUpdateConfiguration(()=>v())}e.$Tgb=b;function c(t){return t&&(0,L.$Af)(t)&&(0,L.$yf)(t.id)&&Array.isArray(t.scopes)}e.$Ugb=c;var $;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})($||(e.SyncResource=$={})),e.$Vgb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(t,...r){return t?[t,...r]:r}e.$Wgb=y;function p(t,r,a,v){return v.joinPath(a.userDataSyncHome,...y(t,r,`lastSync${r}.json`))}e.$Xgb=p,e.$Ygb=(0,R.$Ph)("IUserDataSyncStoreManagementService"),e.$Zgb=(0,R.$Ph)("IUserDataSyncStoreService"),e.$1gb=(0,R.$Ph)("IUserDataSyncLocalStoreService"),e.$2gb="x-operation-id",e.$3gb="X-Execution-Id";function h(t){const r={};return r[e.$3gb]=t,r}e.$4gb=h;var f;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(f||(e.UserDataSyncErrorCode=f={}));class u extends Error{constructor(r,a,v,w){super(r),this.code=a,this.resource=v,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$5gb=u;class d extends u{constructor(r,a,v,w,l){super(r,v,void 0,l),this.url=a,this.serverCode=w}}e.$6gb=d;class E extends u{constructor(r,a){super(r,a)}}e.$7gb=E,function(t){function r(a){if(a instanceof t)return a;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(v&&v[1]){const w=v[2]==="unknown"?void 0:v[2],l=v[3]==="unknown"?void 0:v[3];return new t(a.message,v[1],w,l)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(u||(e.$5gb=u={}));var s;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$8gb="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.$9gb=i,e.$0gb=(0,R.$Ph)("IUserDataSyncEnablementService"),e.$$gb=(0,R.$Ph)("IUserDataSyncService"),e.$_gb=(0,R.$Ph)("IUserDataSyncResourceProviderService"),e.$ahb=(0,R.$Ph)("IUserDataAutoSyncService"),e.$bhb=(0,R.$Ph)("IUserDataSyncUtilService"),e.$chb=(0,R.$Ph)("IUserDataSyncLogService"),e.$dhb="userDataSync",e.$ehb="vscode-userdata-sync",e.$fhb="preview"}),define(oe[235],ae([0,1,30,24]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AEb=void 0;function N(I,R,S,g,C){if(!R)return{remote:{added:Object.keys(I),removed:[],updated:[],all:Object.keys(I).length>0?I:null},local:{added:{},removed:[],updated:{}}};const k=A(I,R);if(k.added.size===0&&k.removed.size===0&&k.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const b=S?A(S,R):{added:Object.keys(R).reduce((f,u)=>(f.add(u),f),new Set),removed:new Set,updated:new Set},c=S?A(S,I):{added:Object.keys(I).reduce((f,u)=>(f.add(u),f),new Set),removed:new Set,updated:new Set},$={added:{},removed:[],updated:{}},y=D.$7m(R),p=!S;for(const f of c.added.values())f!==L.$8gb&&p&&b.added.has(f)||(y[f]=I[f]);for(const f of c.updated.values())y[f]=I[f];for(const f of c.removed.values())g.unregistered.includes(f)||delete y[f];for(const f of b.added.values()){const u=R[f];if(g.machine.includes(f)){C.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(S&&c.added.has(f))continue;const d=I[f];d&&d.value===u.value||f===L.$8gb&&p&&c.added.has(f)||(d?$.updated[f]=u:$.added[f]=u)}for(const f of b.updated.values()){const u=R[f];if(g.machine.includes(f)){C.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(f)||c.removed.has(f))continue;const d=I[f];d&&d.value===u.value||($.updated[f]=u)}for(const f of b.removed.values()){if(g.machine.includes(f)){C.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}c.updated.has(f)||c.removed.has(f)||$.removed.push(f)}const h=A(R,y);return{local:$,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:y}}}e.$AEb=N;function A(I,R){const S=Object.keys(I),g=Object.keys(R),C=g.filter(c=>!S.includes(c)).reduce((c,$)=>(c.add($),c),new Set),k=S.filter(c=>!g.includes(c)).reduce((c,$)=>(c.add($),c),new Set),b=new Set;for(const c of S){if(k.has(c))continue;const $=I[c],y=R[c];D.$$m($,y)||b.add(c)}return{added:C,removed:k,updated:b}}}),define(oe[236],ae([0,1,18,35,86,41,30,78,24]),function(te,e,D,L,N,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oDb=e.$nDb=e.$mDb=e.$lDb=e.$kDb=e.$jDb=void 0;function g(a,v,w){let l=[];w?l=k(w):l=C(v);const m=[],O=[...(0,S.$Pgb)()];if(Array.isArray(l))for(const F of l)F.startsWith("-")?O.push(F.substring(1)):m.push(F);return(0,D.$Lb)([...a,...m].filter(F=>!O.includes(F)))}e.$jDb=g;function C(a){let v=a.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=a.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:a.getValue("settingsSync.ignoredSettings")||[]}function k(a){const v=(0,L.$Wm)(a);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function b(a,v){const w=(0,L.$Wm)(a)||{};let l="{}";for(const m of Object.keys(w)){const O=(0,N.$gT)(l,[m],w[m],v);l=(0,N.$jT)(l,O)}return l}e.$kDb=b;function c(a,v,w,l){if(w.length){const m=r(v),O=(0,L.$Wm)(v)||{},F=(0,L.$Wm)(a);if(!F)return a;const z=[];for(const U of w){const B=O[U],Y=F[U];B===void 0?a=R.edit(a,[U],void 0,l):Y!==void 0?a=R.edit(a,[U],B,l):z.push(s(U,m))}z.sort((U,B)=>U.startOffset-B.startOffset),z.forEach(U=>a=f(U.setting.key,v,a,l))}return a}e.$lDb=c;function $(a,v,w,l,m,O){const F=c(a,v,l,O),z=w!==F,U=w!==v;if(!z&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!U)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(U&&!z)return{conflictsSettings:[],localContent:c(v,a,l,O),remoteContent:null,hasConflicts:!1};if(w===null&&p(a)){const j=y(a,v,l)?null:c(v,a,l,O);return{conflictsSettings:[],localContent:j,remoteContent:null,hasConflicts:!1}}let B=a,Y=v;const K=(0,L.$Wm)(a),x=(0,L.$Wm)(v),V=w?(0,L.$Wm)(w):null,Q=l.reduce((j,T)=>(j.add(T),j),new Set),G=h(K,x,Q),W=h(V,K,Q),ee=h(V,x,Q),ie=new Map,_=new Set,ne=j=>{_.add(j);const T=m.filter(({key:M})=>M===j)[0];T?(B=R.edit(B,[j],T.value,O),Y=R.edit(Y,[j],T.value,O)):ie.set(j,{key:j,localValue:K[j],remoteValue:x[j]})};for(const j of W.removed.values())ee.updated.has(j)?ne(j):Y=R.edit(Y,[j],void 0,O);for(const j of ee.removed.values())_.has(j)||(W.updated.has(j)?ne(j):B=R.edit(B,[j],void 0,O));for(const j of W.updated.values())_.has(j)||(ee.updated.has(j)?G.updated.has(j)&&ne(j):Y=R.edit(Y,[j],K[j],O));for(const j of ee.updated.values())_.has(j)||(W.updated.has(j)?G.updated.has(j)&&ne(j):B=R.edit(B,[j],x[j],O));for(const j of W.added.values())_.has(j)||(ee.added.has(j)?G.updated.has(j)&&ne(j):Y=f(j,B,Y,O));for(const j of ee.added.values())_.has(j)||(W.added.has(j)?G.updated.has(j)&&ne(j):B=f(j,Y,B,O));const Z=ie.size>0||!y(B,Y,l),q=Z||!y(B,a,[]),P=Z||!y(Y,v,[]);return{localContent:q?B:null,remoteContent:P?Y:null,conflictsSettings:[...ie.values()],hasConflicts:Z}}e.$mDb=$;function y(a,v,w){if(a===v)return!0;const l=(0,L.$Wm)(a),m=(0,L.$Wm)(v),O=w.reduce((U,B)=>(U.add(B),U),new Set),F=r(a).filter(U=>!(U.setting&&O.has(U.setting.key))),z=r(v).filter(U=>!(U.setting&&O.has(U.setting.key)));if(F.length!==z.length)return!1;for(let U=0;U<F.length;U++){const B=F[U],Y=z[U];if(B.setting&&Y.setting){if(B.setting.key!==Y.setting.key||!I.$$m(l[B.setting.key],m[B.setting.key]))return!1}else if(!B.setting&&!Y.setting){if(B.value!==Y.value)return!1}else return!1}return!0}function p(a){return a?r(a).length===0:!0}e.$nDb=p;function h(a,v,w){const l=a?Object.keys(a).filter(U=>!w.has(U)):[],m=Object.keys(v).filter(U=>!w.has(U)),O=m.filter(U=>!l.includes(U)).reduce((U,B)=>(U.add(B),U),new Set),F=l.filter(U=>!m.includes(U)).reduce((U,B)=>(U.add(B),U),new Set),z=new Set;if(a)for(const U of l){if(F.has(U))continue;const B=a[U],Y=v[U];I.$$m(B,Y)||z.add(U)}return{added:O,removed:F,updated:z}}function f(a,v,w,l){const m=(0,L.$Wm)(v),O=r(v),F=r(w),z=u(a,O,F);return d(w,a,m[a],z,F,l)}e.$oDb=f;function u(a,v,w){const l=v.findIndex(O=>O.setting?.key===a),m=v[l-1];if(m){if(m.setting){const F=s(m.setting.key,w);if(F)return{index:w.indexOf(F),insertAfter:!0}}else{const F=o(l,v);if(F){const z=s(F.setting.key,w);if(z){const U=n(w.indexOf(z),w),B=i(v,F,v[l]);if(U){const Y=i(w,z,U),K=t(B,Y);return K?{index:w.indexOf(K),insertAfter:!0}:{index:w.indexOf(U),insertAfter:!1}}else{const Y=i(w,z,w[w.length-1]),K=t(B,Y);return K?{index:w.indexOf(K),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const O=v[l+1];if(O)if(O.setting){const F=s(O.setting.key,w);if(F)return{index:w.indexOf(F),insertAfter:!1}}else{const F=n(l,v);if(F){const z=s(F.setting.key,w);if(z){const U=o(w.indexOf(z),w),B=i(v,v[l],F);if(U){const Y=i(w,U,z),K=t(B.reverse(),Y.reverse());return K?{index:w.indexOf(K),insertAfter:!1}:{index:w.indexOf(U),insertAfter:!0}}else{const Y=i(w,w[0],z),K=t(B.reverse(),Y.reverse());return K?{index:w.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function d(a,v,w,l,m,O){let F;return l.index===-1?F=(0,N.$gT)(a,[v],w,O):F=E(a,v,w,l,m,O).map(z=>(0,N.$hT)(a,z,O)[0]),(0,N.$jT)(a,F)}function E(a,v,w,l,m,O){const F=`${JSON.stringify(v)}: ${JSON.stringify(w)}`,z=(0,A.$dT)(O,a),U=m[l.index];if(l.insertAfter){const B=[];if(U.setting)B.push({offset:U.endOffset,length:0,content:","+F});else{const Y=n(l.index,m),K=o(l.index,m),x=K?.setting?.commaOffset;K&&x===void 0&&B.push({offset:K.endOffset,length:0,content:","});const V=x!==void 0&&x>U.endOffset;B.push({offset:V?x+1:U.endOffset,length:0,content:Y?z+F+",":z+F})}return B}else{if(U.setting)return[{offset:U.startOffset,length:0,content:F+","}];const B=(m[l.index-1]&&!m[l.index-1].setting?z:"")+F+(n(l.index,m)?",":"")+z;return[{offset:U.startOffset,length:0,content:B}]}}function s(a,v){return v.filter(w=>w.setting?.key===a)[0]}function o(a,v){for(let w=a-1;w>=0;w--)if(v[w].setting)return v[w]}function n(a,v){for(let w=a+1;w<v.length;w++)if(v[w].setting)return v[w]}function i(a,v,w){const l=a.indexOf(v),m=a.indexOf(w);return a.filter((O,F)=>l<F&&F<m)}function t(a,v){if(a.length&&v.length){let w=0;for(;w<v.length&&w<a.length;w++)if(a[w].value!==v[w].value)return v[w-1];return v[w-1]}}function r(a){const v=[];let w=-1,l,m;const O={onObjectBegin:F=>{w++},onObjectProperty:(F,z,U)=>{w===0&&(l=z,m=F)},onObjectEnd:(F,z)=>{w--,w===0&&v.push({startOffset:l,endOffset:F+z,value:a.substring(l,F+z),setting:{key:m,commaOffset:void 0}})},onArrayBegin:(F,z)=>{w++},onArrayEnd:(F,z)=>{w--,w===0&&v.push({startOffset:l,endOffset:F+z,value:a.substring(l,F+z),setting:{key:m,commaOffset:void 0}})},onLiteralValue:(F,z,U)=>{w===0&&v.push({startOffset:l,endOffset:z+U,value:a.substring(l,z+U),setting:{key:m,commaOffset:void 0}})},onSeparator:(F,z,U)=>{if(w===0&&F===","){let B=v.length-1;for(;B>=0&&!v[B].setting;B--);const Y=v[B];Y&&v.splice(B,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:z}})}},onComment:(F,z)=>{w===0&&v.push({startOffset:F,endOffset:F+z,value:a.substring(F,F+z)})}};return(0,L.$4m)(a,O),v}}),define(oe[79],ae([0,1,3,2,4,24]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Cb=e.$6Cb=void 0,e.$6Cb=(0,N.$Ph)("IUserDataSyncAccountService");let I=class extends L.$Rc{get account(){return this.a}constructor(S,g){super(),this.g=S,this.h=g,this.b=this.B(new D.$Nd),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.$Nd),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$7Cb=I,e.$7Cb=I=pe([X(0,A.$Zgb),X(1,A.$chb)],I)}),define(oe[237],ae([0,1,2,10]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r9b=e.$q9b=e.$p9b=e.$o9b=e.$n9b=e.$m9b=e.$l9b=void 0;class N{constructor(b){this.a=b}listen(b,c){switch(c){case"onError":return this.a.onError}throw new Error(`Event not found: ${c}`)}call(b,c,$){switch(c){case"triggerSync":return this.a.triggerSync($[0],$[1],$[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff($[0])}throw new Error("Invalid call")}}e.$l9b=N;class A{constructor(b){this.a=b}listen(b,c){throw new Error(`Event not found: ${c}`)}call(b,c,$){switch(c){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings($[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(L.URI.revive($[0]))}throw new Error("Invalid call")}}e.$m9b=A;class I{constructor(b){this.a=b}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(b){return this.a.call("resolveUserKeybindings",[b])}async resolveFormattingOptions(b){return this.a.call("resolveFormattingOptions",[b])}}e.$n9b=I;class R{constructor(b){this.a=b}listen(b,c){switch(c){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${c}`)}async call(b,c,$){switch(c){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine($[0],$[1]);case"setEnablements":return this.a.setEnablements($)}throw new Error("Invalid call")}}e.$o9b=R;class S{constructor(b){this.a=b}listen(b,c){switch(c){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${c}`)}call(b,c,$){switch(c){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount($)}throw new Error("Invalid call")}}e.$p9b=S;class g{constructor(b){this.a=b}listen(b,c){switch(c){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${c}`)}call(b,c,$){switch(c){case"switch":return this.a.switch($[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$q9b=g;class C extends D.$Rc{constructor(b){super(),this.a=b,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(b){return this.a.call("switch",[b])}async getPreviousUserDataSyncStore(){const b=await this.a.call("getPreviousUserDataSyncStore");return this.b(b)}b(b){return{url:L.URI.revive(b.url),type:b.type,defaultUrl:L.URI.revive(b.defaultUrl),insidersUrl:L.URI.revive(b.insidersUrl),stableUrl:L.URI.revive(b.stableUrl),canSwitch:b.canSwitch,authenticationProviders:b.authenticationProviders}}}e.$r9b=C}),define(oe[238],ae([0,1,19,174,14,8,24]),function(te,e,D,L,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gFb=void 0;let R=class extends A.$cj{constructor(g,C){super(),this.g=this.B(g.createLogger((0,D.$vg)(C.logsHome,`${I.$dhb}.log`),{id:I.$dhb,name:(0,L.localize)(0,null)}))}trace(g,...C){this.g.trace(g,...C)}debug(g,...C){this.g.debug(g,...C)}info(g,...C){this.g.info(g,...C)}warn(g,...C){this.g.warn(g,...C)}error(g,...C){this.g.error(g,...C)}flush(){this.g.flush()}};e.$gFb=R,e.$gFb=R=pe([X(0,A.$$i),X(1,N.$Wh)],R)}),define(oe[239],ae([0,1,6,3,2]),function(te,e,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m8b=void 0;class A extends N.$Rc{constructor({onDidOpenWindow:R,onDidFocusWindow:S,getActiveWindowId:g}){super(),this.a=this.B(new N.$Qc),L.Event.latch(L.Event.any(R,S))(this.f,this,this.a),this.b=(0,D.$Hg)(()=>g()),(async()=>{try{const k=await this.b;this.c=typeof this.c=="number"?this.c:k}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$m8b=A}),define(oe[112],ae([0,1,177,16,47,19,10,4,23]),function(te,e,D,L,N,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,R.$Ph)("contextService");function g(i){const t=i;return typeof t?.id=="string"&&I.URI.isUri(t.uri)}e.$Zh=g;function C(i){return typeof i?.id=="string"&&!g(i)&&!b(i)}e.$1h=C,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function k(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.$mc)(i)}:t?e.$2h:e.$3h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$4h=k;function b(i){const t=i;return typeof t?.id=="string"&&I.URI.isUri(t.configPath)}e.$5h=b;function c(i){const t=i;if(t?.uri)return{id:t.id,uri:I.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:I.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$6h=c;var $;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function y(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$7h=y;function p(i){const t=i;return!!(t&&typeof t=="object"&&I.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$8h=p;class h{constructor(t,r,a,v,w){this.h=t,this.j=a,this.k=v,this.l=w,this.c=N.$Vh.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=N.$Vh.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=h;class f{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,A.$vg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=f;function u(i){return new f({uri:i,index:0,name:(0,A.$rg)(i)},{uri:i.toString()})}e.$$h=u,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,D.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function d(i,t){return A.$mg.isEqualOrParent(i,t.untitledWorkspacesHome)}e.$di=d;function E(i){let t;return I.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===S.Schemas.tmp}e.$ei=E,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$fi}e.$gi=s;function o(i,t){return!d(i,t)&&!E(i)}e.$hi=o;function n(i){return(typeof i=="string"?(0,L.$nc)(i):(0,A.$tg)(i))===e.$ai}e.$ii=n}),define(oe[17],ae([0,1,52,3,2,19,10,168,14,11,4,8,112,34,28,6,32,27,12]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.ProfileResourceType=void 0;var u;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(u||(e.ProfileResourceType=u={}));function d(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&I.URI.isUri(t.location)&&I.URI.isUri(t.globalStorageHome)&&I.URI.isUri(t.settingsResource)&&I.URI.isUri(t.keybindingsResource)&&I.URI.isUri(t.tasksResource)&&I.URI.isUri(t.snippetsHome)&&I.URI.isUri(t.extensionsResource))}e.$Jk=d,e.$Kk=(0,C.$Ph)("IUserDataProfilesService");function E(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:I.URI.revive(i.location).with({scheme:t}),globalStorageHome:I.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:I.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:I.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:I.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:I.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:I.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:I.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Lk=E;function s(i,t,r,a,v,w){return{id:i,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:w&&v?.useDefaultFlags?.globalState?w.globalStorageHome:(0,A.$vg)(r,"globalStorage"),settingsResource:w&&v?.useDefaultFlags?.settings?w.settingsResource:(0,A.$vg)(r,"settings.json"),keybindingsResource:w&&v?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,A.$vg)(r,"keybindings.json"),tasksResource:w&&v?.useDefaultFlags?.tasks?w.tasksResource:(0,A.$vg)(r,"tasks.json"),snippetsHome:w&&v?.useDefaultFlags?.snippets?w.snippetsHome:(0,A.$vg)(r,"snippets"),extensionsResource:w&&v?.useDefaultFlags?.extensions?w.extensionsResource:(0,A.$vg)(r,"extensions.json"),cacheHome:(0,A.$vg)(a,i),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Mk=s;let o=class extends N.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,v){super(),this.t=t,this.u=r,this.w=a,this.y=v,this.f=!0,this.h=this.B(new L.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new L.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new L.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new L.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new c.$zc,emptyWindows:new Map},this.profilesHome=(0,A.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,f.$yf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}r.push(s((0,A.$sg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},t))}}catch(w){this.y.error(w)}const a=new c.$zc,v=new Map;if(r.length)try{const w=this.Q();if(w.workspaces)for(const[l,m]of Object.entries(w.workspaces)){const O=I.URI.parse(l),F=r.find(z=>z.id===m);F&&a.set(O,F)}if(w.emptyWindows)for(const[l,m]of Object.entries(w.emptyWindows)){const O=r.find(F=>F.id===m);O&&v.set(l,O)}}catch(w){this.y.error(w)}this.z={profiles:r,workspaces:a,emptyWindows:v}}return this.z}D(){const t=s("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,h.$Fe)(r)}\\s(\\d+)`);let v=0;for(const l of this.profiles){const m=a.exec(l.name),O=m?parseInt(m[1]):0;v=O>v?O:v}const w=`${r} ${v+1}`;return this.createProfile((0,D.$Di)((0,p.$eg)()).toString(16),w,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,D.$Di)((0,p.$eg)()).toString(16),t,r,a)}async createProfile(t,r,a,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(t,r,a);return v&&await this.setProfileForWorkspace(v,w),w}async F(t,r,a){if(!(0,f.$yf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const w=this.profiles.find(O=>O.name===r||O.id===t);if(w)return w;const l=s(t,r,(0,A.$vg)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(l.location);const m=[];return this.j.fire({profile:l,join(O){m.push(O)}}),await y.Promises.settled(m),this.I([l],[],[]),l}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(v=>v.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=s(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(v){a.push(v)}});try{await Promise.allSettled(a)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,g.$pk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(v=>v.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return I.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,b.$Zh)(t)?t.uri:(0,b.$5h)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const v=[...this.profiles,...t],w=[];this.s.profiles=[];for(let l of v)l.isDefault||r.some(m=>l.id===m.id)||(l=a.find(m=>l.id===m.id)??l,l.isTransient?this.s.profiles.push(l):w.push({location:l.location,name:l.name,shortName:l.shortName,icon:l.icon,useDefaultFlags:l.useDefaultFlags}));this.P(w),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const v=this.G(t),w=a?this.s:this.C;I.URI.isUri(v)?(w.workspaces.delete(v),r&&w.workspaces.set(v,r)):(w.emptyWindows.delete(v),r&&w.emptyWindows.set(v,r)),a||this.M()}M(){const t={};for(const[a,v]of this.C.workspaces.entries())t[a.toString()]=v.id;const r={};for(const[a,v]of this.C.emptyWindows.entries())r[a.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[w,l]of Object.entries(t.workspaces)){const m=I.URI.parse(l);r[w]=this.w.extUri.isEqual(m,a.location)?a.id:this.w.extUri.basename(m)}const v={};if(t.emptyWindows)for(const[w,l]of Object.entries(t.emptyWindows)){const m=I.URI.parse(l);v[w]=this.w.extUri.isEqual(m,a.location)?a.id:this.w.extUri.basename(m)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Nk=o,e.$Nk=o=pe([X(0,S.$Wh),X(1,g.$$j),X(2,$.$Ik),X(3,k.$0i)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Ok=n}),define(oe[240],ae([0,1,6,2,17]),function(te,e,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z9b=void 0;let A=class extends L.$Rc{constructor(R){super(),this.B(new D.$6g(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$z9b=A,e.$z9b=A=pe([X(0,N.$Kk)],A)}),define(oe[241],ae([0,1,18,6,26,7,3,2,5,12,10,151,29,33,44,8,25,22,28,17]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=void 0;let d=class extends R.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,v,w,l){super(),this.z=t,this.C=r,this.D=a,this.F=v,this.G=w,this.H=l,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new I.$Nd),this.s=this.B(new I.$Nd),this.t=this.B(new I.$Nd),this.u=this.B(new I.$Nd),this.w=this.B(new I.$Nd),this.y=[],this.B((0,R.$Pc)(()=>{this.j.forEach(({task:m})=>m.cancel()),this.m.forEach(m=>m.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,b.$$n)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:w})=>(0,c.$Co)(w,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:s(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(a){throw s(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new b.$bo(k.localize(0,null),b.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(t.map(async({extension:v,options:w})=>{try{const l=await this.O(v,!!w?.installGivenVersion,!!w?.installPreReleaseVersion);a.push({...l,options:w})}catch(l){r.push({identifier:v.identifier,operation:2,source:v,error:l})}})),a.length&&r.push(...await this.I(a));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!C.URI.isUri(v.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,c.$Ko)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,$.$9l)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const w=(await this.getInstalled(1,v.extensionsResource)).find(l=>(0,c.$Co)(l.identifier,t.identifier));w?this.w.fire(w):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async a=>{try{const v=await this.J(a,(w,l)=>t.some(m=>(0,c.$Go)(l.identifier.id)===(0,c.$Ho)(m.manifest.publisher,m.manifest.name))?!1:this.L(w,l));r.push(...v)}catch(v){r.push({identifier:{id:(0,c.$Ho)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:a},v){const w=a.isApplicationScoped||a.isBuiltin||(0,$.$9l)(t),l={...a,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:w,profileLocation:w?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},m=Y=>`${c.$Do.create(Y).toString()}${l.profileLocation?`-${l.profileLocation.toString()}`:""}`;if(!C.URI.isUri(r)){const Y=this.j.get(m(r));if(Y)return this.F.info("Extensions is already requested to install",r.identifier.id),await Y.task.waitUntilTaskIsFinished(),[]}const O=[],F=[],z=[],U=this.Z(t,r,l);C.URI.isUri(r)||this.j.set(m(r),{task:U,waitingTasks:[]}),this.n.fire({identifier:U.identifier,source:r,profileLocation:l.profileLocation}),this.F.info("Installing extension:",U.identifier.id),O.push({task:U,manifest:t});let B=!1;try{if(l.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",U.identifier.id);else try{const K=await this.N(U.identifier,t,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation),x=await this.getInstalled(void 0,l.profileLocation),V={...l,donotIncludePackAndDependencies:!0,context:{...l.context,[b.$6n]:!0}};for(const{gallery:Q,manifest:G}of(0,D.$Lb)(K,({gallery:W})=>W.identifier.id)){B=B||!!G.extensionDependencies?.some(ie=>(0,c.$Co)({id:ie},U.identifier));const W=m(Q),ee=this.j.get(W);if(ee){if(v(U,ee.task)){const ie=ee.task.identifier;this.F.info("Waiting for already requested installing extension",ie.id,U.identifier.id),ee.waitingTasks.push(U),F.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,_=>_.some(ne=>(0,c.$Co)(ne.identifier,ie)))).then(_=>{if(this.F.info("Finished waiting for already requested installing extension",ie.id,U.identifier.id),!_.find(Z=>(0,c.$Co)(Z.identifier,ie))?.local)throw new Error(`Extension ${ie.id} is not installed`)}))}}else if(!x.some(({identifier:ie})=>(0,c.$Co)(ie,Q.identifier))){const ie=this.Z(G,Q,V);this.j.set(W,{task:ie,waitingTasks:[U]}),this.n.fire({identifier:ie.identifier,source:Q,profileLocation:l.profileLocation}),this.F.info("Installing extension:",ie.identifier.id,U.identifier.id),O.push({task:ie,manifest:G})}}}catch(K){if(C.URI.isUri(U.source))(0,D.$Kb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",U.identifier.id,K.message),(0,D.$Kb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",U.identifier.id,K.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",U.identifier.id),K}const Y=O.reduce((K,{task:x,manifest:V})=>(K.set(x.identifier.id.toLowerCase(),{task:x,manifest:V}),K),new Map);for(;Y.size;){let K;const x=[...Y.values()].filter(({manifest:V})=>!V.extensionDependencies?.some(Q=>Y.has(Q.toLowerCase())));x.length?K=Y.size===1?x:x.filter(({task:V})=>!(V===U&&!B)):(this.F.info("Found extensions with circular dependencies",x.map(({task:V})=>V.identifier.id)),K=[...Y.values()]),await this.M(K.map(async({task:V})=>{const Q=new Date().getTime();try{const G=await V.run();if(await this.M(this.y.map(W=>W.postInstall(G,V.source,l,N.CancellationToken.None))),!C.URI.isUri(V.source)){const W=V.operation===3,ee=W?void 0:(new Date().getTime()-V.source.lastUpdated)/1e3;if(o(this.C,W?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Ko)(V.source),verificationStatus:V.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:ee}),S.$p&&V.operation!==3)try{await this.z.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}z.push({local:G,identifier:V.identifier,operation:V.operation,source:V.source,context:V.options.context,profileLocation:V.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw C.URI.isUri(V.source)||o(this.C,V.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Ko)(V.source),verificationStatus:V.verificationStatus,duration:new Date().getTime()-Q,error:G}),this.F.error("Error while installing the extension:",V.identifier.id),G}finally{Y.delete(V.identifier.id.toLowerCase())}}))}return F.length&&await this.M(F),z.forEach(({identifier:K})=>this.F.info("Extension installed successfully:",K.id)),z}catch(Y){if(O.forEach(({task:K})=>K.cancel()),z.length)try{const K=await Promise.allSettled(z.map(({local:x})=>this.$(x,{versionOnly:!0,profileLocation:l.profileLocation}).run()));for(let x=0;x<K.length;x++){const V=K[x],{identifier:Q}=z[x];V.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",Q.id):this.F.warn("Rollback: Error while uninstalling extension",Q.id,(0,A.$9)(V.reason))}}catch(K){this.F.warn("Error while rolling back extensions",(0,A.$9)(K),z.map(({identifier:x})=>x.id))}return O.map(({task:K})=>({identifier:K.identifier,operation:2,source:K.source,context:l.context,profileLocation:l.profileLocation,error:Y}))}finally{for(const{task:Y}of O)Y.source&&!C.URI.isUri(Y.source)&&this.j.delete(m(Y.source))}}L(t,r){for(const[,{task:a,waitingTasks:v}]of this.j.entries())if(a===t&&(v.includes(r)||v.some(w=>this.L(w,r)))||a===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],a=[],v=await Promise.allSettled(t);for(const w of v)w.status==="fulfilled"?r.push(w.value):a.push(w.reason);if(a.length)throw E(a);return r}async N(t,r,a,v,w){if(!this.z.isEnabled())return[];const l=await this.getInstalled(void 0,w),m=[],O=[],F=async(z,U)=>{m.push(z);const B=U.extensionDependencies||[],Y=[...B];if(U.extensionPack){const K=a?l.find(x=>(0,c.$Co)(x.identifier,z)):void 0;for(const x of U.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(V=>(0,c.$Co)({id:V},{id:x}))||Y.every(V=>!(0,c.$Co)({id:V},{id:x}))&&Y.push(x)}if(Y.length){const K=Y.filter(x=>m.every(V=>!(0,c.$Co)(V,{id:x})));if(K.length){const x=await this.z.getExtensions(K.map(V=>({id:V,preRelease:v})),N.CancellationToken.None);for(const V of x){if(m.find(W=>(0,c.$Co)(W,V.identifier)))continue;const Q=B.some(W=>(0,c.$Co)({id:W},V.identifier));let G;try{G=await this.O(V,!1,v)}catch(W){if(Q)throw W;this.F.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,A.$9)(W));continue}O.push({gallery:G.extension,manifest:G.manifest}),await F(G.extension.identifier,G.manifest)}}}};return await F(t,r),O}async O(t,r,a){let v;const w=await this.getExtensionsControlManifest();if(w.malicious.some(O=>(0,c.$Co)(t.identifier,O)))throw new b.$bo(k.localize(1,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);const l=w.deprecated[t.identifier.id.toLowerCase()];if(l?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${l.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:l.extension.id,preRelease:l.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},N.CancellationToken.None))[0],!v)throw new b.$bo(k.localize(2,null,t.identifier.id,l.extension.id),b.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const O=await this.getTargetPlatform();throw new b.$bo(k.localize(3,null,t.identifier.id,this.G.nameLong,(0,b.$7n)(O)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,a),!v)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],N.CancellationToken.None))[0]?new b.$bo(k.localize(4,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.$bo(k.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),b.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const m=await this.z.getManifest(v,N.CancellationToken.None);if(m===null)throw new b.$bo(`Missing manifest for extension ${v.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(m.version!==v.version)throw new b.$bo(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:m}}async P(t,r,a){const v=await this.getTargetPlatform();let w=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(w=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:v,compatible:!0},N.CancellationToken.None))[0]||null),!w&&await this.z.isExtensionCompatible(t,a,v)&&(w=t),w||(r?w=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},N.CancellationToken.None))[0]||null:w=await this.z.getCompatibleExtension(t,a,v)),w}async Q(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=z=>`${z.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,w=this.m.get(v(t.identifier));if(w)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),w.waitUntilTaskIsFinished();const l=z=>{const U=this.$(z,a);return this.m.set(v(U.extension.identifier),U),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${z.identifier.id}@${z.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${z.identifier.id}@${z.manifest.version}`),this.t.fire({identifier:z.identifier,profileLocation:a.profileLocation,applicationScoped:z.isApplicationScoped}),U},m=(z,U)=>{U?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${z.identifier.id}@${z.manifest.version}`,a.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${z.identifier.id}@${z.manifest.version}`,U.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${z.identifier.id}@${z.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${z.identifier.id}@${z.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,c.$Jo)(z),error:U}),this.u.fire({identifier:z.identifier,error:U?.code,profileLocation:a.profileLocation,applicationScoped:z.isApplicationScoped})},O=[],F=[];try{O.push(l(t));const z=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const U=this.U(t,z);for(const B of U)this.m.has(v(B.identifier))?this.F.info("Extensions is already requested to uninstall",B.identifier.id):O.push(l(B))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(O.map(U=>U.extension),z,t),await this.M(O.map(async U=>{try{if(await U.run(),await this.M(this.y.map(B=>B.postUninstall(U.extension,a,N.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,"uninstall")}catch{}m(U.extension)}catch(B){const Y=B instanceof b.$bo?B:new b.$bo((0,A.$9)(B),b.ExtensionManagementErrorCode.Internal);throw m(U.extension,Y),Y}finally{F.push(U)}}))}catch(z){const U=z instanceof b.$bo?z:new b.$bo((0,A.$9)(z),b.ExtensionManagementErrorCode.Internal);for(const B of O){try{B.cancel()}catch{}F.includes(B)||m(B.extension,U)}throw U}finally{for(const z of O)this.m.delete(v(z.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",z.extension.identifier.id)}}R(t,r,a){for(const v of t){const w=this.W(v,r);if(w.length){const l=w.filter(m=>!t.some(O=>(0,c.$Co)(O.identifier,m.identifier)));if(l.length)throw new Error(this.S(v,l,a))}}}S(t,r,a){return a===t?r.length===1?k.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?k.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):k.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?k.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?k.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):k.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const w=r.filter(m=>!m.isBuiltin&&v.some(O=>(0,c.$Co)({id:O},m.identifier))),l=[];for(const m of w)l.push(...this.U(m,r,a));return[...w,...l]}return[]}W(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>(0,c.$Co)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$sp=d,e.$sp=d=pe([X(0,b.$ao),X(1,h.$cl),X(2,f.$Ik),X(3,y.$0i),X(4,p.$pj),X(5,u.$Kk)],d);function E(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$tp=E;function s(i){if(i instanceof b.$bo)return i;const t=new b.$bo(i.message,b.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.$up=s;function o(i,t,{extensionData:r,verificationStatus:a,duration:v,error:w,durationSinceUpdate:l}){let m,O;(0,g.$Gf)(a)&&(a===!0?a="Verified":(a===!1||(m=b.ExtensionManagementErrorCode.Signature,O=a),a="Unverified")),w&&(w instanceof b.$bo?(m=w.code,w.code===b.ExtensionManagementErrorCode.Signature&&(O=w.message)):m=b.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:a,success:!w,duration:v,errorcode:m,errorcodeDetail:O,durationSinceUpdate:l})}class n{constructor(){this.d=new L.$Sg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,L.$Hg)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,L.$Hg)(t=>new Promise((r,a)=>{const v=t.onCancellationRequested(()=>{v.dispose(),a(new A.$4)})})),this.d.open()),this.g.cancel()}}e.$vp=n}),define(oe[51],ae([0,1,6,15,2,3,34,10,29,33,11,4,8,17,28,12,7,22]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class u extends Error{constructor(n,i){super(n),this.code=i}}e.$wp=u,e.$xp=(0,k.$Ph)("IExtensionsProfileScannerService");let d=class extends N.$Rc{constructor(n,i,t,r,a,v){super(),this.j=n,this.m=i,this.n=t,this.r=r,this.s=a,this.t=v,this.b=this.B(new A.$Nd),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Nd),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Nd),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Nd),this.onDidRemoveExtensions=this.g.event,this.h=new I.$zc}scanProfileExtensions(n,i){return this.u(n,void 0,i)}async addExtensionsToProfile(n,i){const t=[],r=[];try{return await this.u(i,a=>{const v=[];for(const w of a)n.some(([l])=>(0,g.$Co)(l.identifier,w.identifier)&&l.manifest.version!==w.version)?t.push(w):v.push(w);for(const[w,l]of n){const m=v.findIndex(F=>(0,g.$Co)(F.identifier,w.identifier)&&F.version===w.manifest.version),O={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:l};m===-1?(r.push(O),v.push(O)):v.splice(m,1,O)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),t.length&&this.f.fire({extensions:t,profileLocation:i}),v}),r.length&&this.c.fire({extensions:r,profileLocation:i}),t.length&&this.g.fire({extensions:t,profileLocation:i}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:i}),t.length&&this.g.fire({extensions:t,error:a,profileLocation:i}),a}}async updateMetadata(n,i){const t=[];return await this.u(i,r=>{const a=[];for(const v of r){const w=n.find(([l])=>(0,g.$Co)(l.identifier,v.identifier)&&l.manifest.version===v.version);w&&(v.metadata={...v.metadata,...w[1]},t.push(v)),a.push(v)}return a}),t}async removeExtensionFromProfile(n,i){const t=[];try{await this.u(i,r=>{const a=[];for(const v of r)(0,g.$Co)(v.identifier,n.identifier)?t.push(v):a.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:i}),a}),t.length&&this.g.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:i}),r}}async u(n,i,t){return this.F(n).queue(async()=>{let r=[],a;try{const v=await this.m.readFile(n);a=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,C.$pk)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new u((0,p.$9)(v),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let v=!1;for(const w of a){E(w)||this.w(n);let l;if((0,y.$yf)(w.relativeLocation)&&w.relativeLocation)l=this.z(w.relativeLocation);else if((0,y.$yf)(w.location))l=this.z(w.location),v=!0,w.relativeLocation=w.location,w.location=l.toJSON();else{l=R.URI.revive(w.location);const m=this.y(l);m&&(v=!0,w.relativeLocation=m)}r.push({identifier:w.identifier,location:l,version:w.version,metadata:w.metadata})}v&&await this.m.writeFile(n,L.$be.fromString(JSON.stringify(a)))}if(i){r=i(r);const v=r.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.y(w.location),metadata:w.metadata}));await this.m.writeFile(n,L.$be.fromString(JSON.stringify(v)))}return r})}w(n){const i=new u(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,C.$pk)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(v=>E(v))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,L.$be.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$pk)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,C.$pk)(a)!==1&&this.t.error(a)}try{await this.m.del(i)}catch(a){(0,C.$pk)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let i=this.h.get(n);return i||(i=new D.$1g,this.h.set(n,i)),i}};e.$yp=d,e.$yp=d=pe([X(1,C.$$j),X(2,c.$Kk),X(3,$.$Ik),X(4,h.$cl),X(5,b.$0i)],d);function E(o){return(0,y.$Af)(o)&&(0,S.$_n)(o.identifier)&&(s(o.location)||(0,y.$yf)(o.location)&&o.location)&&((0,y.$Ff)(o.relativeLocation)||(0,y.$yf)(o.relativeLocation))&&o.version&&(0,y.$yf)(o.version)}function s(o){return o?(0,y.$yf)(o.path)&&(0,y.$yf)(o.scheme):!1}}),define(oe[80],ae([0,1,18,6,30,15,7,35,137,2,23,16,5,19,54,89,12,10,154,14,33,44,68,11,4,8,25,3,64,51,17,28,182]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f,u,d,E,s,o,n,i,t,r,a,v,w,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.Translations=void 0;var O;(function(x){function V(Q,G){if(Q===G)return!0;const W=Object.keys(Q),ee=new Set;for(const ie of Object.keys(G))ee.add(ie);if(W.length!==ee.size)return!1;for(const ie of W){if(Q[ie]!==G[ie])return!1;ee.delete(ie)}return ee.size===0}x.equals=V})(O||(e.Translations=O={})),e.$Bp=(0,n.$Ph)("IExtensionsScannerService");let F=class extends g.$Rc{constructor(V,Q,G,W,ee,ie,_,ne,Z,q,P,j){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=Q,this.r=G,this.s=W,this.t=ee,this.u=ie,this.w=_,this.y=ne,this.z=Z,this.C=q,this.D=P,this.F=j,this.g=this.B(new r.$Nd),this.onDidChangeCache=this.g.event,this.h=(0,c.$vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(B,this.s,this.h)),this.m=this.B(this.F.createInstance(B,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,d.$No)(this.w,this.y)),this.G}async scanAllExtensions(V,Q,G){const[W,ee]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(Q)]),ie=G?await this.scanExtensionsUnderDevelopment(V,[...W,...ee]):[];return this.L(W,ee,ie,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const Q=[];Q.push(this.M(!!V.useCache,V.language)),Q.push(this.N(V.language,!!V.checkControlFile));const[G,W]=await Promise.all(Q);return this.J([...G,...W],0,V,!1)}async scanUserExtensions(V){const Q=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const G=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.P(Q,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,G),ee=V.useCache&&!W.devMode&&W.excludeObsolete?this.m:this.n;let ie;try{ie=await ee.scanExtensions(W)}catch(_){if(_ instanceof v.$wp&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ie=await ee.scanExtensions(W);else throw _}return ie=await this.J(ie,1,V,!0),this.y.trace("Scanned user extensions:",ie.length),ie}async scanExtensionsUnderDevelopment(V,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(W=>W.scheme===C.Schemas.file).map(async W=>{const ee=await this.P(W,!1,1,!0,V.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(ee)).map(_=>(_.type=Q.find(ne=>(0,d.$Co)(ne.identifier,_.identifier))?.type??_.type,this.n.validate(_,ee)))}))).flat();return this.J(G,"development",V,!0)}return[]}async scanExistingExtension(V,Q,G){const W=await this.P(V,!1,Q,!0,G.language,!0,void 0),ee=await this.n.scanExtension(W);return!ee||!G.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(V,Q,G){const W=await this.P(V,!1,Q,!0,G.language,!0,void 0),ee=await this.n.scanOneOrMultipleExtensions(W);return this.J(ee,Q,G,!0)}async scanMetadata(V){const Q=(0,c.$vg)(V,"package.json"),G=(await this.w.readFile(Q)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(V,Q){const G=(0,c.$vg)(V,"package.json"),W=(await this.w.readFile(G)).value.toString(),ee=JSON.parse(W);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,ee.__metadata={...ee.__metadata,...Q},await this.w.writeFile((0,c.$vg)(V,"package.json"),A.$be.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof v.$wp&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$be.fromString(JSON.stringify([])))}catch(Q){(0,o.$pk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.$9)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,Q,G,W){return G.includeAllVersions||(V=this.L(Q===0?V:void 0,Q===1?V:void 0,Q==="development"?V:void 0,await this.getTargetPlatform(),W)),G.includeInvalid||(V=V.filter(ee=>ee.isValid)),V.sort((ee,ie)=>{const _=k.$mc(ee.location.fsPath),ne=k.$mc(ie.location.fsPath);return _<ne?-1:_>ne?1:0})}L(V,Q,G,W,ee){const ie=(ne,Z,q)=>{if(ne.isValid&&!Z.isValid)return!1;if(ne.isValid===Z.isValid){if(ee&&$.gt(ne.manifest.version,Z.manifest.version))return this.y.debug(`Skipping extension ${Z.location.path} with lower version ${Z.manifest.version} in favour of ${ne.location.path} with version ${ne.manifest.version}`),!1;if($.eq(ne.manifest.version,Z.manifest.version)){if(ne.type===0)return this.y.debug(`Skipping extension ${Z.location.path} in favour of system extension ${ne.location.path} with same version`),!1;if(ne.targetPlatform===W)return this.y.debug(`Skipping extension ${Z.location.path} from different target platform ${Z.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${ne.location.path} with ${Z.location.path}.`):this.y.debug(`Overwriting user extension ${ne.location.path} with ${Z.location.path}.`),!0},_=new E.$8l;return V?.forEach(ne=>{const Z=_.get(ne.identifier.id);(!Z||ie(Z,ne,!1))&&_.set(ne.identifier.id,ne)}),Q?.forEach(ne=>{const Z=_.get(ne.identifier.id);if(!Z&&V&&ne.type===0){this.y.debug(`Skipping obsolete system extension ${ne.location.path}.`);return}(!Z||ie(Z,ne,!1))&&_.set(ne.identifier.id,ne)}),G?.forEach(ne=>{const Z=_.get(ne.identifier.id);(!Z||ie(Z,ne,!0))&&_.set(ne.identifier.id,ne),_.set(ne.identifier.id,ne)}),[..._.values()]}async M(V,Q){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),ee=await(V&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(V,Q){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const W=Q?await this.O():{},ee=[],ie=h.URI.file(k.$gc(k.$ic(C.$cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ne of G){const Z=W[ne.name]||"marketplace";switch(Z){case"disabled":break;case"marketplace":ee.push((0,c.$vg)(ie,ne.name));break;default:ee.push(h.URI.file(Z));break}}const _=await Promise.all(ee.map(async ne=>this.n.scanExtension(await this.P(ne,!1,0,!0,V,!0,void 0))));return this.y.trace("Scanned dev system extensions:",_.length),(0,D.$Gb)(_)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,Q,G,W,ee,ie,_){const ne=await this.f(ee??b.$w),Z=await this.Q(V),q=Q&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,P=q?await this.Q(q):void 0;return new z(V,Z,q,P,Q,_,G,W,ie,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,ee,ne)}async Q(V){try{const Q=await this.w.stat(V);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$Cp=F,e.$Cp=F=pe([X(4,w.$Kk),X(5,v.$xp),X(6,o.$$j),X(7,i.$0i),X(8,u.$Wh),X(9,t.$pj),X(10,l.$Ik),X(11,n.$Oh)],F);class z{constructor(V,Q,G,W,ee,ie,_,ne,Z,q,P,j,T,M,H){this.location=V,this.mtime=Q,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=W,this.profile=ee,this.profileScanOptions=ie,this.type=_,this.excludeObsolete=ne,this.validate=Z,this.productVersion=q,this.productDate=P,this.productCommit=j,this.devMode=T,this.language=M,this.translations=H}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,Q){return(0,c.$og)(V.location,Q.location)&&V.mtime===Q.mtime&&(0,c.$og)(V.applicationExtensionslocation,Q.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&V.profile===Q.profile&&N.$$m(V.profileScanOptions,Q.profileScanOptions)&&V.type===Q.type&&V.excludeObsolete===Q.excludeObsolete&&V.validate===Q.validate&&V.productVersion===Q.productVersion&&V.productDate===Q.productDate&&V.productCommit===Q.productCommit&&V.devMode===Q.devMode&&V.language===Q.language&&O.equals(V.translations,Q.translations)}}e.$Dp=z;let U=class extends g.$Rc{constructor(V,Q,G,W,ee){super(),this.f=V,this.g=Q,this.h=G,this.j=W,this.m=ee}async scanExtensions(V){const Q=V.profile?await this.r(V):await this.n(V);let G={};if(V.excludeObsolete&&V.type===1)try{const W=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(W)}catch{}return(0,p.$Lf)(G)?Q:Q.filter(W=>!G[d.$Do.create(W).toString()])}async n(V){const Q=await this.j.resolve(V.location);if(!Q.children?.length)return[];const G=await Promise.all(Q.children.map(async W=>{if(!W.isDirectory||V.type===1&&(0,c.$sg)(W.resource).indexOf(".")===0)return null;const ee=new z(W.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ee)}));return(0,D.$Gb)(G).sort((W,ee)=>W.location.path<ee.location.path?-1:1)}async r(V){let Q=await this.s(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){Q=Q.filter(W=>!W.metadata?.isApplicationScoped);const G=await this.s(V.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,V);Q.push(...G)}return Q}async s(V,Q,G){const W=await this.g.scanProfileExtensions(V,G.profileScanOptions);if(!W.length)return[];const ee=await Promise.all(W.map(async ie=>{if(Q(ie)){const _=new z(ie.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(_,ie.metadata)}return null}));return(0,D.$Gb)(ee)}async scanOneOrMultipleExtensions(V){try{if(await this.j.exists((0,c.$vg)(V.location,"package.json"))){const Q=await this.scanExtension(V);return Q?[Q]:[]}else return await this.scanExtensions(V)}catch(Q){return this.m.error(`Error scanning extensions at ${V.location.path}:`,(0,I.$9)(Q)),[]}}async scanExtension(V,Q){try{let G=await this.scanExtensionManifest(V.location);if(G){G.publisher||(G.publisher=E.$2l),Q=Q??G.__metadata,delete G.__metadata;const W=(0,d.$Ho)(G.publisher,G.name),ee=Q?.id?{id:W,uuid:Q.id}:{id:W},ie=Q?.isSystem?0:V.type,_=ie===0||!!Q?.isBuiltin;G=await this.t(V.location,G,z.createNlsConfiguration(V));const ne={type:ie,identifier:ee,manifest:G,location:V.location,isBuiltin:_,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return V.validate?this.validate(ne,V):ne}}catch(G){V.type!==0&&this.m.error(G)}return null}validate(V,Q){let G=!0;const W=(0,s.$So)(Q.productVersion,Q.productDate,Q.location,V.manifest,V.isBuiltin);for(const[ee,ie]of W)ee===y.default.Error&&(G=!1,this.m.error(this.z(Q.location,ie)));return V.isValid=G,V.validations=W,V}async scanExtensionManifest(V){const Q=(0,c.$vg)(V,"package.json");let G;try{G=(await this.j.readFile(Q)).value.toString()}catch(ee){return(0,o.$pk)(ee)!==1&&this.m.error(this.z(V,(0,f.localize)(0,null,Q.path,ee.message))),null}let W;try{W=JSON.parse(G)}catch{const ie=[];(0,R.$Wm)(G,ie);for(const _ of ie)this.m.error(this.z(V,(0,f.localize)(1,null,Q.path,_.offset,_.length,(0,S.$zp)(_.error))));return null}return(0,R.$6m)(W)!=="object"?(this.m.error(this.z(V,(0,f.localize)(2,null,Q.path))),null):W}async t(V,Q,G){const W=await this.u(V,Q,G);if(W)try{const ee=[],ie=await this.w(W.default,ee);if(ee.length>0)return ee.forEach(ne=>{this.m.error(this.z(V,(0,f.localize)(3,null,W.default?.path,(0,S.$zp)(ne.error))))}),Q;if((0,R.$6m)(W)!=="object")return this.m.error(this.z(V,(0,f.localize)(4,null,W.default?.path))),Q;const _=W.values||Object.create(null);return(0,m.$Ap)(this.m,Q,_,ie)}catch{}return Q}async u(V,Q,G){const W=(0,c.$vg)(V,"package.nls.json"),ee=(Z,q)=>{q.forEach(P=>{this.m.error(this.z(V,(0,f.localize)(5,null,Z?.path,(0,S.$zp)(P.error))))})},ie=Z=>{this.m.error(this.z(V,(0,f.localize)(6,null,Z?.path)))},_=`${Q.publisher}.${Q.name}`,ne=G.translations[_];if(ne)try{const Z=h.URI.file(ne),q=(await this.j.readFile(Z)).value.toString(),P=[],j=(0,R.$Wm)(q,P);return P.length>0?(ee(Z,P),{values:void 0,default:W}):(0,R.$6m)(j)!=="object"?(ie(Z),{values:void 0,default:W}):{values:j.contents?j.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.j.exists(W))return;let q;try{q=await this.y(V,G)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const P=(await this.j.readFile(q.localized)).value.toString(),j=[],T=(0,R.$Wm)(P,j);return j.length>0?(ee(q.localized,j),{values:void 0,default:q.original}):(0,R.$6m)(T)!=="object"?(ie(q.localized),{values:void 0,default:q.original}):{values:T,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(V,Q){if(V)try{const G=(await this.j.readFile(V)).value.toString();return(0,R.$Wm)(G,Q)}catch{}}y(V,Q){return new Promise((G,W)=>{const ee=ie=>{const _=(0,c.$vg)(V,`package.nls.${ie}.json`);this.j.exists(_).then(ne=>{ne&&G({localized:_,original:(0,c.$vg)(V,"package.nls.json")});const Z=ie.lastIndexOf("-");Z===-1?G({localized:(0,c.$vg)(V,"package.nls.json"),original:null}):(ie=ie.substring(0,Z),ee(ie))})};if(Q.devMode||Q.pseudo||!Q.language)return G({localized:(0,c.$vg)(V,"package.nls.json"),original:null});ee(Q.language)})}z(V,Q){return`[${V.path}]: ${Q}`}};U=pe([X(1,v.$xp),X(2,l.$Ik),X(3,o.$$j),X(4,i.$0i)],U);let B=class extends U{constructor(V,Q,G,W,ee,ie,_){super(Q,W,ee,ie,_),this.G=V,this.H=G,this.D=this.B(new L.$Rg(3e3)),this.F=this.B(new r.$Nd),this.onDidChangeCache=this.F.event}async scanExtensions(V){const Q=this.M(V),G=await this.I(Q);if(this.C=V,G&&G.input&&z.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",V.location.toString()),this.D.trigger(()=>this.L()),G.result.map(ee=>(ee.location=h.URI.revive(ee.location),ee));const W=await super.scanExtensions(V);return await this.J(Q,{input:V,result:W}),W}async I(V){try{const Q=await this.j.readFile(V),G=JSON.parse(Q.value.toString());return{result:G.result,input:(0,a.$mh)(G.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",V.path,(0,I.$9)(Q))}return null}async J(V,Q){try{await this.j.writeFile(V,A.$be.fromString(JSON.stringify(Q)))}catch(G){this.m.debug("Error while writing the extension cache file:",V.path,(0,I.$9)(G))}}async L(){if(!this.C)return;const V=this.M(this.C),Q=await this.I(V);if(!Q)return;const G=Q.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!N.$$m(W,G))try{this.m.info("Invalidating Cache",G,W),await this.j.del(V),this.F.fire()}catch(ee){this.m.error(ee)}}M(V){const Q=this.N(V);return this.h.extUri.joinPath(Q.cacheHome,V.type===0?E.$1l:E.$Zl)}N(V){return V.type===0?this.H.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(V.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};B=pe([X(2,w.$Kk),X(3,v.$xp),X(4,l.$Ik),X(5,o.$$j),X(6,i.$0i)],B);function Y(x,V){const Q=(0,d.$Fo)(x.manifest.publisher,x.manifest.name);return{id:Q,identifier:new E.$6l(Q),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:V,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$Ep=Y;class K extends F{constructor(V,Q,G,W,ee,ie,_,ne,Z,q,P,j){super(V,Q,(0,c.$vg)(G,".vscode-oss-dev","extensions","control.json"),W,ee,ie,_,ne,Z,q,P,j),this.R=(async()=>{if(b.$z)try{const T=await this.w.readFile(h.URI.file(b.$z));return JSON.parse(T.value.toString())}catch{}return Object.create(null)})()}f(V){return this.R}}e.$Fp=K}),define(oe[242],ae([0,1,65,6,38,3,2,23,16,31,8,17]),function(te,e,D,L,N,A,I,R,S,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;let b=class extends I.$Rc{constructor($,y){super(),this.b=$,this.f=y,this.a=new L.$Zg(5)}async postUninstall($){const y=this.g($,"uninstall");y&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(p){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(p)}}));try{await g.Promises.rm(this.m($))}catch(p){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(p)}}g($,y){const p=`vscode:${y}`;if($.location.scheme===R.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[p]=="string"){const h=$.manifest.scripts[p].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn($.identifier.id,$.manifest.version,`${p} should be a node script`),null):{script:(0,S.$ic)($.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h($,y,p,h,f){return new Promise((u,d)=>{const E=this.j($,y,p,f);let s;const o=n=>{s&&(clearTimeout(s),s=null),n?d(n):u(void 0)};E.on("error",n=>{o((0,N.$Ai)(n)||"Unknown")}),E.on("exit",(n,i)=>{o(n?`post-${y} process exited with code ${n}`:void 0)}),h&&(s=setTimeout(()=>{s=null,E.kill(),d("timed out")},5e3))})}j($,y,p,h){const f={silent:!0,execArgv:void 0},u=(0,D.fork)($,[`--type=extension-post-${y}`,...p],f);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const d=A.Event.fromNodeEventEmitter(u.stdout,"data"),E=A.Event.fromNodeEventEmitter(u.stderr,"data");d(n=>this.f.info(h.identifier.id,h.manifest.version,`post-${y}`,n)),E(n=>this.f.error(h.identifier.id,h.manifest.version,`post-${y}`,n));const s=A.Event.any(A.Event.map(d,n=>({data:`%c${n}`,format:[""]})),A.Event.map(E,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(s,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(h.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),u}m($){return(0,S.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$Hp=b,e.$Hp=b=pe([X(0,k.$Kk),X(1,C.$0i)],b)}),define(oe[243],ae([0,1,8,17,28,22,51,11,14,10]),function(te,e,D,L,N,A,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=void 0;let C=class extends I.$yp{constructor(b,c,$,y,p,h){super(g.URI.file(b.extensionsPath),c,$,y,p,h)}};e.$MN=C,e.$MN=C=pe([X(0,S.$Xh),X(1,R.$$j),X(2,L.$Kk),X(3,N.$Ik),X(4,A.$cl),X(5,D.$0i)],C)}),define(oe[244],ae([0,1,10,14,51,80,11,4,8,25,28,17]),function(te,e,D,L,N,A,I,R,S,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q8b=void 0;let b=class extends A.$Fp{constructor($,y,p,h,f,u,d,E){super(D.URI.file(f.builtinExtensionsPath),D.URI.file(f.extensionsPath),f.userHome,$.defaultProfile,$,y,p,h,f,u,d,E)}};e.$q8b=b,e.$q8b=b=pe([X(0,k.$Kk),X(1,N.$xp),X(2,I.$$j),X(3,S.$0i),X(4,L.$Xh),X(5,g.$pj),X(6,C.$Ik),X(7,R.$Oh)],b)}),define(oe[21],ae([0,1,6,3,2,100,12,67,4,17]),function(te,e,D,L,N,A,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$9o=e.$8o=e.$7o=void 0,e.$7o="__$__isNewStorageMarker",e.$8o="__$__targetStorageMarker",e.$9o=(0,S.$Ph)("storageService");var C;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var k;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var b;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function c(f){const u=f.get(e.$8o);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.$0o=c;class $ extends N.$Rc{static{this.a=60*1e3}constructor(u={flushInterval:$.a}){super(),this.m=u,this.b=this.B(new L.$Qd),this.c=this.B(new L.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new N.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(u,d,E){return L.Event.filter(this.b.event,s=>s.scope===u&&(d===void 0||s.key===d),E)}n(){this.j.value=(0,D.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,N.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(u,d){const{key:E,external:s}=d;if(E===e.$8o){switch(u){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:u})}else this.b.fire({scope:u,key:E,target:this.J(u)[E],external:s})}w(u){this.f.fire({reason:u})}get(u,d,E){return this.P(d)?.get(u,E)}getBoolean(u,d,E){return this.P(d)?.getBoolean(u,E)}getNumber(u,d,E){return this.P(d)?.getNumber(u,E)}getObject(u,d,E){return this.P(d)?.getObject(u,E)}storeAll(u,d){this.y(()=>{for(const E of u)this.store(E.key,E.value,E.scope,E.target,d)})}store(u,d,E,s,o=!1){if((0,I.$Hf)(d)){this.remove(u,E,o);return}this.y(()=>{this.z(u,E,s),this.P(E)?.set(u,d,o)})}remove(u,d,E=!1){this.y(()=>{this.z(u,d,void 0),this.P(d)?.delete(u,E)})}y(u){this.b.pause(),this.c.pause();try{u()}finally{this.b.resume(),this.c.resume()}}keys(u,d){const E=[],s=this.J(u);for(const o of Object.keys(s))s[o]===d&&E.push(o);return E}z(u,d,E,s=!1){const o=this.J(d);typeof E=="number"?o[u]!==E&&(o[u]=E,this.P(d)?.set(e.$8o,JSON.stringify(o),s)):typeof o[u]=="number"&&(delete o[u],this.P(d)?.set(e.$8o,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(u){switch(u){case-1:return this.I;case 0:return this.G;default:return this.D}}L(u){const d=this.P(u);return d?c(d):Object.create(null)}isNew(u){return this.getBoolean(e.$7o,u)===!0}async flush(u=C.NONE){this.f.fire({reason:u});const d=this.P(-1),E=this.P(0),s=this.P(1);switch(u){case C.NONE:await D.Promises.settled([d?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await D.Promises.settled([d?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,E=this.P(1)?.items??new Map;return h(u,d,E,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(u){return await this.flush(),this.P(u)?.optimize()}async switch(u,d){return this.w(C.NONE),(0,g.$Jk)(u)?this.R(u,d):this.S(u,d)}M(u,d){return!(u.id===d.id||y(d)&&y(u))}N(u,d,E){this.y(()=>{const s=new Set;for(const[o,n]of u)s.add(o),d.get(o)!==n&&this.u(E,{key:o,external:!0});for(const[o]of d.items)s.has(o)||this.u(E,{key:o,external:!0})})}}e.$$o=$;function y(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$_o=y;class p extends ${constructor(){super(),this.U=this.B(new R.$5o(new R.$6o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$5o(new R.$6o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$5o(new R.$6o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(u=>this.u(1,u))),this.B(this.W.onDidChangeStorage(u=>this.u(0,u))),this.B(this.U.onDidChangeStorage(u=>this.u(-1,u)))}P(u){switch(u){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(u){return!1}}e.$ap=p;async function h(f,u,d,E,s,o){const n=O=>{try{return JSON.parse(O)}catch{return O}},i=new Map,t=new Map;f.forEach((O,F)=>{i.set(F,O),t.set(F,n(O))});const r=new Map,a=new Map;u.forEach((O,F)=>{r.set(F,O),a.set(F,n(O))});const v=new Map,w=new Map;d.forEach((O,F)=>{v.set(F,O),w.set(F,n(O))}),console.group(E!==s?`Storage: Application (path: ${E})`:`Storage: Application & Profile (path: ${E}, default profile)`);const l=[];if(i.forEach((O,F)=>{l.push({key:F,value:O})}),console.table(l),console.groupEnd(),console.log(t),E!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const O=[];r.forEach((F,z)=>{O.push({key:z,value:F})}),console.table(O),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const m=[];v.forEach((O,F)=>{m.push({key:F,value:O})}),console.table(m),console.groupEnd(),console.log(w)}e.$bp=h}),define(oe[113],ae([0,1,3,2,12,29,33,21]),function(te,e,D,L,N,A,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Cb=e.$4Cb=void 0;let S=class extends L.$Rc{constructor(k,b){super(),this.a=new D.$Nd,this.onDidChangeEnablement=this.a.event,this.b=this.B(new g(k)),this.B(this.b.onDidChange(c=>this.a.fire({extensions:c,source:"storage"}))),this.B(b.onDidInstallExtensions(c=>c.forEach(({local:$,operation:y})=>{$&&y===4&&this.f($.identifier)})))}async enableExtension(k,b){return this.f(k)?(this.a.fire({extensions:[k],source:b}),!0):!1}async disableExtension(k,b){return this.c(k)?(this.a.fire({extensions:[k],source:b}),!0):!1}getDisabledExtensions(){return this.h(A.$do)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(k){const b=this.getDisabledExtensions();return b.every(c=>!(0,I.$Co)(c,k))?(b.push(k),this.g(b),!0):!1}f(k){const b=this.getDisabledExtensions();for(let c=0;c<b.length;c++){const $=b[c];if((0,I.$Co)($,k))return b.splice(c,1),this.g(b),!0}return!1}g(k){this.j(A.$do,k)}h(k){return this.b.get(k,0)}j(k,b){this.b.set(k,b,0)}};e.$4Cb=S,e.$4Cb=S=pe([X(0,R.$9o),X(1,A.$co)],S);class g extends L.$Rc{constructor(k){super(),this.c=k,this.a=Object.create(null),this.b=this.B(new D.$Nd),this.onDidChange=this.b.event,this.B(k.onDidChangeValue(0,void 0,this.B(new L.$Qc))(b=>this.f(b)))}get(k,b){let c;return b===0?((0,N.$Hf)(this.a[k])&&(this.a[k]=this.g(k,b)),c=this.a[k]):c=this.g(k,b),JSON.parse(c)}set(k,b,c){const $=JSON.stringify(b.map(({id:p,uuid:h})=>({id:p,uuid:h})));this.g(k,c)!==$&&(c===0&&(b.length?this.a[k]=$:delete this.a[k]),this.h(k,b.length?$:void 0,c))}f(k){if(!(0,N.$Hf)(this.a[k.key])&&this.g(k.key,k.scope)!==this.a[k.key]){const c=this.get(k.key,k.scope);delete this.a[k.key];const $=this.get(k.key,k.scope),y=c.filter(h=>!$.some(f=>(0,I.$Co)(h,f))),p=$.filter(h=>!c.some(f=>(0,I.$Co)(f,h)));(y.length||p.length)&&this.b.fire([...y,...p])}}g(k,b){return this.c.get(k,b,"[]")}h(k,b,c){b?this.c.store(k,b,c,1):this.c.remove(k,c)}}e.$5Cb=g}),define(oe[245],ae([0,1,18,26,7,5,37,12,10,20,14,29,33,68,11,8,25,57,223,21,22,61]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f,u,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=void 0;const s=A.$p?"web":(0,k.$9n)(A.$u,I.$dc),o="X-Market-Search-Activity-Id";var n;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function i(...P){return String(P.reduce((j,T)=>j|T,0))}var t;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class l{constructor(j=w){this.d=j}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(j,T=this.d.pageSize){return new l({...this.d,pageNumber:j,pageSize:T})}withFilter(j,...T){const M=[...this.d.criteria,...T.length?T.map(H=>({filterType:j,value:H})):[{filterType:j}]];return new l({...this.d,criteria:M})}withSortBy(j){return new l({...this.d,sortBy:j})}withSortOrder(j){return new l({...this.d,sortOrder:j})}withFlags(...j){return new l({...this.d,flags:j.reduce((T,M)=>T|M,0)})}withAssetTypes(...j){return new l({...this.d,assetTypes:j})}withSource(j){return new l({...this.d,source:j})}get raw(){const{criteria:j,pageNumber:T,pageSize:M,sortBy:H,sortOrder:J,flags:re,assetTypes:ce}=this.d;return{filters:[{criteria:j,pageNumber:T,pageSize:M,sortBy:H,sortOrder:J}],assetTypes:ce,flags:re}}get searchText(){const j=this.d.criteria.filter(T=>T.filterType===t.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(j=>String(j.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function m(P,j){const T=(P||[]).filter(M=>M.statisticName===j)[0];return T?T.value:0}function O(P){const j="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(M=>M.assetType.indexOf(j)===0).reduce((M,H)=>{const J=U(P,H.assetType);return J&&M.push([H.assetType.substring(j.length),J]),M},[])}function F(P){if(P.properties){const j=P.properties.filter(H=>H.key===r.Repository),T=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=j.filter(H=>T.test(H.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return U(P,r.Repository)}function z(P){return{uri:`${P.fallbackAssetUri}/${r.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${r.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function U(P,j){return P.files.filter(M=>M.assetType===j)[0]?{uri:`${P.assetUri}/${j}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${j}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function B(P,j){const T=P.properties?P.properties.filter(H=>H.key===j):[],M=T.length>0&&T[0].value;return M?M.split(",").map(H=>(0,b.$Go)(H)):[]}function Y(P){const j=P.properties?P.properties.filter(T=>T.key===a.Engine):[];return j.length>0&&j[0].value||""}function K(P){const j=P.properties?P.properties.filter(T=>T.key===a.PreRelease):[];return j.length>0&&j[0].value==="true"}function x(P){const j=P.properties?P.properties.filter(M=>M.key===a.LocalizedLanguages):[],T=j.length>0&&j[0].value||"";return T?T.split(","):[]}function V(P){return P.properties?.find(j=>j.key===a.SponsorLink)?.value}function Q(P){return P.indexOf("preview")!==-1}function G(P){return P.targetPlatform?(0,k.$8n)(P.targetPlatform):"undefined"}function W(P){const j=(0,D.$Lb)(P.versions.map(G)),T=!!P.tags?.includes(k.$3n),M=j.indexOf("web");return T?M===-1&&j.push("web"):M!==-1&&j.splice(M,1),j}function ee(P,j){for(let T=0;T<P.length;T++){const M=P[T];if(M.version===P[T-1]?.version){let H=T;if(G(M)===j)for(;H>0&&P[H-1].version===M.version;)H--;H!==T&&(P.splice(T,1),P.splice(H,0,M))}}return P}e.$ep=ee;function ie(P,j,T){P.telemetryData={index:j,querySource:T,queryActivityId:P.queryContext?.[o]}}function _(P,j,T,M){const H=P.versions[0],J={manifest:U(j,r.Manifest),readme:U(j,r.Details),changelog:U(j,r.Changelog),license:U(j,r.License),repository:F(j),download:z(j),icon:U(j,r.Icon),signature:U(j,r.Signature),coreTranslations:O(j)};return{identifier:{id:(0,b.$Ho)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:j.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(H),description:P.shortDescription||"",installCount:m(P.statistics,"install"),rating:m(P.statistics,"averagerating"),ratingCount:m(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:T,assets:J,properties:{dependencies:B(j,a.Dependency),extensionPack:B(j,a.ExtensionPack),engine:Y(j),localizedLanguages:x(j),targetPlatform:G(j),isPreReleaseVersion:K(j)},hasPreReleaseVersion:K(H),hasReleaseVersion:!0,preview:Q(P.flags),isSigned:!!J.signature,queryContext:M}}let ne=class{constructor(j,T,M,H,J,re,ce,ue){this.k=T,this.l=M,this.n=H,this.o=J,this.q=re,this.u=ce,this.w=ue;const he=ce.extensionsGallery,$e=he?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=$e?he.servicePPEUrl:he?.serviceUrl,this.g=$e?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,f.$dp)(ce.version,ce,this.n,this.w,this.q,j,this.o)}x(j=""){return`${this.d}${j}`}isEnabled(){return!!this.d}async getExtensions(j,T,M){const H=L.CancellationToken.isCancellationToken(T)?{}:T,J=L.CancellationToken.isCancellationToken(T)?T:M,re=[],ce=[],ue=[],he=[];let $e=!0;for(const ve of j){ve.uuid?ce.push(ve.uuid):re.push(ve.id);const Ie=!!(ve.version||ve.preRelease);ue.push({id:ve.id,uuid:ve.uuid,includePreRelease:Ie}),ve.version&&he.push({id:ve.id,uuid:ve.uuid,version:ve.version}),$e=$e&&!!ve.hasPreRelease&&!Ie}if(!ce.length&&!re.length)return[];let de=new l().withPage(1,j.length);ce.length&&(de=de.withFilter(t.ExtensionId,...ce)),re.length&&(de=de.withFilter(t.ExtensionName,...re)),(H.queryAllVersions||$e)&&(de=de.withFlags(de.flags,n.IncludeVersions)),H.source&&(de=de.withSource(H.source));const{extensions:we}=await this.z(de,{targetPlatform:H.targetPlatform??s,includePreRelease:ue,versions:he,compatible:!!H.compatible},J);return H.source&&we.forEach((ve,Ie)=>ie(ve,Ie,H.source)),we}async getCompatibleExtension(j,T,M){if((0,k.$0n)(j.allTargetPlatforms,M))return null;if(await this.isExtensionCompatible(j,T,M))return j;const H=new l().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,j.identifier.uuid),{extensions:J}=await this.z(H,{targetPlatform:M,compatible:!0,includePreRelease:T},L.CancellationToken.None);return J[0]||null}async isExtensionCompatible(j,T,M){if(!(0,k.$$n)(j.properties.targetPlatform,j.allTargetPlatforms,M)||!T&&j.properties.isPreReleaseVersion)return!1;let H=j.properties.engine;if(!H){const J=await this.getManifest(j,L.CancellationToken.None);if(!J)throw new Error("Manifest was not found");H=J.engines.vscode}return(0,c.$Uo)(H,this.u.version,this.u.date)}async y(j,T,M,H,J){if(!(0,k.$$n)(G(j),H,J)||T!=="any"&&K(j)!==(T==="prerelease"))return!1;if(M)try{const re=await this.E(j);if(!(0,c.$Uo)(re,this.u.version,this.u.date))return!1}catch(re){return this.l.error(`Error while getting the engine for the version ${j.version}.`,(0,N.$9)(re)),!1}return!0}async query(j,T){let M=j.text||"";const H=j.pageSize??50;let J=new l().withPage(1,H);M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(J=J.withFilter(t.Category,we||de),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(J=J.withFilter(t.Tag,we||de),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(t.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),J=J.withFilter(t.SearchText,M)),J=J.withSortBy(0)):j.ids?J=J.withFilter(t.ExtensionId,...j.ids):j.names?J=J.withFilter(t.ExtensionName,...j.names):J=J.withSortBy(4),typeof j.sortBy=="number"&&(J=J.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(J=J.withSortOrder(j.sortOrder)),j.source&&(J=J.withSource(j.source));const re=async($e,de)=>{const{extensions:we,total:ve}=await this.z($e,{targetPlatform:s,compatible:!1,includePreRelease:!!j.includePreRelease},de);return we.forEach((Ie,Le)=>ie(Ie,($e.pageNumber-1)*$e.pageSize+Le,j.source)),{extensions:we,total:ve}},{extensions:ce,total:ue}=await re(J,T),he=async($e,de)=>{if(de.isCancellationRequested)throw new N.$4;const{extensions:we}=await re(J.withPage($e+1),de);return we};return{firstPage:ce,total:ue,pageSize:J.pageSize,getPage:he}}async z(j,T,M){const H=j.flags;j.flags&n.IncludeLatestVersionOnly&&j.flags&n.IncludeVersions&&(j=j.withFlags(j.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(j.flags&n.IncludeLatestVersionOnly)&&!(j.flags&n.IncludeVersions)&&(j=j.withFlags(j.flags,n.IncludeLatestVersionOnly)),T.versions?.length&&(j=j.withFlags(j.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),j=j.withFlags(j.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:J,total:re,context:ce}=await this.B(j,M);if(!(j.flags&n.IncludeLatestVersionOnly)){const de=[];for(const we of J){const ve=await this.A(we,T,ce);ve&&de.push(ve)}return{extensions:de,total:re}}const he=[],$e=new Map;for(let de=0;de<J.length;de++){const we=J[de],ve={id:(0,b.$Ho)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Ie=(0,R.$Ef)(T.includePreRelease)?T.includePreRelease:!!T.includePreRelease.find(Te=>(0,b.$Co)(Te,ve))?.includePreRelease;if(T.compatible&&(0,k.$0n)(W(we),T.targetPlatform))continue;const Le=await this.A(we,T,ce);!Le||Le.properties.isPreReleaseVersion&&(!Ie||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==T.targetPlatform&&Le.hasPreReleaseVersion?$e.set(we.extensionId,de):he.push([de,Le])}if($e.size){const de=new E.$Jd,we=new l().withFlags(H&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,$e.size).withFilter(t.ExtensionId,...$e.keys()),{extensions:ve}=await this.z(we,T,M);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:$e.size});for(const Ie of ve){const Le=$e.get(Ie.identifier.uuid);he.push([Le,Ie])}}return{extensions:he.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:re}}async A(j,T,M){const H={id:(0,b.$Ho)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},J=T.versions?.find(he=>(0,b.$Co)(he,H))?.version,re=(0,R.$Ef)(T.includePreRelease)?T.includePreRelease:!!T.includePreRelease.find(he=>(0,b.$Co)(he,H))?.includePreRelease,ce=W(j),ue=ee(j.versions,T.targetPlatform);if(T.compatible&&(0,k.$0n)(ce,T.targetPlatform))return null;for(let he=0;he<ue.length;he++){const $e=ue[he];if(!(J&&$e.version!==J)){if(await this.y($e,re?"any":"release",T.compatible,ce,T.targetPlatform))return _(j,$e,ce,M);if(J&&$e.version===J)return null}}return J||T.compatible?null:_(j,j.versions[0],ce)}async B(j,T){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(n.Unpublished));const M=await this.j,H=JSON.stringify(j.raw),J={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},re=new E.$Jd;let ce,ue,he=0;try{if(ce=await this.k.request({type:"POST",url:this.g&&j.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:H,headers:J},T),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:he};const $e=await(0,h.$2o)(ce);if($e){const de=$e.results[0],we=de.extensions,ve=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return he=ve&&ve.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[o]:ce.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch($e){throw ue=$e,$e}finally{this.o.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(H.length),duration:re.elapsed(),success:!!ce&&(0,h.$Xo)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:ue?(0,N.$3)(ue)?"canceled":(0,N.$9)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(j,T,M,H){if(!this.isEnabled())return;const J=A.$p?this.x(`/itemName/${j}.${T}/version/${M}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${j}/extensions/${T}/${M}/stats?statType=${H}`),re=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:re};try{await this.k.request({type:"POST",url:J,headers:ue},L.CancellationToken.None)}catch{}}async download(j,T,M){this.l.trace("ExtensionGalleryService#download",j.identifier.id);const H=(0,b.$Ko)(j),J=new Date().getTime(),re=de=>this.o.publicLog("galleryService:downloadVSIX",{...H,duration:de}),ce=M===2?"install":M===3?"update":"",ue=ce?{uri:`${j.assets.download.uri}${S.URI.parse(j.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${j.assets.download.fallbackUri}${S.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:j.assets.download,he=j.queryContext?.[o]?{[o]:j.queryContext[o]}:void 0,$e=await this.D(ue,he?{headers:he}:void 0);await this.q.writeFile(T,$e.stream),re(new Date().getTime()-J)}async downloadSignatureArchive(j,T){if(!j.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",j.identifier.id);const M=await this.D(j.assets.signature);await this.q.writeFile(T,M.stream)}async getReadme(j,T){if(j.assets.readme){const M=await this.D(j.assets.readme,{},T);return await(0,h.$1o)(M)||""}return""}async getManifest(j,T){if(j.assets.manifest){const M=await this.D(j.assets.manifest,{},T),H=await(0,h.$1o)(M);return H?JSON.parse(H):null}return null}async C(j,T){const M=U(j,r.Manifest);if(!M)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},J=await this.D(M,{headers:H});return await(0,h.$2o)(J)}async getCoreTranslation(j,T){const M=j.assets.coreTranslations.filter(H=>H[0]===T.toUpperCase())[0];if(M){const H=await this.D(M[1]),J=await(0,h.$1o)(H);return J?JSON.parse(J):null}return null}async getChangelog(j,T){if(j.assets.changelog){const M=await this.D(j.assets.changelog,{},T);return await(0,h.$1o)(M)||""}return""}async getAllCompatibleVersions(j,T,M){let H=new l().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);j.identifier.uuid?H=H.withFilter(t.ExtensionId,j.identifier.uuid):H=H.withFilter(t.ExtensionName,j.identifier.id);const{galleryExtensions:J}=await this.B(H,L.CancellationToken.None);if(!J.length)return[];const re=W(J[0]);if((0,k.$0n)(re,M))return[];const ce=[];await Promise.all(J[0].versions.map(async $e=>{try{await this.y($e,T?"any":"release",!0,re,M)&&ce.push($e)}catch{}}));const ue=[],he=new Set;for(const $e of ee(ce,M))he.has($e.version)||(he.add($e.version),ue.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:K($e)}));return ue}async D(j,T={},M=L.CancellationToken.None){const H=await this.j,J={type:"GET"},re={...H,...T.headers||{}};T={...T,...J,headers:re};const ce=j.uri,ue=j.fallbackUri,he={...T,url:ce};try{const $e=await this.k.request(he,M);if($e.res.statusCode===200)return $e;const de=await(0,h.$1o)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${de}`)}catch($e){if((0,N.$3)($e))throw $e;const de=(0,N.$9)($e);this.o.publicLog2("galleryService:cdnFallback",{url:ce,message:de});const we={...T,url:ue};return this.k.request(we,M)}}async E(j){let T=Y(j);if(!T){const M=await this.C(j,L.CancellationToken.None);if(!M)throw new Error("Manifest was not found");T=M.engines.vscode}return T}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const j=await this.k.request({type:"GET",url:this.h},L.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const T=await(0,h.$2o)(j),M=[],H={},J=[];if(T){for(const re of T.malicious)M.push({id:re});if(T.migrateToPreRelease)for(const[re,ce]of Object.entries(T.migrateToPreRelease))(!ce.engine||(0,c.$Uo)(ce.engine,this.u.version,this.u.date))&&(H[re.toLowerCase()]={disallowInstall:!0,extension:{id:ce.id,displayName:ce.displayName,autoMigrate:{storage:!!ce.migrateStorage},preRelease:!0}});if(T.deprecated)for(const[re,ce]of Object.entries(T.deprecated))ce&&(H[re.toLowerCase()]=(0,R.$Ef)(ce)?{}:ce);if(T.search)for(const re of T.search)J.push(re)}return{malicious:M,deprecated:H,search:J}}};ne=pe([X(1,h.$Vo),X(2,y.$0i),X(3,C.$Wh),X(4,d.$cl),X(5,$.$$j),X(6,p.$pj),X(7,g.$ji)],ne);let Z=class extends ne{constructor(j,T,M,H,J,re,ce,ue){super(j,T,M,H,J,re,ce,ue)}};e.$fp=Z,e.$fp=Z=pe([X(0,u.$9o),X(1,h.$Vo),X(2,y.$0i),X(3,C.$Wh),X(4,d.$cl),X(5,$.$$j),X(6,p.$pj),X(7,g.$ji)],Z);let q=class extends ne{constructor(j,T,M,H,J,re,ce){super(void 0,j,T,M,H,J,re,ce)}};e.$gp=q,e.$gp=q=pe([X(0,h.$Vo),X(1,y.$0i),X(2,C.$Wh),X(3,d.$cl),X(4,$.$$j),X(5,p.$pj),X(6,g.$ji)],q)}),define(oe[81],ae([0,1,4,3,2,21,33,25,18,8,12]),function(te,e,D,L,N,A,I,R,S,g,C){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$1u=e.$Zu=void 0,e.$Zu=(0,D.$Ph)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let c=class extends N.$Rc{static{k=this}static{this.a=512*1024}static b(y){return`extensionKeys/${(0,I.$Go)(y.id)}@${y.version}`}static c(y){const p=b.exec(y);if(p&&p[1])return{id:p[1],version:p[2]}}static async removeOutdatedExtensionVersions(y,p){const h=await y.getInstalled(),f=[];for(const[u,d]of k.f(p)){const E=h.find(s=>(0,I.$Co)(s.identifier,{id:u}))?.manifest.version;for(const s of d)E!==s&&f.push(k.b({id:u,version:s}))}for(const u of f)p.remove(u,0)}static f(y){const p=new Map,h=y.keys(0,1);for(const f of h){const u=k.c(f);if(u){let d=p.get(u.id.toLowerCase());d||p.set(u.id.toLowerCase(),d=[]),d.push(u.version)}}return p}constructor(y,p,h){super(),this.j=y,this.m=p,this.n=h,this.g=this.B(new L.$Nd),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=k.f(y),this.B(this.j.onDidChangeValue(0,void 0,this.B(new N.$Qc))(f=>this.r(f)))}r(y){if(this.h.has(y.key.toLowerCase())){this.g.fire();return}const p=k.c(y.key);if(p){if(this.j.get(y.key,0)===void 0)this.h.delete(p.id.toLowerCase());else{let h=this.h.get(p.id.toLowerCase());h||this.h.set(p.id.toLowerCase(),h=[]),h.push(p.version),this.g.fire()}return}}s(y){if((0,C.$yf)(y))return y;const p=y.manifest?y.manifest.publisher:y.publisher,h=y.manifest?y.manifest.name:y.name;return(0,I.$Fo)(p,h)}getExtensionState(y,p){const h=this.s(y),f=this.getExtensionStateRaw(y,p);if(f)try{return JSON.parse(f)}catch(u){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${p}): ${u}`)}}getExtensionStateRaw(y,p){const h=this.s(y),f=this.j.get(h,p?0:1);return f&&f?.length>k.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${p}): ${f.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),f}setExtensionState(y,p,h){const f=this.s(y);p===void 0?this.j.remove(f,h?0:1):this.j.store(f,JSON.stringify(p),h?0:1,1)}setKeysForSync(y,p){this.j.store(k.b(y),JSON.stringify(p),0,1)}getKeysForSync(y){const p=this.m.extensionSyncedKeys?.[y.id.toLowerCase()],h=this.j.get(k.b(y),0),f=h?JSON.parse(h):void 0;return f&&p?(0,S.$Lb)([...f,...p]):f||p}addToMigrationList(y,p){if(y!==p){const h=this.t.filter(f=>!f.includes(y)&&!f.includes(p));h.push([y,p]),this.t=h}}getSourceExtensionToMigrate(y){const p=this.t.find(([,h])=>y===h);return p?p[0]:void 0}get t(){const y=this.j.get("extensionStorage.migrationList",-1,"[]");try{const p=JSON.parse(y);if(Array.isArray(p))return p}catch{}return[]}set t(y){y.length?this.j.store("extensionStorage.migrationList",JSON.stringify(y),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$1u=c,e.$1u=c=k=pe([X(0,A.$9o),X(1,R.$pj),X(2,g.$0i)],c)}),define(oe[246],ae([0,1,29,11,25,14,98,55,21,22,220]),function(te,e,D,L,N,A,I,R,S,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O9b=void 0;let k=class extends C.$15b{constructor(c,$,y,p,h,f,u,d){super(c.userHome,h,$,y,p,f,u,d)}};e.$O9b=k,e.$O9b=k=pe([X(0,A.$Xh),X(1,g.$cl),X(2,D.$co),X(3,S.$9o),X(4,R.$E7b),X(5,I.$dWb),X(6,L.$$j),X(7,N.$pj)],k)}),define(oe[247],ae([0,1,105,3,22,14,2,8,16,65,25,5,6,101,20,164,36,21,12,131,19]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K9b=void 0;const E=[D.$D9b,D.$E9b],s="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends I.$Rc{constructor(a,v,w,l,m,O,F){super(),this.y=a,this.z=v,this.C=w,this.D=O,this.F=F,this.f=new L.$Nd,this.onDidTokenFailed=this.f.event,this.g=new L.$Nd,this.onDidChangeTunnelStatus=this.g.event,this.h=new L.$Nd,this.onDidChangeMode=this.h.event,this.n=D.$B9b,this.w=!1,this.I=(z,U)=>{U?this.j.error(z):this.j.info(z)},this.j=this.B(l.createLogger((0,d.$vg)(w.logsHome,`${D.$F9b}.log`),{id:D.$F9b,name:D.$G9b})),this.t=new b.$Qg(100),this.B(this.j.onDidChangeLogLevel(z=>this.j.info("Log level changed to "+(0,R.$mj)(z)))),this.B(m.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(O.onDidChangeConfiguration(z=>{E.some(U=>z.affectsConfiguration(U))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=D.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let a;k.$k?a=this.C.appRoot:a=(0,S.$lc)((0,S.$lc)(this.C.appRoot)),this.u=(0,S.$ic)(a,"bin",`${this.z.tunnelApplicationName}${k.$j?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const a=this.n.asService;this.H(D.$B9b);try{a&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(D.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",v=!1;const w=(U,B)=>{B?this.j.error(U):a+=U,!this.C.isBuilt&&U.startsWith("   Compiling")&&this.G(D.TunnelStates.connecting((0,y.localize)(0,null)))},l=this.O("status",["status"],w);this.r=l;try{if(await l,this.r!==l)return;const U=JSON.parse(a.trim().split(`
`).find(B=>B.startsWith("{")));if(v=U.service_installed,this.j.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this.n.active){this.G(D.TunnelStates.disconnected());return}}catch(U){this.j.error(U),this.G(D.TunnelStates.disconnected());return}finally{this.r===l&&(this.r=void 0)}const m=this.n.active?this.n.session:void 0;if(m&&m.token){const U=m.token;this.G(D.TunnelStates.connecting((0,y.localize)(1,null,m.accountLabel,m.providerId)));const B=(K,x)=>{K=K.replaceAll(U,"*".repeat(4)),w(K,x)},Y=this.O("login",["user","login","--provider",m.providerId,"--access-token",U,"--log",(0,R.$mj)(this.j.getLevel())],B);this.r=Y;try{if(await Y,this.r!==Y)return}catch(K){this.j.error(K),this.r=void 0,this.f.fire(m),this.G(D.TunnelStates.disconnected(m));return}}const O=this.Q();O?this.G(D.TunnelStates.connecting((0,y.localize)(2,null,O))):this.G(D.TunnelStates.connecting((0,y.localize)(3,null)));const F=["--accept-server-license-terms","--log",(0,R.$mj)(this.j.getLevel())];O?F.push("--name",O):F.push("--random-name");let z=!1;return this.n.active&&this.n.asService&&!v&&(z=await this.M(F)===!1),this.N(m,F,z)}async M(a){let v;try{v=await this.O("serviceInstall",["service","install",...a])}catch(w){this.j.error(w),v=1}if(v!==0){const w=(0,y.localize)(4,null);return this.j.warn(w),this.G(D.TunnelStates.connecting(w)),!1}return!0}async N(a,v,w){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let l=!1;const m=this.O("tunnel",v,(O,F)=>{F?this.j.error(O):this.j.info(O),O.includes("Connected to an existing tunnel process")&&(l=!0);const z=O.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(z){const U={link:z[1],domain:z[2],tunnelName:z[4],isAttached:l};this.G(D.TunnelStates.connected(U,w))}else O.match(/error refreshing token/)&&(m.cancel(),this.f.fire(a),this.G(D.TunnelStates.disconnected(a)))});this.r=m,m.finally(()=>{m===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=D.$B9b,this.G(D.TunnelStates.disconnected()))})}O(a,v,w=this.I){return(0,b.$Hg)(l=>new Promise((m,O)=>{l.isCancellationRequested&&m(-1);let F;const z=["ignore","pipe","pipe"];if(l.onCancellationRequested(()=>{F&&(this.j.info(`${a} terminating(${F.pid})`),F.kill())}),!this.C.isBuilt)w(`Building tunnel CLI from sources and run
`,!1),w(`${a} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),F=(0,g.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,S.$ic)(this.C.appRoot,"cli"),stdio:z});else{w(`Running tunnel CLI
`,!1);const U=this.J();w(`${a} Spawning: ${U} tunnel ${v.join(" ")}
`,!1),F=(0,g.spawn)(U,["tunnel",...v],{cwd:(0,p.homedir)(),stdio:z})}F.stdout.pipe(new u.$uT(`
`)).on("data",U=>{if(F){const B=U.toString();w(B,!1)}}),F.stderr.pipe(new u.$uT(`
`)).on("data",U=>{if(F){const B=U.toString();w(B,!0)}}),F.on("exit",U=>{F&&(w(`${a} exit(${F.pid}): + ${U} `,!1),F=void 0,m(U||0))}),F.on("error",U=>{F&&(w(`${a} error(${F.pid}): + ${U} `,!0),F=void 0,O())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(D.$E9b)}Q(){let a=this.D.getValue(D.$D9b)||(0,p.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(s,-1),v=this.F.getBoolean(o,-1,!1);if(a){const w=JSON.parse(a);if(w&&(0,f.$yf)(w.accountLabel)&&(0,f.$yf)(w.sessionId)&&(0,f.$yf)(w.providerId))return{active:!0,session:w,asService:v};this.j.error("Problems restoring session from storage, invalid format",w)}}catch(a){this.j.error("Problems restoring session from storage",a)}return D.$B9b}S(a){if(a.active){const v={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(s,JSON.stringify(v),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(s,-1),this.F.remove(o,-1)}};e.$K9b=n,e.$K9b=n=pe([X(0,N.$cl),X(1,C.$pj),X(2,A.$Xh),X(3,R.$$i),X(4,c.$I9b),X(5,$.$ji),X(6,h.$9o)],n);function i(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&i(r.session,a.session):!0}),define(oe[248],ae([0,1,6,2,23,19,67,21,76,17]),function(te,e,D,L,N,A,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P9b=void 0;class C extends R.$$o{constructor(b,c,$,y){super(),this.bb=b,this.cb=c,this.db=$,this.eb=y,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new L.$Qc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new L.$Qc),this.ab=this.hb(this.bb)}fb(){const b=this.B(new S.$BDb(this.db.getChannel("storage"))),c=this.B(new I.$5o(b));return this.B(c.onDidChangeStorage($=>this.u(-1,$))),c}gb(b){this.X.clear(),this.W=b;let c;if((0,R.$_o)(b))c=this.U;else{const $=this.X.add(new S.$CDb(this.db.getChannel("storage"),b));c=this.X.add(new I.$5o($))}return this.X.add(c.onDidChangeStorage($=>this.u(0,$))),c}hb(b){this.$.clear(),this.Z=b?.id;let c;if(b){const $=this.$.add(new S.$DDb(this.db.getChannel("storage"),b));c=this.$.add(new I.$5o($)),this.$.add(c.onDidChangeStorage(y=>this.u(1,y)))}return c}async O(){await D.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(b){switch(b){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(b){switch(b){case-1:return this.s.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$vg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:N.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(b){if(!this.M(this.W,b))return;const c=this.Y,$=c.items;c!==this.U&&await c.close(),this.Y=this.gb(b),await this.Y.init(),this.N($,this.Y,0)}async S(b,c){const $=this.ab,y=$?.items??new Map;await $?.close(),this.ab=this.hb(b),await this.ab.init(),this.N(y,this.ab,1)}hasScope(b){return(0,g.$Jk)(b)?this.W.id===b.id:this.Z===b.id}}e.$P9b=C}),define(oe[249],ae([0,1,3,2,17,92]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=e.$TN=void 0;class I{constructor(g,C){this.a=g,this.b=C}listen(g,C){const k=this.b(g);switch(C){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,b=>({all:b.all.map(c=>(0,A.$Nm)({...c},k)),added:b.added.map(c=>(0,A.$Nm)({...c},k)),removed:b.removed.map(c=>(0,A.$Nm)({...c},k)),updated:b.updated.map(c=>(0,A.$Nm)({...c},k))}))}throw new Error(`Invalid listen ${C}`)}async call(g,C,k){const b=this.b(g);switch(C){case"createProfile":{const c=await this.a.createProfile(k[0],k[1],k[2]);return(0,A.$Nm)({...c},b)}case"updateProfile":{let c=(0,N.$Lk)((0,A.$Om)(k[0],b),this.a.profilesHome.scheme);return c=await this.a.updateProfile(c,k[1]),(0,A.$Nm)({...c},b)}case"removeProfile":{const c=(0,N.$Lk)((0,A.$Om)(k[0],b),this.a.profilesHome.scheme);return this.a.removeProfile(c)}}throw new Error(`Invalid call ${C}`)}}e.$TN=I;class R extends L.$Rc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,C,k){super(),this.profilesHome=C,this.f=k,this.a=[],this.b=this.B(new D.$Nd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(b=>(0,N.$Lk)(b,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(b=>{const c=b.added.map(p=>(0,N.$Lk)(p,this.profilesHome.scheme)),$=b.removed.map(p=>(0,N.$Lk)(p,this.profilesHome.scheme)),y=b.updated.map(p=>(0,N.$Lk)(p,this.profilesHome.scheme));this.a=b.all.map(p=>(0,N.$Lk)(p,this.profilesHome.scheme)),this.b.fire({added:c,removed:$,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,C,k){const b=await this.f.call("createNamedProfile",[g,C,k]);return(0,N.$Lk)(b,this.profilesHome.scheme)}async createProfile(g,C,k,b){const c=await this.f.call("createProfile",[g,C,k,b]);return(0,N.$Lk)(c,this.profilesHome.scheme)}async createTransientProfile(g){const C=await this.f.call("createTransientProfile",[g]);return(0,N.$Lk)(C,this.profilesHome.scheme)}async setProfileForWorkspace(g,C){await this.f.call("setProfileForWorkspace",[g,C])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,C){const k=await this.f.call("updateProfile",[g,C]);return(0,N.$Lk)(k,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$UN=R}),define(oe[58],ae([0,1,2,67,4,21,3,76,17]),function(te,e,D,L,N,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HDb=e.$GDb=e.$FDb=void 0,e.$FDb=(0,N.$Ph)("IUserDataProfileStorageService");let g=class extends D.$Rc{constructor(c){super(),this.a=c}async readStorageData(c){return this.withProfileScopedStorageService(c,async $=>this.b($))}async updateStorageData(c,$,y){return this.withProfileScopedStorageService(c,async p=>this.c(p,$,y))}async withProfileScopedStorageService(c,$){if(this.a.hasScope(c))return $(this.a);const y=await this.g(c),p=new k(y);try{await p.initialize();const h=await $(p);return await p.flush(),h}finally{p.dispose(),await this.f(y)}}b(c){const $=new Map,y=p=>{for(const h of c.keys(0,p))$.set(h,{value:c.get(h,0),target:p})};return y(0),y(1),$}c(c,$,y){c.storeAll(Array.from($.entries()).map(([p,h])=>({key:p,value:h,scope:0,target:y})),!0)}async f(c){try{await c.close()}finally{(0,D.$Lc)(c)&&c.dispose()}}};e.$GDb=g,e.$GDb=g=pe([X(0,A.$9o)],g);class C extends g{constructor(c,$,y,p){super(y),this.j=c;const h=c.getChannel("profileStorageListener"),f=this.B(new D.$Sc);this.h=this.B(new I.$Nd({onWillAddFirstListener:()=>{f.value=h.listen("onDidChange")(u=>{p.trace("profile storage changes",u),this.h.fire({targetChanges:u.targetChanges.map(d=>(0,S.$Lk)(d,$.profilesHome.scheme)),valueChanges:u.valueChanges.map(d=>({...d,profile:(0,S.$Lk)(d.profile,$.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>f.value=void 0})),this.onDidChange=this.h.event}async g(c){const $=this.j.getChannel("storage");return(0,A.$_o)(c)?new R.$BDb($):new R.$CDb($,c)}}e.$HDb=C;class k extends A.$$o{constructor(c){super({flushInterval:100}),this.s=this.B(new L.$5o(c))}O(){return this.s.init()}P(c){return c===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(oe[250],ae([0,1,21,8,17,72,58]),function(te,e,D,L,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u9b=void 0;let R=class extends I.$HDb{constructor(g,C,k,b){super(g,C,k,b)}};e.$u9b=R,e.$u9b=R=pe([X(0,A.$S8b),X(1,N.$Kk),X(2,D.$9o),X(3,L.$0i)],R)}),define(oe[39],ae([0,1,18,6,15,26,3,35,2,27,12,169,20,14,11,8,43,21,22,28,24,17]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f,u,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zEb=e.$yEb=e.$xEb=e.$wEb=e.$vEb=e.$uEb=e.$tEb=void 0;function s(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||o(v.syncData)))}e.$tEb=s;function o(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$uEb=o;function n(v,w){return`${(0,g.$qf)(v)}${w.isDefault?"":` (${w.name})`}`}e.$vEb=n;let i=class extends S.$Rc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(w,l,m,O,F,z,U,B,Y,K,x,V){super(),this.syncResource=w,this.collection=l,this.G=m,this.H=O,this.I=F,this.J=z,this.L=U,this.M=B,this.N=Y,this.O=K,this.P=x,this.c=null,this.m="idle",this.n=this.B(new I.$Nd),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new I.$Nd),this.onDidChangeConflicts=this.t.event,this.u=this.B(new L.$Rg(50)),this.w=this.B(new I.$Nd),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(w.syncResource,w.profile),this.h=V.extUri,this.f=this.h.joinPath(O.userDataSyncHome,...(0,d.$Wgb)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.g=this.h.joinPath(this.f,d.$fhb),this.y=(0,d.$Xgb)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,O,this.h),this.j=(0,p.$cp)(O,m,F)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const w=await this.c;this.c=null;const l=await this.Y(w.remoteUserData,w.lastSyncUserData,!0,this.ob());this.S(l)}else{this.O.trace(`${this.D}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.ub(w):!0)&&this.w.fire()}}S(w){this.m!==w&&(this.m=w,this.n.fire(w))}async sync(w,l={}){await this.U(w,!0,this.ob(),l)}async preview(w,l,m={}){return this.U(w,!1,l,m)}async apply(w,l={}){try{this.F={...l};const m=await this.ab(w);return this.S(m),this.c}finally{this.F={}}}async U(w,l,m,O){try{if(this.F={...O},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let F="idle";try{const z=await this.getLastSyncUserData(),U=await this.X(w,z);return F=await this.Y(U,z,l,m),F==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(F)}}finally{this.F={}}}async replace(w){const l=this.kb(w);if(!l)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const m=await this.getLastSyncUserData(),O=await this.X(null,m),F=await this.W(O),z=await this.qb({ref:O.ref,syncData:l},m,F,this.ob(),A.CancellationToken.None),U=[];for(const B of z){const Y=await this.sb(B,B.remoteResource,void 0,A.CancellationToken.None),{remoteChange:K}=await this.sb(B,B.previewResource,B.remoteContent,A.CancellationToken.None);U.push([B,{...Y,remoteChange:K!==0?K:2}])}await this.tb(O,m,U,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(w){const l=await this.j;return!!w.syncData?.machineId&&w.syncData.machineId===l}async X(w,l){if(l){const m=w?w[this.resource]:void 0;if(l.ref===m||m===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async Y(w,l,m,O){if(w.syncData&&w.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new d.$5gb((0,k.localize)(0,null,this.resource,this.pb,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(w,l,m,O)}catch(F){if(F instanceof d.$5gb)switch(F.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(w,l,m,O);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.Y(w,l,m,O)}throw F}}async Z(w,l,m,O){try{const F=await this.W(w),z=!F&&l===null&&this.gb()!==void 0,U=m&&!z;this.c||(this.c=(0,L.$Hg)(Y=>this.eb(w,l,F,U,O,Y)));let B=await this.c;if(m&&z){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of B.resourcePreviews)B=await this.accept(Y.remoteResource)||B}return this.cb(B.resourcePreviews),B.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":m?await this.ab(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(w){return await this.$(w,async l=>{const m=await this.rb(l,A.CancellationToken.None);await this.G.writeFile(l.previewResource,N.$be.fromString(m?.content||""));const O=m&&!m.hasConflicts?await this.sb(l,l.previewResource,void 0,A.CancellationToken.None):void 0;return l.acceptResult=O,l.mergeState=m.hasConflicts?"conflict":O?"accepted":"preview",l.localChange=O?O.localChange:m.localChange,l.remoteChange=O?O.remoteChange:m.remoteChange,l}),this.c}async accept(w,l){return await this.$(w,async m=>{const O=await this.sb(m,w,l,A.CancellationToken.None);return m.acceptResult=O,m.mergeState="accepted",m.localChange=O.localChange,m.remoteChange=O.remoteChange,m}),this.c}async discard(w){return await this.$(w,async l=>{const m=await this.rb(l,A.CancellationToken.None);return await this.G.writeFile(l.previewResource,N.$be.fromString(m.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=m.localChange,l.remoteChange=m.remoteChange,l}),this.c}async $(w,l){if(!this.c)return;let m=await this.c;const O=m.resourcePreviews.findIndex(({localResource:F,remoteResource:z,previewResource:U})=>this.h.isEqual(F,w)||this.h.isEqual(z,w)||this.h.isEqual(U,w));O!==-1&&(this.c=(0,L.$Hg)(async F=>{const z=[...m.resourcePreviews];return z[O]=await l(z[O]),{...m,resourcePreviews:z}}),m=await this.c,this.cb(m.resourcePreviews),m.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(w){if(!this.c)return"idle";const l=await this.c;return l.resourcePreviews.some(({mergeState:m})=>m==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:m})=>m!=="accepted")?"syncing":(await this.tb(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(m=>[m,m.acceptResult]),w),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(w){const l=w.filter(({mergeState:m})=>m==="conflict");(0,D.$tb)(this.s,l,(m,O)=>this.h.isEqual(m.previewResource,O.previewResource))||(this.s=l,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async db(w){const l=this.c?await this.c:null;if(l)for(const m of l.resourcePreviews){if(this.h.isEqual(m.acceptedResource,w))return m.acceptResult?m.acceptResult.content:null;if(this.h.isEqual(m.remoteResource,w))return m.remoteContent;if(this.h.isEqual(m.localResource,w))return m.localContent;if(this.h.isEqual(m.baseResource,w))return m.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(w){(0,$.$pk)(w)!==1&&this.O.error(w)}}async eb(w,l,m,O,F,z){const U=await this.qb(w,l,m,F,z),B=[];for(const Y of U){const K=Y.previewResource.with({scheme:d.$ehb,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)B.push({...Y,acceptedResource:K,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=O?await this.rb(Y,z):void 0;if(z.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,N.$be.fromString(x?.content||""));const V=x&&!x.hasConflicts?await this.sb(Y,Y.previewResource,void 0,z):void 0;B.push({...Y,acceptResult:V,mergeState:x?.hasConflicts?"conflict":V?"accepted":"preview",localChange:V?V.localChange:x?x.localChange:Y.localChange,remoteChange:V?V.remoteChange:x?x.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:l,resourcePreviews:B,isLastSyncFromCurrentMachine:m}}async getLastSyncUserData(){let w=this.gb();if(w||(w=await this.jb()),!w)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const l=JSON.parse(w),m=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!l.version&&!!m&&l.version!==m,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${m}.`),await this.resetLocal(),null;let O,F=1;for(;O===void 0&&F++<6;)try{const z=await this.hb();z&&(z.ref===l.ref?O=z.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(z){if(z instanceof $.$tk&&z.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(z instanceof d.$5gb)throw z;this.O.error(z,F)}}if(O===void 0)try{const z=await this.J.resolveResourceContent(this.resource,l.ref,this.collection,this.F);O=z===null?null:this.kb(z),await this.ib({ref:l.ref,syncData:O})}catch(z){if(z instanceof d.$5gb&&z.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw z}return O===void 0?null:{...l,syncData:O}}async fb(w,l={}){if(l.ref||l.version)throw new Error("Cannot have core properties as additional");const m=this.M.getResourceSyncStateVersion(this.resource),O={ref:w.ref,version:m,...l};this.I.store(this.z,JSON.stringify(O),-1,1),await this.ib(w)}gb(){return this.I.get(this.z,-1)}async hb(){const w=(await this.G.readFile(this.y)).value.toString();try{const l=w?JSON.parse(w):void 0;if(s(l))return l}catch(l){this.O.error(l)}}async ib(w){await this.G.writeFile(this.y,N.$be.fromString(JSON.stringify(w)))}async jb(){try{const w=await this.G.readFile(this.y),l=JSON.parse(w.value.toString());await this.G.del(this.y),l.ref&&l.content!==void 0?(this.I.store(this.z,JSON.stringify({...l,content:void 0}),-1,1),await this.ib({ref:l.ref,syncData:l.content===null?null:JSON.parse(l.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,l)}catch(w){w instanceof $.$tk&&w.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(w)}return this.I.get(this.z,-1)}async getRemoteUserData(w){const{ref:l,content:m}=await this.lb(w);let O=null;return m!==null&&(O=this.kb(m)),{ref:l,syncData:O}}kb(w){try{const l=JSON.parse(w);if(o(l))return l}catch(l){this.O.error(l)}throw new d.$5gb((0,k.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(w){const l=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.J.readResource(this.resource,l,this.collection,this.F)}async mb(w,l){const m=await this.j,O={version:this.pb,machineId:m,content:w};try{return l=await this.J.writeResource(this.resource,JSON.stringify(O),l,this.collection,this.F),{ref:l,syncData:O}}catch(F){throw F instanceof d.$5gb&&F.code==="TooLarge"&&(F=new d.$5gb(F.message,F.code,this.resource)),F}}async nb(w){const l={version:this.pb,content:w};return this.L.writeResource(this.resource,JSON.stringify(l),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(d.$Rgb)}};e.$wEb=i,e.$wEb=i=pe([X(2,$.$$j),X(3,c.$Wh),X(4,h.$9o),X(5,d.$Zgb),X(6,d.$1gb),X(7,d.$0gb),X(8,f.$cl),X(9,d.$chb),X(10,b.$ji),X(11,u.$Ik)],i);let t=class extends i{constructor(w,l,m,O,F,z,U,B,Y,K,x,V,Q){super(l,m,O,F,z,U,B,Y,K,x,V,Q),this.r=w,this.B(this.G.watch(this.h.dirname(w))),this.B(this.G.onDidFilesChange(G=>this.yb(G)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(w,l,m){try{l?await this.G.writeFile(this.r,N.$be.fromString(w),m?void 0:l):await this.G.createFile(this.r,N.$be.fromString(w),{overwrite:m})}catch(O){throw O instanceof $.$tk&&O.fileOperationResult===1||O instanceof $.$tk&&O.fileOperationResult===3?new d.$5gb(O.message,"LocalPreconditionFailed"):O}}async xb(){try{await this.G.del(this.r)}catch(w){if(!(w instanceof $.$tk&&w.fileOperationResult===1))throw w}}yb(w){w.contains(this.r)&&this.Q()}};e.$xEb=t,e.$xEb=t=pe([X(3,$.$$j),X(4,c.$Wh),X(5,h.$9o),X(6,d.$Zgb),X(7,d.$1gb),X(8,d.$0gb),X(9,f.$cl),X(10,d.$chb),X(11,b.$ji),X(12,u.$Ik)],t);let r=class extends t{constructor(w,l,m,O,F,z,U,B,Y,K,x,V,Q,G){super(w,l,m,O,F,z,U,B,Y,K,x,Q,G),this.zb=V,this.Bb=void 0}Ab(w,l){const m=[],O=(0,R.$Wm)(w,m,{allowEmptyContent:!0,allowTrailingComma:!0});return m.length>0||!(0,C.$Ff)(O)&&l!==Array.isArray(O)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$yEb=r,e.$yEb=r=pe([X(3,$.$$j),X(4,c.$Wh),X(5,h.$9o),X(6,d.$Zgb),X(7,d.$1gb),X(8,d.$0gb),X(9,f.$cl),X(10,d.$chb),X(11,d.$bhb),X(12,b.$ji),X(13,u.$Ik)],r);let a=class{constructor(w,l,m,O,F,z,U){this.resource=w,this.g=l,this.h=m,this.j=O,this.k=F,this.l=z,this.d=U.extUri,this.f=(0,d.$Xgb)(void 0,this.resource,m,this.d)}async initialize({ref:w,content:l}){if(!l){this.j.info("Remote content does not exist.",this.resource);return}const m=this.m(l);if(m)try{await this.o({ref:w,syncData:m})}catch(O){this.j.error(O)}}m(w){try{const l=JSON.parse(w);if(o(l))return l}catch(l){this.j.error(l)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(w,l={}){if(l.ref||l.version)throw new Error("Cannot have core properties as additional");const m={ref:w.ref,version:void 0,...l};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(m),-1,1),await this.k.writeFile(this.f,N.$be.fromString(JSON.stringify(w)))}};e.$zEb=a,e.$zEb=a=pe([X(1,E.$Kk),X(2,c.$Wh),X(3,y.$0i),X(4,$.$$j),X(5,h.$9o),X(6,u.$Ik)],a)}),define(oe[114],ae([0,1,6,26,7,3,41,2,27,20,14,113,29,33,81,44,11,4,71,8,21,22,28,17,39,231,111,24,58]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f,u,d,E,s,o,n,i,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b4b=e.$a4b=e.$_3b=e.$$3b=e.$03b=void 0;async function v(z,U){const B=JSON.parse(z.content);if(z.version===1||z.version===2){const Y=(await U.getInstalled(0)).filter(K=>K.isBuiltin);for(const K of B)z.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),z.version===2&&Y.every(x=>!(0,c.$Co)(x.identifier,K.identifier))&&(K.installed=!0)}return B}function w(z){return JSON.parse(z.content)}e.$03b=w;function l(z,U){return z.sort((B,Y)=>!B.identifier.uuid&&Y.identifier.uuid?-1:B.identifier.uuid&&!Y.identifier.uuid?1:(0,S.$Ue)(B.identifier.id,Y.identifier.id)),U?(0,I.$cT)(z,{}):JSON.stringify(z)}e.$$3b=l;let m=class extends n.$wEb{constructor(U,B,Y,K,x,V,Q,G,W,ee,ie,_,ne,Z,q,P,j){super({syncResource:"extensions",profile:U},B,K,Y,x,V,Q,_,ne,ee,ie,q),this.Cb=G,this.Db=W,this.Eb=j,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$ehb,authority:"base"}),this.yb=this.wb.with({scheme:r.$ehb,authority:"local"}),this.zb=this.wb.with({scheme:r.$ehb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$ehb,authority:"accepted"}),this.Bb=this.Eb.createInstance(O),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,T=>T.some(({local:M})=>!!M)),A.Event.filter(this.Cb.onDidUninstallExtension,T=>!T.error),A.Event.filter(P.onDidChange,T=>T.valueChanges.some(({profile:M,changes:H})=>this.syncResource.profile.id===M.id&&H.some(J=>J.key===b.$do))),Z.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(U,B){const Y=U.syncData?await v(U.syncData,this.Cb):null,K=B?.skippedExtensions??[],x=B?.builtinExtensions??null,V=B?.syncData?await v(B.syncData,this.Cb):null,{localExtensions:Q,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:ee}=(0,i.$93b)(Q,Y,V,K,G,x),ie={local:W,remote:ee,content:this.Hb(Q,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:ee!==null?2:0},_=this.Ob(Q,!1);return[{skippedExtensions:K,builtinExtensions:x,baseResource:this.xb,baseContent:V?this.Ob(V,!1):_,localResource:this.yb,localContent:_,localExtensions:Q,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.Ab}]}async ub(U){const B=U.syncData?await v(U.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:K}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$93b)(Y,B,B,U.skippedExtensions||[],K,U.builtinExtensions||[]);return x!==null}Hb(U,B,Y,K){const x=[...B,...Y],V=new Set,Q=G=>{V.add(G.id.toLowerCase()),G.uuid&&V.add(G.uuid)};x.forEach(({identifier:G})=>Q(G)),K.forEach(Q);for(const G of U)V.has(G.identifier.id.toLowerCase())||G.identifier.uuid&&V.has(G.identifier.uuid)||x.push(G);return this.Ob(x,!1)}async rb(U,B){return{...U.previewResult,hasConflicts:!1}}async sb(U,B,Y,K){if(this.h.isEqual(B,this.yb))return this.Kb(U);if(this.h.isEqual(B,this.zb))return this.Lb(U);if(this.h.isEqual(B,this.wb))return U.previewResult;throw new Error(`Invalid Resource: ${B.toString()}`)}async Kb(U){const B=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(B),K=(0,i.$93b)(U.localExtensions,null,null,U.skippedExtensions,Y,U.builtinExtensions),{local:x,remote:V}=K;return{content:U.localContent,local:x,remote:V,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:V!==null?2:0}}async Lb(U){const B=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(B),K=U.remoteContent?JSON.parse(U.remoteContent):null;if(K!==null){const x=(0,i.$93b)(U.localExtensions,K,U.localExtensions,[],Y,U.builtinExtensions),{local:V,remote:Q}=x;return{content:U.remoteContent,local:V,remote:Q,localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:Q!==null?2:0}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(U,B,Y,K){let{skippedExtensions:x,builtinExtensions:V,localExtensions:Q}=Y[0][0];const{local:G,remote:W,localChange:ee,remoteChange:ie}=Y[0][1];if(ee===0&&ie===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==0&&(await this.nb(JSON.stringify(Q)),x=await this.Bb.updateLocalExtensions(G.added,G.removed,G.updated,x,this.syncResource.profile)),W){this.O.trace(`${this.D}: Updating remote extensions...`);const _=JSON.stringify(W.all);U=await this.mb(_,K?null:U.ref),this.O.info(`${this.D}: Updated remote extensions.${W.added.length?` Added: ${JSON.stringify(W.added.map(ne=>ne.identifier.id))}.`:""}${W.updated.length?` Updated: ${JSON.stringify(W.updated.map(ne=>ne.identifier.id))}.`:""}${W.removed.length?` Removed: ${JSON.stringify(W.removed.map(ne=>ne.identifier.id))}.`:""}`)}B?.ref!==U.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),V=this.Nb(Q,V),await this.fb(U,{skippedExtensions:x,builtinExtensions:V}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`))}Nb(U,B){const Y=new Set,K=[];for(const x of U)Y.add(x.identifier.id.toLowerCase()),x.installed||K.push(x.identifier);if(B)for(const x of B)Y.has(x.id.toLowerCase())||K.push(x);return K}async resolveContent(U){if(this.h.isEqual(this.zb,U)||this.h.isEqual(this.xb,U)||this.h.isEqual(this.yb,U)||this.h.isEqual(this.Ab,U)){const B=await this.db(U);return B&&this.Ob(JSON.parse(B),!0)}return null}Ob(U,B){return l(U,B)}async hasLocalData(){try{const{localExtensions:U}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(U.some(B=>B.installed||B.disabled))return!0}catch{}return!1}};e.$_3b=m,e.$_3b=m=pe([X(2,C.$Wh),X(3,p.$$j),X(4,d.$9o),X(5,r.$Zgb),X(6,r.$1gb),X(7,b.$co),X(8,t.$eFb),X(9,r.$chb),X(10,g.$ji),X(11,r.$0gb),X(12,E.$cl),X(13,$.$Zu),X(14,s.$Ik),X(15,a.$FDb),X(16,h.$Oh)],m);let O=class{constructor(U,B,Y,K,x,V){this.a=U,this.b=B,this.c=Y,this.d=K,this.f=x,this.g=V}async getLocalExtensions(U){const B=await this.a.getInstalled(void 0,U.extensionsResource),Y=this.d.getIgnoredExtensions(B);return{localExtensions:await this.j(U,async(x,V)=>{const Q=x.getDisabledExtensions();return B.map(G=>{const{identifier:W,isBuiltin:ee,manifest:ie,preRelease:_,pinned:ne,isApplicationScoped:Z}=G,q={identifier:W,preRelease:_,version:ie.version,pinned:!!ne};Z&&!(0,y.$9l)(ie)&&(q.isApplicationScoped=Z),Q.some(P=>(0,c.$Co)(P,W))&&(q.disabled=!0),ee||(q.installed=!0);try{const P=V.getKeysForSync({id:W.id,version:ie.version});if(P){const j=V.getExtensionState(G,!0)||{};q.state=Object.keys(j).reduce((T,M)=>(P.includes(M)&&(T[M]=j[M]),T),{})}}catch(P){this.g.info(`${(0,n.$vEb)("extensions",U)}: Error while parsing extension state`,(0,N.$9)(P))}return q})}),ignoredExtensions:Y}}async updateLocalExtensions(U,B,Y,K,x){const V=(0,n.$vEb)("extensions",x),Q=[],G=new Map,W=[],ee=[],ie=await this.a.getInstalled(void 0,x.extensionsResource);if((U.length||Y.length)&&await this.j(x,async(Z,q)=>{await D.Promises.settled([...U,...Y].map(async P=>{const j=ie.find(H=>(0,c.$Co)(H.identifier,P.identifier));if(j&&j.isBuiltin){P.state&&j.manifest.version===P.version&&this.h(P.state,j,j.manifest.version,q),Z.getDisabledExtensions().some(J=>(0,c.$Co)(J,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${V}: Disabling extension...`,P.identifier.id),await Z.disableExtension(P.identifier),this.g.info(`${V}: Disabled extension`,P.identifier.id)):(this.g.trace(`${V}: Enabling extension...`,P.identifier.id),await Z.enableExtension(P.identifier),this.g.info(`${V}: Enabled extension`,P.identifier.id))),W.push(P.identifier);return}const T=P.pinned?P.version:void 0,M=(await this.c.getExtensions([{...P.identifier,version:T,preRelease:T?void 0:P.preRelease}],L.CancellationToken.None))[0];if(P.state&&(j?j.manifest.version===P.version:M)&&this.h(P.state,j||M,j?.manifest.version,q),M)try{Z.getDisabledExtensions().some(J=>(0,c.$Co)(J,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${V}: Disabling extension...`,P.identifier.id,M.version),await Z.disableExtension(M.identifier),this.g.info(`${V}: Disabled extension`,P.identifier.id,M.version)):(this.g.trace(`${V}: Enabling extension...`,P.identifier.id,M.version),await Z.enableExtension(M.identifier),this.g.info(`${V}: Enabled extension`,P.identifier.id,M.version))),(!j||j.preRelease!==P.preRelease||j.pinned!==P.pinned||T&&j.manifest.version!==T)&&(await this.a.canInstall(M)?(Q.push({extension:M,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:P.pinned&&!!P.version,installPreReleaseVersion:P.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:P.isApplicationScoped,context:{[b.$4n]:!0,[b.$5n]:!0}}}),G.set(M.identifier.id.toLowerCase(),P)):(this.g.info(`${V}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),ee.push(P)))}catch(H){ee.push(P),this.g.error(H),this.g.info(`${V}: Skipped synchronizing extension`,M.displayName||M.identifier.id)}else ee.push(P),this.g.info(`${V}: Skipped synchronizing extension because the extension is not found.`,P.identifier.id)}))}),B.length){const Z=ie.filter(({identifier:q,isBuiltin:P})=>!P&&B.some(j=>(0,c.$Co)(q,j)));await D.Promises.settled(Z.map(async q=>{this.g.trace(`${V}: Uninstalling local extension...`,q.identifier.id),await this.a.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${V}: Uninstalled local extension.`,q.identifier.id),W.push(q.identifier)}))}const _=await this.a.installGalleryExtensions(Q);for(const{identifier:Z,local:q,error:P,source:j}of _){const T=j;if(q)this.g.info(`${V}: Installed extension.`,Z.id,T.version),W.push(Z);else{const M=G.get(Z.id.toLowerCase());M&&(ee.push(M),this.g.info(`${V}: Skipped synchronizing extension`,T.displayName||T.identifier.id)),P instanceof b.$bo&&[b.ExtensionManagementErrorCode.Incompatible,b.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(P.code)?this.g.info(`${V}: Skipped synchronizing extension because the compatible extension is not found.`,T.displayName||T.identifier.id):P&&this.g.error(P)}}const ne=[];for(const Z of K)W.some(q=>(0,c.$Co)(q,Z.identifier))||ne.push(Z);for(const Z of ee)ne.some(q=>(0,c.$Co)(q.identifier,Z.identifier))||ne.push(Z);return ne}h(U,B,Y,K){const x=K.getExtensionState(B,!0)||{},V=Y?K.getKeysForSync({id:B.identifier.id,version:Y}):void 0;V?V.forEach(Q=>{x[Q]=U[Q]}):Object.keys(U).forEach(Q=>x[Q]=U[Q]),K.setExtensionState(B,x,!0)}async j(U,B){return this.b.withProfileScopedStorageService(U,async Y=>{const K=new R.$Qc,x=this.f.createChild(new f.$Nh([d.$9o,Y])),V=K.add(x.createInstance(k.$4Cb)),Q=K.add(x.createInstance($.$1u));try{return await B(V,Q)}finally{K.dispose()}})}};e.$a4b=O,e.$a4b=O=pe([X(0,b.$co),X(1,a.$FDb),X(2,b.$ao),X(3,t.$eFb),X(4,h.$Oh),X(5,r.$chb)],O);let F=class extends n.$zEb{constructor(U,B,Y,K,x,V,Q,G){super("extensions",K,x,V,Y,Q,G),this.p=U,this.q=B}async t(U){return U.syncData?await v(U.syncData,this.p):null}u(U,B){const Y=[],K=[],x=[];for(const V of U){if(this.q.hasToNeverSyncExtension(V.identifier.id))continue;const Q=B.find(G=>(0,c.$Co)(G.identifier,V.identifier));Q?(Y.push(Q),V.disabled&&x.push(V.identifier)):V.installed&&(K.push({...V.identifier,preRelease:!!V.preRelease}),V.disabled&&x.push(V.identifier))}return{installedExtensions:Y,newExtensions:K,disabledExtensions:x,remoteExtensions:U}}};e.$b4b=F,e.$b4b=F=pe([X(0,b.$co),X(1,t.$eFb),X(2,p.$$j),X(3,o.$Kk),X(4,C.$Wh),X(5,u.$0i),X(6,d.$9o),X(7,s.$Ik)],F)}),define(oe[115],ae([0,1,15,7,3,35,41,5,32,20,14,11,8,43,21,22,28,39,78,235,24,17,58,4]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f,u,d,E,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FEb=e.$EEb=e.$DEb=e.$CEb=e.$BEb=void 0;const n="globalState.argv.",i=["locale"];function t(m,O){const F=m.storage?Object.keys(m.storage).sort():[],z={};return F.forEach(U=>z[U]=m.storage[U]),m.storage=z,O?(0,I.$cT)(m,{}):JSON.stringify(m)}e.$BEb=t;const r=1;let a=class extends h.$wEb{constructor(O,F,z,U,B,Y,K,x,V,Q,G,W,ee,ie){super({syncResource:"globalState",profile:O},F,U,x,W,B,Y,V,Q,K,G,ee),this.Bb=z,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:d.$ehb,authority:"base"}),this.xb=this.vb.with({scheme:d.$ehb,authority:"local"}),this.yb=this.vb.with({scheme:d.$ehb,authority:"remote"}),this.zb=this.vb.with({scheme:d.$ehb,authority:"accepted"}),this.Ab=ie.createInstance(v),this.B(U.watch(this.h.dirname(this.H.argvResource))),this.B(N.Event.any(N.Event.filter(U.onDidFilesChange,_=>_.contains(this.H.argvResource)),N.Event.filter(z.onDidChange,_=>!!(_.targetChanges.some(ne=>this.syncResource.profile.id===ne.id)||_.valueChanges.some(({profile:ne,changes:Z})=>this.syncResource.profile.id===ne.id&&Z.some(q=>q.target===0)))))(()=>this.Q()))}async qb(O,F,z){const U=O.syncData?JSON.parse(O.syncData.content):null;F=F===null&&z?O:F;const B=F&&F.syncData?JSON.parse(F.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);U?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.Jb(B),{local:x,remote:V}=(0,u.$AEb)(Y.storage,U?U.storage:null,B?B.storage:null,K,this.O),Q={content:null,local:x,remote:V,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:V.all!==null?2:0},G=t(Y,!1);return[{baseResource:this.wb,baseContent:B?t(B,!1):G,localResource:this.xb,localContent:G,localUserData:Y,remoteResource:this.yb,remoteContent:U?t(U,!1):null,previewResource:this.vb,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.zb,storageKeys:K}]}async ub(O){const F=O.syncData?JSON.parse(O.syncData.content):null;if(F===null)return!0;const z=await this.Ab.getLocalGlobalState(this.syncResource.profile),U=await this.Jb(F),{remote:B}=(0,u.$AEb)(z.storage,F.storage,F.storage,U,this.O);return B.all!==null}async rb(O,F){return{...O.previewResult,hasConflicts:!1}}async sb(O,F,z,U){if(this.h.isEqual(F,this.xb))return this.Gb(O);if(this.h.isEqual(F,this.yb))return this.Hb(O);if(this.h.isEqual(F,this.vb))return O.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Gb(O){return{content:O.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(O.localUserData.storage),removed:[],updated:[],all:O.localUserData.storage},localChange:0,remoteChange:2}}async Hb(O){if(O.remoteContent!==null){const F=JSON.parse(O.remoteContent),{local:z,remote:U}=(0,u.$AEb)(O.localUserData.storage,F.storage,null,O.storageKeys,this.O);return{content:O.remoteContent,local:z,remote:U,localChange:Object.keys(z.added).length>0||Object.keys(z.updated).length>0||z.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:O.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(O,F,z,U){const{localUserData:B}=z[0][0],{local:Y,remote:K,localChange:x,remoteChange:V}=z[0][1];if(x===0&&V===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(B)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),V!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Q=JSON.stringify({storage:K.all});O=await this.mb(Q,U?null:O.ref),this.O.info(`${this.D}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}F?.ref!==O.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(O),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(O){if(this.h.isEqual(this.yb,O)||this.h.isEqual(this.wb,O)||this.h.isEqual(this.xb,O)||this.h.isEqual(this.zb,O)){const F=await this.db(O);return F&&t(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:O}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(O).length>1||O[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(O){const F=await this.Bb.readStorageData(this.syncResource.profile),z=[],U=[];for(const[K,x]of F)x.target===0?z.push(K):x.target===1&&U.push(K);const B=[...z,...U],Y=O?.storage?Object.keys(O.storage).filter(K=>!K.startsWith(n)&&!B.includes(K)&&F.get(K)!==void 0):[];if(!R.$p){const K=[...d.$Vgb.map(x=>(0,d.$9gb)(x)),d.$8gb];Y.push(...K),U.push(...K)}return{user:z,machine:U,unregistered:Y}}};e.$CEb=a,e.$CEb=a=pe([X(2,s.$FDb),X(3,k.$$j),X(4,d.$Zgb),X(5,d.$1gb),X(6,d.$chb),X(7,C.$Wh),X(8,d.$0gb),X(9,y.$cl),X(10,g.$ji),X(11,$.$9o),X(12,p.$Ik),X(13,o.$Oh)],a);let v=class{constructor(O,F,z,U){this.a=O,this.b=F,this.c=z,this.d=U}async getLocalGlobalState(O){const F={};if(O.isDefault){const U=await this.f(),B=(0,A.$Wm)(U);for(const Y of i)B[Y]!==void 0&&(F[`${n}${Y}`]={version:1,value:B[Y]})}const z=await this.c.readStorageData(O);for(const[U,B]of z)B.value&&B.target===0&&(F[U]={version:1,value:B.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const O=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),O.value.toString()}catch(O){this.d.debug((0,L.$9)(O))}return"{}"}async writeLocalGlobalState({added:O,removed:F,updated:z},U){const B=(0,h.$vEb)("globalState",U),Y={},K=new Map,x=await this.c.readStorageData(U),V=(Q,G)=>{for(const W of Q){if(W.startsWith(n)){Y[W.substring(n.length)]=G?G[W].value:void 0;continue}if(G){const ee=G[W];ee.value!==x.get(W)?.value&&K.set(W,ee.value)}else x.get(W)!==void 0&&K.set(W,void 0)}};if(V(Object.keys(O),O),V(Object.keys(z),z),V(F),Object.keys(Y).length){this.d.trace(`${B}: Updating locale...`);const Q=await this.f();let G=Q;for(const W of Object.keys(Y))G=(0,f.edit)(G,[W],Y[W],{});Q!==G&&(this.d.trace(`${B}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.$be.fromString(G)),this.d.info(`${B}: Updated locale.`)),this.d.info(`${B}: Updated locale`)}K.size&&(this.d.trace(`${B}: Updating global state...`),await this.c.updateStorageData(U,K,0),this.d.info(`${B}: Updated global state`,[...K.keys()]))}};e.$DEb=v,e.$DEb=v=pe([X(0,k.$$j),X(1,C.$Wh),X(2,s.$FDb),X(3,d.$chb)],v);let w=class extends h.$zEb{constructor(O,F,z,U,B,Y){super("globalState",z,U,B,F,O,Y)}async o(O){const F=O.syncData?JSON.parse(O.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const z={},U={};for(const B of Object.keys(F.storage))B.startsWith(n)?z[B.substring(n.length)]=F.storage[B].value:this.l.get(B,0)===void 0&&(U[B]=F.storage[B].value);if(Object.keys(z).length){let B="{}";try{B=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(z))B=(0,f.edit)(B,[Y],z[Y],{});await this.k.writeFile(this.h.argvResource,D.$be.fromString(B))}if(Object.keys(U).length){const B=[];for(const Y of Object.keys(U))B.push({key:Y,value:U[Y],scope:0,target:0});this.l.storeAll(B,!0)}}};e.$EEb=w,e.$EEb=w=pe([X(0,$.$9o),X(1,k.$$j),X(2,E.$Kk),X(3,C.$Wh),X(4,d.$chb),X(5,p.$Ik)],w);let l=class{constructor(O,F,z,U,B){this.a=O,this.b=F,this.c=z,this.d=U,this.f=B}getSyncStoreType(O){return this.h(O)?.storage[d.$8gb]?.value}async sync(O){const F=(0,d.$4gb)((0,S.$eg)());try{return await this.g(O,F)}catch(z){if(z instanceof d.$5gb)switch(z.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(O,F)}throw z}}async g(O,F){const z=await this.a.readResource("globalState",null,void 0,F),U=this.h(z)||{storage:{}};U.storage[d.$8gb]={value:O,version:r};const B=await(0,c.$cp)(this.c,this.d,this.b),Y={version:r,machineId:B,content:t(U,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),z.ref,void 0,F)}h({content:O}){if(!O)return null;const F=JSON.parse(O);if((0,h.$uEb)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};e.$FEb=l,e.$FEb=l=pe([X(1,$.$9o),X(2,C.$Wh),X(3,k.$$j),X(4,b.$0i)],l)}),define(oe[116],ae([0,1,18,15,3,35,5,12,170,20,14,11,21,22,28,17,39,232,24]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f4b=e.$e4b=e.$d4b=void 0;function u(s,o,n){try{const i=JSON.parse(s);if(!o)return(0,R.$Ff)(i.all)?null:i.all;switch(I.OS){case 2:return(0,R.$Ff)(i.mac)?null:i.mac;case 3:return(0,R.$Ff)(i.linux)?null:i.linux;case 1:return(0,R.$Ff)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.$d4b=u;let d=class extends p.$yEb{constructor(o,n,i,t,r,a,v,w,l,m,O,F,z){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,w,l,m,i,t,v,F,r,O,a,z),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:f.$ehb,authority:"base"}),this.Gb=this.Eb.with({scheme:f.$ehb,authority:"local"}),this.Hb=this.Eb.with({scheme:f.$ehb,authority:"remote"}),this.Ib=this.Eb.with({scheme:f.$ehb,authority:"accepted"}),this.B(N.Event.filter(a.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,i,t){const r=o.syncData?u(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&i?o:n;const a=n?this.Ob(n):null,v=await this.vb(),w=await this.Cb();let l=null,m=!1,O=!1,F=!1;if(r){let B=v?v.value.toString():"[]";if(B=B||"[]",this.Ab(B,!0))throw new f.$5gb((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==B||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,h.$c4b)(B,r,a,w,this.zb);Y.hasChanges&&(l=Y.mergeContent,F=Y.hasConflicts,m=F||Y.mergeContent!==B,O=F||Y.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),l=v.value.toString(),O=!0);const z={content:F?a:l,localChange:m?v?2:1:0,remoteChange:O?2:0,hasConflicts:F},U=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:U,localChange:z.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:z.remoteChange,previewResource:this.Eb,previewResult:z,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const i=await this.vb(),t=i?i.value.toString():"",r=await this.Cb(),a=await(0,h.$c4b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,i,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return i===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,i,t){const{fileContent:r}=i[0][0];let{content:a,localChange:v,remoteChange:w}=i[0][1];if(v===0&&w===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new f.$5gb((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),w!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const l=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(l,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,A.$Wm)(o.value.toString());if((0,D.$Kb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:u(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let i={};try{i=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete i.all:i.all=o,I.OS){case 2:i.mac=o;break;case 3:i.linux=o;break;case 1:i.windows=o;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(f.$Sgb)}};e.$e4b=d,e.$e4b=d=pe([X(2,f.$Zgb),X(3,f.$1gb),X(4,f.$chb),X(5,g.$ji),X(6,f.$0gb),X(7,k.$$j),X(8,C.$Wh),X(9,b.$9o),X(10,f.$bhb),X(11,c.$cl),X(12,$.$Ik)],d);let E=class extends p.$zEb{constructor(o,n,i,t,r,a){super("keybindings",n,i,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,L.$be.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$Wm)(o.value.toString());return!(0,D.$Kb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return u(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$f4b=E,e.$f4b=E=pe([X(0,k.$$j),X(1,y.$Kk),X(2,C.$Wh),X(3,f.$chb),X(4,b.$9o),X(5,$.$Ik)],E)}),define(oe[117],ae([0,1,15,3,171,20,74,14,29,11,21,22,28,17,39,236,24]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i4b=e.$h4b=e.$g4b=void 0;function h(E){return E&&E.settings&&typeof E.settings=="string"&&Object.keys(E).length===1}function f(E){const s=JSON.parse(E);return h(s)?s:{settings:E}}e.$g4b=f;let u=class extends $.$yEb{constructor(s,o,n,i,t,r,a,v,w,l,m,O,F,z){super(s.settingsResource,{syncResource:"settings",profile:s},o,n,i,t,r,a,m,O,v,w,l,z),this.Eb=F,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:p.$ehb,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.$ehb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.$ehb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.$ehb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(s){const o=await this.getLastSyncUserData(),n=await this.X(s,o),i=this.Lb(n),t=new I.$Fn(p.$Rgb);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(p.$Rgb)||{}}async qb(s,o,n){const i=await this.vb(),t=await this.Cb(),r=this.Lb(s);o=o===null&&n?s:o;const a=o?this.Lb(o):null,v=await this.Pb();let w=null,l=!1,m=!1,O=!1;if(r){let B=i?i.value.toString().trim():"{}";B=B||"{}",this.Qb(B),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,y.$mDb)(B,r.settings,a?a.settings:null,v,[],t);w=Y.localContent||Y.remoteContent,l=Y.localContent!==null,m=Y.remoteContent!==null,O=Y.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),w=i.value.toString().trim()||"{}",this.Qb(w),m=!0);const F=i?i.value.toString():null,z=a?.settings??null,U={content:O?z:w,localChange:l?2:0,remoteChange:m?2:0,hasConflicts:O};return[{fileContent:i,baseResource:this.baseResource,baseContent:z,localResource:this.localResource,localContent:F,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async ub(s){const o=this.Lb(s);if(o===null)return!0;const n=await this.vb(),i=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,y.$mDb)(i||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(s,o){const n=await this.Cb(),i=await this.Pb();return{...s.previewResult,content:s.previewResult.content?(0,y.$lDb)(s.previewResult.content,"{}",i,n):null}}async sb(s,o,n,i){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:s.fileContent?(0,y.$lDb)(s.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:s.remoteContent!==null?(0,y.$lDb)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,y.$lDb)(n,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(s,o,n,i){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:v}=n[0][1];if(a===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,i),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const w=await this.Cb(),l=this.Lb(s),m=await this.Pb(r);r=(0,y.$lDb)(r,l?l.settings:"{}",m,w),this.O.trace(`${this.D}: Updating remote settings...`),s=await this.mb(JSON.stringify(this.Nb(r)),i?null:s.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(s),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.vb();if(s)return!(0,y.$nDb)(s.value.toString())}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.db(s):null}async db(s){let o=await super.db(s);if(o){const n=await this.Cb(),i=await this.Pb();o=(0,y.$lDb)(o,"{}",i,n)}return o}Lb(s){return s.syncData?this.Mb(s.syncData.content):null}Mb(s){try{return f(s)}catch(o){this.O.error(o)}return null}Nb(s){return{settings:s}}async Pb(s){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(L.Event.any(L.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),L.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,y.$jDb)(o,this.P,s)}Qb(s){if(this.Ab(s,!1))throw new p.$5gb((0,N.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$h4b=u,e.$h4b=u=pe([X(2,g.$$j),X(3,R.$Wh),X(4,C.$9o),X(5,p.$Zgb),X(6,p.$1gb),X(7,p.$chb),X(8,p.$bhb),X(9,A.$ji),X(10,p.$0gb),X(11,k.$cl),X(12,S.$co),X(13,b.$Ik)],u);let d=class extends $.$zEb{constructor(s,o,n,i,t,r){super("settings",o,n,i,s,t,r)}async o(s){const o=s.syncData?this.p(s.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.$be.fromString(o.settings)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,y.$nDb)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}p(s){try{return f(s)}catch(o){this.j.error(o)}return null}};e.$i4b=d,e.$i4b=d=pe([X(0,g.$$j),X(1,c.$Kk),X(2,R.$Wh),X(3,p.$chb),X(4,C.$9o),X(5,b.$Ik)],d)}),define(oe[118],ae([0,1,15,3,30,20,14,11,21,22,28,17,39,233,24]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n4b=e.$m4b=e.$l4b=void 0;function y(f){return JSON.parse(f.content)}e.$l4b=y;let p=class extends b.$wEb{constructor(u,d,E,s,o,n,i,t,r,a,v,w){super({syncResource:"snippets",profile:u},d,s,E,o,n,i,a,v,t,r,w),this.pb=1,this.vb=u.snippetsHome,this.B(this.G.watch(E.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(L.Event.filter(this.G.onDidFilesChange,l=>l.affects(this.vb))(()=>this.Q()))}async qb(u,d,E){const s=await this.Hb(),o=this.Gb(s),n=u.syncData?this.Fb(u.syncData):null;d=d===null&&E?u:d;const i=d&&d.syncData?this.Fb(d.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,c.$j4b)(o,n,i);return this.Bb(t,s,n||{},i||{})}async ub(u){const d=u.syncData?this.Fb(u.syncData):null;if(d===null)return!0;const E=await this.Hb(),s=this.Gb(E),o=(0,c.$j4b)(s,d,d);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(u,d){return u.previewResult}async sb(u,d,E,s){if(this.h.isEqualOrParent(d,this.g.with({scheme:$.$ehb,authority:"local"})))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:u.fileContent?u.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(d,this.g.with({scheme:$.$ehb,authority:"remote"})))return{content:u.remoteContent,localChange:u.remoteContent!==null?u.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(d,this.g))return E===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:E,localChange:E===null?u.fileContent!==null?3:0:2,remoteChange:E===null?u.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(u,d,E,s){const o=E.map(([n,i])=>({...n,acceptResult:i}));o.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,s)),o.some(({remoteChange:n})=>n!==0)&&(u=await this.Eb(o,u,s)),d?.ref!==u.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(u),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(u,d,E,s){const o=new Map;for(const n of Object.keys(u.local.added)){const i={content:u.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"accepted"})})}for(const n of Object.keys(u.local.updated)){const i={content:u.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"accepted"})})}for(const n of u.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"accepted"})})}for(const n of Object.keys(u.remote.added)){const i={content:u.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"accepted"})})}for(const n of Object.keys(u.remote.updated)){const i={content:u.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"accepted"})})}for(const n of u.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"accepted"})})}for(const n of u.conflicts){const i={content:s[n]??null,hasConflicts:!0,localChange:d[n]?2:1,remoteChange:E[n]?2:1},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"local"}),fileContent:d[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"remote"}),remoteContent:E[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"accepted"})})}for(const n of Object.keys(d))if(!o.has(n)){const i={content:d[n]?d[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"local"}),fileContent:d[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"remote"}),remoteContent:E[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ehb,authority:"accepted"})})}return[...o.values()]}async resolveContent(u){return this.h.isEqualOrParent(u,this.g.with({scheme:$.$ehb,authority:"remote"}))||this.h.isEqualOrParent(u,this.g.with({scheme:$.$ehb,authority:"local"}))||this.h.isEqualOrParent(u,this.g.with({scheme:$.$ehb,authority:"base"}))||this.h.isEqualOrParent(u,this.g.with({scheme:$.$ehb,authority:"accepted"}))?this.db(u):null}async hasLocalData(){try{const u=await this.Hb();if(Object.keys(u).length)return!0}catch{}return!1}async Cb(u){const d={};for(const E of u)E.fileContent&&(d[this.h.basename(E.localResource)]=E.fileContent);await this.nb(JSON.stringify(this.Gb(d)))}async Db(u,d){for(const{fileContent:E,acceptResult:s,localResource:o,remoteResource:n,localChange:i}of u)if(i!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);i===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):i===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,D.$be.fromString(s.content),{overwrite:d}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,D.$be.fromString(s.content),d?void 0:E),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(u,d,E){const s=d.syncData?this.Fb(d.syncData):{},o=(0,N.$7m)(s);for(const{acceptResult:n,localResource:i,remoteResource:t,remoteChange:r}of u)if(r!==0){const a=i?this.h.basename(i):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,c.$k4b)(s,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),d=await this.mb(JSON.stringify(o),E?null:d.ref),this.O.info(`${this.D}: Updated remote snippets`)),d}Fb(u){return y(u)}Gb(u){const d={};for(const E of Object.keys(u))d[E]=u[E].value.toString();return d}async Hb(){const u={};let d;try{d=await this.G.resolve(this.vb)}catch(E){if(E instanceof R.$tk&&E.fileOperationResult===1)return u;throw E}for(const E of d.children||[]){const s=E.resource,o=this.h.extname(s);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,s),i=await this.G.readFile(s);u[n]=i}}return u}};e.$m4b=p,e.$m4b=p=pe([X(2,I.$Wh),X(3,R.$$j),X(4,S.$9o),X(5,$.$Zgb),X(6,$.$1gb),X(7,$.$chb),X(8,A.$ji),X(9,$.$0gb),X(10,g.$cl),X(11,C.$Ik)],p);let h=class extends b.$zEb{constructor(u,d,E,s,o,n){super("snippets",d,E,s,u,o,n)}async o(u){const d=u.syncData?JSON.parse(u.syncData.content):null;if(!d){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(d)){const o=d[s];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,s);await this.k.createFile(n,D.$be.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(u)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(u){return u.fileOperationResult===1}}};e.$n4b=h,e.$n4b=h=pe([X(0,R.$$j),X(1,k.$Kk),X(2,I.$Wh),X(3,$.$chb),X(4,S.$9o),X(5,C.$Ik)],h)}),define(oe[119],ae([0,1,15,20,14,11,21,22,28,17,39,24]),function(te,e,D,L,N,A,I,R,S,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q4b=e.$p4b=e.$o4b=void 0;function b(p,h){try{return JSON.parse(p).tasks??null}catch(f){return h.error(f),null}}e.$o4b=b;let c=class extends C.$xEb{constructor(h,f,u,d,E,s,o,n,i,t,r,a){super(h.tasksResource,{syncResource:"tasks",profile:h},f,n,i,t,u,d,o,r,E,s,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:k.$ehb,authority:"base"}),this.Cb=this.Ab.with({scheme:k.$ehb,authority:"local"}),this.Db=this.Ab.with({scheme:k.$ehb,authority:"remote"}),this.Eb=this.Ab.with({scheme:k.$ehb,authority:"accepted"})}async qb(h,f,u,d){const E=h.syncData?b(h.syncData.content,this.O):null;f=f===null&&u?h:f;const s=f?.syncData?b(f.syncData.content,this.O):null,o=await this.vb();let n=null,i=!1,t=!1,r=!1;if(h.syncData){const w=o?o.value.toString():null;if(!s||s!==w||s!==E){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const l=y(w,E,s);n=l.content,r=l.hasConflicts,i=l.hasLocalChanged,t=l.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?s:n,localChange:i?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:s,localResource:this.Cb,localContent:v,localChange:a.localChange,remoteResource:this.Db,remoteContent:E,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(h){const f=h?.syncData?b(h.syncData.content,this.O):null;if(f===null)return!0;const u=await this.vb(),d=u?u.value.toString():null,E=y(d,f,f);return E.hasLocalChanged||E.hasRemoteChanged}async rb(h,f){return h.previewResult}async sb(h,f,u,d){if(this.h.isEqual(f,this.Cb))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(f,this.Db))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(f,this.Ab))return u===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:u,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async tb(h,f,u,d){const{fileContent:E}=u[0][0],{content:s,localChange:o,remoteChange:n}=u[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),E&&await this.nb(JSON.stringify(this.Kb(E.value.toString()))),s?await this.wb(s,E,d):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(s));h=await this.mb(i,d?null:h.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}f?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(h){return this.h.isEqual(this.Db,h)||this.h.isEqual(this.Bb,h)||this.h.isEqual(this.Cb,h)||this.h.isEqual(this.Eb,h)?this.db(h):null}Kb(h){return h?{tasks:h}:{}}};e.$p4b=c,e.$p4b=c=pe([X(2,k.$Zgb),X(3,k.$1gb),X(4,k.$chb),X(5,L.$ji),X(6,k.$0gb),X(7,A.$$j),X(8,N.$Wh),X(9,I.$9o),X(10,R.$cl),X(11,S.$Ik)],c);let $=class extends C.$zEb{constructor(h,f,u,d,E,s){super("tasks",f,u,d,h,E,s),this.c=this.g.defaultProfile.tasksResource}async o(h){const f=h.syncData?b(h.syncData.content,this.j):null;if(!f){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.$be.fromString(f)),await this.n(h)}async p(){return this.k.exists(this.c)}};e.$q4b=$,e.$q4b=$=pe([X(0,A.$$j),X(1,g.$Kk),X(2,N.$Wh),X(3,k.$chb),X(4,I.$9o),X(5,S.$Ik)],$);function y(p,h,f){if(p===null&&h===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(p===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const u=f!==p,d=f!==h;return!u&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:u&&!d?{content:p,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!u?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:p,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[120],ae([0,1,41,20,14,11,21,22,28,17,39,234,24]),function(te,e,D,L,N,A,I,R,S,g,C,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$75b=e.$65b=e.$55b=void 0;let c=class extends C.$wEb{constructor(h,f,u,d,E,s,o,n,i,t,r,a,v){super({syncResource:"profiles",profile:h},f,d,E,s,o,n,r,a,i,t,v),this.vb=u,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:b.$ehb,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.$ehb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.$ehb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.$ehb,authority:"accepted"}),this.B(u.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?y(h.syncData):null}async getRemoteSyncedProfiles(h){const f=await this.getLastSyncUserData(),u=await this.X(h,f);return u?.syncData?y(u.syncData):null}async qb(h,f,u){if(!this.vb.isEnabled())throw new b.$5gb("Cannot sync profiles because they are disabled","LocalError");const d=h.syncData?y(h.syncData):null,E=f?.syncData?y(f.syncData):null,s=this.Db(),{local:o,remote:n}=(0,k.$45b)(s,d,E,[]),i={local:o,remote:n,content:E?this.Eb(E):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=$(s,!1);return[{baseResource:this.baseResource,baseContent:E?this.Eb(E):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:d?this.Eb(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(h){const f=h?.syncData?y(h.syncData):null,u=this.Db(),{remote:d}=(0,k.$45b)(u,f,f,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async rb(h,f){return{...h.previewResult,hasConflicts:!1}}async sb(h,f,u,d){if(this.h.isEqual(f,this.localResource))return this.Ab(h);if(this.h.isEqual(f,this.remoteResource))return this.Bb(h);if(this.h.isEqual(f,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async Ab(h){const f=this.Db(),u=(0,k.$45b)(f,null,null,[]),{local:d,remote:E}=u;return{content:h.localContent,local:d,remote:E,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:E!==null?2:0}}async Bb(h){const f=h.remoteContent?JSON.parse(h.remoteContent):null,u=[],d=[];for(const E of this.Db()){const s=f?.find(o=>o.id===E.id);s&&(u.push({id:E.id,name:E.name,collection:s.collection}),d.push(E))}if(f!==null){const E=(0,k.$45b)(d,f,u,[]),{local:s,remote:o}=E;return{content:h.remoteContent,local:s,remote:o,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(h,f,u,d){const{local:E,remote:s,localChange:o,remoteChange:n}=u[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=u[0][0].remoteProfiles||[];if(i.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new b.$5gb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb($(this.Db(),!1));const t=[];for(const r of E.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of E.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of E.updated){const a=this.vb.profiles.find(v=>v.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=i.length+(s?.added.length??0)<=20;if(r)for(const a of s?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),i.push({id:a.id,name:a.name,collection:v,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of s?.removed||[])i.splice(i.findIndex(({id:v})=>a.id===v),1);for(const a of s?.updated||[]){const v=i.find(({id:w})=>a.id===w);v&&i.splice(i.indexOf(v),1,{...v,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{h=await this.updateRemoteProfiles(i,d?null:h.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&s?.added.length?` Added: ${JSON.stringify(s.added.map(a=>a.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(a=>a.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw a}for(const a of s?.removed||[])await this.J.deleteCollection(a.collection,this.F)}f?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,f){return this.mb(this.Eb(h),f)}async hasLocalData(){return this.Db().length>0}async resolveContent(h){if(this.h.isEqual(this.remoteResource,h)||this.h.isEqual(this.baseResource,h)||this.h.isEqual(this.localResource,h)||this.h.isEqual(this.acceptedResource,h)){const f=await this.db(h);return f&&(0,D.$cT)(JSON.parse(f),{})}return null}Db(){return this.vb.profiles.filter(h=>!h.isDefault&&!h.isTransient)}Eb(h){return JSON.stringify([...h].sort((f,u)=>f.name.localeCompare(u.name)))}};e.$55b=c,e.$55b=c=pe([X(2,g.$Kk),X(3,A.$$j),X(4,N.$Wh),X(5,I.$9o),X(6,b.$Zgb),X(7,b.$1gb),X(8,b.$chb),X(9,L.$ji),X(10,b.$0gb),X(11,R.$cl),X(12,S.$Ik)],c);function $(p,h){const f=[...p].sort((u,d)=>u.name.localeCompare(d.name)).map(u=>({id:u.id,name:u.name}));return h?(0,D.$cT)(f,{}):JSON.stringify(f)}e.$65b=$;function y(p){return JSON.parse(p.content)}e.$75b=y}),define(oe[251],ae([0,1,3,2,5,14,21,22,24]),function(te,e,D,L,N,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R5b=void 0;const g="sync.enable";let C=class extends L.$Rc{constructor(b,c,$,y){super(),this.c=b,this.f=c,this.g=$,this.h=y,this.a=new D.$Nd,this.onDidChangeEnablement=this.a.event,this.b=new D.$Nd,this.onDidChangeResourceEnablement=this.b.event,this.B(b.onDidChangeValue(-1,void 0,this.B(new L.$Qc))(p=>this.m(p)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(g,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(b){b&&!this.canToggleEnablement()||(this.f.publicLog2(g,{enabled:b}),this.c.store(g,b,-1,1))}isResourceEnabled(b){return this.c.getBoolean((0,S.$9gb)(b),-1,!0)}setResourceEnablement(b,c){if(this.isResourceEnabled(b)!==c){const $=(0,S.$9gb)(b);this.j($,c)}}getResourceSyncStateVersion(b){}j(b,c){this.c.store(b,c,-1,N.$p?0:1)}m(b){if(g===b.key){this.a.fire(this.isEnabled());return}const c=S.$Vgb.filter($=>(0,S.$9gb)($)===b.key)[0];if(c){this.b.fire([c,this.isResourceEnabled(c)]);return}}};e.$R5b=C,e.$R5b=C=pe([X(0,I.$9o),X(1,R.$cl),X(2,A.$Wh),X(3,S.$Ygb)],C)}),define(oe[252],ae([0,1,6,15,63,2,19,20,14,11,17,24]),function(te,e,D,L,N,A,I,R,S,g,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$35b=void 0;let b=class extends A.$Rc{constructor($,y,p,h,f){super(),this.a=$,this.b=y,this.c=p,this.f=h,this.g=f,this.h()}async h(){for(const y of this.g.profiles)for(const p of k.$Vgb)try{await this.m(this.j(p,y.isDefault?void 0:y.id))}catch(h){this.f.error(h)}let $;try{$=await this.b.resolve(this.a.userDataSyncHome)}catch(y){(0,g.$pk)(y)!==1&&this.f.error(y);return}if($.children){for(const y of $.children)if(y.isDirectory&&!this.g.profiles.some(p=>p.id===y.name))try{this.f.info("Deleting non existing profile from backup",y.resource.path),await this.b.del(y.resource,{recursive:!0})}catch(p){this.f.error(p)}}}async getAllResourceRefs($,y,p){const h=this.j($,y,p);try{const f=await this.b.resolve(h);if(f.children)return f.children.filter(d=>d.isFile&&!d.name.startsWith("lastSync")).sort().reverse().map(d=>({ref:d.name,created:this.n(d)}))}catch(f){if((0,g.$pk)(f)!==1)throw f}return[]}async resolveResourceContent($,y,p,h){const f=this.j($,p,h),u=(0,I.$vg)(f,y);try{return(await this.b.readFile(u)).value.toString()}catch(d){return this.f.error(d),null}}async writeResource($,y,p,h,f){const u=this.j($,h,f),d=(0,I.$vg)(u,`${(0,N.$em)(p).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,L.$be.fromString(y))}catch(E){this.f.error(E)}}j($,y,p=this.a.userDataSyncHome){return(0,I.$vg)(p,...y?[y,$]:[$])}async m($){try{try{if(!await this.b.exists($))return}catch{return}const y=await this.b.resolve($);if(y.children){const p=y.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),h=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let f=p.filter(d=>Date.now()-this.n(d)>h);const u=p.length-f.length;u<10&&(f=f.slice(10-u)),await D.Promises.settled(f.map(async d=>{this.f.info("Deleting from backup",d.resource.path),await this.b.del(d.resource)}))}}catch(y){this.f.error(y)}}n($){return new Date(parseInt($.name.substring(0,4)),parseInt($.name.substring(4,6))-1,parseInt($.name.substring(6,8)),parseInt($.name.substring(9,11)),parseInt($.name.substring(11,13)),parseInt($.name.substring(13,15))).getTime()}};e.$35b=b,e.$35b=b=pe([X(0,S.$Wh),X(1,g.$$j),X(2,R.$ji),X(3,k.$chb),X(4,C.$Kk)],b)}),define(oe[82],ae([0,1,3,2,5,27,175,14,11,4,25,43,21,24]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogb=e.$Ngb=e.$Mgb=void 0,e.$Mgb=(0,g.$Ph)("IUserDataSyncMachinesService");const y="sync.currentMachineName",p="Safari",h="Chrome",f="Edge",u="Firefox",d="Android";function E(n){switch(n){case p:case h:case f:case u:case d:case(0,N.$i)(0):return!0}return!1}e.$Ngb=E;function s(){return N.$G?p:N.$E?h:N.$H?f:N.$F?u:N.$I?d:(0,N.$i)(N.$p?0:N.$u)}let o=class extends L.$Rc{static{$=this}static{this.a=1}static{this.b="machines"}constructor(i,t,r,a,v,w){super(),this.h=r,this.j=a,this.m=v,this.n=w,this.c=this.B(new D.$Nd),this.onDidChange=this.c.event,this.g=null,this.f=(0,k.$cp)(i,t,r)}async getMachines(i){const t=await this.f;return(await this.s(i)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(i){const t=await this.f,r=await this.s(i);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:s()}),await this.t(r))}async removeCurrentMachine(i){const t=await this.f,r=await this.s(i),a=r.machines.filter(({id:v})=>v!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(i,t,r){const a=await this.s(r),v=a.machines.find(({id:w})=>w===i);if(v){v.name=t,await this.t(a);const w=await this.f;i===w&&this.h.store(y,t,-1,1)}}async setEnablements(i){const t=await this.s();for(const[r,a]of i){const v=t.machines.find(w=>w.id===r);v&&(v.disabled=a?void 0:!0)}await this.t(t)}r(i){const t=this.h.get(y,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${s()} (${this.n.nameShort})`,a=new RegExp(`${(0,A.$Fe)(r)}\\s#(\\d+)`);let v=0;for(const w of i){const l=a.exec(w.name),m=l?parseInt(l[1]):0;v=m>v?m:v}return`${r} #${v+1}`}async s(i){this.g=await this.u(i);const t=this.w(this.g);if(t.version!==$.a)throw new Error((0,I.localize)(0,null,this.n.nameLong));return t}async t(i){const t=JSON.stringify(i),r=await this.j.writeResource($.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(i){if(this.g){const t=i&&i.latest?i.latest[$.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource($.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.m.error(t)}return{version:$.a,machines:[]}}};e.$Ogb=o,e.$Ogb=o=$=pe([X(0,R.$Wh),X(1,S.$$j),X(2,b.$9o),X(3,c.$Zgb),X(4,c.$chb),X(5,C.$pj)],o)}),define(oe[253],ae([0,1,6,63,38,7,3,2,5,19,10,172,25,21,22,24,79,82]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$95b=void 0;const f="sync.disableMachineEventually",u="sync.sessionId",d="sync.storeUrl",E="sync.productQuality";let s=class extends R.$Rc{get n(){const i=this.H.get(d,-1);return i?C.URI.parse(i):void 0}set n(i){i?this.H.store(d,i.toString(),-1,1):this.H.remove(d,-1)}get s(){return this.H.get(E,-1)}set s(i){i?this.H.store(E,i,-1,1):this.H.remove(E,-1)}constructor(i,t,r,a,v,w,l,m,O,F){super(),this.u=t,this.w=r,this.y=a,this.z=v,this.C=w,this.D=l,this.F=m,this.G=O,this.H=F,this.a=this.B(new R.$Sc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new I.$Nd),this.onError=this.h.event,this.S=[],this.f=this.B(new D.$Rg(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,g.$og)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(l.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(z=>this.triggerSync([z],!1,!1))),this.B(I.Event.filter(this.y.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:t}=this.L();i?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.$em)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(u,-1),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const t=y.$5gb.toUserDataSyncError(i);t instanceof y.$7gb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?S.$p&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(f,!0,-1,1),await(0,D.$Ug)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(f,-1,!1)}R(){this.H.remove(f,-1)}async triggerSync(i,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$95b=s,e.$95b=s=pe([X(0,b.$pj),X(1,y.$Ygb),X(2,y.$Zgb),X(3,y.$0gb),X(4,y.$$gb),X(5,y.$chb),X(6,p.$6Cb),X(7,$.$cl),X(8,h.$Mgb),X(9,c.$9o)],s);class o extends R.$Rc{static{this.a="Interval"}constructor(i,t,r,a,v,w,l,m,O){super(),this.m=i,this.n=t,this.r=r,this.s=a,this.u=v,this.w=w,this.y=l,this.z=m,this.C=O,this.b=this.B(new R.$Sc),this.c=this.B(new I.$Nd),this.onDidStartSync=this.c.event,this.f=this.B(new I.$Nd),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Pc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,D.$Vg)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(i,t){const r=(0,D.$Hg)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,A.$3)(v))return}return this.H(i,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,g.$og)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!i&&(!(0,g.$og)(t.defaultUrl,i.defaultUrl)||!(0,g.$og)(t.insidersUrl,i.insidersUrl)||!(0,g.$og)(t.stableUrl,i.stableUrl))}async H(i,t,r){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let a;try{await this.I(t,r)}catch(v){if(this.y.error(v),a=v,y.$5gb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(w){this.y.error(w),a=w}}this.f.fire(a)}async I(i,t){if(this.h=await this.u.createSyncTask(this.g,i),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new y.$7gb((0,k.localize)(0,null),"DefaultServiceChanged"):new y.$7gb((0,k.localize)(1,null),"ServiceChanged"):new y.$7gb((0,k.localize)(2,null),"TurnedOff");const r=this.C.get(u,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new y.$7gb((0,k.localize)(3,null),"DefaultServiceChanged"):new y.$7gb((0,k.localize)(4,null),"ServiceChanged"):new y.$7gb((0,k.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=a.find(l=>l.isCurrent);if(v?.disabled)throw new y.$7gb((0,k.localize)(6,null),"TurnedOff");const w=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-w}),this.g===null)try{this.g=await this.s.manifest(null)}catch(l){throw new y.$7gb((0,N.$Ai)(l),l instanceof y.$5gb?l.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(u,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(oe[254],ae([0,1,10,176,14,11,43,21,28,24,17,39,118,117,116,20,119,114,115,4,120,41,27]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f,u,d,E,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$G6b=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,v,w,l,m,O,F,z){this.e=t,this.f=r,this.g=a,this.h=w,this.i=l,this.j=m,this.k=O,this.l=F,this.n=z,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,d.$75b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const v=this.L(a,"profiles");return(0,d.$75b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(w=>({...w,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:w})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:w,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:w,ref:l})=>({created:w,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:l,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,I.$cp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,v,w){if(t){const{content:l}=await this.M(r,v,a);return l}return this.f.resolveResourceContent(r,v,a,w)}q(t,r,a){const v=this.L(r,t);switch(t){case"settings":return this.t(v,a);case"keybindings":return this.v(v,a);case"tasks":return this.x(v,a);case"snippets":return this.z(v,a);case"globalState":return this.E(v,a);case"extensions":return this.B(v,a);case"profiles":return this.H(v,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(v=>v.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,c.$g4b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,$.$d4b)(t.content,!!this.l.getValue(g.$Sgb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,p.$o4b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const v=this.L(a,"snippets");if(v){const w=(0,b.$l4b)(v),l=[];for(const m of Object.keys(w)){const O=this.d.joinPath(t,m),F=r?this.d.joinPath(r.snippetsHome,m):this.d.joinPath(t,o.a);l.push({resource:O,comparableResource:F})}return l}}return[]}z(t,r){return(0,b.$l4b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,h.$$3b)((0,h.$03b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(h.$a4b).getLocalExtensions(t);return(0,h.$$3b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,f.$BEb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(f.$DEb).getLocalGlobalState(t);return(0,f.$BEb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,E.$cT)(JSON.parse(t.content),{})}return null}async I(t){return(0,d.$65b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,s.$Ie)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(D.URI.from({scheme:g.$ehb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==g.$ehb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let v,w;const l=[];let m,O,F,z,U;for(;r.length;){const B=r.shift();B.startsWith("scheme:")?v=B.substring(7):B.startsWith("authority:")?w=B.substring(10):B.startsWith("syncResource:")?m=B.substring(13):B.startsWith("profile:")?O=B.substring(8):B.startsWith("collection:")?F=B.substring(11):B.startsWith("ref:")?z=B.substring(4):m?U=B:l.push(B)}return{remote:a,syncResource:m,profile:O,collection:F,ref:z,node:U,location:v&&w!==void 0?this.d.joinPath(D.URI.from({scheme:v,authority:w,query:t.query,fragment:t.fragment,path:"/"}),...l):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,k.$uEb)(a))return a}catch(a){this.g.error(a)}throw new g.$5gb((0,L.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const v=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:v}}};e.$G6b=n,e.$G6b=n=o=pe([X(0,g.$Zgb),X(1,g.$1gb),X(2,g.$chb),X(3,S.$Ik),X(4,N.$Wh),X(5,R.$9o),X(6,A.$$j),X(7,C.$Kk),X(8,y.$ji),X(9,u.$Oh)],n)}),define(oe[255],ae([0,1,18,6,26,38,3,2,19,12,32,20,29,11,4,21,22,17,114,115,116,117,118,119,120,24]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f,u,d,E,s,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$85b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Rc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(m,O,F,z,U,B,Y,K,x,V,Q){super(),this.C=m,this.D=O,this.F=F,this.G=z,this.H=U,this.I=B,this.J=Y,this.L=K,this.M=x,this.N=V,this.O=Q,this.f="uninitialized",this.g=this.B(new I.$Nd),this.onDidChangeStatus=this.g.event,this.h=this.B(new I.$Nd),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new I.$Nd),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new I.$Nd),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new I.$Nd),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new I.$Nd),this.onDidResetLocal=this.w.event,this.y=this.B(new I.$Nd),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=F.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Pc)(()=>this.bb()))}async createSyncTask(m,O){this.cb(),this.H.info("Sync started.");const F=new Date().getTime(),z=(0,C.$eg)();try{const K=(0,i.$4gb)(z);O&&(K["Cache-Control"]="no-cache"),m=await this.D.manifest(m,K)}catch(K){const x=i.$5gb.toUserDataSyncError(K);throw w(x,z,this.F,this.I),x}const U=!1,B=this;let Y;return{manifest:m,async run(){if(U)throw new Error("Can run a task only once");Y=(0,L.$Hg)(K=>B.P(m,!1,z,K)),await Y.finally(()=>Y=void 0),B.H.info(`Sync done. Took ${new Date().getTime()-F}ms`),B.$()},stop(){return Y?.cancel(),B.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new i.$5gb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const m=new Date().getTime(),O=(0,C.$eg)(),F=(0,i.$4gb)(O);let z;try{z=await this.D.manifest(null,F)}catch(Y){const K=i.$5gb.toUserDataSyncError(Y);throw w(K,O,this.F,this.I),K}await this.resetLocal();const U=this,B=new N.$Xd;return{id:O,async merge(){return U.P(z,!0,O,B.token)},async apply(){try{try{await U.R(z,O,B.token)}catch(Y){if(i.$5gb.toUserDataSyncError(Y).code==="MethodNotFound")U.H.info("Client is making invalid requests. Cleaning up data..."),await U.cleanUpRemoteData(),U.H.info("Applying manual sync again..."),await U.R(z,O,B.token);else throw Y}}catch(Y){throw U.H.error(Y),Y}U.H.info(`Sync done. Took ${new Date().getTime()-m}ms`),U.$()},async stop(){B.cancel(),await U.U(),await U.resetLocal()}}}async P(m,O,F,z){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const U=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(U,m,O,F,z));const B=U.enabled.find(Y=>Y.resource==="profiles");if(B){const Y=await B.getLastSyncedProfiles()||[];if(z.isCancellationRequested)return;await this.Q(Y,m,O,F,z)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(m,O,F,z,U){for(const B of m){if(U.isCancellationRequested)return;const Y=this.M.profiles.find(x=>x.id===B.id);if(!Y){this.H.error(`Profile with id:${B.id} and name: ${B.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",B.name);const K=this.getOrCreateActiveProfileSynchronizer(Y,B);this.n.push(...await this.S(K,O,F,z,U))}for(const[B,Y]of this.z.entries())this.M.profiles.some(K=>K.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(B))}async R(m,O,F){const z=this.ab();for(const x of z){if(F.isCancellationRequested)return;await x.apply(O,F)}const U=z.find(x=>x.profile.isDefault);if(!U)return;const B=U.enabled.find(x=>x.resource==="profiles");if(!B)return;const K=(await B.getRemoteSyncedProfiles(m?.latest??null)||[]).filter(x=>z.every(V=>V.profile.id!==x.id));K.length&&await this.Q(K,m,!1,O,F)}async S(m,O,F,z,U){return(await m.sync(O,F,z,U)).map(([Y,K])=>({profile:m.profile,syncResource:Y,error:K}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(m=>m.stop()))}async resolveContent(m){const O=await this.N.resolveContent(m);if(O)return O;for(const F of this.ab())for(const z of F.enabled){const U=await z.resolveContent(m);if(U)return U}return null}async replace(m){this.cb();const O=this.N.resolveUserDataSyncResource(m);if(!O)return;const F=await this.resolveContent(m.uri);F&&await this.W(O.profile,async z=>{if(O.syncResource===z.resource)return await z.replace(F),!0})}async accept(m,O,F,z){this.cb(),await this.W(m.profile,async U=>{if(m.syncResource===U.resource)return await U.accept(O,F),z&&await U.apply((0,g.$Ef)(z)?!1:z.force,(0,i.$4gb)((0,C.$eg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async O=>{if(O.resource!=="globalState"&&await O.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async O=>{if(await O.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(m){this.H.error(m)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[m]of this.z.values())try{await m.resetLocal()}catch(O){this.H.error(O)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const m=await this.N.getRemoteSyncedProfiles(),O=m.map(B=>B.collection),F=await this.D.getAllCollections(),z=F.filter(B=>!O.includes(B));z.length&&(this.H.info(`Deleting ${z.length} redundant collections on server`),await Promise.allSettled(z.map(B=>this.D.deleteCollection(B))),this.H.info("Deleted redundant collections on server"));const U=m.filter(B=>F.includes(B.collection));if(U.length!==m.length){const B=this.G.createInstance(n.$55b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await B.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await B.updateRemoteProfiles(U,null),this.H.info("Updated remote profiles on server")}finally{B.dispose()}}}async saveRemoteActivityData(m){this.cb();const O=await this.D.getActivityData();await this.C.writeFile(m,O)}async extractActivityData(m,O){const F=(await this.C.readFile(m)).value.toString(),z=JSON.parse(F);if(z.resources)for(const U in z.resources)for(const B of z.resources[U])await this.O.writeResource(U,B.content,new Date(B.created*1e3),void 0,O);if(z.collections)for(const U in z.collections)for(const B in z.collections[U].resources)for(const Y of z.collections[U].resources?.[B]??[])await this.O.writeResource(B,Y.content,new Date(Y.created*1e3),U,O)}async W(m,O){const F=new R.$Qc;try{const z=this.z.get(m.id);if(z){const x=await this.X(z[0],O,F);return(0,g.$Ff)(x)?null:x}if(m.isDefault){const x=F.add(this.G.createInstance(a,m,void 0)),V=await this.X(x,O,F);return(0,g.$Ff)(V)?null:V}if(this.M.isEnabled())return null;const U=F.add(this.G.createInstance(n.$55b,m,void 0)),B=await this.D.manifest(null),K=(await U.getRemoteSyncedProfiles(B?.latest??null)||[]).find(x=>x.id===m.id);if(K){const x=F.add(this.G.createInstance(a,m,K.collection)),V=await this.X(x,O,F);return(0,g.$Ff)(V)?null:V}return null}finally{F.dispose()}}async X(m,O,F){const z=[...m.enabled,...m.disabled.reduce((U,B)=>(B!=="workspaceState"&&U.push(F.add(m.createSynchronizer(B))),U),[])];for(const U of z){const B=await O(U);if(!(0,g.$Ff)(B))return B}}Y(m){const O=this.f;this.f!==m&&(this.f=m,this.g.fire(m),O==="hasConflicts"&&this.$())}Z(){const m=this.ab().map(O=>O.conflicts).flat();(0,D.$tb)(this.j,m,(O,F)=>O.profile.id===F.profile.id&&O.syncResource===F.syncResource&&(0,D.$tb)(O.conflicts,F.conflicts,(z,U)=>(0,S.$og)(z.previewResource,U.previewResource)))||(this.j=m,this.m.fire(m))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(m,O){let F=this.z.get(m.id);if(F&&F[0].collection!==O?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),F[1].dispose(),F=void 0,this.z.delete(m.id)),!F){const z=new R.$Qc,U=z.add(this.G.createInstance(a,m,O?.collection));z.add(U.onDidChangeStatus(B=>this.Y(B))),z.add(U.onDidChangeConflicts(B=>this.Z())),z.add(U.onDidChangeLocal(B=>this.h.fire(B))),this.z.set(m.id,F=[U,z])}return F[0]}ab(){const m=[];for(const[O]of this.z.values())m.push(O);return m}bb(){this.z.forEach(([,m])=>m.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$85b=r,e.$85b=r=pe([X(0,c.$$j),X(1,i.$Zgb),X(2,i.$Ygb),X(3,$.$Oh),X(4,i.$chb),X(5,p.$cl),X(6,y.$9o),X(7,i.$0gb),X(8,h.$Kk),X(9,i.$_gb),X(10,i.$1gb)],r);let a=class extends R.$Rc{get enabled(){return this.f.sort((m,O)=>m[1]-O[1]).map(([m])=>m)}get disabled(){return i.$Vgb.filter(m=>!this.r.isResourceEnabled(m))}get status(){return this.g}get conflicts(){return this.m}constructor(m,O,F,z,U,B,Y,K,x,V){super(),this.profile=m,this.collection=O,this.r=F,this.t=z,this.u=U,this.w=B,this.y=Y,this.z=K,this.C=x,this.D=V,this.f=[],this.g="idle",this.h=this.B(new I.$Nd),this.onDidChangeStatus=this.h.event,this.j=this.B(new I.$Nd),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new I.$Nd),this.onDidChangeConflicts=this.n.event,this.B(F.onDidChangeResourceEnablement(([Q,G])=>this.F(Q,G))),this.B((0,R.$Pc)(()=>this.f.splice(0,this.f.length).forEach(([,,Q])=>Q.dispose())));for(const Q of i.$Vgb)F.isResourceEnabled(Q)&&this.G(Q)}F(m,O){O?this.G(m):this.H(m)}G(m){if(this.f.some(([U])=>U.resource===m))return;if(m==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(m==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||m==="workspaceState")return;if(m!=="profiles"&&this.profile.useDefaultFlags?.[m]){this.z.debug(`Skipping syncing ${m} in ${this.profile.name} because it is already synced by default profile`);return}const O=new R.$Qc,F=O.add(this.createSynchronizer(m));O.add(F.onDidChangeStatus(()=>this.L())),O.add(F.onDidChangeConflicts(()=>this.M())),O.add(F.onDidChangeLocal(()=>this.j.fire(m)));const z=this.N(m);this.f.push([F,z,O])}H(m){const O=this.f.findIndex(([F])=>F.resource===m);if(O!==-1){const[[F,,z]]=this.f.splice(O,1);z.dispose(),this.L(),Promise.allSettled([F.stop(),F.resetLocal()]).then(null,U=>this.z.error(U))}}createSynchronizer(m){switch(m){case"settings":return this.t.createInstance(E.$h4b,this.profile,this.collection);case"keybindings":return this.t.createInstance(d.$e4b,this.profile,this.collection);case"snippets":return this.t.createInstance(s.$m4b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$p4b,this.profile,this.collection);case"globalState":return this.t.createInstance(u.$CEb,this.profile,this.collection);case"extensions":return this.t.createInstance(f.$_3b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$55b,this.profile,this.collection)}}async sync(m,O,F,z){if(z.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const B=[],Y=(0,i.$4gb)(F),K=(this.collection?m?.collections?.[this.collection]?.latest:m?.latest)??null,x=O?await this.I(K):{};for(const V of U){if(z.isCancellationRequested)return[];if(!this.r.isResourceEnabled(V.resource))return[];try{if(O){const Q=await V.preview(K,x,Y);if(Q)for(const G of Q.resourcePreviews)(G.localChange!==0||G.remoteChange!==0)&&G.mergeState==="preview"&&await V.merge(G.previewResource)}else await V.sync(K,Y)}catch(Q){const G=i.$5gb.toUserDataSyncError(Q);if(w(G,F,this.w,this.y),v(Q))throw G;this.z.error(Q),this.z.error(`${V.resource}: ${(0,A.$Ai)(Q)}`),B.push([V.resource,G])}}return B}finally{this.L()}}async apply(m,O){const F=(0,i.$4gb)(m);for(const z of this.enabled){if(O.isCancellationRequested)return;try{await z.apply(!1,F)}catch(U){const B=i.$5gb.toUserDataSyncError(U);if(w(B,m,this.w,this.y),v(U))throw B;this.z.error(U),this.z.error(`${z.resource}: ${(0,A.$Ai)(U)}`)}}}async stop(){for(const m of this.enabled)try{m.status!=="idle"&&await m.stop()}catch(O){this.z.error(O)}}async resetLocal(){for(const m of this.enabled)try{await m.resetLocal()}catch(O){this.z.error(`${m.resource}: ${(0,A.$Ai)(O)}`),this.z.error(O)}}async I(m){if(!this.profile.isDefault)return{};const O=this.D.getValue(i.$Rgb),F=this.enabled.find(z=>z instanceof E.$h4b);if(F){const z=await F.getRemoteUserDataSyncConfiguration(m);return{...O,...z}}return O}J(m){this.g!==m&&(this.g=m,this.h.fire(m))}L(){return this.M(),this.enabled.some(m=>m.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(m=>m.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const m=this.enabled.filter(O=>O.status==="hasConflicts").filter(O=>O.conflicts.conflicts.length>0).map(O=>O.conflicts);(0,D.$tb)(this.m,m,(O,F)=>O.syncResource===F.syncResource&&(0,D.$tb)(O.conflicts,F.conflicts,(z,U)=>(0,S.$og)(z.previewResource,U.previewResource)))||(this.m=m,this.n.fire(m))}N(m){switch(m){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=pe([X(2,i.$0gb),X(3,$.$Oh),X(4,b.$ao),X(5,i.$Ygb),X(6,p.$cl),X(7,i.$chb),X(8,h.$Kk),X(9,k.$ji)],a);function v(l){if(l instanceof i.$5gb)switch(l.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function w(l,m,O,F){F.publicLog2("sync/error",{code:l.code,serverCode:l instanceof i.$6gb?String(l.serverCode):void 0,url:l instanceof i.$6gb?l.url:void 0,resource:l.resource,executionId:m,service:O.userDataSyncStore.url.toString()})}}),define(oe[256],ae([0,1,3,2,10,17,24]),function(te,e,D,L,N,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t9b=e.$s9b=void 0;function R(b,c){return{...b,profile:(0,A.$Lk)(b.profile,c.profilesHome.scheme)}}function S(b){return{created:b.created,uri:N.URI.revive(b.uri)}}class g{constructor(c,$,y){this.c=c,this.d=$,this.f=y,this.a=new Map,this.b=new D.$Nd}listen(c,$){switch($){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${$}`)}async call(c,$,y){try{return await this.g(c,$,y)}catch(p){throw this.f.error(p),p}}async g(c,$,y){switch($){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(N.URI.revive(y[0]));case"accept":return this.c.accept(R(y[0],this.d),N.URI.revive(y[1]),y[2],y[3]);case"replace":return this.c.replace(S(y[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(N.URI.revive(y[0]));case"extractActivityData":return this.c.extractActivityData(N.URI.revive(y[0]),N.URI.revive(y[1]));case"createManualSyncTask":return this.i()}if($.startsWith("manualSync/")){const p=$.substring(11),h=y[0],f=this.h(h);switch(y=y.slice(1),p){case"merge":return f.merge();case"apply":return f.apply().then(()=>this.a.delete(this.j(f.id)));case"stop":return f.stop().finally(()=>this.a.delete(this.j(f.id)))}}throw new Error("Invalid call")}h(c){const $=this.a.get(this.j(c));if(!$)throw new Error(`Manual sync taks not found: ${c}`);return $}async i(){const c=await this.c.createManualSyncTask();return this.a.set(this.j(c.id),c),c.id}j(c){return`manualSyncTask-${c}`}}e.$s9b=g;let C=class extends L.$Rc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(c,$){super(),this.n=$,this.b="uninitialized",this.c=this.B(new D.$Nd),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.$Nd),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new D.$Nd),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new D.$Nd),this.onSyncErrors=this.m.event,this.a={call(y,p,h){return c.call(y,p,h).then(null,f=>{throw I.$5gb.toUserDataSyncError(f)})},listen(y,p){return c.listen(y,p)}},this.a.call("_getInitialData").then(([y,p,h])=>{this.s(y),this.t(p),h&&this.u(h),this.B(this.a.listen("onDidChangeStatus")(f=>this.s(f))),this.B(this.a.listen("onDidChangeLastSyncTime")(f=>this.u(f)))}),this.B(this.a.listen("onDidChangeConflicts")(y=>this.t(y))),this.B(this.a.listen("onSyncErrors")(y=>this.m.fire(y.map(p=>({...p,error:I.$5gb.toUserDataSyncError(p.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const c=await this.a.call("createManualSyncTask"),$=this;return new k(c,{async call(p,h,f){return $.a.call(`manualSync/${p}`,[c,...Array.isArray(h)?h:[h]],f)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(c,$,y,p){return this.a.call("accept",[c,$,y,p])}resolveContent(c){return this.a.call("resolveContent",[c])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(c){return this.a.call("replace",[c])}saveRemoteActivityData(c){return this.a.call("getRemoteActivityData",[c])}extractActivityData(c,$){return this.a.call("extractActivityData",[c,$])}async s(c){this.b=c,this.c.fire(c)}async t(c){this.f=c.map($=>({syncResource:$.syncResource,profile:(0,A.$Lk)($.profile,this.n.profilesHome.scheme),conflicts:$.conflicts.map(y=>({...y,baseResource:N.URI.revive(y.baseResource),localResource:N.URI.revive(y.localResource),remoteResource:N.URI.revive(y.remoteResource),previewResource:N.URI.revive(y.previewResource)}))})),this.g.fire(this.f)}u(c){this.h!==c&&(this.h=c,this.j.fire(c))}};e.$t9b=C,e.$t9b=C=pe([X(1,A.$Kk)],C);class k extends L.$Rc{constructor(c,$){super(),this.id=c,this.a=$}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[257],ae([0,1,6,26,7,3,2,139,5,19,12,10,32,20,14,11,25,57,43,21,24]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sEb=e.$rEb=e.$qEb=e.$pEb=e.$oEb=void 0;const E="configurationSync.store",s="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends I.$Rc{get userDataSyncStore(){return this.b}get c(){return this.h.get(d.$8gb,-1)}set c(F){this.h.store(d.$8gb,F,-1,S.$p?0:1)}constructor(F,z,U){super(),this.f=F,this.g=z,this.h=U,this.a=this.B(new A.$Nd),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const B=this.B(new I.$Qc);this.B(A.Event.filter(U.onDidChangeValue(-1,d.$8gb,B),()=>this.c!==this.userDataSyncStore?.type,B)(()=>this.j()))}j(){this.b=this.m(this.f[E]),this.a.fire()}m(F){if(F&&(F=S.$p&&F.web?{...F,...F.web}:F,(0,C.$yf)(F.url)&&(0,C.$Af)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(z=>Array.isArray(F.authenticationProviders[z].scopes)))){const z=F,U=!!z.canSwitch,B=z.url===z.insidersUrl?"insiders":"stable",Y=(U?this.c:void 0)||B,K=Y==="insiders"?z.insidersUrl:Y==="stable"?z.stableUrl:z.url;return{url:k.URI.parse(K),type:Y,defaultType:B,defaultUrl:k.URI.parse(z.url),stableUrl:k.URI.parse(z.stableUrl),insidersUrl:k.URI.parse(z.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(z.authenticationProviders).reduce((x,V)=>(x.push({id:V,scopes:z.authenticationProviders[V].scopes}),x),[])}}}};e.$oEb=a,e.$oEb=a=pe([X(0,p.$pj),X(1,c.$ji),X(2,u.$9o)],a);let v=class extends a{constructor(F,z,U){super(F,z,U);const B=this.h.get(s,-1);B&&(this.n=JSON.parse(B));const Y=this.f[E];Y?this.h.store(s,JSON.stringify(Y),-1,1):this.h.remove(s,-1)}async switch(F){F!==this.c&&(this.c=F,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$pEb=v,e.$pEb=v=pe([X(0,p.$pj),X(1,c.$ji),X(2,u.$9o)],v);let w=class extends I.$Rc{get donotMakeRequestsUntil(){return this.j}constructor(F,z,U,B,Y,K,x){super(),this.n=U,this.r=B,this.s=x,this.g=this.B(new A.$Nd),this.onTokenFailed=this.g.event,this.h=this.B(new A.$Nd),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$Nd),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(F),this.c=(0,f.$cp)(Y,K,x).then(V=>{const Q={"X-Client-Name":`${z.applicationName}${S.$p?"-web":""}`,"X-Client-Version":z.version};return z.commit&&(Q["X-Client-Commit"]=z.commit),Q}),this.f=new m(t,r,this.n,this.r),this.u(),this.B((0,I.$Pc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(F,z){this.b={token:F,type:z}}t(F){this.a=F?(0,g.$vg)(F,"v1"):void 0}u(){const F=this.s.getNumber(o,-1);F&&Date.now()<F&&this.y(new Date(F))}y(F){this.j?.getTime()!==F?.getTime()&&(this.j=F,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,D.$Hg)(z=>(0,D.$Ug)(this.j.getTime()-Date.now(),z).then(()=>this.y(void 0))),this.w.then(null,z=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,g.$vg)(this.a,"collection").toString();F={...F},F["Content-Type"]="application/json";const U=await this.D(z,{type:"GET",headers:F},[],L.CancellationToken.None);return(await(0,h.$2o)(U))?.map(({id:B})=>B)||[]}async createCollection(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,g.$vg)(this.a,"collection").toString();F={...F},F["Content-Type"]=R.$Sr.text;const U=await this.D(z,{type:"POST",headers:F},[],L.CancellationToken.None),B=await(0,h.$1o)(U);if(!B)throw new d.$6gb("Server did not return the collection id",z,"NoCollection",U.res.statusCode,U.res.headers[d.$2gb]);return B}async deleteCollection(F,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=F?(0,g.$vg)(this.a,"collection",F).toString():(0,g.$vg)(this.a,"collection").toString();z={...z},await this.D(U,{type:"DELETE",headers:z},[],L.CancellationToken.None)}async getAllResourceRefs(F,z){if(!this.a)throw new Error("No settings sync store url configured.");const U=this.z(this.a,z,F),B={},Y=await this.D(U.toString(),{type:"GET",headers:B},[],L.CancellationToken.None);return(await(0,h.$2o)(Y)||[]).map(({url:x,created:V})=>({ref:(0,g.$xg)(U,U.with({path:x})),created:V*1e3}))}async resolveResourceContent(F,z,U,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,g.$vg)(this.z(this.a,U,F),z).toString();B={...B},B["Cache-Control"]="no-cache";const K=await this.D(Y,{type:"GET",headers:B},[],L.CancellationToken.None);return await(0,h.$1o)(K)}async deleteResource(F,z,U){if(!this.a)throw new Error("No settings sync store url configured.");const B=z!==null?(0,g.$vg)(this.z(this.a,U,F),z).toString():this.z(this.a,U,F).toString(),Y={};await this.D(B,{type:"DELETE",headers:Y},[],L.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$vg)(this.a,"resource").toString(),z={"Content-Type":R.$Sr.text};await this.D(F,{type:"DELETE",headers:z},[],L.CancellationToken.None)}async readResource(F,z,U,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,g.$vg)(this.z(this.a,U,F),"latest").toString();B={...B},B["Cache-Control"]="no-cache",z&&(B["If-None-Match"]=z.ref);const K=await this.D(Y,{type:"GET",headers:B},[304],L.CancellationToken.None);let x=null;if(K.res.statusCode===304&&(x=z),x===null){const V=K.res.headers.etag;if(!V)throw new d.$6gb("Server did not return the ref",Y,"NoRef",K.res.statusCode,K.res.headers[d.$2gb]);const Q=await(0,h.$1o)(K);if(!Q&&K.res.statusCode===304)throw new d.$6gb("Empty response",Y,"EmptyResponse",K.res.statusCode,K.res.headers[d.$2gb]);x={ref:V,content:Q}}return x}async writeResource(F,z,U,B,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=this.z(this.a,B,F).toString();Y={...Y},Y["Content-Type"]=R.$Sr.text,U&&(Y["If-Match"]=U);const x=await this.D(K,{type:"POST",data:z,headers:Y},[],L.CancellationToken.None),V=x.res.headers.etag;if(!V)throw new d.$6gb("Server did not return the ref",K,"NoRef",x.res.statusCode,x.res.headers[d.$2gb]);return V}async manifest(F,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,g.$vg)(this.a,"manifest").toString();z={...z},z["Content-Type"]="application/json",F&&(z["If-None-Match"]=F.ref);const B=await this.D(U,{type:"GET",headers:z},[304],L.CancellationToken.None);let Y=null;if(B.res.statusCode===304&&(Y=F),!Y){const x=B.res.headers.etag;if(!x)throw new d.$6gb("Server did not return the ref",U,"NoRef",B.res.statusCode,B.res.headers[d.$2gb]);const V=await(0,h.$1o)(B);if(!V&&B.res.statusCode===304)throw new d.$6gb("Empty response",U,"EmptyResponse",B.res.statusCode,B.res.headers[d.$2gb]);V&&(Y={...JSON.parse(V),ref:x})}const K=this.s.get(n,-1);return K&&Y&&K!==Y.session&&this.C(),Y===null&&K&&this.C(),Y&&this.s.store(n,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$vg)(this.a,"download").toString(),z={},U=await this.D(F,{type:"GET",headers:z},[],L.CancellationToken.None);if(!(0,h.$Xo)(U))throw new d.$6gb("Server returned "+U.res.statusCode,F,"EmptyResponse",U.res.statusCode,U.res.headers[d.$2gb]);if((0,h.$Yo)(U))throw new d.$6gb("Empty response",F,"EmptyResponse",U.res.statusCode,U.res.headers[d.$2gb]);return U.stream}z(F,z,U){return z?(0,g.$vg)(F,"collection",z,"resource",U):(0,g.$vg)(F,"resource",U)}C(){this.s.remove(n,-1),this.s.remove(i,-1)}async D(F,z,U,B){if(!this.b)throw new d.$6gb("No Auth Token Available",F,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new d.$6gb(`${z.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;z.headers={...z.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(z.headers),this.r.trace("Sending request to server",{url:F,type:z.type,headers:{...z.headers,authorization:void 0}});let K;try{K=await this.f.request(F,z,B)}catch(W){if(!(W instanceof d.$6gb)){let ee="RequestFailed";const ie=(0,N.$9)(W).toLowerCase();ie.includes("xhr timeout")?ee="RequestTimeout":ie.includes("protocol")&&ie.includes("not supported")?ee="RequestProtocolNotSupported":ie.includes("request path contains unescaped characters")?ee="RequestPathNotEscaped":ie.includes("headers must be an object")?ee="RequestHeadersNotObject":(0,N.$3)(W)&&(ee="RequestCanceled"),W=new d.$6gb(`Connection refused for the request '${F}'.`,F,ee,void 0,void 0)}throw this.r.info("Request failed",F),W}const x=K.res.headers[d.$2gb],V={url:F,status:K.res.statusCode,"execution-id":z.headers[d.$3gb],"operation-id":x},Q=(0,h.$Xo)(K)||K.res.statusCode&&U.includes(K.res.statusCode);let G="";if(Q?this.r.trace("Request succeeded",V):(G=await(0,h.$Zo)(K)||"",this.r.info("Request failed",V,G)),K.res.statusCode===401||K.res.statusCode===403){if(this.b=void 0,K.res.statusCode===401)throw this.g.fire("Unauthorized"),new d.$6gb(`${z.type} request '${F}' failed because of Unauthorized (401).`,F,"Unauthorized",K.res.statusCode,x);if(K.res.statusCode===403)throw this.g.fire("Forbidden"),new d.$6gb(`${z.type} request '${F}' failed because the access is forbidden (403).`,F,"Forbidden",K.res.statusCode,x)}if(this.h.fire(),K.res.statusCode===404)throw new d.$6gb(`${z.type} request '${F}' failed because the requested resource is not found (404).`,F,"NotFound",K.res.statusCode,x);if(K.res.statusCode===405)throw new d.$6gb(`${z.type} request '${F}' failed because the requested endpoint is not found (405). ${G}`,F,"MethodNotFound",K.res.statusCode,x);if(K.res.statusCode===409)throw new d.$6gb(`${z.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,"Conflict",K.res.statusCode,x);if(K.res.statusCode===410)throw new d.$6gb(`${z.type} request '${F}' failed because the requested resource is not longer available (410).`,F,"Gone",K.res.statusCode,x);if(K.res.statusCode===412)throw new d.$6gb(`${z.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,"PreconditionFailed",K.res.statusCode,x);if(K.res.statusCode===413)throw new d.$6gb(`${z.type} request '${F}' failed because of too large payload (413).`,F,"TooLarge",K.res.statusCode,x);if(K.res.statusCode===426)throw new d.$6gb(`${z.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,"UpgradeRequired",K.res.statusCode,x);if(K.res.statusCode===429){const W=K.res.headers["retry-after"];throw W?(this.y(new Date(Date.now()+parseInt(W)*1e3)),new d.$6gb(`${z.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",K.res.statusCode,x)):new d.$6gb(`${z.type} request '${F}' failed because of too many requests (429).`,F,"RemoteTooManyRequests",K.res.statusCode,x)}if(!Q)throw new d.$6gb("Server returned "+K.res.statusCode,F,"Unknown",K.res.statusCode,x);return K}F(F){let z=this.s.get(i,-1);z===void 0&&(z=(0,b.$eg)(),this.s.store(i,z,-1,1)),F["X-Machine-Session-Id"]=z;const U=this.s.get(n,-1);U!==void 0&&(F["X-User-Session-Id"]=U)}};e.$qEb=w,e.$qEb=w=pe([X(1,p.$pj),X(2,h.$Vo),X(3,d.$chb),X(4,$.$Wh),X(5,y.$$j),X(6,u.$9o)],w);let l=class extends w{constructor(F,z,U,B,Y,K,x){super(F.userDataSyncStore?.url,z,U,B,Y,K,x),this.B(F.onDidChangeUserDataSyncStore(()=>this.t(F.userDataSyncStore?.url)))}};e.$rEb=l,e.$rEb=l=pe([X(0,d.$Ygb),X(1,p.$pj),X(2,h.$Vo),X(3,d.$chb),X(4,$.$Wh),X(5,y.$$j),X(6,u.$9o)],l);class m{constructor(F,z,U,B){this.c=F,this.d=z,this.f=U,this.g=B,this.a=[],this.b=void 0}request(F,z,U){if(this.h()&&this.i(),z.url=F,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new d.$6gb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,F,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(F),this.f.request(z,U)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$sEb=m}),define(oe[258],ae([0,1,3,55,25,21,22,253,24,79,82]),function(te,e,D,L,N,A,I,R,S,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N9b=void 0;let k=class extends R.$95b{constructor(c,$,y,p,h,f,u,d,E,s,o){super(c,$,y,p,h,u,d,E,s,o),this.B(D.Event.debounce(D.Event.any(D.Event.map(f.onDidFocusWindow,()=>"windowFocus"),D.Event.map(f.onDidOpenWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$N9b=k,e.$N9b=k=pe([X(0,N.$pj),X(1,S.$Ygb),X(2,S.$Zgb),X(3,S.$0gb),X(4,S.$$gb),X(5,L.$E7b),X(6,S.$chb),X(7,g.$6Cb),X(8,I.$cl),X(9,C.$Mgb),X(10,A.$9o)],k)}),define(oe[259],ae([0,1,70,23,5,19]),function(te,e,D,L,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7b=e.$_6b=e.$$6b=e.$06b=void 0,e.$06b=128/4;function I(g){function C(){let k=g.scheme===L.Schemas.file?(0,A.$jg)(g):g.toString();return N.$l||(k=k.toLowerCase()),(0,D.createHash)("md5").update(k).digest("hex")}return{id:C(),configPath:g}}e.$$6b=I;function R(g,C){function k(){if(g.scheme!==L.Schemas.file)return(0,D.createHash)("md5").update(g.toString()).digest("hex");if(!C)return;let c;return N.$l?c=C.ino:N.$k?c=C.birthtime.getTime():N.$j&&(typeof C.birthtimeMs=="number"?c=Math.floor(C.birthtimeMs):c=C.birthtime.getTime()),(0,D.createHash)("md5").update(g.fsPath).update(c?String(c):"").digest("hex")}const b=k();if(typeof b=="string")return{id:b,uri:g}}e.$_6b=R;function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$a7b=S}),define(oe[260],ae([0,1,6,7,2,16,31,14,8,76,112,259,55,72,23]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h9b=void 0;let y=class extends N.$Rc{constructor(h,f,u,d){super(),this.a=h,this.b=f,this.c=u,this.f=d,this.B(new D.$6g(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=this.a.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,f=await I.Promises.readdir(h),u=new g.$EDb(this.f.getChannel("storage"));await Promise.all(f.map(async d=>{const E=(0,A.$ic)(h,d);d.length===k.$06b||d===C.$2h.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===d)||await u.isUsed(E)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await I.Promises.rm(E))}))}catch(h){(0,L.$Z)(h)}}};e.$h9b=y,e.$h9b=y=pe([X(0,R.$Xh),X(1,S.$0i),X(2,b.$E7b),X(3,c.$S8b)],y)}),define(oe[83],ae([0,1,53,6,16,12,31,147,271,272]),function(te,e,D,L,N,A,I,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.zip=e.$op=e.$np=void 0,e.$np="end of central directory record signature not found";const C=new RegExp(e.$np);class k extends Error{constructor(o,n){let i=n.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=n}}e.$op=k;function b(s){const o=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>o&n).reduce((n,i)=>n+i,o&61440)}function c(s){if(s instanceof k)return s;let o;return C.test(s.message)&&(o="CorruptZip"),new k(o,s)}function $(s,o,n,i,t,r){const a=N.$lc(o),v=N.$ic(i,a);if(!v.startsWith(i))return Promise.reject(new Error(R.localize(0,null,o)));const w=N.$ic(i,o);let l;return r.onCancellationRequested(()=>{l?.destroy()}),Promise.resolve(I.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((m,O)=>{if(!r.isCancellationRequested)try{l=(0,D.createWriteStream)(w,{mode:n}),l.once("close",()=>m()),l.once("error",O),s.once("error",O),s.pipe(l)}catch(F){O(F)}}))}function y(s,o,n,i){let t=(0,L.$Hg)(()=>Promise.resolve()),r=0;const a=i.onCancellationRequested(()=>{t.cancel(),s.close()});return new Promise((v,w)=>{const l=new L.$Og,m=O=>{O.isCancellationRequested||(r++,s.readEntry())};s.once("error",w),s.once("close",()=>t.then(()=>{i.isCancellationRequested||s.entryCount===r?v():w(new k("Incomplete",new Error(R.localize(1,null,r,s.entryCount))))},w)),s.readEntry(),s.on("entry",O=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(O.fileName)){m(i);return}const F=O.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(F)){const B=N.$ic(o,F);t=(0,L.$Hg)(Y=>I.Promises.mkdir(B,{recursive:!0}).then(()=>m(Y)).then(void 0,w));return}const z=h(s,O),U=b(O);t=(0,L.$Hg)(B=>l.queue(()=>z.then(Y=>$(Y,F,U,o,n,B).then(()=>m(B)))).then(null,w))})}).finally(()=>a.dispose())}function p(s,o=!1){return new Promise((n,i)=>{(0,S.open)(s,o?{lazyEntries:!0}:void 0,(t,r)=>{t?i(c(t)):n((0,A.$Jf)(r))})})}function h(s,o){return new Promise((n,i)=>{s.openReadStream(o,(t,r)=>{t?i(c(t)):n((0,A.$Jf)(r))})})}function f(s,o){return new Promise((n,i)=>{const t=new g.ZipFile;o.forEach(a=>{a.contents?t.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&t.addFile(a.localPath,a.path)}),t.end();const r=(0,D.createWriteStream)(s);t.outputStream.pipe(r),t.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>n(s))})}e.zip=f;function u(s,o,n={},i){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=p(s,!0);return n.overwrite&&(r=r.then(a=>I.Promises.rm(o).then(()=>a))),r.then(a=>y(a,o,{sourcePathRegex:t},i))}e.$qp=u;function d(s,o){return p(s).then(n=>new Promise((i,t)=>{n.on("entry",r=>{r.fileName===o&&h(n,r).then(a=>i(a),a=>t(a))}),n.once("close",()=>t(new Error(R.localize(2,null,o))))}))}function E(s,o){return d(s,o).then(n=>new Promise((i,t)=>{const r=[];n.once("error",t),n.on("data",a=>r.push(a)),n.on("end",()=>i(Buffer.concat(r)))}))}e.$rp=E}),define(oe[261],ae([0,1,6,7,2,23,19,54,12,32,31,83,20,14,29,33,97,11,8]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;let d=class extends N.$Rc{static{u=this}static{this.c=".sigzip"}constructor(s,o,n,i,t,r){super(),this.h=o,this.j=n,this.m=i,this.n=t,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,n){await this.g;const i=(0,I.$vg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new $.$bo(r.message,$.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(s)){const r=await this.u(s);try{t=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(a){const v=a;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${v.output}`),t===$.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===$.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new $.$bo(k.$np,$.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${s.identifier.id}`),{location:i,verificationStatus:t}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,S.$Ef)(o)?o:!0}async u(s){await this.g;const o=(0,I.$vg)(this.extensionsDownloadDir,`${this.z(s)}${u.c}`);return await this.w(s,o,n=>this.j.downloadSignatureArchive(s,n)),o}async w(s,o,n){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await n(o);return}const i=(0,I.$vg)(this.extensionsDownloadDir,`.${(0,g.$eg)()}`);await this.h.exists(i)||await n(i);try{await C.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(i)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,L.$9)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],n=[],i=[];for(const a of s.children)if(a.name.endsWith(u.c))i.push(a.resource);else{const v=y.$Do.parse(a.name);v&&n.push([v,a])}const t=(0,y.$Io)(n,([a])=>a),r=[];for(const a of t)a.sort((v,w)=>R.rcompare(v[0].version,w[0].version)),o.push(...a.slice(1).map(v=>v[1].resource)),r.push(a[0][1]);r.sort((a,v)=>a.mtime-v.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...i),await D.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(s){this.r.error(s)}}z(s){return this.f?y.$Do.create(s).toString().toLowerCase():(0,g.$eg)()}};e.$Gp=d,e.$Gp=d=u=pe([X(0,c.$Xh),X(1,h.$$j),X(2,$.$ao),X(3,b.$ji),X(4,p.$hp),X(5,f.$0i)],d)}),define(oe[262],ae([0,1,83,156]),function(te,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;function N(A){return(0,D.$rp)(A,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,L.localize)(0,null))}})}e.$Ip=N}),define(oe[121],ae([0,1,6,15,26,38,7,3,52,2,34,23,16,19,54,12,10,32,31,83,155,96,14,241,29,33,51,80,261,242,262,211,222,68,11,4,8,25,22,28,17]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f,u,d,E,s,o,n,i,t,r,a,v,w,l,m,O,F,z,U,B,Y,K,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.$Mp=e.$Lp=void 0,e.$Lp=(0,z.$Qh)(n.$co);const V=".vsctmp";let Q=class extends o.$sp{constructor(Z,q,P,j,T,M,H,J,re,ce,ue,he){super(Z,q,ue,P,ce,he),this.fb=T,this.gb=M,this.hb=H,this.ib=re,this.eb=new Map,this.rb=new C.$Ac;const $e=this.B(J.createInstance(v.$Hp));this.bb=this.B(J.createInstance(G,we=>$e.postUninstall(we))),this.cb=this.B(new l.$Jp(he,re,ue,this,this.F)),this.db=this.B(J.createInstance(a.$Gp));const de=this.B(new m.$Kp(this,this.fb,he,M,ue,re,P));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$No)(this.ib,this.F)),this.jb}async zip(Z){this.F.trace("ExtensionManagementService#zip",Z.identifier.id);const q=await this.pb(Z),P=await(0,u.zip)((0,c.$vg)(this.db.extensionsDownloadDir,(0,h.$eg)()).fsPath,q);return p.URI.file(P)}async unzip(Z){return this.F.trace("ExtensionManagementService#unzip",Z.toString()),(await this.install(Z)).identifier}async getManifest(Z){const{location:q,cleanup:P}=await this.lb(Z),j=b.$jc(q.fsPath);try{return await(0,w.$Ip)(j)}finally{await P()}}getInstalled(Z,q=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(Z??null,q)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Z){return this.bb.scanUserExtensionAtLocation(Z)}async install(Z,q={}){this.F.trace("ExtensionManagementService#install",Z.toString());const{location:P,cleanup:j}=await this.lb(Z);try{const T=await(0,w.$Ip)(b.$jc(P.fsPath)),M=(0,i.$Ho)(T.publisher,T.name);if(T.engines&&T.engines.vscode&&!(0,O.$Uo)(T.engines.vscode,this.G.version,this.G.date))throw new Error(d.localize(0,null,M,this.G.version));const J=(await this.I([{manifest:T,extension:P,options:q}])).find(({identifier:re})=>(0,i.$Co)(re,{id:M}));if(J?.local)return J.local;throw J?.error?J.error:(0,o.$up)(new Error(`Unknown error while installing extension ${M}`))}finally{await j()}}async installFromLocation(Z,q){this.F.trace("ExtensionManagementService#installFromLocation",Z.toString());const P=await this.bb.scanUserExtensionAtLocation(Z);if(!P)throw new Error(`Cannot find a valid extension from the location ${Z.toString()}`);return await this.ub([[P,void 0]],q),this.F.info("Successfully installed extension",P.identifier.id,q.toString()),P}async installExtensionsFromProfile(Z,q,P){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Z,q.toString(),P.toString());const j=(await this.bb.scanExtensions(1,q)).filter(T=>Z.some(M=>(0,i.$Co)(M,T.identifier)));if(j.length){const T=await Promise.all(j.map(M=>this.bb.scanMetadata(M,q)));await this.ub(j.map((M,H)=>[M,T[H]]),P),this.F.info("Successfully installed extensions",j.map(M=>M.identifier.id),P.toString())}return j}async updateMetadata(Z,q,P=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",Z.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),Z=await this.bb.updateMetadata(Z,q,P),this.cb.invalidate(P),this.w.fire(Z),Z}async reinstallFromGallery(Z){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Z.identifier.id),!this.z.isEnabled())throw new Error(d.localize(1,null));const q=await this.getTargetPlatform(),[P]=await this.z.getExtensions([{...Z.identifier,preRelease:Z.preRelease}],{targetPlatform:q,compatible:!0},N.CancellationToken.None);if(!P)throw new Error(d.localize(2,null));await this.bb.setUninstalled(Z);try{await this.bb.removeUninstalledExtension(Z)}catch(j){throw new Error(d.localize(3,null,(0,A.$Ai)(j)))}return this.installFromGallery(P)}ab(Z,q,P,j){return this.bb.copyExtension(Z,q,P,j)}copyExtensions(Z,q){return this.bb.copyExtensions(Z,q)}markAsUninstalled(...Z){return this.bb.setUninstalled(...Z)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(Z){this.F.error(Z)}}async download(Z,q,P){const{location:j}=await this.db.download(Z,q,!P);return j}async lb(Z){if(Z.scheme===k.Schemas.file)return{location:Z,async cleanup(){}};this.F.trace("Downloading extension from",Z.toString());const q=(0,c.$vg)(this.db.extensionsDownloadDir,(0,h.$eg)());return await this.hb.download(Z,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.ib.del(q)}catch(j){this.F.error(j)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(Z,q,P){if(p.URI.isUri(q))return new ie(Z,q,P,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const j=i.$Do.create(q).toString();let T=this.eb.get(j);return T||(this.eb.set(j,T=new ee(Z,q,P,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),T.waitUntilTaskIsFinished().finally(()=>this.eb.delete(j))),T}$(Z,q){return new _(Z,q.profileLocation,this.gb)}async pb(Z){const q=async j=>{let T=await f.Promises.readdir(j);T=T.map(J=>b.$ic(j,J));const M=await Promise.all(T.map(J=>f.Promises.stat(J)));let H=Promise.resolve([]);return M.forEach((J,re)=>{const ce=T[re];J.isFile()&&(H=H.then(ue=>[...ue,ce])),J.isDirectory()&&(H=H.then(ue=>q(ce).then(he=>[...ue,...he])))}),H};return(await q(Z.location.fsPath)).map(j=>({path:`extension/${b.$kc(Z.location.fsPath,j)}`,localPath:j}))}async qb({added:Z,removed:q}){if(q){const P=Z&&this.D.extUri.isEqual(q.profileLocation,Z.profileLocation)?q.extensions.filter(j=>Z.extensions.every(T=>!(0,i.$Co)(T,j))):q.extensions;for(const j of P)this.F.info("Extensions removed from another source",j.id,q.profileLocation.toString()),this.u.fire({identifier:j,profileLocation:q.profileLocation})}if(Z){const j=(await this.bb.scanExtensions(1,Z.profileLocation)).filter(T=>Z.extensions.some(M=>(0,i.$Co)(M,T.identifier)));this.s.fire(j.map(T=>(this.F.info("Extensions added from another source",T.identifier.id,Z.profileLocation.toString()),{identifier:T.identifier,local:T,profileLocation:Z.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(q=>this.rb.add(q)));const Z=await this.ib.resolve(this.fb.userExtensionsLocation);for(const q of Z.children??[])q.isDirectory&&this.rb.add(q.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(q=>this.tb(q)))}async tb(Z){if(!Z.affects(this.fb.userExtensionsLocation,1))return;const q=[];for(const P of Z.rawAdded){if(this.rb.has(P)||!this.D.extUri.isEqual(this.D.extUri.dirname(P),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(P,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(P).startsWith(".")||!(await this.ib.stat(P)).isDirectory)continue;const j=await this.bb.scanUserExtensionAtLocation(P);j&&j.installedTimestamp===void 0&&(this.rb.add(P),q.push(j))}q.length&&(await this.ub(q.map(P=>[P,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(P=>P.identifier.id)))}async ub(Z,q){const P=Z.map(j=>j[0]);await this.vb(P),await this.gb.addExtensionsToProfile(Z,q),this.s.fire(P.map(j=>({local:j,identifier:j.identifier,operation:1,profileLocation:q})))}async vb(Z){const q=await this.bb.getUninstalledExtensions();for(const P of Z){const j=i.$Do.create(P);q[j.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",j.id),await this.bb.setInstalled(j),this.F.info("Removed the extension from uninstalled list:",j.id))}}};e.$Mp=Q,e.$Mp=Q=pe([X(0,n.$ao),X(1,Y.$cl),X(2,U.$0i),X(3,s.$Xh),X(4,r.$Bp),X(5,t.$xp),X(6,E.$Rn),X(7,z.$Oh),X(8,F.$$j),X(9,B.$pj),X(10,K.$Ik),X(11,x.$Kk)],Q);let G=class extends g.$Rc{constructor(Z,q,P,j,T,M){super(),this.j=Z,this.m=q,this.n=P,this.s=j,this.t=T,this.u=M,this.h=this.B(new R.$Nd),this.onExtract=this.h.event,this.c=(0,c.$vg)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$1g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(Z,q){const P={includeInvalid:!0,profileLocation:q};let j=[];return Z===null||Z===0?j.push(...await this.n.scanAllExtensions({includeInvalid:!0},P,!1)):Z===1&&j.push(...await this.n.scanUserExtensions(P)),j=Z!==null?j.filter(T=>T.type===Z):j,Promise.all(j.map(T=>this.F(T)))}async scanAllUserExtensions(Z){const q=await this.n.scanUserExtensions({includeAllVersions:!Z,includeInvalid:!0});return Promise.all(q.map(P=>this.F(P)))}async scanUserExtensionAtLocation(Z){try{const q=await this.n.scanExistingExtension(Z,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(Z,q,P,j,T){const M=Z.toString(),H=p.URI.file(b.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,h.$eg)()}`)),J=p.URI.file(b.$ic(this.n.userExtensionsLocation.fsPath,M));let re=await this.m.exists(J);if(re&&j){try{await this.y(Z.id,J,"removeExisting")}catch{throw new n.$bo(d.localize(4,null,J.fsPath,Z.id),n.ExtensionManagementErrorCode.Delete)}re=!1}if(!re)try{try{this.u.trace(`Started extracting the extension from ${q} to ${J.fsPath}`),await(0,u.$qp)(q,H.fsPath,{sourcePath:"extension",overwrite:!0},T),this.u.info(`Extracted extension to ${J}:`,Z.id)}catch(ce){let ue=n.ExtensionManagementErrorCode.Extract;throw ce instanceof u.$op&&(ce.type==="CorruptZip"?ue=n.ExtensionManagementErrorCode.CorruptZip:ce.type==="Incomplete"&&(ue=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$bo(ce.message,ue)}await this.n.updateMetadata(H,P);try{this.u.trace(`Started renaming the extension from ${H.fsPath} to ${J.fsPath}`),await this.C(H.fsPath,J.fsPath),this.u.info("Renamed to",J.fsPath)}catch(ce){if(ce.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",Z.id);else throw this.u.info(`Rename failed because of ${(0,I.$9)(ce)}. Deleted from extracted location`,H),ce}this.h.fire(J)}catch(ce){try{await this.m.del(H,{recursive:!0})}catch{}throw ce}return this.D(J,1)}async scanMetadata(Z,q){return q?(await this.w(Z,q))?.metadata:this.n.scanMetadata(Z.location)}async w(Z,q){return(await this.s.scanProfileExtensions(q)).find(j=>(0,i.$Co)(j.identifier,Z.identifier))}async updateMetadata(Z,q,P){return P?await this.s.updateMetadata([[Z,q]],P):await this.n.updateMetadata(Z.location,q),this.D(Z.location,Z.type,P)}getUninstalledExtensions(){return this.z()}async setUninstalled(...Z){const q=Z.map(P=>i.$Do.create(P));await this.z(P=>q.forEach(j=>{P[j.toString()]=!0,this.u.info("Marked extension as uninstalled",j.toString())}))}async setInstalled(Z){await this.z(q=>delete q[Z.toString()])}async removeExtension(Z,q){if(this.t.extUri.isEqualOrParent(Z.location,this.n.userExtensionsLocation))return this.y(Z.identifier.id,Z.location,q)}async removeUninstalledExtension(Z){await this.removeExtension(Z,"uninstalled"),await this.z(q=>delete q[i.$Do.create(Z).toString()])}async copyExtension(Z,q,P,j){const T=await this.w(Z,q),M=await this.w(Z,P);return j={...T?.metadata,...j},M?await this.s.updateMetadata([[Z,{...M.metadata,...j}]],P):await this.s.addExtensionsToProfile([[Z,j]],P),this.D(Z.location,Z.type,P)}async copyExtensions(Z,q){const P=await this.scanExtensions(1,Z),j=await Promise.all(P.filter(T=>!T.isApplicationScoped).map(async T=>[T,await this.scanMetadata(T,Z)]));await this.s.addExtensionsToProfile(j,q)}async y(Z,q,P){this.u.trace(`Deleting ${P} extension from disk`,Z,q.fsPath);const j=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,S.$Di)((0,h.$eg)()).toString(16)}${V}`);await this.C(q.fsPath,j.fsPath),await this.m.del(j,{recursive:!0}),this.u.info(`Deleted ${P} extension from disk`,Z,q.fsPath)}async z(Z){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(j){if((0,F.$pk)(j)!==1)throw j}let P={};if(q)try{P=JSON.parse(q)}catch{}return Z&&(Z(P),Object.keys(P).length?await this.m.writeFile(this.c,L.$be.fromString(JSON.stringify(P))):await this.m.del(this.c)),P})}async C(Z,q){try{await f.Promises.rename(Z,q,2*60*1e3)}catch(P){throw new n.$bo(P.message||d.localize(5,null,Z,q),P.code||n.ExtensionManagementErrorCode.Rename)}}async D(Z,q,P){if(P){const T=(await this.n.scanUserExtensions({profileLocation:P})).find(M=>this.t.extUri.isEqual(M.location,Z));if(T)return this.F(T)}else{const j=await this.n.scanExistingExtension(Z,q,{includeInvalid:!0});if(j)return this.F(j)}throw new Error(d.localize(6,null,Z.path))}async F(Z){const q=await this.m.resolve(Z.location);let P,j;return q.children&&(P=q.children.find(({name:T})=>/^readme(\.txt|\.md|)$/i.test(T))?.resource,j=q.children.find(({name:T})=>/^changelog(\.txt|\.md|)$/i.test(T))?.resource),{identifier:Z.identifier,type:Z.type,isBuiltin:Z.isBuiltin||!!Z.metadata?.isBuiltin,location:Z.location,manifest:Z.manifest,targetPlatform:Z.targetPlatform,validations:Z.validations,isValid:Z.isValid,readmeUrl:P,changelogUrl:j,publisherDisplayName:Z.metadata?.publisherDisplayName||null,publisherId:Z.metadata?.publisherId||null,isApplicationScoped:!!Z.metadata?.isApplicationScoped,isMachineScoped:!!Z.metadata?.isMachineScoped,isPreReleaseVersion:!!Z.metadata?.isPreReleaseVersion,preRelease:!!Z.metadata?.preRelease,installedTimestamp:Z.metadata?.installedTimestamp,updated:!!Z.metadata?.updated,pinned:!!Z.metadata?.pinned}}async G(){const Z=await this.getUninstalledExtensions();if(Object.keys(Z).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(Z));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),P=new Set;for(const T of q)Z[i.$Do.create(T).toString()]||P.add(T.identifier.id.toLowerCase());try{const T=(0,i.$Io)(q,M=>M.identifier);await D.Promises.settled(T.map(async M=>{const H=M.sort((J,re)=>$.rcompare(J.manifest.version,re.manifest.version))[0];P.has(H.identifier.id.toLowerCase())||await this.j(await this.F(H))}))}catch(T){this.u.error(T)}const j=q.filter(T=>T.metadata&&Z[i.$Do.create(T).toString()]);await Promise.allSettled(j.map(T=>this.removeUninstalledExtension(T)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let Z;try{Z=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,F.$pk)(q)!==1&&this.u.error(q);return}if(Z?.children)try{await Promise.allSettled(Z.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(V))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(P){(0,F.$pk)(P)!==1&&this.u.error(P)}}}))}catch{}}};e.$Np=G,e.$Np=G=pe([X(1,F.$$j),X(2,r.$Bp),X(3,t.$xp),X(4,K.$Ik),X(5,U.$0i)],G);class W extends o.$vp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$Ff)(this.options.operation)?this.l:this.options.operation}constructor(Z,q,P,j,T,M,H,J,re){super(),this.identifier=Z,this.source=q,this.options=P,this.m=j,this.n=T,this.o=M,this.p=H,this.q=J,this.s=re,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(Z){const[q,P]=await this.x(Z);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,P]],this.j),q}async u({zipPath:Z,key:q,metadata:P},j,T){let M=await this.v(q);return M||(this.s.trace("Extracting extension...",q.id),M=await this.m.extractUserExtension(q,Z,P,j,T),this.s.info("Extracting extension completed.",q.id)),M}async v(Z){return await this.w(Z)?(this.s.trace("Removing the extension from uninstalled list:",Z.id),await this.m.setInstalled(Z),this.s.info("Removed the extension from uninstalled list:",Z.id),(await this.m.scanAllUserExtensions(!0)).find(j=>i.$Do.create(j).equals(Z))):void 0}async w(Z){return!!(await this.m.getUninstalledExtensions())[Z.toString()]}}class ee extends W{constructor(Z,q,P,j,T,M,H,J,re,ce){super(q.identifier,q,P,T,M,H,J,re,ce),this.y=q,this.z=j}async x(Z){const P=(await this.m.scanExtensions(null,this.options.profileLocation)).find(H=>(0,i.$Co)(H.identifier,this.y.identifier));P&&(this.l=3);const j={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,isSystem:P?.type===0?!0:void 0,updated:!!P,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,y.$Ef)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:P?.preRelease)};if(P?.manifest.version===this.y.version)return[await this.m.updateMetadata(P,j),j];const{location:T,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.B(T.fsPath),[await this.u({zipPath:T.fsPath,key:i.$Do.create(this.y),metadata:j},!1,Z),j]}catch(H){try{await this.z.delete(T)}catch(J){this.s.warn("Error while deleting the downloaded file",T.toString(),(0,I.$9)(J))}throw H}}async B(Z){try{await(0,w.$Ip)(Z)}catch(q){throw new n.$bo((0,o.$tp)(q).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Op=ee;class ie extends W{constructor(Z,q,P,j,T,M,H,J,re,ce){super({id:(0,i.$Ho)(Z.publisher,Z.name)},q,P,T,M,H,J,re,ce),this.y=Z,this.z=q,this.A=j}async h(Z){const q=await super.h(Z);return this.D(q,Z),q}async x(Z){const q=new i.$Do(this.identifier,this.y.version),j=(await this.m.scanExtensions(1,this.options.profileLocation)).find(H=>(0,i.$Co)(this.identifier,H.identifier)),T={isApplicationScoped:this.options.isApplicationScoped||j?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||j?.isMachineScoped,isBuiltin:this.options.isBuiltin||j?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(j)if(this.l=3,q.equals(new i.$Do(j.identifier,j.manifest.version)))try{await this.m.removeExtension(j,"existing")}catch{throw new Error(d.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&$.gt(j.manifest.version,this.y.version)&&await this.m.setUninstalled(j);else{const H=await this.v(q);if(H)try{await this.m.removeExtension(H,"existing")}catch{throw new Error(d.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:b.$jc(this.z.fsPath),key:q,metadata:T},!0,Z),T]}async D(Z,q){try{let[P]=await this.A.getExtensions([{id:Z.identifier.id,version:Z.manifest.version}],q);if(P||([P]=await this.A.getExtensions([{id:Z.identifier.id}],q)),P){const j={id:P.identifier.uuid,publisherDisplayName:P.publisherDisplayName,publisherId:P.publisherId,isPreReleaseVersion:P.properties.isPreReleaseVersion,preRelease:P.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(Z,j,this.options.profileLocation)}}catch{}}}class _ extends o.$vp{constructor(Z,q,P){super(),this.extension=Z,this.j=q,this.k=P}async h(Z){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[263],ae([0,1,2,29,81,221,121,8,21]),function(te,e,D,L,N,A,I,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H9b=void 0;let g=class extends D.$Rc{constructor(k,b,c,$,y,p){super(),k.cleanUp(),(0,A.$tWb)(k,b,c,$,p),N.$1u.removeOutdatedExtensionVersions(k,y)}};e.$H9b=g,e.$H9b=g=pe([X(0,I.$Lp),X(1,L.$ao),X(2,N.$Zu),X(3,L.$fo),X(4,S.$9o),X(5,R.$0i)],g)}),define(oe[122],ae([0,1,70,62,36,273,15,7,3,2,16,5,32,42,66]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0;class y{traceSocketEvent(l,m){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,m)}constructor(l,m=""){this.f=!0,this.debugLabel=m,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,R.$Z)(O)}},this.socket.on("error",this.a),this.b=O=>{this.traceSocketEvent("close",{hadError:O}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(l){const m=O=>{this.traceSocketEvent("read",O),l(I.$be.wrap(O))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(l){const m=O=>{l({type:0,hadError:O,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(l){const m=()=>{l()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(l){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,R.$Z)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,R.$Z)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.$Eh=y;var p;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var h;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(h||(h={}));class f extends g.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(l,m){this.socket.traceSocketEvent(l,m)}constructor(l,m,O,F){super(),this.f=this.B(new S.$Nd),this.g=this.B(new S.$Nd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:O?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new u(this,m,O,F,this.f,(z,U)=>this.m(z,U))),this.B(this.a.onError(z=>{console.error(z),(0,R.$Z)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new $.$zh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this.f.event(l)}onClose(l){return this.g.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){let m=0;for(;m<l.byteLength;)this.a.writeMessage(l.slice(m,Math.min(m+262144,l.byteLength)),{compressed:!0,opcode:2}),m+=262144}m(l,{compressed:m,opcode:O}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let F=2;l.byteLength<126?F+=0:l.byteLength<2**16?F+=2:F+=8;const z=I.$be.alloc(F),U=m?64:0,B=O&15;if(z.writeUInt8(128|U|B,0),l.byteLength<126)z.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){z.writeUInt8(126,1);let Y=1;z.writeUInt8(l.byteLength>>>8&255,++Y),z.writeUInt8(l.byteLength>>>0&255,++Y)}else{z.writeUInt8(127,1);let Y=1;z.writeUInt8(0,++Y),z.writeUInt8(0,++Y),z.writeUInt8(0,++Y),z.writeUInt8(0,++Y),z.writeUInt8(l.byteLength>>>24&255,++Y),z.writeUInt8(l.byteLength>>>16&255,++Y),z.writeUInt8(l.byteLength>>>8&255,++Y),z.writeUInt8(l.byteLength>>>0&255,++Y)}this.socket.write(I.$be.concat([z,l]))}end(){this.h=!0,this.socket.end()}n(l){if(l.byteLength!==0){for(this.b.acceptChunk(l);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const m=this.b.peek(this.j.readLen),O=m.readUInt8(0),F=(O&128)>>>7,z=(O&64)>>>6,U=O&15,B=m.readUInt8(1),Y=(B&128)>>>7,K=B&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const m=this.b.read(this.j.readLen),O=m.readUInt8(1),F=(O&128)>>>7;let z=O&127,U=1;z===126?z=m.readUInt8(++U)*2**8+m.readUInt8(++U):z===127&&(z=m.readUInt8(++U)*0+m.readUInt8(++U)*0+m.readUInt8(++U)*0+m.readUInt8(++U)*0+m.readUInt8(++U)*2**24+m.readUInt8(++U)*2**16+m.readUInt8(++U)*2**8+m.readUInt8(++U));let B=0;F&&(B=m.readUInt8(++U)*2**24+m.readUInt8(++U)*2**16+m.readUInt8(++U)*2**8+m.readUInt8(++U)),this.j.state=3,this.j.readLen=z,this.j.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const m=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),s(m,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(m,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(m,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Fh=f;class u extends g.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.$be.alloc(0)}constructor(l,m,O,F,z,U){super(),this.n=l,this.r=z,this.s=U,this.a=this.B(new S.$Nd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$Nd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new S.$Nd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,m?(this.b=this.B(new d(this.n,F,O,{windowBits:15})),this.f=this.B(new E(this.n,{windowBits:15})),this.B(this.b.onError(B=>this.a.fire(B))),this.B(this.f.onError(B=>this.a.fire(B)))):(this.b=null,this.f=null)}writeMessage(l,m){this.g.push({data:l,options:m}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:l,options:m}=this.g.shift();if(this.f&&m.compressed){const O=await this.w(this.f,l);this.s(O,m)}else this.s(l,{...m,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(l,m){return new Promise((O,F)=>{l.write(m),l.flush(z=>O(z))})}acceptFrame(l,m,O){this.h.push({data:l,isCompressed:m,isLastFrameOfMessage:O}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const l=this.h.shift();if(this.b&&l.isCompressed){const m=await this.C(this.b,l.data,l.isLastFrameOfMessage);this.r.fire(m)}else this.r.fire(l.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(l,m,O){return new Promise((F,z)=>{l.write(m),O&&l.write(I.$be.fromByteArray([0,0,255,255])),l.flush(U=>F(U))})}}class d extends g.$Rc{get recordedInflateBytes(){return this.j?I.$be.concat(this.f):I.$be.alloc(0)}constructor(l,m,O,F){super(),this.h=l,this.j=m,this.a=this.B(new S.$Nd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(F),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(I.$be.wrap(z))}),O&&(this.h.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this.b.write(O.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(l){this.j&&this.f.push(l.clone()),this.h.traceSocketEvent("zlibInflateWrite",l),this.b.write(l.buffer)}flush(l){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const m=I.$be.concat(this.g);this.g.length=0,l(m)})}}class E extends g.$Rc{constructor(l,m){super(),this.g=l,this.a=this.B(new S.$Nd),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",O=>{this.g.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.g.traceSocketEvent("zlibDeflateData",O),this.f.push(I.$be.wrap(O))})}write(l){this.g.traceSocketEvent("zlibDeflateWrite",l.buffer),this.b.write(l.buffer)}flush(l){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let m=I.$be.concat(this.f);this.f.length=0,m=m.slice(0,m.byteLength-4),l(m)})}}function s(w,l){if(l===0)return;const m=w.byteLength>>>2;for(let Y=0;Y<m;Y++){const K=w.readUInt32BE(Y*4);w.writeUInt32BE(K^l,Y*4)}const O=m*4,F=w.byteLength-O,z=l>>>24&255,U=l>>>16&255,B=l>>>8&255;F>=1&&w.writeUInt8(w.readUInt8(O)^z,O),F>=2&&w.writeUInt8(w.readUInt8(O+1)^U,O+1),F>=3&&w.writeUInt8(w.readUInt8(O+2)^B,O+2)}e.$Gh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const w=(0,b.$eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const l=process.platform!=="darwin"&&e.$Gh?e.$Gh:(0,N.tmpdir)(),m=(0,C.$ic)(l,`vscode-ipc-${w}.sock`);return t(m),m}e.$Hh=n;function i(w,l,m){const O=(0,D.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${m}-${l}-sock`;const F=m.substr(0,4),z=l.substr(0,6),U=O.substr(0,8);let B;return process.platform!=="darwin"&&e.$Gh&&!process.env.VSCODE_PORTABLE?B=(0,C.$ic)(e.$Gh,`vscode-${U}-${F}-${z}.sock`):B=(0,C.$ic)(w,`${F}-${z}.sock`),t(B),B}e.$Ih=i;function t(w){const l=o[k.$u];typeof l=="number"&&w.length>=l&&console.warn(`WARNING: IPC handle "${w}" is longer than ${l} chars, try a shorter --user-data-dir`)}class r extends c.$th{static b(l){const m=S.Event.fromNodeEventEmitter(l,"connection");return S.Event.map(m,O=>({protocol:new $.$Ah(new y(O,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(O,"close"))}))}constructor(l){super(r.b(l)),this.d=l}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Jh=r;function a(w){return new Promise((l,m)=>{const O=(0,L.createServer)();O.on("error",m),O.listen(w,()=>{O.removeListener("error",m),l(new r(O))})})}e.$Kh=a;function v(w,l){return new Promise((m,O)=>{const F=(0,L.createConnection)(w,()=>{F.removeListener("error",O),m($.$Bh.fromSocket(new y(F,`ipc-client${l}`),l))});F.once("error",O)})}e.$Lh=v}),define(oe[264],ae([0,1,62,122,209]),function(te,e,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=void 0,e.$Q9b=new class{supports(A){return!0}connect({host:A,port:I},R,S,g){return new Promise((C,k)=>{const b=D.createConnection({host:A,port:I},()=>{b.removeListener("error",k),b.write((0,N.$Skb)(R,S,g));const c=$=>{$.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",c),C(new L.$Eh(b,g)))};b.on("data",c)});b.setNoDelay(!0),b.once("error",k)})}}}),define(oe[265],ae([0,1,62,36,132,122,6,2,5,20,8,25,212,104,106,77,15]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M8b=e.$L8b=e.$K8b=e.$J8b=void 0;async function h(s,o,n,i,t){let r;for(let a=3;a&&(r?.dispose(),r=await new f(s,o,n,i,t).waitForReady(),!(t&&N.$hg[t]||!N.$hg[r.tunnelLocalPort]));a--);return r}class f extends R.$Rc{constructor(o,n,i,t,r){super(),this.m=n,this.n=r,this.privacy=y.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=D.createServer(),this.c=new I.$Sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,y.$hv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,N.$ig)(o,2,1e3,n),t=null;return this.b.listen(i,this.m),await this.c.wait(),t=this.b.address(),t||(i=0,this.b.listen(i,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,y.$fv)(this.tunnelRemoteHost)||(0,y.$hv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,b.$6k)(this.a,n,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof A.$Eh?t.socket.destroy():t.end()}),t instanceof A.$Eh?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(i=>o.write(i.buffer)),o.on("data",i=>n.write(p.$be.wrap(i))),o.resume()}t(o,n){const i=n.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$J8b=f;let u=class extends y.$kv{constructor(o,n,i,t,r){super(n,r),this.u=o,this.v=i,this.w=t}isPortPrivileged(o){return(0,y.$iv)(o,this.l,S.OS,L.release())}s(o,n,i,t,r,a,v,w){const l=this.r(n,i);if(l)return++l.refcount,l.value;if((0,y.$cv)(o))return this.t(o,n,i,r,a,v,w);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${i} on local port ${r}.`);const m={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},O=h(m,t,n,i,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,i,O),O}}};e.$K8b=u,e.$K8b=u=pe([X(0,c.$Zk),X(1,C.$0i),X(2,$.$3k),X(3,k.$pj),X(4,g.$ji)],u);let d=class extends u{constructor(o,n,i,t,r){super(o,n,i,t,r)}};e.$L8b=d,e.$L8b=d=pe([X(0,c.$Zk),X(1,C.$0i),X(2,$.$3k),X(3,k.$pj),X(4,g.$ji)],d);let E=class extends R.$Rc{constructor(o,n,i,t,r){super(),this.b=o,this.c=n,this.f=i,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,i,t,r,a,v,w,l){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${a}.`),!this.a.has(o)){const m=new d(this.b,this.c,this.g,this.f,this.h);this.B(m),this.a.set(o,m),m.onTunnelClosed(async()=>{(await m.tunnels).length===0&&(m.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,i,t,r,a,v,w,l)}};e.$M8b=E,e.$M8b=E=pe([X(0,c.$Zk),X(1,C.$0i),X(2,k.$pj),X(3,$.$3k),X(4,g.$ji)],E)}),define(oe[274],ae([0,1,36,38,7,2,23,10,18,3,42,146,203,204,195,196,260,186,188,20,208,95,219,96,214,14,113,245,29,97,187,121,98,11,198,199,69,4,194,71,73,224,8,200,102,25,57,21,107,22,108,109,110,45,227,81,111,24,79,252,237,238,82,251,255,256,257,58,250,239,106,218,77,265,213,228,28,229,5,230,189,206,205,80,244,17,51,202,56,249,226,240,105,254,263,9,201,101,247,243,215,183,55,258,246,72,248,104,264,181,216]),function(te,e,D,L,N,A,I,R,S,g,C,k,b,c,$,y,p,h,f,u,d,E,s,o,n,i,t,r,a,v,w,l,m,O,F,z,U,B,Y,K,x,V,Q,G,W,ee,ie,_,ne,Z,q,P,j,T,M,H,J,re,ce,ue,he,$e,de,we,ve,Ie,Le,Te,le,ge,be,Se,Pe,ze,je,Ue,Me,se,fe,me,ye,ke,Re,Ce,De,Oe,Ae,Fe,Be,qe,Ve,_e,ut,yt,vt,Et,kt,ft,St,Ct,Pt,Rt,It,Dt,Ot,dt,jt,gt,Nt,At,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends A.$Rc{constructor(Ee){super(),this.f=Ee,this.a=this.B(new k.$LT(this)),this.b=void 0,this.c=this.B(new g.$Nd),this.g()}g(){let Ee=!1;const Ne=()=>{Ee||(Ee=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ne),(0,k.$MT)(process.parentPort,it.$Y7b.exit,Ne)}async init(){const Ee=await this.h();(0,re.$Tgb)(),Ee.invokeFunction(Ne=>{const Ke=Ne.get(Q.$0i),We=Ne.get(Z.$cl),Ze=Ne.get(Oe.$Kk);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ne),this.m(Ke),this.n(We,Ze),this.B(Ze.onDidChangeProfiles(()=>this.n(We,Ze)))}),this.B((0,A.$Oc)(Ee.createInstance(b.$d9b,this.f.codeCachePath),Ee.createInstance(c.$e9b),Ee.createInstance(p.$h9b),Ee.createInstance(y.$g9b),Ee.createInstance($.$f9b),Ee.createInstance(vt.$H9b),Ee.createInstance(_e.$z9b)))}async h(){const Ee=new K.$Nh,Ne={_serviceBrand:void 0,...W.default};Ee.set(ee.$pj,Ne);const Ke=new C.$xh(He=>He==="main"),We=new dt.$T8b(this.a,Ke);Ee.set(dt.$S8b,We);const Ze=this.f.policiesData?new Fe.$p8b(this.f.policiesData,We.getChannel("policy")):new Be.$nn;Ee.set(Be.$ln,Ze);const Ge=new At.$jm(this.f.args,Ne);Ee.set(i.$Xh,Ge);const xe=new G.$br(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(He=>({...He,resource:R.URI.revive(He.resource)})),We.getChannel("logger"));Ee.set(Q.$$i,xe);const st=this.B(xe.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ct=this.B(new Q.$fj(st.getLevel())),Je=this.B(new kt.$NN(st,[ct]));Ee.set(Q.$0i,Je),this.b=this.B(new ft.$J9b(Je)),Ee.set(ft.$I9b,this.b);const Qe=this.B(new F.$Qp(Je));Ee.set(O.$$j,Qe);const lt=this.B(new z.$dq(Je));Qe.registerProvider(I.Schemas.file,lt);const rt=new se.$Cr(Qe);Ee.set(Me.$Ik,rt);const Xe=this.B(new qe.$UN(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),We.getChannel("userDataProfiles")));Ee.set(Oe.$Kk,Xe);const ht=this.B(new me.$R8b(I.Schemas.file,this.B(new ye.$wN(We.getChannel(ye.$vN),{pathCaseSensitive:fe.$l})),I.Schemas.vscodeUserData,Xe,rt,Je));Qe.registerProvider(I.Schemas.vscodeUserData,ht);const Ye=this.B(new d.$Nn(Xe.defaultProfile.settingsResource,Qe,Ze,Je));Ee.set(u.$ji,Ye);const et=new jt.$P9b(void 0,{defaultProfile:Xe.defaultProfile,currentProfile:Xe.defaultProfile},We,Ge);Ee.set(_.$9o,et),this.B((0,A.$Pc)(()=>et.flush())),await Promise.all([Ye.initialize(),et.initialize()]);const mt=new Pt.$Zq(We.getChannel("request"));Ee.set(ie.$Vo,mt),Ee.set(h.$i9b,new U.$Mh(f.$j9b,void 0,!1)),Ee.set(Re.$4E,new U.$Mh(ke.$y9b,void 0,!1));const bt=C.ProxyChannel.toService(We.getChannel("nativeHost"));Ee.set(It.$E7b,bt),Ee.set(o.$Rn,new U.$Mh(n.$3N,void 0,!0));const Ft=this.B(new ge.$m8b(bt)),Mt=new C.$xh(He=>Ft.getActiveClientId().then(at=>He===at));Ee.set(m.$dWb,new Rt.$L9b(this.a.getChannel("extensionRecommendationNotification",Mt)));let ot;const tt=[],wt=(0,T.$zo)(Ne,Ye);if((0,T.$uo)(Ne,Ge)){const He=new P.$o5b(Je,xe,Ge,Ne);if(tt.push(He),!(0,T.$vo)(Ne,Ge)&&Ne.aiConfig?.ariaKey){const at=new Ve.$BN(mt,wt,"monacoworkbench",null,Ne.aiConfig.ariaKey);this.B((0,A.$Pc)(()=>at.flush())),tt.push(at)}ot=new j.$4q({appenders:tt,commonProperties:(0,ne.$ko)((0,D.release)(),(0,D.hostname)(),process.arch,Ne.commit,Ne.version,this.f.machineId,this.f.sqmId,wt),sendErrorTelemetry:!0,piiPaths:(0,T.$Ao)(Ge)},Ye,Ne)}else{ot=T.$oo;const He=T.$so;tt.push(He)}this.a.registerChannel("telemetryAppender",new q.$47b(tt)),Ee.set(Z.$cl,ot);const Tt=new M.$k9b(Ye,ot,Je,xe,Ge,Ne);Ee.set(Z.$dl,Tt),Ee.set(Ae.$xp,new U.$Mh(Ct.$MN,void 0,!0)),Ee.set(Ce.$Bp,new U.$Mh(De.$q8b,void 0,!0)),Ee.set(v.$hp,new U.$Mh(v.$ip,void 0,!0)),Ee.set(l.$Lp,new U.$Mh(l.$Mp,void 0,!0)),Ee.set(a.$ao,new U.$Mh(r.$fp,void 0,!0)),Ee.set(a.$go,new U.$Mh(Ot.$O9b,void 0,!1)),Ee.set(x.$Vq,new U.$Mh(V.$Xq,void 0,!1)),Ee.set(E.$qm,new U.$Mh(s.$Jr,void 0,!1)),Ee.set(ce.$6Cb,new U.$Mh(ce.$7Cb,void 0,!0)),Ee.set(re.$chb,new U.$Mh($e.$gFb,void 0,!0)),Ee.set(re.$bhb,new he.$n9b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),Ee.set(a.$fo,new U.$Mh(t.$4Cb,void 0,!1)),Ee.set(J.$eFb,new U.$Mh(J.$fFb,void 0,!0)),Ee.set(H.$Zu,new U.$Mh(H.$1u)),Ee.set(re.$Ygb,new U.$Mh(Le.$pEb,void 0,!0)),Ee.set(re.$Zgb,new U.$Mh(Le.$rEb,void 0,!0)),Ee.set(de.$Mgb,new U.$Mh(de.$Ogb,void 0,!0)),Ee.set(re.$1gb,new U.$Mh(ue.$35b,void 0,!1)),Ee.set(re.$0gb,new U.$Mh(we.$R5b,void 0,!0)),Ee.set(re.$$gb,new U.$Mh(ve.$85b,void 0,!1)),Ee.set(Te.$FDb,new U.$Mh(le.$u9b,void 0,!0)),Ee.set(re.$_gb,new U.$Mh(yt.$G6b,void 0,!0)),Ee.set(be.$3k,new U.$Mh(Se.$O8b,void 0,!1));const pt=new gt.$1k;return Ee.set(gt.$Zk,pt),pt.register(0,Nt.$Q9b),Ee.set(Pe.$bv,new U.$Mh(ze.$M8b)),Ee.set(je.$v9b,new U.$Mh(Ue.$x9b)),Ee.set(ut.$A9b,new U.$Mh(St.$K9b)),new Y.$gq(Ee)}j(Ee){const Ne=this.B(new A.$Qc),Ke=new w.$kp(Ee.get(a.$co),()=>null);this.a.registerChannel("extensions",Ke);const We=C.ProxyChannel.fromService(Ee.get(x.$Vq),Ne);this.a.registerChannel("languagePacks",We);const Ze=C.ProxyChannel.fromService(Ee.get(E.$qm),Ne);this.a.registerChannel("diagnostics",Ze);const Ge=new w.$mp(Ee.get(a.$go));this.a.registerChannel("extensionTipsService",Ge);const xe=C.ProxyChannel.fromService(Ee.get(h.$i9b),Ne);this.a.registerChannel("checksum",xe);const st=C.ProxyChannel.fromService(Ee.get(Re.$4E),Ne);this.a.registerChannel("v8InspectProfiling",st);const ct=new he.$o9b(Ee.get(de.$Mgb));this.a.registerChannel("userDataSyncMachines",ct);const Je=C.ProxyChannel.fromService(Ee.get(Z.$dl),Ne);this.a.registerChannel("customEndpointTelemetry",Je);const Qe=new he.$p9b(Ee.get(ce.$6Cb));this.a.registerChannel("userDataSyncAccount",Qe);const lt=new he.$q9b(Ee.get(re.$Ygb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Ie.$s9b(Ee.get(re.$$gb),Ee.get(Oe.$Kk),Ee.get(Q.$0i));this.a.registerChannel("userDataSync",rt);const Xe=this.B(Ee.get(B.$Oh).createInstance(Dt.$N9b)),ht=new he.$l9b(Xe);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(Ee.get(re.$_gb),Ne));const Ye=C.ProxyChannel.fromService(Ee.get(je.$v9b),Ne);this.a.registerChannel(je.$w9b,Ye);const et=C.ProxyChannel.fromService(Ee.get(ut.$A9b),Ne);this.a.registerChannel("remoteTunnel",et)}m(Ee){process.on("uncaughtException",Ne=>(0,N.$Z)(Ne)),process.on("unhandledRejection",Ne=>(0,N.$Z)(Ne)),(0,N.setUnexpectedErrorHandler)(Ne=>{const Ke=(0,L.$Ai)(Ne,!0);Ke&&Ee.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Ee,Ne){Ee.publicLog2("profilesInfo",{count:Ne.profiles.length})}handledClientConnection(Ee){if(Ee.data!==it.$17b.response)return!1;const Ne=(0,S.$Nb)(Ee.ports);return Ne?(this.c.fire(Ne),!0):!1}}async function $t(nt){const Ee=new Lt(nt);process.parentPort.postMessage(it.$Y7b.ipcReady),await Ee.init(),process.parentPort.postMessage(it.$Y7b.initDone)}e.main=$t,process.parentPort.once("message",nt=>{$t(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/98417b150aeb47dd81dc58893789da4b4cb0e095/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
